#ifndef _PN_ACCESSORY_ISI_H_
#define _PN_ACCESSORY_ISI_H_

#include <stdint.h> 

//Resource Accessory Server
//PN_ACCESSORY 0x1C 
//ISI version 002.003
#define ACCESSORY_SERVER_ISI_VERSION_Z     2
#define ACCESSORY_SERVER_ISI_VERSION_Y     3

//In case of problems concerning content of this file contact Markku Loukusa, Sauli Laukka or Markus Mrsky
//Server specific message descriptions and feature&protocol descriptions can be found from: https://oucmswww.nmp.nokia.com:58443/document_browser/ccm_wa/GIF_SPECS/ 


//ISI VERSION CHANGE HISTORY

//Version: 002.003                                           
//Status: NonDraft                                          
//Date: 10-Apr-2008     Lasse Kongas
//Reason: Error correction
//Reference: SWAM ADB / EK08041044788, NON-DRAFT

//Version: 002.002                                           
//Status: NonDraft                                          
//Date: 07-Feb-2008     Lasse Kongas
//Reason: Improvements
//Reference: SWAM ADB / EK08010739070, NON-DRAFT

//Version: 002.001                                           
//Status: NonDraft                                          
//Date: 16-Nov-2007     Lasse Kongas
//Reason: New features
//Reference: SWAM ADB / EK07111246286, NON-DRAFT

//Version: 002.000                                           
//Status: NonDraft                                          
//Date: 20-Aug-2007     Jari Huhtamaki
//Reason: New features
//Reference: SWAM ADB / JH0708213489, NON-DRAFT

//Version: 001.008                                           
//Status: NonDraft                                          
//Date: 08-May-2007     Sami Sutinen
//Reason: New features
//Reference: SWAM ADB / SS07050838321, NON-DRAFT

//Version: 001.007                                           
//Status: NonDraft                                          
//Date: 13-Dec-2006     Sami Sutinen
//Reason: New features
//Reference: SWAM ADB / SS06121341573, NON-DRAFT

//Version: 001.006                                           
//Status: NonDraft                                          
//Date: 22-Nov-2006     Kari Merilainen
//Reason: New features
//Reference: SWAM ADB / KM06112344292, NON-DRAFT

//Version: 001.005                                           
//Status: NonDraft                                          
//Date: 28-Aug-2006     Jari Huhtamaki
//Reason: New features
//Reference: SWAM ADB / JH06082841031, NON-DRAFT

//Version: 001.004                                           
//Status: NonDraft                                          
//Date: 22-Aug-2006     Jani Pellikka
//Reason: New features
//Reference: SCO: ISA RM / 009-27330, NON-DRAFT

//Version: 001.003                                           
//Status: NonDraft                                          
//Date: 22-May-2006     Jari Huhtamaki
//Reason: New features
//Reference: CR: SWAM ADB / JH06052265532, NON-DRAFT

//Version: 001.002                                           
//Status: NonDraft                                          
//Date: 08-May-2006     Kari Merilainen
//Reason: NokiaAV - Production tests
//Reference: SCO: ISA RM / 010-23460:ACC Srv: NOKAV: Calibration IF for C-Video cable, NON-DRAFT

//Version: 001.001                                           
//Status: NonDraft                                          
//Date: 04-May-2006     Kari Merilainen
//Reason: NokiaAV - Production tests
//Reference: SCO: ISA RM / 010-23033: ACC Srv: NOKAV: Test interface for TV_Out testing, NON-DRAFT

//Version: 001.000                                           
//Status: NonDraft                                          
//Date: 01-Mar-2006     Jari Huhtamaki
//Reason: ECI Features
//Reference: SCO: ISA RM / 010-19044, NON-DRAFT

//Version: 000.052                                           
//Status: NonDraft                                          
//Date: 12-Dec-2005     Kari Merilinen
//Reason: NokiaAV - Production tests
//Reference: SCO: ISA RM / 010-17727:ACC Srv: NOKAV: Accessory Production Tests, NON-DRAFT

//Version: 000.051                                           
//Status: NonDraft                                          
//Date: 01-Dec-2005     Kari Merilinen
//Reason: NokiaAV - MIC Change & DSP hook polling
//Reference: SCO: ISA RM / 010-19042 AUD Srv: NOKAV: Report MIC2 power to ACC HAL, NON-DRAFT

//Version: 000.050                                           
//Status: NonDraft                                          
//Date: 21-Nov-2005     Kari Merilinen
//Reason: NokiaAV FTD
//Reference: SCO: ISA RM / 009-19843 ACC Srv: NOKAV: FTD Display, NON-DRAFT

//Version: 000.049                                           
//Status: NonDraft                                          
//Date: 20-Oct-2005     Jari Huhtamki
//Reason: NokiaAV
//Reference: SCO: ISA RM / 009-19831 ACC Srv: NOKAV: ISI Interface, NON-DRAFT

//Version: 000.048                                           
//Status: NonDraft                                          
//Date: 09-Aug-2005     Kari Merilainen
//Reason: TV-Out support
//Reference: SCO: ISA RM / 010-12404: TV-Out support in ISA accessory SW, NON-DRAFT

//Version: 000.047                                           
//Status: NonDraft                                          
//Date: 27-May-2005     Kari Merilainen
//Reason: Flash accessory low power support
//Reference: SCO: ISA RM / 009-18056: Camera PD-2 support, NON-DRAFT

//Version: 000.046                                           
//Status: NonDraft                                          
//Date: 18-Apr-2005     Mika P. Kangas
//Reason: Error fix
//Reference: -

//Version: 000.045                                           
//Status: NonDraft                                          
//Date: 01-Apr-2005     Mika P. Kangas
//Reason: Sub blocks moved to shared file
//Reference: ISA RM / 009-17465: AUD Srv: Audio routing for S60 3.0, NON-DRAFT

//Version: 000.044                                           
//Status: NonDraft                                          
//Date: 30-Mar-2005     Kari Merilainen
//Reason: Nemo-W Line-In & Vibra ACK Support
//Reference: ISA RM / 010-8869 & 101-11822, NON-DRAFT

//Version: 000.043                                           
//Status: NonDraft                                          
//Date: 03-Mar-2005     Kari Merilainen
//Reason: HS20 & HS28 Support
//Reference: ISA RM / 010-10156 & 010-8865, NON-DRAFT

//Version: 000.042                                           
//Status: NonDraft                                          
//Date: 17-Feb-2005     Jari Huhtamaki
//Reason: HS23 Volume keys
//Reference: ISA RM / 010-9837, NON-DRAFT

//Version: 000.041                                           
//Status: NonDraft                                          
//Date: 03-Jan-2005     Jari Huhtamaki
//Reason: Acc test req added. Vibra change.
//Reference: ISA RM / 010-4117 & 010-4124, NON-DRAFT

//Version: 000.040                                           
//Status: NonDraft                                          
//Date: 31-May-2004     Jari Huhtamaki
//Reason: New acc types added.
//Reference: ISA RM / 010-4117 & 010-4124, NON-DRAFT

//Version: 000.039                                           
//Status: NonDraft                                          
//Date: 21-May-2004     Jari Huhtamaki
//Reason: New acc type added.
//Reference: ISA RM / 010-3657, NON-DRAFT

//Version: 000.038                                           
//Status: NonDraft                                          
//Date: 21-Apr-2004     Jari Huhtamaki
//Reason: New subtype added.
//Reference: ISA RM / 009-10895, NON-DRAFT

//Version: 000.037                                           
//Status: NonDraft                                          
//Date: 26-Jan-2004     Kening Ren
//Reason: Tomahawk Audio Block
//Reference: ISA RM / 009-5713, NON-DRAFT

//Version: 000.036                                           
//Status: NonDraft                                          
//Date: 12-Aug-2003     Jari Huhtamaki
//Reason: Tomahawk Audio Block
//Reference: ISA RM / 010-2157, NON-DRAFT

//Version: 000.035                                           
//Status: NonDraft                                          
//Date: 06-May-2003     Kening Ren
//Reason: Vibra cover control ISI update
//Reference: ISA RM / 009-3735, NON-DRAFT

//Version: 000.034                                           
//Status: NonDraft                                          
//Date: 24-Jan-2003     Kening Ren
//Reason: Active cover control update
//Reference: ISA RM / 8425, NON-DRAFT

//Version: 000.033                                           
//Status: NonDraft                                          
//Date: 29-Nov-2002     Tommi Mammela
//Reason: Active cover update
//Reference: ISA RM / 9149, NON-DRAFT

//Version: 000.002                                           
//Status: NonDraft                                          
//Date: 15-Nov-2002     Jari Huhtamaki
//Reason: Tomahawk update
//Reference: -, NON-DRAFT

//Version: 000.001                                           
//Status: NonDraft                                          
//Date: 19-Sep-2002     Kening Ren
//Reason: Tomahawk TTY added
//Reference: -, NON-DRAFT


//CONSTANTS
#define ACC_PXM_ISR_IND                                       0xE0                                                  
#define ACC_JACK_ISR_IND                                      0xE1                                                  
#define ACC_TTY_MODE_MASK                                     0x04                                                     
#define ACC_DLR3_MODE_MASK                                    0x08                                                     
#define ACC_HEADSET_MODE_MASK                                 0x10                                                  
#define ACC_LOOPSET_MODE_MASK                                 0x20                                                  
#define ACC_HD_OR_LPS_MODE_MASK                               0x30                                                  
#define ACC_HD_LPS_TTY_MODE_MASK                              0x34                                                  
#define ACC_PPHF_MODE_MASK                                    0x40                                                  
#define ACC_CARKIT_MODE_MASK                                  0x80                                                  
#define ACC_CAR_KIT_EVENT_MASK                                0x01                                                     
#define ACC_CAR_KIT_IGN_MASK                                  0x02                                                     
#define ACC_CAR_KIT_SPEAKER_MASK                              0x04                                                     
#define ACC_CAR_KIT_ACT_MIC_MASK                              0x08                                                     
#define ACC_CAR_KIT_TANGENT_MASK                              0x10                                                  
#define ACC_CAR_KIT_CRADLE_MASK                               0x20                                                  
#define ACC_CAR_KIT_HS_MASK                                   0x40                                                  
#define ACC_CAR_KIT_TEST_MASK                                 0x80                                                  
#define ACC_CAR_KIT_FAIL_MASK                                 0x80                                                  
#define ACC_HEADSET_BTN_DOWN_MASK                             0x01                                                     
#define ACC_HEADSET_LONG_HOOK_MASK                            0x02                                                     
#define ACC_BT_HEADSET_MODE_MASK                              0x01                                                     
#define ACC_BT_CARKIT_MODE_MASK                               0x02                                                     
#define ACC_BT_NOKIA1_MASK                                    0x8000                                                
#define ACC_BT_NOKIA2_MASK                                    0x4000                                                
#define ACC_BT_OTHER_MASK                                     0x2000                                                
#define ACC_DEVICE_MASK                                       0x1FFF                                                
#define ACC_MANUFACTURER_MASK                                 0xE000                                                
#define ACC_REMOTE_VOLUME_CONTROL_SUPPORT                     0x01                                                     
#define ACC_AC_I2C_MASK                                       0x01                                                     
#define ACC_AC_ASYNC_MASK                                     0x02                                                     
#define ACC_AC_TYPE_3_MASK                                    0x04                                                     
#define ACC_AC_TYPE_4_MASK                                    0x08                                                     
#define ACC_AC_PWM_1_MASK                                     0x10                                                  
#define ACC_AC_PWM_2_MASK                                     0x20                                                  
#define ACC_AC_PWM_3_MASK                                     0x40                                                  
#define ACC_AC_PWM_ALL_MASK                                   0x70                                                  
#define ACC_AC_CTI_1_MASK                                     0x80                                                  
#define ACC_AC_CTI_2_MASK                                     0x0100                                                   
#define ACC_AC_CTI_ALL_MASK                                   0x0180                                                   
#define ACC_AC_FREQ_1_MASK                                    0x0200                                                   
#define ACC_AC_FREQ_2_MASK                                    0x0400                                                   
#define ACC_AC_FREQ_3_MASK                                    0x0800                                                   
#define ACC_AC_FREQ_ALL_MASK                                  0x0E00                                                   
#define ACC_ALLOC                                             0x02                                                     
#define ACC_ANY_SIZE                                          1                                                     


//TABLES

//ConstantTable for ACC_PXM_STATUS
#define ACC_PXM_NOT_DETECTED                                  0x00                                                     
#define ACC_PXM_DETECTED                                      0x01                                                     
#define ACC_PXM_FAULT                                         0x02                                                     

//ConstantTable for ACC_PXM_CALIB_STATUS
#define ACC_PXM_CALIB_OK                                      0x00                                                     
#define ACC_PXM_CALIB_START_ILLEGAL_PARAMETER                 0x01                                                     
#define ACC_PXM_CALIB_GAIN_INT_FAIL                           0x02                                                     
#define ACC_PXM_CALIB_DET_TR_FAIL                             0x03                                                     
#define ACC_PXM_CALIB_FAULT_TR_FAIL                           0x04                                                     
#define ACC_PXM_CALIB_OFFSET_FAIL                             0x05                                                     
#define ACC_PXM_CALIB_DET_NOT_DONE                            0x06                                                     
#define ACC_PXM_CALIB_COMBINATION_FAIL                        0x07                                                     
#define ACC_PXM_CALIB_COMBINATION_W_OFF_FAIL                  0x08                                                     
#define ACC_PXM_CALIB_FAULT_INT_FAIL                          0x09                                                     
#define ACC_PXM_CALIB_FAULT_OVER_LIMIT_FAIL                   0x0A                                                     
#define ACC_PXM_CALIB_GAIN_MAX_LIMIT_FAIL                     0x0B                                                     
#define ACC_PXM_CALIB_GAIN_MIN_LIMIT_FAIL                     0x0C                                                     

//ConstantTable for ACC_ALI_TRIGGER_TYPE
#define ACC_ALI_TRIGGER_OFF                                   0x00                                                     
#define ACC_ALI_TRIGGER_OVER_LEVEL                            0x01                                                     
#define ACC_ALI_TRIGGER_UNDER_LEVEL                           0x02                                                     

//ConstantTable for ACC_STATUS_EXT
#define ACC_OK                                                0x00                                                     
#define ACC_NOT_VALID                                         0x01                                                     
#define ACC_NOT_READY                                         0x02                                                     

//ConstantTable for ACC_STATUS
//#define ACC_OK                                              0x00                        //Already defined as 0x00
//#define ACC_NOT_VALID                                       0x01                        //Already defined as 0x01
#define ACC_FAIL                                              0x02                                                     
#define ACC_BUSY                                              0x03                                                     
#define ACC_ALLOC_FAIL                                        0x04                                                     

//ConstantTable for DCT3DCT4_EXT
#define ACC_DCT3DCT4_EXT_NONE                                 0x00                                                     
#define ACC_DCT3DCT4_EXT_DT1                                  0x10                                                  

//ConstantTable for ACC_AC_STATUS
//#define ACC_OK                                              0x00                        //Already defined as 0x00
//#define ACC_NOT_VALID                                       0x01                        //Already defined as 0x01
#define ACC_AC_NOT_POSSIBLE                                   0x02                                                     

//ConstantTable for ACC_ON_OFF
#define ACC_OFF                                               0x00                                                     
#define ACC_ON                                                0x01                                                     

//ConstantTable for ACC_AC_ENABLE_DISABLE
#define ACC_AC_DISABLE                                        0x00                                                     
#define ACC_AC_ENABLE                                         0x01                                                     

//ConstantTable for ACC_MODE
#define ACC_NOT_CONNECTED                                     0x00                                                     
#define ACC_UNSUPPORTED_CONNECTED                             0x01                                                     
//#define ACC_NOT_READY                                       0x02                        //Already defined as 0x02
#define ACC_AUDIO_TEST_BOX                                    0x03                                                     
#define ACC_TTY                                               0x04                                                     
#define ACC_TTY_UNIV                                          0x06                                                     
#define ACC_CABLE_DLR3                                        0x08                                                     
#define ACC_HEADSET_HDC9                                      0x10                                                  
#define ACC_HEADSET_HDC5                                      0x11                                                  
#define ACC_HEADSET_UNIV                                      0x12                                                  
#define ACC_LOOPSET_LPS1                                      0x20                                                  
#define ACC_LOOPSET_LPS3                                      0x21                                                  
#define ACC_PPHF                                              0x40                                                  
#define ACC_PPHF_EXT_MIC                                      0x41                                                  
#define ACC_CAR_HFU2                                          0x80                                                  
#define ACC_CAR_HFU2T                                         0x81                                                  

//ConstantTable for ACC_BT_DEVICE
#define ACC_BT_HD                                             0x2001                                                
#define ACC_BT_CAR_HF                                         0x2002                                                
#define ACC_BT_GENERAL_AUDIO                                  0x2004                                                
#define ACC_BT_HD_NOKIA                                       0x8001                                                
#define ACC_BT_CAR_HF_NOKIA                                   0x8002                                                

//ConstantTable for ACC_LPS_MODE
#define ACC_HEADSET                                           0x00                                                     
#define ACC_LOOPSET                                           0x01                                                     
#define ACC_LINEIN                                            0x03                                                     
//#define ACC_TTY                                             0x04                        //Already defined as 0x04

//ConstantTable for ACC_THWK_MASTER_TYPE

//ConstantTable for ACC_THWK_SUB_TYPE_OTHER

//ConstantTable for ACC_THWK_SUB_TYPE_HD

//ConstantTable for ACC_THWK_SUB_TYPE_HF

//ConstantTable for ACC_THWK_SUB_TYPE_DC

//ConstantTable for ACC_THWK_SUB_TYPE_TD

//ConstantTable for ACC_THWK_SUB_TYPE_CAM

//ConstantTable for ACC_THWK_SUB_TYPE_MISC

//ConstantTable for ACC_THWK_SUB_TYPE_ADAPTER

//ConstantTable for ACC_PXM_CALIB_REQ_ACTION
#define ACC_SB_PXM_DETECTION_CALIB_PARAMETERS                 0x10                                                  
#define ACC_SB_PXM_FAULT_CALIB_PARAMETERS                     0x11                                                  

//ConstantTable for ACC_PXM_CALIB_RESP_ACTION
#define ACC_SB_PXM_DETECTION_CALIB_RESULT                     0x12                                                  
#define ACC_SB_PXM_FAULT_CALIB_RESULT                         0x13                                                  

//ConstantTable for ACC_TEST_REQ_ACTION
#define ACC_ENABLE_MICBIAS                                    0x00                                                     
#define ACC_DISABLE_MICBIAS                                   0x01                                                     
#define ACC_READ_HOOK_LINE_STATE                              0x02                                                     
#define ACC_READ_ACI_LINE_STATE                               0x03                                                     
#define ACC_TEST_HOOK_INTERRUPT                               0x04                                                     
#define ACC_READ_AV_PLUG_STATE                                0x05                                                     
#define ACC_ENABLE_AV_ECICTRL                                 0x06                                                     
#define ACC_DISABLE_AV_ECICTRL                                0x07                                                     
#define ACC_ENABLE_AV_MICB2                                   0x08                                                     
#define ACC_DISABLE_AV_MICB2                                  0x09                                                     
#define ACC_ENABLE_AV_TVOUT                                   0x0A                                                     
#define ACC_DISABLE_AV_TVOUT                                  0x0B                                                     
#define ACC_ENABLE_USB                                        0x0C                                                     
#define ACC_DISABLE_USB                                       0x0D                                                     

//ConstantTable for ACC_TEST_REQ_STATUS
//#define ACC_OK                                              0x00                        //Already defined as 0x00
//#define ACC_NOT_VALID                                       0x01                        //Already defined as 0x01
//#define ACC_FAIL                                            0x02                        //Already defined as 0x02
#define ACC_HIGH                                              0x05                                                     
#define ACC_LOW                                               0x06                                                     

//ConstantTable for ACC_AC_PWM_SEQ
#define ACC_AC_PWM_SEQ_1                                      0x01                                                     
#define ACC_AC_PWM_SEQ_2                                      0x02                                                     
#define ACC_AC_PWM_SEQ_3                                      0x03                                                     
#define ACC_AC_PWM_SEQ_4                                      0x04                                                     
#define ACC_AC_PWM_SEQ_5                                      0x05                                                     
#define ACC_AC_PWM_SEQ_6                                      0x06                                                     
#define ACC_AC_PWM_SEQ_7                                      0x07                                                     
#define ACC_AC_PWM_SEQ_8                                      0x08                                                     
#define ACC_AC_PWM_SEQ_9                                      0x09                                                     
#define ACC_AC_PWM_SEQ_10                                     0x0A                                                     
#define ACC_AC_PWM_SEQ_11                                     0x0B                                                     
#define ACC_AC_PWM_SEQ_12                                     0x00                                                     
#define ACC_AC_PWM_SEQ_13                                     0x0C                                                     

//ConstantTable for ACC_AUDIO_PROFILE
//#define ACC_HEADSET                                         0x00                        //Already defined as 0x00
//#define ACC_LOOPSET                                         0x01                        //Already defined as 0x01
#define ACC_CAR_HANDSFREE                                     0x02                                                     
#define ACC_OFFICE_HANDSFREE                                  0x03                                                     
#define ACC_MUSIC_DEVICE                                      0x04                                                     
#define ACC_TTY_TEXTPHONE                                     0x06                                                     
#define ACC_HEADPHONE                                         0x80                                                  
#define ACC_LINE_IN                                           0x81                                                  
#define ACC_LINE_OUT                                          0x82                                                  
#define ACC_NO_AUDIO                                          0xFF                                                  

//ConstantTable for ACC_CONNECTOR
#define ACC_CONNECTOR_NOKIA_AV                                0x01                                                     
#define ACC_CONNECTOR_USB                                     0x02                                                     

//ConstantTable for ACC_AUDIO_TYPE
#define ACC_MONO                                              0x00                                                     
#define ACC_STEREO                                            0x01                                                     

//ConstantTable for ACC_FEATURES
#define ACC_NO_FEATURE                                        0x00                                                     
#define ACC_IGNITION_SENSE_OFF                                0x01                                                     
#define ACC_IGNITION_SENSE_ON                                 0x4001                                                
#define ACC_HANDSET_HOOK_OFF                                  0x02                                                     
#define ACC_HANDSET_HOOK_ON                                   0x4002                                                
#define ACC_POWER_SUPPLY_OFF                                  0x03                                                     
#define ACC_POWER_SUPPLY_ON                                   0x4003                                                
#define ACC_ANSWER_END_OFF                                    0x07                                                     
#define ACC_ANSWER_END_ON                                     0x4007                                                
#define ACC_LONG_HOOK_OFF                                     0x2007                                                
#define ACC_LONG_HOOK_ON                                      0x6007                                                
#define ACC_ANSWER_END_DOUBLECLICK                            0x1007                                                
#define ACC_HEADSET_PLUG_OFF                                  0x08                                                     
#define ACC_HEADSET_PLUG_ON                                   0x4008                                                
#define ACC_VOLUME_UP_OFF                                     0x0B                                                     
#define ACC_VOLUME_UP_ON                                      0x400B                                                
#define ACC_VOLUME_DOWN_OFF                                   0x0C                                                     
#define ACC_VOLUME_DOWN_ON                                    0x400C                                                
#define ACC_PLAY_PAUSE_OFF                                    0x0D                                                     
#define ACC_PLAY_PAUSE_ON                                     0x400D                                                
#define ACC_STOP_OFF                                          0x0E                                                     
#define ACC_STOP_ON                                           0x400E                                                
#define ACC_NEXT_OFF                                          0x0F                                                     
#define ACC_NEXT_ON                                           0x400F                                                
#define ACC_FAST_FORWARD_OFF                                  0x200F                                                
#define ACC_FAST_FORWARD_ON                                   0x600F                                                
#define ACC_PREVIOUS_OFF                                      0x10                                                  
#define ACC_PREVIOUS_ON                                       0x4010                                                
#define ACC_REWIND_OFF                                        0x2010                                                
#define ACC_REWIND_ON                                         0x6010                                                
#define ACC_POC_OFF                                           0x11                                                  
#define ACC_POC_ON                                            0x4011                                                
#define ACC_SYNCHRONISE_BTN_OFF                               0x14                                                  
#define ACC_SYNCHRONISE_BTN_ON                                0x4014                                                
#define ACC_MUSIC_SOURCE_SELECTOR_OFF                         0x15                                                  
#define ACC_MUSIC_SOURCE_SELECTOR_ON                          0x4015                                                
#define ACC_REDIAL_OFF                                        0x16                                                  
#define ACC_REDIAL_ON                                         0x4016                                                
#define ACC_POC_MUTE_OFF                                      0x22                                                  
#define ACC_POC_MUTE_ON                                       0x4022                                                
#define ACC_USB_CLASS_SWITCHING_OFF                           0x23                                                  
#define ACC_USB_CLASS_SWITCHING_ON                            0x4023                                                
#define ACC_MUTE_OFF                                          0x24                                                  
#define ACC_MUTE_ON                                           0x4024                                                
#define ACC_CAR_RADIO_MUTE_OFF                                0x8002                                                
#define ACC_CAR_RADIO_MUTE_ON                                 0xC002                                                
#define ACC_AUDIO_AMPLIFIER_OFF                               0x8005                                                
#define ACC_AUDIO_AMPLIFIER_ON                                0xC005                                                
#define ACC_RING_INDICATOR_OFF                                0x8008                                                
#define ACC_RING_INDICATOR_ON                                 0xC008                                                
#define ACC_CALL_ACTIVE_OFF                                   0x8009                                                
#define ACC_CALL_ACTIVE_ON                                    0xC009                                                
#define ACC_AUDIO_BLOCK_IN_USE_OFF                            0x800E                                                
#define ACC_AUDIO_BLOCK_IN_USE_ON                             0xC00E                                                
#define ACC_STEREO_AUDIO_ACTIVE_OFF                           0x800F                                                
#define ACC_STEREO_AUDIO_ACTIVE_ON                            0xC00F                                                
#define ACC_MONO_AUDIO_ACTIVE_OFF                             0x8010                                                
#define ACC_MONO_AUDIO_ACTIVE_ON                              0xC010                                                

//ConstantTable for ACC_MIC_ID
#define ACC_MIC_NONE                                          0x00                                                     
#define ACC_MIC1                                              0x01                                                     
#define ACC_MIC2                                              0x02                                                     
#define ACC_MIC3                                              0x03                                                     

//ConstantTable for ACC_VIBRA_ON_OFF
//#define ACC_OFF                                             0x00                        //Already defined as 0x00
//#define ACC_ON                                              0x01                        //Already defined as 0x01
#define ACC_FREE                                              0x04                                                     
#define ACC_DURATION                                          0x08                                                     
#define ACC_VIBRA_ALLOC_OFF                                   0x02                                                     
#define ACC_VIBRA_ALLOC_ON                                    0x03                                                     
#define ACC_VIBRA_ALLOC_DURATION                              0x0B                                                     

//BitmaskTables for ACC_BT_DEVICE_MASK
#define ACC_BT_NOT_CONNECTED                                  0x0000                                                     
//#define ACC_BT_HD                                           0x2001                     //Already defined as 0x2001
//#define ACC_BT_CAR_HF                                       0x2002                     //Already defined as 0x2002
//#define ACC_BT_GENERAL_AUDIO                                0x2004                     //Already defined as 0x2004
#define ACC_BT_HD_NOKIA2                                      0x4001                                                  
#define ACC_BT_CAR_HF_NOKIA2                                  0x4002                                                  
//#define ACC_BT_HD_NOKIA                                     0x8001                     //Already defined as 0x8001
//#define ACC_BT_CAR_HF_NOKIA                                 0x8002                     //Already defined as 0x8002

//BitmaskTables for ACC_HOOK_INFORMATION_STATUS
#define ACC_HEADSET_BTN_UP                                    0x00                                                     
#define ACC_HEADSET_BTN_DOWN                                  0x01                                                     
#define ACC_HEADSET_LONG_HOOK                                 0x02                                                     
#define ACC_HEADSET_LHOOK_NOT_DETECTED                        0x00                                                     
#define ACC_HEADSET_LHOOK_DETECTED                            0x01                                                     

//BitmaskTables for ACC_HFU2_POWER_CONTROL
#define ACC_POWERDOWN_NOT_SELECTED                            0x00                                                     
#define ACC_POWERDOWN_SELECTED                                0x01                                                     
#define ACC_CHARGER_OFF                                       0x00                                                     
#define ACC_CHARGER_ON                                        0x01                                                     

//BitmaskTables for ACC_HFU2_AUDIO_PATH
#define ACC_NOT_ROUTE_AUDIOS_TO_SPEAKER                       0x00                                                     
#define ACC_ROUTE_AUDIOS_TO_SPEAKER                           0x01                                                     
#define ACC_NOT_ROUTE_AUDIOS_TO_HANDSET                       0x00                                                     
#define ACC_ROUTE_AUDIOS_TO_HANDSET                           0x01                                                     

//BitmaskTables for ACC_HFU2_UNIT_INFORMATION
#define ACC_STARTUP_IND                                       0x00                                                     
#define ACC_STATE_CHANGE_IND                                  0x01                                                     
#define ACC_IGN_STATE_OFF                                     0x00                                                     
#define ACC_IGN_STATE_ON                                      0x01                                                     
#define ACC_MIC_SPEAKER_NOT_CONNECTED                         0x00                                                     
#define ACC_MIC_SPEAKER_CONNECTED                             0x01                                                     
#define ACC_ACTIVE_MIC_OFF                                    0x00                                                     
#define ACC_ACTIVE_MIC_ON                                     0x01                                                     
#define ACC_TANGENT_UP                                        0x00                                                     
#define ACC_TANGENT_DOWN                                      0x01                                                     
#define ACC_CAR_KIT_CRADLE_OFF_HOOK                           0x00                                                     
#define ACC_CAR_KIT_CRADLE_ON_HOOK                            0x01                                                     
#define ACC_CAR_KIT_HANDSET_OFF_HOOK                          0x00                                                     
#define ACC_CAR_KIT_HANDSET_ON_HOOK                           0x01                                                     
#define ACC_TEST_MODE_OFF                                     0x00                                                     
#define ACC_TEST_MODE_ON                                      0x01                                                     

//BitmaskTables for ACC_HFU2_SELF_TEST_DATA
#define ACC_MEM_TEST_SUCCESS                                  0x00                                                     
#define ACC_MEM_TEST_FAIL                                     0x01                                                     

//BitmaskTables for ACC_AC_COVER_TYPE
#define ACC_AC_NO_COVER                                       0x0000                                                     
#define ACC_AC_I2C                                            0x0001                                                     
#define ACC_AC_ASYNC                                          0x0002                                                     
#define ACC_AC_TYPE_3                                         0x0004                                                     
#define ACC_AC_TYPE_4                                         0x0008                                                     
#define ACC_AC_PWM_1                                          0x0010                                                  
#define ACC_AC_PWM_2                                          0x0020                                                  
#define ACC_AC_PWM_3                                          0x0040                                                  
#define ACC_AC_CTI_1                                          0x0080                                                  
#define ACC_AC_CTI_2                                          0x0100                                                   
#define ACC_AC_FREQ_1                                         0x0200                                                   
#define ACC_AC_FREQ_2                                         0x0400                                                   
#define ACC_AC_FREQ_3                                         0x0800                                                   

//BitmaskTables for ACC_BT_REMOTE_VOLUME_CONTROL
#define ACC_REMOTE_VOLUME_CONTROL                             0x01                                                     

//BitmaskTables for ACC_THWK_INFO_FEATURE_ID
#define ACC_THWK_NO_FEATURE                                   0x0000                                                     
#define ACC_THWK_FLASH_READY_ON                               0x0010                                                  
#define ACC_THWK_LONG_HOOK                                    0x0020                                                  
#define ACC_THWK_CAMERA_LENS_COVER_ON                         0x0040                                                  
#define ACC_THWK_HD_PLUG_ON                                   0x0080                                                  
#define ACC_THWK_SYNC_BTN_ON                                  0x0100                                                   
#define ACC_THWK_DTR_ON                                       0x0200                                                   
#define ACC_THWK_RTS_ON                                       0x0400                                                   
#define ACC_THWK_POWER_SUPPLY_ON                              0x0800                                                   
#define ACC_THWK_HOOK_ON                                      0x1000                                                  
#define ACC_THWK_IGNITION_SENSE_ON                            0x2000                                                  
#define ACC_THWK_EXT_AUDIO_IN                                 0x4000                                                  
#define ACC_THWK_ANSWER_END                                   0x8000                                                  

//BitmaskTables for ACC_THWK_INFO_FEATURE2_ID
//#define ACC_THWK_NO_FEATURE                                 0x00                        //Already defined as 0x00
#define ACC_THWK_BACK_KEY                                     0x01                                                     
#define ACC_THWK_FORWARD_KEY                                  0x02                                                     
#define ACC_THWK_LONG_BACK_KEY                                0x04                                                     
#define ACC_THWK_LONG_FORWARD_KEY                             0x08                                                     

//BitmaskTables for ACC_THWK_EXEC_FEATURE_ID
//#define ACC_THWK_NO_FEATURE                                 0x0000                        //Already defined as 0x0000
#define ACC_THWK_VIDEO_LIGHT_ON                               0x0004                                                     
#define ACC_THWK_FLASH_ACTIVATION_ON                          0x0008                                                     
#define ACC_THWK_CAMERA_MODULE_ON                             0x0010                                                  
#define ACC_THWK_DCD_ON                                       0x0020                                                  
#define ACC_THWK_RI_ON                                        0x0040                                                  
#define ACC_THWK_DSR_ON                                       0x0080                                                  
#define ACC_THWK_CTS_ON                                       0x0100                                                   
#define ACC_THWK_HANDSET_AUDIO_ON                             0x0200                                                   
#define ACC_THWK_CHARGER_ON                                   0x0400                                                   
#define ACC_THWK_POWER_ON                                     0x0800                                                   
#define ACC_THWK_CAR_RADIO_MUTE_ON                            0x1000                                                  
#define ACC_THWK_MUTE_ON                                      0x2000                                                  
#define ACC_THWK_EXT_AUDIO_IN_ON                              0x4000                                                  
#define ACC_THWK_AUD_AMP_ON                                   0x8000                                                  

//BitmaskTables for ACC_VIBRA_PRIORITY
#define ACC_GAME_1                                            0x01                                                     
#define ACC_GAME_2                                            0x02                                                     
#define ACC_RINGTONE_1                                        0x04                                                     
#define ACC_RINGTONE_2                                        0x08                                                     
#define ACC_ALERT_1                                           0x10                                                  
#define ACC_ALERT_2                                           0x20                                                  
#define ACC_HIGHPR_1                                          0x40                                                  
#define ACC_HIGHPR_2                                          0x80                                                  

//BitmaskTables for ACC_DEVICE_PROFILE
#define ACC_DP_NOT_CONNECTED                                  0x00000001                                                     
#define ACC_DP_UNSUPPORTED_CONNECTED                          0x00000002                                                     
#define ACC_DP_CVIDEO                                         0x00000004                                                     
#define ACC_DP_OPEN_CABLE                                     0x00000008                                                     
#define ACC_DP_FM_RADIO_ANTENNA                               0x00000010                                                  
#define ACC_DP_DATA_CABLE                                     0x00000020                                                  

//ConstantTable for FtdTable
#define ACC_SB_FTD_ACC_MODE                                   0x10                                                  
#define ACC_SB_FTD_ACC_DET_ON                                 0x11                                                  
#define ACC_SB_FTD_ACC_HEADINT                                0x12                                                  
#define ACC_SB_FTD_ACC_HOOKINT                                0x13                                                  
#define ACC_SB_FTD_ACC_COUNTER                                0x14                                                  
#define ACC_SB_FTD_ACC_PPHF_WI                                0x15                                                  
#define ACC_SB_FTD_ACC_PPHF_DOWN                              0x16                                                  
#define ACC_SB_FTD_ACC_CHRG_DC                                0x17                                                  
#define ACC_SB_FTD_ACC_HD_BTN_DOWN                            0x18                                                  
#define ACC_SB_FTD_ACC_HFU2_INFO                              0x19                                                  
#define ACC_SB_FTD_ACC_HFU2_SU_INFO                           0x1A                                                  
#define ACC_SB_FTD_ACC_VBR_STATE                              0x1B                                                  
#define ACC_SB_FTD_ACC_VBR_INT                                0x1C                                                  
#define ACC_SB_FTD_ACC_PXM_STATE                              0x1D                                                  
#define ACC_SB_FTD_ACC_ALI_LUM                                0x1E                                                  
#define ACC_SB_FTD_ACC_PXM_REG                                0x1F                                                  
#define ACC_SB_FTD_ACC_ALI_CAL_VAL                            0x20                                                  
#define ACC_SB_FTD_ACC_ALI_TEMP_VAL                           0x21                                                  
#define ACC_SB_FTD_ACC_ALI_RAW_VAL                            0x22                                                  
#define ACC_SB_FTD_ACC_ALI_CALCONV                            0x23                                                  
#define ACC_SB_FTD_ACC_ALI_VCXOTEMP                           0x24                                                  
#define ACC_SB_FTD_ACC_AC_EAD                                 0x25                                                  
#define ACC_SB_FTD_ACC_AC_TYPE                                0x26                                                  
#define ACC_SB_FTD_ACC_AC_STATE                               0x27                                                  
#define ACC_SB_FTD_ACC_MASTYPE                                0x28                                                  
#define ACC_SB_FTD_ACC_SUBTYPE                                0x29                                                  
#define ACC_SB_FTD_ACC_ACCID                                  0x2A                                                  
#define ACC_SB_FTD_ACC_PORTDATA                               0x2B                                                  
#define ACC_SB_FTD_ACC_DDR                                    0x2C                                                  
#define ACC_SB_FTD_ACC_INOPT                                  0x2D                                                  
#define ACC_SB_FTD_ACC_VOUT                                   0x2E                                                  
#define ACC_SB_FTD_ACC_HIGHCURR                               0x2F                                                  
#define ACC_SB_FTD_ACC_PULLUP                                 0x30                                                  
#define ACC_SB_FTD_ACC_BUSY                                   0x31                                                  
#define ACC_SB_FTD_ACC_ACISPDR                                0x32                                                  
#define ACC_SB_FTD_ACC_ACIDELAY                               0x33                                                  
#define ACC_SB_FTD_ACC_AUDBLOCK                               0x34                                                  
#define ACC_SB_FTD_ACC_AB_VER                                 0x35                                                  
#define ACC_SB_FTD_ACC_ACI_DATA1                              0x36                                                  
#define ACC_SB_FTD_ACC_ACI_DATA2                              0x37                                                  
#define ACC_SB_FTD_ACC_ACI_DATA3                              0x38                                                  
#define ACC_SB_FTD_ACC_ACI_DATA4                              0x39                                                  
#define ACC_SB_FTD_ACC_ACI_DATA5                              0x3A                                                  
#define ACC_SB_FTD_ACC_ACI_DATA6                              0x3B                                                  
#define ACC_SB_FTD_ACC_ACI_DATA7                              0x3C                                                  
#define ACC_SB_FTD_ACC_ACI_DATA8                              0x3D                                                  
#define ACC_SB_FTD_NOK_AV_GENIO_STATE                         0x3E                                                  
#define ACC_SB_FTD_NOK_AV_MICDATA                             0x3F                                                  
#define ACC_SB_FTD_NOK_AV_MICVIDEO                            0x40                                                  
#define ACC_SB_FTD_NOK_AV_ECI_HW_VERSION                      0x41                                                  
#define ACC_SB_FTD_NOK_AV_ECI_SW_VERSION                      0x42                                                  
#define ACC_SB_FTD_NOK_AV_MIC_CTRL                            0x43                                                  
#define ACC_SB_FTD_NOK_AV_ECI_PORT_DATA                       0x44                                                  
#define ACC_SB_FTD_NOK_AV_ECI_DDR_REG_DATA                    0x45                                                  
#define ACC_SB_FTD_NOK_AV_ECI_INT_REG_CFG1                    0x46                                                  
#define ACC_SB_FTD_NOK_AV_ECI_INT_REG_CFG2                    0x47                                                  
#define ACC_SB_FTD_NOK_AV_ENH_ID                              0x48                                                  
#define ACC_SB_FTD_NOK_AV_ENH_MOD                             0x49                                                  
#define ACC_SB_FTD_NOK_AV_CONN_CONF                           0x4A                                                  
#define ACC_SB_FTD_NOK_AV_NUM_OF_FEATURES                     0x4B                                                  
#define ACC_SB_FTD_NOK_AV_ACTIVE_STATE                        0x4C                                                  
#define ACC_SB_FTD_NOK_AV_FEA_MAP1                            0x4D                                                  
#define ACC_SB_FTD_NOK_AV_FEA_MAP2                            0x4E                                                  
#define ACC_SB_FTD_NOK_AV_FEA_MAP3                            0x4F                                                  
#define ACC_SB_FTD_NOK_AV_FEA_MAP4                            0x50                                                  
#define ACC_SB_FTD_NOK_AV_FEA_MAP5                            0x51                                                  
#define ACC_SB_FTD_NOK_AV_FEA_MAP6                            0x52                                                  
#define ACC_SB_FTD_NOK_AV_FEA_MAP7                            0x53                                                  
#define ACC_SB_FTD_NOK_AV_FEA_MAP8                            0x54                                                  
#define ACC_SB_FTD_NOK_AV_FEA_MAP9                            0x55                                                  
#define ACC_SB_FTD_NOK_AV_FEA_MAP10                           0x56                                                  
#define ACC_SB_FTD_NOK_AV_FEA_MAP11                           0x57                                                  
#define ACC_SB_FTD_NOK_AV_FEA_MAP12                           0x58                                                  
#define ACC_SB_FTD_NOK_AV_FEA_MAP13                           0x59                                                  
#define ACC_SB_FTD_NOK_AV_FEA_MAP14                           0x5A                                                  
#define ACC_SB_FTD_NOK_AV_FEA_MAP15                           0x5B                                                  
#define ACC_SB_FTD_NOK_AV_FEA_MAP16                           0x5C                                                  
#define ACC_SB_FTD_NOK_AV_AUDIO_PROFILE                       0x5D                                                  
#define ACC_SB_FTD_NOK_AV_AUDIO_TYPE                          0x5E                                                  
#define ACC_SB_FTD_NOK_AV_DEV_PROFILE                         0x5F                                                  
#define ACC_SB_FTD_NOK_AV_ENH_ACTIVE                          0x60                                                  


//SUBBLOCKS


//Definition for struct ACC_SB_PXM_DETECTION_CALIB_PARAMETERS
//#define ACC_SB_PXM_DETECTION_CALIB_PARAMETERS               0x10                       //Already defined as 0x10
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_length;
             uint8_t      gain;
             uint8_t      det_tr;
             int8_t       det_offset;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
            } __attribute__((packed)) ACC_SB_PXM_DETECTION_CALIB_PARAMETERS_STR;
#define SIZE_ACC_SB_PXM_DETECTION_CALIB_PARAMETERS            sizeof(ACC_SB_PXM_DETECTION_CALIB_PARAMETERS_STR)


//Definition for struct ACC_SB_PXM_FAULT_CALIB_PARAMETERS
//#define ACC_SB_PXM_FAULT_CALIB_PARAMETERS                   0x11                       //Already defined as 0x11
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_length;
             uint8_t      fault_tr;
             int8_t       fault_offset;
            } __attribute__((packed)) ACC_SB_PXM_FAULT_CALIB_PARAMETERS_STR;
#define SIZE_ACC_SB_PXM_FAULT_CALIB_PARAMETERS                sizeof(ACC_SB_PXM_FAULT_CALIB_PARAMETERS_STR)


//Definition for struct ACC_SB_PXM_DETECTION_CALIB_RESULT
//#define ACC_SB_PXM_DETECTION_CALIB_RESULT                   0x12                       //Already defined as 0x12
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_length;
             uint8_t      status;
             uint8_t      gain;
             uint8_t      det_tr;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
            } __attribute__((packed)) ACC_SB_PXM_DETECTION_CALIB_RESULT_STR;
#define SIZE_ACC_SB_PXM_DETECTION_CALIB_RESULT                sizeof(ACC_SB_PXM_DETECTION_CALIB_RESULT_STR)


//Definition for struct ACC_SB_PXM_FAULT_CALIB_RESULT
//#define ACC_SB_PXM_FAULT_CALIB_RESULT                       0x13                       //Already defined as 0x13
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_length;
             uint8_t      status;
             uint8_t      fault_tr;
            } __attribute__((packed)) ACC_SB_PXM_FAULT_CALIB_RESULT_STR;
#define SIZE_ACC_SB_PXM_FAULT_CALIB_RESULT                    sizeof(ACC_SB_PXM_FAULT_CALIB_RESULT_STR)


//Definition for struct ACC_MODEL_STRING_DATA
#define ACC_MODEL_STRING_DATA                                 0x00                                                     
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_length;
             uint8_t      ascii_string[18];
            } __attribute__((packed)) ACC_MODEL_STRING_DATA_STR;
#define SIZE_ACC_MODEL_STRING_DATA                            sizeof(ACC_MODEL_STRING_DATA_STR)


//Definition for struct ACC_SB_AUDIO_BLOCK
#define ACC_SB_AUDIO_BLOCK                                    0x05                                                     
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_length;
             uint16_t     feature;
             uint8_t      audio_block_data[19];
             uint8_t      fillerbyte1;
            } __attribute__((packed)) ACC_SB_AUDIO_BLOCK_STR;
#define SIZE_ACC_SB_AUDIO_BLOCK                               sizeof(ACC_SB_AUDIO_BLOCK_STR)


//Definition for struct ACC_SB_AUDIO_BLOCK_EXTENSION
#define ACC_SB_AUDIO_BLOCK_EXTENSION                          0x06                                                     
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_length;
             uint16_t     feature;
             uint8_t      audio_block_data[11];
             uint8_t      fillerbyte1;
            } __attribute__((packed)) ACC_SB_AUDIO_BLOCK_EXTENSION_STR;
#define SIZE_ACC_SB_AUDIO_BLOCK_EXTENSION                     sizeof(ACC_SB_AUDIO_BLOCK_EXTENSION_STR)


//Definition for struct ACC_SB_FEATURES
#define ACC_SB_FEATURES                                       0x04                                                     
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_length;
             uint8_t      fillerbyte1;
             uint8_t      feature_count;
             uint16_t     features[0];
            } __attribute__((packed)) ACC_SB_FEATURES_STR;
#define SIZE_ACC_SB_FEATURES                                  sizeof(ACC_SB_FEATURES_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct ACC_SB_EKEY
#define ACC_SB_EKEY                                           0x07                                                     
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_length;
             uint16_t     enhancement_id;
             uint8_t      enhancement_mod;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
            } __attribute__((packed)) ACC_SB_EKEY_STR;
#define SIZE_ACC_SB_EKEY                                      sizeof(ACC_SB_EKEY_STR)


//MESSAGES


//Definition for struct ACC_PXM_CALIB_REQ
#define ACC_PXM_CALIB_REQ                                     0x40                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      action;
             uint8_t      sub_block_count;
            } __attribute__((packed)) ACC_PXM_CALIB_REQ_STR;
#define SIZE_ACC_PXM_CALIB_REQ                                sizeof(ACC_PXM_CALIB_REQ_STR)


//Definition for struct ACC_PXM_CALIB_RESP
#define ACC_PXM_CALIB_RESP                                    0x41                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      action;
             uint8_t      sub_block_count;
            } __attribute__((packed)) ACC_PXM_CALIB_RESP_STR;
#define SIZE_ACC_PXM_CALIB_RESP                               sizeof(ACC_PXM_CALIB_RESP_STR)


//Definition for struct ACC_PXM_CONTROL_REQ
#define ACC_PXM_CONTROL_REQ                                   0x00                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      control;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) ACC_PXM_CONTROL_REQ_STR;
#define SIZE_ACC_PXM_CONTROL_REQ                              sizeof(ACC_PXM_CONTROL_REQ_STR)


//Definition for struct ACC_PXM_CONTROL_RESP
#define ACC_PXM_CONTROL_RESP                                  0x01                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) ACC_PXM_CONTROL_RESP_STR;
#define SIZE_ACC_PXM_CONTROL_RESP                             sizeof(ACC_PXM_CONTROL_RESP_STR)


//Definition for struct ACC_PXM_DETECT_REQ
#define ACC_PXM_DETECT_REQ                                    0x02                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) ACC_PXM_DETECT_REQ_STR;
#define SIZE_ACC_PXM_DETECT_REQ                               sizeof(ACC_PXM_DETECT_REQ_STR)


//Definition for struct ACC_PXM_DETECT_RESP
#define ACC_PXM_DETECT_RESP                                   0x03                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      pxm_status;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) ACC_PXM_DETECT_RESP_STR;
#define SIZE_ACC_PXM_DETECT_RESP                              sizeof(ACC_PXM_DETECT_RESP_STR)


//Definition for struct ACC_PXM_DETECT_IND
#define ACC_PXM_DETECT_IND                                    0x04                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      pxm_status;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) ACC_PXM_DETECT_IND_STR;
#define SIZE_ACC_PXM_DETECT_IND                               sizeof(ACC_PXM_DETECT_IND_STR)


//Definition for struct ACC_ALI_READ_REQ
#define ACC_ALI_READ_REQ                                      0x05                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) ACC_ALI_READ_REQ_STR;
#define SIZE_ACC_ALI_READ_REQ                                 sizeof(ACC_ALI_READ_REQ_STR)


//Definition for struct ACC_ALI_READ_RESP
#define ACC_ALI_READ_RESP                                     0x06                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      luminance;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) ACC_ALI_READ_RESP_STR;
#define SIZE_ACC_ALI_READ_RESP                                sizeof(ACC_ALI_READ_RESP_STR)


//Definition for struct ACC_ALI_CALIB_REQ
#define ACC_ALI_CALIB_REQ                                     0x48                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             int16_t      ref_level;
            } __attribute__((packed)) ACC_ALI_CALIB_REQ_STR;
#define SIZE_ACC_ALI_CALIB_REQ                                sizeof(ACC_ALI_CALIB_REQ_STR)


//Definition for struct ACC_ALI_CALIB_RESP
#define ACC_ALI_CALIB_RESP                                    0x49                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             int16_t      start_level;
             uint16_t     cal_conv;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) ACC_ALI_CALIB_RESP_STR;
#define SIZE_ACC_ALI_CALIB_RESP                               sizeof(ACC_ALI_CALIB_RESP_STR)


//Definition for struct ACC_ALI_TUNE_REQ
#define ACC_ALI_TUNE_REQ                                      0x07                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             int8_t       user_diff;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) ACC_ALI_TUNE_REQ_STR;
#define SIZE_ACC_ALI_TUNE_REQ                                 sizeof(ACC_ALI_TUNE_REQ_STR)


//Definition for struct ACC_ALI_TUNE_RESP
#define ACC_ALI_TUNE_RESP                                     0x08                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) ACC_ALI_TUNE_RESP_STR;
#define SIZE_ACC_ALI_TUNE_RESP                                sizeof(ACC_ALI_TUNE_RESP_STR)


//Definition for struct ACC_ALI_TRIGGER_REQ
#define ACC_ALI_TRIGGER_REQ                                   0x09                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             int8_t       trigger_level;
             uint8_t      trigger_type;
            } __attribute__((packed)) ACC_ALI_TRIGGER_REQ_STR;
#define SIZE_ACC_ALI_TRIGGER_REQ                              sizeof(ACC_ALI_TRIGGER_REQ_STR)


//Definition for struct ACC_ALI_TRIGGER_RESP
#define ACC_ALI_TRIGGER_RESP                                  0x0A                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) ACC_ALI_TRIGGER_RESP_STR;
#define SIZE_ACC_ALI_TRIGGER_RESP                             sizeof(ACC_ALI_TRIGGER_RESP_STR)


//Definition for struct ACC_ALI_TRIGGER_IND
#define ACC_ALI_TRIGGER_IND                                   0x0B                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      trigger_info;
             uint8_t      luminance;
            } __attribute__((packed)) ACC_ALI_TRIGGER_IND_STR;
#define SIZE_ACC_ALI_TRIGGER_IND                              sizeof(ACC_ALI_TRIGGER_IND_STR)


//Definition for struct ACC_VIBRA_CTRL_REQ
#define ACC_VIBRA_CTRL_REQ                                    0x0C                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      vibra_control;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) ACC_VIBRA_CTRL_REQ_STR;
#define SIZE_ACC_VIBRA_CTRL_REQ                               sizeof(ACC_VIBRA_CTRL_REQ_STR)


//Definition for struct ACC_VIBRA_CTRL_RESP
#define ACC_VIBRA_CTRL_RESP                                   0x0D                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) ACC_VIBRA_CTRL_RESP_STR;
#define SIZE_ACC_VIBRA_CTRL_RESP                              sizeof(ACC_VIBRA_CTRL_RESP_STR)


//Definition for struct ACC_VIBRA_CLKFREQ_REQ
#define ACC_VIBRA_CLKFREQ_REQ                                 0x0E                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      intensity;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) ACC_VIBRA_CLKFREQ_REQ_STR;
#define SIZE_ACC_VIBRA_CLKFREQ_REQ                            sizeof(ACC_VIBRA_CLKFREQ_REQ_STR)


//Definition for struct ACC_VIBRA_CLKFREQ_RESP
#define ACC_VIBRA_CLKFREQ_RESP                                0x0F                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) ACC_VIBRA_CLKFREQ_RESP_STR;
#define SIZE_ACC_VIBRA_CLKFREQ_RESP                           sizeof(ACC_VIBRA_CLKFREQ_RESP_STR)


//Definition for struct ACC_VIBRA_CONTROL_CHANGE_REQ
#define ACC_VIBRA_CONTROL_CHANGE_REQ                          0x7C                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      control_change_flag;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) ACC_VIBRA_CONTROL_CHANGE_REQ_STR;
#define SIZE_ACC_VIBRA_CONTROL_CHANGE_REQ                     sizeof(ACC_VIBRA_CONTROL_CHANGE_REQ_STR)


//Definition for struct ACC_VIBRA_CONTROL_CHANGE_RESP
#define ACC_VIBRA_CONTROL_CHANGE_RESP                         0x7D                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) ACC_VIBRA_CONTROL_CHANGE_RESP_STR;
#define SIZE_ACC_VIBRA_CONTROL_CHANGE_RESP                    sizeof(ACC_VIBRA_CONTROL_CHANGE_RESP_STR)


//Definition for struct ACC_MODE_GET_REQ
#define ACC_MODE_GET_REQ                                      0x10                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) ACC_MODE_GET_REQ_STR;
#define SIZE_ACC_MODE_GET_REQ                                 sizeof(ACC_MODE_GET_REQ_STR)


//Definition for struct ACC_MODE_GET_RESP
#define ACC_MODE_GET_RESP                                     0x11                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      accessory_mode;
             uint8_t      dct3dct4_ext;
            } __attribute__((packed)) ACC_MODE_GET_RESP_STR;
#define SIZE_ACC_MODE_GET_RESP                                sizeof(ACC_MODE_GET_RESP_STR)


//Definition for struct ACC_MODE_CHANGED_IND
#define ACC_MODE_CHANGED_IND                                  0x12                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      accessory_mode;
             uint8_t      dct3dct4_ext;
            } __attribute__((packed)) ACC_MODE_CHANGED_IND_STR;
#define SIZE_ACC_MODE_CHANGED_IND                             sizeof(ACC_MODE_CHANGED_IND_STR)


//Definition for struct ACC_ATTACH_REQ
#define ACC_ATTACH_REQ                                        0x50                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      pn_dev_id;
             uint8_t      pn_obj_id;
             uint8_t      bt_dev_addr[6];
             uint16_t     bt_device;
             uint8_t      supported_features;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
            } __attribute__((packed)) ACC_ATTACH_REQ_STR;
#define SIZE_ACC_ATTACH_REQ                                   sizeof(ACC_ATTACH_REQ_STR)


//Definition for struct ACC_ATTACH_RESP
#define ACC_ATTACH_RESP                                       0x51                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) ACC_ATTACH_RESP_STR;
#define SIZE_ACC_ATTACH_RESP                                  sizeof(ACC_ATTACH_RESP_STR)


//Definition for struct ACC_DETACH_REQ
#define ACC_DETACH_REQ                                        0x52                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      pn_dev_id;
             uint8_t      pn_obj_id;
             uint8_t      bt_dev_addr[6];
             uint16_t     bt_device;
            } __attribute__((packed)) ACC_DETACH_REQ_STR;
#define SIZE_ACC_DETACH_REQ                                   sizeof(ACC_DETACH_REQ_STR)


//Definition for struct ACC_DETACH_RESP
#define ACC_DETACH_RESP                                       0x53                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) ACC_DETACH_RESP_STR;
#define SIZE_ACC_DETACH_RESP                                  sizeof(ACC_DETACH_RESP_STR)


//Definition for struct ACC_BT_MODE_CHANGED_IND
#define ACC_BT_MODE_CHANGED_IND                               0x54                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      pn_dev_id;
             uint8_t      pn_obj_id;
             uint8_t      bt_dev_addr[6];
             uint16_t     bt_device;
             uint16_t     bt_device_mask;
             uint8_t      supported_features;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) ACC_BT_MODE_CHANGED_IND_STR;
#define SIZE_ACC_BT_MODE_CHANGED_IND                          sizeof(ACC_BT_MODE_CHANGED_IND_STR)


//Definition for struct ACC_SET_LPS_MODE_REQ
#define ACC_SET_LPS_MODE_REQ                                  0x13                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      force_mode;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) ACC_SET_LPS_MODE_REQ_STR;
#define SIZE_ACC_SET_LPS_MODE_REQ                             sizeof(ACC_SET_LPS_MODE_REQ_STR)


//Definition for struct ACC_SET_LPS_MODE_RESP
#define ACC_SET_LPS_MODE_RESP                                 0x14                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) ACC_SET_LPS_MODE_RESP_STR;
#define SIZE_ACC_SET_LPS_MODE_RESP                            sizeof(ACC_SET_LPS_MODE_RESP_STR)


//Definition for struct ACC_LPS_MODE_GET_REQ
#define ACC_LPS_MODE_GET_REQ                                  0x29                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) ACC_LPS_MODE_GET_REQ_STR;
#define SIZE_ACC_LPS_MODE_GET_REQ                             sizeof(ACC_LPS_MODE_GET_REQ_STR)


//Definition for struct ACC_LPS_MODE_GET_RESP
#define ACC_LPS_MODE_GET_RESP                                 0x2A                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      force_mode;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) ACC_LPS_MODE_GET_RESP_STR;
#define SIZE_ACC_LPS_MODE_GET_RESP                            sizeof(ACC_LPS_MODE_GET_RESP_STR)


//Definition for struct ACC_TEST_MODE_REQ
#define ACC_TEST_MODE_REQ                                     0x2B                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      test_mode_flag;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) ACC_TEST_MODE_REQ_STR;
#define SIZE_ACC_TEST_MODE_REQ                                sizeof(ACC_TEST_MODE_REQ_STR)


//Definition for struct ACC_TEST_MODE_RESP
#define ACC_TEST_MODE_RESP                                    0x2C                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) ACC_TEST_MODE_RESP_STR;
#define SIZE_ACC_TEST_MODE_RESP                               sizeof(ACC_TEST_MODE_RESP_STR)


//Definition for struct ACC_TEST_REQ
#define ACC_TEST_REQ                                          0x35                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      action;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) ACC_TEST_REQ_STR;
#define SIZE_ACC_TEST_REQ                                     sizeof(ACC_TEST_REQ_STR)


//Definition for struct ACC_TEST_RESP
#define ACC_TEST_RESP                                         0x36                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      action;
             uint8_t      status;
            } __attribute__((packed)) ACC_TEST_RESP_STR;
#define SIZE_ACC_TEST_RESP                                    sizeof(ACC_TEST_RESP_STR)


//Definition for struct ACC_HOOK_INFO_IND
#define ACC_HOOK_INFO_IND                                     0x15                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      state;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) ACC_HOOK_INFO_IND_STR;
#define SIZE_ACC_HOOK_INFO_IND                                sizeof(ACC_HOOK_INFO_IND_STR)


//Definition for struct ACC_CRM_REQ
#define ACC_CRM_REQ                                           0x16                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      mute_state;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) ACC_CRM_REQ_STR;
#define SIZE_ACC_CRM_REQ                                      sizeof(ACC_CRM_REQ_STR)


//Definition for struct ACC_CRM_RESP
#define ACC_CRM_RESP                                          0x17                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      mode_status;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) ACC_CRM_RESP_STR;
#define SIZE_ACC_CRM_RESP                                     sizeof(ACC_CRM_RESP_STR)


//Definition for struct ACC_IGN_STATE_GET_REQ
#define ACC_IGN_STATE_GET_REQ                                 0x18                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) ACC_IGN_STATE_GET_REQ_STR;
#define SIZE_ACC_IGN_STATE_GET_REQ                            sizeof(ACC_IGN_STATE_GET_REQ_STR)


//Definition for struct ACC_IGN_STATE_GET_RESP
#define ACC_IGN_STATE_GET_RESP                                0x19                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      mode_status;
             uint8_t      ignition_state;
            } __attribute__((packed)) ACC_IGN_STATE_GET_RESP_STR;
#define SIZE_ACC_IGN_STATE_GET_RESP                           sizeof(ACC_IGN_STATE_GET_RESP_STR)


//Definition for struct ACC_AMC_REQ
#define ACC_AMC_REQ                                           0x1A                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      amc_state;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) ACC_AMC_REQ_STR;
#define SIZE_ACC_AMC_REQ                                      sizeof(ACC_AMC_REQ_STR)


//Definition for struct ACC_AMC_RESP
#define ACC_AMC_RESP                                          0x1B                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      mode_status;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) ACC_AMC_RESP_STR;
#define SIZE_ACC_AMC_RESP                                     sizeof(ACC_AMC_RESP_STR)


//Definition for struct ACC_VOLUME_REQ
#define ACC_VOLUME_REQ                                        0x1C                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      volume;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) ACC_VOLUME_REQ_STR;
#define SIZE_ACC_VOLUME_REQ                                   sizeof(ACC_VOLUME_REQ_STR)


//Definition for struct ACC_VOLUME_RESP
#define ACC_VOLUME_RESP                                       0x1D                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      mode_status;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) ACC_VOLUME_RESP_STR;
#define SIZE_ACC_VOLUME_RESP                                  sizeof(ACC_VOLUME_RESP_STR)


//Definition for struct ACC_MIC_GAIN_REQ
#define ACC_MIC_GAIN_REQ                                      0x1E                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      gain;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) ACC_MIC_GAIN_REQ_STR;
#define SIZE_ACC_MIC_GAIN_REQ                                 sizeof(ACC_MIC_GAIN_REQ_STR)


//Definition for struct ACC_MIC_GAIN_RESP
#define ACC_MIC_GAIN_RESP                                     0x1F                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      mode_status;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) ACC_MIC_GAIN_RESP_STR;
#define SIZE_ACC_MIC_GAIN_RESP                                sizeof(ACC_MIC_GAIN_RESP_STR)


//Definition for struct ACC_POWER_REQ
#define ACC_POWER_REQ                                         0x20                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      power_data;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) ACC_POWER_REQ_STR;
#define SIZE_ACC_POWER_REQ                                    sizeof(ACC_POWER_REQ_STR)


//Definition for struct ACC_POWER_RESP
#define ACC_POWER_RESP                                        0x21                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      mode_status;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) ACC_POWER_RESP_STR;
#define SIZE_ACC_POWER_RESP                                   sizeof(ACC_POWER_RESP_STR)


//Definition for struct ACC_AUDIO_REQ
#define ACC_AUDIO_REQ                                         0x22                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      audio_paths;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) ACC_AUDIO_REQ_STR;
#define SIZE_ACC_AUDIO_REQ                                    sizeof(ACC_AUDIO_REQ_STR)


//Definition for struct ACC_AUDIO_RESP
#define ACC_AUDIO_RESP                                        0x23                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      mode_status;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) ACC_AUDIO_RESP_STR;
#define SIZE_ACC_AUDIO_RESP                                   sizeof(ACC_AUDIO_RESP_STR)


//Definition for struct ACC_MODEL_READ_REQ
#define ACC_MODEL_READ_REQ                                    0x24                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) ACC_MODEL_READ_REQ_STR;
#define SIZE_ACC_MODEL_READ_REQ                               sizeof(ACC_MODEL_READ_REQ_STR)


//Definition for struct ACC_MODEL_READ_RESP
#define ACC_MODEL_READ_RESP                                   0x25                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      mode_status;
             uint8_t      sub_block_count;
            } __attribute__((packed)) ACC_MODEL_READ_RESP_STR;
#define SIZE_ACC_MODEL_READ_RESP                              sizeof(ACC_MODEL_READ_RESP_STR)


//Definition for struct ACC_CAR_KIT_MODE_CHANGED_IND
#define ACC_CAR_KIT_MODE_CHANGED_IND                          0x26                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      unit_data;
             uint8_t      self_test_data;
            } __attribute__((packed)) ACC_CAR_KIT_MODE_CHANGED_IND_STR;
#define SIZE_ACC_CAR_KIT_MODE_CHANGED_IND                     sizeof(ACC_CAR_KIT_MODE_CHANGED_IND_STR)


//Definition for struct ACC_CAR_KIT_MODE_GET_REQ
#define ACC_CAR_KIT_MODE_GET_REQ                              0x27                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) ACC_CAR_KIT_MODE_GET_REQ_STR;
#define SIZE_ACC_CAR_KIT_MODE_GET_REQ                         sizeof(ACC_CAR_KIT_MODE_GET_REQ_STR)


//Definition for struct ACC_CAR_KIT_MODE_GET_RESP
#define ACC_CAR_KIT_MODE_GET_RESP                             0x28                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      mode_status;
             uint8_t      unit_data;
             uint8_t      self_test_data;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
            } __attribute__((packed)) ACC_CAR_KIT_MODE_GET_RESP_STR;
#define SIZE_ACC_CAR_KIT_MODE_GET_RESP                        sizeof(ACC_CAR_KIT_MODE_GET_RESP_STR)


//Definition for struct ACC_AC_MODE_CHANGED_IND
#define ACC_AC_MODE_CHANGED_IND                               0x62                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint16_t     cover_type;
            } __attribute__((packed)) ACC_AC_MODE_CHANGED_IND_STR;
#define SIZE_ACC_AC_MODE_CHANGED_IND                          sizeof(ACC_AC_MODE_CHANGED_IND_STR)


//Definition for struct ACC_AC_CONTROL_REQ
#define ACC_AC_CONTROL_REQ                                    0x63                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      cover_control;
             uint8_t      mode_control;
            } __attribute__((packed)) ACC_AC_CONTROL_REQ_STR;
#define SIZE_ACC_AC_CONTROL_REQ                               sizeof(ACC_AC_CONTROL_REQ_STR)


//Definition for struct ACC_AC_CONTROL_RESP
#define ACC_AC_CONTROL_RESP                                   0x64                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      cover_status;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) ACC_AC_CONTROL_RESP_STR;
#define SIZE_ACC_AC_CONTROL_RESP                              sizeof(ACC_AC_CONTROL_RESP_STR)


//Definition for struct ACC_AC_MODE_GET_REQ
#define ACC_AC_MODE_GET_REQ                                   0x65                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) ACC_AC_MODE_GET_REQ_STR;
#define SIZE_ACC_AC_MODE_GET_REQ                              sizeof(ACC_AC_MODE_GET_REQ_STR)


//Definition for struct ACC_AC_MODE_GET_RESP
#define ACC_AC_MODE_GET_RESP                                  0x66                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint16_t     cover_type;
            } __attribute__((packed)) ACC_AC_MODE_GET_RESP_STR;
#define SIZE_ACC_AC_MODE_GET_RESP                             sizeof(ACC_AC_MODE_GET_RESP_STR)


//Definition for struct ACC_THWK_MODE_GET_REQ
#define ACC_THWK_MODE_GET_REQ                                 0x2D                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) ACC_THWK_MODE_GET_REQ_STR;
#define SIZE_ACC_THWK_MODE_GET_REQ                            sizeof(ACC_THWK_MODE_GET_REQ_STR)


//Definition for struct ACC_THWK_MODE_GET_RESP
#define ACC_THWK_MODE_GET_RESP                                0x2E                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      master_type;
             uint8_t      sub_type;
             uint8_t      acc_id;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      sub_block_count;
            } __attribute__((packed)) ACC_THWK_MODE_GET_RESP_STR;
#define SIZE_ACC_THWK_MODE_GET_RESP                           sizeof(ACC_THWK_MODE_GET_RESP_STR)


//Definition for struct ACC_THWK_MODE_CHANGED_IND
#define ACC_THWK_MODE_CHANGED_IND                             0x2F                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      master_type;
             uint8_t      sub_type;
             uint8_t      acc_id;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      sub_block_count;
            } __attribute__((packed)) ACC_THWK_MODE_CHANGED_IND_STR;
#define SIZE_ACC_THWK_MODE_CHANGED_IND                        sizeof(ACC_THWK_MODE_CHANGED_IND_STR)


//Definition for struct ACC_THWK_FEATURE_INFO_REQ
#define ACC_THWK_FEATURE_INFO_REQ                             0x30                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) ACC_THWK_FEATURE_INFO_REQ_STR;
#define SIZE_ACC_THWK_FEATURE_INFO_REQ                        sizeof(ACC_THWK_FEATURE_INFO_REQ_STR)


//Definition for struct ACC_THWK_FEATURE_INFO_RESP
#define ACC_THWK_FEATURE_INFO_RESP                            0x31                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      sub_block_count;
            } __attribute__((packed)) ACC_THWK_FEATURE_INFO_RESP_STR;
#define SIZE_ACC_THWK_FEATURE_INFO_RESP                       sizeof(ACC_THWK_FEATURE_INFO_RESP_STR)


//Definition for struct ACC_THWK_FEATURE_INFO_IND
#define ACC_THWK_FEATURE_INFO_IND                             0x32                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      sub_block_count;
            } __attribute__((packed)) ACC_THWK_FEATURE_INFO_IND_STR;
#define SIZE_ACC_THWK_FEATURE_INFO_IND                        sizeof(ACC_THWK_FEATURE_INFO_IND_STR)


//Definition for struct ACC_THWK_FEATURE_EXEC_REQ
#define ACC_THWK_FEATURE_EXEC_REQ                             0x33                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      sub_block_count;
            } __attribute__((packed)) ACC_THWK_FEATURE_EXEC_REQ_STR;
#define SIZE_ACC_THWK_FEATURE_EXEC_REQ                        sizeof(ACC_THWK_FEATURE_EXEC_REQ_STR)


//Definition for struct ACC_THWK_FEATURE_EXEC_RESP
#define ACC_THWK_FEATURE_EXEC_RESP                            0x34                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) ACC_THWK_FEATURE_EXEC_RESP_STR;
#define SIZE_ACC_THWK_FEATURE_EXEC_RESP                       sizeof(ACC_THWK_FEATURE_EXEC_RESP_STR)


//Definition for struct ACC_VIBRA_CONTROL_REQ
#define ACC_VIBRA_CONTROL_REQ                                 0x67                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      priority;
             int8_t       intensity;
             uint8_t      action;
             uint8_t      fillerbyte1;
             uint16_t     duration;
            } __attribute__((packed)) ACC_VIBRA_CONTROL_REQ_STR;
#define SIZE_ACC_VIBRA_CONTROL_REQ                            sizeof(ACC_VIBRA_CONTROL_REQ_STR)


//Definition for struct ACC_VIBRA_CONTROL_RESP
#define ACC_VIBRA_CONTROL_RESP                                0x68                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      priority_table;
            } __attribute__((packed)) ACC_VIBRA_CONTROL_RESP_STR;
#define SIZE_ACC_VIBRA_CONTROL_RESP                           sizeof(ACC_VIBRA_CONTROL_RESP_STR)


//Definition for struct ACC_VIBRA_STATUS_GET_REQ
#define ACC_VIBRA_STATUS_GET_REQ                              0x69                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) ACC_VIBRA_STATUS_GET_REQ_STR;
#define SIZE_ACC_VIBRA_STATUS_GET_REQ                         sizeof(ACC_VIBRA_STATUS_GET_REQ_STR)


//Definition for struct ACC_VIBRA_STATUS_GET_RESP
#define ACC_VIBRA_STATUS_GET_RESP                             0x6A                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             int8_t       current_int;
             uint8_t      default_int;
             uint8_t      int_upp_limit;
             uint8_t      int_low_limit;
             uint8_t      priority_table;
             uint8_t      current_state;
            } __attribute__((packed)) ACC_VIBRA_STATUS_GET_RESP_STR;
#define SIZE_ACC_VIBRA_STATUS_GET_RESP                        sizeof(ACC_VIBRA_STATUS_GET_RESP_STR)


//Definition for struct ACC_AC_OPERATION_REQ
#define ACC_AC_OPERATION_REQ                                  0x6B                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      operation;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) ACC_AC_OPERATION_REQ_STR;
#define SIZE_ACC_AC_OPERATION_REQ                             sizeof(ACC_AC_OPERATION_REQ_STR)


//Definition for struct ACC_AC_OPERATION_RESP
#define ACC_AC_OPERATION_RESP                                 0x6C                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      result;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) ACC_AC_OPERATION_RESP_STR;
#define SIZE_ACC_AC_OPERATION_RESP                            sizeof(ACC_AC_OPERATION_RESP_STR)


//Definition for struct ACC_VIBRA_EVENTS_SUBSCRIBE_REQ
#define ACC_VIBRA_EVENTS_SUBSCRIBE_REQ                        0x70                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) ACC_VIBRA_EVENTS_SUBSCRIBE_REQ_STR;
#define SIZE_ACC_VIBRA_EVENTS_SUBSCRIBE_REQ                   sizeof(ACC_VIBRA_EVENTS_SUBSCRIBE_REQ_STR)


//Definition for struct ACC_VIBRA_EVENTS_SUBSCRIBE_RESP
#define ACC_VIBRA_EVENTS_SUBSCRIBE_RESP                       0x71                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) ACC_VIBRA_EVENTS_SUBSCRIBE_RESP_STR;
#define SIZE_ACC_VIBRA_EVENTS_SUBSCRIBE_RESP                  sizeof(ACC_VIBRA_EVENTS_SUBSCRIBE_RESP_STR)


//Definition for struct ACC_VIBRA_ON_EVENT_ALLOW_REQ
#define ACC_VIBRA_ON_EVENT_ALLOW_REQ                          0x72                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      runmode;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) ACC_VIBRA_ON_EVENT_ALLOW_REQ_STR;
#define SIZE_ACC_VIBRA_ON_EVENT_ALLOW_REQ                     sizeof(ACC_VIBRA_ON_EVENT_ALLOW_REQ_STR)


//Definition for struct ACC_VIBRA_ON_EVENT_ALLOW_RESP
#define ACC_VIBRA_ON_EVENT_ALLOW_RESP                         0x73                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) ACC_VIBRA_ON_EVENT_ALLOW_RESP_STR;
#define SIZE_ACC_VIBRA_ON_EVENT_ALLOW_RESP                    sizeof(ACC_VIBRA_ON_EVENT_ALLOW_RESP_STR)


//Definition for struct ACC_VIBRA_EVENT_ON_NTF
#define ACC_VIBRA_EVENT_ON_NTF                                0x74                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) ACC_VIBRA_EVENT_ON_NTF_STR;
#define SIZE_ACC_VIBRA_EVENT_ON_NTF                           sizeof(ACC_VIBRA_EVENT_ON_NTF_STR)


//Definition for struct ACC_VIBRA_EVENT_OFF_NTF
#define ACC_VIBRA_EVENT_OFF_NTF                               0x75                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) ACC_VIBRA_EVENT_OFF_NTF_STR;
#define SIZE_ACC_VIBRA_EVENT_OFF_NTF                          sizeof(ACC_VIBRA_EVENT_OFF_NTF_STR)


//Definition for struct ACC_CONNECTION_IND
#define ACC_CONNECTION_IND                                    0x37                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      audio_profile;
             uint8_t      audio_type;
             uint32_t     device_profile;
             uint8_t      active;
             uint8_t      connector;
             uint8_t      fillerbyte1;
             uint8_t      sub_block_count;
            } __attribute__((packed)) ACC_CONNECTION_IND_STR;
#define SIZE_ACC_CONNECTION_IND                               sizeof(ACC_CONNECTION_IND_STR)


//Definition for struct ACC_CONNECTION_GET_REQ
#define ACC_CONNECTION_GET_REQ                                0x38                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      connector;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) ACC_CONNECTION_GET_REQ_STR;
#define SIZE_ACC_CONNECTION_GET_REQ                           sizeof(ACC_CONNECTION_GET_REQ_STR)


//Definition for struct ACC_CONNECTION_GET_RESP
#define ACC_CONNECTION_GET_RESP                               0x39                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      audio_profile;
             uint8_t      audio_type;
             uint32_t     device_profile;
             uint8_t      active;
             uint8_t      connector;
             uint8_t      fillerbyte1;
             uint8_t      sub_block_count;
            } __attribute__((packed)) ACC_CONNECTION_GET_RESP_STR;
#define SIZE_ACC_CONNECTION_GET_RESP                          sizeof(ACC_CONNECTION_GET_RESP_STR)


//Definition for struct ACC_CONNECTION_STATE_SET_REQ
#define ACC_CONNECTION_STATE_SET_REQ                          0x3A                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      active;
             uint8_t      connector;
            } __attribute__((packed)) ACC_CONNECTION_STATE_SET_REQ_STR;
#define SIZE_ACC_CONNECTION_STATE_SET_REQ                     sizeof(ACC_CONNECTION_STATE_SET_REQ_STR)


//Definition for struct ACC_CONNECTION_STATE_SET_RESP
#define ACC_CONNECTION_STATE_SET_RESP                         0x3B                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) ACC_CONNECTION_STATE_SET_RESP_STR;
#define SIZE_ACC_CONNECTION_STATE_SET_RESP                    sizeof(ACC_CONNECTION_STATE_SET_RESP_STR)


//Definition for struct ACC_CONNECTION_CHANGE_REQ
#define ACC_CONNECTION_CHANGE_REQ                             0x3C                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      audio_profile;
             uint8_t      audio_type;
             uint32_t     device_profile;
             uint8_t      connector;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
            } __attribute__((packed)) ACC_CONNECTION_CHANGE_REQ_STR;
#define SIZE_ACC_CONNECTION_CHANGE_REQ                        sizeof(ACC_CONNECTION_CHANGE_REQ_STR)


//Definition for struct ACC_CONNECTION_CHANGE_RESP
#define ACC_CONNECTION_CHANGE_RESP                            0x3D                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) ACC_CONNECTION_CHANGE_RESP_STR;
#define SIZE_ACC_CONNECTION_CHANGE_RESP                       sizeof(ACC_CONNECTION_CHANGE_RESP_STR)


//Definition for struct ACC_DEFAULT_CONNECTION_CHANGE_REQ
#define ACC_DEFAULT_CONNECTION_CHANGE_REQ                     0x3E                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      audio_profile;
             uint8_t      audio_type;
             uint32_t     device_profile;
             uint8_t      connector;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
            } __attribute__((packed)) ACC_DEFAULT_CONNECTION_CHANGE_REQ_STR;
#define SIZE_ACC_DEFAULT_CONNECTION_CHANGE_REQ                sizeof(ACC_DEFAULT_CONNECTION_CHANGE_REQ_STR)


//Definition for struct ACC_DEFAULT_CONNECTION_CHANGE_RESP
#define ACC_DEFAULT_CONNECTION_CHANGE_RESP                    0x3F                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) ACC_DEFAULT_CONNECTION_CHANGE_RESP_STR;
#define SIZE_ACC_DEFAULT_CONNECTION_CHANGE_RESP               sizeof(ACC_DEFAULT_CONNECTION_CHANGE_RESP_STR)


//Definition for struct ACC_FEATURE_STATE_IND
#define ACC_FEATURE_STATE_IND                                 0x42                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      active;
             uint8_t      connector;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
             uint8_t      sub_block_count;
            } __attribute__((packed)) ACC_FEATURE_STATE_IND_STR;
#define SIZE_ACC_FEATURE_STATE_IND                            sizeof(ACC_FEATURE_STATE_IND_STR)


//Definition for struct ACC_FEATURE_STATE_GET_REQ
#define ACC_FEATURE_STATE_GET_REQ                             0x43                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      connector;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) ACC_FEATURE_STATE_GET_REQ_STR;
#define SIZE_ACC_FEATURE_STATE_GET_REQ                        sizeof(ACC_FEATURE_STATE_GET_REQ_STR)


//Definition for struct ACC_FEATURE_STATE_GET_RESP
#define ACC_FEATURE_STATE_GET_RESP                            0x44                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      connector;
             uint8_t      sub_block_count;
            } __attribute__((packed)) ACC_FEATURE_STATE_GET_RESP_STR;
#define SIZE_ACC_FEATURE_STATE_GET_RESP                       sizeof(ACC_FEATURE_STATE_GET_RESP_STR)


//Definition for struct ACC_FEATURE_SET_REQ
#define ACC_FEATURE_SET_REQ                                   0x45                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      connector;
             uint8_t      sub_block_count;
            } __attribute__((packed)) ACC_FEATURE_SET_REQ_STR;
#define SIZE_ACC_FEATURE_SET_REQ                              sizeof(ACC_FEATURE_SET_REQ_STR)


//Definition for struct ACC_FEATURE_SET_RESP
#define ACC_FEATURE_SET_RESP                                  0x46                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) ACC_FEATURE_SET_RESP_STR;
#define SIZE_ACC_FEATURE_SET_RESP                             sizeof(ACC_FEATURE_SET_RESP_STR)


//Definition for struct ACC_MIC_STATE_CHANGED_REQ
#define ACC_MIC_STATE_CHANGED_REQ                             0x76                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      mic_id;
             uint8_t      power;
            } __attribute__((packed)) ACC_MIC_STATE_CHANGED_REQ_STR;
#define SIZE_ACC_MIC_STATE_CHANGED_REQ                        sizeof(ACC_MIC_STATE_CHANGED_REQ_STR)


//Definition for struct ACC_MIC_STATE_CHANGED_RESP
#define ACC_MIC_STATE_CHANGED_RESP                            0x77                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) ACC_MIC_STATE_CHANGED_RESP_STR;
#define SIZE_ACC_MIC_STATE_CHANGED_RESP                       sizeof(ACC_MIC_STATE_CHANGED_RESP_STR)


//Definition for struct ACC_ISR_HOOKINT_REQ
#define ACC_ISR_HOOKINT_REQ                                   0x78                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) ACC_ISR_HOOKINT_REQ_STR;
#define SIZE_ACC_ISR_HOOKINT_REQ                              sizeof(ACC_ISR_HOOKINT_REQ_STR)


//Definition for struct ACC_ISR_HOOKINT_RESP
#define ACC_ISR_HOOKINT_RESP                                  0x79                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) ACC_ISR_HOOKINT_RESP_STR;
#define SIZE_ACC_ISR_HOOKINT_RESP                             sizeof(ACC_ISR_HOOKINT_RESP_STR)


//Definition for struct ACC_AV_CVIDEO_CALIBRATE_REQ
#define ACC_AV_CVIDEO_CALIBRATE_REQ                           0x7A                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) ACC_AV_CVIDEO_CALIBRATE_REQ_STR;
#define SIZE_ACC_AV_CVIDEO_CALIBRATE_REQ                      sizeof(ACC_AV_CVIDEO_CALIBRATE_REQ_STR)


//Definition for struct ACC_AV_CVIDEO_CALIBRATE_RESP
#define ACC_AV_CVIDEO_CALIBRATE_RESP                          0x7B                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint16_t     calibvalue;
             uint8_t      status;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
            } __attribute__((packed)) ACC_AV_CVIDEO_CALIBRATE_RESP_STR;
#define SIZE_ACC_AV_CVIDEO_CALIBRATE_RESP                     sizeof(ACC_AV_CVIDEO_CALIBRATE_RESP_STR)

#endif
