#ifndef _PN_ACCESSORY_SHARED_ISI_H_
#define _PN_ACCESSORY_SHARED_ISI_H_

#include <stdint.h> 

//Resource Accessory Shared Sub Block Descriptions
//PN_ACCESSORY 0x1C 
//ISI version 002.003
#define ACCESSORY_SHARED_SUB_BLOCK_DESCRIPTIONS_ISI_VERSION_Z     2
#define ACCESSORY_SHARED_SUB_BLOCK_DESCRIPTIONS_ISI_VERSION_Y     3

//In case of problems concerning content of this file contact Markku Loukusa, Sauli Laukka or Markus Mrsky
//Server specific message descriptions and feature&protocol descriptions can be found from: https://oucmswww.nmp.nokia.com:58443/document_browser/ccm_wa/GIF_SPECS/ 


//ISI VERSION CHANGE HISTORY

//Version: 002.003                                           
//Status: NonDraft                                          
//Date: 10-Apr-2008     Lasse Kongas
//Reason: Error correction
//Reference: SWAM ADB / EK08041044788, NON-DRAFT

//Version: 002.002                                           
//Status: NonDraft                                          
//Date: 07-Feb-2008     Lasse Kongas
//Reason: Improvements
//Reference: SWAM ADB / EK08010739070, NON-DRAFT

//Version: 002.001                                           
//Status: NonDraft                                          
//Date: 16-Nov-2007     Lasse Kongas
//Reason: New features
//Reference: CR: SWAM DB /EK07111246286, NON-DRAFT

//Version: 002.000                                           
//Status: NonDraft                                          
//Date: 20-Aug-2007     Jari Huhtamaki
//Reason: New features
//Reference: SWAM ADB / JH0708213489, NON-DRAFT

//Version: 001.008                                           
//Status: NonDraft                                          
//Date: 08-May-2007     Sami Sutinen
//Reason: New features
//Reference: SWAM ADB / SS07050838321, NON-DRAFT

//Version: 001.007                                           
//Status: NonDraft                                          
//Date: 13-Dec-2006     Sami Sutinen
//Reason: New features
//Reference: SWAM ADB / SS06121341573, NON-DRAFT

//Version: 001.006                                           
//Status: NonDraft                                          
//Date: 22-Nov-2006     Kari Merilainen
//Reason: New features
//Reference: SWAM ADB / KM06112344292, NON-DRAFT

//Version: 001.005                                           
//Status: NonDraft                                          
//Date: 28-Aug-2006     Jari Huhtamaki
//Reason: New features
//Reference: SWAM ADB / JH06082841031, NON-DRAFT

//Version: 001.004                                           
//Status: NonDraft                                          
//Date: 22-Aug-2006     Jani Pellikka
//Reason: New features
//Reference: SCO: ISA RM / 009-27330, NON-DRAFT

//Version: 001.003                                           
//Status: NonDraft                                          
//Date: 22-May-2006     Jari Huhtamaki
//Reason: New features
//Reference: CR: SWAM ADB / JH06052265532, NON-DRAFT

//Version: 001.002                                           
//Status: NonDraft                                          
//Date: 08-May-2006     Kari Merilainen
//Reason: NokiaAV - Production test
//Reference: SCO: ISA RM / 010-23460:ACC Srv: NOKAV: Calibration IF for C-Video cable, NON-DRAFT

//Version: 001.001                                           
//Status: NonDraft                                          
//Date: 04-May-2006     Kari Merilainen
//Reason: NokiaAV - Production tests
//Reference: SCO: ISA RM / 010-23033: ACC Srv: NOKAV: Test interface for TV_Out testing, NON-DRAFT

//Version: 001.000                                           
//Status: NonDraft                                          
//Date: 02-Mar-2006     Jari Huhtamaki
//Reason: ECI Features
//Reference: SCO: ISA RM / 010-19044, NON-DRAFT

//Version: 000.052                                           
//Status: NonDraft                                          
//Date: 12-Dec-2005     Kari Merilinen
//Reason: NokiaAV - Production tests
//Reference: SCO: ISA RM / 010-17727:ACC Srv: NOKAV: Accessory Production Tests, NON-DRAFT

//Version: 000.051                                           
//Status: NonDraft                                          
//Date: 01-Dec-2005     Kari Merilinen
//Reason: NokiaAV - MIC Change & DSP hook polling
//Reference: SCO: ISA RM / 010-19042 AUD Srv: NOKAV: Report MIC2 power to ACC HAL, NON-DRAFT

//Version: 000.050                                           
//Status: NonDraft                                          
//Date: 21-Nov-2005     Kari Merilinen
//Reason: NokiaAV FTD
//Reference: SCO: ISA RM / 009-19843 ACC Srv: NOKAV: FTD Display, NON-DRAFT

//Version: 000.049                                           
//Status: NonDraft                                          
//Date: 20-Oct-2005     Jari Huhtamki
//Reason: NokiaAV
//Reference: SCO: ISA RM / 009-19831 ACC Srv: NOKAV: ISI Interface, NON-DRAFT

//Version: 000.048                                           
//Status: NonDraft                                          
//Date: 09-Aug-2005     Kari Merilainen
//Reason: TV-Out support
//Reference: SCO: ISA RM / 010-12404: TV-Out support in ISA accessory SW, NON-DRAFT

//Version: 000.047                                           
//Status: NonDraft                                          
//Date: 27-May-2005     Kari Merilainen
//Reason: Flash accessory low power support
//Reference: SCO: ISA RM / 009-18056: Camera PD-2 support, NON-DRAFT

//Version: 000.046                                           
//Status: NonDraft                                          
//Date: 18-Apr-2005     Mika P. Kangas
//Reason: Error fix
//Reference: -, NON-DRAFT

//Version: 000.045                                           
//Status: NonDraft                                          
//Date: 01-Apr-2005     Mika P. Kangas
//Reason: Created
//Reference: ISA RM / 009-17465: AUD Srv: Audio routing for S60 3.0, NON-DRAFT


//CONSTANTS
#define ACC_ISI_VERSION_ZZZ                                   0x02                                                     
#define ACC_ISI_VERSION_YYY                                   0x03                                                     


//TABLES

//ConstantTable for ACC_THWK_MASTER_TYPE
#define ACC_THWK_OTHER                                        0x00                                                     
#define ACC_THWK_HEADSET                                      0x01                                                     
#define ACC_THWK_HANDSFREE                                    0x02                                                     
#define ACC_THWK_DATACABLE                                    0x03                                                     
#define ACC_THWK_TEST_DEVICE                                  0x04                                                     
#define ACC_THWK_CAMERA                                       0x05                                                     
#define ACC_THWK_MISC                                         0x06                                                     
#define ACC_THWK_ADAPTER                                      0x07                                                     
#define ACC_THWK_NO_INFORMATION                               0xFC                                                  
#define ACC_THWK_NOT_READY                                    0xFE                                                  
#define ACC_THWK_UNSUPPORTED                                  0xFD                                                  
#define ACC_THWK_NOT_CONNECTED                                0xFF                                                  

//ConstantTable for ACC_THWK_SUB_TYPE_OTHER
#define ACC_THWK_HEADSET_UNIV                                 0x01                                                     
#define ACC_THWK_TTY_UNIV                                     0x02                                                     
#define ACC_THWK_LINEIN                                       0x03                                                     
#define ACC_THWK_TTY                                          0x10                                                  
//#define ACC_THWK_NO_INFORMATION                             0xFC                       //Already defined as 0xFC
//#define ACC_THWK_NOT_READY                                  0xFE                       //Already defined as 0xFE
//#define ACC_THWK_UNSUPPORTED                                0xFD                       //Already defined as 0xFD
//#define ACC_THWK_NOT_CONNECTED                              0xFF                       //Already defined as 0xFF

//ConstantTable for ACC_THWK_SUB_TYPE_HD
#define ACC_THWK_HD_BASIC                                     0x00                                                     
#define ACC_THWK_HD_STEREO                                    0x01                                                     
#define ACC_THWK_HD_LOOPSET                                   0x02                                                     
#define ACC_THWK_HD_RADIO                                     0x03                                                     
#define ACC_THWK_HD_ADVANCED                                  0x05                                                     
#define ACC_THWK_HD_HIFI                                      0x06                                                     
//#define ACC_THWK_NO_INFORMATION                             0xFC                       //Already defined as 0xFC
//#define ACC_THWK_NOT_READY                                  0xFE                       //Already defined as 0xFE
//#define ACC_THWK_UNSUPPORTED                                0xFD                       //Already defined as 0xFD
//#define ACC_THWK_NOT_CONNECTED                              0xFF                       //Already defined as 0xFF

//ConstantTable for ACC_THWK_SUB_TYPE_HF
#define ACC_THWK_HF_BASIC                                     0x00                                                     
#define ACC_THWK_HF_ADVANCED                                  0x01                                                     
#define ACC_THWK_HF_STEREO_OFFICE                             0x02                                                     
//#define ACC_THWK_NO_INFORMATION                             0xFC                       //Already defined as 0xFC
//#define ACC_THWK_NOT_READY                                  0xFE                       //Already defined as 0xFE
//#define ACC_THWK_UNSUPPORTED                                0xFD                       //Already defined as 0xFD
//#define ACC_THWK_NOT_CONNECTED                              0xFF                       //Already defined as 0xFF

//ConstantTable for ACC_THWK_SUB_TYPE_DC
#define ACC_THWK_DC_RS232                                     0x00                                                     
#define ACC_THWK_DC_USB                                       0x01                                                     
//#define ACC_THWK_NO_INFORMATION                             0xFC                       //Already defined as 0xFC
//#define ACC_THWK_NOT_READY                                  0xFE                       //Already defined as 0xFE
//#define ACC_THWK_UNSUPPORTED                                0xFD                       //Already defined as 0xFD
//#define ACC_THWK_NOT_CONNECTED                              0xFF                       //Already defined as 0xFF

//ConstantTable for ACC_THWK_SUB_TYPE_TD
#define ACC_THWK_TD_AUDIO                                     0x00                                                     
//#define ACC_THWK_NO_INFORMATION                             0xFC                       //Already defined as 0xFC
//#define ACC_THWK_NOT_READY                                  0xFE                       //Already defined as 0xFE
//#define ACC_THWK_UNSUPPORTED                                0xFD                       //Already defined as 0xFD
//#define ACC_THWK_NOT_CONNECTED                              0xFF                       //Already defined as 0xFF

//ConstantTable for ACC_THWK_SUB_TYPE_CAM
#define ACC_THWK_CAM_HEADSET                                  0x00                                                     
//#define ACC_THWK_NO_INFORMATION                             0xFC                       //Already defined as 0xFC
//#define ACC_THWK_NOT_READY                                  0xFE                       //Already defined as 0xFE
//#define ACC_THWK_UNSUPPORTED                                0xFD                       //Already defined as 0xFD
//#define ACC_THWK_NOT_CONNECTED                              0xFF                       //Already defined as 0xFF

//ConstantTable for ACC_THWK_SUB_TYPE_MISC
#define ACC_THWK_MISC_FLASH_LIGHT                             0x00                                                     
//#define ACC_THWK_NO_INFORMATION                             0xFC                       //Already defined as 0xFC
//#define ACC_THWK_NOT_READY                                  0xFE                       //Already defined as 0xFE
//#define ACC_THWK_UNSUPPORTED                                0xFD                       //Already defined as 0xFD
//#define ACC_THWK_NOT_CONNECTED                              0xFF                       //Already defined as 0xFF

//ConstantTable for ACC_THWK_SUB_TYPE_ADAPTER
#define ACC_THWK_ADA_REMOTE                                   0x00                                                     
#define ACC_THWK_ADA_TVOUT                                    0x01                                                     
//#define ACC_THWK_LINEIN                                     0x03                        //Already defined as 0x03
//#define ACC_THWK_NO_INFORMATION                             0xFC                       //Already defined as 0xFC
//#define ACC_THWK_NOT_READY                                  0xFE                       //Already defined as 0xFE
//#define ACC_THWK_UNSUPPORTED                                0xFD                       //Already defined as 0xFD
//#define ACC_THWK_NOT_CONNECTED                              0xFF                       //Already defined as 0xFF

//ConstantTable for ACC_THWK_SUB_TYPE_NO_INFORMATION
//#define ACC_THWK_NO_INFORMATION                             0xFC                       //Already defined as 0xFC

//BitmaskTables for ACC_THWK_INFO_FEATURE_ID
#define ACC_THWK_NO_FEATURE                                   0x0000                                                     
#define ACC_THWK_PLAY_PAUSE_KEY                               0x0001                                                     
#define ACC_THWK_STOP_KEY                                     0x0002                                                     
#define ACC_THWK_VOLUME_UP                                    0x0004                                                     
#define ACC_THWK_VOLUME_DOWN                                  0x0008                                                     
#define ACC_THWK_FLASH_READY_ON                               0x0010                                                  
#define ACC_THWK_LONG_HOOK                                    0x0020                                                  
#define ACC_THWK_CAMERA_LENS_COVER_ON                         0x0040                                                  
#define ACC_THWK_HD_PLUG_ON                                   0x0080                                                  
#define ACC_THWK_SYNC_BTN_ON                                  0x0100                                                   
#define ACC_THWK_DTR_ON                                       0x0200                                                   
#define ACC_THWK_RTS_ON                                       0x0400                                                   
#define ACC_THWK_POWER_SUPPLY_ON                              0x0800                                                   
#define ACC_THWK_HOOK_ON                                      0x1000                                                  
#define ACC_THWK_IGNITION_SENSE_ON                            0x2000                                                  
#define ACC_THWK_EXT_AUDIO_IN                                 0x4000                                                  
#define ACC_THWK_ANSWER_END                                   0x8000                                                  

//BitmaskTables for ACC_THWK_INFO_FEATURE2_ID
//#define ACC_THWK_NO_FEATURE                                 0x00                        //Already defined as 0x00
#define ACC_THWK_BACK_KEY                                     0x01                                                     
#define ACC_THWK_FORWARD_KEY                                  0x02                                                     
#define ACC_THWK_LONG_BACK_KEY                                0x04                                                     
#define ACC_THWK_LONG_FORWARD_KEY                             0x08                                                     

//BitmaskTables for ACC_THWK_EXEC_FEATURE_ID
//#define ACC_THWK_NO_FEATURE                                 0x0000                        //Already defined as 0x0000
#define ACC_THWK_FLASH_LOW_POWER_ON                           0x0002                                                     
#define ACC_THWK_VIDEO_LIGHT_ON                               0x0004                                                     
#define ACC_THWK_FLASH_ACTIVATION_ON                          0x0008                                                     
#define ACC_THWK_CAMERA_MODULE_ON                             0x0010                                                  
#define ACC_THWK_DCD_ON                                       0x0020                                                  
#define ACC_THWK_RI_ON                                        0x0040                                                  
#define ACC_THWK_DSR_ON                                       0x0080                                                  
#define ACC_THWK_CTS_ON                                       0x0100                                                   
#define ACC_THWK_HANDSET_AUDIO_ON                             0x0200                                                   
#define ACC_THWK_CHARGER_ON                                   0x0400                                                   
#define ACC_THWK_POWER_ON                                     0x0800                                                   
#define ACC_THWK_CAR_RADIO_MUTE_ON                            0x1000                                                  
#define ACC_THWK_MUTE_ON                                      0x2000                                                  
#define ACC_THWK_EXT_AUDIO_IN_ON                              0x4000                                                  
#define ACC_THWK_AUD_AMP_ON                                   0x8000                                                  


//SUBBLOCKS


//Definition for struct ACC_SB_THWK_EXEC_FEATURE
#define ACC_SB_THWK_EXEC_FEATURE                              0x02                                                     
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_length;
             uint16_t     fea_id;
             uint16_t     fea_state;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) ACC_SB_THWK_EXEC_FEATURE_STR;
#define SIZE_ACC_SB_THWK_EXEC_FEATURE                         sizeof(ACC_SB_THWK_EXEC_FEATURE_STR)


//Definition for struct ACC_SB_THWK_INFO_FEATURE
#define ACC_SB_THWK_INFO_FEATURE                              0x01                                                     
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_length;
             uint16_t     fea_id;
             uint16_t     fea_state;
             uint8_t      fea2_id;
             uint8_t      fea2_state;
            } __attribute__((packed)) ACC_SB_THWK_INFO_FEATURE_STR;
#define SIZE_ACC_SB_THWK_INFO_FEATURE                         sizeof(ACC_SB_THWK_INFO_FEATURE_STR)


//Definition for struct ACC_SB_THWK_AUDIO_BLOCK
#define ACC_SB_THWK_AUDIO_BLOCK                               0x03                                                     
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_length;
             uint8_t      audio_block_data[15];
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
            } __attribute__((packed)) ACC_SB_THWK_AUDIO_BLOCK_STR;
#define SIZE_ACC_SB_THWK_AUDIO_BLOCK                          sizeof(ACC_SB_THWK_AUDIO_BLOCK_STR)

#endif
