#ifndef _PN_APEFTD_ISI_H_
#define _PN_APEFTD_ISI_H_

#include <stdint.h> 

//Resource APE FTD
//PN_RES_TYPE_SOS_FIELD_TEST 0x03 
//ISI version 001.001
#define APE_FTD_ISI_VERSION_Z     1
#define APE_FTD_ISI_VERSION_Y     1

//In case of problems concerning content of this file contact Markku Loukusa, Sauli Laukka or Markus Mrsky
//Server specific message descriptions and feature&protocol descriptions can be found from: https://oucmswww.nmp.nokia.com:58443/document_browser/ccm_wa/GIF_SPECS/ 


//ISI VERSION CHANGE HISTORY

//Version: 001.001                                           
//Status: Unknown                                           
//Date: -               -
//Reason: -
//Reference: -

//Version: 000.001                                           
//Status: Unknown                                           
//Date: -               -
//Reason: -
//Reference: -


//CONSTANTS
#define APE_FTD_MAX_STR_LEN                                   0xFFF4                                                
#define MAX_FTD_DATA_ITEMS                                    0xFF                                                  
#define APE_FTD_ANY_SIZE                                      1                                                     


//TABLES

//ConstantTable for APE_FTD_DATA_STATUSES
#define APE_FTD_DATA_OK                                       0x00                                                     
#define APE_FTD_DATA_FAIL                                     0x01                                                     
#define APE_FTD_DATA_NOT_ACTIVATED                            0x02                                                     
#define APE_FTD_DATA_NOT_SUPPORTED                            0x03                                                     
#define APE_FTD_DATA_NOT_AVAILABLE                            0x04                                                     

//ConstantTable for APE_FTD_STRING_TYPE
#define APE_FTD_STRING_ASCII                                  0x00                                                     
#define APE_FTD_STRING_UNICODE                                0x01                                                     

//ConstantTable for APE_FTD_UID
#define KPSFIELDTESTUID                                       0x102824C5                                            

//ConstantTable for APE_FTD_EXECUTE_TYPE
#define APE_FTD_EXECUTE_WITH_INPUT                            0x01                                                     
#define APE_FTD_EXECUTE_WITHOUT_INPUT                         0x02                                                     

//ConstantTable for APE_FTD_CONSTANTS_TABLE_BYTE
#define APE_FTD_INPUT_PROPERTY                                0x01                                                     
#define APE_FTD_OUTPUT_PROPERTY                               0x02                                                     
#define APE_FTD_BYTE_VALUE_NOT_DEFINED                        0x00                                                     

//ConstantTable for APE_FTD_CONSTANTS_TABLE_STRING
#define APE_FTD_STRING_VALUE_NOT_DEFINED                      0x00                                                     

//ConstantTable for APE_FTD_CONSTANTS_TABLE_BYTEARRAY
#define APE_FTD_BYTEARRAY_VALUE_NOT_DEFINED                   0x00                                                     

//ConstantTable for APE_FTD_CONSTANTS_TABLE_WORD
#define APE_FTD_WORD_VALUE_NOT_DEFINED                        0x00                                                     

//ConstantTable for APE_FTD_CONSTANTS_TABLE_DWORD
#define APE_FTD_DWORD_VALUE_NOT_DEFINED                       0x00                                                     


//STRUCTURES


//Definition for struct APE_FTD_INPUT_PROPERTY_KEY
typedef struct
            { 
             uint8_t      property_key_1;
             uint8_t      property_key_2;
             uint8_t      property_key_3;
             uint8_t      property_key_4;
            } __attribute__((packed)) APE_FTD_INPUT_PROPERTY_KEY_STR;
#define SIZE_APE_FTD_INPUT_PROPERTY_KEY                       sizeof(APE_FTD_INPUT_PROPERTY_KEY_STR)


//Definition for struct APE_FTD_OUTPUT_PROPERTY_KEY
typedef struct
            { 
             uint8_t      property_key_1;
             uint8_t      property_key_2;
             uint8_t      property_key_3;
             uint8_t      property_key_4;
            } __attribute__((packed)) APE_FTD_OUTPUT_PROPERTY_KEY_STR;
#define SIZE_APE_FTD_OUTPUT_PROPERTY_KEY                      sizeof(APE_FTD_OUTPUT_PROPERTY_KEY_STR)


//SUBBLOCKS


//Definition for struct APE_FTD_DATA_BYTE
#define APE_FTD_DATA_BYTE                                     0x01                                                     
typedef struct
            { 
             uint16_t     id;
             uint16_t     length;
             uint8_t      data;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
            } __attribute__((packed)) APE_FTD_DATA_BYTE_STR;
#define SIZE_APE_FTD_DATA_BYTE                                sizeof(APE_FTD_DATA_BYTE_STR)


//Definition for struct APE_FTD_DATA_WORD
#define APE_FTD_DATA_WORD                                     0x02                                                     
typedef struct
            { 
             uint16_t     id;
             uint16_t     length;
             uint16_t     data;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) APE_FTD_DATA_WORD_STR;
#define SIZE_APE_FTD_DATA_WORD                                sizeof(APE_FTD_DATA_WORD_STR)


//Definition for struct APE_FTD_DATA_DWORD
#define APE_FTD_DATA_DWORD                                    0x04                                                     
typedef struct
            { 
             uint16_t     id;
             uint16_t     length;
             uint32_t     data;
            } __attribute__((packed)) APE_FTD_DATA_DWORD_STR;
#define SIZE_APE_FTD_DATA_DWORD                               sizeof(APE_FTD_DATA_DWORD_STR)


//Definition for struct APE_FTD_DATA_STRING
#define APE_FTD_DATA_STRING                                   0x05                                                     
typedef struct
            { 
             uint16_t     id;
             uint16_t     length;
             uint8_t      str_type;
             uint8_t      fillerbyte1;
             uint16_t     string_length;
             uint8_t      string[0];
            } __attribute__((packed)) APE_FTD_DATA_STRING_STR;
#define SIZE_APE_FTD_DATA_STRING                              sizeof(APE_FTD_DATA_STRING_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct APE_FTD_DATA_BYTEARRAY
#define APE_FTD_DATA_BYTEARRAY                                0x06                                                     
typedef struct
            { 
             uint16_t     id;
             uint16_t     length;
             uint8_t      arraylen;
             uint8_t      array[0];
            } __attribute__((packed)) APE_FTD_DATA_BYTEARRAY_STR;
#define SIZE_APE_FTD_DATA_BYTEARRAY                           sizeof(APE_FTD_DATA_BYTEARRAY_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct APE_FTD_DATA_STATUS
#define APE_FTD_DATA_STATUS                                   0x00                                                     
typedef struct
            { 
             uint16_t     id;
             uint16_t     length;
             uint16_t     dataitem_id;
             uint8_t      status;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) APE_FTD_DATA_STATUS_STR;
#define SIZE_APE_FTD_DATA_STATUS                              sizeof(APE_FTD_DATA_STATUS_STR)


//MESSAGES


//Definition for struct APE_FTD_VERSION_GET_REQ
#define APE_FTD_VERSION_GET_REQ                               0x06                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
            } __attribute__((packed)) APE_FTD_VERSION_GET_REQ_STR;
#define SIZE_APE_FTD_VERSION_GET_REQ                          sizeof(APE_FTD_VERSION_GET_REQ_STR)


//Definition for struct APE_FTD_VERSION_GET_RESP
#define APE_FTD_VERSION_GET_RESP                              0x07                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      isi_version_zzz;
             uint8_t      isi_version_yyy;
            } __attribute__((packed)) APE_FTD_VERSION_GET_RESP_STR;
#define SIZE_APE_FTD_VERSION_GET_RESP                         sizeof(APE_FTD_VERSION_GET_RESP_STR)


//Definition for struct APE_FTD_ACTIVATE_REQ
#define APE_FTD_ACTIVATE_REQ                                  0x00                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint16_t     message_length;
             uint8_t      data_item_count;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
             uint16_t     ids[0];
            } __attribute__((packed)) APE_FTD_ACTIVATE_REQ_STR;
#define SIZE_APE_FTD_ACTIVATE_REQ                             sizeof(APE_FTD_ACTIVATE_REQ_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct APE_FTD_ACTIVATE_RESP
#define APE_FTD_ACTIVATE_RESP                                 0x01                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint16_t     message_length;
             uint8_t      data_item_count;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
            } __attribute__((packed)) APE_FTD_ACTIVATE_RESP_STR;
#define SIZE_APE_FTD_ACTIVATE_RESP                            sizeof(APE_FTD_ACTIVATE_RESP_STR)


//Definition for struct APE_FTD_DEACTIVATE_REQ
#define APE_FTD_DEACTIVATE_REQ                                0x02                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint16_t     message_length;
             uint8_t      data_item_count;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
             uint16_t     ids[0];
            } __attribute__((packed)) APE_FTD_DEACTIVATE_REQ_STR;
#define SIZE_APE_FTD_DEACTIVATE_REQ                           sizeof(APE_FTD_DEACTIVATE_REQ_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct APE_FTD_DEACTIVATE_RESP
#define APE_FTD_DEACTIVATE_RESP                               0x03                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint16_t     message_length;
             uint8_t      data_item_count;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
            } __attribute__((packed)) APE_FTD_DEACTIVATE_RESP_STR;
#define SIZE_APE_FTD_DEACTIVATE_RESP                          sizeof(APE_FTD_DEACTIVATE_RESP_STR)


//Definition for struct APE_FTD_EXECUTE_REQ
#define APE_FTD_EXECUTE_REQ                                   0x04                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint16_t     message_length;
             uint8_t      fillerbyte1;
             uint8_t      execute_type;
             uint16_t     data_item_id;
             uint32_t     input_data;
            } __attribute__((packed)) APE_FTD_EXECUTE_REQ_STR;
#define SIZE_APE_FTD_EXECUTE_REQ                              sizeof(APE_FTD_EXECUTE_REQ_STR)


//Definition for struct APE_FTD_EXECUTE_RESP
#define APE_FTD_EXECUTE_RESP                                  0x05                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint16_t     message_length;
             uint16_t     status_item_id;
             uint16_t     status_item_len;
             uint16_t     data_item_id;
             uint8_t      data_status;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) APE_FTD_EXECUTE_RESP_STR;
#define SIZE_APE_FTD_EXECUTE_RESP                             sizeof(APE_FTD_EXECUTE_RESP_STR)

#endif
