#ifndef _PN_ATK_ISI_H_
#define _PN_ATK_ISI_H_

#include <stdint.h> 

//Resource Application Toolkit Server
//PN_ATK 0x5A 
//ISI version 006.000
#define APPLICATION_TOOLKIT_SERVER_ISI_VERSION_Z     6
#define APPLICATION_TOOLKIT_SERVER_ISI_VERSION_Y     0

//In case of problems concerning content of this file contact Henrik Ala-Uotila
//Server specific message descriptions and feature&protocol descriptions can be found from: https://oucmswww.nmp.nokia.com:58443/document_browser/ccm_wa/GIF_SPECS/ 


//ISI VERSION CHANGE HISTORY

//Version: 006.000                                           
//Status: Approved                                          
//Date: 08-Jul-2008     John Sorensen
//Reason: 408-4871: Chipset API: SS server changes - Smart Cards impacts
//Reference: LN Inspection Agenda(SWAM):JS08061334873, Approved

//Version: 005.002                                           
//Status: Approved                                          
//Date: 16-Jan-2007     John Sorensen
//Reason: 009-29494: Replacement of SS and Call guardians
//Reference: LN Inspection Agenda(SWAM/ISI):JS06121436870/JS06122137742, Approved

//Version: 005.001                                           
//Status: Approved                                          
//Date: 09-Oct-2006     Paetur Petersen
//Reason: 006-14365: Support for SETUP IDLE MODE TEXT for Atomic1
//Reference: LN Inspection Agenda(SWAM):PPPP06101251917, Approved

//Version: 005.000                                           
//Status: Approved                                          
//Date: 22-Feb-2005     John Soerensen
//Reason: ISA RM-RIM ID: 006-9665:Remove reading and writing 'confirm SIM service actions' flag
//Reference: Change request:JS05111132405 LN Inspection Agenda(SWAM):JS06022239297, Approved

//Version: 003.002                                           
//Status: Approved                                          
//Date: 9-Feb-2006      Ronny Hansen
//Reason: ISI spec. version changed
//Reference: SWAM: RH06020934900, Approved

//Version: 003.001                                           
//Status: Proposal                                          
//Date: 16-Nov-2005     Ronny Hansen
//Reason: Changes for Call Control for GPRS
//Reference: SWAM: RH05112546772LN Inspection Agenda: RH05112348372, Proposal

//Version: 003.000                                           
//Status: Approved                                          
//Date: 30-September-2005 Keld Stougaard
//Reason: Update version number due to prior changes
//Reference: RM-RIM: 006-8575: LN Inspection Agenda: KS05072238552, Approved

//Version: 002.025                                           
//Status: Approved                                          
//Date: 24-August-2005  Keld Stougaard
//Reason: Approved version of version 002.024
//Reference: RM-RIM: 006-8575: LN Inspection Agenda: KS05072238552, Approved

//Version: 002.024                                           
//Status: Proposal                                          
//Date: 18-July-2005    Keld Stougaard
//Reason: Implementation of change request
//Reference: RM-RIM: 006-8575: LN Inspection Agenda: KS05072238552, Proposal

//Version: 002.023                                           
//Status: Approved                                          
//Date: 02-June-2005    John Soerensen
//Reason: Approved version of version 002.022
//Reference: SWAM: HJ05042949604 Release 4 interfaces changes for ATK interface,LN Inspection Agenda: JS05052436828, Approved

//Version: 002.022                                           
//Status: Proposal                                          
//Date: 02-June-2005    John Soerensen
//Reason: New SBs added to existing messages
//Reference: SWAM: HJ05042949604 Release 4 interfaces changes for ATK interface,LN Inspection Agenda: JS05052436828, Proposal

//Version: 002.021                                           
//Status: Approved                                          
//Date: 17-Feb-2005     Paetur Petersen
//Reason: Approved version of version 002.020
//Reference: RM-RIM 006-4143 Bearer Independent Protocol (BIP), LN Inspection Agenda: PP05020960713, Approved

//Version: 002.020                                           
//Status: Proposal                                          
//Date: 09-Feb-2005     Paetur Petersen
//Reason: Updated interface description for BIP
//Reference: RM-RIM 006-4143 Bearer Independent Protocol (BIP), Proposal

//Version: 002.019                                           
//Status: Approved                                          
//Date: 10-Dec-2004     Keld Stougaard
//Reason: Approved version of version 002.018
//Reference: Action DB for SWAM CR, KS04110150427, LN Inspection Agenda: KS04111837569, Approved

//Version: 002.018                                           
//Status: Proposal                                          
//Date: 29-Oct-2004     Keld Stougaard
//Reason: Implementation of Requirement Change Request
//Reference: Action DB for SWAM CR, KS04110150427, Proposal

//Version: 002.017                                           
//Status: Approved                                          
//Date: 10-Aug-2004     Keld Stougaard
//Reason: Approved version of version 002.016
//Reference: Action DB for SWAM, KS04070653933, Approved

//Version: 002.016                                           
//Status: Proposal                                          
//Date: 10-May-2004     Keld Stougaard
//Reason: Clarification to UI and additonal interface to SMS server
//Reference: RM-RIM SCO: 006-3969 and 009-11562, Requirement Change request, KS04071460158, Proposal

//Version: 002.015                                           
//Status: Approved                                          
//Date: 15-Mar-2004     Ole Brandstrup Hansen
//Reason: Approved after inspection
//Reference: ActionDB for SWAM, item: OH04030347451, RM-RIM # 006-3373, Approved

//Version: 002.014                                           
//Status: Proposal                                          
//Date: 24-Feb-2004     Ole Brandstrup Hansen
//Reason: New interface between  between ATK server and UI provider
//Reference: ActionDB for SWAM, item: OH04021953061, RM-RIM # 006-3373, Proposal

//Version: 002.013                                           
//Status: Approved                                          
//Date: 24-Feb-2004     Boerge Fischer
//Reason: Approved after inspection
//Reference: ActionDB for SWAM, item BF04021752418, TEC/SWP/ISA ActionDB, item BF04020656764, Approved

//Version: 002.012                                           
//Status: Proposal                                          
//Date: 17-Feb-2004     Boerge Fischer
//Reason: Update for Idle Screen available event, User Activity event and Browser Termination event
//Reference: SWAM CR: BF04012744410, ML04020450548, Proposal

//Version: 002.011                                           
//Status: Approved                                          
//Date: 16-Feb-2004     Boerge Fischer
//Reason: Approved after inspection
//Reference: ActionDB for SWAM, item BF04020648245, TEC/SWP/ISA ActionDB, item BF04011543971, Approved

//Version: 002.010                                           
//Status: Proposal                                          
//Date: 13-Jan-2004     Boerge Fischer
//Reason: Icon support in Set Up Idle Mode Text
//Reference: SWAM CR: BF04011343073, Proposal

//Version: 002.009                                           
//Status: Approved                                          
//Date: 26-Sep-2003     Keld Stougaard
//Reason: New interface for reading and writing 'confirm SIM service actions' flag
//Reference: SWAM CR: JB03072535879, Approved

//Version: 002.008                                           
//Status: Proposal                                          
//Date: 31-Jul-2003     Jens Ole Madsen
//Reason: New interface for reading and writing 'confirm SIM service actions' flag
//Reference: SWAM CR: JB03072535879, PROPOSAL

//Version: 002.007                                           
//Status: Approved                                          
//Date: 23-May-2003     Keld Stougaard
//Reason: New interface between ATK server and UI provider
//Reference: SWAM CR: ML03050155479 and PP03042950452, APPROVED

//Version: 002.006                                           
//Status: Proposal                                          
//Date: 12-May-2003     Keld Stougaard
//Reason: Implementation of several change requests
//Reference: SWAM CR: ML03050155479 and PP03042950452, PROPOSAL

//Version: 002.005                                           
//Status: Approved                                          
//Date: 29-apr-2003     Erik Laursen
//Reason: New interface between ATK Server and SIMSON SIM Server
//Reference: SWAM CR: EL03032656195 and SWAM EL03041044406, APPROVED

//Version: 002.004                                           
//Status: Proposal                                          
//Date: 20-mar-2003     Erik Laursen
//Reason: New interface between ATK Server and SIMSON SIM Server
//Reference: SWAM CR: EL03032656195, PROPOSAL

//Version: 002.003                                           
//Status: Approved                                          
//Date: 13-Mar-2003     Martin Steen
//Reason: New interface for ATK UI provider added
//Reference: Action DB for SWAM, MS03030451908, APPROVED

//Version: 002.000                                           
//Status: Proposal                                          
//Date: 12-Dec-2002     Martin Steen
//Reason: 
//Reference: -

//Version: 001.000                                           
//Status: Approved                                          
//Date: 21-Feb-2003     Keld Stougaard
//Reason: 
//Reference: -


//CONSTANTS


//TABLES

//BitmaskTables for ATK_GET_INKEY_CMD_QUALIFIER
#define ATK_HELP_INFO_AVAILABLE                               0x80                                                  
#define ATK_HELP_INFO_NOT_AVAILABLE                           0x00                                                     
#define ATK_CHARACTER_SET_DISABLED                            0x04                                                     
#define ATK_CHARACTER_SET_ENABLED                             0x00                                                     
#define ATK_UCS2_ALPHABET                                     0x02                                                     
#define ATK_SMS_DEF_ALPHABET                                  0x00                                                     
#define ATK_ALPHABET_SET                                      0x01                                                     
#define ATK_DIGITS_ONLY                                       0x00                                                     

//BitmaskTables for ATK_HELP_INFO_CMD_QUALIFIER
#define ATK_HELP_INFORMATION_AVAIL                            0x01                                                     
#define ATK_HELP_INFORMATION_NOT_AVAIL                        0x00                                                     

//BitmaskTables for ATK_GET_INPUT_CMD_QUALIFIER
#define ATK_HELP_INFO_AVAIL                                   0x80                                                  
#define ATK_HELP_INFO_NOT_AVAIL                               0x00                                                     
#define ATK_USER_INPUT_NOT_REVEALED                           0x04                                                     
#define ATK_USER_INPUT_REVEALED                               0x00                                                     
//#define ATK_ALPHABET_SET                                    0x01                        //Already defined as 0x01
//#define ATK_DIGITS_ONLY                                     0x00                        //Already defined as 0x00

//BitmaskTables for ATK_DISP_TEXT_CMD_QUALIFIER
#define ATK_PRIORITY_NORMAL                                   0x00                                                     
#define ATK_PRIORITY_HIGH                                     0x80                                                  
#define ATK_MESSAGE_CLEAR_AFTER_DELAY                         0x00                                                     
#define ATK_MESSAGE_WAIT_FOR_USER                             0x01                                                     

//BitmaskTables for ATK_ICON_QUALIFIER
#define ATK_ICON_SELF_EXPLANATORY                             0x00                                                     
#define ATK_ICON_NOT_SELF_EXPLANATORY                         0x01                                                     

//ConstantTable for ATK_ALPHA_PRESENT
#define ATK_ALPHA_NOT_PRESENT                                 0x00                                                     
#define ATK_ALPHA_PRESENT                                     0x01                                                     

//ConstantTable for ATK_SETUPCALL_CMD_QUALIFIER
#define ATK_QUALIFIER_IF_NOT_BUSY_ON_ANOTHER_CALL             0x00                                                     
#define ATK_QUALIFIER_IF_NOT_BUSY_ON_ANOTHER_CALL_WITH_REDIAL    0x01                                                     
#define ATK_QUALIFIER_ALWAYS_OTHER_CALLS_ON_HOLD              0x02                                                     
#define ATK_QUALIFIER_ALWAYS_OTHER_CALLS_ON_HOLD_WITH_REDIAL    0x03                                                     
#define ATK_QUALIFIER_ALWAYS_OTHER_CALLS_DISCONNECT           0x04                                                     
#define ATK_QUALIFIER_ALWAYS_OTHER_CALLS_DISCONNECT_WITH_REDIAL    0x05                                                     

//ConstantTable for ATK_FIELD_VALIDITY
#define ATK_NEXT_ITEM_NOT_INCLUDED                            0x00                                                     
#define ATK_NEXT_ITEM_INCLUDED                                0x01                                                     

//ConstantTable for ATK_REFRESH_GENERAL_RESULT
#define ATK_COMMAND_REFRESH_NOT_OK                            0x00                                                     
#define ATK_COMMAND_REFRESH_OK                                0x01                                                     

//ConstantTable for ATK_GENERAL_RESULT
#define ATK_COMMAND_PERFORMED_SUCCESSFULLY                    0x00                                                     
#define ATK_SESSION_TERMINATED_BY_USER                        0x10                                                  
#define ATK_BACKWARD_MOVE_REQUESTED_BY_USER                   0x11                                                  
#define ATK_NO_RESPONSE_FROM_USER                             0x12                                                  
#define ATK_HELP_REQUESTED_BY_USER                            0x13                                                  
#define ATK_USSD_TRANSACTION_TERMINATED_BY_USER               0x14                                                  
#define ATK_ME_CURRENTLY_UNABLE_TO_PROCESS_COMMAND            0x20                                                  
#define ATK_NETW_CURRENTLY_UNABLE_TO_PROCESS_COMMAND          0x21                                                  
#define ATK_COMMAND_NOT_ACCEPTED_BY_USER                      0x22                                                  
#define ATK_USER_CLEARED_DOWN_CALL_BEFORE_CONNECTION          0x23                                                  
#define ATK_INTERACTION_WITH_CALLCONTROL_TEMPORARY_PROBLEM    0x25                                                  
#define ATK_BEYOND_ME_CAPABILLITIES                           0x30                                                  
#define ATK_COMMAND_DATA_NOT_UNDERSTOOD                       0x32                                                  
#define ATK_SS_RETURN_ERROR                                   0x34                                                  
#define ATK_REQUIRED_VALUE_MISSING                            0x36                                                  
#define ATK_USSD_RETURN_ERROR                                 0x37                                                  
#define ATK_INTERACTION_WITH_CALLCONTROL_PERMANENT_PROBLEM    0x39                                                  

//ConstantTable for ATK_DURATION_TIME_UNIT
#define ATK_UNIT_SECONDS                                      0x00                                                     
#define ATK_UNIT_MINUTES                                      0x01                                                     
#define ATK_UNIT_TENTH_SECONDS                                0x02                                                     

//ConstantTable for ATK_REFRESH_TYPE
#define ATK_REFRESH_SIM_INIT_FULL_FILE_CHANGE_NOTF            0x00                                                     
#define ATK_REFRESH_FILE_NOTF                                 0x01                                                     
#define ATK_REFRESH_SIM_INIT_FILE_CHANGE_NOTF                 0x02                                                     
#define ATK_REFRESH_SIM_INIT                                  0x03                                                     
#define ATK_REFRESH_RESET                                     0x04                                                     
#define ATK_REFRESH_APPL_RESET                                0x05                                                     
#define ATK_REFRESH_3G_SESSION_RESET                          0x06                                                     

//ConstantTable for ATK_SMS_CMD_QUALIFIER
#define ATK_SMS_PACK_NOT_REQUIRED                             0x00                                                     
#define ATK_SMS_PACK_REQUIRED                                 0x01                                                     

//ConstantTable for ATK_TON_NPI
#define ATK_NO_TONNPI                                         0xFF                                                  
#define ATK_TONNPI_INTERNATIONAL                              0x91                                                  
#define ATK_TONNPI_UNKNOWN                                    0x81                                                  

//ConstantTable for ATK_TONE
#define ATK_TONE_DIAL_TONE                                    0x01                                                     
#define ATK_TONE_CALLED_SUBSCRIBER_BUSY                       0x02                                                     
#define ATK_TONE_CONGESTION                                   0x03                                                     
#define ATK_TONE_RP_ACKNOWLEDGE                               0x04                                                     
#define ATK_TONE_RP_NOT_AVAILABLE                             0x05                                                     
#define ATK_TONE_ERROR                                        0x06                                                     
#define ATK_TONE_CALL_WAITING                                 0x07                                                     
#define ATK_TONE_RINGING                                      0x08                                                     
#define ATK_TONE_BEEP                                         0x10                                                  
#define ATK_TONE_POSITIVE_ACKNOWLEDGE                         0x11                                                  
#define ATK_TONE_NEGATIVE_ACKNOWLEDGE                         0x12                                                  

//ConstantTable for ATK_NO_SERVICE_TYPE
#define ATK_NO_SERVICE_TYPE                                   0xFA                                                  

//ConstantTable for ATK_BROWSER_SETTINGS
#define ATK_BROWSER_DEFAULT_SETTINGS                          0xFF                                                  

//ConstantTable for ATK_SMS_ADDR_TYPE
#define ATK_SMS_GSM_0340_ADDR                                 0x01                                                     
#define ATK_SMS_GSM_0411_ADDR                                 0x02                                                     

//ConstantTable for ATK_SM_CONTROL_RESULT
#define ATK_SM_CONTROL_RESULT_ALLOWED                         0x00                                                     
#define ATK_SM_CONTROL_RESULT_NOT_ALLOWED                     0x01                                                     
#define ATK_SM_CONTROL_RESULT_ALLOWED_WITH_MODIFICATIONS      0x02                                                     

//ConstantTable for ATK_INPUTMODE
#define ATK_INPUTMODE_NUMERIC                                 0x00                                                     
#define ATK_INPUTMODE_ALPHA                                   0x01                                                     
#define ATK_INPUTMODE_PASSWORD                                0x02                                                     

//ConstantTable for ATK_ALPHABET
#define ATK_ALPHABET_SMS                                      0x00                                                     
#define ATK_ALPHABET_UCS2                                     0x01                                                     

//ConstantTable for ATK_COMMAND_CLASS

//ConstantTable for ATK_TIMEOUT
#define ATK_TIMEOUT_NEVER                                     0x00                                                     
#define ATK_TIMEOUT_AFTER_DELAY                               0x01                                                     

//ConstantTable for ATK_UI_NAVIGATION
#define ATK_UI_RESULT_ACCEPT                                  0x01                                                     
#define ATK_UI_RESULT_REJECT                                  0x00                                                     
#define ATK_UI_RESULT_TERMINATE                               0x02                                                     
#define ATK_UI_RESULT_TIMEOUT                                 0x03                                                     
#define ATK_UI_RESULT_HELP                                    0x04                                                     
#define ATK_UI_RESULT_SELECT                                  0x05                                                     

//ConstantTable for ATK_UI_RESULT
#define ATK_UI_RESULT_OK                                      0x00                                                     
#define ATK_UI_RESULT_OK_NOT_SHOWN                            0x01                                                     
#define ATK_UI_RESULT_OK_ICON_NOT_SHOWN                       0x02                                                     
#define ATK_UI_RESULT_BUSY                                    0x03                                                     
#define ATK_UI_RESULT_FAIL                                    0x04                                                     

//ConstantTable for ATK_BC_REPEAT_INDICATOR
#define ATK_CIRCULAR_REPEAT_INDICATOR                         0x01                                                     
#define ATK_SEQUENTIAL_REPEAT_INDICATOR                       0x03                                                     

//ConstantTable for ATK_CALLCONTROL_GENERAL_RESULT
#define ATK_ALLOWED                                           0x01                                                     
#define ATK_MODIFIED                                          0x02                                                     
#define ATK_CHANGED                                           0x03                                                     
#define ATK_REJECTED                                          0x04                                                     
#define ATK_REJECTED_BY_FDN                                   0x05                                                     
#define ATK_REJECTED_BY_CS_AFTER_MODIFIED                     0x06                                                     
#define ATK_REJECTED_BY_CS_AFTER_CHANGED                      0x07                                                     
#define ATK_ERROR                                             0x08                                                     
#define ATK_MODIFIED_INVISIBLE                                0x12                                                  
#define ATK_CHANGED_INVISIBLE                                 0x13                                                  
#define ATK_REJECTED_INVISIBLE                                0x14                                                  

//ConstantTable for ATK_COMMAND_PRIORITY
#define ATK_UI_PRIORITY_NORMAL                                0x00                                                     
#define ATK_UI_PRIORITY_HIGH                                  0x01                                                     

//ConstantTable for ATK_PRESENTATION_TYPE
#define ATK_UI_NO_TYPE                                        0x00                                                     
#define ATK_UI_DATA_VALUES                                    0x01                                                     
#define ATK_UI_NAVIGATION_OPTIONS                             0x02                                                     

//ConstantTable for ATK_SELECTION_PREFERENCE
#define ATK_UI_NO_PREFERENCE                                  0x00                                                     
#define ATK_UI_SOFTKEY_PREFERENCE                             0x01                                                     

//ConstantTable for ATK_EMERGENCY

//ConstantTable for ATK_RESULT
#define ATK_NOT_ACCEPT                                        0x00                                                     
#define ATK_ACCEPT                                            0x01                                                     

//ConstantTable for ATK_CALLCONTROL_STATUS
#define ATK_CALL_CONTROL_NOT_ACTIVE                           0x00                                                     
#define ATK_CALL_CONTROL_ACTIVE                               0x01                                                     

//ConstantTable for ATK_ICON_ID

//ConstantTable for ATK_PROFILE_REQ_CARD_TYPE
#define ATK_SIM_CARD_SIM                                      0x00                                                     
#define ATK_SIM_CARD_USIM                                     0x01                                                     

//ConstantTable for ATK_SW_DATA_NTF_STATUS
#define ATK_SIM_SERV_OK                                       0x00                                                     
#define ATK_SIM_SERV_NOT_READY                                0x01                                                     
#define ATK_SIM_SERV_ERROR                                    0x02                                                     

//ConstantTable for ATK_REQUEST

//ConstantTable for ATK_EVENT_TYPE
#define ATK_EVENT_USER_ACTIVITY                               0x00                                                     
#define ATK_EVENT_IDLE_SCREEN_AVAILABLE                       0x01                                                     
#define ATK_EVENT_BROWSER_TERMINATION                         0x02                                                     

//ConstantTable for ATK_EVENT_INFO
#define ATK_EVENT_INFO_NO                                     0x00                                                     
#define ATK_EVENT_INFO_USER_TERMINATION                       0x01                                                     
#define ATK_EVENT_INFO_ERROR_TERMINATION                      0x02                                                     

//ConstantTable for ATK_EVENT_MONITORING_STATE
#define ATK_EVENT_MONITORING_ON                               0x00                                                     
#define ATK_EVENT_MONITORING_OFF                              0x01                                                     

//ConstantTable for ATK_COMMAND_INFO
#define ATK_IN_CALL                                           0x01                                                     
#define ATK_SIM_RESET                                         0x02                                                     

//ConstantTable for ATK_UI_SUPPRESS_INDICATOR
#define ATK_UI_NO_SUPPRESS                                    0x00                                                     
#define ATK_UI_SUPPRESS                                       0x01                                                     


//STRUCTURES


//Definition for struct ATK_ITEM_DATA
typedef struct
            { 
             uint8_t      item_identifier;
             uint8_t      textstringlength;
             uint16_t     textstring[0];
            } __attribute__((packed)) ATK_ITEM_DATA_STR;
#define SIZE_ATK_ITEM_DATA                                    sizeof(ATK_ITEM_DATA_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//SUBBLOCKS


//Definition for struct ATK_SB_UI_INPUT
#define ATK_SB_UI_INPUT                                       0xB1                                                  
typedef struct
            { 
             uint8_t      sb_id;
             uint8_t      fillerbyte1;
             uint16_t     sb_len;
             uint16_t     minimum_length;
             uint16_t     maximum_length;
             uint16_t     default_value_length;
             uint8_t      inputmode;
             uint8_t      alphabet;
             uint16_t     default_value[0];
            } __attribute__((packed)) ATK_SB_UI_INPUT_STR;
#define SIZE_ATK_SB_UI_INPUT                                  sizeof(ATK_SB_UI_INPUT_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct ATK_SB_UI_ITEM
#define ATK_SB_UI_ITEM                                        0xB2                                                  
typedef struct
            { 
             uint8_t      sb_id;
             uint8_t      fillerbyte1;
             uint16_t     sb_len;
             uint8_t      item_id;
             uint8_t      icon_id;
             uint8_t      sim_icon_id;
             uint8_t      command_class;
             uint16_t     text_length;
             uint16_t     text[0];
            } __attribute__((packed)) ATK_SB_UI_ITEM_STR;
#define SIZE_ATK_SB_UI_ITEM                                   sizeof(ATK_SB_UI_ITEM_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct ATK_SB_UI_SELECTION
#define ATK_SB_UI_SELECTION                                   0xB3                                                  
typedef struct
            { 
             uint8_t      sb_id;
             uint8_t      fillerbyte1;
             uint16_t     sb_len;
             uint8_t      item_id;
             uint8_t      fillerbyte2[3];
            } __attribute__((packed)) ATK_SB_UI_SELECTION_STR;
#define SIZE_ATK_SB_UI_SELECTION                              sizeof(ATK_SB_UI_SELECTION_STR)


//Definition for struct ATK_SB_UI_REFRESH
#define ATK_SB_UI_REFRESH                                     0xB5                                                  
typedef struct
            { 
             uint8_t      sb_id;
             uint8_t      fillerbyte1;
             uint16_t     sb_len;
             uint8_t      refreshtype;
             uint8_t      fillerbyte2[3];
            } __attribute__((packed)) ATK_SB_UI_REFRESH_STR;
#define SIZE_ATK_SB_UI_REFRESH                                sizeof(ATK_SB_UI_REFRESH_STR)


//Definition for struct ATK_SB_UI_DURATION
#define ATK_SB_UI_DURATION                                    0xB6                                                  
typedef struct
            { 
             uint8_t      sb_id;
             uint8_t      fillerbyte1;
             uint16_t     sb_len;
             uint32_t     duration;
            } __attribute__((packed)) ATK_SB_UI_DURATION_STR;
#define SIZE_ATK_SB_UI_DURATION                               sizeof(ATK_SB_UI_DURATION_STR)


//Definition for struct ATK_SB_UI_IMMEDIATE_DIGIT_RESPONSE
#define ATK_SB_UI_IMMEDIATE_DIGIT_RESPONSE                    0xB7                                                  
typedef struct
            { 
             uint8_t      sb_id;
             uint8_t      fillerbyte1;
             uint16_t     sb_len;
            } __attribute__((packed)) ATK_SB_UI_IMMEDIATE_DIGIT_RESPONSE_STR;
#define SIZE_ATK_SB_UI_IMMEDIATE_DIGIT_RESPONSE               sizeof(ATK_SB_UI_IMMEDIATE_DIGIT_RESPONSE_STR)


//Definition for struct ATK_SB_SMS_ADDR
#define ATK_SB_SMS_ADDR                                       0xC0                                                  
typedef struct
            { 
             uint8_t      sb_id;
             uint8_t      fillerbyte1;
             uint16_t     sb_len;
             uint8_t      addrtype;
             uint8_t      datalength;
             uint8_t      data[0];
            } __attribute__((packed)) ATK_SB_SMS_ADDR_STR;
#define SIZE_ATK_SB_SMS_ADDR                                  sizeof(ATK_SB_SMS_ADDR_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct ATK_SB_ACTIVATE_PDP_CONTEXT_REQUEST
#define ATK_SB_ACTIVATE_PDP_CONTEXT_REQUEST                   0xB8                                                  
typedef struct
            { 
             uint8_t      sb_id;
             uint8_t      fillerbyte1;
             uint16_t     sb_len;
             uint16_t     datalength;
             uint16_t     fillerbyte2;
             uint8_t      data[0];
            } __attribute__((packed)) ATK_SB_ACTIVATE_PDP_CONTEXT_REQUEST_STR;
#define SIZE_ATK_SB_ACTIVATE_PDP_CONTEXT_REQUEST              sizeof(ATK_SB_ACTIVATE_PDP_CONTEXT_REQUEST_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct ATK_SB_BC_REPEAT
#define ATK_SB_BC_REPEAT                                      0xA3                                                  
typedef struct
            { 
             uint8_t      sb_id;
             uint8_t      fillerbyte1;
             uint16_t     sb_len;
             uint8_t      bc_repeat_indicator;
             uint8_t      fillerbyte2[3];
            } __attribute__((packed)) ATK_SB_BC_REPEAT_STR;
#define SIZE_ATK_SB_BC_REPEAT                                 sizeof(ATK_SB_BC_REPEAT_STR)


//Definition for struct ATK_SB_SS_UI_SUPPRESS_INFO
#define ATK_SB_SS_UI_SUPPRESS_INFO                            0xA5                                                  
typedef struct
            { 
             uint8_t      sb_id;
             uint8_t      fillerbyte1;
             uint16_t     sb_len;
             uint8_t      ui_suppress_ind;
             uint8_t      fillerbyte2[3];
            } __attribute__((packed)) ATK_SB_SS_UI_SUPPRESS_INFO_STR;
#define SIZE_ATK_SB_SS_UI_SUPPRESS_INFO                       sizeof(ATK_SB_SS_UI_SUPPRESS_INFO_STR)


//MESSAGES


//Definition for struct ATK_CMD_DISPLAY_TEXT_REQ
#define ATK_CMD_DISPLAY_TEXT_REQ                              0x41                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      cmdqualifier;
             uint8_t      textlength;
             uint8_t      immediateresponse;
             uint16_t     text[0];
            } __attribute__((packed)) ATK_CMD_DISPLAY_TEXT_REQ_STR;
#define SIZE_ATK_CMD_DISPLAY_TEXT_REQ                         sizeof(ATK_CMD_DISPLAY_TEXT_REQ_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct ATK_CMD_DISPLAY_TEXT_RESP
#define ATK_CMD_DISPLAY_TEXT_RESP                             0x4B                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      generalresult;
             uint8_t      additionalinfo;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
            } __attribute__((packed)) ATK_CMD_DISPLAY_TEXT_RESP_STR;
#define SIZE_ATK_CMD_DISPLAY_TEXT_RESP                        sizeof(ATK_CMD_DISPLAY_TEXT_RESP_STR)


//Definition for struct ATK_CMD_GET_INKEY_REQ
#define ATK_CMD_GET_INKEY_REQ                                 0x42                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      cmdqualifier;
             uint8_t      textlength;
             uint8_t      fillerbyte1;
             uint16_t     text[0];
            } __attribute__((packed)) ATK_CMD_GET_INKEY_REQ_STR;
#define SIZE_ATK_CMD_GET_INKEY_REQ                            sizeof(ATK_CMD_GET_INKEY_REQ_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct ATK_CMD_GET_INKEY_RESP
#define ATK_CMD_GET_INKEY_RESP                                0x4C                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      generalresult;
             uint8_t      additionalinfo;
             uint8_t      fillerbyte1;
             int16_t      text;
            } __attribute__((packed)) ATK_CMD_GET_INKEY_RESP_STR;
#define SIZE_ATK_CMD_GET_INKEY_RESP                           sizeof(ATK_CMD_GET_INKEY_RESP_STR)


//Definition for struct ATK_CMD_GET_INPUT_REQ
#define ATK_CMD_GET_INPUT_REQ                                 0x43                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      cmdqualifier;
             uint8_t      inputminlength;
             uint8_t      inputmaxlength;
             uint8_t      textlength;
             uint8_t      defaulttextlength;
             uint16_t     text[0];
             uint16_t     default_text[0];
            } __attribute__((packed)) ATK_CMD_GET_INPUT_REQ_STR;
#define SIZE_ATK_CMD_GET_INPUT_REQ                            sizeof(ATK_CMD_GET_INPUT_REQ_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct ATK_CMD_GET_INPUT_RESP
#define ATK_CMD_GET_INPUT_RESP                                0x4D                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      generalresult;
             uint8_t      additionalinfo;
             uint8_t      textlength;
             uint16_t     text[0];
            } __attribute__((packed)) ATK_CMD_GET_INPUT_RESP_STR;
#define SIZE_ATK_CMD_GET_INPUT_RESP                           sizeof(ATK_CMD_GET_INPUT_RESP_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct ATK_CMD_PLAY_TONE_REQ
#define ATK_CMD_PLAY_TONE_REQ                                 0x44                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      tone;
             uint8_t      durationtimeunit;
             uint8_t      timeinterval;
             uint8_t      alphaidentifierlength;
             uint8_t      fillerbyte1;
             uint16_t     alphaidentifier[0];
            } __attribute__((packed)) ATK_CMD_PLAY_TONE_REQ_STR;
#define SIZE_ATK_CMD_PLAY_TONE_REQ                            sizeof(ATK_CMD_PLAY_TONE_REQ_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct ATK_CMD_PLAY_TONE_RESP
#define ATK_CMD_PLAY_TONE_RESP                                0x4E                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      generalresult;
             uint8_t      additionalinfo;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
            } __attribute__((packed)) ATK_CMD_PLAY_TONE_RESP_STR;
#define SIZE_ATK_CMD_PLAY_TONE_RESP                           sizeof(ATK_CMD_PLAY_TONE_RESP_STR)


//Definition for struct ATK_CMD_REFRESH_REQ
#define ATK_CMD_REFRESH_REQ                                   0x4A                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      refreshtype;
             uint8_t      filelength;
             uint8_t      fillerbyte1;
             uint16_t     file[0];
            } __attribute__((packed)) ATK_CMD_REFRESH_REQ_STR;
#define SIZE_ATK_CMD_REFRESH_REQ                              sizeof(ATK_CMD_REFRESH_REQ_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct ATK_CMD_REFRESH_RESP
#define ATK_CMD_REFRESH_RESP                                  0x54                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      generalresult;
             uint8_t      additionalinfo;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
            } __attribute__((packed)) ATK_CMD_REFRESH_RESP_STR;
#define SIZE_ATK_CMD_REFRESH_RESP                             sizeof(ATK_CMD_REFRESH_RESP_STR)


//Definition for struct ATK_CMD_SELECT_ITEM_REQ
#define ATK_CMD_SELECT_ITEM_REQ                               0x45                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      cmdqualifier;
             uint8_t      fieldvalidity;
             uint8_t      alphaidentifierlength;
             uint8_t      numberofitemdata;
             uint8_t      defaultitem;
             uint16_t     data[0];
             uint8_t      itemnextindicator[0];
            } __attribute__((packed)) ATK_CMD_SELECT_ITEM_REQ_STR;
#define SIZE_ATK_CMD_SELECT_ITEM_REQ                          sizeof(ATK_CMD_SELECT_ITEM_REQ_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct ATK_CMD_SELECT_ITEM_RESP
#define ATK_CMD_SELECT_ITEM_RESP                              0x4F                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      generalresult;
             uint8_t      additionalinfo;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
            } __attribute__((packed)) ATK_CMD_SELECT_ITEM_RESP_STR;
#define SIZE_ATK_CMD_SELECT_ITEM_RESP                         sizeof(ATK_CMD_SELECT_ITEM_RESP_STR)


//Definition for struct ATK_CMD_SEND_SMS_REQ
#define ATK_CMD_SEND_SMS_REQ                                  0x46                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      commandinfo;
             uint8_t      cmdqualifier;
             uint8_t      tonandnpi;
             uint8_t      alphaidentifierlength;
             uint8_t      addresslength;
             uint8_t      smstpdulength;
             uint8_t      fillerbyte1;
             uint16_t     data[0];
             uint8_t      address[0];
             uint8_t      smstpdu[0];
            } __attribute__((packed)) ATK_CMD_SEND_SMS_REQ_STR;
#define SIZE_ATK_CMD_SEND_SMS_REQ                             sizeof(ATK_CMD_SEND_SMS_REQ_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct ATK_CMD_SEND_SMS_RESP
#define ATK_CMD_SEND_SMS_RESP                                 0x50                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      generalresult;
             uint8_t      additionalinfo;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
            } __attribute__((packed)) ATK_CMD_SEND_SMS_RESP_STR;
#define SIZE_ATK_CMD_SEND_SMS_RESP                            sizeof(ATK_CMD_SEND_SMS_RESP_STR)


//Definition for struct ATK_CMD_SEND_SS_REQ
#define ATK_CMD_SEND_SS_REQ                                   0x47                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      tonandnpi;
             uint8_t      alphaidentifierlength;
             uint8_t      ssstringlength;
             uint8_t      commandinfo;
             uint8_t      fillerbyte1;
             uint16_t     data[0];
             uint8_t      ssstring[0];
            } __attribute__((packed)) ATK_CMD_SEND_SS_REQ_STR;
#define SIZE_ATK_CMD_SEND_SS_REQ                              sizeof(ATK_CMD_SEND_SS_REQ_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct ATK_CMD_SEND_SS_RESP
#define ATK_CMD_SEND_SS_RESP                                  0x51                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      generalresult;
             uint8_t      additionalinfolength;
             uint8_t      additionalinfo[0];
            } __attribute__((packed)) ATK_CMD_SEND_SS_RESP_STR;
#define SIZE_ATK_CMD_SEND_SS_RESP                             sizeof(ATK_CMD_SEND_SS_RESP_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct ATK_CMD_SEND_USSD_REQ
#define ATK_CMD_SEND_USSD_REQ                                 0x67                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      commandinfo;
             uint8_t      alphaidentifierlength;
             uint8_t      datacodingscheme;
             uint8_t      ussdstringlength;
             uint8_t      fillerbyte1;
             uint16_t     data[0];
             uint16_t     ussdstring[0];
            } __attribute__((packed)) ATK_CMD_SEND_USSD_REQ_STR;
#define SIZE_ATK_CMD_SEND_USSD_REQ                            sizeof(ATK_CMD_SEND_USSD_REQ_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct ATK_CMD_SEND_USSD_RESP
#define ATK_CMD_SEND_USSD_RESP                                0x66                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      generalresult;
             uint8_t      additionalinfolength;
             uint8_t      textlength;
             uint8_t      datacodingscheme;
             uint8_t      fillerbyte1;
             uint16_t     data[0];
             uint8_t      additional_info[0];
            } __attribute__((packed)) ATK_CMD_SEND_USSD_RESP_STR;
#define SIZE_ATK_CMD_SEND_USSD_RESP                           sizeof(ATK_CMD_SEND_USSD_RESP_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct ATK_CMD_SETUP_CALL_REQ
#define ATK_CMD_SETUP_CALL_REQ                                0x48                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      cmdqualifier;
             uint8_t      tonandnpi;
             uint8_t      durationtimeunit;
             uint8_t      timeinterval;
             uint8_t      calltype;
             uint8_t      alphaidentifierlength;
             uint8_t      diallingnumberstringlength;
             uint8_t      calledpartysubaddresslength;
             uint8_t      capatibilityconfigurationparameterlength;
             uint16_t     data[0];
             uint8_t      diallingnumberstring[0];
             uint8_t      calledpartysubaddress[0];
             uint8_t      bearers[0];
            } __attribute__((packed)) ATK_CMD_SETUP_CALL_REQ_STR;
#define SIZE_ATK_CMD_SETUP_CALL_REQ                           sizeof(ATK_CMD_SETUP_CALL_REQ_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct ATK_CMD_SETUP_CALL_RESP
#define ATK_CMD_SETUP_CALL_RESP                               0x52                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      generalresult;
             uint8_t      additionalinfo;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
            } __attribute__((packed)) ATK_CMD_SETUP_CALL_RESP_STR;
#define SIZE_ATK_CMD_SETUP_CALL_RESP                          sizeof(ATK_CMD_SETUP_CALL_RESP_STR)


//Definition for struct ATK_CMD_SETUP_MENU_REQ
#define ATK_CMD_SETUP_MENU_REQ                                0x49                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      cmdqualifier;
             uint8_t      fieldvalidity;
             uint8_t      alphaidentifierlength;
             uint8_t      numberofitemdata;
             uint8_t      fillerbyte1;
             uint16_t     data[0];
             uint8_t      itemnextindicator[0];
             uint8_t      fillerbyte2;
             uint16_t     itemdata[0];
            } __attribute__((packed)) ATK_CMD_SETUP_MENU_REQ_STR;
#define SIZE_ATK_CMD_SETUP_MENU_REQ                           sizeof(ATK_CMD_SETUP_MENU_REQ_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct ATK_CMD_SETUP_MENU_RESP
#define ATK_CMD_SETUP_MENU_RESP                               0x53                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      generalresult;
             uint8_t      additionalinfo;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
            } __attribute__((packed)) ATK_CMD_SETUP_MENU_RESP_STR;
#define SIZE_ATK_CMD_SETUP_MENU_RESP                          sizeof(ATK_CMD_SETUP_MENU_RESP_STR)


//Definition for struct ATK_CMD_GENERIC_REQ
#define ATK_CMD_GENERIC_REQ                                   0x10                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      cardid;
             uint8_t      fillerbyte1;
             uint16_t     length_of_data;
             uint8_t      data_element[0];
            } __attribute__((packed)) ATK_CMD_GENERIC_REQ_STR;
#define SIZE_ATK_CMD_GENERIC_REQ                              sizeof(ATK_CMD_GENERIC_REQ_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct ATK_CMD_GENERIC_RESP
#define ATK_CMD_GENERIC_RESP                                  0x11                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      tid;
             uint8_t      fillerbyte1;
             uint16_t     length_of_data;
             uint8_t      data_element[0];
            } __attribute__((packed)) ATK_CMD_GENERIC_RESP_STR;
#define SIZE_ATK_CMD_GENERIC_RESP                             sizeof(ATK_CMD_GENERIC_RESP_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct ATK_CMD_COMPLETE_NTF
#define ATK_CMD_COMPLETE_NTF                                  0x30                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      session_id;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) ATK_CMD_COMPLETE_NTF_STR;
#define SIZE_ATK_CMD_COMPLETE_NTF                             sizeof(ATK_CMD_COMPLETE_NTF_STR)


//Definition for struct ATK_SESSION_COMPLETE_NTF
#define ATK_SESSION_COMPLETE_NTF                              0x31                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      session_id;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) ATK_SESSION_COMPLETE_NTF_STR;
#define SIZE_ATK_SESSION_COMPLETE_NTF                         sizeof(ATK_SESSION_COMPLETE_NTF_STR)


//Definition for struct ATK_MONITOR_EVENT_NTF
#define ATK_MONITOR_EVENT_NTF                                 0x32                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      event_type;
             uint8_t      monitoring_state;
            } __attribute__((packed)) ATK_MONITOR_EVENT_NTF_STR;
#define SIZE_ATK_MONITOR_EVENT_NTF                            sizeof(ATK_MONITOR_EVENT_NTF_STR)


//Definition for struct ATK_REPORT_EVENT_NTF
#define ATK_REPORT_EVENT_NTF                                  0x33                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      event_type;
             uint8_t      event_info;
            } __attribute__((packed)) ATK_REPORT_EVENT_NTF_STR;
#define SIZE_ATK_REPORT_EVENT_NTF                             sizeof(ATK_REPORT_EVENT_NTF_STR)


//Definition for struct ATK_EVENT_UI_INFO_NTF
#define ATK_EVENT_UI_INFO_NTF                                 0x34                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      command_class;
             uint8_t      command_info;
            } __attribute__((packed)) ATK_EVENT_UI_INFO_NTF_STR;
#define SIZE_ATK_EVENT_UI_INFO_NTF                            sizeof(ATK_EVENT_UI_INFO_NTF_STR)


//Definition for struct ATK_STATUS_IND
#define ATK_STATUS_IND                                        0x0D                                                     
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      callcontrol_status;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) ATK_STATUS_IND_STR;
#define SIZE_ATK_STATUS_IND                                   sizeof(ATK_STATUS_IND_STR)


//Definition for struct ATK_UI_REGISTER_REQ
#define ATK_UI_REGISTER_REQ                                   0x00                                                     
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint16_t     fillerbyte1;
            } __attribute__((packed)) ATK_UI_REGISTER_REQ_STR;
#define SIZE_ATK_UI_REGISTER_REQ                              sizeof(ATK_UI_REGISTER_REQ_STR)


//Definition for struct ATK_UI_REGISTER_RESP
#define ATK_UI_REGISTER_RESP                                  0x01                                                     
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      result;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) ATK_UI_REGISTER_RESP_STR;
#define SIZE_ATK_UI_REGISTER_RESP                             sizeof(ATK_UI_REGISTER_RESP_STR)


//Definition for struct ATK_UI_UNREGISTER_REQ
#define ATK_UI_UNREGISTER_REQ                                 0x02                                                     
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint16_t     fillerbyte1;
            } __attribute__((packed)) ATK_UI_UNREGISTER_REQ_STR;
#define SIZE_ATK_UI_UNREGISTER_REQ                            sizeof(ATK_UI_UNREGISTER_REQ_STR)


//Definition for struct ATK_UI_UNREGISTER_RESP
#define ATK_UI_UNREGISTER_RESP                                0x03                                                     
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      result;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) ATK_UI_UNREGISTER_RESP_STR;
#define SIZE_ATK_UI_UNREGISTER_RESP                           sizeof(ATK_UI_UNREGISTER_RESP_STR)


//Definition for struct ATK_EVENT_UI_REQ
#define ATK_EVENT_UI_REQ                                      0x04                                                     
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      navigation_event;
             uint8_t      session_id;
             uint8_t      id;
             uint8_t      no_of_blocks;
             uint16_t     fillerbyte1;
            } __attribute__((packed)) ATK_EVENT_UI_REQ_STR;
#define SIZE_ATK_EVENT_UI_REQ                                 sizeof(ATK_EVENT_UI_REQ_STR)


//Definition for struct ATK_EVENT_UI_RESP
#define ATK_EVENT_UI_RESP                                     0x05                                                     
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      ack_ok;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) ATK_EVENT_UI_RESP_STR;
#define SIZE_ATK_EVENT_UI_RESP                                sizeof(ATK_EVENT_UI_RESP_STR)


//Definition for struct ATK_UI_TEXT_REQ
#define ATK_UI_TEXT_REQ                                       0x20                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      session_id;
             uint8_t      command_class;
             uint8_t      command_priority;
             uint8_t      command_timeout_id;
             uint8_t      no_of_blocks;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) ATK_UI_TEXT_REQ_STR;
#define SIZE_ATK_UI_TEXT_REQ                                  sizeof(ATK_UI_TEXT_REQ_STR)


//Definition for struct ATK_UI_PROGRESS_REQ
#define ATK_UI_PROGRESS_REQ                                   0x21                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      session_id;
             uint8_t      command_class;
             uint8_t      command_priority;
             uint8_t      fillerbyte1[3];
             uint32_t     duration;
            } __attribute__((packed)) ATK_UI_PROGRESS_REQ_STR;
#define SIZE_ATK_UI_PROGRESS_REQ                              sizeof(ATK_UI_PROGRESS_REQ_STR)


//Definition for struct ATK_UI_INPUT_REQ
#define ATK_UI_INPUT_REQ                                      0x23                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      session_id;
             uint8_t      command_class;
             uint8_t      command_priority;
             uint8_t      help_available;
             uint8_t      no_of_blocks;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) ATK_UI_INPUT_REQ_STR;
#define SIZE_ATK_UI_INPUT_REQ                                 sizeof(ATK_UI_INPUT_REQ_STR)


//Definition for struct ATK_UI_SELECT_REQ
#define ATK_UI_SELECT_REQ                                     0x24                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      session_id;
             uint8_t      command_class;
             uint8_t      command_priority;
             uint8_t      help_available;
             uint8_t      presentation_type;
             uint8_t      selection_preference;
             uint8_t      default_item_id;
             uint8_t      no_of_blocks;
             uint16_t     fillerbyte1;
            } __attribute__((packed)) ATK_UI_SELECT_REQ_STR;
#define SIZE_ATK_UI_SELECT_REQ                                sizeof(ATK_UI_SELECT_REQ_STR)


//Definition for struct ATK_UI_MENU_REQ
#define ATK_UI_MENU_REQ                                       0x29                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      session_id;
             uint8_t      command_class;
             uint8_t      help_available;
             uint8_t      selection_preference;
             uint8_t      no_of_blocks;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) ATK_UI_MENU_REQ_STR;
#define SIZE_ATK_UI_MENU_REQ                                  sizeof(ATK_UI_MENU_REQ_STR)


//Definition for struct ATK_UI_CONFIRM_REQ
#define ATK_UI_CONFIRM_REQ                                    0x22                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      session_id;
             uint8_t      command_class;
             uint8_t      command_priority;
             uint8_t      help_available;
             uint8_t      no_of_blocks;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) ATK_UI_CONFIRM_REQ_STR;
#define SIZE_ATK_UI_CONFIRM_REQ                               sizeof(ATK_UI_CONFIRM_REQ_STR)


//Definition for struct ATK_UI_BROWSER_REQ
#define ATK_UI_BROWSER_REQ                                    0x25                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      session_id;
             uint8_t      command_class;
             uint8_t      command_priority;
             uint8_t      browser_relaunch;
             uint8_t      setting_set;
             uint8_t      setting_set_index;
             uint8_t      no_of_blocks;
             uint8_t      fillerbyte1[3];
            } __attribute__((packed)) ATK_UI_BROWSER_REQ_STR;
#define SIZE_ATK_UI_BROWSER_REQ                               sizeof(ATK_UI_BROWSER_REQ_STR)


//Definition for struct ATK_UI_BROWSER_STATUS_REQ
#define ATK_UI_BROWSER_STATUS_REQ                             0x26                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      session_id;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) ATK_UI_BROWSER_STATUS_REQ_STR;
#define SIZE_ATK_UI_BROWSER_STATUS_REQ                        sizeof(ATK_UI_BROWSER_STATUS_REQ_STR)


//Definition for struct ATK_UI_WAIT_REQ
#define ATK_UI_WAIT_REQ                                       0x28                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      session_id;
             uint8_t      command_class;
             uint8_t      command_priority;
             uint8_t      fillerbyte1[3];
            } __attribute__((packed)) ATK_UI_WAIT_REQ_STR;
#define SIZE_ATK_UI_WAIT_REQ                                  sizeof(ATK_UI_WAIT_REQ_STR)


//Definition for struct ATK_UI_RESP
#define ATK_UI_RESP                                           0x27                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      result_id;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) ATK_UI_RESP_STR;
#define SIZE_ATK_UI_RESP                                      sizeof(ATK_UI_RESP_STR)


//Definition for struct ATK_PROFILE_REQ
#define ATK_PROFILE_REQ                                       0x14                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      cardid;
             uint8_t      cardtype;
            } __attribute__((packed)) ATK_PROFILE_REQ_STR;
#define SIZE_ATK_PROFILE_REQ                                  sizeof(ATK_PROFILE_REQ_STR)


//Definition for struct ATK_PROFILE_RESP
#define ATK_PROFILE_RESP                                      0x15                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      cardid;
             uint8_t      callctrlsupport;
             uint8_t      tid;
             uint16_t     fillerbyte1;
             uint8_t      datalength;
             uint8_t      data[0];
            } __attribute__((packed)) ATK_PROFILE_RESP_STR;
#define SIZE_ATK_PROFILE_RESP                                 sizeof(ATK_PROFILE_RESP_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct ATK_ENVELOPE_NTF
#define ATK_ENVELOPE_NTF                                      0x12                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      cardid;
             uint8_t      datalength;
             uint8_t      data[0];
            } __attribute__((packed)) ATK_ENVELOPE_NTF_STR;
#define SIZE_ATK_ENVELOPE_NTF                                 sizeof(ATK_ENVELOPE_NTF_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct ATK_SW_DATA_NTF
#define ATK_SW_DATA_NTF                                       0x13                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      cardid;
             uint8_t      status;
             uint8_t      sw1;
             uint8_t      sw2;
             uint16_t     datalength;
             uint8_t      data[0];
            } __attribute__((packed)) ATK_SW_DATA_NTF_STR;
#define SIZE_ATK_SW_DATA_NTF                                  sizeof(ATK_SW_DATA_NTF_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct ATK_MO_SM_CONTROL_REQ
#define ATK_MO_SM_CONTROL_REQ                                 0x35                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      no_of_blocks;
            } __attribute__((packed)) ATK_MO_SM_CONTROL_REQ_STR;
#define SIZE_ATK_MO_SM_CONTROL_REQ                            sizeof(ATK_MO_SM_CONTROL_REQ_STR)


//Definition for struct ATK_MO_SM_CONTROL_RESP
#define ATK_MO_SM_CONTROL_RESP                                0x36                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      result;
             uint8_t      no_of_blocks;
            } __attribute__((packed)) ATK_MO_SM_CONTROL_RESP_STR;
#define SIZE_ATK_MO_SM_CONTROL_RESP                           sizeof(ATK_MO_SM_CONTROL_RESP_STR)


//Definition for struct ATK_PDP_CC_REQ
#define ATK_PDP_CC_REQ                                        0x70                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      no_of_blocks;
            } __attribute__((packed)) ATK_PDP_CC_REQ_STR;
#define SIZE_ATK_PDP_CC_REQ                                   sizeof(ATK_PDP_CC_REQ_STR)


//Definition for struct ATK_PDP_CC_RESP
#define ATK_PDP_CC_RESP                                       0x71                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      callcontrol_general_result;
             uint8_t      sb_count;
            } __attribute__((packed)) ATK_PDP_CC_RESP_STR;
#define SIZE_ATK_PDP_CC_RESP                                  sizeof(ATK_PDP_CC_RESP_STR)


//Definition for struct ATK_UI_TEXT_NTF
#define ATK_UI_TEXT_NTF                                       0x72                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      session_id;
             uint8_t      command_class;
             uint8_t      command_priority;
             uint8_t      command_timeout_id;
             uint8_t      no_of_blocks;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) ATK_UI_TEXT_NTF_STR;
#define SIZE_ATK_UI_TEXT_NTF                                  sizeof(ATK_UI_TEXT_NTF_STR)


//Definition for struct ATK_SUPPRESS_UI_IND
#define ATK_SUPPRESS_UI_IND                                   0x75                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      sb_count;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) ATK_SUPPRESS_UI_IND_STR;
#define SIZE_ATK_SUPPRESS_UI_IND                              sizeof(ATK_SUPPRESS_UI_IND_STR)


//Definition for struct ATK_CALL_CONTROL_REQ
#define ATK_CALL_CONTROL_REQ                                  0x73                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      fillerbyte1;
             uint8_t      no_of_blocks;
            } __attribute__((packed)) ATK_CALL_CONTROL_REQ_STR;
#define SIZE_ATK_CALL_CONTROL_REQ                             sizeof(ATK_CALL_CONTROL_REQ_STR)


//Definition for struct ATK_CALL_CONTROL_RESP
#define ATK_CALL_CONTROL_RESP                                 0x74                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      callcontrol_general_result;
             uint8_t      sb_count;
            } __attribute__((packed)) ATK_CALL_CONTROL_RESP_STR;
#define SIZE_ATK_CALL_CONTROL_RESP                            sizeof(ATK_CALL_CONTROL_RESP_STR)

#endif
