#ifndef _PN_AUDIO_ISI_H_
#define _PN_AUDIO_ISI_H_

#include <stdint.h> 

//Resource Audio Server
//PN_AUDIO 0x0B 
//ISI version 008.024
#define AUDIO_SERVER_ISI_VERSION_Z     8
#define AUDIO_SERVER_ISI_VERSION_Y     24

//In case of problems concerning content of this file contact Henrik Ala-Uotila
//Server specific message descriptions and feature&protocol descriptions can be found from: https://oucmswww.nmp.nokia.com:58443/document_browser/ccm_wa/GIF_SPECS/ 


//ISI VERSION CHANGE HISTORY

//Version: 008.024                                           
//Status: NonDraft                                          
//Date: 28-Apr-2009     Niina Pussinen
//Reason: AUD_EANC_MIC_DATA_RESP has to be changed back
//Reference: -

//Version: 008.022                                           
//Status: NonDraft                                          
//Date: 06-Apr-2009     Niina Pussinen
//Reason: Change request
//Reference: SWAM CR: NP09031339141, NON-DRAFT

//Version: 008.019                                           
//Status: NonDraft                                          
//Date: 12-Sep-2008     Adrian Chirica
//Reason: Change request
//Reference: SWAM CR: AC08083040574, NON-DRAFT

//Version: 008.018                                           
//Status: NonDraft                                          
//Date: 15-May-2008     Adrian Chirica
//Reason: Bug Fix
//Reference: SWAM CR: AN08041749576, NON-DRAFT

//Version: 008.017                                           
//Status: NonDraft                                          
//Date: 07-May-2008     Adrian Chirica, Jaakko Rautiainen 
//Reason: Change request
//Reference: SWAM CR: AC08042449305, NON-DRAFT

//Version: 008.016                                           
//Status: NonDraft                                          
//Date: 23-Mar-2008     Pasi Alatalo
//Reason: Change request
//Reference: SWAM CR: AN08041749576, NON-DRAFT

//Version: 008.015                                           
//Status: NonDraft                                          
//Date: 31-Mar-2008     Petteri Hyvonen
//Reason: Change request
//Reference: SWAM CR: EH08033156573, NON-DRAFT

//Version: 008.014                                           
//Status: NonDraft                                          
//Date: 20-Mar-2008     Jaakko Rautiainen
//Reason: Change request
//Reference: SWAM CR: JR08032051561, NON-DRAFT

//Version: 008.013                                           
//Status: NonDraft                                          
//Date: 19-Feb-2008     Jaakko Rautiainen
//Reason: Change request
//Reference: SWAM CR: JR08022051386, NON-DRAFT

//Version: 008.012                                           
//Status: NonDraft                                          
//Date: 14-Feb-2008     Janne Ervasti, Rasmus Rahunen, Jani Krkel
//Reason: Audio server UPP split.
//Reference: 414-4504, 403-5694, 403-10649, NON-DRAFT

//Version: 008.011                                           
//Status: NonDraft                                          
//Date: 15-Jan-2008     Janne Vimpari
//Reason: Change request
//Reference: SWAM CR: JV08011556803, NON-DRAFT

//Version: 008.010                                           
//Status: NonDraft                                          
//Date: 04-Jan-2008     Janne Vimpari
//Reason: Change request
//Reference: RM-RIM 403-9345, ADB SWAM JV0801044858, NON-DRAFT

//Version: 008.009                                           
//Status: NonDraft                                          
//Date: 10-Dec-2007     Paavo Salonen
//Reason: Change request
//Reference: RM-RIM 401-5601, ADB SWAM PS07121059105, NON-DRAFT

//Version: 008.008                                           
//Status: NonDraft                                          
//Date: 20-Nov-2007     Jaakko Rautiainen
//Reason: Change request
//Reference: RM-RIM 403-9201, ADB SWAM JR07111958783, NON-DRAFT

//Version: 008.007                                           
//Status: NonDraft                                          
//Date: 06-Nov-2007     Paavo Salonen
//Reason: Change request
//Reference: RM-RIM 401-5611, ADB SWAM PS07110651102, NON-DRAFT

//Version: 008.006                                           
//Status: NonDraft                                          
//Date: 25-Sep-2007     Seppo Jauho
//Reason: Change request
//Reference: RM-RIM 401-5500, ADB SWAM SJ07092554528, NON-DRAFT

//Version: 008.005                                           
//Status: NonDraft                                          
//Date: 19-Sep-2007     Seppo Jauho
//Reason: Change request
//Reference: RM-RIM 401-5307, RM-RIM 401-5190, ADB SWAM SJ07091242230, NON-DRAFT

//Version: 008.004                                           
//Status: NonDraft                                          
//Date: 09-Aug-2007     Mika P. Kangas
//Reason: Change request
//Reference: RM-RIM 402-2988, 010-31685, ADB SWAM MK07080950055, NON-DRAFT

//Version: 008.003                                           
//Status: NonDraft                                          
//Date: 26-Jun-2007     Janne Vimpari
//Reason: Change request
//Reference: RM-RIM 009-30070, ADB SWAM JV07060855686, NON-DRAFT

//Version: 008.002                                           
//Status: NonDraft                                          
//Date: 19-Jun-2007     Janne Vimpari
//Reason: Change request Add AUD_MODE_AUDIO_REC
//Reference: RM-RIM 403-1583, ADB SWAM JV07061359846, NON-DRAFT

//Version: 008.001                                           
//Status: NonDraft                                          
//Date: 3-May-2007      Janne Ervasti
//Reason: Change request (FTD data mode changes).
//Reference: RM-RIM 009-28730, ADB SWAM JE07050239685, NON-DRAFT

//Version: 008.000                                           
//Status: NonDraft                                          
//Date: 12-Mar-2007     Anton Nevala
//Reason: Change request
//Reference: ADB SWAM AN07032036224, NON-DRAFT

//Version: 007.009                                           
//Status: NonDraft                                          
//Date: 12-Mar-2007     Marko Kangasluoma
//Reason: Change request
//Reference: ADB SWAM MK07031251079, NON-DRAFT

//Version: 007.008                                           
//Status: NonDraft                                          
//Date: 20-Dec-2006     Anton Nevala
//Reason: Change request
//Reference: ADB SWAM AN06121952700, NON-DRAFT

//Version: 007.007                                           
//Status: NonDraft                                          
//Date: 22-Nov-2006     Mika P. Kangas
//Reason: Change request
//Reference: ADB SWAM MK06112154700, NON-DRAFT

//Version: 007.006                                           
//Status: NonDraft                                          
//Date: 10-Nov-2006     Mika P. Kangas
//Reason: Change request
//Reference: ADB SWAM MK06110953626, NON-DRAFT

//Version: 007.005                                           
//Status: NonDraft                                          
//Date: 18-Oct-2006     Anton Nevala
//Reason: Change request
//Reference: ADB SWAM AN06101758966, ADB SWAM AN06102056604, NON-DRAFT

//Version: 007.004                                           
//Status: NonDraft                                          
//Date: 26-Sep-2006     Jaakko Rautiainen
//Reason: Change request
//Reference: ADB SWAM JR06092049285, NON-DRAFT

//Version: 007.003                                           
//Status: NonDraft                                          
//Date: 12-Sep-2006     Anton Nevala
//Reason: Change request
//Reference: ADB SWAM AN06090761597, NON-DRAFT

//Version: 007.002                                           
//Status: NonDraft                                          
//Date: 11-Aug-2006     Jani Pellikka
//Reason: Change request
//Reference: ADB SWAM JP06081433480, NON-DRAFT

//Version: 007.001                                           
//Status: NonDraft                                          
//Date: 08-Jun-2006     Jani Pellikka
//Reason: Change request
//Reference: ADB SWAM JP06060844679, NON-DRAFT

//Version: 007.000                                           
//Status: NonDraft                                          
//Date: 22-May-2006     Jani Pellikka
//Reason: Change request
//Reference: ADB SWAM JP06052429518, NON-DRAFT

//Version: 006.014                                           
//Status: NonDraft                                          
//Date: 10-May-2006     Jani Pellikka
//Reason: Change request
//Reference: ADB SWAM CR AN06050233373, NON-DRAFT

//Version: 006.013                                           
//Status: NonDraft                                          
//Date: 09-Mar-2006     Anton Nevala
//Reason: Change request
//Reference: ADB SWAM CR AN06030757429, NON-DRAFT

//Version: 006.012                                           
//Status: NonDraft                                          
//Date: 03-Mar-2006     Marko Kangasluoma
//Reason: Change request
//Reference: ADB SWAM CR MK06022753147, NON-DRAFT

//Version: 006.011                                           
//Status: NonDraft                                          
//Date: 12-Dec-2005     Anton Nevala
//Reason: Change request
//Reference: ADB SWAM CR AN05120942086, NON-DRAFT

//Version: 006.010                                           
//Status: NonDraft                                          
//Date: 12-Dec-2005     Marko Kangasluoma
//Reason: Change request
//Reference: ADB SWAM CR MK05112246823, NON-DRAFT

//Version: 006.009                                           
//Status: NonDraft                                          
//Date: 01-Dec-2005     Anton Nevala
//Reason: Change request
//Reference: ADB SWAM CR AN05120136458, NON-DRAFT

//Version: 006.008                                           
//Status: NonDraft                                          
//Date: 14-Nov-2005     Anton Nevala
//Reason: Change request
//Reference: ADB SWAM CR AN05110956275, NON-DRAFT

//Version: 006.007                                           
//Status: NonDraft                                          
//Date: 20-Oct-2005     Anton Nevala
//Reason: Change request
//Reference: ADB SWAM CR AN05102044080, NON-DRAFT

//Version: 006.006                                           
//Status: NonDraft                                          
//Date: 10-Oct-2005     Mika P. Kangas
//Reason: Change request
//Reference: ADB SWAM CR MK05092652108, NON-DRAFT

//Version: 006.005                                           
//Status: NonDraft                                          
//Date: 23-Sep-2005     Mika P. Kangas
//Reason: Change request
//Reference: ADB SWAM CR MK05092652108, NON-DRAFT

//Version: 006.004                                           
//Status: NonDraft                                          
//Date: 15-Sep-2005     Marko Kangasluoma
//Reason: Change request
//Reference: ADB SWAM CR MK05083056633, NON-DRAFT

//Version: 006.003                                           
//Status: NonDraft                                          
//Date: 31-Aug-2005     Anton Nevala
//Reason: Change request
//Reference: ADB SWAM CR AN05083058267, NON-DRAFT

//Version: 006.002                                           
//Status: NonDraft                                          
//Date: 15-Aug-2005     Anton Nevala
//Reason: Change request
//Reference: ADB SWAM CR AN05080947503, NON-DRAFT

//Version: 006.001                                           
//Status: NonDraft                                          
//Date: 12-Apr-2005     Mika P. Kangas
//Reason: Change request
//Reference: ADB SWAM CR MK05050241185, NON-DRAFT

//Version: 006.000                                           
//Status: NonDraft                                          
//Date: 28-Apr-2005     Marko Kangasluoma
//Reason: Change request
//Reference: ADB SWAM CR MK05041955966 Audio Server: EAP time and pause interface", NON-DRAFT

//Version: 005.028                                           
//Status: NonDraft                                          
//Date: 08-Apr-2005     Jaakko Rautiainen
//Reason: Change request
//Reference: ADB SWAM CR JR05040539062 "Audio Server: 5 new modes, 1 new client type", NON-DRAFT

//Version: 005.027                                           
//Status: NonDraft                                          
//Date: 01-Apr-2005     Mika P. Kangas
//Reason: Change request
//Reference: ADB SWAM CR MK05031647456, NON-DRAFT

//Version: 005.026                                           
//Status: NonDraft                                          
//Date: 07-Feb-2005     Marko Kangasluoma
//Reason: Change request
//Reference: ADB SWAM CR MK05013157091 "Audio Server: EAP capture and effect interface change", NON-DRAFT

//Version: 005.025                                           
//Status: NonDraft                                          
//Date: 17-Jan-2005     Anton Nevala
//Reason: Change request
//Reference: ADB SWAM CR AN05011349117 "Audio Server: New value for AUD_MIXER_APP_REC_SELECT Attribute", NON-DRAFT

//Version: 005.024                                           
//Status: NonDraft                                          
//Date: 05-Jan-2005     Anton Nevala
//Reason: Change request
//Reference: ADB SWAM CR AN04122334741 "Audio Server: 3 new modes, 2 message definition remove", NON-DRAFT

//Version: 005.023                                           
//Status: NonDraft                                          
//Date: 08-Dec-2004     Jaakko Rautiainen
//Reason: Change request
//Reference: ADB SWAM CR JR04120334038 "Audio server: New audio mode for CK-10, Car Kit 10", NON-DRAFT

//Version: 005.022                                           
//Status: NonDraft                                          
//Date: 29-Oct-2004     Anton Nevala
//Reason: Change request
//Reference: ADB SWAM CR AN04102544508 "Audio server: Audio ISI interface changes for HAC", NON-DRAFT

//Version: 005.021                                           
//Status: NonDraft                                          
//Date: 21-Oct-2004     Marko Kangasluoma
//Reason: Change request
//Reference: ADB SWAM CR MK04101543136 "Audio server: EAP interface changes", NON-DRAFT

//Version: 005.020                                           
//Status: NonDraft                                          
//Date: 25-Sep-2004     Jaakko Rautiainen
//Reason: Change request
//Reference: ADB SWAM CR JR04092239071 "Audio server: BT streaming changes", NON-DRAFT


//CONSTANTS
#define AUD_NUM_MESSAGE_TYPES                                 0x25                                                  
#define AUD_COMM_MESSAGE_TYPES                                0x0B                                                     
#define AUD_NUM_MAX_CLIENTS                                   0x20                                                  
#define AUD_NUM_ACC_MODES                                     0x4E                                                  
#define AUD_NUM_CELL_MODES                                    0x02                                                     
#define AUD_NUM_SERVICES                                      0x09                                                     
#define AUD_NUM_ANALOG_IN_ATTRIBUTES                          0x03                                                     
#define AUD_NUM_ANALOG_IN_VOLUME_LEVELS                       0x0A                                                     
#define AUD_NUM_ANALOG_OUT_ATTRIBUTES                         0x03                                                     
#define AUD_NUM_ANALOG_OUT_VOLUME_LEVELS                      0x0A                                                     
#define AUD_NUM_DSP_PARAMS_ATTRIBUTES                         0x07                                                     
#define AUD_NUM_DTMF_ATTRIBUTES                               0x03                                                     
#define AUD_NUM_DTMF_VOLUME_LEVELS                            0x0A                                                     
#define AUD_NUM_TONE_ATTRIBUTES                               0x0D                                                     
#define AUD_NUM_TONE_VOLUME_LEVELS                            0x0A                                                     
#define AUD_NUM_MIXER_ATTRIBUTES                              0x12                                                  
#define AUD_NUM_MODE_ATTRIBUTES                               0x03                                                     
#define AUD_DIGITAL_OUT_VOL_LEVEL                             0x00                                                     
#define AUD_NUM_DIGITAL_OUT_ATTRIBUTES                        0x06                                                     
#define AUD_NUM_DIGITAL_OUT_VOLUME_LEVELS                     0x0A                                                     
#define AUD_NUM_AUD_MUTE_ATTRIBUTES                           0x03                                                     
#define AUD_NUM_MIXER_UL_IN_ATTRIBUTES                        0x0C                                                     
#define AUD_NUM_MIXER_DL_OUT_ATTRIBUTES                       0x1E                                                  
#define AUD_NUM_TEST_TYPES                                    0x1D                                                  
#define AUD_NUM_ERROR_CAUSES                                  0x08                                                     
#define AUD_NUM_OPERATIONS                                    0x05                                                     
#define AUD_NUM_SETTING_STATUSES                              0x05                                                     
#define AUD_NUM_CLIENT_TYPES                                  0x0D                                                     
#define FTD_ACC                                               0x00                                                     
#define FTD_AD                                                0x01                                                     
#define FTD_ULI                                               0x02                                                     
#define FTD_DLO                                               0x03                                                     
#define FTD_GAIN                                              0x04                                                     
#define FTD_VOL                                               0x05                                                     
#define FTD_DPW                                               0x06                                                     
#define FTD_UPW                                               0x07                                                     
#define COMM_FTD_DATA_AUD_BASE                                0x01A0                                                   
#define AUD_COMM_FTD_DATA_NUM                                 0x08                                                     
#define AUD_PAUSE                                             0x00                                                     
#define AUD_DSP_MAX_PARDATA_LEN                               0x80                                                  
#define AUD_EQU_MAX_NAME_LENGTH                               0x14                                                  


//TABLES

//ConstantTable for AUD_MODE_VALUES
#define AUD_MODE_HP                                           0x00                                                     
#define AUD_MODE_HDC5                                         0x01                                                     
#define AUD_MODE_HDC9                                         0x02                                                     
#define AUD_MODE_LPS1                                         0x03                                                     
#define AUD_MODE_LPS3                                         0x04                                                     
#define AUD_MODE_PPHF                                         0x05                                                     
#define AUD_MODE_PPHF_EXT_MIC                                 0x06                                                     
#define AUD_MODE_CAR_HFU2                                     0x07                                                     
#define AUD_MODE_CAR_HFU2_HS                                  0x08                                                     
#define AUD_MODE_ANCO_HP                                      0x09                                                     
#define AUD_MODE_ANCO_ANC                                     0x0A                                                     
#define AUD_MODE_ANCO_IHF                                     0x0B                                                     
#define AUD_MODE_SMART_ACCESSORY                              0x0C                                                     
#define AUD_MODE_IHF                                          0x0D                                                     
#define AUD_MODE_MSTI                                         0x0E                                                     
#define AUD_MODE_FM_RADIO                                     0x0F                                                     
#define AUD_MODE_TEST                                         0x10                                                  
#define AUD_MODE_TTY                                          0x11                                                  
#define AUD_MODE_HP_SLIDE_OPEN                                0x12                                                  
#define AUD_MODE_ACTIVE_COVER                                 0x13                                                  
#define AUD_MODE_FM_RADIO_OVER_IHF                            0x14                                                  
#define AUD_MODE_THWK_HD_MO                                   0x15                                                  
#define AUD_MODE_THWK_HD_ST                                   0x16                                                  
#define AUD_MODE_THWK_LPS                                     0x17                                                  
#define AUD_MODE_THWK_BHF                                     0x18                                                  
#define AUD_MODE_THWK_HFU                                     0x19                                                  
#define AUD_MODE_THWK_EXT_HS                                  0x1A                                                  
#define AUD_MODE_THWK_HF_ST                                   0x1B                                                  
#define AUD_MODE_POC                                          0x1C                                                  
#define AUD_MODE_THWK_GENERIC                                 0x1D                                                  
#define AUD_MODE_UNIV_HEADSET                                 0x1E                                                  
#define AUD_MODE_UNIV_TTY                                     0x1F                                                  
#define AUD_MODE_UNIV_FM_RADIO                                0x20                                                  
#define AUD_MODE_POC_HD                                       0x21                                                  
#define AUD_MODE_POC_HF                                       0x22                                                  
#define AUD_MODE_LPS_AUMIC                                    0x23                                                  
#define AUD_MODE_LPS_EXT_IN                                   0x24                                                  
#define AUD_MODE_THWK_TEST_BOX                                0x25                                                  
#define AUD_MODE_HAC                                          0x26                                                  
#define AUD_MODE_BTHSTREAM                                    0x27                                                  
#define AUD_MODE_CK_10                                        0x28                                                  
#define AUD_MODE_TEST_CABLE                                   0x29                                                  
#define AUD_MODE_HD_ST_2                                      0x2A                                                  
#define AUD_MODE_STEREO_MIC                                   0x2B                                                  
#define AUD_MODE_EXT_MIC                                      0x2C                                                  
#define AUD_MODE_UNIV_STEREO                                  0x2D                                                  
#define AUD_MODE_UNIV_STEREO_EXT_MIC                          0x2E                                                  
#define AUD_MODE_LINE_IN_REC                                  0x2F                                                  
#define AUD_MODE_FM_RADIO_REC                                 0x30                                                  
#define AUD_MODE_PHAP_HP                                      0x31                                                  
#define AUD_MODE_PHAP_HP_SLIDE_OPEN                           0x32                                                  
#define AUD_MODE_TVOUT                                        0x33                                                  
#define AUD_MODE_AV_STEREO_HD                                 0x34                                                  
#define AUD_MODE_AV_STEREO_HD_HP_MIC                          0x35                                                  
#define AUD_MODE_AV_GENERIC                                   0x36                                                  
#define AUD_MODE_AD15                                         0x37                                                  
#define AUD_MODE_HS20                                         0x38                                                  
#define AUD_MODE_HS29                                         0x39                                                  
#define AUD_MODE_STEREO_CAR_HF                                0x3A                                                  
#define AUD_MODE_AV_BASIC_HF                                  0x3B                                                  
#define AUD_MODE_AV_EXT_MIC                                   0x3C                                                  
#define AUD_MODE_AV_TTY                                       0x3D                                                  
#define AUD_MODE_SPEECH_REC                                   0x3E                                                  
#define AUD_MODE_VIDEO_REC                                    0x3F                                                  
#define AUD_MODE_THWK_HIFI_HD                                 0x40                                                  
#define AUD_MODE_THWK_RADIO_HD                                0x41                                                  
#define AUD_MODE_LINE_OUT                                     0x42                                                  
#define AUD_MODE_USB_HD                                       0x43                                                  
#define AUD_MODE_USB_CAR_HF                                   0x44                                                  
#define AUD_MODE_AUDIO_REC                                    0x45                                                  
#define AUD_MODE_FM_RADIO_USB                                 0x46                                                  
#define AUD_MODE_USB_HD_HP_MIC                                0x47                                                  
#define AUD_MODE_USB_EXT_MIC                                  0x48                                                  
#define AUD_MODE_MOBILE_TV                                    0x49                                                  
#define AUD_MODE_FMTX_ONLY                                    0x4A                                                  
#define AUD_MODE_FMTX_AND_PHONE                               0x4B                                                  
#define AUD_MODE_POC_HS                                       0x4C                                                  
#define AUD_MODE_POC_BTH                                      0x4D                                                  

//ConstantTable for AUD_MODE_ANA_DIGI
#define AUD_MODE_DIGITAL                                      0x00                                                     
#define AUD_MODE_ANALOG                                       0x01                                                     

//ConstantTable for AUD_SERVICES_ALL
#define AUD_ANALOG_IN                                         0x00                                                     
#define AUD_ANALOG_OUT                                        0x01                                                     
#define AUD_DSP_PARAMS                                        0x02                                                     
#define AUD_DTMF                                              0x03                                                     
#define AUD_TONE                                              0x04                                                     
#define AUD_MIXER                                             0x05                                                     
#define AUD_MODE                                              0x06                                                     
#define AUD_DIGITAL_OUT                                       0x07                                                     
#define AUD_MUTE                                              0x08                                                     
#define AUD_ALL_SERVICES                                      0x09                                                     

//ConstantTable for AUD_ANALOG_IN_ATTRIBUTES_ALL
#define AUD_ANALOG_IN_GAIN_LEVEL                              0x00                                                     
#define AUD_ANALOG_IN_GAIN_ABS_VALUE                          0x01                                                     
#define AUD_ANALOG_IN_SIDETONE                                0x02                                                     
#define AUD_ALL_ATTRIBUTES                                    0x3F                                                  

//ConstantTable for AUD_ANALOG_OUT_ATTRIBUTES_ALL
#define AUD_ANALOG_OUT_VOL_LEVEL                              0x00                                                     
#define AUD_ANALOG_OUT_VOL_ABS_VALUE                          0x01                                                     
#define AUD_ANALOG_OUT_VOL_BALANCE                            0x02                                                     
//#define AUD_ALL_ATTRIBUTES                                  0x3F                       //Already defined as 0x3F

//ConstantTable for AUD_DSP_PARAMS_ATTRIBUTES_ALL
#define AUD_DSP_PARAM_BLOCK                                   0x00                                                     
#define AUD_DSP_ALGORITHMS_1                                  0x01                                                     
#define AUD_DSP_ALGORITHMS_2                                  0x02                                                     
#define AUD_DSP_PHAP                                          0x03                                                     
#define AUD_DSP_ALGORITHMS_3                                  0x04                                                     
#define AUD_DSP_ALGORITHMS_4                                  0x05                                                     
#define AUD_DSP_ALGORITHMS_5                                  0x06                                                     
//#define AUD_ALL_ATTRIBUTES                                  0x3F                       //Already defined as 0x3F

//ConstantTable for AUD_DTMF_ATTRIBUTES_ALL
#define AUD_DTMF_SWITCH                                       0x00                                                     
#define AUD_DTMF_DIGIT                                        0x01                                                     
#define AUD_DTMF_VOLUME_LEVEL                                 0x02                                                     
//#define AUD_ALL_ATTRIBUTES                                  0x3F                       //Already defined as 0x3F

//ConstantTable for AUD_TONE_ATTRIBUTES_ALL
#define AUD_TONE_SWITCH_1                                     0x00                                                     
#define AUD_TONE_FREQUENCY_1                                  0x01                                                     
#define AUD_TONE_VOLUME_LEVEL_1                               0x02                                                     
#define AUD_TONE_SWITCH_2                                     0x03                                                     
#define AUD_TONE_FREQUENCY_2                                  0x04                                                     
#define AUD_TONE_VOLUME_LEVEL_2                               0x05                                                     
#define AUD_TONE_SWITCH_3                                     0x06                                                     
#define AUD_TONE_FREQUENCY_3                                  0x07                                                     
#define AUD_TONE_VOLUME_LEVEL_3                               0x08                                                     
#define AUD_TONE_SWITCH_4                                     0x09                                                     
#define AUD_TONE_FREQUENCY_4                                  0x0A                                                     
#define AUD_TONE_VOLUME_LEVEL_4                               0x0B                                                     
#define AUD_TONE_SEQUENCE_TYPE                                0x0C                                                     
//#define AUD_ALL_ATTRIBUTES                                  0x3F                       //Already defined as 0x3F

//ConstantTable for AUD_MIXER_ATTRIBUTES_ALL
#define AUD_MIXER_UL_POWER_SWITCH                             0x00                                                     
#define AUD_MIXER_UL_IN_SELECT                                0x01                                                     
#define AUD_MIXER_UL_IN_SWITCH                                0x02                                                     
#define AUD_MIXER_UL_OUT_SWITCH                               0x03                                                     
#define AUD_MIXER_DTMF_OUT_SELECT                             0x04                                                     
#define AUD_MIXER_TONE_OUT_SELECT                             0x05                                                     
#define AUD_MIXER_DL_POWER_SWITCH                             0x06                                                     
#define AUD_MIXER_DL_IN_SWITCH                                0x07                                                     
#define AUD_MIXER_DL_OUT_SWITCH                               0x08                                                     
#define AUD_MIXER_DL_OUT_SELECT                               0x09                                                     
#define AUD_MIXER_MODE_OUT_SELECT                             0x0A                                                     
#define AUD_MIXER_QUALITY_SELECT                              0x0B                                                     
#define AUD_MIXER_APP_IN_SELECT                               0x0C                                                     
#define AUD_MIXER_APP_UL_SELECT                               0x0D                                                     
#define AUD_MIXER_APP_REC_SELECT                              0x0E                                                     
#define AUD_MIXER_DL_OUT_TRANSMIT_SELECT                      0x0F                                                     
#define AUD_MIXER_PLAYBACK_MODE_SELECT                        0x10                                                  
#define AUD_MIXER_APE_SPEECH_TONE_SWITCH                      0x11                                                  
//#define AUD_ALL_ATTRIBUTES                                  0x3F                       //Already defined as 0x3F

//ConstantTable for AUD_MODE_ATTRIBUTES_ALL
#define AUD_MODE_ANA_DIGI                                     0x00                                                     
#define AUD_MODE_ACCESSORY                                    0x01                                                     
#define AUD_MODE_SECONDARY                                    0x02                                                     
//#define AUD_ALL_ATTRIBUTES                                  0x3F                       //Already defined as 0x3F

//ConstantTable for AUD_DIGITAL_OUT_ATTRIBUTES_ALL
#define AUD_DIGITAL_OUT_SPEECH_GAIN_LOG                       0x00                                                     
#define AUD_DIGITAL_OUT_ABS_VALUE                             0x01                                                     
#define AUD_DIGITAL_OUT_AUDIO_GAIN_LOG                        0x02                                                     
#define AUD_DIGITAL_OUT_CMTDL_GAIN_LOG                        0x03                                                     
#define AUD_DIGITAL_OUT_CMTUL_GAIN_LOG                        0x04                                                     
#define AUD_DIGITAL_OUT_REC_GAIN_LOG                          0x05                                                     
//#define AUD_ALL_ATTRIBUTES                                  0x3F                       //Already defined as 0x3F

//ConstantTable for AUD_MUTE_ATTRIBUTES_ALL
#define AUD_ANA_MUTE_SWITCH                                   0x00                                                     
#define AUD_DIGI_MUTE_SWITCH                                  0x01                                                     
//#define AUD_ALL_ATTRIBUTES                                  0x3F                       //Already defined as 0x3F

//ConstantTable for AUD_EQU_FAILURE_REASON
#define AUD_EQU_ID_ERROR                                      0x00                                                     
#define AUD_EQU_GAIN_ERROR                                    0x01                                                     
#define AUD_EQU_LIMIT_FREQ_ERROR                              0x02                                                     
#define AUD_EQU_BAND_NUM_ERROR                                0x03                                                     
#define AUD_EQU_INVALID_ID                                    0x04                                                     

//ConstantTable for AUD_EQU_TYPE
#define AUD_EQU_PRESET                                        0x00                                                     
#define AUD_EQU_GRAPHICAL                                     0x01                                                     
#define AUD_EQU_TONE_CONTROL                                  0x02                                                     
#define AUD_EQU_OTHER_ADJUSTABLE                              0x03                                                     
#define AUD_EQU_OTHER_NON_ADJUSTABLE                          0x04                                                     

//ConstantTable for AUD_EQU_STATE
#define AUD_EQU_OFF                                           0x00                                                     
#define AUD_EQU_ON                                            0x01                                                     

//ConstantTable for AUD_SCO_STATE
#define AUD_SCO_OFF                                           0x00                                                     
#define AUD_SCO_ON                                            0x01                                                     

//ConstantTable for AUD_SCO_STATUS
#define AUD_SCO_OK                                            0x00                                                     
#define AUD_SCO_FAIL                                          0x01                                                     

//ConstantTable for AUD_AVDTP_COMMAND
#define AUD_AVDTP_CONFIGURE                                   0x00                                                     

//ConstantTable for AUD_AVDTP_STREAM_TYPE
#define AUD_AVDTP_SBC_IN_USE                                  0x00                                                     
#define AUD_AVDTP_SBC_NOT_IN_USE                              0x01                                                     

//ConstantTable for AUD_AVDTP_STATUS
#define AUD_AVDTP_OK                                          0x00                                                     
#define AUD_AVDTP_FAIL                                        0x01                                                     

//ConstantTable for AUD_DEFATTR_STATUS
#define AUD_DEFATTR_OK                                        0x00                                                     
#define AUD_DEFATTR_FAIL                                      0x01                                                     
#define AUD_DEFATTR_FAIL_INVALID_SERVICE                      0x02                                                     
#define AUD_DEFATTR_FAIL_INVALID_ATTR_ID                      0x03                                                     
#define AUD_DEFATTR_FAIL_INVALID_VALUE                        0x04                                                     

//ConstantTable for AUD_VOLUME_CONTROL_TYPE
#define AUD_VOLUME_PERCENT_CONTROL                            0x01                                                     
#define AUD_VOLUME_Q87_CONTROL                                0x02                                                     

//BitmaskTables for AUD_VOLUME_MEDIA_TYPE
#define AUD_CALL_VOLUME                                       0x0001                                                     
#define AUD_SPEECH_PLAYBACK_VOLUME                            0x0002                                                     
#define AUD_MEDIA_PLAYBACK_VOLUME                             0x0004                                                     
#define AUD_TRADITIONAL_TONE_VOLUME                           0x0008                                                     
#define AUD_FM_RADIO_VOLUME                                   0x0010                                                  
#define AUD_DTMF_TONE_VOLUME                                  0x0020                                                  

//ConstantTable for AUD_EANC_STATE
#define AUD_EANC_OFF                                          0x00                                                     
#define AUD_EANC_ON                                           0x01                                                     

//ConstantTable for AUD_TONE_SEQUENCE_TYPE
#define AUD_TONE_SEQUENCE_RING                                0x00                                                     
#define AUD_TONE_SEQUENCE_RING_SCAN                           0x01                                                     
#define AUD_TONE_SEQUENCE_ALERT                               0x02                                                     
#define AUD_TONE_SEQUENCE_KEY                                 0x03                                                     
#define AUD_TONE_SEQUENCE_MUSIC_PLAY                          0x04                                                     

//ConstantTable for AUD_ANALOG_OUT_VOL_BALANCE
#define AUD_ANALOG_OUT_VOL_BALANCE_L0                         0x00                                                     
#define AUD_ANALOG_OUT_VOL_BALANCE_L1                         0x01                                                     
#define AUD_ANALOG_OUT_VOL_BALANCE_L2                         0x02                                                     
#define AUD_ANALOG_OUT_VOL_BALANCE_L3                         0x03                                                     
#define AUD_ANALOG_OUT_VOL_BALANCE_L4                         0x04                                                     
#define AUD_ANALOG_OUT_VOL_BALANCE_L5                         0x05                                                     
#define AUD_ANALOG_OUT_VOL_BALANCE_L6                         0x06                                                     
#define AUD_ANALOG_OUT_VOL_BALANCE_L7                         0x07                                                     
#define AUD_ANALOG_OUT_VOL_BALANCE_L8                         0x08                                                     
#define AUD_ANALOG_OUT_VOL_BALANCE_L9                         0x09                                                     
#define AUD_ANALOG_OUT_VOL_BALANCE_L10                        0x0A                                                     
#define AUD_ANALOG_OUT_VOL_BALANCE_R0                         0x10                                                  
#define AUD_ANALOG_OUT_VOL_BALANCE_R1                         0x11                                                  
#define AUD_ANALOG_OUT_VOL_BALANCE_R2                         0x12                                                  
#define AUD_ANALOG_OUT_VOL_BALANCE_R3                         0x13                                                  
#define AUD_ANALOG_OUT_VOL_BALANCE_R4                         0x14                                                  
#define AUD_ANALOG_OUT_VOL_BALANCE_R5                         0x15                                                  
#define AUD_ANALOG_OUT_VOL_BALANCE_R6                         0x16                                                  
#define AUD_ANALOG_OUT_VOL_BALANCE_R7                         0x17                                                  
#define AUD_ANALOG_OUT_VOL_BALANCE_R8                         0x18                                                  
#define AUD_ANALOG_OUT_VOL_BALANCE_R9                         0x19                                                  
#define AUD_ANALOG_OUT_VOL_BALANCE_R10                        0x1A                                                  
#define AUD_ANALOG_OUT_VOL_BALANCE_C                          0x20                                                  

//ConstantTable for AUD_MIXER_UL_IN_SELECT
#define AUD_MIXER_UL_IN_MUTED                                 0x00                                                     
#define AUD_MIXER_UL_IN_HD_MIC                                0x01                                                     
#define AUD_MIXER_UL_IN_HF_MIC                                0x02                                                     
#define AUD_MIXER_UL_IN_HP_MIC                                0x03                                                     
#define AUD_MIXER_UL_IN_FM_MIC                                0x04                                                     
#define AUD_MIXER_UL_IN_BT                                    0x05                                                     
#define AUD_MIXER_UL_IN_DIGI                                  0x06                                                     
#define AUD_MIXER_UL_IN_FCI                                   0x07                                                     
#define AUD_MIXER_UL_IN_I2S                                   0x08                                                     
#define AUD_MIXER_UL_IN_DIGI_STEREO                           0x09                                                     
#define AUD_MIXER_UL_IN_EXT_MIC                               0x0A                                                     
#define AUD_MIXER_UL_IN_USB_MIC                               0x0B                                                     

//ConstantTable for AUD_MIXER_DL_OUT_SELECT
#define AUD_MIXER_DL_OUT_MUTED                                0x00                                                     
#define AUD_MIXER_DL_OUT_HP_EAR                               0x01                                                     
#define AUD_MIXER_DL_OUT_HD_EAR                               0x02                                                     
#define AUD_MIXER_DL_OUT_HF_EAR                               0x03                                                     
#define AUD_MIXER_DL_OUT_X_EAR                                0x04                                                     
#define AUD_MIXER_DL_OUT_STEREO_HD_EAR                        0x05                                                     
#define AUD_MIXER_DL_OUT_STEREO_HF_EAR                        0x06                                                     
#define AUD_MIXER_DL_OUT_IHFSP                                0x07                                                     
#define AUD_MIXER_DL_OUT_BT_EAR                               0x08                                                     
#define AUD_MIXER_DL_OUT_EXT_IHF                              0x09                                                     
#define AUD_MIXER_DL_OUT_EXT_IHF_LEFT                         0x0A                                                     
#define AUD_MIXER_DL_OUT_EXT_IHF_RIGHT                        0x0B                                                     
#define AUD_MIXER_DL_OUT_EXT_EAR_AMP                          0x0C                                                     
#define AUD_MIXER_DL_OUT_EAR_I2S                              0x0D                                                     
#define AUD_MIXER_DL_OUT_EXT_EAR_AMP_L                        0x0E                                                     
#define AUD_MIXER_DL_OUT_EXT_EAR_AMP_R                        0x0F                                                     
#define AUD_MIXER_DL_OUT_EXT_EAR_HFBIAS                       0x10                                                  
#define AUD_MIXER_DL_OUT_EXT_EAR_HFBIAS_L                     0x11                                                  
#define AUD_MIXER_DL_OUT_EXT_EAR_HFBIAS_R                     0x12                                                  
#define AUD_MIXER_DL_OUT_FMTX                                 0x13                                                  
#define AUD_MIXER_DL_OUT_FMTX_L                               0x14                                                  
#define AUD_MIXER_DL_OUT_FMTX_R                               0x15                                                  
#define AUD_MIXER_DL_OUT_USB                                  0x16                                                  
#define AUD_MIXER_DL_OUT_USB_L                                0x17                                                  
#define AUD_MIXER_DL_OUT_USB_R                                0x18                                                  
#define AUD_MIXER_DL_OUT_HD_EAR_L                             0x19                                                  
#define AUD_MIXER_DL_OUT_HD_EAR_R                             0x1A                                                  
#define AUD_MIXER_DL_OUT_HAC                                  0x1B                                                  
#define AUD_MIXER_DL_OUT_EAR_I2S_L                            0x1C                                                  
#define AUD_MIXER_DL_OUT_EAR_I2S_R                            0x1D                                                  

//BitmaskTables for AUD_MIXER_DTMF_OUT_SELECT
#define AUD_MIXER_DTMF_OUT_MUTED                              0x00                                                     
#define AUD_MIXER_DTMF_OUT_EAR                                0x01                                                     
#define AUD_MIXER_DTMF_OUT_ACC                                0x02                                                     
#define AUD_MIXER_DTMF_OUT_MEMORY                             0x04                                                     
#define AUD_MIXER_DTMF_OUT_TX                                 0x08                                                     
#define AUD_MIXER_DTMF_OUT_DEFAULT                            0x80                                                  

//BitmaskTables for AUD_MIXER_TONE_OUT_SELECT
#define AUD_MIXER_TONE_OUT_MUTED                              0x00                                                     
#define AUD_MIXER_TONE_OUT_EAR                                0x01                                                     
#define AUD_MIXER_TONE_OUT_SPEECH_EAR                         0x04                                                     
#define AUD_MIXER_TONE_OUT_BUZZER                             0x08                                                     
#define AUD_MIXER_TONE_OUT_HIGH_QUALITY                       0x10                                                  
#define AUD_MIXER_TONE_OUT_EAR_TX                             0x21                                                  
#define AUD_MIXER_TONE_OUT_SPEECH                             0x40                                                  
#define AUD_MIXER_TONE_OUT_DEFAULT                            0x80                                                  

//ConstantTable for AUD_MIXER_MODE_OUT_SELECT
#define AUD_MIXER_MODE_OUT_MONO                               0x00                                                     
#define AUD_MIXER_MODE_OUT_STEREO                             0x01                                                     

//ConstantTable for AUD_MIXER_QUALITY_SELECT
#define AUD_MIXER_QUALITY_NB                                  0x00                                                     
#define AUD_MIXER_QUALITY_WB                                  0x01                                                     
#define AUD_MIXER_QUALITY_HQ                                  0x02                                                     

//BitmaskTables for AUD_MIXER_APP_IN_SELECT
#define AUD_MIXER_APP_IN_MUTE                                 0x00                                                     
#define AUD_MIXER_APP_IN_CMT_DL                               0x01                                                     
#define AUD_MIXER_APP_IN_APE_SPEECH                           0x02                                                     
#define AUD_MIXER_APP_IN_APE_AUDIO                            0x04                                                     

//BitmaskTables for AUD_MIXER_APP_UL_SELECT
#define AUD_MIXER_APP_UL_MUTED                                0x00                                                     
#define AUD_MIXER_APP_UL_MIC                                  0x01                                                     
#define AUD_MIXER_APP_UL_TONE                                 0x02                                                     
#define AUD_MIXER_APP_UL_SPEECH                               0x04                                                     
#define AUD_MIXER_APP_UL_AUDIO                                0x08                                                     

//BitmaskTables for AUD_MIXER_APP_REC_SELECT
#define AUD_MIXER_APP_REC_MUTED                               0x00                                                     
#define AUD_MIXER_APP_REC_MIC                                 0x01                                                     
#define AUD_MIXER_APP_REC_CMTDL                               0x02                                                     
#define AUD_MIXER_APE_AUD_REC                                 0x04                                                     
#define AUD_MIXER_APE_TONE_AUD_REC                            0x08                                                     

//ConstantTable for AUD_MIXER_DL_OUT_TRANSMIT_SELECT
#define AUD_MIXER_DL_OUT_TRANSMIT_OFF                         0x00                                                     
#define AUD_MIXER_DL_OUT_TRANSMIT_TX_ONLY                     0x01                                                     
#define AUD_MIXER_DL_OUT_TRANSMIT_TX_AND_PHONE                0x02                                                     

//ConstantTable for AUD_MIXER_PLAYBACK_MODE_SELECT
#define AUD_MIXER_PLAYBACK_REALTIME                           0x00                                                     
#define AUD_MIXER_PLAYBACK_POWERSAVE                          0x01                                                     

//ConstantTable for AUD_TEST_TYPES
#define AUD_TEST_HP_IN_EXT_OUT                                0x01                                                     
#define AUD_TEST_EXT_IN_HP_OUT                                0x02                                                     
#define AUD_TEST_DIG_IN_DIG_OUT                               0x04                                                     
#define AUD_TEST_AIC33_LINEIN_LEFT_HP_OUT                     0x05                                                     
#define AUD_TEST_AIC33_LINEIN_RIGHT_HP_OUT                    0x06                                                     
#define AUD_TEST_EXT_IN_HAC_OUT                               0x07                                                     
#define AUD_TEST_ADC_OUT_DAC_IN                               0x08                                                     
#define AUD_TEST_STEREO_DIG_IN_EXT_OUT                        0x09                                                     
#define AUD_TEST_BUZZER                                       0x10                                                  
#define AUD_TEST_HP_IN_AV_OUT                                 0x11                                                  
#define AUD_TEST_AV_IN_AV_OUT                                 0x12                                                  
#define AUD_TEST_FM_IN_AV_OUT                                 0x13                                                  
#define AUD_TEST_AV_IN_IHF_OUT                                0x14                                                  
#define AUD_TEST_AV_IN_HP_OUT                                 0x15                                                  
#define AUD_TEST_USB_IN_USB_OUT                               0x16                                                  
#define AUD_TEST_HP_IN_USB_OUT                                0x17                                                  
#define AUD_TEST_USB_IN_IHF_OUT                               0x18                                                  
#define AUD_TEST_USB_IN_HP_OUT                                0x19                                                  
#define AUD_TEST_MIC_IN_EANC_ON_OUT                           0x1A                                                  
#define AUD_TEST_MIC_IN_EANC_OFF_OUT                          0x1B                                                  
#define AUD_TEST_EANC_PROD_MODE                               0x1C                                                  
#define AUD_TEST_EANC_SP_MODE                                 0x1D                                                  
#define AUD_TEST_FM_TX_OUT                                    0x1E                                                  
#define AUD_TEST_HP_MIC1_IN_AV_OUT                            0x1F                                                  
#define AUD_TEST_HP_MIC2_IN_AV_OUT                            0x21                                                  
#define AUD_TEST_HP_STEREO_IN_AV_OUT                          0x22                                                  
#define AUD_TEST_EXT_IN_IHF_OUT                               0x20                                                  
#define AUD_TEST_EXT_IN_EXT_OUT                               0x40                                                  
#define AUD_TEST_FM_IN_EXT_OUT                                0x80                                                  

//ConstantTable for AUD_ERROR_CAUSES
#define AUD_CLIENT_NOT_SUPPORTED                              0x00                                                     
#define AUD_CLIENT_NOT_ALLOWED                                0x01                                                     
#define AUD_CLIENT_NOT_REGISTERED                             0x02                                                     
#define AUD_SERVICE_NOT_AVAILABLE                             0x03                                                     
#define AUD_ATTRIBUTE_NOT_AVAILABLE                           0x04                                                     
#define AUD_ALL_SETTINGS_INVALID                              0x05                                                     
#define AUD_SETTING_NOT_POSSIBLE                              0x06                                                     
#define AUD_TEST_TYPE_NOT_AVAILABLE                           0x07                                                     

//ConstantTable for AUD_ATTRIBUTE_SETTING_OPERATIONS
#define AUD_VALUE_SUBSTITUTE                                  0x00                                                     
#define AUD_VALUE_INCREASE                                    0x01                                                     
#define AUD_VALUE_DECREASE                                    0x02                                                     
#define AUD_VALUE_BITWISE_OR                                  0x03                                                     
#define AUD_VALUE_BITWISE_AND                                 0x04                                                     

//ConstantTable for AUDIO_SERVICE_CONFIGURATIONS
#define AUD_CONFIG_NON_DEFAULT                                0x00                                                     
#define AUD_CONFIG_DEFAULT                                    0x01                                                     

//ConstantTable for AUD_LAYER_UPDATE_GENERAL_STATUS
#define AUD_ALL_SETTINGS_OK                                   0x00                                                     
#define AUD_SOME_SETTINGS_LIMITED                             0x01                                                     
#define AUD_SOME_SETTINGS_INVALID                             0x02                                                     

//ConstantTable for AUD_LAYER_UPDATE_ATTR_SPEC_STATUS
#define AUD_SETTING_NOT_ALLOWED                               0x00                                                     
#define AUD_SETTING_VALUE_NOT_OK                              0x01                                                     
#define AUD_SETTING_OK                                        0x02                                                     
#define AUD_SETTING_CUT_TO_UPPER_LIMIT                        0x03                                                     
#define AUD_SETTING_CUT_TO_LOWER_LIMIT                        0x04                                                     

//ConstantTable for AUD_LAYER_UPDATE_GENERAL_EFFICIENCY
#define AUD_ALL_SETTINGS_EFFECTIVE                            0x00                                                     
#define AUD_SOME_SETTINGS_INEFFECTIVE                         0x01                                                     

//ConstantTable for AUD_LAYER_UPDATE_ATTR_EFFICIENCY
#define AUD_LAYER_INEFFECTIVE                                 0x00                                                     
#define AUD_LAYER_EFFECTIVE                                   0x01                                                     

//ConstantTable for AUD_LAYER_UPDATE_ATTR_EVENTS
#define AUD_LAYER_ON_TOP                                      0x00                                                     
#define AUD_LAYER_SETTING_CHANGE                              0x01                                                     

//ConstantTable for AUD_FEATURE_ID
#define AUD_VOICE_UI                                          0x01                                                     

//ConstantTable for AUD_SWITCH_VALUES
#define AUD_SWITCH_OFF                                        0x00                                                     
#define AUD_SWITCH_ON                                         0x01                                                     

//ConstantTable for AUD_CLIENT_TYPES
#define AUD_NO_CLIENT_TYPE                                    0x00                                                     
#define AUD_UI_CLIENT_TYPE                                    0x01                                                     
#define AUD_CS_CLIENT_TYPE                                    0x02                                                     
#define AUD_ACC_CLIENT_TYPE                                   0x03                                                     
#define AUD_EXT_CLIENT_TYPE                                   0x04                                                     
#define AUD_BATT_CLIENT_TYPE                                  0x05                                                     
#define AUD_DSP_CLIENT_TYPE                                   0x06                                                     
#define AUD_TEST_CLIENT_TYPE                                  0x07                                                     
#define AUD_SOUND_CLIENT_TYPE                                 0x08                                                     
#define AUD_CS_HIGH_CLIENT_TYPE                               0x09                                                     
#define AUD_VOL_CTRL_CLIENT_TYPE                              0x0A                                                     
#define AUD_UI_2_CLIENT_TYPE                                  0x0B                                                     
#define AUD_KODIAK_CLIENT_TYPE                                0x0C                                                     

//ConstantTable for AUD_DSP_PHAP_VALUES
#define AUD_DSP_PHAP_OFF                                      0x00                                                     
#define AUD_DSP_PHAP_NORMAL                                   0x01                                                     
#define AUD_DSP_PHAP_SLIGHT                                   0x02                                                     
#define AUD_DSP_PHAP_MILD                                     0x03                                                     
#define AUD_DSP_PHAP_MODERATE                                 0x04                                                     

//BitmaskTables for AUD_DSP_ALGORITHMS_1
#define AUD_DSP_ALGORITHM_OFF                                 0x0000                                                     
#define AUD_DSP_ALGORITHM_AEC                                 0x0001                                                     
#define AUD_DSP_ALGORITHM_AEC_SUPP                            0x0002                                                     
#define AUD_DSP_ALGORITHM_UALWE                               0x0004                                                     
#define AUD_DSP_ALGORITHM_UALWE_PAUSE_ATT                     0x0008                                                     
#define AUD_DSP_ALGORITHM_DALWE                               0x0010                                                  
#define AUD_DSP_ALGORITHM_DALWE_PAUSE_ATT                     0x0020                                                  
#define AUD_DSP_ALGORITHM_DDRC                                0x0040                                                  
#define AUD_DSP_ALGORITHM_UDRC                                0x0080                                                  
#define AUD_DSP_ALGORITHM_FDRC                                0x0100                                                   
#define AUD_DSP_ALGORITHM_AGC                                 0x0200                                                   
#define AUD_DSP_ALGORITHM_AVC                                 0x0400                                                   
#define AUD_DSP_ALGORITHM_GEQ                                 0x0800                                                   
#define AUD_DSP_ALGORITHM_PEQ                                 0x1000                                                  
#define AUD_DSP_ALGORITHM_AEC_CN                              0x2000                                                  
#define AUD_DSP_ALGORITHM_IHF                                 0x4000                                                  
#define AUD_DSP_ALGORITHM_MIMDRC                              0x8000                                                  

//BitmaskTables for AUD_DSP_ALGORITHMS_2
//#define AUD_DSP_ALGORITHM_OFF                               0x0000                        //Already defined as 0x0000
#define AUD_DSP_ALGORITHM_EEQ                                 0x0001                                                     
#define AUD_DSP_ALGORITHM_MEQ                                 0x0002                                                     
#define AUD_DSP_ALGORITHM_ANC                                 0x0004                                                     
#define AUD_DSP_ALGORITHM_MICHP                               0x0008                                                     
#define AUD_DSP_ALGORITHM_UEM_DECIM                           0x0010                                                  
#define AUD_DSP_ALGORITHM_UEM_INTERP                          0x0020                                                  
#define AUD_DSP_ALGORITHM_SIDETONE_EQU                        0x0040                                                  
#define AUD_DSP_ALGORITHM_MIDI_HP                             0x0080                                                  
#define AUD_DSP_ALGORITHM_MIDI_EQU                            0x0100                                                   
#define AUD_DSP_ALGORITHM_MIDI_LIM                            0x0200                                                   
#define AUD_DSP_ALGORITHM_DDRC_VOL_DEP                        0x0400                                                   
#define AUD_DSP_ALGORITHM_DDRC_NOISE_DEP                      0x0800                                                   
#define AUD_DSP_ALGORITHM_MIDI_REVERB                         0x1000                                                  
#define AUD_DSP_ALGORITHM_HQ_EEQ                              0x2000                                                  
#define AUD_DSP_ALGORITHM_HQ_MEQ                              0x4000                                                  
#define AUD_DSP_ALGORITHM_ABE                                 0x8000                                                  

//BitmaskTables for AUD_DSP_ALGORITHMS_3
//#define AUD_DSP_ALGORITHM_OFF                               0x0000                        //Already defined as 0x0000
#define AUD_DSP_ALGORITHM_NES                                 0x0001                                                     
#define AUD_DSP_ALGORITHM_AMODE_AEC                           0x0002                                                     
#define AUD_DSP_ALGORITHM_EAR_PROT_LIM                        0x0004                                                     
#define AUD_DSP_ALGORITHM_FAST_DRC                            0x0008                                                     
#define AUD_DSP_ALGORITHM_SPC_TTY                             0x0010                                                  
#define AUD_DSP_ALGORITHM_SIZZ_SUPP                           0x0020                                                  
#define AUD_DSP_ALGORITHM_AVC_LOOPSET                         0x0040                                                  
#define AUD_DSP_ALGORITHM_AMODE_LIMA                          0x0080                                                  
#define AUD_DSP_ALGORITHM_EARHP                               0x0100                                                   
#define AUD_DSP_ALGORITHM_FAST_DRC_TX                         0x0200                                                   
#define AUD_DSP_ALGORITHM_WNR                                 0x0400                                                   
#define AUD_DSP_ALGORITHM_SHC                                 0x0800                                                   
#define AUD_DSP_ALGORITHM_VAD                                 0x1000                                                  
#define AUD_DSP_ALGORITHM_SLM                                 0x2000                                                  
#define AUD_DSP_ALGORITHM_MANUAL_CONTROL                      0x4000                                                  
#define AUD_DSP_ALGORITHM_XDRC                                0x8000                                                  

//BitmaskTables for AUD_DSP_ALGORITHMS_4
//#define AUD_DSP_ALGORITHM_OFF                               0x0000                        //Already defined as 0x0000
#define AUD_DSP_ALGORITHM_XPROT_TEMP                          0x0001                                                     
#define AUD_DSP_ALGORITHM_XPROT_DISP                          0x0002                                                     
#define AUD_DSP_ALGORITHM_MUMDRC                              0x0004                                                     
#define AUD_DSP_ALGORITHM_STW_HD                              0x0008                                                     
#define AUD_DSP_ALGORITHM_STW_LS                              0x0010                                                  
#define AUD_DSP_ALGORITHM_DOPPLER                             0x0020                                                  
#define AUD_DSP_ALGORITHM_POS3D_HD                            0x0040                                                  
#define AUD_DSP_ALGORITHM_POS3D_LS                            0x0080                                                  
#define AUD_DSP_ALGORITHM_REVERB                              0x0100                                                   
#define AUD_DSP_ALGORITHM_AUDIO_VIS                           0x0200                                                   
#define AUD_DSP_ALGORITHM_SPAC                                0x0400                                                   
#define AUD_DSP_ALGORITHM_REC_MUMDRC                          0x0800                                                   
#define AUD_DSP_ALGORITHM_REC_LIMITER                         0x1000                                                  
#define AUD_DSP_ALGORITHM_FULLBAND_AGC                        0x2000                                                  

//BitmaskTables for AUD_DSP_ALGORITHMS_5
//#define AUD_DSP_ALGORITHM_OFF                               0x0000                        //Already defined as 0x0000
#define AUD_DSP_ALGORITHM_UDRC_WHISPER_MODE                   0x0001                                                     
#define AUD_DSP_ALGORITHM_RX_IAVC                             0x0002                                                     
#define AUD_DSP_ALGORITHM_TX_IAVC                             0x0004                                                     
#define AUD_DSP_ALGORITHM_MB_UDRC                             0x0008                                                     
#define AUD_DSP_ALGORITHM_LIMITER                             0x0010                                                  
#define AUD_DSP_ALGORITHM_LIMITER_CONDITIONAL                 0x0020                                                  
#define AUD_DSP_ALGORITHM_NB_SPC_EMPHASIS                     0x0040                                                  
#define AUD_DSP_ALGORITHM_MMIC_SELECT_CAL_GAIN_ESTIM          0x0080                                                  
#define AUD_DSP_ALGORITHM_MMIC_SELECT_CAL_GAIN_APPLY          0x0100                                                   
#define AUD_DSP_ALGORITHM_MMIC_SELECT_STB                     0x0200                                                   
#define AUD_DSP_ALGORITHM_MMIC_SELECT_AIC                     0x0400                                                   
#define AUD_DSP_ALGORITHM_MMIC_SELECT_POS                     0x0800                                                   
#define AUD_DSP_ALGORITHM_MMIC                                0x1000                                                  
#define AUD_DSP_ALGORITHM_TRUE_WB                             0x2000                                                  

//BitmaskTables for AUD_CLIENT_TYPES_1
#define AUD_CLIENT_SOUND                                      0x01                                                     
#define AUD_CLIENT_UI                                         0x02                                                     
#define AUD_CLIENT_CS                                         0x04                                                     
#define AUD_CLIENT_ACC                                        0x08                                                     
#define AUD_CLIENT_EXT                                        0x10                                                  
#define AUD_CLIENT_BATT                                       0x20                                                  
#define AUD_CLIENT_DSP                                        0x40                                                  
#define AUD_CLIENT_TEST                                       0x80                                                  

//BitmaskTables for AUD_CLIENT_TYPES_2
#define AUD_CLIENT_CS_HIGH                                    0x02                                                     

//ConstantTable for AUD_HW_STATUSES
#define AUD_HW_STATUS_READY                                   0x00                                                     
#define AUD_HW_STATUS_BUSY                                    0x01                                                     

//ConstantTable for FtdTable
#define COMM_FTD_DATA_AUD_ACCESSORY_MODE                      0x01A0                                                   
#define COMM_FTD_DATA_AUD_ANADIGI_MODE                        0x01A1                                                   
#define COMM_FTD_DATA_AUD_MIXER_ULI                           0x01A2                                                   
#define COMM_FTD_DATA_AUD_MIXER_DLO                           0x01A3                                                   
#define COMM_FTD_DATA_AUD_AIN_GAIN                            0x01A4                                                   
#define COMM_FTD_DATA_AUD_AOU_VOL                             0x01A5                                                   
#define COMM_FTD_DATA_AUD_MIXER_DPW                           0x01A6                                                   
#define COMM_FTD_DATA_AUD_MIXER_UPW                           0x01A7                                                   

//ConstantTable for AUD_TEST_TX_OUT_ROUTE
#define AUD_FM_TX_OUT_LEFT                                    0x01                                                     
#define AUD_FM_TX_OUT_RIGHT                                   0x02                                                     
#define AUD_FM_TX_OUT_STEREO                                  0x03                                                     

//ConstantTable for AUD_TEST_ERRORS
//#define AUD_TEST_TYPE_NOT_AVAILABLE                         0x07                        //Already defined as 0x07
//#define AUD_SETTING_NOT_ALLOWED                             0x00                        //Already defined as 0x00
//#define AUD_SETTING_NOT_POSSIBLE                            0x06                        //Already defined as 0x06
#define AUD_EANC_L_MIC_FAIL                                   0x10                                                  
#define AUD_EANC_R_MIC_FAIL                                   0x11                                                  
#define AUD_EANC_BOTH_MICS_FAIL                               0x12                                                  


//SUBBLOCKS


//Definition for struct AUD_SERVICE_REPORT
#define AUD_SERVICE_REPORT                                    0x00                                                     
typedef struct
            { 
             uint8_t      subblockid;
             uint8_t      subblocklength;
             uint8_t      serviceid;
             uint8_t      attributesetup;
            } __attribute__((packed)) AUD_SERVICE_REPORT_STR;
#define SIZE_AUD_SERVICE_REPORT                               sizeof(AUD_SERVICE_REPORT_STR)


//Definition for struct AUD_ATTRIBUTE_SETUP_REPORT
#define AUD_ATTRIBUTE_SETUP_REPORT                            0x01                                                     
typedef struct
            { 
             uint8_t      subblockid;
             uint8_t      subblocklength;
             uint8_t      attributeid;
             uint8_t      fillerbyte1;
             uint16_t     defaultvalue;
             uint16_t     minimumvalue;
             uint16_t     maximumvalue;
             uint16_t     fillerbyte2;
            } __attribute__((packed)) AUD_ATTRIBUTE_SETUP_REPORT_STR;
#define SIZE_AUD_ATTRIBUTE_SETUP_REPORT                       sizeof(AUD_ATTRIBUTE_SETUP_REPORT_STR)


//Definition for struct AUD_DSP_PARBLOCK
#define AUD_DSP_PARBLOCK                                      0x04                                                     
typedef struct
            { 
             uint8_t      subblockid;
             uint8_t      subblocklength;
             uint8_t      datablocklength;
             uint8_t      fillerbyte1;
             uint8_t      datablockframe[128];
            } __attribute__((packed)) AUD_DSP_PARBLOCK_STR;
#define SIZE_AUD_DSP_PARBLOCK                                 sizeof(AUD_DSP_PARBLOCK_STR)


//Definition for struct AUD_SETTING_REPORT
#define AUD_SETTING_REPORT                                    0x02                                                     
typedef struct
            { 
             uint8_t      subblockid;
             uint8_t      subblocklength;
             uint8_t      attributeid;
             uint8_t      filler;
             uint16_t     attributevalue;
             uint16_t     filler;
            } __attribute__((packed)) AUD_SETTING_REPORT_STR;
#define SIZE_AUD_SETTING_REPORT                               sizeof(AUD_SETTING_REPORT_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.
//This definition is propably impossible to generate due the IF/ELSE statements in specification.
//See ISI message specification for further details of message structure.
//https://oucmswww.nmp.nokia.com:59080/document_browser/


//Definition for struct AUD_LAYER_SETTING
#define AUD_LAYER_SETTING                                     0x03                                                     
typedef struct
            { 
             uint8_t      subblockid;
             uint8_t      subblocklength;
             uint8_t      attributeid;
             uint8_t      operation;
             uint16_t     attributevalue;
             uint16_t     filler;
            } __attribute__((packed)) AUD_LAYER_SETTING_STR;
#define SIZE_AUD_LAYER_SETTING                                sizeof(AUD_LAYER_SETTING_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.
//This definition is propably impossible to generate due the IF/ELSE statements in specification.
//See ISI message specification for further details of message structure.
//https://oucmswww.nmp.nokia.com:59080/document_browser/


//Definition for struct AUD_ATTRIBUTE_LAYER_REPORT
#define AUD_ATTRIBUTE_LAYER_REPORT                            0x05                                                     
typedef struct
            { 
             uint8_t      subblockid;
             uint8_t      subblocklength;
             uint8_t      attributeid;
             uint8_t      event;
             uint8_t      clienttype;
             uint8_t      fillerbyte1;
             uint16_t     attributevalue;
            } __attribute__((packed)) AUD_ATTRIBUTE_LAYER_REPORT_STR;
#define SIZE_AUD_ATTRIBUTE_LAYER_REPORT                       sizeof(AUD_ATTRIBUTE_LAYER_REPORT_STR)


//Definition for struct AUD_ATTRIBUTE_UPDATE_REPORT
#define AUD_ATTRIBUTE_UPDATE_REPORT                           0x06                                                     
typedef struct
            { 
             uint8_t      subblockid;
             uint8_t      subblocklength;
             uint8_t      attributeid;
             uint8_t      status;
             uint8_t      efficiency;
             uint8_t      fillerbyte1;
             uint16_t     fillerbyte2;
            } __attribute__((packed)) AUD_ATTRIBUTE_UPDATE_REPORT_STR;
#define SIZE_AUD_ATTRIBUTE_UPDATE_REPORT                      sizeof(AUD_ATTRIBUTE_UPDATE_REPORT_STR)


//Definition for struct AUD_VOLUME_CONTROL_SB
#define AUD_VOLUME_CONTROL_SB                                 0x09                                                     
typedef struct
            { 
             uint8_t      subblockid;
             uint8_t      subblocklength;
             uint16_t     media_type;
             uint8_t      control_format;
             uint8_t      fillerbyte1;
             uint16_t     fillerbyte2;
             uint16_t     pri_volume_in_percetance;
             int16_t      pri_volume_in_q87;
             uint16_t     sec_volume_in_percetance;
             int16_t      sec_volume_in_q87;
            } __attribute__((packed)) AUD_VOLUME_CONTROL_SB_STR;
#define SIZE_AUD_VOLUME_CONTROL_SB                            sizeof(AUD_VOLUME_CONTROL_SB_STR)


//Definition for struct AUD_VOLUME_CONTROL_RESPONSE_SB
#define AUD_VOLUME_CONTROL_RESPONSE_SB                        0x0A                                                     
typedef struct
            { 
             uint8_t      subblockid;
             uint8_t      subblocklength;
             uint16_t     media_type;
             uint8_t      control_format;
             uint8_t      fillerbyte1;
             uint16_t     fillerbyte2;
             uint16_t     requested_pri_volume_in_percetance;
             int16_t      requested_pri_volume_in_q87;
             int16_t      pri_actual_gain;
             int16_t      pri_missing_gain;
             int16_t      pri_target_gain;
             int16_t      pri_analog_gain;
             int16_t      pri_digital_gain;
             int16_t      pri_min_gain;
             int16_t      pri_max_gain;
             uint16_t     requested_sec_volume_in_percetance;
             int16_t      requested_sec_volume_in_q87;
             int16_t      sec_actual_gain;
             int16_t      sec_missing_gain;
             int16_t      sec_target_gain;
             int16_t      sec_analog_gain;
             int16_t      sec_digital_gain;
             int16_t      sec_min_gain;
             int16_t      sec_max_gain;
            } __attribute__((packed)) AUD_VOLUME_CONTROL_RESPONSE_SB_STR;
#define SIZE_AUD_VOLUME_CONTROL_RESPONSE_SB                   sizeof(AUD_VOLUME_CONTROL_RESPONSE_SB_STR)


//Definition for struct AUD_EQU_DEFINITION
#define AUD_EQU_DEFINITION                                    0x07                                                     
typedef struct
            { 
             uint8_t      subblockid;
             uint8_t      subblocklength;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      limitfrequency[16];
             int8_t       bandsgain[8];
             uint8_t      fillerbyte3;
             uint8_t      namelength;
             uint16_t     name;
            } __attribute__((packed)) AUD_EQU_DEFINITION_STR;
#define SIZE_AUD_EQU_DEFINITION                               sizeof(AUD_EQU_DEFINITION_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct AUD_COMM_FTD_DATA_BYTE
#define AUD_COMM_FTD_DATA_BYTE                                0x01                                                     
typedef struct
            { 
             uint16_t     subblockid;
             uint8_t      subblock_length;
             uint8_t      data;
            } __attribute__((packed)) AUD_COMM_FTD_DATA_BYTE_STR;
#define SIZE_AUD_COMM_FTD_DATA_BYTE                           sizeof(AUD_COMM_FTD_DATA_BYTE_STR)


//Definition for struct AUD_EQU_GENERAL_INFO
#define AUD_EQU_GENERAL_INFO                                  0x08                                                     
typedef struct
            { 
             uint8_t      subblockid;
             uint8_t      subblocklength;
             uint8_t      equmaxnum;
             uint8_t      equpresetnum;
             int8_t       gainmin;
             int8_t       gainmax;
             uint8_t      bandsmaxnum;
             uint8_t      fillerbyte1;
             uint8_t      bandwidth[16];
             uint8_t      centerfreq[16];
             uint8_t      crossoverfreq[14];
             uint16_t     fillerbyte2;
            } __attribute__((packed)) AUD_EQU_GENERAL_INFO_STR;
#define SIZE_AUD_EQU_GENERAL_INFO                             sizeof(AUD_EQU_GENERAL_INFO_STR)


//MESSAGES


//Definition for struct AUD_REGISTER_IN_REQ
#define AUD_REGISTER_IN_REQ                                   0x00                                                     
typedef struct
            { 
             uint8_t      transactionid;
             uint8_t      messageid;
             uint8_t      clienttype;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) AUD_REGISTER_IN_REQ_STR;
#define SIZE_AUD_REGISTER_IN_REQ                              sizeof(AUD_REGISTER_IN_REQ_STR)


//Definition for struct AUD_REGISTER_IN_OK_RESP
#define AUD_REGISTER_IN_OK_RESP                               0x01                                                     
typedef struct
            { 
             uint8_t      transactionid;
             uint8_t      messageid;
             uint8_t      clientid;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) AUD_REGISTER_IN_OK_RESP_STR;
#define SIZE_AUD_REGISTER_IN_OK_RESP                          sizeof(AUD_REGISTER_IN_OK_RESP_STR)


//Definition for struct AUD_REGISTER_IN_FAIL_RESP
#define AUD_REGISTER_IN_FAIL_RESP                             0x02                                                     
typedef struct
            { 
             uint8_t      transactionid;
             uint8_t      messageid;
             uint8_t      failurereason;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) AUD_REGISTER_IN_FAIL_RESP_STR;
#define SIZE_AUD_REGISTER_IN_FAIL_RESP                        sizeof(AUD_REGISTER_IN_FAIL_RESP_STR)


//Definition for struct AUD_REGISTER_IN_IND
#define AUD_REGISTER_IN_IND                                   0x03                                                     
typedef struct
            { 
             uint8_t      transactionid;
             uint8_t      messageid;
             uint8_t      clienttype;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) AUD_REGISTER_IN_IND_STR;
#define SIZE_AUD_REGISTER_IN_IND                              sizeof(AUD_REGISTER_IN_IND_STR)


//Definition for struct AUD_REGISTER_OUT_REQ
#define AUD_REGISTER_OUT_REQ                                  0x04                                                     
typedef struct
            { 
             uint8_t      transactionid;
             uint8_t      messageid;
             uint8_t      clientid;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) AUD_REGISTER_OUT_REQ_STR;
#define SIZE_AUD_REGISTER_OUT_REQ                             sizeof(AUD_REGISTER_OUT_REQ_STR)


//Definition for struct AUD_REGISTER_OUT_OK_RESP
#define AUD_REGISTER_OUT_OK_RESP                              0x05                                                     
typedef struct
            { 
             uint8_t      transactionid;
             uint8_t      messageid;
             uint16_t     fillerbyte1;
            } __attribute__((packed)) AUD_REGISTER_OUT_OK_RESP_STR;
#define SIZE_AUD_REGISTER_OUT_OK_RESP                         sizeof(AUD_REGISTER_OUT_OK_RESP_STR)


//Definition for struct AUD_REGISTER_OUT_FAIL_RESP
#define AUD_REGISTER_OUT_FAIL_RESP                            0x06                                                     
typedef struct
            { 
             uint8_t      transactionid;
             uint8_t      messageid;
             uint8_t      failurereason;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) AUD_REGISTER_OUT_FAIL_RESP_STR;
#define SIZE_AUD_REGISTER_OUT_FAIL_RESP                       sizeof(AUD_REGISTER_OUT_FAIL_RESP_STR)


//Definition for struct AUD_REGISTER_OUT_IND
#define AUD_REGISTER_OUT_IND                                  0x07                                                     
typedef struct
            { 
             uint8_t      transactionid;
             uint8_t      messageid;
             uint8_t      clienttype;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) AUD_REGISTER_OUT_IND_STR;
#define SIZE_AUD_REGISTER_OUT_IND                             sizeof(AUD_REGISTER_OUT_IND_STR)


//Definition for struct AUD_SERVICES_GET_REQ
#define AUD_SERVICES_GET_REQ                                  0x08                                                     
typedef struct
            { 
             uint8_t      transactionid;
             uint8_t      messageid;
             uint16_t     fillerbyte1;
            } __attribute__((packed)) AUD_SERVICES_GET_REQ_STR;
#define SIZE_AUD_SERVICES_GET_REQ                             sizeof(AUD_SERVICES_GET_REQ_STR)


//Definition for struct AUD_SERVICES_GET_DEFAULT_OK_RESP
#define AUD_SERVICES_GET_DEFAULT_OK_RESP                      0x09                                                     
typedef struct
            { 
             uint8_t      transactionid;
             uint8_t      messageid;
             uint16_t     fillerbyte1;
            } __attribute__((packed)) AUD_SERVICES_GET_DEFAULT_OK_RESP_STR;
#define SIZE_AUD_SERVICES_GET_DEFAULT_OK_RESP                 sizeof(AUD_SERVICES_GET_DEFAULT_OK_RESP_STR)


//Definition for struct AUD_SERVICES_GET_CUSTOM_OK_RESP
#define AUD_SERVICES_GET_CUSTOM_OK_RESP                       0x0A                                                     
typedef struct
            { 
             uint8_t      transactionid;
             uint8_t      messageid;
             uint8_t      fillerbyte1;
             uint8_t      numofsubblocks;
            } __attribute__((packed)) AUD_SERVICES_GET_CUSTOM_OK_RESP_STR;
#define SIZE_AUD_SERVICES_GET_CUSTOM_OK_RESP                  sizeof(AUD_SERVICES_GET_CUSTOM_OK_RESP_STR)


//Definition for struct AUD_ATTRIBUTES_GET_REQ
#define AUD_ATTRIBUTES_GET_REQ                                0x0B                                                     
typedef struct
            { 
             uint8_t      transactionid;
             uint8_t      messageid;
             uint8_t      serviceid;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) AUD_ATTRIBUTES_GET_REQ_STR;
#define SIZE_AUD_ATTRIBUTES_GET_REQ                           sizeof(AUD_ATTRIBUTES_GET_REQ_STR)


//Definition for struct AUD_ATTRIBUTES_GET_DEFAULT_OK_RESP
#define AUD_ATTRIBUTES_GET_DEFAULT_OK_RESP                    0x0C                                                     
typedef struct
            { 
             uint8_t      transactionid;
             uint8_t      messageid;
             uint8_t      serviceid;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) AUD_ATTRIBUTES_GET_DEFAULT_OK_RESP_STR;
#define SIZE_AUD_ATTRIBUTES_GET_DEFAULT_OK_RESP               sizeof(AUD_ATTRIBUTES_GET_DEFAULT_OK_RESP_STR)


//Definition for struct AUD_ATTRIBUTES_GET_CUSTOM_OK_RESP
#define AUD_ATTRIBUTES_GET_CUSTOM_OK_RESP                     0x0D                                                     
typedef struct
            { 
             uint8_t      transactionid;
             uint8_t      messageid;
             uint8_t      serviceid;
             uint8_t      numofsubblocks;
            } __attribute__((packed)) AUD_ATTRIBUTES_GET_CUSTOM_OK_RESP_STR;
#define SIZE_AUD_ATTRIBUTES_GET_CUSTOM_OK_RESP                sizeof(AUD_ATTRIBUTES_GET_CUSTOM_OK_RESP_STR)


//Definition for struct AUD_ATTRIBUTES_GET_FAIL_RESP
#define AUD_ATTRIBUTES_GET_FAIL_RESP                          0x0E                                                     
typedef struct
            { 
             uint8_t      transactionid;
             uint8_t      messageid;
             uint8_t      serviceid;
             uint8_t      failurereason;
            } __attribute__((packed)) AUD_ATTRIBUTES_GET_FAIL_RESP_STR;
#define SIZE_AUD_ATTRIBUTES_GET_FAIL_RESP                     sizeof(AUD_ATTRIBUTES_GET_FAIL_RESP_STR)


//Definition for struct AUD_REGISTERED_GET_REQ
#define AUD_REGISTERED_GET_REQ                                0x0F                                                     
typedef struct
            { 
             uint8_t      transactionid;
             uint8_t      messageid;
             uint16_t     fillerbyte1;
            } __attribute__((packed)) AUD_REGISTERED_GET_REQ_STR;
#define SIZE_AUD_REGISTERED_GET_REQ                           sizeof(AUD_REGISTERED_GET_REQ_STR)


//Definition for struct AUD_REGISTERED_GET_OK_RESP
#define AUD_REGISTERED_GET_OK_RESP                            0x10                                                  
typedef struct
            { 
             uint8_t      transactionid;
             uint8_t      messageid;
             uint8_t      numofclients;
             uint8_t      clienttypes;
             uint8_t      clienttypese;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
            } __attribute__((packed)) AUD_REGISTERED_GET_OK_RESP_STR;
#define SIZE_AUD_REGISTERED_GET_OK_RESP                       sizeof(AUD_REGISTERED_GET_OK_RESP_STR)


//Definition for struct AUD_SETTING_GET_REQ
#define AUD_SETTING_GET_REQ                                   0x11                                                  
typedef struct
            { 
             uint8_t      transactionid;
             uint8_t      messageid;
             uint8_t      serviceid;
             uint8_t      attributeid;
            } __attribute__((packed)) AUD_SETTING_GET_REQ_STR;
#define SIZE_AUD_SETTING_GET_REQ                              sizeof(AUD_SETTING_GET_REQ_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct AUD_SETTING_GET_OK_RESP
#define AUD_SETTING_GET_OK_RESP                               0x12                                                  
typedef struct
            { 
             uint8_t      transactionid;
             uint8_t      messageid;
             uint8_t      serviceid;
             uint8_t      numofsubblocks;
            } __attribute__((packed)) AUD_SETTING_GET_OK_RESP_STR;
#define SIZE_AUD_SETTING_GET_OK_RESP                          sizeof(AUD_SETTING_GET_OK_RESP_STR)


//Definition for struct AUD_SETTING_GET_FAIL_RESP
#define AUD_SETTING_GET_FAIL_RESP                             0x13                                                  
typedef struct
            { 
             uint8_t      transactionid;
             uint8_t      messageid;
             uint8_t      serviceid;
             uint8_t      attributeid;
             uint8_t      failurereason;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
            } __attribute__((packed)) AUD_SETTING_GET_FAIL_RESP_STR;
#define SIZE_AUD_SETTING_GET_FAIL_RESP                        sizeof(AUD_SETTING_GET_FAIL_RESP_STR)


//Definition for struct AUD_LAYER_UPDATE_REQ
#define AUD_LAYER_UPDATE_REQ                                  0x14                                                  
typedef struct
            { 
             uint8_t      transactionid;
             uint8_t      messageid;
             uint8_t      clientid;
             uint8_t      serviceid;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
             uint8_t      numofsubblocks;
            } __attribute__((packed)) AUD_LAYER_UPDATE_REQ_STR;
#define SIZE_AUD_LAYER_UPDATE_REQ                             sizeof(AUD_LAYER_UPDATE_REQ_STR)


//Definition for struct AUD_LAYER_UPDATE_OK_RESP
#define AUD_LAYER_UPDATE_OK_RESP                              0x15                                                  
typedef struct
            { 
             uint8_t      transactionid;
             uint8_t      messageid;
             uint8_t      serviceid;
             uint8_t      generalstatus;
             uint16_t     fillerbyte1;
             uint8_t      generalefficiency;
             uint8_t      numofsubblocks;
            } __attribute__((packed)) AUD_LAYER_UPDATE_OK_RESP_STR;
#define SIZE_AUD_LAYER_UPDATE_OK_RESP                         sizeof(AUD_LAYER_UPDATE_OK_RESP_STR)


//Definition for struct AUD_LAYER_UPDATE_FAIL_RESP
#define AUD_LAYER_UPDATE_FAIL_RESP                            0x16                                                  
typedef struct
            { 
             uint8_t      transactionid;
             uint8_t      messageid;
             uint8_t      serviceid;
             uint8_t      failurereason;
            } __attribute__((packed)) AUD_LAYER_UPDATE_FAIL_RESP_STR;
#define SIZE_AUD_LAYER_UPDATE_FAIL_RESP                       sizeof(AUD_LAYER_UPDATE_FAIL_RESP_STR)


//Definition for struct AUD_LAYER_UPDATE_IND
#define AUD_LAYER_UPDATE_IND                                  0x17                                                  
typedef struct
            { 
             uint8_t      transactionid;
             uint8_t      messageid;
             uint8_t      serviceid;
             uint8_t      numofsubblocks;
            } __attribute__((packed)) AUD_LAYER_UPDATE_IND_STR;
#define SIZE_AUD_LAYER_UPDATE_IND                             sizeof(AUD_LAYER_UPDATE_IND_STR)


//Definition for struct AUD_LAYER_UPDATE_NEEDED_IND
#define AUD_LAYER_UPDATE_NEEDED_IND                           0x18                                                  
typedef struct
            { 
             uint8_t      transactionid;
             uint8_t      messageid;
             uint8_t      clientid;
             uint8_t      serviceid;
            } __attribute__((packed)) AUD_LAYER_UPDATE_NEEDED_IND_STR;
#define SIZE_AUD_LAYER_UPDATE_NEEDED_IND                      sizeof(AUD_LAYER_UPDATE_NEEDED_IND_STR)


//Definition for struct AUD_LAYER_DESTROY_REQ
#define AUD_LAYER_DESTROY_REQ                                 0x19                                                  
typedef struct
            { 
             uint8_t      transactionid;
             uint8_t      messageid;
             uint8_t      clientid;
             uint8_t      serviceid;
             uint8_t      attributeid;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
            } __attribute__((packed)) AUD_LAYER_DESTROY_REQ_STR;
#define SIZE_AUD_LAYER_DESTROY_REQ                            sizeof(AUD_LAYER_DESTROY_REQ_STR)


//Definition for struct AUD_LAYER_DESTROY_OK_RESP
#define AUD_LAYER_DESTROY_OK_RESP                             0x1A                                                  
typedef struct
            { 
             uint8_t      transactionid;
             uint8_t      messageid;
             uint8_t      serviceid;
             uint8_t      attributeid;
            } __attribute__((packed)) AUD_LAYER_DESTROY_OK_RESP_STR;
#define SIZE_AUD_LAYER_DESTROY_OK_RESP                        sizeof(AUD_LAYER_DESTROY_OK_RESP_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct AUD_LAYER_DESTROY_FAIL_RESP
#define AUD_LAYER_DESTROY_FAIL_RESP                           0x1B                                                  
typedef struct
            { 
             uint8_t      transactionid;
             uint8_t      messageid;
             uint8_t      serviceid;
             uint8_t      failurereason;
            } __attribute__((packed)) AUD_LAYER_DESTROY_FAIL_RESP_STR;
#define SIZE_AUD_LAYER_DESTROY_FAIL_RESP                      sizeof(AUD_LAYER_DESTROY_FAIL_RESP_STR)


//Definition for struct AUD_TEST_START_REQ
#define AUD_TEST_START_REQ                                    0x1C                                                  
typedef struct
            { 
             uint8_t      transactionid;
             uint8_t      messageid;
             uint8_t      testtype;
             uint8_t      fillerbyte1;
             uint16_t     frequency;
             uint16_t     duration;
            } __attribute__((packed)) AUD_TEST_START_REQ_STR;
#define SIZE_AUD_TEST_START_REQ                               sizeof(AUD_TEST_START_REQ_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.
//This definition is propably impossible to generate due the IF/ELSE statements in specification.
//See ISI message specification for further details of message structure.
//https://oucmswww.nmp.nokia.com:59080/document_browser/


//Definition for struct AUD_TEST_START_OK_RESP
#define AUD_TEST_START_OK_RESP                                0x1D                                                  
typedef struct
            { 
             uint8_t      transactionid;
             uint8_t      messageid;
             uint8_t      testtype;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) AUD_TEST_START_OK_RESP_STR;
#define SIZE_AUD_TEST_START_OK_RESP                           sizeof(AUD_TEST_START_OK_RESP_STR)


//Definition for struct AUD_TEST_START_FAIL_RESP
#define AUD_TEST_START_FAIL_RESP                              0x1E                                                  
typedef struct
            { 
             uint8_t      transactionid;
             uint8_t      messageid;
             uint8_t      testtype;
             uint8_t      failurereason;
            } __attribute__((packed)) AUD_TEST_START_FAIL_RESP_STR;
#define SIZE_AUD_TEST_START_FAIL_RESP                         sizeof(AUD_TEST_START_FAIL_RESP_STR)


//Definition for struct AUD_TEST_STOP_REQ
#define AUD_TEST_STOP_REQ                                     0x1F                                                  
typedef struct
            { 
             uint8_t      transactionid;
             uint8_t      messageid;
             uint8_t      testtype;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) AUD_TEST_STOP_REQ_STR;
#define SIZE_AUD_TEST_STOP_REQ                                sizeof(AUD_TEST_STOP_REQ_STR)


//Definition for struct AUD_TEST_STOP_OK_RESP
#define AUD_TEST_STOP_OK_RESP                                 0x20                                                  
typedef struct
            { 
             uint8_t      transactionid;
             uint8_t      messageid;
             uint8_t      testtype;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) AUD_TEST_STOP_OK_RESP_STR;
#define SIZE_AUD_TEST_STOP_OK_RESP                            sizeof(AUD_TEST_STOP_OK_RESP_STR)


//Definition for struct AUD_TEST_STOP_FAIL_RESP
#define AUD_TEST_STOP_FAIL_RESP                               0x21                                                  
typedef struct
            { 
             uint8_t      transactionid;
             uint8_t      messageid;
             uint8_t      testtype;
             uint8_t      failurereason;
            } __attribute__((packed)) AUD_TEST_STOP_FAIL_RESP_STR;
#define SIZE_AUD_TEST_STOP_FAIL_RESP                          sizeof(AUD_TEST_STOP_FAIL_RESP_STR)


//Definition for struct AUD_EANC_STATUS_CHANGE_REQ
#define AUD_EANC_STATUS_CHANGE_REQ                            0x6B                                                  
typedef struct
            { 
             uint8_t      transactionid;
             uint8_t      messageid;
             uint8_t      command;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) AUD_EANC_STATUS_CHANGE_REQ_STR;
#define SIZE_AUD_EANC_STATUS_CHANGE_REQ                       sizeof(AUD_EANC_STATUS_CHANGE_REQ_STR)


//Definition for struct AUD_EANC_STATUS_CHANGE_RESP
#define AUD_EANC_STATUS_CHANGE_RESP                           0x6C                                                  
typedef struct
            { 
             uint8_t      transactionid;
             uint8_t      messageid;
             uint8_t      command;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) AUD_EANC_STATUS_CHANGE_RESP_STR;
#define SIZE_AUD_EANC_STATUS_CHANGE_RESP                      sizeof(AUD_EANC_STATUS_CHANGE_RESP_STR)


//Definition for struct AUD_EANC_STATUS_CHANGE_IND
#define AUD_EANC_STATUS_CHANGE_IND                            0x6E                                                  
typedef struct
            { 
             uint8_t      transactionid;
             uint8_t      messageid;
             uint8_t      status;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) AUD_EANC_STATUS_CHANGE_IND_STR;
#define SIZE_AUD_EANC_STATUS_CHANGE_IND                       sizeof(AUD_EANC_STATUS_CHANGE_IND_STR)


//Definition for struct AUD_EANC_MIC_DATA_REQ
#define AUD_EANC_MIC_DATA_REQ                                 0x6F                                                  
typedef struct
            { 
             uint8_t      transactionid;
             uint8_t      messageid;
            } __attribute__((packed)) AUD_EANC_MIC_DATA_REQ_STR;
#define SIZE_AUD_EANC_MIC_DATA_REQ                            sizeof(AUD_EANC_MIC_DATA_REQ_STR)


//Definition for struct AUD_EANC_MIC_DATA_RESP
#define AUD_EANC_MIC_DATA_RESP                                0x70                                                  
typedef struct
            { 
             uint8_t      transactionid;
             uint8_t      messageid;
             uint16_t     mic1data_hi;
             uint16_t     mic1data_low;
             uint16_t     mic2data_hi;
             uint16_t     mic2data_low;
            } __attribute__((packed)) AUD_EANC_MIC_DATA_RESP_STR;
#define SIZE_AUD_EANC_MIC_DATA_RESP                           sizeof(AUD_EANC_MIC_DATA_RESP_STR)


//Definition for struct AUD_HW_STATUS_IND
#define AUD_HW_STATUS_IND                                     0x22                                                  
typedef struct
            { 
             uint8_t      transactionid;
             uint8_t      messageid;
             uint8_t      hw_status;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) AUD_HW_STATUS_IND_STR;
#define SIZE_AUD_HW_STATUS_IND                                sizeof(AUD_HW_STATUS_IND_STR)


//Definition for struct AUD_EQU_CREATE_REQ
#define AUD_EQU_CREATE_REQ                                    0x40                                                  
typedef struct
            { 
             uint8_t      transactionid;
             uint8_t      messageid;
             uint8_t      equalizerid;
             uint8_t      bands;
             uint8_t      equalizertype;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      numofsubblocks;
            } __attribute__((packed)) AUD_EQU_CREATE_REQ_STR;
#define SIZE_AUD_EQU_CREATE_REQ                               sizeof(AUD_EQU_CREATE_REQ_STR)


//Definition for struct AUD_EQU_CREATE_OK_RESP
#define AUD_EQU_CREATE_OK_RESP                                0x41                                                  
typedef struct
            { 
             uint8_t      transactionid;
             uint8_t      messageid;
             uint16_t     fillerbyte1;
            } __attribute__((packed)) AUD_EQU_CREATE_OK_RESP_STR;
#define SIZE_AUD_EQU_CREATE_OK_RESP                           sizeof(AUD_EQU_CREATE_OK_RESP_STR)


//Definition for struct AUD_EQU_CREATE_FAIL_RESP
#define AUD_EQU_CREATE_FAIL_RESP                              0x42                                                  
typedef struct
            { 
             uint8_t      transactionid;
             uint8_t      messageid;
             uint8_t      failurereason;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) AUD_EQU_CREATE_FAIL_RESP_STR;
#define SIZE_AUD_EQU_CREATE_FAIL_RESP                         sizeof(AUD_EQU_CREATE_FAIL_RESP_STR)


//Definition for struct AUD_EQU_INFO_REQ
#define AUD_EQU_INFO_REQ                                      0x43                                                  
typedef struct
            { 
             uint8_t      transactionid;
             uint8_t      messageid;
             uint8_t      equalizerid;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) AUD_EQU_INFO_REQ_STR;
#define SIZE_AUD_EQU_INFO_REQ                                 sizeof(AUD_EQU_INFO_REQ_STR)


//Definition for struct AUD_EQU_INFO_OK_RESP
#define AUD_EQU_INFO_OK_RESP                                  0x44                                                  
typedef struct
            { 
             uint8_t      transactionid;
             uint8_t      messageid;
             uint8_t      equalizerid;
             uint8_t      bands;
             uint8_t      equalizertype;
             uint8_t      equalizerstate;
             uint8_t      fillerbyte1;
             uint8_t      numofsubblocks;
            } __attribute__((packed)) AUD_EQU_INFO_OK_RESP_STR;
#define SIZE_AUD_EQU_INFO_OK_RESP                             sizeof(AUD_EQU_INFO_OK_RESP_STR)


//Definition for struct AUD_EQU_INFO_FAIL_RESP
#define AUD_EQU_INFO_FAIL_RESP                                0x45                                                  
typedef struct
            { 
             uint8_t      transactionid;
             uint8_t      messageid;
             uint8_t      failurereason;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) AUD_EQU_INFO_FAIL_RESP_STR;
#define SIZE_AUD_EQU_INFO_FAIL_RESP                           sizeof(AUD_EQU_INFO_FAIL_RESP_STR)


//Definition for struct AUD_EQU_SWITCH_STATE_REQ
#define AUD_EQU_SWITCH_STATE_REQ                              0x46                                                  
typedef struct
            { 
             uint8_t      transactionid;
             uint8_t      messageid;
             uint8_t      equalizerid;
             uint8_t      state;
            } __attribute__((packed)) AUD_EQU_SWITCH_STATE_REQ_STR;
#define SIZE_AUD_EQU_SWITCH_STATE_REQ                         sizeof(AUD_EQU_SWITCH_STATE_REQ_STR)


//Definition for struct AUD_EQU_SWITCH_STATE_OK_RESP
#define AUD_EQU_SWITCH_STATE_OK_RESP                          0x47                                                  
typedef struct
            { 
             uint8_t      transactionid;
             uint8_t      messageid;
             uint16_t     fillerbyte1;
            } __attribute__((packed)) AUD_EQU_SWITCH_STATE_OK_RESP_STR;
#define SIZE_AUD_EQU_SWITCH_STATE_OK_RESP                     sizeof(AUD_EQU_SWITCH_STATE_OK_RESP_STR)


//Definition for struct AUD_EQU_SWITCH_STATE_FAIL_RESP
#define AUD_EQU_SWITCH_STATE_FAIL_RESP                        0x48                                                  
typedef struct
            { 
             uint8_t      transactionid;
             uint8_t      messageid;
             uint8_t      failurereason;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) AUD_EQU_SWITCH_STATE_FAIL_RESP_STR;
#define SIZE_AUD_EQU_SWITCH_STATE_FAIL_RESP                   sizeof(AUD_EQU_SWITCH_STATE_FAIL_RESP_STR)


//Definition for struct AUD_EQU_SWITCH_STATE_IND
#define AUD_EQU_SWITCH_STATE_IND                              0x49                                                  
typedef struct
            { 
             uint8_t      transactionid;
             uint8_t      messageid;
             uint8_t      equalizerid;
             uint8_t      state;
            } __attribute__((packed)) AUD_EQU_SWITCH_STATE_IND_STR;
#define SIZE_AUD_EQU_SWITCH_STATE_IND                         sizeof(AUD_EQU_SWITCH_STATE_IND_STR)


//Definition for struct AUD_EQU_ADJUST_REQ
#define AUD_EQU_ADJUST_REQ                                    0x4A                                                  
typedef struct
            { 
             uint8_t      transactionid;
             uint8_t      messageid;
             uint8_t      equalizerid;
             uint8_t      numofsubblocks;
            } __attribute__((packed)) AUD_EQU_ADJUST_REQ_STR;
#define SIZE_AUD_EQU_ADJUST_REQ                               sizeof(AUD_EQU_ADJUST_REQ_STR)


//Definition for struct AUD_EQU_ADJUST_OK_RESP
#define AUD_EQU_ADJUST_OK_RESP                                0x4B                                                  
typedef struct
            { 
             uint8_t      transactionid;
             uint8_t      messageid;
             uint16_t     fillerbyte1;
            } __attribute__((packed)) AUD_EQU_ADJUST_OK_RESP_STR;
#define SIZE_AUD_EQU_ADJUST_OK_RESP                           sizeof(AUD_EQU_ADJUST_OK_RESP_STR)


//Definition for struct AUD_EQU_ADJUST_FAIL_RESP
#define AUD_EQU_ADJUST_FAIL_RESP                              0x4C                                                  
typedef struct
            { 
             uint8_t      transactionid;
             uint8_t      messageid;
             uint8_t      failurereason;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) AUD_EQU_ADJUST_FAIL_RESP_STR;
#define SIZE_AUD_EQU_ADJUST_FAIL_RESP                         sizeof(AUD_EQU_ADJUST_FAIL_RESP_STR)


//Definition for struct AUD_EQU_DELETE_REQ
#define AUD_EQU_DELETE_REQ                                    0x4D                                                  
typedef struct
            { 
             uint8_t      transactionid;
             uint8_t      messageid;
             uint8_t      equalizerid;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) AUD_EQU_DELETE_REQ_STR;
#define SIZE_AUD_EQU_DELETE_REQ                               sizeof(AUD_EQU_DELETE_REQ_STR)


//Definition for struct AUD_EQU_DELETE_OK_RESP
#define AUD_EQU_DELETE_OK_RESP                                0x4E                                                  
typedef struct
            { 
             uint8_t      transactionid;
             uint8_t      messageid;
             uint8_t      equalizerid;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) AUD_EQU_DELETE_OK_RESP_STR;
#define SIZE_AUD_EQU_DELETE_OK_RESP                           sizeof(AUD_EQU_DELETE_OK_RESP_STR)


//Definition for struct AUD_EQU_DELETE_FAIL_RESP
#define AUD_EQU_DELETE_FAIL_RESP                              0x4F                                                  
typedef struct
            { 
             uint8_t      transactionid;
             uint8_t      messageid;
             uint8_t      failurereason;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) AUD_EQU_DELETE_FAIL_RESP_STR;
#define SIZE_AUD_EQU_DELETE_FAIL_RESP                         sizeof(AUD_EQU_DELETE_FAIL_RESP_STR)


//Definition for struct AUD_EQU_ACTIVE_ID_REQ
#define AUD_EQU_ACTIVE_ID_REQ                                 0x50                                                  
typedef struct
            { 
             uint8_t      transactionid;
             uint8_t      messageid;
             uint16_t     fillerbyte1;
            } __attribute__((packed)) AUD_EQU_ACTIVE_ID_REQ_STR;
#define SIZE_AUD_EQU_ACTIVE_ID_REQ                            sizeof(AUD_EQU_ACTIVE_ID_REQ_STR)


//Definition for struct AUD_EQU_ACTIVE_ID_OK_RESP
#define AUD_EQU_ACTIVE_ID_OK_RESP                             0x51                                                  
typedef struct
            { 
             uint8_t      transactionid;
             uint8_t      messageid;
             uint8_t      equalizerid;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) AUD_EQU_ACTIVE_ID_OK_RESP_STR;
#define SIZE_AUD_EQU_ACTIVE_ID_OK_RESP                        sizeof(AUD_EQU_ACTIVE_ID_OK_RESP_STR)


//Definition for struct AUD_EQU_ACTIVE_ID_FAIL_RESP
#define AUD_EQU_ACTIVE_ID_FAIL_RESP                           0x52                                                  
typedef struct
            { 
             uint8_t      transactionid;
             uint8_t      messageid;
             uint8_t      failurereason;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) AUD_EQU_ACTIVE_ID_FAIL_RESP_STR;
#define SIZE_AUD_EQU_ACTIVE_ID_FAIL_RESP                      sizeof(AUD_EQU_ACTIVE_ID_FAIL_RESP_STR)


//Definition for struct AUD_EQU_GENERAL_INFO_REQ
#define AUD_EQU_GENERAL_INFO_REQ                              0x61                                                  
typedef struct
            { 
             uint8_t      transactionid;
             uint8_t      messageid;
             uint16_t     fillerbyte1;
            } __attribute__((packed)) AUD_EQU_GENERAL_INFO_REQ_STR;
#define SIZE_AUD_EQU_GENERAL_INFO_REQ                         sizeof(AUD_EQU_GENERAL_INFO_REQ_STR)


//Definition for struct AUD_EQU_GENERAL_INFO_RESP
#define AUD_EQU_GENERAL_INFO_RESP                             0x62                                                  
typedef struct
            { 
             uint8_t      transactionid;
             uint8_t      messageid;
             uint8_t      fillerbyte1;
             uint8_t      numofsubblocks;
            } __attribute__((packed)) AUD_EQU_GENERAL_INFO_RESP_STR;
#define SIZE_AUD_EQU_GENERAL_INFO_RESP                        sizeof(AUD_EQU_GENERAL_INFO_RESP_STR)


//Definition for struct AUD_EQU_CREATED_IND
#define AUD_EQU_CREATED_IND                                   0x63                                                  
typedef struct
            { 
             uint8_t      transactionid;
             uint8_t      messageid;
             uint8_t      equalizerid;
             uint8_t      numofsubblocks;
            } __attribute__((packed)) AUD_EQU_CREATED_IND_STR;
#define SIZE_AUD_EQU_CREATED_IND                              sizeof(AUD_EQU_CREATED_IND_STR)


//Definition for struct AUD_EQU_DELETED_IND
#define AUD_EQU_DELETED_IND                                   0x64                                                  
typedef struct
            { 
             uint8_t      transactionid;
             uint8_t      messageid;
             uint8_t      equalizerid;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) AUD_EQU_DELETED_IND_STR;
#define SIZE_AUD_EQU_DELETED_IND                              sizeof(AUD_EQU_DELETED_IND_STR)


//Definition for struct AUD_EQU_ADJUSTED_IND
#define AUD_EQU_ADJUSTED_IND                                  0x65                                                  
typedef struct
            { 
             uint8_t      transactionid;
             uint8_t      messageid;
             uint8_t      equalizerid;
             uint8_t      numofsubblocks;
            } __attribute__((packed)) AUD_EQU_ADJUSTED_IND_STR;
#define SIZE_AUD_EQU_ADJUSTED_IND                             sizeof(AUD_EQU_ADJUSTED_IND_STR)


//Definition for struct AUD_SCO_CONTROL_RESP
#define AUD_SCO_CONTROL_RESP                                  0x5A                                                  
typedef struct
            { 
             uint8_t      transactionid;
             uint8_t      messageid;
             uint8_t      status;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) AUD_SCO_CONTROL_RESP_STR;
#define SIZE_AUD_SCO_CONTROL_RESP                             sizeof(AUD_SCO_CONTROL_RESP_STR)


//Definition for struct AUD_BTHSTREAM_STATUS_CHANGE_REQ
#define AUD_BTHSTREAM_STATUS_CHANGE_REQ                       0x5B                                                  
typedef struct
            { 
             uint8_t      transactionid;
             uint8_t      messageid;
             uint8_t      command;
             uint8_t      streamtype;
            } __attribute__((packed)) AUD_BTHSTREAM_STATUS_CHANGE_REQ_STR;
#define SIZE_AUD_BTHSTREAM_STATUS_CHANGE_REQ                  sizeof(AUD_BTHSTREAM_STATUS_CHANGE_REQ_STR)


//Definition for struct AUD_BTHSTREAM_STATUS_CHANGE_RESP
#define AUD_BTHSTREAM_STATUS_CHANGE_RESP                      0x5C                                                  
typedef struct
            { 
             uint8_t      transactionid;
             uint8_t      messageid;
             uint8_t      command;
             uint8_t      status;
            } __attribute__((packed)) AUD_BTHSTREAM_STATUS_CHANGE_RESP_STR;
#define SIZE_AUD_BTHSTREAM_STATUS_CHANGE_RESP                 sizeof(AUD_BTHSTREAM_STATUS_CHANGE_RESP_STR)


//Definition for struct AUD_DEFATTR_CHANGE_REQ
#define AUD_DEFATTR_CHANGE_REQ                                0x5D                                                  
typedef struct
            { 
             uint8_t      transactionid;
             uint8_t      messageid;
             uint8_t      service;
             uint8_t      attributeid;
             uint16_t     value;
             uint16_t     fillerbyte1;
            } __attribute__((packed)) AUD_DEFATTR_CHANGE_REQ_STR;
#define SIZE_AUD_DEFATTR_CHANGE_REQ                           sizeof(AUD_DEFATTR_CHANGE_REQ_STR)


//Definition for struct AUD_DEFATTR_CHANGE_RESP
#define AUD_DEFATTR_CHANGE_RESP                               0x5E                                                  
typedef struct
            { 
             uint8_t      transactionid;
             uint8_t      messageid;
             uint8_t      status;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) AUD_DEFATTR_CHANGE_RESP_STR;
#define SIZE_AUD_DEFATTR_CHANGE_RESP                          sizeof(AUD_DEFATTR_CHANGE_RESP_STR)


//Definition for struct AUD_DEFATTR_VALUE_GET_REQ
#define AUD_DEFATTR_VALUE_GET_REQ                             0x5F                                                  
typedef struct
            { 
             uint8_t      transactionid;
             uint8_t      messageid;
             uint8_t      service;
             uint8_t      attributeid;
            } __attribute__((packed)) AUD_DEFATTR_VALUE_GET_REQ_STR;
#define SIZE_AUD_DEFATTR_VALUE_GET_REQ                        sizeof(AUD_DEFATTR_VALUE_GET_REQ_STR)


//Definition for struct AUD_DEFATTR_VALUE_GET_RESP
#define AUD_DEFATTR_VALUE_GET_RESP                            0x60                                                  
typedef struct
            { 
             uint8_t      transactionid;
             uint8_t      messageid;
             uint8_t      status;
             uint8_t      fillerbyte1;
             uint16_t     value;
             uint16_t     fillerbyte2;
            } __attribute__((packed)) AUD_DEFATTR_VALUE_GET_RESP_STR;
#define SIZE_AUD_DEFATTR_VALUE_GET_RESP                       sizeof(AUD_DEFATTR_VALUE_GET_RESP_STR)


//Definition for struct AUD_VOLUME_CONTROL_REQ
#define AUD_VOLUME_CONTROL_REQ                                0x66                                                  
typedef struct
            { 
             uint8_t      transactionid;
             uint8_t      messageid;
             uint8_t      fillerbyte1;
             uint8_t      num_of_subblocks;
            } __attribute__((packed)) AUD_VOLUME_CONTROL_REQ_STR;
#define SIZE_AUD_VOLUME_CONTROL_REQ                           sizeof(AUD_VOLUME_CONTROL_REQ_STR)


//Definition for struct AUD_VOLUME_CONTROL_RESP
#define AUD_VOLUME_CONTROL_RESP                               0x67                                                  
typedef struct
            { 
             uint8_t      transactionid;
             uint8_t      messageid;
             uint16_t     failed_media_types;
             uint16_t     fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      num_of_subblocks;
            } __attribute__((packed)) AUD_VOLUME_CONTROL_RESP_STR;
#define SIZE_AUD_VOLUME_CONTROL_RESP                          sizeof(AUD_VOLUME_CONTROL_RESP_STR)


//Definition for struct AUD_VOLUME_GET_REQ
#define AUD_VOLUME_GET_REQ                                    0x68                                                  
typedef struct
            { 
             uint8_t      transactionid;
             uint8_t      messageid;
             uint16_t     media_types;
            } __attribute__((packed)) AUD_VOLUME_GET_REQ_STR;
#define SIZE_AUD_VOLUME_GET_REQ                               sizeof(AUD_VOLUME_GET_REQ_STR)


//Definition for struct AUD_VOLUME_GET_RESP
#define AUD_VOLUME_GET_RESP                                   0x69                                                  
typedef struct
            { 
             uint8_t      transactionid;
             uint8_t      messageid;
             uint8_t      fillerbyte1;
             uint8_t      num_of_subblocks;
            } __attribute__((packed)) AUD_VOLUME_GET_RESP_STR;
#define SIZE_AUD_VOLUME_GET_RESP                              sizeof(AUD_VOLUME_GET_RESP_STR)


//Definition for struct AUD_VOLUME_CONTROL_IND
#define AUD_VOLUME_CONTROL_IND                                0x6D                                                  
typedef struct
            { 
             uint8_t      transactionid;
             uint8_t      messageid;
             uint8_t      fillerbyte1;
             uint8_t      num_of_subblocks;
            } __attribute__((packed)) AUD_VOLUME_CONTROL_IND_STR;
#define SIZE_AUD_VOLUME_CONTROL_IND                           sizeof(AUD_VOLUME_CONTROL_IND_STR)


//Definition for struct AUD_ATTACH_ACCESSORY_EVENT_REQ
#define AUD_ATTACH_ACCESSORY_EVENT_REQ                        0x23                                                  
typedef struct
            { 
             uint8_t      transactionid;
             uint8_t      messageid;
             uint8_t      master_type;
             uint8_t      sub_type;
             uint8_t      acc_id;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      sub_block_count;
            } __attribute__((packed)) AUD_ATTACH_ACCESSORY_EVENT_REQ_STR;
#define SIZE_AUD_ATTACH_ACCESSORY_EVENT_REQ                   sizeof(AUD_ATTACH_ACCESSORY_EVENT_REQ_STR)


//Definition for struct AUD_ATTACH_ACCESSORY_EVENT_OK_RESP
#define AUD_ATTACH_ACCESSORY_EVENT_OK_RESP                    0x24                                                  
typedef struct
            { 
             uint8_t      transactionid;
             uint8_t      messageid;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) AUD_ATTACH_ACCESSORY_EVENT_OK_RESP_STR;
#define SIZE_AUD_ATTACH_ACCESSORY_EVENT_OK_RESP               sizeof(AUD_ATTACH_ACCESSORY_EVENT_OK_RESP_STR)


//Definition for struct AUD_FIFO_INTERRUPT_IND
#define AUD_FIFO_INTERRUPT_IND                                0x6A                                                  
typedef struct
            { 
             uint8_t      transactionid;
             uint8_t      messageid;
             uint16_t     fillerbyte1;
            } __attribute__((packed)) AUD_FIFO_INTERRUPT_IND_STR;
#define SIZE_AUD_FIFO_INTERRUPT_IND                           sizeof(AUD_FIFO_INTERRUPT_IND_STR)


//Definition for struct AUD_FEATURE_SET_REQ
#define AUD_FEATURE_SET_REQ                                   0x26                                                  
typedef struct
            { 
             uint8_t      transactionid;
             uint8_t      messageid;
             uint8_t      featureid;
             uint8_t      featureidstate;
            } __attribute__((packed)) AUD_FEATURE_SET_REQ_STR;
#define SIZE_AUD_FEATURE_SET_REQ                              sizeof(AUD_FEATURE_SET_REQ_STR)


//Definition for struct AUD_FEATURE_SET_RESP
#define AUD_FEATURE_SET_RESP                                  0x27                                                  
typedef struct
            { 
             uint8_t      transactionid;
             uint8_t      messageid;
             uint8_t      result;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) AUD_FEATURE_SET_RESP_STR;
#define SIZE_AUD_FEATURE_SET_RESP                             sizeof(AUD_FEATURE_SET_RESP_STR)

#endif
