#ifndef _PN_BEARERCTRL_ISI_H_
#define _PN_BEARERCTRL_ISI_H_

#include <stdint.h> 

//Resource Bearer Control Server
//PN_BEARERCTRL 0x60 
//ISI version 012.000
#define BEARER_CONTROL_SERVER_ISI_VERSION_Z     12
#define BEARER_CONTROL_SERVER_ISI_VERSION_Y     0

//In case of problems concerning content of this file contact Markku Loukusa, Sauli Laukka or Markus Mrsky
//Server specific message descriptions and feature&protocol descriptions can be found from: https://oucmswww.nmp.nokia.com:58443/document_browser/ccm_wa/GIF_SPECS/ 


//ISI VERSION CHANGE HISTORY

//Version: 012.000                                           
//Status: NonDraft                                          
//Date: 27-Aug-2008     Henri Rosten
//Reason: Cleanup of BCS and FCS functionalities. 
//Reference: ISA RM Tool 403-11095: Clean up of BCS and FCS Functionalities. CCM Task tr1cfwln#44154. , NON-DRAFT

//Version: 011.002                                           
//Status: NonDraft                                          
//Date: 03-Jul-2008     Jani Haapakoski
//Reason: New app IDs for Posix API. Removal of obsolete IDs. 
//Reference: ISA RM Tool 417-11478: BCS: New application IDs for S40 NG/POSIX Platform APIs. ISA RM Tool 408-5484: New Feature ID for DR. Core server. ISA RM Tool 403-11095: Clean up of BCS and FCS Functionalities. ADB for SWAM / INTERFACE / ISImessage_Core / JH08063049022. CCM Task tr1cfwln#40844. , NON-DRAFT

//Version: 011.001                                           
//Status: NonDraft                                          
//Date: 17-Apr-2008     Henri Rosten
//Reason: Bearer control chipset API. 
//Reference: ADB for SWAM / INTERFACE / ISImessage / HR08041729710. CCM Task tr1prot2#42735. , NON-DRAFT

//Version: 011.000                                           
//Status: NonDraft                                          
//Date: 13-Dec-2007     Jani Haapakoski
//Reason: Definition removals/redefinitions and new app ID. 
//Reference: ISA RM Tool 010-29239: Remove obsolete BCS IDs. ISA RM Tool 403-11644: BCS/FCS: New feature/application IDs for Presence Service API. ADB for SWAM / INTERFACE / ISImessage / JH07120552978. ADB for SWAM / INTERFACE / ISImessage / JH07121239833. CCM Task tr1prot2#35719. , NON-DRAFT

//Version: 010.005                                           
//Status: NonDraft                                          
//Date: 24-May-2007     Markus Lassila
//Reason: New bearer and application ID for MBMS mobile TV. 
//Reference: ISA RM Tool 403-1889: BCS IDs for MBMS Mobile TV. ADB for SWAM / INTERFACE / ISImessage / ML07051456055. CCM Task tr1prot2#28007., NON-DRAFT

//Version: 010.004                                           
//Status: NonDraft                                          
//Date: 18-May-2007     Markus Lassila
//Reason: New application ID for MOPS Linger. 
//Reference: ISA RM Tool 403-1954: New Feature ID for WLAN keepalive timer. ADB for SWAM / INTERFACE / ISImessage / ML07050446272. CCM Task tr1prot2#27680., NON-DRAFT

//Version: 010.003                                           
//Status: NonDraft                                          
//Date: 20-Feb-2007     Markus Lassila
//Reason: New application ID for VoIP. 
//Reference: ISA RM Tool 010-33508: New IDs for VoIP. ADB for SWAM / INTERFACE / ISImessage / ML07020848883. CCM Task tr1prot2#25118., NON-DRAFT

//Version: 010.002                                           
//Status: NonDraft                                          
//Date: 24-Jan-2007     Markus Lassila
//Reason: New application ID for Maps Application. 
//Reference: ISA RM Tool 010-33224: New IDs for Maps Application. ADB for SWAM / INTERFACE / ISImessage / ML07012241303. CCM Task tr1prot2#24492., NON-DRAFT

//Version: 010.001                                           
//Status: NonDraft                                          
//Date: 29-Dec-2006     Markus Lassila
//Reason: Support for WLAN bearer. 
//Reference: ISA RM Tool 009-30275: BCS/FCS ID for Generic WLAN. ADB for SWAM / INTERFACE / ISImessage / ML06121146644. CCM Task tr1prot2#23848. , NON-DRAFT

//Version: 010.000                                           
//Status: NonDraft                                          
//Date: 13-Dec-2006     Jani Haapakoski
//Reason: CDMA support removal.
//Reference: ISA RM Tool 009-28840: Remove BCS/FCS Support for CDMA. ADB for SWAM / INTERFACE / ISImessage / JH06120559124. CCM Task tr1prot2#23520., NON-DRAFT

//Version: 009.008                                           
//Status: NonDraft                                          
//Date: 06-Nov-2006     Jani Haapakoski
//Reason: FTD table update.
//Reference: ISA RM Tool 009-27662: Inclusion of BCS/FCS FTD Data in Macro File. ADB for SWAM / INTERFACE / ISImessage / JH06102550311. CCM Task tr1prot2#21654., NON-DRAFT

//Version: 009.007                                           
//Status: NonDraft                                          
//Date: 21-Feb-2006     Jani Haapakoski
//Reason: New application ID for Take & Keep.
//Reference: ISA RM Tool 010-21853: Feature ID for Content Upload. ADB for SWAM / INTERFACE / ISImessage / JH06021344356. CCM Task tr1prot2#13020., NON-DRAFT

//Version: 009.006                                           
//Status: NonDraft                                          
//Date: 31-Jan-2006     Jani Haapakoski
//Reason: New application ID for BT PAN NAP.
//Reference: ISA RM Tool 009-22340: Application ID for BT PAN NAP. ADB for SWAM / INTERFACE / ISImessage / JH06011663449. CCM Task tr1prot2#12222., NON-DRAFT

//Version: 009.005                                           
//Status: NonDraft                                          
//Date: 21-Oct-2005     Jaakko Paloneva
//Reason: New application ID for IMS Always Online.
//Reference: ISA RM Tool 009-21273: Application and Feature IDs for IMS always online. ADB for SWAM / INTERFACE / ISImessage / JP05101440111. CCM Task tr1prot2#10427., NON-DRAFT

//Version: 009.004                                           
//Status: NonDraft                                          
//Date: 21-Sep-2005     Jaakko Paloneva
//Reason: New application IDs for CDMA dial-ups.
//Reference: ISA RM Tool 009-21072: New IDs for CDMA dial-up calls. ADB for SWAM / INTERFACE / ISImessage / JP05092052368. CCM Task tr1prot2#9850., NON-DRAFT

//Version: 009.003                                           
//Status: NonDraft                                          
//Date: 08-Jun-2005     Jaakko Paloneva
//Reason: Several new application IDs
//Reference: ISA RM Tool 010-14040: Application ID for Always Online. ISA RM Tool 010-14044: Application ID for Native Email. ISA RM Tool 009-19594: Application and feature ID for CDMA PictureMail. ISA RM Tool 009-19612: Application and feature ID for m-IMAP email. ISA RM Tool 009-19613: Application and feature ID for FOTA. ISA RM Tool 009-19596: BCS/FCS support for H3G Active Desktop. ISA RM Tool 009-19610: Application and feature ID for Location Based Services. ADB for SWAM / INTERFACE / ISImessage / JP05052444869. ADB for SWAM / INTERFACE / ISImessage / JP05060742415. CCM Task tr1prot2#8072., NON-DRAFT

//Version: 009.002                                           
//Status: NonDraft                                          
//Date: 25-Apr-2005     Jaakko Paloneva
//Reason: Several new application IDs
//Reference: ISA RM Tool 009-16983: Application ID for Livecast. ISA RM Tool 010-13422: Application and feature IDs for Video Sharing. ISA RM Tool 010-13420: Application ID for CDMA PTT. ADB for SWAM / INTERFACE / ISImessage / JP05041551627. CCM Task tr1prot2#6770., NON-DRAFT

//Version: 009.001                                           
//Status: NonDraft                                          
//Date: 24-Feb-2005     Jaakko Paloneva
//Reason: Application ID for Video Call.
//Reference: ISA RM Tool 009-16243: Application ID for Video Call. ADB for SWAM / INTERFACE / ISImessage / JP05022247972. CCM Task tr1prot2#5339., NON-DRAFT

//Version: 009.000                                           
//Status: NonDraft                                          
//Date: 11-Feb-2005     Jaakko Paloneva
//Reason: Application ID for BIP & removal of BCS_BEARER_CDMA_HSD.
//Reference: ISA RM Tool 009-16832: Application and feature ID for BIP over GPRS. ADB for SWAM / INTERFACE / ISImessage / JP05020857176. ADB for SWAM / INTERFACE / ISImessage / JP05020757830. CCM Task tr1prot2#4946., NON-DRAFT

//Version: 008.001                                           
//Status: NonDraft                                          
//Date: 31-Jan-2005     Jaakko Paloneva
//Reason: New application ID for BREW
//Reference: ISA RM Tool 009-16242: Feature ID for BREW. ADB for SWAM / INTERFACE / ISImessage / JP05013134115. CCM Task tr1prot2#4616., NON-DRAFT

//Version: 008.000                                           
//Status: NonDraft                                          
//Date: 25-Aug-2004     Jaakko Paloneva
//Reason: Improvement to notifications to solve user query UI problems.
//Reference: ADB for SWAM / INTERFACE / ISImessage / JP04081853861. CCM Task tr_beaco#1232., NON-DRAFT

//Version: 007.026                                           
//Status: NonDraft                                          
//Date: 26-Apr-2004     Jaakko Paloneva
//Reason: Support for Flight Mode.
//Reference: ISA RM Tool 009-9877: Bearer/feature control support for Flight Mode. ADB for SWAM / INTERFACE / ISImessage / JP04042639336. CCM Task tr_beaco#3299., NON-DRAFT

//Version: 007.025                                           
//Status: NonDraft                                          
//Date: 24-Mar-2004     Jaakko Paloneva
//Reason: New status indications for FCS/BCS.
//Reference: ISA RM Tool 009-10724: New status indications for FCS/BCS. ADB for SWAM / INTERFACE / ISImessage / JP04031735492. CCM Task tr_beaco#3003., NON-DRAFT

//Version: 007.024                                           
//Status: NonDraft                                          
//Date: 18-Dec-2003     Jaakko Paloneva
//Reason: BCS to support CDMA speech and data calls.
//Reference: ISA RM Tool 009-8123: BCS to support CDMA speech and data calls ADB for SWAM / INTERFACE / ISImessage / JP03121030213. CCM Task tr_beaco#1756., NON-DRAFT

//Version: 007.023                                           
//Status: NonDraft                                          
//Date: 01-Aug-2003     Jarkko Puharinen
//Reason: New application ID for implicit MIP.
//Reference: ISA RM Tool 010-2211: New Feature ID for CDMA MIP. ADB for SWAM / INTERFACE / ISImessage / JP03072956001. CCM Task tr_beaco#1224., NON-DRAFT

//Version: 007.022                                           
//Status: NonDraft                                          
//Date: 06-Jun-2003     Jarkko Puharinen
//Reason: New application ID for video streaming.
//Reference: ISA RM Tool 009-4588: New application ID for Video Streaming. ADB for SWAM / INTERFACE / ISImessage / JP03060242979. CCM Task tr_beaco#1099., NON-DRAFT

//Version: 007.021                                           
//Status: Approved                                          
//Date: 09-May-2003     Jarkko Puharinen
//Reason: Inspection corrections.
//Reference: ADB for SWAM / INTERFACE / ISImessage / JP03042557515. CCM Task tr_beaco#960., APPROVED

//Version: 007.020                                           
//Status: NonDraft                                          
//Date: 02-May-2003     Jarkko Puharinen
//Reason: New application and bearer IDs for CDMA and Java.
//Reference: ISA RM Tool: ID 009-3846: New application ID for Java download. ISA RM Tool: ID 009-4081: Bearer control CDMA support. ADB for SWAM / INTERFACE / ISImessage / JP03042557515. CCM Task tr_beaco#929., NON-DRAFT

//Version: 007.019                                           
//Status: NonDraft                                          
//Date: 18-Feb-2003     Jarkko Puharinen
//Reason: New application IDs for OTA Push SIA and WAP Inbox.
//Reference: ISA RM Tool: ID 009-1665, New application ID for WAP OTA Push SIA. ISA RM Tool: ID 010-759, New application ID for Inbox. ADB for SWAM / INTERFACE / ISImessage / JP03021037189. CCM Task tr_beaco#765., NON-DRAFT

//Version: 007.018                                           
//Status: NonDraft                                          
//Date: 10-Jan-2003     Jarkko Puharinen
//Reason: New application ID for Browser Script.
//Reference: ISA RM Tool: ID #009-1961, New application ID for Browser script. ADB for SWAM / INTERFACE / ISImessage / JP03010752093. CCM Task tr_beaco#688., NON-DRAFT

//Version: 007.017                                           
//Status: Approved                                          
//Date: 02-Jan-2003     Jarkko Puharinen
//Reason: Inspection corrections.
//Reference: ADB for SWAM / JP02121949106. CCM Task tr_beaco#677. , APPROVED

//Version: 007.016                                           
//Status: NonDraft                                          
//Date: 19-Dec-2002     Jarkko Puharinen
//Reason: New application IDs.
//Reference: ISA RM Tool: ID #009-1669, New application ID for RIM Email. ISA RM Tool: ID #4920, Bearer Control Support for POC. ADB for SWAM / INTERFACE / ISImessage / JP02121234706. CCM Task tr_beaco#662., NON-DRAFT

//Version: 007.015                                           
//Status: Approved                                          
//Date: 18-Nov-2002     Jarkko Puharinen
//Reason: Inspection correction.
//Reference: ADB for SWAM / JP02111239039. CCM Task tr_beaco#576. , APPROVED

//Version: 007.014                                           
//Status: NonDraft                                          
//Date: 12-Nov-2002     Jarkko Puharinen
//Reason: Application ID for IMPS.
//Reference: ISA RM Tool: ID #009-466, New Application ID for IMPS server. ADB for SWAM / INTERFACE / ISImessage / JP02110657993. CM Task tr_beaco#557., NON-DRAFT

//Version: 007.013                                           
//Status: NonDraft                                          
//Date: 22-Oct-2002     Jarkko Puharinen
//Reason: Application IDs for BROWSER and JAVA_SOCKET.
//Reference: ISA RM Tool: ID #010-178, New application ID for Browser. ISA RM Tool: ID #010-177, New application ID for Java sockets. ADB for SWAM / INTERFACE / ISImessage / JP02101635497. ADB for SWAM / INTERFACE / ISImessage / JP02101640337. CM Task tr_beaco#499., NON-DRAFT

//Version: 007.012                                           
//Status: Approved                                          
//Date: 06-Sep-2002     Jarkko Puharinen
//Reason: ISI interface inspected.
//Reference: ADB for SWAM / JP02090339499. CM Task tr_beaco#420., APPROVED

//Version: 007.011                                           
//Status: NonDraft                                          
//Date: 27-Aug-2002     Jarkko Puharinen
//Reason: Application ID for COD application.
//Reference: ISA RM Tool: ID #9384, New application ID for COD application. ADB for SWAM / INTERFACE / ISImessage / JP02082735808. CM Task tr_beaco#402., NON-DRAFT

//Version: 007.010                                           
//Status: Approved                                          
//Date: 05-Aug-2002     Tommi Kangas
//Reason: ISI interface inspected.
//Reference: ActionDB for SWAM / TK02070240929. CM Task tr_beaco#358., APPROVED

//Version: 007.009                                           
//Status: Draft                                             
//Date: 28-Jun-2002     Tommi Kangas
//Reason: New identifiers added.
//Reference: ActionDB for SWAM / TK02062449297. CM Task tr_beaco#325., DRAFT

//Version: 007.008                                           
//Status: Approved                                          
//Date: 18-Jun-2002     Tommi Kangas
//Reason: ISI interface inspected.
//Reference: ActionDB for SWAM / TK02061134313. CM Task tr_beaco#313., APPROVED

//Version: 007.007                                           
//Status: Draft                                             
//Date: 05-Jun-2002     Tommi Kangas
//Reason: Changes in FTD subblocks.
//Reference: ActionDB for SWAM / TK02052750806. CM Task tr_beaco#292., DRAFT

//Version: 007.006                                           
//Status: Approved                                          
//Date: 20-May-2002     Tommi Kangas
//Reason: Changes from ISI inspection.
//Reference: ActionDB for SWAM / TK02051349350. CM Task tr_beaco#272., APPROVED

//Version: 007.005                                           
//Status: Draft                                             
//Date: 10-May-2002     Tommi Kangas
//Reason: New message added to the interface.
//Reference: ActionDB for SWAM / TK02050839993. CM Task tr_beaco#256., DRAFT

//Version: 007.004                                           
//Status: Approved                                          
//Date: 08-Apr-2002     Tommi Kangas
//Reason: Document inspected and approved.
//Reference: ActionDB for SWAM / VS02040387122. CM Task tr_beaco#209., APPROVED

//Version: 007.003                                           
//Status: Draft                                             
//Date: 02-Apr-2002     Tommi Kangas
//Reason: Definition added for reservation_id 0.
//Reference: ActionDB for SWAM / TK02032138717. CM Task tr_beaco#203., DRAFT

//Version: 007.002                                           
//Status: Approved                                          
//Date: 25-Feb-2002     Tommi Kangas
//Reason: Changes from ISI inspection.
//Reference: ActionDB for SWAM / VS02021533538. CM Task tr_beaco#136., APPROVED

//Version: 007.001                                           
//Status: Draft                                             
//Date: 06-Feb-2002     Tommi Kangas
//Reason: AlwaysOnline support removed and FTD data table added.
//Reference: CM Task tr_beaco#116., DRAFT

//Version: 007.000                                           
//Status: Draft                                             
//Date: 30-Jan-2002     Tommi Kangas
//Reason: New ISI interface for Bearer Control Server.
//Reference: CM Task tr_beaco#101., DRAFT


//CONSTANTS
#define BCS_RESERVATION_ID_NOT_VALID                          0x00                                                     
#define BCS_FTD_SB_ID_FIRST                                   0x2000                                                
#define BCS_FTD_SB_ID_LAST                                    0x2019                                                
#define BCS_ANY_SIZE                                          1                                                     


//TABLES

//ConstantTable for BCS_STATUS_VALUE
#define BCS_ALLOWED                                           0x01                                                     
#define BCS_DENIED                                            0x02                                                     

//ConstantTable for BCS_CAUSE_VALUE
#define BCS_OK                                                0x01                                                     
#define BCS_BLOCKED                                           0x02                                                     
#define BCS_INTERRUPTED                                       0x03                                                     
#define BCS_EXCEPTION                                         0x04                                                     

//ConstantTable for BCS_USER_QUERY_BLOCKING_FLAG
#define BCS_NOT_BLOCKED_BY_USER_QUERY                         0x00                                                     
#define BCS_BLOCKED_BY_USER_QUERY                             0x01                                                     

//ConstantTable for FtdTable
#define FTD_SB_BCS_CONTEXT_COUNT                              0x2000                                                
#define FTD_SB_BCS_BEA_CLIENT_COUNT                           0x2001                                                
#define FTD_SB_BCS_FEA_CLIENT_COUNT                           0x2002                                                
#define FTD_SB_BCS_CLIENT_STATUS_G01                          0x2003                                                
#define FTD_SB_BCS_CLIENT_STATUS_G02                          0x2004                                                
#define FTD_SB_BCS_CLIENT_STATUS_G03                          0x2005                                                
#define FTD_SB_BCS_CLIENT_STATUS_G04                          0x2006                                                
#define FTD_SB_BCS_CLIENT_STATUS_G05                          0x2007                                                
#define FTD_SB_BCS_CLIENT_STATUS_G06                          0x2008                                                
#define FTD_SB_BCS_CLIENT_STATUS_G07                          0x2009                                                
#define FTD_SB_BCS_CLIENT_STATUS_G08                          0x200A                                                
#define FTD_SB_BCS_CLIENT_STATUS_G09                          0x200B                                                
#define FTD_SB_BCS_CLIENT_STATUS_G10                          0x200C                                                
#define FTD_SB_BCS_CLIENT_STATUS_G11                          0x200D                                                
#define FTD_SB_BCS_CLIENT_STATUS_G12                          0x200E                                                
#define FTD_SB_BCS_CLIENT_STATUS_G13                          0x200F                                                
#define FTD_SB_BCS_CLIENT_STATUS_G14                          0x2010                                                
#define FTD_SB_BCS_CLIENT_STATUS_G15                          0x2011                                                
#define FTD_SB_BCS_CLIENT_STATUS_G16                          0x2012                                                
#define FTD_SB_BCS_LAST_BLOCKED_FEA                           0x2013                                                
#define FTD_SB_BCS_LAST_INTERRUPTED_FEA                       0x2014                                                
#define FTD_SB_BCS_LAST_EXCEPTION_FEA                         0x2015                                                
#define FTD_SB_BCS_ACTIVE_FEATURE_MASK                        0x2016                                                
#define FTD_SB_BCS_BLOCKING_MASK                              0x2017                                                
#define FTD_SB_BCS_INTERRUPTING_MASK                          0x2018                                                
#define FTD_SB_BCS_EXCEPTION_MASK                             0x2019                                                


//SUBBLOCKS


//Definition for struct BCS_SB_CONNECTION_SETTINGS
#define BCS_SB_CONNECTION_SETTINGS                            0x01                                                     
typedef struct
            { 
             uint8_t      sb_id;
             uint8_t      sb_len;
             uint8_t      settings_len;
             uint8_t      settings[0];
            } __attribute__((packed)) BCS_SB_CONNECTION_SETTINGS_STR;
#define SIZE_BCS_SB_CONNECTION_SETTINGS                       sizeof(BCS_SB_CONNECTION_SETTINGS_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct BCS_SB_CAUSE_INFO
#define BCS_SB_CAUSE_INFO                                     0x02                                                     
typedef struct
            { 
             uint8_t      sb_id;
             uint8_t      sb_len;
             uint8_t      application_id;
             uint8_t      bearer_id;
            } __attribute__((packed)) BCS_SB_CAUSE_INFO_STR;
#define SIZE_BCS_SB_CAUSE_INFO                                sizeof(BCS_SB_CAUSE_INFO_STR)


//MESSAGES


//Definition for struct BCS_RESERVE_REQ
#define BCS_RESERVE_REQ                                       0x01                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      application_id;
             uint8_t      bearer_id;
             uint8_t      fillerbyte1[3];
             uint8_t      sub_block_count;
            } __attribute__((packed)) BCS_RESERVE_REQ_STR;
#define SIZE_BCS_RESERVE_REQ                                  sizeof(BCS_RESERVE_REQ_STR)


//Definition for struct BCS_RESERVE_RESP
#define BCS_RESERVE_RESP                                      0x02                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      reservation_id;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) BCS_RESERVE_RESP_STR;
#define SIZE_BCS_RESERVE_RESP                                 sizeof(BCS_RESERVE_RESP_STR)


//Definition for struct BCS_RELEASE_REQ
#define BCS_RELEASE_REQ                                       0x03                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      reservation_id;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) BCS_RELEASE_REQ_STR;
#define SIZE_BCS_RELEASE_REQ                                  sizeof(BCS_RELEASE_REQ_STR)


//Definition for struct BCS_RELEASE_RESP
#define BCS_RELEASE_RESP                                      0x04                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      reservation_id;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) BCS_RELEASE_RESP_STR;
#define SIZE_BCS_RELEASE_RESP                                 sizeof(BCS_RELEASE_RESP_STR)


//Definition for struct BCS_RELEASE_IND
#define BCS_RELEASE_IND                                       0x07                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      reservation_id;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) BCS_RELEASE_IND_STR;
#define SIZE_BCS_RELEASE_IND                                  sizeof(BCS_RELEASE_IND_STR)


//Definition for struct BCS_RESERVATION_STATUS_NTF
#define BCS_RESERVATION_STATUS_NTF                            0x05                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      reservation_id;
             uint8_t      status;
             uint8_t      cause;
             uint8_t      uq_blocking_flag;
             uint8_t      fillerbyte1;
             uint8_t      sub_block_count;
            } __attribute__((packed)) BCS_RESERVATION_STATUS_NTF_STR;
#define SIZE_BCS_RESERVATION_STATUS_NTF                       sizeof(BCS_RESERVATION_STATUS_NTF_STR)


//Definition for struct BCS_RESERVATION_STATUS_IND
#define BCS_RESERVATION_STATUS_IND                            0x06                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      reservation_id;
             uint8_t      application_id;
             uint8_t      bearer_id;
             uint8_t      status;
             uint8_t      cause;
             uint8_t      sub_block_count;
            } __attribute__((packed)) BCS_RESERVATION_STATUS_IND_STR;
#define SIZE_BCS_RESERVATION_STATUS_IND                       sizeof(BCS_RESERVATION_STATUS_IND_STR)


//Definition for struct BCS_STATE_GET_REQ
#define BCS_STATE_GET_REQ                                     0x08                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) BCS_STATE_GET_REQ_STR;
#define SIZE_BCS_STATE_GET_REQ                                sizeof(BCS_STATE_GET_REQ_STR)


//Definition for struct BCS_STATE_GET_RESP
#define BCS_STATE_GET_RESP                                    0x09                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      active_clients;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) BCS_STATE_GET_RESP_STR;
#define SIZE_BCS_STATE_GET_RESP                               sizeof(BCS_STATE_GET_RESP_STR)

#endif
