#ifndef _PN_CALL_ISI_H_
#define _PN_CALL_ISI_H_

#include <stdint.h> 

//Resource Call Server
//PN_CALL 0x01 
//ISI version 007.018
#define CALL_SERVER_ISI_VERSION_Z     7
#define CALL_SERVER_ISI_VERSION_Y     18

//In case of problems concerning content of this file contact Henrik Ala-Uotila
//Server specific message descriptions and feature&protocol descriptions can be found from: https://oucmswww.nmp.nokia.com:58443/document_browser/ccm_wa/GIF_SPECS/ 


//ISI VERSION CHANGE HISTORY

//Version: 007.020                                           
//Status: Approved                                          
//Date: 06-Jun-2008     Meija Lohiniva
//Reason: Inspection
//Reference: ADB for SWAM, Inspection ID: ML08052635757, APPROVED

//Version: 007.019                                           
//Status: Draft                                             
//Date: 20-May-2008     Meija Lohiniva
//Reason: New feature
//Reference: ADB for SWAM, Inspection ID: ML08052635757, DRAFT

//Version: 007.018                                           
//Status: Approved                                          
//Date: 10-Apr-2008     Mika Leppanen
//Reason: Inspection
//Reference: ADB for SWAM, Inspection ID: ML08040728948, APPROVED

//Version: 007.017                                           
//Status: Draft                                             
//Date: 17-Mar-2008     Mika Leppanen
//Reason: New feature
//Reference: RM-RIM SUB 417-2661, DRAFT

//Version: 007.016                                           
//Status: Approved                                          
//Date: 15-Feb-2008     Mika Leppanen
//Reason: New feature
//Reference: RM-RIM SUB 417-265, ADB for SWAM, Inspection ID: ML08021227724, APPROVED

//Version: 007.015                                           
//Status: Approved                                          
//Date: 11-Feb-2008     Toni Heikkinen
//Reason: Inspection
//Reference: ADB for SWAM, Inspection ID: TH08012851750, APPROVED

//Version: 007.014                                           
//Status: Draft                                             
//Date: 28-Jan-2008     Toni Heikkinen
//Reason: New feature
//Reference: WP RM-RIM SUB 402-3635, DRAFT

//Version: 007.013                                           
//Status: Approved                                          
//Date: 14-Jan-2008     Arto Maatta
//Reason: Inspection
//Reference: ADB for SWAM, Inspection ID: AM08010856375, APPROVED

//Version: 007.012                                           
//Status: Draft                                             
//Date: 02-Jan-2008     Arto Maatta
//Reason: New features
//Reference: WP RM-RIM SUB 414-3697, DRAFT

//Version: 007.011                                           
//Status: Approved                                          
//Date: 20-Nov-2007     Arto Maatta
//Reason: Inspection
//Reference: ADB for SWAM, Inspection ID: AM07111456137, APPROVED

//Version: 007.010                                           
//Status: Draft                                             
//Date: 06-Nov-2007     Arto Maatta
//Reason: New features
//Reference: WP RM-RIM SUB 414-2603, DRAFT

//Version: 007.009                                           
//Status: Approved                                          
//Date: 25-Sep-2007     Mika Leppanen
//Reason: Inspection
//Reference: ADB for SWAM, Inspection ID: ML07091861442, APPROVED

//Version: 007.008                                           
//Status: Draft                                             
//Date: 18-Sep-2007     Mika Leppanen
//Reason: New features
//Reference: WP RM-RIM SUB 414-1364, WP RM-RIM SUB 402-1112, WP RM-RIM SUB 414-1387, DRAFT

//Version: 007.007                                           
//Status: Approved                                          
//Date: 03-Sep-2007     Arto Maatta
//Reason: Inspection
//Reference: ADB for SWAM, Inspection ID: AM07082457512, APPROVED

//Version: 007.006                                           
//Status: Draft                                             
//Date: 24-Aug-2007     Arto Maatta
//Reason: New features
//Reference: WP RM-RIM SUB 414-745, DRAFT

//Version: 007.005                                           
//Status: Approved                                          
//Date: 22-Aug-2007     Toni Heikkinen
//Reason: Inspection
//Reference: -, APPROVED

//Version: 007.004                                           
//Status: Draft                                             
//Date: 22-Aug-2007     Toni Heikkinen
//Reason: Correction
//Reference: -, DRAFT

//Version: 007.003                                           
//Status: Approved                                          
//Date: 30-Jul-2007     Toni Heikkinen
//Reason: Inspection
//Reference: ADB for SWAM, Inspection ID: TH07062137494, APPROVED

//Version: 007.002                                           
//Status: Draft                                             
//Date: 05-Jun-2007     Toni Heikkinen
//Reason: New features
//Reference: WP RM-RIM SUB 402-2097, WP RM-RIM SUB 009-31265, DRAFT

//Version: 007.001                                           
//Status: Approved                                          
//Date: 23-May-2007     Mika Leppanen
//Reason: Inspection
//Reference: ADB for SWAM, Inspection ID: ML07051541803, APPROVED

//Version: 007.000                                           
//Status: Draft                                             
//Date: 15-May-2007     Mika Leppanen
//Reason: New features
//Reference: WP RM-RIM SCO 402-624, WP RM-RIM SCO 402-623, WP RM-RIM SCO 401-1608, DRAFT

//Version: 006.005                                           
//Status: Approved                                          
//Date: 15-Feb-2007     Toni Heikkinen
//Reason: Inspection
//Reference: ADB for SWAM, Inspection ID: TH07021437118, APPROVED

//Version: 006.004                                           
//Status: Draft                                             
//Date: 07-Feb-2007     Toni Heikkinen
//Reason: New feature
//Reference: WP RM-RIM SUB 009-31504, DRAFT

//Version: 006.003                                           
//Status: Approved                                          
//Date: 18-Jan-2007     Mika Leppanen
//Reason: Inspection
//Reference: ADB for SWAM, Inspection ID: ML07011244263, APPROVED

//Version: 006.002                                           
//Status: Draft                                             
//Date: 12-Jan-2007     Mika Leppanen
//Reason: New feature
//Reference: WP RM-RIM SUB 009-29981, DRAFT

//Version: 006.001                                           
//Status: Approved                                          
//Date: 04-Jan-2007     Mika Leppanen
//Reason: Inspection
//Reference: ADB for SWAM, Inspection ID: ML06121553574, APPROVED

//Version: 006.000                                           
//Status: Draft                                             
//Date: 15-Dec-2006     Mika Leppanen
//Reason: New feature
//Reference: WP RM-RIM REQ 009-26305, DRAFT

//Version: 005.010                                           
//Status: Approved                                          
//Date: 07-Dec-2006     Toni Heikkinen
//Reason: Inspection
//Reference: ADB for SWAM, Inspection ID: TH06120445104, APPROVED

//Version: 005.009                                           
//Status: Draft                                             
//Date: 28-Nov-2006     Toni Heikkinen
//Reason: New feature
//Reference: WP RM-RIM SUB 009-29981, DRAFT

//Version: 005.008                                           
//Status: Approved                                          
//Date: 24-Nov-2006     Arto Maatta
//Reason: Inspection
//Reference: ADB for SWAM, Inspection ID: AM06112145293, APPROVED

//Version: 005.007                                           
//Status: Draft                                             
//Date: 21-Nov-2006     Arto Maatta
//Reason: New feature
//Reference: WP RM-RIM SUB 010-28625, DRAFT

//Version: 005.006                                           
//Status: Approved                                          
//Date: 03-Oct-2006     Toni Heikkinen
//Reason: Flagging correction
//Reference: -

//Version: 005.005                                           
//Status: Approved                                          
//Date: 12-Sep-2006     Toni Heikkinen
//Reason: Inspection
//Reference: ADB for SWAM, Inspection ID: TH06090143203, APPROVED

//Version: 005.004                                           
//Status: Draft                                             
//Date: 22-Aug-2006     Toni Heikkinen
//Reason: New feature
//Reference: WP RM-RIM REQ 010-24174, DRAFT

//Version: 005.003                                           
//Status: Approved                                          
//Date: 12-Jun-2006     Toni Heikkinen
//Reason: Inspection
//Reference: ADB for SWAM, Inspection ID: TH06052446504, APPROVED

//Version: 005.002                                           
//Status: Draft                                             
//Date: 02-May-2006     Toni Heikkinen
//Reason: New feature
//Reference: WP RM-RIM SUB 010-24773, DRAFT

//Version: 005.001                                           
//Status: Approved                                          
//Date: 15-Dec-2005     Mika Leppanen
//Reason: Inspection
//Reference: ADB for SWAM, Inspection ID: ML05120739273, APPROVED

//Version: 005.000                                           
//Status: Draft                                             
//Date: 05-Dec-2005     Mika Leppanen
//Reason: New features
//Reference: WP RM-RIM SUB 010-13847 (TracFone Control in Call Server), DRAFT

//Version: 004.045                                           
//Status: Approved                                          
//Date: 30-Nov-2005     Mika Leppanen
//Reason: Inspection
//Reference: ADB for SWAM, Inspection ID: ML05112841493, APPROVED

//Version: 004.044                                           
//Status: Draft                                             
//Date: 23-Nov-2005     Mika Leppanen
//Reason: New feature
//Reference: WP RM-RIM REQ 010-19277, DRAFT

//Version: 004.043                                           
//Status: Approved                                          
//Date: 06-Sep-2005     Timo Krall
//Reason: Inspection
//Reference: ADB for SWAM CR:TK05081552860, Inspection ID: TK05082947314, APPROVED

//Version: 004.042                                           
//Status: Draft                                             
//Date: 29-Aug-2005     Timo Krall
//Reason: Implemented CR
//Reference: ADB for SWAM CR:TK05081552860, Inspection ID: TK05082947314, DRAFT

//Version: 004.041                                           
//Status: Approved                                          
//Date: 09-Aug-2005     Mika Leppanen
//Reason: Inspection
//Reference: ADB for SWAM, Inspection ID: ML05070636180, APPROVED

//Version: 004.040                                           
//Status: Draft                                             
//Date: 06-Jul-2005     Mika Leppanen
//Reason: New features
//Reference: WP RM-RIM SUB 009-14808 (NAS Synchronisation Indicator), DRAFT

//Version: 004.039                                           
//Status: Approved                                          
//Date: 27-Apr-2005     Mika Leppanen
//Reason: Inspection
//Reference: ADB for SWAM, Inspection ID: ML05042245615, APPROVED

//Version: 004.038                                           
//Status: Draft                                             
//Date: 12-Apr-2005     Mika Leppanen
//Reason: New features
//Reference: WP RM-RIM SUB 010-12544 (Shorter timers for DTMF handling), WP RM-RIM REQ 010-13370 (16-bit ISI header to Call Server), DRAFT

//Version: 004.037                                           
//Status: Approved                                          
//Date: 07-Apr-2005     Mika Leppanen
//Reason: Inspection
//Reference: ADB for SWAM, Inspection ID: ML05033048870, APPROVED

//Version: 004.036                                           
//Status: Draft                                             
//Date: 30-Mar-2005     Mika Leppanen
//Reason: New features
//Reference: WP RM SUB 010-12042 Shared sub blocks, WP RM SUB 010-12043 Call ID to service denied indication, WP RM SUB 009-17618 Origin info to clients, DRAFT

//Version: 004.035                                           
//Status: Approved                                          
//Date: 14-Mar-2005     Mika Leppanen
//Reason: Inspection
//Reference: ADB for SWAM, Inspection ID: ML05030848317, APPROVED

//Version: 004.034                                           
//Status: Draft                                             
//Date: 02-Mar-2005     Mika Leppanen
//Reason: New feature
//Reference: WP RM-RIM SUB 010-9640 Call duration to call history, DRAFT

//Version: 004.033                                           
//Status: Approved                                          
//Date: 24-Jan-2005     Mika Leppanen
//Reason: Inspection
//Reference: ADB for SWAM, Inspection ID: ML05011740420, APPROVED

//Version: 004.032                                           
//Status: Draft                                             
//Date: 17-Jan-2005     Mika Leppanen
//Reason: New feature
//Reference: WP RM-RIM SUB 010-9323 User connection indication, DRAFT

//Version: 004.031                                           
//Status: Approved                                          
//Date: 03-Nov-2004     Mika Leppanen
//Reason: Inspection
//Reference: ADB for SWAM, Inspection ID: ML04110153068, APPROVED

//Version: 004.030                                           
//Status: Draft                                             
//Date: 25-Oct-2004     Mika Leppanen
//Reason: New features
//Reference: WP RM-RIM SUB 010-8270 Emergency number erase, WP RM-RIM SUB 009-12701 CLIR and CLIP settings, WP RM-RIM SUB 010-8034 remote party number, DRAFT

//Version: 004.029                                           
//Status: Approved                                          
//Date: 31-Aug-2004     Mika Leppanen
//Reason: Inspection
//Reference: ADB for SWAM, Inspection ID: ML04082560267, APPROVED

//Version: 004.028                                           
//Status: Draft                                             
//Date: 12-Aug-2004     Mika Leppanen
//Reason: New feature
//Reference: WP RM-RIM SUB 010-5871, WP RM-RIM SUB 009-10290, DRAFT

//Version: 004.027                                           
//Status: Approved                                          
//Date: 30-Jun-2004     Arto Maatta
//Reason: Inspection
//Reference: ADB for SWAM, Inspection ID: AM04062357906, APPROVED

//Version: 004.026                                           
//Status: Draft                                             
//Date: 21-Jun-2004     Arto Maatta
//Reason: New feature
//Reference: WP RM-RIM SUB 010-4794, DRAFT

//Version: 004.025                                           
//Status: Approved                                          
//Date: 25-May-2004     Mika Leppanen
//Reason: Inspection
//Reference: ADB for SWAM, Inspection ID: ML04051739939, APPROVED

//Version: 004.024                                           
//Status: Draft                                             
//Date: 17-May-2004     Mika Leppanen
//Reason: New features
//Reference: WP RM-RIM SUB 009-10611 (alpha ID), ADB for SWAM, CR ID: ML04050540292, WP RM-RIM SUB 009-11590 (CS inactive mode), ADB for SWAM, CR ID: AM04040732623, DRAFT

//Version: 004.023                                           
//Status: Approved                                          
//Date: 10-Mar-2004     Arto Maatta
//Reason: Inspection
//Reference: ISA RM-RIM SCO: 001-299, ADB for SWAM, inspection ID: AM04022734342, APPROVED

//Version: 004.022                                           
//Status: Draft                                             
//Date: 26-Feb-2004     Arto Maatta
//Reason: Changes for the SIM toolkit Send DTMF
//Reference: ISA RM-RIM SCO: 001-299, ADB for SWAM, inspection ID: AM04022734342, DRAFT

//Version: 004.021                                           
//Status: Draft                                             
//Date: 05-Feb-2004     Arto Maatta
//Reason: Changes for the SIM toolkit Send DTMF
//Reference: ISA RM-RIM SCO: 001-299, ADB for SWAM, inspection ID: AM04022344984, ADB for SWAM, CR ID: AM04021038037, DRAFT

//Version: 004.020                                           
//Status: Approved                                          
//Date: 27-Jan-2004     Esa Harju
//Reason: Inspection
//Reference: ADB for SWAM, inspection ID: EH04011543975, APPROVED

//Version: 004.019                                           
//Status: Draft                                             
//Date: 03-Dec-2003     Esa Harju
//Reason: Corrections and additions
//Reference: ISA RM-RIM SUB: 009-7361, ADB for PCP errors ID: ET03091750032, ADB for PCP errors ID: ER03102668608, ADB for SWAM, inspection ID: EH03120951862, DRAFT

//Version: 004.018                                           
//Status: Approved                                          
//Date: 25-Sep-2003     Mika Leppnen
//Reason: Inspection
//Reference: ADB for SWAM, inspection ID: ML03090343523, APPROVED

//Version: 004.017                                           
//Status: Draft                                             
//Date: 03-Sep-2003     Mika Leppnen
//Reason: New feature
//Reference: ISA RM tool ID: 009-4621 ALS Setting to be moved to the Call Server, ISA RM tool ID: 010-1021 Moving of Call Timers to ISA 3 Call Server, ADB for SWAM, change request ID: ML03081339386, DRAFT

//Version: 004.016                                           
//Status: Approved                                          
//Date: 22-Apr-2003     Mika Leppnen
//Reason: Inspection
//Reference: ADB for SWAM, inspection ID: ML03041038044, APPROVED

//Version: 004.015                                           
//Status: Draft                                             
//Date: 07-Apr-2003     Mika Leppnen
//Reason: Addition
//Reference: ADB for SWAM, change request ID: ML03040738711, DRAFT

//Version: 004.014                                           
//Status: Approved                                          
//Date: 02-Apr-2003     Mika Leppnen
//Reason: Inspection
//Reference: ADB for SWAM, inspection ID: ML03032547867, APPROVED

//Version: 004.013                                           
//Status: Draft                                             
//Date: 25-Mar-2003     Mika Leppnen
//Reason: Additions
//Reference: ADB for SWAM, change request ID: ML03031959984, DRAFT

//Version: 004.012                                           
//Status: Approved                                          
//Date: 05-Dec-2002     Mika Leppnen
//Reason: Inspection
//Reference: ADB for SWAM inspection ID: ML02120445056, APPROVED

//Version: 004.011                                           
//Status: Draft                                             
//Date: 02-Dec-2002     Mika Leppnen
//Reason: Inspection
//Reference: ADB for SWAM inspection ID: ML02120445056, DRAFT

//Version: 004.010                                           
//Status: Approved                                          
//Date: 02-Dec-2002     Mika Leppnen
//Reason: Inspection
//Reference: ADB for SWAM inspection ID: ML02112660236, APPROVED

//Version: 004.009                                           
//Status: Draft                                             
//Date: 26-Nov-2002     Mika Leppnen
//Reason: Inspection
//Reference: ADB for SWAM inspection ID: ML02112660236, DRAFT

//Version: 004.008                                           
//Status: Approved                                          
//Date: 19-Nov-2002     Mika Leppnen
//Reason: Inspection
//Reference: ADB for SWAM inspection ID: ML02103158731, APPROVED

//Version: 004.007                                           
//Status: Draft                                             
//Date: 10-Nov-2002     Mika Leppnen
//Reason: Inspection
//Reference: ADB for SWAM inspection ID: ML02103158731, DRAFT


//CONSTANTS
#define CALL_GSM_CUG_DEFAULT                                  0xFFFF                                                
#define NO_ISI_SUB_BLOCKS                                     0x00                                                     
#define CALL_DTMF_P_DIGIT                                     0x70                                                  
#define CALL_DTMF_W_DIGIT                                     0x77                                                  
#define CALL_DTMF_NO_TONE                                     0x00                                                     
#define CALL_DTMF_DEFAULT                                     0x00                                                     
#define CALL_DTMF_NO_DELAY                                    0x01                                                     
#define CALL_INDEX_NOT_VALID                                  0x00                                                     
#define CALL_NUMBER_TYPE_NONE                                 0x00                                                     
#define CALL_NUMBER_GROUP_NONE                                0x00                                                     


//TABLES

//BitmaskTables for CALL_ID
#define CALL_ID_NONE                                          0x00                                                     
#define CALL_ID_1                                             0x01                                                     
#define CALL_ID_2                                             0x02                                                     
#define CALL_ID_3                                             0x03                                                     
#define CALL_ID_4                                             0x04                                                     
#define CALL_ID_5                                             0x05                                                     
#define CALL_ID_6                                             0x06                                                     
#define CALL_ID_7                                             0x07                                                     
#define CALL_ID_CONFERENCE                                    0x10                                                  
#define CALL_ID_WAITING                                       0x20                                                  
#define CALL_ID_HOLD                                          0x40                                                  
#define CALL_ID_ACTIVE                                        0x80                                                  
#define CALL_ID_ALL                                           0xF0                                                  

//ConstantTable for CALL_CAUSE_TYPE_SENDER_CS
#define CALL_CAUSE_TYPE_DEFAULT                               0x00                                                     

//ConstantTable for CALL_CAUSE_TYPE_SENDER_CS

//ConstantTable for CALL_CAUSE_TYPE_SENDER
#define CALL_CAUSE_TYPE_CLIENT                                0x01                                                     
#define CALL_CAUSE_TYPE_SERVER                                0x02                                                     
#define CALL_CAUSE_TYPE_NETWORK                               0x03                                                     

//ConstantTable for CALL_CAUSE
#define CALL_CAUSE_NO_CAUSE                                   0x00                                                     
#define CALL_CAUSE_NO_CALL                                    0x01                                                     
#define CALL_CAUSE_TIMEOUT                                    0x02                                                     
#define CALL_CAUSE_RELEASE_BY_USER                            0x03                                                     
#define CALL_CAUSE_BUSY_USER_REQUEST                          0x04                                                     
#define CALL_CAUSE_ERROR_REQUEST                              0x05                                                     
#define CALL_CAUSE_COST_LIMIT_REACHED                         0x06                                                     
#define CALL_CAUSE_CALL_ACTIVE                                0x07                                                     
#define CALL_CAUSE_NO_CALL_ACTIVE                             0x08                                                     
#define CALL_CAUSE_INVALID_CALL_MODE                          0x09                                                     
#define CALL_CAUSE_SIGNALLING_FAILURE                         0x0A                                                     
#define CALL_CAUSE_TOO_LONG_ADDRESS                           0x0B                                                     
#define CALL_CAUSE_INVALID_ADDRESS                            0x0C                                                     
#define CALL_CAUSE_EMERGENCY                                  0x0D                                                     
#define CALL_CAUSE_NO_TRAFFIC_CHANNEL                         0x0E                                                     
#define CALL_CAUSE_NO_COVERAGE                                0x0F                                                     
#define CALL_CAUSE_CODE_REQUIRED                              0x10                                                  
#define CALL_CAUSE_NOT_ALLOWED                                0x11                                                  
#define CALL_CAUSE_NO_DTMF                                    0x12                                                  
#define CALL_CAUSE_CHANNEL_LOSS                               0x13                                                  
#define CALL_CAUSE_FDN_NOT_OK                                 0x14                                                  
#define CALL_CAUSE_USER_TERMINATED                            0x15                                                  
#define CALL_CAUSE_BLACKLIST_BLOCKED                          0x16                                                  
#define CALL_CAUSE_BLACKLIST_DELAYED                          0x17                                                  
#define CALL_CAUSE_NUMBER_NOT_FOUND                           0x18                                                  
#define CALL_CAUSE_NUMBER_CANNOT_REMOVE                       0x19                                                  
#define CALL_CAUSE_EMERGENCY_FAILURE                          0x1A                                                  
#define CALL_CAUSE_CS_SUSPENDED                               0x1B                                                  
#define CALL_CAUSE_DCM_DRIVE_MODE                             0x1C                                                  
#define CALL_CAUSE_MULTIMEDIA_NOT_ALLOWED                     0x1D                                                  
#define CALL_CAUSE_SIM_REJECTED                               0x1E                                                  
#define CALL_CAUSE_NO_SIM                                     0x1F                                                  
#define CALL_CAUSE_SIM_LOCK_OPERATIVE                         0x20                                                  
#define CALL_CAUSE_SIMATKCC_REJECTED                          0x21                                                  
#define CALL_CAUSE_SIMATKCC_MODIFIED                          0x22                                                  
#define CALL_CAUSE_DTMF_INVALID_DIGIT                         0x23                                                  
#define CALL_CAUSE_DTMF_SEND_ONGOING                          0x24                                                  
#define CALL_CAUSE_CS_INACTIVE                                0x25                                                  
#define CALL_CAUSE_SECURITY_MODE                              0x26                                                  
#define CALL_CAUSE_TRACFONE_FAILED                            0x27                                                  
#define CALL_CAUSE_TRACFONE_WAIT_FAILED                       0x28                                                  
#define CALL_CAUSE_TRACFONE_CONF_FAILED                       0x29                                                  
#define CALL_CAUSE_TEMPERATURE_LIMIT                          0x2A                                                  
#define CALL_CAUSE_KODIAK_POC_FAILED                          0x2B                                                  
#define CALL_CAUSE_NOT_REGISTERED                             0x2C                                                  
#define CALL_CAUSE_CS_CALLS_ONLY                              0x2D                                                  
#define CALL_CAUSE_VOIP_CALLS_ONLY                            0x2E                                                  
#define CALL_CAUSE_LIMITED_CALL_ACTIVE                        0x2F                                                  
#define CALL_CAUSE_LIMITED_CALL_NOT_ALLOWED                   0x30                                                  
#define CALL_CAUSE_SECURE_CALL_NOT_POSSIBLE                   0x31                                                  
#define CALL_CAUSE_INTERCEPT                                  0x32                                                  

//ConstantTable for CALL_GSM_CAUSE
#define CALL_GSM_CAUSE_UNASSIGNED_NUMBER                      0x01                                                     
#define CALL_GSM_CAUSE_NO_ROUTE                               0x03                                                     
#define CALL_GSM_CAUSE_CH_UNACCEPTABLE                        0x06                                                     
#define CALL_GSM_CAUSE_OPER_BARRING                           0x08                                                     
#define CALL_GSM_CAUSE_NORMAL                                 0x10                                                  
#define CALL_GSM_CAUSE_USER_BUSY                              0x11                                                  
#define CALL_GSM_CAUSE_NO_USER_RESPONSE                       0x12                                                  
#define CALL_GSM_CAUSE_ALERT_NO_ANSWER                        0x13                                                  
#define CALL_GSM_CAUSE_CALL_REJECTED                          0x15                                                  
#define CALL_GSM_CAUSE_NUMBER_CHANGED                         0x16                                                  
#define CALL_GSM_CAUSE_NON_SELECT_CLEAR                       0x1A                                                  
#define CALL_GSM_CAUSE_DEST_OUT_OF_ORDER                      0x1B                                                  
#define CALL_GSM_CAUSE_INVALID_NUMBER                         0x1C                                                  
#define CALL_GSM_CAUSE_FACILITY_REJECTED                      0x1D                                                  
#define CALL_GSM_CAUSE_RESP_TO_STATUS                         0x1E                                                  
#define CALL_GSM_CAUSE_NORMAL_UNSPECIFIED                     0x1F                                                  
#define CALL_GSM_CAUSE_NO_CHANNEL                             0x22                                                  
#define CALL_GSM_CAUSE_NETW_OUT_OF_ORDER                      0x26                                                  
#define CALL_GSM_CAUSE_TEMPORARY_FAILURE                      0x29                                                  
#define CALL_GSM_CAUSE_CONGESTION                             0x2A                                                  
#define CALL_GSM_CAUSE_ACCESS_INFO_DISC                       0x2B                                                  
#define CALL_GSM_CAUSE_CHANNEL_NA                             0x2C                                                  
#define CALL_GSM_CAUSE_RESOURCES_NA                           0x2F                                                  
#define CALL_GSM_CAUSE_QOS_NA                                 0x31                                                  
#define CALL_GSM_CAUSE_FACILITY_UNSUBS                        0x32                                                  
#define CALL_GSM_CAUSE_COMING_BARRED_CUG                      0x37                                                  
#define CALL_GSM_CAUSE_BC_UNAUTHORIZED                        0x39                                                  
#define CALL_GSM_CAUSE_BC_NA                                  0x3A                                                  
#define CALL_GSM_CAUSE_SERVICE_NA                             0x3F                                                  
#define CALL_GSM_CAUSE_BEARER_NOT_IMPL                        0x41                                                  
#define CALL_GSM_CAUSE_ACM_MAX                                0x44                                                  
#define CALL_GSM_CAUSE_FACILITY_NOT_IMPL                      0x45                                                  
#define CALL_GSM_CAUSE_ONLY_RDI_BC                            0x46                                                  
#define CALL_GSM_CAUSE_SERVICE_NOT_IMPL                       0x4F                                                  
#define CALL_GSM_CAUSE_INVALID_TI                             0x51                                                  
#define CALL_GSM_CAUSE_NOT_IN_CUG                             0x57                                                  
#define CALL_GSM_CAUSE_INCOMPATIBLE_DEST                      0x58                                                  
#define CALL_GSM_CAUSE_INV_TRANS_NET_SEL                      0x5B                                                  
#define CALL_GSM_CAUSE_SEMANTICAL_ERR                         0x5F                                                  
#define CALL_GSM_CAUSE_INVALID_MANDATORY                      0x60                                                  
#define CALL_GSM_CAUSE_MSG_TYPE_INEXIST                       0x61                                                  
#define CALL_GSM_CAUSE_MSG_TYPE_INCOMPAT                      0x62                                                  
#define CALL_GSM_CAUSE_IE_NON_EXISTENT                        0x63                                                  
#define CALL_GSM_CAUSE_COND_IE_ERROR                          0x64                                                  
#define CALL_GSM_CAUSE_MSG_INCOMPATIBLE                       0x65                                                  
#define CALL_GSM_CAUSE_TIMER_EXPIRY                           0x66                                                  
#define CALL_GSM_CAUSE_PROTOCOL_ERROR                         0x6F                                                  
#define CALL_GSM_CAUSE_INTERWORKING                           0x7F                                                  

//ConstantTable for CALL_STATUS
#define CALL_STATUS_IDLE                                      0x00                                                     
#define CALL_STATUS_CREATE                                    0x01                                                     
#define CALL_STATUS_COMING                                    0x02                                                     
#define CALL_STATUS_PROCEEDING                                0x03                                                     
#define CALL_STATUS_MO_ALERTING                               0x04                                                     
#define CALL_STATUS_MT_ALERTING                               0x05                                                     
#define CALL_STATUS_WAITING                                   0x06                                                     
#define CALL_STATUS_ANSWERED                                  0x07                                                     
#define CALL_STATUS_ACTIVE                                    0x08                                                     
#define CALL_STATUS_MO_RELEASE                                0x09                                                     
#define CALL_STATUS_MT_RELEASE                                0x0A                                                     
#define CALL_STATUS_HOLD_INITIATED                            0x0B                                                     
#define CALL_STATUS_HOLD                                      0x0C                                                     
#define CALL_STATUS_RETRIEVE_INITIATED                        0x0D                                                     
#define CALL_STATUS_RECONNECT_PENDING                         0x0E                                                     
#define CALL_STATUS_TERMINATED                                0x0F                                                     
#define CALL_STATUS_SWAP_INITIATED                            0x10                                                  

//BitmaskTables for CALL_SERVER_STATUS
#define CALL_SERVER_STATUS_INACTIVE                           0x00                                                     
#define CALL_SERVER_STATUS_ACTIVE                             0x01                                                     
#define CALL_SERVER_STATUS_GSM                                0x00                                                     

//BitmaskTables for CALL_ALERTING_INFO
#define CALL_AI_GEN_ALERTING_TONE                             0x01                                                     

//BitmaskTables for CALL_RELEASE_INFO
#define CALL_RI_IN_BAND_INFO                                  0x01                                                     

//BitmaskTables for CALL_GSM_ALLOWED_ACTIONS
#define CALL_GSM_AA_CCBS_POSSIBLE                             0x80                                                  

//ConstantTable for CALL_OPERATION
#define CALL_OP_HOLD                                          0x01                                                     
#define CALL_OP_RETRIEVE                                      0x02                                                     
#define CALL_OP_SWAP                                          0x03                                                     
#define CALL_OP_CONFERENCE_BUILD                              0x04                                                     
#define CALL_OP_CONFERENCE_SPLIT                              0x05                                                     
#define CALL_OP_DATA_RATE_CHANGE                              0x06                                                     
#define CALL_GSM_OP_CUG                                       0xA0                                                  
#define CALL_GSM_OP_TRANSFER                                  0xA1                                                  
#define CALL_GSM_OP_DEFLECT                                   0xA2                                                  
#define CALL_GSM_OP_CCBS                                      0xA3                                                  
#define CALL_GSM_OP_UUS1                                      0xA4                                                  
#define CALL_GSM_OP_UUS2                                      0xA5                                                  
#define CALL_GSM_OP_UUS3                                      0xA6                                                  

//BitmaskTables for CALL_OPERATION_INFO
#define CALL_GSM_OP_UUS_REQUIRED                              0x01                                                     

//ConstantTable for CALL_DTMF_STATUS
#define CALL_DTMF_IDLE                                        0x00                                                     
#define CALL_DTMF_ACTIVE                                      0x01                                                     

//ConstantTable for CALL_RECONNECT_STATUS
#define CALL_RECONNECT_PENDING                                0x01                                                     
#define CALL_RECONNECTED                                      0x02                                                     

//ConstantTable for CALL_PROPERTY
#define CALL_PROP_ALL                                         0x01                                                     
#define CALL_GSM_PROP_IMMEDIATE_CONNECT                       0xA0                                                  
#define CALL_GSM_PROP_CUG_INFO                                0xA1                                                  
#define CALL_GSM_PROP_CALL_MODE_DEFAULT                       0xA2                                                  
#define CALL_GSM_PROP_DCM_DRIVE_MODE                          0xA3                                                  
#define CALL_GSM_PROP_MULTIMEDIA_CALL                         0xA4                                                  
#define CALL_GSM_PROP_SPEECH_FALLBACK                         0xA5                                                  
#define CALL_GSM_PROP_ALS                                     0xA6                                                  
#define CALL_GSM_PROP_SECURITY_MODE                           0xA7                                                  
#define CALL_GSM_PROP_LINE_ID                                 0xA8                                                  
#define CALL_PROP_PREFERRED_SYSTEM                            0xA9                                                  
#define CALL_PROP_VOIP_LINE_ID                                0xAA                                                  

//ConstantTable for CALL_GSM_PROP_IMMEDIATE_CONNECT
#define CALL_GSM_IMM_CONNECT_OFF                              0x00                                                     
#define CALL_GSM_IMM_CONNECT_ON                               0x01                                                     

//ConstantTable for CALL_GSM_PROP_DCM_DRIVE_MODE
#define CALL_GSM_DCM_DRIVE_MODE_OFF                           0x00                                                     
#define CALL_GSM_DCM_DRIVE_MODE_ON                            0x01                                                     

//ConstantTable for CALL_GSM_PROP_MULTIMEDIA_CALL
#define CALL_GSM_DISALLOW_MULTIMEDIA_CALL                     0x00                                                     
#define CALL_GSM_ALLOW_MULTIMEDIA_CALL                        0x01                                                     

//ConstantTable for CALL_GSM_PROP_SPEECH_FALLBACK
#define CALL_GSM_DISALLOW_SPEECH_FALLBACK                     0x00                                                     
#define CALL_GSM_ALLOW_SPEECH_FALLBACK                        0x01                                                     

//ConstantTable for CALL_GSM_PROP_ALS
#define CALL_GSM_PROP_ALS_LINE_NORMAL                         0x00                                                     
#define CALL_GSM_PROP_ALS_LINE_2                              0x01                                                     

//ConstantTable for CALL_GSM_PROP_SECURITY_MODE
#define CALL_GSM_PROP_SEC_MODE_DISABLED                       0x00                                                     
#define CALL_GSM_PROP_SEC_MODE_ENABLED                        0x01                                                     

//ConstantTable for CALL_GSM_PROP_LINE_ID
#define CALL_GSM_PROP_PRESENTATION_DEFAULT                    0x00                                                     
#define CALL_GSM_PROP_PRESENTATION_ALLOWED                    0x01                                                     
#define CALL_GSM_PROP_PRESENTATION_RESTRICTED                 0x02                                                     

//ConstantTable for CALL_PROP_PREFERRED_SYSTEM
#define CALL_PROP_CS_ONLY                                     0x00                                                     
#define CALL_PROP_VOIP_ONLY                                   0x01                                                     
#define CALL_PROP_CS_PREFERRED                                0x02                                                     
#define CALL_PROP_VOIP_PREFERRED                              0x03                                                     

//ConstantTable for CALL_PROP_VOIP_LINE_ID
#define CALL_PROP_VOIP_PRESENT_ALLOWED                        0x00                                                     
#define CALL_PROP_VOIP_PRESENT_RESTRICTED                     0x01                                                     

//ConstantTable for CALL_EMERGENCY_NUMBER_OPERATION
#define CALL_EMERGENCY_NUMBER_REMOVE                          0x00                                                     
#define CALL_EMERGENCY_NUMBER_ADD                             0x01                                                     
#define CALL_EMERGENCY_NUMBER_INDEX_MODIFY                    0x02                                                     

//ConstantTable for CALL_EMERGENCY_NUMBER_CHECK_STATUS
#define CALL_EMERGENCY_NBR_CHECK_FAIL                         0x00                                                     
#define CALL_EMERGENCY_NBR_CHECK_PASS                         0x01                                                     

//ConstantTable for CALL_GSM_PREFERENTIAL_CUG
#define CALL_GSM_CUG_PREF                                     0x00                                                     
#define CALL_GSM_CUG_PREF_SUPPRESS                            0x01                                                     

//ConstantTable for CALL_GSM_CUG_OUTGOING_ACCESS
#define CALL_GSM_CUG_OA                                       0x00                                                     
#define CALL_GSM_CUG_OA_SUPPRESS                              0x01                                                     

//ConstantTable for CALL_GSM_ALERTING_PATTERN
#define CALL_GSM_ALERTING_LEVEL_0                             0x00                                                     
#define CALL_GSM_ALERTING_LEVEL_1                             0x01                                                     
#define CALL_GSM_ALERTING_LEVEL_2                             0x02                                                     
#define CALL_GSM_ALERTING_CATEGORY_1                          0x04                                                     
#define CALL_GSM_ALERTING_CATEGORY_2                          0x05                                                     
#define CALL_GSM_ALERTING_CATEGORY_3                          0x06                                                     
#define CALL_GSM_ALERTING_CATEGORY_4                          0x07                                                     
#define CALL_GSM_ALERTING_CATEGORY_5                          0x08                                                     

//ConstantTable for CALL_GSM_CONDITION
#define CALL_GSM_COND_UNKNOWN                                 0x00                                                     
#define CALL_GSM_COND_PERMANENT                               0x01                                                     
#define CALL_GSM_COND_TRANSIENT                               0x02                                                     

//ConstantTable for CALL_GSM_SS_DIAGNOSTICS
#define CALL_GSM_SSD_OUTGOING_BARR_CUG                        0x01                                                     
#define CALL_GSM_SSD_NO_CUG                                   0x02                                                     
#define CALL_GSM_SSD_UNKNOWN_CUG                              0x03                                                     
#define CALL_GSM_SSD_INCOMPATIBLE_CUG                         0x04                                                     
#define CALL_GSM_SSD_CUG_FAIL                                 0x05                                                     
#define CALL_GSM_SSD_CLIR_NOT_SUBSCRIBED                      0x06                                                     
#define CALL_GSM_SSD_CCBS_POSSIBLE                            0x07                                                     
#define CALL_GSM_SSD_CCBS_NOT_POSSIBLE                        0x08                                                     

//ConstantTable for CALL_GSM_MMI_BASIC_SERVICE_CODE
#define CALL_ALL_TELE_AND_BEARER                              0x00                                                     
#define CALL_GSM_ALL_TELE                                     0x0A                                                     
#define CALL_GSM_TELEPHONY                                    0x0B                                                     
#define CALL_GSM_ALL_DATA_TELE                                0x0C                                                     
#define CALL_GSM_FACSIMILE                                    0x0D                                                     
#define CALL_GSM_SMS                                          0x10                                                  
#define CALL_GSM_VOICE_GROUP                                  0x11                                                  
#define CALL_GSM_ALL_TELE_EXC_SMS                             0x13                                                  
#define CALL_GSM_ALL_PLMN_SPEC_TELE_SERV                      0x32                                                  
#define CALL_GSM_PLMN_SPEC_TELE_SERV_1                        0x33                                                  
#define CALL_GSM_PLMN_SPEC_TELE_SERV_2                        0x34                                                  
#define CALL_GSM_PLMN_SPEC_TELE_SERV_3                        0x35                                                  
#define CALL_GSM_PLMN_SPEC_TELE_SERV_4                        0x36                                                  
#define CALL_GSM_PLMN_SPEC_TELE_SERV_5                        0x37                                                  
#define CALL_GSM_PLMN_SPEC_TELE_SERV_6                        0x38                                                  
#define CALL_GSM_PLMN_SPEC_TELE_SERV_7                        0x39                                                  
#define CALL_GSM_PLMN_SPEC_TELE_SERV_8                        0x3A                                                  
#define CALL_GSM_PLMN_SPEC_TELE_SERV_9                        0x3B                                                  
#define CALL_GSM_PLMN_SPEC_TELE_SERV_A                        0x3C                                                  
#define CALL_GSM_PLMN_SPEC_TELE_SERV_B                        0x3D                                                  
#define CALL_GSM_PLMN_SPEC_TELE_SERV_C                        0x3E                                                  
#define CALL_GSM_PLMN_SPEC_TELE_SERV_D                        0x3F                                                  
#define CALL_GSM_PLMN_SPEC_TELE_SERV_E                        0x40                                                  
#define CALL_GSM_PLMN_SPEC_TELE_SERV_F                        0x41                                                  
#define CALL_GSM_AUX_TELEPHONY                                0x59                                                  
#define CALL_GSM_ALL_BEARER                                   0x14                                                  
#define CALL_GSM_ALL_ASYNC                                    0x15                                                  
#define CALL_GSM_ALL_SYNC                                     0x16                                                  
#define CALL_GSM_ALL_DATA_CIRCUIT_SYNC                        0x18                                                  
#define CALL_GSM_ALL_DATA_CIRCUIT_ASYNC                       0x19                                                  
#define CALL_GSM_ALL_DATA_PACKET_SYNC                         0x1A                                                  
#define CALL_GSM_ALL_PAD_ACCESS                               0x1B                                                  
#define CALL_GSM_ALL_PLMN_SPEC_BEAR_SERV                      0x46                                                  
#define CALL_GSM_PLMN_SPEC_BEAR_SERV_1                        0x47                                                  
#define CALL_GSM_PLMN_SPEC_BEAR_SERV_2                        0x48                                                  
#define CALL_GSM_PLMN_SPEC_BEAR_SERV_3                        0x49                                                  
#define CALL_GSM_PLMN_SPEC_BEAR_SERV_4                        0x4A                                                  
#define CALL_GSM_PLMN_SPEC_BEAR_SERV_5                        0x4B                                                  
#define CALL_GSM_PLMN_SPEC_BEAR_SERV_6                        0x4C                                                  
#define CALL_GSM_PLMN_SPEC_BEAR_SERV_7                        0x4D                                                  
#define CALL_GSM_PLMN_SPEC_BEAR_SERV_8                        0x4E                                                  
#define CALL_GSM_PLMN_SPEC_BEAR_SERV_9                        0x4F                                                  
#define CALL_GSM_PLMN_SPEC_BEAR_SERV_A                        0x50                                                  
#define CALL_GSM_PLMN_SPEC_BEAR_SERV_B                        0x51                                                  
#define CALL_GSM_PLMN_SPEC_BEAR_SERV_C                        0x52                                                  
#define CALL_GSM_PLMN_SPEC_BEAR_SERV_D                        0x53                                                  
#define CALL_GSM_PLMN_SPEC_BEAR_SERV_E                        0x54                                                  
#define CALL_GSM_PLMN_SPEC_BEAR_SERV_F                        0x55                                                  
#define CALL_GSM_UNKNOWN_SERVICE                              0xFF                                                  

//ConstantTable for CALL_GSM_NOTIFICATION_INDICATOR
#define CALL_GSM_NOTIFY_USER_SUSPENDED                        0x00                                                     
#define CALL_GSM_NOTIFY_USER_RESUMED                          0x01                                                     
#define CALL_GSM_NOTIFY_BEARER_CHANGE                         0x02                                                     

//ConstantTable for CALL_GSM_MMI_SS_CODES
#define CALL_GSM_SSC_ALL_SS                                   0x00                                                     
#define CALL_GSM_SSC_ALL_FWDS                                 0x02                                                     
#define CALL_GSM_SSC_ALL_COND_FWD                             0x04                                                     
#define CALL_GSM_SSC_CFU                                      0x15                                                  
#define CALL_GSM_SSC_CFB                                      0x43                                                  
#define CALL_GSM_SSC_CFNRY                                    0x3D                                                  
#define CALL_GSM_SSC_CFGNC                                    0x3E                                                  
#define CALL_GSM_SSC_ALL_BARRINGS                             0x014A                                                   
#define CALL_GSM_SSC_BAOC                                     0x21                                                  
#define CALL_GSM_SSC_BOIC                                     0x014B                                                   
#define CALL_GSM_SSC_BOIC_EXHC                                0x014C                                                   
#define CALL_GSM_SSC_BAIC                                     0x23                                                  
#define CALL_GSM_SSC_BAIC_ROAM                                0x015F                                                   
#define CALL_GSM_SSC_OUTGOING_BARR_SERV                       0x014D                                                   
#define CALL_GSM_SSC_INCOMING_BARR_SERV                       0x0161                                                   
#define CALL_GSM_SSC_CALL_WAITING                             0x2B                                                  
#define CALL_GSM_SSC_CLIP                                     0x1E                                                  
#define CALL_GSM_SSC_CLIR                                     0x1F                                                  
#define CALL_GSM_SSC_COLP                                     0x4C                                                  
#define CALL_GSM_SSC_COLR                                     0x4D                                                  
#define CALL_GSM_SSC_CCBS                                     0x25                                                  
#define CALL_GSM_SSC_CNAP                                     0x012C                                                   
#define CALL_GSM_SSC_ECT                                      0x60                                                  
#define CALL_GSM_SSC_CD                                       0x42                                                  
#define CALL_GSM_SSC_ALL_UUS                                  0x0168                                                   
#define CALL_GSM_SSC_UUS1                                     0x0169                                                   
#define CALL_GSM_SSC_UUS2                                     0x016A                                                   
#define CALL_GSM_SSC_UUS3                                     0x016B                                                   
#define CALL_GSM_SSC_MSP1                                     0x024F                                                   
#define CALL_GSM_SSC_MSP2                                     0x0250                                                   
#define CALL_GSM_SSC_MSP3                                     0x0251                                                   
#define CALL_GSM_SSC_MSP4                                     0x0252                                                   
#define CALL_GSM_SSC_MPTY                                     0xFFFE                                                
#define CALL_GSM_SSC_CALL_HOLD                                0xFFFF                                                

//BitmaskTables for CALL_GSM_SS_STATUS
#define CALL_GSM_SS_STATUS_ACTIVE                             0x01                                                     
#define CALL_GSM_SS_STATUS_REGISTERED                         0x02                                                     
#define CALL_GSM_SS_STATUS_PROVISIONED                        0x04                                                     
#define CALL_GSM_SS_STATUS_QUIESCENT                          0x08                                                     

//BitmaskTables for CALL_GSM_SS_NOTIFICATION
#define CALL_GSM_SSN_INCOMING_IS_FWD                          0x01                                                     
#define CALL_GSM_SSN_INCOMING_FWD                             0x02                                                     
#define CALL_GSM_SSN_OUTGOING_FWD                             0x04                                                     

//BitmaskTables for CALL_GSM_SS_INDICATOR
#define CALL_GSM_SSI_CALL_IS_WAITING                          0x01                                                     
#define CALL_GSM_SSI_MPTY                                     0x02                                                     
#define CALL_GSM_SSI_CLIR_SUPPR_REJ                           0x04                                                     

//ConstantTable for CALL_GSM_SS_HOLD_INDICATOR
#define CALL_GSM_HOLD_IND_RETRIEVED                           0x00                                                     
#define CALL_GSM_HOLD_IND_ON_HOLD                             0x01                                                     

//ConstantTable for CALL_GSM_SS_ECT_INDICATOR
#define CALL_GSM_ECT_CALL_STATE_ALERT                         0x00                                                     
#define CALL_GSM_ECT_CALL_STATE_ACTIVE                        0x01                                                     

//ConstantTable for CALL_GSM_BLACKLIST_DURATION
#define CALL_GSM_BLACKLIST_TIMEOUT                            0x00                                                     
#define CALL_GSM_BLACKLIST_DURATION_5                         0x05                                                     
#define CALL_GSM_BLACKLIST_DURATION_60                        0x3C                                                  
#define CALL_GSM_BLACKLIST_DURATION_180                       0xB4                                                  

//ConstantTable for CALL_GSM_DATA_BAUD_RATE
#define CALL_GSM_BAUDRATE_2400                                0x04                                                     
#define CALL_GSM_BAUDRATE_4800                                0x08                                                     
#define CALL_GSM_BAUDRATE_9600                                0x10                                                  
#define CALL_GSM_BAUDRATE_14400                               0x40                                                  

//ConstantTable for CALL_GSM_TCH_VALUES
#define CALL_GSM_NORMAL_DATA_TCH_1                            0x00                                                     
#define CALL_GSM_MULTISLOT_DATA_TCH_1                         0x01                                                     
#define CALL_GSM_MULTISLOT_DATA_TCH_2                         0x02                                                     
#define CALL_GSM_MULTISLOT_DATA_TCH_3                         0x03                                                     

//ConstantTable for CALL_REPLACE_DESTINATION_ADDRESS
#define CALL_REPLACE_ADDRESS_FALSE                            0x00                                                     
#define CALL_REPLACE_ADDRESS_TRUE                             0x01                                                     

//ConstantTable for CALL_CCP_CHECK_RESULT
#define CALL_GSM_CCP_CHECK_RESULT_FAIL                        0x00                                                     
#define CALL_GSM_CCP_CHECK_RESULT_OK                          0x01                                                     

//ConstantTable for CALL_GSM_FNUR_VALUES
#define CALL_GSM_FNUR_9600                                    0x01                                                     
#define CALL_GSM_FNUR_14400                                   0x02                                                     
#define CALL_GSM_FNUR_19200                                   0x03                                                     
#define CALL_GSM_FNUR_28800                                   0x04                                                     
#define CALL_GSM_FNUR_38400                                   0x05                                                     
#define CALL_GSM_FNUR_48000                                   0x06                                                     
#define CALL_GSM_FNUR_56000                                   0x07                                                     
#define CALL_GSM_FNUR_64000                                   0x08                                                     
#define CALL_GSM_FNUR_33600                                   0x09                                                     
#define CALL_GSM_FNUR_32000                                   0x0A                                                     
#define CALL_GSM_FNUR_31200                                   0x0B                                                     

//ConstantTable for CALL_DTMF_PAUSE_VALUES
#define CALL_DTMF_PAUSE_1S                                    0x01                                                     
#define CALL_DTMF_PAUSE_2S                                    0x02                                                     
#define CALL_DTMF_PAUSE_3S                                    0x03                                                     

//ConstantTable for CALL_DTMF_INFO_VALUES
#define CALL_DTMF_ENABLE_TONE_IND_SEND                        0x01                                                     
#define CALL_DTMF_DISABLE_TONE_IND_SEND                       0x02                                                     

//ConstantTable for CALL_GSM_CAUSE_OF_NO_CLI_VALUES
#define CALL_GSM_CLI_UNAVAILABLE                              0x01                                                     
#define CALL_GSM_CLI_REJECT_BY_USER                           0x02                                                     
#define CALL_GSM_CLI_INTERACTION                              0x03                                                     
#define CALL_GSM_CLI_COIN_LINE_PAYPHONE                       0x04                                                     

//ConstantTable for CALL_GSM_MM_CAUSE_VALUES
#define CALL_GSM_MM_CAUSE_HLR_IMSI_UNKNOWN                    0x02                                                     
#define CALL_GSM_MM_CAUSE_ILLEGAL_MS                          0x03                                                     
#define CALL_GSM_MM_CAUSE_VLR_IMSI_UNKNOWN                    0x04                                                     
#define CALL_GSM_MM_CAUSE_IMEI_NOT_ACCEPTED                   0x05                                                     
#define CALL_GSM_MM_CAUSE_ILLEGAL_ME                          0x06                                                     
#define CALL_GSM_MM_CAUSE_PLMN_NOT_ALLOWED                    0x0B                                                     
#define CALL_GSM_MM_CAUSE_LA_NOT_ALLOWED                      0x0C                                                     
#define CALL_GSM_MM_CAUSE_ROAM_NOT_ALLOWED_LA                 0x0D                                                     
#define CALL_GSM_MM_CAUSE_NO_SUITABLE_CELLS_LA                0x0F                                                     
#define CALL_GSM_MM_CAUSE_NETWORK_FAILURE                     0x11                                                  
#define CALL_GSM_MM_CAUSE_MAC_FAILURE                         0x14                                                  
#define CALL_GSM_MM_CAUSE_SYNC_FAILURE                        0x15                                                  
#define CALL_GSM_MM_CAUSE_CONGESTION                          0x16                                                  
#define CALL_GSM_MM_CAUSE_AUTH_UNACCEPTABLE                   0x17                                                  
#define CALL_GSM_MM_CAUSE_NOT_SUPP_S_OPTION                   0x20                                                  
#define CALL_GSM_MM_CAUSE_NOT_SUBS_S_OPTION                   0x21                                                  
#define CALL_GSM_MM_CAUSE_OUT_OF_ORDER_S_OPTION               0x22                                                  
#define CALL_GSM_MM_CAUSE_CALL_NOT_IDENTIFIED                 0x26                                                  
#define CALL_GSM_MM_CAUSE_SEMANT_INCORRECT                    0x5F                                                  
#define CALL_GSM_MM_CAUSE_INV_MAND_INFORMATION                0x60                                                  
#define CALL_GSM_MM_CAUSE_NON_EXISTENT_MSG_TYPE               0x61                                                  
#define CALL_GSM_MM_CAUSE_NOT_COMP_MSG_TYPE                   0x62                                                  
#define CALL_GSM_MM_CAUSE_NOT_EXISTENT_IE                     0x63                                                  
#define CALL_GSM_MM_CAUSE_CONDITIONAL_IE_ERROR                0x64                                                  
#define CALL_GSM_MM_CAUSE_MSG_NOT_COMPATIBLE                  0x65                                                  
#define CALL_GSM_MM_CAUSE_PROTOCOL_ERROR                      0x6F                                                  

//ConstantTable for CALL_GSM_DISCONNECTION_TYPE
#define CALL_GSM_DISC_TYPE_NOT_APPLICAPLE                     0x00                                                     
#define CALL_GSM_DISC_TYPE_NEAR_END                           0x01                                                     
#define CALL_GSM_DISC_TYPE_FAR_END                            0x02                                                     

//ConstantTable for CALL_GSM_AIRIF_SS_OPERATIONS
#define CALL_GSM_AIF_SSO_NOTIFYSS                             0x10                                                  
#define CALL_GSM_AIF_SSO_CALL_DEFLECTION                      0x75                                                  
#define CALL_GSM_AIF_SSO_UUS                                  0x76                                                  
#define CALL_GSM_AIF_SSO_FORW_CUG_INFO                        0x78                                                  
#define CALL_GSM_AIF_SSO_SPLIT_MPTY                           0x79                                                  
#define CALL_GSM_AIF_SSO_RETR_MPTY                            0x7A                                                  
#define CALL_GSM_AIF_SSO_HOLD_MPTY                            0x7B                                                  
#define CALL_GSM_AIF_SSO_BUILD_MPTY                           0x7C                                                  
#define CALL_GSM_AIF_SSO_FORW_AOC                             0x7D                                                  
#define CALL_GSM_AIF_SSO_ECT                                  0x7E                                                  

//ConstantTable for CALL_GSM_AIRIF_SS_CODES
#define CALL_GSM_AIF_SSC_NOT_APPLICAPLE                       0xFF                                                  
#define CALL_GSM_AIF_SSC_ALL_SS                               0x00                                                     
#define CALL_GSM_AIF_SSC_ALL_FWDS                             0x20                                                  
#define CALL_GSM_AIF_SSC_ALL_COND_FWD                         0x28                                                  
#define CALL_GSM_AIF_SSC_CFU                                  0x21                                                  
#define CALL_GSM_AIF_SSC_CFB                                  0x29                                                  
#define CALL_GSM_AIF_SSC_CFNRY                                0x2A                                                  
#define CALL_GSM_AIF_SSC_CFGNC                                0x2B                                                  
#define CALL_GSM_AIF_SSC_ALL_BARRINGS                         0x90                                                  
#define CALL_GSM_AIF_SSC_BAOC                                 0x92                                                  
#define CALL_GSM_AIF_SSC_BOIC                                 0x93                                                  
#define CALL_GSM_AIF_SSC_BOIC_EXHC                            0x94                                                  
#define CALL_GSM_AIF_SSC_BAIC                                 0x9A                                                  
#define CALL_GSM_AIF_SSC_BAIC_ROAM                            0x9B                                                  
#define CALL_GSM_AIF_SSC_OUTGOING_BARR_SERV                   0x91                                                  
#define CALL_GSM_AIF_SSC_INCOMING_BARR_SERV                   0x99                                                  
#define CALL_GSM_AIF_SSC_CALL_WAITING                         0x41                                                  
#define CALL_GSM_AIF_SSC_CLIP                                 0x11                                                  
#define CALL_GSM_AIF_SSC_CLIR                                 0x12                                                  
#define CALL_GSM_AIF_SSC_COLP                                 0x13                                                  
#define CALL_GSM_AIF_SSC_COLR                                 0x14                                                  
#define CALL_GSM_AIF_SSC_CCBS                                 0x43                                                  
#define CALL_GSM_AIF_SSC_CNAP                                 0x19                                                  
#define CALL_GSM_AIF_SSC_ECT                                  0x31                                                  
#define CALL_GSM_AIF_SSC_CD                                   0x24                                                  
#define CALL_GSM_AIF_SSC_ALL_UUS                              0x80                                                  
#define CALL_GSM_AIF_SSC_UUS1                                 0x81                                                  
#define CALL_GSM_AIF_SSC_UUS2                                 0x82                                                  
#define CALL_GSM_AIF_SSC_UUS3                                 0x83                                                  
#define CALL_GSM_AIF_SSC_MPTY                                 0x51                                                  
#define CALL_GSM_AIF_SSC_CALL_HOLD                            0x42                                                  

//ConstantTable for CALL_ALS_LINES
#define CALL_ALS_LINE_ACTIVE                                  0x00                                                     
#define CALL_ALS_LINE_1                                       0x01                                                     
#define CALL_ALS_LINE_2                                       0x02                                                     

//ConstantTable for CALL_ALS_STATUS
#define CALL_ALS_STATUS_NOT_READY                             0x00                                                     
#define CALL_ALS_STATUS_DISABLED                              0x01                                                     
#define CALL_ALS_STATUS_ENABLED                               0x02                                                     

//ConstantTable for CALL_TIMER_IDS
#define CALL_LAST_TIMER                                       0x00                                                     
#define CALL_ACTIVE_TIMER                                     0x01                                                     
#define CALL_RECEIVED_TIMER                                   0x02                                                     
#define CALL_DIALLED_TIMER                                    0x03                                                     
#define CALL_ALL_TIMER                                        0x04                                                     
#define CALL_LIFE_TIMER                                       0x05                                                     
#define CALL_SINGLE_TIMER                                     0x06                                                     

//BitmaskTables for CALL_TIMERS
#define CALL_LAST_ACTIVE_TIMER_SEL                            0x01                                                     
#define CALL_RECEIVED_TIMER_SEL                               0x02                                                     
#define CALL_DIALLED_TIMER_SEL                                0x04                                                     
#define CALL_ALL_TIMER_SEL                                    0x08                                                     
#define CALL_LIFE_TIMER_SEL                                   0x10                                                  
#define CALL_SELECT_ALL_TIMERS_SEL                            0x1F                                                  
#define CALL_SELECT_SINGLE_TIMERS_SEL                         0x80                                                  

//ConstantTable for CALL_TIMER_NOTIFICATIONS
#define CALL_TIMER_NTF_NOT_APPLICABLE                         0x00                                                     
#define CALL_TIMER_NTF_DISABLE                                0x01                                                     
#define CALL_TIMER_NTF_ENABLE                                 0x02                                                     
#define CALL_TIMER_NTF_ALREADY_ORDERED                        0x03                                                     
#define CALL_TIMER_NTF_NOT_ORDERED                            0x04                                                     

//ConstantTable for CALL_AUTO_ST_CHANGE
#define CALL_AUTO_ST_CHANGE_DISABLE                           0x00                                                     
#define CALL_AUTO_ST_CHANGE_DISABLE_WAITING                   0x01                                                     

//BitmaskTables for CALL_REQ_ADDITIONAL_INFO
#define CALL_ADD_INFO_NONE                                    0x00                                                     
#define CALL_ADD_INFO_EMERG_CALL                              0x01                                                     

//BitmaskTables for CALL_EMERG_SERVICE_CATEGORY
#define CALL_SERVICE_CAT_NONE                                 0x00                                                     
#define CALL_SERVICE_CAT_POLICE                               0x01                                                     
#define CALL_SERVICE_CAT_AMBULANCE                            0x02                                                     
#define CALL_SERVICE_CAT_FIRE_BRIGADE                         0x04                                                     
#define CALL_SERVICE_CAT_MARINE_GUARD                         0x08                                                     
#define CALL_SERVICE_CAT_MOUNTAIN_RESCUE                      0x10                                                  

//ConstantTable for CALL_STATUS_MOD
#define CALL_STATUS_MODE_DEFAULT                              0x00                                                     
#define CALL_STATUS_MODE_ADDR                                 0x01                                                     
#define CALL_STATUS_MODE_ADDR_AND_ORIGIN                      0x02                                                     
#define CALL_STATUS_MODE_POC                                  0x03                                                     
#define CALL_STATUS_MODE_VOIP_ADDR                            0x04                                                     

//ConstantTable for CALL_USER_CONN
#define CALL_USER_CONN_CLOSED                                 0x00                                                     
#define CALL_USER_CONN_ATTACHED                               0x01                                                     

//BitmaskTables for CALL_EMERG_NBR_ORIGIN
#define CALL_EMERG_NBR_ORIG_HARD_CODED                        0x01                                                     
#define CALL_EMERG_NBR_ORIG_SIM                               0x02                                                     
#define CALL_EMERG_NBR_ORIG_NETWORK                           0x04                                                     
#define CALL_EMERG_NBR_ORIG_PERMANENT_MEM                     0x08                                                     

//BitmaskTables for CALL_EMERG_TYPE
#define CALL_EMERG_TYPE_NOT_VALID                             0x00                                                     
#define CALL_EMERG_TYPE_PRODUCT                               0x01                                                     
#define CALL_EMERG_TYPE_INTERNAL                              0x02                                                     

//ConstantTable for CALL_SERVICE_ACTIVATE_STATUS
#define CALL_SERVICE_ACTIVATE                                 0x01                                                     

//BitmaskTables for CALL_SYSTEM
#define CALL_SYSTEM_COMP                                      0x00                                                     
#define CALL_SYSTEM_CS                                        0x01                                                     
#define CALL_SYSTEM_VOIP                                      0x02                                                     
#define CALL_SYSTEM_ALL                                       0xFF                                                  

//BitmaskTables for CALL_SYSTEM_SEL
//#define CALL_SYSTEM_COMP                                    0x00                        //Already defined as 0x00
//#define CALL_SYSTEM_CS                                      0x00                        //Already defined as 0x01
//#define CALL_SYSTEM_VOIP                                    0x00                        //Already defined as 0x02

//BitmaskTables for CALL_SYSTEM_ADD_INFO
#define CALL_SYSTEM_INFO_DEFAULT                              0x00                                                     
#define CALL_SYSTEM_FORCE                                     0x01                                                     
#define CALL_SYSTEM_ORIGIN_CLIENT                             0x02                                                     

//BitmaskTables for CALL_URI_ADD_INFO
#define CALL_URI_DEFAULT                                      0x00                                                     
#define CALL_URI_FROM_PHONE_NUMBER                            0x01                                                     
#define CALL_URI_FORMAT_FULL                                  0x02                                                     
#define CALL_URI_FORMAT_STRIPPED                              0x04                                                     
#define CALL_URI_FORMAT_CLIENT                                0x08                                                     

//BitmaskTables for CALL_MEDIA_SEL
#define CALL_MEDIA_INFO_AUDIO                                 0x01                                                     
#define CALL_MEDIA_INFO_VIDEO                                 0x02                                                     

//ConstantTable for CALL_UL_OR_DL_HANDLE
#define CALL_HANDLE_DL                                        0x00                                                     
#define CALL_HANDLE_UL                                        0x01                                                     

//ConstantTable for CALL_SIM_ATK_STATUS
#define CALL_SIM_ATK_CONTINUE                                 0x00                                                     
#define CALL_SIM_ATK_REJECT                                   0x01                                                     

//ConstantTable for CALL_OPERATIONS
#define CALL_OPER_TRANSFER                                    0x01                                                     
#define CALL_OPER_FORWARDING                                  0x02                                                     

//ConstantTable for CALL_FORWARDING_SIDES
#define CALL_FORWARDING_CALL_ORIGINATOR                       0x01                                                     

//ConstantTable for CALL_TRANSFER_SIDES
#define CALL_TRANSFER_TRANSFEROR                              0x01                                                     
#define CALL_TRANSFER_TRANSFEREE                              0x02                                                     
#define CALL_TRANSFER_TRANSFER_TARGET                         0x03                                                     

//ConstantTable for CALL_TRANSFER_STATUSES
#define CALL_TRANSFER_INITIATED                               0x01                                                     
#define CALL_TRANSFER_COMPLETED                               0x02                                                     
#define CALL_TRANSFER_FAILED                                  0x03                                                     
#define CALL_TRANSFER_ON_HOLD                                 0x04                                                     
#define CALL_TRANSFER_TRANSFEREE_ACCEPTED                     0x05                                                     
#define CALL_TRANSFER_TARGET_RELEASE                          0x06                                                     
#define CALL_TRANSFER_TRANSFEREE_RELEASE                      0x07                                                     

//ConstantTable for CALL_TEST_CALL_STATUS
#define CALL_TEST_CALL_STATUS_IDLE                            0x00                                                     
#define CALL_TEST_CALL_STATUS_ACTIVE                          0x01                                                     

//ConstantTable for CALL_AUDIO_CONF_STATUS
#define CALL_AUDIO_CONF_DENIED                                0x01                                                     
#define CALL_AUDIO_CONF_ALLOWED                               0x02                                                     

//ConstantTable for CALL_SECURITY_STATUS
#define CALL_SECURE_NOT_APPLICAPLE                            0x00                                                     
#define CALL_NON_SECURE                                       0x01                                                     
#define CALL_SECURE                                           0x02                                                     

//ConstantTable for CALL_MODE_CHANGE
#define CALL_MODE_SPEECH_TO_VIDEO                             0x01                                                     
#define CALL_MODE_DATA_TO_VIDEO                               0x02                                                     
#define CALL_MODE_VIDEO_TO_SPEECH                             0x03                                                     
#define CALL_MODE_VIDEO_TO_DATA                               0x04                                                     

//BitmaskTables for CALL_ADD_PARAMS_SEL
#define CALL_ADD_PARAMS_DEFAULT                               0x00                                                     
#define CALL_ADD_PARAMS_VIDEO_SHARING                         0x01                                                     

//ConstantTable for CALL_DSAC_RESTRICTION
#define CALL_DSAC_RESTRICTION_CS                              0x01                                                     


//SUBBLOCKS


//Definition for struct CALL_ORIGIN_ADDRESS
#define CALL_ORIGIN_ADDRESS                                   0x01                                                     
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      addr_type;
             uint8_t      presentation;
             uint8_t      fillerbyte1;
             uint8_t      addr_len;
             uint16_t     addr[0];
            } __attribute__((packed)) CALL_ORIGIN_ADDRESS_STR;
#define SIZE_CALL_ORIGIN_ADDRESS                              sizeof(CALL_ORIGIN_ADDRESS_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct CALL_ORIGIN_SUBADDRESS
#define CALL_ORIGIN_SUBADDRESS                                0x02                                                     
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      addr_len;
             uint8_t      addr[0];
            } __attribute__((packed)) CALL_ORIGIN_SUBADDRESS_STR;
#define SIZE_CALL_ORIGIN_SUBADDRESS                           sizeof(CALL_ORIGIN_SUBADDRESS_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct CALL_DESTINATION_ADDRESS
#define CALL_DESTINATION_ADDRESS                              0x03                                                     
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      addr_type;
             uint8_t      presentation;
             uint8_t      fillerbyte1;
             uint8_t      addr_len;
             uint16_t     addr[0];
            } __attribute__((packed)) CALL_DESTINATION_ADDRESS_STR;
#define SIZE_CALL_DESTINATION_ADDRESS                         sizeof(CALL_DESTINATION_ADDRESS_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct CALL_DESTINATION_SUBADDRESS
#define CALL_DESTINATION_SUBADDRESS                           0x04                                                     
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      addr_len;
             uint8_t      addr[0];
            } __attribute__((packed)) CALL_DESTINATION_SUBADDRESS_STR;
#define SIZE_CALL_DESTINATION_SUBADDRESS                      sizeof(CALL_DESTINATION_SUBADDRESS_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct CALL_DESTINATION_PRE_ADDRESS
#define CALL_DESTINATION_PRE_ADDRESS                          0x05                                                     
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      addr_info;
             uint8_t      addr_len;
             uint16_t     addr[0];
            } __attribute__((packed)) CALL_DESTINATION_PRE_ADDRESS_STR;
#define SIZE_CALL_DESTINATION_PRE_ADDRESS                     sizeof(CALL_DESTINATION_PRE_ADDRESS_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct CALL_DESTINATION_POST_ADDRESS
#define CALL_DESTINATION_POST_ADDRESS                         0x06                                                     
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      addr_info;
             uint8_t      addr_len;
             uint16_t     addr[0];
            } __attribute__((packed)) CALL_DESTINATION_POST_ADDRESS_STR;
#define SIZE_CALL_DESTINATION_POST_ADDRESS                    sizeof(CALL_DESTINATION_POST_ADDRESS_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct CALL_MODE
#define CALL_MODE                                             0x07                                                     
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      mode;
             uint8_t      mode_info;
            } __attribute__((packed)) CALL_MODE_STR;
#define SIZE_CALL_MODE                                        sizeof(CALL_MODE_STR)


//Definition for struct CALL_CAUSE
#define CALL_CAUSE                                            0x08                                                     
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      cause_type;
             uint8_t      cause;
            } __attribute__((packed)) CALL_CAUSE_STR;
#define SIZE_CALL_CAUSE                                       sizeof(CALL_CAUSE_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct CALL_OPERATION
#define CALL_OPERATION                                        0x09                                                     
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      operation;
             uint8_t      operation_info;
            } __attribute__((packed)) CALL_OPERATION_STR;
#define SIZE_CALL_OPERATION                                   sizeof(CALL_OPERATION_STR)


//Definition for struct CALL_STATUS
#define CALL_STATUS                                           0x0A                                                     
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      status;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) CALL_STATUS_STR;
#define SIZE_CALL_STATUS                                      sizeof(CALL_STATUS_STR)


//Definition for struct CALL_STATUS_INFO
#define CALL_STATUS_INFO                                      0x0B                                                     
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      call_id;
             uint8_t      mode;
             uint8_t      mode_info;
             uint8_t      status;
             uint8_t      system;
             uint8_t      security_status;
            } __attribute__((packed)) CALL_STATUS_INFO_STR;
#define SIZE_CALL_STATUS_INFO                                 sizeof(CALL_STATUS_INFO_STR)


//Definition for struct CALL_ALERTING_INFO
#define CALL_ALERTING_INFO                                    0x0C                                                     
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      alerting_info;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) CALL_ALERTING_INFO_STR;
#define SIZE_CALL_ALERTING_INFO                               sizeof(CALL_ALERTING_INFO_STR)


//Definition for struct CALL_RELEASE_INFO
#define CALL_RELEASE_INFO                                     0x0D                                                     
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      release_info;
             uint8_t      allowed_acts;
            } __attribute__((packed)) CALL_RELEASE_INFO_STR;
#define SIZE_CALL_RELEASE_INFO                                sizeof(CALL_RELEASE_INFO_STR)


//Definition for struct CALL_ORIGIN_INFO
#define CALL_ORIGIN_INFO                                      0x0E                                                     
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      presentation;
             uint8_t      nbr_source;
             uint8_t      nbr_type;
             uint8_t      nbr_group;
             uint8_t      link_id;
             uint8_t      name_len;
             uint16_t     name[0];
            } __attribute__((packed)) CALL_ORIGIN_INFO_STR;
#define SIZE_CALL_ORIGIN_INFO                                 sizeof(CALL_ORIGIN_INFO_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct CALL_DTMF_DIGIT
#define CALL_DTMF_DIGIT                                       0x0F                                                     
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             int16_t      data;
            } __attribute__((packed)) CALL_DTMF_DIGIT_STR;
#define SIZE_CALL_DTMF_DIGIT                                  sizeof(CALL_DTMF_DIGIT_STR)


//Definition for struct CALL_DTMF_STRING
#define CALL_DTMF_STRING                                      0x10                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      pause_length;
             uint8_t      data_len;
             uint16_t     data[0];
            } __attribute__((packed)) CALL_DTMF_STRING_STR;
#define SIZE_CALL_DTMF_STRING                                 sizeof(CALL_DTMF_STRING_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct CALL_DTMF_BCD_STRING
#define CALL_DTMF_BCD_STRING                                  0x19                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      pause_length;
             uint8_t      fillerbyte1;
             uint16_t     data_len;
             uint16_t     data[0];
            } __attribute__((packed)) CALL_DTMF_BCD_STRING_STR;
#define SIZE_CALL_DTMF_BCD_STRING                             sizeof(CALL_DTMF_BCD_STRING_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct CALL_DTMF_INFO
#define CALL_DTMF_INFO                                        0x1A                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      dtmf_info;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) CALL_DTMF_INFO_STR;
#define SIZE_CALL_DTMF_INFO                                   sizeof(CALL_DTMF_INFO_STR)


//Definition for struct CALL_PROPERTY_INFO
#define CALL_PROPERTY_INFO                                    0x13                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      property;
             uint8_t      property_value;
            } __attribute__((packed)) CALL_PROPERTY_INFO_STR;
#define SIZE_CALL_PROPERTY_INFO                               sizeof(CALL_PROPERTY_INFO_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct CALL_EMERGENCY_NUMBER
#define CALL_EMERGENCY_NUMBER                                 0x14                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      origin;
             uint8_t      permanent_mem_info;
             uint8_t      fillerbyte1;
             uint8_t      link_id;
             uint8_t      addr_type;
             uint8_t      addr_len;
             uint16_t     addr[0];
            } __attribute__((packed)) CALL_EMERGENCY_NUMBER_STR;
#define SIZE_CALL_EMERGENCY_NUMBER                            sizeof(CALL_EMERGENCY_NUMBER_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct CALL_DTMF_STATUS
#define CALL_DTMF_STATUS                                      0x11                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      status;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) CALL_DTMF_STATUS_STR;
#define SIZE_CALL_DTMF_STATUS                                 sizeof(CALL_DTMF_STATUS_STR)


//Definition for struct CALL_DTMF_TONE
#define CALL_DTMF_TONE                                        0x12                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             int16_t      tone;
            } __attribute__((packed)) CALL_DTMF_TONE_STR;
#define SIZE_CALL_DTMF_TONE                                   sizeof(CALL_DTMF_TONE_STR)


//Definition for struct CALL_GSM_CUG_INFO
#define CALL_GSM_CUG_INFO                                     0xA0                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      pref_cug;
             uint8_t      cug_oa;
             int16_t      cug_ind;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) CALL_GSM_CUG_INFO_STR;
#define SIZE_CALL_GSM_CUG_INFO                                sizeof(CALL_GSM_CUG_INFO_STR)


//Definition for struct CALL_GSM_ALERTING_PATTERN
#define CALL_GSM_ALERTING_PATTERN                             0xA1                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      alerting_pattern;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) CALL_GSM_ALERTING_PATTERN_STR;
#define SIZE_CALL_GSM_ALERTING_PATTERN                        sizeof(CALL_GSM_ALERTING_PATTERN_STR)


//Definition for struct CALL_GSM_DEFLECTION_ADDRESS
#define CALL_GSM_DEFLECTION_ADDRESS                           0xA2                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      addr_type;
             uint8_t      presentation;
             uint8_t      fillerbyte1;
             uint8_t      addr_len;
             uint16_t     addr[0];
            } __attribute__((packed)) CALL_GSM_DEFLECTION_ADDRESS_STR;
#define SIZE_CALL_GSM_DEFLECTION_ADDRESS                      sizeof(CALL_GSM_DEFLECTION_ADDRESS_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct CALL_GSM_DEFLECTION_SUBADDRESS
#define CALL_GSM_DEFLECTION_SUBADDRESS                        0xA3                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      addr_len;
             uint8_t      addr[0];
            } __attribute__((packed)) CALL_GSM_DEFLECTION_SUBADDRESS_STR;
#define SIZE_CALL_GSM_DEFLECTION_SUBADDRESS                   sizeof(CALL_GSM_DEFLECTION_SUBADDRESS_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct CALL_GSM_REDIRECTING_ADDRESS
#define CALL_GSM_REDIRECTING_ADDRESS                          0xA4                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      addr_type;
             uint8_t      presentation;
             uint8_t      fillerbyte1;
             uint8_t      addr_len;
             uint16_t     addr[0];
            } __attribute__((packed)) CALL_GSM_REDIRECTING_ADDRESS_STR;
#define SIZE_CALL_GSM_REDIRECTING_ADDRESS                     sizeof(CALL_GSM_REDIRECTING_ADDRESS_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct CALL_GSM_REDIRECTING_SUBADDRESS
#define CALL_GSM_REDIRECTING_SUBADDRESS                       0xA5                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      addr_len;
             uint8_t      addr[0];
            } __attribute__((packed)) CALL_GSM_REDIRECTING_SUBADDRESS_STR;
#define SIZE_CALL_GSM_REDIRECTING_SUBADDRESS                  sizeof(CALL_GSM_REDIRECTING_SUBADDRESS_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct CALL_GSM_REMOTE_ADDRESS
#define CALL_GSM_REMOTE_ADDRESS                               0xA6                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      addr_type;
             uint8_t      presentation;
             uint8_t      fillerbyte1;
             uint8_t      addr_len;
             uint16_t     addr[0];
            } __attribute__((packed)) CALL_GSM_REMOTE_ADDRESS_STR;
#define SIZE_CALL_GSM_REMOTE_ADDRESS                          sizeof(CALL_GSM_REMOTE_ADDRESS_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct CALL_GSM_REMOTE_SUBADDRESS
#define CALL_GSM_REMOTE_SUBADDRESS                            0xA7                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      addr_len;
             uint8_t      addr[0];
            } __attribute__((packed)) CALL_GSM_REMOTE_SUBADDRESS_STR;
#define SIZE_CALL_GSM_REMOTE_SUBADDRESS                       sizeof(CALL_GSM_REMOTE_SUBADDRESS_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct CALL_GSM_USER_TO_USER_INFO
#define CALL_GSM_USER_TO_USER_INFO                            0xA8                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint16_t     utou_len;
             uint8_t      utou[0];
            } __attribute__((packed)) CALL_GSM_USER_TO_USER_INFO_STR;
#define SIZE_CALL_GSM_USER_TO_USER_INFO                       sizeof(CALL_GSM_USER_TO_USER_INFO_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct CALL_GSM_DIAGNOSTICS
#define CALL_GSM_DIAGNOSTICS                                  0xA9                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      condition;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) CALL_GSM_DIAGNOSTICS_STR;
#define SIZE_CALL_GSM_DIAGNOSTICS                             sizeof(CALL_GSM_DIAGNOSTICS_STR)


//Definition for struct CALL_GSM_SS_DIAGNOSTICS
#define CALL_GSM_SS_DIAGNOSTICS                               0xAA                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      diagnostics;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) CALL_GSM_SS_DIAGNOSTICS_STR;
#define SIZE_CALL_GSM_SS_DIAGNOSTICS                          sizeof(CALL_GSM_SS_DIAGNOSTICS_STR)


//Definition for struct CALL_GSM_NEW_DESTINATION
#define CALL_GSM_NEW_DESTINATION                              0xAB                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      addr_type;
             uint8_t      presentation;
             uint8_t      fillerbyte1;
             uint8_t      addr_len;
             uint16_t     addr[0];
            } __attribute__((packed)) CALL_GSM_NEW_DESTINATION_STR;
#define SIZE_CALL_GSM_NEW_DESTINATION                         sizeof(CALL_GSM_NEW_DESTINATION_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct CALL_GSM_CCBS_INFO
#define CALL_GSM_CCBS_INFO                                    0xAC                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      index;
             uint8_t      mmi_serv_code;
            } __attribute__((packed)) CALL_GSM_CCBS_INFO_STR;
#define SIZE_CALL_GSM_CCBS_INFO                               sizeof(CALL_GSM_CCBS_INFO_STR)


//Definition for struct CALL_GSM_ADDRESS_OF_B
#define CALL_GSM_ADDRESS_OF_B                                 0xAD                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      addr_type;
             uint8_t      presentation;
             uint8_t      fillerbyte1;
             uint8_t      addr_len;
             uint16_t     addr[0];
            } __attribute__((packed)) CALL_GSM_ADDRESS_OF_B_STR;
#define SIZE_CALL_GSM_ADDRESS_OF_B                            sizeof(CALL_GSM_ADDRESS_OF_B_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct CALL_GSM_SUBADDRESS_OF_B
#define CALL_GSM_SUBADDRESS_OF_B                              0xB0                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      addr_len;
             uint8_t      addr[0];
            } __attribute__((packed)) CALL_GSM_SUBADDRESS_OF_B_STR;
#define SIZE_CALL_GSM_SUBADDRESS_OF_B                         sizeof(CALL_GSM_SUBADDRESS_OF_B_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct CALL_GSM_NOTIFY
#define CALL_GSM_NOTIFY                                       0xB1                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      notification;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) CALL_GSM_NOTIFY_STR;
#define SIZE_CALL_GSM_NOTIFY                                  sizeof(CALL_GSM_NOTIFY_STR)


//Definition for struct CALL_GSM_SS_NOTIFY
#define CALL_GSM_SS_NOTIFY                                    0xB2                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      ss_notification;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) CALL_GSM_SS_NOTIFY_STR;
#define SIZE_CALL_GSM_SS_NOTIFY                               sizeof(CALL_GSM_SS_NOTIFY_STR)


//Definition for struct CALL_GSM_SS_CODE
#define CALL_GSM_SS_CODE                                      0xB3                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint16_t     mmi_ss_code;
            } __attribute__((packed)) CALL_GSM_SS_CODE_STR;
#define SIZE_CALL_GSM_SS_CODE                                 sizeof(CALL_GSM_SS_CODE_STR)


//Definition for struct CALL_GSM_SS_STATUS
#define CALL_GSM_SS_STATUS                                    0xB4                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      ss_status;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) CALL_GSM_SS_STATUS_STR;
#define SIZE_CALL_GSM_SS_STATUS                               sizeof(CALL_GSM_SS_STATUS_STR)


//Definition for struct CALL_GSM_SS_NOTIFY_INDICATOR
#define CALL_GSM_SS_NOTIFY_INDICATOR                          0xB5                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      ss_indicator;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) CALL_GSM_SS_NOTIFY_INDICATOR_STR;
#define SIZE_CALL_GSM_SS_NOTIFY_INDICATOR                     sizeof(CALL_GSM_SS_NOTIFY_INDICATOR_STR)


//Definition for struct CALL_GSM_SS_HOLD_INDICATOR
#define CALL_GSM_SS_HOLD_INDICATOR                            0xB6                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      ss_hold_indicator;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) CALL_GSM_SS_HOLD_INDICATOR_STR;
#define SIZE_CALL_GSM_SS_HOLD_INDICATOR                       sizeof(CALL_GSM_SS_HOLD_INDICATOR_STR)


//Definition for struct CALL_GSM_SS_ECT_INDICATOR
#define CALL_GSM_SS_ECT_INDICATOR                             0xB7                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      ss_ect_indicator;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) CALL_GSM_SS_ECT_INDICATOR_STR;
#define SIZE_CALL_GSM_SS_ECT_INDICATOR                        sizeof(CALL_GSM_SS_ECT_INDICATOR_STR)


//Definition for struct CALL_GSM_DATA_CH_INFO
#define CALL_GSM_DATA_CH_INFO                                 0xB8                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      baudrate;
             uint8_t      tch_down;
             uint8_t      tch_up;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
            } __attribute__((packed)) CALL_GSM_DATA_CH_INFO_STR;
#define SIZE_CALL_GSM_DATA_CH_INFO                            sizeof(CALL_GSM_DATA_CH_INFO_STR)


//Definition for struct CALL_DESTINATION_CS_ADDRESS
#define CALL_DESTINATION_CS_ADDRESS                           0x16                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      replace;
             uint8_t      presentation;
             uint8_t      fillerbyte1;
             uint8_t      addr_len;
             uint8_t      addr[0];
            } __attribute__((packed)) CALL_DESTINATION_CS_ADDRESS_STR;
#define SIZE_CALL_DESTINATION_CS_ADDRESS                      sizeof(CALL_DESTINATION_CS_ADDRESS_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct CALL_GSM_CCP
#define CALL_GSM_CCP                                          0xBA                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      bc_length;
             uint8_t      bc_data[0];
            } __attribute__((packed)) CALL_GSM_CCP_STR;
#define SIZE_CALL_GSM_CCP                                     sizeof(CALL_GSM_CCP_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct CALL_GSM_RAB_INFO
#define CALL_GSM_RAB_INFO                                     0xB9                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      rab_id;
             uint8_t      num_of_rbs;
             uint8_t      rb[0];
            } __attribute__((packed)) CALL_GSM_RAB_INFO_STR;
#define SIZE_CALL_GSM_RAB_INFO                                sizeof(CALL_GSM_RAB_INFO_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct CALL_GSM_FNUR_INFO
#define CALL_GSM_FNUR_INFO                                    0xBB                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      fnur;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) CALL_GSM_FNUR_INFO_STR;
#define SIZE_CALL_GSM_FNUR_INFO                               sizeof(CALL_GSM_FNUR_INFO_STR)


//Definition for struct CALL_GSM_CAUSE_OF_NO_CLI
#define CALL_GSM_CAUSE_OF_NO_CLI                              0xBC                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      cause;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) CALL_GSM_CAUSE_OF_NO_CLI_STR;
#define SIZE_CALL_GSM_CAUSE_OF_NO_CLI                         sizeof(CALL_GSM_CAUSE_OF_NO_CLI_STR)


//Definition for struct CALL_GSM_MM_CAUSE
#define CALL_GSM_MM_CAUSE                                     0xBD                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      cause;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) CALL_GSM_MM_CAUSE_STR;
#define SIZE_CALL_GSM_MM_CAUSE                                sizeof(CALL_GSM_MM_CAUSE_STR)


//Definition for struct CALL_GSM_EVENT_INFO
#define CALL_GSM_EVENT_INFO                                   0xBE                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      transaction_id;
             uint8_t      disc_type;
            } __attribute__((packed)) CALL_GSM_EVENT_INFO_STR;
#define SIZE_CALL_GSM_EVENT_INFO                              sizeof(CALL_GSM_EVENT_INFO_STR)


//Definition for struct CALL_GSM_DETAILED_CAUSE
#define CALL_GSM_DETAILED_CAUSE                               0xBF                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      cause_len;
             uint8_t      cause[0];
            } __attribute__((packed)) CALL_GSM_DETAILED_CAUSE_STR;
#define SIZE_CALL_GSM_DETAILED_CAUSE                          sizeof(CALL_GSM_DETAILED_CAUSE_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct CALL_GSM_SS_DATA
#define CALL_GSM_SS_DATA                                      0xC0                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      ss_data_len;
             uint8_t      ss_data[0];
            } __attribute__((packed)) CALL_GSM_SS_DATA_STR;
#define SIZE_CALL_GSM_SS_DATA                                 sizeof(CALL_GSM_SS_DATA_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct CALL_TIMER
#define CALL_TIMER                                            0x17                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      timer_id;
             uint8_t      fillerbyte1;
             uint32_t     time_value;
            } __attribute__((packed)) CALL_TIMER_STR;
#define SIZE_CALL_TIMER                                       sizeof(CALL_TIMER_STR)


//Definition for struct CALL_GSM_ALS_INFO
#define CALL_GSM_ALS_INFO                                     0xC1                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      als_sim_status;
             uint8_t      als_pp_status;
            } __attribute__((packed)) CALL_GSM_ALS_INFO_STR;
#define SIZE_CALL_GSM_ALS_INFO                                sizeof(CALL_GSM_ALS_INFO_STR)


//Definition for struct CALL_STATE_AUTO_CHANGE
#define CALL_STATE_AUTO_CHANGE                                0x18                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      state_auto_change;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) CALL_STATE_AUTO_CHANGE_STR;
#define SIZE_CALL_STATE_AUTO_CHANGE                           sizeof(CALL_STATE_AUTO_CHANGE_STR)


//Definition for struct CALL_EMERGENCY_NUMBER_INFO
#define CALL_EMERGENCY_NUMBER_INFO                            0x1B                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      link_id;
             uint8_t      serv_category;
             uint8_t      fillerbyte1;
             uint8_t      alpha_id_len;
             uint16_t     alpha_id[0];
            } __attribute__((packed)) CALL_EMERGENCY_NUMBER_INFO_STR;
#define SIZE_CALL_EMERGENCY_NUMBER_INFO                       sizeof(CALL_EMERGENCY_NUMBER_INFO_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct CALL_STATUS_MODE
#define CALL_STATUS_MODE                                      0x1C                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      mode;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) CALL_STATUS_MODE_STR;
#define SIZE_CALL_STATUS_MODE                                 sizeof(CALL_STATUS_MODE_STR)


//Definition for struct CALL_ADDR_AND_STATUS_INFO
#define CALL_ADDR_AND_STATUS_INFO                             0x1D                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      call_id;
             uint8_t      mode;
             uint8_t      mode_info;
             uint8_t      status;
             uint8_t      system;
             uint8_t      link_id;
             uint8_t      addr_type;
             uint8_t      presentation;
             uint8_t      security_status;
             uint8_t      addr_len;
             uint16_t     addr[0];
            } __attribute__((packed)) CALL_ADDR_AND_STATUS_INFO_STR;
#define SIZE_CALL_ADDR_AND_STATUS_INFO                        sizeof(CALL_ADDR_AND_STATUS_INFO_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct CALL_DTMF_TIMERS
#define CALL_DTMF_TIMERS                                      0x1E                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint16_t     dtmf_dur;
             uint16_t     dtmf_gap;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) CALL_DTMF_TIMERS_STR;
#define SIZE_CALL_DTMF_TIMERS                                 sizeof(CALL_DTMF_TIMERS_STR)


//Definition for struct CALL_NAS_SYNC_INDICATOR
#define CALL_NAS_SYNC_INDICATOR                               0x1F                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      coid;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) CALL_NAS_SYNC_INDICATOR_STR;
#define SIZE_CALL_NAS_SYNC_INDICATOR                          sizeof(CALL_NAS_SYNC_INDICATOR_STR)


//Definition for struct CALL_NW_CAUSE
#define CALL_NW_CAUSE                                         0x20                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      cause_type;
             uint8_t      cause;
            } __attribute__((packed)) CALL_NW_CAUSE_STR;
#define SIZE_CALL_NW_CAUSE                                    sizeof(CALL_NW_CAUSE_STR)


//Definition for struct CALL_TRACFONE_RESULT
#define CALL_TRACFONE_RESULT                                  0x21                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      result;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) CALL_TRACFONE_RESULT_STR;
#define SIZE_CALL_TRACFONE_RESULT                             sizeof(CALL_TRACFONE_RESULT_STR)


//Definition for struct CALL_KODIAK_POC
#define CALL_KODIAK_POC                                       0x22                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      call_type;
             uint8_t      link_id;
            } __attribute__((packed)) CALL_KODIAK_POC_STR;
#define SIZE_CALL_KODIAK_POC                                  sizeof(CALL_KODIAK_POC_STR)


//Definition for struct CALL_DISPLAY_NUMBER
#define CALL_DISPLAY_NUMBER                                   0x23                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      addr_type;
             uint8_t      presentation;
             uint8_t      fillerbyte1;
             uint8_t      addr_len;
             uint16_t     addr[0];
            } __attribute__((packed)) CALL_DISPLAY_NUMBER_STR;
#define SIZE_CALL_DISPLAY_NUMBER                              sizeof(CALL_DISPLAY_NUMBER_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct CALL_DESTINATION_URI
#define CALL_DESTINATION_URI                                  0x24                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      add_info;
             uint8_t      addr_len;
             uint16_t     addr[0];
            } __attribute__((packed)) CALL_DESTINATION_URI_STR;
#define SIZE_CALL_DESTINATION_URI                             sizeof(CALL_DESTINATION_URI_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct CALL_ORIGIN_URI
#define CALL_ORIGIN_URI                                       0x25                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      add_info;
             uint8_t      addr_len;
             uint16_t     addr[0];
            } __attribute__((packed)) CALL_ORIGIN_URI_STR;
#define SIZE_CALL_ORIGIN_URI                                  sizeof(CALL_ORIGIN_URI_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct CALL_URI
#define CALL_URI                                              0x26                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      link_id;
             uint8_t      add_info;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
             uint8_t      addr_len;
             uint16_t     addr[0];
            } __attribute__((packed)) CALL_URI_STR;
#define SIZE_CALL_URI                                         sizeof(CALL_URI_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct CALL_SYSTEM_INFO
#define CALL_SYSTEM_INFO                                      0x27                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      system;
             uint8_t      add_info;
            } __attribute__((packed)) CALL_SYSTEM_INFO_STR;
#define SIZE_CALL_SYSTEM_INFO                                 sizeof(CALL_SYSTEM_INFO_STR)


//Definition for struct CALL_SYSTEMS
#define CALL_SYSTEMS                                          0x28                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      system;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) CALL_SYSTEMS_STR;
#define SIZE_CALL_SYSTEMS                                     sizeof(CALL_SYSTEMS_STR)


//Definition for struct CALL_VOIP_TIMER
#define CALL_VOIP_TIMER                                       0x29                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      timer_id;
             uint8_t      fillerbyte1;
             uint32_t     time_value;
            } __attribute__((packed)) CALL_VOIP_TIMER_STR;
#define SIZE_CALL_VOIP_TIMER                                  sizeof(CALL_VOIP_TIMER_STR)


//Definition for struct CALL_REDIRECTING_URI
#define CALL_REDIRECTING_URI                                  0x2A                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      add_info;
             uint8_t      addr_len;
             uint16_t     addr[0];
            } __attribute__((packed)) CALL_REDIRECTING_URI_STR;
#define SIZE_CALL_REDIRECTING_URI                             sizeof(CALL_REDIRECTING_URI_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct CALL_REMOTE_URI
#define CALL_REMOTE_URI                                       0x2B                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      add_info;
             uint8_t      addr_len;
             uint16_t     addr[0];
            } __attribute__((packed)) CALL_REMOTE_URI_STR;
#define SIZE_CALL_REMOTE_URI                                  sizeof(CALL_REMOTE_URI_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct CALL_DEFLECTION_URI
#define CALL_DEFLECTION_URI                                   0x2C                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      add_info;
             uint8_t      addr_len;
             uint16_t     addr[0];
            } __attribute__((packed)) CALL_DEFLECTION_URI_STR;
#define SIZE_CALL_DEFLECTION_URI                              sizeof(CALL_DEFLECTION_URI_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct CALL_TRANSFER_INFO
#define CALL_TRANSFER_INFO                                    0x2D                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      side;
             uint8_t      status;
            } __attribute__((packed)) CALL_TRANSFER_INFO_STR;
#define SIZE_CALL_TRANSFER_INFO                               sizeof(CALL_TRANSFER_INFO_STR)


//Definition for struct CALL_FORWARDING_INFO
#define CALL_FORWARDING_INFO                                  0x2E                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      side;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) CALL_FORWARDING_INFO_STR;
#define SIZE_CALL_FORWARDING_INFO                             sizeof(CALL_FORWARDING_INFO_STR)


//Definition for struct CALL_ID_INFO
#define CALL_ID_INFO                                          0x2F                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      call_id;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) CALL_ID_INFO_STR;
#define SIZE_CALL_ID_INFO                                     sizeof(CALL_ID_INFO_STR)


//Definition for struct CALL_TEST_CALL
#define CALL_TEST_CALL                                        0x30                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      test_call_status;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) CALL_TEST_CALL_STR;
#define SIZE_CALL_TEST_CALL                                   sizeof(CALL_TEST_CALL_STR)


//Definition for struct CALL_AUDIO_CONF_INFO
#define CALL_AUDIO_CONF_INFO                                  0x31                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      audio_conf_info;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) CALL_AUDIO_CONF_INFO_STR;
#define SIZE_CALL_AUDIO_CONF_INFO                             sizeof(CALL_AUDIO_CONF_INFO_STR)


//Definition for struct CALL_SECURITY_INFO
#define CALL_SECURITY_INFO                                    0x33                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      security_status;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) CALL_SECURITY_INFO_STR;
#define SIZE_CALL_SECURITY_INFO                               sizeof(CALL_SECURITY_INFO_STR)


//Definition for struct CALL_SINGLE_TIMERS
#define CALL_SINGLE_TIMERS                                    0x32                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint32_t     time_value_call_1_id;
             uint32_t     time_value_call_2_id;
             uint32_t     time_value_call_3_id;
             uint32_t     time_value_call_4_id;
             uint32_t     time_value_call_5_id;
             uint32_t     time_value_call_6_id;
             uint32_t     time_value_call_7_id;
             uint32_t     time_value_conf;
            } __attribute__((packed)) CALL_SINGLE_TIMERS_STR;
#define SIZE_CALL_SINGLE_TIMERS                               sizeof(CALL_SINGLE_TIMERS_STR)


//Definition for struct CALL_MEDIA_INFO
#define CALL_MEDIA_INFO                                       0x35                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      media;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) CALL_MEDIA_INFO_STR;
#define SIZE_CALL_MEDIA_INFO                                  sizeof(CALL_MEDIA_INFO_STR)


//Definition for struct CALL_MEDIA_HANDLE
#define CALL_MEDIA_HANDLE                                     0x34                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint16_t     master_avpo_handle;
             uint32_t     control_avpo_id;
            } __attribute__((packed)) CALL_MEDIA_HANDLE_STR;
#define SIZE_CALL_MEDIA_HANDLE                                sizeof(CALL_MEDIA_HANDLE_STR)


//Definition for struct CALL_MODE_CHANGE_INFO
#define CALL_MODE_CHANGE_INFO                                 0x36                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      mode_change;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) CALL_MODE_CHANGE_INFO_STR;
#define SIZE_CALL_MODE_CHANGE_INFO                            sizeof(CALL_MODE_CHANGE_INFO_STR)


//Definition for struct CALL_ADDITIONAL_PARAMS
#define CALL_ADDITIONAL_PARAMS                                0x37                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      add_params;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) CALL_ADDITIONAL_PARAMS_STR;
#define SIZE_CALL_ADDITIONAL_PARAMS                           sizeof(CALL_ADDITIONAL_PARAMS_STR)


//Definition for struct CALL_DSAC_INFO
#define CALL_DSAC_INFO                                        0x38                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      dsac_restr;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) CALL_DSAC_INFO_STR;
#define SIZE_CALL_DSAC_INFO                                   sizeof(CALL_DSAC_INFO_STR)


//MESSAGES


//Definition for struct CALL_CREATE_REQ
#define CALL_CREATE_REQ                                       0x01                                                     
typedef struct
            { 
             uint8_t      tr_id;
             uint8_t      message_id;
             uint8_t      call_id;
             uint8_t      sub_blocks;
             CALL_MODE_STR    mode[0];
            } __attribute__((packed)) CALL_CREATE_REQ_STR;
#define SIZE_CALL_CREATE_REQ                                  sizeof(CALL_CREATE_REQ_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct CALL_CREATE_RESP
#define CALL_CREATE_RESP                                      0x02                                                     
typedef struct
            { 
             uint8_t      tr_id;
             uint8_t      message_id;
             uint8_t      call_id;
             uint8_t      sub_blocks;
            } __attribute__((packed)) CALL_CREATE_RESP_STR;
#define SIZE_CALL_CREATE_RESP                                 sizeof(CALL_CREATE_RESP_STR)


//Definition for struct CALL_COMING_IND
#define CALL_COMING_IND                                       0x03                                                     
typedef struct
            { 
             uint8_t      tr_id;
             uint8_t      message_id;
             uint8_t      call_id;
             uint8_t      sub_blocks;
             CALL_MODE_STR    mode[0];
            } __attribute__((packed)) CALL_COMING_IND_STR;
#define SIZE_CALL_COMING_IND                                  sizeof(CALL_COMING_IND_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct CALL_MO_ALERT_IND
#define CALL_MO_ALERT_IND                                     0x04                                                     
typedef struct
            { 
             uint8_t      tr_id;
             uint8_t      message_id;
             uint8_t      call_id;
             uint8_t      sub_blocks;
            } __attribute__((packed)) CALL_MO_ALERT_IND_STR;
#define SIZE_CALL_MO_ALERT_IND                                sizeof(CALL_MO_ALERT_IND_STR)


//Definition for struct CALL_MT_ALERT_IND
#define CALL_MT_ALERT_IND                                     0x05                                                     
typedef struct
            { 
             uint8_t      tr_id;
             uint8_t      message_id;
             uint8_t      call_id;
             uint8_t      sub_blocks;
            } __attribute__((packed)) CALL_MT_ALERT_IND_STR;
#define SIZE_CALL_MT_ALERT_IND                                sizeof(CALL_MT_ALERT_IND_STR)


//Definition for struct CALL_WAITING_IND
#define CALL_WAITING_IND                                      0x06                                                     
typedef struct
            { 
             uint8_t      tr_id;
             uint8_t      message_id;
             uint8_t      call_id;
             uint8_t      sub_blocks;
            } __attribute__((packed)) CALL_WAITING_IND_STR;
#define SIZE_CALL_WAITING_IND                                 sizeof(CALL_WAITING_IND_STR)


//Definition for struct CALL_ANSWER_REQ
#define CALL_ANSWER_REQ                                       0x07                                                     
typedef struct
            { 
             uint8_t      tr_id;
             uint8_t      message_id;
             uint8_t      call_id;
             uint8_t      sub_blocks;
            } __attribute__((packed)) CALL_ANSWER_REQ_STR;
#define SIZE_CALL_ANSWER_REQ                                  sizeof(CALL_ANSWER_REQ_STR)


//Definition for struct CALL_ANSWER_RESP
#define CALL_ANSWER_RESP                                      0x08                                                     
typedef struct
            { 
             uint8_t      tr_id;
             uint8_t      message_id;
             uint8_t      call_id;
             uint8_t      sub_blocks;
            } __attribute__((packed)) CALL_ANSWER_RESP_STR;
#define SIZE_CALL_ANSWER_RESP                                 sizeof(CALL_ANSWER_RESP_STR)


//Definition for struct CALL_RELEASE_REQ
#define CALL_RELEASE_REQ                                      0x09                                                     
typedef struct
            { 
             uint8_t      tr_id;
             uint8_t      message_id;
             uint8_t      call_id;
             uint8_t      sub_blocks;
             CALL_CAUSE_STR    cause[0];
            } __attribute__((packed)) CALL_RELEASE_REQ_STR;
#define SIZE_CALL_RELEASE_REQ                                 sizeof(CALL_RELEASE_REQ_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct CALL_RELEASE_RESP
#define CALL_RELEASE_RESP                                     0x0A                                                     
typedef struct
            { 
             uint8_t      tr_id;
             uint8_t      message_id;
             uint8_t      call_id;
             uint8_t      sub_blocks;
            } __attribute__((packed)) CALL_RELEASE_RESP_STR;
#define SIZE_CALL_RELEASE_RESP                                sizeof(CALL_RELEASE_RESP_STR)


//Definition for struct CALL_RELEASE_IND
#define CALL_RELEASE_IND                                      0x0B                                                     
typedef struct
            { 
             uint8_t      tr_id;
             uint8_t      message_id;
             uint8_t      call_id;
             uint8_t      sub_blocks;
             CALL_CAUSE_STR    cause[0];
            } __attribute__((packed)) CALL_RELEASE_IND_STR;
#define SIZE_CALL_RELEASE_IND                                 sizeof(CALL_RELEASE_IND_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct CALL_TERMINATED_IND
#define CALL_TERMINATED_IND                                   0x0C                                                     
typedef struct
            { 
             uint8_t      tr_id;
             uint8_t      message_id;
             uint8_t      call_id;
             uint8_t      sub_blocks;
             CALL_CAUSE_STR    cause[0];
             CALL_MODE_STR    mode[0];
            } __attribute__((packed)) CALL_TERMINATED_IND_STR;
#define SIZE_CALL_TERMINATED_IND                              sizeof(CALL_TERMINATED_IND_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct CALL_STATUS_REQ
#define CALL_STATUS_REQ                                       0x0D                                                     
typedef struct
            { 
             uint8_t      tr_id;
             uint8_t      message_id;
             uint8_t      call_id;
             uint8_t      sub_blocks;
            } __attribute__((packed)) CALL_STATUS_REQ_STR;
#define SIZE_CALL_STATUS_REQ                                  sizeof(CALL_STATUS_REQ_STR)


//Definition for struct CALL_STATUS_RESP
#define CALL_STATUS_RESP                                      0x0E                                                     
typedef struct
            { 
             uint8_t      tr_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      sub_blocks;
            } __attribute__((packed)) CALL_STATUS_RESP_STR;
#define SIZE_CALL_STATUS_RESP                                 sizeof(CALL_STATUS_RESP_STR)


//Definition for struct CALL_STATUS_IND
#define CALL_STATUS_IND                                       0x0F                                                     
typedef struct
            { 
             uint8_t      tr_id;
             uint8_t      message_id;
             uint8_t      call_id;
             uint8_t      sub_blocks;
             CALL_STATUS_STR    status[0];
             CALL_MODE_STR    mode[0];
            } __attribute__((packed)) CALL_STATUS_IND_STR;
#define SIZE_CALL_STATUS_IND                                  sizeof(CALL_STATUS_IND_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct CALL_SERVER_STATUS_IND
#define CALL_SERVER_STATUS_IND                                0x10                                                  
typedef struct
            { 
             uint8_t      tr_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      sub_blocks;
            } __attribute__((packed)) CALL_SERVER_STATUS_IND_STR;
#define SIZE_CALL_SERVER_STATUS_IND                           sizeof(CALL_SERVER_STATUS_IND_STR)


//Definition for struct CALL_CONTROL_REQ
#define CALL_CONTROL_REQ                                      0x11                                                  
typedef struct
            { 
             uint8_t      tr_id;
             uint8_t      message_id;
             uint8_t      call_id;
             uint8_t      sub_blocks;
             CALL_OPERATION_STR    operation[0];
            } __attribute__((packed)) CALL_CONTROL_REQ_STR;
#define SIZE_CALL_CONTROL_REQ                                 sizeof(CALL_CONTROL_REQ_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct CALL_CONTROL_RESP
#define CALL_CONTROL_RESP                                     0x12                                                  
typedef struct
            { 
             uint8_t      tr_id;
             uint8_t      message_id;
             uint8_t      call_id;
             uint8_t      sub_blocks;
             CALL_OPERATION_STR    operation[0];
            } __attribute__((packed)) CALL_CONTROL_RESP_STR;
#define SIZE_CALL_CONTROL_RESP                                sizeof(CALL_CONTROL_RESP_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct CALL_CONTROL_IND
#define CALL_CONTROL_IND                                      0x13                                                  
typedef struct
            { 
             uint8_t      tr_id;
             uint8_t      message_id;
             uint8_t      call_id;
             uint8_t      sub_blocks;
             CALL_OPERATION_STR    operation[0];
            } __attribute__((packed)) CALL_CONTROL_IND_STR;
#define SIZE_CALL_CONTROL_IND                                 sizeof(CALL_CONTROL_IND_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct CALL_MODE_SWITCH_REQ
#define CALL_MODE_SWITCH_REQ                                  0x14                                                  
typedef struct
            { 
             uint8_t      tr_id;
             uint8_t      message_id;
             uint8_t      call_id;
             uint8_t      sub_blocks;
             CALL_MODE_STR    mode[0];
            } __attribute__((packed)) CALL_MODE_SWITCH_REQ_STR;
#define SIZE_CALL_MODE_SWITCH_REQ                             sizeof(CALL_MODE_SWITCH_REQ_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct CALL_MODE_SWITCH_RESP
#define CALL_MODE_SWITCH_RESP                                 0x15                                                  
typedef struct
            { 
             uint8_t      tr_id;
             uint8_t      message_id;
             uint8_t      call_id;
             uint8_t      sub_blocks;
            } __attribute__((packed)) CALL_MODE_SWITCH_RESP_STR;
#define SIZE_CALL_MODE_SWITCH_RESP                            sizeof(CALL_MODE_SWITCH_RESP_STR)


//Definition for struct CALL_MODE_SWITCH_IND
#define CALL_MODE_SWITCH_IND                                  0x16                                                  
typedef struct
            { 
             uint8_t      tr_id;
             uint8_t      message_id;
             uint8_t      call_id;
             uint8_t      sub_blocks;
             CALL_MODE_STR    mode[0];
            } __attribute__((packed)) CALL_MODE_SWITCH_IND_STR;
#define SIZE_CALL_MODE_SWITCH_IND                             sizeof(CALL_MODE_SWITCH_IND_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct CALL_DTMF_SEND_REQ
#define CALL_DTMF_SEND_REQ                                    0x17                                                  
typedef struct
            { 
             uint8_t      tr_id;
             uint8_t      message_id;
             uint8_t      call_id;
             uint8_t      sub_blocks;
            } __attribute__((packed)) CALL_DTMF_SEND_REQ_STR;
#define SIZE_CALL_DTMF_SEND_REQ                               sizeof(CALL_DTMF_SEND_REQ_STR)


//Definition for struct CALL_DTMF_SEND_RESP
#define CALL_DTMF_SEND_RESP                                   0x18                                                  
typedef struct
            { 
             uint8_t      tr_id;
             uint8_t      message_id;
             uint8_t      call_id;
             uint8_t      sub_blocks;
            } __attribute__((packed)) CALL_DTMF_SEND_RESP_STR;
#define SIZE_CALL_DTMF_SEND_RESP                              sizeof(CALL_DTMF_SEND_RESP_STR)


//Definition for struct CALL_DTMF_STOP_REQ
#define CALL_DTMF_STOP_REQ                                    0x19                                                  
typedef struct
            { 
             uint8_t      tr_id;
             uint8_t      message_id;
             uint8_t      call_id;
             uint8_t      sub_blocks;
            } __attribute__((packed)) CALL_DTMF_STOP_REQ_STR;
#define SIZE_CALL_DTMF_STOP_REQ                               sizeof(CALL_DTMF_STOP_REQ_STR)


//Definition for struct CALL_DTMF_STOP_RESP
#define CALL_DTMF_STOP_RESP                                   0x1A                                                  
typedef struct
            { 
             uint8_t      tr_id;
             uint8_t      message_id;
             uint8_t      call_id;
             uint8_t      sub_blocks;
            } __attribute__((packed)) CALL_DTMF_STOP_RESP_STR;
#define SIZE_CALL_DTMF_STOP_RESP                              sizeof(CALL_DTMF_STOP_RESP_STR)


//Definition for struct CALL_DTMF_STATUS_IND
#define CALL_DTMF_STATUS_IND                                  0x1B                                                  
typedef struct
            { 
             uint8_t      tr_id;
             uint8_t      message_id;
             uint8_t      call_id;
             uint8_t      sub_blocks;
             CALL_DTMF_STATUS_STR    status[0];
            } __attribute__((packed)) CALL_DTMF_STATUS_IND_STR;
#define SIZE_CALL_DTMF_STATUS_IND                             sizeof(CALL_DTMF_STATUS_IND_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct CALL_DTMF_TONE_IND
#define CALL_DTMF_TONE_IND                                    0x1C                                                  
typedef struct
            { 
             uint8_t      tr_id;
             uint8_t      message_id;
             uint8_t      call_id;
             uint8_t      sub_blocks;
             CALL_DTMF_TONE_STR    tone[0];
            } __attribute__((packed)) CALL_DTMF_TONE_IND_STR;
#define SIZE_CALL_DTMF_TONE_IND                               sizeof(CALL_DTMF_TONE_IND_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct CALL_RECONNECT_IND
#define CALL_RECONNECT_IND                                    0x1E                                                  
typedef struct
            { 
             uint8_t      tr_id;
             uint8_t      message_id;
             uint8_t      reconnect_status;
             uint8_t      sub_blocks;
            } __attribute__((packed)) CALL_RECONNECT_IND_STR;
#define SIZE_CALL_RECONNECT_IND                               sizeof(CALL_RECONNECT_IND_STR)


//Definition for struct CALL_PROPERTY_GET_REQ
#define CALL_PROPERTY_GET_REQ                                 0x1F                                                  
typedef struct
            { 
             uint8_t      tr_id;
             uint8_t      message_id;
             uint8_t      property;
             uint8_t      sub_blocks;
            } __attribute__((packed)) CALL_PROPERTY_GET_REQ_STR;
#define SIZE_CALL_PROPERTY_GET_REQ                            sizeof(CALL_PROPERTY_GET_REQ_STR)


//Definition for struct CALL_PROPERTY_GET_RESP
#define CALL_PROPERTY_GET_RESP                                0x20                                                  
typedef struct
            { 
             uint8_t      tr_id;
             uint8_t      message_id;
             uint8_t      property;
             uint8_t      sub_blocks;
            } __attribute__((packed)) CALL_PROPERTY_GET_RESP_STR;
#define SIZE_CALL_PROPERTY_GET_RESP                           sizeof(CALL_PROPERTY_GET_RESP_STR)


//Definition for struct CALL_PROPERTY_SET_REQ
#define CALL_PROPERTY_SET_REQ                                 0x21                                                  
typedef struct
            { 
             uint8_t      tr_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      sub_blocks;
             CALL_PROPERTY_INFO_STR    property_info[0];
            } __attribute__((packed)) CALL_PROPERTY_SET_REQ_STR;
#define SIZE_CALL_PROPERTY_SET_REQ                            sizeof(CALL_PROPERTY_SET_REQ_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct CALL_PROPERTY_SET_RESP
#define CALL_PROPERTY_SET_RESP                                0x22                                                  
typedef struct
            { 
             uint8_t      tr_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      sub_blocks;
             CALL_PROPERTY_INFO_STR    property_info[0];
            } __attribute__((packed)) CALL_PROPERTY_SET_RESP_STR;
#define SIZE_CALL_PROPERTY_SET_RESP                           sizeof(CALL_PROPERTY_SET_RESP_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct CALL_PROPERTY_SET_IND
#define CALL_PROPERTY_SET_IND                                 0x23                                                  
typedef struct
            { 
             uint8_t      tr_id;
             uint8_t      message_id;
             uint8_t      property;
             uint8_t      sub_blocks;
             CALL_PROPERTY_INFO_STR    property_info[0];
            } __attribute__((packed)) CALL_PROPERTY_SET_IND_STR;
#define SIZE_CALL_PROPERTY_SET_IND                            sizeof(CALL_PROPERTY_SET_IND_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct CALL_EMERGENCY_NBR_CHECK_REQ
#define CALL_EMERGENCY_NBR_CHECK_REQ                          0x28                                                  
typedef struct
            { 
             uint8_t      tr_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      sub_blocks;
             CALL_DESTINATION_ADDRESS_STR    number[0];
            } __attribute__((packed)) CALL_EMERGENCY_NBR_CHECK_REQ_STR;
#define SIZE_CALL_EMERGENCY_NBR_CHECK_REQ                     sizeof(CALL_EMERGENCY_NBR_CHECK_REQ_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct CALL_EMERGENCY_NBR_CHECK_RESP
#define CALL_EMERGENCY_NBR_CHECK_RESP                         0x29                                                  
typedef struct
            { 
             uint8_t      tr_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      sub_blocks;
            } __attribute__((packed)) CALL_EMERGENCY_NBR_CHECK_RESP_STR;
#define SIZE_CALL_EMERGENCY_NBR_CHECK_RESP                    sizeof(CALL_EMERGENCY_NBR_CHECK_RESP_STR)


//Definition for struct CALL_EMERGENCY_NBR_GET_REQ
#define CALL_EMERGENCY_NBR_GET_REQ                            0x26                                                  
typedef struct
            { 
             uint8_t      tr_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      sub_blocks;
            } __attribute__((packed)) CALL_EMERGENCY_NBR_GET_REQ_STR;
#define SIZE_CALL_EMERGENCY_NBR_GET_REQ                       sizeof(CALL_EMERGENCY_NBR_GET_REQ_STR)


//Definition for struct CALL_EMERGENCY_NBR_GET_RESP
#define CALL_EMERGENCY_NBR_GET_RESP                           0x27                                                  
typedef struct
            { 
             uint8_t      tr_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      sub_blocks;
            } __attribute__((packed)) CALL_EMERGENCY_NBR_GET_RESP_STR;
#define SIZE_CALL_EMERGENCY_NBR_GET_RESP                      sizeof(CALL_EMERGENCY_NBR_GET_RESP_STR)


//Definition for struct CALL_EMERGENCY_NBR_MODIFY_REQ
#define CALL_EMERGENCY_NBR_MODIFY_REQ                         0x24                                                  
typedef struct
            { 
             uint8_t      tr_id;
             uint8_t      message_id;
             uint8_t      operation;
             uint8_t      sub_blocks;
            } __attribute__((packed)) CALL_EMERGENCY_NBR_MODIFY_REQ_STR;
#define SIZE_CALL_EMERGENCY_NBR_MODIFY_REQ                    sizeof(CALL_EMERGENCY_NBR_MODIFY_REQ_STR)


//Definition for struct CALL_EMERGENCY_NBR_MODIFY_RESP
#define CALL_EMERGENCY_NBR_MODIFY_RESP                        0x25                                                  
typedef struct
            { 
             uint8_t      tr_id;
             uint8_t      message_id;
             uint8_t      operation;
             uint8_t      sub_blocks;
            } __attribute__((packed)) CALL_EMERGENCY_NBR_MODIFY_RESP_STR;
#define SIZE_CALL_EMERGENCY_NBR_MODIFY_RESP                   sizeof(CALL_EMERGENCY_NBR_MODIFY_RESP_STR)


//Definition for struct CALL_GSM_NOTIFICATION_IND
#define CALL_GSM_NOTIFICATION_IND                             0xA0                                                  
typedef struct
            { 
             uint8_t      tr_id;
             uint8_t      message_id;
             uint8_t      call_id;
             uint8_t      sub_blocks;
            } __attribute__((packed)) CALL_GSM_NOTIFICATION_IND_STR;
#define SIZE_CALL_GSM_NOTIFICATION_IND                        sizeof(CALL_GSM_NOTIFICATION_IND_STR)


//Definition for struct CALL_GSM_USER_TO_USER_REQ
#define CALL_GSM_USER_TO_USER_REQ                             0xA1                                                  
typedef struct
            { 
             uint8_t      tr_id;
             uint8_t      message_id;
             uint8_t      call_id;
             uint8_t      sub_blocks;
            } __attribute__((packed)) CALL_GSM_USER_TO_USER_REQ_STR;
#define SIZE_CALL_GSM_USER_TO_USER_REQ                        sizeof(CALL_GSM_USER_TO_USER_REQ_STR)


//Definition for struct CALL_GSM_USER_TO_USER_RESP
#define CALL_GSM_USER_TO_USER_RESP                            0xA2                                                  
typedef struct
            { 
             uint8_t      tr_id;
             uint8_t      message_id;
             uint8_t      call_id;
             uint8_t      sub_blocks;
            } __attribute__((packed)) CALL_GSM_USER_TO_USER_RESP_STR;
#define SIZE_CALL_GSM_USER_TO_USER_RESP                       sizeof(CALL_GSM_USER_TO_USER_RESP_STR)


//Definition for struct CALL_GSM_USER_TO_USER_IND
#define CALL_GSM_USER_TO_USER_IND                             0xA3                                                  
typedef struct
            { 
             uint8_t      tr_id;
             uint8_t      message_id;
             uint8_t      call_id;
             uint8_t      sub_blocks;
            } __attribute__((packed)) CALL_GSM_USER_TO_USER_IND_STR;
#define SIZE_CALL_GSM_USER_TO_USER_IND                        sizeof(CALL_GSM_USER_TO_USER_IND_STR)


//Definition for struct CALL_GSM_BLACKLIST_CLEAR_REQ
#define CALL_GSM_BLACKLIST_CLEAR_REQ                          0xA4                                                  
typedef struct
            { 
             uint8_t      tr_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      sub_blocks;
            } __attribute__((packed)) CALL_GSM_BLACKLIST_CLEAR_REQ_STR;
#define SIZE_CALL_GSM_BLACKLIST_CLEAR_REQ                     sizeof(CALL_GSM_BLACKLIST_CLEAR_REQ_STR)


//Definition for struct CALL_GSM_BLACKLIST_CLEAR_RESP
#define CALL_GSM_BLACKLIST_CLEAR_RESP                         0xA5                                                  
typedef struct
            { 
             uint8_t      tr_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      sub_blocks;
            } __attribute__((packed)) CALL_GSM_BLACKLIST_CLEAR_RESP_STR;
#define SIZE_CALL_GSM_BLACKLIST_CLEAR_RESP                    sizeof(CALL_GSM_BLACKLIST_CLEAR_RESP_STR)


//Definition for struct CALL_GSM_BLACKLIST_TIMER_IND
#define CALL_GSM_BLACKLIST_TIMER_IND                          0xA6                                                  
typedef struct
            { 
             uint8_t      tr_id;
             uint8_t      message_id;
             uint8_t      duration;
             uint8_t      sub_blocks;
            } __attribute__((packed)) CALL_GSM_BLACKLIST_TIMER_IND_STR;
#define SIZE_CALL_GSM_BLACKLIST_TIMER_IND                     sizeof(CALL_GSM_BLACKLIST_TIMER_IND_STR)


//Definition for struct CALL_GSM_DATA_CH_INFO_IND
#define CALL_GSM_DATA_CH_INFO_IND                             0xA7                                                  
typedef struct
            { 
             uint8_t      tr_id;
             uint8_t      message_id;
             uint8_t      call_id;
             uint8_t      sub_blocks;
             CALL_MODE_STR    mode[0];
             CALL_GSM_DATA_CH_INFO_STR    info[0];
            } __attribute__((packed)) CALL_GSM_DATA_CH_INFO_IND_STR;
#define SIZE_CALL_GSM_DATA_CH_INFO_IND                        sizeof(CALL_GSM_DATA_CH_INFO_IND_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct CALL_GSM_CCP_GET_REQ
#define CALL_GSM_CCP_GET_REQ                                  0xAA                                                  
typedef struct
            { 
             uint8_t      tr_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      sub_blocks;
             CALL_MODE_STR    mode[0];
            } __attribute__((packed)) CALL_GSM_CCP_GET_REQ_STR;
#define SIZE_CALL_GSM_CCP_GET_REQ                             sizeof(CALL_GSM_CCP_GET_REQ_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct CALL_GSM_CCP_GET_RESP
#define CALL_GSM_CCP_GET_RESP                                 0xAB                                                  
typedef struct
            { 
             uint8_t      tr_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      sub_blocks;
            } __attribute__((packed)) CALL_GSM_CCP_GET_RESP_STR;
#define SIZE_CALL_GSM_CCP_GET_RESP                            sizeof(CALL_GSM_CCP_GET_RESP_STR)


//Definition for struct CALL_GSM_CCP_CHECK_REQ
#define CALL_GSM_CCP_CHECK_REQ                                0xAC                                                  
typedef struct
            { 
             uint8_t      tr_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      sub_blocks;
            } __attribute__((packed)) CALL_GSM_CCP_CHECK_REQ_STR;
#define SIZE_CALL_GSM_CCP_CHECK_REQ                           sizeof(CALL_GSM_CCP_CHECK_REQ_STR)


//Definition for struct CALL_GSM_CCP_CHECK_RESP
#define CALL_GSM_CCP_CHECK_RESP                               0xAD                                                  
typedef struct
            { 
             uint8_t      tr_id;
             uint8_t      message_id;
             uint8_t      result;
             uint8_t      sub_blocks;
            } __attribute__((packed)) CALL_GSM_CCP_CHECK_RESP_STR;
#define SIZE_CALL_GSM_CCP_CHECK_RESP                          sizeof(CALL_GSM_CCP_CHECK_RESP_STR)


//Definition for struct CALL_GSM_COMING_REJ_IND
#define CALL_GSM_COMING_REJ_IND                               0xA9                                                  
typedef struct
            { 
             uint8_t      tr_id;
             uint8_t      message_id;
             uint8_t      call_id;
             uint8_t      sub_blocks;
             CALL_MODE_STR    mode[0];
             CALL_CAUSE_STR    cause[0];
            } __attribute__((packed)) CALL_GSM_COMING_REJ_IND_STR;
#define SIZE_CALL_GSM_COMING_REJ_IND                          sizeof(CALL_GSM_COMING_REJ_IND_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct CALL_GSM_RAB_IND
#define CALL_GSM_RAB_IND                                      0xA8                                                  
typedef struct
            { 
             uint8_t      tr_id;
             uint8_t      message_id;
             uint8_t      call_id;
             uint8_t      sub_blocks;
             CALL_GSM_RAB_INFO_STR    rab_info[0];
            } __attribute__((packed)) CALL_GSM_RAB_IND_STR;
#define SIZE_CALL_GSM_RAB_IND                                 sizeof(CALL_GSM_RAB_IND_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct CALL_GSM_IMMEDIATE_MODIFY_IND
#define CALL_GSM_IMMEDIATE_MODIFY_IND                         0xAE                                                  
typedef struct
            { 
             uint8_t      tr_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      sub_blocks;
            } __attribute__((packed)) CALL_GSM_IMMEDIATE_MODIFY_IND_STR;
#define SIZE_CALL_GSM_IMMEDIATE_MODIFY_IND                    sizeof(CALL_GSM_IMMEDIATE_MODIFY_IND_STR)


//Definition for struct CALL_CREATE_NO_SIMATK_REQ
#define CALL_CREATE_NO_SIMATK_REQ                             0x2A                                                  
typedef struct
            { 
             uint8_t      tr_id;
             uint8_t      message_id;
             uint8_t      call_id;
             uint8_t      sub_blocks;
             CALL_MODE_STR    mode[0];
            } __attribute__((packed)) CALL_CREATE_NO_SIMATK_REQ_STR;
#define SIZE_CALL_CREATE_NO_SIMATK_REQ                        sizeof(CALL_CREATE_NO_SIMATK_REQ_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct CALL_GSM_SS_DATA_IND
#define CALL_GSM_SS_DATA_IND                                  0xAF                                                  
typedef struct
            { 
             uint8_t      tr_id;
             uint8_t      message_id;
             uint8_t      call_id;
             uint8_t      air_ss_operation;
             uint8_t      air_ss_code;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      sub_blocks;
            } __attribute__((packed)) CALL_GSM_SS_DATA_IND_STR;
#define SIZE_CALL_GSM_SS_DATA_IND                             sizeof(CALL_GSM_SS_DATA_IND_STR)


//Definition for struct CALL_TIMER_REQ
#define CALL_TIMER_REQ                                        0x2B                                                  
typedef struct
            { 
             uint8_t      tr_id;
             uint8_t      message_id;
             uint8_t      timers;
             uint8_t      notification;
             uint8_t      als_line;
             uint8_t      system;
             uint8_t      fillerbyte1;
             uint8_t      sub_blocks;
            } __attribute__((packed)) CALL_TIMER_REQ_STR;
#define SIZE_CALL_TIMER_REQ                                   sizeof(CALL_TIMER_REQ_STR)


//Definition for struct CALL_TIMER_RESP
#define CALL_TIMER_RESP                                       0x2C                                                  
typedef struct
            { 
             uint8_t      tr_id;
             uint8_t      message_id;
             uint8_t      als_line;
             uint8_t      notification;
             uint8_t      system;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      sub_blocks;
            } __attribute__((packed)) CALL_TIMER_RESP_STR;
#define SIZE_CALL_TIMER_RESP                                  sizeof(CALL_TIMER_RESP_STR)


//Definition for struct CALL_TIMER_NTF
#define CALL_TIMER_NTF                                        0x2D                                                  
typedef struct
            { 
             uint8_t      tr_id;
             uint8_t      message_id;
             uint8_t      als_line;
             uint8_t      sub_blocks;
            } __attribute__((packed)) CALL_TIMER_NTF_STR;
#define SIZE_CALL_TIMER_NTF                                   sizeof(CALL_TIMER_NTF_STR)


//Definition for struct CALL_TIMER_IND
#define CALL_TIMER_IND                                        0x2E                                                  
typedef struct
            { 
             uint8_t      tr_id;
             uint8_t      message_id;
             uint8_t      als_line;
             uint8_t      sub_blocks;
            } __attribute__((packed)) CALL_TIMER_IND_STR;
#define SIZE_CALL_TIMER_IND                                   sizeof(CALL_TIMER_IND_STR)


//Definition for struct CALL_TIMER_RESET_REQ
#define CALL_TIMER_RESET_REQ                                  0x2F                                                  
typedef struct
            { 
             uint8_t      tr_id;
             uint8_t      message_id;
             uint8_t      als_lines;
             uint8_t      sub_blocks;
            } __attribute__((packed)) CALL_TIMER_RESET_REQ_STR;
#define SIZE_CALL_TIMER_RESET_REQ                             sizeof(CALL_TIMER_RESET_REQ_STR)


//Definition for struct CALL_TIMER_RESET_RESP
#define CALL_TIMER_RESET_RESP                                 0x30                                                  
typedef struct
            { 
             uint8_t      tr_id;
             uint8_t      message_id;
             uint8_t      als_lines;
             uint8_t      sub_blocks;
            } __attribute__((packed)) CALL_TIMER_RESET_RESP_STR;
#define SIZE_CALL_TIMER_RESET_RESP                            sizeof(CALL_TIMER_RESET_RESP_STR)


//Definition for struct CALL_EMERGENCY_NBR_IND
#define CALL_EMERGENCY_NBR_IND                                0x31                                                  
typedef struct
            { 
             uint8_t      tr_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      sub_blocks;
            } __attribute__((packed)) CALL_EMERGENCY_NBR_IND_STR;
#define SIZE_CALL_EMERGENCY_NBR_IND                           sizeof(CALL_EMERGENCY_NBR_IND_STR)


//Definition for struct CALL_SERVICE_DENIED_IND
#define CALL_SERVICE_DENIED_IND                               0x32                                                  
typedef struct
            { 
             uint8_t      tr_id;
             uint8_t      message_id;
             uint8_t      req_message_id;
             uint8_t      additional_info;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
             uint8_t      sub_blocks;
            } __attribute__((packed)) CALL_SERVICE_DENIED_IND_STR;
#define SIZE_CALL_SERVICE_DENIED_IND                          sizeof(CALL_SERVICE_DENIED_IND_STR)


//Definition for struct CALL_RELEASE_END_REQ
#define CALL_RELEASE_END_REQ                                  0x34                                                  
typedef struct
            { 
             uint8_t      tr_id;
             uint8_t      message_id;
             uint8_t      call_id;
             uint8_t      sub_blocks;
            } __attribute__((packed)) CALL_RELEASE_END_REQ_STR;
#define SIZE_CALL_RELEASE_END_REQ                             sizeof(CALL_RELEASE_END_REQ_STR)


//Definition for struct CALL_RELEASE_END_RESP
#define CALL_RELEASE_END_RESP                                 0x35                                                  
typedef struct
            { 
             uint8_t      tr_id;
             uint8_t      message_id;
             uint8_t      call_id;
             uint8_t      sub_blocks;
            } __attribute__((packed)) CALL_RELEASE_END_RESP_STR;
#define SIZE_CALL_RELEASE_END_RESP                            sizeof(CALL_RELEASE_END_RESP_STR)


//Definition for struct CALL_USER_CONNECT_IND
#define CALL_USER_CONNECT_IND                                 0x33                                                  
typedef struct
            { 
             uint8_t      tr_id;
             uint8_t      message_id;
             uint8_t      user_conn;
             uint8_t      sub_blocks;
            } __attribute__((packed)) CALL_USER_CONNECT_IND_STR;
#define SIZE_CALL_USER_CONNECT_IND                            sizeof(CALL_USER_CONNECT_IND_STR)


//Definition for struct CALL_AUDIO_CONNECT_IND
#define CALL_AUDIO_CONNECT_IND                                0x40                                                  
typedef struct
            { 
             uint8_t      tr_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      sub_blocks;
            } __attribute__((packed)) CALL_AUDIO_CONNECT_IND_STR;
#define SIZE_CALL_AUDIO_CONNECT_IND                           sizeof(CALL_AUDIO_CONNECT_IND_STR)


//Definition for struct CALL_KODIAK_ALLOW_CTRL_REQ
#define CALL_KODIAK_ALLOW_CTRL_REQ                            0x36                                                  
typedef struct
            { 
             uint8_t      tr_id;
             uint8_t      message_id;
             uint8_t      call_id;
             uint8_t      sub_blocks;
            } __attribute__((packed)) CALL_KODIAK_ALLOW_CTRL_REQ_STR;
#define SIZE_CALL_KODIAK_ALLOW_CTRL_REQ                       sizeof(CALL_KODIAK_ALLOW_CTRL_REQ_STR)


//Definition for struct CALL_KODIAK_ALLOW_CTRL_RESP
#define CALL_KODIAK_ALLOW_CTRL_RESP                           0x37                                                  
typedef struct
            { 
             uint8_t      tr_id;
             uint8_t      message_id;
             uint8_t      call_id;
             uint8_t      sub_blocks;
            } __attribute__((packed)) CALL_KODIAK_ALLOW_CTRL_RESP_STR;
#define SIZE_CALL_KODIAK_ALLOW_CTRL_RESP                      sizeof(CALL_KODIAK_ALLOW_CTRL_RESP_STR)


//Definition for struct CALL_SERVICE_ACTIVATE_IND
#define CALL_SERVICE_ACTIVATE_IND                             0x38                                                  
typedef struct
            { 
             uint8_t      tr_id;
             uint8_t      message_id;
             uint8_t      call_id;
             uint8_t      req_message_id;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
             uint8_t      sub_blocks;
             CALL_MODE_STR    mode[0];
            } __attribute__((packed)) CALL_SERVICE_ACTIVATE_IND_STR;
#define SIZE_CALL_SERVICE_ACTIVATE_IND                        sizeof(CALL_SERVICE_ACTIVATE_IND_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct CALL_SERVICE_ACTIVATE_REQ
#define CALL_SERVICE_ACTIVATE_REQ                             0x39                                                  
typedef struct
            { 
             uint8_t      tr_id;
             uint8_t      message_id;
             uint8_t      call_id;
             uint8_t      activate_status;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
             uint8_t      sub_blocks;
            } __attribute__((packed)) CALL_SERVICE_ACTIVATE_REQ_STR;
#define SIZE_CALL_SERVICE_ACTIVATE_REQ                        sizeof(CALL_SERVICE_ACTIVATE_REQ_STR)


//Definition for struct CALL_SERVICE_ACTIVATE_RESP
#define CALL_SERVICE_ACTIVATE_RESP                            0x3A                                                  
typedef struct
            { 
             uint8_t      tr_id;
             uint8_t      message_id;
             uint8_t      call_id;
             uint8_t      sub_blocks;
            } __attribute__((packed)) CALL_SERVICE_ACTIVATE_RESP_STR;
#define SIZE_CALL_SERVICE_ACTIVATE_RESP                       sizeof(CALL_SERVICE_ACTIVATE_RESP_STR)


//Definition for struct CALL_SIM_ATK_IND
#define CALL_SIM_ATK_IND                                      0x3B                                                  
typedef struct
            { 
             uint8_t      tr_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      sub_blocks;
            } __attribute__((packed)) CALL_SIM_ATK_IND_STR;
#define SIZE_CALL_SIM_ATK_IND                                 sizeof(CALL_SIM_ATK_IND_STR)


//Definition for struct CALL_CONTROL_OPER_IND
#define CALL_CONTROL_OPER_IND                                 0x3C                                                  
typedef struct
            { 
             uint8_t      tr_id;
             uint8_t      message_id;
             uint8_t      call_id;
             uint8_t      call_operation;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
             uint8_t      sub_blocks;
            } __attribute__((packed)) CALL_CONTROL_OPER_IND_STR;
#define SIZE_CALL_CONTROL_OPER_IND                            sizeof(CALL_CONTROL_OPER_IND_STR)


//Definition for struct CALL_TEST_CALL_STATUS_IND
#define CALL_TEST_CALL_STATUS_IND                             0x3E                                                  
typedef struct
            { 
             uint8_t      tr_id;
             uint8_t      message_id;
             uint8_t      call_id;
             uint8_t      sub_blocks;
             CALL_STATUS_STR    status[0];
             CALL_MODE_STR    mode[0];
            } __attribute__((packed)) CALL_TEST_CALL_STATUS_IND_STR;
#define SIZE_CALL_TEST_CALL_STATUS_IND                        sizeof(CALL_TEST_CALL_STATUS_IND_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct CALL_SIM_ATK_INFO_IND
#define CALL_SIM_ATK_INFO_IND                                 0x3F                                                  
typedef struct
            { 
             uint8_t      tr_id;
             uint8_t      message_id;
             uint8_t      call_id;
             uint8_t      sub_blocks;
            } __attribute__((packed)) CALL_SIM_ATK_INFO_IND_STR;
#define SIZE_CALL_SIM_ATK_INFO_IND                            sizeof(CALL_SIM_ATK_INFO_IND_STR)


//Definition for struct CALL_SECURITY_IND
#define CALL_SECURITY_IND                                     0x41                                                  
typedef struct
            { 
             uint8_t      tr_id;
             uint8_t      message_id;
             uint8_t      call_id;
             uint8_t      sub_blocks;
            } __attribute__((packed)) CALL_SECURITY_IND_STR;
#define SIZE_CALL_SECURITY_IND                                sizeof(CALL_SECURITY_IND_STR)


//Definition for struct CALL_MEDIA_HANDLE_REQ
#define CALL_MEDIA_HANDLE_REQ                                 0x42                                                  
typedef struct
            { 
             uint8_t      tr_id;
             uint8_t      message_id;
             uint8_t      call_id;
             uint8_t      ul_or_dl_handle;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
             uint8_t      sub_blocks;
            } __attribute__((packed)) CALL_MEDIA_HANDLE_REQ_STR;
#define SIZE_CALL_MEDIA_HANDLE_REQ                            sizeof(CALL_MEDIA_HANDLE_REQ_STR)


//Definition for struct CALL_MEDIA_HANDLE_RESP
#define CALL_MEDIA_HANDLE_RESP                                0x43                                                  
typedef struct
            { 
             uint8_t      tr_id;
             uint8_t      message_id;
             uint8_t      call_id;
             uint8_t      ul_or_dl_handle;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
             uint8_t      sub_blocks;
            } __attribute__((packed)) CALL_MEDIA_HANDLE_RESP_STR;
#define SIZE_CALL_MEDIA_HANDLE_RESP                           sizeof(CALL_MEDIA_HANDLE_RESP_STR)

#endif
