#ifndef _PN_COMMGR_ISI_H_
#define _PN_COMMGR_ISI_H_

#include <stdint.h> 

//Resource Communication Manager
//PN_COMMGR 0x10 
//ISI version 001.001
#define COMMUNICATION_MANAGER_ISI_VERSION_Z     1
#define COMMUNICATION_MANAGER_ISI_VERSION_Y     1

//In case of problems concerning content of this file contact Markku Loukusa, Sauli Laukka or Markus Mrsky
//Server specific message descriptions and feature&protocol descriptions can be found from: https://oucmswww.nmp.nokia.com:58443/document_browser/ccm_wa/GIF_SPECS/ 


//ISI VERSION CHANGE HISTORY

//Version: 001.001                                           
//Status: Approved                                          
//Date: 30-Aug-2006     Jens Kristoffersen
//Reason: SCO: Restructuring of the Phonet header-file structure.
//Reference: WP RM-RIM SCO: 006-5259: SWAM CR: JK06032331288, APPROVED

//Version: 001.000                                           
//Status: Approved                                          
//Date: 01-Jun-2006     Jens Kristoffersen
//Reason: SCO: Restructuring of the Phonet header-file structure.
//Reference: WP RM-RIM SCO: 006-5259: SWAM CR: JK06032331288, APPROVED


//CONSTANTS
#define CM_ANY_SIZE                                           1                                                     


//MESSAGES


//Definition for struct PNS_SUBSCRIBED_RESOURCES_IND
#define PNS_SUBSCRIBED_RESOURCES_IND                          0x10                                                  
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint8_t      resource_count;
             uint8_t      resource_list[0];
            } __attribute__((packed)) PNS_SUBSCRIBED_RESOURCES_IND_STR;
#define SIZE_PNS_SUBSCRIBED_RESOURCES_IND                     sizeof(PNS_SUBSCRIBED_RESOURCES_IND_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct PNS_SUBSCRIBED_RESOURCES_EXTEND_IND
#define PNS_SUBSCRIBED_RESOURCES_EXTEND_IND                   0x12                                                  
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint8_t      resource_count;
             uint8_t      filler;
             uint32_t     resource_list[0];
            } __attribute__((packed)) PNS_SUBSCRIBED_RESOURCES_EXTEND_IND_STR;
#define SIZE_PNS_SUBSCRIBED_RESOURCES_EXTEND_IND              sizeof(PNS_SUBSCRIBED_RESOURCES_EXTEND_IND_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct PNS_SUBSCRIBED_RESOURCES_PMM_IND
#define PNS_SUBSCRIBED_RESOURCES_PMM_IND                      0x11                                                  
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint8_t      resource_count;
             uint8_t      filler;
             uint8_t      resource_list[0];
            } __attribute__((packed)) PNS_SUBSCRIBED_RESOURCES_PMM_IND_STR;
#define SIZE_PNS_SUBSCRIBED_RESOURCES_PMM_IND                 sizeof(PNS_SUBSCRIBED_RESOURCES_PMM_IND_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct PNS_SUBSCRIBED_RESOURCES_PMM_EXTEND_IND
#define PNS_SUBSCRIBED_RESOURCES_PMM_EXTEND_IND               0x13                                                  
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint8_t      resource_count;
             uint8_t      filler;
             uint32_t     resource_list[0];
            } __attribute__((packed)) PNS_SUBSCRIBED_RESOURCES_PMM_EXTEND_IND_STR;
#define SIZE_PNS_SUBSCRIBED_RESOURCES_PMM_EXTEND_IND          sizeof(PNS_SUBSCRIBED_RESOURCES_PMM_EXTEND_IND_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.

#endif
