#ifndef _PN_COMMON_EXT_ISI_H_
#define _PN_COMMON_EXT_ISI_H_

#include <stdint.h> 

//Resource Common Messages (Extended)
//ISI version 000.029
#define COMMON_MESSAGES_EXTENDED_ISI_VERSION_Z     0
#define COMMON_MESSAGES_EXTENDED_ISI_VERSION_Y     29

//In case of problems concerning content of this file contact Markku Loukusa, Sauli Laukka or Markus Mrsky
//Server specific message descriptions and feature&protocol descriptions can be found from: https://oucmswww.nmp.nokia.com:58443/document_browser/ccm_wa/GIF_SPECS/ 


//ISI VERSION CHANGE HISTORY

//Version: 000.029                                           
//Status: Approved                                          
//Date: 03-May-2007     Leif Karilainen
//Reason: Minor updates
//Reference: See SWAM ADB LK07050349205, APPROVED

//Version: 000.028                                           
//Status: Approved                                          
//Date: 08-Dec-2006     Leif Karilainen
//Reason: Update to support extended resource ID concept behind flag COMMON_MESSAGES_EXTENDED_INTERFACE first time.
//Reference: See SWAM ADB LK06120455502, APPROVED

//Version: 000.027                                           
//Status: Approved                                          
//Date: 04-Jan-2006     Leif Karilainen
//Reason: Minor update
//Reference: See SWAM ADB LK06010448865, APPROVED

//Version: 000.026                                           
//Status: Approved                                          
//Date: 26-Aug-2004     Leif Karilainen
//Reason: New message.
//Reference: See SWAM ADB LK04082636973, APPROVED

//Version: 000.025                                           
//Status: Approved                                          
//Date: 26-Apr-2004     Leif Karilainen
//Reason: comm_isi_m.h needs updates.
//Reference: See SWAM ADB LK04042648164, APPROVED

//Version: 000.024                                           
//Status: Approved                                          
//Date: 01-Mar-2004     Leif Karilainen
//Reason: comm_isi_16.h needs updates.
//Reference: See SWAM ADB LK04030137132, APPROVED

//Version: 000.023                                           
//Status: Approved                                          
//Date: 12-Jan-2004     Leif Karilainen
//Reason: New common ISI message.
//Reference: See SWAM ADB LK04011246215., APPROVED

//Version: 000.022                                           
//Status: Approved                                          
//Date: 13-Oct-2003     Leif Karilainen
//Reason: Comments from inspection.
//Reference: See SWAM ADB LK03093036140., APPROVED

//Version: 000.021                                           
//Status: Approved                                          
//Date: 29-Sep-2003     Leif Karilainen
//Reason: Autogenerated common ISI header taken into use in sw packages.
//Reference: See SWAM ADB LK03093036140., APPROVED

//Version: 000.020                                           
//Status: Approved                                          
//Date: 28-Apr-2003     Leif Karilainen
//Reason: New message macro template taken into use and some macros updated because of new autogen version (DEFINE_CONST_TBL_BEGIN -->CONST_TBL_BEGIN and similar kind of cases). COMM_FTD_SYSTEM_SWITCH sub block added. COMM_MAX_FTD_STRING_LENGTH changed from 127 to 124. This version is now compatible with the ISI:COMMON_FEATURES.BASE-SPEC;000.020.
//Reference: See SWAM ADB LK03042933779., APPROVED

//Version: 000.019                                           
//Status: NonDraft                                          
//Date: 30-Nov-2001     Leif Karilainen
//Reason: Defects found in inspection are corrected. This version is now compatible with the ISI:COMMON_MESSAGES.BASE-SPEC;19.0
//Reference: See SWAM ADB LK01112144458, NON-DRAFT


//CONSTANTS
#define COMM_ISI_H_VERSION                                    0x1D                                                  
#define COMMON_MESSAGE                                        0xF0                                                  
#define SBC_MESSAGE                                           0xF1                                                  
#define SERVER_MESSAGE_SPACE_EXTENSION                        0xF2                                                  
#define COMM_MAX_FTD_STRING_LENGTH                            0x7C                                                  
#define COMM_MAX_FTD_DATA_LENGTH                              0xF8                                                  
#define COMM_MAX_VERSION_COMMENTS_LENGTH                      0x7F                                                  
#define COMM_MAX_FTD_DATA_ITEMS                               0xFF                                                  


//TABLES

//ConstantTable for COMM_FTD_FAIL_REASON
#define COMM_FTD_DATA_NOT_ACTIVATED                           0x00                                                     
#define COMM_FTD_DATA_NOT_SUPPORTED                           0x01                                                     
#define COMM_FTD_DATA_NOT_AVAILABLE                           0x02                                                     

//ConstantTable for COMM_GEN_STATUS_INFO
#define COMM_STATUS_OK                                        0x00                                                     
#define COMM_STATUS_FAIL                                      0x01                                                     

//ConstantTable for COMM_PWR_OFF_STATES
#define COMM_PWR_OFF                                          0x00                                                     
#define COMM_PWR_CHARGING                                     0x01                                                     
#define COMM_PWR_DISCHARGING                                  0x02                                                     

//ConstantTable for COMM_STRING_TYPE
#define COMM_STRING_ASCII                                     0x00                                                     
#define COMM_STRING_UNICODE                                   0x01                                                     

//ConstantTable for COMM_ISA_ENTITY_NOT_REACHABLE_STATUS
#define COMM_ISA_ENTITY_NOT_AVAILABLE                         0x00                                                     
#define COMM_ISA_ENTITY_NOT_EXISTING                          0x01                                                     

//ConstantTable for COMM_FTD_SYSTEM_SWITCH_INFO
#define COMM_FTD_SWITCH_WCDMA_TO_GSM                          0x01                                                     
#define COMM_FTD_SWITCH_GSM_TO_WCDMA                          0x02                                                     

//ConstantTable for COMM_RF_OPERATION
#define COMM_RF_ON                                            0x00                                                     
#define COMM_RF_OFF                                           0x01                                                     
#define COMM_RF_WIFI                                          0x02                                                     


//SUBBLOCKS


//Definition for struct COMM_FTD_DATA_FAIL
#define COMM_FTD_DATA_FAIL                                    0x00                                                     
typedef struct
            { 
             uint16_t     subblockid;
             uint8_t      subblock_length;
             uint8_t      fillerbyte1;
             uint16_t     not_identified_subblockid;
             uint8_t      fail_reason;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) COMM_FTD_DATA_FAIL_STR;
#define SIZE_COMM_FTD_DATA_FAIL                               sizeof(COMM_FTD_DATA_FAIL_STR)


//Definition for struct COMM_FTD_DATA_ALL
#define COMM_FTD_DATA_ALL                                     0x01                                                     
typedef struct
            { 
             uint16_t     subblockid;
             uint8_t      subblock_length;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) COMM_FTD_DATA_ALL_STR;
#define SIZE_COMM_FTD_DATA_ALL                                sizeof(COMM_FTD_DATA_ALL_STR)


//Definition for struct COMM_FTD_SYSTEM_SWITCH
#define COMM_FTD_SYSTEM_SWITCH                                0x02                                                     
typedef struct
            { 
             uint16_t     subblockid;
             uint8_t      subblock_length;
             uint8_t      system_switch;
            } __attribute__((packed)) COMM_FTD_SYSTEM_SWITCH_STR;
#define SIZE_COMM_FTD_SYSTEM_SWITCH                           sizeof(COMM_FTD_SYSTEM_SWITCH_STR)


//SUBBLOCKTEMPLATES


//Definition for struct COMM_FTD_DATA_BYTE
#define COMM_FTD_DATA_BYTE                                    0x00                                                     
typedef struct
            { 
             uint16_t     subblockid;
             uint8_t      subblock_length;
             uint8_t      data;
            } __attribute__((packed)) COMM_FTD_DATA_BYTE_STR;
#define SIZE_COMM_FTD_DATA_BYTE                               sizeof(COMM_FTD_DATA_BYTE_STR)


//Definition for struct COMM_FTD_DATA_WORD
#define COMM_FTD_DATA_WORD                                    0x00                                                     
typedef struct
            { 
             uint16_t     subblockid;
             uint8_t      subblock_length;
             uint8_t      fillerbyte1;
             uint16_t     data;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
            } __attribute__((packed)) COMM_FTD_DATA_WORD_STR;
#define SIZE_COMM_FTD_DATA_WORD                               sizeof(COMM_FTD_DATA_WORD_STR)


//Definition for struct COMM_FTD_DATA_DWORD
#define COMM_FTD_DATA_DWORD                                   0x00                                                     
typedef struct
            { 
             uint16_t     subblockid;
             uint8_t      subblock_length;
             uint8_t      fillerbyte1;
             uint32_t     data;
            } __attribute__((packed)) COMM_FTD_DATA_DWORD_STR;
#define SIZE_COMM_FTD_DATA_DWORD                              sizeof(COMM_FTD_DATA_DWORD_STR)


//Definition for struct COMM_FTD_DATA_STRING
#define COMM_FTD_DATA_STRING                                  0x00                                                     
typedef struct
            { 
             uint16_t     subblockid;
             uint8_t      subblock_length;
             uint8_t      string_lenght;
             uint8_t      string[0];
            } __attribute__((packed)) COMM_FTD_DATA_STRING_STR;
#define SIZE_COMM_FTD_DATA_STRING                             sizeof(COMM_FTD_DATA_STRING_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct COMM_FTD_DATA_TABLE
#define COMM_FTD_DATA_TABLE                                   0x00                                                     
typedef struct
            { 
             uint16_t     subblockid;
             uint8_t      subblock_length;
             uint8_t      data_length;
             uint8_t      data[0];
            } __attribute__((packed)) COMM_FTD_DATA_TABLE_STR;
#define SIZE_COMM_FTD_DATA_TABLE                              sizeof(COMM_FTD_DATA_TABLE_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//MESSAGES


//SERVICE TYPES
#define COMM_ISA_ENTITY_NOT_REACHABLE_RESP                    0x14                                                  
#define COMM_SERVICE_NOT_IDENTIFIED_RESP                      0x01                                                     
#define COMM_SERVER_VERSION_GET_REQ                           0x02                                                     
#define COMM_SERVER_VERSION_GET_RESP                          0x03                                                     
#define COMM_ISI_VERSION_GET_REQ                              0x12                                                  
#define COMM_ISI_VERSION_GET_RESP                             0x13                                                  
#define COMM_FTD_DATA_REQ                                     0x04                                                     
#define COMM_FTD_DATA_RESP                                    0x05                                                     
#define COMM_FTD_TEST_DATA_REQ                                0x06                                                     
#define COMM_FTD_TEST_DATA_RESP                               0x07                                                     
#define COMM_FTD_DATA_DEACTIVATE_REQ                          0x08                                                     
#define COMM_FTD_DATA_DEACTIVATE_RESP                         0x09                                                     
#define COMM_PWR_OFF_CONFIRM_REQ                              0x0C                                                     
#define COMM_PWR_OFF_CONFIRM_RESP                             0x0D                                                     
#define COMM_NVD_SET_DEFAULT_REQ                              0x0E                                                     
#define COMM_NVD_SET_DEFAULT_RESP                             0x0F                                                     
#define COMM_NVD_VERSION_CHK_REQ                              0x10                                                  
#define COMM_NVD_VERSION_CHK_RESP                             0x11                                                  
#define COMM_RF_CONTROL_REQ                                   0x15                                                  
#define COMM_RF_CONTROL_RESP                                  0x16                                                  
#define COMM_SERVICE_NOT_AUTHENTICATED_RESP                   0x17                                                  


//Definition for struct COMMON_MESSAGE


//Definition for struct COMMON_MESSAGE_EXTENDED_COMM_ISA_ENTITY_NOT_REACHABLE_RESP
#define COMMON_MESSAGE_EXTENDED_COMM_ISA_ENTITY_NOT_REACHABLE_RESP    0xF0                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      type;
             uint8_t      subtype;
             uint8_t      sub_message_id;
             uint8_t      not_delivered_messageid;
             uint8_t      status;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) COMMON_MESSAGE_EXTENDED_COMM_ISA_ENTITY_NOT_REACHABLE_RESP_STR;
#define SIZE_COMMON_MESSAGE_EXTENDED_COMM_ISA_ENTITY_NOT_REACHABLE_RESP    sizeof(COMMON_MESSAGE_EXTENDED_COMM_ISA_ENTITY_NOT_REACHABLE_RESP_STR)


//Definition for struct COMMON_MESSAGE


//Definition for struct COMMON_MESSAGE_EXTENDED_COMM_SERVICE_NOT_IDENTIFIED_RESP
#define COMMON_MESSAGE_EXTENDED_COMM_SERVICE_NOT_IDENTIFIED_RESP    0xF0                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      type;
             uint8_t      subtype;
             uint8_t      sub_message_id;
             uint8_t      not_served_messageid;
             uint8_t      message_extension;
             uint8_t      not_served_submessageid;
            } __attribute__((packed)) COMMON_MESSAGE_EXTENDED_COMM_SERVICE_NOT_IDENTIFIED_RESP_STR;
#define SIZE_COMMON_MESSAGE_EXTENDED_COMM_SERVICE_NOT_IDENTIFIED_RESP    sizeof(COMMON_MESSAGE_EXTENDED_COMM_SERVICE_NOT_IDENTIFIED_RESP_STR)


//Definition for struct COMMON_MESSAGE


//Definition for struct COMMON_MESSAGE_EXTENDED_COMM_SERVER_VERSION_GET_REQ
#define COMMON_MESSAGE_EXTENDED_COMM_SERVER_VERSION_GET_REQ    0xF0                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      type;
             uint8_t      subtype;
             uint8_t      sub_message_id;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
            } __attribute__((packed)) COMMON_MESSAGE_EXTENDED_COMM_SERVER_VERSION_GET_REQ_STR;
#define SIZE_COMMON_MESSAGE_EXTENDED_COMM_SERVER_VERSION_GET_REQ    sizeof(COMMON_MESSAGE_EXTENDED_COMM_SERVER_VERSION_GET_REQ_STR)


//Definition for struct COMMON_MESSAGE


//Definition for struct COMMON_MESSAGE_EXTENDED_COMM_SERVER_VERSION_GET_RESP
#define COMMON_MESSAGE_EXTENDED_COMM_SERVER_VERSION_GET_RESP    0xF0                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      type;
             uint8_t      subtype;
             uint8_t      sub_message_id;
             uint8_t      version_nbr_zzz;
             uint8_t      version_nbr_yyy;
             uint8_t      version_nbr_xxx;
             uint8_t      release_year;
             uint8_t      release_month;
             uint8_t      release_day;
             uint8_t      version_comments_length;
             uint8_t      version_comments[0];
            } __attribute__((packed)) COMMON_MESSAGE_EXTENDED_COMM_SERVER_VERSION_GET_RESP_STR;
#define SIZE_COMMON_MESSAGE_EXTENDED_COMM_SERVER_VERSION_GET_RESP    sizeof(COMMON_MESSAGE_EXTENDED_COMM_SERVER_VERSION_GET_RESP_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct COMMON_MESSAGE


//Definition for struct COMMON_MESSAGE_EXTENDED_COMM_ISI_VERSION_GET_REQ
#define COMMON_MESSAGE_EXTENDED_COMM_ISI_VERSION_GET_REQ      0xF0                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      type;
             uint8_t      subtype;
             uint8_t      sub_message_id;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
            } __attribute__((packed)) COMMON_MESSAGE_EXTENDED_COMM_ISI_VERSION_GET_REQ_STR;
#define SIZE_COMMON_MESSAGE_EXTENDED_COMM_ISI_VERSION_GET_REQ    sizeof(COMMON_MESSAGE_EXTENDED_COMM_ISI_VERSION_GET_REQ_STR)


//Definition for struct COMMON_MESSAGE


//Definition for struct COMMON_MESSAGE_EXTENDED_COMM_ISI_VERSION_GET_RESP
#define COMMON_MESSAGE_EXTENDED_COMM_ISI_VERSION_GET_RESP     0xF0                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      type;
             uint8_t      subtype;
             uint8_t      sub_message_id;
             uint8_t      isi_version_zzz;
             uint8_t      isi_version_yyy;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) COMMON_MESSAGE_EXTENDED_COMM_ISI_VERSION_GET_RESP_STR;
#define SIZE_COMMON_MESSAGE_EXTENDED_COMM_ISI_VERSION_GET_RESP    sizeof(COMMON_MESSAGE_EXTENDED_COMM_ISI_VERSION_GET_RESP_STR)


//Definition for struct COMMON_MESSAGE


//Definition for struct COMMON_MESSAGE_EXTENDED_COMM_FTD_DATA_REQ
#define COMMON_MESSAGE_EXTENDED_COMM_FTD_DATA_REQ             0xF0                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      type;
             uint8_t      subtype;
             uint8_t      sub_message_id;
             uint8_t      nbr_of_ftd_data_items;
            } __attribute__((packed)) COMMON_MESSAGE_EXTENDED_COMM_FTD_DATA_REQ_STR;
#define SIZE_COMMON_MESSAGE_EXTENDED_COMM_FTD_DATA_REQ        sizeof(COMMON_MESSAGE_EXTENDED_COMM_FTD_DATA_REQ_STR)


//Definition for struct COMMON_MESSAGE


//Definition for struct COMMON_MESSAGE_EXTENDED_COMM_FTD_DATA_RESP
#define COMMON_MESSAGE_EXTENDED_COMM_FTD_DATA_RESP            0xF0                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      type;
             uint8_t      subtype;
             uint8_t      sub_message_id;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      nbr_of_subblocks;
            } __attribute__((packed)) COMMON_MESSAGE_EXTENDED_COMM_FTD_DATA_RESP_STR;
#define SIZE_COMMON_MESSAGE_EXTENDED_COMM_FTD_DATA_RESP       sizeof(COMMON_MESSAGE_EXTENDED_COMM_FTD_DATA_RESP_STR)


//Definition for struct COMMON_MESSAGE


//Definition for struct COMMON_MESSAGE_EXTENDED_COMM_FTD_TEST_DATA_REQ
#define COMMON_MESSAGE_EXTENDED_COMM_FTD_TEST_DATA_REQ        0xF0                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      type;
             uint8_t      subtype;
             uint8_t      sub_message_id;
             uint8_t      fillerbyte1;
             uint16_t     ftd_data_item;
             uint32_t     user_provided_data;
            } __attribute__((packed)) COMMON_MESSAGE_EXTENDED_COMM_FTD_TEST_DATA_REQ_STR;
#define SIZE_COMMON_MESSAGE_EXTENDED_COMM_FTD_TEST_DATA_REQ    sizeof(COMMON_MESSAGE_EXTENDED_COMM_FTD_TEST_DATA_REQ_STR)


//Definition for struct COMMON_MESSAGE


//Definition for struct COMMON_MESSAGE_EXTENDED_COMM_FTD_TEST_DATA_RESP
#define COMMON_MESSAGE_EXTENDED_COMM_FTD_TEST_DATA_RESP       0xF0                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      type;
             uint8_t      subtype;
             uint8_t      sub_message_id;
             uint8_t      status;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) COMMON_MESSAGE_EXTENDED_COMM_FTD_TEST_DATA_RESP_STR;
#define SIZE_COMMON_MESSAGE_EXTENDED_COMM_FTD_TEST_DATA_RESP    sizeof(COMMON_MESSAGE_EXTENDED_COMM_FTD_TEST_DATA_RESP_STR)


//Definition for struct COMMON_MESSAGE


//Definition for struct COMMON_MESSAGE_EXTENDED_COMM_FTD_DATA_DEACTIVATE_REQ
#define COMMON_MESSAGE_EXTENDED_COMM_FTD_DATA_DEACTIVATE_REQ    0xF0                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      type;
             uint8_t      subtype;
             uint8_t      sub_message_id;
             uint8_t      nbr_of_ftd_data_items;
            } __attribute__((packed)) COMMON_MESSAGE_EXTENDED_COMM_FTD_DATA_DEACTIVATE_REQ_STR;
#define SIZE_COMMON_MESSAGE_EXTENDED_COMM_FTD_DATA_DEACTIVATE_REQ    sizeof(COMMON_MESSAGE_EXTENDED_COMM_FTD_DATA_DEACTIVATE_REQ_STR)


//Definition for struct COMMON_MESSAGE


//Definition for struct COMMON_MESSAGE_EXTENDED_COMM_FTD_DATA_DEACTIVATE_RESP
#define COMMON_MESSAGE_EXTENDED_COMM_FTD_DATA_DEACTIVATE_RESP    0xF0                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      type;
             uint8_t      subtype;
             uint8_t      sub_message_id;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      nbr_of_subblocks;
            } __attribute__((packed)) COMMON_MESSAGE_EXTENDED_COMM_FTD_DATA_DEACTIVATE_RESP_STR;
#define SIZE_COMMON_MESSAGE_EXTENDED_COMM_FTD_DATA_DEACTIVATE_RESP    sizeof(COMMON_MESSAGE_EXTENDED_COMM_FTD_DATA_DEACTIVATE_RESP_STR)


//Definition for struct COMMON_MESSAGE


//Definition for struct COMMON_MESSAGE_EXTENDED_COMM_PWR_OFF_CONFIRM_REQ
#define COMMON_MESSAGE_EXTENDED_COMM_PWR_OFF_CONFIRM_REQ      0xF0                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      type;
             uint8_t      subtype;
             uint8_t      sub_message_id;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
            } __attribute__((packed)) COMMON_MESSAGE_EXTENDED_COMM_PWR_OFF_CONFIRM_REQ_STR;
#define SIZE_COMMON_MESSAGE_EXTENDED_COMM_PWR_OFF_CONFIRM_REQ    sizeof(COMMON_MESSAGE_EXTENDED_COMM_PWR_OFF_CONFIRM_REQ_STR)


//Definition for struct COMMON_MESSAGE


//Definition for struct COMMON_MESSAGE_EXTENDED_COMM_PWR_OFF_CONFIRM_RESP
#define COMMON_MESSAGE_EXTENDED_COMM_PWR_OFF_CONFIRM_RESP     0xF0                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      type;
             uint8_t      subtype;
             uint8_t      sub_message_id;
             uint8_t      state;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) COMMON_MESSAGE_EXTENDED_COMM_PWR_OFF_CONFIRM_RESP_STR;
#define SIZE_COMMON_MESSAGE_EXTENDED_COMM_PWR_OFF_CONFIRM_RESP    sizeof(COMMON_MESSAGE_EXTENDED_COMM_PWR_OFF_CONFIRM_RESP_STR)


//Definition for struct COMMON_MESSAGE


//Definition for struct COMMON_MESSAGE_EXTENDED_COMM_NVD_SET_DEFAULT_REQ
#define COMMON_MESSAGE_EXTENDED_COMM_NVD_SET_DEFAULT_REQ      0xF0                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      type;
             uint8_t      subtype;
             uint8_t      sub_message_id;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
             uint32_t     reason;
            } __attribute__((packed)) COMMON_MESSAGE_EXTENDED_COMM_NVD_SET_DEFAULT_REQ_STR;
#define SIZE_COMMON_MESSAGE_EXTENDED_COMM_NVD_SET_DEFAULT_REQ    sizeof(COMMON_MESSAGE_EXTENDED_COMM_NVD_SET_DEFAULT_REQ_STR)


//Definition for struct COMMON_MESSAGE


//Definition for struct COMMON_MESSAGE_EXTENDED_COMM_NVD_SET_DEFAULT_RESP
#define COMMON_MESSAGE_EXTENDED_COMM_NVD_SET_DEFAULT_RESP     0xF0                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      type;
             uint8_t      subtype;
             uint8_t      sub_message_id;
             uint8_t      status;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) COMMON_MESSAGE_EXTENDED_COMM_NVD_SET_DEFAULT_RESP_STR;
#define SIZE_COMMON_MESSAGE_EXTENDED_COMM_NVD_SET_DEFAULT_RESP    sizeof(COMMON_MESSAGE_EXTENDED_COMM_NVD_SET_DEFAULT_RESP_STR)


//Definition for struct COMMON_MESSAGE


//Definition for struct COMMON_MESSAGE_EXTENDED_COMM_NVD_VERSION_CHK_REQ
#define COMMON_MESSAGE_EXTENDED_COMM_NVD_VERSION_CHK_REQ      0xF0                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      type;
             uint8_t      subtype;
             uint8_t      sub_message_id;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
            } __attribute__((packed)) COMMON_MESSAGE_EXTENDED_COMM_NVD_VERSION_CHK_REQ_STR;
#define SIZE_COMMON_MESSAGE_EXTENDED_COMM_NVD_VERSION_CHK_REQ    sizeof(COMMON_MESSAGE_EXTENDED_COMM_NVD_VERSION_CHK_REQ_STR)


//Definition for struct COMMON_MESSAGE


//Definition for struct COMMON_MESSAGE_EXTENDED_COMM_NVD_VERSION_CHK_RESP
#define COMMON_MESSAGE_EXTENDED_COMM_NVD_VERSION_CHK_RESP     0xF0                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      type;
             uint8_t      subtype;
             uint8_t      sub_message_id;
             uint8_t      status;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) COMMON_MESSAGE_EXTENDED_COMM_NVD_VERSION_CHK_RESP_STR;
#define SIZE_COMMON_MESSAGE_EXTENDED_COMM_NVD_VERSION_CHK_RESP    sizeof(COMMON_MESSAGE_EXTENDED_COMM_NVD_VERSION_CHK_RESP_STR)


//Definition for struct COMMON_MESSAGE


//Definition for struct COMMON_MESSAGE_EXTENDED_COMM_RF_CONTROL_REQ
#define COMMON_MESSAGE_EXTENDED_COMM_RF_CONTROL_REQ           0xF0                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      type;
             uint8_t      subtype;
             uint8_t      sub_message_id;
             uint8_t      operation;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) COMMON_MESSAGE_EXTENDED_COMM_RF_CONTROL_REQ_STR;
#define SIZE_COMMON_MESSAGE_EXTENDED_COMM_RF_CONTROL_REQ      sizeof(COMMON_MESSAGE_EXTENDED_COMM_RF_CONTROL_REQ_STR)


//Definition for struct COMMON_MESSAGE


//Definition for struct COMMON_MESSAGE_EXTENDED_COMM_RF_CONTROL_RESP
#define COMMON_MESSAGE_EXTENDED_COMM_RF_CONTROL_RESP          0xF0                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      type;
             uint8_t      subtype;
             uint8_t      sub_message_id;
             uint8_t      status;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) COMMON_MESSAGE_EXTENDED_COMM_RF_CONTROL_RESP_STR;
#define SIZE_COMMON_MESSAGE_EXTENDED_COMM_RF_CONTROL_RESP     sizeof(COMMON_MESSAGE_EXTENDED_COMM_RF_CONTROL_RESP_STR)


//Definition for struct COMMON_MESSAGE


//Definition for struct COMMON_MESSAGE_EXTENDED_COMM_SERVICE_NOT_AUTHENTICATED_RESP
#define COMMON_MESSAGE_EXTENDED_COMM_SERVICE_NOT_AUTHENTICATED_RESP    0xF0                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      type;
             uint8_t      subtype;
             uint8_t      sub_message_id;
             uint8_t      not_served_messageid;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) COMMON_MESSAGE_EXTENDED_COMM_SERVICE_NOT_AUTHENTICATED_RESP_STR;
#define SIZE_COMMON_MESSAGE_EXTENDED_COMM_SERVICE_NOT_AUTHENTICATED_RESP    sizeof(COMMON_MESSAGE_EXTENDED_COMM_SERVICE_NOT_AUTHENTICATED_RESP_STR)

#endif
