#ifndef _PN_ENERGY_ISI_H_
#define _PN_ENERGY_ISI_H_

#include <stdint.h> 

//Resource Energy Management Server
//PN_ENERGY 0x17 
//ISI version 008.026
#define ENERGY_MANAGEMENT_SERVER_ISI_VERSION_Z     8
#define ENERGY_MANAGEMENT_SERVER_ISI_VERSION_Y     26

//In case of problems concerning content of this file contact Markku Loukusa, Sauli Laukka or Markus Mrsky
//Server specific message descriptions and feature&protocol descriptions can be found from: https://oucmswww.nmp.nokia.com:58443/document_browser/ccm_wa/GIF_SPECS/ 


//ISI VERSION CHANGE HISTORY

//Version: 008.026                                           
//Status: Approved                                          
//Date: 08-Oct-2008     Aske Olsson
//Reason: SCO: 417-2595: Charger (change) indication.
//Reference: RM-RIM: 417-2595, SWAM CR: AO08090543618 , SWAM Inspection: AO08100837484, CM Synergy task id: co1core2#29647, APPROVED

//Version: 008.025                                           
//Status: Approved                                          
//Date: 15-Jul-2008     Michael Bjerking
//Reason: SCO: 408-3933 : Enable field test display support for point-based battery monitor
//Reference: RM-RIM: 408-2412, SWAM CR: None SWAM Inspection: MB08071558296, CM Synergy task id: co1core2#26225, APPROVED

//Version: 008.024                                           
//Status: Approved                                          
//Date: 03-Jul-2008     Michael Bjerking
//Reason: SCO: 408-5415 : BCOM EB3: Chipset API: Energy Management API Implementation (Phase 2 EM server)
//Reference: RM-RIM: 417-7622, SWAM CR: MB08050538512, SWAM Inspection: None, CM Synergy task id: co1core2#22663, APPROVED

//Version: 008.023                                           
//Status: Approved                                          
//Date: 16-Jun-2008     Aske Olsson
//Reason: SCO 408-3608: Dedicated charger detection production testing with ISP1704/7.
//Reference: RM-RIM: 408-3608, SWAM CR: AO08051644192, SWAM Inspection: AO08061352466, CM Synergy task id: co1core2#19597, APPROVED

//Version: 008.022                                           
//Status: Approved                                          
//Date: 03-Jun-2008     Frank Joergensen
//Reason: SCO
//Reference: RM-RIM: 408-2986, SWAM CR: FJ08042552190, CM Synergy task id (headers): co1core2#15174, CM Synergy task id (spec): co1core2#15175, APPROVED

//Version: 008.021                                           
//Status: Approved                                          
//Date: 22-Feb-2008     Aske Olsson
//Reason: SCO 408-1779: Extend the notification EM_MEASUREMENT_NTF to include battery voltage.
//Reference: RM-RIM: 408-1779, SWAM CR: AO08022552302, SWAM Inspection: AO08042547746, CM Synergy task id: co1core2#13942, APPROVED

//Version: 008.020                                           
//Status: Approved                                          
//Date: 15-Dec-2007     Frank Joergensen
//Reason: SCO, LitePlus Support
//Reference: RM-RIM: 408-2173 & 408-2670SWAM CR: FJ08010463793, CM Synergy task id (ISI C-files): co1core#90465, CM Synergy task id (ISI Spec): co1core#92192, APPROVED

//Version: 008.012                                           
//Status: Approved                                          
//Date: 15-Oct-2007     Martin Steen
//Reason: SCO 
//Reference: RM-RIM: SCO: 006-16370, 408-2046,SWAM CR: MS07100142816, SWAM Inspection: MS07101650548, CM Synergy task id: co1core#84462, APPROVED

//Version: 008.011                                           
//Status: Approved                                          
//Date: 23-May-2007     Martin Steen
//Reason: SCO 
//Reference: RM-RIM: SCO: 404-492, SWAM CR: MS07052332726, SWAM Inspection: MS07083047343, CM Synergy task id: co1core#75676, APPROVED

//Version: 008.010                                           
//Status: Approved                                          
//Date: 16-Feb-2007     Robin Hansen
//Reason: SCO 
//Reference: RM-RIM: SCO: 006-14685, SWAM CR: RH07090250880, SWAM Inspection: RH07030537867, CM Synergy task id: co1core#69220, APPROVED

//Version: 008.009                                           
//Status: Approved                                          
//Date: 05-Jan-2007     Michael Bjerking
//Reason: SCO 
//Reference: RM-RIM: SCO: 006-15266, CR: MB07011252222, ActionDB for SWAM: MB07012247812, CM Synergy task id: co1core#67139, APPROVED

//Version: 008.008                                           
//Status: Approved                                          
//Date: 08-Sep-2006     Ronny Hansen
//Reason: SCO 
//Reference: RM-RIM: SCO: 006-13026, CR: RH06090848162, ActionDB for SWAM: RH06091357937, CM Synergy task id: co1core#60472, APPROVED

//Version: 008.007                                           
//Status: Approved                                          
//Date: 17-Aug-2006     Ronny Hansen
//Reason: PCP 
//Reference: PCP Error: RH06081542680, CR: RH06081834277, ActionDB for SWAM: RH06082234515, CM Synergy task id: co1core#59009, APPROVED

//Version: 008.006                                           
//Status: Approved                                          
//Date: 07-Jun-2006     Michael Bjerking
//Reason: SCO 
//Reference: RM-RIM: 006-8980, CR: FJ06050258515, ActionDB for SWAM: RH06051753834, CM Synergy task id: co1core#52098, APPROVED

//Version: 008.005                                           
//Status: Approved                                          
//Date: 07-Apr-2006     Hongyan Sun
//Reason: SCO 
//Reference: RM-RIM 006-5989, ActionDB for SWAM: HS06032835542, CM Synergy task id: co1core#49821 and co1core#49405 , APPROVED

//Version: 008.004                                           
//Status: Approved                                          
//Date: 31-May-2005     Bjarne Glerup
//Reason: UMA and BUB added.
//Reference: ActionDB for SWAM: BG05041450145, RM-RIM 006-7490, Continuus task id: co1core#33209 and co1core#33271., APPROVED

//Version: 008.003                                           
//Status: Approved                                          
//Date: 21-Jan-2005     Knud Poulsen
//Reason: Assorted updates, comments, bugfixes.
//Reference: ActionDB for SWAM: KP05010639844, Inspection in SWAM: KP05012136979, Continuus task id: co1core#25258 and co1core#25260., APPROVED

//Version: 008.002                                           
//Status: Approved                                          
//Date: 13-Jul-2004     Knud Poulsen
//Reason: RM-RIM id 006-3127.
//Reference: ActionDB for SWAM: KP04042753279, Inspection in SWAM: KP04061442320, Continuus task id: co1core#13857 and co1core#13865., APPROVED

//Version: 008.001                                           
//Status: Approved                                          
//Date: 01-Apr-2003     Frank Joergensen
//Reason: RM-RIM id 006-2315.
//Reference: ActionDB for SWAM: FJ04032451620, Continuus task id: co_core#26823 and co_core#26824., APPROVED

//Version: 008.000                                           
//Status: Approved                                          
//Date: 10-Feb-2003     Soeren Chr. Bisgaard
//Reason: PCP Error: JN03112943738.
//Reference: ActionDB for SWAM: SB04011239570, Continuus task id: co_core#24496 and co_core#24582. Continuus task id: co_core#24685 and co_core#24709., APPROVED

//Version: 007.015                                           
//Status: Approved                                          
//Date: 19-Nov-2003     Soeren Chr. Bisgaard
//Reason: Removal of USB interface for Symbian-OS.
//Reference: ISA RM id: 010-1509, ISA RM id: 006-2435, ISA RM id: 006-2863, ActionDB for SWAM: SB03103141983, Continuus task id: co_core#22755., APPROVED

//Version: 007.014                                           
//Status: Approved                                          
//Date: 17-Oct-2003     Soeren Chr. Bisgaard
//Reason: New interface for PM and Symbian OS.
//Reference: ISA RM id: 010-1509, ISA RM id: 006-1614, ISA RM id: 006-2435, ActionDB for SWAM: SB03092927902, Continuus task id: co_core#21351., APPROVED

//Version: 007.013                                           
//Status: Approved                                          
//Date: 18-Sep-2003     Frank Joergensen
//Reason: New transfer function and Sensor changed.
//Reference: ISA RM id: 006-2259, ISA RM id: 006-1962, ActionDB for SWAM: FJ03090443402, Continuus task id: co_core#21316., APPROVED

//Version: 007.012                                           
//Status: Approved                                          
//Date: 15-Jul-2003     Emil Froeding
//Reason: Changes in EM interface for BB5 implementation and internal Compass feature.
//Reference: ISA RM id: 006-1962, ISA RM id: 006-1878, ActionDB for SWAM: EF03070749492, Continuus task id: co_core#20031., APPROVED

//Version: 007.011                                           
//Status: Approved                                          
//Date: 8-Nov-2002      Carsten Hauge
//Reason: Touchpad current consumption support.
//Reference: ISA RM id: 009-1134, ActionDB for SWAM: CH02110843061, Continuus task id: co_core#14098., APPROVED

//Version: 007.010                                           
//Status: Approved                                          
//Date: 10-Oct-2002     Carsten Hauge
//Reason: USB MM and Thermometer support and inspection of Calibration optimization in production line.
//Reference: ISA RM id: 8247 & 9449, ActionDB for SWAM: CH02101042545, Continuus task id: co_core#13339, Inspection minutes in SWAM: CH02100254109., APPROVED

//Version: 007.009                                           
//Status: Approved                                          
//Date: 18-Sep-2002     Carsten Hauge
//Reason: Calibration optimization in production.
//Reference: ISA RM id: 9128, ActionDB for SWAM: CH02091830634, Continuus task id: co_core#12701, APPROVED

//Version: 007.008                                           
//Status: Approved                                          
//Date: 5-Sep-2002      Carsten Hauge
//Reason: UEME & UEMC support.
//Reference: ISA RM id: 6342 & 4604, Continuus task id: co_core#12106, co_core#12178, APPROVED

//Version: 007.007                                           
//Status: Approved                                          
//Date: 11-Jul-2002     Carsten Hauge
//Reason: Flashlight support and use of new message macro's.
//Reference: ActionDB for SWAM: CH02071137963, ISA RM id: 5520, Continuus task id: co_core#9438., APPROVED

//Version: 007.006                                           
//Status: Approved                                          
//Date: 30-Apr-2002     Carsten Hauge
//Reason: New FTD's and Midi support.
//Reference: ActionDB for SWAM: CH02043046082 ActionDB for TEC: PP02040364886 (Midi) ActionDB for TEC: ? (FTD. See link in ActionDB for SWAM) Continuus task id: co_core#8073., APPROVED

//Version: 007.005                                           
//Status: Approved                                          
//Date: 25-Mar-2002     Carsten Hauge
//Reason: Lynx battery support.
//Reference: ActionDB for SWAM: CH02032245662 ActionDB for TEC:  PP02012047922 Continuus task id: co_core#7285., APPROVED

//Version: 007.004                                           
//Status: Approved                                          
//Date: 6-Mar-2002      Carsten Hauge
//Reason: Battery Audio Bars interface.
//Reference: ActionDB for SWAM: CH02030642364 ActionDB for TEC:  PP02022043835 Continuus task id: co_core#6921., APPROVED

//Version: 007.003                                           
//Status: Approved                                          
//Date: 19-Feb-2002     Carsten Hauge
//Reason: Redesign of EM_INFO_IND and EM_INDICATION_INFO comment added for EM_BATTERY_STATE_CHANGE.
//Reference: ActionDB for SWAM: CH02012443643 ActionDB for TEC: SH02012436608 Continuus task id: co_core#6062., APPROVED

//Version: 007.002                                           
//Status: Approved                                          
//Date: 18-Jan-2002     Carsten Hauge
//Reason: ADSP current consumption support added.
//Reference: ActionDB for SWAM: CH02011637397 ActionDB for TEC: PP02010428130 Continuus task id: co_core#5404., APPROVED

//Version: 007.001                                           
//Status: Approved                                          
//Date: 20-Dec-2001     Carsten Hauge
//Reason: ADC calibration for Cover Type Indicator (CTI).
//Reference: ActionDB for TP Software: PP01111437534. ActionDB for SWAM: CH01120338054. Continuus task id: co_core#4386, co_core#4910., APPROVED

//Version: 007.000                                           
//Status: Approved                                          
//Date: 22-Nov-2001     Carsten Hauge
//Reason: Production line need a way to tell if the sample hold circuit is defective. Backward combability to version 006.002 is removed, since it is no longer used. Tomahawk connector needs a way to tell that the DC Out uses current.
//Reference: ActionDB for TP Software: PH01101258963. ActionDB for SWAM: CH01112146479. Continuus task id: co_core#3922., APPROVED


//CONSTANTS
#define EM_INFO_NOT_KNOWN_YET                                 0x00                                                     
#define EM_INFO_NOT_SUPPORTED                                 0xFFFF                                                
#define EM_INFO_NO_SUPPORT                                    0xFF                                                  
#define EM_ANY_SIZE                                           1                                                     
#define EM_PSM_INT_DEVICE_ON                                  0x64                                                  
#define EM_PSM_INT_DEVICE_OFF                                 0x00                                                     


//TABLES

//ConstantTable for EM_CHIPSET_CAL_TYPE
#define EM_ADC_CAL_APPLIED_VOLTAGE                            0x01                                                     
#define EM_ADC_CAL_APPLIED_CURRENT                            0x02                                                     
#define EM_ADC_CAL_SENSOR                                     0x03                                                     

//ConstantTable for EM_CHIPSET_CAL_STORE
#define EM_ADC_CAL_STORE                                      0x01                                                     
#define EM_ADC_CAL_RESTORE                                    0x02                                                     
#define EM_ADC_CAL_CLEAR                                      0x03                                                     

//BitmaskTables for EM_CHIPSET_OPT_CAL
#define EM_CAL_STORE_PMM                                      0x0001                                                     
#define EM_CAL_RETURN_DATA                                    0x0002                                                     

//ConstantTable for EM_STATUS
//#define EM_INFO_NOT_KNOWN_YET                               0x00                        //Already defined as 0x00
#define EM_INFO_OK                                            0x01                                                     
#define EM_INFO_FAIL                                          0x02                                                     

//ConstantTable for EM_CHARGER_STATUS_INFO
#define EM_CHARGER_DISCONNECTED                               0x00                                                     
#define EM_CHARGER_CONNECTED                                  0x01                                                     
#define EM_CHARGER_CONNECTION_ERROR                           0x02                                                     

//ConstantTable for EM_CHARGER_TYPE_INFO
//#define EM_INFO_NOT_KNOWN_YET                               0x00                        //Already defined as 0x00
#define EM_CHARGER_TYPE_ERROR                                 0x01                                                     
#define EM_CHARGER_ACP7                                       0x02                                                     
#define EM_CHARGER_TWO_WIRES                                  0x03                                                     
#define EM_CHARGER_THREE_WIRES                                0x04                                                     
#define EM_CHARGER_VOLTAGE_ERROR                              0x05                                                     
#define EM_CHARGER_CURRENT_ERROR                              0x06                                                     
#define EM_CHARGER_SPECIAL                                    0x07                                                     
#define EM_CHARGER_USB_HOST_HUB_LOW                           0x08                                                     
#define EM_CHARGER_USB_HOST_HUB_HIGH                          0x09                                                     
#define EM_CHARGER_USB_DEDICATED_CHARGER                      0x0A                                                     
#define EM_CHARGER_USB_HOST_HUB_CHARGER_HIGH                  0x0B                                                     
#define EM_CHARGER_USB_HOST_HUB_CHARGER_FULL                  0x0C                                                     

//ConstantTable for EM_BATTERY_TYPE_INFO
//#define EM_INFO_NOT_KNOWN_YET                               0x00                        //Already defined as 0x00
#define EM_BATTERY_TYPE_SERVICE                               0x01                                                     
#define EM_BATTERY_TYPE_NICKEL                                0x02                                                     
#define EM_BATTERY_TYPE_4V1_LITHIUM                           0x03                                                     
#define EM_BATTERY_TYPE_4V2_LITHIUM                           0x04                                                     
#define EM_BATTERY_TYPE_ERROR                                 0xFFFF                                                

//ConstantTable for EM_BATTERY_GEN_INFO
#define BATTERY_GENERATION_DCT3_BSI                           0x01                                                     
#define BATTERY_GENERATION_DCT4_BSI                           0x02                                                     
#define BATTERY_GENERATION_LYNX_BSI                           0x03                                                     
#define BATTERY_GENERATION_TABBY_BSI                          0x04                                                     

//ConstantTable for EM_CHARGING_STATE_INFO
//#define EM_INFO_NOT_KNOWN_YET                               0x00                        //Already defined as 0x00
#define EM_CHARGING_STATE_OFF                                 0x01                                                     
#define EM_CHARGING_STATE_ON                                  0x02                                                     
#define EM_CHARGING_STATE_ALMOST_FULL                         0x03                                                     
#define EM_CHARGING_STATE_FULL                                0x04                                                     
#define EM_CHARGING_STATE_ERROR                               0x05                                                     
#define EM_CHARGING_STATE_CONTINUE                            0x06                                                     

//ConstantTable for EM_CHARGING_MODE_INFO
//#define EM_INFO_NOT_KNOWN_YET                               0x00                        //Already defined as 0x00
#define EM_CHARGING_NOT_CHARGING                              0x01                                                     
#define EM_CHARGING_INITIALISATION                            0x02                                                     
#define EM_CHARGING_TEMP_CHECKING                             0x03                                                     
#define EM_CHARGING_BATTERY_ERROR                             0x04                                                     
#define EM_CHARGING_CHARGE_DISABLED                           0x05                                                     
#define EM_CHARGING_DISCHARGING                               0x06                                                     
#define EM_CHARGING_CHARGER_DISCONNECTED                      0x07                                                     
#define EM_CHARGING_POWER_CONSUMING                           0x08                                                     
#define EM_CHARGING_COLD_CHARGE                               0x09                                                     
#define EM_CHARGING_HOT_CHARGE                                0x0A                                                     
#define EM_CHARGING_MAINTENANCE_CHARGE                        0x0B                                                     
#define EM_CHARGING_LITHIUM_CHARGE                            0x0C                                                     
#define EM_CHARGING_NICKEL_CHARGE                             0x0D                                                     
#define EM_CHARGING_ACTION_PAUSE                              0x0E                                                     
#define EM_CHARGING_ACTION_DISABLE                            0x0F                                                     
#define EM_CHARGING_SPECIAL_CHARGE                            0x10                                                  
#define EM_CHARGING_OVV_RECOVERY                              0x11                                                  
#define EM_CHARGING_SPECIAL_WAIT                              0x12                                                  

//ConstantTable for EM_MON_BATT_POWER_INFO
#define EM_MONITORING_BATT_OK                                 0x01                                                     
#define EM_MONITORING_BATT_LOW                                0x02                                                     
#define EM_MONITORING_BATT_EMPTY                              0x03                                                     
#define EM_MONITORING_BATT_LOW_FOR_BOOT                       0x04                                                     

//ConstantTable for EM_PSM_CS_ACTIVE_STATE_INFO
//#define EM_INFO_NOT_KNOWN_YET                               0x00                        //Already defined as 0x00
#define EM_PSM_CS_STATE_IDLE                                  0x01                                                     
#define EM_PSM_CS_STATE_NSPS                                  0x02                                                     
#define EM_PSM_CS_STATE_SCANNING                              0x03                                                     
#define EM_PSM_CS_STATE_SIGNALING                             0x04                                                     
#define EM_PSM_CS_STATE_CALL                                  0x05                                                     
#define EM_PSM_CS_STATE_CSD                                   0x06                                                     
#define EM_PSM_CS_STATE_HSCSD                                 0x07                                                     
#define EM_PSM_CS_STATE_GPRS                                  0x08                                                     
#define EM_PSM_CS_STATE_EDGE                                  0x09                                                     
#define EM_PSM_CS_STATE_DATA                                  0x0A                                                     

//ConstantTable for EM_PSM_CS_ACTIVE_PROTOCOL_INFO
//#define EM_INFO_NOT_KNOWN_YET                               0x00                        //Already defined as 0x00
#define EM_PSM_CS_PROTOCOL_GSM                                0x01                                                     
#define EM_PSM_CS_PROTOCOL_TDMA                               0x02                                                     
#define EM_PSM_CS_PROTOCOL_CDMA                               0x03                                                     
#define EM_PSM_CS_PROTOCOL_AMPS                               0x04                                                     
#define EM_PSM_CS_PROTOCOL_PDC                                0x05                                                     
#define EM_PSM_CS_PROTOCOL_WCDMA                              0x06                                                     
#define EM_PSM_CS_PROTOCOL_NMT                                0x07                                                     
#define EM_PSM_CS_PROTOCOL_TETRA                              0x08                                                     
#define EM_PSM_CS_PROTOCOL_UMA                                0x09                                                     
#define EM_PSM_CS_PROTOCOL_RF_INACTIVE                        0xFF                                                  

//ConstantTable for EM_PSM_INTERNAL_DEVICE_INFO
#define EM_PSM_INT_DISPLAY_LIGHT                              0x00                                                     
#define EM_PSM_INT_KEYBOARD_LIGHT                             0x01                                                     
#define EM_PSM_INT_VIBRA                                      0x02                                                     
#define EM_PSM_INT_BUZZER                                     0x03                                                     
#define EM_PSM_INT_IRDA                                       0x04                                                     
#define EM_PSM_INT_DC_OUT                                     0x05                                                     
#define EM_PSM_INT_RADIO                                      0x06                                                     
#define EM_PSM_INT_VIDEO                                      0x07                                                     
#define EM_PSM_INT_GPS                                        0x08                                                     
#define EM_PSM_INT_MP3                                        0x09                                                     
#define EM_PSM_INT_IHF                                        0x0A                                                     
#define EM_PSM_INT_VRR                                        0x0B                                                     
#define EM_PSM_INT_ADSP                                       0x0C                                                     
#define EM_PSM_INT_MIDI                                       0x0D                                                     
#define EM_PSM_INT_FLASHLIGHT                                 0x0E                                                     
#define EM_PSM_INT_USB                                        0x0F                                                     
#define EM_PSM_INT_TOUCHPAD                                   0x10                                                  

//ConstantTable for EM_PSM_EXTERNAL_DEVICE_INFO
#define EM_PSM_EXT_DATA_CABLE                                 0x00                                                     
#define EM_PSM_EXT_CAMERA                                     0x01                                                     
#define EM_PSM_EXT_COVER_POWER                                0x02                                                     
#define EM_PSM_EXT_BLUETOOTH                                  0x03                                                     
#define EM_PSM_EXT_SENSORS                                    0x04                                                     
#define EM_PSM_EXT_LIGHTS                                     0x05                                                     

//ConstantTable for EM_PSM_SW_FEATURE_STATUS
#define EM_PSM_SW_FEATURE_INACTIVE                            0x00                                                     
#define EM_PSM_SW_FEATURE_ACTIVE                              0x01                                                     

//ConstantTable for EM_CONTROL_DISABLE_CHARGING_INFO
#define EM_CONTROL_CHARGING_ENABLE                            0x00                                                     
#define EM_CONTROL_CHARGING_DISABLE                           0x01                                                     

//ConstantTable for EM_CONTROL_PAUSE_CHARGING_INFO
#define EM_CONTROL_CHARGING_RESUME                            0x00                                                     
#define EM_CONTROL_CHARGING_PAUSE                             0x01                                                     

//ConstantTable for EM_CONTROL_HW_VOLT_LIMIT_INFO
#define EM_CONTROL_VLIM_MINIMUM                               0x00                                                     
#define EM_CONTROL_VLIM_LITHIUM                               0x01                                                     
#define EM_CONTROL_VLIM_NICKEL                                0x02                                                     

//ConstantTable for EM_CONTROL_TX_VOLT_LIMIT_INFO
#define EM_CONTROL_TX_VLIM_ON                                 0x00                                                     
#define EM_CONTROL_TX_VLIM_OFF                                0x01                                                     

//ConstantTable for EM_CONTROL_BACKUP_BATTERY_INFO
#define EM_CONTROL_BUB_CHARGING_SW_CTRL                       0x00                                                     
#define EM_CONTROL_BUB_CHARGING_DISABLE                       0x01                                                     
#define EM_CONTROL_BUB_CHARGING_ENABLE                        0x02                                                     
#define EM_CONTROL_BUB_DISCHARGING                            0x03                                                     
#define EM_CONTROL_BUB_NO_SUPPORT                             0xFF                                                  

//ConstantTable for EM_ADC_CHANNEL_INFO
#define EM_ADC_VBAT_DIV                                       0x00                                                     
#define EM_ADC_VBAT_SCAL                                      0x01                                                     
#define EM_ADC_VCHAR                                          0x02                                                     
#define EM_ADC_ICHAR                                          0x03                                                     
#define EM_ADC_BSI                                            0x04                                                     
#define EM_ADC_BTEMP                                          0x05                                                     
#define EM_ADC_HEADINT                                        0x06                                                     
#define EM_ADC_HOOKINT                                        0x07                                                     
#define EM_ADC_LS                                             0x08                                                     
#define EM_ADC_PATEMP                                         0x09                                                     
#define EM_ADC_VCXOTEMP                                       0x0A                                                     
#define EM_ADC_KEYB1                                          0x0B                                                     
#define EM_ADC_KEYB2                                          0x0C                                                     
#define EM_ADC_VBAT_INIT                                      0x0D                                                     
#define EM_ADC_IBAT_AVG                                       0x0E                                                     
#define EM_ADC_IBAT_FAST                                      0x0F                                                     
#define EM_ADC_HEADINT2                                       0x10                                                  
#define EM_ADC_ALCO                                           0x11                                                  
#define EM_ADC_AUXDET                                         0x12                                                  
#define EM_ADC_VBACK                                          0x13                                                  
#define EM_ADC_LS_TEMP                                        0x14                                                  
#define EM_ADC_RF_MEAS                                        0x15                                                  
#define EM_ADC_WB_TX_DET                                      0x16                                                  
#define EM_ADC_RETU_TEMP                                      0x17                                                  
#define EM_ADC_VBAT_SAMPLED                                   0x18                                                  
#define EM_ADC_VBUS                                           0x19                                                  
#define EM_ADC_IDDET                                          0x1A                                                  
#define EM_ADC_TESTNET1                                       0x1B                                                  
#define EM_ADC_TESTNET2                                       0x1C                                                  
#define EM_ADC_TESTNET3                                       0x1D                                                  
#define EM_ADC_SCALE1_CAL                                     0x1E                                                  
#define EM_ADC_SCALE2_CAL                                     0x1F                                                  
#define EM_ADC_SCALE3_CAL                                     0x20                                                  
#define EM_ADC_SCALE4_CAL                                     0x21                                                  
#define EM_ADC_SCALE5_CAL                                     0x22                                                  
#define EM_ADC_TESTNET1_VCHAR_ADC                             0xDD                                                  
#define EM_ADC_TESTNET2_BSI                                   0xDE                                                  
#define EM_ADC_TESTNET3_VBAT_VANA                             0xDF                                                  
#define EM_ADC_MAIN_CAL                                       0xFE                                                  
#define EM_ADC_ALL_CAL                                        0xFF                                                  

//ConstantTable for EM_ADC_TRANSFER_FUNCTION_INFO
#define EM_ADC_NON_FLAG                                       0x00                                                     
#define EM_ADC_LIN_FLAG                                       0x01                                                     
#define EM_ADC_HYP_FLAG                                       0x02                                                     
#define EM_ADC_LOG_FLAG                                       0x03                                                     
#define EM_ADC_PARALLEL_NTC_FLAG                              0x04                                                     

//ConstantTable for EM_ADC_ACTION_INFO
#define EM_ADC_CAL_FLAG                                       0x00                                                     
#define EM_ADC_DEFAULT_FLAG                                   0x01                                                     
#define EM_ADC_ALG_FLAG                                       0x02                                                     
#define EM_ADC_STORED_MEAS_FLAG                               0x03                                                     

//ConstantTable for EM_ADC_LOCK_INFO
#define EM_ADC_LOCK_RESET_ALL                                 0x00                                                     
#define EM_ADC_LOCK_RESET                                     0x01                                                     
#define EM_ADC_LOCK_SET                                       0x02                                                     

//ConstantTable for EM_TEMPERATURE_INFO
#define EM_TEMPERATURE_OK                                     0x00                                                     
#define EM_TEMPERATURE_FAIL                                   0x01                                                     

//ConstantTable for EM_POWER_CONSUMER_INFO
#define EM_POWER_CAMERA                                       0x00                                                     
#define EM_POWER_MMC                                          0x01                                                     
#define EM_POWER_BT                                           0x02                                                     
#define EM_POWER_DISPLAY                                      0x03                                                     

//ConstantTable for EM_POWER_STATE_INFO
#define EM_POWER_OFF                                          0x00                                                     
#define EM_POWER_ON                                           0x01                                                     

//ConstantTable for EM_SOS_EVENT_INFO
#define EM_SOS_TIMER_EVENT                                    0x00                                                     

//ConstantTable for EM_ADC_ALG_ID_INFO
#define EM_ADC_ALG_NONE                                       0x00                                                     
#define EM_ADC_ALG_LIN_ADC_DEP                                0x01                                                     
#define EM_ADC_ALG_HYP_ADC_DEP                                0x02                                                     
#define EM_ADC_ALG_LOG_ADC_DEP                                0x03                                                     
#define EM_ADC_ALG_PAR_NTC                                    0x04                                                     
#define EM_ADC_ALG_LIN_BASIC                                  0x05                                                     
#define EM_ADC_ALG_LIN_BASIC_UNIT_ONLY                        0x06                                                     
#define EM_ADC_ALG_HYP_VAR_VREF                               0x07                                                     
#define EM_ADC_ALG_LIN_IBAT_ZOCUSC                            0x08                                                     

//ConstantTable for EM_MEASUREMENT_ACTION
#define EM_MEASUREMENT_ACTION_START                           0x00                                                     
#define EM_MEASUREMENT_ACTION_STOP                            0x01                                                     

//ConstantTable for EM_MEASUREMENT_VALUE
#define EM_MEASUREMENT_TYPE_CURRENT                           0x00                                                     
#define EM_MEASUREMENT_TYPE_VOLTAGE                           0x01                                                     

//ConstantTable for EM_MEASUREMENT_PERIOD
#define EM_MEASUREMENT_PERIOD_CONF_HW_RATE                    0x00                                                     
#define EM_MEASUREMENT_PERIOD_250MS                           0x01                                                     
#define EM_MEASUREMENT_PERIOD_1S                              0x02                                                     
#define EM_MEASUREMENT_PERIOD_5S                              0x03                                                     

//ConstantTable for EM_MEASUREMENT_RESULT
#define EM_MEASUREMENT_RESULT_OK                              0x00                                                     
#define EM_MEASUREMENT_RESULT_NOK                             0x01                                                     
#define EM_MEASUREMENT_RESULT_NOT_SUPPORTED                   0x02                                                     

//ConstantTable for EM_SELFTEST_ID
#define EM_SELFTEST_USB_CHARGING                              0x01                                                     

//ConstantTable for EM_SELFTEST_RESULT
#define EM_SELFTEST_RESULT_PASS                               0x00                                                     
#define EM_SELFTEST_RESULT_FAIL                               0x01                                                     
#define EM_SELFTEST_RESULT_NOT_SUPPORTED                      0x02                                                     

//ConstantTable for EM_CONTROL_USB_CHARGER_ACTION
#define EM_CONTROL_USB_CHARGER_ACTION_ENABLE                  0x00                                                     
#define EM_CONTROL_USB_CHARGER_ACTION_DISABLE                 0x01                                                     
#define EM_CONTROL_USB_CHARGER_ACTION_SET_CURRENT_100         0x02                                                     
#define EM_CONTROL_USB_CHARGER_ACTION_SET_CURRENT_500         0x03                                                     
#define EM_CONTROL_USB_CHARGER_ACTION_SET_CURRENT             0x04                                                     
#define EM_CONTROL_USB_CHARGER_ACTION_CONTROL_RELEASE         0x05                                                     
#define EM_CONTROL_USB_CHARGER_ACTION_FLOAT_VOLTAGE           0x06                                                     
#define EM_CONTROL_USB_CHARGER_ACTION_INPUT_CURRENT           0x07                                                     
#define EM_CONTROL_USB_CHARGER_ACTION_OUTPUT_CURRENT          0x08                                                     
#define EM_CONTROL_USB_CHARGER_ACTION_MSASIC_USB_CHARGING     0x09                                                     
#define EM_CONTROL_USB_CHARGER_ACTION_GET_500_100_DETECT_PIN_STATUS    0x0A                                                     
#define EM_CONTROL_USB_CHARGER_ACTION_GET_MSASIC_VBUSDET_STATUS    0x0B                                                     
#define EM_CONTROL_USB_CHARGER_ACTION_GET_CHARGER_TYPE        0x0C                                                     

//ConstantTable for EM_ME_STATE_RESULT
#define EM_ME_STATE_RESULT_OK                                 0x00                                                     
#define EM_ME_STATE_RESULT_NOK                                0x01                                                     

//ConstantTable for EM_ME_STATE_ACTION
#define EM_ME_STATE_ACTION_OFF                                0x00                                                     
#define EM_ME_STATE_ACTION_ON                                 0x01                                                     

//ConstantTable for EM_CONTROL_USB_CHARGER_TYPE_INFO
#define EM_CONTROL_USB_CHARGER_NOT_PRESENT                    0x00                                                     
#define EM_CONTROL_USB_CHARGER_DEDICATED_CHARGER              0x01                                                     
#define EM_CONTROL_USB_CHARGER_HOST_CHARGER                   0x02                                                     

//ConstantTable for EM_CONTROL_USB_CHARGER_HOST_CURRENT
#define EM_CONTROL_USB_CHARGER_HOST_CURRENT_NA                0x00                                                     
#define EM_CONTROL_USB_CHARGER_HOST_CURRENT_100               0x01                                                     
#define EM_CONTROL_USB_CHARGER_HOST_CURRENT_500               0x02                                                     

//BitmaskTables for EM_CHARGER_INFO
#define EM_CHARGER_STATUS                                     0x01                                                     
#define EM_CHARGER_TYPE                                       0x02                                                     
#define EM_CHARGER_VOLTAGE                                    0x04                                                     
#define EM_CHARGER_CURRENT                                    0x08                                                     

//BitmaskTables for EM_CONTROL_INFO
#define EM_CONTROL_DISABLE_CHARGING                           0x01                                                     
#define EM_CONTROL_PAUSE_CHARGING                             0x02                                                     
#define EM_CONTROL_HW_VOLT_LIMIT                              0x04                                                     
#define EM_CONTROL_TX_VOLT_LIMIT                              0x08                                                     
#define EM_CONTROL_BACKUP_BATTERY                             0x10                                                  
#define EM_CONTROL_PWM                                        0x20                                                  
#define EM_CONTROL_USB_CHARGER                                0x40                                                  

//BitmaskTables for EM_BATTERY_INFO
#define EM_BATTERY_TYPE                                       0x0001                                                     
#define EM_BATTERY_NOMINAL_CAPA                               0x0002                                                     
#define EM_BATTERY_TEMP                                       0x0004                                                     
#define EM_BATTERY_VOLTAGE                                    0x0008                                                     
#define EM_BATTERY_VOLTAGE_TX_ON                              0x0010                                                  
#define EM_BATTERY_VOLTAGE_TX_OFF                             0x0020                                                  
#define EM_BATTERY_VOLTAGE_PWM_ON                             0x0040                                                  
#define EM_BATTERY_VOLTAGE_PWM_OFF                            0x0080                                                  
#define EM_BATTERY_GENERATION                                 0x0100                                                   
#define EM_BATTERY_VOLTAGE_SH_CHK                             0x0200                                                   

//BitmaskTables for EM_CHARGING_INFO
#define EM_CHARGING_STATE                                     0x01                                                     
#define EM_CHARGING_MODE                                      0x02                                                     

//BitmaskTables for EM_MONITORING_INFO
#define EM_MONITORING_BATT_POWER                              0x01                                                     
#define EM_MONITORING_BATT_BARS                               0x02                                                     
#define EM_MONITORING_BATT_CAPA                               0x04                                                     
#define EM_MONITORING_BATT_TIME                               0x08                                                     
#define EM_MONITORING_BATT_AUDIO_BARS                         0x10                                                  

//BitmaskTables for EM_PSM_INFO
#define EM_PSM_BATTERY_CURRENT                                0x0001                                                     
#define EM_PSM_PHONE_CURRENT                                  0x0002                                                     
#define EM_PSM_DISCHARGE_AMOUNT                               0x0004                                                     
#define EM_PSM_CS_ACTIVE_STATE                                0x0008                                                     
#define EM_PSM_CS_ACTIVE_PROTOCOL                             0x0010                                                  
#define EM_PSM_CS_IDLE_ACTIVITY                               0x0020                                                  
#define EM_PSM_BATMON4_PHONE_STATE                            0x0040                                                  
#define EM_PSM_SW_FEATURE_COUNTER                             0x0080                                                  
#define EM_PSM_ACTIVITY                                       0x0100                                                   

//BitmaskTables for EM_PSM_ACTIVITY_INFO
#define EM_PSM_DISPLAY_LIGHT_ACTIVE                           0x00000001                                                     
#define EM_PSM_KEYBOARD_LIGHT_ACTIVE                          0x00000002                                                     
#define EM_PSM_VIBRA_ACTIVE                                   0x00000004                                                     
#define EM_PSM_BUZZER_ACTIVE                                  0x00000008                                                     
#define EM_PSM_IRDA_ACTIVE                                    0x00000010                                                  
#define EM_PSM_DC_OUT_ACTIVE                                  0x00000020                                                  
#define EM_PSM_RADIO_ACTIVE                                   0x00000040                                                  
#define EM_PSM_VIDEO_ACTIVE                                   0x00000080                                                  
#define EM_PSM_GPS_ACTIVE                                     0x00000100                                                   
#define EM_PSM_MP3_ACTIVE                                     0x00000200                                                   
#define EM_PSM_IHF_ACTIVE                                     0x00000400                                                   
#define EM_PSM_VRR_ACTIVE                                     0x00000800                                                   
#define EM_PSM_ADSP_ACTIVE                                    0x00001000                                                  
#define EM_PSM_MIDI_ACTIVE                                    0x00002000                                                  
#define EM_PSM_FLASHLIGHT_ACTIVE                              0x00004000                                                  
#define EM_PSM_USB_ACTIVE                                     0x00008000                                                  
#define EM_PSM_TOUCHPAD_ACTIVE                                0x00010000                                                 
#define EM_PSM_SENSORS_ACTIVE                                 0x08000000                                               
#define EM_PSM_BLUETOOTH_ACTIVE                               0x10000000                                            
#define EM_PSM_COVER_POWER_ACTIVE                             0x20000000                                            
#define EM_PSM_CAMERA_ACTIVE                                  0x40000000                                            
#define EM_PSM_DATA_CABLE_ACTIVE                              0x80000000                                            

//BitmaskTables for EM_INDICATION_INFO
#define EM_CHARGER_STATE_CHANGE                               0x0001                                                     
#define EM_BATTERY_STATE_CHANGE                               0x0002                                                     
#define EM_CHARGING_STATE_CHANGE                              0x0004                                                     
#define EM_MONITORING_STATE_CHANGE                            0x0008                                                     
#define EM_CS_BATTERY_EMPTY                                   0x0010                                                  

//ConstantTable for FtdTable
#define EM_SB_FTD_STATUS                                      0x0100                                                   
#define EM_SB_FTD_BAT_TYPE                                    0x0101                                                   
#define EM_SB_FTD_CURRENT_BAT_TEMP                            0x0102                                                   
#define EM_SB_FTD_INST_BAT_VOLT                               0x0103                                                   
#define EM_SB_FTD_BAT_CAPACITY                                0x0104                                                   
#define EM_SB_FTD_NUMBER_OF_BAT_BARS                          0x0105                                                   
#define EM_SB_FTD_REMAIN_STBY_HOURS                           0x0106                                                   
#define EM_SB_FTD_ELAPSED_TIME                                0x0107                                                   
#define EM_SB_FTD_DMF_BAT_VOLT                                0x0108                                                   
#define EM_SB_FTD_REMAIN_STBY_MINUTES                         0x0109                                                   
#define EM_SB_FTD_PHI_VARIABLE                                0x010A                                                   
#define EM_SB_FTD_VOLT_AT_FIRST_BAT_LOW                       0x010B                                                   
#define EM_SB_FTD_DELTA_PHI_VARIABLE                          0x010C                                                   
#define EM_SB_FTD_NUMBER_BAT_LOW_WARN                         0x010D                                                   
#define EM_SB_FTD_PARAM_ERRORS                                0x010E                                                   
#define EM_SB_FTD_CS_IDLE_ACTIVITY                            0x010F                                                   
#define EM_SB_FTD_CS_STATE                                    0x0110                                                   
#define EM_SB_FTD_CS_PROTOCOL                                 0x0111                                                   
#define EM_SB_FTD_BAT_CURRENT                                 0x0112                                                   
#define EM_SB_FTD_PHONE_CURRENT                               0x0113                                                   
#define EM_SB_FTD_FEATURE_CURRENT                             0x0114                                                   
#define EM_SB_FTD_DISCHARGE_AMOUNT                            0x0115                                                   
#define EM_SB_FTD_BATMON4_STATE                               0x0116                                                   
#define EM_SB_FTD_PRESENT_CHR_TYPE                            0x0117                                                   
#define EM_SB_FTD_PREVIOUS_CHR_TYPE                           0x0118                                                   
#define EM_SB_FTD_AVERAGE_CHR_VOLT                            0x0119                                                   
#define EM_SB_FTD_CALC_CHR_CURRENT                            0x011A                                                   
#define EM_SB_FTD_CHR_REC_STATE                               0x011B                                                   
#define EM_SB_FTD_NUMBER_CHR_CHECKS                           0x011C                                                   
#define EM_SB_FTD_PRESENT_CHA_MODE                            0x011D                                                   
#define EM_SB_FTD_PREVIOUS_CHA_MODE                           0x011E                                                   
#define EM_SB_FTD_PWM_FREQ                                    0x011F                                                   
#define EM_SB_FTD_CHA_TIME                                    0x0120                                                   
#define EM_SB_FTD_CHA_INST_BAT_VOLT                           0x0121                                                   
#define EM_SB_FTD_OS_PWM_BAT_VOLT                             0x0122                                                   
#define EM_SB_FTD_CS_PWM_BAT_VOLT                             0x0123                                                   
#define EM_SB_FTD_INST_CHR_CURRENT                            0x0124                                                   
#define EM_SB_FTD_BAT_FULL_FLAG                               0x0125                                                   
#define EM_SB_FTD_CHA_MODE                                    0x0126                                                   
#define EM_SB_FTD_OS_DV_DETECT                                0x0127                                                   
#define EM_SB_FTD_SLOW_DV_DETECT                              0x0128                                                   
#define EM_SB_FTD_DV_OVER_TIME_DETECT                         0x0129                                                   
#define EM_SB_FTD_CHARGE_AMOUNT_DETECT                        0x012A                                                   
#define EM_SB_FTD_BAT_VOLT_DETECT                             0x012B                                                   
#define EM_SB_FTD_BAT_TEMP_DETECT                             0x012C                                                   
#define EM_SB_FTD_FUZZY_SUM                                   0x012D                                                   
#define EM_SB_FTD_MAINTENANCE_CHA_TIME                        0x012E                                                   
#define EM_SB_FTD_OS_DV_OVER_TIME                             0x012F                                                   
#define EM_SB_FTD_ACTIVITY_BYTE1                              0x0130                                                   
#define EM_SB_FTD_ACTIVITY_BYTE2                              0x0131                                                   
#define EM_SB_FTD_ACTIVITY_BYTE3                              0x0132                                                   
#define EM_SB_FTD_ACTIVITY_BYTE4                              0x0133                                                   
#define EM_SB_FTD_VERSIONNO                                   0x0134                                                   
#define EM_SB_FTD_ACTIVE_SW_FEATURE                           0x0135                                                   
#define EM_SB_FTD_SW_PWM_VALUE                                0x0136                                                   
#define EM_SB_FTD_OVV_LIMIT                                   0x0137                                                   
#define EM_SB_FTD_BUB_CHARGING                                0x0138                                                   
#define EM_SB_FTD_EST_TX_OFF                                  0x0139                                                   
#define EM_SB_FTD_MEAS_TX_ON                                  0x013A                                                   
#define EM_SB_FTD_MISC_MON_INT_FLAGS1                         0x013B                                                   
#define EM_SB_FTD_BAT_POW_IND                                 0x013C                                                   
#define EM_SB_FTD_CALC_VOLT_LEVEL                             0x013D                                                   
#define EM_SB_FTD_WARN_COUNT                                  0x013E                                                   
#define EM_SB_FTD_MISC_MON_INT_FLAGS2                         0x013F                                                   
#define EM_SB_FTD_CURRENT_MON_EST1                            0x0140                                                   
#define EM_SB_FTD_MON_VOLT                                    0x0141                                                   
#define EM_SB_FTD_MISC_MON_INT_FLAGS3                         0x0142                                                   
#define EM_SB_FTD_CURRENT_MON_EST2                            0x0143                                                   
#define EM_SB_FTD_CALC_BAT_BAR                                0x0144                                                   
#define EM_SB_FTD_CONF_MIN_CURRENT                            0x0145                                                   
#define EM_SB_FTD_BAT_IMP                                     0x0146                                                   
#define EM_SB_FTD_BAT_FULL_THRES                              0x0147                                                   
#define EM_SB_FTD_BAT_LOW_THRES                               0x0148                                                   
#define EM_SB_FTD_BAT_BOOT_VOLT                               0x0149                                                   
#define EM_SB_FTD_CONF_BAT_SAFETY_LEVEL                       0x014A                                                   
#define EM_SB_FTD_CONF_BAT_EMPTY_LEVEL                        0x014B                                                   
#define EM_SB_FTD_MON_ALG_ADJ                                 0x014C                                                   
#define EM_SB_FTD_CONF_BAT_FOOTPRINT                          0x014D                                                   
#define EM_SB_FTD_CONF_BAT_BARS                               0x014E                                                   
#define EM_SB_FTD_CHARGED_AMOUNT                              0x014F                                                   
#define EM_SB_FTD_HW_PWM_VALUE                                0x0150                                                   
#define EM_SB_FTD_STRING1                                     0x0151                                                   
#define EM_SB_FTD_STRING2                                     0x0152                                                   
#define EM_SB_FTD_STRING3                                     0x0153                                                   
#define EM_SB_FTD_STRING4                                     0x0154                                                   
#define EM_SB_FTD_STRING5                                     0x0155                                                   
#define EM_SB_FTD_STRING6                                     0x0156                                                   
#define EM_SB_FTD_STRING7                                     0x0157                                                   
#define EM_SB_FTD_STRING8                                     0x0158                                                   
#define EM_SB_FTD_REMAIN_PROMILLE                             0x0159                                                   
#define EM_SB_FTD_DELTA_CAPACITY                              0x015A                                                   
#define EM_SB_FTD_REMAIN_CAPACITY                             0x015B                                                   


//STRUCTURES


//Definition for struct EM_ADC_CAL_RAW_MEAS_RESULT_SEQ_ENTRY
typedef struct
            { 
             uint8_t      adc_channel;
             uint8_t      fillerbyte1;
             int16_t      meas_cal_ref;
             uint16_t     meas_raw_reading;
             uint16_t     fillerbyte2;
            } __attribute__((packed)) EM_ADC_CAL_RAW_MEAS_RESULT_SEQ_ENTRY_STR;
#define SIZE_EM_ADC_CAL_RAW_MEAS_RESULT_SEQ_ENTRY             sizeof(EM_ADC_CAL_RAW_MEAS_RESULT_SEQ_ENTRY_STR)


//SUBBLOCKS


//Definition for struct EM_CHARGER_STATUS_DATA
#define EM_CHARGER_STATUS_DATA                                0x00                                                     
typedef struct
            { 
             uint8_t      sb_id;
             uint8_t      sb_size;
             uint8_t      req_data;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) EM_CHARGER_STATUS_DATA_STR;
#define SIZE_EM_CHARGER_STATUS_DATA                           sizeof(EM_CHARGER_STATUS_DATA_STR)


//Definition for struct EM_CHARGER_TYPE_DATA
#define EM_CHARGER_TYPE_DATA                                  0x01                                                     
typedef struct
            { 
             uint8_t      sb_id;
             uint8_t      sb_size;
             uint8_t      req_data;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) EM_CHARGER_TYPE_DATA_STR;
#define SIZE_EM_CHARGER_TYPE_DATA                             sizeof(EM_CHARGER_TYPE_DATA_STR)


//Definition for struct EM_CHARGER_VOLTAGE_DATA
#define EM_CHARGER_VOLTAGE_DATA                               0x02                                                     
typedef struct
            { 
             uint8_t      sb_id;
             uint8_t      sb_size;
             uint16_t     req_data;
            } __attribute__((packed)) EM_CHARGER_VOLTAGE_DATA_STR;
#define SIZE_EM_CHARGER_VOLTAGE_DATA                          sizeof(EM_CHARGER_VOLTAGE_DATA_STR)


//Definition for struct EM_CHARGER_CURRENT_DATA
#define EM_CHARGER_CURRENT_DATA                               0x03                                                     
typedef struct
            { 
             uint8_t      sb_id;
             uint8_t      sb_size;
             uint16_t     req_data;
            } __attribute__((packed)) EM_CHARGER_CURRENT_DATA_STR;
#define SIZE_EM_CHARGER_CURRENT_DATA                          sizeof(EM_CHARGER_CURRENT_DATA_STR)


//Definition for struct EM_CONTROL_DISABLE_CHARGING_DATA
#define EM_CONTROL_DISABLE_CHARGING_DATA                      0x04                                                     
typedef struct
            { 
             uint8_t      sb_id;
             uint8_t      sb_size;
             uint8_t      req_data;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) EM_CONTROL_DISABLE_CHARGING_DATA_STR;
#define SIZE_EM_CONTROL_DISABLE_CHARGING_DATA                 sizeof(EM_CONTROL_DISABLE_CHARGING_DATA_STR)


//Definition for struct EM_CONTROL_PAUSE_CHARGING_DATA
#define EM_CONTROL_PAUSE_CHARGING_DATA                        0x05                                                     
typedef struct
            { 
             uint8_t      sb_id;
             uint8_t      sb_size;
             uint8_t      req_data;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) EM_CONTROL_PAUSE_CHARGING_DATA_STR;
#define SIZE_EM_CONTROL_PAUSE_CHARGING_DATA                   sizeof(EM_CONTROL_PAUSE_CHARGING_DATA_STR)


//Definition for struct EM_CONTROL_HW_VOLT_LIMIT_DATA
#define EM_CONTROL_HW_VOLT_LIMIT_DATA                         0x06                                                     
typedef struct
            { 
             uint8_t      sb_id;
             uint8_t      sb_size;
             uint8_t      req_data;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) EM_CONTROL_HW_VOLT_LIMIT_DATA_STR;
#define SIZE_EM_CONTROL_HW_VOLT_LIMIT_DATA                    sizeof(EM_CONTROL_HW_VOLT_LIMIT_DATA_STR)


//Definition for struct EM_CONTROL_TX_VOLT_LIMIT_DATA
#define EM_CONTROL_TX_VOLT_LIMIT_DATA                         0x07                                                     
typedef struct
            { 
             uint8_t      sb_id;
             uint8_t      sb_size;
             uint8_t      req_data;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) EM_CONTROL_TX_VOLT_LIMIT_DATA_STR;
#define SIZE_EM_CONTROL_TX_VOLT_LIMIT_DATA                    sizeof(EM_CONTROL_TX_VOLT_LIMIT_DATA_STR)


//Definition for struct EM_CONTROL_BACKUP_BATTERY_DATA
#define EM_CONTROL_BACKUP_BATTERY_DATA                        0x08                                                     
typedef struct
            { 
             uint8_t      sb_id;
             uint8_t      sb_size;
             uint8_t      req_data;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) EM_CONTROL_BACKUP_BATTERY_DATA_STR;
#define SIZE_EM_CONTROL_BACKUP_BATTERY_DATA                   sizeof(EM_CONTROL_BACKUP_BATTERY_DATA_STR)


//Definition for struct EM_CONTROL_PWM_DATA
#define EM_CONTROL_PWM_DATA                                   0x09                                                     
typedef struct
            { 
             uint8_t      sb_id;
             uint8_t      sb_size;
             uint8_t      req_data0;
             uint8_t      req_data1;
            } __attribute__((packed)) EM_CONTROL_PWM_DATA_STR;
#define SIZE_EM_CONTROL_PWM_DATA                              sizeof(EM_CONTROL_PWM_DATA_STR)


//Definition for struct EM_BATTERY_TYPE_DATA
#define EM_BATTERY_TYPE_DATA                                  0x0A                                                     
typedef struct
            { 
             uint8_t      sb_id;
             uint8_t      sb_size;
             uint16_t     req_data;
            } __attribute__((packed)) EM_BATTERY_TYPE_DATA_STR;
#define SIZE_EM_BATTERY_TYPE_DATA                             sizeof(EM_BATTERY_TYPE_DATA_STR)


//Definition for struct EM_BATTERY_NOMINAL_CAPA_DATA
#define EM_BATTERY_NOMINAL_CAPA_DATA                          0x0B                                                     
typedef struct
            { 
             uint8_t      sb_id;
             uint8_t      sb_size;
             uint16_t     req_data;
            } __attribute__((packed)) EM_BATTERY_NOMINAL_CAPA_DATA_STR;
#define SIZE_EM_BATTERY_NOMINAL_CAPA_DATA                     sizeof(EM_BATTERY_NOMINAL_CAPA_DATA_STR)


//Definition for struct EM_BATTERY_TEMP_DATA
#define EM_BATTERY_TEMP_DATA                                  0x0C                                                     
typedef struct
            { 
             uint8_t      sb_id;
             uint8_t      sb_size;
             uint16_t     req_data;
            } __attribute__((packed)) EM_BATTERY_TEMP_DATA_STR;
#define SIZE_EM_BATTERY_TEMP_DATA                             sizeof(EM_BATTERY_TEMP_DATA_STR)


//Definition for struct EM_BATTERY_VOLTAGE_DATA
#define EM_BATTERY_VOLTAGE_DATA                               0x0D                                                     
typedef struct
            { 
             uint8_t      sb_id;
             uint8_t      sb_size;
             uint16_t     req_data;
            } __attribute__((packed)) EM_BATTERY_VOLTAGE_DATA_STR;
#define SIZE_EM_BATTERY_VOLTAGE_DATA                          sizeof(EM_BATTERY_VOLTAGE_DATA_STR)


//Definition for struct EM_BATTERY_VOLTAGE_TX_ON_DATA
#define EM_BATTERY_VOLTAGE_TX_ON_DATA                         0x0E                                                     
typedef struct
            { 
             uint8_t      sb_id;
             uint8_t      sb_size;
             uint16_t     req_data;
            } __attribute__((packed)) EM_BATTERY_VOLTAGE_TX_ON_DATA_STR;
#define SIZE_EM_BATTERY_VOLTAGE_TX_ON_DATA                    sizeof(EM_BATTERY_VOLTAGE_TX_ON_DATA_STR)


//Definition for struct EM_BATTERY_VOLTAGE_TX_OFF_DATA
#define EM_BATTERY_VOLTAGE_TX_OFF_DATA                        0x0F                                                     
typedef struct
            { 
             uint8_t      sb_id;
             uint8_t      sb_size;
             uint16_t     req_data;
            } __attribute__((packed)) EM_BATTERY_VOLTAGE_TX_OFF_DATA_STR;
#define SIZE_EM_BATTERY_VOLTAGE_TX_OFF_DATA                   sizeof(EM_BATTERY_VOLTAGE_TX_OFF_DATA_STR)


//Definition for struct EM_BATTERY_VOLTAGE_PWM_ON_DATA
#define EM_BATTERY_VOLTAGE_PWM_ON_DATA                        0x10                                                  
typedef struct
            { 
             uint8_t      sb_id;
             uint8_t      sb_size;
             uint16_t     req_data;
            } __attribute__((packed)) EM_BATTERY_VOLTAGE_PWM_ON_DATA_STR;
#define SIZE_EM_BATTERY_VOLTAGE_PWM_ON_DATA                   sizeof(EM_BATTERY_VOLTAGE_PWM_ON_DATA_STR)


//Definition for struct EM_BATTERY_VOLTAGE_PWM_OFF_DATA
#define EM_BATTERY_VOLTAGE_PWM_OFF_DATA                       0x11                                                  
typedef struct
            { 
             uint8_t      sb_id;
             uint8_t      sb_size;
             uint16_t     req_data;
            } __attribute__((packed)) EM_BATTERY_VOLTAGE_PWM_OFF_DATA_STR;
#define SIZE_EM_BATTERY_VOLTAGE_PWM_OFF_DATA                  sizeof(EM_BATTERY_VOLTAGE_PWM_OFF_DATA_STR)


//Definition for struct EM_BATTERY_GENERATION_DATA
#define EM_BATTERY_GENERATION_DATA                            0x12                                                  
typedef struct
            { 
             uint8_t      sb_id;
             uint8_t      sb_size;
             uint16_t     req_data;
            } __attribute__((packed)) EM_BATTERY_GENERATION_DATA_STR;
#define SIZE_EM_BATTERY_GENERATION_DATA                       sizeof(EM_BATTERY_GENERATION_DATA_STR)


//Definition for struct EM_BATTERY_VOLTAGE_SH_CHK_DATA
#define EM_BATTERY_VOLTAGE_SH_CHK_DATA                        0x22                                                  
typedef struct
            { 
             uint8_t      sb_id;
             uint8_t      sb_size;
             uint16_t     req_data;
            } __attribute__((packed)) EM_BATTERY_VOLTAGE_SH_CHK_DATA_STR;
#define SIZE_EM_BATTERY_VOLTAGE_SH_CHK_DATA                   sizeof(EM_BATTERY_VOLTAGE_SH_CHK_DATA_STR)


//Definition for struct EM_CHARGING_STATE_DATA
#define EM_CHARGING_STATE_DATA                                0x13                                                  
typedef struct
            { 
             uint8_t      sb_id;
             uint8_t      sb_size;
             uint8_t      req_data;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) EM_CHARGING_STATE_DATA_STR;
#define SIZE_EM_CHARGING_STATE_DATA                           sizeof(EM_CHARGING_STATE_DATA_STR)


//Definition for struct EM_CHARGING_MODE_DATA
#define EM_CHARGING_MODE_DATA                                 0x14                                                  
typedef struct
            { 
             uint8_t      sb_id;
             uint8_t      sb_size;
             uint8_t      req_data;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) EM_CHARGING_MODE_DATA_STR;
#define SIZE_EM_CHARGING_MODE_DATA                            sizeof(EM_CHARGING_MODE_DATA_STR)


//Definition for struct EM_MONITORING_BATT_POWER_DATA
#define EM_MONITORING_BATT_POWER_DATA                         0x15                                                  
typedef struct
            { 
             uint8_t      sb_id;
             uint8_t      sb_size;
             uint8_t      req_data;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) EM_MONITORING_BATT_POWER_DATA_STR;
#define SIZE_EM_MONITORING_BATT_POWER_DATA                    sizeof(EM_MONITORING_BATT_POWER_DATA_STR)


//Definition for struct EM_MONITORING_BATT_BARS_DATA
#define EM_MONITORING_BATT_BARS_DATA                          0x16                                                  
typedef struct
            { 
             uint8_t      sb_id;
             uint8_t      sb_size;
             uint8_t      req_data0;
             uint8_t      req_data1;
            } __attribute__((packed)) EM_MONITORING_BATT_BARS_DATA_STR;
#define SIZE_EM_MONITORING_BATT_BARS_DATA                     sizeof(EM_MONITORING_BATT_BARS_DATA_STR)


//Definition for struct EM_MONITORING_BATT_CAPA_DATA
#define EM_MONITORING_BATT_CAPA_DATA                          0x17                                                  
typedef struct
            { 
             uint8_t      sb_id;
             uint8_t      sb_size;
             uint16_t     eminfobattcap;
            } __attribute__((packed)) EM_MONITORING_BATT_CAPA_DATA_STR;
#define SIZE_EM_MONITORING_BATT_CAPA_DATA                     sizeof(EM_MONITORING_BATT_CAPA_DATA_STR)


//Definition for struct EM_MONITORING_BATT_TIME_DATA
#define EM_MONITORING_BATT_TIME_DATA                          0x18                                                  
typedef struct
            { 
             uint8_t      sb_id;
             uint8_t      sb_size;
             uint16_t     eminfobatttime;
            } __attribute__((packed)) EM_MONITORING_BATT_TIME_DATA_STR;
#define SIZE_EM_MONITORING_BATT_TIME_DATA                     sizeof(EM_MONITORING_BATT_TIME_DATA_STR)


//Definition for struct EM_MONITORING_BATTAUDIOBARS_DATA
#define EM_MONITORING_BATTAUDIOBARS_DATA                      0x25                                                  
typedef struct
            { 
             uint8_t      sb_id;
             uint8_t      sb_size;
             uint8_t      req_data0;
             uint8_t      req_data1;
            } __attribute__((packed)) EM_MONITORING_BATTAUDIOBARS_DATA_STR;
#define SIZE_EM_MONITORING_BATTAUDIOBARS_DATA                 sizeof(EM_MONITORING_BATTAUDIOBARS_DATA_STR)


//Definition for struct EM_PSM_BATTERY_CURRENT_DATA
#define EM_PSM_BATTERY_CURRENT_DATA                           0x19                                                  
typedef struct
            { 
             uint8_t      sb_id;
             uint8_t      sb_size;
             int16_t      req_data;
            } __attribute__((packed)) EM_PSM_BATTERY_CURRENT_DATA_STR;
#define SIZE_EM_PSM_BATTERY_CURRENT_DATA                      sizeof(EM_PSM_BATTERY_CURRENT_DATA_STR)


//Definition for struct EM_PSM_PHONE_CURRENT_DATA
#define EM_PSM_PHONE_CURRENT_DATA                             0x1A                                                  
typedef struct
            { 
             uint8_t      sb_id;
             uint8_t      sb_size;
             uint16_t     req_data;
            } __attribute__((packed)) EM_PSM_PHONE_CURRENT_DATA_STR;
#define SIZE_EM_PSM_PHONE_CURRENT_DATA                        sizeof(EM_PSM_PHONE_CURRENT_DATA_STR)


//Definition for struct EM_PSM_DISCHARGE_AMOUNT_DATA
#define EM_PSM_DISCHARGE_AMOUNT_DATA                          0x1B                                                  
typedef struct
            { 
             uint8_t      sb_id;
             uint8_t      sb_size;
             int16_t      req_data;
            } __attribute__((packed)) EM_PSM_DISCHARGE_AMOUNT_DATA_STR;
#define SIZE_EM_PSM_DISCHARGE_AMOUNT_DATA                     sizeof(EM_PSM_DISCHARGE_AMOUNT_DATA_STR)


//Definition for struct EM_PSM_CS_ACTIVE_STATE_DATA
#define EM_PSM_CS_ACTIVE_STATE_DATA                           0x1C                                                  
typedef struct
            { 
             uint8_t      sb_id;
             uint8_t      sb_size;
             uint8_t      req_data;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) EM_PSM_CS_ACTIVE_STATE_DATA_STR;
#define SIZE_EM_PSM_CS_ACTIVE_STATE_DATA                      sizeof(EM_PSM_CS_ACTIVE_STATE_DATA_STR)


//Definition for struct EM_PSM_CS_ACTIVE_PROTOCOL_DATA
#define EM_PSM_CS_ACTIVE_PROTOCOL_DATA                        0x1D                                                  
typedef struct
            { 
             uint8_t      sb_id;
             uint8_t      sb_size;
             uint8_t      req_data;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) EM_PSM_CS_ACTIVE_PROTOCOL_DATA_STR;
#define SIZE_EM_PSM_CS_ACTIVE_PROTOCOL_DATA                   sizeof(EM_PSM_CS_ACTIVE_PROTOCOL_DATA_STR)


//Definition for struct EM_PSM_CS_IDLE_ACTIVITY_DATA
#define EM_PSM_CS_IDLE_ACTIVITY_DATA                          0x1E                                                  
typedef struct
            { 
             uint8_t      sb_id;
             uint8_t      sb_size;
             uint8_t      req_data;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) EM_PSM_CS_IDLE_ACTIVITY_DATA_STR;
#define SIZE_EM_PSM_CS_IDLE_ACTIVITY_DATA                     sizeof(EM_PSM_CS_IDLE_ACTIVITY_DATA_STR)


//Definition for struct EM_PSM_BATMON4_PHONE_STATE_DATA
#define EM_PSM_BATMON4_PHONE_STATE_DATA                       0x1F                                                  
typedef struct
            { 
             uint8_t      sb_id;
             uint8_t      sb_size;
             uint16_t     req_data;
            } __attribute__((packed)) EM_PSM_BATMON4_PHONE_STATE_DATA_STR;
#define SIZE_EM_PSM_BATMON4_PHONE_STATE_DATA                  sizeof(EM_PSM_BATMON4_PHONE_STATE_DATA_STR)


//Definition for struct EM_PSM_SW_FEATURE_COUNTER_DATA
#define EM_PSM_SW_FEATURE_COUNTER_DATA                        0x20                                                  
typedef struct
            { 
             uint8_t      sb_id;
             uint8_t      sb_size;
             uint16_t     req_data;
            } __attribute__((packed)) EM_PSM_SW_FEATURE_COUNTER_DATA_STR;
#define SIZE_EM_PSM_SW_FEATURE_COUNTER_DATA                   sizeof(EM_PSM_SW_FEATURE_COUNTER_DATA_STR)


//Definition for struct EM_PSM_ACTIVITY_DATA
#define EM_PSM_ACTIVITY_DATA                                  0x21                                                  
typedef struct
            { 
             uint8_t      sb_id;
             uint8_t      sb_size;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint32_t     req_data;
            } __attribute__((packed)) EM_PSM_ACTIVITY_DATA_STR;
#define SIZE_EM_PSM_ACTIVITY_DATA                             sizeof(EM_PSM_ACTIVITY_DATA_STR)


//Definition for struct EM_ADC_CAL_GEN_DATA
#define EM_ADC_CAL_GEN_DATA                                   0x23                                                  
typedef struct
            { 
             uint8_t      sb_id;
             uint8_t      sb_size;
             uint8_t      data0;
             uint8_t      data1;
             uint32_t     data2;
             uint32_t     data3;
            } __attribute__((packed)) EM_ADC_CAL_GEN_DATA_STR;
#define SIZE_EM_ADC_CAL_GEN_DATA                              sizeof(EM_ADC_CAL_GEN_DATA_STR)


//Definition for struct EM_ADC_CAL_LOG_DATA
#define EM_ADC_CAL_LOG_DATA                                   0x24                                                  
typedef struct
            { 
             uint8_t      sb_id;
             uint8_t      sb_size;
             uint8_t      data0;
             uint8_t      data1;
             uint16_t     data2;
             uint16_t     data3;
             uint16_t     data4;
             uint16_t     fillerbyte1;
            } __attribute__((packed)) EM_ADC_CAL_LOG_DATA_STR;
#define SIZE_EM_ADC_CAL_LOG_DATA                              sizeof(EM_ADC_CAL_LOG_DATA_STR)


//Definition for struct EM_ADC_CAL_ALG_DATA
#define EM_ADC_CAL_ALG_DATA                                   0x29                                                  
typedef struct
            { 
             uint8_t      sb_id;
             uint8_t      sb_size;
             uint8_t      data0;
             uint8_t      data1;
             uint16_t     data2;
             uint16_t     data3;
             uint16_t     data4;
             uint16_t     data5;
            } __attribute__((packed)) EM_ADC_CAL_ALG_DATA_STR;
#define SIZE_EM_ADC_CAL_ALG_DATA                              sizeof(EM_ADC_CAL_ALG_DATA_STR)


//Definition for struct EM_ADC_CAL_STORED_MEAS_DATA
#define EM_ADC_CAL_STORED_MEAS_DATA                           0x2D                                                  
typedef struct
            { 
             uint8_t      sb_id;
             uint8_t      sb_size;
             uint8_t      num_of_meas;
             uint8_t      fillerbyte1;
             EM_ADC_CAL_RAW_MEAS_RESULT_SEQ_ENTRY_STR    measurement_table[0];
            } __attribute__((packed)) EM_ADC_CAL_STORED_MEAS_DATA_STR;
#define SIZE_EM_ADC_CAL_STORED_MEAS_DATA                      sizeof(EM_ADC_CAL_STORED_MEAS_DATA_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct EM_ADC_CAL_TUNE_REQ_DATA
#define EM_ADC_CAL_TUNE_REQ_DATA                              0x26                                                  
typedef struct
            { 
             uint8_t      sb_id;
             uint8_t      sb_size;
             uint8_t      channel_id;
             uint8_t      sample_amount;
             int16_t      trigger_level;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) EM_ADC_CAL_TUNE_REQ_DATA_STR;
#define SIZE_EM_ADC_CAL_TUNE_REQ_DATA                         sizeof(EM_ADC_CAL_TUNE_REQ_DATA_STR)


//Definition for struct EM_ADC_CAL_TUNE_RESP_DATA
#define EM_ADC_CAL_TUNE_RESP_DATA                             0x27                                                  
typedef struct
            { 
             uint8_t      sb_id;
             uint8_t      sb_size;
             uint8_t      channel_id;
             uint8_t      status;
             int16_t      measured_value;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) EM_ADC_CAL_TUNE_RESP_DATA_STR;
#define SIZE_EM_ADC_CAL_TUNE_RESP_DATA                        sizeof(EM_ADC_CAL_TUNE_RESP_DATA_STR)


//Definition for struct EM_SOS_TIMER_EVENT_DATA
#define EM_SOS_TIMER_EVENT_DATA                               0x28                                                  
typedef struct
            { 
             uint8_t      sb_id;
             uint8_t      sb_size;
             uint16_t     req_data;
            } __attribute__((packed)) EM_SOS_TIMER_EVENT_DATA_STR;
#define SIZE_EM_SOS_TIMER_EVENT_DATA                          sizeof(EM_SOS_TIMER_EVENT_DATA_STR)


//Definition for struct EM_MEASUREMENT_TYPE
#define EM_MEASUREMENT_TYPE                                   0x2A                                                  
typedef struct
            { 
             uint8_t      sb_id;
             uint8_t      sb_size;
             uint8_t      type;
             uint8_t      period;
            } __attribute__((packed)) EM_MEASUREMENT_TYPE_STR;
#define SIZE_EM_MEASUREMENT_TYPE                              sizeof(EM_MEASUREMENT_TYPE_STR)


//Definition for struct EM_MEASUREMENT
#define EM_MEASUREMENT                                        0x2B                                                  
typedef struct
            { 
             uint8_t      sb_id;
             uint8_t      sb_size;
             uint8_t      type;
             uint8_t      fillerbyte1;
             uint32_t     time;
             uint32_t     value;
            } __attribute__((packed)) EM_MEASUREMENT_STR;
#define SIZE_EM_MEASUREMENT                                   sizeof(EM_MEASUREMENT_STR)


//Definition for struct EM_CONTROL_USB_CHARGER_DATA
#define EM_CONTROL_USB_CHARGER_DATA                           0x2C                                                  
typedef struct
            { 
             uint8_t      sb_id;
             uint8_t      sb_size;
             uint8_t      action;
             uint8_t      fillerbyte1;
             uint32_t     value;
            } __attribute__((packed)) EM_CONTROL_USB_CHARGER_DATA_STR;
#define SIZE_EM_CONTROL_USB_CHARGER_DATA                      sizeof(EM_CONTROL_USB_CHARGER_DATA_STR)


//Definition for struct EM_CONTROL_USB_CHARGER_TYPE
#define EM_CONTROL_USB_CHARGER_TYPE                           0x2E                                                  
typedef struct
            { 
             uint8_t      sb_id;
             uint8_t      sb_size;
             uint8_t      type;
             uint8_t      current;
            } __attribute__((packed)) EM_CONTROL_USB_CHARGER_TYPE_STR;
#define SIZE_EM_CONTROL_USB_CHARGER_TYPE                      sizeof(EM_CONTROL_USB_CHARGER_TYPE_STR)


//Definition for struct EM_ADC_CHIPSET_CAL_CALCULATE_REQ_DATA
#define EM_ADC_CHIPSET_CAL_CALCULATE_REQ_DATA                 0x2F                                                  
typedef struct
            { 
             uint8_t      sb_id;
             uint8_t      sb_size;
             uint8_t      data0;
             uint8_t      type;
             uint16_t     adc_raw_reading;
             uint16_t     fillerbyte1;
             int32_t      reference_value;
             uint32_t     identification;
            } __attribute__((packed)) EM_ADC_CHIPSET_CAL_CALCULATE_REQ_DATA_STR;
#define SIZE_EM_ADC_CHIPSET_CAL_CALCULATE_REQ_DATA            sizeof(EM_ADC_CHIPSET_CAL_CALCULATE_REQ_DATA_STR)


//Definition for struct EM_ADC_CHIPSET_CAL_READ_REQ_DATA
#define EM_ADC_CHIPSET_CAL_READ_REQ_DATA                      0x31                                                  
typedef struct
            { 
             uint8_t      sb_id;
             uint8_t      sb_size;
             uint8_t      data0;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) EM_ADC_CHIPSET_CAL_READ_REQ_DATA_STR;
#define SIZE_EM_ADC_CHIPSET_CAL_READ_REQ_DATA                 sizeof(EM_ADC_CHIPSET_CAL_READ_REQ_DATA_STR)


//Definition for struct EM_ADC_CHIPSET_CAL_READ_RESP_DATA
#define EM_ADC_CHIPSET_CAL_READ_RESP_DATA                     0x32                                                  
typedef struct
            { 
             uint8_t      sb_id;
             uint8_t      sb_size;
             uint8_t      data0;
             uint8_t      fillerbyte1;
             uint32_t     data2;
             uint32_t     data3;
             uint32_t     data4;
             uint32_t     data5;
            } __attribute__((packed)) EM_ADC_CHIPSET_CAL_READ_RESP_DATA_STR;
#define SIZE_EM_ADC_CHIPSET_CAL_READ_RESP_DATA                sizeof(EM_ADC_CHIPSET_CAL_READ_RESP_DATA_STR)


//MESSAGES


//Definition for struct EM_CHARGER_INFO_REQ
#define EM_CHARGER_INFO_REQ                                   0x00                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      req_info;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) EM_CHARGER_INFO_REQ_STR;
#define SIZE_EM_CHARGER_INFO_REQ                              sizeof(EM_CHARGER_INFO_REQ_STR)


//Definition for struct EM_CHARGER_INFO_RESP
#define EM_CHARGER_INFO_RESP                                  0x01                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      sb_amount;
            } __attribute__((packed)) EM_CHARGER_INFO_RESP_STR;
#define SIZE_EM_CHARGER_INFO_RESP                             sizeof(EM_CHARGER_INFO_RESP_STR)


//Definition for struct EM_CONTROL_WRITE_REQ
#define EM_CONTROL_WRITE_REQ                                  0x02                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      write_req;
             uint8_t      sb_amount;
            } __attribute__((packed)) EM_CONTROL_WRITE_REQ_STR;
#define SIZE_EM_CONTROL_WRITE_REQ                             sizeof(EM_CONTROL_WRITE_REQ_STR)


//Definition for struct EM_CONTROL_WRITE_RESP
#define EM_CONTROL_WRITE_RESP                                 0x03                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      resp_status;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) EM_CONTROL_WRITE_RESP_STR;
#define SIZE_EM_CONTROL_WRITE_RESP                            sizeof(EM_CONTROL_WRITE_RESP_STR)


//Definition for struct EM_CONTROL_READ_REQ
#define EM_CONTROL_READ_REQ                                   0x04                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      req_info;
             uint8_t      sb_amount;
            } __attribute__((packed)) EM_CONTROL_READ_REQ_STR;
#define SIZE_EM_CONTROL_READ_REQ                              sizeof(EM_CONTROL_READ_REQ_STR)


//Definition for struct EM_CONTROL_READ_RESP
#define EM_CONTROL_READ_RESP                                  0x05                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      sb_amount;
            } __attribute__((packed)) EM_CONTROL_READ_RESP_STR;
#define SIZE_EM_CONTROL_READ_RESP                             sizeof(EM_CONTROL_READ_RESP_STR)


//Definition for struct EM_BATTERY_INFO_REQ
#define EM_BATTERY_INFO_REQ                                   0x06                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint16_t     req_info;
            } __attribute__((packed)) EM_BATTERY_INFO_REQ_STR;
#define SIZE_EM_BATTERY_INFO_REQ                              sizeof(EM_BATTERY_INFO_REQ_STR)


//Definition for struct EM_BATTERY_INFO_RESP
#define EM_BATTERY_INFO_RESP                                  0x07                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      sb_amount;
            } __attribute__((packed)) EM_BATTERY_INFO_RESP_STR;
#define SIZE_EM_BATTERY_INFO_RESP                             sizeof(EM_BATTERY_INFO_RESP_STR)


//Definition for struct EM_CHARGING_INFO_REQ
#define EM_CHARGING_INFO_REQ                                  0x08                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      req_info;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) EM_CHARGING_INFO_REQ_STR;
#define SIZE_EM_CHARGING_INFO_REQ                             sizeof(EM_CHARGING_INFO_REQ_STR)


//Definition for struct EM_CHARGING_INFO_RESP
#define EM_CHARGING_INFO_RESP                                 0x09                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      sb_amount;
            } __attribute__((packed)) EM_CHARGING_INFO_RESP_STR;
#define SIZE_EM_CHARGING_INFO_RESP                            sizeof(EM_CHARGING_INFO_RESP_STR)


//Definition for struct EM_MONITORING_INFO_REQ
#define EM_MONITORING_INFO_REQ                                0x0A                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      req_info;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) EM_MONITORING_INFO_REQ_STR;
#define SIZE_EM_MONITORING_INFO_REQ                           sizeof(EM_MONITORING_INFO_REQ_STR)


//Definition for struct EM_MONITORING_INFO_RESP
#define EM_MONITORING_INFO_RESP                               0x0B                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      sb_amount;
            } __attribute__((packed)) EM_MONITORING_INFO_RESP_STR;
#define SIZE_EM_MONITORING_INFO_RESP                          sizeof(EM_MONITORING_INFO_RESP_STR)


//Definition for struct EM_MONITORING_VOLTAGE_REQ
#define EM_MONITORING_VOLTAGE_REQ                             0x0C                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint16_t     req_info;
            } __attribute__((packed)) EM_MONITORING_VOLTAGE_REQ_STR;
#define SIZE_EM_MONITORING_VOLTAGE_REQ                        sizeof(EM_MONITORING_VOLTAGE_REQ_STR)


//Definition for struct EM_MONITORING_VOLTAGE_RESP
#define EM_MONITORING_VOLTAGE_RESP                            0x0D                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      resp_status;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) EM_MONITORING_VOLTAGE_RESP_STR;
#define SIZE_EM_MONITORING_VOLTAGE_RESP                       sizeof(EM_MONITORING_VOLTAGE_RESP_STR)


//Definition for struct EM_MONITORING_VOLTAGE_IND
#define EM_MONITORING_VOLTAGE_IND                             0x0E                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint16_t     ind_info;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
             uint8_t      sb_amount;
            } __attribute__((packed)) EM_MONITORING_VOLTAGE_IND_STR;
#define SIZE_EM_MONITORING_VOLTAGE_IND                        sizeof(EM_MONITORING_VOLTAGE_IND_STR)


//Definition for struct EM_ADC_READ_REQ
#define EM_ADC_READ_REQ                                       0x0F                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      req_info0;
             uint8_t      req_info1;
            } __attribute__((packed)) EM_ADC_READ_REQ_STR;
#define SIZE_EM_ADC_READ_REQ                                  sizeof(EM_ADC_READ_REQ_STR)


//Definition for struct EM_ADC_READ_RESP
#define EM_ADC_READ_RESP                                      0x10                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      resp_status;
             uint8_t      fillerbyte1;
             uint32_t     resp_data;
            } __attribute__((packed)) EM_ADC_READ_RESP_STR;
#define SIZE_EM_ADC_READ_RESP                                 sizeof(EM_ADC_READ_RESP_STR)


//Definition for struct EM_ADC_UNIT_REQ
#define EM_ADC_UNIT_REQ                                       0x11                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      req_info0;
             uint8_t      req_info1;
            } __attribute__((packed)) EM_ADC_UNIT_REQ_STR;
#define SIZE_EM_ADC_UNIT_REQ                                  sizeof(EM_ADC_UNIT_REQ_STR)


//Definition for struct EM_ADC_UNIT_RESP
#define EM_ADC_UNIT_RESP                                      0x12                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      resp_status;
             uint8_t      fillerbyte1;
             uint32_t     resp_data;
            } __attribute__((packed)) EM_ADC_UNIT_RESP_STR;
#define SIZE_EM_ADC_UNIT_RESP                                 sizeof(EM_ADC_UNIT_RESP_STR)


//Definition for struct EM_ADC_CAL_WRITE_REQ
#define EM_ADC_CAL_WRITE_REQ                                  0x22                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      action;
             uint8_t      sb_amount;
            } __attribute__((packed)) EM_ADC_CAL_WRITE_REQ_STR;
#define SIZE_EM_ADC_CAL_WRITE_REQ                             sizeof(EM_ADC_CAL_WRITE_REQ_STR)


//Definition for struct EM_ADC_CAL_WRITE_RESP
#define EM_ADC_CAL_WRITE_RESP                                 0x23                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      resp_status;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) EM_ADC_CAL_WRITE_RESP_STR;
#define SIZE_EM_ADC_CAL_WRITE_RESP                            sizeof(EM_ADC_CAL_WRITE_RESP_STR)


//Definition for struct EM_ADC_CAL_READ_REQ
#define EM_ADC_CAL_READ_REQ                                   0x24                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      action;
             uint8_t      channel;
            } __attribute__((packed)) EM_ADC_CAL_READ_REQ_STR;
#define SIZE_EM_ADC_CAL_READ_REQ                              sizeof(EM_ADC_CAL_READ_REQ_STR)


//Definition for struct EM_ADC_CAL_READ_RESP
#define EM_ADC_CAL_READ_RESP                                  0x25                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      sb_amount;
            } __attribute__((packed)) EM_ADC_CAL_READ_RESP_STR;
#define SIZE_EM_ADC_CAL_READ_RESP                             sizeof(EM_ADC_CAL_READ_RESP_STR)


//Definition for struct EM_ADC_UNIT_LOCK_REQ
#define EM_ADC_UNIT_LOCK_REQ                                  0x26                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      data0;
             uint8_t      data1;
             uint32_t     data2;
            } __attribute__((packed)) EM_ADC_UNIT_LOCK_REQ_STR;
#define SIZE_EM_ADC_UNIT_LOCK_REQ                             sizeof(EM_ADC_UNIT_LOCK_REQ_STR)


//Definition for struct EM_ADC_UNIT_LOCK_RESP
#define EM_ADC_UNIT_LOCK_RESP                                 0x27                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      resp_status;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) EM_ADC_UNIT_LOCK_RESP_STR;
#define SIZE_EM_ADC_UNIT_LOCK_RESP                            sizeof(EM_ADC_UNIT_LOCK_RESP_STR)


//Definition for struct EM_ADC_CAL_TUNE_REQ
#define EM_ADC_CAL_TUNE_REQ                                   0x28                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint16_t     state_transition_timer_value;
             uint16_t     timeout_timer_value;
             uint8_t      fillerbyte1;
             uint8_t      sb_amount;
            } __attribute__((packed)) EM_ADC_CAL_TUNE_REQ_STR;
#define SIZE_EM_ADC_CAL_TUNE_REQ                              sizeof(EM_ADC_CAL_TUNE_REQ_STR)


//Definition for struct EM_ADC_CAL_TUNE_RESP
#define EM_ADC_CAL_TUNE_RESP                                  0x29                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      sb_amount;
            } __attribute__((packed)) EM_ADC_CAL_TUNE_RESP_STR;
#define SIZE_EM_ADC_CAL_TUNE_RESP                             sizeof(EM_ADC_CAL_TUNE_RESP_STR)


//Definition for struct EM_PSM_CS_STATE_WRITE_REQ
#define EM_PSM_CS_STATE_WRITE_REQ                             0x13                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      req_info;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) EM_PSM_CS_STATE_WRITE_REQ_STR;
#define SIZE_EM_PSM_CS_STATE_WRITE_REQ                        sizeof(EM_PSM_CS_STATE_WRITE_REQ_STR)


//Definition for struct EM_PSM_CS_STATE_WRITE_RESP
#define EM_PSM_CS_STATE_WRITE_RESP                            0x14                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      resp_status;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) EM_PSM_CS_STATE_WRITE_RESP_STR;
#define SIZE_EM_PSM_CS_STATE_WRITE_RESP                       sizeof(EM_PSM_CS_STATE_WRITE_RESP_STR)


//Definition for struct EM_PSM_CS_PROTOCOL_WRITE_REQ
#define EM_PSM_CS_PROTOCOL_WRITE_REQ                          0x15                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      req_info;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) EM_PSM_CS_PROTOCOL_WRITE_REQ_STR;
#define SIZE_EM_PSM_CS_PROTOCOL_WRITE_REQ                     sizeof(EM_PSM_CS_PROTOCOL_WRITE_REQ_STR)


//Definition for struct EM_PSM_CS_PROTOCOL_WRITE_RESP
#define EM_PSM_CS_PROTOCOL_WRITE_RESP                         0x16                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      resp_status;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) EM_PSM_CS_PROTOCOL_WRITE_RESP_STR;
#define SIZE_EM_PSM_CS_PROTOCOL_WRITE_RESP                    sizeof(EM_PSM_CS_PROTOCOL_WRITE_RESP_STR)


//Definition for struct EM_PSM_CS_IDLE_ACTIVITY_REQ
#define EM_PSM_CS_IDLE_ACTIVITY_REQ                           0x17                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      req_info;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) EM_PSM_CS_IDLE_ACTIVITY_REQ_STR;
#define SIZE_EM_PSM_CS_IDLE_ACTIVITY_REQ                      sizeof(EM_PSM_CS_IDLE_ACTIVITY_REQ_STR)


//Definition for struct EM_PSM_CS_IDLE_ACTIVITY_RESP
#define EM_PSM_CS_IDLE_ACTIVITY_RESP                          0x18                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      resp_status;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) EM_PSM_CS_IDLE_ACTIVITY_RESP_STR;
#define SIZE_EM_PSM_CS_IDLE_ACTIVITY_RESP                     sizeof(EM_PSM_CS_IDLE_ACTIVITY_RESP_STR)


//Definition for struct EM_PSM_INTERNAL_WRITE_REQ
#define EM_PSM_INTERNAL_WRITE_REQ                             0x19                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      req_info0;
             uint8_t      req_info1;
            } __attribute__((packed)) EM_PSM_INTERNAL_WRITE_REQ_STR;
#define SIZE_EM_PSM_INTERNAL_WRITE_REQ                        sizeof(EM_PSM_INTERNAL_WRITE_REQ_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct EM_PSM_INTERNAL_WRITE_RESP
#define EM_PSM_INTERNAL_WRITE_RESP                            0x1A                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      resp_status;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) EM_PSM_INTERNAL_WRITE_RESP_STR;
#define SIZE_EM_PSM_INTERNAL_WRITE_RESP                       sizeof(EM_PSM_INTERNAL_WRITE_RESP_STR)


//Definition for struct EM_PSM_EXTERNAL_WRITE_REQ
#define EM_PSM_EXTERNAL_WRITE_REQ                             0x1B                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      req_info0;
             uint8_t      fillerbyte1;
             uint16_t     req_info1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
            } __attribute__((packed)) EM_PSM_EXTERNAL_WRITE_REQ_STR;
#define SIZE_EM_PSM_EXTERNAL_WRITE_REQ                        sizeof(EM_PSM_EXTERNAL_WRITE_REQ_STR)


//Definition for struct EM_PSM_EXTERNAL_WRITE_RESP
#define EM_PSM_EXTERNAL_WRITE_RESP                            0x1C                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      resp_status;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) EM_PSM_EXTERNAL_WRITE_RESP_STR;
#define SIZE_EM_PSM_EXTERNAL_WRITE_RESP                       sizeof(EM_PSM_EXTERNAL_WRITE_RESP_STR)


//Definition for struct EM_PSM_SW_FEATURE_REQ
#define EM_PSM_SW_FEATURE_REQ                                 0x1D                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      req_info;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) EM_PSM_SW_FEATURE_REQ_STR;
#define SIZE_EM_PSM_SW_FEATURE_REQ                            sizeof(EM_PSM_SW_FEATURE_REQ_STR)


//Definition for struct EM_PSM_SW_FEATURE_RESP
#define EM_PSM_SW_FEATURE_RESP                                0x1E                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      resp_status;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) EM_PSM_SW_FEATURE_RESP_STR;
#define SIZE_EM_PSM_SW_FEATURE_RESP                           sizeof(EM_PSM_SW_FEATURE_RESP_STR)


//Definition for struct EM_PSM_READ_REQ
#define EM_PSM_READ_REQ                                       0x1F                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint16_t     req_info;
            } __attribute__((packed)) EM_PSM_READ_REQ_STR;
#define SIZE_EM_PSM_READ_REQ                                  sizeof(EM_PSM_READ_REQ_STR)


//Definition for struct EM_PSM_READ_RESP
#define EM_PSM_READ_RESP                                      0x20                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      sb_amount;
            } __attribute__((packed)) EM_PSM_READ_RESP_STR;
#define SIZE_EM_PSM_READ_RESP                                 sizeof(EM_PSM_READ_RESP_STR)


//Definition for struct EM_INFO_IND
#define EM_INFO_IND                                           0x21                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint16_t     ind_info;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
             uint8_t      sb_amount;
            } __attribute__((packed)) EM_INFO_IND_STR;
#define SIZE_EM_INFO_IND                                      sizeof(EM_INFO_IND_STR)


//Definition for struct EM_TEMPERATURE_QUERY_REQ
#define EM_TEMPERATURE_QUERY_REQ                              0x2A                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) EM_TEMPERATURE_QUERY_REQ_STR;
#define SIZE_EM_TEMPERATURE_QUERY_REQ                         sizeof(EM_TEMPERATURE_QUERY_REQ_STR)


//Definition for struct EM_TEMPERATURE_QUERY_RESP
#define EM_TEMPERATURE_QUERY_RESP                             0x2B                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      resp_status;
             uint8_t      fillerbyte1;
             uint32_t     resp_data;
            } __attribute__((packed)) EM_TEMPERATURE_QUERY_RESP_STR;
#define SIZE_EM_TEMPERATURE_QUERY_RESP                        sizeof(EM_TEMPERATURE_QUERY_RESP_STR)


//Definition for struct EM_TEMPERATURE_CHANGED_IND
#define EM_TEMPERATURE_CHANGED_IND                            0x2C                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      resp_status;
             uint8_t      fillerbyte1;
             uint32_t     resp_data;
            } __attribute__((packed)) EM_TEMPERATURE_CHANGED_IND_STR;
#define SIZE_EM_TEMPERATURE_CHANGED_IND                       sizeof(EM_TEMPERATURE_CHANGED_IND_STR)


//Definition for struct EM_POWER_REQ
#define EM_POWER_REQ                                          0x2D                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      req_info0;
             uint8_t      req_info1;
            } __attribute__((packed)) EM_POWER_REQ_STR;
#define SIZE_EM_POWER_REQ                                     sizeof(EM_POWER_REQ_STR)


//Definition for struct EM_POWER_RESP
#define EM_POWER_RESP                                         0x2E                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      resp_status;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) EM_POWER_RESP_STR;
#define SIZE_EM_POWER_RESP                                    sizeof(EM_POWER_RESP_STR)


//Definition for struct EM_SOS_EVENT_REQ
#define EM_SOS_EVENT_REQ                                      0x2F                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      sb_amount;
            } __attribute__((packed)) EM_SOS_EVENT_REQ_STR;
#define SIZE_EM_SOS_EVENT_REQ                                 sizeof(EM_SOS_EVENT_REQ_STR)


//Definition for struct EM_SOS_EVENT_RESP
#define EM_SOS_EVENT_RESP                                     0x30                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      resp_status;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) EM_SOS_EVENT_RESP_STR;
#define SIZE_EM_SOS_EVENT_RESP                                sizeof(EM_SOS_EVENT_RESP_STR)


//Definition for struct EM_SOS_EVENT_NTF
#define EM_SOS_EVENT_NTF                                      0x31                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      ntf_event;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) EM_SOS_EVENT_NTF_STR;
#define SIZE_EM_SOS_EVENT_NTF                                 sizeof(EM_SOS_EVENT_NTF_STR)


//Definition for struct EM_MEASUREMENT_REQ
#define EM_MEASUREMENT_REQ                                    0x32                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      measurement_action;
             uint8_t      sb_amount;
            } __attribute__((packed)) EM_MEASUREMENT_REQ_STR;
#define SIZE_EM_MEASUREMENT_REQ                               sizeof(EM_MEASUREMENT_REQ_STR)


//Definition for struct EM_MEASUREMENT_RESP
#define EM_MEASUREMENT_RESP                                   0x33                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      measurement_result;
             uint8_t      fillerbyte1;
             uint32_t     time;
            } __attribute__((packed)) EM_MEASUREMENT_RESP_STR;
#define SIZE_EM_MEASUREMENT_RESP                              sizeof(EM_MEASUREMENT_RESP_STR)


//Definition for struct EM_MEASUREMENT_NTF
#define EM_MEASUREMENT_NTF                                    0x34                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      sb_amount;
            } __attribute__((packed)) EM_MEASUREMENT_NTF_STR;
#define SIZE_EM_MEASUREMENT_NTF                               sizeof(EM_MEASUREMENT_NTF_STR)


//Definition for struct EM_SELFTEST_REQ
#define EM_SELFTEST_REQ                                       0x35                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      selftest_id;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) EM_SELFTEST_REQ_STR;
#define SIZE_EM_SELFTEST_REQ                                  sizeof(EM_SELFTEST_REQ_STR)


//Definition for struct EM_SELFTEST_RESP
#define EM_SELFTEST_RESP                                      0x36                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      selftest_result;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) EM_SELFTEST_RESP_STR;
#define SIZE_EM_SELFTEST_RESP                                 sizeof(EM_SELFTEST_RESP_STR)


//Definition for struct EM_ME_STATE_REQ
#define EM_ME_STATE_REQ                                       0x37                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      mestate_onoff;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) EM_ME_STATE_REQ_STR;
#define SIZE_EM_ME_STATE_REQ                                  sizeof(EM_ME_STATE_REQ_STR)


//Definition for struct EM_ME_STATE_RESP
#define EM_ME_STATE_RESP                                      0x38                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      mestate_result;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) EM_ME_STATE_RESP_STR;
#define SIZE_EM_ME_STATE_RESP                                 sizeof(EM_ME_STATE_RESP_STR)


//Definition for struct EM_ADC_CHIPSET_CAL_CALCULATE_REQ
#define EM_ADC_CHIPSET_CAL_CALCULATE_REQ                      0x39                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint16_t     option;
             uint8_t      sb_amount;
             uint8_t      fillerbyte1[3];
            } __attribute__((packed)) EM_ADC_CHIPSET_CAL_CALCULATE_REQ_STR;
#define SIZE_EM_ADC_CHIPSET_CAL_CALCULATE_REQ                 sizeof(EM_ADC_CHIPSET_CAL_CALCULATE_REQ_STR)


//Definition for struct EM_ADC_CHIPSET_CAL_CALCULATE_RESP
#define EM_ADC_CHIPSET_CAL_CALCULATE_RESP                     0x3A                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      sb_amount;
            } __attribute__((packed)) EM_ADC_CHIPSET_CAL_CALCULATE_RESP_STR;
#define SIZE_EM_ADC_CHIPSET_CAL_CALCULATE_RESP                sizeof(EM_ADC_CHIPSET_CAL_CALCULATE_RESP_STR)


//Definition for struct EM_ADC_CHIPSET_CAL_READ_REQ
#define EM_ADC_CHIPSET_CAL_READ_REQ                           0x3B                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      sb_amount;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) EM_ADC_CHIPSET_CAL_READ_REQ_STR;
#define SIZE_EM_ADC_CHIPSET_CAL_READ_REQ                      sizeof(EM_ADC_CHIPSET_CAL_READ_REQ_STR)


//Definition for struct EM_ADC_CHIPSET_CAL_READ_RESP
#define EM_ADC_CHIPSET_CAL_READ_RESP                          0x3C                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      sb_amount;
            } __attribute__((packed)) EM_ADC_CHIPSET_CAL_READ_RESP_STR;
#define SIZE_EM_ADC_CHIPSET_CAL_READ_RESP                     sizeof(EM_ADC_CHIPSET_CAL_READ_RESP_STR)


//Definition for struct EM_ADC_CHIPSET_CAL_STORE_REQ
#define EM_ADC_CHIPSET_CAL_STORE_REQ                          0x3D                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      action;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) EM_ADC_CHIPSET_CAL_STORE_REQ_STR;
#define SIZE_EM_ADC_CHIPSET_CAL_STORE_REQ                     sizeof(EM_ADC_CHIPSET_CAL_STORE_REQ_STR)


//Definition for struct EM_ADC_CHIPSET_CAL_STORE_RESP
#define EM_ADC_CHIPSET_CAL_STORE_RESP                         0x3E                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) EM_ADC_CHIPSET_CAL_STORE_RESP_STR;
#define SIZE_EM_ADC_CHIPSET_CAL_STORE_RESP                    sizeof(EM_ADC_CHIPSET_CAL_STORE_RESP_STR)

#endif
