#ifndef _PN_GPDS_ISI_H_
#define _PN_GPDS_ISI_H_

#include <stdint.h> 

//Resource General Packet Data Server
//PN_GPDS 0x31 
//ISI version 018.002
#define GENERAL_PACKET_DATA_SERVER_ISI_VERSION_Z     18
#define GENERAL_PACKET_DATA_SERVER_ISI_VERSION_Y     2

//In case of problems concerning content of this file contact Henrik Ala-Uotila
//Server specific message descriptions and feature&protocol descriptions can be found from: https://oucmswww.nmp.nokia.com:58443/document_browser/ccm_wa/GIF_SPECS/ 


//ISI VERSION CHANGE HISTORY

//Version: 018.002                                           
//Status: Approved                                          
//Date: 22-Aug-2008     Matti Moisanen
//Reason: Update
//Reference: Action DB for SWAM inspection ID: MM08081940458 , APPROVED

//Version: 018.001                                           
//Status: Proposal                                          
//Date: 19-Aug-2008     Matti Moisanen
//Reason: Update
//Reference: Action DB for SWAM inspection ID: MM08081940458 , PROPOSAL

//Version: 018.000                                           
//Status: Approved                                          
//Date: 15-Apr-2008     Matti Moisanen
//Reason: Update
//Reference: Action DB for SWAM inspection ID: MM08041041492 , APPROVED

//Version: 017.026                                           
//Status: Approved                                          
//Date: 19-Aug-2008     Matti Moisanen
//Reason: Update
//Reference: Action DB for SWAM inspection ID: MM08081940458 , APPROVED

//Version: 017.025                                           
//Status: Proposal                                          
//Date: 07-Apr-2008     Matti Moisanen
//Reason: Update
//Reference: Action DB for SWAM inspection ID: MM08041041492 , PROPOSAL

//Version: 017.024                                           
//Status: Approved                                          
//Date: 01-Apr-2008     Matti Moisanen
//Reason: Update
//Reference: Action DB for SWAM inspection ID: MM08032843602 , APPROVED

//Version: 017.023                                           
//Status: Proposal                                          
//Date: 28-Mar-2008     Matti Moisanen
//Reason: Update
//Reference: Action DB for SWAM inspection ID: MM08032843602 , PROPOSAL

//Version: 017.022                                           
//Status: Approved                                          
//Date: 27-Sep-2007     Matti Moisanen
//Reason: Update
//Reference: Action DB for SWAM inspection ID: MM07092629743 , APPROVED

//Version: 017.021                                           
//Status: Proposal                                          
//Date: 25-Sep-2007     Matti Moisanen
//Reason: Update
//Reference: Action DB for SWAM inspection ID: MM07092629743 , PROPOSAL

//Version: 017.020                                           
//Status: Approved                                          
//Date: 25-Sep-2007     Matti Moisanen
//Reason: Update
//Reference: Action DB for SWAM inspection ID: MM07091332368 , APPROVED

//Version: 017.019                                           
//Status: Proposal                                          
//Date: 12-Sep-2007     Matti Moisanen
//Reason: Update
//Reference: Action DB for SWAM inspection ID: MM07091332368 , PROPOSAL

//Version: 017.018                                           
//Status: Approved                                          
//Date: 19-Jun-2007     Matti Moisanen
//Reason: Update
//Reference: Action DB for SWAM inspection ID: MM07061439289 , APPROVED

//Version: 017.017                                           
//Status: Proposal                                          
//Date: 13-Jun-2007     Matti Moisanen
//Reason: Update
//Reference: Action DB for SWAM inspection ID: MM07061439289 , PROPOSAL

//Version: 017.016                                           
//Status: Approved                                          
//Date: 01-Jun-2007     Matti Moisanen
//Reason: Update
//Reference: Action DB for SWAM inspection ID: MM07052553763 , Approved

//Version: 017.015                                           
//Status: Proposal                                          
//Date: 25-May-2007     Matti Moisanen
//Reason: Update
//Reference: Action DB for SWAM inspection ID: MM07052553763 , PROPOSAL

//Version: 017.014                                           
//Status: Approved                                          
//Date: 23-May-2007     Matti Moisanen
//Reason: Update
//Reference: Action DB for SWAM inspection ID: MM07051646906 , APPROVED

//Version: 017.013                                           
//Status: Proposal                                          
//Date: 16-May-2007     Matti Moisanen
//Reason: Update
//Reference: Action DB for SWAM inspection ID: MM07051646906 , PROPOSAL

//Version: 017.012                                           
//Status: Approved                                          
//Date: 4-May-2007      Matti Moisanen
//Reason: Update
//Reference: Action DB for SWAM inspection ID: MM07050328500 , APPROVED

//Version: 017.011                                           
//Status: Proposal                                          
//Date: 3-May-2007      Matti Moisanen
//Reason: Update
//Reference: Action DB for SWAM inspection ID: MM07050328500 , PROPOSAL

//Version: 017.010                                           
//Status: Approved                                          
//Date: 26-Mar-2007     Matti Moisanen
//Reason: Update
//Reference: Action DB for SWAM inspection ID: MM07032053184 , APPROVED

//Version: 017.009                                           
//Status: Proposal                                          
//Date: 20-Mar-2007     Matti Moisanen
//Reason: Update
//Reference: Action DB for SWAM inspection ID: MM07032053184 , PROPOSAL

//Version: 017.008                                           
//Status: Approved                                          
//Date: 28-Feb-2007     Matti Moisanen
//Reason: Update
//Reference: Action DB for SWAM inspection ID: MM07020235407 , APPROVED

//Version: 017.007                                           
//Status: Proposal                                          
//Date: 15-Feb-2007     Matti Moisanen
//Reason: Update
//Reference: Action DB for SWAM inspection ID:  , PROPOSAL

//Version: 017.006                                           
//Status: Approved                                          
//Date: 29-Nov-2006     Tapio Askeli
//Reason: Update
//Reference: Action DB for SWAM inspection ID: TA: TA06111546430, APPROVED

//Version: 017.005                                           
//Status: Proposal                                          
//Date: 15-Nov-2006     Tapio Askeli
//Reason: Update
//Reference: 010-27185: Field test improvements within PMD files - MACN CCN, PROPOSAL

//Version: 017.004                                           
//Status: Approved                                          
//Date: 13-Jun-2006     Ilkka Leinonen
//Reason: Update
//Reference: Action DB for SWAM inspection ID: IL06060843901, APPROVED

//Version: 017.003                                           
//Status: Proposal                                          
//Date: 08-Jun-2006     Ilkka Leinonen
//Reason: Update
//Reference: SUB: 010-24773, PROPOSAL

//Version: 017.002                                           
//Status: Approved                                          
//Date: 03-Feb-2006     Sweta Pradhanang
//Reason: Update
//Reference: Action DB for SWAM inspection ID:SP06012735617, APPROVED

//Version: 017.001                                           
//Status: Proposal                                          
//Date: 12-Jan-2006     Sweta Pradhanang
//Reason: Update
//Reference: SUB/SCO:009-22186,009-22188, PROPOSAL

//Version: 017.000                                           
//Status: Approved                                          
//Date: 30-Nov-2005     Juuso Oikarinen
//Reason: Correction
//Reference: ADB For SWAM id: JO05112446559, APPROVED

//Version: 016.009                                           
//Status: Proposal                                          
//Date: 29-Nov-2005     Juuso Oikarinen
//Reason: Update
//Reference: SUB/SCO: 009-17851, PROPOSAL

//Version: 016.008                                           
//Status: Proposal                                          
//Date: 24-Nov-2005     Juuso Oikarinen
//Reason: Update
//Reference: SUB/SCO: 009-17851, PROPOSAL

//Version: 016.007                                           
//Status: Approved                                          
//Date: 23-Nov-2005     Sweta Pradhanang
//Reason: Correction
//Reference: PCP Error ID:PC05111836883, APPROVED

//Version: 016.006                                           
//Status: Proposal                                          
//Date: 23-Nov-2005     Sweta Pradhanang
//Reason: Correction
//Reference: PCP Error ID:PC05111836883, PROPOSAL

//Version: 016.005                                           
//Status: Approved                                          
//Date: 14-Nov-2005     Sweta Pradhanang
//Reason: Correction
//Reference: Action DB for SWAM inspection ID:SP05111039671, APPROVED

//Version: 016.004                                           
//Status: Proposal                                          
//Date: 08-Nov-2005     Sweta Pradhanang
//Reason: Correction
//Reference: PCP Error ID:VK05092038143, TR05102141053, PROPOSAL

//Version: 016.003                                           
//Status: Approved                                          
//Date: 24-Oct-2005     Sweta Pradhanang
//Reason: Update
//Reference: Action DB for SWAM inspection ID: SP05101849999, APPROVED

//Version: 016.002                                           
//Status: Proposal                                          
//Date: 14-Oct-2005     Sweta Pradhanang
//Reason: Update
//Reference: SUB/SCO:009-20903, PROPOSAL

//Version: 016.001                                           
//Status: Approved                                          
//Date: 12-Sep-2005     Sweta Pradhanang
//Reason: Inspection
//Reference: Action DB for SWAM inspection ID:SP05090136505, APPROVED

//Version: 016.000                                           
//Status: Proposal                                          
//Date: 26-Aug-2005     Sweta Pradhanang
//Reason: Update
//Reference: SUB/SCO:009-19562, 009-19915, PROPOSAL

//Version: 015.001                                           
//Status: Approved                                          
//Date: 21-Jun-2005     Sweta Pradhanang
//Reason: Inspection
//Reference: Action DB for SWAM inspection ID:SP05061535280, APPROVED

//Version: 015.000                                           
//Status: Proposal                                          
//Date: 14-Jun-2005     Sweta Pradhanang
//Reason: Update
//Reference: SUB/SCO:009-15058: Radio Activity Status in 3G, PROPOSAL

//Version: 014.001                                           
//Status: Approved                                          
//Date: 30-May-2005     Sweta Pradhanang
//Reason: Update
//Reference: Action DB for SWAM inspection ID:SP05051836903, APPROVED

//Version: 014.000                                           
//Status: Proposal                                          
//Date: 18-May-2005     Sweta Pradhanang
//Reason: Update
//Reference: SUB/SCO:009-15058: Radio Activity Status in 3G, PROPOSAL

//Version: 013.007                                           
//Status: Approved                                          
//Date: 11-May-2005     Sweta Pradhanang
//Reason: Update
//Reference: Action DB for SWAM inspection ID: SP05050353344, APPROVED

//Version: 013.006                                           
//Status: Unknown                                           
//Date: 03-May-2005     Sweta Pradhanang
//Reason: Update
//Reference: SCO:009-17947, PCP Error ID:MK05031737898 , NON_DRAFT

//Version: 013.005                                           
//Status: Unknown                                           
//Date: 08-Mar-2005     Sweta Pradhanang
//Reason: Update
//Reference: SCO: 009-15467, NON_DRAFT

//Version: 013.004                                           
//Status: Unknown                                           
//Date: 10-Feb-2005     Sweta Pradhanang
//Reason: Update
//Reference: SCO: 009-15467, NON_DRAFT

//Version: 013.003                                           
//Status: Unknown                                           
//Date: 04-Feb-2005     Sweta Pradhanang
//Reason: Correction
//Reference: Compilation error, NON_DRAFT

//Version: 013.002                                           
//Status: Unknown                                           
//Date: 19-Jan-2005     Sweta Pradhanang
//Reason: Update
//Reference: Action DB for SWAM inspection ID: AP04112845656, NON_DRAFT

//Version: 013.001                                           
//Status: Unknown                                           
//Date: 05-Jan-2005     Sweta Pradhanang
//Reason: Update
//Reference: Action DB for SWAM inspection ID: AP04112845656, NON_DRAFT

//Version: 013.000                                           
//Status: Unknown                                           
//Date: 09-Dec-2004     Sweta Pradhanang
//Reason: Update
//Reference: SCO:009-14807, NON_DRAFT

//Version: 012.011                                           
//Status: Unknown                                           
//Date: 24-Nov-2004     Sweta Pradhanang
//Reason: Update
//Reference: SCO:009-14807, NON_DRAFT

//Version: 012.010                                           
//Status: Unknown                                           
//Date: 08-Nov-2004     Sweta Pradhanang
//Reason: Update
//Reference: SCO: 010-8447, NON_DRAFT

//Version: 012.009                                           
//Status: Unknown                                           
//Date: 11-Aug-2004     Sweta Pradhanang
//Reason: Update
//Reference: SCO:009-12761, NON_DRAFT

//Version: 012.008                                           
//Status: Unknown                                           
//Date: 29-Jun-2004     Sweta Pradhanang
//Reason: Update
//Reference: SCO:009-12761, NON_DRAFT

//Version: 012.007                                           
//Status: Unknown                                           
//Date: 18-Feb-2004     Sweta Pradhanang
//Reason: Update
//Reference: TEC/SWP/ISA ActionDB: AS03120345697, NON_DRAFT

//Version: 012.006                                           
//Status: Unknown                                           
//Date: 09-Jan-2004     Sweta Pradhanang
//Reason: Move file
//Reference: TEC/SWP/ISA ActionDB: AS04010751307, NON_DRAFT

//Version: 012.005                                           
//Status: Unknown                                           
//Date: 11-Dec-2003     Sweta Pradhanang
//Reason: Update
//Reference: TEC/SWP/ISA ActionDB: AS03092550839, NON_DRAFT

//Version: 012.004                                           
//Status: Unknown                                           
//Date: 05-Nov-2003     Sweta Pradhanang
//Reason: Update
//Reference: TEC/SWP/ISA ActionDB: AS03092458190, NON_DRAFT

//Version: 012.003                                           
//Status: Unknown                                           
//Date: 27-Oct-2003     Sweta Pradhanang
//Reason: Update
//Reference: TEC/SWP/ISA ActionDB: AS03081855392, NON_DRAFT

//Version: 012.002                                           
//Status: Unknown                                           
//Date: 08-Oct-2003     Sweta Pradhanang
//Reason: Update
//Reference: TEC/SWP/ISA ActionDB: AS03092457548 , NON_DRAFT

//Version: 012.001                                           
//Status: Unknown                                           
//Date: 22-Sep-2003     Kalle Haviala
//Reason: Correction
//Reference: PCP Errors: TK03091951194, NON_DRAFT

//Version: 012.000                                           
//Status: Unknown                                           
//Date: 06-Jun-2003     Kalle Haviala
//Reason: Inspection
//Reference: ActionDB for SWAM: AS03053046350, NON_DRAFT

//Version: 011.001                                           
//Status: Unknown                                           
//Date: 28-May-2003     Kalle Haviala
//Reason: Update
//Reference: ActionDB for SWAM: AS03051537547, NON_DRAFT

//Version: 011.000                                           
//Status: Unknown                                           
//Date: 11-Apr-2003     Kalle Haviala
//Reason: Inspection
//Reference: ActionDB for SWAM: AS03032644758, NON_DRAFT

//Version: 010.006                                           
//Status: Unknown                                           
//Date: 25-Mar-2003     Kalle Haviala
//Reason: Update
//Reference: ActionDB for SWAM: AS03030657444, AS03030347986, AS03031251767, NON_DRAFT

//Version: 010.005                                           
//Status: Unknown                                           
//Date: 24-Mar-2003     Kalle Haviala
//Reason: Update
//Reference: PCP Errors: MM03032446289, NON_DRAFT

//Version: 010.004                                           
//Status: Unknown                                           
//Date: 07-Mar-2003     Kalle Haviala
//Reason: Update
//Reference: -, NON_DRAFT

//Version: 010.003                                           
//Status: Unknown                                           
//Date: 06-Mar-2003     Kalle Haviala
//Reason: Update
//Reference: ActionDB for SWAM: AS03012940262, NON_DRAFT

//Version: 010.002                                           
//Status: Unknown                                           
//Date: 28-Jan-2003     Kalle Haviala
//Reason: Created
//Reference: -, NON_DRAFT


//CONSTANTS
#define GPDS_IP_DATAGRAM_MAX_LENGTH                           0x05DC                                                   
#define GPDS_PPP_INFO_MAX_LENGTH                              0x05DC                                                   
#define GPDS_QOS99_SUBSCRIBED                                 0x00                                                     
#define GPDS_QOS99_DEFAULT                                    0xFFFF                                                
#define GPDS_MAX_USERNAME_SIZE                                0x35                                                  
#define GPDS_MAX_PASSWORD_SIZE                                0x35                                                  
#define GPDS_MAX_CHALLENGE_SIZE                               0x35                                                  
#define GPDS_MAX_RESPONSE_SIZE                                0x34                                                  
#define GPDS_MAX_SMS_PDU_DATA                                 0x012C                                                   
#define GPDS_MAX_CID_LIST_SIZE                                0x0E                                                     
#define GPDS_ANY_SIZE                                         1                                                     


//TABLES

//ConstantTable for GPDS_PPP_MODE
#define GPDS_LL_FRAMED_PPP                                    0x00                                                     
#define GPDS_LL_NONFRAMED_PPP                                 0x01                                                     
#define GPDS_LL_PLAIN                                         0x02                                                     

//ConstantTable for GPDS_CID
#define GPDS_CID_ALL                                          0xFE                                                  
#define GPDS_CID_VOID                                         0xFF                                                  

//ConstantTable for GPDS_STATUS
#define GPDS_ERROR                                            0x00                                                     
#define GPDS_OK                                               0x01                                                     
#define GPDS_FAIL                                             0x02                                                     

//ConstantTable for GPDS_ATTACH_MODE
#define GPDS_ATTACH_MODE_MANUAL                               0x00                                                     
#define GPDS_ATTACH_MODE_AUTOMATIC                            0x01                                                     
#define GPDS_ATTACH_MODE_DEFAULT                              0xFF                                                  

//ConstantTable for GPDS_ATTACH_STATUS
#define GPDS_DETACHED                                         0x00                                                     
#define GPDS_ATTACHED                                         0x01                                                     

//ConstantTable for GPDS_MT_ACT_MODE
#define GPDS_MT_ACT_MODE_REJECT                               0x00                                                     
#define GPDS_MT_ACT_MODE_ACCEPT                               0x01                                                     
#define GPDS_MT_ACT_MODE_DEFAULT                              0xFF                                                  

//ConstantTable for GPDS_CLASSC_MODE
#define GPDS_CLASSC_MODE_GPRS                                 0x00                                                     
#define GPDS_CLASSC_MODE_GSM                                  0x01                                                     
#define GPDS_CLASSC_MODE_DEFAULT                              0xFF                                                  

//ConstantTable for GPDS_PRECEDENCE
#define GPDS_QOS_PREC_0                                       0x00                                                     
#define GPDS_QOS_PREC_1                                       0x01                                                     
#define GPDS_QOS_PREC_2                                       0x02                                                     
#define GPDS_QOS_PREC_3                                       0x03                                                     
#define GPDS_QOS_PREC_DEFAULT                                 0xFF                                                  

//ConstantTable for GPDS_DELAY
#define GPDS_QOS_DELC_0                                       0x00                                                     
#define GPDS_QOS_DELC_1                                       0x01                                                     
#define GPDS_QOS_DELC_2                                       0x02                                                     
#define GPDS_QOS_DELC_3                                       0x03                                                     
#define GPDS_QOS_DELC_4                                       0x04                                                     
#define GPDS_QOS_DELC_DEFAULT                                 0xFF                                                  

//ConstantTable for GPDS_RELIABILITY
#define GPDS_QOS_RELC_0                                       0x00                                                     
#define GPDS_QOS_RELC_1                                       0x01                                                     
#define GPDS_QOS_RELC_2                                       0x02                                                     
#define GPDS_QOS_RELC_3                                       0x03                                                     
#define GPDS_QOS_RELC_4                                       0x04                                                     
#define GPDS_QOS_RELC_5                                       0x05                                                     
#define GPDS_QOS_RELC_DEFAULT                                 0xFF                                                  

//ConstantTable for GPDS_PEAK_THROUGHPUT
#define GPDS_QOS_PETC_0                                       0x00                                                     
#define GPDS_QOS_PETC_1                                       0x01                                                     
#define GPDS_QOS_PETC_2                                       0x02                                                     
#define GPDS_QOS_PETC_3                                       0x03                                                     
#define GPDS_QOS_PETC_4                                       0x04                                                     
#define GPDS_QOS_PETC_5                                       0x05                                                     
#define GPDS_QOS_PETC_6                                       0x06                                                     
#define GPDS_QOS_PETC_7                                       0x07                                                     
#define GPDS_QOS_PETC_8                                       0x08                                                     
#define GPDS_QOS_PETC_9                                       0x09                                                     
#define GPDS_QOS_PETC_DEFAULT                                 0xFF                                                  

//ConstantTable for GPDS_MEAN_THROUGHPUT
#define GPDS_QOS_METC_0                                       0x00                                                     
#define GPDS_QOS_METC_1                                       0x01                                                     
#define GPDS_QOS_METC_2                                       0x02                                                     
#define GPDS_QOS_METC_3                                       0x03                                                     
#define GPDS_QOS_METC_4                                       0x04                                                     
#define GPDS_QOS_METC_5                                       0x05                                                     
#define GPDS_QOS_METC_6                                       0x06                                                     
#define GPDS_QOS_METC_7                                       0x07                                                     
#define GPDS_QOS_METC_8                                       0x08                                                     
#define GPDS_QOS_METC_9                                       0x09                                                     
#define GPDS_QOS_METC_10                                      0x0A                                                     
#define GPDS_QOS_METC_11                                      0x0B                                                     
#define GPDS_QOS_METC_12                                      0x0C                                                     
#define GPDS_QOS_METC_13                                      0x0D                                                     
#define GPDS_QOS_METC_14                                      0x0E                                                     
#define GPDS_QOS_METC_15                                      0x0F                                                     
#define GPDS_QOS_METC_16                                      0x10                                                  
#define GPDS_QOS_METC_17                                      0x11                                                  
#define GPDS_QOS_METC_18                                      0x12                                                  
#define GPDS_QOS_METC_31                                      0x1F                                                  
#define GPDS_QOS_METC_DEFAULT                                 0xFF                                                  

//ConstantTable for GPDS_CAUSE
#define GPDS_CAUSE_UNKNOWN                                    0x00                                                     
#define GPDS_CAUSE_IMSI                                       0x02                                                     
#define GPDS_CAUSE_MS_ILLEGAL                                 0x03                                                     
#define GPDS_CAUSE_ME_ILLEGAL                                 0x06                                                     
#define GPDS_CAUSE_GPRS_NOT_ALLOWED                           0x07                                                     
#define GPDS_NOT_ALLOWED                                      0x08                                                     
#define GPDS_CAUSE_MS_IDENTITY                                0x09                                                     
#define GPDS_CAUSE_DETACH                                     0x0A                                                     
#define GPDS_PLMN_NOT_ALLOWED                                 0x0B                                                     
#define GPDS_LA_NOT_ALLOWED                                   0x0C                                                     
#define GPDS_ROAMING_NOT_ALLOWED                              0x0D                                                     
#define GPDS_CAUSE_GPRS_NOT_ALLOWED_IN_PLMN                   0x0E                                                     
#define GPDS_CAUSE_MSC_NOT_REACH                              0x10                                                  
#define GPDS_CAUSE_PLMN_FAIL                                  0x11                                                  
#define GPDS_CAUSE_NETWORK_CONGESTION                         0x16                                                  
#define GPDS_CAUSE_MBMS_BEARER_CAPABILITY_INSUFFICIENT        0x18                                                  
#define GPDS_CAUSE_LLC_SNDCP_FAILURE                          0x19                                                  
#define GPDS_CAUSE_RESOURCE_INSUFF                            0x1A                                                  
#define GPDS_CAUSE_APN                                        0x1B                                                  
#define GPDS_CAUSE_PDP_UNKNOWN                                0x1C                                                  
#define GPDS_CAUSE_AUTHENTICATION                             0x1D                                                  
#define GPDS_CAUSE_ACT_REJECT_GGSN                            0x1E                                                  
#define GPDS_CAUSE_ACT_REJECT                                 0x1F                                                  
#define GPDS_CAUSE_SERV_OPT_NOT_SUPPORTED                     0x20                                                  
#define GPDS_CAUSE_SERV_OPT_NOT_SUBSCRIBED                    0x21                                                  
#define GPDS_CAUSE_SERV_OPT_OUT_OF_ORDER                      0x22                                                  
#define GPDS_CAUSE_NSAPI_ALREADY_USED                         0x23                                                  
#define GPDS_CAUSE_DEACT_REGULAR                              0x24                                                  
#define GPDS_CAUSE_QOS                                        0x25                                                  
#define GPDS_CAUSE_NETWORK_FAIL                               0x26                                                  
#define GPDS_CAUSE_REACTIVATION_REQ                           0x27                                                  
#define GPDS_CAUSE_FEAT_NOT_SUPPORTED                         0x28                                                  
#define GPDS_CAUSE_TFT_SEMANTIC_ERROR                         0x29                                                  
#define GPDS_CAUSE_TFT_SYNTAX_ERROR                           0x2A                                                  
#define GPDS_CAUSE_CONTEXT_UNKNOWN                            0x2B                                                  
#define GPDS_CAUSE_FILTER_SEMANTIC_ERROR                      0x2C                                                  
#define GPDS_CAUSE_FILTER_SYNTAX_ERROR                        0x2D                                                  
#define GPDS_CAUSE_CONT_WITHOUT_TFT                           0x2E                                                  
#define GPDS_CAUSE_MULTICAST_MEMBERSHIP_TIMEOUT               0x2F                                                  
#define GPDS_CAUSE_INVALID_MANDATORY_INFO                     0x60                                                  
#define GPDS_CAUSE_MSG_TYPE_NON_EXISTENTOR_NOT_IMPLTD         0x61                                                  
#define GPDS_CAUSE_MSG_TYPE_NOT_COMPATIBLE_WITH_PROTOCOL_STATE    0x62                                                  
#define GPDS_CAUSE_IE_NON_EXISTENT_OR_NOT_IMPLEMENTED         0x63                                                  
#define GPDS_CAUSE_CONDITIONAL_IE_ERROR                       0x64                                                  
#define GPDS_CUASEMSG_NOT_COMPATIBLE_WITH_PROTOCOL_STATE      0x65                                                  
#define GPDS_CAUSE_UNSPECIFIED                                0x6F                                                  
#define GPDS_CAUSE_APN_INCOMPATIBLE_WITH_CURR_CTXT            0x70                                                  
#define GPDS_CAUSE_FDN                                        0xA0                                                  
#define GPDS_CAUSE_USER_ABORT                                 0xA1                                                  
#define GPDS_CAUSE_CS_INACTIVE                                0xA2                                                  
#define GPDS_CAUSE_CSD_OVERRIDE                               0xA3                                                  
#define GPDS_CAUSE_APN_CONTROL                                0xA4                                                  
#define GPDS_CAUSE_CALL_CONTROL                               0xA5                                                  
#define GPDS_CAUSE_TEMPERATURE_LIMIT                          0xA6                                                  
#define GPDS_CAUSE_RETRY_COUNTER_EXPIRED                      0xC8                                                  
#define GPDS_CAUSE_NO_CONNECTION                              0xC9                                                  
#define GPDS_CAUSE_DETACHED                                   0xF5                                                  
#define GPDS_CAUSE_NO_SERVICE_POWER_SAVE                      0xF7                                                  
#define GPDS_CAUSE_SIM_REMOVED                                0xF9                                                  
#define GPDS_CAUSE_POWER_OFF                                  0xFA                                                  
#define GPDS_CAUSE_LAI_FORBIDDEN_NATIONAL_ROAM_LIST           0xFB                                                  
#define GPDS_CAUSE_LAI_FORBIDDEN_REG_PROVISION_LIST           0xFC                                                  
#define GPDS_CAUSE_ACCESS_BARRED                              0xFD                                                  
#define GPDS_CAUSE_FATAL_FAILURE                              0xFE                                                  
#define GPDS_CAUSE_AUT_FAILURE                                0xFF                                                  

//ConstantTable for GPDS_CLIENT_TYPE
#define GPDS_CONTEXT_CLIENT_SOCKET                            0x01                                                     
#define GPDS_CONTEXT_CLIENT_DIAL_UP                           0x02                                                     
#define GPDS_CONTEXT_CLIENT_UNKNOWN                           0x00                                                     

//ConstantTable for GPDS_CONTEXT_TYPE
#define GPDS_CONT_TYPE_NORMAL                                 0x00                                                     
#define GPDS_CONT_TYPE_NWI                                    0x01                                                     
#define GPDS_CONT_TYPE_SEC                                    0x02                                                     

//ConstantTable for GPDS_ATTACH_TYPE
#define GPDS_ATTACH_TYPE_GPRS                                 0x01                                                     
#define GPDS_ATTACH_TYPE_COMBINED                             0x03                                                     

//ConstantTable for GPDS_DETACH_TYPE
#define GPDS_DETACH_TYPE_GPRS_MO_POFF                         0x00                                                     
#define GPDS_DETACH_TYPE_GPRS_MO                              0x01                                                     
#define GPDS_DETACH_TYPE_MO_COMBINED_POFF                     0x02                                                     
#define GPDS_DETACH_TYPE_MO_COMBINED                          0x03                                                     
#define GPDS_DETACH_TYPE_MT_REATTACH_REQ                      0x04                                                     
#define GPDS_DETACH_TYPE_MT                                   0x05                                                     
#define GPDS_DETACH_TYPE_MO_REATTACH                          0x06                                                     
#define GPDS_DETACH_TYPE_MO_COMB_REATTACH                     0x07                                                     

//ConstantTable for GPDS_TRANSFER_STATUS
#define GPDS_TRANSFER_NOT_AVAIL                               0x00                                                     
#define GPDS_TRANSFER_AVAIL                                   0x01                                                     

//ConstantTable for GPDS_TRANSFER_CAUSE
#define GPDS_TRANSFER_CAUSE_ATTACHED                          0x02                                                     
#define GPDS_TRANSFER_CAUSE_DETACHED                          0x03                                                     
#define GPDS_TRANSFER_CAUSE_RESUMED                           0x04                                                     
#define GPDS_TRANSFER_CAUSE_SUSPENDED_NO_COVERAGE             0x05                                                     
#define GPDS_TRANSFER_CAUSE_SUSPENDED_CALL_SMS                0x07                                                     
#define GPDS_TRANSFER_CAUSE_SUSPENDED_CALL                    0x08                                                     
#define GPDS_TRANSFER_CAUSE_SUSPENDED_RAU                     0x09                                                     
#define GPDS_TRANSFER_CAUSE_SUSPENDED_LU                      0x0A                                                     
#define GPDS_TRANSFER_CAUSE_DSAC_RESTRICTION                  0x0B                                                     

//ConstantTable for GPDS_TEST_MODE_PDU_CONTENT
#define GPDS_RANDOM                                           0x00                                                     
#define GPDS_CONSTANT                                         0x01                                                     

//ConstantTable for GPDS_TEST_MODE_RLC_MODE
#define GPDS_ACKNOWLEDGED                                     0x00                                                     
#define GPDS_UNACKNOWLEDGED                                   0x01                                                     

//ConstantTable for GPDS_DIRECTION
#define GPDS_RADIO_UPLINK                                     0x00                                                     
#define GPDS_RADIO_DOWNLINK                                   0x01                                                     
#define GPDS_RADIO_BIDIRECTION                                0x02                                                     

//ConstantTable for GPDS_RADIO_STATUS
#define GPDS_RADIO_ON                                         0x01                                                     
#define GPDS_RADIO_OFF                                        0x00                                                     

//ConstantTable for GPDS_FORCED_READY_STATE
#define GPDS_FORCED_READY_STATE_OFF                           0x00                                                     
#define GPDS_FORCED_READY_STATE_ON                            0x01                                                     

//ConstantTable for GPDS_FOLLOW_ON_REQUEST_MODE
#define GPDS_FOLLOW_OFF                                       0x00                                                     
#define GPDS_FOLLOW_ON                                        0x01                                                     

//ConstantTable for GPDS_PDP_TYPE
#define GPDS_PDP_TYPE_PPP                                     0x01                                                     
#define GPDS_PDP_TYPE_IPV4                                    0x21                                                  
#define GPDS_PDP_TYPE_IPV6                                    0x57                                                  
#define GPDS_PDP_TYPE_DEFAULT                                 0xFF                                                  

//ConstantTable for GPDS_AOL_CONTEXT
#define GPDS_AOL_CTX_NOT_ACTIVE                               0x00                                                     
#define GPDS_AOL_CTX_HPLMN_ACTIVE                             0x01                                                     
#define GPDS_AOL_CTX_VPLMN_ACTIVE                             0x02                                                     
#define GPDS_AOL_CTX_ACTIVE                                   0x03                                                     

//ConstantTable for GPDS_MBMS_SERVICE_RESULT
#define GPDS_MBMS_SERVICE_REQ_ERROR                           0x01                                                     
#define GPDS_MBMS_SERVICE_REQ_OK                              0x02                                                     

//ConstantTable for GPDS_MBMS_SUPPORT_STATUS
#define GPDS_MBMS_SUPPORTED                                   0x01                                                     
#define GPDS_MBMS_NOT_SUPPORTED                               0x02                                                     

//ConstantTable for GPDS_MBMS_BEARER_STATE
#define GPDS_MBMS_BEARER_ESTABLISHED                          0x01                                                     
#define GPDS_MBMS_BEARER_RELEASED                             0x02                                                     

//ConstantTable for GPDS_MBMS_RELEASE_CAUSE
#define GPDS_MBMS_BEARER_ESTABLISHMENT                        0x00                                                     
#define GPDS_MBMS_NORMAL_RELEASE                              0x01                                                     
#define GPDS_MBMS_USER_INITIATED_RELEASE                      0x02                                                     
#define GPDS_MBMS_SERVICE_NOT_PRESENT                         0x03                                                     
#define GPDS_MBMS_MBMS_NOT_PRESENT                            0x04                                                     
#define GPDS_MBMS_RELEASE_DUE_TO_NON_MBMS                     0x05                                                     
#define GPDS_MBMS_RELEASE_DUE_TO_MBMS                         0x06                                                     

//ConstantTable for GPDS_TEST_LOOP_MODE
#define GPDS_TEST_LOOP_1_TO_1                                 0x01                                                     
#define GPDS_TEST_LOOP_1_TO_2                                 0x02                                                     
#define GPDS_TEST_LOOP_1_TO_3                                 0x03                                                     
#define GPDS_TEST_LOOP_UPLINK_ONLY                            0x04                                                     
#define GPDS_TEST_LOOP_DOWNLINK_ONLY                          0x05                                                     

//ConstantTable for GPDS_RESOURCE_CONTROL_RESULT
#define GPDS_ALLOWED                                          0x01                                                     
#define GPDS_MODIFIED                                         0x02                                                     
#define GPDS_REJECTED                                         0x03                                                     

//ConstantTable for GPDS_RESOURCE_CONF_OPERATION
#define GPDS_RESOURCE_CONF_GET                                0x01                                                     
#define GPDS_RESOURCE_CONF_SET                                0x02                                                     

//ConstantTable for GPDS_RESOURCE_CONF_STATUS
#define GPDS_RESOURCE_CONF_READY                              0x01                                                     
#define GPDS_RESOURCE_CONF_RECONFIGURED                       0x02                                                     

//BitmaskTables for GPDS_RESOURCE_IDS
#define GPDS_RES_ID_CC_FOR_GPRS                               0x0001                                                     

//BitmaskTables for GPDS_RESOURCE_IDS_MASK
#define GPDS_RES_ID_MASK_CC_FOR_GPRS                          0x0001                                                     

//BitmaskTables for GPDS_RESOURCE_IDS_CONF_REQ
#define GPDS_RES_ID_CONF_CC_FOR_GPRS                          0x0001                                                     

//ConstantTable for GPDS_PIPE_REDIRECTION_STATUS
#define GPDS_PIPE_REDIRECTION_STARTING                        0x01                                                     
#define GPDS_PIPE_REDIRECTION_DONE                            0x02                                                     

//ConstantTable for FtdTable
#define FTD_SB_GPDS_ATT_AND_PDP                               0x10                                                  
#define FTD_SB_GPDS_NSAPI_1                                   0x11                                                  
#define FTD_SB_GPDS_SAPI_1                                    0x12                                                  
#define FTD_SB_GPDS_PDP_ADDRESS_1_1                           0x13                                                  
#define FTD_SB_GPDS_PDP_ADDRESS_1_2                           0x14                                                  
#define FTD_SB_GPDS_PDP_ADDRESS_1_3                           0x15                                                  
#define FTD_SB_GPDS_PDP_ADDRESS_1_4                           0x16                                                  
#define FTD_SB_GPDS_NSAPI_2                                   0x17                                                  
#define FTD_SB_GPDS_SAPI_2                                    0x18                                                  
#define FTD_SB_GPDS_PDP_ADDRESS_2_1                           0x19                                                  
#define FTD_SB_GPDS_PDP_ADDRESS_2_2                           0x1A                                                  
#define FTD_SB_GPDS_PDP_ADDRESS_2_3                           0x1B                                                  
#define FTD_SB_GPDS_PDP_ADDRESS_2_4                           0x1C                                                  
#define FTD_SB_PDI_FCS_FAIL                                   0x1D                                                  
#define FTD_SB_PDI_MRU                                        0x1E                                                  
#define FTD_SB_PDI_MTU                                        0x1F                                                  
#define FTD_SB_SN_RELC_1                                      0x20                                                  
#define FTD_SB_SN_PREC_1                                      0x21                                                  
#define FTD_SB_SN_DELC_1                                      0x22                                                  
#define FTD_SB_SN_PTPC_1                                      0x23                                                  
#define FTD_SB_SN_MTPC_1                                      0x24                                                  
#define FTD_SB_SN_RPRI_1                                      0x25                                                  
#define FTD_SB_SN_DCOMP_1                                     0x26                                                  
#define FTD_SB_SN_HCOMP_1                                     0x27                                                  
#define FTD_SB_SN_NPDU_ABORT                                  0x28                                                  
#define FTD_SB_SN_NPDU_RECV                                   0x29                                                  
#define FTD_SB_SN_NPDU_SENT                                   0x2A                                                  
#define FTD_SB_SN_NPDU_RESENT                                 0x2B                                                  
#define FTD_SB_SN_RELC_2                                      0x2C                                                  
#define FTD_SB_SN_PREC_2                                      0x2D                                                  
#define FTD_SB_SN_DELC_2                                      0x2E                                                  
#define FTD_SB_SN_PTPC_2                                      0x2F                                                  
#define FTD_SB_SN_MTPC_2                                      0x30                                                  
#define FTD_SB_SN_RPRI_2                                      0x31                                                  
#define FTD_SB_SN_DCOMP_2                                     0x32                                                  
#define FTD_SB_SN_HCOMP_2                                     0x33                                                  
#define FTD_SB_LLC_FCS_FAIL                                   0x34                                                  
#define FTD_SB_LLC_KC1                                        0x35                                                  
#define FTD_SB_LLC_KC2                                        0x36                                                  
#define FTD_SB_LLC_OC_I_UL                                    0x37                                                  
#define FTD_SB_LLC_OC_I_DL                                    0x38                                                  
#define FTD_SB_LLC_OC_UI_UL                                   0x39                                                  
#define FTD_SB_LLC_OC_UI_DL                                   0x3A                                                  
#define FTD_SB_LLC_PDU_MISS                                   0x3B                                                  
#define FTD_SB_LLC_PDU_RECV                                   0x3C                                                  
#define FTD_SB_LLC_PDU_RESENT                                 0x3D                                                  
#define FTD_SB_LLC_PDU_SENT                                   0x3E                                                  
#define FTD_SB_LLC_N200_1                                     0x3F                                                  
#define FTD_SB_LLC_T200_1                                     0x40                                                  
#define FTD_SB_LLC_N201_U_1                                   0x41                                                  
#define FTD_SB_LLC_N201_I_1                                   0x42                                                  
#define FTD_SB_LLC_KD_1                                       0x43                                                  
#define FTD_SB_LLC_KU_1                                       0x44                                                  
#define FTD_SB_LLC_VS_1                                       0x45                                                  
#define FTD_SB_LLC_VR_1                                       0x46                                                  
#define FTD_SB_LLC_VA_1                                       0x47                                                  
#define FTD_SB_LLC_N200_2                                     0x48                                                  
#define FTD_SB_LLC_T200_2                                     0x49                                                  
#define FTD_SB_LLC_N201_U_2                                   0x4A                                                  
#define FTD_SB_LLC_N201_I_2                                   0x4B                                                  
#define FTD_SB_LLC_KD_2                                       0x4C                                                  
#define FTD_SB_LLC_KU_2                                       0x4D                                                  
#define FTD_SB_LLC_VS_2                                       0x4E                                                  
#define FTD_SB_LLC_VR_2                                       0x4F                                                  
#define FTD_SB_LLC_VA_2                                       0x50                                                  
#define FTD_SB_RLC_PAN_MAX                                    0x51                                                  
#define FTD_SB_RLC_PAN_DEC                                    0x52                                                  
#define FTD_SB_RLC_PAN_INC                                    0x53                                                  
#define FTD_SB_RLC_T3192                                      0x54                                                  
#define FTD_SB_RLC_BS_CV_MAX                                  0x55                                                  
#define FTD_SB_RLC_ACK_SENT                                   0x56                                                  
#define FTD_SB_RLC_DL_MODE                                    0x57                                                  
#define FTD_SB_RLC_DL_CH_CODE                                 0x58                                                  
#define FTD_SB_RLC_DL_SLOTS                                   0x59                                                  
#define FTD_SB_RLC_BLOCKS_RECV                                0x5A                                                  
#define FTD_SB_RLC_BLOCKS_MISS                                0x5B                                                  
#define FTD_SB_RLC_TBF_REL_T3190                              0x5C                                                  
#define FTD_SB_RLC_PDU_ABORT                                  0x5D                                                  
#define FTD_SB_RLC_UL_MODE                                    0x5E                                                  
#define FTD_SB_RLC_UL_CH_CODE                                 0x5F                                                  
#define FTD_SB_RLC_UL_SLOTS                                   0x60                                                  
#define FTD_SB_RLC_ENDING_MODE                                0x61                                                  
#define FTD_SB_RLC_TBF_REL_NO                                 0x62                                                  
#define FTD_SB_RLC_ACK_RECV                                   0x63                                                  
#define FTD_SB_RLC_BLOCKS_SENT                                0x64                                                  
#define FTD_SB_RLC_BLOCKS_RESENT                              0x65                                                  
#define FTD_SB_RLC_N3102                                      0x66                                                  
#define FTD_SB_RLC_WINDOW_STALL                               0x67                                                  
#define FTD_SB_RLC_CONT_RES_FAIL                              0x68                                                  
#define FTD_SB_RLC_TBF_REL_N3102                              0x69                                                  
#define FTD_SB_RLC_TBF_REL_T3164                              0x6A                                                  
#define FTD_SB_RLC_TBF_REL_T3180                              0x6B                                                  
#define FTD_SB_RLC_TBF_REL_T3182                              0x6C                                                  
#define FTD_SB_RLC_TBF_REL_T3184                              0x6D                                                  
#define FTD_SB_GMM_ATTACH_STATUS                              0x6E                                                  
#define FTD_SB_GMM_R_AND_S                                    0x6F                                                  
#define FTD_SB_GMM_NW_MODE                                    0x70                                                  
#define FTD_SB_GMM_ATTACH_TYPE                                0x71                                                  
#define FTD_SB_GMM_READY_TMR_STATUS                           0x72                                                  
#define FTD_SB_GMM_READY_TMR_TIMEOUT                          0x73                                                  
#define FTD_SB_GMM_RAU_TMR_CURRENT                            0x74                                                  
#define FTD_SB_GMM_RAU_TMR_TIMEOUT                            0x75                                                  
#define FTD_SB_GMM_PTMSI_VALUE                                0x76                                                  
#define FTD_SB_GMM_RAI_VALUE                                  0x77                                                  
#define FTD_SB_GMM_CIPHERING_VALUE                            0x78                                                  
#define FTD_SB_GMM_SPLIT_PG_CYCLE_VALUE                       0x79                                                  
#define FTD_SB_GMM_NON_DRX_TMR                                0x7A                                                  
#define FTD_SB_GMM_SMS_PRIORITY                               0x7B                                                  
#define FTD_SB_GMM_ATTACH_FAIL_CAUSE                          0x7C                                                  
#define FTD_SB_GMM_ATTACH_ATTEMPT                             0x7D                                                  
#define FTD_SB_GMM_ATTACH_OK                                  0x7E                                                  
#define FTD_SB_GMM_NTW_INIT_DET_CAUSE                         0x7F                                                  
#define FTD_SB_GMM_NTW_INIT_DETACH                            0x80                                                  
#define FTD_SB_MAC_DL_TFI                                     0x81                                                  
#define FTD_SB_MAC_ALLOC_MODE                                 0x82                                                  
#define FTD_SB_MAC_UL_TBF_EST_CAUSE                           0x83                                                  
#define FTD_SB_MAC_CH_REQ_TYPE                                0x84                                                  
#define FTD_SB_MAC_RADIO_PRIORITY                             0x85                                                  
#define FTD_SB_MAC_TBF_EST_RES                                0x86                                                  
#define FTD_SB_MAC_TBF_EST_REALIZED                           0x87                                                  
#define FTD_SB_MAC_CTRL_ACK_TYPE                              0x88                                                  
#define FTD_SB_MAC_ACC_BURST_TYPE                             0x89                                                  
#define FTD_SB_MAC_DRX_TIMER_MAX                              0x8A                                                  
#define FTD_SB_MAC_SPLIT_PG_CYCLE_ON_CCCH                     0x8B                                                  
#define FTD_SB_MAC_PAGE_MODE                                  0x8C                                                  
#define FTD_SB_MAC_NC_MODE_BROADCAST                          0x8D                                                  
#define FTD_SB_MAC_T3168_VALUE                                0x8E                                                  
#define FTD_SB_MAC_PCCCH_SUPPORTED                            0x8F                                                  
#define FTD_SB_MAC_BS_PBCCH_BLKS                              0x90                                                  
#define FTD_SB_MAC_BS_PCC_CHANS                               0x91                                                  
#define FTD_SB_MAC_BS_PAG_BLKS_RES                            0x92                                                  
#define FTD_SB_MAC_BS_PCC_REL                                 0x93                                                  
#define FTD_SB_MAC_BS_PRACH_BLKS                              0x94                                                  
#define FTD_SB_MAC_MAX_PRA_RETRANS                            0x95                                                  
#define FTD_SB_MAC_PSI5_BROADCAST                             0x96                                                  
#define FTD_SB_MAC_PSI1_REPEAT_PERIOD                         0x97                                                  
#define FTD_SB_MAC_PSI_COUNT_LR                               0x98                                                  
#define FTD_SB_MAC_PSI_COUNT_HR                               0x99                                                  
#define FTD_SB_MAC_PSI_STATUS_IND                             0x9A                                                  
#define FTD_SB_MAC_QUAL_REP_SENT_IN                           0x9B                                                  
#define FTD_SB_MAC_QUAL_REP_C                                 0x9C                                                  
#define FTD_SB_MAC_QUAL_REP_RXQUAL                            0x9D                                                  
#define FTD_SB_MAC_QUAL_REP_SIGN_VAR                          0x9E                                                  
#define FTD_SB_MAC_QUAL_REP_I_LEVEL_TN0                       0x9F                                                  
#define FTD_SB_MAC_QUAL_REP_I_LEVEL_TN1                       0xA0                                                  
#define FTD_SB_MAC_QUAL_REP_I_LEVEL_TN2                       0xA1                                                  
#define FTD_SB_MAC_QUAL_REP_I_LEVEL_TN3                       0xA2                                                  
#define FTD_SB_MAC_QUAL_REP_I_LEVEL_TN4                       0xA3                                                  
#define FTD_SB_MAC_QUAL_REP_I_LEVEL_TN5                       0xA4                                                  
#define FTD_SB_MAC_QUAL_REP_I_LEVEL_TN6                       0xA5                                                  
#define FTD_SB_MAC_QUAL_REP_I_LEVEL_TN7                       0xA6                                                  
#define FTD_SB_MAC_NC_MODE                                    0xA7                                                  
#define FTD_SB_MAC_NC_NON_DRX_PERIOD                          0xA8                                                  
#define FTD_SB_MAC_NC_REPORTING_PERIOD                        0xA9                                                  
#define FTD_SB_MAC_NC_PARAMS_SOURCE                           0xAA                                                  
#define FTD_SB_MAC_EXT_MEAS_ORDER                             0xAB                                                  
#define FTD_SB_MAC_EXT_MEAS_REP_TYPE                          0xAC                                                  
#define FTD_SB_MAC_EXT_REPORTING_PERIOD                       0xAD                                                  
#define FTD_SB_MAC_EXT_PARAMS_SOURCE                          0xAE                                                  
#define FTD_SB_MAC_EXT_NCC_PERMITTED                          0xAF                                                  
#define FTD_SB_MAC_NC_REP_RXLEV_SERVCELL                      0xB0                                                  
#define FTD_SB_MAC_NC_REP_INT_SERVCELL                        0xB1                                                  
#define FTD_SB_MAC_NC_REP_1_CARRIER                           0xB2                                                  
#define FTD_SB_MAC_NC_REP_1_BSIC                              0xB3                                                  
#define FTD_SB_MAC_NC_REP_1_RXLEV                             0xB4                                                  
#define FTD_SB_MAC_NC_REP_2_CARRIER                           0xB5                                                  
#define FTD_SB_MAC_NC_REP_2_BSIC                              0xB6                                                  
#define FTD_SB_MAC_NC_REP_2_RXLEV                             0xB7                                                  
#define FTD_SB_MAC_NC_REP_3_CARRIER                           0xB8                                                  
#define FTD_SB_MAC_NC_REP_3_BSIC                              0xB9                                                  
#define FTD_SB_MAC_NC_REP_3_RXLEV                             0xBA                                                  
#define FTD_SB_MAC_NC_REP_4_CARRIER                           0xBB                                                  
#define FTD_SB_MAC_NC_REP_4_BSIC                              0xBC                                                  
#define FTD_SB_MAC_NC_REP_4_RXLEV                             0xBD                                                  
#define FTD_SB_MAC_NC_REP_5_CARRIER                           0xBE                                                  
#define FTD_SB_MAC_NC_REP_5_BSIC                              0xBF                                                  
#define FTD_SB_MAC_NC_REP_5_RXLEV                             0xC0                                                  
#define FTD_SB_MAC_NC_REP_6_CARRIER                           0xC1                                                  
#define FTD_SB_MAC_NC_REP_6_BSIC                              0xC2                                                  
#define FTD_SB_MAC_NC_REP_6_RXLEV                             0xC3                                                  
#define FTD_SB_MAC_EXT_REP_1_CARRIER                          0xC4                                                  
#define FTD_SB_MAC_EXT_REP_1_BSIC                             0xC5                                                  
#define FTD_SB_MAC_EXT_REP_1_RXLEV                            0xC6                                                  
#define FTD_SB_MAC_EXT_REP_2_CARRIER                          0xC7                                                  
#define FTD_SB_MAC_EXT_REP_2_BSIC                             0xC8                                                  
#define FTD_SB_MAC_EXT_REP_2_RXLEV                            0xC9                                                  
#define FTD_SB_MAC_EXT_REP_3_CARRIER                          0xCA                                                  
#define FTD_SB_MAC_EXT_REP_3_BSIC                             0xCB                                                  
#define FTD_SB_MAC_EXT_REP_3_RXLEV                            0xCC                                                  
#define FTD_SB_MAC_EXT_REP_4_CARRIER                          0xCD                                                  
#define FTD_SB_MAC_EXT_REP_4_BSIC                             0xCE                                                  
#define FTD_SB_MAC_EXT_REP_4_RXLEV                            0xCF                                                  
#define FTD_SB_MAC_EXT_REP_5_CARRIER                          0xD0                                                  
#define FTD_SB_MAC_EXT_REP_5_BSIC                             0xD1                                                  
#define FTD_SB_MAC_EXT_REP_5_RXLEV                            0xD2                                                  
#define FTD_SB_MAC_EXT_REP_6_CARRIER                          0xD3                                                  
#define FTD_SB_MAC_EXT_REP_6_BSIC                             0xD4                                                  
#define FTD_SB_MAC_EXT_REP_6_RXLEV                            0xD5                                                  
#define FTD_SB_MAC_EXT_REP_I_LEVEL_TN0                        0xD6                                                  
#define FTD_SB_MAC_EXT_REP_I_LEVEL_TN1                        0xD7                                                  
#define FTD_SB_MAC_EXT_REP_I_LEVEL_TN2                        0xD8                                                  
#define FTD_SB_MAC_EXT_REP_I_LEVEL_TN3                        0xD9                                                  
#define FTD_SB_MAC_EXT_REP_I_LEVEL_TN4                        0xDA                                                  
#define FTD_SB_MAC_EXT_REP_I_LEVEL_TN5                        0xDB                                                  
#define FTD_SB_MAC_EXT_REP_I_LEVEL_TN6                        0xDC                                                  
#define FTD_SB_MAC_EXT_REP_I_LEVEL_TN7                        0xDD                                                  
#define FTD_SB_MAC_DL_PWR_CTRL_BTS_MODE                       0xDE                                                  
#define FTD_SB_MAC_DL_PWR_CTRL_P0                             0xDF                                                  
#define FTD_SB_MAC_DL_PWR_CTRL_PR_MODE                        0xE0                                                  
#define FTD_SB_MAC_CTR_UL_IDLE_CCCH_ATT                       0xE1                                                  
#define FTD_SB_MAC_CTR_UL_IDLE_CCCH                           0xE2                                                  
#define FTD_SB_MAC_CTR_UL_IDLE_PCCCH_ATT                      0xE3                                                  
#define FTD_SB_MAC_CTR_UL_IDLE_PCCCH                          0xE4                                                  
#define FTD_SB_MAC_CTR_UL_DURING_DL_ATT                       0xE5                                                  
#define FTD_SB_MAC_CTR_UL_DURING_DL                           0xE6                                                  
#define FTD_SB_MAC_CTR_DL_EST_CCCH                            0xE7                                                  
#define FTD_SB_MAC_CTR_DL_EST_PCCCH                           0xE8                                                  
#define FTD_SB_MAC_CTR_DL_EST_T3192_RUNNING                   0xE9                                                  
#define FTD_SB_MAC_CTR_DL_EST_TRANSFER                        0xEA                                                  
#define FTD_SB_MAC_CTR_UL_REALLOC_ATT                         0xEB                                                  
#define FTD_SB_MAC_CTR_UL_REALLOC                             0xEC                                                  
#define FTD_SB_MAC_CTR_UL_REALLOC_NET                         0xED                                                  
#define FTD_SB_MAC_CTR_DL_REALLOC                             0xEE                                                  
#define FTD_SB_MAC_CTR_UL_FAIL_CCCH_OTHER                     0xEF                                                  
#define FTD_SB_MAC_CTR_UL_FAIL_PCCCH_OTHER                    0xF0                                                  
#define FTD_SB_MAC_CTR_UL_FAIL_REJECT_CCCH                    0xF1                                                  
#define FTD_SB_MAC_CTR_UL_FAIL_REJECT_PCCCH                   0xF2                                                  
#define FTD_SB_MAC_CTR_UL_FAIL_TIMEOUT_CCCH                   0xF3                                                  
#define FTD_SB_MAC_CTR_UL_FAIL_TIMEOUT_PCCCH                  0xF4                                                  
#define FTD_SB_MAC_CTR_UL_WAIT_ON_SDCCH                       0xF5                                                  
#define FTD_SB_MAC_CTR_UL_QUEUE_ON_PCCCH                      0xF6                                                  
#define FTD_SB_MAC_CTR_ABN_UL_REL_TBF_RELEASE                 0xF7                                                  
#define FTD_SB_MAC_CTR_ABN_UL_REL_T3188_EXPIRY                0xF8                                                  
#define FTD_SB_MAC_CTR_DL_ACKS_SENT                           0xF9                                                  
#define FTD_SB_MAC_CTR_UL_ACKS_RECEIVED                       0xFA                                                  
#define FTD_SB_MAC_CTR_OTHER_CTRL_BLOCKS                      0xFB                                                  
#define FTD_SB_MAC_CTR_OTHER_CTRL_BLOCKS_SENT                 0xFC                                                  
#define FTD_SB_MAC_CTR_4ACC_BURSTS_PCAS_SENT                  0xFD                                                  
#define FTD_SB_MAC_CTR_SUSPEND_IDLE                           0xFE                                                  
#define FTD_SB_MAC_CTR_SUSPEND_TRANSFER                       0xFF                                                  
#define FTD_SB_MAC_CTR_RESUME                                 0x0100                                                   
#define FTD_SB_MAC_CTR_PACKET_PAGING_PTMSI_PCCCH              0x0101                                                   
#define FTD_SB_MAC_CTR_PACKET_PAGING_IMSI_PCCCH               0x0102                                                   
#define FTD_SB_MAC_CTR_PACKET_PAGING_PTMSI_CCCH               0x0103                                                   
#define FTD_SB_MAC_CTR_PACKET_PAGING_IMSI_CCCH                0x0104                                                   
#define FTD_SB_MAC_CTR_PSI13_ON_PACCH                         0x0105                                                   
#define FTD_SB_MAC_CTR_PSI1_ON_PACCH                          0x0106                                                   
#define FTD_SB_MAC_CTR_MEAS_REP_SEND_CCCH_ATT                 0x0107                                                   
#define FTD_SB_MAC_CTR_MEAS_REP_SEND_CCCH                     0x0108                                                   
#define FTD_SB_MAC_CTR_MEAS_REP_SEND_PCCCH_ATT                0x0109                                                   
#define FTD_SB_MAC_CTR_MEAS_REP_SEND_PCCCH                    0x010A                                                   
#define FTD_SB_MAC_CTR_MEAS_REP_SEND_TBF_ATT                  0x010B                                                   
#define FTD_SB_MAC_CTR_MEAS_REP_SEND_TBF                      0x010C                                                   
#define FTD_SB_GPDS_CONTEXT_COUNT                             0x010D                                                   
#define FTD_SB_GPDS_ACTIVE_CIDS                               0x010E                                                   
#define FTD_SB_GPDS_RELATEDPRIM_CID                           0x010F                                                   
#define FTD_SB_GMM_PREVENT_READY_EXPIRY                       0x0110                                                   
#define FTD_SB_GMM_PRAU_FAIL_CAUSE                            0x0111                                                   
#define FTD_SB_GMM_PRAU_ATTEMPT                               0x0112                                                   
#define FTD_SB_GMM_PRAU_OK                                    0x0113                                                   
#define FTD_SB_GMM_RAU_FAIL_CAUSE                             0x0114                                                   
#define FTD_SB_RAU_ATTEMPT                                    0x0115                                                   
#define FTD_SB_RAU_OK                                         0x0116                                                   
#define FTD_SB_SM_MO_PDP_FAIL_CAUSE                           0x0117                                                   
#define FTD_SB_SM_MO_PDP_ATTEMPT                              0x0118                                                   
#define FTD_SB_SM_MO_PDP_OK                                   0x0119                                                   
#define FTD_SB_SM_MO_PDP_DEAC_CAUSE                           0x011A                                                   
#define FTD_SB_SM_MT_PDP_DEAC_CAUSE                           0x011B                                                   
#define FTD_SB_MAC_UL_TBF_IDLE_ATTEMPT                        0x011C                                                   
#define FTD_SB_RLC_UL_TBF_IDLE_SUCC                           0x011D                                                   
#define FTD_SB_MAC_UL_TBF_TRANS_ATTEMPT                       0x011E                                                   
#define FTD_SB_RLC_UL_TBF_TRANS_SUCC                          0x011F                                                   
#define FTD_SB_MAC_DL_TBF_COUNTER                             0x0120                                                   
#define FTD_SB_RLC_UL_TBF_ABNORM_REL                          0x0121                                                   
#define FTD_SB_MAC_RESEL_C_C                                  0x0122                                                   
#define FTD_SB_MAC_RESEL_C_P                                  0x0123                                                   
#define FTD_SB_MAC_RESEL_P_C                                  0x0124                                                   
#define FTD_SB_MAC_RESEL_P_P                                  0x0125                                                   
#define FTD_SB_MAC_PCCO_C_C_ATT                               0x0126                                                   
#define FTD_SB_MAC_PCCO_C_C_OK                                0x0127                                                   
#define FTD_SB_MAC_PCCO_C_P_ATT                               0x0128                                                   
#define FTD_SB_MAC_PCCO_C_P_OK                                0x0129                                                   
#define FTD_SB_MAC_PCCO_P_C_ATT                               0x012A                                                   
#define FTD_SB_MAC_PCCO_P_C_OK                                0x012B                                                   
#define FTD_SB_MAC_PCCO_P_P_ATT                               0x012C                                                   
#define FTD_SB_MAC_PCCO_P_P_OK                                0x012D                                                   
#define FTD_SB_GMM_FOLLOW_ON_REQUEST                          0x0130                                                   
#define FTD_SB_ERLC_MCS_DOWNLINK                              0x0155                                                   
#define FTD_SB_ERLC_MS_OUT_OF_MEM                             0x0156                                                   
#define FTD_SB_ERLC_WINDOW_DOWNLINK                           0x0157                                                   
#define FTD_SB_ERLC_MCS_UPLINK                                0x0158                                                   
#define FTD_SB_ERLC_RESEGMENT                                 0x0159                                                   
#define FTD_SB_ERLC_LINK_ADAPTATIONS                          0x015A                                                   
#define FTD_SB_ERLC_WINDOW_UPLINK                             0x015B                                                   
#define FTD_SB_ERLC_PRE_EMPTIVE                               0x015C                                                   
#define FTD_SB_EGPRS_LQ_MEAS_MODE                             0x015D                                                   
#define FTD_SB_EGPRS_BEP_MEAN_GPSK                            0x015E                                                   
#define FTD_SB_EGPRS_BEP_CV_GPSK                              0x015F                                                   
#define FTD_SB_EGPRS_BEP_MEAN_8PSK                            0x0160                                                   
#define FTD_SB_EGPRS_BEP_CV_8PSK                              0x0161                                                   
#define FTD_SB_DTM_GTTP_UL_CTR                                0x0170                                                   
#define FTD_SB_DTM_GTTP_DL_CTR                                0x0171                                                   
#define FTD_SB_GPDS_MSL_SMS_SERV_REQ_COUNTER                  0x01A0                                                   
#define FTD_SB_GPDS_MSL_DATA_SERV_REQ_COUNTER                 0x01A1                                                   
#define FTD_SB_GPDS_MSL_GSM_SERV_REQ_COUNTER                  0x01A2                                                   
#define FTD_SB_GPDS_MSL_INTSYS_HO_COUNTER                     0x01A3                                                   
#define FTD_SB_GPDS_CHANGE_CONTEXT                            0x0200                                                   
#define FTD_SB_GPDS_CID                                       0x0201                                                   
#define FTD_SB_GPDS_NSAPI                                     0x0202                                                   
#define FTD_SB_GPDS_SAPI                                      0x0203                                                   
#define FTD_SB_GPDS_PDP_ADDRESS_V4_1                          0x0204                                                   
#define FTD_SB_GPDS_PDP_ADDRESS_V4_2                          0x0205                                                   
#define FTD_SB_GPDS_PDP_ADDRESS_V4_3                          0x0206                                                   
#define FTD_SB_GPDS_PDP_ADDRESS_V4_4                          0x0207                                                   
#define FTD_SB_GPDS_SM_RELC                                   0x0208                                                   
#define FTD_SB_GPDS_SM_DELC                                   0x0209                                                   
#define FTD_SB_GPDS_SM_PREC                                   0x020A                                                   
#define FTD_SB_GPDS_SM_PTPC                                   0x020B                                                   
#define FTD_SB_GPDS_SM_MTPC                                   0x020C                                                   
#define FTD_SB_GPDS_SM_TRAC                                   0x0250                                                   
#define FTD_SB_GPDS_SM_DOES                                   0x0251                                                   
#define FTD_SB_GPDS_SM_DELO                                   0x0252                                                   
#define FTD_SB_GPDS_SM_MSDU                                   0x0253                                                   
#define FTD_SB_GPDS_SM_MBRU                                   0x0254                                                   
#define FTD_SB_GPDS_SM_MBRD                                   0x0255                                                   
#define FTD_SB_GPDS_SM_RBER                                   0x0256                                                   
#define FTD_SB_GPDS_SM_SDER                                   0x0257                                                   
#define FTD_SB_GPDS_SM_TRHP                                   0x0258                                                   
#define FTD_SB_GPDS_SM_TRDL                                   0x0259                                                   
#define FTD_SB_GPDS_SM_GBRU                                   0x025A                                                   
#define FTD_SB_GPDS_SM_GBRD                                   0x025B                                                   
#define FTD_SB_GPDS_MSL_RBID                                  0x02A0                                                   
#define FTD_SB_GPDS_MSL_RPRI                                  0x02A1                                                   
#define FTD_SB_GPDS_MSL_PFID                                  0x02A2                                                   
#define FTD_SB_GPDS_MSL_HCOMP                                 0x02A3                                                   
#define FTD_SB_GPDS_MSL_DCOMP                                 0x02A4                                                   
#define FTD_SB_GPDS_PDCP_RBID                                 0x02A5                                                   
#define FTD_SB_GPDS_PDCP_HEADER                               0x02A6                                                   
#define FTD_SB_GPDS_PDCP_RELOC                                0x02A7                                                   
#define FTD_SB_GPDS_PDCP_MAX_WS                               0x02A8                                                   
#define FTD_SB_GPDS_PDCP_RECV_DISC                            0x02A9                                                   
#define FTD_SB_GPDS_PDCP_SENT_DISC                            0x02AA                                                   
#define FTD_SB_GPDS_PDCP_SEQ_RECV                             0x02AB                                                   
#define FTD_SB_GPDS_PDCP_SEQ_SENT                             0x02AC                                                   
#define FTD_SB_GPDS_PDCP_PDU_RECV                             0x02AD                                                   
#define FTD_SB_GPDS_PDCP_PDU_SENT                             0x02AE                                                   
#define FTD_SB_GPDS_RFC2507_MAX_PERIOD                        0x02AF                                                   
#define FTD_SB_GPDS_RFC2507_MAX_TIME                          0x02B0                                                   
#define FTD_SB_GPDS_RFC2507_MAX_HEADER                        0x02B1                                                   
#define FTD_SB_GPDS_RFC2507_EXP_REORD                         0x02B2                                                   
#define FTD_SB_GPDS_RFC2507_TCP_SPACE                         0x02B3                                                   
#define FTD_SB_GPDS_RFC2507_NON_TCP_SPACE                     0x02B4                                                   
#define FTD_SB_GPDS_RFC2507_CTX_STATE_RECV                    0x02B5                                                   
#define FTD_SB_GPDS_RFC2507_CTX_STATE_SENT                    0x02B6                                                   
#define FTD_SB_URR_STATE                                      0x0300                                                   
#define FTD_SB_URR_SCAN_FREQUENCY                             0x0301                                                   
#define FTD_SB_URR_CAUSE                                      0x0302                                                   
#define FTD_SB_URR_REGISTER_REATT                             0x0303                                                   
#define FTD_SB_URR_ROVE_IN_CTR                                0x0304                                                   
#define FTD_SB_URR_ROVE_OUT_CTR                               0x0305                                                   
#define FTD_SB_URR_HO_TO_UMAN_CTR                             0x0306                                                   
#define FTD_SB_URR_HO_TO_GERAN_CTR                            0x0307                                                   
#define FTD_SB_URR_ARFCN                                      0x0308                                                   
#define FTD_SB_URR_BSIC                                       0x0309                                                   
#define FTD_SB_URR_LAC_BLACKLIST                              0x030A                                                   
#define FTD_SB_URR_ADDR_TYPE                                  0x030B                                                   
#define FTD_SB_URR_UNC_ADDRESS_1                              0x030C                                                   
#define FTD_SB_URR_UNC_ADDRESS_2                              0x030D                                                   
#define FTD_SB_URR_UNC_ADDRESS_3                              0x030E                                                   
#define FTD_SB_URR_UNC_ADDRESS_4                              0x030F                                                   
#define FTD_SB_URR_SGW_ADDRESS_1                              0x0310                                                   
#define FTD_SB_URR_SGW_ADDRESS_2                              0x0311                                                   
#define FTD_SB_URR_SGW_ADDRESS_3                              0x0312                                                   
#define FTD_SB_URR_SGW_ADDRESS_4                              0x0313                                                   
#define FTD_SB_URLC_CAUSE                                     0x0330                                                   


//SUBBLOCKS


//Definition for struct GPDS_COMP_INFO
#define GPDS_COMP_INFO                                        0x00                                                     
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint8_t      data_compression;
             uint8_t      header_compression;
            } __attribute__((packed)) GPDS_COMP_INFO_STR;
#define SIZE_GPDS_COMP_INFO                                   sizeof(GPDS_COMP_INFO_STR)


//Definition for struct GPDS_QOS_REQ_INFO
#define GPDS_QOS_REQ_INFO                                     0x01                                                     
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint8_t      precedence;
             uint8_t      delay;
             uint8_t      reliability;
             uint8_t      peak_throughput;
             uint8_t      mean_throughput;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) GPDS_QOS_REQ_INFO_STR;
#define SIZE_GPDS_QOS_REQ_INFO                                sizeof(GPDS_QOS_REQ_INFO_STR)


//Definition for struct GPDS_QOS_MIN_INFO
#define GPDS_QOS_MIN_INFO                                     0x02                                                     
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint8_t      precedence;
             uint8_t      delay;
             uint8_t      reliability;
             uint8_t      peak_throughput;
             uint8_t      mean_throughput;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) GPDS_QOS_MIN_INFO_STR;
#define SIZE_GPDS_QOS_MIN_INFO                                sizeof(GPDS_QOS_MIN_INFO_STR)


//Definition for struct GPDS_QOS_NEG_INFO
#define GPDS_QOS_NEG_INFO                                     0x03                                                     
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint8_t      precedence;
             uint8_t      delay;
             uint8_t      reliability;
             uint8_t      peak_throughput;
             uint8_t      mean_throughput;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) GPDS_QOS_NEG_INFO_STR;
#define SIZE_GPDS_QOS_NEG_INFO                                sizeof(GPDS_QOS_NEG_INFO_STR)


//Definition for struct GPDS_PDP_ADDRESS_INFO
#define GPDS_PDP_ADDRESS_INFO                                 0x04                                                     
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint8_t      fillerbyte1;
             uint8_t      addr_length;
             uint8_t      address[0];
            } __attribute__((packed)) GPDS_PDP_ADDRESS_INFO_STR;
#define SIZE_GPDS_PDP_ADDRESS_INFO                            sizeof(GPDS_PDP_ADDRESS_INFO_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct GPDS_APN_INFO
#define GPDS_APN_INFO                                         0x05                                                     
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint8_t      addr_length;
             uint8_t      apn_name[0];
            } __attribute__((packed)) GPDS_APN_INFO_STR;
#define SIZE_GPDS_APN_INFO                                    sizeof(GPDS_APN_INFO_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct GPDS_FILT_SRC_IPV4_ADDR_INFO
#define GPDS_FILT_SRC_IPV4_ADDR_INFO                          0x10                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint8_t      ipv4_addr_mask;
             uint8_t      fillerbyte1;
             uint32_t     ipv4_address;
            } __attribute__((packed)) GPDS_FILT_SRC_IPV4_ADDR_INFO_STR;
#define SIZE_GPDS_FILT_SRC_IPV4_ADDR_INFO                     sizeof(GPDS_FILT_SRC_IPV4_ADDR_INFO_STR)


//Definition for struct GPDS_FILT_SRC_IPV6_ADDR_INFO
#define GPDS_FILT_SRC_IPV6_ADDR_INFO                          0x20                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint8_t      ipv6_addr_mask;
             uint8_t      fillerbyte1;
             uint8_t      ipv6_address[16];
            } __attribute__((packed)) GPDS_FILT_SRC_IPV6_ADDR_INFO_STR;
#define SIZE_GPDS_FILT_SRC_IPV6_ADDR_INFO                     sizeof(GPDS_FILT_SRC_IPV6_ADDR_INFO_STR)


//Definition for struct GPDS_FILT_PROTOCOL_INFO
#define GPDS_FILT_PROTOCOL_INFO                               0x30                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint8_t      protocol_id;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) GPDS_FILT_PROTOCOL_INFO_STR;
#define SIZE_GPDS_FILT_PROTOCOL_INFO                          sizeof(GPDS_FILT_PROTOCOL_INFO_STR)


//Definition for struct GPDS_FILT_DST_PORT_INFO
#define GPDS_FILT_DST_PORT_INFO                               0x40                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint16_t     destination_port;
            } __attribute__((packed)) GPDS_FILT_DST_PORT_INFO_STR;
#define SIZE_GPDS_FILT_DST_PORT_INFO                          sizeof(GPDS_FILT_DST_PORT_INFO_STR)


//Definition for struct GPDS_FILT_DST_PORT_RANGE_INFO
#define GPDS_FILT_DST_PORT_RANGE_INFO                         0x41                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint16_t     low_limit_dst_port_range;
             uint16_t     high_limit_dst_port_range;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) GPDS_FILT_DST_PORT_RANGE_INFO_STR;
#define SIZE_GPDS_FILT_DST_PORT_RANGE_INFO                    sizeof(GPDS_FILT_DST_PORT_RANGE_INFO_STR)


//Definition for struct GPDS_FILT_SRC_PORT_INFO
#define GPDS_FILT_SRC_PORT_INFO                               0x50                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint16_t     source_port;
            } __attribute__((packed)) GPDS_FILT_SRC_PORT_INFO_STR;
#define SIZE_GPDS_FILT_SRC_PORT_INFO                          sizeof(GPDS_FILT_SRC_PORT_INFO_STR)


//Definition for struct GPDS_FILT_SRC_PORT_RANGE_INFO
#define GPDS_FILT_SRC_PORT_RANGE_INFO                         0x51                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint16_t     low_limit_src_port_range;
             uint16_t     high_limit_src_port_range;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) GPDS_FILT_SRC_PORT_RANGE_INFO_STR;
#define SIZE_GPDS_FILT_SRC_PORT_RANGE_INFO                    sizeof(GPDS_FILT_SRC_PORT_RANGE_INFO_STR)


//Definition for struct GPDS_FILT_SPI_INFO
#define GPDS_FILT_SPI_INFO                                    0x60                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint32_t     security_param_ind;
            } __attribute__((packed)) GPDS_FILT_SPI_INFO_STR;
#define SIZE_GPDS_FILT_SPI_INFO                               sizeof(GPDS_FILT_SPI_INFO_STR)


//Definition for struct GPDS_FILT_TOS_INFO
#define GPDS_FILT_TOS_INFO                                    0x70                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint8_t      tos;
             uint8_t      tos_mask;
            } __attribute__((packed)) GPDS_FILT_TOS_INFO_STR;
#define SIZE_GPDS_FILT_TOS_INFO                               sizeof(GPDS_FILT_TOS_INFO_STR)


//Definition for struct GPDS_FILT_FLOW_LABEL_INFO
#define GPDS_FILT_FLOW_LABEL_INFO                             0x80                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint32_t     flow_label;
            } __attribute__((packed)) GPDS_FILT_FLOW_LABEL_INFO_STR;
#define SIZE_GPDS_FILT_FLOW_LABEL_INFO                        sizeof(GPDS_FILT_FLOW_LABEL_INFO_STR)


//Definition for struct GPDS_TFT_FILTER_INFO
#define GPDS_TFT_FILTER_INFO                                  0x0A                                                     
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint8_t      packet_filter_id;
             uint8_t      filter_eval_prec;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
             uint8_t      number_of_subblocks;
            } __attribute__((packed)) GPDS_TFT_FILTER_INFO_STR;
#define SIZE_GPDS_TFT_FILTER_INFO                             sizeof(GPDS_TFT_FILTER_INFO_STR)


//Definition for struct GPDS_TFT_INFO
#define GPDS_TFT_INFO                                         0x09                                                     
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint8_t      tft_operation;
             uint8_t      number_of_subblocks;
            } __attribute__((packed)) GPDS_TFT_INFO_STR;
#define SIZE_GPDS_TFT_INFO                                    sizeof(GPDS_TFT_INFO_STR)


//Definition for struct GPDS_QOS99_REQ_INFO
#define GPDS_QOS99_REQ_INFO                                   0x06                                                     
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint8_t      traffic_class;
             uint8_t      delivery_order;
             uint8_t      delivery_of_erroneus_sdu;
             uint8_t      residual_ber;
             uint8_t      error_ratio;
             uint8_t      priority;
             uint16_t     transfer_delay;
             uint16_t     max_sdu_size;
             uint16_t     max_bitrate_uplink;
             uint16_t     max_bitrate_downlink;
             uint16_t     gua_bitrate_uplink;
             uint16_t     gua_bitrate_downlink;
            } __attribute__((packed)) GPDS_QOS99_REQ_INFO_STR;
#define SIZE_GPDS_QOS99_REQ_INFO                              sizeof(GPDS_QOS99_REQ_INFO_STR)


//Definition for struct GPDS_QOS99_MIN_INFO
#define GPDS_QOS99_MIN_INFO                                   0x07                                                     
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint8_t      traffic_class;
             uint8_t      delivery_order;
             uint8_t      delivery_of_erroneus_sdu;
             uint8_t      residual_ber;
             uint8_t      error_ratio;
             uint8_t      priority;
             uint16_t     transfer_delay;
             uint16_t     max_sdu_size;
             uint16_t     max_bitrate_uplink;
             uint16_t     max_bitrate_downlink;
             uint16_t     gua_bitrate_uplink;
             uint16_t     gua_bitrate_downlink;
            } __attribute__((packed)) GPDS_QOS99_MIN_INFO_STR;
#define SIZE_GPDS_QOS99_MIN_INFO                              sizeof(GPDS_QOS99_MIN_INFO_STR)


//Definition for struct GPDS_QOS99_NEG_INFO
#define GPDS_QOS99_NEG_INFO                                   0x08                                                     
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint8_t      traffic_class;
             uint8_t      delivery_order;
             uint8_t      delivery_of_erroneus_sdu;
             uint8_t      residual_ber;
             uint8_t      error_ratio;
             uint8_t      priority;
             uint16_t     transfer_delay;
             uint16_t     max_sdu_size;
             uint16_t     max_bitrate_uplink;
             uint16_t     max_bitrate_downlink;
             uint16_t     gua_bitrate_uplink;
             uint16_t     gua_bitrate_downlink;
            } __attribute__((packed)) GPDS_QOS99_NEG_INFO_STR;
#define SIZE_GPDS_QOS99_NEG_INFO                              sizeof(GPDS_QOS99_NEG_INFO_STR)


//Definition for struct GPDS_PDNS_ADDRESS_INFO
#define GPDS_PDNS_ADDRESS_INFO                                0x0D                                                     
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint8_t      fillerbyte1;
             uint8_t      addr_length;
             uint8_t      address[0];
            } __attribute__((packed)) GPDS_PDNS_ADDRESS_INFO_STR;
#define SIZE_GPDS_PDNS_ADDRESS_INFO                           sizeof(GPDS_PDNS_ADDRESS_INFO_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct GPDS_SDNS_ADDRESS_INFO
#define GPDS_SDNS_ADDRESS_INFO                                0x0E                                                     
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint8_t      fillerbyte1;
             uint8_t      addr_length;
             uint8_t      address[0];
            } __attribute__((packed)) GPDS_SDNS_ADDRESS_INFO_STR;
#define SIZE_GPDS_SDNS_ADDRESS_INFO                           sizeof(GPDS_SDNS_ADDRESS_INFO_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct GPDS_USERNAME_INFO
#define GPDS_USERNAME_INFO                                    0x0B                                                     
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint8_t      username_length;
             uint8_t      username[0];
            } __attribute__((packed)) GPDS_USERNAME_INFO_STR;
#define SIZE_GPDS_USERNAME_INFO                               sizeof(GPDS_USERNAME_INFO_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct GPDS_PASSWORD_INFO
#define GPDS_PASSWORD_INFO                                    0x0C                                                     
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint8_t      password_length;
             uint8_t      password[0];
            } __attribute__((packed)) GPDS_PASSWORD_INFO_STR;
#define SIZE_GPDS_PASSWORD_INFO                               sizeof(GPDS_PASSWORD_INFO_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct GPDS_DNS_ADDRESS_REQ_INFO
#define GPDS_DNS_ADDRESS_REQ_INFO                             0x90                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) GPDS_DNS_ADDRESS_REQ_INFO_STR;
#define SIZE_GPDS_DNS_ADDRESS_REQ_INFO                        sizeof(GPDS_DNS_ADDRESS_REQ_INFO_STR)


//Definition for struct GPDS_CHALLENGE_INFO
#define GPDS_CHALLENGE_INFO                                   0x0F                                                     
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint8_t      challenge_length;
             uint8_t      challenge[0];
            } __attribute__((packed)) GPDS_CHALLENGE_INFO_STR;
#define SIZE_GPDS_CHALLENGE_INFO                              sizeof(GPDS_CHALLENGE_INFO_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct GPDS_CONDITIONAL_DETACH_INFO
#define GPDS_CONDITIONAL_DETACH_INFO                          0xA0                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) GPDS_CONDITIONAL_DETACH_INFO_STR;
#define SIZE_GPDS_CONDITIONAL_DETACH_INFO                     sizeof(GPDS_CONDITIONAL_DETACH_INFO_STR)


//Definition for struct GPDS_RESPONSE_INFO
#define GPDS_RESPONSE_INFO                                    0x11                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint8_t      identifier;
             uint8_t      response_length;
             uint8_t      response[0];
            } __attribute__((packed)) GPDS_RESPONSE_INFO_STR;
#define SIZE_GPDS_RESPONSE_INFO                               sizeof(GPDS_RESPONSE_INFO_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct GPDS_MBMS_SERVICE_BEARER_STATE
#define GPDS_MBMS_SERVICE_BEARER_STATE                        0xA1                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint8_t      tmgi[6];
             uint8_t      mbms_bearer_state;
             uint8_t      cause;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) GPDS_MBMS_SERVICE_BEARER_STATE_STR;
#define SIZE_GPDS_MBMS_SERVICE_BEARER_STATE                   sizeof(GPDS_MBMS_SERVICE_BEARER_STATE_STR)


//Definition for struct GPDS_MBMS_MULTICAST_PARAMS
#define GPDS_MBMS_MULTICAST_PARAMS                            0xA2                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint8_t      mbms_pdp_type;
             uint8_t      fillerbyte1;
             uint16_t     mbms_bearer_capabilities;
             uint8_t      fillerbyte2;
             uint8_t      number_of_sub_blocks;
            } __attribute__((packed)) GPDS_MBMS_MULTICAST_PARAMS_STR;
#define SIZE_GPDS_MBMS_MULTICAST_PARAMS                       sizeof(GPDS_MBMS_MULTICAST_PARAMS_STR)


//Definition for struct GPDS_ACTIVATE_PDP_CONTEXT_REQUEST
#define GPDS_ACTIVATE_PDP_CONTEXT_REQUEST                     0xA4                                                  
typedef struct
            { 
             uint8_t      sb_id;
             uint8_t      fillerbyte1;
             uint16_t     sb_len;
             uint16_t     datalength;
             uint8_t      data[0];
            } __attribute__((packed)) GPDS_ACTIVATE_PDP_CONTEXT_REQUEST_STR;
#define SIZE_GPDS_ACTIVATE_PDP_CONTEXT_REQUEST                sizeof(GPDS_ACTIVATE_PDP_CONTEXT_REQUEST_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct GPDS_RESOURCE_CONF
#define GPDS_RESOURCE_CONF                                    0xA5                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint16_t     gpds_resource_id;
             uint16_t     res_configuration;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) GPDS_RESOURCE_CONF_STR;
#define SIZE_GPDS_RESOURCE_CONF                               sizeof(GPDS_RESOURCE_CONF_STR)


//Definition for struct GPDS_RESOURCE
#define GPDS_RESOURCE                                         0xA3                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint16_t     res;
            } __attribute__((packed)) GPDS_RESOURCE_STR;
#define SIZE_GPDS_RESOURCE                                    sizeof(GPDS_RESOURCE_STR)


//Definition for struct GPDS_RESOURCE_CONF_REQUIRED
#define GPDS_RESOURCE_CONF_REQUIRED                           0xA6                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint16_t     res_pp;
            } __attribute__((packed)) GPDS_RESOURCE_CONF_REQUIRED_STR;
#define SIZE_GPDS_RESOURCE_CONF_REQUIRED                      sizeof(GPDS_RESOURCE_CONF_REQUIRED_STR)


//Definition for struct GPDS_PIPE_REDIRECTION_INFO
#define GPDS_PIPE_REDIRECTION_INFO                            0xA7                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint8_t      cid;
             uint8_t      operation_status;
            } __attribute__((packed)) GPDS_PIPE_REDIRECTION_INFO_STR;
#define SIZE_GPDS_PIPE_REDIRECTION_INFO                       sizeof(GPDS_PIPE_REDIRECTION_INFO_STR)


//MESSAGES


//Definition for struct GPDS_LL_CONFIGURE_REQ
#define GPDS_LL_CONFIGURE_REQ                                 0x00                                                     
typedef struct
            { 
             uint8_t      utid;
             uint8_t      msg_id;
             uint8_t      cid;
             uint8_t      pipe_handle;
             uint8_t      ppp_mode;
            } __attribute__((packed)) GPDS_LL_CONFIGURE_REQ_STR;
#define SIZE_GPDS_LL_CONFIGURE_REQ                            sizeof(GPDS_LL_CONFIGURE_REQ_STR)


//Definition for struct GPDS_LL_CONFIGURE_RESP
#define GPDS_LL_CONFIGURE_RESP                                0x01                                                     
typedef struct
            { 
             uint8_t      utid;
             uint8_t      msg_id;
             uint8_t      cid;
             uint8_t      status;
            } __attribute__((packed)) GPDS_LL_CONFIGURE_RESP_STR;
#define SIZE_GPDS_LL_CONFIGURE_RESP                           sizeof(GPDS_LL_CONFIGURE_RESP_STR)


//Definition for struct GPDS_CONTEXT_ID_CREATE_REQ
#define GPDS_CONTEXT_ID_CREATE_REQ                            0x02                                                     
typedef struct
            { 
             uint8_t      utid;
             uint8_t      msg_id;
            } __attribute__((packed)) GPDS_CONTEXT_ID_CREATE_REQ_STR;
#define SIZE_GPDS_CONTEXT_ID_CREATE_REQ                       sizeof(GPDS_CONTEXT_ID_CREATE_REQ_STR)


//Definition for struct GPDS_CONTEXT_ID_CREATE_RESP
#define GPDS_CONTEXT_ID_CREATE_RESP                           0x03                                                     
typedef struct
            { 
             uint8_t      utid;
             uint8_t      msg_id;
             uint8_t      cid;
             uint8_t      status;
            } __attribute__((packed)) GPDS_CONTEXT_ID_CREATE_RESP_STR;
#define SIZE_GPDS_CONTEXT_ID_CREATE_RESP                      sizeof(GPDS_CONTEXT_ID_CREATE_RESP_STR)


//Definition for struct GPDS_CONTEXT_ID_CREATE_IND
#define GPDS_CONTEXT_ID_CREATE_IND                            0x04                                                     
typedef struct
            { 
             uint8_t      utid;
             uint8_t      msg_id;
             uint8_t      cid;
            } __attribute__((packed)) GPDS_CONTEXT_ID_CREATE_IND_STR;
#define SIZE_GPDS_CONTEXT_ID_CREATE_IND                       sizeof(GPDS_CONTEXT_ID_CREATE_IND_STR)


//Definition for struct GPDS_CONTEXT_ID_DELETE_IND
#define GPDS_CONTEXT_ID_DELETE_IND                            0x05                                                     
typedef struct
            { 
             uint8_t      utid;
             uint8_t      msg_id;
             uint8_t      cid;
            } __attribute__((packed)) GPDS_CONTEXT_ID_DELETE_IND_STR;
#define SIZE_GPDS_CONTEXT_ID_DELETE_IND                       sizeof(GPDS_CONTEXT_ID_DELETE_IND_STR)


//Definition for struct GPDS_LL_BIND_REQ
#define GPDS_LL_BIND_REQ                                      0x20                                                  
typedef struct
            { 
             uint8_t      utid;
             uint8_t      msg_id;
             uint8_t      cid;
             uint8_t      pipe_handle;
            } __attribute__((packed)) GPDS_LL_BIND_REQ_STR;
#define SIZE_GPDS_LL_BIND_REQ                                 sizeof(GPDS_LL_BIND_REQ_STR)


//Definition for struct GPDS_LL_BIND_RESP
#define GPDS_LL_BIND_RESP                                     0x21                                                  
typedef struct
            { 
             uint8_t      utid;
             uint8_t      msg_id;
             uint8_t      cid;
             uint8_t      status;
            } __attribute__((packed)) GPDS_LL_BIND_RESP_STR;
#define SIZE_GPDS_LL_BIND_RESP                                sizeof(GPDS_LL_BIND_RESP_STR)


//Definition for struct GPDS_CONTEXT_CONFIGURE_REQ
#define GPDS_CONTEXT_CONFIGURE_REQ                            0x06                                                     
typedef struct
            { 
             uint8_t      utid;
             uint8_t      msg_id;
             uint8_t      cid;
             uint8_t      pdp_type;
             uint8_t      context_type;
             uint8_t      primary_cid;
             uint8_t      fillerbyte1;
             uint8_t      number_of_sub_blocks;
            } __attribute__((packed)) GPDS_CONTEXT_CONFIGURE_REQ_STR;
#define SIZE_GPDS_CONTEXT_CONFIGURE_REQ                       sizeof(GPDS_CONTEXT_CONFIGURE_REQ_STR)


//Definition for struct GPDS_CONTEXT_CONFIGURE_RESP
#define GPDS_CONTEXT_CONFIGURE_RESP                           0x07                                                     
typedef struct
            { 
             uint8_t      utid;
             uint8_t      msg_id;
             uint8_t      cid;
             uint8_t      status;
            } __attribute__((packed)) GPDS_CONTEXT_CONFIGURE_RESP_STR;
#define SIZE_GPDS_CONTEXT_CONFIGURE_RESP                      sizeof(GPDS_CONTEXT_CONFIGURE_RESP_STR)


//Definition for struct GPDS_CONTEXT_MODIFY_REQ
#define GPDS_CONTEXT_MODIFY_REQ                               0x2A                                                  
typedef struct
            { 
             uint8_t      utid;
             uint8_t      msg_id;
             uint8_t      cid;
             uint8_t      number_of_sub_blocks;
            } __attribute__((packed)) GPDS_CONTEXT_MODIFY_REQ_STR;
#define SIZE_GPDS_CONTEXT_MODIFY_REQ                          sizeof(GPDS_CONTEXT_MODIFY_REQ_STR)


//Definition for struct GPDS_CONTEXT_MODIFY_RESP
#define GPDS_CONTEXT_MODIFY_RESP                              0x2B                                                  
typedef struct
            { 
             uint8_t      utid;
             uint8_t      msg_id;
             uint8_t      cid;
             uint8_t      status;
             uint8_t      cause;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      number_of_sub_blocks;
            } __attribute__((packed)) GPDS_CONTEXT_MODIFY_RESP_STR;
#define SIZE_GPDS_CONTEXT_MODIFY_RESP                         sizeof(GPDS_CONTEXT_MODIFY_RESP_STR)


//Definition for struct GPDS_CONTEXT_MODIFY_IND
#define GPDS_CONTEXT_MODIFY_IND                               0x2C                                                  
typedef struct
            { 
             uint8_t      utid;
             uint8_t      msg_id;
             uint8_t      cid;
             uint8_t      number_of_sub_blocks;
            } __attribute__((packed)) GPDS_CONTEXT_MODIFY_IND_STR;
#define SIZE_GPDS_CONTEXT_MODIFY_IND                          sizeof(GPDS_CONTEXT_MODIFY_IND_STR)


//Definition for struct GPDS_CONTEXT_ACTIVATE_REQ
#define GPDS_CONTEXT_ACTIVATE_REQ                             0x08                                                     
typedef struct
            { 
             uint8_t      utid;
             uint8_t      msg_id;
             uint8_t      cid;
             uint8_t      number_of_sub_blocks;
            } __attribute__((packed)) GPDS_CONTEXT_ACTIVATE_REQ_STR;
#define SIZE_GPDS_CONTEXT_ACTIVATE_REQ                        sizeof(GPDS_CONTEXT_ACTIVATE_REQ_STR)


//Definition for struct GPDS_CONTEXT_ACTIVATE_RESP
#define GPDS_CONTEXT_ACTIVATE_RESP                            0x09                                                     
typedef struct
            { 
             uint8_t      utid;
             uint8_t      msg_id;
             uint8_t      cid;
             uint8_t      status;
             uint8_t      cause;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      number_of_sub_blocks;
            } __attribute__((packed)) GPDS_CONTEXT_ACTIVATE_RESP_STR;
#define SIZE_GPDS_CONTEXT_ACTIVATE_RESP                       sizeof(GPDS_CONTEXT_ACTIVATE_RESP_STR)


//Definition for struct GPDS_CONTEXT_ACTIVATE_IND
#define GPDS_CONTEXT_ACTIVATE_IND                             0x0A                                                     
typedef struct
            { 
             uint8_t      utid;
             uint8_t      msg_id;
             uint8_t      cid;
             uint8_t      number_of_sub_blocks;
            } __attribute__((packed)) GPDS_CONTEXT_ACTIVATE_IND_STR;
#define SIZE_GPDS_CONTEXT_ACTIVATE_IND                        sizeof(GPDS_CONTEXT_ACTIVATE_IND_STR)


//Definition for struct GPDS_CONTEXT_ACTIVATING_IND
#define GPDS_CONTEXT_ACTIVATING_IND                           0x25                                                  
typedef struct
            { 
             uint8_t      utid;
             uint8_t      msg_id;
             uint8_t      cid;
             uint8_t      client_type;
             uint8_t      pdp_type;
             uint8_t      context_type;
             uint8_t      fillerbyte1;
             uint8_t      number_of_sub_blocks;
            } __attribute__((packed)) GPDS_CONTEXT_ACTIVATING_IND_STR;
#define SIZE_GPDS_CONTEXT_ACTIVATING_IND                      sizeof(GPDS_CONTEXT_ACTIVATING_IND_STR)


//Definition for struct GPDS_CONTEXT_ACTIVATE_FAIL_IND
#define GPDS_CONTEXT_ACTIVATE_FAIL_IND                        0x1F                                                  
typedef struct
            { 
             uint8_t      utid;
             uint8_t      msg_id;
             uint8_t      cid;
             uint8_t      cause;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
             uint8_t      number_of_sub_blocks;
            } __attribute__((packed)) GPDS_CONTEXT_ACTIVATE_FAIL_IND_STR;
#define SIZE_GPDS_CONTEXT_ACTIVATE_FAIL_IND                   sizeof(GPDS_CONTEXT_ACTIVATE_FAIL_IND_STR)


//Definition for struct GPDS_CONTEXT_DEACTIVATE_REQ
#define GPDS_CONTEXT_DEACTIVATE_REQ                           0x0B                                                     
typedef struct
            { 
             uint8_t      utid;
             uint8_t      msg_id;
             uint8_t      cid;
            } __attribute__((packed)) GPDS_CONTEXT_DEACTIVATE_REQ_STR;
#define SIZE_GPDS_CONTEXT_DEACTIVATE_REQ                      sizeof(GPDS_CONTEXT_DEACTIVATE_REQ_STR)


//Definition for struct GPDS_CONTEXT_DEACTIVATE_RESP
#define GPDS_CONTEXT_DEACTIVATE_RESP                          0x0C                                                     
typedef struct
            { 
             uint8_t      utid;
             uint8_t      msg_id;
             uint8_t      cid;
             uint8_t      status;
            } __attribute__((packed)) GPDS_CONTEXT_DEACTIVATE_RESP_STR;
#define SIZE_GPDS_CONTEXT_DEACTIVATE_RESP                     sizeof(GPDS_CONTEXT_DEACTIVATE_RESP_STR)


//Definition for struct GPDS_CONTEXT_DEACTIVATE_IND
#define GPDS_CONTEXT_DEACTIVATE_IND                           0x0D                                                     
typedef struct
            { 
             uint8_t      utid;
             uint8_t      msg_id;
             uint8_t      cid;
             uint8_t      cause;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
             uint8_t      number_of_sub_blocks;
            } __attribute__((packed)) GPDS_CONTEXT_DEACTIVATE_IND_STR;
#define SIZE_GPDS_CONTEXT_DEACTIVATE_IND                      sizeof(GPDS_CONTEXT_DEACTIVATE_IND_STR)


//Definition for struct GPDS_CONTEXT_DEACTIVATING_IND
#define GPDS_CONTEXT_DEACTIVATING_IND                         0x2F                                                  
typedef struct
            { 
             uint8_t      utid;
             uint8_t      msg_id;
             uint8_t      cid;
            } __attribute__((packed)) GPDS_CONTEXT_DEACTIVATING_IND_STR;
#define SIZE_GPDS_CONTEXT_DEACTIVATING_IND                    sizeof(GPDS_CONTEXT_DEACTIVATING_IND_STR)


//Definition for struct GPDS_CONTEXT_NWI_ACT_REQUEST_IND
#define GPDS_CONTEXT_NWI_ACT_REQUEST_IND                      0x0E                                                     
typedef struct
            { 
             uint8_t      utid;
             uint8_t      msg_id;
             uint8_t      pdp_type;
             uint8_t      number_of_sub_blocks;
            } __attribute__((packed)) GPDS_CONTEXT_NWI_ACT_REQUEST_IND_STR;
#define SIZE_GPDS_CONTEXT_NWI_ACT_REQUEST_IND                 sizeof(GPDS_CONTEXT_NWI_ACT_REQUEST_IND_STR)


//Definition for struct GPDS_CONTEXT_NWI_ACT_REJECT_REQ
#define GPDS_CONTEXT_NWI_ACT_REJECT_REQ                       0x0F                                                     
typedef struct
            { 
             uint8_t      utid;
             uint8_t      msg_id;
             uint8_t      cause;
            } __attribute__((packed)) GPDS_CONTEXT_NWI_ACT_REJECT_REQ_STR;
#define SIZE_GPDS_CONTEXT_NWI_ACT_REJECT_REQ                  sizeof(GPDS_CONTEXT_NWI_ACT_REJECT_REQ_STR)


//Definition for struct GPDS_CONTEXT_NWI_ACT_REJECT_RESP
#define GPDS_CONTEXT_NWI_ACT_REJECT_RESP                      0x10                                                  
typedef struct
            { 
             uint8_t      utid;
             uint8_t      msg_id;
            } __attribute__((packed)) GPDS_CONTEXT_NWI_ACT_REJECT_RESP_STR;
#define SIZE_GPDS_CONTEXT_NWI_ACT_REJECT_RESP                 sizeof(GPDS_CONTEXT_NWI_ACT_REJECT_RESP_STR)


//Definition for struct GPDS_CONFIGURE_REQ
#define GPDS_CONFIGURE_REQ                                    0x11                                                  
typedef struct
            { 
             uint8_t      utid;
             uint8_t      msg_id;
             uint8_t      attach_mode;
             uint8_t      mt_context_act_mode;
             uint8_t      class_c_mode;
             uint8_t      aol_context;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) GPDS_CONFIGURE_REQ_STR;
#define SIZE_GPDS_CONFIGURE_REQ                               sizeof(GPDS_CONFIGURE_REQ_STR)


//Definition for struct GPDS_CONFIGURE_RESP
#define GPDS_CONFIGURE_RESP                                   0x12                                                  
typedef struct
            { 
             uint8_t      utid;
             uint8_t      msg_id;
             uint8_t      status;
            } __attribute__((packed)) GPDS_CONFIGURE_RESP_STR;
#define SIZE_GPDS_CONFIGURE_RESP                              sizeof(GPDS_CONFIGURE_RESP_STR)


//Definition for struct GPDS_ATTACH_REQ
#define GPDS_ATTACH_REQ                                       0x13                                                  
typedef struct
            { 
             uint8_t      utid;
             uint8_t      msg_id;
             uint8_t      follow;
            } __attribute__((packed)) GPDS_ATTACH_REQ_STR;
#define SIZE_GPDS_ATTACH_REQ                                  sizeof(GPDS_ATTACH_REQ_STR)


//Definition for struct GPDS_ATTACH_RESP
#define GPDS_ATTACH_RESP                                      0x14                                                  
typedef struct
            { 
             uint8_t      utid;
             uint8_t      msg_id;
             uint8_t      status;
             uint8_t      cause;
             uint8_t      attach_type;
            } __attribute__((packed)) GPDS_ATTACH_RESP_STR;
#define SIZE_GPDS_ATTACH_RESP                                 sizeof(GPDS_ATTACH_RESP_STR)


//Definition for struct GPDS_ATTACH_IND
#define GPDS_ATTACH_IND                                       0x15                                                  
typedef struct
            { 
             uint8_t      utid;
             uint8_t      msg_id;
             uint8_t      attach_type;
            } __attribute__((packed)) GPDS_ATTACH_IND_STR;
#define SIZE_GPDS_ATTACH_IND                                  sizeof(GPDS_ATTACH_IND_STR)


//Definition for struct GPDS_ATTACH_FAIL_IND
#define GPDS_ATTACH_FAIL_IND                                  0x2D                                                  
typedef struct
            { 
             uint8_t      utid;
             uint8_t      msg_id;
             uint8_t      cause;
            } __attribute__((packed)) GPDS_ATTACH_FAIL_IND_STR;
#define SIZE_GPDS_ATTACH_FAIL_IND                             sizeof(GPDS_ATTACH_FAIL_IND_STR)


//Definition for struct GPDS_DETACH_REQ
#define GPDS_DETACH_REQ                                       0x16                                                  
typedef struct
            { 
             uint8_t      utid;
             uint8_t      msg_id;
             uint8_t      fillerbyte1;
             uint8_t      number_of_sub_blocks;
            } __attribute__((packed)) GPDS_DETACH_REQ_STR;
#define SIZE_GPDS_DETACH_REQ                                  sizeof(GPDS_DETACH_REQ_STR)


//Definition for struct GPDS_DETACH_RESP
#define GPDS_DETACH_RESP                                      0x17                                                  
typedef struct
            { 
             uint8_t      utid;
             uint8_t      msg_id;
             uint8_t      status;
             uint8_t      detach_type;
            } __attribute__((packed)) GPDS_DETACH_RESP_STR;
#define SIZE_GPDS_DETACH_RESP                                 sizeof(GPDS_DETACH_RESP_STR)


//Definition for struct GPDS_DETACH_IND
#define GPDS_DETACH_IND                                       0x18                                                  
typedef struct
            { 
             uint8_t      utid;
             uint8_t      msg_id;
             uint8_t      cause;
             uint8_t      detach_type;
            } __attribute__((packed)) GPDS_DETACH_IND_STR;
#define SIZE_GPDS_DETACH_IND                                  sizeof(GPDS_DETACH_IND_STR)


//Definition for struct GPDS_STATUS_REQ
#define GPDS_STATUS_REQ                                       0x19                                                  
typedef struct
            { 
             uint8_t      utid;
             uint8_t      msg_id;
            } __attribute__((packed)) GPDS_STATUS_REQ_STR;
#define SIZE_GPDS_STATUS_REQ                                  sizeof(GPDS_STATUS_REQ_STR)


//Definition for struct GPDS_STATUS_RESP
#define GPDS_STATUS_RESP                                      0x1A                                                  
typedef struct
            { 
             uint8_t      utid;
             uint8_t      msg_id;
             uint8_t      attach_status;
             uint8_t      context_count;
             uint32_t     tx_byte_count;
             uint32_t     rx_byte_count;
             uint8_t      transfer_status;
             uint8_t      transfer_cause;
             uint8_t      cid_list[0];
            } __attribute__((packed)) GPDS_STATUS_RESP_STR;
#define SIZE_GPDS_STATUS_RESP                                 sizeof(GPDS_STATUS_RESP_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct GPDS_CONTEXT_STATUS_REQ
#define GPDS_CONTEXT_STATUS_REQ                               0x22                                                  
typedef struct
            { 
             uint8_t      utid;
             uint8_t      msg_id;
             uint8_t      cid;
            } __attribute__((packed)) GPDS_CONTEXT_STATUS_REQ_STR;
#define SIZE_GPDS_CONTEXT_STATUS_REQ                          sizeof(GPDS_CONTEXT_STATUS_REQ_STR)


//Definition for struct GPDS_CONTEXT_STATUS_RESP
#define GPDS_CONTEXT_STATUS_RESP                              0x23                                                  
typedef struct
            { 
             uint8_t      utid;
             uint8_t      msg_id;
             uint8_t      cid;
             uint8_t      status;
             uint32_t     tx_byte_count;
             uint32_t     rx_byte_count;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
             uint8_t      number_of_sub_blocks;
            } __attribute__((packed)) GPDS_CONTEXT_STATUS_RESP_STR;
#define SIZE_GPDS_CONTEXT_STATUS_RESP                         sizeof(GPDS_CONTEXT_STATUS_RESP_STR)


//Definition for struct GPDS_CONTEXT_STATUS_IND
#define GPDS_CONTEXT_STATUS_IND                               0x24                                                  
typedef struct
            { 
             uint8_t      utid;
             uint8_t      msg_id;
             uint8_t      fillerbyte1;
             uint8_t      cid;
             uint32_t     tx_byte_count;
             uint32_t     rx_byte_count;
            } __attribute__((packed)) GPDS_CONTEXT_STATUS_IND_STR;
#define SIZE_GPDS_CONTEXT_STATUS_IND                          sizeof(GPDS_CONTEXT_STATUS_IND_STR)


//Definition for struct GPDS_SMS_PDU_SEND_REQ
#define GPDS_SMS_PDU_SEND_REQ                                 0x1B                                                  
typedef struct
            { 
             uint8_t      utid;
             uint8_t      msg_id;
             uint16_t     pdu_length;
             uint8_t      pdu_data[0];
            } __attribute__((packed)) GPDS_SMS_PDU_SEND_REQ_STR;
#define SIZE_GPDS_SMS_PDU_SEND_REQ                            sizeof(GPDS_SMS_PDU_SEND_REQ_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct GPDS_SMS_PDU_SEND_RESP
#define GPDS_SMS_PDU_SEND_RESP                                0x1C                                                  
typedef struct
            { 
             uint8_t      utid;
             uint8_t      msg_id;
             uint8_t      status;
            } __attribute__((packed)) GPDS_SMS_PDU_SEND_RESP_STR;
#define SIZE_GPDS_SMS_PDU_SEND_RESP                           sizeof(GPDS_SMS_PDU_SEND_RESP_STR)


//Definition for struct GPDS_SMS_PDU_RECEIVE_IND
#define GPDS_SMS_PDU_RECEIVE_IND                              0x1D                                                  
typedef struct
            { 
             uint8_t      utid;
             uint8_t      msg_id;
             uint16_t     pdu_length;
             uint8_t      pdu_data[0];
            } __attribute__((packed)) GPDS_SMS_PDU_RECEIVE_IND_STR;
#define SIZE_GPDS_SMS_PDU_RECEIVE_IND                         sizeof(GPDS_SMS_PDU_RECEIVE_IND_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct GPDS_TRANSFER_STATUS_IND
#define GPDS_TRANSFER_STATUS_IND                              0x1E                                                  
typedef struct
            { 
             uint8_t      utid;
             uint8_t      msg_id;
             uint8_t      status;
             uint8_t      transfer_cause;
            } __attribute__((packed)) GPDS_TRANSFER_STATUS_IND_STR;
#define SIZE_GPDS_TRANSFER_STATUS_IND                         sizeof(GPDS_TRANSFER_STATUS_IND_STR)


//Definition for struct GPDS_CONFIGURATION_INFO_REQ
#define GPDS_CONFIGURATION_INFO_REQ                           0x30                                                  
typedef struct
            { 
             uint8_t      utid;
             uint8_t      msg_id;
            } __attribute__((packed)) GPDS_CONFIGURATION_INFO_REQ_STR;
#define SIZE_GPDS_CONFIGURATION_INFO_REQ                      sizeof(GPDS_CONFIGURATION_INFO_REQ_STR)


//Definition for struct GPDS_CONFIGURATION_INFO_RESP
#define GPDS_CONFIGURATION_INFO_RESP                          0x31                                                  
typedef struct
            { 
             uint8_t      utid;
             uint8_t      msg_id;
             uint8_t      attach_mode;
             uint8_t      mt_act_mode;
             uint8_t      classc_mode;
             uint8_t      aol_context;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) GPDS_CONFIGURATION_INFO_RESP_STR;
#define SIZE_GPDS_CONFIGURATION_INFO_RESP                     sizeof(GPDS_CONFIGURATION_INFO_RESP_STR)


//Definition for struct GPDS_CONFIGURATION_INFO_IND
#define GPDS_CONFIGURATION_INFO_IND                           0x32                                                  
typedef struct
            { 
             uint8_t      utid;
             uint8_t      msg_id;
             uint8_t      attach_mode;
             uint8_t      mt_act_mode;
             uint8_t      classc_mode;
             uint8_t      aol_context;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) GPDS_CONFIGURATION_INFO_IND_STR;
#define SIZE_GPDS_CONFIGURATION_INFO_IND                      sizeof(GPDS_CONFIGURATION_INFO_IND_STR)


//Definition for struct GPDS_CONTEXT_AUTH_REQ
#define GPDS_CONTEXT_AUTH_REQ                                 0x33                                                  
typedef struct
            { 
             uint8_t      utid;
             uint8_t      msg_id;
             uint8_t      cid;
             uint8_t      number_of_sub_blocks;
            } __attribute__((packed)) GPDS_CONTEXT_AUTH_REQ_STR;
#define SIZE_GPDS_CONTEXT_AUTH_REQ                            sizeof(GPDS_CONTEXT_AUTH_REQ_STR)


//Definition for struct GPDS_CONTEXT_AUTH_RESP
#define GPDS_CONTEXT_AUTH_RESP                                0x34                                                  
typedef struct
            { 
             uint8_t      utid;
             uint8_t      msg_id;
             uint8_t      cid;
             uint8_t      status;
            } __attribute__((packed)) GPDS_CONTEXT_AUTH_RESP_STR;
#define SIZE_GPDS_CONTEXT_AUTH_RESP                           sizeof(GPDS_CONTEXT_AUTH_RESP_STR)


//Definition for struct GPDS_TEST_MODE_REQ
#define GPDS_TEST_MODE_REQ                                    0x35                                                  
typedef struct
            { 
             uint8_t      utid;
             uint8_t      msg_id;
             uint16_t     number_of_pdus;
             uint16_t     length_of_pdus;
             uint8_t      content_of_pdus;
             uint8_t      test_mode;
             uint8_t      priority;
             uint8_t      throughput;
             uint8_t      rlc_mode;
            } __attribute__((packed)) GPDS_TEST_MODE_REQ_STR;
#define SIZE_GPDS_TEST_MODE_REQ                               sizeof(GPDS_TEST_MODE_REQ_STR)


//Definition for struct GPDS_TEST_MODE_RESP
#define GPDS_TEST_MODE_RESP                                   0x36                                                  
typedef struct
            { 
             uint8_t      utid;
             uint8_t      msg_id;
             uint8_t      status;
            } __attribute__((packed)) GPDS_TEST_MODE_RESP_STR;
#define SIZE_GPDS_TEST_MODE_RESP                              sizeof(GPDS_TEST_MODE_RESP_STR)


//Definition for struct GPDS_RADIO_ACTIVITY_IND
#define GPDS_RADIO_ACTIVITY_IND                               0x37                                                  
typedef struct
            { 
             uint8_t      utid;
             uint8_t      msg_id;
             uint8_t      direction;
             uint8_t      status;
             uint8_t      cid;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
            } __attribute__((packed)) GPDS_RADIO_ACTIVITY_IND_STR;
#define SIZE_GPDS_RADIO_ACTIVITY_IND                          sizeof(GPDS_RADIO_ACTIVITY_IND_STR)


//Definition for struct GPDS_FORCED_READY_STATE_REQ
#define GPDS_FORCED_READY_STATE_REQ                           0x38                                                  
typedef struct
            { 
             uint8_t      utid;
             uint8_t      msg_id;
             uint8_t      state;
            } __attribute__((packed)) GPDS_FORCED_READY_STATE_REQ_STR;
#define SIZE_GPDS_FORCED_READY_STATE_REQ                      sizeof(GPDS_FORCED_READY_STATE_REQ_STR)


//Definition for struct GPDS_FORCED_READY_STATE_RESP
#define GPDS_FORCED_READY_STATE_RESP                          0x39                                                  
typedef struct
            { 
             uint8_t      utid;
             uint8_t      msg_id;
             uint8_t      status;
            } __attribute__((packed)) GPDS_FORCED_READY_STATE_RESP_STR;
#define SIZE_GPDS_FORCED_READY_STATE_RESP                     sizeof(GPDS_FORCED_READY_STATE_RESP_STR)


//Definition for struct GPDS_CONTEXTS_CLEAR_REQ
#define GPDS_CONTEXTS_CLEAR_REQ                               0x3A                                                  
typedef struct
            { 
             uint8_t      utid;
             uint8_t      msg_id;
            } __attribute__((packed)) GPDS_CONTEXTS_CLEAR_REQ_STR;
#define SIZE_GPDS_CONTEXTS_CLEAR_REQ                          sizeof(GPDS_CONTEXTS_CLEAR_REQ_STR)


//Definition for struct GPDS_CONTEXTS_CLEAR_RESP
#define GPDS_CONTEXTS_CLEAR_RESP                              0x3B                                                  
typedef struct
            { 
             uint8_t      utid;
             uint8_t      msg_id;
            } __attribute__((packed)) GPDS_CONTEXTS_CLEAR_RESP_STR;
#define SIZE_GPDS_CONTEXTS_CLEAR_RESP                         sizeof(GPDS_CONTEXTS_CLEAR_RESP_STR)


//Definition for struct GPDS_MBMS_SERVICE_SELECTION_REQ
#define GPDS_MBMS_SERVICE_SELECTION_REQ                       0x3C                                                  
typedef struct
            { 
             uint8_t      utid;
             uint8_t      msg_id;
             uint8_t      fillerbyte1;
             uint8_t      number_of_sub_blocks;
            } __attribute__((packed)) GPDS_MBMS_SERVICE_SELECTION_REQ_STR;
#define SIZE_GPDS_MBMS_SERVICE_SELECTION_REQ                  sizeof(GPDS_MBMS_SERVICE_SELECTION_REQ_STR)


//Definition for struct GPDS_MBMS_SERVICE_SELECTION_RESP
#define GPDS_MBMS_SERVICE_SELECTION_RESP                      0x3D                                                  
typedef struct
            { 
             uint8_t      utid;
             uint8_t      msg_id;
             uint8_t      selection_result;
            } __attribute__((packed)) GPDS_MBMS_SERVICE_SELECTION_RESP_STR;
#define SIZE_GPDS_MBMS_SERVICE_SELECTION_RESP                 sizeof(GPDS_MBMS_SERVICE_SELECTION_RESP_STR)


//Definition for struct GPDS_MBMS_STATUS_IND
#define GPDS_MBMS_STATUS_IND                                  0x3E                                                  
typedef struct
            { 
             uint8_t      utid;
             uint8_t      msg_id;
             uint8_t      support_status;
             uint8_t      number_of_sub_blocks;
            } __attribute__((packed)) GPDS_MBMS_STATUS_IND_STR;
#define SIZE_GPDS_MBMS_STATUS_IND                             sizeof(GPDS_MBMS_STATUS_IND_STR)


//Definition for struct GPDS_MBMS_CONTEXT_CREATE_REQ
#define GPDS_MBMS_CONTEXT_CREATE_REQ                          0x3F                                                  
typedef struct
            { 
             uint8_t      utid;
             uint8_t      msg_id;
             uint8_t      pipe_handle;
             uint8_t      mbms_service_type;
            } __attribute__((packed)) GPDS_MBMS_CONTEXT_CREATE_REQ_STR;
#define SIZE_GPDS_MBMS_CONTEXT_CREATE_REQ                     sizeof(GPDS_MBMS_CONTEXT_CREATE_REQ_STR)


//Definition for struct GPDS_MBMS_CONTEXT_CREATE_RESP
#define GPDS_MBMS_CONTEXT_CREATE_RESP                         0x40                                                  
typedef struct
            { 
             uint8_t      utid;
             uint8_t      msg_id;
             uint8_t      status;
             uint8_t      cid;
            } __attribute__((packed)) GPDS_MBMS_CONTEXT_CREATE_RESP_STR;
#define SIZE_GPDS_MBMS_CONTEXT_CREATE_RESP                    sizeof(GPDS_MBMS_CONTEXT_CREATE_RESP_STR)


//Definition for struct GPDS_MBMS_CONTEXT_ACTIVATE_REQ
#define GPDS_MBMS_CONTEXT_ACTIVATE_REQ                        0x41                                                  
typedef struct
            { 
             uint8_t      utid;
             uint8_t      msg_id;
             uint8_t      cid;
             uint8_t      number_of_sub_blocks;
            } __attribute__((packed)) GPDS_MBMS_CONTEXT_ACTIVATE_REQ_STR;
#define SIZE_GPDS_MBMS_CONTEXT_ACTIVATE_REQ                   sizeof(GPDS_MBMS_CONTEXT_ACTIVATE_REQ_STR)


//Definition for struct GPDS_MBMS_CONTEXT_ACTIVATE_RESP
#define GPDS_MBMS_CONTEXT_ACTIVATE_RESP                       0x42                                                  
typedef struct
            { 
             uint8_t      utid;
             uint8_t      msg_id;
             uint8_t      cid;
             uint8_t      status;
             uint8_t      cause;
             uint8_t      tmgi[6];
             uint8_t      fillerbyte1;
            } __attribute__((packed)) GPDS_MBMS_CONTEXT_ACTIVATE_RESP_STR;
#define SIZE_GPDS_MBMS_CONTEXT_ACTIVATE_RESP                  sizeof(GPDS_MBMS_CONTEXT_ACTIVATE_RESP_STR)


//Definition for struct GPDS_MBMS_CONTEXT_DELETE_REQ
#define GPDS_MBMS_CONTEXT_DELETE_REQ                          0x43                                                  
typedef struct
            { 
             uint8_t      utid;
             uint8_t      msg_id;
             uint8_t      cid;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) GPDS_MBMS_CONTEXT_DELETE_REQ_STR;
#define SIZE_GPDS_MBMS_CONTEXT_DELETE_REQ                     sizeof(GPDS_MBMS_CONTEXT_DELETE_REQ_STR)


//Definition for struct GPDS_MBMS_CONTEXT_DELETE_RESP
#define GPDS_MBMS_CONTEXT_DELETE_RESP                         0x44                                                  
typedef struct
            { 
             uint8_t      utid;
             uint8_t      msg_id;
             uint8_t      status;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) GPDS_MBMS_CONTEXT_DELETE_RESP_STR;
#define SIZE_GPDS_MBMS_CONTEXT_DELETE_RESP                    sizeof(GPDS_MBMS_CONTEXT_DELETE_RESP_STR)


//Definition for struct GPDS_MBMS_CONTEXT_DELETE_IND
#define GPDS_MBMS_CONTEXT_DELETE_IND                          0x45                                                  
typedef struct
            { 
             uint8_t      utid;
             uint8_t      msg_id;
             uint8_t      cid;
             uint8_t      cause;
            } __attribute__((packed)) GPDS_MBMS_CONTEXT_DELETE_IND_STR;
#define SIZE_GPDS_MBMS_CONTEXT_DELETE_IND                     sizeof(GPDS_MBMS_CONTEXT_DELETE_IND_STR)


//Definition for struct GPDS_MBMS_SERVICE_SELECTION_IND
#define GPDS_MBMS_SERVICE_SELECTION_IND                       0x46                                                  
typedef struct
            { 
             uint8_t      utid;
             uint8_t      msg_id;
             uint8_t      fillerbyte1;
             uint8_t      number_of_sub_blocks;
            } __attribute__((packed)) GPDS_MBMS_SERVICE_SELECTION_IND_STR;
#define SIZE_GPDS_MBMS_SERVICE_SELECTION_IND                  sizeof(GPDS_MBMS_SERVICE_SELECTION_IND_STR)


//Definition for struct GPDS_MBMS_SERVICE_AVAILABLE_IND
#define GPDS_MBMS_SERVICE_AVAILABLE_IND                       0x47                                                  
typedef struct
            { 
             uint8_t      utid;
             uint8_t      msg_id;
             uint8_t      fillerbyte1;
             uint8_t      nbr_of_mbms_services;
             GPDS_SHARED_AVAILABLE_MBMS_SERVICE_INFO_SEQ_STR    mbms_available_service[0];
            } __attribute__((packed)) GPDS_MBMS_SERVICE_AVAILABLE_IND_STR;
#define SIZE_GPDS_MBMS_SERVICE_AVAILABLE_IND                  sizeof(GPDS_MBMS_SERVICE_AVAILABLE_IND_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct GPDS_TEST_REQ
#define GPDS_TEST_REQ                                         0x48                                                  
typedef struct
            { 
             uint8_t      utid;
             uint8_t      msg_id;
             uint8_t      hsp_test_mode;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) GPDS_TEST_REQ_STR;
#define SIZE_GPDS_TEST_REQ                                    sizeof(GPDS_TEST_REQ_STR)


//Definition for struct GPDS_TEST_RESP
#define GPDS_TEST_RESP                                        0x49                                                  
typedef struct
            { 
             uint8_t      utid;
             uint8_t      msg_id;
             uint8_t      status;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) GPDS_TEST_RESP_STR;
#define SIZE_GPDS_TEST_RESP                                   sizeof(GPDS_TEST_RESP_STR)


//Definition for struct GPDS_RESOURCE_CONTROL_IND
#define GPDS_RESOURCE_CONTROL_IND                             0x50                                                  
typedef struct
            { 
             uint8_t      utid;
             uint8_t      msg_id;
             uint8_t      sequence_id;
             uint8_t      sub_block_count;
            } __attribute__((packed)) GPDS_RESOURCE_CONTROL_IND_STR;
#define SIZE_GPDS_RESOURCE_CONTROL_IND                        sizeof(GPDS_RESOURCE_CONTROL_IND_STR)


//Definition for struct GPDS_RESOURCE_CONTROL_REQ
#define GPDS_RESOURCE_CONTROL_REQ                             0x51                                                  
typedef struct
            { 
             uint8_t      utid;
             uint8_t      msg_id;
             uint8_t      sequence_id;
             uint8_t      cc_result;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
             uint8_t      sub_block_count;
            } __attribute__((packed)) GPDS_RESOURCE_CONTROL_REQ_STR;
#define SIZE_GPDS_RESOURCE_CONTROL_REQ                        sizeof(GPDS_RESOURCE_CONTROL_REQ_STR)


//Definition for struct GPDS_RESOURCE_CONTROL_RESP
#define GPDS_RESOURCE_CONTROL_RESP                            0x52                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      sequence_id;
             uint8_t      status;
            } __attribute__((packed)) GPDS_RESOURCE_CONTROL_RESP_STR;
#define SIZE_GPDS_RESOURCE_CONTROL_RESP                       sizeof(GPDS_RESOURCE_CONTROL_RESP_STR)


//Definition for struct GPDS_RESOURCE_CONF_REQ
#define GPDS_RESOURCE_CONF_REQ                                0x54                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      conf_operation;
             uint8_t      sub_block_count;
            } __attribute__((packed)) GPDS_RESOURCE_CONF_REQ_STR;
#define SIZE_GPDS_RESOURCE_CONF_REQ                           sizeof(GPDS_RESOURCE_CONF_REQ_STR)


//Definition for struct GPDS_RESOURCE_CONF_RESP
#define GPDS_RESOURCE_CONF_RESP                               0x55                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      conf_operation;
             uint8_t      status;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
             uint8_t      sub_block_count;
            } __attribute__((packed)) GPDS_RESOURCE_CONF_RESP_STR;
#define SIZE_GPDS_RESOURCE_CONF_RESP                          sizeof(GPDS_RESOURCE_CONF_RESP_STR)


//Definition for struct GPDS_RESOURCE_CONF_IND
#define GPDS_RESOURCE_CONF_IND                                0x53                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      conf_status;
             uint8_t      sub_blocks;
            } __attribute__((packed)) GPDS_RESOURCE_CONF_IND_STR;
#define SIZE_GPDS_RESOURCE_CONF_IND                           sizeof(GPDS_RESOURCE_CONF_IND_STR)


//Definition for struct GPDS_PROPERTY_SET_REQ
#define GPDS_PROPERTY_SET_REQ                                 0x56                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      sub_block_count;
            } __attribute__((packed)) GPDS_PROPERTY_SET_REQ_STR;
#define SIZE_GPDS_PROPERTY_SET_REQ                            sizeof(GPDS_PROPERTY_SET_REQ_STR)


//Definition for struct GPDS_PROPERTY_SET_RESP
#define GPDS_PROPERTY_SET_RESP                                0x57                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) GPDS_PROPERTY_SET_RESP_STR;
#define SIZE_GPDS_PROPERTY_SET_RESP                           sizeof(GPDS_PROPERTY_SET_RESP_STR)


//Definition for struct GPDS_RESP
#define GPDS_RESP                                             0xEE                                                  
typedef struct
            { 
             uint8_t      utid;
             uint8_t      msg_id;
             uint8_t      cid;
             uint8_t      status;
            } __attribute__((packed)) GPDS_RESP_STR;
#define SIZE_GPDS_RESP                                        sizeof(GPDS_RESP_STR)

#endif
