#ifndef _PN_GPDS_SHARED_ISI_H_
#define _PN_GPDS_SHARED_ISI_H_

#include <stdint.h> 

//Resource GPDS Shared Subblock Descriptions
//PN_GPDS 0x31 
//ISI version 018.002
#define GPDS_SHARED_SUBBLOCK_DESCRIPTIONS_ISI_VERSION_Z     18
#define GPDS_SHARED_SUBBLOCK_DESCRIPTIONS_ISI_VERSION_Y     2

//In case of problems concerning content of this file contact Henrik Ala-Uotila
//Server specific message descriptions and feature&protocol descriptions can be found from: https://oucmswww.nmp.nokia.com:58443/document_browser/ccm_wa/GIF_SPECS/ 


//ISI VERSION CHANGE HISTORY

//Version: 018.002                                           
//Status: Approved                                          
//Date: 22-Aug-2008     Matti Moisanen
//Reason: Update
//Reference: Action DB for SWAM inspection ID: MM08081940458 , APPROVED

//Version: 018.001                                           
//Status: Proposal                                          
//Date: 19-Aug-2008     Matti Moisanen
//Reason: Update
//Reference: Action DB for SWAM inspection ID: MM08081940458 , PROPOSAL

//Version: 018.000                                           
//Status: Approved                                          
//Date: 15-Apr-2008     Matti Moisanen
//Reason: Update
//Reference: Action DB for SWAM inspection ID: MM08041041492 , APPROVED

//Version: 017.025                                           
//Status: Proposal                                          
//Date: 08-Apr-2008     Matti Moisanen
//Reason: Update
//Reference: Action DB for SWAM inspection ID: MM08041041492 , PROPOSAL

//Version: 017.024                                           
//Status: Approved                                          
//Date: 01-Apr-2008     Matti Moisanen
//Reason: Update
//Reference: Action DB for SWAM inspection ID: MM08032843602  , APPROVED

//Version: 017.023                                           
//Status: Proposal                                          
//Date: 28-Mar-2008     Matti Moisanen
//Reason: Update
//Reference: Action DB for SWAM inspection ID: MM08032843602  , PROPOSAL

//Version: 017.022                                           
//Status: Approved                                          
//Date: 27-Sep-2007     Matti Moisanen
//Reason: Update
//Reference: Action DB for SWAM inspection ID: MM07092629743 , APPROVED

//Version: 017.021                                           
//Status: Proposal                                          
//Date: 25-Sep-2007     Matti Moisanen
//Reason: Update
//Reference: Action DB for SWAM inspection ID: MM07092629743 , PROPOSAL

//Version: 017.020                                           
//Status: Approved                                          
//Date: 25-Sep-2007     Matti Moisanen
//Reason: Update
//Reference: Action DB for SWAM inspection ID: MM07091332368 , APPROVED

//Version: 017.019                                           
//Status: Proposal                                          
//Date: 12-Sep-2007     Matti Moisanen
//Reason: Update
//Reference: Action DB for SWAM inspection ID: MM07091332368 , PROPOSAL

//Version: 017.018                                           
//Status: Proposal                                          
//Date: 19-Jun-2007     Matti Moisanen
//Reason: Update
//Reference: Action DB for SWAM inspection ID: MM07061439289 , PROPOSAL

//Version: 017.017                                           
//Status: Proposal                                          
//Date: 13-Jun-2007     Matti Moisanen
//Reason: Update
//Reference: Action DB for SWAM inspection ID: MM07061439289 , PROPOSAL

//Version: 017.016                                           
//Status: Approved                                          
//Date: 01-Jun-2007     Matti Moisanen
//Reason: Update
//Reference: Action DB for SWAM inspection ID: MM07052553763 , APPROVED

//Version: 017.015                                           
//Status: Proposal                                          
//Date: 25-May-2007     Matti Moisanen
//Reason: Update
//Reference: Action DB for SWAM inspection ID: MM07052553763 , PROPOSAL

//Version: 017.014                                           
//Status: Approved                                          
//Date: 23-May-2007     Matti Moisanen
//Reason: Update
//Reference: Action DB for SWAM inspection ID: MM07051646906 , APPROVED

//Version: 017.013                                           
//Status: Proposal                                          
//Date: 16-May-2007     Matti Moisanen
//Reason: Update
//Reference: Action DB for SWAM inspection ID: MM07051646906 , PROPOSAL

//Version: 017.012                                           
//Status: Approved                                          
//Date: 4-May-2007      Matti Moisanen
//Reason: Update
//Reference: Action DB for SWAM inspection ID: MM07050328500 , APPROVED

//Version: 017.011                                           
//Status: Proposal                                          
//Date: 3-May-2007      Matti Moisanen
//Reason: Update
//Reference: Action DB for SWAM inspection ID: MM07050328500 , PROPOSAL

//Version: 017.010                                           
//Status: Approved                                          
//Date: 26-Mar-2007     Matti Moisanen
//Reason: Update
//Reference: Action DB for SWAM inspection ID: MM07032053184 , APPROVED

//Version: 017.009                                           
//Status: Proposal                                          
//Date: 20-Mar-2007     Matti Moisanen
//Reason: Update
//Reference: Action DB for SWAM inspection ID: MM07032053184 , PROPOSAL

//Version: 017.008                                           
//Status: Approved                                          
//Date: 28-Feb-2007     Matti Moisanen
//Reason: Update
//Reference: Action DB for SWAM inspection ID: MM07022069704 , APPROVED

//Version: 017.007                                           
//Status: Proposal                                          
//Date: 15-Feb-2007     Matti Moisanen
//Reason: Update
//Reference: Action DB for SWAM inspection ID: , PROPOSAL

//Version: 017.006                                           
//Status: Approved                                          
//Date: 29-Nov-2007     Tapio Askeli
//Reason: Update
//Reference: Action DB for SWAM inspection ID: TA06111546430, APPROVED

//Version: 017.005                                           
//Status: Proposal                                          
//Date: 15-Nov-2006     Tapio Askeli
//Reason: Update
//Reference: 010-27185: Field test improvements within PMD files - MACN CCN, PROPOSAL

//Version: 017.004                                           
//Status: Approved                                          
//Date: 13-Jun-2006     Ilkka Leinonen
//Reason: Update
//Reference: Action DB for SWAM inspection ID: IL06060843901, APPROVED

//Version: 017.003                                           
//Status: Proposal                                          
//Date: 08-Jun-2006     Ilkka Leinonen
//Reason: Update
//Reference: SUB: 010-24773, PROPOSAL

//Version: 017.002                                           
//Status: Approved                                          
//Date: 03-Feb-2006     Sweta Pradhanang
//Reason: Update
//Reference: Action DB for SWAM inspection ID:SP06012735617, APPROVED

//Version: 017.001                                           
//Status: Proposal                                          
//Date: 12-Jan-2006     Sweta Pradhanang
//Reason: Update
//Reference: SUB/SCO:009-22186,009-22188, PROPOSAL

//Version: 017.000                                           
//Status: Approved                                          
//Date: 30-Nov-2005     Juuso Oikarinen
//Reason: Correction
//Reference: ADB For SWAM id: JO05112446559, APPROVED

//Version: 016.009                                           
//Status: Proposal                                          
//Date: 29-Nov-2005     Juuso Oikarinen
//Reason: Update
//Reference: SUB/SCO: 009-17851, PROPOSAL

//Version: 016.008                                           
//Status: Proposal                                          
//Date: 24-Nov-2005     Juuso Oikarinen
//Reason: Update
//Reference: SUB/SCO: 009-17851, PROPOSAL

//Version: 016.007                                           
//Status: Approved                                          
//Date: 23-Nov-2005     Sweta Pradhanang
//Reason: Correction
//Reference: PCP Error ID:PC05111836883, APPROVED

//Version: 016.006                                           
//Status: Proposal                                          
//Date: 23-Nov-2005     Sweta Pradhanang
//Reason: Correction
//Reference: PCP Error ID:PC05111836883, PROPOSAL

//Version: 016.005                                           
//Status: Approved                                          
//Date: 14-Nov-2005     Sweta Pradhanang
//Reason: Correction
//Reference: Action DB for SWAM inspection ID:SP05111039671, APPROVED

//Version: 016.004                                           
//Status: Proposal                                          
//Date: 08-Nov-2005     Sweta Pradhanang
//Reason: Correction
//Reference: PCP Error ID:VK05092038143, TR05102141053, PROPOSAL

//Version: 016.003                                           
//Status: Approved                                          
//Date: 24-Oct-2005     Sweta Pradhanang
//Reason: Update
//Reference: Action DB for SWAM inspection ID: SP05101849999, APPROVED

//Version: 016.002                                           
//Status: Proposal                                          
//Date: 14-Oct-2005     Sweta Pradhanang
//Reason: Update
//Reference: SUB/SCO:009-20903, PROPOSAL

//Version: 016.001                                           
//Status: Approved                                          
//Date: 12-Sep-2005     Sweta Pradhanang
//Reason: Inspection
//Reference: Action DB for SWAM inspection ID:SP05090136505, APPROVED

//Version: 016.000                                           
//Status: Proposal                                          
//Date: 26-Aug-2005     Sweta Pradhanang
//Reason: Update
//Reference: SUB/SCO:009-19562, 009-19915, PROPOSAL

//Version: 015.001                                           
//Status: Approved                                          
//Date: 21-Jun-2005     Sweta Pradhanang
//Reason: Inspection
//Reference: Action DB for SWAM inspection ID:SP05061535280, APPROVED

//Version: 015.000                                           
//Status: Proposal                                          
//Date: 14-Jun-2005     Sweta Pradhanang
//Reason: Update
//Reference: SUB/SCO:009-17956: New MaxBitRate for HSDPA, PROPOSAL

//Version: 014.001                                           
//Status: Approved                                          
//Date: 30-May-2005     Sweta Pradhanang
//Reason: Update
//Reference: Action DB for SWAM inspection ID:SP05051836903, APPROVED

//Version: 014.000                                           
//Status: Proposal                                          
//Date: 18-May-2005     Sweta Pradhanang
//Reason: Update
//Reference: SUB/SCO:009-15058: Radio Activity Status in 3G, PROPOSAL

//Version: 013.007                                           
//Status: Approved                                          
//Date: 11-May-2005     Sweta Pradhanang
//Reason: Update
//Reference: Action DB for SWAM inspection ID: SP05050353344, APPROVED

//Version: 013.006                                           
//Status: Unknown                                           
//Date: 03-May-2005     Sweta Pradhanang
//Reason: Update
//Reference: SCO:009-17947, PCP Error ID:MK05031737898 , NON_DRAFT

//Version: 013.005                                           
//Status: Unknown                                           
//Date: 08-Mar-2005     Sweta Pradhanang
//Reason: Update
//Reference: SCO: 009-15467, PCP Error:PP05022154456, NON_DRAFT

//Version: 013.004                                           
//Status: Unknown                                           
//Date: 10-Feb-2005     Sweta Pradhanang
//Reason: Update
//Reference: SCO: 009-15467, NON_DRAFT

//Version: 013.003                                           
//Status: Unknown                                           
//Date: 04-Feb-2005     Sweta Pradhanang
//Reason: Correction
//Reference: Compilation error, NON_DRAFT

//Version: 013.002                                           
//Status: Unknown                                           
//Date: 19-Jan-2005     Sweta Pradhanang
//Reason: Update
//Reference: Action DB for SWAM inspection ID: AP04112845656, NON_DRAFT

//Version: 013.001                                           
//Status: Unknown                                           
//Date: 07-Jan-2005     Sweta Pradhanang
//Reason: Update
//Reference: Action DB for SWAM inspection ID: AP04112845656, NON_DRAFT

//Version: 013.000                                           
//Status: Unknown                                           
//Date: 09-Dec-2004     Sweta Pradhanang
//Reason: Update
//Reference: SCO:009-14807, NON_DRAFT

//Version: 012.011                                           
//Status: Unknown                                           
//Date: 24-Nov-2004     Sweta Pradhanang
//Reason: Update
//Reference: SCO: 009-14807, NON_DRAFT

//Version: 012.010                                           
//Status: Unknown                                           
//Date: 08-Nov-2004     Sweta Pradhanang
//Reason: Update
//Reference: SCO: 010-8447, NON_DRAFT

//Version: 012.009                                           
//Status: Unknown                                           
//Date: 11-Aug-2004     Sweta Pradhanang
//Reason: Update
//Reference: SCO:009-12761, NON_DRAFT

//Version: 012.008                                           
//Status: Unknown                                           
//Date: 29-Jun-2004     Sweta Pradhanang
//Reason: Update
//Reference: SCO:009-12761, NON_DRAFT

//Version: 012.007                                           
//Status: Unknown                                           
//Date: 18-Feb-2004     Sweta Pradhanang
//Reason: Update
//Reference: TEC/SWP/ISA ActionDB: AS03120345697, NON_DRAFT

//Version: 012.006                                           
//Status: Unknown                                           
//Date: 09-Jan-2004     Sweta Pradhanang
//Reason: Move file
//Reference: TEC/SWP/ISA ActionDB: AS04010751307, NON_DRAFT

//Version: 012.005                                           
//Status: Unknown                                           
//Date: 11-Dec-2003     Sweta Pradhanang
//Reason: Update
//Reference: TEC/SWP/ISA ActionDB: AS03092550839, NON_DRAFT

//Version: 012.004                                           
//Status: Unknown                                           
//Date: 05-Nov-2003     Sweta Pradhanang
//Reason: Update
//Reference: TEC/SWP/ISA ActionDB: AS03092458190, NON_DRAFT

//Version: 012.003                                           
//Status: Unknown                                           
//Date: 27-Oct-2003     Sweta Pradhanang
//Reason: Update
//Reference: TEC/SWP/ISA ActionDB: AS03081855392, NON_DRAFT

//Version: 012.002                                           
//Status: Unknown                                           
//Date: 08-Oct-2003     Sweta Pradhanang
//Reason: Update
//Reference: TEC/SWP/ISA ActionDB: AS03092457548 , NON_DRAFT

//Version: 012.001                                           
//Status: Unknown                                           
//Date: 22-Sep-2003     Kalle Haviala
//Reason: Correction
//Reference: PCP Errors: TK03091951194, NON_DRAFT

//Version: 012.000                                           
//Status: Unknown                                           
//Date: 06-Jun-2003     Kalle Haviala
//Reason: Inspection
//Reference: ActionDB for SWAM: AS03053046350, NON_DRAFT

//Version: 011.001                                           
//Status: Unknown                                           
//Date: 28-May-2003     Kalle Haviala
//Reason: Created
//Reference: -


//CONSTANTS
#define GPDS_MAX_APN_STRING_SIZE                              0x64                                                  
#define GPDS_MAX_TFT_INFO_SB_DATA                             0x0100                                                   
#define GPDS_MAX_TFT_AUTH_TOKEN_SIZE                          0xF4                                                  
//#define GPDS_TMGI_LEN                                       0x06                        //Already defined as 0x06


//TABLES

//ConstantTable for GPDS_DATA_COMPRESSION
#define GPDS_PDP_DCOMP_OFF                                    0x00                                                     
#define GPDS_PDP_DCOMP_ON                                     0x01                                                     
#define GPDS_PDP_DCOMP_DEFAULT                                0xFF                                                  

//ConstantTable for GPDS_HEADER_COMPRESSION
#define GPDS_PDP_HCOMP_OFF                                    0x00                                                     
#define GPDS_PDP_HCOMP_ON                                     0x01                                                     
#define GPDS_PDP_HCOMP_DEFAULT                                0xFF                                                  

//ConstantTable for GPDS_QOS99_TRAFFIC_CLASSES
#define GPDS_QOS99_TRAC_SUBSCRIBED                            0x00                                                     
#define GPDS_QOS99_TRAC_CONVERSATIONAL                        0x01                                                     
#define GPDS_QOS99_TRAC_STREAMING                             0x02                                                     
#define GPDS_QOS99_TRAC_INTERACTIVE                           0x03                                                     
#define GPDS_QOS99_TRAC_BACKGROUND                            0x04                                                     
#define GPDS_QOS99_TRAC_DEFAULT                               0xFF                                                  

//ConstantTable for GPDS_QOS99_DELIVERY_ORDERS
#define GPDS_QOS99_DELO_SUBSCRIBED                            0x00                                                     
#define GPDS_QOS99_DELO_YES                                   0x01                                                     
#define GPDS_QOS99_DELO_NO                                    0x02                                                     
#define GPDS_QOS99_DELO_DEFAULT                               0xFF                                                  

//ConstantTable for GPDS_QOS99_DELIVERY_OF_ERRONEOUS_SDUS
#define GPDS_QOS99_DOES_SUBSCRIBED                            0x00                                                     
#define GPDS_QOS99_DOES_NO_DETECT                             0x01                                                     
#define GPDS_QOS99_DOES_YES                                   0x02                                                     
#define GPDS_QOS99_DOES_NO                                    0x03                                                     
#define GPDS_QOS99_DOES_DEFAULT                               0xFF                                                  

//ConstantTable for GPDS_QOS99_RESIDUAL_BERS
#define GPDS_QOS99_RBER_SUBSCRIBED                            0x00                                                     
#define GPDS_QOS99_RBER_1                                     0x52                                                  
#define GPDS_QOS99_RBER_2                                     0x12                                                  
#define GPDS_QOS99_RBER_3                                     0x53                                                  
#define GPDS_QOS99_RBER_4                                     0x43                                                  
#define GPDS_QOS99_RBER_5                                     0x13                                                  
#define GPDS_QOS99_RBER_6                                     0x14                                                  
#define GPDS_QOS99_RBER_7                                     0x15                                                  
#define GPDS_QOS99_RBER_8                                     0x16                                                  
#define GPDS_QOS99_RBER_9                                     0x68                                                  
#define GPDS_QOS99_RBER_DEFAULT                               0xFF                                                  

//ConstantTable for GPDS_QOS99_ERROR_RATIOS
#define GPDS_QOS99_SDER_SUBSCRIBED                            0x00                                                     
#define GPDS_QOS99_SDER_1                                     0x12                                                  
#define GPDS_QOS99_SDER_2                                     0x73                                                  
#define GPDS_QOS99_SDER_3                                     0x13                                                  
#define GPDS_QOS99_SDER_4                                     0x14                                                  
#define GPDS_QOS99_SDER_5                                     0x15                                                  
#define GPDS_QOS99_SDER_6                                     0x16                                                  
#define GPDS_QOS99_SDER_7                                     0x11                                                  
#define GPDS_QOS99_SDER_DEFAULT                               0xFF                                                  

//ConstantTable for GPDS_QOS99_TRAFFIC_HANDLING_PRIORITIES
#define GPDS_QOS99_TRHP_SUBSCRIBED                            0x00                                                     
#define GPDS_QOS99_TRHP_1                                     0x01                                                     
#define GPDS_QOS99_TRHP_2                                     0x02                                                     
#define GPDS_QOS99_TRHP_3                                     0x03                                                     
#define GPDS_QOS99_TRHP_DEFAULT                               0xFF                                                  

//ConstantTable for GPDS_TFT_OPERATION
#define GPDS_TFT_CREATE_NEW                                   0x01                                                     
#define GPDS_TFT_DELETE_EXISTING                              0x02                                                     
#define GPDS_TFT_ADD_PACKET_FILTERS                           0x03                                                     
#define GPDS_TFT_REPLACE_PACKET_FILTERS                       0x04                                                     
#define GPDS_TFT_DELETE_PACKET_FILTERS                        0x05                                                     
#define GPDS_TFT_NO_OPERATION                                 0x06                                                     

//ConstantTable for GPDS_REL5_SOURCE_DESC
#define GPDS_SOURCE_UNKNOWN                                   0x00                                                     
#define GPDS_SOURCE_SPEECH                                    0x01                                                     
#define GPDS_SOURCE_DEFAULT                                   0xFF                                                  

//ConstantTable for GPDS_REL5_SGN_IND_FLAG
#define GPDS_QOS_NOT_OPT_SGN                                  0x00                                                     
#define GPDS_QOS_OPT_SGN                                      0x01                                                     
#define GPDS_QOS_OPT_DEFAULT                                  0xFF                                                  

//ConstantTable for GPDS_IM_CN_SIGN_FLAG
#define GPDS_CTX_NOT_FOR_DEDICATED_SIGN                       0x00                                                     
#define GPDS_CTX_FOR_DEDICATED_SIGN                           0x01                                                     

//ConstantTable for GPDS_MBMS_ACCESS_BEARER
#define GPDS_ACCESS_BEARER_2G                                 0x00                                                     
#define GPDS_ACCESS_BEARER_3G                                 0x01                                                     

//ConstantTable for GPDS_MBMS_SERVICE_MODE
#define GPDS_MBMS_SERVICE_MODE_MULTICAST                      0x01                                                     
#define GPDS_MBMS_SERVICE_MODE_BROADCAST                      0x02                                                     
#define GPDS_MBMS_SERVICE_MODE_SELECTED_BROADCAST             0x03                                                     

//ConstantTable for GPDS_MBMS_SERVICE_RECEIVE_MODE
#define GPDS_MBMS_SERVICE_RECEIVE                             0x01                                                     
#define GPDS_MBMS_SERVICE_MONITOR                             0x02                                                     

//ConstantTable for GPDS_MBMS_SESSION_BLOCKING_USED
#define GPDS_MBMS_SESSION_BLOCKING_USED                       0x01                                                     
#define GPDS_MBMS_SESSION_BLOCKING_NOT_USED                   0x02                                                     

//ConstantTable for GPDS_MBMS_SERVICE_AVAILABILITY
#define GPDS_MBMS_SERV_NOT_SIGN_MBMS_INACTIVE                 0x01                                                     
#define GPDS_MBMS_SERV_NOT_SIGN_MBMS_ACTIVE                   0x02                                                     
#define GPDS_MBMS_SERV_SIGNALLED_ON_CELL                      0x03                                                     
#define GPDS_MBMS_SERV_ACTIVE_ON_CELL                         0x04                                                     
#define GPDS_MBMS_SERV_OUTSIDE_UE_CAPABILITY                  0x05                                                     


//STRUCTURES


//Definition for struct GPDS_SHARED_MBMS_SERVICE_INFO_SEQ
typedef struct
            { 
             uint8_t      tmgi[6];
             uint8_t      mbms_service_mode;
             uint8_t      mbms_session_id;
             uint8_t      mbms_session_blocking_used;
             uint8_t      mbms_service_receive_command;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) GPDS_SHARED_MBMS_SERVICE_INFO_SEQ_STR;
#define SIZE_GPDS_SHARED_MBMS_SERVICE_INFO_SEQ                sizeof(GPDS_SHARED_MBMS_SERVICE_INFO_SEQ_STR)


//Definition for struct GPDS_SHARED_AVAILABLE_MBMS_SERVICE_INFO_SEQ
typedef struct
            { 
             uint8_t      tmgi[6];
             uint8_t      mbms_service_availability;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) GPDS_SHARED_AVAILABLE_MBMS_SERVICE_INFO_SEQ_STR;
#define SIZE_GPDS_SHARED_AVAILABLE_MBMS_SERVICE_INFO_SEQ      sizeof(GPDS_SHARED_AVAILABLE_MBMS_SERVICE_INFO_SEQ_STR)


//SUBBLOCKS


//Definition for struct GPDS_SHARED_APN_INFO
#define GPDS_SHARED_APN_INFO                                  0xE1                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint8_t      addr_length;
             uint8_t      apn_name[0];
            } __attribute__((packed)) GPDS_SHARED_APN_INFO_STR;
#define SIZE_GPDS_SHARED_APN_INFO                             sizeof(GPDS_SHARED_APN_INFO_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct GPDS_SHARED_COMP_INFO
#define GPDS_SHARED_COMP_INFO                                 0xE0                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint8_t      data_compression;
             uint8_t      header_compression;
            } __attribute__((packed)) GPDS_SHARED_COMP_INFO_STR;
#define SIZE_GPDS_SHARED_COMP_INFO                            sizeof(GPDS_SHARED_COMP_INFO_STR)


//Definition for struct GPDS_SHARED_QOS99_REQ_INFO
#define GPDS_SHARED_QOS99_REQ_INFO                            0xE2                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint8_t      traffic_class;
             uint8_t      delivery_order;
             uint8_t      delivery_of_erroneus_sdu;
             uint8_t      residual_ber;
             uint8_t      error_ratio;
             uint8_t      priority;
             uint16_t     transfer_delay;
             uint16_t     max_sdu_size;
             uint16_t     max_bitrate_uplink;
             uint16_t     max_bitrate_downlink;
             uint16_t     gua_bitrate_uplink;
             uint16_t     gua_bitrate_downlink;
            } __attribute__((packed)) GPDS_SHARED_QOS99_REQ_INFO_STR;
#define SIZE_GPDS_SHARED_QOS99_REQ_INFO                       sizeof(GPDS_SHARED_QOS99_REQ_INFO_STR)


//Definition for struct GPDS_SHARED_QOS99_MIN_INFO
#define GPDS_SHARED_QOS99_MIN_INFO                            0xE3                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint8_t      traffic_class;
             uint8_t      delivery_order;
             uint8_t      delivery_of_erroneus_sdu;
             uint8_t      residual_ber;
             uint8_t      error_ratio;
             uint8_t      priority;
             uint16_t     transfer_delay;
             uint16_t     max_sdu_size;
             uint16_t     max_bitrate_uplink;
             uint16_t     max_bitrate_downlink;
             uint16_t     gua_bitrate_uplink;
             uint16_t     gua_bitrate_downlink;
            } __attribute__((packed)) GPDS_SHARED_QOS99_MIN_INFO_STR;
#define SIZE_GPDS_SHARED_QOS99_MIN_INFO                       sizeof(GPDS_SHARED_QOS99_MIN_INFO_STR)


//Definition for struct GPDS_SHARED_QOS99_NEG_INFO
#define GPDS_SHARED_QOS99_NEG_INFO                            0xE4                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint8_t      traffic_class;
             uint8_t      delivery_order;
             uint8_t      delivery_of_erroneus_sdu;
             uint8_t      residual_ber;
             uint8_t      error_ratio;
             uint8_t      priority;
             uint16_t     transfer_delay;
             uint16_t     max_sdu_size;
             uint16_t     max_bitrate_uplink;
             uint16_t     max_bitrate_downlink;
             uint16_t     gua_bitrate_uplink;
             uint16_t     gua_bitrate_downlink;
            } __attribute__((packed)) GPDS_SHARED_QOS99_NEG_INFO_STR;
#define SIZE_GPDS_SHARED_QOS99_NEG_INFO                       sizeof(GPDS_SHARED_QOS99_NEG_INFO_STR)


//Definition for struct GPDS_SHARED_FILT_SRC_IPV4_ADDR_INFO
#define GPDS_SHARED_FILT_SRC_IPV4_ADDR_INFO                   0xE6                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint8_t      ipv4_addr_mask;
             uint8_t      fillerbyte1;
             uint32_t     ipv4_address;
            } __attribute__((packed)) GPDS_SHARED_FILT_SRC_IPV4_ADDR_INFO_STR;
#define SIZE_GPDS_SHARED_FILT_SRC_IPV4_ADDR_INFO              sizeof(GPDS_SHARED_FILT_SRC_IPV4_ADDR_INFO_STR)


//Definition for struct GPDS_SHARED_FILT_SRC_IPV6_ADDR_INFO
#define GPDS_SHARED_FILT_SRC_IPV6_ADDR_INFO                   0xE7                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint8_t      ipv6_addr_mask;
             uint8_t      fillerbyte1;
             uint8_t      ipv6_address[16];
            } __attribute__((packed)) GPDS_SHARED_FILT_SRC_IPV6_ADDR_INFO_STR;
#define SIZE_GPDS_SHARED_FILT_SRC_IPV6_ADDR_INFO              sizeof(GPDS_SHARED_FILT_SRC_IPV6_ADDR_INFO_STR)


//Definition for struct GPDS_SHARED_FILT_PROTOCOL_INFO
#define GPDS_SHARED_FILT_PROTOCOL_INFO                        0xE8                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint8_t      protocol_id;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) GPDS_SHARED_FILT_PROTOCOL_INFO_STR;
#define SIZE_GPDS_SHARED_FILT_PROTOCOL_INFO                   sizeof(GPDS_SHARED_FILT_PROTOCOL_INFO_STR)


//Definition for struct GPDS_SHARED_FILT_DST_PORT_INFO
#define GPDS_SHARED_FILT_DST_PORT_INFO                        0xE9                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint16_t     destination_port;
            } __attribute__((packed)) GPDS_SHARED_FILT_DST_PORT_INFO_STR;
#define SIZE_GPDS_SHARED_FILT_DST_PORT_INFO                   sizeof(GPDS_SHARED_FILT_DST_PORT_INFO_STR)


//Definition for struct GPDS_SHARED_FILT_DST_PORT_RANGE_INFO
#define GPDS_SHARED_FILT_DST_PORT_RANGE_INFO                  0xEA                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint16_t     low_limit_dst_port_range;
             uint16_t     high_limit_dst_port_range;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) GPDS_SHARED_FILT_DST_PORT_RANGE_INFO_STR;
#define SIZE_GPDS_SHARED_FILT_DST_PORT_RANGE_INFO             sizeof(GPDS_SHARED_FILT_DST_PORT_RANGE_INFO_STR)


//Definition for struct GPDS_SHARED_FILT_SRC_PORT_INFO
#define GPDS_SHARED_FILT_SRC_PORT_INFO                        0xEB                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint16_t     source_port;
            } __attribute__((packed)) GPDS_SHARED_FILT_SRC_PORT_INFO_STR;
#define SIZE_GPDS_SHARED_FILT_SRC_PORT_INFO                   sizeof(GPDS_SHARED_FILT_SRC_PORT_INFO_STR)


//Definition for struct GPDS_SHARED_FILT_SRC_PORT_RANGE_INFO
#define GPDS_SHARED_FILT_SRC_PORT_RANGE_INFO                  0xEC                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint16_t     low_limit_src_port_range;
             uint16_t     high_limit_src_port_range;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) GPDS_SHARED_FILT_SRC_PORT_RANGE_INFO_STR;
#define SIZE_GPDS_SHARED_FILT_SRC_PORT_RANGE_INFO             sizeof(GPDS_SHARED_FILT_SRC_PORT_RANGE_INFO_STR)


//Definition for struct GPDS_SHARED_FILT_SPI_INFO
#define GPDS_SHARED_FILT_SPI_INFO                             0xED                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint32_t     security_param_ind;
            } __attribute__((packed)) GPDS_SHARED_FILT_SPI_INFO_STR;
#define SIZE_GPDS_SHARED_FILT_SPI_INFO                        sizeof(GPDS_SHARED_FILT_SPI_INFO_STR)


//Definition for struct GPDS_SHARED_FILT_TOS_INFO
#define GPDS_SHARED_FILT_TOS_INFO                             0xEE                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint8_t      tos;
             uint8_t      tos_mask;
            } __attribute__((packed)) GPDS_SHARED_FILT_TOS_INFO_STR;
#define SIZE_GPDS_SHARED_FILT_TOS_INFO                        sizeof(GPDS_SHARED_FILT_TOS_INFO_STR)


//Definition for struct GPDS_SHARED_FILT_FLOW_LABEL_INFO
#define GPDS_SHARED_FILT_FLOW_LABEL_INFO                      0xEF                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint32_t     flow_label;
            } __attribute__((packed)) GPDS_SHARED_FILT_FLOW_LABEL_INFO_STR;
#define SIZE_GPDS_SHARED_FILT_FLOW_LABEL_INFO                 sizeof(GPDS_SHARED_FILT_FLOW_LABEL_INFO_STR)


//Definition for struct GPDS_SHARED_TFT_PACKET_FILTER_INFO
#define GPDS_SHARED_TFT_PACKET_FILTER_INFO                    0xF6                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint8_t      packet_filter_id;
             uint8_t      filter_eval_prec;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
             uint8_t      number_of_subblocks;
            } __attribute__((packed)) GPDS_SHARED_TFT_PACKET_FILTER_INFO_STR;
#define SIZE_GPDS_SHARED_TFT_PACKET_FILTER_INFO               sizeof(GPDS_SHARED_TFT_PACKET_FILTER_INFO_STR)


//Definition for struct GPDS_SHARED_TFT_PARAMETER_IP_FLOW_INFO
#define GPDS_SHARED_TFT_PARAMETER_IP_FLOW_INFO                0xF2                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint16_t     media_comp_no;
             uint16_t     ip_flow_no;
            } __attribute__((packed)) GPDS_SHARED_TFT_PARAMETER_IP_FLOW_INFO_STR;
#define SIZE_GPDS_SHARED_TFT_PARAMETER_IP_FLOW_INFO           sizeof(GPDS_SHARED_TFT_PARAMETER_IP_FLOW_INFO_STR)


//Definition for struct GPDS_SHARED_TFT_PARAMETER_AUTH_TOKEN_INFO
#define GPDS_SHARED_TFT_PARAMETER_AUTH_TOKEN_INFO             0xF1                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint8_t      auth_token_length;
             uint8_t      fillerbyte1;
             uint8_t      auth_token[0];
            } __attribute__((packed)) GPDS_SHARED_TFT_PARAMETER_AUTH_TOKEN_INFO_STR;
#define SIZE_GPDS_SHARED_TFT_PARAMETER_AUTH_TOKEN_INFO        sizeof(GPDS_SHARED_TFT_PARAMETER_AUTH_TOKEN_INFO_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct GPDS_SHARED_TFT_INFO
#define GPDS_SHARED_TFT_INFO                                  0xE5                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint8_t      tft_operation;
             uint8_t      number_of_subblocks;
            } __attribute__((packed)) GPDS_SHARED_TFT_INFO_STR;
#define SIZE_GPDS_SHARED_TFT_INFO                             sizeof(GPDS_SHARED_TFT_INFO_STR)


//Definition for struct GPDS_SHARED_PCSCF_ADDRESS_REQ_INFO
#define GPDS_SHARED_PCSCF_ADDRESS_REQ_INFO                    0xF3                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) GPDS_SHARED_PCSCF_ADDRESS_REQ_INFO_STR;
#define SIZE_GPDS_SHARED_PCSCF_ADDRESS_REQ_INFO               sizeof(GPDS_SHARED_PCSCF_ADDRESS_REQ_INFO_STR)


//Definition for struct GPDS_SHARED_PCSCF_ADDRESS_INFO
#define GPDS_SHARED_PCSCF_ADDRESS_INFO                        0xF4                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint8_t      fillerbyte1;
             uint8_t      addr_length;
             uint8_t      pcscf_address[0];
            } __attribute__((packed)) GPDS_SHARED_PCSCF_ADDRESS_INFO_STR;
#define SIZE_GPDS_SHARED_PCSCF_ADDRESS_INFO                   sizeof(GPDS_SHARED_PCSCF_ADDRESS_INFO_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct GPDS_SHARED_POLICY_CONTROL_REJ_CODE_INFO
#define GPDS_SHARED_POLICY_CONTROL_REJ_CODE_INFO              0xF5                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint8_t      rejection_cause;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) GPDS_SHARED_POLICY_CONTROL_REJ_CODE_INFO_STR;
#define SIZE_GPDS_SHARED_POLICY_CONTROL_REJ_CODE_INFO         sizeof(GPDS_SHARED_POLICY_CONTROL_REJ_CODE_INFO_STR)


//Definition for struct GPDS_SHARED_IM_CN_SIGNALING_FLAG_INFO
#define GPDS_SHARED_IM_CN_SIGNALING_FLAG_INFO                 0xF7                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint8_t      imcn_sig_flag;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) GPDS_SHARED_IM_CN_SIGNALING_FLAG_INFO_STR;
#define SIZE_GPDS_SHARED_IM_CN_SIGNALING_FLAG_INFO            sizeof(GPDS_SHARED_IM_CN_SIGNALING_FLAG_INFO_STR)


//Definition for struct GPDS_SHARED_REL5_QOS_INFO
#define GPDS_SHARED_REL5_QOS_INFO                             0xF8                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint8_t      src_stat_desc;
             uint8_t      sig_ind_flag;
            } __attribute__((packed)) GPDS_SHARED_REL5_QOS_INFO_STR;
#define SIZE_GPDS_SHARED_REL5_QOS_INFO                        sizeof(GPDS_SHARED_REL5_QOS_INFO_STR)


//Definition for struct GPDS_SHARED_RADIO_ACTIVITY_REQ_INFO
#define GPDS_SHARED_RADIO_ACTIVITY_REQ_INFO                   0xF9                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) GPDS_SHARED_RADIO_ACTIVITY_REQ_INFO_STR;
#define SIZE_GPDS_SHARED_RADIO_ACTIVITY_REQ_INFO              sizeof(GPDS_SHARED_RADIO_ACTIVITY_REQ_INFO_STR)


//Definition for struct GPDS_SHARED_MBMS_SERVICE_LIST_INFO
#define GPDS_SHARED_MBMS_SERVICE_LIST_INFO                    0xFB                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint8_t      mbms_access_bearer;
             uint8_t      nbr_of_mbms_services;
             GPDS_SHARED_MBMS_SERVICE_INFO_SEQ_STR    mbms_service_info[0];
            } __attribute__((packed)) GPDS_SHARED_MBMS_SERVICE_LIST_INFO_STR;
#define SIZE_GPDS_SHARED_MBMS_SERVICE_LIST_INFO               sizeof(GPDS_SHARED_MBMS_SERVICE_LIST_INFO_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct GPDS_SHARED_INITIAL_DL_DCH_RATE
#define GPDS_SHARED_INITIAL_DL_DCH_RATE                       0xFC                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint16_t     max_bitrate_downlink;
            } __attribute__((packed)) GPDS_SHARED_INITIAL_DL_DCH_RATE_STR;
#define SIZE_GPDS_SHARED_INITIAL_DL_DCH_RATE                  sizeof(GPDS_SHARED_INITIAL_DL_DCH_RATE_STR)

#endif
