#ifndef _PN_KEY_ISI_H_
#define _PN_KEY_ISI_H_

#include <stdint.h> 

//Resource Keyboard Server
//PN_KEY 0x0C 
//ISI version 013.036
#define KEYBOARD_SERVER_ISI_VERSION_Z     13
#define KEYBOARD_SERVER_ISI_VERSION_Y     36

//In case of problems concerning content of this file contact Henrik Ala-Uotila
//Server specific message descriptions and feature&protocol descriptions can be found from: https://oucmswww.nmp.nokia.com:58443/document_browser/ccm_wa/GIF_SPECS/ 


//ISI VERSION CHANGE HISTORY

//Version: 013.036                                           
//Status: Approved                                          
//Date: 16-Sep-2008     Risto-Matti Kunnas
//Reason: RM-RIM: SCO 417-17419
//Reference: Interface CR: ADB for SWAM: RK08082949452, Inspection minutes:, APPROVED

//Version: 013.035                                           
//Status: Approved                                          
//Date: 11-Sep-2008     Risto-Matti Kunnas
//Reason: RM-RIM: SCO 408-4389
//Reference: Interface CR: ADB for SWAM:, Inspection minutes:, APPROVED

//Version: 013.034                                           
//Status: Approved                                          
//Date: 02-Sep-2008     Risto-Matti Kunnas
//Reason: RM-RIM: 417-13687
//Reference: Interface CR: ADB for SWAM: RK08050962038, Inspection minutes: ADB for SWAM: RK08090246436 , APPROVED

//Version: 013.033                                           
//Status: Draft                                             
//Date: 13-Aug-2008     Risto-Matti Kunnas
//Reason: RM-RIM:
//Reference: Interface CR:, Inspection minutes:, DRAFT

//Version: 013.032                                           
//Status: Approved                                          
//Date: 06-Aug-2008     Arto Kangas
//Reason: RM-RIM: SCO 417-8543
//Reference: Interface CR: ADB for SWAM: AK08081252230, Inspection minutes: , APPROVED

//Version: 013.031                                           
//Status: Approved                                          
//Date: 19-Jun-2008     Risto-Matti Kunnas
//Reason: RM-RIM: SUB 408-4122
//Reference: Interface CR: ADB for SWAM: RK08061360471. , Inspection minutes: ADB for SWAM: . , APPROVED

//Version: 013.030                                           
//Status: Approved                                          
//Date: 03-Jun-2008     Risto-Matti Kunnas
//Reason: RM-RIM: SCO 408-3945
//Reference: Interface CR: ADB for SWAM: RK08050962038. , Inspection minutes: ADB for SWAM: . , APPROVED

//Version: 013.029                                           
//Status: Approved                                          
//Date: 08-Jan-2008     Sami Nieminen
//Reason: RM-RIM: SCO 408-2568
//Reference: Interface CR: ADB for SWAM: SN08010838028. , Inspection minutes: ADB for SWAM: . , APPROVED

//Version: 013.028                                           
//Status: Approved                                          
//Date: 10-Oct-2007     Carsten Hauge
//Reason: 3DFS and Avago subblock and control interface changes
//Reference: Interface CR: ADB for SWAM: CH07100350658. , Inspection minutes: ADB for SWAM: CH07100842651. , APPROVED

//Version: 013.027                                           
//Status: Approved                                          
//Date: 26-Sep-2007     Carsten Hauge
//Reason: New keycodes for I_CPR 7.2
//Reference: Interface CR: ADB for SWAM: CH07091850137. , Inspection minutes: ADB for SWAM: CH07092033202. , APPROVED

//Version: 013.026                                           
//Status: NonDraft                                          
//Date: 20-Jun-2007     Boerge Fischer
//Reason: Request from Tum Wojciech (EXT-TietoEnator/CzechRepublic)
//Reference: Interface CR: ADB for SWAM BF07062063221. , Inspection minutes: ADB for SWAM BF07062062809. , NON-DRAFT

//Version: 013.025                                           
//Status: NonDraft                                          
//Date: 07-Dec-2006     Boerge Fischer
//Reason: Change request
//Reference: Interface CR: ADB for SWAM BF06120762364. , Inspection minutes: ADB for SWAM BF06120763111. , NON-DRAFT

//Version: 013.024                                           
//Status: NonDraft                                          
//Date: 08-Aug-2006     Boerge Fischer
//Reason: Change request
//Reference: Interface CR: ADB for SWAM BF06062352619. , Inspection minutes: ADB for SWAM BF06062734766. , NON-DRAFT

//Version: 013.023                                           
//Status: NonDraft                                          
//Date: 18-May-2006     Boerge Fischer
//Reason: Change request
//Reference: Interface CR: ADB for SWAM BF06051853253. , Inspection minutes: ADB for SWAM BF06051857941. , NON-DRAFT

//Version: 013.022                                           
//Status: NonDraft                                          
//Date: 01-Nov-2005     Vesa P. Keranen
//Reason: Change request
//Reference: Interface CR: ADB for SWAM VK05103144179. , NON-DRAFT

//Version: 013.021                                           
//Status: NonDraft                                          
//Date: 28-Jul-2005     Vesa P. Keranen
//Reason: Change request
//Reference: Interface CR: ADB for SWAM VK05072830018. , Inspection minutes: ADB for SWAM VK05072930818. , NON-DRAFT

//Version: 013.020                                           
//Status: NonDraft                                          
//Date: 14-June-2004    Vesa Keranen
//Reason: Change request
//Reference: Interface CR: ADB for SWAM VK04060447498. , Inspection minutes: ADB for SWAM VK04061443211. , NON-DRAFT

//Version: 013.019                                           
//Status: NonDraft                                          
//Date: 14-May-2004     Vesa Keranen
//Reason: Change request
//Reference: Interface CR: ADB for SWAM VK04050745977. , Inspection minutes: ADB for SWAM VK04051443595. , NON-DRAFT

//Version: 013.018                                           
//Status: NonDraft                                          
//Date: 13-May-2004     Vesa Keranen
//Reason: Change request
//Reference: Interface CR: ADB for SWAM VK04050645482. , Inspection minutes: ADB for SWAM VK04051334551. , NON-DRAFT

//Version: 013.017                                           
//Status: NonDraft                                          
//Date: 01-Apr-2004     Vesa Keranen
//Reason: Change request
//Reference: Interface CR: ADB for SWAM VK04032538367. , Inspection minutes: ADB for SWAM VK04040231989. , NON-DRAFT

//Version: 013.016                                           
//Status: NonDraft                                          
//Date: 12-Mar-2004     Vesa Keranen
//Reason: Change request
//Reference: Interface CR: ADB for SWAM VK04031235527. , Inspection minutes: ADB for SWAM  VK04031237429. , NON-DRAFT

//Version: 013.015                                           
//Status: NonDraft                                          
//Date: 25-Feb-2004     Vesa Keranen
//Reason: Change request
//Reference: Interface CR: ADB for SWAM  VK04021649189. , Inspection minutes: ADB for SWAM VK04022536440., NON-DRAFT

//Version: 013.014                                           
//Status: NonDraft                                          
//Date: 12-Feb-2004     Vesa Keranen
//Reason: Corrections
//Reference: Inspection minutes: ADB for SWAM VK04020551339., NON-DRAFT

//Version: 013.013                                           
//Status: NonDraft                                          
//Date: 27-Jan-2004     Vesa Keranen
//Reason: Change request
//Reference: 009-9080: Keyboard server: ISI Interface for Rotator events. , Interface CR: ADB for SWAM VK04013030512. , Inspection minutes: ADB for SWAM VK04020551339., NON-DRAFT

//Version: 013.012                                           
//Status: NonDraft                                          
//Date: 16-Oct-2003     Vesa Keranen
//Reason: Change request
//Reference: Interface CR: ADB for SWAM VK03101654032. , Inspection minutes: ADB for SWAM VK03101648494. , NON-DRAFT

//Version: 013.011                                           
//Status: NonDraft                                          
//Date: 07-Oct-2003     Vesa Keranen
//Reason: Corrections
//Reference: ADB for SWAM:  VK03092649902, Comment ID: SM03100362173, CH03100252444, NON-DRAFT

//Version: 013.010                                           
//Status: NonDraft                                          
//Date: 24-Sep-2003     Vesa Keranen
//Reason: Improvements
//Reference: -, NON-DRAFT

//Version: 013.009                                           
//Status: NonDraft                                          
//Date: 09-Jun-2003     Vesa Keranen
//Reason: Change request
//Reference: ADB for SWAM VK03041443971 for Interface CR.ADB for SWAM VK03060348130 for Inspection Minutes., NON-DRAFT

//Version: 013.008                                           
//Status: NonDraft                                          
//Date: 26-Mar-2003     Jani Lamberg
//Reason: New features & consistency check
//Reference: ADB for SWAM JL03031862541 for Interface CR.ADB for SWAM JL03032656169 for Inspection Minutes., NON-DRAFT

//Version: 013.007                                           
//Status: NonDraft                                          
//Date: 17-Mar-2003     Arno Tuominen
//Reason: New features & consistency check
//Reference: ADB for SWAM AT03020739111 & ISA RM-RIM 009-2767 for CR.             ADB for SWAM JL02102849741 for Inspection Minutes., NON-DRAFT

//Version: 013.006                                           
//Status: NonDraft                                          
//Date: 18-Feb-2003     Arno Tuominen
//Reason: Change request
//Reference: ADB for SWAM AT03020739111 for interfrace CR.ISA RM-RIM 009-2767 for feature CR., NON-DRAFT

//Version: 013.005                                           
//Status: NonDraft                                          
//Date: 30-Oct-2002     Jani Lamberg
//Reason: New features
//Reference: ADB for SWAM JS02070249698 & JL02100346289 for CR.             ADB for SWAM AT03022432721 for Inspection Minutes., NON-DRAFT


//CONSTANTS
#define KBD_FILL_BYTE                                         0x00                                                     
#define KBD_ROLLER_KEY_INFO_LENGTH                            0x04                                                     
#define KBD_SINGLE_PRESS_KEY_EVENT_INFO_LENGTH                0x08                                                     
#define KBD_TEST_UI_KEY_RESULT_LENGTH                         0x08                                                     
#define KBD_TEST_UI_ROTATOR_RESULT_LENGTH                     0x08                                                     
#define KBD_ANY_SIZE                                          1                                                     


//TABLES

//ConstantTable for KBD_KEY
#define KBD_KEY_0                                             0x30                                                  
#define KBD_KEY_1                                             0x31                                                  
#define KBD_KEY_2                                             0x32                                                  
#define KBD_KEY_3                                             0x33                                                  
#define KBD_KEY_4                                             0x34                                                  
#define KBD_KEY_5                                             0x35                                                  
#define KBD_KEY_6                                             0x36                                                  
#define KBD_KEY_7                                             0x37                                                  
#define KBD_KEY_8                                             0x38                                                  
#define KBD_KEY_9                                             0x39                                                  
#define KBD_KEY_STAR                                          0x2A                                                  
#define KBD_KEY_HASH                                          0x23                                                  
#define KBD_KEY_ROW1_COL1                                     0x80                                                  
#define KBD_KEY_ROW1_COL2                                     0x81                                                  
#define KBD_KEY_ROW1_COL3                                     0x82                                                  
#define KBD_KEY_ROW1_COL4                                     0x83                                                  
#define KBD_KEY_ROW1_COL5                                     0x84                                                  
#define KBD_KEY_ROW1_COL6                                     0x85                                                  
#define KBD_KEY_ROW1_COL7                                     0x86                                                  
#define KBD_KEY_ROW1_COL8                                     0x87                                                  
#define KBD_KEY_ROW1_COL9                                     0x88                                                  
#define KBD_KEY_ROW1_COL10                                    0x89                                                  
#define KBD_KEY_ROW1_COL11                                    0x8A                                                  
#define KBD_KEY_ROW1_COL12                                    0x8B                                                  
#define KBD_KEY_ROW2_COL1                                     0x90                                                  
#define KBD_KEY_ROW2_COL2                                     0x91                                                  
#define KBD_KEY_ROW2_COL3                                     0x92                                                  
#define KBD_KEY_ROW2_COL4                                     0x93                                                  
#define KBD_KEY_ROW2_COL5                                     0x94                                                  
#define KBD_KEY_ROW2_COL6                                     0x95                                                  
#define KBD_KEY_ROW2_COL7                                     0x96                                                  
#define KBD_KEY_ROW2_COL8                                     0x97                                                  
#define KBD_KEY_ROW2_COL9                                     0x98                                                  
#define KBD_KEY_ROW2_COL10                                    0x99                                                  
#define KBD_KEY_ROW2_COL11                                    0x9A                                                  
#define KBD_KEY_ROW2_COL12                                    0x9B                                                  
#define KBD_KEY_ROW3_COL1                                     0xA0                                                  
#define KBD_KEY_ROW3_COL2                                     0xA1                                                  
#define KBD_KEY_ROW3_COL3                                     0xA2                                                  
#define KBD_KEY_ROW3_COL4                                     0xA3                                                  
#define KBD_KEY_ROW3_COL5                                     0xA4                                                  
#define KBD_KEY_ROW3_COL6                                     0xA5                                                  
#define KBD_KEY_ROW3_COL7                                     0xA6                                                  
#define KBD_KEY_ROW3_COL8                                     0xA7                                                  
#define KBD_KEY_ROW3_COL9                                     0xA8                                                  
#define KBD_KEY_ROW3_COL10                                    0xA9                                                  
#define KBD_KEY_ROW3_COL11                                    0xAA                                                  
#define KBD_KEY_ROW3_COL12                                    0xAB                                                  
#define KBD_KEY_ROW4_COL1                                     0xB0                                                  
#define KBD_KEY_ROW4_COL2                                     0xB1                                                  
#define KBD_KEY_ROW4_COL3                                     0xB2                                                  
#define KBD_KEY_ROW4_COL4                                     0xB3                                                  
#define KBD_KEY_ROW4_COL5                                     0xB4                                                  
#define KBD_KEY_ROW4_COL6                                     0xB5                                                  
#define KBD_KEY_ROW4_COL7                                     0xB6                                                  
#define KBD_KEY_ROW4_COL8                                     0xB7                                                  
#define KBD_KEY_ROW4_COL9                                     0xB8                                                  
#define KBD_KEY_ROW4_COL10                                    0xB9                                                  
#define KBD_KEY_ROW4_COL11                                    0xBA                                                  
#define KBD_KEY_ROW4_COL12                                    0xBB                                                  
#define KBD_KEY_ROW5_COL1                                     0xC0                                                  
#define KBD_KEY_ROW5_COL2                                     0xC1                                                  
#define KBD_KEY_ROW5_COL3                                     0xC2                                                  
#define KBD_KEY_ROW5_COL4                                     0xC3                                                  
#define KBD_KEY_ROW5_COL5                                     0xC4                                                  
#define KBD_KEY_ROW5_COL6                                     0xC5                                                  
#define KBD_KEY_ROW5_COL7                                     0xC6                                                  
#define KBD_KEY_ROW5_COL8                                     0xC7                                                  
#define KBD_KEY_ROW5_COL9                                     0xC8                                                  
#define KBD_KEY_ROW5_COL10                                    0xC9                                                  
#define KBD_KEY_ROW5_COL11                                    0xCA                                                  
#define KBD_KEY_ROW5_COL12                                    0xCB                                                  
#define KBD_KEY_TK_LAYOUT0_KEY0                               0x2000                                                
#define KBD_KEY_TK_LAYOUT0_KEY1                               0x2001                                                
#define KBD_KEY_TK_LAYOUT0_KEY2                               0x2002                                                
#define KBD_KEY_TK_LAYOUT0_KEY3                               0x2003                                                
#define KBD_KEY_TK_LAYOUT0_KEY4                               0x2004                                                
#define KBD_KEY_TK_LAYOUT0_KEY5                               0x2005                                                
#define KBD_KEY_TK_LAYOUT0_KEY6                               0x2006                                                
#define KBD_KEY_TK_LAYOUT0_KEY7                               0x2007                                                
#define KBD_KEY_TK_LAYOUT0_KEY8                               0x2008                                                
#define KBD_KEY_TK_LAYOUT0_KEY9                               0x2009                                                
#define KBD_KEY_TK_LAYOUT0_KEY10                              0x200A                                                
#define KBD_KEY_TK_LAYOUT0_KEY11                              0x200B                                                
#define KBD_KEY_TK_LAYOUT0_KEY12                              0x200C                                                
#define KBD_KEY_TK_LAYOUT0_KEY13                              0x200D                                                
#define KBD_KEY_TK_LAYOUT0_KEY14                              0x200E                                                
#define KBD_KEY_TK_LAYOUT0_KEY15                              0x200F                                                
#define KBD_KEY_TK_LAYOUT0_KEY16                              0x2010                                                
#define KBD_KEY_TK_LAYOUT0_KEY17                              0x2011                                                
#define KBD_KEY_TK_LAYOUT0_KEY18                              0x2012                                                
#define KBD_KEY_TK_LAYOUT0_KEY19                              0x2013                                                
#define KBD_KEY_TK_LAYOUT0_KEY20                              0x2014                                                
#define KBD_KEY_TK_LAYOUT0_KEY21                              0x2015                                                
#define KBD_KEY_TK_LAYOUT0_KEY22                              0x2016                                                
#define KBD_KEY_TK_LAYOUT0_KEY23                              0x2017                                                
#define KBD_KEY_TK_LAYOUT0_KEY24                              0x2018                                                
#define KBD_KEY_TK_LAYOUT0_KEY25                              0x2019                                                
#define KBD_KEY_TK_LAYOUT0_KEY26                              0x201A                                                
#define KBD_KEY_TK_LAYOUT0_KEY27                              0x201B                                                
#define KBD_KEY_TK_LAYOUT0_KEY28                              0x201C                                                
#define KBD_KEY_TK_LAYOUT0_KEY29                              0x201D                                                
#define KBD_KEY_TK_LAYOUT0_KEY30                              0x201E                                                
#define KBD_KEY_TK_LAYOUT0_KEY31                              0x201F                                                
#define KBD_KEY_TK_LAYOUT0_KEY32                              0x2020                                                
#define KBD_KEY_TK_LAYOUT0_KEY33                              0x2021                                                
#define KBD_KEY_TK_LAYOUT0_KEY34                              0x2022                                                
#define KBD_KEY_TK_LAYOUT0_KEY35                              0x2023                                                
#define KBD_KEY_TK_LAYOUT0_KEY36                              0x2024                                                
#define KBD_KEY_TK_LAYOUT0_KEY37                              0x2025                                                
#define KBD_KEY_TK_LAYOUT0_KEY38                              0x2026                                                
#define KBD_KEY_TK_LAYOUT0_KEY39                              0x2027                                                
#define KBD_KEY_TK_LAYOUT0_KEY40                              0x2028                                                
#define KBD_KEY_TK_LAYOUT0_KEY41                              0x2029                                                
#define KBD_KEY_TK_LAYOUT0_KEY42                              0x202A                                                
#define KBD_KEY_TK_LAYOUT0_KEY43                              0x202B                                                
#define KBD_KEY_TK_LAYOUT0_KEY44                              0x202C                                                
#define KBD_KEY_TK_LAYOUT0_KEY45                              0x202D                                                
#define KBD_KEY_TK_LAYOUT0_KEY46                              0x202E                                                
#define KBD_KEY_TK_LAYOUT0_KEY47                              0x202F                                                
#define KBD_KEY_TK_LAYOUT0_KEY48                              0x2030                                                
#define KBD_KEY_TK_LAYOUT0_KEY49                              0x2031                                                
#define KBD_KEY_TK_LAYOUT0_KEY50                              0x2032                                                
#define KBD_KEY_TK_LAYOUT0_KEY51                              0x2033                                                
#define KBD_KEY_TK_LAYOUT0_KEY52                              0x2034                                                
#define KBD_KEY_TK_LAYOUT0_KEY53                              0x2035                                                
#define KBD_KEY_TK_LAYOUT0_KEY54                              0x2036                                                
#define KBD_KEY_TK_LAYOUT0_KEY55                              0x2037                                                
#define KBD_KEY_TK_LAYOUT0_KEY56                              0x2038                                                
#define KBD_KEY_TK_LAYOUT0_KEY57                              0x2039                                                
#define KBD_KEY_TK_LAYOUT0_KEY58                              0x203A                                                
#define KBD_KEY_TK_LAYOUT0_KEY59                              0x203B                                                
#define KBD_KEY_TK_LAYOUT0_KEY60                              0x203C                                                
#define KBD_KEY_TK_LAYOUT0_KEY61                              0x203D                                                
#define KBD_KEY_TK_LAYOUT0_KEY62                              0x203E                                                
#define KBD_KEY_TK_LAYOUT0_KEY63                              0x203F                                                
#define KBD_KEY_TK_LAYOUT1_KEY0                               0x2040                                                
#define KBD_KEY_TK_LAYOUT1_KEY1                               0x2041                                                
#define KBD_KEY_TK_LAYOUT1_KEY2                               0x2042                                                
#define KBD_KEY_TK_LAYOUT1_KEY3                               0x2043                                                
#define KBD_KEY_TK_LAYOUT1_KEY4                               0x2044                                                
#define KBD_KEY_TK_LAYOUT1_KEY5                               0x2045                                                
#define KBD_KEY_TK_LAYOUT1_KEY6                               0x2046                                                
#define KBD_KEY_TK_LAYOUT1_KEY7                               0x2047                                                
#define KBD_KEY_TK_LAYOUT1_KEY8                               0x2048                                                
#define KBD_KEY_TK_LAYOUT1_KEY9                               0x2049                                                
#define KBD_KEY_TK_LAYOUT1_KEY10                              0x204A                                                
#define KBD_KEY_TK_LAYOUT1_KEY11                              0x204B                                                
#define KBD_KEY_TK_LAYOUT1_KEY12                              0x204C                                                
#define KBD_KEY_TK_LAYOUT1_KEY13                              0x204D                                                
#define KBD_KEY_TK_LAYOUT1_KEY14                              0x204E                                                
#define KBD_KEY_TK_LAYOUT1_KEY15                              0x204F                                                
#define KBD_KEY_TK_LAYOUT1_KEY16                              0x2050                                                
#define KBD_KEY_TK_LAYOUT1_KEY17                              0x2051                                                
#define KBD_KEY_TK_LAYOUT1_KEY18                              0x2052                                                
#define KBD_KEY_TK_LAYOUT1_KEY19                              0x2053                                                
#define KBD_KEY_TK_LAYOUT1_KEY20                              0x2054                                                
#define KBD_KEY_TK_LAYOUT1_KEY21                              0x2055                                                
#define KBD_KEY_TK_LAYOUT1_KEY22                              0x2056                                                
#define KBD_KEY_TK_LAYOUT1_KEY23                              0x2057                                                
#define KBD_KEY_TK_LAYOUT1_KEY24                              0x2058                                                
#define KBD_KEY_TK_LAYOUT1_KEY25                              0x2059                                                
#define KBD_KEY_TK_LAYOUT1_KEY26                              0x205A                                                
#define KBD_KEY_TK_LAYOUT1_KEY27                              0x205B                                                
#define KBD_KEY_TK_LAYOUT1_KEY28                              0x205C                                                
#define KBD_KEY_TK_LAYOUT1_KEY29                              0x205D                                                
#define KBD_KEY_TK_LAYOUT1_KEY30                              0x205E                                                
#define KBD_KEY_TK_LAYOUT1_KEY31                              0x205F                                                
#define KBD_KEY_TK_LAYOUT1_KEY32                              0x2060                                                
#define KBD_KEY_TK_LAYOUT1_KEY33                              0x2061                                                
#define KBD_KEY_TK_LAYOUT1_KEY34                              0x2062                                                
#define KBD_KEY_TK_LAYOUT1_KEY35                              0x2063                                                
#define KBD_KEY_TK_LAYOUT1_KEY36                              0x2064                                                
#define KBD_KEY_TK_LAYOUT1_KEY37                              0x2065                                                
#define KBD_KEY_TK_LAYOUT1_KEY38                              0x2066                                                
#define KBD_KEY_TK_LAYOUT1_KEY39                              0x2067                                                
#define KBD_KEY_TK_LAYOUT1_KEY40                              0x2068                                                
#define KBD_KEY_TK_LAYOUT1_KEY41                              0x2069                                                
#define KBD_KEY_TK_LAYOUT1_KEY42                              0x206A                                                
#define KBD_KEY_TK_LAYOUT1_KEY43                              0x206B                                                
#define KBD_KEY_TK_LAYOUT1_KEY44                              0x206C                                                
#define KBD_KEY_TK_LAYOUT1_KEY45                              0x206D                                                
#define KBD_KEY_TK_LAYOUT1_KEY46                              0x206E                                                
#define KBD_KEY_TK_LAYOUT1_KEY47                              0x206F                                                
#define KBD_KEY_TK_LAYOUT1_KEY48                              0x2070                                                
#define KBD_KEY_TK_LAYOUT1_KEY49                              0x2071                                                
#define KBD_KEY_TK_LAYOUT1_KEY50                              0x2072                                                
#define KBD_KEY_TK_LAYOUT1_KEY51                              0x2073                                                
#define KBD_KEY_TK_LAYOUT1_KEY52                              0x2074                                                
#define KBD_KEY_TK_LAYOUT1_KEY53                              0x2075                                                
#define KBD_KEY_TK_LAYOUT1_KEY54                              0x2076                                                
#define KBD_KEY_TK_LAYOUT1_KEY55                              0x2077                                                
#define KBD_KEY_TK_LAYOUT1_KEY56                              0x2078                                                
#define KBD_KEY_TK_LAYOUT1_KEY57                              0x2079                                                
#define KBD_KEY_TK_LAYOUT1_KEY58                              0x207A                                                
#define KBD_KEY_TK_LAYOUT1_KEY59                              0x207B                                                
#define KBD_KEY_TK_LAYOUT1_KEY60                              0x207C                                                
#define KBD_KEY_TK_LAYOUT1_KEY61                              0x207D                                                
#define KBD_KEY_TK_LAYOUT1_KEY62                              0x207E                                                
#define KBD_KEY_TK_LAYOUT1_KEY63                              0x207F                                                
#define KBD_KEY_TK_LAYOUT2_KEY0                               0x2080                                                
#define KBD_KEY_TK_LAYOUT2_KEY1                               0x2081                                                
#define KBD_KEY_TK_LAYOUT2_KEY2                               0x2082                                                
#define KBD_KEY_TK_LAYOUT2_KEY3                               0x2083                                                
#define KBD_KEY_TK_LAYOUT2_KEY4                               0x2084                                                
#define KBD_KEY_TK_LAYOUT2_KEY5                               0x2085                                                
#define KBD_KEY_TK_LAYOUT2_KEY6                               0x2086                                                
#define KBD_KEY_TK_LAYOUT2_KEY7                               0x2087                                                
#define KBD_KEY_TK_LAYOUT2_KEY8                               0x2088                                                
#define KBD_KEY_TK_LAYOUT2_KEY9                               0x2089                                                
#define KBD_KEY_TK_LAYOUT2_KEY10                              0x208A                                                
#define KBD_KEY_TK_LAYOUT2_KEY11                              0x208B                                                
#define KBD_KEY_TK_LAYOUT2_KEY12                              0x208C                                                
#define KBD_KEY_TK_LAYOUT2_KEY13                              0x208D                                                
#define KBD_KEY_TK_LAYOUT2_KEY14                              0x208E                                                
#define KBD_KEY_TK_LAYOUT2_KEY15                              0x208F                                                
#define KBD_KEY_TK_LAYOUT2_KEY16                              0x2090                                                
#define KBD_KEY_TK_LAYOUT2_KEY17                              0x2091                                                
#define KBD_KEY_TK_LAYOUT2_KEY18                              0x2092                                                
#define KBD_KEY_TK_LAYOUT2_KEY19                              0x2093                                                
#define KBD_KEY_TK_LAYOUT2_KEY20                              0x2094                                                
#define KBD_KEY_TK_LAYOUT2_KEY21                              0x2095                                                
#define KBD_KEY_TK_LAYOUT2_KEY22                              0x2096                                                
#define KBD_KEY_TK_LAYOUT2_KEY23                              0x2097                                                
#define KBD_KEY_TK_LAYOUT2_KEY24                              0x2098                                                
#define KBD_KEY_TK_LAYOUT2_KEY25                              0x2099                                                
#define KBD_KEY_TK_LAYOUT2_KEY26                              0x209A                                                
#define KBD_KEY_TK_LAYOUT2_KEY27                              0x209B                                                
#define KBD_KEY_TK_LAYOUT2_KEY28                              0x209C                                                
#define KBD_KEY_TK_LAYOUT2_KEY29                              0x209D                                                
#define KBD_KEY_TK_LAYOUT2_KEY30                              0x209E                                                
#define KBD_KEY_TK_LAYOUT2_KEY31                              0x209F                                                
#define KBD_KEY_TK_LAYOUT2_KEY32                              0x20A0                                                
#define KBD_KEY_TK_LAYOUT2_KEY33                              0x20A1                                                
#define KBD_KEY_TK_LAYOUT2_KEY34                              0x20A2                                                
#define KBD_KEY_TK_LAYOUT2_KEY35                              0x20A3                                                
#define KBD_KEY_TK_LAYOUT2_KEY36                              0x20A4                                                
#define KBD_KEY_TK_LAYOUT2_KEY37                              0x20A5                                                
#define KBD_KEY_TK_LAYOUT2_KEY38                              0x20A6                                                
#define KBD_KEY_TK_LAYOUT2_KEY39                              0x20A7                                                
#define KBD_KEY_TK_LAYOUT2_KEY40                              0x20A8                                                
#define KBD_KEY_TK_LAYOUT2_KEY41                              0x20A9                                                
#define KBD_KEY_TK_LAYOUT2_KEY42                              0x20AA                                                
#define KBD_KEY_TK_LAYOUT2_KEY43                              0x20AB                                                
#define KBD_KEY_TK_LAYOUT2_KEY44                              0x20AC                                                
#define KBD_KEY_TK_LAYOUT2_KEY45                              0x20AD                                                
#define KBD_KEY_TK_LAYOUT2_KEY46                              0x20AE                                                
#define KBD_KEY_TK_LAYOUT2_KEY47                              0x20AF                                                
#define KBD_KEY_TK_LAYOUT2_KEY48                              0x20B0                                                
#define KBD_KEY_TK_LAYOUT2_KEY49                              0x20B1                                                
#define KBD_KEY_TK_LAYOUT2_KEY50                              0x20B2                                                
#define KBD_KEY_TK_LAYOUT2_KEY51                              0x20B3                                                
#define KBD_KEY_TK_LAYOUT2_KEY52                              0x20B4                                                
#define KBD_KEY_TK_LAYOUT2_KEY53                              0x20B5                                                
#define KBD_KEY_TK_LAYOUT2_KEY54                              0x20B6                                                
#define KBD_KEY_TK_LAYOUT2_KEY55                              0x20B7                                                
#define KBD_KEY_TK_LAYOUT2_KEY56                              0x20B8                                                
#define KBD_KEY_TK_LAYOUT2_KEY57                              0x20B9                                                
#define KBD_KEY_TK_LAYOUT2_KEY58                              0x20BA                                                
#define KBD_KEY_TK_LAYOUT2_KEY59                              0x20BB                                                
#define KBD_KEY_TK_LAYOUT2_KEY60                              0x20BC                                                
#define KBD_KEY_TK_LAYOUT2_KEY61                              0x20BD                                                
#define KBD_KEY_TK_LAYOUT2_KEY62                              0x20BE                                                
#define KBD_KEY_TK_LAYOUT2_KEY63                              0x20BF                                                
#define KBD_KEY_TK_LAYOUT3_KEY0                               0x20C0                                                
#define KBD_KEY_TK_LAYOUT3_KEY1                               0x20C1                                                
#define KBD_KEY_TK_LAYOUT3_KEY2                               0x20C2                                                
#define KBD_KEY_TK_LAYOUT3_KEY3                               0x20C3                                                
#define KBD_KEY_TK_LAYOUT3_KEY4                               0x20C4                                                
#define KBD_KEY_TK_LAYOUT3_KEY5                               0x20C5                                                
#define KBD_KEY_TK_LAYOUT3_KEY6                               0x20C6                                                
#define KBD_KEY_TK_LAYOUT3_KEY7                               0x20C7                                                
#define KBD_KEY_TK_LAYOUT3_KEY8                               0x20C8                                                
#define KBD_KEY_TK_LAYOUT3_KEY9                               0x20C9                                                
#define KBD_KEY_TK_LAYOUT3_KEY10                              0x20CA                                                
#define KBD_KEY_TK_LAYOUT3_KEY11                              0x20CB                                                
#define KBD_KEY_TK_LAYOUT3_KEY12                              0x20CC                                                
#define KBD_KEY_TK_LAYOUT3_KEY13                              0x20CD                                                
#define KBD_KEY_TK_LAYOUT3_KEY14                              0x20CE                                                
#define KBD_KEY_TK_LAYOUT3_KEY15                              0x20CF                                                
#define KBD_KEY_TK_LAYOUT3_KEY16                              0x20D0                                                
#define KBD_KEY_TK_LAYOUT3_KEY17                              0x20D1                                                
#define KBD_KEY_TK_LAYOUT3_KEY18                              0x20D2                                                
#define KBD_KEY_TK_LAYOUT3_KEY19                              0x20D3                                                
#define KBD_KEY_TK_LAYOUT3_KEY20                              0x20D4                                                
#define KBD_KEY_TK_LAYOUT3_KEY21                              0x20D5                                                
#define KBD_KEY_TK_LAYOUT3_KEY22                              0x20D6                                                
#define KBD_KEY_TK_LAYOUT3_KEY23                              0x20D7                                                
#define KBD_KEY_TK_LAYOUT3_KEY24                              0x20D8                                                
#define KBD_KEY_TK_LAYOUT3_KEY25                              0x20D9                                                
#define KBD_KEY_TK_LAYOUT3_KEY26                              0x20DA                                                
#define KBD_KEY_TK_LAYOUT3_KEY27                              0x20DB                                                
#define KBD_KEY_TK_LAYOUT3_KEY28                              0x20DC                                                
#define KBD_KEY_TK_LAYOUT3_KEY29                              0x20DD                                                
#define KBD_KEY_TK_LAYOUT3_KEY30                              0x20DE                                                
#define KBD_KEY_TK_LAYOUT3_KEY31                              0x20DF                                                
#define KBD_KEY_TK_LAYOUT3_KEY32                              0x20E0                                                
#define KBD_KEY_TK_LAYOUT3_KEY33                              0x20E1                                                
#define KBD_KEY_TK_LAYOUT3_KEY34                              0x20E2                                                
#define KBD_KEY_TK_LAYOUT3_KEY35                              0x20E3                                                
#define KBD_KEY_TK_LAYOUT3_KEY36                              0x20E4                                                
#define KBD_KEY_TK_LAYOUT3_KEY37                              0x20E5                                                
#define KBD_KEY_TK_LAYOUT3_KEY38                              0x20E6                                                
#define KBD_KEY_TK_LAYOUT3_KEY39                              0x20E7                                                
#define KBD_KEY_TK_LAYOUT3_KEY40                              0x20E8                                                
#define KBD_KEY_TK_LAYOUT3_KEY41                              0x20E9                                                
#define KBD_KEY_TK_LAYOUT3_KEY42                              0x20EA                                                
#define KBD_KEY_TK_LAYOUT3_KEY43                              0x20EB                                                
#define KBD_KEY_TK_LAYOUT3_KEY44                              0x20EC                                                
#define KBD_KEY_TK_LAYOUT3_KEY45                              0x20ED                                                
#define KBD_KEY_TK_LAYOUT3_KEY46                              0x20EE                                                
#define KBD_KEY_TK_LAYOUT3_KEY47                              0x20EF                                                
#define KBD_KEY_TK_LAYOUT3_KEY48                              0x20F0                                                
#define KBD_KEY_TK_LAYOUT3_KEY49                              0x20F1                                                
#define KBD_KEY_TK_LAYOUT3_KEY50                              0x20F2                                                
#define KBD_KEY_TK_LAYOUT3_KEY51                              0x20F3                                                
#define KBD_KEY_TK_LAYOUT3_KEY52                              0x20F4                                                
#define KBD_KEY_TK_LAYOUT3_KEY53                              0x20F5                                                
#define KBD_KEY_TK_LAYOUT3_KEY54                              0x20F6                                                
#define KBD_KEY_TK_LAYOUT3_KEY55                              0x20F7                                                
#define KBD_KEY_TK_LAYOUT3_KEY56                              0x20F8                                                
#define KBD_KEY_TK_LAYOUT3_KEY57                              0x20F9                                                
#define KBD_KEY_TK_LAYOUT3_KEY58                              0x20FA                                                
#define KBD_KEY_TK_LAYOUT3_KEY59                              0x20FB                                                
#define KBD_KEY_TK_LAYOUT3_KEY60                              0x20FC                                                
#define KBD_KEY_TK_LAYOUT3_KEY61                              0x20FD                                                
#define KBD_KEY_TK_LAYOUT3_KEY62                              0x20FE                                                
#define KBD_KEY_TK_LAYOUT3_KEY63                              0x20FF                                                
#define KBD_KEY_EXT_PTT                                       0x4001                                                
#define KBD_KEY_EXT_SEND                                      0x4002                                                
#define KBD_KEY_EXT_END                                       0x4003                                                
#define KBD_KEY_NO_KEY                                        0xE000                                                
#define KBD_KEY_POWER                                         0xE001                                                
#define KBD_KEY_SLIDE                                         0xE002                                                
#define KBD_KEY_SOFT_L                                        0xE003                                                
#define KBD_KEY_SOFT_R                                        0xE004                                                
#define KBD_KEY_SEND                                          0xE005                                                
#define KBD_KEY_END                                           0xE006                                                
#define KBD_KEY_ARROW_U                                       0xE007                                                
#define KBD_KEY_ARROW_D                                       0xE008                                                
#define KBD_KEY_ROLLER                                        0xE009                                                
#define KBD_KEY_VOL_UP                                        0xE00A                                                
#define KBD_KEY_VOL_DOWN                                      0xE00B                                                
#define KBD_KEY_SELECT                                        0xE00C                                                
#define KBD_KEY_ARROW_L                                       0xE00D                                                
#define KBD_KEY_ARROW_R                                       0xE00E                                                
#define KBD_KEY_VOICE_RECOG                                   0xE00F                                                
#define KBD_KEY_FLIP                                          0xE010                                                
#define KBD_KEY_ADC1_1                                        0xE011                                                
#define KBD_KEY_ADC1_2                                        0xE012                                                
#define KBD_KEY_ADC1_3                                        0xE013                                                
#define KBD_KEY_ADC1_4                                        0xE014                                                
#define KBD_KEY_ADC1_5                                        0xE015                                                
#define KBD_KEY_ADC1_6                                        0xE016                                                
#define KBD_KEY_ADC1_7                                        0xE017                                                
#define KBD_KEY_ADC1_8                                        0xE018                                                
#define KBD_KEY_ADC2_1                                        0xE021                                                
#define KBD_KEY_ADC2_2                                        0xE022                                                
#define KBD_KEY_ADC2_3                                        0xE023                                                
#define KBD_KEY_ADC2_4                                        0xE024                                                
#define KBD_KEY_ADC2_5                                        0xE025                                                
#define KBD_KEY_ADC2_6                                        0xE026                                                
#define KBD_KEY_ADC2_7                                        0xE027                                                
#define KBD_KEY_ADC2_8                                        0xE028                                                
#define KBD_KEY_P0_0_PIN                                      0xE031                                                
#define KBD_KEY_P0_1_PIN                                      0xE032                                                
#define KBD_KEY_P0_2_PIN                                      0xE033                                                
#define KBD_KEY_P0_3_PIN                                      0xE034                                                
#define KBD_KEY_P0_4_PIN                                      0xE035                                                
#define KBD_KEY_P0_5_PIN                                      0xE036                                                
#define KBD_KEY_P1_0_PIN                                      0xE041                                                
#define KBD_KEY_P1_1_PIN                                      0xE042                                                
#define KBD_KEY_P1_2_PIN                                      0xE043                                                
#define KBD_KEY_P1_3_PIN                                      0xE044                                                
#define KBD_KEY_P1_4_PIN                                      0xE045                                                
#define KBD_KEY_P1_5_PIN                                      0xE046                                                
#define KBD_KEY_HOT                                           0xE051                                                
#define KBD_KEY_CLEAR                                         0xE052                                                
#define KBD_KEY_TPARTY                                        0xE054                                                
#define KBD_KEY_RECORD                                        0xE055                                                
#define KBD_KEY_PTT                                           0xE056                                                
#define KBD_KEY_ROTATOR_U                                     0xE057                                                
#define KBD_KEY_ROTATOR_D                                     0xE058                                                
#define KBD_KEY_ROTATOR_L                                     0xE059                                                
#define KBD_KEY_ROTATOR_R                                     0xE05A                                                
#define KBD_KEY_UI_ROTATION                                   0xE05B                                                
#define KBD_KEY_CAMERA                                        0xE05C                                                
#define KBD_KEY_CAMERA_PREPARE                                0xE05D                                                
#define KBD_KEY_CAMERA_COVER                                  0xE05E                                                
#define KBD_KEY_COVER_SOFT_1                                  0xE05F                                                
#define KBD_KEY_COVER_SOFT_2                                  0xE060                                                
#define KBD_KEY_COVER_SOFT_3                                  0xE061                                                
#define KBD_KEY_NAVISLIDE_LEFT                                0xE062                                                
#define KBD_KEY_NAVISLIDE_RIGHT                               0xE063                                                
#define KBD_KEY_MENU                                          0xE064                                                
#define KBD_KEY_DEVICE_0                                      0xE065                                                
#define KBD_KEY_DEVICE_1                                      0xE066                                                
#define KBD_KEY_DEVICE_2                                      0xE067                                                
#define KBD_KEY_LAUNCH_MAGNET                                 0xE068                                                
#define KBD_KEY_EXT_MP_PLAY_PAUSE                             0xE069                                                
#define KBD_KEY_EXT_MP_STOP                                   0xE06A                                                
#define KBD_KEY_EXT_MP_PREV_TRACK                             0xE06B                                                
#define KBD_KEY_EXT_MP_NEXT_TRACK                             0xE06C                                                
#define KBD_KEY_UI_RELAX_MODE                                 0xE06D                                                
#define KBD_KEY_MEDIA                                         0xE06E                                                
#define KBD_KEY_CV                                            0xE06F                                                
#define KBD_KEY_KEYLOCK                                       0xE070                                                
#define KBD_KEY_KEYLOCK_TOGGLE                                0xE071                                                
#define KBD_KEY_CHANNEL_A                                     0xE072                                                
#define KBD_KEY_CHANNEL_B                                     0xE073                                                
#define KBD_KEY_FUNCTION                                      0xE074                                                
#define KBD_KEY_PHONE_LOCK                                    0xE075                                                
#define KBD_KEY_MUTE_KEY                                      0xE076                                                
#define KBD_KEY_RECALL                                        0xE077                                                
#define KBD_KEY_STORE_MEMORY                                  0xE078                                                
#define KBD_KEY_AUXILIARY                                     0xE079                                                

//ConstantTable for KBD_STATUS
#define KBD_OK                                                0x00                                                     
#define KBD_FAIL                                              0x01                                                     

//ConstantTable for KBD_KEY_STATE
#define KBD_KEY_UP                                            0x00                                                     
#define KBD_KEY_DOWN                                          0x01                                                     
#define KBD_KEY_LONG                                          0x02                                                     
#define KBD_KEY_REPEAT                                        0x03                                                     
#define KBD_KEY_SHORT                                         0x04                                                     
#define KBD_KEY_IDLE                                          0x05                                                     

//ConstantTable for KBD_ROLLER_DIRECTION
#define KBD_ROLLER_NORTH                                      0x01                                                     
#define KBD_ROLLER_SOUTH                                      0x02                                                     

//ConstantTable for KBD_ROTATOR_MODE
#define KBD_ROTATOR_SLOW_MODE                                 0x00                                                     
#define KBD_ROTATOR_FAST_MODE_START                           0x01                                                     
#define KBD_ROTATOR_FAST_MODE_STEP                            0x02                                                     
#define KBD_ROTATOR_FAST_MODE_STOP                            0x03                                                     

//ConstantTable for KBD_ROTATOR_DIRECTION
#define KBD_ROTATOR_CLOCKWISE                                 0x00                                                     
#define KBD_ROTATOR_ANTI_CLOCKWISE                            0x01                                                     

//ConstantTable for KBD_ROTATOR_CONTROL_ACTION
#define KBD_ROTATOR_ENABLE                                    0x00                                                     
#define KBD_ROTATOR_DISABLE                                   0x01                                                     
#define KBD_ROTATOR_SPEED_SETTING_0                           0x02                                                     
#define KBD_ROTATOR_SPEED_SETTING_1                           0x03                                                     
#define KBD_ROTATOR_SPEED_SETTING_2                           0x04                                                     
#define KBD_ROTATOR_SPEED_SETTING_3                           0x05                                                     
#define KBD_ROTATOR_SPEED_SETTING_4                           0x06                                                     

//ConstantTable for KBD_CONTROL_ACTION
#define KBD_KEYCODE_MAPPING_PRIMARY                           0x00                                                     
#define KBD_KEYCODE_MAPPING_SECONDARY                         0x01                                                     

//ConstantTable for KBD_ROTATOR_CONTROL_STATUS
#define KBD_ROTATOR_OK                                        0x00                                                     
#define KBD_ROTATOR_FAIL                                      0x01                                                     

//ConstantTable for KBD_SLIDE_STATE
#define KBD_SLIDE_CLOSED                                      0x00                                                     
#define KBD_SLIDE_OPEN                                        0x01                                                     

//ConstantTable for KBD_FLIP_STATE
#define KBD_FLIP_CLOSED                                       0x00                                                     
#define KBD_FLIP_OPEN                                         0x01                                                     

//ConstantTable for KBD_KEYLOCK_STATE
#define KBD_KEYLOCK_CLOSED                                    0x00                                                     
#define KBD_KEYLOCK_OPEN                                      0x01                                                     

//ConstantTable for KBD_PWR_KEY_STATUS
#define KBD_PROCEED                                           0x00                                                     
#define KBD_ABORT                                             0x01                                                     
#define KBD_WAIT                                              0x02                                                     

//ConstantTable for KBD_TEST_ACTION
#define KBD_TEST_UI_START                                     0x00                                                     
#define KBD_TEST_UI_RESULT_GET                                0x01                                                     
#define KBD_TEST_UI_STOP                                      0x02                                                     
#define KBD_TEST_FLIP_CONNECTION                              0x03                                                     
#define KBD_TEST_FLIP_POWER_ON                                0x04                                                     
#define KBD_TEST_FLIP_POWER_OFF                               0x05                                                     

//ConstantTable for KBD_TEST_STATUS
#define KBD_TEST_OK                                           0x00                                                     
#define KBD_TEST_FAIL                                         0x01                                                     
#define KBD_TEST_BUSY                                         0x02                                                     
#define KBD_TEST_NOT_SUPPORTED                                0x03                                                     

//ConstantTable for KBD_BUFFERING_ACTION
#define KBD_BUFFERING_STOP                                    0x00                                                     
#define KBD_BUFFERING_START                                   0x01                                                     

//ConstantTable for KBD_POINTING_DEVICE_CONTROL_ACTION
#define KBD_POINTING_DEVICE_LOW_SENSITIVITY                   0x00                                                     
#define KBD_POINTING_DEVICE_HIGH_SENSITIVITY                  0x01                                                     

//ConstantTable for KBD_READ_RAW_DATA_DEVICE
#define KBD_READ_RAW_DATA_CAPACITIVE_KEY                      0x01                                                     

//ConstantTable for KBD_READ_RAW_DATA_SIZE
#define KBD_READ_RAW_DATA_SIZE_8                              0x00                                                     
#define KBD_READ_RAW_DATA_SIZE_16                             0x01                                                     
#define KBD_READ_RAW_DATA_SIZE_32                             0x02                                                     

//ConstantTable for KBD_POWER_CONTROL_DEVICE_ID
#define KBD_POWER_CONTROL_CAPACITIVE_KEY                      0x01                                                     

//ConstantTable for KBD_POWER_CONTROL_MODE
#define KBD_POWER_CONTROL_MODE_OFF                            0x00                                                     
#define KBD_POWER_CONTROL_MODE_LOW                            0x01                                                     
#define KBD_POWER_CONTROL_MODE_DEFAULT                        0x02                                                     
#define KBD_POWER_CONTROL_MODE_MAX                            0x03                                                     
#define KBD_POWER_CONTROL_MODE_STEP_UP                        0x04                                                     
#define KBD_POWER_CONTROL_MODE_STEP_DOWN                      0x05                                                     

//BitmaskTables for KBD_TEST_KEY_TEST_STATE
#define KBD_TEST_UI_KEY_PRESSED                               0x01                                                     
#define KBD_TEST_UI_KEY_RELEASED                              0x02                                                     
#define KBD_TEST_UI_KEY_LONG_PRESSED                          0x04                                                     
#define KBD_TEST_UI_KEY_REPEAT_PRESSED                        0x08                                                     
#define KBD_TEST_UI_KEY_OPENED                                0x10                                                  
#define KBD_TEST_UI_KEY_CLOSED                                0x20                                                  
#define KBD_TEST_UI_KEY_SHORT_PRESSED                         0x40                                                  
#define KBD_TEST_UI_KEY_IDLE                                  0x80                                                  

//BitmaskTables for KBD_DEVICE_STATUS
#define KBD_ADC_KEYBOARD_MASK                                 0x01                                                     
#define KBD_MATRIX_KEYBOARD_MASK                              0x02                                                     
#define KBD_METAL_DOME_KEYBOARD_MASK                          0x04                                                     
#define KBD_FLIP_KEYBOARD_MASK                                0x08                                                     

//BitmaskTables for KBD_SPECIAL_KEY_STATUS
#define KBD_KEY_SLIDE_MASK                                    0x01                                                     
#define KBD_KEY_POWER_MASK                                    0x02                                                     
#define KBD_KEY_FLIP_MASK                                     0x04                                                     
#define KBD_KEY_GENIO_MASK                                    0x08                                                     
#define KBD_KEY_KEYLOCK_MASK                                  0x10                                                  
#define KBD_KEY_CAMERA_COVER_MASK                             0x20                                                  

//BitmaskTables for KBD_SPECIAL_KEY_STATUS_KDI_P0
#define KBD_KEY_P0_0_PIN_MASK                                 0x01                                                     
#define KBD_KEY_P0_1_PIN_MASK                                 0x02                                                     
#define KBD_KEY_P0_2_PIN_MASK                                 0x04                                                     
#define KBD_KEY_P0_3_PIN_MASK                                 0x08                                                     
#define KBD_KEY_P0_4_PIN_MASK                                 0x10                                                  
#define KBD_KEY_P0_5_PIN_MASK                                 0x20                                                  

//BitmaskTables for KBD_SPECIAL_KEY_STATUS_KDI_P1
#define KBD_KEY_P1_0_PIN_MASK                                 0x01                                                     
#define KBD_KEY_P1_1_PIN_MASK                                 0x02                                                     
#define KBD_KEY_P1_2_PIN_MASK                                 0x04                                                     
#define KBD_KEY_P1_3_PIN_MASK                                 0x08                                                     
#define KBD_KEY_P1_4_PIN_MASK                                 0x10                                                  
#define KBD_KEY_P1_5_PIN_MASK                                 0x20                                                  

//BitmaskTables for KBD_MULTI_KEY_STATUS
#define KBD_ROLLER_MASK                                       0x01                                                     


//STRUCTURES


//Definition for struct KBD_TEST_UI_KEY_T
typedef struct
            { 
             uint16_t     key_code;
             uint8_t      fillerbyte1;
             uint8_t      key_test_state;
            } __attribute__((packed)) KBD_TEST_UI_KEY_T_STR;
#define SIZE_KBD_TEST_UI_KEY_T                                sizeof(KBD_TEST_UI_KEY_T_STR)


//SUBBLOCKS


//Definition for struct KBD_ROLLER_KEY_INFO
#define KBD_ROLLER_KEY_INFO                                   0x00                                                     
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint8_t      direction;
             uint8_t      movement;
            } __attribute__((packed)) KBD_ROLLER_KEY_INFO_STR;
#define SIZE_KBD_ROLLER_KEY_INFO                              sizeof(KBD_ROLLER_KEY_INFO_STR)


//Definition for struct KBD_SINGLE_PRESS_KEY_EVENT_INFO
#define KBD_SINGLE_PRESS_KEY_EVENT_INFO                       0x01                                                     
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint16_t     key_code;
             uint8_t      state;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
            } __attribute__((packed)) KBD_SINGLE_PRESS_KEY_EVENT_INFO_STR;
#define SIZE_KBD_SINGLE_PRESS_KEY_EVENT_INFO                  sizeof(KBD_SINGLE_PRESS_KEY_EVENT_INFO_STR)


//Definition for struct KBD_ROTATOR_EVENT_INFO
#define KBD_ROTATOR_EVENT_INFO                                0x03                                                     
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint8_t      mode;
             uint8_t      direction;
             uint16_t     ticks;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) KBD_ROTATOR_EVENT_INFO_STR;
#define SIZE_KBD_ROTATOR_EVENT_INFO                           sizeof(KBD_ROTATOR_EVENT_INFO_STR)


//Definition for struct KBD_TEST_UI_KEY_RESULT
#define KBD_TEST_UI_KEY_RESULT                                0x02                                                     
typedef struct
            { 
             uint8_t      id;
             uint8_t      fillerbyte1;
             uint16_t     length;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
             uint16_t     number_of_keys;
             KBD_TEST_UI_KEY_T_STR    key_table[0];
            } __attribute__((packed)) KBD_TEST_UI_KEY_RESULT_STR;
#define SIZE_KBD_TEST_UI_KEY_RESULT                           sizeof(KBD_TEST_UI_KEY_RESULT_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct KBD_TEST_UI_ROTATOR_RESULT
#define KBD_TEST_UI_ROTATOR_RESULT                            0x04                                                     
typedef struct
            { 
             uint8_t      id;
             uint8_t      fillerbyte1;
             uint16_t     length;
             uint16_t     clockwise_ticks;
             uint16_t     anticlockwise_ticks;
            } __attribute__((packed)) KBD_TEST_UI_ROTATOR_RESULT_STR;
#define SIZE_KBD_TEST_UI_ROTATOR_RESULT                       sizeof(KBD_TEST_UI_ROTATOR_RESULT_STR)


//Definition for struct KBD_POINTING_DEVICE_INFO
#define KBD_POINTING_DEVICE_INFO                              0x05                                                     
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             int8_t       x_axis;
             int8_t       y_axis;
            } __attribute__((packed)) KBD_POINTING_DEVICE_INFO_STR;
#define SIZE_KBD_POINTING_DEVICE_INFO                         sizeof(KBD_POINTING_DEVICE_INFO_STR)


//Definition for struct KBD_CAPACITIVE_KEY_GLOBAL_SETTINGS
#define KBD_CAPACITIVE_KEY_GLOBAL_SETTINGS                    0x06                                                     
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint16_t     powermode;
             uint16_t     repetition_level;
             uint16_t     detector_integrator;
             uint16_t     key_filtering_level;
            } __attribute__((packed)) KBD_CAPACITIVE_KEY_GLOBAL_SETTINGS_STR;
#define SIZE_KBD_CAPACITIVE_KEY_GLOBAL_SETTINGS               sizeof(KBD_CAPACITIVE_KEY_GLOBAL_SETTINGS_STR)


//Definition for struct KBD_CAPACITIVE_KEY_TYPE1_SETTINGS
#define KBD_CAPACITIVE_KEY_TYPE1_SETTINGS                     0x07                                                     
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint8_t      key_index;
             uint8_t      matrix_burst_pulses;
             uint8_t      detect_threshold;
             uint8_t      aks_offset;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) KBD_CAPACITIVE_KEY_TYPE1_SETTINGS_STR;
#define SIZE_KBD_CAPACITIVE_KEY_TYPE1_SETTINGS                sizeof(KBD_CAPACITIVE_KEY_TYPE1_SETTINGS_STR)


//Definition for struct KBD_CAPACITIVE_KEY_TYPE2_SETTINGS
#define KBD_CAPACITIVE_KEY_TYPE2_SETTINGS                     0x08                                                     
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint8_t      stage_number;
             uint8_t      parameter_mask;
             uint16_t     stage_connection_low;
             uint16_t     stage_connection_high;
             uint16_t     afe_offset;
             uint16_t     sensitivity;
             uint16_t     offset_low;
             uint16_t     offset_high;
             uint16_t     offset_low_clamp;
             uint16_t     offset_high_clamp;
            } __attribute__((packed)) KBD_CAPACITIVE_KEY_TYPE2_SETTINGS_STR;
#define SIZE_KBD_CAPACITIVE_KEY_TYPE2_SETTINGS                sizeof(KBD_CAPACITIVE_KEY_TYPE2_SETTINGS_STR)


//Definition for struct KBD_RAW_DATA_INFO
#define KBD_RAW_DATA_INFO                                     0x09                                                     
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint16_t     high_byte;
             uint16_t     low_byte;
            } __attribute__((packed)) KBD_RAW_DATA_INFO_STR;
#define SIZE_KBD_RAW_DATA_INFO                                sizeof(KBD_RAW_DATA_INFO_STR)


//MESSAGES


//Definition for struct KBD_EVENT_IND
#define KBD_EVENT_IND                                         0x00                                                     
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      num_of_sub_blocks;
            } __attribute__((packed)) KBD_EVENT_IND_STR;
#define SIZE_KBD_EVENT_IND                                    sizeof(KBD_EVENT_IND_STR)


//Definition for struct KBD_ROTATOR_EVENT_IND
#define KBD_ROTATOR_EVENT_IND                                 0x22                                                  
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint8_t      mode;
             uint8_t      direction;
             uint16_t     ticks;
             uint16_t     angle;
            } __attribute__((packed)) KBD_ROTATOR_EVENT_IND_STR;
#define SIZE_KBD_ROTATOR_EVENT_IND                            sizeof(KBD_ROTATOR_EVENT_IND_STR)


//Definition for struct KBD_INFO_REQ
#define KBD_INFO_REQ                                          0x01                                                     
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) KBD_INFO_REQ_STR;
#define SIZE_KBD_INFO_REQ                                     sizeof(KBD_INFO_REQ_STR)


//Definition for struct KBD_INFO_RESP
#define KBD_INFO_RESP                                         0x02                                                     
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint8_t      kbd_devices;
             uint8_t      special_keys;
             uint8_t      special_keys_p0;
             uint8_t      special_keys_p1;
             uint8_t      multi_press_keys;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) KBD_INFO_RESP_STR;
#define SIZE_KBD_INFO_RESP                                    sizeof(KBD_INFO_RESP_STR)


//Definition for struct KBD_CONFIG_REQ
#define KBD_CONFIG_REQ                                        0x03                                                     
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) KBD_CONFIG_REQ_STR;
#define SIZE_KBD_CONFIG_REQ                                   sizeof(KBD_CONFIG_REQ_STR)


//Definition for struct KBD_CONFIG_RESP
#define KBD_CONFIG_RESP                                       0x04                                                     
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint8_t      kbd_devices;
             uint8_t      special_keys;
             uint8_t      special_keys_p0;
             uint8_t      special_keys_p1;
             uint8_t      multi_press_keys;
             uint8_t      num_of_soft_keys;
            } __attribute__((packed)) KBD_CONFIG_RESP_STR;
#define SIZE_KBD_CONFIG_RESP                                  sizeof(KBD_CONFIG_RESP_STR)


//Definition for struct KBD_ROTATOR_CONTROL_REQ
#define KBD_ROTATOR_CONTROL_REQ                               0x05                                                     
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint8_t      action;
             uint8_t      num_of_sub_blocks;
            } __attribute__((packed)) KBD_ROTATOR_CONTROL_REQ_STR;
#define SIZE_KBD_ROTATOR_CONTROL_REQ                          sizeof(KBD_ROTATOR_CONTROL_REQ_STR)


//Definition for struct KBD_ROTATOR_CONTROL_RESP
#define KBD_ROTATOR_CONTROL_RESP                              0x06                                                     
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      num_of_sub_blocks;
            } __attribute__((packed)) KBD_ROTATOR_CONTROL_RESP_STR;
#define SIZE_KBD_ROTATOR_CONTROL_RESP                         sizeof(KBD_ROTATOR_CONTROL_RESP_STR)


//Definition for struct KBD_CONTROL_REQ
#define KBD_CONTROL_REQ                                       0x07                                                     
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint8_t      action;
             uint8_t      num_of_sub_blocks;
            } __attribute__((packed)) KBD_CONTROL_REQ_STR;
#define SIZE_KBD_CONTROL_REQ                                  sizeof(KBD_CONTROL_REQ_STR)


//Definition for struct KBD_CONTROL_RESP
#define KBD_CONTROL_RESP                                      0x08                                                     
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      num_of_sub_blocks;
            } __attribute__((packed)) KBD_CONTROL_RESP_STR;
#define SIZE_KBD_CONTROL_RESP                                 sizeof(KBD_CONTROL_RESP_STR)


//Definition for struct KBD_PWR_KEY_CHECK_REQ
#define KBD_PWR_KEY_CHECK_REQ                                 0x0E                                                     
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) KBD_PWR_KEY_CHECK_REQ_STR;
#define SIZE_KBD_PWR_KEY_CHECK_REQ                            sizeof(KBD_PWR_KEY_CHECK_REQ_STR)


//Definition for struct KBD_PWR_KEY_CHECK_RESP
#define KBD_PWR_KEY_CHECK_RESP                                0x0F                                                     
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) KBD_PWR_KEY_CHECK_RESP_STR;
#define SIZE_KBD_PWR_KEY_CHECK_RESP                           sizeof(KBD_PWR_KEY_CHECK_RESP_STR)


//Definition for struct KBD_PWR_KEY_INFO_IND
#define KBD_PWR_KEY_INFO_IND                                  0x10                                                  
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) KBD_PWR_KEY_INFO_IND_STR;
#define SIZE_KBD_PWR_KEY_INFO_IND                             sizeof(KBD_PWR_KEY_INFO_IND_STR)


//Definition for struct KBD_EVENT_SIMULATION_REQ
#define KBD_EVENT_SIMULATION_REQ                              0x11                                                  
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      num_of_sub_blocks;
            } __attribute__((packed)) KBD_EVENT_SIMULATION_REQ_STR;
#define SIZE_KBD_EVENT_SIMULATION_REQ                         sizeof(KBD_EVENT_SIMULATION_REQ_STR)


//Definition for struct KBD_EVENT_SIMULATION_RESP
#define KBD_EVENT_SIMULATION_RESP                             0x12                                                  
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) KBD_EVENT_SIMULATION_RESP_STR;
#define SIZE_KBD_EVENT_SIMULATION_RESP                        sizeof(KBD_EVENT_SIMULATION_RESP_STR)


//Definition for struct KBD_TEST_REQ
#define KBD_TEST_REQ                                          0x15                                                  
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint8_t      action;
             uint8_t      num_of_sub_blocks;
            } __attribute__((packed)) KBD_TEST_REQ_STR;
#define SIZE_KBD_TEST_REQ                                     sizeof(KBD_TEST_REQ_STR)


//Definition for struct KBD_TEST_RESP
#define KBD_TEST_RESP                                         0x16                                                  
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      num_of_sub_blocks;
            } __attribute__((packed)) KBD_TEST_RESP_STR;
#define SIZE_KBD_TEST_RESP                                    sizeof(KBD_TEST_RESP_STR)


//Definition for struct KBD_BUFFERING_CONTROL_REQ
#define KBD_BUFFERING_CONTROL_REQ                             0x17                                                  
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint8_t      action;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) KBD_BUFFERING_CONTROL_REQ_STR;
#define SIZE_KBD_BUFFERING_CONTROL_REQ                        sizeof(KBD_BUFFERING_CONTROL_REQ_STR)


//Definition for struct KBD_BUFFERING_CONTROL_RESP
#define KBD_BUFFERING_CONTROL_RESP                            0x18                                                  
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) KBD_BUFFERING_CONTROL_RESP_STR;
#define SIZE_KBD_BUFFERING_CONTROL_RESP                       sizeof(KBD_BUFFERING_CONTROL_RESP_STR)


//Definition for struct KBD_BUFFERING_ACK_NTF
#define KBD_BUFFERING_ACK_NTF                                 0x19                                                  
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) KBD_BUFFERING_ACK_NTF_STR;
#define SIZE_KBD_BUFFERING_ACK_NTF                            sizeof(KBD_BUFFERING_ACK_NTF_STR)


//Definition for struct KBD_POINTING_DEVICE_CONTROL_REQ
#define KBD_POINTING_DEVICE_CONTROL_REQ                       0x23                                                  
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint8_t      action;
             uint8_t      num_of_sub_blocks;
            } __attribute__((packed)) KBD_POINTING_DEVICE_CONTROL_REQ_STR;
#define SIZE_KBD_POINTING_DEVICE_CONTROL_REQ                  sizeof(KBD_POINTING_DEVICE_CONTROL_REQ_STR)


//Definition for struct KBD_POINTING_DEVICE_CONTROL_RESP
#define KBD_POINTING_DEVICE_CONTROL_RESP                      0x24                                                  
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      num_of_sub_blocks;
            } __attribute__((packed)) KBD_POINTING_DEVICE_CONTROL_RESP_STR;
#define SIZE_KBD_POINTING_DEVICE_CONTROL_RESP                 sizeof(KBD_POINTING_DEVICE_CONTROL_RESP_STR)


//Definition for struct KBD_CAPACITIVE_KEY_CONTROL_REQ
#define KBD_CAPACITIVE_KEY_CONTROL_REQ                        0x25                                                  
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint16_t     num_of_sub_blocks;
            } __attribute__((packed)) KBD_CAPACITIVE_KEY_CONTROL_REQ_STR;
#define SIZE_KBD_CAPACITIVE_KEY_CONTROL_REQ                   sizeof(KBD_CAPACITIVE_KEY_CONTROL_REQ_STR)


//Definition for struct KBD_CAPACITIVE_KEY_CONTROL_RESP
#define KBD_CAPACITIVE_KEY_CONTROL_RESP                       0x26                                                  
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      num_of_sub_blocks;
            } __attribute__((packed)) KBD_CAPACITIVE_KEY_CONTROL_RESP_STR;
#define SIZE_KBD_CAPACITIVE_KEY_CONTROL_RESP                  sizeof(KBD_CAPACITIVE_KEY_CONTROL_RESP_STR)


//Definition for struct KBD_READ_RAW_DATA_REQ
#define KBD_READ_RAW_DATA_REQ                                 0x27                                                  
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint8_t      device_id;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) KBD_READ_RAW_DATA_REQ_STR;
#define SIZE_KBD_READ_RAW_DATA_REQ                            sizeof(KBD_READ_RAW_DATA_REQ_STR)


//Definition for struct KBD_READ_RAW_DATA_RESP
#define KBD_READ_RAW_DATA_RESP                                0x28                                                  
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      register_size;
             uint16_t     num_of_sub_blocks;
            } __attribute__((packed)) KBD_READ_RAW_DATA_RESP_STR;
#define SIZE_KBD_READ_RAW_DATA_RESP                           sizeof(KBD_READ_RAW_DATA_RESP_STR)


//Definition for struct KBD_POWER_CONTROL_REQ
#define KBD_POWER_CONTROL_REQ                                 0x29                                                  
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint8_t      device_id;
             uint8_t      power_mode;
            } __attribute__((packed)) KBD_POWER_CONTROL_REQ_STR;
#define SIZE_KBD_POWER_CONTROL_REQ                            sizeof(KBD_POWER_CONTROL_REQ_STR)


//Definition for struct KBD_POWER_CONTROL_RESP
#define KBD_POWER_CONTROL_RESP                                0x2A                                                  
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) KBD_POWER_CONTROL_RESP_STR;
#define SIZE_KBD_POWER_CONTROL_RESP                           sizeof(KBD_POWER_CONTROL_RESP_STR)

#endif
