#ifndef _PN_LIGHT_ISI_H_
#define _PN_LIGHT_ISI_H_

#include <stdint.h> 

//Resource Light Control Server
//PN_LIGHT 0x3A 
//ISI version 003.009
#define LIGHT_CONTROL_SERVER_ISI_VERSION_Z     3
#define LIGHT_CONTROL_SERVER_ISI_VERSION_Y     9

//In case of problems concerning content of this file contact Markku Loukusa, Sauli Laukka or Markus Mrsky
//Server specific message descriptions and feature&protocol descriptions can be found from: https://oucmswww.nmp.nokia.com:58443/document_browser/ccm_wa/GIF_SPECS/ 


//ISI VERSION CHANGE HISTORY

//Version: 003.009                                           
//Status: Approved                                          
//Date: 20-Oct-2008     Boerge Fischer
//Reason: SCO
//Reference: SWAM CR ID: BF08100745872, RM-RIM ID: 408-5003, APPROVED

//Version: 003.008                                           
//Status: Approved                                          
//Date: 11-Jun-2008     Ole Krogh
//Reason: SCO
//Reference: SWAM CR ID: OK08061041281, RM-RIM ID: 408-5104, APPROVED

//Version: 003.007                                           
//Status: Approved                                          
//Date: 10-Mar-2008     Ole Krogh
//Reason: SCO
//Reference: SWAM CR ID: OK08022636686, RM-RIM ID: 408-1801, APPROVED

//Version: 003.006                                           
//Status: Approved                                          
//Date: 15-Jan-2008     Jonas Rabbe
//Reason: SCO
//Reference: SWAM CR ID: JR07111952122, RM-RIM ID: 408-2435, APPROVED

//Version: 003.005                                           
//Status: Proposal                                          
//Date: 21-Dec-2006     Frede Nielsen
//Reason: SCO
//Reference: SWAM CR ID: SB06122037013, RM-RIM ID: 006-15502, PROPOSAL

//Version: 003.004                                           
//Status: Approved                                          
//Date: 19-Dec-2006     Boerge Fischer
//Reason: SCO
//Reference: SWAM CR ID: BF06121454920, RM-RIM ID: 006-15501, APPROVED

//Version: 003.003                                           
//Status: Approved                                          
//Date: 09-Oct-2006     Ole Krogh
//Reason: SCO
//Reference: SWAM ID: OK06072643555, RM-RIM ID: 006-12456, APPROVED

//Version: 003.002                                           
//Status: Approved                                          
//Date: 28-May-2006     Soeren Chr. Bisgaard
//Reason: SCO
//Reference: SWAM ID: SB06050851323, RM-RIM ID: 010-19627, APPROVED

//Version: 003.001                                           
//Status: Approved                                          
//Date: 06-Feb-2006     Soeren Chr. Bisgaard
//Reason: SCO
//Reference: SWAM ID: SB06012339777, RM-RIM ID: 006-10983, APPROVED

//Version: 003.000                                           
//Status: Approved                                          
//Date: 09-Jan-2006     Soeren Chr. Bisgaard
//Reason: SCO
//Reference: SWAM ID: SB05040128800 and SB05111428930, RM-RIM ID: 006-9513 and 006-10792, APPROVED

//Version: 002.000                                           
//Status: Approved                                          
//Date: 03-Oct-2005     Soeren Chr. Bisgaard
//Reason: SCO
//Reference: SWAM ID: SB05040128800, RM-RIM ID: 006-9513, APPROVED

//Version: 001.004                                           
//Status: Approved                                          
//Date: 13-Nov-2006     Ole Krogh
//Reason: SCO
//Reference: SWAM ID: OK06102439918, RM-RIM ID: 006-13908, APPROVED

//Version: 001.003                                           
//Status: Approved                                          
//Date: 07-Oct-2005     Robin Hansen
//Reason: SCO
//Reference: SWAM ID: RH05100654480, RM-RIM ID: 006-8862, APPROVED

//Version: 001.002                                           
//Status: Approved                                          
//Date: 03-Oct-2005     Soeren Chr. Bisgaard
//Reason: SCO
//Reference: SWAM ID: FJ05091543559, RM-RIM ID: 006-9541, APPROVED

//Version: 001.001                                           
//Status: Approved                                          
//Date: 03-May-2005     Soeren Chr. Bisgaard
//Reason: SCO
//Reference: SWAM ID: SB05041854225, RM tool ID: 006-5987 , APPROVED

//Version: 001.000                                           
//Status: NonDraft                                          
//Date: 24-May-2004     Jari Angeria
//Reason: SCO
//Reference: SWAM ID JA04051028756, RM tool ID: 010-4560 , NON-DRAFT

//Version: 000.022                                           
//Status: NonDraft                                          
//Date: 07-Apr-2004     Jari Angeria
//Reason: SCO
//Reference: SWAM ID JA04033145621, RM tool ID: 009-10601 , NON-DRAFT

//Version: 000.021                                           
//Status: NonDraft                                          
//Date: 09-Mar-2004     Jari Angeria
//Reason: SCO
//Reference: SWAM ID JA04030943237, RM tool ID: 009-10588 , NON-DRAFT

//Version: 000.020                                           
//Status: NonDraft                                          
//Date: 27-Jan-2004     Jari Angeria
//Reason: SCO
//Reference:  - , NON-DRAFT

//Version: 000.019                                           
//Status: NonDraft                                          
//Date: 03-Dec-2003     Jari Angeria
//Reason: SCO
//Reference: SWAM ID JA03100750035, RM tool ID: 009-5227 , NON-DRAFT

//Version: 000.018                                           
//Status: NonDraft                                          
//Date: 03-Dec-2003     Jari Angeria
//Reason: SCO
//Reference: SWAM ID JA03112740381, RM tool ID: 010-3148 , NON-DRAFT

//Version: 000.017                                           
//Status: NonDraft                                          
//Date: 03-Now-2003     Vesa Keranen
//Reason: Correction
//Reference: PCP Error DB: EH03110333251 , NON-DRAFT

//Version: 000.016                                           
//Status: NonDraft                                          
//Date: 20-Oct-2003     Vesa Keranen
//Reason: Correction
//Reference: SWAM Action DB ID: VK03100637037 , Comment ID: SM03101752021, NON-DRAFT

//Version: 000.015                                           
//Status: NonDraft                                          
//Date: 16-Oct-2003     Vesa Keranen
//Reason: Improvements
//Reference: -, NON-DRAFT

//Version: 000.014                                           
//Status: NonDraft                                          
//Date: 23-Sep-2003     Jari Angeria
//Reason: SCO
//Reference: SWAM ID JA03100750035, Continuus task ID 22954, RM tool ID: 009-411 , NON-DRAFT

//Version: 000.013                                           
//Status: NonDraft                                          
//Date: 23-Sep-2003     Jari Angeria
//Reason: Inspection
//Reference: LN ADB for SWAM:  Inspection Agenda JA0391152156, NON-DRAFT

//Version: 000.012                                           
//Status: NonDraft                                          
//Date: 26-Aug-2003     Jari Angeria
//Reason: Inspection
//Reference: SWAM CR ID: JA0306346046, NON-DRAFT

//Version: 000.011                                           
//Status: NonDraft                                          
//Date: 17-Feb-2003     Jari Angeria
//Reason: Inspection
//Reference: LN ADB for AD SW:JA03021737155, NON-DRAFT

//Version: 000.010                                           
//Status: NonDraft                                          
//Date: 21-Jan-2003     Jari Angeria
//Reason: Inspection
//Reference: LN ADB for AD SW:JA03011632487, NON-DRAFT

//Version: 000.009                                           
//Status: NonDraft                                          
//Date: 30-Sep-2002     Jari Angeria
//Reason: Inspection
//Reference: LN ADB for AD SW:JA02100147054, NON-DRAFT

//Version: 000.008                                           
//Status: NonDraft                                          
//Date: 16-Sep-2002     Jari Angeria
//Reason: Added ambient light ISI messages
//Reference: LN ADB for SWAM: JA02052835304, NON-DRAFT

//Version: 000.007                                           
//Status: NonDraft                                          
//Date: 28-Jun-2002     Jari Angeria
//Reason: Added Flashlight ISI messages 
//Reference: LN ADB for SWAM: JA02053143075, NON-DRAFT


//TABLES

//ConstantTable for LIGHT_CONTROL
#define LIGHT_ENABLE                                          0x01                                                     
#define LIGHT_DISABLE                                         0x02                                                     

//ConstantTable for LIGHT_TIMING
#define LIGHT_TIMED                                           0x01                                                     
#define LIGHT_NONTIMED                                        0x02                                                     

//ConstantTable for LIGHT_STATES_AND_MODES
#define LIGHT_ON                                              0x01                                                     
#define LIGHT_OFF                                             0x02                                                     
#define LIGHT_BLINK                                           0x03                                                     
#define LIGHT_PRIORITY_BLINK                                  0x04                                                     
#define LIGHT_SENSOR                                          0x05                                                     
#define LIGHT_CONTROLLABLE                                    0x06                                                     
#define LIGHT_UNCONTROLLABLE                                  0x07                                                     
#define LIGHT_MODE_NORMAL                                     0xA1                                                  
#define LIGHT_MODE_ON                                         0xA2                                                  

//ConstantTable for LIGHT_SENSOR_MODES
#define LIGHT_SENSOR_MODE_ALLWAYS_ON                          0xA3                                                  
#define LIGHT_SENSOR_MODE_BRIGHT                              0xA4                                                  
#define LIGHT_SENSOR_MODE_NORMAL                              0xA5                                                  
#define LIGHT_SENSOR_MODE_ECONOMY                             0xA6                                                  
#define LIGHT_SENSOR_MODE_ALLWAYS_OFF                         0xA7                                                  

//ConstantTable for LIGHT_ALC_TRIGGER_TYPE
#define LIGHT_ALC_TRIGGER_OFF                                 0x00                                                     
#define LIGHT_ALC_TRIGGER_OVER_LEVEL                          0x01                                                     
#define LIGHT_ALC_TRIGGER_UNDER_LEVEL                         0x02                                                     

//ConstantTable for LIGHT_ALC_HW_TYPE_INFO
#define LIGHT_ALC_HW_TYPE_NOT_SUPPORTED                       0x00                                                     
#define LIGHT_ALC_HW_TYPE_CHARLIE                             0x01                                                     
#define LIGHT_ALC_HW_TYPE_POLIWAG                             0x02                                                     

//ConstantTable for LIGHT_STATUS
#define LIGHT_OK                                              0x00                                                     
#define LIGHT_FAIL                                            0x01                                                     
#define LIGHT_CONTROL_FAILED                                  0x02                                                     
#define LIGHT_INTENSITY_FAILED                                0x03                                                     
#define LIGHT_DIM_FAILED                                      0x04                                                     
#define LIGHT_TIME_FAILED                                     0x05                                                     
#define LIGHT_BLINK_FAILED                                    0x06                                                     
#define LIGHT_SENSOR_FAILED                                   0x07                                                     
#define LIGHT_FLASHLIGHT_CONTROL_FAILED                       0x0B                                                     
#define LIGHT_FLASHLIGHT_TIME_FAILED                          0x0C                                                     
#define LIGHT_FLASHLIGHT_BLINK_FAILED                         0x0D                                                     
#define LIGHT_SENSOR_MODE_FAILED                              0x0E                                                     
#define LIGHT_LED_TEST_ONGOING_ERROR                          0x0F                                                     
#define LIGHT_LED_TEST_SEQ_RUN_ERROR                          0x10                                                  
#define LIGHT_LED_TEST_ADC_ERROR                              0x11                                                  

//ConstantTable for LIGHT_DISCO_TARGET
#define LIGHT_PATTERN                                         0x01                                                     
#define LIGHT_SEQUENCE                                        0x02                                                     
#define LIGHT_COLOUR                                          0x04                                                     

//ConstantTable for LIGHT_DISCO_PATTERN_STATE
#define DISCO_NORMAL                                          0x00                                                     
#define DISCO_1ST_RYTHMIC_SEQUENCE                            0x01                                                     
#define DISCO_2ST_RYTHMIC_SEQUENCE                            0x02                                                     

//ConstantTable for LIGHT_INFO_QUERY
#define LIGHT_INFO_QUERY_ONCE                                 0x00                                                     
#define LIGHT_INFO_QUERY_SUBSCRIBE                            0x01                                                     
#define LIGHT_INFO_QUERY_UNSUBSCRIBE                          0x02                                                     

//ConstantTable for LIGHT_TIMER_TYPE
#define LIGHT_TIMER_STRICT                                    0x01                                                     
#define LIGHT_TIMER_SLACK                                     0x02                                                     

//ConstantTable for LIGHT_SEQ_ACTION
#define LIGHT_SEQ_START                                       0x00                                                     
#define LIGHT_SEQ_START_NUM                                   0x01                                                     
#define LIGHT_SEQ_START_TIMED                                 0x02                                                     
#define LIGHT_SEQ_STOP                                        0xFF                                                  

//ConstantTable for LIGHT_LED_CURRENT_SELECT
#define LIGHT_LED_CURRENT_CONFIGURATION                       0x00                                                     
#define LIGHT_LED_CURRENT_RELATIVE                            0x01                                                     
#define LIGHT_LED_CURRENT_ABSOLUTE                            0x02                                                     

//BitmaskTables for LIGHT_SETTINGS
#define LIGHT_CONTROL_SETTING                                 0x00000001                                                     
#define LIGHT_TIME_SETTING                                    0x00000002                                                     
#define LIGHT_BLINK_SETTING                                   0x00000004                                                     
#define LIGHT_DIM_CONTROL_SETTING                             0x00000008                                                     
#define LIGHT_SENSOR_SETTING                                  0x00000010                                                  
#define LIGHT_DISPLAY_INTENSITY_SETTING                       0x00000020                                                  
#define LIGHT_KBD_INTENSITY_SETTING                           0x00000040                                                  
#define LIGHT_DISPLAY2_INTENSITY_SETTING                      0x00000080                                                  
#define LIGHT_FLASHLIGHT_CONTROL_SETTING                      0x00000400                                                   
#define LIGHT_FLASHLIGHT_TIME_SETTING                         0x00000800                                                   
#define LIGHT_FLASHLIGHT_BLINK_SETTING                        0x00001000                                                  
#define LIGHT_KBD2_INTENSITY_SETTING                          0x00002000                                                  
#define LIGHT_SENSOR_MODE_SETTING                             0x00004000                                                  
#define LIGHT_TIMER_SETTING                                   0x00008000                                                  

//BitmaskTables for LIGHT_TARGET
#define LIGHT_DISPLAY                                         0x01                                                     
#define LIGHT_KBD                                             0x02                                                     
#define LIGHT_DISPLAY2                                        0x04                                                     
#define LIGHT_KBD2                                            0x08                                                     
#define LIGHT_FLASHLIGHT                                      0x10                                                  
#define LIGHT_REC                                             0x20                                                  
#define LIGHT_EMAIL                                           0x40                                                  
#define LIGHT_TARGET_EXTEND                                   0x80                                                  

//BitmaskTables for LIGHT_TARGET2
#define LIGHT_INDICATOR_LED                                   0x01                                                     

//BitmaskTables for LIGHT_DISCO_PATTERN
#define LIGHT_DISCO_DISPLAY                                   0x00000001                                                     
#define LIGHT_DISCO_KBD                                       0x00000002                                                     
#define LIGHT_DISCO_KBD2                                      0x00000004                                                     
#define LIGHT_DISCO_LIGHT1                                    0x00000008                                                     
#define LIGHT_DISCO_LIGHT2                                    0x00000010                                                  
#define LIGHT_DISCO_LIGHT3                                    0x00000020                                                  
#define LIGHT_DISCO_LIGHT4                                    0x00000040                                                  
#define LIGHT_DISCO_LIGHT5                                    0x00000080                                                  
#define LIGHT_DISCO_LIGHT6                                    0x00000100                                                   
#define LIGHT_DISCO_LIGHT7                                    0x00000200                                                   
#define LIGHT_DISCO_LIGHT8                                    0x00000400                                                   
#define LIGHT_DISCO_LIGHT9                                    0x00000800                                                   
#define LIGHT_DISCO_LIGHT10                                   0x00001000                                                  
#define LIGHT_DISCO_LIGHT11                                   0x00002000                                                  
#define LIGHT_DISCO_LIGHT12                                   0x00004000                                                  
#define LIGHT_DISCO_LIGHT13                                   0x00008000                                                  
#define LIGHT_DISCO_LIGHT14                                   0x00010000                                                 
#define LIGHT_DISCO_LIGHT15                                   0x00020000                                                 
#define LIGHT_DISCO_LIGHT16                                   0x00040000                                                 
#define LIGHT_DISCO_LIGHT17                                   0x00080000                                                 
#define LIGHT_DISCO_LIGHT18                                   0x00100000                                                
#define LIGHT_DISCO_LIGHT19                                   0x00200000                                                
#define LIGHT_DISCO_LIGHT20                                   0x00400000                                                
#define LIGHT_DISCO_LIGHT21                                   0x00800000                                                
#define LIGHT_DISCO_LIGHT22                                   0x01000000                                               
#define LIGHT_DISCO_LIGHT23                                   0x02000000                                               
#define LIGHT_DISCO_LIGHT24                                   0x04000000                                               
#define LIGHT_DISCO_LIGHT25                                   0x08000000                                               
#define LIGHT_DISCO_LIGHT26                                   0x10000000                                            
#define LIGHT_DISCO_LIGHT27                                   0x20000000                                            
#define LIGHT_DISCO_LIGHT28                                   0x40000000                                            
#define LIGHT_DISCO_LIGHT29                                   0x80000000                                            

//BitmaskTables for LIGHT_CHANNELS
#define LIGHT_CHANNEL_01                                      0x00000001                                                     
#define LIGHT_CHANNEL_02                                      0x00000002                                                     
#define LIGHT_CHANNEL_03                                      0x00000004                                                     
#define LIGHT_CHANNEL_04                                      0x00000008                                                     
#define LIGHT_CHANNEL_05                                      0x00000010                                                  
#define LIGHT_CHANNEL_06                                      0x00000020                                                  
#define LIGHT_CHANNEL_07                                      0x00000040                                                  
#define LIGHT_CHANNEL_08                                      0x00000080                                                  
#define LIGHT_CHANNEL_09                                      0x00000100                                                   
#define LIGHT_CHANNEL_10                                      0x00000200                                                   
#define LIGHT_CHANNEL_11                                      0x00000400                                                   
#define LIGHT_CHANNEL_12                                      0x00000800                                                   
#define LIGHT_CHANNEL_13                                      0x00001000                                                  
#define LIGHT_CHANNEL_14                                      0x00002000                                                  
#define LIGHT_CHANNEL_15                                      0x00004000                                                  
#define LIGHT_CHANNEL_16                                      0x00008000                                                  
#define LIGHT_CHANNEL_17                                      0x00010000                                                 
#define LIGHT_CHANNEL_18                                      0x00020000                                                 
#define LIGHT_CHANNEL_19                                      0x00040000                                                 
#define LIGHT_CHANNEL_20                                      0x00080000                                                 
#define LIGHT_CHANNEL_21                                      0x00100000                                                
#define LIGHT_CHANNEL_22                                      0x00200000                                                
#define LIGHT_CHANNEL_23                                      0x00400000                                                
#define LIGHT_CHANNEL_24                                      0x00800000                                                
#define LIGHT_CHANNEL_25                                      0x01000000                                               
#define LIGHT_CHANNEL_26                                      0x02000000                                               
#define LIGHT_CHANNEL_27                                      0x04000000                                               
#define LIGHT_CHANNEL_28                                      0x08000000                                               
#define LIGHT_CHANNEL_29                                      0x10000000                                            
#define LIGHT_CHANNEL_30                                      0x20000000                                            
#define LIGHT_CHANNEL_31                                      0x40000000                                            
#define LIGHT_CHANNEL_32                                      0x80000000                                            

//BitmaskTables for LIGHT_CHANNELS2
#define LIGHT_CHANNEL_33                                      0x00000001                                                     
#define LIGHT_CHANNEL_34                                      0x00000002                                                     
#define LIGHT_CHANNEL_35                                      0x00000004                                                     
#define LIGHT_CHANNEL_36                                      0x00000008                                                     
#define LIGHT_CHANNEL_37                                      0x00000010                                                  
#define LIGHT_CHANNEL_38                                      0x00000020                                                  
#define LIGHT_CHANNEL_39                                      0x00000040                                                  
#define LIGHT_CHANNEL_40                                      0x00000080                                                  
#define LIGHT_CHANNEL_41                                      0x00000100                                                   
#define LIGHT_CHANNEL_42                                      0x00000200                                                   
#define LIGHT_CHANNEL_43                                      0x00000400                                                   
#define LIGHT_CHANNEL_44                                      0x00000800                                                   
#define LIGHT_CHANNEL_45                                      0x00001000                                                  
#define LIGHT_CHANNEL_46                                      0x00002000                                                  
#define LIGHT_CHANNEL_47                                      0x00004000                                                  
#define LIGHT_CHANNEL_48                                      0x00008000                                                  
#define LIGHT_CHANNEL_49                                      0x00010000                                                 
#define LIGHT_CHANNEL_50                                      0x00020000                                                 
#define LIGHT_CHANNEL_51                                      0x00040000                                                 
#define LIGHT_CHANNEL_52                                      0x00080000                                                 
#define LIGHT_CHANNEL_53                                      0x00100000                                                
#define LIGHT_CHANNEL_54                                      0x00200000                                                
#define LIGHT_CHANNEL_55                                      0x00400000                                                
#define LIGHT_CHANNEL_56                                      0x00800000                                                
#define LIGHT_CHANNEL_57                                      0x01000000                                               
#define LIGHT_CHANNEL_58                                      0x02000000                                               
#define LIGHT_CHANNEL_59                                      0x04000000                                               
#define LIGHT_CHANNEL_60                                      0x08000000                                               
#define LIGHT_CHANNEL_61                                      0x10000000                                            
#define LIGHT_CHANNEL_62                                      0x20000000                                            
#define LIGHT_CHANNEL_63                                      0x40000000                                            
#define LIGHT_CHANNEL_64                                      0x80000000                                            

//BitmaskTables for LIGHT_PARAMETERS
#define LIGHT_CONTROLLED_OFF                                  0x0001                                                     
#define LIGHT_CONTROLLED_INTENSITY                            0x0002                                                     
#define LIGHT_CONTROLLED_ALS                                  0x0004                                                     
#define LIGHT_CONTROLLED_BLINK                                0x0008                                                     
#define LIGHT_CONTROLLED_TIMER                                0x0010                                                  
#define LIGHT_CONTROLLED_SLOPE                                0x0020                                                  
#define LIGHT_CONTROLLED_FLEXYBLINK                           0x0040                                                  
#define LIGHT_CONTROLLED_SLOW_DIMMING                         0x0080                                                  
#define LIGHT_CONTROLLED_RGB_COLOUR                           0x0100                                                   
#define LIGHT_CONTROLLED_OFF_INTENSITY_FLEXYBLINK             0x0200                                                   

//BitmaskTables for LIGHT_INFO_TRIGGER
#define LIGHT_INFO_DATA_ACTIVITY                              0x00000001                                                     
#define LIGHT_INFO_DATA_INTENSITY                             0x00000002                                                     

//BitmaskTables for LIGHT_ACTIVE_ATTR
#define LIGHT_ATTR_INACTIVE                                   0x0001                                                     
#define LIGHT_ATTR_ACTIVE                                     0x0002                                                     
#define LIGHT_ATTR_ALS                                        0x0004                                                     
#define LIGHT_ATTR_BLINK                                      0x0008                                                     
#define LIGHT_ATTR_TIMER                                      0x0010                                                  
#define LIGHT_ATTR_FLEXYBLINK                                 0x0020                                                  
#define LIGHT_ATTR_OFF_INTENSITY_FLEXYBLINK                   0x0040                                                  

//BitmaskTables for LIGHT_CONF_QUERY
#define LIGHT_CONF_CHANNELS                                   0x01                                                     
#define LIGHT_CONF_NAMES                                      0x02                                                     

//BitmaskTables for LIGHT_SETTINGS_ACTION
#define LIGHT_SETTINGS_SET                                    0x01                                                     
#define LIGHT_SETTINGS_CLEAR                                  0x02                                                     

//BitmaskTables for LIGHT_SEQ_PARAMETER
#define LIGHT_SEQ_REPORT                                      0x01                                                     
#define LIGHT_SEQ_REVERSE                                     0x02                                                     

//BitmaskTables for LIGHT_SEQ_STATUS
#define LIGHT_SEQ_RUNNING                                     0x01                                                     
#define LIGHT_SEQ_STOPPED                                     0x02                                                     

//BitmaskTables for LIGHT_CALIBRATION_DATA
#define LIGHT_RGB_CALIBRATION                                 0x01                                                     

//ConstantTable for FtdTable
#define LIGHT_SB_FTD_ALC_LUM                                  0x1E                                                  
#define LIGHT_SB_FTD_ALC_CAL_VAL                              0x20                                                  
#define LIGHT_SB_FTD_ALC_TEMP_VAL                             0x21                                                  
#define LIGHT_SB_FTD_ALC_RAW_VAL                              0x22                                                  
#define LIGHT_SB_FTD_ALC_CALCONV                              0x23                                                  
#define LIGHT_SB_FTD_ALC_VCXOTEMP                             0x24                                                  


//SUBBLOCKS


//Definition for struct LIGHT_SB_CONTROL
#define LIGHT_SB_CONTROL                                      0x01                                                     
typedef struct
            { 
             uint8_t      sub_id;
             uint8_t      length;
             uint8_t      light_control;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) LIGHT_SB_CONTROL_STR;
#define SIZE_LIGHT_SB_CONTROL                                 sizeof(LIGHT_SB_CONTROL_STR)


//Definition for struct LIGHT_SB_DIM_CONTROL
#define LIGHT_SB_DIM_CONTROL                                  0x02                                                     
typedef struct
            { 
             uint8_t      sub_id;
             uint8_t      length;
             uint8_t      light_control;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) LIGHT_SB_DIM_CONTROL_STR;
#define SIZE_LIGHT_SB_DIM_CONTROL                             sizeof(LIGHT_SB_DIM_CONTROL_STR)


//Definition for struct LIGHT_SB_FLASHLIGHT_CONTROL
#define LIGHT_SB_FLASHLIGHT_CONTROL                           0x0B                                                     
typedef struct
            { 
             uint8_t      sub_id;
             uint8_t      length;
             uint8_t      light_control;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) LIGHT_SB_FLASHLIGHT_CONTROL_STR;
#define SIZE_LIGHT_SB_FLASHLIGHT_CONTROL                      sizeof(LIGHT_SB_FLASHLIGHT_CONTROL_STR)


//Definition for struct LIGHT_SB_DISPLAY_INTENSITY
#define LIGHT_SB_DISPLAY_INTENSITY                            0x03                                                     
typedef struct
            { 
             uint8_t      sub_id;
             uint8_t      length;
             uint8_t      intensity;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) LIGHT_SB_DISPLAY_INTENSITY_STR;
#define SIZE_LIGHT_SB_DISPLAY_INTENSITY                       sizeof(LIGHT_SB_DISPLAY_INTENSITY_STR)


//Definition for struct LIGHT_SB_KBD_INTENSITY
#define LIGHT_SB_KBD_INTENSITY                                0x04                                                     
typedef struct
            { 
             uint8_t      sub_id;
             uint8_t      length;
             uint8_t      intensity;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) LIGHT_SB_KBD_INTENSITY_STR;
#define SIZE_LIGHT_SB_KBD_INTENSITY                           sizeof(LIGHT_SB_KBD_INTENSITY_STR)


//Definition for struct LIGHT_SB_DISPLAY2_INTENSITY
#define LIGHT_SB_DISPLAY2_INTENSITY                           0x08                                                     
typedef struct
            { 
             uint8_t      sub_id;
             uint8_t      length;
             uint8_t      intensity;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) LIGHT_SB_DISPLAY2_INTENSITY_STR;
#define SIZE_LIGHT_SB_DISPLAY2_INTENSITY                      sizeof(LIGHT_SB_DISPLAY2_INTENSITY_STR)


//Definition for struct LIGHT_SB_KBD2_INTENSITY
#define LIGHT_SB_KBD2_INTENSITY                               0x0E                                                     
typedef struct
            { 
             uint8_t      sub_id;
             uint8_t      length;
             uint8_t      intensity;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) LIGHT_SB_KBD2_INTENSITY_STR;
#define SIZE_LIGHT_SB_KBD2_INTENSITY                          sizeof(LIGHT_SB_KBD2_INTENSITY_STR)


//Definition for struct LIGHT_SB_TIME
#define LIGHT_SB_TIME                                         0x05                                                     
typedef struct
            { 
             uint8_t      sub_id;
             uint8_t      length;
             uint8_t      light_timing_setting;
             uint8_t      lights_on_time;
            } __attribute__((packed)) LIGHT_SB_TIME_STR;
#define SIZE_LIGHT_SB_TIME                                    sizeof(LIGHT_SB_TIME_STR)


//Definition for struct LIGHT_SB_FLASHLIGHT_TIME
#define LIGHT_SB_FLASHLIGHT_TIME                              0x0C                                                     
typedef struct
            { 
             uint8_t      sub_id;
             uint8_t      length;
             uint8_t      light_timing_setting;
             uint8_t      lights_on_time;
            } __attribute__((packed)) LIGHT_SB_FLASHLIGHT_TIME_STR;
#define SIZE_LIGHT_SB_FLASHLIGHT_TIME                         sizeof(LIGHT_SB_FLASHLIGHT_TIME_STR)


//Definition for struct LIGHT_SB_BLINK
#define LIGHT_SB_BLINK                                        0x06                                                     
typedef struct
            { 
             uint8_t      sub_id;
             uint8_t      length;
             uint8_t      blink_on_time;
             uint8_t      blink_off_time;
            } __attribute__((packed)) LIGHT_SB_BLINK_STR;
#define SIZE_LIGHT_SB_BLINK                                   sizeof(LIGHT_SB_BLINK_STR)


//Definition for struct LIGHT_SB_FLASHLIGHT_BLINK
#define LIGHT_SB_FLASHLIGHT_BLINK                             0x0D                                                     
typedef struct
            { 
             uint8_t      sub_id;
             uint8_t      length;
             uint8_t      blink_on_time;
             uint8_t      blink_off_time;
            } __attribute__((packed)) LIGHT_SB_FLASHLIGHT_BLINK_STR;
#define SIZE_LIGHT_SB_FLASHLIGHT_BLINK                        sizeof(LIGHT_SB_FLASHLIGHT_BLINK_STR)


//Definition for struct LIGHT_SB_SENSOR
#define LIGHT_SB_SENSOR                                       0x07                                                     
typedef struct
            { 
             uint8_t      sub_id;
             uint8_t      length;
             uint8_t      alc_threshold_lightsoff;
             uint8_t      alc_threshold_lightson;
            } __attribute__((packed)) LIGHT_SB_SENSOR_STR;
#define SIZE_LIGHT_SB_SENSOR                                  sizeof(LIGHT_SB_SENSOR_STR)


//Definition for struct LIGHT_SB_DISCO_COLOUR
#define LIGHT_SB_DISCO_COLOUR                                 0x0F                                                     
typedef struct
            { 
             uint8_t      sub_id;
             uint8_t      length;
             uint8_t      location;
             uint8_t      location_colour;
             uint8_t      location_intensity;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
            } __attribute__((packed)) LIGHT_SB_DISCO_COLOUR_STR;
#define SIZE_LIGHT_SB_DISCO_COLOUR                            sizeof(LIGHT_SB_DISCO_COLOUR_STR)


//Definition for struct LIGHT_SB_SENSOR_MODE
#define LIGHT_SB_SENSOR_MODE                                  0x10                                                  
typedef struct
            { 
             uint8_t      sub_id;
             uint8_t      length;
             uint8_t      sensor_mode;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) LIGHT_SB_SENSOR_MODE_STR;
#define SIZE_LIGHT_SB_SENSOR_MODE                             sizeof(LIGHT_SB_SENSOR_MODE_STR)


//Definition for struct LIGHT_SB_TRIGGER_REPEAT
#define LIGHT_SB_TRIGGER_REPEAT                               0x11                                                  
typedef struct
            { 
             uint8_t      sub_id;
             uint8_t      length;
             uint16_t     min_trigger_time;
             uint16_t     max_trigger_time;
             uint16_t     reserved1;
            } __attribute__((packed)) LIGHT_SB_TRIGGER_REPEAT_STR;
#define SIZE_LIGHT_SB_TRIGGER_REPEAT                          sizeof(LIGHT_SB_TRIGGER_REPEAT_STR)


//Definition for struct LIGHT_SB_INTENSITY
#define LIGHT_SB_INTENSITY                                    0x12                                                  
typedef struct
            { 
             uint8_t      sub_id;
             uint8_t      length;
             uint16_t     light_intensity_level;
            } __attribute__((packed)) LIGHT_SB_INTENSITY_STR;
#define SIZE_LIGHT_SB_INTENSITY                               sizeof(LIGHT_SB_INTENSITY_STR)


//Definition for struct LIGHT_SB_TIMER
#define LIGHT_SB_TIMER                                        0x13                                                  
typedef struct
            { 
             uint8_t      sub_id;
             uint8_t      length;
             uint16_t     light_on_time;
            } __attribute__((packed)) LIGHT_SB_TIMER_STR;
#define SIZE_LIGHT_SB_TIMER                                   sizeof(LIGHT_SB_TIMER_STR)


//Definition for struct LIGHT_SB_SLOPE
#define LIGHT_SB_SLOPE                                        0x14                                                  
typedef struct
            { 
             uint8_t      sub_id;
             uint8_t      length;
             uint16_t     slope_step_size_rising_edge;
             uint16_t     slope_step_time_rising_edge;
             uint16_t     slope_step_size_falling_edge;
             uint16_t     slope_step_time_falling_edge;
             uint16_t     fillerbyte1;
            } __attribute__((packed)) LIGHT_SB_SLOPE_STR;
#define SIZE_LIGHT_SB_SLOPE                                   sizeof(LIGHT_SB_SLOPE_STR)


//Definition for struct LIGHT_SB_CHANNELS
#define LIGHT_SB_CHANNELS                                     0x15                                                  
typedef struct
            { 
             uint8_t      sub_id;
             uint8_t      length;
             uint16_t     fillerbyte1;
             uint32_t     conf_channels2;
             uint32_t     conf_channels;
            } __attribute__((packed)) LIGHT_SB_CHANNELS_STR;
#define SIZE_LIGHT_SB_CHANNELS                                sizeof(LIGHT_SB_CHANNELS_STR)


//Definition for struct LIGHT_SB_CONF_NAMES
#define LIGHT_SB_CONF_NAMES                                   0x16                                                  
typedef struct
            { 
             uint8_t      sub_id;
             uint8_t      length;
             uint8_t      channel_num;
             uint8_t      fillerbyte1;
             uint8_t      channel_name[12];
            } __attribute__((packed)) LIGHT_SB_CONF_NAMES_STR;
#define SIZE_LIGHT_SB_CONF_NAMES                              sizeof(LIGHT_SB_CONF_NAMES_STR)


//Definition for struct LIGHT_SB_FLEXYBLINK
#define LIGHT_SB_FLEXYBLINK                                   0x17                                                  
typedef struct
            { 
             uint8_t      sub_id;
             uint8_t      length;
             uint8_t      blink_on_timer_type;
             uint8_t      blink_off_timer_type;
             uint16_t     blink_on_duration;
             uint16_t     blink_off_duration;
            } __attribute__((packed)) LIGHT_SB_FLEXYBLINK_STR;
#define SIZE_LIGHT_SB_FLEXYBLINK                              sizeof(LIGHT_SB_FLEXYBLINK_STR)


//Definition for struct LIGHT_SB_SLOW_DIMMING
#define LIGHT_SB_SLOW_DIMMING                                 0x18                                                  
typedef struct
            { 
             uint8_t      sub_id;
             uint8_t      length;
             uint16_t     slope_step_size_slow_dimming_edge;
             uint16_t     slope_step_time_slow_dimming_edge;
             uint8_t      relative_slow_dimming_intensity_level;
             uint8_t      fillerbyte1;
             uint16_t     slow_dimming_time;
             uint16_t     fillerbyte2;
            } __attribute__((packed)) LIGHT_SB_SLOW_DIMMING_STR;
#define SIZE_LIGHT_SB_SLOW_DIMMING                            sizeof(LIGHT_SB_SLOW_DIMMING_STR)


//Definition for struct LIGHT_SB_RGB_COLOUR
#define LIGHT_SB_RGB_COLOUR                                   0x19                                                  
typedef struct
            { 
             uint8_t      sub_id;
             uint8_t      length;
             uint8_t      red_intensity;
             uint8_t      green_intensity;
             uint8_t      blue_intensity;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
            } __attribute__((packed)) LIGHT_SB_RGB_COLOUR_STR;
#define SIZE_LIGHT_SB_RGB_COLOUR                              sizeof(LIGHT_SB_RGB_COLOUR_STR)


//Definition for struct LIGHT_SB_RGB_CALIBRATION_DATA
#define LIGHT_SB_RGB_CALIBRATION_DATA                         0x20                                                  
typedef struct
            { 
             uint8_t      sub_id;
             uint8_t      length;
             uint8_t      channel_number;
             uint8_t      fillerbyte1;
             uint16_t     red_wavelength;
             uint16_t     red_intensity;
             uint16_t     green_wavelength;
             uint16_t     green_intensity;
             uint16_t     blue_wavelength;
             uint16_t     blue_intensity;
            } __attribute__((packed)) LIGHT_SB_RGB_CALIBRATION_DATA_STR;
#define SIZE_LIGHT_SB_RGB_CALIBRATION_DATA                    sizeof(LIGHT_SB_RGB_CALIBRATION_DATA_STR)


//Definition for struct LIGHT_SB_OFF_INTENSITY_FLEXYBLINK
#define LIGHT_SB_OFF_INTENSITY_FLEXYBLINK                     0x21                                                  
typedef struct
            { 
             uint8_t      sub_id;
             uint8_t      length;
             uint8_t      blink_on_timer_type;
             uint8_t      blink_off_timer_type;
             uint16_t     blink_on_duration;
             uint16_t     blink_off_duration;
             uint16_t     blink_off_intensity_level;
             uint16_t     fillerbyte1;
            } __attribute__((packed)) LIGHT_SB_OFF_INTENSITY_FLEXYBLINK_STR;
#define SIZE_LIGHT_SB_OFF_INTENSITY_FLEXYBLINK                sizeof(LIGHT_SB_OFF_INTENSITY_FLEXYBLINK_STR)


//Definition for struct LIGHT_SB_LYSTI_LED_TEST_CURRENT
#define LIGHT_SB_LYSTI_LED_TEST_CURRENT                       0x22                                                  
typedef struct
            { 
             uint8_t      sub_id;
             uint8_t      length;
             uint8_t      led_cur_d1;
             uint8_t      led_cur_d2;
             uint8_t      led_cur_d3;
             uint8_t      led_cur_d4;
             uint8_t      led_cur_d5;
             uint8_t      led_cur_d6;
             uint8_t      led_cur_d7;
             uint8_t      led_cur_d8;
             uint8_t      led_cur_d9;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) LIGHT_SB_LYSTI_LED_TEST_CURRENT_STR;
#define SIZE_LIGHT_SB_LYSTI_LED_TEST_CURRENT                  sizeof(LIGHT_SB_LYSTI_LED_TEST_CURRENT_STR)


//Definition for struct LIGHT_SB_LYSTI_LED_TEST_RESULT
#define LIGHT_SB_LYSTI_LED_TEST_RESULT                        0x23                                                  
typedef struct
            { 
             uint8_t      sub_id;
             uint8_t      length;
             int16_t      led_on_mv_d1;
             int16_t      led_on_mv_d2;
             int16_t      led_on_mv_d3;
             int16_t      led_on_mv_d4;
             int16_t      led_on_mv_d5;
             int16_t      led_on_mv_d6;
             int16_t      led_on_mv_d7;
             int16_t      led_on_mv_d8;
             int16_t      led_on_mv_d9;
             int16_t      led_off_mv_d1;
             int16_t      led_off_mv_d2;
             int16_t      led_off_mv_d3;
             int16_t      led_off_mv_d4;
             int16_t      led_off_mv_d5;
             int16_t      led_off_mv_d6;
             int16_t      led_off_mv_d7;
             int16_t      led_off_mv_d8;
             int16_t      led_off_mv_d9;
             int16_t      supply_voltage_vdd_mv;
             int16_t      charge_pump_vout_mv_off_mode;
             int16_t      charge_pump_vout_mv_1x_mode;
             int16_t      charge_pump_vout_mv_1_5x_mode;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) LIGHT_SB_LYSTI_LED_TEST_RESULT_STR;
#define SIZE_LIGHT_SB_LYSTI_LED_TEST_RESULT                   sizeof(LIGHT_SB_LYSTI_LED_TEST_RESULT_STR)


//MESSAGES


//Definition for struct LIGHT_SETTINGS_READ_REQ
#define LIGHT_SETTINGS_READ_REQ                               0x01                                                     
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint32_t     light_setting;
            } __attribute__((packed)) LIGHT_SETTINGS_READ_REQ_STR;
#define SIZE_LIGHT_SETTINGS_READ_REQ                          sizeof(LIGHT_SETTINGS_READ_REQ_STR)


//Definition for struct LIGHT_SETTINGS_READ_RESP
#define LIGHT_SETTINGS_READ_RESP                              0x02                                                     
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint8_t      op_status;
             uint8_t      num_of_sub;
            } __attribute__((packed)) LIGHT_SETTINGS_READ_RESP_STR;
#define SIZE_LIGHT_SETTINGS_READ_RESP                         sizeof(LIGHT_SETTINGS_READ_RESP_STR)


//Definition for struct LIGHT_SETTINGS_WRITE_REQ
#define LIGHT_SETTINGS_WRITE_REQ                              0x03                                                     
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      num_of_sub;
            } __attribute__((packed)) LIGHT_SETTINGS_WRITE_REQ_STR;
#define SIZE_LIGHT_SETTINGS_WRITE_REQ                         sizeof(LIGHT_SETTINGS_WRITE_REQ_STR)


//Definition for struct LIGHT_SETTINGS_WRITE_RESP
#define LIGHT_SETTINGS_WRITE_RESP                             0x04                                                     
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint8_t      op_status;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) LIGHT_SETTINGS_WRITE_RESP_STR;
#define SIZE_LIGHT_SETTINGS_WRITE_RESP                        sizeof(LIGHT_SETTINGS_WRITE_RESP_STR)


//Definition for struct LIGHT_CONTROL_REQ
#define LIGHT_CONTROL_REQ                                     0x05                                                     
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint8_t      control_target;
             uint8_t      light_state;
             uint8_t      control_target2;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      num_of_sub;
            } __attribute__((packed)) LIGHT_CONTROL_REQ_STR;
#define SIZE_LIGHT_CONTROL_REQ                                sizeof(LIGHT_CONTROL_REQ_STR)


//Definition for struct LIGHT_CONTROL_RESP
#define LIGHT_CONTROL_RESP                                    0x06                                                     
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint8_t      op_status;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) LIGHT_CONTROL_RESP_STR;
#define SIZE_LIGHT_CONTROL_RESP                               sizeof(LIGHT_CONTROL_RESP_STR)


//Definition for struct LIGHT_STATUS_CHANGED_IND
#define LIGHT_STATUS_CHANGED_IND                              0x07                                                     
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint8_t      control_target;
             uint8_t      light_state;
            } __attribute__((packed)) LIGHT_STATUS_CHANGED_IND_STR;
#define SIZE_LIGHT_STATUS_CHANGED_IND                         sizeof(LIGHT_STATUS_CHANGED_IND_STR)


//Definition for struct LIGHT_ALC_READ_REQ
#define LIGHT_ALC_READ_REQ                                    0x08                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) LIGHT_ALC_READ_REQ_STR;
#define SIZE_LIGHT_ALC_READ_REQ                               sizeof(LIGHT_ALC_READ_REQ_STR)


//Definition for struct LIGHT_ALC_READ_RESP
#define LIGHT_ALC_READ_RESP                                   0x09                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint16_t     luminance;
            } __attribute__((packed)) LIGHT_ALC_READ_RESP_STR;
#define SIZE_LIGHT_ALC_READ_RESP                              sizeof(LIGHT_ALC_READ_RESP_STR)


//Definition for struct LIGHT_ALC_CALIB_REQ
#define LIGHT_ALC_CALIB_REQ                                   0x0E                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             int16_t      ref_level;
            } __attribute__((packed)) LIGHT_ALC_CALIB_REQ_STR;
#define SIZE_LIGHT_ALC_CALIB_REQ                              sizeof(LIGHT_ALC_CALIB_REQ_STR)


//Definition for struct LIGHT_ALC_CALIB_RESP
#define LIGHT_ALC_CALIB_RESP                                  0x0F                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             int16_t      start_level;
             uint16_t     cal_conv;
             uint16_t     iphoto;
            } __attribute__((packed)) LIGHT_ALC_CALIB_RESP_STR;
#define SIZE_LIGHT_ALC_CALIB_RESP                             sizeof(LIGHT_ALC_CALIB_RESP_STR)


//Definition for struct LIGHT_ALC_POLIWAG_CALIB_REQ
#define LIGHT_ALC_POLIWAG_CALIB_REQ                           0x2F                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint16_t     fillerbyte1;
             uint32_t     ref_level;
            } __attribute__((packed)) LIGHT_ALC_POLIWAG_CALIB_REQ_STR;
#define SIZE_LIGHT_ALC_POLIWAG_CALIB_REQ                      sizeof(LIGHT_ALC_POLIWAG_CALIB_REQ_STR)


//Definition for struct LIGHT_ALC_POLIWAG_CALIB_RESP
#define LIGHT_ALC_POLIWAG_CALIB_RESP                          0x30                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             int16_t      start_level;
             uint32_t     cal_conv;
             uint32_t     iphoto;
            } __attribute__((packed)) LIGHT_ALC_POLIWAG_CALIB_RESP_STR;
#define SIZE_LIGHT_ALC_POLIWAG_CALIB_RESP                     sizeof(LIGHT_ALC_POLIWAG_CALIB_RESP_STR)


//Definition for struct LIGHT_ALC_HW_TYPE_REQ
#define LIGHT_ALC_HW_TYPE_REQ                                 0x2D                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint16_t     fillerbyte1;
            } __attribute__((packed)) LIGHT_ALC_HW_TYPE_REQ_STR;
#define SIZE_LIGHT_ALC_HW_TYPE_REQ                            sizeof(LIGHT_ALC_HW_TYPE_REQ_STR)


//Definition for struct LIGHT_ALC_HW_TYPE_RESP
#define LIGHT_ALC_HW_TYPE_RESP                                0x2E                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      light_alc_hw_type;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) LIGHT_ALC_HW_TYPE_RESP_STR;
#define SIZE_LIGHT_ALC_HW_TYPE_RESP                           sizeof(LIGHT_ALC_HW_TYPE_RESP_STR)


//Definition for struct LIGHT_ALC_TUNE_REQ
#define LIGHT_ALC_TUNE_REQ                                    0x0A                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             int8_t       user_diff;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) LIGHT_ALC_TUNE_REQ_STR;
#define SIZE_LIGHT_ALC_TUNE_REQ                               sizeof(LIGHT_ALC_TUNE_REQ_STR)


//Definition for struct LIGHT_ALC_TUNE_RESP
#define LIGHT_ALC_TUNE_RESP                                   0x0B                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) LIGHT_ALC_TUNE_RESP_STR;
#define SIZE_LIGHT_ALC_TUNE_RESP                              sizeof(LIGHT_ALC_TUNE_RESP_STR)


//Definition for struct LIGHT_ALC_TRIGGER_REQ
#define LIGHT_ALC_TRIGGER_REQ                                 0x0C                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             int8_t       trigger_level;
             uint8_t      trigger_type;
            } __attribute__((packed)) LIGHT_ALC_TRIGGER_REQ_STR;
#define SIZE_LIGHT_ALC_TRIGGER_REQ                            sizeof(LIGHT_ALC_TRIGGER_REQ_STR)


//Definition for struct LIGHT_ALC_TRIGGER_RESP
#define LIGHT_ALC_TRIGGER_RESP                                0x0D                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) LIGHT_ALC_TRIGGER_RESP_STR;
#define SIZE_LIGHT_ALC_TRIGGER_RESP                           sizeof(LIGHT_ALC_TRIGGER_RESP_STR)


//Definition for struct LIGHT_ALC_TRIGGER_IND
#define LIGHT_ALC_TRIGGER_IND                                 0x10                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      trigger_info;
             uint8_t      luminance;
            } __attribute__((packed)) LIGHT_ALC_TRIGGER_IND_STR;
#define SIZE_LIGHT_ALC_TRIGGER_IND                            sizeof(LIGHT_ALC_TRIGGER_IND_STR)


//Definition for struct LIGHT_ALC_RC_CALIB_REQ
#define LIGHT_ALC_RC_CALIB_REQ                                0x1A                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) LIGHT_ALC_RC_CALIB_REQ_STR;
#define SIZE_LIGHT_ALC_RC_CALIB_REQ                           sizeof(LIGHT_ALC_RC_CALIB_REQ_STR)


//Definition for struct LIGHT_ALC_RC_CALIB_RESP
#define LIGHT_ALC_RC_CALIB_RESP                               0x1B                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             int16_t      start_level;
             uint8_t      resistor_correction;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
             uint32_t     resistance;
            } __attribute__((packed)) LIGHT_ALC_RC_CALIB_RESP_STR;
#define SIZE_LIGHT_ALC_RC_CALIB_RESP                          sizeof(LIGHT_ALC_RC_CALIB_RESP_STR)


//Definition for struct LIGHT_ALC_SAVE_CALIB_VALUE_REQ
#define LIGHT_ALC_SAVE_CALIB_VALUE_REQ                        0x1C                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      target;
             uint8_t      save_value;
            } __attribute__((packed)) LIGHT_ALC_SAVE_CALIB_VALUE_REQ_STR;
#define SIZE_LIGHT_ALC_SAVE_CALIB_VALUE_REQ                   sizeof(LIGHT_ALC_SAVE_CALIB_VALUE_REQ_STR)


//Definition for struct LIGHT_ALC_SAVE_CALIB_VALUE_RESP
#define LIGHT_ALC_SAVE_CALIB_VALUE_RESP                       0x1D                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) LIGHT_ALC_SAVE_CALIB_VALUE_RESP_STR;
#define SIZE_LIGHT_ALC_SAVE_CALIB_VALUE_RESP                  sizeof(LIGHT_ALC_SAVE_CALIB_VALUE_RESP_STR)


//Definition for struct LIGHT_DISCO_ENABLE_REQ
#define LIGHT_DISCO_ENABLE_REQ                                0x11                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      target;
             uint8_t      action;
            } __attribute__((packed)) LIGHT_DISCO_ENABLE_REQ_STR;
#define SIZE_LIGHT_DISCO_ENABLE_REQ                           sizeof(LIGHT_DISCO_ENABLE_REQ_STR)


//Definition for struct LIGHT_DISCO_ENABLE_RESP
#define LIGHT_DISCO_ENABLE_RESP                               0x12                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) LIGHT_DISCO_ENABLE_RESP_STR;
#define SIZE_LIGHT_DISCO_ENABLE_RESP                          sizeof(LIGHT_DISCO_ENABLE_RESP_STR)


//Definition for struct LIGHT_DISCO_PATTERN_REQ
#define LIGHT_DISCO_PATTERN_REQ                               0x13                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      intensity;
             uint8_t      pattern_state;
             uint32_t     pattern;
            } __attribute__((packed)) LIGHT_DISCO_PATTERN_REQ_STR;
#define SIZE_LIGHT_DISCO_PATTERN_REQ                          sizeof(LIGHT_DISCO_PATTERN_REQ_STR)


//Definition for struct LIGHT_DISCO_PATTERN_RESP
#define LIGHT_DISCO_PATTERN_RESP                              0x14                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) LIGHT_DISCO_PATTERN_RESP_STR;
#define SIZE_LIGHT_DISCO_PATTERN_RESP                         sizeof(LIGHT_DISCO_PATTERN_RESP_STR)


//Definition for struct LIGHT_DISCO_SEQUENCE_REQ
#define LIGHT_DISCO_SEQUENCE_REQ                              0x15                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      sequence_nro;
             uint8_t      action;
             uint16_t     time;
             uint8_t      multiplier;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) LIGHT_DISCO_SEQUENCE_REQ_STR;
#define SIZE_LIGHT_DISCO_SEQUENCE_REQ                         sizeof(LIGHT_DISCO_SEQUENCE_REQ_STR)


//Definition for struct LIGHT_DISCO_SEQUENCE_RESP
#define LIGHT_DISCO_SEQUENCE_RESP                             0x16                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) LIGHT_DISCO_SEQUENCE_RESP_STR;
#define SIZE_LIGHT_DISCO_SEQUENCE_RESP                        sizeof(LIGHT_DISCO_SEQUENCE_RESP_STR)


//Definition for struct LIGHT_DISCO_SEQUENCE_IND
#define LIGHT_DISCO_SEQUENCE_IND                              0x17                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      seq_state;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) LIGHT_DISCO_SEQUENCE_IND_STR;
#define SIZE_LIGHT_DISCO_SEQUENCE_IND                         sizeof(LIGHT_DISCO_SEQUENCE_IND_STR)


//Definition for struct LIGHT_DISCO_COLOUR_REQ
#define LIGHT_DISCO_COLOUR_REQ                                0x18                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      num_of_sub;
            } __attribute__((packed)) LIGHT_DISCO_COLOUR_REQ_STR;
#define SIZE_LIGHT_DISCO_COLOUR_REQ                           sizeof(LIGHT_DISCO_COLOUR_REQ_STR)


//Definition for struct LIGHT_DISCO_COLOUR_RESP
#define LIGHT_DISCO_COLOUR_RESP                               0x19                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      failed_sb;
            } __attribute__((packed)) LIGHT_DISCO_COLOUR_RESP_STR;
#define SIZE_LIGHT_DISCO_COLOUR_RESP                          sizeof(LIGHT_DISCO_COLOUR_RESP_STR)


//Definition for struct LIGHT_CHANNEL_REQ
#define LIGHT_CHANNEL_REQ                                     0x20                                                  
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint16_t     fillerbyte1;
             uint32_t     control_channels2;
             uint32_t     control_channels;
             uint16_t     light_attributes;
             uint8_t      fillerbyte2;
             uint8_t      num_of_subblocks;
            } __attribute__((packed)) LIGHT_CHANNEL_REQ_STR;
#define SIZE_LIGHT_CHANNEL_REQ                                sizeof(LIGHT_CHANNEL_REQ_STR)


//Definition for struct LIGHT_CHANNEL_RESP
#define LIGHT_CHANNEL_RESP                                    0x21                                                  
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint8_t      light_status;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) LIGHT_CHANNEL_RESP_STR;
#define SIZE_LIGHT_CHANNEL_RESP                               sizeof(LIGHT_CHANNEL_RESP_STR)


//Definition for struct LIGHT_INFO_QUERY_REQ
#define LIGHT_INFO_QUERY_REQ                                  0x1E                                                  
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      action;
             uint32_t     control_channels2;
             uint32_t     control_channels;
             uint32_t     trigger;
            } __attribute__((packed)) LIGHT_INFO_QUERY_REQ_STR;
#define SIZE_LIGHT_INFO_QUERY_REQ                             sizeof(LIGHT_INFO_QUERY_REQ_STR)


//Definition for struct LIGHT_INFO_QUERY_RESP
#define LIGHT_INFO_QUERY_RESP                                 0x1F                                                  
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint8_t      light_status;
             uint8_t      action;
             uint8_t      fillerbyte1;
             uint8_t      channel_num;
             uint16_t     active_attributes;
             uint16_t     light_intensity;
             uint16_t     fillerbyte2;
            } __attribute__((packed)) LIGHT_INFO_QUERY_RESP_STR;
#define SIZE_LIGHT_INFO_QUERY_RESP                            sizeof(LIGHT_INFO_QUERY_RESP_STR)


//Definition for struct LIGHT_CONF_REQ
#define LIGHT_CONF_REQ                                        0x22                                                  
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint8_t      conf_query;
             uint8_t      num_of_subblocks;
            } __attribute__((packed)) LIGHT_CONF_REQ_STR;
#define SIZE_LIGHT_CONF_REQ                                   sizeof(LIGHT_CONF_REQ_STR)


//Definition for struct LIGHT_CONF_RESP
#define LIGHT_CONF_RESP                                       0x23                                                  
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint8_t      light_status;
             uint8_t      num_of_subblocks;
            } __attribute__((packed)) LIGHT_CONF_RESP_STR;
#define SIZE_LIGHT_CONF_RESP                                  sizeof(LIGHT_CONF_RESP_STR)


//Definition for struct LIGHT_CHANNEL_SETTINGS_WRITE_REQ
#define LIGHT_CHANNEL_SETTINGS_WRITE_REQ                      0x24                                                  
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      light_settings_action;
             uint32_t     control_channels2;
             uint32_t     control_channels;
             uint16_t     fillerbyte2;
             uint8_t      fillerbyte3;
             uint8_t      num_of_subblocks;
            } __attribute__((packed)) LIGHT_CHANNEL_SETTINGS_WRITE_REQ_STR;
#define SIZE_LIGHT_CHANNEL_SETTINGS_WRITE_REQ                 sizeof(LIGHT_CHANNEL_SETTINGS_WRITE_REQ_STR)


//Definition for struct LIGHT_CHANNEL_SETTINGS_WRITE_RESP
#define LIGHT_CHANNEL_SETTINGS_WRITE_RESP                     0x25                                                  
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint8_t      light_status;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) LIGHT_CHANNEL_SETTINGS_WRITE_RESP_STR;
#define SIZE_LIGHT_CHANNEL_SETTINGS_WRITE_RESP                sizeof(LIGHT_CHANNEL_SETTINGS_WRITE_RESP_STR)


//Definition for struct LIGHT_CHANNEL_SETTINGS_READ_REQ
#define LIGHT_CHANNEL_SETTINGS_READ_REQ                       0x26                                                  
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      channel_num;
            } __attribute__((packed)) LIGHT_CHANNEL_SETTINGS_READ_REQ_STR;
#define SIZE_LIGHT_CHANNEL_SETTINGS_READ_REQ                  sizeof(LIGHT_CHANNEL_SETTINGS_READ_REQ_STR)


//Definition for struct LIGHT_CHANNEL_SETTINGS_READ_RESP
#define LIGHT_CHANNEL_SETTINGS_READ_RESP                      0x27                                                  
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint8_t      light_status;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      channel_num;
             uint8_t      fillerbyte3;
             uint8_t      num_of_subblocks;
            } __attribute__((packed)) LIGHT_CHANNEL_SETTINGS_READ_RESP_STR;
#define SIZE_LIGHT_CHANNEL_SETTINGS_READ_RESP                 sizeof(LIGHT_CHANNEL_SETTINGS_READ_RESP_STR)


//Definition for struct LIGHT_SEQUENCE_REQ
#define LIGHT_SEQUENCE_REQ                                    0x28                                                  
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint16_t     sequence_num;
             uint8_t      action;
             uint8_t      parameter;
             uint16_t     action_value;
            } __attribute__((packed)) LIGHT_SEQUENCE_REQ_STR;
#define SIZE_LIGHT_SEQUENCE_REQ                               sizeof(LIGHT_SEQUENCE_REQ_STR)


//Definition for struct LIGHT_SEQUENCE_RESP
#define LIGHT_SEQUENCE_RESP                                   0x29                                                  
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint8_t      light_status;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) LIGHT_SEQUENCE_RESP_STR;
#define SIZE_LIGHT_SEQUENCE_RESP                              sizeof(LIGHT_SEQUENCE_RESP_STR)


//Definition for struct LIGHT_SEQUENCE_NTF
#define LIGHT_SEQUENCE_NTF                                    0x2A                                                  
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint16_t     sequence_num;
             uint8_t      light_seq_status;
             uint8_t      fillerbyte1;
             uint16_t     fillerbyte2;
            } __attribute__((packed)) LIGHT_SEQUENCE_NTF_STR;
#define SIZE_LIGHT_SEQUENCE_NTF                               sizeof(LIGHT_SEQUENCE_NTF_STR)


//Definition for struct LIGHT_SEQUENCE_CONF_REQ
#define LIGHT_SEQUENCE_CONF_REQ                               0x2B                                                  
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint16_t     sequence_num;
            } __attribute__((packed)) LIGHT_SEQUENCE_CONF_REQ_STR;
#define SIZE_LIGHT_SEQUENCE_CONF_REQ                          sizeof(LIGHT_SEQUENCE_CONF_REQ_STR)


//Definition for struct LIGHT_SEQUENCE_CONF_RESP
#define LIGHT_SEQUENCE_CONF_RESP                              0x2C                                                  
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint8_t      light_status;
             uint8_t      num_of_subblocks;
            } __attribute__((packed)) LIGHT_SEQUENCE_CONF_RESP_STR;
#define SIZE_LIGHT_SEQUENCE_CONF_RESP                         sizeof(LIGHT_SEQUENCE_CONF_RESP_STR)


//Definition for struct LIGHT_CALIBRATION_DATA_READ_REQ
#define LIGHT_CALIBRATION_DATA_READ_REQ                       0x31                                                  
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint8_t      light_calibration_data;
             uint8_t      num_of_subblocks;
            } __attribute__((packed)) LIGHT_CALIBRATION_DATA_READ_REQ_STR;
#define SIZE_LIGHT_CALIBRATION_DATA_READ_REQ                  sizeof(LIGHT_CALIBRATION_DATA_READ_REQ_STR)


//Definition for struct LIGHT_CALIBRATION_DATA_READ_RESP
#define LIGHT_CALIBRATION_DATA_READ_RESP                      0x32                                                  
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint8_t      light_status;
             uint8_t      num_of_subblocks;
            } __attribute__((packed)) LIGHT_CALIBRATION_DATA_READ_RESP_STR;
#define SIZE_LIGHT_CALIBRATION_DATA_READ_RESP                 sizeof(LIGHT_CALIBRATION_DATA_READ_RESP_STR)


//Definition for struct LIGHT_CALIBRATION_DATA_WRITE_REQ
#define LIGHT_CALIBRATION_DATA_WRITE_REQ                      0x33                                                  
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint8_t      light_calibration_data;
             uint8_t      num_of_subblocks;
            } __attribute__((packed)) LIGHT_CALIBRATION_DATA_WRITE_REQ_STR;
#define SIZE_LIGHT_CALIBRATION_DATA_WRITE_REQ                 sizeof(LIGHT_CALIBRATION_DATA_WRITE_REQ_STR)


//Definition for struct LIGHT_CALIBRATION_DATA_WRITE_RESP
#define LIGHT_CALIBRATION_DATA_WRITE_RESP                     0x34                                                  
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint8_t      light_status;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) LIGHT_CALIBRATION_DATA_WRITE_RESP_STR;
#define SIZE_LIGHT_CALIBRATION_DATA_WRITE_RESP                sizeof(LIGHT_CALIBRATION_DATA_WRITE_RESP_STR)


//Definition for struct LIGHT_SELF_TEST_REQ
#define LIGHT_SELF_TEST_REQ                                   0x35                                                  
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) LIGHT_SELF_TEST_REQ_STR;
#define SIZE_LIGHT_SELF_TEST_REQ                              sizeof(LIGHT_SELF_TEST_REQ_STR)


//Definition for struct LIGHT_SELF_TEST_RESP
#define LIGHT_SELF_TEST_RESP                                  0x36                                                  
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint8_t      light_status;
             uint8_t      reserved1;
            } __attribute__((packed)) LIGHT_SELF_TEST_RESP_STR;
#define SIZE_LIGHT_SELF_TEST_RESP                             sizeof(LIGHT_SELF_TEST_RESP_STR)


//Definition for struct LIGHT_SEQUENCE_COLOUR_REQ
#define LIGHT_SEQUENCE_COLOUR_REQ                             0x37                                                  
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint16_t     sequence_num;
             uint8_t      action;
             uint8_t      parameter;
             uint16_t     action_value;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
             uint8_t      num_of_subblocks;
            } __attribute__((packed)) LIGHT_SEQUENCE_COLOUR_REQ_STR;
#define SIZE_LIGHT_SEQUENCE_COLOUR_REQ                        sizeof(LIGHT_SEQUENCE_COLOUR_REQ_STR)


//Definition for struct LIGHT_SEQUENCE_COLOUR_RESP
#define LIGHT_SEQUENCE_COLOUR_RESP                            0x38                                                  
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint8_t      light_status;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) LIGHT_SEQUENCE_COLOUR_RESP_STR;
#define SIZE_LIGHT_SEQUENCE_COLOUR_RESP                       sizeof(LIGHT_SEQUENCE_COLOUR_RESP_STR)


//Definition for struct LIGHT_LYSTI_LED_TEST_REQ
#define LIGHT_LYSTI_LED_TEST_REQ                              0x39                                                  
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint8_t      device_id;
             uint8_t      led_current_select;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
             uint8_t      num_of_subblocks;
            } __attribute__((packed)) LIGHT_LYSTI_LED_TEST_REQ_STR;
#define SIZE_LIGHT_LYSTI_LED_TEST_REQ                         sizeof(LIGHT_LYSTI_LED_TEST_REQ_STR)


//Definition for struct LIGHT_LYSTI_LED_TEST_RESP
#define LIGHT_LYSTI_LED_TEST_RESP                             0x3A                                                  
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint8_t      device_id;
             uint8_t      light_status;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
             uint8_t      num_of_subblocks;
            } __attribute__((packed)) LIGHT_LYSTI_LED_TEST_RESP_STR;
#define SIZE_LIGHT_LYSTI_LED_TEST_RESP                        sizeof(LIGHT_LYSTI_LED_TEST_RESP_STR)

#endif
