#ifndef _PN_MODEM_NETWORK_ISI_H_
#define _PN_MODEM_NETWORK_ISI_H_

#include <stdint.h> 

//Resource Modem Network Select Server
//PN_MODEM_NETWORK 0xC8 
//ISI version 016.001
#define MODEM_NETWORK_SELECT_SERVER_ISI_VERSION_Z     16
#define MODEM_NETWORK_SELECT_SERVER_ISI_VERSION_Y     1

//In case of problems concerning content of this file contact Markku Loukusa, Sauli Laukka or Markus Mrsky
//Server specific message descriptions and feature&protocol descriptions can be found from: https://oucmswww.nmp.nokia.com:58443/document_browser/ccm_wa/GIF_SPECS/ 


//ISI VERSION CHANGE HISTORY

//Version: 016.001                                           
//Status: NonDraft                                          
//Date: 19-Aug-2008     Sauli Mikkonen
//Reason: Implemented CR
//Reference: ADB for SWAM CR SM08081456747, ADB for SWAM inspection agenda SM08081949462, NON-DRAFT

//Version: 016.000                                           
//Status: NonDraft                                          
//Date: 14-May-2008     Harri Mantyniemi
//Reason: Implemented CR
//Reference: ADB for SWAM CR HM08050745123, ADB for SWAM inspection agenda HM08051442328, NON-DRAFT

//Version: 015.000                                           
//Status: NonDraft                                          
//Date: 25-Feb-2008     Sauli Mikkonen
//Reason: Implemented CR
//Reference: ADB for SWAM CR SM07121140539, ADB for SWAM inspection agenda SM08022540286, NON-DRAFT

//Version: 014.001                                           
//Status: NonDraft                                          
//Date: 15-Jan-2008     Sauli Mikkonen
//Reason: Implemented CR
//Reference: ADB for SWAM CR SM07121140539, ADB for SWAM inspection agenda SM08010948358, NON-DRAFT

//Version: 014.000                                           
//Status: NonDraft                                          
//Date: 08-Jan-2008     Sauli Mikkonen
//Reason: Implemented CR
//Reference: ADB for SWAM CR SM07121140539, ADB for SWAM inspection agenda SM08010948358, NON-DRAFT

//Version: 013.000                                           
//Status: NonDraft                                          
//Date: 13-Dec-2007     Harri Mantyniemi
//Reason: Implemented CR
//Reference: ADB for SWAM CR HM07120344752, ADB for SWAM inspection agenda HM07121332550, NON-DRAFT

//Version: 012.001                                           
//Status: NonDraft                                          
//Date: 09-Nov-2007     Harri Mantyniemi
//Reason: Implemented CR
//Reference: ADB for SWAM CR HM07102544080, ADB for SWAM inspection agenda HM07110740425, NON-DRAFT

//Version: 012.000                                           
//Status: NonDraft                                          
//Date: 07-Nov-2007     Harri Mantyniemi
//Reason: Implemented CR
//Reference: ADB for SWAM CR HM07102544080, ADB for SWAM inspection agenda HM07110740425, NON-DRAFT

//Version: 011.002                                           
//Status: NonDraft                                          
//Date: 21-May-2007     Sauli Mikkonen
//Reason: Implemented CR
//Reference: ADB for SWAM CR SM07050860512, ADB for SWAM inspection agenda SM07051563593, NON-DRAFT

//Version: 011.001                                           
//Status: NonDraft                                          
//Date: 19-Apr-2007     Sauli Mikkonen
//Reason: Implemented CR
//Reference: ADB for SWAM CR --, ADB for SWAM inspection agenda --, NON-DRAFT

//Version: 011.000                                           
//Status: NonDraft                                          
//Date: 05-Mar-2007     Harri Mantyniemi
//Reason: Implemented CR
//Reference: ADB for SWAM CR HM07022749151, ADB for SWAM inspection agenda HM07030526864, NON-DRAFT

//Version: 010.001                                           
//Status: NonDraft                                          
//Date: 14-Feb-2007     Jutta Liuska
//Reason: Implemented CR
//Reference: ADB for SWAM CR JL07021350451, ADB for SWAM inspection agenda JL07021456272, NON-DRAFT

//Version: 010.000                                           
//Status: NonDraft                                          
//Date: 13-Feb-2007     Harri Mantyniemi
//Reason: Implemented CR
//Reference: ADB for SWAM CR HM07013135303, ADB for SWAM inspection agenda HM07021241166, NON-DRAFT

//Version: 009.010                                           
//Status: NonDraft                                          
//Date: 29-Jan-2007     Samuli Heikkinen
//Reason: Implemented CR
//Reference: ADB for SWAM CR TBD, ADB for SWAM inspection agenda TBD, NON-DRAFT

//Version: 009.009                                           
//Status: NonDraft                                          
//Date: 18-Jan-2007     Harri Mantyniemi
//Reason: Implemented CR
//Reference: ADB for SWAM CR HM07011034654, ADB for SWAM inspection agenda HM07011756501, NON-DRAFT

//Version: 009.008                                           
//Status: NonDraft                                          
//Date: 09-Jan-2007     Sauli Mikkonen
//Reason: Implemented CR
//Reference: ADB for SWAM inspection agenda SM06121356732, NON-DRAFT

//Version: 009.007                                           
//Status: NonDraft                                          
//Date: 20-Dec-2006     Jutta Junkkonen
//Reason: Implemented CR
//Reference: ADB for SWAM CR JJ06121940434, NON-DRAFT

//Version: 009.006                                           
//Status: NonDraft                                          
//Date: 18-Dec-2006     Samuli Heikkinen
//Reason: Implemented CR
//Reference: ADB for SWAM CR SH06120846477, ADB for SWAM inspection agenda SH06121849405, NON-DRAFT

//Version: 009.005                                           
//Status: NonDraft                                          
//Date: 13-OCT-2006     Markku Loukusa
//Reason: Implemented CR
//Reference: ADB for SWAM CR ML06092942755, ADB for SWAM inspection agenda ML06101338026, NON-DRAFT

//Version: 009.004                                           
//Status: NonDraft                                          
//Date: 20-Sep-2006     Markku Loukusa
//Reason: Implemented CR
//Reference: ADB for SWAM CR ML06091343327, ADB for SWAM inspection agenda ML06092029368, NON-DRAFT

//Version: 009.003                                           
//Status: NonDraft                                          
//Date: 11-Sep-2006     Samuli Heikkinen
//Reason: Design change
//Reference: ADB for SWAM inspection agenda SH06091134624, NON-DRAFT

//Version: 009.002                                           
//Status: NonDraft                                          
//Date: 04-Sep-2006     Samuli Heikkinen
//Reason: Implemented CR
//Reference: ADB for SWAM CR SH06083135185, ADB for SWAM inspection agenda SH06090447743, NON-DRAFT

//Version: 009.001                                           
//Status: NonDraft                                          
//Date: 10-Aug-2006     Samuli Heikkinen
//Reason: Implemented CR
//Reference: ADB for SWAM CR SH06060535870, ADB for SWAM inspection agenda SH06061349308, NON-DRAFT

//Version: 009.000                                           
//Status: NonDraft                                          
//Date: 03-Aug-2006     Sauli Mikkonen
//Reason: Implemented CR
//Reference: ADB for SWAM CR ML06061354144, ADB for SWAM inspection agenda SM06052447472, NON-DRAFT

//Version: 008.000                                           
//Status: NonDraft                                          
//Date: 02-Aug-2006     Samuli Heikkinen
//Reason: Implemented CR
//Reference: ADB for SWAM CR SH06080234408, ADB for SWAM inspection agenda SH06080450078, NON-DRAFT

//Version: 007.003                                           
//Status: NonDraft                                          
//Date: 14-Jun-2006     Markku Loukusa
//Reason: Implemented CR
//Reference: ADB for SWAM CR ML06061440686, ADB for SWAM inspection agenda ML06061645599, NON-DRAFT

//Version: 007.002                                           
//Status: NonDraft                                          
//Date: 08-Jun-2006     Samuli Heikkinen
//Reason: Implemented CR
//Reference: ADB for SWAM CR SH06060648175, ADB for SWAM inspection agenda SH06060838989, NON-DRAFT

//Version: 007.001                                           
//Status: NonDraft                                          
//Date: 19-May-2006     Sauli Mikkonen
//Reason: Implemented CR
//Reference: ADB for SWAM CR SM06051540814, ADB for SWAM inspection agenda SM06052447472, NON-DRAFT

//Version: 007.000                                           
//Status: NonDraft                                          
//Date: 22-Mar-2006     Markku Loukusa
//Reason: Implemented CR
//Reference: ADB for SWAM CR ML05121547145, ML06031640629, ADB for SWAM inspection agenda ML06032332622, NON-DRAFT

//Version: 006.002                                           
//Status: NonDraft                                          
//Date: 30-Nov-2005     Markku Loukusa
//Reason: Implemented CR
//Reference: ADB for SWAM CR ML05112441091:, ADB for SWAM inspection agenda ML05113042357, NON-DRAFT

//Version: 006.001                                           
//Status: NonDraft                                          
//Date: 10-Nov-2005     Markku Loukusa
//Reason: Implemented CR
//Reference: ADB for SWAM CR:ML05102741522, ADB for SWAM inspection agenda ML05111135387, NON-DRAFT

//Version: 006.000                                           
//Status: NonDraft                                          
//Date: 30-Sep-2005     Markku Loukusa
//Reason: Implemented CR
//Reference: ADB for SWAM CR:ML05090922242, ADB for SWAM inspection agenda ML05093050983, NON-DRAFT

//Version: 005.002                                           
//Status: NonDraft                                          
//Date: 06-Sep-2005     Timo Krall
//Reason: Inspection
//Reference: ADB for SWAM CR:TK05081552860, Inspection ID: TK05082947314, NON-DRAFT

//Version: 005.001                                           
//Status: Draft                                             
//Date: 29-Aug-2005     Timo Krall
//Reason: Implemented CR
//Reference: ADB for SWAM CR:TK05081552860, Inspection ID: TK05082947314, DRAFT

//Version: 005.000                                           
//Status: NonDraft                                          
//Date: 19-Aug-2005     Samuli Heikkinen
//Reason: Implemented CR
//Reference: ADB for SWAM SH05080832037, SH05081633899, NON-DRAFT

//Version: 004.004                                           
//Status: NonDraft                                          
//Date: 17-Jun-2005     Markku Loukusa
//Reason: Implemented CR
//Reference: ADB for SWAM ML05061553985, ML05062254316, NON-DRAFT

//Version: 004.003                                           
//Status: NonDraft                                          
//Date: 18-May-2005     Markku Loukusa
//Reason: Implemented CR
//Reference: ADB for SWAM HM05042231487, ML05051833166, NON-DRAFT

//Version: 004.002                                           
//Status: NonDraft                                          
//Date: 16-Mar-2005     Markku Loukusa
//Reason: Implemented CR
//Reference: ADB for SWAM JJ05031631002, NON-DRAFT

//Version: 004.001                                           
//Status: NonDraft                                          
//Date: 15-Feb-2005     Markku Loukusa
//Reason: Implemented CR
//Reference: ADB for SWAM ML05012644395, NON-DRAFT

//Version: 004.000                                           
//Status: NonDraft                                          
//Date: 10-Jan-2005     Markku Loukusa
//Reason: Implemented CR
//Reference: ADB for SWAM ML04123140770, NON-DRAFT

//Version: 003.021                                           
//Status: NonDraft                                          
//Date: 03-Dec-2004     Harri Mntyniemi
//Reason: Implemented CR
//Reference: ADB for SWAM HM04111028966, NON-DRAFT

//Version: 003.020                                           
//Status: NonDraft                                          
//Date: 29-Nov-2004     Harri Mntyniemi
//Reason: Implemented CR
//Reference: ADB for SWAM HM04111028966, NON-DRAFT

//Version: 003.019                                           
//Status: NonDraft                                          
//Date: 02-Sep-2004     Harri Mntyniemi
//Reason: Implemented CR
//Reference: ADB for SWAM HM04082328794, NON-DRAFT

//Version: 003.018                                           
//Status: NonDraft                                          
//Date: 30-Mar-2004     Markku Loukusa
//Reason: Implemented CR
//Reference: ADB for SWAM ML04032456462, NON-DRAFT

//Version: 003.017                                           
//Status: NonDraft                                          
//Date: 19-Feb-2004     Samuli Heikkinen
//Reason: Defects corrected
//Reference: ADB for SWAM SH04021049513, NON-DRAFT

//Version: 003.016                                           
//Status: NonDraft                                          
//Date: 11-Feb-2004     Samuli Heikkinen
//Reason: Implemented CR
//Reference: ADB for SWAM SH04021049513, NON-DRAFT

//Version: 003.015                                           
//Status: NonDraft                                          
//Date: 04-Feb-2004     Samuli Heikkinen
//Reason: Defects corrected
//Reference: ADB for SWAM SH04011435751, NON-DRAFT

//Version: 003.014                                           
//Status: NonDraft                                          
//Date: 19-Jan-2004     Samuli Heikkinen
//Reason: Implemented CR
//Reference: ADB for SWAM SH04011435751, NON-DRAFT

//Version: 003.013                                           
//Status: NonDraft                                          
//Date: 26-Nov-2003     Markku Loukusa
//Reason: Implemented CR
//Reference: ADB for SWAM ML03112530871, NON-DRAFT

//Version: 003.012                                           
//Status: NonDraft                                          
//Date: 16-Oct-2003     Markku Loukusa
//Reason: Implemented CR
//Reference: ADB for SWAM VJ03092645177, NON-DRAFT

//Version: 003.011                                           
//Status: NonDraft                                          
//Date: 02-Sep-2003     Markku Loukusa
//Reason: Implemented CR
//Reference: ADB for SWAM ML03082256697, NON-DRAFT

//Version: 003.010                                           
//Status: NonDraft                                          
//Date: 02-Jun-2003     Samuli Heikkinen
//Reason: Implemented CR
//Reference: ADB for SWAM SH03060235353, NON-DRAFT

//Version: 003.009                                           
//Status: NonDraft                                          
//Date: 29-Apr-2003     Markku Loukusa
//Reason: Inspection.
//Reference: ADB for SWAM ML03041630617., NON-DRAFT

//Version: 003.008                                           
//Status: NonDraft                                          
//Date: 15-Apr-2003     Markku Loukusa
//Reason: Official launch of document.
//Reference: ADB for SWAM ML03040439123., NON-DRAFT


//CONSTANTS
#define FTD_CLEAR_BTS_TEST                                    0x0D05                                                   
#define NET_INVALID_TIME                                      0x64                                                  
#define NET_FILL                                              0x00                                                     
#define NET_ALPHA_TAG_LEN                                     0x20                                                  
#define NET_ECID_UCID_UNDEFINED                               0xFFFFFFFF                                            
#define NET_ECID_CPICH_ECNO_UNDEFINED                         0xFF                                                  
#define NET_ECID_CPICH_RSCP_UNDEFINED                         -127                                                  
#define NET_ECID_PATHLOSS_UNDEFINED                           0xFF                                                  
#define NET_MODEM_ANY_SIZE                                    1                                                     
#define NET_RSSI_UNDEFINED                                    0x00                                                     
#define NET_INDEX_NOT_USED                                    0x00                                                     
#define NET_SCRAMBLING_CODE_UNDEFINED                         0xFFFF                                                
#define NET_ECID_TA_UNDEFINED                                 0xFF                                                  


//TABLES

//ConstantTable for FtdTable
#define FTD_SB_BTS_TEST                                       0x1303                                                
#define FTD_SB_BTS_STATUS                                     0x1304                                                
#define FTD_SB_FIRST_PREF                                     0x1311                                                
#define FTD_SB_SECOND_PREF                                    0x1312                                                
#define FTD_SB_THIRD_PREF                                     0x1313                                                

//ConstantTable for NET_MODEM_SUCCESS_CODES
#define NET_CAUSE_OK                                          0x00                                                     
#define NET_CAUSE_COMMUNICATION_ERROR                         0x01                                                     
#define NET_CAUSE_INVALID_PARAMETER                           0x02                                                     
#define NET_CAUSE_NO_SIM                                      0x03                                                     
#define NET_CAUSE_SIM_NOT_YET_READY                           0x04                                                     
#define NET_CAUSE_NET_NOT_FOUND                               0x05                                                     
#define NET_CAUSE_REQUEST_NOT_ALLOWED                         0x06                                                     
#define NET_CAUSE_CALL_ACTIVE                                 0x07                                                     
#define NET_CAUSE_SERVER_BUSY                                 0x08                                                     
#define NET_CAUSE_SECURITY_CODE_REQUIRED                      0x09                                                     
#define NET_CAUSE_NOTHING_TO_CANCEL                           0x0A                                                     
#define NET_CAUSE_UNABLE_TO_CANCEL                            0x0B                                                     
#define NET_CAUSE_NETWORK_FORBIDDEN                           0x0C                                                     
#define NET_CAUSE_REQUEST_REJECTED                            0x0D                                                     
#define NET_CAUSE_CS_NOT_SUPPORTED                            0x0E                                                     
#define NET_CAUSE_PAR_INFO_NOT_AVAILABLE                      0x0F                                                     
#define NET_CAUSE_NOT_DONE                                    0x10                                                  
#define NET_CAUSE_NO_SELECTED_NETWORK                         0x11                                                  
#define NET_CAUSE_REQUEST_INTERRUPTED                         0x12                                                  
#define NET_CAUSE_TOO_BIG_INDEX                               0x14                                                  
#define NET_CAUSE_MEMORY_FULL                                 0x15                                                  
#define NET_CAUSE_SERVICE_NOT_ALLOWED                         0x16                                                  
#define NET_CAUSE_NOT_SUPPORTED_IN_TECH                       0x17                                                  

//ConstantTable for NET_MODEM_NETWORK_SEARCH_MODE
#define NET_MANUAL_SEARCH                                     0x00                                                     
#define NET_NEW_SEARCH_START                                  0x01                                                     
#define NET_NEW_SEARCH_NEXT                                   0x02                                                     
#define NET_NEW_EXTENDED_SEARCH_START                         0x03                                                     

//ConstantTable for NET_CS_TYPE
#define NET_CS_GSM                                            0x00                                                     

//ConstantTable for NET_CS_OPERATION_MODE
#define NET_CS_OP_MODE_NORMAL                                 0x00                                                     
#define NET_CS_OP_MODE_GAN_ONLY                               0x01                                                     

//ConstantTable for NET_MEASUREMENT_TYPES
#define NET_STRONGEST_RSSIS                                   0x01                                                     
#define NET_CURRENT_CELL_RSSI                                 0x02                                                     

//ConstantTable for NET_CONTROL_MESSAGE_TYPES
#define NET_CS_RESUME                                         0x01                                                     
#define NET_CS_POWER_OFF                                      0x02                                                     
#define NET_CS_POWER_ON                                       0x03                                                     
#define NET_CS_POWER_WIFI                                     0x05                                                     

//ConstantTable for NET_RESUME_TYPES
#define NET_BAND_RESUME                                       0x04                                                     

//ConstantTable for NET_MODEM_REGISTRATION_STATUS
#define NET_REG_STATUS_HOME                                   0x00                                                     
#define NET_REG_STATUS_ROAM                                   0x01                                                     
#define NET_REG_STATUS_ROAM_BLINK                             0x02                                                     
#define NET_REG_STATUS_NOSERV                                 0x03                                                     
#define NET_REG_STATUS_NOSERV_SEARCHING                       0x04                                                     
#define NET_REG_STATUS_NOSERV_NOTSEARCHING                    0x05                                                     
#define NET_REG_STATUS_NOSERV_NOSIM                           0x06                                                     
#define NET_REG_STATUS_POWER_OFF                              0x08                                                     
#define NET_REG_STATUS_NSPS                                   0x09                                                     
#define NET_REG_STATUS_NSPS_NO_COVERAGE                       0x0A                                                     
#define NET_REG_STATUS_NOSERV_SIM_REJECTED_BY_NW              0x0B                                                     

//ConstantTable for NET_SERVICE_STATUS
#define NET_SERVICE                                           0x00                                                     
#define NET_LIMITED_SERVICE                                   0x01                                                     
#define NET_NO_COVERAGE                                       0x02                                                     

//ConstantTable for NET_MODEM_NETWORK_SELECTION_MODE
#define NET_SELECT_MODE_UNKNOWN                               0x00                                                     
#define NET_SELECT_MODE_MANUAL                                0x01                                                     
#define NET_SELECT_MODE_AUTOMATIC                             0x02                                                     
#define NET_SELECT_MODE_USER_RESELECTION                      0x03                                                     
#define NET_SELECT_MODE_NO_SELECTION                          0x04                                                     

//ConstantTable for NET_MODEM_NETWORK_STATUS
#define NET_OPER_STATUS_UNKNOWN                               0x00                                                     
#define NET_OPER_STATUS_AVAILABLE                             0x01                                                     
#define NET_OPER_STATUS_CURRENT                               0x02                                                     
#define NET_OPER_STATUS_FORBIDDEN                             0x03                                                     

//BitmaskTables for NET_ADDITIONAL_RAT_INFO
#define NET_GSM_COMPACT_NOT_SUPPORTED                         0x00                                                     
#define NET_GSM_COMPACT_SUPPORTED                             0x01                                                     
#define NET_UMA_RAT                                           0x02                                                     

//ConstantTable for NET_TEST_CARRIER_SETTING_OPERATIONS
#define NET_TEST_CARRIER_SET                                  0x00                                                     
#define NET_TEST_CARRIER_CLEAR                                0x01                                                     
#define NET_TEST_CARRIER_READ                                 0x02                                                     
#define NET_TEST_CARRIER_SCAN_START                           0x03                                                     
#define NET_TEST_CARRIER_SCAN_END                             0x04                                                     
#define NET_TEST_ASSISTED_HO_START                            0x05                                                     
#define NET_TEST_SUPPRESS_HO_START                            0x06                                                     
#define NET_TEST_HAND_OVER_END                                0x07                                                     

//ConstantTable for NET_TEST_CARRIER_TYPE
#define NET_PRODUCTION_CARRIER                                0x00                                                     
#define NET_BTS_TEST_CARRIER                                  0x01                                                     

//ConstantTable for NET_BAND_SELECTION
#define NET_GSM900_1800                                       0x00                                                     
#define NET_GSM850_1900                                       0x01                                                     

//ConstantTable for NET_CIPHERING_STATUS
#define NET_CIPHERING_INDICATOR_OFF                           0x00                                                     
#define NET_CIPHERING_INDICATOR_ON                            0x01                                                     
#define NET_CIPHERING_NO_CONNECTION                           0x02                                                     

//ConstantTable for NET_CIPHERING_KEY_STATUS
#define NET_KEY_STATUS_UNKNOWN                                0x00                                                     
#define NET_KEY_STATUS_DERIVED                                0x01                                                     
#define NET_KEY_STATUS_NOT_DERIVED                            0x02                                                     

//ConstantTable for NET_CIPHERING_CONTEXT
#define NET_CONTEXT_UNKNOWN                                   0x00                                                     
#define NET_CONTEXT_GSM                                       0x01                                                     
#define NET_CONTEXT_UMTS                                      0x02                                                     

//ConstantTable for NET_ACTIVE_RAT
#define NET_ACTIVE_RAT_UNKNOWN                                0x00                                                     
#define NET_ACTIVE_RAT_GSM                                    0x01                                                     
#define NET_ACTIVE_RAT_UMTS                                   0x02                                                     

//ConstantTable for NET_RAT_NAME
#define NET_GSM_RAT                                           0x01                                                     
#define NET_UMTS_RAT                                          0x02                                                     

//ConstantTable for NET_RAT_TYPE
#define NET_CURRENT_RAT                                       0x00                                                     
#define NET_SUPPORTED_RATS                                    0x01                                                     

//ConstantTable for NET_LICENSE_INFO_BLOCK_TYPE
#define NET_USA_LICENSE_BLOCKS                                0x00                                                     

//BitmaskTables for NET_US_1900_MHZ_LICENSE_INFO
#define NET_LICENSE_USA1900_A                                 0x01                                                     
#define NET_LICENSE_USA1900_B                                 0x02                                                     
#define NET_LICENSE_USA1900_C                                 0x04                                                     
#define NET_LICENSE_USA1900_D                                 0x08                                                     
#define NET_LICENSE_USA1900_E                                 0x10                                                  
#define NET_LICENSE_USA1900_F                                 0x20                                                  

//BitmaskTables for NET_US_800_MHZ_LICENSE_INFO
#define NET_LICENSE_USA800_a                                  0x01                                                     
#define NET_LICENSE_USA800_b                                  0x02                                                     

//ConstantTable for NET_DAYLIGHT_SAVING_TIME
#define NET_DST_INFO_NOT_AVAIL                                0x64                                                  
#define NET_DST_1_HOUR                                        0x01                                                     
#define NET_DST_2_HOURS                                       0x02                                                     
#define NET_DST_0_HOUR                                        0x00                                                     

//ConstantTable for NET_CS_STATES
#define NET_CS_INACTIVE                                       0x00                                                     
#define NET_CS_ACTIVE                                         0x01                                                     

//ConstantTable for NET_SIM_REFRESH_TYPES
#define NET_SIM_COLD_REFRESH                                  0x00                                                     
#define NET_SIM_WARM_REFRESH                                  0x01                                                     
#define NET_SIM_WARM_REFRESH_MM_RESTART                       0x02                                                     

//ConstantTable for NET_MODEM_GSM_NETWORK_TYPE
#define NET_GSM_HOME_PLMN                                     0x00                                                     
#define NET_GSM_PREFERRED_PLMN                                0x01                                                     
#define NET_GSM_FORBIDDEN_PLMN                                0x02                                                     
#define NET_GSM_OTHER_PLMN                                    0x03                                                     
#define NET_GSM_NO_PLMN_AVAIL                                 0x04                                                     

//ConstantTable for NET_MODEM_UMTS_AVAIL_INFO
#define NET_UMTS_NOT_AVAILABLE                                0x00                                                     
#define NET_UMTS_AVAILABLE                                    0x01                                                     

//ConstantTable for NET_MODEM_REJECT_CODES
#define NET_GSM_IMSI_UNKNOWN_IN_HLR                           0x02                                                     
#define NET_GSM_ILLEGAL_MS                                    0x03                                                     
#define NET_GSM_IMSI_UNKNOWN_IN_VLR                           0x04                                                     
#define NET_GSM_IMEI_NOT_ACCEPTED                             0x05                                                     
#define NET_GSM_ILLEGAL_ME                                    0x06                                                     
#define NET_GSM_GPRS_SERVICES_NOT_ALLOWED                     0x07                                                     
#define NET_GSM_GPRS_AND_NON_GPRS_NA                          0x08                                                     
#define NET_GSM_MS_ID_CANNOT_BE_DERIVED                       0x09                                                     
#define NET_GSM_IMPLICITLY_DETACHED                           0x0A                                                     
#define NET_GSM_PLMN_NOT_ALLOWED                              0x0B                                                     
#define NET_GSM_LA_NOT_ALLOWED                                0x0C                                                     
#define NET_GSM_ROAMING_NOT_IN_THIS_LA                        0x0D                                                     
#define NET_GSM_GPRS_SERV_NA_IN_THIS_PLMN                     0x0E                                                     
#define NET_GSM_NO_SUITABLE_CELLS_IN_LA                       0x0F                                                     
#define NET_GSM_MSC_TEMP_NOT_REACHABLE                        0x10                                                  
#define NET_GSM_NETWORK_FAILURE                               0x11                                                  
#define NET_GSM_MAC_FAILURE                                   0x14                                                  
#define NET_GSM_SYNCH_FAILURE                                 0x15                                                  
#define NET_GSM_CONGESTION                                    0x16                                                  
#define NET_GSM_AUTH_UNACCEPTABLE                             0x17                                                  
#define NET_GSM_SERV_OPT_NOT_SUPPORTED                        0x20                                                  
#define NET_GSM_SERV_OPT_NOT_SUBSCRIBED                       0x21                                                  
#define NET_GSM_SERV_TEMP_OUT_OF_ORDER                        0x22                                                  
#define NET_GSM_RETRY_ENTRY_NEW_CELL_LOW                      0x30                                                  
#define NET_GSM_RETRY_ENTRY_NEW_CELL_HIGH                     0x3F                                                  
#define NET_GSM_SEMANTICALLY_INCORRECT                        0x5F                                                  
#define NET_GSM_INVALID_MANDATORY_INFO                        0x60                                                  
#define NET_GSM_MSG_TYPE_NONEXISTENT                          0x61                                                  
#define NET_GSM_CONDITIONAL_IE_ERROR                          0x64                                                  
#define NET_GSM_MSG_TYPE_WRONG_STATE                          0x65                                                  
#define NET_GSM_PROTOCOL_ERROR_UNSPECIFIED                    0x6F                                                  

//ConstantTable for NET_NEIGHBOUR_CELL_INFO_TYPE
#define NET_HOME_ZONE_CELLS                                   0x00                                                     
#define NET_SIM_NMR                                           0x01                                                     
#define NET_SIM_INTRA_FREQ_NMR                                0x02                                                     
#define NET_SIM_INTER_FREQ_NMR                                0x03                                                     
#define NET_SIM_INTER_RAT_NMR                                 0x04                                                     
#define NET_ECID_INFORMATION                                  0x05                                                     

//ConstantTable for NET_MODEM_GSM_BAND_INFO_TBL
#define NET_GSM_BAND_900_1800                                 0x00                                                     
#define NET_GSM_BAND_850_1900                                 0x01                                                     
#define NET_GSM_BAND_INFO_NOT_AVAIL                           0x02                                                     
#define NET_GSM_BAND_ALL_SUPPORTED_BANDS                      0x03                                                     
#define NET_GSM_BAND_850_LOCKED                               0xB0                                                  
#define NET_GSM_BAND_900_LOCKED                               0xA0                                                  
#define NET_GSM_BAND_1800_LOCKED                              0xA1                                                  
#define NET_GSM_BAND_1900_LOCKED                              0xB1                                                  

//BitmaskTables for NET_GSM_BANDS_INFO_TBL
#define NET_GSM_BAND_ALL_MASK                                 0x00000000                                                     
#define NET_GSM_BAND_900_MASK                                 0x00000001                                                     
#define NET_GSM_BAND_1800_MASK                                0x00000002                                                     
#define NET_GSM_BAND_1900_MASK                                0x00000004                                                     
#define NET_GSM_BAND_850_MASK                                 0x00000008                                                     

//BitmaskTables for NET_WCDMA_BANDS_INFO_TBL
#define NET_WCDMA_FDD_BAND_ALL_MASK                           0x00000000                                                     
#define NET_WCDMA_FDD_BAND_1_MASK                             0x00000001                                                     
#define NET_WCDMA_FDD_BAND_2_MASK                             0x00000002                                                     
#define NET_WCDMA_FDD_BAND_3_MASK                             0x00000004                                                     
#define NET_WCDMA_FDD_BAND_4_MASK                             0x00000008                                                     
#define NET_WCDMA_FDD_BAND_5_MASK                             0x00000010                                                  
#define NET_WCDMA_FDD_BAND_6_MASK                             0x00000020                                                  
#define NET_WCDMA_FDD_BAND_7_MASK                             0x00000040                                                  
#define NET_WCDMA_FDD_BAND_8_MASK                             0x00000080                                                  
#define NET_WCDMA_FDD_BAND_9_MASK                             0x00000100                                                   
#define NET_WCDMA_FDD_BAND_10_MASK                            0x00000200                                                   
#define NET_WCDMA_FDD_BAND_11_MASK                            0x00000400                                                   
#define NET_WCDMA_FDD_BAND_12_MASK                            0x00000800                                                   
#define NET_WCDMA_FDD_BAND_13_MASK                            0x00001000                                                  
#define NET_WCDMA_FDD_BAND_14_MASK                            0x00002000                                                  
#define NET_WCDMA_FDD_BAND_15_MASK                            0x00004000                                                  
#define NET_WCDMA_FDD_BAND_16_MASK                            0x00008000                                                  
#define NET_WCDMA_FDD_BAND_17_MASK                            0x00010000                                                 
#define NET_WCDMA_FDD_BAND_18_MASK                            0x00020000                                                 
#define NET_WCDMA_FDD_BAND_19_MASK                            0x00040000                                                 
#define NET_WCDMA_FDD_BAND_20_MASK                            0x00080000                                                 
#define NET_WCDMA_FDD_BAND_21_MASK                            0x00100000                                                
#define NET_WCDMA_FDD_BAND_22_MASK                            0x00200000                                                
#define NET_WCDMA_FDD_BAND_23_MASK                            0x00400000                                                
#define NET_WCDMA_FDD_BAND_24_MASK                            0x00800000                                                

//ConstantTable for NET_MODEM_GPRS_NETWORK_MODE
#define NET_GPRS_MODE_NONE                                    0x00                                                     
#define NET_GPRS_MODE_I                                       0x01                                                     
#define NET_GPRS_MODE_II                                      0x02                                                     
#define NET_GPRS_MODE_III                                     0x03                                                     

//ConstantTable for NET_INDICATION_TYPES
#define NET_GSM_LCS_CHANGE_OF_PLMN                            0x00                                                     
#define NET_GSM_LCS_CHANGE_OF_LA                              0x01                                                     
#define NET_GSM_LCS_NORMAL_LOC_UPDATE                         0x02                                                     
#define NET_GSM_LCS_PERIODIC_LOC_UPDATE                       0x03                                                     

//ConstantTable for NET_GPS_NAVIGATION_TYPES
#define NET_GPS_NEW_SAT_AND_NEW_MODEL                         0x00                                                     
#define NET_GPS_OLD_SAT_AND_OLD_MODEL                         0x01                                                     
#define NET_GPS_OLD_SAT_AND_NEW_MODEL                         0x02                                                     

//ConstantTable for NET_UMA_FAILURE_REASON
#define NET_NETWORK_CONGESTION                                0x00                                                     
#define NET_AP_NOT_ALLOWED                                    0x01                                                     
#define NET_LOCATION_NOT_ALLOWED                              0x02                                                     
#define NET_INVALID_UNC                                       0x03                                                     
#define NET_GEO_LOCATION_NOT_KNOWN                            0x04                                                     
#define NET_IMSI_NOT_ALLOWED                                  0x05                                                     
#define NET_UNSPECIFIED                                       0x06                                                     
#define NET_UNC_SGW_CERTIF_NOT_VALID                          0x07                                                     
#define NET_EAP_SIM_AUTH_FAILED                               0x08                                                     
#define NET_TCP_ESTABLISHMENT_FAILED                          0x09                                                     
#define NET_REDIRECTION                                       0x0A                                                     
#define NET_EAP_AKA_AUTH_FAILED                               0x0B                                                     
#define NET_TCP_CONNECTION_RESET                              0x14                                                  
#define NET_TCP_LINK_CREATION_FAILED                          0x15                                                  
#define NET_DHCP_QUERY_NO_IP_ADDRESS                          0x16                                                  
#define NET_DNS_QUERY_FAILED                                  0x17                                                  
#define NET_ARP_PROCEDURE_FAILED                              0x18                                                  
#define NET_NW_LINK_CREATION_FAILED                           0x19                                                  
#define NET_SEC_TUNNEL_CREATION_FAIL                          0x1A                                                  
#define NET_WLAN_AUTH_FAILED                                  0x1E                                                  
#define NET_WLAN_COVERAGE_LOSS                                0x1F                                                  
#define NET_WLAN_GENERIC_FAILURE                              0x20                                                  
#define NET_UMA_PLMN_REJECTED                                 0x21                                                  
#define NET_UMA_LU_REJECTED                                   0x22                                                  
#define NET_IP_ADDRESS_UPDATED                                0x23                                                  
#define NET_NW_LINK_LOST                                      0x24                                                  
#define NET_TCP_CONNECTION_LOST                               0x25                                                  
#define NET_UMA_UNRECOVERABLE_LOOP                            0x26                                                  
#define NET_UMA_VOICE_CALL_FAILED                             0x28                                                  
#define NET_DNS_QUERY_SGW_FAILED                              0x29                                                  
#define NET_DNS_QUERY_UNC_FAILED                              0x30                                                  
#define NET_UMA_CONNECTED                                     0xFE                                                  

//ConstantTable for NET_UMA_FAILURE_SEVERITY
#define NET_SEVERITY_MINOR                                    0x00                                                     
#define NET_SEVERITY_SEVERE                                   0x01                                                     
#define NET_SEVERITY_FATAL                                    0x02                                                     

//ConstantTable for NET_UMA_FAILURE_PHASE
#define NET_DISCOVERY_PROCEDURE                               0x00                                                     
#define NET_REGISTRATION_PROCEDURE                            0x01                                                     
#define NET_REG_REDIR_PROCEDURE                               0x02                                                     
#define NET_ERR_AFTER_UMA_REGISTRATION                        0x03                                                     

//ConstantTable for NET_RRLP_SUPL_HANDLE_STATUS_CODES
#define NET_LS_SAME_REF_NBR                                   0x01                                                     
#define NET_LS_DIFF_REF_NBR                                   0x02                                                     
#define NET_LS_PROTOCOL_ERROR                                 0x03                                                     
#define NET_LS_MEAS_RESP_OK                                   0x04                                                     
#define NET_LS_AD_ACK_OK                                      0x05                                                     

//ConstantTable for NET_RRLP_STATUS
#define NET_RRLP_STATUS_OK                                    0x00                                                     
#define NET_RRLP_STATUS_SAME_REF_NBR                          0x01                                                     
#define NET_RRLP_STATUS_DIFF_REF_NBR                          0x02                                                     

//ConstantTable for NET_UTRAN_RADIO_STATE
#define NET_UTRAN_RADIO_IDLE                                  0x00                                                     
#define NET_UTRAN_RADIO_CELL_DCH                              0x01                                                     


//STRUCTURES


//Definition for struct NET_GSM_LCS_GPS_TOW_ASSIST_SEQ
typedef struct
            { 
             uint8_t      sat_id;
             uint8_t      tlmreserved;
             uint16_t     tlm;
             uint8_t      antispoof;
             uint8_t      alert;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) NET_GSM_LCS_GPS_TOW_ASSIST_SEQ_STR;
#define SIZE_NET_GSM_LCS_GPS_TOW_ASSIST_SEQ                   sizeof(NET_GSM_LCS_GPS_TOW_ASSIST_SEQ_STR)


//Definition for struct NET_GSM_LCS_GPS_SAT_LIST_SEQ
typedef struct
            { 
             uint8_t      sat_id;
             uint8_t      iode;
             uint8_t      udre;
             int8_t       rrc;
             int16_t      prc;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) NET_GSM_LCS_GPS_SAT_LIST_SEQ_STR;
#define SIZE_NET_GSM_LCS_GPS_SAT_LIST_SEQ                     sizeof(NET_GSM_LCS_GPS_SAT_LIST_SEQ_STR)


//Definition for struct NET_GSM_LCS_GPS_NAV_LIST_SEQ
typedef struct
            { 
             uint8_t      sat_id;
             uint8_t      sat_status;
             uint8_t      code_on_l2;
             uint8_t      ura;
             uint8_t      svhealth;
             uint8_t      l2_p_data_flag;
             uint16_t     iodc;
             uint32_t     sf1reserved1;
             uint32_t     sf1reserved2;
             uint32_t     sf1reserved3;
             uint16_t     sf1reserved4;
             uint16_t     toc;
             int8_t       tgd;
             int8_t       af_2;
             int16_t      af_1;
             int32_t      af_0;
             int16_t      crs;
             int16_t      delta_n;
             int32_t      m_0;
             int16_t      cuc;
             int16_t      cus;
             uint32_t     e;
             uint32_t     a_power_half;
             uint16_t     toe;
             uint8_t      fit_flag;
             uint8_t      aoda;
             int16_t      cic;
             int16_t      cis;
             int32_t      omega_0;
             int32_t      i0;
             int16_t      crc;
             int16_t      i_dot;
             int32_t      omega;
             int32_t      omega_dot;
            } __attribute__((packed)) NET_GSM_LCS_GPS_NAV_LIST_SEQ_STR;
#define SIZE_NET_GSM_LCS_GPS_NAV_LIST_SEQ                     sizeof(NET_GSM_LCS_GPS_NAV_LIST_SEQ_STR)


//Definition for struct NET_GSM_LCS_GPS_ALMANAC_LIST_SEQ
typedef struct
            { 
             uint8_t      sat_id;
             uint8_t      toa;
             uint16_t     e;
             int16_t      delta_i;
             int16_t      omega_dot;
             uint8_t      sv_health;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
             uint32_t     a_power_half;
             int32_t      omega_0;
             int32_t      omega;
             int32_t      m0;
             int16_t      af_0;
             int16_t      af_1;
            } __attribute__((packed)) NET_GSM_LCS_GPS_ALMANAC_LIST_SEQ_STR;
#define SIZE_NET_GSM_LCS_GPS_ALMANAC_LIST_SEQ                 sizeof(NET_GSM_LCS_GPS_ALMANAC_LIST_SEQ_STR)


//Definition for struct NET_GSM_LCS_GPS_AQUIS_LIST_SEQ
typedef struct
            { 
             uint8_t      svid;
             uint8_t      add_dopp_present;
             int16_t      doppler_0;
             uint8_t      doppler_1;
             uint8_t      doppler_uncertainty;
             uint16_t     code_phase;
             uint8_t      int_code_phase;
             uint8_t      gps_bit_number;
             uint16_t     code_phase_search_window;
             uint8_t      add_angle_present;
             uint8_t      azimuth;
             uint8_t      elevation;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) NET_GSM_LCS_GPS_AQUIS_LIST_SEQ_STR;
#define SIZE_NET_GSM_LCS_GPS_AQUIS_LIST_SEQ                   sizeof(NET_GSM_LCS_GPS_AQUIS_LIST_SEQ_STR)


//Definition for struct NET_GSM_NMR_LIST_SEQ
typedef struct
            { 
             uint16_t     arfcn;
             uint8_t      bsic;
             uint8_t      rx_level;
            } __attribute__((packed)) NET_GSM_NMR_LIST_SEQ_STR;
#define SIZE_NET_GSM_NMR_LIST_SEQ                             sizeof(NET_GSM_NMR_LIST_SEQ_STR)


//Definition for struct NET_UTRAN_CELL_LIST_SEQ
typedef struct
            { 
             uint32_t     uc_id;
             uint16_t     p_cpich;
             uint8_t      cpich_ecno;
             int8_t       cpich_rscp;
             uint8_t      pathloss;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
            } __attribute__((packed)) NET_UTRAN_CELL_LIST_SEQ_STR;
#define SIZE_NET_UTRAN_CELL_LIST_SEQ                          sizeof(NET_UTRAN_CELL_LIST_SEQ_STR)


//Definition for struct NET_UTRAN_NEIGH_LIST_SEQ
typedef struct
            { 
             uint16_t     uarfcn_dl;
             uint8_t      uc_rssi;
             uint8_t      n_cell;
             NET_UTRAN_CELL_LIST_SEQ_STR    detailed_cell_info[0];
            } __attribute__((packed)) NET_UTRAN_NEIGH_LIST_SEQ_STR;
#define SIZE_NET_UTRAN_NEIGH_LIST_SEQ                         sizeof(NET_UTRAN_NEIGH_LIST_SEQ_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//SUBBLOCKS


//Definition for struct NET_MODEM_REG_INFO_COMMON
#define NET_MODEM_REG_INFO_COMMON                             0x00                                                     
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_length;
             uint8_t      registration_status;
             uint8_t      network_selection_mode;
            } __attribute__((packed)) NET_MODEM_REG_INFO_COMMON_STR;
#define SIZE_NET_MODEM_REG_INFO_COMMON                        sizeof(NET_MODEM_REG_INFO_COMMON_STR)


//Definition for struct NET_MODEM_AVAIL_NETWORK_INFO_COMMON
#define NET_MODEM_AVAIL_NETWORK_INFO_COMMON                   0x01                                                     
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_length;
             uint8_t      network_status;
             uint8_t      index;
            } __attribute__((packed)) NET_MODEM_AVAIL_NETWORK_INFO_COMMON_STR;
#define SIZE_NET_MODEM_AVAIL_NETWORK_INFO_COMMON              sizeof(NET_MODEM_AVAIL_NETWORK_INFO_COMMON_STR)


//Definition for struct NET_OPERATOR_INFO_COMMON
#define NET_OPERATOR_INFO_COMMON                              0x02                                                     
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_length;
             uint8_t      selection_mode;
             uint8_t      index;
            } __attribute__((packed)) NET_OPERATOR_INFO_COMMON_STR;
#define SIZE_NET_OPERATOR_INFO_COMMON                         sizeof(NET_OPERATOR_INFO_COMMON_STR)


//Definition for struct NET_RSSI_GSM_STRONGEST
#define NET_RSSI_GSM_STRONGEST                                0x13                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_length;
             uint8_t      band_info;
             uint8_t      nbr_of_results;
             uint16_t     sub_block_data[0];
             uint8_t      sub_block_data_2[0];
            } __attribute__((packed)) NET_RSSI_GSM_STRONGEST_STR;
#define SIZE_NET_RSSI_GSM_STRONGEST                           sizeof(NET_RSSI_GSM_STRONGEST_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct NET_RSSI_CURRENT
#define NET_RSSI_CURRENT                                      0x04                                                     
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_length;
             uint8_t      signal_bars;
             uint8_t      rssi_in_dbm;
            } __attribute__((packed)) NET_RSSI_CURRENT_STR;
#define SIZE_NET_RSSI_CURRENT                                 sizeof(NET_RSSI_CURRENT_STR)


//Definition for struct NET_TEST_CARRIER_PARAM
#define NET_TEST_CARRIER_PARAM                                0x05                                                     
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_length;
             uint16_t     carrier_channel_nbr;
             uint8_t      band_selection;
             uint8_t      test_carrier_type;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) NET_TEST_CARRIER_PARAM_STR;
#define SIZE_NET_TEST_CARRIER_PARAM                           sizeof(NET_TEST_CARRIER_PARAM_STR)


//Definition for struct NET_TEST_WCDMA_PARAMS
#define NET_TEST_WCDMA_PARAMS                                 0x2D                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_length;
             uint16_t     carrier_channel_nbr;
             uint16_t     carrier_scrambling_code;
             uint8_t      test_carrier_type;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) NET_TEST_WCDMA_PARAMS_STR;
#define SIZE_NET_TEST_WCDMA_PARAMS                            sizeof(NET_TEST_WCDMA_PARAMS_STR)


//Definition for struct NET_TEST_GSM_SCAN_PARAMS
#define NET_TEST_GSM_SCAN_PARAMS                              0x40                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_length;
             uint8_t      bsic_decode_status;
             uint8_t      fillerbyte1;
             uint32_t     gsm_band_info;
             uint16_t     channel_nbr_low;
             uint16_t     channel_nbr_high;
            } __attribute__((packed)) NET_TEST_GSM_SCAN_PARAMS_STR;
#define SIZE_NET_TEST_GSM_SCAN_PARAMS                         sizeof(NET_TEST_GSM_SCAN_PARAMS_STR)


//Definition for struct NET_TEST_WCDMA_SCAN_PARAMS
#define NET_TEST_WCDMA_SCAN_PARAMS                            0x41                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_length;
             uint8_t      fillerbyte1;
             uint8_t      rscp;
             uint32_t     wcdma_band_info;
            } __attribute__((packed)) NET_TEST_WCDMA_SCAN_PARAMS_STR;
#define SIZE_NET_TEST_WCDMA_SCAN_PARAMS                       sizeof(NET_TEST_WCDMA_SCAN_PARAMS_STR)


//Definition for struct NET_TEST_GSM_HO_PARAMS
#define NET_TEST_GSM_HO_PARAMS                                0x42                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_length;
             uint16_t     carrier_channel_nbr;
             uint32_t     gsm_band_info;
             uint8_t      bsic;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
            } __attribute__((packed)) NET_TEST_GSM_HO_PARAMS_STR;
#define SIZE_NET_TEST_GSM_HO_PARAMS                           sizeof(NET_TEST_GSM_HO_PARAMS_STR)


//Definition for struct NET_TEST_WRAN_HO_PARAMS
#define NET_TEST_WRAN_HO_PARAMS                               0x43                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_length;
             uint16_t     carrier_channel_nbr;
             uint16_t     carrier_scrambling_code;
             uint16_t     ecno_enhance;
             uint16_t     rscp_enhance;
             uint16_t     ecno_degrade;
             uint16_t     rscp_degrade;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) NET_TEST_WRAN_HO_PARAMS_STR;
#define SIZE_NET_TEST_WRAN_HO_PARAMS                          sizeof(NET_TEST_WRAN_HO_PARAMS_STR)


//Definition for struct NET_RESUME_INFO
#define NET_RESUME_INFO                                       0x15                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_length;
             uint8_t      resume_type;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) NET_RESUME_INFO_STR;
#define SIZE_NET_RESUME_INFO                                  sizeof(NET_RESUME_INFO_STR)


//Definition for struct NET_LICENSE_BLOCK_INFO
#define NET_LICENSE_BLOCK_INFO                                0x19                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_length;
             uint8_t      license_block_info_type;
             uint8_t      us1900_license_info;
             uint8_t      us800_license_info;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
            } __attribute__((packed)) NET_LICENSE_BLOCK_INFO_STR;
#define SIZE_NET_LICENSE_BLOCK_INFO                           sizeof(NET_LICENSE_BLOCK_INFO_STR)
//This definition is propably impossible to generate due the IF/ELSE statements in specification.
//See ISI message specification for further details of message structure.
//https://oucmswww.nmp.nokia.com:59080/document_browser/


//Definition for struct NET_CIPHERING_INFO
#define NET_CIPHERING_INFO                                    0x29                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_length;
             uint8_t      ciphering_key_status;
             uint8_t      ciphering_context;
             uint8_t      active_rat;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
            } __attribute__((packed)) NET_CIPHERING_INFO_STR;
#define SIZE_NET_CIPHERING_INFO                               sizeof(NET_CIPHERING_INFO_STR)


//Definition for struct NET_MODEM_GSM_REG_INFO
#define NET_MODEM_GSM_REG_INFO                                0x09                                                     
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_length;
             uint16_t     current_lac;
             uint32_t     current_cell_id;
             uint8_t      operator_code[3];
             uint8_t      gsm_band_info;
             uint8_t      network_type;
             uint8_t      gprs_support_in_cell;
             uint8_t      gprs_network_mode;
             uint8_t      cs_services;
             uint8_t      gprs_services;
             uint8_t      egprs_support_in_cell;
             uint8_t      dtm_support_in_cell;
             uint8_t      current_rac;
             uint8_t      hsdpa_available_in_cell;
             uint8_t      hsupa_available_in_cell;
             uint8_t      camped_in_hplmn;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) NET_MODEM_GSM_REG_INFO_STR;
#define SIZE_NET_MODEM_GSM_REG_INFO                           sizeof(NET_MODEM_GSM_REG_INFO_STR)


//Definition for struct NET_MODEM_CURRENT_CELL_INFO
#define NET_MODEM_CURRENT_CELL_INFO                           0x39                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_length;
             uint16_t     current_lac;
             uint32_t     current_cell_id;
             uint8_t      operator_code[3];
             uint8_t      gsm_band_info;
             uint8_t      network_type;
             uint8_t      gprs_support_in_cell;
             uint8_t      gprs_network_mode;
             uint8_t      cs_services;
             uint8_t      gprs_services;
             uint8_t      egprs_support_in_cell;
             uint8_t      dtm_support_in_cell;
             uint8_t      current_rac;
             uint8_t      hsdpa_available_in_cell;
             uint8_t      hsupa_available_in_cell;
             uint8_t      camped_in_hplmn;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) NET_MODEM_CURRENT_CELL_INFO_STR;
#define SIZE_NET_MODEM_CURRENT_CELL_INFO                      sizeof(NET_MODEM_CURRENT_CELL_INFO_STR)


//Definition for struct NET_TIME_INFO
#define NET_TIME_INFO                                         0x10                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_length;
             uint8_t      year;
             uint8_t      month;
             uint8_t      day;
             uint8_t      hour;
             uint8_t      minute;
             uint8_t      second;
             uint8_t      time_zone;
             uint8_t      day_light_saving_time;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) NET_TIME_INFO_STR;
#define SIZE_NET_TIME_INFO                                    sizeof(NET_TIME_INFO_STR)


//Definition for struct NET_MODEM_DETAILED_NETWORK_INFO
#define NET_MODEM_DETAILED_NETWORK_INFO                       0x0B                                                     
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_length;
             uint8_t      oper_code[3];
             uint8_t      band_info;
             uint8_t      network_type;
             uint8_t      umts_available;
             uint16_t     current_lac;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) NET_MODEM_DETAILED_NETWORK_INFO_STR;
#define SIZE_NET_MODEM_DETAILED_NETWORK_INFO                  sizeof(NET_MODEM_DETAILED_NETWORK_INFO_STR)


//Definition for struct NET_MODEM_GSM_OPERATOR_INFO
#define NET_MODEM_GSM_OPERATOR_INFO                           0x0C                                                     
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_length;
             uint8_t      oper_code[3];
             uint8_t      band_info;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) NET_MODEM_GSM_OPERATOR_INFO_STR;
#define SIZE_NET_MODEM_GSM_OPERATOR_INFO                      sizeof(NET_MODEM_GSM_OPERATOR_INFO_STR)


//Definition for struct NET_GSM_HOME_CELLS_INFO
#define NET_GSM_HOME_CELLS_INFO                               0x0D                                                     
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_length;
             uint8_t      number_of_measurements;
             uint8_t      fillerbyte1;
             uint32_t     cell_identity_1[0];
             uint16_t     rest_of_sub_block_data[0];
             uint8_t      rssi[0];
            } __attribute__((packed)) NET_GSM_HOME_CELLS_INFO_STR;
#define SIZE_NET_GSM_HOME_CELLS_INFO                          sizeof(NET_GSM_HOME_CELLS_INFO_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct NET_GSM_SIM_NMR_INFO
#define NET_GSM_SIM_NMR_INFO                                  0x0E                                                     
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_length;
             uint8_t      measurement_results[16];
             uint8_t      fillerbyte1;
             uint8_t      number_of_channels;
             uint16_t     arfcn[0];
            } __attribute__((packed)) NET_GSM_SIM_NMR_INFO_STR;
#define SIZE_NET_GSM_SIM_NMR_INFO                             sizeof(NET_GSM_SIM_NMR_INFO_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct NET_MODEM_CAUSE_EXTENSION
#define NET_MODEM_CAUSE_EXTENSION                             0x0F                                                     
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_length;
             uint8_t      reject_code;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) NET_MODEM_CAUSE_EXTENSION_STR;
#define SIZE_NET_MODEM_CAUSE_EXTENSION                        sizeof(NET_MODEM_CAUSE_EXTENSION_STR)


//Definition for struct NET_MODEM_GSM_BAND_INFO
#define NET_MODEM_GSM_BAND_INFO                               0x11                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_length;
             uint8_t      band_info;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) NET_MODEM_GSM_BAND_INFO_STR;
#define SIZE_NET_MODEM_GSM_BAND_INFO                          sizeof(NET_MODEM_GSM_BAND_INFO_STR)


//Definition for struct NET_BAND_INFO
#define NET_BAND_INFO                                         0x17                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_length;
             uint16_t     fillerbyte1;
             uint32_t     gsm_band_info;
             uint32_t     wcdma_band_info;
            } __attribute__((packed)) NET_BAND_INFO_STR;
#define SIZE_NET_BAND_INFO                                    sizeof(NET_BAND_INFO_STR)


//Definition for struct NET_UTRAN_SIM_NMR_INFO
#define NET_UTRAN_SIM_NMR_INFO                                0x3D                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_length;
             uint8_t      meas_report_length;
             uint8_t      fillerbyte1;
             uint8_t      meas_report[0];
            } __attribute__((packed)) NET_UTRAN_SIM_NMR_INFO_STR;
#define SIZE_NET_UTRAN_SIM_NMR_INFO                           sizeof(NET_UTRAN_SIM_NMR_INFO_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct NET_ECID_GERAN_INFO
#define NET_ECID_GERAN_INFO                                   0x3E                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_length;
             uint16_t     current_mcc;
             uint16_t     current_mnc;
             uint16_t     current_lac;
             uint16_t     current_cell_id;
             uint8_t      current_ta;
             uint8_t      n_nmr;
             NET_GSM_NMR_LIST_SEQ_STR    gsm_nmr_list[0];
            } __attribute__((packed)) NET_ECID_GERAN_INFO_STR;
#define SIZE_NET_ECID_GERAN_INFO                              sizeof(NET_ECID_GERAN_INFO_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct NET_ECID_UTRAN_FDD_INFO
#define NET_ECID_UTRAN_FDD_INFO                               0x3F                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      fillerbyte1;
             uint16_t     sub_block_length;
             uint32_t     uc_id;
             uint16_t     current_mcc;
             uint16_t     current_mnc;
             uint16_t     pri_scrambling;
             uint16_t     uarfcn_dl;
             uint8_t      n_nmr;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
             uint8_t      fillerbyte4;
             NET_UTRAN_NEIGH_LIST_SEQ_STR    wcdma_nmr_list[0];
            } __attribute__((packed)) NET_ECID_UTRAN_FDD_INFO_STR;
#define SIZE_NET_ECID_UTRAN_FDD_INFO                          sizeof(NET_ECID_UTRAN_FDD_INFO_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct NET_RAT_INFO
#define NET_RAT_INFO                                          0x2C                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_length;
             uint8_t      rat_name;
             uint8_t      additional_rat_info_length;
             uint8_t      additional_rat_info[0];
            } __attribute__((packed)) NET_RAT_INFO_STR;
#define SIZE_NET_RAT_INFO                                     sizeof(NET_RAT_INFO_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct NET_GSM_LCS_GPS_REF_TIME
#define NET_GSM_LCS_GPS_REF_TIME                              0x2E                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      fillerbyte1;
             uint16_t     sub_block_length;
             uint32_t     gps_tow;
             uint16_t     gps_week;
             uint8_t      gsm_time_present;
             uint8_t      bsic;
             uint16_t     bcch_carrier;
             uint8_t      tn;
             uint8_t      bn;
             uint32_t     fnm;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
             uint8_t      fillerbyte4;
             uint8_t      n_ta;
             NET_GSM_LCS_GPS_TOW_ASSIST_SEQ_STR    gps_tow_assist[0];
            } __attribute__((packed)) NET_GSM_LCS_GPS_REF_TIME_STR;
#define SIZE_NET_GSM_LCS_GPS_REF_TIME                         sizeof(NET_GSM_LCS_GPS_REF_TIME_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct NET_GSM_LCS_GPS_REF_LOCATION
#define NET_GSM_LCS_GPS_REF_LOCATION                          0x2F                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      fillerbyte1;
             uint16_t     sub_block_length;
             uint8_t      byte_count;
             uint8_t      shape_bytes[14];
             uint8_t      fillerbyte2;
            } __attribute__((packed)) NET_GSM_LCS_GPS_REF_LOCATION_STR;
#define SIZE_NET_GSM_LCS_GPS_REF_LOCATION                     sizeof(NET_GSM_LCS_GPS_REF_LOCATION_STR)


//Definition for struct NET_GSM_LCS_GPS_DGPS_CORRECTIONS
#define NET_GSM_LCS_GPS_DGPS_CORRECTIONS                      0x30                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      fillerbyte1;
             uint16_t     sub_block_length;
             uint32_t     gps_tow;
             uint8_t      status;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
             uint8_t      n_sat;
             NET_GSM_LCS_GPS_SAT_LIST_SEQ_STR    sat_list[0];
            } __attribute__((packed)) NET_GSM_LCS_GPS_DGPS_CORRECTIONS_STR;
#define SIZE_NET_GSM_LCS_GPS_DGPS_CORRECTIONS                 sizeof(NET_GSM_LCS_GPS_DGPS_CORRECTIONS_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct NET_GSM_LCS_GPS_NAVIGATION
#define NET_GSM_LCS_GPS_NAVIGATION                            0x31                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      fillerbyte1;
             uint16_t     sub_block_length;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
             uint8_t      fillerbyte4;
             uint8_t      n_sat;
             NET_GSM_LCS_GPS_NAV_LIST_SEQ_STR    sat_list[0];
            } __attribute__((packed)) NET_GSM_LCS_GPS_NAVIGATION_STR;
#define SIZE_NET_GSM_LCS_GPS_NAVIGATION                       sizeof(NET_GSM_LCS_GPS_NAVIGATION_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct NET_GSM_LCS_GPS_IONOSPHERIC
#define NET_GSM_LCS_GPS_IONOSPHERIC                           0x32                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      fillerbyte1;
             uint16_t     sub_block_length;
             int8_t       alfa_0;
             int8_t       alfa_1;
             int8_t       alfa_2;
             int8_t       alfa_3;
             int8_t       beta_0;
             int8_t       beta_1;
             int8_t       beta_2;
             int8_t       beta_3;
            } __attribute__((packed)) NET_GSM_LCS_GPS_IONOSPHERIC_STR;
#define SIZE_NET_GSM_LCS_GPS_IONOSPHERIC                      sizeof(NET_GSM_LCS_GPS_IONOSPHERIC_STR)


//Definition for struct NET_GSM_LCS_GPS_UTC
#define NET_GSM_LCS_GPS_UTC                                   0x33                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      fillerbyte1;
             uint16_t     sub_block_length;
             int32_t      utc_a1;
             int32_t      utc_a0;
             uint8_t      utc_tot;
             uint8_t      utc_wnt;
             int8_t       utc_delta_tls;
             uint8_t      utc_wnlsf;
             int8_t       utc_dn;
             int8_t       utc_delta_tlsf;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
            } __attribute__((packed)) NET_GSM_LCS_GPS_UTC_STR;
#define SIZE_NET_GSM_LCS_GPS_UTC                              sizeof(NET_GSM_LCS_GPS_UTC_STR)


//Definition for struct NET_GSM_LCS_GPS_ALMANAC
#define NET_GSM_LCS_GPS_ALMANAC                               0x34                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      fillerbyte1;
             uint16_t     sub_block_length;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
             uint8_t      almanac_wna;
             uint8_t      n_sat;
             NET_GSM_LCS_GPS_ALMANAC_LIST_SEQ_STR    sat_list[0];
            } __attribute__((packed)) NET_GSM_LCS_GPS_ALMANAC_STR;
#define SIZE_NET_GSM_LCS_GPS_ALMANAC                          sizeof(NET_GSM_LCS_GPS_ALMANAC_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct NET_GSM_LCS_GPS_AQUISITION
#define NET_GSM_LCS_GPS_AQUISITION                            0x35                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      fillerbyte1;
             uint16_t     sub_block_length;
             uint32_t     gps_tow;
             uint8_t      gsm_time_present;
             uint8_t      bsic;
             uint16_t     bcch_carrier;
             uint32_t     fnm;
             uint8_t      tn;
             uint8_t      bn;
             uint8_t      fillerbyte2;
             uint8_t      n_sat;
             NET_GSM_LCS_GPS_AQUIS_LIST_SEQ_STR    sat_list[0];
            } __attribute__((packed)) NET_GSM_LCS_GPS_AQUISITION_STR;
#define SIZE_NET_GSM_LCS_GPS_AQUISITION                       sizeof(NET_GSM_LCS_GPS_AQUISITION_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct NET_GSM_LCS_GPS_BAD_SAT
#define NET_GSM_LCS_GPS_BAD_SAT                               0x36                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      fillerbyte1;
             uint16_t     sub_block_length;
             uint8_t      byte_count;
             uint8_t      bad_sat[16];
             uint8_t      fillerbyte2[3];
            } __attribute__((packed)) NET_GSM_LCS_GPS_BAD_SAT_STR;
#define SIZE_NET_GSM_LCS_GPS_BAD_SAT                          sizeof(NET_GSM_LCS_GPS_BAD_SAT_STR)


//Definition for struct NET_GSM_LCS_SUPL
#define NET_GSM_LCS_SUPL                                      0x3A                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      fillerbyte1;
             uint16_t     sub_block_length;
             uint32_t     supl_id;
             uint8_t      rrlp_ref_nbr;
             uint8_t      status;
             uint16_t     fillerbyte2;
            } __attribute__((packed)) NET_GSM_LCS_SUPL_STR;
#define SIZE_NET_GSM_LCS_SUPL                                 sizeof(NET_GSM_LCS_SUPL_STR)


//Definition for struct NET_GSM_LCS_EXT_REF_IE
#define NET_GSM_LCS_EXT_REF_IE                                0x3B                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      fillerbyte1;
             uint16_t     sub_block_length;
             uint32_t     ext_tran_id;
             uint8_t      smlc_code;
             uint8_t      fillerbyte2[3];
            } __attribute__((packed)) NET_GSM_LCS_EXT_REF_IE_STR;
#define SIZE_NET_GSM_LCS_EXT_REF_IE                           sizeof(NET_GSM_LCS_EXT_REF_IE_STR)


//Definition for struct NET_GSM_LCS_GPS_TIME_ASSIST_MEAS
#define NET_GSM_LCS_GPS_TIME_ASSIST_MEAS                      0x44                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      fillerbyte1;
             uint16_t     sub_block_length;
            } __attribute__((packed)) NET_GSM_LCS_GPS_TIME_ASSIST_MEAS_STR;
#define SIZE_NET_GSM_LCS_GPS_TIME_ASSIST_MEAS                 sizeof(NET_GSM_LCS_GPS_TIME_ASSIST_MEAS_STR)


//Definition for struct NET_GSM_LCS_GPS_REF_TIME_UNC
#define NET_GSM_LCS_GPS_REF_TIME_UNC                          0x45                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      fillerbyte1;
             uint16_t     sub_block_length;
             uint8_t      gps_ref_time_unc;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
             uint8_t      fillerbyte4;
            } __attribute__((packed)) NET_GSM_LCS_GPS_REF_TIME_UNC_STR;
#define SIZE_NET_GSM_LCS_GPS_REF_TIME_UNC                     sizeof(NET_GSM_LCS_GPS_REF_TIME_UNC_STR)


//Definition for struct NET_MODEM_UMA_SERVICE_ZONE_INFO
#define NET_MODEM_UMA_SERVICE_ZONE_INFO                       0x37                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_length;
             uint8_t      uma_service_zone_inicator;
             uint8_t      alpha_tag_length;
             uint8_t      alpha_tag[0];
            } __attribute__((packed)) NET_MODEM_UMA_SERVICE_ZONE_INFO_STR;
#define SIZE_NET_MODEM_UMA_SERVICE_ZONE_INFO                  sizeof(NET_MODEM_UMA_SERVICE_ZONE_INFO_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct NET_UMA_FAILURE_INFO
#define NET_UMA_FAILURE_INFO                                  0x38                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_length;
             uint8_t      failure_cause;
             uint8_t      failure_severity;
             uint8_t      failure_phase;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
            } __attribute__((packed)) NET_UMA_FAILURE_INFO_STR;
#define SIZE_NET_UMA_FAILURE_INFO                             sizeof(NET_UMA_FAILURE_INFO_STR)


//Definition for struct NET_UTRAN_RADIO_INFO
#define NET_UTRAN_RADIO_INFO                                  0x3C                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_length;
             uint8_t      radio_state;
             uint8_t      hsdpa_allocated;
             uint8_t      hsupa_allocated;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
            } __attribute__((packed)) NET_UTRAN_RADIO_INFO_STR;
#define SIZE_NET_UTRAN_RADIO_INFO                             sizeof(NET_UTRAN_RADIO_INFO_STR)


//Definition for struct NET_UARFCN_INFO
#define NET_UARFCN_INFO                                       0x28                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_length;
             uint16_t     uarfcn;
            } __attribute__((packed)) NET_UARFCN_INFO_STR;
#define SIZE_NET_UARFCN_INFO                                  sizeof(NET_UARFCN_INFO_STR)


//Definition for struct NET_GSM_CELL_INFO
#define NET_GSM_CELL_INFO                                     0x46                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_length;
             uint16_t     current_lac;
             uint32_t     current_cell_id;
             uint32_t     net_gsm_cell_info_band;
             uint8_t      operator_code[3];
             uint8_t      service_status;
             uint8_t      network_type;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
            } __attribute__((packed)) NET_GSM_CELL_INFO_STR;
#define SIZE_NET_GSM_CELL_INFO                                sizeof(NET_GSM_CELL_INFO_STR)


//Definition for struct NET_WCDMA_CELL_INFO
#define NET_WCDMA_CELL_INFO                                   0x47                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_length;
             uint16_t     current_lac;
             uint32_t     current_cell_id;
             uint32_t     net_wcdma_cell_info_band;
             uint8_t      operator_code[3];
             uint8_t      service_status;
             uint8_t      network_type;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
            } __attribute__((packed)) NET_WCDMA_CELL_INFO_STR;
#define SIZE_NET_WCDMA_CELL_INFO                              sizeof(NET_WCDMA_CELL_INFO_STR)


//Definition for struct NET_FULL_NITZ_NAME
#define NET_FULL_NITZ_NAME                                    0x48                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_length;
             uint8_t      data_length;
             uint8_t      fillerbyte1;
             uint8_t      data[0];
            } __attribute__((packed)) NET_FULL_NITZ_NAME_STR;
#define SIZE_NET_FULL_NITZ_NAME                               sizeof(NET_FULL_NITZ_NAME_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct NET_SHORT_NITZ_NAME
#define NET_SHORT_NITZ_NAME                                   0x49                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_length;
             uint8_t      data_length;
             uint8_t      fillerbyte1;
             uint8_t      data[0];
            } __attribute__((packed)) NET_SHORT_NITZ_NAME_STR;
#define SIZE_NET_SHORT_NITZ_NAME                              sizeof(NET_SHORT_NITZ_NAME_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//MESSAGES


//Definition for struct NET_MODEM_REG_STATUS_GET_REQ
#define NET_MODEM_REG_STATUS_GET_REQ                          0x00                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
            } __attribute__((packed)) NET_MODEM_REG_STATUS_GET_REQ_STR;
#define SIZE_NET_MODEM_REG_STATUS_GET_REQ                     sizeof(NET_MODEM_REG_STATUS_GET_REQ_STR)


//Definition for struct NET_MODEM_REG_STATUS_GET_RESP
#define NET_MODEM_REG_STATUS_GET_RESP                         0x01                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      success_code;
             uint8_t      sub_block_count;
            } __attribute__((packed)) NET_MODEM_REG_STATUS_GET_RESP_STR;
#define SIZE_NET_MODEM_REG_STATUS_GET_RESP                    sizeof(NET_MODEM_REG_STATUS_GET_RESP_STR)


//Definition for struct NET_MODEM_REG_STATUS_IND
#define NET_MODEM_REG_STATUS_IND                              0x02                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      sub_block_count;
            } __attribute__((packed)) NET_MODEM_REG_STATUS_IND_STR;
#define SIZE_NET_MODEM_REG_STATUS_IND                         sizeof(NET_MODEM_REG_STATUS_IND_STR)


//Definition for struct NET_MODEM_AVAILABLE_GET_REQ
#define NET_MODEM_AVAILABLE_GET_REQ                           0x03                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      mode;
             uint8_t      sub_block_count;
            } __attribute__((packed)) NET_MODEM_AVAILABLE_GET_REQ_STR;
#define SIZE_NET_MODEM_AVAILABLE_GET_REQ                      sizeof(NET_MODEM_AVAILABLE_GET_REQ_STR)


//Definition for struct NET_MODEM_AVAILABLE_GET_RESP
#define NET_MODEM_AVAILABLE_GET_RESP                          0x04                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      success_code;
             uint8_t      sub_block_count;
            } __attribute__((packed)) NET_MODEM_AVAILABLE_GET_RESP_STR;
#define SIZE_NET_MODEM_AVAILABLE_GET_RESP                     sizeof(NET_MODEM_AVAILABLE_GET_RESP_STR)


//Definition for struct NET_AVAILABLE_CANCEL_REQ
#define NET_AVAILABLE_CANCEL_REQ                              0x05                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
            } __attribute__((packed)) NET_AVAILABLE_CANCEL_REQ_STR;
#define SIZE_NET_AVAILABLE_CANCEL_REQ                         sizeof(NET_AVAILABLE_CANCEL_REQ_STR)


//Definition for struct NET_AVAILABLE_CANCEL_RESP
#define NET_AVAILABLE_CANCEL_RESP                             0x06                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      success_code;
            } __attribute__((packed)) NET_AVAILABLE_CANCEL_RESP_STR;
#define SIZE_NET_AVAILABLE_CANCEL_RESP                        sizeof(NET_AVAILABLE_CANCEL_RESP_STR)


//Definition for struct NET_SET_REQ
#define NET_SET_REQ                                           0x07                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      reg_in_another_protocol;
             uint8_t      sub_block_count;
            } __attribute__((packed)) NET_SET_REQ_STR;
#define SIZE_NET_SET_REQ                                      sizeof(NET_SET_REQ_STR)


//Definition for struct NET_SET_RESP
#define NET_SET_RESP                                          0x08                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      success_code;
             uint8_t      sub_block_count;
            } __attribute__((packed)) NET_SET_RESP_STR;
#define SIZE_NET_SET_RESP                                     sizeof(NET_SET_RESP_STR)


//Definition for struct NET_SET_CANCEL_REQ
#define NET_SET_CANCEL_REQ                                    0x09                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
            } __attribute__((packed)) NET_SET_CANCEL_REQ_STR;
#define SIZE_NET_SET_CANCEL_REQ                               sizeof(NET_SET_CANCEL_REQ_STR)


//Definition for struct NET_SET_CANCEL_RESP
#define NET_SET_CANCEL_RESP                                   0x0A                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      success_code;
            } __attribute__((packed)) NET_SET_CANCEL_RESP_STR;
#define SIZE_NET_SET_CANCEL_RESP                              sizeof(NET_SET_CANCEL_RESP_STR)


//Definition for struct NET_RSSI_GET_REQ
#define NET_RSSI_GET_REQ                                      0x0B                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      cs_type;
             uint8_t      measurement_type;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
             uint8_t      sub_block_count;
            } __attribute__((packed)) NET_RSSI_GET_REQ_STR;
#define SIZE_NET_RSSI_GET_REQ                                 sizeof(NET_RSSI_GET_REQ_STR)


//Definition for struct NET_RSSI_GET_RESP
#define NET_RSSI_GET_RESP                                     0x0C                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      success_code;
             uint8_t      sub_block_count;
            } __attribute__((packed)) NET_RSSI_GET_RESP_STR;
#define SIZE_NET_RSSI_GET_RESP                                sizeof(NET_RSSI_GET_RESP_STR)


//Definition for struct NET_RSSI_IND
#define NET_RSSI_IND                                          0x1E                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      signals_bar;
             uint8_t      rssi_in_dbm;
            } __attribute__((packed)) NET_RSSI_IND_STR;
#define SIZE_NET_RSSI_IND                                     sizeof(NET_RSSI_IND_STR)


//Definition for struct NET_CS_CONTROL_REQ
#define NET_CS_CONTROL_REQ                                    0x0D                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      control_message;
             uint8_t      sub_block_count;
            } __attribute__((packed)) NET_CS_CONTROL_REQ_STR;
#define SIZE_NET_CS_CONTROL_REQ                               sizeof(NET_CS_CONTROL_REQ_STR)


//Definition for struct NET_CS_CONTROL_RESP
#define NET_CS_CONTROL_RESP                                   0x0E                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      cs_type;
             uint8_t      success_code;
             uint8_t      control_message;
            } __attribute__((packed)) NET_CS_CONTROL_RESP_STR;
#define SIZE_NET_CS_CONTROL_RESP                              sizeof(NET_CS_CONTROL_RESP_STR)


//Definition for struct NET_CS_WAKEUP_REQ
#define NET_CS_WAKEUP_REQ                                     0x0F                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
            } __attribute__((packed)) NET_CS_WAKEUP_REQ_STR;
#define SIZE_NET_CS_WAKEUP_REQ                                sizeof(NET_CS_WAKEUP_REQ_STR)


//Definition for struct NET_CS_WAKEUP_RESP
#define NET_CS_WAKEUP_RESP                                    0x10                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
            } __attribute__((packed)) NET_CS_WAKEUP_RESP_STR;
#define SIZE_NET_CS_WAKEUP_RESP                               sizeof(NET_CS_WAKEUP_RESP_STR)


//Definition for struct NET_TEST_CARRIER_REQ
#define NET_TEST_CARRIER_REQ                                  0x11                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      operation;
             uint8_t      sub_block_count;
            } __attribute__((packed)) NET_TEST_CARRIER_REQ_STR;
#define SIZE_NET_TEST_CARRIER_REQ                             sizeof(NET_TEST_CARRIER_REQ_STR)


//Definition for struct NET_TEST_CARRIER_RESP
#define NET_TEST_CARRIER_RESP                                 0x12                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      success_code;
             uint8_t      sub_block_count;
            } __attribute__((packed)) NET_TEST_CARRIER_RESP_STR;
#define SIZE_NET_TEST_CARRIER_RESP                            sizeof(NET_TEST_CARRIER_RESP_STR)


//Definition for struct NET_NETWORK_SELECT_MODE_SET_REQ
#define NET_NETWORK_SELECT_MODE_SET_REQ                       0x1C                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      selection_mode;
            } __attribute__((packed)) NET_NETWORK_SELECT_MODE_SET_REQ_STR;
#define SIZE_NET_NETWORK_SELECT_MODE_SET_REQ                  sizeof(NET_NETWORK_SELECT_MODE_SET_REQ_STR)


//Definition for struct NET_NETWORK_SELECT_MODE_SET_RESP
#define NET_NETWORK_SELECT_MODE_SET_RESP                      0x1D                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      success_code;
            } __attribute__((packed)) NET_NETWORK_SELECT_MODE_SET_RESP_STR;
#define SIZE_NET_NETWORK_SELECT_MODE_SET_RESP                 sizeof(NET_NETWORK_SELECT_MODE_SET_RESP_STR)


//Definition for struct NET_CIPHERING_IND
#define NET_CIPHERING_IND                                     0x20                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      ciphering_status;
             uint8_t      sub_block_count;
            } __attribute__((packed)) NET_CIPHERING_IND_STR;
#define SIZE_NET_CIPHERING_IND                                sizeof(NET_CIPHERING_IND_STR)


//Definition for struct NET_TIME_IND
#define NET_TIME_IND                                          0x27                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      sub_block_count;
            } __attribute__((packed)) NET_TIME_IND_STR;
#define SIZE_NET_TIME_IND                                     sizeof(NET_TIME_IND_STR)


//Definition for struct NET_CS_STATE_IND
#define NET_CS_STATE_IND                                      0x19                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      cs_state;
             uint8_t      cs_type;
             uint8_t      cs_operation_mode;
             uint8_t      fillerbyte1[3];
            } __attribute__((packed)) NET_CS_STATE_IND_STR;
#define SIZE_NET_CS_STATE_IND                                 sizeof(NET_CS_STATE_IND_STR)


//Definition for struct NET_SIM_REFRESH_REQ
#define NET_SIM_REFRESH_REQ                                   0x32                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      refresh_type;
            } __attribute__((packed)) NET_SIM_REFRESH_REQ_STR;
#define SIZE_NET_SIM_REFRESH_REQ                              sizeof(NET_SIM_REFRESH_REQ_STR)


//Definition for struct NET_SIM_REFRESH_RESP
#define NET_SIM_REFRESH_RESP                                  0x33                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      success_code;
             uint8_t      refresh_type;
            } __attribute__((packed)) NET_SIM_REFRESH_RESP_STR;
#define SIZE_NET_SIM_REFRESH_RESP                             sizeof(NET_SIM_REFRESH_RESP_STR)


//Definition for struct NET_NEIGHBOUR_CELLS_REQ
#define NET_NEIGHBOUR_CELLS_REQ                               0x1A                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      cell_info_type;
            } __attribute__((packed)) NET_NEIGHBOUR_CELLS_REQ_STR;
#define SIZE_NET_NEIGHBOUR_CELLS_REQ                          sizeof(NET_NEIGHBOUR_CELLS_REQ_STR)


//Definition for struct NET_NEIGHBOUR_CELLS_RESP
#define NET_NEIGHBOUR_CELLS_RESP                              0x1B                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      success_code;
             uint8_t      sub_block_count;
            } __attribute__((packed)) NET_NEIGHBOUR_CELLS_RESP_STR;
#define SIZE_NET_NEIGHBOUR_CELLS_RESP                         sizeof(NET_NEIGHBOUR_CELLS_RESP_STR)


//Definition for struct NET_RAT_IND
#define NET_RAT_IND                                           0x35                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      sub_block_count;
            } __attribute__((packed)) NET_RAT_IND_STR;
#define SIZE_NET_RAT_IND                                      sizeof(NET_RAT_IND_STR)


//Definition for struct NET_RAT_REQ
#define NET_RAT_REQ                                           0x36                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      rat_type;
            } __attribute__((packed)) NET_RAT_REQ_STR;
#define SIZE_NET_RAT_REQ                                      sizeof(NET_RAT_REQ_STR)


//Definition for struct NET_RAT_RESP
#define NET_RAT_RESP                                          0x37                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      success_code;
             uint8_t      sub_block_count;
            } __attribute__((packed)) NET_RAT_RESP_STR;
#define SIZE_NET_RAT_RESP                                     sizeof(NET_RAT_RESP_STR)


//Definition for struct NET_GSM_LCS_LOCATION_IND
#define NET_GSM_LCS_LOCATION_IND                              0x31                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      indication_type;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) NET_GSM_LCS_LOCATION_IND_STR;
#define SIZE_NET_GSM_LCS_LOCATION_IND                         sizeof(NET_GSM_LCS_LOCATION_IND_STR)


//Definition for struct NET_GSM_LCS_ASTNC_NTF
#define NET_GSM_LCS_ASTNC_NTF                                 0x34                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      more_astnc_coming;
             uint8_t      sub_block_count;
            } __attribute__((packed)) NET_GSM_LCS_ASTNC_NTF_STR;
#define SIZE_NET_GSM_LCS_ASTNC_NTF                            sizeof(NET_GSM_LCS_ASTNC_NTF_STR)


//Definition for struct NET_AGPS_FRAME_TRIGGER_REQ
#define NET_AGPS_FRAME_TRIGGER_REQ                            0x38                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
            } __attribute__((packed)) NET_AGPS_FRAME_TRIGGER_REQ_STR;
#define SIZE_NET_AGPS_FRAME_TRIGGER_REQ                       sizeof(NET_AGPS_FRAME_TRIGGER_REQ_STR)


//Definition for struct NET_AGPS_FRAME_TRIGGER_RESP
#define NET_AGPS_FRAME_TRIGGER_RESP                           0x39                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint16_t     bit_no;
             uint32_t     frame_number;
             uint8_t      time_slot;
             uint8_t      ta;
             uint16_t     bcch_carrier;
             uint8_t      bsic;
             uint8_t      success_code;
            } __attribute__((packed)) NET_AGPS_FRAME_TRIGGER_RESP_STR;
#define SIZE_NET_AGPS_FRAME_TRIGGER_RESP                      sizeof(NET_AGPS_FRAME_TRIGGER_RESP_STR)


//Definition for struct NET_RRLP_SUPL_HANDLE_REQ
#define NET_RRLP_SUPL_HANDLE_REQ                              0x3D                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint16_t     data_length;
             uint32_t     supl_id;
             uint8_t      data[0];
            } __attribute__((packed)) NET_RRLP_SUPL_HANDLE_REQ_STR;
#define SIZE_NET_RRLP_SUPL_HANDLE_REQ                         sizeof(NET_RRLP_SUPL_HANDLE_REQ_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct NET_RRLP_SUPL_HANDLE_RESP
#define NET_RRLP_SUPL_HANDLE_RESP                             0x3E                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status_code;
             uint8_t      fillerbyte1;
             uint32_t     supl_id;
             uint16_t     data_length;
             uint16_t     fillerbyte2;
             uint8_t      data[0];
            } __attribute__((packed)) NET_RRLP_SUPL_HANDLE_RESP_STR;
#define SIZE_NET_RRLP_SUPL_HANDLE_RESP                        sizeof(NET_RRLP_SUPL_HANDLE_RESP_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct NET_CS_STATE_REQ
#define NET_CS_STATE_REQ                                      0x3A                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
            } __attribute__((packed)) NET_CS_STATE_REQ_STR;
#define SIZE_NET_CS_STATE_REQ                                 sizeof(NET_CS_STATE_REQ_STR)


//Definition for struct NET_CS_STATE_RESP
#define NET_CS_STATE_RESP                                     0x3B                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      success_code;
             uint8_t      cs_state;
             uint8_t      cs_operation_mode;
            } __attribute__((packed)) NET_CS_STATE_RESP_STR;
#define SIZE_NET_CS_STATE_RESP                                sizeof(NET_CS_STATE_RESP_STR)


//Definition for struct NET_UMA_INFO_IND
#define NET_UMA_INFO_IND                                      0x3C                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      sub_block_count;
            } __attribute__((packed)) NET_UMA_INFO_IND_STR;
#define SIZE_NET_UMA_INFO_IND                                 sizeof(NET_UMA_INFO_IND_STR)


//Definition for struct NET_RADIO_INFO_IND
#define NET_RADIO_INFO_IND                                    0x3F                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      sub_block_count;
            } __attribute__((packed)) NET_RADIO_INFO_IND_STR;
#define SIZE_NET_RADIO_INFO_IND                               sizeof(NET_RADIO_INFO_IND_STR)


//Definition for struct NET_CHANNEL_INFO_IND
#define NET_CHANNEL_INFO_IND                                  0x2C                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      sub_block_count;
            } __attribute__((packed)) NET_CHANNEL_INFO_IND_STR;
#define SIZE_NET_CHANNEL_INFO_IND                             sizeof(NET_CHANNEL_INFO_IND_STR)


//Definition for struct NET_CHANNEL_INFO_REQ
#define NET_CHANNEL_INFO_REQ                                  0x2D                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
            } __attribute__((packed)) NET_CHANNEL_INFO_REQ_STR;
#define SIZE_NET_CHANNEL_INFO_REQ                             sizeof(NET_CHANNEL_INFO_REQ_STR)


//Definition for struct NET_CHANNEL_INFO_RESP
#define NET_CHANNEL_INFO_RESP                                 0x2E                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      success_code;
             uint8_t      sub_block_count;
            } __attribute__((packed)) NET_CHANNEL_INFO_RESP_STR;
#define SIZE_NET_CHANNEL_INFO_RESP                            sizeof(NET_CHANNEL_INFO_RESP_STR)


//Definition for struct NET_CELL_INFO_GET_REQ
#define NET_CELL_INFO_GET_REQ                                 0x40                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
            } __attribute__((packed)) NET_CELL_INFO_GET_REQ_STR;
#define SIZE_NET_CELL_INFO_GET_REQ                            sizeof(NET_CELL_INFO_GET_REQ_STR)


//Definition for struct NET_CELL_INFO_GET_RESP
#define NET_CELL_INFO_GET_RESP                                0x41                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      success_code;
             uint8_t      sub_block_count;
            } __attribute__((packed)) NET_CELL_INFO_GET_RESP_STR;
#define SIZE_NET_CELL_INFO_GET_RESP                           sizeof(NET_CELL_INFO_GET_RESP_STR)


//Definition for struct NET_CELL_INFO_IND
#define NET_CELL_INFO_IND                                     0x42                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      sub_block_count;
            } __attribute__((packed)) NET_CELL_INFO_IND_STR;
#define SIZE_NET_CELL_INFO_IND                                sizeof(NET_CELL_INFO_IND_STR)


//Definition for struct NET_NITZ_NAME_IND
#define NET_NITZ_NAME_IND                                     0x43                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      operator_code[3];
             uint16_t     fillerbyte1;
             uint8_t      sub_block_count;
            } __attribute__((packed)) NET_NITZ_NAME_IND_STR;
#define SIZE_NET_NITZ_NAME_IND                                sizeof(NET_NITZ_NAME_IND_STR)

#endif
