#ifndef _PN_MON_ISI_H_
#define _PN_MON_ISI_H_

#include <stdint.h> 

//Resource Monitor Server
//PN_MON 0x38 
//ISI version 025.011
#define MONITOR_SERVER_ISI_VERSION_Z     25
#define MONITOR_SERVER_ISI_VERSION_Y     11

//In case of problems concerning content of this file contact Markku Loukusa, Sauli Laukka or Markus Mrsky
//Server specific message descriptions and feature&protocol descriptions can be found from: https://oucmswww.nmp.nokia.com:58443/document_browser/ccm_wa/GIF_SPECS/ 


//ISI VERSION CHANGE HISTORY

//Version: 026.000                                           
//Status: NonDraft                                          
//Date: 25-Sep-2007     Leon Joergensen
//Reason: Change request
//Reference: WP RM-RIM SCO: , Interface CR: ADB for SWAM : , NON-DRAFT

//Version: 025.011                                           
//Status: NonDraft                                          
//Date: 18-Feb-2008     Leon Joergensen
//Reason: Change request
//Reference: WP RM-RIM SCO: 408-2372 new interface for vendor trace activation , Interface CR: ADB for SWAM : LJ08042232409, NON-DRAFT

//Version: 025.010                                           
//Status: NonDraft                                          
//Date: 11-Dec-2007     Leon Joergensen
//Reason: Change request
//Reference: WP RM-RIM SCO: 408-3013 new interface for runtime enabling of invariant traces , Interface CR: ADB for SWAM : LJ07121872918 , NON-DRAFT

//Version: 025.009                                           
//Status: NonDraft                                          
//Date: O2-Jul-2007     Leon Joergensen
//Reason: Change request
//Reference: WP RM-RIM SCO: 408-1326, Interface CR: ADB for SWAM : , NON-DRAFT

//Version: 025.008                                           
//Status: NonDraft                                          
//Date: 25-Jun-2007     Leon Joergensen
//Reason: Change request
//Reference: WP RM-RIM SCO: 408-1327, Interface CR: ADB for SWAM : LJ07062549950., NON-DRAFT

//Version: 025.007                                           
//Status: NonDraft                                          
//Date: 19-Apr-2007     Leon Joergensen
//Reason: Change request
//Reference: WP RM-RIM SCO: 006-16126, Interface CR: ADB for SWAM : LJ07042043897., Inspection minutes: ADB for SWAM LJ07042043897 , NON-DRAFT

//Version: 025.006                                           
//Status: NonDraft                                          
//Date: 05-Mar-2007     Leon Joergensen
//Reason: Change request
//Reference: WP RM-RIM SCO: 006-15849 Monitor: Dynamic tracing of POWER HAL , Interface CR: ADB for SWAM : LJ07012936930. , Inspection minutes: ADB for SWAM LJ07030673792. , NON-DRAFT

//Version: 025.004                                           
//Status: NonDraft                                          
//Date: 14-Aug-2006     Leon Joergensen
//Reason: Comments from inspection
//Reference: Interface CR: ADB for SWAM LJ06081149783 , NON-DRAFT

//Version: 025.003                                           
//Status: NonDraft                                          
//Date: 11-Aug-2006     Leon Joergensen
//Reason: Change request
//Reference: WP RM-RIM SCO: 009-26604 Monitor: ER: Call to be dropped when battery temp too high , Interface CR: ADB for SWAM LJ06081149783 , NON-DRAFT

//Version: 025.002                                           
//Status: NonDraft                                          
//Date: 09-May-2006     Harri Turunen
//Reason: Change request
//Reference: Interface CR: ADB for SWAM HT06051132905. , NON-DRAFT

//Version: 025.001                                           
//Status: NonDraft                                          
//Date: 27-Mar-2006     Harri Turunen
//Reason: Change request
//Reference: Interface CR: ADB for SWAM HT06032256916. , NON-DRAFT

//Version: 025.000                                           
//Status: NonDraft                                          
//Date: 21-Feb-2006     Harri Turunen
//Reason: Change request
//Reference: Interface CR: ADB for SWAM HT06030649130. , NON-DRAFT

//Version: 024.004                                           
//Status: NonDraft                                          
//Date: 09-Jan-2006     Harri Turunen
//Reason: Change request
//Reference: Interface CR: ADB for SWAM HT06010548625. , NON-DRAFT

//Version: 024.003                                           
//Status: NonDraft                                          
//Date: 30-Nov-2005     Harri Turunen
//Reason: Change request
//Reference: Interface CR: ADB for SWAM HT05112243061. , Inspection minutes: ADB for SWAM HT05113033551. , NON-DRAFT

//Version: 024.002                                           
//Status: NonDraft                                          
//Date: 21-Nov-2005     Harri Turunen
//Reason: Change request
//Reference: Interface CR: ADB for SWAM HT05111555217. , Inspection minutes: ADB for SWAM HT05112060329. , NON-DRAFT

//Version: 024.001                                           
//Status: NonDraft                                          
//Date: 31-Oct-2005     Harri Turunen
//Reason: Change request
//Reference: Interface CR: ADB for SWAM HT05102537596. , Inspection minutes: ADB for SWAM HT05110158782. , NON-DRAFT

//Version: 024.000                                           
//Status: NonDraft                                          
//Date: 30-Sep-2005     Harri Turunen
//Reason: Change request
//Reference: Interface CR: ADB for SWAM HT05092627886. , Inspection minutes: ADB for SWAM HT05100349600. , NON-DRAFT

//Version: 023.000                                           
//Status: NonDraft                                          
//Date: 16-May-2005     Harri Turunen
//Reason: Change request
//Reference: Interface CR: ADB for SWAM HT05051334856. , Inspection minutes: ADB for SWAM HT05051652882. , NON-DRAFT

//Version: 022.000                                           
//Status: NonDraft                                          
//Date: 14-Apr-2005     Harri Turunen
//Reason: Change request
//Reference: Interface CR: ADB for SWAM HT05040551855. , Inspection minutes: ADB for SWAM HT05040758256. , NON-DRAFT

//Version: 021.001                                           
//Status: NonDraft                                          
//Date: 15-Feb-2005     Harri Turunen
//Reason: Change request
//Reference: Interface CR: ADB for SWAM HT05020858394. , Inspection minutes: ADB for SWAM HT05021547917. , NON-DRAFT

//Version: 021.000                                           
//Status: NonDraft                                          
//Date: 13-Dec-2004     Harri Turunen
//Reason: Change request
//Reference: Interface CR: ADB for SWAM HT04120856288. , Inspection minutes: ADB for SWAM HT04121447169. , NON-DRAFT

//Version: 020.025                                           
//Status: NonDraft                                          
//Date: 9-Nov-2004      Harri Turunen
//Reason: Change request
//Reference: Interface CR: ADB for SWAM HT04102936040. , Inspection minutes: ADB for SWAM HT04110559787. , NON-DRAFT

//Version: 020.024                                           
//Status: Unknown                                           
//Date: -               -
//Reason: -
//Reference: -

//Version: 020.023                                           
//Status: Unknown                                           
//Date: -               -
//Reason: -
//Reference: -

//Version: 020.022                                           
//Status: Unknown                                           
//Date: -               -
//Reason: -
//Reference: -

//Version: 020.021                                           
//Status: Unknown                                           
//Date: -               -
//Reason: -
//Reference: -

//Version: 020.020                                           
//Status: Unknown                                           
//Date: -               -
//Reason: -
//Reference: -

//Version: 020.019                                           
//Status: Unknown                                           
//Date: -               -
//Reason: -
//Reference: -

//Version: 020.017                                           
//Status: Unknown                                           
//Date: -               -
//Reason: -
//Reference: -

//Version: 020.015                                           
//Status: Unknown                                           
//Date: -               -
//Reason: -
//Reference: -

//Version: 020.014                                           
//Status: Unknown                                           
//Date: 24-Sep-2003     -
//Reason: -
//Reference: -

//Version: 020.013                                           
//Status: Unknown                                           
//Date: 28-Aug-2003     -
//Reason: -
//Reference: -

//Version: 020.010                                           
//Status: Unknown                                           
//Date: -               -
//Reason: -
//Reference: -

//Version: 020.009                                           
//Status: Unknown                                           
//Date: -               -
//Reason: -
//Reference: -

//Version: 020.007                                           
//Status: Unknown                                           
//Date: -               -
//Reason: -
//Reference: -

//Version: 020.005                                           
//Status: Unknown                                           
//Date: -               -
//Reason: -
//Reference: -

//Version: 020.003                                           
//Status: Unknown                                           
//Date: -               -
//Reason: -
//Reference: -

//Version: 020.002                                           
//Status: Unknown                                           
//Date: -               -
//Reason: -
//Reference: -

//Version: 020.001                                           
//Status: Unknown                                           
//Date: -               -
//Reason: -
//Reference: -

//Version: 020.000                                           
//Status: Unknown                                           
//Date: -               -
//Reason: -
//Reference: -

//Version: 019.006                                           
//Status: Unknown                                           
//Date: -               -
//Reason: -
//Reference: -

//Version: 019.005                                           
//Status: Unknown                                           
//Date: -               -
//Reason: -
//Reference: -

//Version: 019.004                                           
//Status: Unknown                                           
//Date: -               -
//Reason: -
//Reference: -

//Version: 019.003                                           
//Status: Unknown                                           
//Date: -               -
//Reason: -
//Reference: -

//Version: 019.002                                           
//Status: Unknown                                           
//Date: -               -
//Reason: -
//Reference: -

//Version: 019.001                                           
//Status: Unknown                                           
//Date: -               -
//Reason: -
//Reference: -

//Version: 019.000                                           
//Status: Unknown                                           
//Date: -               -
//Reason: -
//Reference: -

//Version: 018.000                                           
//Status: Unknown                                           
//Date: -               -
//Reason: -
//Reference: -

//Version: 017.000                                           
//Status: Unknown                                           
//Date: -               -
//Reason: -
//Reference: -

//Version: 016.000                                           
//Status: Unknown                                           
//Date: -               -
//Reason: -
//Reference: -


//CONSTANTS
#define MON_FTD_RESET_UNKNOWN                                 0x01                                                     
#define MON_FTD_RESET_POWER_OFF_CHARGER_CONNECTED             0x02                                                     
#define MON_FTD_RESET_POWER_OFF_KEY_PRESSED                   0x03                                                     
#define MON_FTD_RESET_SW_RESET_REQUESTED                      0x04                                                     
#define MON_FTD_RESET_INT_ERROR                               0x05                                                     
#define MON_FTD_RESET_STACK_OVERFLOW                          0x06                                                     
#define MON_FTD_RESET_WD_RESET_REQUESTED                      0x07                                                     
#define MON_FTD_RESET_DIV_BY_ZERO                             0x08                                                     
#define MON_FTD_RESET_DSP_NO_RESPONSE_ERROR                   0x09                                                     
#define MON_FTD_RESET_DSP_ERROR                               0x0A                                                     
#define MON_FTD_RESET_DSP_INVALID_MSG_ERROR                   0x0B                                                     
#define MON_FTD_RESET_PRODUCTION_RESET                        0x0C                                                     
#define MON_FTD_RESET_ASSERTION_FAILED                        0x0D                                                     
#define MON_FTD_RESET_UNDEFINED_INSTRUCTION                   0x0E                                                     
#define MON_FTD_RESET_IO_ABORT                                0x0F                                                     
#define MON_FTD_RESET_NULL_ACCESS                             0x10                                                  
#define MON_FTD_RESET_ADDRESS_ERROR                           0x11                                                  
#define MON_FTD_RESET_ALIGNMENT_ERROR                         0x12                                                  
#define MON_FTD_RESET_FLASH_WRITE_PROTECTION                  0x13                                                  
#define MON_FTD_RESET_CBUS_ERROR                              0x14                                                  
#define MON_FTD_RESET_POWER_OFF_RTC                           0x15                                                  
#define MON_FTD_RESET_OS_FATAL_HANDLER                        0x16                                                  
#define MON_FTD_RESET_FLASH_BLOCK_OVERFLOW                    0x17                                                  
#define MON_FTD_RESET_DSP_STARTUP_FAILED                      0x18                                                  
#define MON_FTD_RESET_ASIC_WD_RESET                           0x19                                                  
#define MON_FTD_RESET_EPOC_RESET                              0x1A                                                  
#define MON_FTD_RESET_ADSP_NO_RESPONSE_ERROR                  0x1B                                                  
#define MON_FTD_RESET_ADSP_ERROR                              0x1C                                                  
#define MON_FTD_RESET_ADSP_INVALID_MSG_ERROR                  0x1D                                                  
#define MON_FTD_RESET_ADSP_STARTUP_FAILED                     0x1E                                                  
#define MON_FTD_RESET_ABORT_EBUSC                             0x1F                                                  
#define MON_FTD_RESET_ABORT_PREFETCH                          0x20                                                  
#define MON_FTD_RESET_ABORT_DATA                              0x21                                                  
#define MON_ANY_SIZE                                          1                                                     
#define MON_RBUG_CMD_REQ                                      0x10                                                  
#define MON_RBUG_CMD_RESP                                     0x11                                                  
#define MON_RBUG_IND                                          0x12                                                  


//TABLES

//BitmaskTables for MON_HAL_TRACE_MASK_BITMAP
#define MON_HAL_TRACE_MASK_OFF                                0x00000000                                                     
#define MON_HAL_TRACE_MASK_GENERAL                            0x00000001                                                     
#define MON_HAL_TRACE_MASK_POWER                              0x00000002                                                     
#define MON_HAL_TRACE_MASK_TIMER                              0x00000004                                                     
#define MON_HAL_TRACE_MASK_MSIC                               0x00000008                                                     
#define MON_HAL_TRACE_MASK_DMA                                0x00000010                                                  
#define MON_HAL_TRACE_MASK_NMPRTLIB                           0x00000020                                                  
#define MON_HAL_TRACE_MASK_IRQ                                0x00000040                                                  
#define MON_HAL_TRACE_MASK_FIQ                                0x00000080                                                  
#define MON_HAL_TRACE_MASK_BSE                                0x00000100                                                   
#define MON_HAL_TRACE_MASK_INFO                               0x01000000                                               
#define MON_HAL_TRACE_MASK_ENTRY                              0x02000000                                               
#define MON_HAL_TRACE_MASK_EXIT                               0x04000000                                               
#define MON_HAL_TRACE_MASK_INTERNAL                           0x08000000                                               

//ConstantTable for MON_INV_TRACE_RUNTIME_STATUS
#define MON_INV_ENABLE                                        0x01                                                     
#define MON_INV_DISABLE                                       0x02                                                     

//ConstantTable for MON_INV_TRACE_RET_STATUS
#define MON_INV_OK                                            0x01                                                     
#define MON_INV_FAIL                                          0x02                                                     

//ConstantTable for MON_PPC_DATA_ALL
#define MON_PPC_ALL                                           0x00                                                     
#define MON_PPC_REQUESTED                                     0x01                                                     

//ConstantTable for MON_PPC_DATA_LAST
#define MON_PPC_LAST                                          0x00                                                     
#define MON_PPC_NOT_LAST                                      0x01                                                     

//ConstantTable for MON_TRACE_ACTIVATION_READ_SYM
#define MON_TRACE_ACTIVATION_BITMAP                           0x00                                                     
#define MON_TRACE_ACTIVATION_ENTITY_BITMAP                    0x01                                                     
#define MON_TRACE_ACTIVATION_SETTINGS                         0x02                                                     

//ConstantTable for MON_PPC_DATA_TYPE
#define MON_PPC_BYTE                                          0x00                                                     
#define MON_PPC_WORD                                          0x01                                                     
#define MON_PPC_DWORD                                         0x02                                                     

//ConstantTable for MON_PPC_ITEM_TYPE
#define MON_PPC_TYPE_NONE                                     0x00                                                     
#define MON_PPC_TYPE_RESET_DATE                               0x01                                                     
#define MON_PPC_TYPE_BYTE_COUNTER                             0x02                                                     
#define MON_PPC_TYPE_WORD_COUNTER                             0x03                                                     
#define MON_PPC_TYPE_DWORD_COUNTER                            0x04                                                     
#define MON_PPC_TYPE_FIFO                                     0x05                                                     
#define MON_PPC_TYPE_BITMAP                                   0x06                                                     
#define MON_PPC_TYPE_WATER_MARK                               0x07                                                     
#define MON_PPC_TYPE_BIGGEST_VAL                              0x08                                                     
#define MON_PPC_TYPE_FAST_COUNTER                             0x09                                                     
#define MON_PPC_TYPE_FAIL_INFO                                0x0A                                                     

//ConstantTable for MON_RESPONSE_SYMBOLS
#define MON_RESPONSE_OK                                       0x00                                                     
#define MON_RESPONSE_FAIL                                     0x01                                                     
#define MON_CAUSE_INVALID_PARAMETER                           0x02                                                     
#define MON_CAUSE_PMM_FAIL                                    0x03                                                     
#define MON_CAUSE_NO_ITEM_FOUND                               0x04                                                     
#define MON_CAUSE_SERVICE_DISABLED                            0x06                                                     
#define MON_CAUSE_EXT_TIME_STAMP_NOT_AVAILABLE                0x07                                                     
#define MON_CAUSE_TRACE_ACTIVATION_BUSY                       0x08                                                     
#define MON_CAUSE_DSP_FAIL                                    0x09                                                     
#define MON_CAUSE_UNKNOWN_ENTITY                              0x0A                                                     
#define MON_CAUSE_PARTIAL_UPDATE                              0x0B                                                     
#define MON_CAUSE_DSP_UNKNOWN_ENTITY                          0x0C                                                     
#define MON_CAUSE_DSP_PARTIAL_UPDATE                          0x0D                                                     
#define MON_CAUSE_DSP_UNSUPPORTED                             0x0E                                                     

//ConstantTable for MON_OS_TRACE_SYMBOLS
#define MON_OS_TRACE_OK                                       0x00                                                     
#define MON_OS_TRACE_FAIL                                     0x01                                                     
#define MON_OS_TRACE_ACT_ON_PMM                               0x02                                                     
#define MON_OS_TRACE_ACT_NOT_ON_PMM                           0x03                                                     

//ConstantTable for MON_OS_TRACE_COMMANDS
#define MON_OS_TRACE_ACT_SAVE_TO_PMM                          0x00                                                     
#define MON_OS_TRACE_ACT_ERASE_FROM_PMM                       0x01                                                     

//BitmaskTables for MON_OS_TRACE_CONTROL_BITMAP
#define MON_OS_MONITOR_DYNAMIC_HOOKS_BIT                      0x00000001                                                     
#define MON_OS_MONITOR_STATUS_HOOKS_BIT                       0x00000002                                                     
#define MON_OS_MONITOR_RESOURCE_HOOKS_BIT                     0x00000004                                                     
#define MON_OS_MONITOR_BLOCK_HOOKS_BIT                        0x00000008                                                     
#define MON_OS_MONITOR_MSG_HOOKS_BIT                          0x00000010                                                  
#define MON_OS_MONITOR_TIMER_HOOKS_BIT                        0x00000020                                                  
#define MON_OS_MONITOR_SCHEDULING_HOOKS_BIT                   0x00000040                                                  
#define MON_OS_MONITOR_STARTUP_HOOKS_BIT                      0x00000080                                                  
#define MON_OS_MONITOR_INFO_HOOKS_BIT                         0x00000100                                                   
#define MON_OS_MONITOR_WARNING_HOOKS_BIT                      0x00000200                                                   
#define MON_OS_MONITOR_INTERRUPT_HOOKS_BIT                    0x00000400                                                   

//BitmaskTables for MON_OS_TRACE_CONTROL_BITMAP
//#define MON_OS_MONITOR_DYNAMIC_HOOKS_BIT                    0x00000001                        //Already defined as 0x00000001
//#define MON_OS_MONITOR_STATUS_HOOKS_BIT                     0x00000002                        //Already defined as 0x00000002
//#define MON_OS_MONITOR_RESOURCE_HOOKS_BIT                   0x00000004                        //Already defined as 0x00000004
//#define MON_OS_MONITOR_BLOCK_HOOKS_BIT                      0x00000008                        //Already defined as 0x00000008
//#define MON_OS_MONITOR_MSG_HOOKS_BIT                        0x00000010                       //Already defined as 0x00000010
//#define MON_OS_MONITOR_TIMER_HOOKS_BIT                      0x00000020                       //Already defined as 0x00000020
//#define MON_OS_MONITOR_SCHEDULING_HOOKS_BIT                 0x00000040                       //Already defined as 0x00000040
//#define MON_OS_MONITOR_STARTUP_HOOKS_BIT                    0x00000080                       //Already defined as 0x00000080
//#define MON_OS_MONITOR_INFO_HOOKS_BIT                       0x00000100                      //Already defined as 0x00000100
//#define MON_OS_MONITOR_WARNING_HOOKS_BIT                    0x00000200                      //Already defined as 0x00000200
//#define MON_OS_MONITOR_INTERRUPT_HOOKS_BIT                  0x00000400                      //Already defined as 0x00000400
#define MON_OS_MONITOR_SIGNAL_BOOKS_BIT                       0x00000800                                                   

//ConstantTable for MON_FTD_SYM
#define MON_FTD_MODE_RD                                       0x04                                                     
#define MON_FTD_MODE_INFRA                                    0x02                                                     
#define MON_FTD_MODE_OPERATOR                                 0x01                                                     
#define MON_FTD_MODE_IDLE                                     0x00                                                     

//ConstantTable for MON_TRACE_SYM
#define MON_TRACE_ALL_POSSIBLE                                0x40                                                  
#define MON_TRACE_ALL_SHORT                                   0x41                                                  
#define MON_TRACE_ALL_EXTENDED                                0x42                                                  

//ConstantTable for MON_TIMESTAMP_SYM
#define MON_TRACE_TIME_STAMP_REQUESTED                        0x43                                                  
#define MON_TRACE_NO_TIME_STAMP                               0x44                                                  
#define MON_TRACE_EXT_TIME_STAMP_REQUESTED                    0x47                                                  

//ConstantTable for MON_TRACE_ACTIVATION_SYM
#define MON_TRACE_ACT_PMM_STORAGE                             0x45                                                  
#define MON_TRACE_ACT_NO_INIT_STORAGE                         0x46                                                  

//ConstantTable for MON_TRACE_TYPES_SYM

//ConstantTable for MON_PPC_SYM
#define MON_PPC_UPDATE_WAIT_RESPONSE                          0x60                                                  
#define MON_PPC_UPDATE_NO_RESPONSE                            0x61                                                  

//ConstantTable for MON_PPC_DEC_SYM
#define MON_PPC_DECREMENT_WAIT_RESPONSE                       0x62                                                  
#define MON_PPC_DECREMENT_NO_RESPONSE                         0x63                                                  

//ConstantTable for MON_OPERATOR_FTD_SYM
#define MON_OPERATOR_FTD_ACTIVATE                             0x00                                                     
#define MON_OPERATOR_FTD_DEACTIVATE                           0x01                                                     

//BitmaskTables for MON_TRACE_FAIL_REASONS
#define MON_CAUSE_EPOC_FAIL                                   0x0001                                                     
#define MON_CAUSE_BT_FAIL                                     0x0002                                                     

//ConstantTable for MON_DSP_RESPONSE_SYM
#define MON_DSP_UPDATE_WAIT_RESPONSE                          0x70                                                  
#define MON_DSP_UPDATE_NO_RESPONSE                            0x71                                                  

//ConstantTable for MON_ADSP_ERROR_SYM
#define MON_ADSP_FATAL_ERROR                                  0x00                                                     
#define MON_ADSP_NON_FATAL_ERROR                              0x01                                                     

//ConstantTable for MON_CDSP_ERROR_TYPE
#define MON_CDSP_USER_ERROR                                   0x00                                                     
#define MON_CDSP_OS_ERROR                                     0x01                                                     
#define MON_CDSP_USER_ERROR_LONG                              0x02                                                     
#define MON_CDSP_OS_ERROR_LONG                                0x03                                                     

//ConstantTable for MON_CDSP_ERROR_SEVERITY
#define MON_CDSP_FATAL_ERROR                                  0x00                                                     
#define MON_CDSP_NON_FATAL_ERROR                              0x01                                                     

//ConstantTable for MON_PPC_FT_TYPE_SYM
#define MON_PPC_FT_BYTE                                       0x00                                                     
#define MON_PPC_FT_WORD                                       0x01                                                     
#define MON_PPC_FT_DWORD                                      0x02                                                     
#define MON_PPC_FT_TABLE                                      0x03                                                     

//ConstantTable for MON_AUTOSMS_ACTION_SYM
#define MON_ENABLE                                            0x00                                                     
#define MON_DISABLE                                           0x01                                                     

//ConstantTable for MON_SENSOR_TEMP
#define MON_BATTERY_TEMP_MAX                                  0x00                                                     
#define MON_BATTERY_TEMP_NORMAL                               0x01                                                     

//ConstantTable for MON_TRACE_BITMAP_TYPE_SYM
#define MON_NOS_TRACES                                        0x00                                                     
#define MON_HAL_TRACES                                        0x01                                                     
#define MON_MASTER_TRACES                                     0x02                                                     
#define MON_VENDOR_DLL_TRACES                                 0x03                                                     
#define MON_PN_TRACES                                         0x04                                                     
#define MON_CM_TRACES                                         0x05                                                     
#define MON_MCU_TRACES_EXTENDED                               0x06                                                     
#define MON_MCU_TRACES_SHORT                                  0x07                                                     
#define MON_INVARIANT_TRACES                                  0x08                                                     
#define MON_UNKNOWN_SB_TRACES                                 0xFF                                                  

//BitmaskTables for MON_TRACE_ACTIVATION_READ_FLAGS_SYM
#define MON_DONT_READ_SETTINGS                                0x00                                                     
#define MON_READ_SETTINGS                                     0x01                                                     

//ConstantTable for FtdTable
#define FTD_SB_LAST_RESET_REASON                              0x0F00                                                   
#define FTD_SB_TASK_BEFORE_RESET                              0x0F01                                                   
#define FTD_SB_POINTER_TO_DEALLOC                             0x0F07                                                   
#define FTD_SB_PPC_DMM_OVER_DEALLOC                           0x0074                                                    
#define FTD_SB_TASK_DOUBLE_DEALLOC                            0x0F09                                                   
#define FTD_SB_DYNMEM_OVERWRITE                               0x0F0A                                                   
#define FTD_SB_DYNMEM_EXHAUSTED                               0x0F0B                                                   
#define FTD_SB_DYNMEM_INTERNAL                                0x0F0C                                                   
#define FTD_SB_MODIFIED_POINTER                               0x0F0D                                                   
#define FTD_SB_DYNMEM_BIG_BLOCK                               0x0F0E                                                   
#define FTD_SB_STACK_STATUS_1                                 0x0F22                                                   
#define FTD_SB_STACK_STATUS_2                                 0x0F23                                                   
#define FTD_SB_STACK_STATUS_3                                 0x0F24                                                   
#define FTD_SB_STACK_STATUS_4                                 0x0F25                                                   
#define FTD_SB_BLOCK_SET_STATUS_1                             0x0F26                                                   
#define FTD_SB_BLOCK_SET_STATUS_2                             0x0F27                                                   
#define FTD_SB_BLOCK_RES_SET1                                 0x0F30                                                   
#define FTD_SB_BLOCK_RES_SET2                                 0x0F31                                                   
#define FTD_SB_BLOCK_RES_SET3                                 0x0F32                                                   
#define FTD_SB_BLOCK_RES_SET4                                 0x0F33                                                   
#define FTD_SB_BLOCK_RES_SET5                                 0x0F34                                                   
#define FTD_SB_BLOCK_RES_SET6                                 0x0F35                                                   
#define FTD_SB_BLOCK_RES_SET7                                 0x0F36                                                   
#define FTD_SB_BLOCK_RES_SET8                                 0x0F37                                                   
#define FTD_SB_BLOCK_RES_SET9                                 0x0F38                                                   
#define FTD_SB_BLOCK_RES_SET10                                0x0F39                                                   
#define FTD_SB_BLOCK_RES_SET11                                0x0F3A                                                   
#define FTD_SB_BLOCK_RES_SET12                                0x0F3B                                                   
#define FTD_SB_BLOCK_RES_SET13                                0x0F3C                                                   
#define FTD_SB_BLOCK_RES_SET14                                0x0F3D                                                   
#define FTD_SB_BLOCK_RES_SET15                                0x0F3E                                                   
#define FTD_SB_BLOCK_RES_SET16                                0x0F3F                                                   
#define FTD_SB_FREE_BL_WORST_CASE_SET1                        0x0F40                                                   
#define FTD_SB_FREE_BL_WORST_CASE_SET2                        0x0F41                                                   
#define FTD_SB_FREE_BL_WORST_CASE_SET3                        0x0F42                                                   
#define FTD_SB_FREE_BL_WORST_CASE_SET4                        0x0F43                                                   
#define FTD_SB_FREE_BL_WORST_CASE_SET5                        0x0F44                                                   
#define FTD_SB_FREE_BL_WORST_CASE_SET6                        0x0F45                                                   
#define FTD_SB_FREE_BL_WORST_CASE_SET7                        0x0F46                                                   
#define FTD_SB_FREE_BL_WORST_CASE_SET8                        0x0F47                                                   
#define FTD_SB_FREE_BL_WORST_CASE_SET9                        0x0F48                                                   
#define FTD_SB_FREE_BL_WORST_CASE_SET10                       0x0F49                                                   
#define FTD_SB_FREE_BL_WORST_CASE_SET11                       0x0F4A                                                   
#define FTD_SB_FREE_BL_WORST_CASE_SET12                       0x0F4B                                                   
#define FTD_SB_FREE_BL_WORST_CASE_SET13                       0x0F4C                                                   
#define FTD_SB_FREE_BL_WORST_CASE_SET14                       0x0F4D                                                   
#define FTD_SB_FREE_BL_WORST_CASE_SET15                       0x0F4E                                                   
#define FTD_SB_FREE_BL_WORST_CASE_SET16                       0x0F4F                                                   
#define FTD_SB_STACK_STATUS_TASK_0                            0x0F50                                                   
#define FTD_SB_STACK_STATUS_TASK_1                            0x0F51                                                   
#define FTD_SB_STACK_STATUS_TASK_2                            0x0F52                                                   
#define FTD_SB_STACK_STATUS_TASK_3                            0x0F53                                                   
#define FTD_SB_STACK_STATUS_TASK_4                            0x0F54                                                   
#define FTD_SB_STACK_STATUS_TASK_5                            0x0F55                                                   
#define FTD_SB_STACK_STATUS_TASK_6                            0x0F56                                                   
#define FTD_SB_STACK_STATUS_TASK_7                            0x0F57                                                   
#define FTD_SB_STACK_STATUS_TASK_8                            0x0F58                                                   
#define FTD_SB_STACK_STATUS_TASK_9                            0x0F59                                                   
#define FTD_SB_STACK_STATUS_TASK_10                           0x0F5A                                                   
#define FTD_SB_STACK_STATUS_TASK_11                           0x0F5B                                                   
#define FTD_SB_STACK_STATUS_TASK_12                           0x0F5C                                                   
#define FTD_SB_STACK_STATUS_TASK_13                           0x0F5D                                                   
#define FTD_SB_STACK_STATUS_TASK_14                           0x0F5E                                                   
#define FTD_SB_STACK_STATUS_TASK_15                           0x0F5F                                                   
#define FTD_SB_STACK_STATUS_TASK_16                           0x0F60                                                   
#define FTD_SB_STACK_STATUS_TASK_17                           0x0F61                                                   
#define FTD_SB_STACK_STATUS_TASK_18                           0x0F62                                                   
#define FTD_SB_STACK_STATUS_TASK_19                           0x0F63                                                   
#define FTD_SB_STACK_STATUS_TASK_20                           0x0F64                                                   
#define FTD_SB_STACK_STATUS_TASK_21                           0x0F65                                                   
#define FTD_SB_STACK_STATUS_TASK_22                           0x0F66                                                   
#define FTD_SB_STACK_STATUS_TASK_23                           0x0F67                                                   
#define FTD_SB_STACK_STATUS_TASK_24                           0x0F68                                                   
#define FTD_SB_STACK_STATUS_TASK_25                           0x0F69                                                   
#define FTD_SB_STACK_STATUS_TASK_26                           0x0F6A                                                   
#define FTD_SB_STACK_STATUS_TASK_27                           0x0F6B                                                   
#define FTD_SB_STACK_STATUS_TASK_28                           0x0F6C                                                   
#define FTD_SB_STACK_STATUS_TASK_29                           0x0F6D                                                   
#define FTD_SB_STACK_STATUS_TASK_30                           0x0F6E                                                   
#define FTD_SB_STACK_STATUS_TASK_31                           0x0F6F                                                   
#define FTD_SB_STACK_STATUS_TASK_32                           0x0F70                                                   
#define FTD_SB_STACK_STATUS_TASK_33                           0x0F71                                                   
#define FTD_SB_STACK_STATUS_TASK_34                           0x0F72                                                   
#define FTD_SB_STACK_STATUS_TASK_35                           0x0F73                                                   
#define FTD_SB_STACK_STATUS_TASK_36                           0x0F74                                                   
#define FTD_SB_STACK_STATUS_TASK_37                           0x0F75                                                   
#define FTD_SB_STACK_STATUS_TASK_38                           0x0F76                                                   
#define FTD_SB_STACK_STATUS_TASK_39                           0x0F77                                                   
#define FTD_SB_STACK_STATUS_TASK_40                           0x0F7A                                                   
#define FTD_SB_STACK_STATUS_TASK_41                           0x0F7B                                                   
#define FTD_SB_STACK_STATUS_TASK_42                           0x0F7C                                                   
#define FTD_SB_STACK_STATUS_TASK_43                           0x0F7D                                                   
#define FTD_SB_STACK_STATUS_TASK_44                           0x0F7E                                                   
#define FTD_SB_STACK_STATUS_TASK_45                           0x0F7F                                                   
#define FTD_SB_STACK_STATUS_TASK_46                           0x1F98                                                
#define FTD_SB_STACK_STATUS_TASK_47                           0x1F99                                                
#define FTD_SB_STACK_STATUS_TASK_48                           0x1F9A                                                
#define FTD_SB_STACK_STATUS_TASK_49                           0x1F9B                                                
#define FTD_SB_STACK_STATUS_TASK_50                           0x1F9C                                                
#define FTD_SB_STACK_STATUS_TASK_51                           0x1F9D                                                
#define FTD_SB_STACK_STATUS_TASK_52                           0x1F9E                                                
#define FTD_SB_STACK_STATUS_TASK_53                           0x1F9F                                                
#define FTD_SB_STACK_STATUS_TASK_54                           0x1FA0                                                
#define FTD_SB_STACK_STATUS_TASK_55                           0x1FA1                                                
#define FTD_SB_STACK_STATUS_TASK_56                           0x1FA2                                                
#define FTD_SB_STACK_STATUS_TASK_57                           0x1FA3                                                
#define FTD_SB_STACK_STATUS_TASK_58                           0x1FA4                                                
#define FTD_SB_STACK_STATUS_TASK_59                           0x1FA5                                                
#define FTD_SB_STACK_STATUS_TASK_60                           0x1FA6                                                
#define FTD_SB_STACK_STATUS_TASK_61                           0x1FA7                                                
#define FTD_SB_STACK_STATUS_TASK_62                           0x1FA8                                                
#define FTD_SB_STACK_STATUS_TASK_63                           0x1FA9                                                
#define FTD_SB_STACK_STATUS_TASK_64                           0x1FAA                                                
#define FTD_SB_STACK_STATUS_TASK_65                           0x1FAB                                                
#define FTD_SB_STACK_STATUS_TASK_66                           0x1FAC                                                
#define FTD_SB_STACK_STATUS_TASK_67                           0x1FAD                                                
#define FTD_SB_STACK_STATUS_TASK_68                           0x1FAE                                                
#define FTD_SB_STACK_STATUS_SYSTEM_1                          0x0F78                                                   
#define FTD_SB_STACK_STATUS_SYSTEM_2                          0x0F79                                                   
#define FTD_SB_MSGBUF_STATUS_TASK_0                           0x0F80                                                   
#define FTD_SB_MSGBUF_STATUS_TASK_1                           0x0F81                                                   
#define FTD_SB_MSGBUF_STATUS_TASK_2                           0x0F82                                                   
#define FTD_SB_MSGBUF_STATUS_TASK_3                           0x0F83                                                   
#define FTD_SB_MSGBUF_STATUS_TASK_4                           0x0F84                                                   
#define FTD_SB_MSGBUF_STATUS_TASK_5                           0x0F85                                                   
#define FTD_SB_MSGBUF_STATUS_TASK_6                           0x0F86                                                   
#define FTD_SB_MSGBUF_STATUS_TASK_7                           0x0F87                                                   
#define FTD_SB_MSGBUF_STATUS_TASK_8                           0x0F88                                                   
#define FTD_SB_MSGBUF_STATUS_TASK_9                           0x0F89                                                   
#define FTD_SB_MSGBUF_STATUS_TASK_10                          0x0F8A                                                   
#define FTD_SB_MSGBUF_STATUS_TASK_11                          0x0F8B                                                   
#define FTD_SB_MSGBUF_STATUS_TASK_12                          0x0F8C                                                   
#define FTD_SB_MSGBUF_STATUS_TASK_13                          0x0F8D                                                   
#define FTD_SB_MSGBUF_STATUS_TASK_14                          0x0F8E                                                   
#define FTD_SB_MSGBUF_STATUS_TASK_15                          0x0F8F                                                   
#define FTD_SB_MSGBUF_STATUS_TASK_16                          0x0F90                                                   
#define FTD_SB_MSGBUF_STATUS_TASK_17                          0x0F91                                                   
#define FTD_SB_MSGBUF_STATUS_TASK_18                          0x0F92                                                   
#define FTD_SB_MSGBUF_STATUS_TASK_19                          0x0F93                                                   
#define FTD_SB_MSGBUF_STATUS_TASK_20                          0x0F94                                                   
#define FTD_SB_MSGBUF_STATUS_TASK_21                          0x0F95                                                   
#define FTD_SB_MSGBUF_STATUS_TASK_22                          0x0F96                                                   
#define FTD_SB_MSGBUF_STATUS_TASK_23                          0x0F97                                                   
#define FTD_SB_MSGBUF_STATUS_TASK_24                          0x0F98                                                   
#define FTD_SB_MSGBUF_STATUS_TASK_25                          0x0F99                                                   
#define FTD_SB_MSGBUF_STATUS_TASK_26                          0x0F9A                                                   
#define FTD_SB_MSGBUF_STATUS_TASK_27                          0x0F9B                                                   
#define FTD_SB_MSGBUF_STATUS_TASK_28                          0x0F9C                                                   
#define FTD_SB_MSGBUF_STATUS_TASK_29                          0x0F9D                                                   
#define FTD_SB_MSGBUF_STATUS_TASK_30                          0x0F9E                                                   
#define FTD_SB_MSGBUF_STATUS_TASK_31                          0x0F9F                                                   
#define FTD_SB_GSMDSP_STARTUP_FAILED                          0x0FA0                                                   
#define FTD_SB_GSMDSP_NO_RESPONSE                             0x0FA1                                                   
#define FTD_SB_GSMDSP_ERROR                                   0x0FA2                                                   
#define FTD_SB_TDMADSP_STARTUP_FAILED                         0x0FA3                                                   
#define FTD_SB_TDMADSP_NO_RESPONSE                            0x0FA4                                                   
#define FTD_SB_TDMADSP_ERROR                                  0x0FA5                                                   
#define FTD_SB_WCDMADSP_STARTUP_FAILED                        0x0FA9                                                   
#define FTD_SB_WCDMADSP_NO_RESPONSE                           0x0FAA                                                   
#define FTD_SB_WCDMADSP_ERROR                                 0x0FAB                                                   
#define FTD_SB_ADSP_STARTUP_FAILED                            0x0FAC                                                   
#define FTD_SB_ADSP_NO_RESPONSE                               0x0FAD                                                   
#define FTD_SB_ADSP_ERROR                                     0x0FAE                                                   
#define FTD_SB_SYSTEM_BEFORE_RESET                            0x0FAF                                                   
#define FTD_SB_MSGBUF_STATUS_TASK_32                          0x1F00                                                
#define FTD_SB_MSGBUF_STATUS_TASK_33                          0x1F01                                                
#define FTD_SB_MSGBUF_STATUS_TASK_34                          0x1F02                                                
#define FTD_SB_MSGBUF_STATUS_TASK_35                          0x1F03                                                
#define FTD_SB_MSGBUF_STATUS_TASK_36                          0x1F04                                                
#define FTD_SB_MSGBUF_STATUS_TASK_37                          0x1F05                                                
#define FTD_SB_MSGBUF_STATUS_TASK_38                          0x1F06                                                
#define FTD_SB_MSGBUF_STATUS_TASK_39                          0x1F07                                                
#define FTD_SB_MSGBUF_STATUS_TASK_40                          0x1F08                                                
#define FTD_SB_MSGBUF_STATUS_TASK_41                          0x1F09                                                
#define FTD_SB_MSGBUF_STATUS_TASK_42                          0x1F0A                                                
#define FTD_SB_MSGBUF_STATUS_TASK_43                          0x1F0B                                                
#define FTD_SB_MSGBUF_STATUS_TASK_44                          0x1F0C                                                
#define FTD_SB_MSGBUF_STATUS_TASK_45                          0x1F0D                                                
#define FTD_SB_MSGBUF_STATUS_TASK_46                          0x1F0E                                                
#define FTD_SB_MSGBUF_STATUS_TASK_47                          0x1FCF                                                
#define FTD_SB_MSGBUF_STATUS_TASK_48                          0x1FD0                                                
#define FTD_SB_MSGBUF_STATUS_TASK_49                          0x1FD1                                                
#define FTD_SB_MSGBUF_STATUS_TASK_50                          0x1FD2                                                
#define FTD_SB_MSGBUF_STATUS_TASK_51                          0x1FD3                                                
#define FTD_SB_MSGBUF_STATUS_TASK_52                          0x1FD4                                                
#define FTD_SB_MSGBUF_STATUS_TASK_53                          0x1FD5                                                
#define FTD_SB_MSGBUF_STATUS_TASK_54                          0x1FD6                                                
#define FTD_SB_MSGBUF_STATUS_TASK_55                          0x1FD7                                                
#define FTD_SB_MSGBUF_STATUS_TASK_56                          0x1FD8                                                
#define FTD_SB_MSGBUF_STATUS_TASK_57                          0x1FD9                                                
#define FTD_SB_MSGBUF_STATUS_TASK_58                          0x1FDA                                                
#define FTD_SB_MSGBUF_STATUS_TASK_59                          0x1FDB                                                
#define FTD_SB_MSGBUF_STATUS_TASK_60                          0x1FDC                                                
#define FTD_SB_MSGBUF_STATUS_TASK_61                          0x1FDD                                                
#define FTD_SB_MSGBUF_STATUS_TASK_62                          0x1FDE                                                
#define FTD_SB_MSGBUF_STATUS_TASK_63                          0x1FDF                                                
#define FTD_SB_MSGBUF_STATUS_TASK_64                          0x1FE0                                                
#define FTD_SB_MSGBUF_STATUS_TASK_65                          0x1FE1                                                
#define FTD_SB_MSGBUF_STATUS_TASK_66                          0x1FE2                                                
#define FTD_SB_MSGBUF_STATUS_TASK_67                          0x1FE3                                                
#define FTD_SB_MSGBUF_STATUS_TASK_68                          0x1FE4                                                
#define FTD_SB_FASTBUF_STATUS_TASK_0                          0x1F0F                                                
#define FTD_SB_FASTBUF_STATUS_TASK_1                          0x1F10                                                
#define FTD_SB_FASTBUF_STATUS_TASK_2                          0x1F11                                                
#define FTD_SB_FASTBUF_STATUS_TASK_3                          0x1F12                                                
#define FTD_SB_FASTBUF_STATUS_TASK_4                          0x1F13                                                
#define FTD_SB_FASTBUF_STATUS_TASK_5                          0x1F14                                                
#define FTD_SB_FASTBUF_STATUS_TASK_6                          0x1F15                                                
#define FTD_SB_FASTBUF_STATUS_TASK_7                          0x1F16                                                
#define FTD_SB_FASTBUF_STATUS_TASK_8                          0x1F17                                                
#define FTD_SB_FASTBUF_STATUS_TASK_9                          0x1F18                                                
#define FTD_SB_FASTBUF_STATUS_TASK_10                         0x1F19                                                
#define FTD_SB_FASTBUF_STATUS_TASK_11                         0x1F1A                                                
#define FTD_SB_FASTBUF_STATUS_TASK_12                         0x1F1B                                                
#define FTD_SB_FASTBUF_STATUS_TASK_13                         0x1F1C                                                
#define FTD_SB_FASTBUF_STATUS_TASK_14                         0x1F1D                                                
#define FTD_SB_FASTBUF_STATUS_TASK_15                         0x1F1E                                                
#define FTD_SB_FASTBUF_STATUS_TASK_16                         0x1F1F                                                
#define FTD_SB_FASTBUF_STATUS_TASK_17                         0x1F20                                                
#define FTD_SB_FASTBUF_STATUS_TASK_18                         0x1F21                                                
#define FTD_SB_FASTBUF_STATUS_TASK_19                         0x1F22                                                
#define FTD_SB_FASTBUF_STATUS_TASK_20                         0x1F23                                                
#define FTD_SB_FASTBUF_STATUS_TASK_21                         0x1F24                                                
#define FTD_SB_FASTBUF_STATUS_TASK_22                         0x1F25                                                
#define FTD_SB_FASTBUF_STATUS_TASK_23                         0x1F26                                                
#define FTD_SB_FASTBUF_STATUS_TASK_24                         0x1F27                                                
#define FTD_SB_FASTBUF_STATUS_TASK_25                         0x1F28                                                
#define FTD_SB_FASTBUF_STATUS_TASK_26                         0x1F29                                                
#define FTD_SB_FASTBUF_STATUS_TASK_27                         0x1F2A                                                
#define FTD_SB_FASTBUF_STATUS_TASK_28                         0x1F2B                                                
#define FTD_SB_FASTBUF_STATUS_TASK_29                         0x1F2C                                                
#define FTD_SB_FASTBUF_STATUS_TASK_30                         0x1F2D                                                
#define FTD_SB_FASTBUF_STATUS_TASK_31                         0x1F2E                                                
#define FTD_SB_FASTBUF_STATUS_TASK_32                         0x1F2F                                                
#define FTD_SB_FASTBUF_STATUS_TASK_33                         0x1F30                                                
#define FTD_SB_FASTBUF_STATUS_TASK_34                         0x1F31                                                
#define FTD_SB_FASTBUF_STATUS_TASK_35                         0x1F32                                                
#define FTD_SB_FASTBUF_STATUS_TASK_36                         0x1F33                                                
#define FTD_SB_FASTBUF_STATUS_TASK_37                         0x1F34                                                
#define FTD_SB_FASTBUF_STATUS_TASK_38                         0x1F35                                                
#define FTD_SB_FASTBUF_STATUS_TASK_39                         0x1F36                                                
#define FTD_SB_FASTBUF_STATUS_TASK_40                         0x1F37                                                
#define FTD_SB_FASTBUF_STATUS_TASK_41                         0x1F38                                                
#define FTD_SB_FASTBUF_STATUS_TASK_42                         0x1F39                                                
#define FTD_SB_FASTBUF_STATUS_TASK_43                         0x1F3A                                                
#define FTD_SB_FASTBUF_STATUS_TASK_44                         0x1F3B                                                
#define FTD_SB_FASTBUF_STATUS_TASK_45                         0x1F3C                                                
#define FTD_SB_FASTBUF_STATUS_TASK_46                         0x1F3D                                                
#define FTD_SB_FASTBUF_STATUS_TASK_47                         0x2005                                                
#define FTD_SB_FASTBUF_STATUS_TASK_48                         0x2006                                                
#define FTD_SB_FASTBUF_STATUS_TASK_49                         0x2007                                                
#define FTD_SB_FASTBUF_STATUS_TASK_50                         0x2008                                                
#define FTD_SB_FASTBUF_STATUS_TASK_51                         0x2009                                                
#define FTD_SB_FASTBUF_STATUS_TASK_52                         0x200A                                                
#define FTD_SB_FASTBUF_STATUS_TASK_53                         0x200B                                                
#define FTD_SB_FASTBUF_STATUS_TASK_54                         0x200C                                                
#define FTD_SB_FASTBUF_STATUS_TASK_55                         0x200D                                                
#define FTD_SB_FASTBUF_STATUS_TASK_56                         0x200E                                                
#define FTD_SB_FASTBUF_STATUS_TASK_57                         0x200F                                                
#define FTD_SB_FASTBUF_STATUS_TASK_58                         0x2010                                                
#define FTD_SB_FASTBUF_STATUS_TASK_59                         0x2011                                                
#define FTD_SB_FASTBUF_STATUS_TASK_60                         0x2012                                                
#define FTD_SB_FASTBUF_STATUS_TASK_61                         0x2013                                                
#define FTD_SB_FASTBUF_STATUS_TASK_62                         0x2014                                                
#define FTD_SB_FASTBUF_STATUS_TASK_63                         0x2015                                                
#define FTD_SB_FASTBUF_STATUS_TASK_64                         0x2016                                                
#define FTD_SB_FASTBUF_STATUS_TASK_65                         0x2017                                                
#define FTD_SB_FASTBUF_STATUS_TASK_66                         0x2018                                                
#define FTD_SB_FASTBUF_STATUS_TASK_67                         0x2019                                                
#define FTD_SB_FASTBUF_STATUS_TASK_68                         0x201A                                                
#define FTD_SB_TASKNAME_0                                     0x203B                                                
#define FTD_SB_TASKNAME_1                                     0x203C                                                
#define FTD_SB_TASKNAME_2                                     0x203D                                                
#define FTD_SB_TASKNAME_3                                     0x203E                                                
#define FTD_SB_TASKNAME_4                                     0x203F                                                
#define FTD_SB_TASKNAME_5                                     0x2040                                                
#define FTD_SB_TASKNAME_6                                     0x2041                                                
#define FTD_SB_TASKNAME_7                                     0x2042                                                
#define FTD_SB_TASKNAME_8                                     0x2043                                                
#define FTD_SB_TASKNAME_9                                     0x2044                                                
#define FTD_SB_TASKNAME_10                                    0x2045                                                
#define FTD_SB_TASKNAME_11                                    0x2046                                                
#define FTD_SB_TASKNAME_12                                    0x2047                                                
#define FTD_SB_TASKNAME_13                                    0x2048                                                
#define FTD_SB_TASKNAME_14                                    0x2049                                                
#define FTD_SB_TASKNAME_15                                    0x204A                                                
#define FTD_SB_TASKNAME_16                                    0x204B                                                
#define FTD_SB_TASKNAME_17                                    0x204C                                                
#define FTD_SB_TASKNAME_18                                    0x204D                                                
#define FTD_SB_TASKNAME_19                                    0x204E                                                
#define FTD_SB_TASKNAME_20                                    0x204F                                                
#define FTD_SB_TASKNAME_21                                    0x2050                                                
#define FTD_SB_TASKNAME_22                                    0x2051                                                
#define FTD_SB_TASKNAME_23                                    0x2052                                                
#define FTD_SB_TASKNAME_24                                    0x2053                                                
#define FTD_SB_TASKNAME_25                                    0x2054                                                
#define FTD_SB_TASKNAME_26                                    0x2055                                                
#define FTD_SB_TASKNAME_27                                    0x2056                                                
#define FTD_SB_TASKNAME_28                                    0x2057                                                
#define FTD_SB_TASKNAME_29                                    0x2058                                                
#define FTD_SB_TASKNAME_30                                    0x2059                                                
#define FTD_SB_TASKNAME_31                                    0x205A                                                
#define FTD_SB_TASKNAME_32                                    0x205B                                                
#define FTD_SB_TASKNAME_33                                    0x205C                                                
#define FTD_SB_TASKNAME_34                                    0x205D                                                
#define FTD_SB_TASKNAME_35                                    0x205E                                                
#define FTD_SB_TASKNAME_36                                    0x205F                                                
#define FTD_SB_TASKNAME_37                                    0x2060                                                
#define FTD_SB_TASKNAME_38                                    0x2061                                                
#define FTD_SB_TASKNAME_39                                    0x2062                                                
#define FTD_SB_TASKNAME_40                                    0x2063                                                
#define FTD_SB_TASKNAME_41                                    0x2064                                                
#define FTD_SB_TASKNAME_42                                    0x2065                                                
#define FTD_SB_TASKNAME_43                                    0x2066                                                
#define FTD_SB_TASKNAME_44                                    0x2067                                                
#define FTD_SB_TASKNAME_45                                    0x2068                                                
#define FTD_SB_TASKNAME_46                                    0x2069                                                
#define FTD_SB_TASKNAME_47                                    0x206A                                                
#define FTD_SB_TASKNAME_48                                    0x206B                                                
#define FTD_SB_TASKNAME_49                                    0x206C                                                
#define FTD_SB_TASKNAME_50                                    0x206D                                                
#define FTD_SB_TASKNAME_51                                    0x206E                                                
#define FTD_SB_TASKNAME_52                                    0x206F                                                
#define FTD_SB_TASKNAME_53                                    0x2070                                                
#define FTD_SB_TASKNAME_54                                    0x2071                                                
#define FTD_SB_TASKNAME_55                                    0x2072                                                
#define FTD_SB_TASKNAME_56                                    0x2073                                                
#define FTD_SB_TASKNAME_57                                    0x2074                                                
#define FTD_SB_TASKNAME_58                                    0x2075                                                
#define FTD_SB_TASKNAME_59                                    0x2076                                                
#define FTD_SB_TASKNAME_60                                    0x2077                                                
#define FTD_SB_TASKNAME_61                                    0x2078                                                
#define FTD_SB_TASKNAME_62                                    0x2079                                                
#define FTD_SB_TASKNAME_63                                    0x207A                                                
#define FTD_SB_TASKNAME_64                                    0x207B                                                
#define FTD_SB_TASKNAME_65                                    0x207C                                                
#define FTD_SB_TASKNAME_66                                    0x207D                                                
#define FTD_SB_TASKNAME_67                                    0x207E                                                
#define FTD_SB_TASKNAME_68                                    0x207F                                                
#define FTD_SB_STACK_PRE_RESET_STATUS_0                       0x20A1                                                
#define FTD_SB_STACK_PRE_RESET_STATUS_1                       0x20A2                                                
#define FTD_SB_STACK_PRE_RESET_STATUS_2                       0x20A3                                                
#define FTD_SB_STACK_PRE_RESET_STATUS_3                       0x20A4                                                
#define FTD_SB_STACK_PRE_RESET_STATUS_4                       0x20A5                                                
#define FTD_SB_STACK_PRE_RESET_STATUS_5                       0x20A6                                                
#define FTD_SB_STACK_PRE_RESET_STATUS_6                       0x20A7                                                
#define FTD_SB_STACK_PRE_RESET_STATUS_7                       0x20A8                                                
#define FTD_SB_STACK_PRE_RESET_STATUS_8                       0x20A9                                                
#define FTD_SB_STACK_PRE_RESET_STATUS_9                       0x20AA                                                
#define FTD_SB_STACK_PRE_RESET_STATUS_10                      0x20AB                                                
#define FTD_SB_STACK_PRE_RESET_STATUS_11                      0x20AC                                                
#define FTD_SB_STACK_PRE_RESET_STATUS_12                      0x20AD                                                
#define FTD_SB_STACK_PRE_RESET_STATUS_13                      0x20AE                                                
#define FTD_SB_STACK_PRE_RESET_STATUS_14                      0x20AF                                                
#define FTD_SB_STACK_PRE_RESET_STATUS_15                      0x20B0                                                
#define FTD_SB_STACK_PRE_RESET_STATUS_16                      0x20B1                                                
#define FTD_SB_STACK_PRE_RESET_STATUS_17                      0x20B2                                                
#define FTD_SB_STACK_PRE_RESET_STATUS_18                      0x20B3                                                
#define FTD_SB_STACK_PRE_RESET_STATUS_19                      0x20B4                                                
#define FTD_SB_STACK_PRE_RESET_STATUS_20                      0x20B5                                                
#define FTD_SB_STACK_PRE_RESET_STATUS_21                      0x20B6                                                
#define FTD_SB_STACK_PRE_RESET_STATUS_22                      0x20B7                                                
#define FTD_SB_STACK_PRE_RESET_STATUS_23                      0x20B8                                                
#define FTD_SB_STACK_PRE_RESET_STATUS_24                      0x20B9                                                
#define FTD_SB_STACK_PRE_RESET_STATUS_25                      0x20BA                                                
#define FTD_SB_STACK_PRE_RESET_STATUS_26                      0x20BB                                                
#define FTD_SB_STACK_PRE_RESET_STATUS_27                      0x20BC                                                
#define FTD_SB_STACK_PRE_RESET_STATUS_28                      0x20BD                                                
#define FTD_SB_STACK_PRE_RESET_STATUS_29                      0x20BE                                                
#define FTD_SB_STACK_PRE_RESET_STATUS_30                      0x20BF                                                
#define FTD_SB_STACK_PRE_RESET_STATUS_31                      0x20C0                                                
#define FTD_SB_STACK_PRE_RESET_STATUS_32                      0x20C1                                                
#define FTD_SB_STACK_PRE_RESET_STATUS_33                      0x20C2                                                
#define FTD_SB_STACK_PRE_RESET_STATUS_34                      0x20C3                                                
#define FTD_SB_STACK_PRE_RESET_STATUS_35                      0x20C4                                                
#define FTD_SB_STACK_PRE_RESET_STATUS_36                      0x20C5                                                
#define FTD_SB_STACK_PRE_RESET_STATUS_37                      0x20C6                                                
#define FTD_SB_STACK_PRE_RESET_STATUS_38                      0x20C7                                                
#define FTD_SB_STACK_PRE_RESET_STATUS_39                      0x20C8                                                
#define FTD_SB_STACK_PRE_RESET_STATUS_40                      0x20C9                                                
#define FTD_SB_STACK_PRE_RESET_STATUS_41                      0x20CA                                                
#define FTD_SB_STACK_PRE_RESET_STATUS_42                      0x20CB                                                
#define FTD_SB_STACK_PRE_RESET_STATUS_43                      0x20CC                                                
#define FTD_SB_STACK_PRE_RESET_STATUS_44                      0x20CD                                                
#define FTD_SB_STACK_PRE_RESET_STATUS_45                      0x20CE                                                
#define FTD_SB_STACK_PRE_RESET_STATUS_46                      0x20CF                                                
#define FTD_SB_STACK_PRE_RESET_STATUS_47                      0x20D0                                                
#define FTD_SB_STACK_PRE_RESET_STATUS_48                      0x20D1                                                
#define FTD_SB_STACK_PRE_RESET_STATUS_49                      0x20D2                                                
#define FTD_SB_STACK_PRE_RESET_STATUS_50                      0x20D3                                                
#define FTD_SB_STACK_PRE_RESET_STATUS_51                      0x20D4                                                
#define FTD_SB_STACK_PRE_RESET_STATUS_52                      0x20D5                                                
#define FTD_SB_STACK_PRE_RESET_STATUS_53                      0x20D6                                                
#define FTD_SB_STACK_PRE_RESET_STATUS_54                      0x20D7                                                
#define FTD_SB_STACK_PRE_RESET_STATUS_55                      0x20D8                                                
#define FTD_SB_STACK_PRE_RESET_STATUS_56                      0x20D9                                                
#define FTD_SB_STACK_PRE_RESET_STATUS_57                      0x20DA                                                
#define FTD_SB_STACK_PRE_RESET_STATUS_58                      0x20DB                                                
#define FTD_SB_STACK_PRE_RESET_STATUS_59                      0x20DC                                                
#define FTD_SB_STACK_PRE_RESET_STATUS_60                      0x20DD                                                
#define FTD_SB_STACK_PRE_RESET_STATUS_61                      0x20DE                                                
#define FTD_SB_STACK_PRE_RESET_STATUS_62                      0x20DF                                                
#define FTD_SB_STACK_PRE_RESET_STATUS_63                      0x20E0                                                
#define FTD_SB_STACK_PRE_RESET_STATUS_64                      0x20E1                                                
#define FTD_SB_STACK_PRE_RESET_STATUS_65                      0x20E2                                                
#define FTD_SB_STACK_PRE_RESET_STATUS_66                      0x20E3                                                
#define FTD_SB_STACK_PRE_RESET_STATUS_67                      0x20E4                                                
#define FTD_SB_STACK_PRE_RESET_STATUS_68                      0x20E5                                                
#define FTD_SB_STACK_PRE_RESET_STATUS_SYSTEM_1                0x20E6                                                
#define FTD_SB_STACK_PRE_RESET_STATUS_SYSTEM_2                0x20E7                                                
#define FTD_SB_TASK_SET_TOGGLE                                0x2109                                                
#define FTD_SB_TASK_SET_STATUS                                0x210A                                                
#define FTD_SB_FLASH_BLOCK_OVERFLOW                           0x2200                                                
#define FTD_SB_CBUS_RESET                                     0x2201                                                
#define FTD_SB_OS_FATAL_RESET                                 0x2202                                                
#define FTD_SB_EPOC_RESET                                     0x2203                                                
#define FTD_SB_HEAP_LARGEST_FREE                              0x2204                                                
#define FTD_SB_MON_DSP_MAIN_ERR_CODE_0                        0x2205                                                
#define FTD_SB_MON_DSP_EXTRA_ERR_CODE_0                       0x2206                                                
#define FTD_SB_MON_DSP_MAIN_ERR_CODE_1                        0x2207                                                
#define FTD_SB_MON_DSP_EXTRA_ERR_CODE_1                       0x2208                                                
#define FTD_SB_MON_DSP_MAIN_ERR_CODE_2                        0x2209                                                
#define FTD_SB_MON_DSP_EXTRA_ERR_CODE_2                       0x220A                                                
#define FTD_SB_MON_DSP_MAIN_ERR_CODE_3                        0x220B                                                
#define FTD_SB_MON_DSP_EXTRA_ERR_CODE_3                       0x220C                                                
#define FTD_SB_MON_DSP_MAIN_ERR_CODE_4                        0x220D                                                
#define FTD_SB_MON_DSP_EXTRA_ERR_CODE_4                       0x220E                                                
#define FTD_SB_MON_DSP_MAIN_ERR_CODE_5                        0x220F                                                
#define FTD_SB_MON_DSP_EXTRA_ERR_CODE_5                       0x2210                                                
#define FTD_SB_MON_DSP_MAIN_ERR_CODE_6                        0x2211                                                
#define FTD_SB_MON_DSP_EXTRA_ERR_CODE_6                       0x2212                                                
#define FTD_SB_MON_DSP_MAIN_ERR_CODE_7                        0x2213                                                
#define FTD_SB_MON_DSP_EXTRA_ERR_CODE_7                       0x2214                                                
#define FTD_SB_MON_DSP_FATAL_ERR_CODE_DATE_0                  0x2215                                                
#define FTD_SB_MON_DSP_FATAL_ERR_CODE_TIME_0                  0x2216                                                
#define FTD_SB_MON_DSP_FATAL_ERR_CODE_DATE_1                  0x2217                                                
#define FTD_SB_MON_DSP_FATAL_ERR_CODE_TIME_1                  0x2218                                                
#define FTD_SB_MON_DSP_FATAL_ERR_CODE_DATE_2                  0x2219                                                
#define FTD_SB_MON_DSP_FATAL_ERR_CODE_TIME_2                  0x221A                                                
#define FTD_SB_MON_DSP_FATAL_ERR_CODE_DATE_3                  0x221B                                                
#define FTD_SB_MON_DSP_FATAL_ERR_CODE_TIME_3                  0x221C                                                
#define FTD_SB_MON_DSP_FATAL_ERR_CODE_DATE_4                  0x221D                                                
#define FTD_SB_MON_DSP_FATAL_ERR_CODE_TIME_4                  0x221E                                                
#define FTD_SB_MON_DSP_FATAL_ERR_CODE_DATE_5                  0x221F                                                
#define FTD_SB_MON_DSP_FATAL_ERR_CODE_TIME_5                  0x2220                                                
#define FTD_SB_MON_DSP_FATAL_ERR_CODE_DATE_6                  0x2221                                                
#define FTD_SB_MON_DSP_FATAL_ERR_CODE_TIME_6                  0x2222                                                
#define FTD_SB_MON_DSP_FATAL_ERR_CODE_DATE_7                  0x2223                                                
#define FTD_SB_MON_DSP_FATAL_ERR_CODE_TIME_7                  0x2224                                                
#define FTD_SB_MON_DSP_PID_LIST_LATEST_ENTRY_INDEX            0x2225                                                
#define FTD_SB_MON_DSP_RX_MSG_LIST_LATEST_ENTRY_INDEX         0x2226                                                
#define FTD_SB_MON_DSP_TX_MSG_LIST_LATEST_ENTRY_INDEX         0x2227                                                
#define FTD_SB_MON_DSP_WARNING_LIST_LATEST_ENTRY_INDEX        0x2228                                                
#define FTD_SB_MON_DSP_PID_0                                  0x2229                                                
#define FTD_SB_MON_DSP_PID_1                                  0x222A                                                
#define FTD_SB_MON_DSP_PID_2                                  0x222B                                                
#define FTD_SB_MON_DSP_PID_3                                  0x222C                                                
#define FTD_SB_MON_DSP_PID_4                                  0x222D                                                
#define FTD_SB_MON_DSP_PID_5                                  0x222E                                                
#define FTD_SB_MON_DSP_PID_6                                  0x222F                                                
#define FTD_SB_MON_DSP_PID_7                                  0x2230                                                
#define FTD_SB_MON_DSP_PID_8                                  0x2231                                                
#define FTD_SB_MON_DSP_PID_9                                  0x2232                                                
#define FTD_SB_MON_DSP_PID_10                                 0x2233                                                
#define FTD_SB_MON_DSP_PID_11                                 0x2234                                                
#define FTD_SB_MON_DSP_PID_12                                 0x2235                                                
#define FTD_SB_MON_DSP_PID_13                                 0x2236                                                
#define FTD_SB_MON_DSP_PID_14                                 0x2237                                                
#define FTD_SB_MON_DSP_PID_15                                 0x2238                                                
#define FTD_SB_MON_DSP_PID_16                                 0x2239                                                
#define FTD_SB_MON_DSP_PID_17                                 0x223A                                                
#define FTD_SB_MON_DSP_PID_18                                 0x223B                                                
#define FTD_SB_MON_DSP_PID_19                                 0x223C                                                
#define FTD_SB_MON_DSP_PID_20                                 0x223D                                                
#define FTD_SB_MON_DSP_PID_21                                 0x223E                                                
#define FTD_SB_MON_DSP_PID_22                                 0x223F                                                
#define FTD_SB_MON_DSP_PID_23                                 0x2240                                                
#define FTD_SB_MON_DSP_PID_24                                 0x2241                                                
#define FTD_SB_MON_DSP_PID_25                                 0x2242                                                
#define FTD_SB_MON_DSP_PID_26                                 0x2243                                                
#define FTD_SB_MON_DSP_PID_27                                 0x2244                                                
#define FTD_SB_MON_DSP_PID_28                                 0x2245                                                
#define FTD_SB_MON_DSP_PID_29                                 0x2246                                                
#define FTD_SB_MON_DSP_PID_30                                 0x2247                                                
#define FTD_SB_MON_DSP_PID_31                                 0x2248                                                
#define FTD_SB_MON_DSP_RX_SIGID_0                             0x2249                                                
#define FTD_SB_MON_DSP_RX_SIGID_1                             0x224A                                                
#define FTD_SB_MON_DSP_RX_SIGID_2                             0x224B                                                
#define FTD_SB_MON_DSP_RX_SIGID_3                             0x224C                                                
#define FTD_SB_MON_DSP_RX_SIGID_4                             0x224D                                                
#define FTD_SB_MON_DSP_RX_SIGID_5                             0x224E                                                
#define FTD_SB_MON_DSP_RX_SIGID_6                             0x224F                                                
#define FTD_SB_MON_DSP_RX_SIGID_7                             0x2250                                                
#define FTD_SB_MON_DSP_RX_SIGID_8                             0x2251                                                
#define FTD_SB_MON_DSP_RX_SIGID_9                             0x2252                                                
#define FTD_SB_MON_DSP_RX_SIGID_10                            0x2253                                                
#define FTD_SB_MON_DSP_RX_SIGID_11                            0x2254                                                
#define FTD_SB_MON_DSP_RX_SIGID_12                            0x2255                                                
#define FTD_SB_MON_DSP_RX_SIGID_13                            0x2256                                                
#define FTD_SB_MON_DSP_RX_SIGID_14                            0x2257                                                
#define FTD_SB_MON_DSP_RX_SIGID_15                            0x2258                                                
#define FTD_SB_MON_DSP_TX_SIGID_0                             0x2259                                                
#define FTD_SB_MON_DSP_TX_SIGID_1                             0x225A                                                
#define FTD_SB_MON_DSP_TX_SIGID_2                             0x225B                                                
#define FTD_SB_MON_DSP_TX_SIGID_3                             0x225C                                                
#define FTD_SB_MON_DSP_TX_SIGID_4                             0x225D                                                
#define FTD_SB_MON_DSP_TX_SIGID_5                             0x225E                                                
#define FTD_SB_MON_DSP_TX_SIGID_6                             0x225F                                                
#define FTD_SB_MON_DSP_TX_SIGID_7                             0x2260                                                
#define FTD_SB_MON_DSP_TX_SIGID_8                             0x2261                                                
#define FTD_SB_MON_DSP_TX_SIGID_9                             0x2262                                                
#define FTD_SB_MON_DSP_TX_SIGID_10                            0x2263                                                
#define FTD_SB_MON_DSP_TX_SIGID_11                            0x2264                                                
#define FTD_SB_MON_DSP_TX_SIGID_12                            0x2265                                                
#define FTD_SB_MON_DSP_TX_SIGID_13                            0x2266                                                
#define FTD_SB_MON_DSP_TX_SIGID_14                            0x2267                                                
#define FTD_SB_MON_DSP_TX_SIGID_15                            0x2268                                                
#define FTD_SB_MON_DSP_WARNING_CODE_0                         0x2269                                                
#define FTD_SB_MON_DSP_EXTRA_WARNING_CODE_0                   0x226A                                                
#define FTD_SB_MON_DSP_WARNING_CODE_1                         0x226B                                                
#define FTD_SB_MON_DSP_EXTRA_WARNING_CODE_1                   0x226C                                                
#define FTD_SB_MON_DSP_WARNING_CODE_2                         0x226D                                                
#define FTD_SB_MON_DSP_EXTRA_WARNING_CODE_2                   0x226E                                                
#define FTD_SB_MON_DSP_WARNING_CODE_3                         0x226F                                                
#define FTD_SB_MON_DSP_EXTRA_WARNING_CODE_3                   0x2270                                                
#define FTD_SB_MON_DSP_WARNING_CODE_4                         0x2271                                                
#define FTD_SB_MON_DSP_EXTRA_WARNING_CODE_4                   0x2272                                                
#define FTD_SB_MON_DSP_WARNING_CODE_5                         0x2273                                                
#define FTD_SB_MON_DSP_EXTRA_WARNING_CODE_5                   0x2274                                                
#define FTD_SB_MON_DSP_WARNING_CODE_6                         0x2275                                                
#define FTD_SB_MON_DSP_EXTRA_WARNING_CODE_6                   0x2276                                                
#define FTD_SB_MON_DSP_WARNING_CODE_7                         0x2277                                                
#define FTD_SB_MON_DSP_EXTRA_WARNING_CODE_7                   0x2278                                                
#define FTD_SB_OS_PRE_RESET_ERROR_STATUS                      0x1F3E                                                
#define FTD_SB_OS_PRE_RESET_ERROR_FUNCTION_ID                 0x1F3F                                                
#define FTD_SB_OS_PRE_RESET_ERROR_TASK                        0x1F40                                                
#define FTD_SB_OS_PRE_RESET_ERROR_PARAMETER_1                 0x1F41                                                
#define FTD_SB_OS_PRE_RESET_ERROR_PARAMETER_2                 0x1F42                                                
#define FTD_SB_OS_PRE_RESET_ERROR_PARAMETER_3                 0x1F43                                                
#define FTD_SB_OS_CURRENT_ERROR_STATUS                        0x1F44                                                
#define FTD_SB_OS_CURRENT_ERROR_FUNCTION_ID                   0x1F45                                                
#define FTD_SB_OS_CURRENT_ERROR_TASK                          0x1F46                                                
#define FTD_SB_OS_CURRENT_ERROR_PARAMETER_1                   0x1F47                                                
#define FTD_SB_OS_CURRENT_ERROR_PARAMETER_2                   0x1F48                                                
#define FTD_SB_OS_CURRENT_ERROR_PARAMETER_3                   0x1F49                                                
#define FTD_SB_OS_PRE_RESET_WARN_STATUS                       0x1F4A                                                
#define FTD_SB_OS_PRE_RESET_WARN_FUNCTION_ID                  0x1F4B                                                
#define FTD_SB_OS_PRE_RESET_WARN_TASK                         0x1F4C                                                
#define FTD_SB_OS_PRE_RESET_WARN_PARAMETER_1                  0x1F4D                                                
#define FTD_SB_OS_PRE_RESET_WARN_PARAMETER_2                  0x1F4E                                                
#define FTD_SB_OS_PRE_RESET_WARN_PARAMETER_3                  0x1F4F                                                
#define FTD_SB_OS_CURRENT_WARN_STATUS                         0x1F50                                                
#define FTD_SB_OS_CURRENT_WARN_FUNCTION_ID                    0x1F51                                                
#define FTD_SB_OS_CURRENT_WARN_TASK                           0x1F52                                                
#define FTD_SB_OS_CURRENT_WARN_PARAMETER_1                    0x1F53                                                
#define FTD_SB_OS_CURRENT_WARN_PARAMETER_2                    0x1F54                                                
#define FTD_SB_OS_CURRENT_WARN_PARAMETER_3                    0x1F55                                                
#define FTD_SB_OS_PRE_RESET_REM_STATUS                        0x1F56                                                
#define FTD_SB_OS_PRE_RESET_REM_FUNCTION_ID                   0x1F57                                                
#define FTD_SB_OS_PRE_RESET_REM_TASK                          0x1F58                                                
#define FTD_SB_OS_PRE_RESET_REM_PARAMETER_1                   0x1F59                                                
#define FTD_SB_OS_PRE_RESET_REM_PARAMETER_2                   0x1F5A                                                
#define FTD_SB_OS_PRE_RESET_REM_PARAMETER_3                   0x1F5B                                                
#define FTD_SB_OS_CURRENT_REM_STATUS                          0x1F5C                                                
#define FTD_SB_OS_CURRENT_REM_FUNCTION_ID                     0x1F5D                                                
#define FTD_SB_OS_CURRENT_REM_TASK                            0x1F5E                                                
#define FTD_SB_OS_CURRENT_REM_PARAMETER_1                     0x1F5F                                                
#define FTD_SB_OS_CURRENT_REM_PARAMETER_2                     0x1F60                                                
#define FTD_SB_OS_CURRENT_REM_PARAMETER_3                     0x1F61                                                
#define FTD_SB_HEAP_USED_BYTES                                0x1F62                                                
#define FTD_SB_HEAP_USED_BLOCKS                               0x1F63                                                
#define FTD_SB_HEAP_FREE_BYTES                                0x1F64                                                
#define FTD_SB_HEAP_FREE_BLOCKS                               0x1F65                                                
#define FTD_SB_HEAP_ZERO_ALLOCATES                            0x1F66                                                
#define FTD_SB_HEAP_DOUBLE_DEALLOC                            0x1F67                                                
#define FTD_SB_HEAP_INVALID_POINTER                           0x1F68                                                
#define FTD_SB_HEAP_CORRUPT_BLOCK                             0x1F69                                                
#define FTD_SB_HEAP_PNTRCHK_FAIL                              0x1F6A                                                
#define FTD_SB_ASSERT_LATEST_FILE                             0x1F6B                                                
#define FTD_SB_ASSERT_LATEST_LINE                             0x1F6C                                                
#define FTD_SB_ASSERT_TOTAL_COUNT                             0x1F6D                                                
#define FTD_SB_HEAP_MEM_OWNER_TASK_1                          0x1F6E                                                
#define FTD_SB_HEAP_MEM_OWNER_BLOCKS_1                        0x1F6F                                                
#define FTD_SB_HEAP_MEM_OWNER_TASK_2                          0x1F70                                                
#define FTD_SB_HEAP_MEM_OWNER_BLOCKS_2                        0x1F71                                                
#define FTD_SB_HEAP_MEM_OWNER_TASK_3                          0x1F72                                                
#define FTD_SB_HEAP_MEM_OWNER_BLOCKS_3                        0x1F73                                                
#define FTD_SB_HEAP_MEM_OWNER_TASK_4                          0x1F74                                                
#define FTD_SB_HEAP_MEM_OWNER_BLOCKS_4                        0x1F75                                                
#define FTD_SB_PPC_FLIP_OPEN_TIMES                            0x0405                                                   
#define FTD_SB_PPC_EL_ON_TIME                                 0x0406                                                   
#define FTD_SB_PPC_KEYPAD_CHINESE_CHARACTER_INPUT             0x0407                                                   
#define FTD_SB_PPC_LOGICAL_AREA_HIT_1                         0x0408                                                   
#define FTD_SB_PPC_LOGICAL_AREA_HIT_2                         0x0409                                                   
#define FTD_SB_PPC_LOGICAL_AREA_HIT_3                         0x040A                                                   
#define FTD_SB_PPC_LOGICAL_AREA_HIT_4                         0x040B                                                   
#define FTD_SB_PPC_LOGICAL_AREA_HIT_5                         0x040C                                                   
#define FTD_SB_PPC_LOGICAL_AREA_HIT_6                         0x040D                                                   
#define FTD_SB_PPC_LOGICAL_AREA_HIT_7                         0x040E                                                   
#define FTD_SB_PPC_LOGICAL_AREA_HIT_8                         0x040F                                                   
#define FTD_SB_PPC_LOGICAL_AREA_HIT_9                         0x0410                                                   
#define FTD_SB_PPC_HWRE_FIRST_HIT                             0x0401                                                   
#define FTD_SB_PPC_HWRE_IN_THE_LIST                           0x0402                                                   
#define FTD_SB_PPC_HWRE_NOT_IN_THE_LIST                       0x0403                                                   
#define FTD_SB_UNKNOWN_RESET                                  0x0F0F                                                   
#define FTD_SB_POFF_CHARGER_CNN                               0x0F10                                                   
#define FTD_SB_POFF_KEY                                       0x0F11                                                   
#define FTD_SB_SW_RESET                                       0x0F12                                                   
#define FTD_SB_INTERNAL_ERROR                                 0x0F13                                                   
#define FTD_SB_STACK_OF_RESET                                 0x0F14                                                   
#define FTD_SB_WATCHDOG_RESET                                 0x0F15                                                   
#define FTD_SB_DIV_BY_0_RESET                                 0x0F16                                                   
#define FTD_SB_DSP_DEAD_RESET                                 0x0F17                                                   
#define FTD_SB_DSP_ERROR                                      0x0F18                                                   
#define FTD_SB_INV_DSPMSG_RESET                               0x0F19                                                   
#define FTD_SB_PRODUCTION_RESET                               0x0F1A                                                   
#define FTD_SB_ASSERTFAIL_RESET                               0x0F1B                                                   
#define FTD_SB_UNDEFINSTR_RESET                               0x0F1C                                                   
#define FTD_SB_IO_ABORT_RESET                                 0x0F1D                                                   
#define FTD_SB_NULLPOINTER_RESET                              0x0F1E                                                   
#define FTD_SB_ADDR_ERROR_RESET                               0x0F1F                                                   
#define FTD_SB_ALIGNMENT_RESET                                0x0F20                                                   
#define FTD_SB_FLASH_WRITE_RESET                              0x0F21                                                   
#define FTD_SB_DSP_STARTUP_FAILED                             0x0F29                                                   
#define FTD_SB_UNHANDLED_ABORT_RESET                          0x0F2A                                                   
#define FTD_SB_GSM_DSP_RESET                                  0x0D00                                                   
#define FTD_BER_TEST_TOGGLE                                   0x0E00                                                   
#define FTD_BER_TEST_STATUS                                   0x0E01                                                   
#define FTD_BER_FRAMES_SENT                                   0x0E02                                                   
#define FTD_BER_FRAMES_RECEIVED                               0x0E03                                                   
#define FTD_BER_FRAMES_FAILED                                 0x0E04                                                   
#define FTD_BER_BAD_CRC                                       0x0E05                                                   
#define FTD_IRDA_MM_SW_VERSION                                0x0E06                                                   
#define FTD_IRDA_MM_HAL_VERSION                               0x0E07                                                   
#define FTD_IRDA_MM_TRANS_TYPE                                0x0E08                                                   
#define FTD_IRDA_HAL_FRAMES_SENT                              0x0E09                                                   
#define FTD_IRDA_HAL_FRAMES_RECEIVED                          0x0E0A                                                   
#define FTD_IRDA_HAL_FRAMES_SENT_FAILED                       0x0E0B                                                   
#define FTD_IRDA_HAL_FRAMES_RECEIVED_FAILED                   0x0E0C                                                   
#define FTD_IRDA_HAL_BYTES_SENT                               0x0E0D                                                   
#define FTD_IRDA_HAL_BYTES_RECEIVED                           0x0E0E                                                   
#define FTD_IRDA_HAL_CRC_FAILURES                             0x0E0F                                                   
#define FTD_IRDA_HAL_BER                                      0x0E10                                                   
#define FTD_IRDA_PROD_SELF_TEST_CONTROL                       0x0E11                                                   
#define FTD_IRDA_PROD_SELF_TEST_STATUS                        0x0E12                                                   
#define FTD_IRDA_LAP_BAUD                                     0x0E13                                                   
#define FTD_IRDA_LAP_BOFS                                     0x0E14                                                   
#define FTD_IRDA_LAP_MAX_FRAME_LENGTH                         0x0E15                                                   
#define FTD_IRDA_LAP_LINK_DISCONNECT_TIME                     0x0E16                                                   
#define FTD_IRDA_LAP_MIN_TURNAROUND                           0x0E17                                                   
#define FTD_IRDA_LAP_MAX_TURNAROUND                           0x0E18                                                   
#define FTD_IRDA_LAP_WINDOW_SIZE                              0x0E19                                                   
#define FTD_IRDA_LAP_STATUS                                   0x0E1A                                                   
#define FTD_IRDA_LAP_NR                                       0x0E1B                                                   
#define FTD_IRDA_LAP_NS                                       0x0E1C                                                   
#define FTD_IRDA_LAP_MISMATCHED                               0x0E1D                                                   
#define FTD_IRDA_LAP_ADDR_CONTENTION                          0x0E1E                                                   
#define FTD_IRDA_LAP_QUEUE_SIZE                               0x0E1F                                                   
#define FTD_IRDA_LAP_QUEUE_HIGH_WATERMARK                     0x0E20                                                   
#define FTD_IRDA_LAP_DISCOVERED_NUMBER_OF_DEVICES             0x0E21                                                   
#define FTD_IRDA_LAP_DISCOVERED_DEVICE_NUMBER                 0x0E22                                                   
#define FTD_IRDA_LAP_DISCOVERED_ADDRESS                       0x0E23                                                   
#define FTD_IRDA_LAP_DISCOVERED_SOL                           0x0E24                                                   
#define FTD_IRDA_LAP_DISCOVERED_SNIFFER                       0x0E25                                                   
#define FTD_IRDA_LAP_DISCOVERED_HINTS                         0x0E26                                                   
#define FTD_IRDA_LAP_DISCOVERED_NICKNAME                      0x0E27                                                   
#define FTD_IRDA_LAP_DISCOVERED_DEVICE_NUMBER_TO_DISPLAY      0x0E28                                                   
#define FTD_IRDA_LAP_TEST_FRAME_CONTROL                       0x0E29                                                   
#define FTD_IRDA_LAP_TEST_FRAME_STATUS                        0x0E2A                                                   
#define FTD_IRDA_LAP_TTP_CLOSED_LOOP_CONTROL                  0x0E2B                                                   
#define FTD_IRDA_LAP_TTP_CLOSED_LOOP_STATUS                   0x0E2C                                                   
#define FTD_IRDA_LMP_OBEX                                     0x0E2D                                                   
#define FTD_IRDA_LMP_IRCOMM3                                  0x0E2E                                                   
#define FTD_IRDA_LMP_IRCOMM9                                  0x0E2F                                                   
#define FTD_IRDA_LMP_IRCOMM_JAVA                              0x0E30                                                   
#define FTD_IRDA_LMP_IRDIAL                                   0x0E31                                                   
#define FTD_IRDA_LMP_PHONET                                   0x0E32                                                   
#define FTD_IRDA_LMP_IRFM                                     0x0E33                                                   
#define FTD_IRDA_LMP_IRNET                                    0x0E34                                                   
#define FTD_IRDA_LMP_STATION_CONTROL_STATE                    0x0E35                                                   
#define FTD_IRDA_LMP_CHANNEL_NUMBER                           0x0E36                                                   
#define FTD_IRDA_LMP_CHANNEL_USE                              0x0E37                                                   
#define FTD_IRDA_LMP_CHANNEL_STATE                            0x0E38                                                   
#define FTD_IRDA_LMP_CHANNEL_QUEUE_SIZE                       0x0E39                                                   
#define FTD_IRDA_LMP_CHANNEL_QUEUE_WATERMARK                  0x0E3A                                                   
#define FTD_IRDA_LMP_CHANNEL_BYTES_SENT                       0x0E3B                                                   
#define FTD_IRDA_LMP_CHANNEL_BYTES_RECEIVED                   0x0E3C                                                   
#define FTD_IRDA_LMP_CHANNEL_NUMBER_TO_DISPLAY                0x0E3D                                                   
#define FTD_IRDA_LMP_NOT_STARTED                              0x0E3E                                                   
#define FTD_IRDA_LMP_STILL_ACTIVE                             0x0E3F                                                   
#define FTD_IRDA_LMP_LOCAL_REQUEST                            0x0E40                                                   
#define FTD_IRDA_LMP_REMOTE_INDICATION                        0x0E41                                                   
#define FTD_IRDA_LMP_ACCESS                                   0x0E42                                                   
#define FTD_IRDA_LMP_WRONG_LSAP                               0x0E43                                                   
#define FTD_IRDA_LMP_MAX_CONN_REACHED                         0x0E44                                                   
#define FTD_IRDA_LMP_LACK_OF_RESOURCES                        0x0E45                                                   
#define FTD_IRDA_TTP_CHANNEL_NUMBER                           0x0E46                                                   
#define FTD_IRDA_TTP_SEND_CREDIT                              0x0E47                                                   
#define FTD_IRDA_TTP_REMOTE_CREDIT                            0x0E48                                                   
#define FTD_IRDA_AVAILABLE_CREDIT                             0x0E49                                                   
#define FTD_IRDA_TTP_TX_QUEUE_SIZE                            0x0E4A                                                   
#define FTD_IRDA_TTP_TX_QUEUE_HIGH_WATERMARK                  0x0E4B                                                   
#define FTD_IRDA_TTP_RX_QUEUE_SIZE                            0x0E4C                                                   
#define FTD_IRDA_TTP_RX_QUEUE_HIGH_WATERMARK                  0x0E4D                                                   
#define FTD_IRDA_TTP_STATE                                    0x0E4E                                                   
#define FTD_IRDA_TTP_FLOW_CONTROL_TOGGLES                     0x0E4F                                                   
#define FTD_IRDA_TTP_CHANNEL_NUMBER_TO_DISPLAY                0x0E50                                                   
#define FTD_IRDA_TTP_BAUD                                     0x0E51                                                   
#define FTD_IRDA_TTP_BOFS                                     0x0E52                                                   
#define FTD_IRDA_TTP_MAX_FRAME_LENGTH                         0x0E53                                                   
#define FTD_IRDA_TTP_LINK_DISCONNECT_TIME                     0x0E54                                                   
#define FTD_IRDA_TTP_MIN_TURNAROUND                           0x0E55                                                   
#define FTD_IRDA_TTP_MAX_TURNAROUND                           0x0E56                                                   
#define FTD_IRDA_TTP_WINDOW_SIZE                              0x0E57                                                   
#define FTD_IRDA_ISI_NUMBER_OF_IPC                            0x0E58                                                   
#define FTD_IRDA_ISI_IPC_BEING_DISPLAYED                      0x0E59                                                   
#define FTD_IRDA_ISI_IPC_FLOW                                 0x0E5A                                                   
#define FTD_IRDA_ISI_IPC_STATE                                0x0E5B                                                   
#define FTD_IRDA_ISI_MM_STATE                                 0x0E5C                                                   
#define FTD_IRDA_ULTRA_FRAMES_RECEIVED                        0x0E5D                                                   
#define FTD_IRDA_ISI_IPC_TO_DISPLAY                           0x0E5E                                                   
#define FTD_IRDA_ISI_DEVICE_ID                                0x0E5F                                                   
#define FTD_IRDA_ISI_OBJECT_ID                                0x0E60                                                   
#define FTD_IRDA_ISI_NAME_SERVICE_STATE                       0x0E61                                                   
#define FTD_IRDA_ISI_DEVICE_SERVICE_STATE                     0x0E62                                                   
#define FTD_IRDA_ISI_NAME_SERVICE_STATE_DEV_OBJ_ID_TO_DISPLAY    0x0E63                                                   
#define FTD_IRDA_MEMORY_SIZE                                  0x0E64                                                   
#define FTD_IRDA_MEMORY_HIGH_WATERMARK                        0x0E65                                                   
#define FTD_IRDA_MEMORY_BLOCKS_USED                           0x0E66                                                   
#define FTD_IRDA_MEMORY_BLOCKS_FREE                           0x0E67                                                   
#define FTD_IRDA_MEMORY_BLOCKS_HIGH_WATERMARK                 0x0E68                                                   
#define FTD_IRDA_IRCOMM_CHANNEL_ID                            0x0E69                                                   
#define FTD_IRDA_IRCOMM_IRDIAL_STATE                          0x0E6A                                                   
#define FTD_IRDA_IRCOMM_SERVICE_TYPE                          0x0E6B                                                   
#define FTD_IRDA_IRDIAL_FLOW_CONTROL                          0x0E6C                                                   
#define FTD_IRDA_IRCOMM_FLOW_CONTROL_RTS                      0x0E6D                                                   
#define FTD_IRDA_IRCOMM_FLOW_CONTROL_CTS                      0x0E6E                                                   
#define FTD_IRDA_IRCOMM_FLOW_CONTROL_DSR                      0x0E6F                                                   
#define FTD_IRDA_IRCOMM_FLOW_CONTROL_DTR                      0x0E70                                                   
#define FTD_IRDA_IRCOMM_FLOW_CONTROL_XON                      0x0E71                                                   
#define FTD_IRDA_IRCOMM_FLOW_CONTROL_XOFF                     0x0E72                                                   
#define FTD_IRDA_IRCOMM_FLOW_CONTROL_ENQ                      0x0E73                                                   
#define FTD_IRDA_IRCOMM_FLOW_CONTROL_ACK                      0x0E74                                                   
#define FTD_IRDA_IRCOMM_IRDIAL_BUFFER_SIZE                    0x0E75                                                   
#define FTD_IRDA_IRCOMM_IRDIAL_BUFFER_LOW_WATERMARK           0x0E76                                                   
#define FTD_IRDA_IRCOMM_IRDIAL_BUFFER_HIGH_WATERMARK          0x0E77                                                   
#define FTD_IRDA_IRCOMM_IRDIAL_BUFFER_EXCESS_WATERMARK        0x0E78                                                   
#define FTD_IRDA_IRCOMM_IRDIAL_CHANNEL_ID_TO_DISPLAY          0x0E79                                                   
#define FTD_USB_MM_SW_VERSION                                 0xFE00                                                
#define FTD_USB_MM_HAL_VERSION                                0xFE01                                                
#define FTD_USB_MM_CORE_VERSION                               0xFE02                                                
#define FTD_USB_MM_TIKU_VERSION                               0xFE03                                                
#define FTD_USB_MM_STATE                                      0xFE04                                                
#define FTD_USB_MM_DEVICE_STATE                               0xFE05                                                
#define FTD_USB_MM_BUS_STATE                                  0xFE06                                                
#define FTD_USB_MM_EM_STATE                                   0xFE07                                                
#define FTD_USB_MM_ATTACHES                                   0xFE08                                                
#define FTD_USB_MM_DETACHES                                   0xFE09                                                
#define FTD_USB_MM_SUSPENDS                                   0xFE0A                                                
#define FTD_USB_MM_RESUMES                                    0xFE0B                                                
#define FTD_USB_MM_RESETS                                     0xFE0C                                                
#define FTD_USB_MM_CURR_CONFIGURATION                         0xFE0D                                                
#define FTD_USB_MM_NO_TX_IRPS                                 0xFE0E                                                
#define FTD_USB_MM_NO_RX_IRPS                                 0xFE0F                                                
#define FTD_USB_MM_RESUME_LAST                                0xFE10                                                
#define FTD_USB_MM_RESUME_LONGEST                             0xFE11                                                
#define FTD_USB_MM_SUSPEND_LAST                               0xFE12                                                
#define FTD_USB_MM_SUSPEND_LONGEST                            0xFE13                                                
#define FTD_USB_MM_RESET_LAST                                 0xFE14                                                
#define FTD_USB_MM_RESET_LONGEST                              0xFE15                                                
#define FTD_USB_MM_WAKEUP_SUPPORTED                           0xFE16                                                
#define FTD_USB_MM_WAKEUP_ENABLED                             0xFE17                                                
#define FTD_USB_MM_WAKEUP_ATTEMPTS                            0xFE18                                                
#define FTD_USB_MM_DATA_LOG_CONTROL                           0xFE19                                                
#define FTD_USB_MM_DATA_TX                                    0xFE1A                                                
#define FTD_USB_MM_DATA_TX_TPUT_MOV_AV                        0xFE1B                                                
#define FTD_USB_MM_DATA_TX_TPUT_INST_AV                       0xFE1C                                                
#define FTD_USB_MM_DATA_RX                                    0xFE1D                                                
#define FTD_USB_MM_DATA_RX_TPUT_MOV_AV                        0xFE1E                                                
#define FTD_USB_MM_DATA_RX_TPUT_INST_AV                       0xFE1F                                                
#define FTD_USB_MM_PHONET_ACTIVE                              0xFE20                                                
#define FTD_USB_MM_PHONET_FLOW_CTRL                           0xFE21                                                
#define FTD_USB_MM_INFO_PHONET_IN_EP_NO                       0xFE22                                                
#define FTD_USB_MM_INFO_PHONET_LOOPBACK_IN                    0xFE23                                                
#define FTD_USB_MM_INFO_PHONET_IN_EP_STATUS                   0xFE24                                                
#define FTD_USB_MM_INFO_PHONET_IN_EP_SIZE                     0xFE25                                                
#define FTD_USB_MM_INFO_PHONET_OUT_EP_NO                      0xFE26                                                
#define FTD_USB_MM_INFO_PHONET_LOOPBACK_OUT                   0xFE27                                                
#define FTD_USB_MM_INFO_PHONET_OUT_STATUS                     0xFE28                                                
#define FTD_USB_MM_INFO_PHONET_OUT_EP_SIZE                    0xFE29                                                
#define FTD_USB_MM_INFO_1_NAME                                0xFE2A                                                
#define FTD_USB_MM_INFO_1_NSI_STATE                           0xFE2B                                                
#define FTD_USB_MM_INFO_1_ALT_INTERFACE                       0xFE2C                                                
#define FTD_USB_MM_INFO_1_PCR_STATE                           0xFE2D                                                
#define FTD_USB_MM_INFO_1_PIPE_HANDLE                         0xFE2E                                                
#define FTD_USB_MM_INFO_1_PIPE_STATE                          0xFE2F                                                
#define FTD_USB_MM_INFO_1_PIPE_RX_FLOW_STATE                  0xFE30                                                
#define FTD_USB_MM_INFO_1_IN_EP_NO                            0xFE31                                                
#define FTD_USB_MM_INFO_1_LOOPBACK_IN                         0xFE32                                                
#define FTD_USB_MM_INFO_1_IN_EP_STATUS                        0xFE33                                                
#define FTD_USB_MM_INFO_1_IN_EP_SIZE                          0xFE34                                                
#define FTD_USB_MM_INFO_1_OUT_EP_NO                           0xFE35                                                
#define FTD_USB_MM_INFO_1_LOOPBACK_OUT                        0xFE36                                                
#define FTD_USB_MM_INFO_1_OUT_STATUS                          0xFE37                                                
#define FTD_USB_MM_INFO_1_OUT_EP_SIZE                         0xFE38                                                
#define FTD_USB_MM_INFO_2_NAME                                0xFE39                                                
#define FTD_USB_MM_INFO_2_NSI_STATE                           0xFE3A                                                
#define FTD_USB_MM_INFO_2_ALT_INTERFACE                       0xFE3B                                                
#define FTD_USB_MM_INFO_2_PCR_STATE                           0xFE3C                                                
#define FTD_USB_MM_INFO_2_PIPE_HANDLE                         0xFE3D                                                
#define FTD_USB_MM_INFO_2_PIPE_STATE                          0xFE3E                                                
#define FTD_USB_MM_INFO_2_PIPE_RX_FLOW_STATE                  0xFE3F                                                
#define FTD_USB_MM_INFO_2_IN_EP_NO                            0xFE40                                                
#define FTD_USB_MM_INFO_2_LOOPBACK_IN                         0xFE41                                                
#define FTD_USB_MM_INFO_2_IN_EP_STATUS                        0xFE42                                                
#define FTD_USB_MM_INFO_2_IN_EP_SIZE                          0xFE43                                                
#define FTD_USB_MM_INFO_2_OUT_EP_NO                           0xFE44                                                
#define FTD_USB_MM_INFO_2_LOOPBACK_OUT                        0xFE45                                                
#define FTD_USB_MM_INFO_2_OUT_STATUS                          0xFE46                                                
#define FTD_USB_MM_INFO_2_OUT_EP_SIZE                         0xFE47                                                
#define FTD_USB_MM_INFO_3_NAME                                0xFE48                                                
#define FTD_USB_MM_INFO_3_NSI_STATE                           0xFE49                                                
#define FTD_USB_MM_INFO_3_ALT_INTERFACE                       0xFE4A                                                
#define FTD_USB_MM_INFO_3_PCR_STATE                           0xFE4B                                                
#define FTD_USB_MM_INFO_3_PIPE_HANDLE                         0xFE4C                                                
#define FTD_USB_MM_INFO_3_PIPE_STATE                          0xFE4D                                                
#define FTD_USB_MM_INFO_3_PIPE_RX_FLOW_STATE                  0xFE4E                                                
#define FTD_USB_MM_INFO_3_IN_EP_NO                            0xFE4F                                                
#define FTD_USB_MM_INFO_3_LOOPBACK_IN                         0xFE50                                                
#define FTD_USB_MM_INFO_3_IN_EP_STATUS                        0xFE51                                                
#define FTD_USB_MM_INFO_3_IN_EP_SIZE                          0xFE52                                                
#define FTD_USB_MM_INFO_3_OUT_EP_NO                           0xFE53                                                
#define FTD_USB_MM_INFO_3_LOOPBACK_OUT                        0xFE54                                                
#define FTD_USB_MM_INFO_3_OUT_STATUS                          0xFE55                                                
#define FTD_USB_MM_INFO_3_OUT_EP_SIZE                         0xFE56                                                
#define FTD_USB_MM_INFO_4_NAME                                0xFE57                                                
#define FTD_USB_MM_INFO_4_NSI_STATE                           0xFE58                                                
#define FTD_USB_MM_INFO_4_ALT_INTERFACE                       0xFE59                                                
#define FTD_USB_MM_INFO_4_PCR_STATE                           0xFE5A                                                
#define FTD_USB_MM_INFO_4_PIPE_HANDLE                         0xFE5B                                                
#define FTD_USB_MM_INFO_4_PIPE_STATE                          0xFE5C                                                
#define FTD_USB_MM_INFO_4_PIPE_RX_FLOW_STATE                  0xFE5D                                                
#define FTD_USB_MM_INFO_4_IN_EP_NO                            0xFE5E                                                
#define FTD_USB_MM_INFO_4_LOOPBACK_IN                         0xFE5F                                                
#define FTD_USB_MM_INFO_4_IN_EP_STATUS                        0xFE60                                                
#define FTD_USB_MM_INFO_4_IN_EP_SIZE                          0xFE61                                                
#define FTD_USB_MM_INFO_4_OUT_EP_NO                           0xFE62                                                
#define FTD_USB_MM_INFO_4_LOOPBACK_OUT                        0xFE63                                                
#define FTD_USB_MM_INFO_4_OUT_STATUS                          0xFE64                                                
#define FTD_USB_MM_INFO_4_OUT_EP_SIZE                         0xFE65                                                
#define FTD_USB_MM_INFO_5_NAME                                0xFE66                                                
#define FTD_USB_MM_INFO_5_NSI_STATE                           0xFE67                                                
#define FTD_USB_MM_INFO_5_ALT_INTERFACE                       0xFE68                                                
#define FTD_USB_MM_INFO_5_PCR_STATE                           0xFE69                                                
#define FTD_USB_MM_INFO_5_PIPE_HANDLE                         0xFE6A                                                
#define FTD_USB_MM_INFO_5_PIPE_STATE                          0xFE6B                                                
#define FTD_USB_MM_INFO_5_PIPE_RX_FLOW_STATE                  0xFE6C                                                
#define FTD_USB_MM_INFO_5_IN_EP_NO                            0xFE6D                                                
#define FTD_USB_MM_INFO_5_LOOPBACK_IN                         0xFE6E                                                
#define FTD_USB_MM_INFO_5_IN_EP_STATUS                        0xFE6F                                                
#define FTD_USB_MM_INFO_5_IN_EP_SIZE                          0xFE70                                                
#define FTD_USB_MM_INFO_5_OUT_EP_NO                           0xFE71                                                
#define FTD_USB_MM_INFO_5_LOOPBACK_OUT                        0xFE72                                                
#define FTD_USB_MM_INFO_5_OUT_STATUS                          0xFE73                                                
#define FTD_USB_MM_INFO_5_OUT_EP_SIZE                         0xFE74                                                
#define FTD_USB_MM_INFO_6_NAME                                0xFE75                                                
#define FTD_USB_MM_INFO_6_NSI_STATE                           0xFE76                                                
#define FTD_USB_MM_INFO_6_ALT_INTERFACE                       0xFE77                                                
#define FTD_USB_MM_INFO_6_PCR_STATE                           0xFE78                                                
#define FTD_USB_MM_INFO_6_PIPE_HANDLE                         0xFE79                                                
#define FTD_USB_MM_INFO_6_PIPE_STATE                          0xFE7A                                                
#define FTD_USB_MM_INFO_6_PIPE_RX_FLOW_STATE                  0xFE7B                                                
#define FTD_USB_MM_INFO_6_IN_EP_NO                            0xFE7C                                                
#define FTD_USB_MM_INFO_6_LOOPBACK_IN                         0xFE7D                                                
#define FTD_USB_MM_INFO_6_IN_EP_STATUS                        0xFE7E                                                
#define FTD_USB_MM_INFO_6_IN_EP_SIZE                          0xFE7F                                                
#define FTD_USB_MM_INFO_6_OUT_EP_NO                           0xFE80                                                
#define FTD_USB_MM_INFO_6_LOOPBACK_OUT                        0xFE81                                                
#define FTD_USB_MM_INFO_6_OUT_STATUS                          0xFE82                                                
#define FTD_USB_MM_INFO_6_OUT_EP_SIZE                         0xFE83                                                
#define FTD_USB_MM_INFO_7_NAME                                0xFE84                                                
#define FTD_USB_MM_INFO_7_NSI_STATE                           0xFE85                                                
#define FTD_USB_MM_INFO_7_ALT_INTERFACE                       0xFE86                                                
#define FTD_USB_MM_INFO_7_PCR_STATE                           0xFE87                                                
#define FTD_USB_MM_INFO_7_PIPE_HANDLE                         0xFE88                                                
#define FTD_USB_MM_INFO_7_PIPE_STATE                          0xFE89                                                
#define FTD_USB_MM_INFO_7_PIPE_RX_FLOW_STATE                  0xFE8A                                                
#define FTD_USB_MM_INFO_7_IN_EP_NO                            0xFE8B                                                
#define FTD_USB_MM_INFO_7_LOOPBACK_IN                         0xFE8C                                                
#define FTD_USB_MM_INFO_7_IN_EP_STATUS                        0xFE8D                                                
#define FTD_USB_MM_INFO_7_IN_EP_SIZE                          0xFE8E                                                
#define FTD_USB_MM_INFO_7_OUT_EP_NO                           0xFE8F                                                
#define FTD_USB_MM_INFO_7_LOOPBACK_OUT                        0xFE90                                                
#define FTD_USB_MM_INFO_7_OUT_STATUS                          0xFE91                                                
#define FTD_USB_MM_INFO_7_OUT_EP_SIZE                         0xFE92                                                
#define FTD_USB_MM_INFO_8_NAME                                0xFE93                                                
#define FTD_USB_MM_INFO_8_NSI_STATE                           0xFE94                                                
#define FTD_USB_MM_INFO_8_ALT_INTERFACE                       0xFE95                                                
#define FTD_USB_MM_INFO_8_PCR_STATE                           0xFE96                                                
#define FTD_USB_MM_INFO_8_PIPE_HANDLE                         0xFE97                                                
#define FTD_USB_MM_INFO_8_PIPE_STATE                          0xFE98                                                
#define FTD_USB_MM_INFO_8_PIPE_RX_FLOW_STATE                  0xFE99                                                
#define FTD_USB_MM_INFO_8_IN_EP_NO                            0xFE9A                                                
#define FTD_USB_MM_INFO_8_LOOPBACK_IN                         0xFE9B                                                
#define FTD_USB_MM_INFO_8_IN_EP_STATUS                        0xFE9C                                                
#define FTD_USB_MM_INFO_8_IN_EP_SIZE                          0xFE9D                                                
#define FTD_USB_MM_INFO_8_OUT_EP_NO                           0xFE9E                                                
#define FTD_USB_MM_INFO_8_LOOPBACK_OUT                        0xFE9F                                                
#define FTD_USB_MM_INFO_8_OUT_STATUS                          0xFEA0                                                
#define FTD_USB_MM_INFO_8_OUT_EP_SIZE                         0xFEA1                                                
#define FTD_USB_MM_INFO_9_NAME                                0xFEA2                                                
#define FTD_USB_MM_INFO_9_NSI_STATE                           0xFEA3                                                
#define FTD_USB_MM_INFO_9_ALT_INTERFACE                       0xFEA4                                                
#define FTD_USB_MM_INFO_9_PCR_STATE                           0xFEA5                                                
#define FTD_USB_MM_INFO_9_PIPE_HANDLE                         0xFEA6                                                
#define FTD_USB_MM_INFO_9_PIPE_STATE                          0xFEA7                                                
#define FTD_USB_MM_INFO_9_PIPE_RX_FLOW_STATE                  0xFEA8                                                
#define FTD_USB_MM_INFO_9_IN_EP_NO                            0xFEA9                                                
#define FTD_USB_MM_INFO_9_LOOPBACK_IN                         0xFEAA                                                
#define FTD_USB_MM_INFO_9_IN_EP_STATUS                        0xFEAB                                                
#define FTD_USB_MM_INFO_9_IN_EP_SIZE                          0xFEAC                                                
#define FTD_USB_MM_INFO_9_OUT_EP_NO                           0xFEAD                                                
#define FTD_USB_MM_INFO_9_LOOPBACK_OUT                        0xFEAE                                                
#define FTD_USB_MM_INFO_9_OUT_STATUS                          0xFEAF                                                
#define FTD_USB_MM_INFO_9_OUT_EP_SIZE                         0xFEB0                                                
#define FTD_USB_MM_INFO_10_NAME                               0xFEB1                                                
#define FTD_USB_MM_INFO_10_NSI_STATE                          0xFEB2                                                
#define FTD_USB_MM_INFO_10_ALT_INTERFACE                      0xFEB3                                                
#define FTD_USB_MM_INFO_10_PCR_STATE                          0xFEB4                                                
#define FTD_USB_MM_INFO_10_PIPE_HANDLE                        0xFEB5                                                
#define FTD_USB_MM_INFO_10_PIPE_STATE                         0xFEB6                                                
#define FTD_USB_MM_INFO_10_PIPE_RX_FLOW_STATE                 0xFEB7                                                
#define FTD_USB_MM_INFO_10_IN_EP_NO                           0xFEB8                                                
#define FTD_USB_MM_INFO_10_LOOPBACK_IN                        0xFEB9                                                
#define FTD_USB_MM_INFO_10_IN_EP_STATUS                       0xFEBA                                                
#define FTD_USB_MM_INFO_10_IN_EP_SIZE                         0xFEBB                                                
#define FTD_USB_MM_INFO_10_OUT_EP_NO                          0xFEBC                                                
#define FTD_USB_MM_INFO_10_LOOPBACK_OUT                       0xFEBD                                                
#define FTD_USB_MM_INFO_10_OUT_STATUS                         0xFEBE                                                
#define FTD_USB_MM_INFO_10_OUT_EP_SIZE                        0xFEBF                                                
#define FTD_USB_MM_INFO_11_NAME                               0xFEC0                                                
#define FTD_USB_MM_INFO_11_NSI_STATE                          0xFEC1                                                
#define FTD_USB_MM_INFO_11_ALT_INTERFACE                      0xFEC2                                                
#define FTD_USB_MM_INFO_11_PCR_STATE                          0xFEC3                                                
#define FTD_USB_MM_INFO_11_PIPE_HANDLE                        0xFEC4                                                
#define FTD_USB_MM_INFO_11_PIPE_STATE                         0xFEC5                                                
#define FTD_USB_MM_INFO_11_PIPE_RX_FLOW_STATE                 0xFEC6                                                
#define FTD_USB_MM_INFO_11_IN_EP_NO                           0xFEC7                                                
#define FTD_USB_MM_INFO_11_LOOPBACK_IN                        0xFEC8                                                
#define FTD_USB_MM_INFO_11_IN_EP_STATUS                       0xFEC9                                                
#define FTD_USB_MM_INFO_11_IN_EP_SIZE                         0xFECA                                                
#define FTD_USB_MM_INFO_11_OUT_EP_NO                          0xFECB                                                
#define FTD_USB_MM_INFO_11_LOOPBACK_OUT                       0xFECC                                                
#define FTD_USB_MM_INFO_11_OUT_STATUS                         0xFECD                                                
#define FTD_USB_MM_INFO_11_OUT_EP_SIZE                        0xFECE                                                
#define FTD_USB_MM_INFO_12_NAME                               0xFECF                                                
#define FTD_USB_MM_INFO_12_NSI_STATE                          0xFED0                                                
#define FTD_USB_MM_INFO_12_ALT_INTERFACE                      0xFED1                                                
#define FTD_USB_MM_INFO_12_PCR_STATE                          0xFED2                                                
#define FTD_USB_MM_INFO_12_PIPE_HANDLE                        0xFED3                                                
#define FTD_USB_MM_INFO_12_PIPE_STATE                         0xFED4                                                
#define FTD_USB_MM_INFO_12_PIPE_RX_FLOW_STATE                 0xFED5                                                
#define FTD_USB_MM_INFO_12_IN_EP_NO                           0xFED6                                                
#define FTD_USB_MM_INFO_12_LOOPBACK_IN                        0xFED7                                                
#define FTD_USB_MM_INFO_12_IN_EP_STATUS                       0xFED8                                                
#define FTD_USB_MM_INFO_12_IN_EP_SIZE                         0xFED9                                                
#define FTD_USB_MM_INFO_12_OUT_EP_NO                          0xFEDA                                                
#define FTD_USB_MM_INFO_12_LOOPBACK_OUT                       0xFEDB                                                
#define FTD_USB_MM_INFO_12_OUT_STATUS                         0xFEDC                                                
#define FTD_USB_MM_INFO_12_OUT_EP_SIZE                        0xFEDD                                                
#define FTD_NUM_MASTER_CON                                    0xFF50                                                
#define FTD_NUM_SLAVE_INSTANCE                                0xFF51                                                
#define FTD_ACTIVE_SLEEP_RATIO                                0xFF52                                                
#define FTD_HW_VERSION_NUM                                    0xFF53                                                
#define FTD_SW_VERSION_NUM                                    0xFF54                                                
#define FTD_CLASS_OF_DEVICE                                   0xFF55                                                
#define FTD_BT_COUNTRY_CODE                                   0xFF56                                                
#define FTD_BD_ADDR                                           0xFF57                                                
#define FTD_FRIENDLY_NAME                                     0xFF58                                                
#define FTD_CON_1_HANDLE                                      0xFF20                                                
#define FTD_CON_1_BD_ADDR                                     0xFF21                                                
#define FTD_CON_1_CON_STATE                                   0xFF23                                                
#define FTD_CON_1_LOC_DEV_STATE                               0xFF24                                                
#define FTD_CON_1_QUALITY                                     0xFF60                                                
#define FTD_CON_2_HANDLE                                      0xFF25                                                
#define FTD_CON_2_BD_ADDR                                     0xFF26                                                
#define FTD_CON_2_CON_STATE                                   0xFF28                                                
#define FTD_CON_2_LOC_DEV_STATE                               0xFF29                                                
#define FTD_CON_2_QUALITY                                     0xFF61                                                
#define FTD_CON_3_HANDLE                                      0xFF2A                                                
#define FTD_CON_3_BD_ADDR                                     0xFF2B                                                
#define FTD_CON_3_CON_STATE                                   0xFF2D                                                
#define FTD_CON_3_LOC_DEV_STATE                               0xFF2E                                                
#define FTD_CON_3_QUALITY                                     0xFF62                                                
#define FTD_CON_4_HANDLE                                      0xFF30                                                
#define FTD_CON_4_BD_ADDR                                     0xFF31                                                
#define FTD_CON_4_CON_STATE                                   0xFF33                                                
#define FTD_CON_4_LOC_DEV_STATE                               0xFF34                                                
#define FTD_CON_4_QUALITY                                     0xFF63                                                
#define FTD_CON_5_HANDLE                                      0xFF35                                                
#define FTD_CON_5_BD_ADDR                                     0xFF36                                                
#define FTD_CON_5_CON_STATE                                   0xFF38                                                
#define FTD_CON_5_LOC_DEV_STATE                               0xFF39                                                
#define FTD_CON_5_QUALITY                                     0xFF64                                                
#define FTD_CON_6_HANDLE                                      0xFF3A                                                
#define FTD_CON_6_BD_ADDR                                     0xFF3B                                                
#define FTD_CON_6_CON_STATE                                   0xFF3D                                                
#define FTD_CON_6_LOC_DEV_STATE                               0xFF3E                                                
#define FTD_CON_6_QUALITY                                     0xFF65                                                
#define FTD_CON_7_HANDLE                                      0xFF40                                                
#define FTD_CON_7_BD_ADDR                                     0xFF41                                                
#define FTD_CON_7_CON_STATE                                   0xFF43                                                
#define FTD_CON_7_LOC_DEV_STATE                               0xFF44                                                
#define FTD_CON_7_QUALITY                                     0xFF66                                                
#define FTD_CON_8_HANDLE                                      0xFF45                                                
#define FTD_CON_8_BD_ADDR                                     0xFF46                                                
#define FTD_CON_8_CON_STATE                                   0xFF48                                                
#define FTD_CON_8_LOC_DEV_STATE                               0xFF49                                                
#define FTD_CON_8_QUALITY                                     0xFF67                                                
#define FTD_OS_FREE_BLOCKS                                    0xFF70                                                
#define FTD_PMD_RESET_REASON                                  0xFF5B                                                
#define FTD_PMD_RESET_ARM_MODE                                0xFF5C                                                
#define FTD_PMD_TASK_STATE                                    0xFF59                                                
#define FTD_PMD_TIMER_STATE                                   0xFF5E                                                
#define FTD_PMD_RESOURCE_STATE                                0xFF5F                                                
#define FTD_PMD_FREE_BLOCKS                                   0xFF5A                                                
#define FTD_SB_BT_MM_BD_ADDR_1                                0xFF80                                                
#define FTD_SB_BT_MM_PN_DEV_ID_1                              0xFF81                                                
#define FTD_SB_BT_MM_PN_OBJ_ID_1                              0xFF82                                                
#define FTD_SB_BT_MM_CONN_DIR_1                               0xFF83                                                
#define FTD_SB_BT_MM_SCO_HANDLE_1                             0xFF84                                                
#define FTD_SB_BT_MM_SERVICE_ID_1                             0xFF85                                                
#define FTD_SB_BT_MM_BD_ADDR_2                                0xFF86                                                
#define FTD_SB_BT_MM_PN_DEV_ID_2                              0xFF87                                                
#define FTD_SB_BT_MM_PN_OBJ_ID_2                              0xFF88                                                
#define FTD_SB_BT_MM_CONN_DIR_2                               0xFF89                                                
#define FTD_SB_BT_MM_SCO_HANDLE_2                             0xFF8A                                                
#define FTD_SB_BT_MM_SERVICE_ID_2                             0xFF8B                                                
#define FTD_SB_BT_QUEUE_MAX_LENGTH                            0xFF8C                                                
#define FTD_SB_BT_STORAGE_MAX_LENGTH                          0xFF8D                                                
#define FTD_SB_BT_EM_LEVEL                                    0xFF8E                                                
#define FTD_SB_BT_INTERNAL_STATE                              0xFF8F                                                
#define FTD_SB_BT_CONFIG_USED                                 0xFFFE                                                
#define FTD_SB_BT_SDP_OPEN_CLIENT_SESSION                     0xFF90                                                
#define FTD_SB_BT_SDP_CLIENT_L2_HANDLE                        0xFF91                                                
#define FTD_SB_BT_SDP_CLIENT_STATE                            0xFF92                                                
#define FTD_SB_BT_SDP_SENT_PDU_COUNT                          0xFF93                                                
#define FTD_SB_BT_SDP_SENT_PDU_ID                             0xFF94                                                
#define FTD_SB_BT_SDP_RECEIVED_ERROR_CODE                     0xFF95                                                
#define FTD_SB_BT_SDP_SERVICE_RECORD_COUNT                    0xFF96                                                
#define FTD_SB_BT_SDP_OPEN_SERVER_SESSION                     0xFF97                                                
#define FTD_SB_BT_SDP_SERVER_L2_HANDLE                        0xFF98                                                
#define FTD_SB_BT_SDP_RECEIVED_PDU_COUNT                      0xFF99                                                
#define FTD_SB_BT_SDP_RECEIVED_PDU_ID                         0xFF9A                                                
#define FTD_SB_BT_SDP_EXAMINED_SR_HANDLE                      0xFF9B                                                
#define FTD_SB_BT_SDP_RETURNED_ERROR_CODE                     0xFF9C                                                
#define FTD_SB_BT_SDP_RETURNED_ATTRIBUTE_ID                   0xFF9D                                                
#define FTD_SB_BT_HCI_COMMANDS_SENT                           0xFFA0                                                
#define FTD_SB_BT_HCI_EVENTS_RECEIVED                         0xFFA1                                                
#define FTD_SB_BT_HCI_ERRORS                                  0xFFA2                                                
#define FTD_SB_BT_HCI_DATA_RECEIVED                           0xFFA3                                                
#define FTD_SB_BT_HCI_DATA_RECEIVED_MAX                       0xFFA4                                                
#define FTD_SB_BT_HCI_DATA_SENT                               0xFFA5                                                
#define FTD_SB_BT_HCI_DATA_SENT_MAX                           0xFFA6                                                
#define FTD_SB_BT_HCI_COMMAND_LIST1                           0xFFA7                                                
#define FTD_SB_BT_HCI_EVENT_LIST1                             0xFFA8                                                
#define FTD_SB_BT_HCI_EVENT_STATUS1                           0xFFA9                                                
#define FTD_SB_BT_HCI_COMMAND_LIST2                           0xFFAA                                                
#define FTD_SB_BT_HCI_EVENT_LIST2                             0xFFAB                                                
#define FTD_SB_BT_HCI_EVENT_STATUS2                           0xFFAC                                                
#define FTD_SB_BT_HCI_COMMAND_LIST3                           0xFFAD                                                
#define FTD_SB_BT_HCI_EVENT_LIST3                             0xFFAE                                                
#define FTD_SB_BT_HCI_EVENT_STATUS3                           0xFFAF                                                
#define FTD_SB_BT_HCI_COMMAND_LIST4                           0xFFB0                                                
#define FTD_SB_BT_HCI_EVENT_LIST4                             0xFFB1                                                
#define FTD_SB_BT_HCI_EVENT_STATUS4                           0xFFB2                                                
#define FTD_SB_BT_MCE_CONNECTIONS                             0xFFB3                                                
#define FTD_SB_BT_MCE_DISCONNECTIONS                          0xFFB4                                                
#define FTD_SB_BT_MCE_ERRORS                                  0xFFB5                                                
#define FTD_SB_BT_MCE_BUFFER_READY                            0xFFB6                                                
#define FTD_SB_BT_MCE_STATUS_OF_LAST_CONN                     0xFFB7                                                
#define FTD_SB_BT_MCE_LOCAL_BD_ADDR                           0xFFB8                                                
#define FTD_SB_BT_MCE_DEV_DB_BD_ADDR                          0xFFB9                                                
#define FTD_SB_BT_MCE_DEV_DB_COD                              0xFFBA                                                
#define FTD_SB_BT_MCE_CONN_DB_BD_ADDR                         0xFFBB                                                
#define FTD_SB_BT_MCE_CONN_DB_CONN_HANDLE                     0xFFBC                                                
#define FTD_SB_BT_MCE_CONN_DB_PACKET_TYPE                     0xFFBD                                                
#define FTD_SB_BT_MCE_CONN_DB_LINK_TYPE                       0xFFBE                                                
#define FTD_SB_BT_MCE_CONN_DB_ROLE                            0xFFBF                                                
#define FTD_SB_BT_MCE_CONN_DB_ENC                             0xFFC0                                                
#define FTD_SB_BT_MCE_SECU_DB_BD_ADDR                         0xFFC1                                                
#define FTD_SB_BT_MCE_SECU_DB_P_ID                            0xFFC2                                                
#define FTD_SB_BT_MCE_SECU_DB_C_ID                            0xFFC3                                                
#define FTD_SB_BT_MCE_SECU_DB_LEVEL                           0xFFC4                                                
#define FTD_SB_BT_MCE_SECU_DB_STATUS                          0xFFC5                                                
#define FTD_SB_BT_MCE_SECU_DB_NUM                             0xFFC6                                                
#define FTD_SB_BT_STACK_VERSION_STR                           0xFFC7                                                
#define FTD_SB_BT_STACK_VERSION_DATE                          0xFFC8                                                
#define FTD_SB_BT_PEP_SERVICES                                0xFFC9                                                
#define FTD_SB_BT_PEP_CONNECTION                              0xFFCA                                                
#define FTD_SB_BT_PEP_SERVICE_ID_1                            0xFFCB                                                
#define FTD_SB_BT_PEP_SERVICE_STATE_1                         0xFFCC                                                
#define FTD_SB_BT_PEP_SERVICE_ID_2                            0xFFCD                                                
#define FTD_SB_BT_PEP_SERVICE_STATE_2                         0xFFCE                                                
#define FTD_SB_BT_PEP_SERVICE_ID_3                            0xFFCF                                                
#define FTD_SB_BT_PEP_SERVICE_STATE_3                         0xFFD0                                                
#define FTD_SB_BT_PEP_SERVICE_ID_4                            0xFFD1                                                
#define FTD_SB_BT_PEP_SERVICE_STATE_4                         0xFFD2                                                
#define FTD_SB_BT_PEP_SERVICE_ID_5                            0xFFD3                                                
#define FTD_SB_BT_PEP_SERVICE_STATE_5                         0xFFD4                                                
#define FTD_SB_BT_PEP_SERVICE_ID_6                            0xFFD5                                                
#define FTD_SB_BT_PEP_SERVICE_STATE_6                         0xFFD6                                                
#define FTD_SB_BT_PEP_BDADDR                                  0xFFD7                                                
#define FTD_SB_BT_PEP_DLC                                     0xFFD8                                                
#define FTD_SB_BT_PEP_SERVICE_TYPE                            0xFFD9                                                
#define FTD_SB_BT_PEP_DEVICE                                  0xFFDA                                                
#define FTD_SB_BT_PEP_OBJECT                                  0xFFDB                                                
#define FTD_SB_BT_PEP_DATA_TX                                 0xFFDC                                                
#define FTD_SB_BT_PEP_FLOW_TX                                 0xFFDD                                                
#define FTD_SB_BT_PEP_DATA_RX                                 0xFFDE                                                
#define FTD_SB_BT_PEP_FLOW_RX                                 0xFFDF                                                
#define FTD_SB_BT_L2CAP_CIDS                                  0xFFE0                                                
#define FTD_SB_BT_L2CAP_MTUS                                  0xFFE1                                                
#define FTD_SB_BT_L2CAP_STATES                                0xFFE2                                                
#define FTD_SB_BT_L2CAP_HCI_HANDLE                            0xFFE3                                                
#define FTD_SB_BT_L2CAP_DATA_REC                              0xFFE5                                                
#define FTD_SB_BT_L2CAP_DATA_SENT                             0xFFE4                                                
#define FTD_SB_BT_L2CAP_ACL_HCI_HANDLE                        0xFFEB                                                
#define FTD_SB_BT_L2CAP_PACK_AT_HC                            0xFFE6                                                
#define FTD_SB_BT_L2CAP_LAST_SENT                             0xFFE7                                                
#define FTD_SB_BT_L2CAP_NCH_CID                               0xFFE8                                                
#define FTD_SB_BT_L2CAP_NCH_HCI_HANDLE                        0xFFEC                                                
#define FTD_SB_BT_L2CAP_NCH_CODE                              0xFFE9                                                
#define FTD_SB_BT_L2CAP_FLOW                                  0xFFEA                                                
#define FTD_SB_BT_RFCOMM_BDA                                  0xFFF0                                                
#define FTD_SB_BT_RFCOMM_L2HAN                                0xFFF1                                                
#define FTD_SB_BT_RFCOMM_L2MTU                                0xFFF2                                                
#define FTD_SB_BT_RFCOMM_SESSION                              0xFFF3                                                
#define FTD_SB_BT_RFCOMM_SES_CTRL                             0xFFF4                                                
#define FTD_SB_BT_RFCOMM_DATA_LEN                             0xFFF5                                                
#define FTD_SB_BT_RFCOMM_RFHANDLE                             0xFFF6                                                
#define FTD_SB_BT_RFCOMM_CREDITS                              0xFFF7                                                
#define FTD_SB_BT_RFCOMM_PACKETS_BUF                          0xFFF8                                                
#define FTD_SB_BT_RFCOMM_DATA_SENT                            0xFFF9                                                
#define FTD_SB_BT_RFCOMM_DATA_RECE                            0xFFFA                                                
#define FTD_SB_BT_RFCOMM_DLCI                                 0xFFFB                                                
#define FTD_SB_BT_RFCOMM_DLCI_CTRL                            0xFFFC                                                
#define FTD_SB_BT_RFCOMM_V_24_SIGNALS                         0xFFFD                                                
#define FTD_SB_PPC_HANDOVER                                   0x003C                                                    
#define FTD_SB_PPC_HO_COUNT_D800_A800                         0x0051                                                    
#define FTD_SB_PPC_HO_COUNT_D800_D800                         0x0052                                                    
#define FTD_SB_PPC_HO_COUNT_D1900_D1900                       0x0053                                                    
#define FTD_SB_PPC_HO_COUNT_D800_D1900                        0x0054                                                    
#define FTD_SB_PPC_HO_COUNT_D1900_D800                        0x0055                                                    
#define FTD_SB_PPC_HO_COUNT_D1900_A800                        0x0056                                                    
#define FTD_SB_STACK_WATER_MARKS                              0x0F02                                                   
#define FTD_SB_MBUF_WATER_MARKS                               0x0F03                                                   
#define FTD_SB_FAST_MBUF_WATER_MARKS                          0x0F04                                                   
#define FTD_SB_PPC_DMM_NO_BUF                                 0x001B                                                    
#define FTD_SB_PPC_DSP_RESET                                  0x001F                                                    
#define FTD_SB_PPC_SW_CRASH                                   0x0020                                                    
#define FTD_SB_PPC_ASIC_WD_RESET                              0x0021                                                    
#define FTD_SB_PPC_PA_OVER_T_PWR_OFF                          0x0023                                                    
#define FTD_SB_PPC_PA_OVER_T_BATT_TEMP                        0x0024                                                    
#define FTD_SB_PPC_BATT_OVER_T_PWR_OFF                        0x0025                                                    
#define FTD_SB_PPC_BATT_OVER_T_PA_TEMP                        0x0026                                                    
#define FTD_SB_PPC_BATT_CHARGED_FULL                          0x0027                                                    
#define FTD_SB_PPC_INV_CHA_CONN                               0x002A                                                    
#define FTD_SB_PPC_INV_BATT_CONN                              0x002C                                                    
#define FTD_SB_PPC_INV_BATT_CONN_BTEMP                        0x002D                                                    
#define FTD_SB_PPC_INV_BATT_CONN_BSIZE                        0x002E                                                    
#define FTD_SB_PPC_CHA_CONN                                   0x002F                                                    
#define FTD_SB_PPC_CHA_DISCONN                                0x0030                                                    
#define FTD_SB_PPC_CUMUL_CALL_TIMER                           0x0033                                                    
#define FTD_SB_PPC_DROPPED_CALL                               0x0037                                                    
#define FTD_SB_PPC_DROPPED_CALL_RSSI                          0x0038                                                    
#define FTD_SB_PPC_DROPPED_CALL_BER                           0x0039                                                    
#define FTD_SB_PPC_BAD_POWER_OFF                              0x0040                                                    
#define FTD_SB_PPC_CALL_COUNT_MO_DTCH                         0x0049                                                    
#define FTD_SB_PPC_CALL_COUNT_MT_DTCH                         0x004A                                                    
#define FTD_SB_PPC_CAMERA_CONTROL_FAILED                      0x015E                                                   
#define FTD_SB_PPC_CAMERA_DATA_FAILED                         0x015F                                                   
#define FTD_SB_PPC_CAMERA_APP_START                           0x0160                                                   
#define FTD_SB_PPC_PICTURE_LANDSCAPE                          0x0161                                                   
#define FTD_SB_PPC_PICTURE_PORTRAIT                           0x0162                                                   
#define FTD_SB_PPC_PICTURE_TWILIGHT                           0x0163                                                   
#define FTD_SB_PPC_PICTURE_DISCARDED                          0x0164                                                   
#define FTD_SB_PPC_CAMERA_VIEW_RUNTIME                        0x0165                                                   
#define FTD_SB_PPC_COMPACT_CAMERA_PORT_STUCK                  0x0166                                                   
#define FTD_SB_PPC_MCU_GEN_ADSP_RESET                         0x0205                                                   
#define FTD_SB_PPC_ADSP_NON_FATAL_ERRORS_TOTAL                0x024A                                                   
#define FTD_SB_PPC_ADSP_ORI_RESETS_TOTAL                      0x024D                                                   
#define FTD_SB_ADSP_CLEAR_CNT                                 0x1F76                                                
#define FTD_SB_ADSP_MCU_RESET_DATE                            0x1F77                                                
#define FTD_SB_PPC_ADSP_ORI_RESETS_ERROR_CODES_1              0x1F78                                                
#define FTD_SB_PPC_ADSP_ORI_RESETS_ERROR_TASK_ID_1            0x1F79                                                
#define FTD_SB_PPC_ADSP_ORI_RESETS_ERROR_CODES_2              0x1F7A                                                
#define FTD_SB_PPC_ADSP_ORI_RESETS_ERROR_TASK_ID_2            0x1F7B                                                
#define FTD_SB_PPC_ADSP_ORI_RESETS_ERROR_CODES_3              0x1F7C                                                
#define FTD_SB_PPC_ADSP_ORI_RESETS_ERROR_TASK_ID_3            0x1F7D                                                
#define FTD_SB_PPC_ADSP_ORI_RESETS_ERROR_CODES_4              0x1F7E                                                
#define FTD_SB_PPC_ADSP_ORI_RESETS_ERROR_TASK_ID_4            0x1F7F                                                
#define FTD_SB_PPC_ADSP_NON_FATAL_ERRORS_CODE_1               0x1F80                                                
#define FTD_SB_PPC_ADSP_NON_FATAL_ERROR_TASK_ID_1             0x1F81                                                
#define FTD_SB_PPC_ADSP_NON_FATAL_ERRORS_CODE_2               0x1F82                                                
#define FTD_SB_PPC_ADSP_NON_FATAL_ERROR_TASK_ID_2             0x1F83                                                
#define FTD_SB_PPC_ADSP_NON_FATAL_ERRORS_CODE_3               0x1F84                                                
#define FTD_SB_PPC_ADSP_NON_FATAL_ERROR_TASK_ID_3             0x1F85                                                
#define FTD_SB_PPC_ADSP_NON_FATAL_ERRORS_CODE_4               0x1F86                                                
#define FTD_SB_PPC_ADSP_NON_FATAL_ERROR_TASK_ID_4             0x1F87                                                
#define FTD_SB_ADSP_LAST_FATAL_ERR_CODE_DATE_1                0x1F88                                                
#define FTD_SB_ADSP_LAST_FATAL_ERR_CODE_TIME_1                0x1F89                                                
#define FTD_SB_ADSP_LAST_FATAL_ERR_CODE_DATE_2                0x1F8A                                                
#define FTD_SB_ADSP_LAST_FATAL_ERR_CODE_TIME_2                0x1F8B                                                
#define FTD_SB_ADSP_LAST_FATAL_ERR_CODE_DATE_3                0x1F8C                                                
#define FTD_SB_ADSP_LAST_FATAL_ERR_CODE_TIME_3                0x1F8D                                                
#define FTD_SB_ADSP_LAST_FATAL_ERR_CODE_DATE_4                0x1F8E                                                
#define FTD_SB_ADSP_LAST_FATAL_ERR_CODE_TIME_4                0x1F8F                                                
#define FTD_SB_ADSP_LAST_NON_FATAL_ERR_CODE_DATE_1            0x1F90                                                
#define FTD_SB_ADSP_LAST_NON_FATAL_ERR_CODE_TIME_1            0x1F91                                                
#define FTD_SB_ADSP_LAST_NON_FATAL_ERR_CODE_DATE_2            0x1F92                                                
#define FTD_SB_ADSP_LAST_NON_FATAL_ERR_CODE_TIME_2            0x1F93                                                
#define FTD_SB_ADSP_LAST_NON_FATAL_ERR_CODE_DATE_3            0x1F94                                                
#define FTD_SB_ADSP_LAST_NON_FATAL_ERR_CODE_TIME_3            0x1F95                                                
#define FTD_SB_ADSP_LAST_NON_FATAL_ERR_CODE_DATE_4            0x1F96                                                
#define FTD_SB_ADSP_LAST_NON_FATAL_ERR_CODE_TIME_4            0x1F97                                                
#define FTD_SB_L3D_DTCH_LOSS_CNT                              0x0093                                                    
#define FTD_SB_L3D_DPCH_LOSS_CNT                              0x0097                                                    
#define FTD_SB_L3D_HHANDOFF_CNT                               0x00BC                                                    
#define FTD_SB_L3D_IB_HHANDOFF_CNT                            0x00C1                                                    
#define FTD_SB_L3D_D_A_HANDOFF_CNT                            0x00C2                                                    
#define FTD_SB_L3D_IDL_HANDOFF_CNT                            0x00C3                                                    
#define FTD_SB_L3D_IF_IDL_HANDOFF_CNT                         0x00C5                                                    
#define FTD_SB_L3D_IB_IDL_HANDOFF_CNT                         0x00C6                                                    
#define FTD_SB_PPC_PWRUP_IN_SERV                              0x0014                                                    
#define FTD_SB_PPC_FAILED_HANDOVER                            0x003D                                                    
#define FTD_SB_PPC_CALL_SILENT_RETRY                          0x0290                                                   
#define FTD_SB_PPC_CUMUL_AMPS_CALL_TIMER                      0x028E                                                   
#define FTD_SB_PPC_CALL_USER_ORIGINATED                       0x028F                                                   


//STRUCTURES


//Definition for struct MON_ERROR_SEQ
typedef struct
            { 
             uint32_t     error_code;
             uint32_t     extra_error_code;
            } __attribute__((packed)) MON_ERROR_SEQ_STR;
#define SIZE_MON_ERROR_SEQ                                    sizeof(MON_ERROR_SEQ_STR)


//Definition for struct MON_SB_BT
typedef struct
            { 
             uint8_t      id;
             uint16_t     bitmap;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) MON_SB_BT_STR;
#define SIZE_MON_SB_BT                                        sizeof(MON_SB_BT_STR)


//Definition for struct MON_SB_BT_RESP
typedef struct
            { 
             uint8_t      id;
             uint8_t      status;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) MON_SB_BT_RESP_STR;
#define SIZE_MON_SB_BT_RESP                                   sizeof(MON_SB_BT_RESP_STR)


//SUBBLOCKS


//Definition for struct MON_SB_TRACE_ACTIVATION_BITMAP_STORAGE
#define MON_SB_TRACE_ACTIVATION_BITMAP_STORAGE                0x10                                                  
typedef struct
            { 
             uint8_t      sb_id;
             uint8_t      sb_len;
             uint8_t      storage;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) MON_SB_TRACE_ACTIVATION_BITMAP_STORAGE_STR;
#define SIZE_MON_SB_TRACE_ACTIVATION_BITMAP_STORAGE           sizeof(MON_SB_TRACE_ACTIVATION_BITMAP_STORAGE_STR)


//Definition for struct MON_SB_TRACE_ACTIVATION_TIMESTAMP
#define MON_SB_TRACE_ACTIVATION_TIMESTAMP                     0x0F                                                     
typedef struct
            { 
             uint8_t      sb_id;
             uint8_t      sb_len;
             uint8_t      timestamp;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) MON_SB_TRACE_ACTIVATION_TIMESTAMP_STR;
#define SIZE_MON_SB_TRACE_ACTIVATION_TIMESTAMP                sizeof(MON_SB_TRACE_ACTIVATION_TIMESTAMP_STR)


//Definition for struct MON_SB_TRACE_ACTIVATION_BITMAP
#define MON_SB_TRACE_ACTIVATION_BITMAP                        0x11                                                  
typedef struct
            { 
             uint8_t      sb_id;
             uint8_t      sb_len;
             uint8_t      trace_type;
             uint8_t      entity_id;
             uint8_t      fillerbyte1[3];
             uint8_t      bitmap_length;
             uint32_t     bitmap[0];
            } __attribute__((packed)) MON_SB_TRACE_ACTIVATION_BITMAP_STR;
#define SIZE_MON_SB_TRACE_ACTIVATION_BITMAP                   sizeof(MON_SB_TRACE_ACTIVATION_BITMAP_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct MON_SB_OS_TICKS_INFO
#define MON_SB_OS_TICKS_INFO                                  0x06                                                     
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint16_t     os_ticks;
            } __attribute__((packed)) MON_SB_OS_TICKS_INFO_STR;
#define SIZE_MON_SB_OS_TICKS_INFO                             sizeof(MON_SB_OS_TICKS_INFO_STR)


//Definition for struct MON_SB_TRACE_FAIL_REASONS
#define MON_SB_TRACE_FAIL_REASONS                             0x07                                                     
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint16_t     reasons;
            } __attribute__((packed)) MON_SB_TRACE_FAIL_REASONS_STR;
#define SIZE_MON_SB_TRACE_FAIL_REASONS                        sizeof(MON_SB_TRACE_FAIL_REASONS_STR)


//Definition for struct MON_SB_TRACE_ACTIVATE_INFO
#define MON_SB_TRACE_ACTIVATE_INFO                            0x12                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint8_t      trace_type;
             uint8_t      resp_info;
            } __attribute__((packed)) MON_SB_TRACE_ACTIVATE_INFO_STR;
#define SIZE_MON_SB_TRACE_ACTIVATE_INFO                       sizeof(MON_SB_TRACE_ACTIVATE_INFO_STR)


//Definition for struct MON_SB_TRACE_CM_FILTER_BITMAP
#define MON_SB_TRACE_CM_FILTER_BITMAP                         0x09                                                     
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint8_t      fillerbyte1;
             uint8_t      filter_length;
             uint8_t      filter_bitmap[0];
            } __attribute__((packed)) MON_SB_TRACE_CM_FILTER_BITMAP_STR;
#define SIZE_MON_SB_TRACE_CM_FILTER_BITMAP                    sizeof(MON_SB_TRACE_CM_FILTER_BITMAP_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct MON_SB_TRACE_PN_FILTER_BITMAP
#define MON_SB_TRACE_PN_FILTER_BITMAP                         0x0A                                                     
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint8_t      fillerbyte1;
             uint8_t      filter_length;
             uint8_t      filter_bitmap[0];
            } __attribute__((packed)) MON_SB_TRACE_PN_FILTER_BITMAP_STR;
#define SIZE_MON_SB_TRACE_PN_FILTER_BITMAP                    sizeof(MON_SB_TRACE_PN_FILTER_BITMAP_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct MON_SB_OS_CALL_STACK_DEPTH
#define MON_SB_OS_CALL_STACK_DEPTH                            0x0D                                                     
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint16_t     task_id;
             uint8_t      depth;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
            } __attribute__((packed)) MON_SB_OS_CALL_STACK_DEPTH_STR;
#define SIZE_MON_SB_OS_CALL_STACK_DEPTH                       sizeof(MON_SB_OS_CALL_STACK_DEPTH_STR)


//Definition for struct MON_PPC_RESET_LEVEL_0_DATE
#define MON_PPC_RESET_LEVEL_0_DATE                            0x00                                                     
typedef struct
            { 
             uint16_t     id;
             uint8_t      length;
             uint8_t      year;
             uint8_t      month;
             uint8_t      day;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) MON_PPC_RESET_LEVEL_0_DATE_STR;
#define SIZE_MON_PPC_RESET_LEVEL_0_DATE                       sizeof(MON_PPC_RESET_LEVEL_0_DATE_STR)


//Definition for struct MON_PPC_RESET_LEVEL_1_DATE
#define MON_PPC_RESET_LEVEL_1_DATE                            0x01                                                     
typedef struct
            { 
             uint16_t     id;
             uint8_t      length;
             uint8_t      year;
             uint8_t      month;
             uint8_t      day;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) MON_PPC_RESET_LEVEL_1_DATE_STR;
#define SIZE_MON_PPC_RESET_LEVEL_1_DATE                       sizeof(MON_PPC_RESET_LEVEL_1_DATE_STR)


//Definition for struct MON_PPC_RESET_LEVEL_2_DATE
#define MON_PPC_RESET_LEVEL_2_DATE                            0x02                                                     
typedef struct
            { 
             uint16_t     id;
             uint8_t      length;
             uint8_t      year;
             uint8_t      month;
             uint8_t      day;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) MON_PPC_RESET_LEVEL_2_DATE_STR;
#define SIZE_MON_PPC_RESET_LEVEL_2_DATE                       sizeof(MON_PPC_RESET_LEVEL_2_DATE_STR)


//Definition for struct MON_PPC_RESET_LEVEL_3_DATE
#define MON_PPC_RESET_LEVEL_3_DATE                            0x03                                                     
typedef struct
            { 
             uint16_t     id;
             uint8_t      length;
             uint8_t      year;
             uint8_t      month;
             uint8_t      day;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) MON_PPC_RESET_LEVEL_3_DATE_STR;
#define SIZE_MON_PPC_RESET_LEVEL_3_DATE                       sizeof(MON_PPC_RESET_LEVEL_3_DATE_STR)


//Definition for struct MON_PPC_FAIL_INFO
#define MON_PPC_FAIL_INFO                                     0x04                                                     
typedef struct
            { 
             uint16_t     id;
             uint8_t      length;
             uint8_t      reason;
             uint16_t     failed_id;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) MON_PPC_FAIL_INFO_STR;
#define SIZE_MON_PPC_FAIL_INFO                                sizeof(MON_PPC_FAIL_INFO_STR)


//Definition for struct MON_SB_ADSP_ERROR_STATUS
#define MON_SB_ADSP_ERROR_STATUS                              0x00                                                     
typedef struct
            { 
             uint8_t      sb_id;
             uint8_t      sb_length;
             uint8_t      fillerbyte1;
             uint8_t      severity;
             uint32_t     error_code;
             uint16_t     error_pid;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
            } __attribute__((packed)) MON_SB_ADSP_ERROR_STATUS_STR;
#define SIZE_MON_SB_ADSP_ERROR_STATUS                         sizeof(MON_SB_ADSP_ERROR_STATUS_STR)


//Definition for struct MON_SB_CDSP_ERROR_STATUS
#define MON_SB_CDSP_ERROR_STATUS                              0x01                                                     
typedef struct
            { 
             uint8_t      sb_id;
             uint8_t      sb_length;
             uint16_t     os_task_id;
             uint16_t     type;
             uint16_t     error_severity;
             MON_ERROR_SEQ_STR    errors[0];
             uint32_t     time_stamp;
             uint16_t     pid_list_last_index;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      pid[64];
             uint16_t     rx_list_last_index;
             uint8_t      fillerbyte3;
             uint8_t      fillerbyte4;
             uint8_t      rx[32];
             uint16_t     tx_list_last_index;
             uint8_t      fillerbyte5;
             uint8_t      fillerbyte6;
             uint8_t      tx[32];
             uint16_t     warning_list_last_index;
             uint8_t      fillerbyte7;
             uint8_t      fillerbyte8;
             MON_ERROR_SEQ_STR    warning[64];
            } __attribute__((packed)) MON_SB_CDSP_ERROR_STATUS_STR;
#define SIZE_MON_SB_CDSP_ERROR_STATUS                         sizeof(MON_SB_CDSP_ERROR_STATUS_STR)


//Definition for struct MON_PPC_FT_BYTE
//#define MON_PPC_FT_BYTE                                     0x00                        //Already defined as 0x00
typedef struct
            { 
             uint16_t     id;
             uint8_t      length;
             uint8_t      type;
             uint8_t      data;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
            } __attribute__((packed)) MON_PPC_FT_BYTE_STR;
#define SIZE_MON_PPC_FT_BYTE                                  sizeof(MON_PPC_FT_BYTE_STR)


//Definition for struct MON_PPC_FT_WORD
//#define MON_PPC_FT_WORD                                     0x01                        //Already defined as 0x01
typedef struct
            { 
             uint16_t     id;
             uint8_t      length;
             uint8_t      type;
             uint16_t     data;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) MON_PPC_FT_WORD_STR;
#define SIZE_MON_PPC_FT_WORD                                  sizeof(MON_PPC_FT_WORD_STR)


//Definition for struct MON_PPC_FT_DWORD
//#define MON_PPC_FT_DWORD                                    0x02                        //Already defined as 0x02
typedef struct
            { 
             uint16_t     id;
             uint8_t      length;
             uint8_t      type;
             uint32_t     data;
            } __attribute__((packed)) MON_PPC_FT_DWORD_STR;
#define SIZE_MON_PPC_FT_DWORD                                 sizeof(MON_PPC_FT_DWORD_STR)


//Definition for struct MON_PPC_FT_TABLE
//#define MON_PPC_FT_TABLE                                    0x03                        //Already defined as 0x03
typedef struct
            { 
             uint16_t     id;
             uint8_t      length;
             uint8_t      type;
             uint8_t      item_type;
             uint8_t      data_length;
             uint8_t      data[0];
            } __attribute__((packed)) MON_PPC_FT_TABLE_STR;
#define SIZE_MON_PPC_FT_TABLE                                 sizeof(MON_PPC_FT_TABLE_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct MON_MULDER_DUMP
#define MON_MULDER_DUMP                                       0x01                                                     
typedef struct
            { 
             uint8_t      id;
             uint8_t      fillerbyte1;
             uint16_t     length;
             uint16_t     fillerbyte2;
             uint16_t     dump_length;
             uint8_t      dump_data[0];
            } __attribute__((packed)) MON_MULDER_DUMP_STR;
#define SIZE_MON_MULDER_DUMP                                  sizeof(MON_MULDER_DUMP_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct MON_MULDER_DUMP_ID
#define MON_MULDER_DUMP_ID                                    0x02                                                     
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint16_t     dump_index;
            } __attribute__((packed)) MON_MULDER_DUMP_ID_STR;
#define SIZE_MON_MULDER_DUMP_ID                               sizeof(MON_MULDER_DUMP_ID_STR)


//Definition for struct MON_SENSOR_TEMP_SB
#define MON_SENSOR_TEMP_SB                                    0x40                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint8_t      fillerbyte1;
             uint8_t      temp_type;
            } __attribute__((packed)) MON_SENSOR_TEMP_SB_STR;
#define SIZE_MON_SENSOR_TEMP_SB                               sizeof(MON_SENSOR_TEMP_SB_STR)


//MESSAGES


//Definition for struct MON_SENSOR_IND
#define MON_SENSOR_IND                                        0x3F                                                  
typedef struct
            { 
             uint8_t      utid;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      num_of_sub;
            } __attribute__((packed)) MON_SENSOR_IND_STR;
#define SIZE_MON_SENSOR_IND                                   sizeof(MON_SENSOR_IND_STR)


//Definition for struct MON_TRACE_ACTIVATION_CHANGED_IND
#define MON_TRACE_ACTIVATION_CHANGED_IND                      0x45                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      sub_block_count;
            } __attribute__((packed)) MON_TRACE_ACTIVATION_CHANGED_IND_STR;
#define SIZE_MON_TRACE_ACTIVATION_CHANGED_IND                 sizeof(MON_TRACE_ACTIVATION_CHANGED_IND_STR)


//Definition for struct VENDOR_TRACE_ACTIVATE_REQ
#define VENDOR_TRACE_ACTIVATE_REQ                             0x50                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      sub_block_count;
            } __attribute__((packed)) VENDOR_TRACE_ACTIVATE_REQ_STR;
#define SIZE_VENDOR_TRACE_ACTIVATE_REQ                        sizeof(VENDOR_TRACE_ACTIVATE_REQ_STR)


//Definition for struct VENDOR_TRACE_ACTIVATE_RESP
#define VENDOR_TRACE_ACTIVATE_RESP                            0x51                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      sub_block_count;
            } __attribute__((packed)) VENDOR_TRACE_ACTIVATE_RESP_STR;
#define SIZE_VENDOR_TRACE_ACTIVATE_RESP                       sizeof(VENDOR_TRACE_ACTIVATE_RESP_STR)


//Definition for struct VENDOR_TRACE_ACTIVATION_READ_STATUS_REQ
#define VENDOR_TRACE_ACTIVATION_READ_STATUS_REQ               0x52                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint16_t     fillerbyte1;
            } __attribute__((packed)) VENDOR_TRACE_ACTIVATION_READ_STATUS_REQ_STR;
#define SIZE_VENDOR_TRACE_ACTIVATION_READ_STATUS_REQ          sizeof(VENDOR_TRACE_ACTIVATION_READ_STATUS_REQ_STR)


//Definition for struct VENDOR_TRACE_ACTIVATION_READ_STATUS_RESP
#define VENDOR_TRACE_ACTIVATION_READ_STATUS_RESP              0x53                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint16_t     sub_block_count;
            } __attribute__((packed)) VENDOR_TRACE_ACTIVATION_READ_STATUS_RESP_STR;
#define SIZE_VENDOR_TRACE_ACTIVATION_READ_STATUS_RESP         sizeof(VENDOR_TRACE_ACTIVATION_READ_STATUS_RESP_STR)


//Definition for struct MON_TRACE_ACTIVATE_REQ
#define MON_TRACE_ACTIVATE_REQ                                0x00                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      sub_block_count;
            } __attribute__((packed)) MON_TRACE_ACTIVATE_REQ_STR;
#define SIZE_MON_TRACE_ACTIVATE_REQ                           sizeof(MON_TRACE_ACTIVATE_REQ_STR)


//Definition for struct MON_TRACE_ACTIVATE_RESP
#define MON_TRACE_ACTIVATE_RESP                               0x01                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      sub_block_count;
            } __attribute__((packed)) MON_TRACE_ACTIVATE_RESP_STR;
#define SIZE_MON_TRACE_ACTIVATE_RESP                          sizeof(MON_TRACE_ACTIVATE_RESP_STR)


//Definition for struct MON_TRACE_DEACTIVATE_REQ
#define MON_TRACE_DEACTIVATE_REQ                              0x03                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint16_t     fillerbyte1;
            } __attribute__((packed)) MON_TRACE_DEACTIVATE_REQ_STR;
#define SIZE_MON_TRACE_DEACTIVATE_REQ                         sizeof(MON_TRACE_DEACTIVATE_REQ_STR)


//Definition for struct MON_TRACE_DEACTIVATE_RESP
#define MON_TRACE_DEACTIVATE_RESP                             0x04                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      sub_block_count;
            } __attribute__((packed)) MON_TRACE_DEACTIVATE_RESP_STR;
#define SIZE_MON_TRACE_DEACTIVATE_RESP                        sizeof(MON_TRACE_DEACTIVATE_RESP_STR)


//Definition for struct MON_TRACE_ACTIVATION_READ_STATUS_REQ
#define MON_TRACE_ACTIVATION_READ_STATUS_REQ                  0x46                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      flags;
             uint8_t      bitmap_count;
             uint16_t     bitmaps[0];
            } __attribute__((packed)) MON_TRACE_ACTIVATION_READ_STATUS_REQ_STR;
#define SIZE_MON_TRACE_ACTIVATION_READ_STATUS_REQ             sizeof(MON_TRACE_ACTIVATION_READ_STATUS_REQ_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct MON_TRACE_ACTIVATION_READ_STATUS_RESP
#define MON_TRACE_ACTIVATION_READ_STATUS_RESP                 0x47                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      sub_block_count;
            } __attribute__((packed)) MON_TRACE_ACTIVATION_READ_STATUS_RESP_STR;
#define SIZE_MON_TRACE_ACTIVATION_READ_STATUS_RESP            sizeof(MON_TRACE_ACTIVATION_READ_STATUS_RESP_STR)


//Definition for struct MON_INV_TRACE_RUNTIME_ENABLING_REQ
#define MON_INV_TRACE_RUNTIME_ENABLING_REQ                    0x4A                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      status;
            } __attribute__((packed)) MON_INV_TRACE_RUNTIME_ENABLING_REQ_STR;
#define SIZE_MON_INV_TRACE_RUNTIME_ENABLING_REQ               sizeof(MON_INV_TRACE_RUNTIME_ENABLING_REQ_STR)


//Definition for struct MON_INV_TRACE_RUNTIME_ENABLING_RESP
#define MON_INV_TRACE_RUNTIME_ENABLING_RESP                   0x4B                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      status;
            } __attribute__((packed)) MON_INV_TRACE_RUNTIME_ENABLING_RESP_STR;
#define SIZE_MON_INV_TRACE_RUNTIME_ENABLING_RESP              sizeof(MON_INV_TRACE_RUNTIME_ENABLING_RESP_STR)


//Definition for struct MON_INV_TRACE_RUNTIME_STATUS_REQ
#define MON_INV_TRACE_RUNTIME_STATUS_REQ                      0x4C                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint16_t     fillerbyte1;
            } __attribute__((packed)) MON_INV_TRACE_RUNTIME_STATUS_REQ_STR;
#define SIZE_MON_INV_TRACE_RUNTIME_STATUS_REQ                 sizeof(MON_INV_TRACE_RUNTIME_STATUS_REQ_STR)


//Definition for struct MON_INV_TRACE_RUNTIME_STATUS_RESP
#define MON_INV_TRACE_RUNTIME_STATUS_RESP                     0x4E                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      status;
            } __attribute__((packed)) MON_INV_TRACE_RUNTIME_STATUS_RESP_STR;
#define SIZE_MON_INV_TRACE_RUNTIME_STATUS_RESP                sizeof(MON_INV_TRACE_RUNTIME_STATUS_RESP_STR)


//Definition for struct MON_FTD_MODE_READ_REQ
#define MON_FTD_MODE_READ_REQ                                 0x08                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) MON_FTD_MODE_READ_REQ_STR;
#define SIZE_MON_FTD_MODE_READ_REQ                            sizeof(MON_FTD_MODE_READ_REQ_STR)


//Definition for struct MON_FTD_MODE_READ_RESP
#define MON_FTD_MODE_READ_RESP                                0x09                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      mode;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) MON_FTD_MODE_READ_RESP_STR;
#define SIZE_MON_FTD_MODE_READ_RESP                           sizeof(MON_FTD_MODE_READ_RESP_STR)


//Definition for struct MON_PPC_READ_REQ
#define MON_PPC_READ_REQ                                      0x0A                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint16_t     ppc_id_count;
            } __attribute__((packed)) MON_PPC_READ_REQ_STR;
#define SIZE_MON_PPC_READ_REQ                                 sizeof(MON_PPC_READ_REQ_STR)


//Definition for struct MON_PPC_READ_RESP
#define MON_PPC_READ_RESP                                     0x0B                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint16_t     sub_block_count;
            } __attribute__((packed)) MON_PPC_READ_RESP_STR;
#define SIZE_MON_PPC_READ_RESP                                sizeof(MON_PPC_READ_RESP_STR)


//Definition for struct MON_PPC_RESET_REQ
#define MON_PPC_RESET_REQ                                     0x0C                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      sub_block_count;
            } __attribute__((packed)) MON_PPC_RESET_REQ_STR;
#define SIZE_MON_PPC_RESET_REQ                                sizeof(MON_PPC_RESET_REQ_STR)


//Definition for struct MON_PPC_RESET_RESP
#define MON_PPC_RESET_RESP                                    0x0D                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) MON_PPC_RESET_RESP_STR;
#define SIZE_MON_PPC_RESET_RESP                               sizeof(MON_PPC_RESET_RESP_STR)


//Definition for struct MON_PPC_UPDATE_REQ
#define MON_PPC_UPDATE_REQ                                    0x0E                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      response_needed;
             uint8_t      sub_block_count;
            } __attribute__((packed)) MON_PPC_UPDATE_REQ_STR;
#define SIZE_MON_PPC_UPDATE_REQ                               sizeof(MON_PPC_UPDATE_REQ_STR)


//Definition for struct MON_PPC_UPDATE_RESP
#define MON_PPC_UPDATE_RESP                                   0x0F                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      sub_block_count;
            } __attribute__((packed)) MON_PPC_UPDATE_RESP_STR;
#define SIZE_MON_PPC_UPDATE_RESP                              sizeof(MON_PPC_UPDATE_RESP_STR)


//Definition for struct MON_PPC_DECREMENT_REQ
#define MON_PPC_DECREMENT_REQ                                 0x17                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      response_needed;
             uint8_t      sub_block_count;
            } __attribute__((packed)) MON_PPC_DECREMENT_REQ_STR;
#define SIZE_MON_PPC_DECREMENT_REQ                            sizeof(MON_PPC_DECREMENT_REQ_STR)


//Definition for struct MON_PPC_DECREMENT_RESP
#define MON_PPC_DECREMENT_RESP                                0x18                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      sub_block_count;
            } __attribute__((packed)) MON_PPC_DECREMENT_RESP_STR;
#define SIZE_MON_PPC_DECREMENT_RESP                           sizeof(MON_PPC_DECREMENT_RESP_STR)


//Definition for struct MON_OPERATOR_FTD_REQ
#define MON_OPERATOR_FTD_REQ                                  0x13                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      state;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) MON_OPERATOR_FTD_REQ_STR;
#define SIZE_MON_OPERATOR_FTD_REQ                             sizeof(MON_OPERATOR_FTD_REQ_STR)


//Definition for struct MON_OPERATOR_FTD_RESP
#define MON_OPERATOR_FTD_RESP                                 0x14                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) MON_OPERATOR_FTD_RESP_STR;
#define SIZE_MON_OPERATOR_FTD_RESP                            sizeof(MON_OPERATOR_FTD_RESP_STR)


//Definition for struct MON_DSP_STATUS_UPDATE_REQ
#define MON_DSP_STATUS_UPDATE_REQ                             0x15                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      response_needed;
             uint8_t      sub_block_count;
            } __attribute__((packed)) MON_DSP_STATUS_UPDATE_REQ_STR;
#define SIZE_MON_DSP_STATUS_UPDATE_REQ                        sizeof(MON_DSP_STATUS_UPDATE_REQ_STR)


//Definition for struct MON_DSP_STATUS_UPDATE_RESP
#define MON_DSP_STATUS_UPDATE_RESP                            0x16                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) MON_DSP_STATUS_UPDATE_RESP_STR;
#define SIZE_MON_DSP_STATUS_UPDATE_RESP                       sizeof(MON_DSP_STATUS_UPDATE_RESP_STR)


//Definition for struct MON_OS_TRACE_ENABLE_REQ
#define MON_OS_TRACE_ENABLE_REQ                               0x1D                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      trace_info_storage;
             uint8_t      fillerbyte1;
             uint32_t     os_trace_bitmap;
            } __attribute__((packed)) MON_OS_TRACE_ENABLE_REQ_STR;
#define SIZE_MON_OS_TRACE_ENABLE_REQ                          sizeof(MON_OS_TRACE_ENABLE_REQ_STR)


//Definition for struct MON_OS_TRACE_ENABLE_RESP
#define MON_OS_TRACE_ENABLE_RESP                              0x1E                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      status;
            } __attribute__((packed)) MON_OS_TRACE_ENABLE_RESP_STR;
#define SIZE_MON_OS_TRACE_ENABLE_RESP                         sizeof(MON_OS_TRACE_ENABLE_RESP_STR)


//Definition for struct MON_OS_TRACE_DISABLE_REQ
#define MON_OS_TRACE_DISABLE_REQ                              0x1F                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      trace_info_storage;
             uint8_t      fillerbyte1;
             uint32_t     os_trace_bitmap;
            } __attribute__((packed)) MON_OS_TRACE_DISABLE_REQ_STR;
#define SIZE_MON_OS_TRACE_DISABLE_REQ                         sizeof(MON_OS_TRACE_DISABLE_REQ_STR)


//Definition for struct MON_OS_TRACE_DISABLE_RESP
#define MON_OS_TRACE_DISABLE_RESP                             0x20                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      status;
            } __attribute__((packed)) MON_OS_TRACE_DISABLE_RESP_STR;
#define SIZE_MON_OS_TRACE_DISABLE_RESP                        sizeof(MON_OS_TRACE_DISABLE_RESP_STR)


//Definition for struct MON_OS_TRACE_STATUS_REQ
#define MON_OS_TRACE_STATUS_REQ                               0x21                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) MON_OS_TRACE_STATUS_REQ_STR;
#define SIZE_MON_OS_TRACE_STATUS_REQ                          sizeof(MON_OS_TRACE_STATUS_REQ_STR)


//Definition for struct MON_OS_TRACE_STATUS_RESP
#define MON_OS_TRACE_STATUS_RESP                              0x22                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      trace_info_storage;
             uint8_t      fillerbyte1;
             uint32_t     os_trace_bitmap;
            } __attribute__((packed)) MON_OS_TRACE_STATUS_RESP_STR;
#define SIZE_MON_OS_TRACE_STATUS_RESP                         sizeof(MON_OS_TRACE_STATUS_RESP_STR)


//Definition for struct MON_PPC_DATA_GET_REQ
#define MON_PPC_DATA_GET_REQ                                  0x23                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      all_data;
             uint8_t      fillerbyte1;
             uint16_t     ppc_id_count;
            } __attribute__((packed)) MON_PPC_DATA_GET_REQ_STR;
#define SIZE_MON_PPC_DATA_GET_REQ                             sizeof(MON_PPC_DATA_GET_REQ_STR)


//Definition for struct MON_PPC_DATA_GET_RESP
#define MON_PPC_DATA_GET_RESP                                 0x24                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      last_response;
             uint8_t      fillerbyte1;
             uint16_t     sub_block_count;
            } __attribute__((packed)) MON_PPC_DATA_GET_RESP_STR;
#define SIZE_MON_PPC_DATA_GET_RESP                            sizeof(MON_PPC_DATA_GET_RESP_STR)


//Definition for struct MON_TASK_STACK_USAGE_REQ
#define MON_TASK_STACK_USAGE_REQ                              0x25                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      os_task_id;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) MON_TASK_STACK_USAGE_REQ_STR;
#define SIZE_MON_TASK_STACK_USAGE_REQ                         sizeof(MON_TASK_STACK_USAGE_REQ_STR)


//Definition for struct MON_TASK_STACK_USAGE_RESP
#define MON_TASK_STACK_USAGE_RESP                             0x26                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      os_task_id;
             uint32_t     worst_stack;
             uint32_t     allocated_stack;
             uint32_t     uptime;
             uint8_t      number_of_tasks;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      string_length;
             uint8_t      task_name[0];
            } __attribute__((packed)) MON_TASK_STACK_USAGE_RESP_STR;
#define SIZE_MON_TASK_STACK_USAGE_RESP                        sizeof(MON_TASK_STACK_USAGE_RESP_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct MON_RESOURCE_STACK_USAGE_REQ
#define MON_RESOURCE_STACK_USAGE_REQ                          0x27                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint32_t     pn_res_id;
            } __attribute__((packed)) MON_RESOURCE_STACK_USAGE_REQ_STR;
#define SIZE_MON_RESOURCE_STACK_USAGE_REQ                     sizeof(MON_RESOURCE_STACK_USAGE_REQ_STR)


//Definition for struct MON_RESOURCE_STACK_USAGE_RESP
#define MON_RESOURCE_STACK_USAGE_RESP                         0x28                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      number_of_tasks;
             uint16_t     obj_id;
             uint8_t      task_id;
             uint8_t      string_length;
             uint32_t     worst_stack;
             uint32_t     allocated_stack;
             uint32_t     uptime;
             uint8_t      task_name[0];
            } __attribute__((packed)) MON_RESOURCE_STACK_USAGE_RESP_STR;
#define SIZE_MON_RESOURCE_STACK_USAGE_RESP                    sizeof(MON_RESOURCE_STACK_USAGE_RESP_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct MON_TRACE_INFO_REQ
#define MON_TRACE_INFO_REQ                                    0x29                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) MON_TRACE_INFO_REQ_STR;
#define SIZE_MON_TRACE_INFO_REQ                               sizeof(MON_TRACE_INFO_REQ_STR)


//Definition for struct MON_TRACE_INFO_RESP
#define MON_TRACE_INFO_RESP                                   0x2A                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      length;
             uint8_t      filename[0];
            } __attribute__((packed)) MON_TRACE_INFO_RESP_STR;
#define SIZE_MON_TRACE_INFO_RESP                              sizeof(MON_TRACE_INFO_RESP_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct MON_MULDER_AUTOSMS_CTRL_REQ
#define MON_MULDER_AUTOSMS_CTRL_REQ                           0x2B                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      action;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) MON_MULDER_AUTOSMS_CTRL_REQ_STR;
#define SIZE_MON_MULDER_AUTOSMS_CTRL_REQ                      sizeof(MON_MULDER_AUTOSMS_CTRL_REQ_STR)


//Definition for struct MON_MULDER_AUTOSMS_CTRL_RESP
#define MON_MULDER_AUTOSMS_CTRL_RESP                          0x2C                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      response;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) MON_MULDER_AUTOSMS_CTRL_RESP_STR;
#define SIZE_MON_MULDER_AUTOSMS_CTRL_RESP                     sizeof(MON_MULDER_AUTOSMS_CTRL_RESP_STR)


//Definition for struct MON_MULDER_DUMP_DELETE_REQ
#define MON_MULDER_DUMP_DELETE_REQ                            0x33                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint16_t     dump_id;
            } __attribute__((packed)) MON_MULDER_DUMP_DELETE_REQ_STR;
#define SIZE_MON_MULDER_DUMP_DELETE_REQ                       sizeof(MON_MULDER_DUMP_DELETE_REQ_STR)


//Definition for struct MON_MULDER_DUMP_DELETE_RESP
#define MON_MULDER_DUMP_DELETE_RESP                           0x34                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) MON_MULDER_DUMP_DELETE_RESP_STR;
#define SIZE_MON_MULDER_DUMP_DELETE_RESP                      sizeof(MON_MULDER_DUMP_DELETE_RESP_STR)


//Definition for struct MON_MULDER_DUMP_GET_REQ
#define MON_MULDER_DUMP_GET_REQ                               0x2F                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint16_t     dump_id;
            } __attribute__((packed)) MON_MULDER_DUMP_GET_REQ_STR;
#define SIZE_MON_MULDER_DUMP_GET_REQ                          sizeof(MON_MULDER_DUMP_GET_REQ_STR)


//Definition for struct MON_MULDER_DUMP_GET_RESP
#define MON_MULDER_DUMP_GET_RESP                              0x30                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      sub_block_count;
            } __attribute__((packed)) MON_MULDER_DUMP_GET_RESP_STR;
#define SIZE_MON_MULDER_DUMP_GET_RESP                         sizeof(MON_MULDER_DUMP_GET_RESP_STR)


//Definition for struct MON_MULDER_DUMP_ID_GET_REQ
#define MON_MULDER_DUMP_ID_GET_REQ                            0x2D                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) MON_MULDER_DUMP_ID_GET_REQ_STR;
#define SIZE_MON_MULDER_DUMP_ID_GET_REQ                       sizeof(MON_MULDER_DUMP_ID_GET_REQ_STR)


//Definition for struct MON_MULDER_DUMP_ID_GET_RESP
#define MON_MULDER_DUMP_ID_GET_RESP                           0x2E                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      sub_block_count;
            } __attribute__((packed)) MON_MULDER_DUMP_ID_GET_RESP_STR;
#define SIZE_MON_MULDER_DUMP_ID_GET_RESP                      sizeof(MON_MULDER_DUMP_ID_GET_RESP_STR)


//Definition for struct MON_FTD_CONTROL_REQ
#define MON_FTD_CONTROL_REQ                                   0x31                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      action;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) MON_FTD_CONTROL_REQ_STR;
#define SIZE_MON_FTD_CONTROL_REQ                              sizeof(MON_FTD_CONTROL_REQ_STR)


//Definition for struct MON_FTD_CONTROL_RESP
#define MON_FTD_CONTROL_RESP                                  0x32                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) MON_FTD_CONTROL_RESP_STR;
#define SIZE_MON_FTD_CONTROL_RESP                             sizeof(MON_FTD_CONTROL_RESP_STR)


//Definition for struct MON_MULDER_APO_INFO_REQ
#define MON_MULDER_APO_INFO_REQ                               0x3B                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) MON_MULDER_APO_INFO_REQ_STR;
#define SIZE_MON_MULDER_APO_INFO_REQ                          sizeof(MON_MULDER_APO_INFO_REQ_STR)


//Definition for struct MON_MULDER_APO_INFO_RESP
#define MON_MULDER_APO_INFO_RESP                              0x3C                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint32_t     apo_start_address;
             uint32_t     apo_size_on_pmm;
            } __attribute__((packed)) MON_MULDER_APO_INFO_RESP_STR;
#define SIZE_MON_MULDER_APO_INFO_RESP                         sizeof(MON_MULDER_APO_INFO_RESP_STR)


//Definition for struct MON_OS_TRACE_CALL_STACK_DEPTH_SET_REQ
#define MON_OS_TRACE_CALL_STACK_DEPTH_SET_REQ                 0x3D                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      sub_block_count;
            } __attribute__((packed)) MON_OS_TRACE_CALL_STACK_DEPTH_SET_REQ_STR;
#define SIZE_MON_OS_TRACE_CALL_STACK_DEPTH_SET_REQ            sizeof(MON_OS_TRACE_CALL_STACK_DEPTH_SET_REQ_STR)


//Definition for struct MON_OS_TRACE_CALL_STACK_DEPTH_SET_RESP
#define MON_OS_TRACE_CALL_STACK_DEPTH_SET_RESP                0x3E                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      status;
            } __attribute__((packed)) MON_OS_TRACE_CALL_STACK_DEPTH_SET_RESP_STR;
#define SIZE_MON_OS_TRACE_CALL_STACK_DEPTH_SET_RESP           sizeof(MON_OS_TRACE_CALL_STACK_DEPTH_SET_RESP_STR)

#endif
