#ifndef _PN_MTC_ISI_H_
#define _PN_MTC_ISI_H_

#include <stdint.h> 

//Resource Mobile Terminal Controller Server
//PN_MTC 0x15 
//ISI version 018.000
#define MOBILE_TERMINAL_CONTROLLER_SERVER_ISI_VERSION_Z     18
#define MOBILE_TERMINAL_CONTROLLER_SERVER_ISI_VERSION_Y     0

//In case of problems concerning content of this file contact Markku Loukusa, Sauli Laukka or Markus Mrsky
//Server specific message descriptions and feature&protocol descriptions can be found from: https://oucmswww.nmp.nokia.com:58443/document_browser/ccm_wa/GIF_SPECS/ 


//ISI VERSION CHANGE HISTORY

//Version: 018.000                                           
//Status: NonDraft                                          
//Date: 05-Feb-2008     Timo Toivola
//Reason: Change request
//Reference: ADB for SWAM TT08020542226 for interface CR., NON-DRAFT

//Version: 017.019                                           
//Status: NonDraft                                          
//Date: 20-Jun-2007     Harri Turunen
//Reason: Change request
//Reference: Interface CR: ADB for SWAM HT07061549310. , NON-DRAFT

//Version: 017.018                                           
//Status: NonDraft                                          
//Date: 16-May-2007     Harri Turunen
//Reason: Change request
//Reference: Interface CR: ADB for SWAM HT07043054138. , NON-DRAFT

//Version: 017.017                                           
//Status: NonDraft                                          
//Date: 20-Dec-2006     Pasi Tolonen
//Reason: Change request
//Reference: Interface CR: ADB for SWAM PT06121537900. , NON-DRAFT

//Version: 017.016                                           
//Status: NonDraft                                          
//Date: 18-Dec-2006     Harri Turunen
//Reason: Change request
//Reference: Interface CR: ADB for SWAM HT06121148817. , NON-DRAFT

//Version: 017.015                                           
//Status: NonDraft                                          
//Date: 31-Oct-2006     Harri Turunen
//Reason: Change request
//Reference: Interface CR: ADB for SWAM HT06102436714. , NON-DRAFT

//Version: 017.014                                           
//Status: NonDraft                                          
//Date: 15-Sep-2006     Harri Turunen
//Reason: Change request
//Reference: Interface CR: ADB for SWAM HT06090759277. , NON-DRAFT

//Version: 017.013                                           
//Status: NonDraft                                          
//Date: 25-Aug-2006     Harri Turunen
//Reason: Change request
//Reference: Interface CR: ADB for SWAM HT06082534368. , NON-DRAFT

//Version: 017.012                                           
//Status: NonDraft                                          
//Date: 19-Jun-2006     Pasi Tolonen
//Reason: Change request
//Reference: Interface CR: ADB for SWAM PT06061939747. , NON-DRAFT

//Version: 017.011                                           
//Status: NonDraft                                          
//Date: 14-Mar-2006     Vesa P.Keranen
//Reason: Change request
//Reference: Interface CR: ADB for SWAM VK06031443009. , NON-DRAFT

//Version: 017.010                                           
//Status: NonDraft                                          
//Date: 03-Jan-2006     Vesa P.Keranen
//Reason: Change request
//Reference: Interface CR: ADB for SWAM VK06010348611. , Inspection minutes: ADB for SWAM VK06010350953. , NON-DRAFT

//Version: 017.009                                           
//Status: NonDraft                                          
//Date: 12-Oct-2005     Vesa P.Keranen
//Reason: Change request
//Reference: Interface CR: ADB for SWAM VK05092043422. , Inspection minutes: ADB for SWAM VK05092745290. , NON-DRAFT

//Version: 017.008                                           
//Status: NonDraft                                          
//Date: 04-Oct-2005     Vesa P.Keranen
//Reason: Change request
//Reference: Interface CR: ADB for SWAM VK05092050795. , Inspection minutes: ADB for SWAM VK05092926351. , NON-DRAFT

//Version: 017.007                                           
//Status: NonDraft                                          
//Date: 23-Aug-2004     Toni Laivo
//Reason: Change request
//Reference: ActionDB for SWAM / TL04082345432, NON-DRAFT

//Version: 017.006                                           
//Status: NonDraft                                          
//Date: 24-Mar-2004     Toni Laivo
//Reason: Change request
//Reference: ActionDB for SWAM / TL04032428422, NON-DRAFT

//Version: 017.005                                           
//Status: NonDraft                                          
//Date: 01-Mar-2004     Toni Laivo
//Reason: Change request
//Reference: ActionDB for SWAM / TL04030134794, NON-DRAFT

//Version: 017.004                                           
//Status: NonDraft                                          
//Date: 19-Nov-2003     Toni Laivo
//Reason: Moved to continuus
//Reference: -, NON-DRAFT

//Version: 017.003                                           
//Status: NonDraft                                          
//Date: 22-Oct-2003     Toni Laivo
//Reason: Change request and update
//Reference: ActionDB for SWAM / TL03100852978, NON-DRAFT

//Version: 017.002                                           
//Status: NonDraft                                          
//Date: 13-May-2003     Toni Laivo
//Reason: Change request
//Reference: ActionDB for SWAM / TL03051344216, NON-DRAFT

//Version: 017.001                                           
//Status: NonDraft                                          
//Date: 08-Mar-2003     Toni Laivo
//Reason: Change request
//Reference: ActionDB for SWAM / TL03040849466, NON-DRAFT

//Version: 017.000                                           
//Status: NonDraft                                          
//Date: 23-Sep-2002     Toni Laivo
//Reason: Version update
//Reference: ActionDB for SWAM / IJ02032226253, NON-DRAFT


//CONSTANTS
#define MTC_LAST_REQ_ID                                       0x18                                                  
#define MTC_LAST_MSG_ID                                       0xC3                                                  
#define MTC_SLEEP_WITH_RESET                                  0x8000                                                
#define MTC_CDPS                                              0xA1                                                  
#define MTC_ANY_SIZE                                          1                                                     


//TABLES

//ConstantTable for MTC_ACTION
#define MTC_START                                             0x03                                                     
#define MTC_READY                                             0x04                                                     
#define MTC_NOS_READY                                         0x0C                                                     
#define MTC_SOS_START                                         0x11                                                  
#define MTC_SOS_READY                                         0x12                                                  
#define MTC_NOT_SUPPORTED                                     0x14                                                  
#define MTC_NOT_AVAILABLE                                     0x15                                                  

//ConstantTable for MTC_STATUS_INFO
#define MTC_OK                                                0x00                                                     
#define MTC_FAIL                                              0x01                                                     
#define MTC_NOT_ALLOWED                                       0x02                                                     
#define MTC_STATE_TRANSITION_GOING_ON                         0x05                                                     
#define MTC_ALREADY_ACTIVE                                    0x06                                                     
#define MTC_SERVICE_DISABLED                                  0x10                                                  
#define MTC_NOT_READY_YET                                     0x13                                                  
//#define MTC_NOT_SUPPORTED                                   0x14                       //Already defined as 0x14
#define MTC_TRANSITION_ONGOING                                0x16                                                  
#define MTC_RESET_REQUIRED                                    0x17                                                  

//ConstantTable for MTC_STATE_CONSTANTS
#define MTC_POWER_OFF                                         0x00                                                     
#define MTC_NORMAL                                            0x01                                                     
#define MTC_CHARGING                                          0x02                                                     
#define MTC_ALARM                                             0x03                                                     
#define MTC_TEST                                              0x04                                                     
#define MTC_LOCAL                                             0x05                                                     
#define MTC_WARRANTY                                          0x06                                                     
#define MTC_RELIABILITY                                       0x07                                                     
#define MTC_SELFTEST_FAIL                                     0x08                                                     
#define MTC_SWDL                                              0x09                                                     
#define MTC_RF_INACTIVE                                       0x0A                                                     
#define MTC_ID_WRITE                                          0x0B                                                     
#define MTC_DISCHARGING                                       0x0C                                                     
#define MTC_DISK_WIPE                                         0x0D                                                     
#define MTC_SW_RESET                                          0x0E                                                     
#define MTC_CMT_ONLY_MODE                                     0xFF                                                  

//ConstantTable for MTC_RESET_TYPE
#define MTC_HIDDEN_RESET                                      0x07                                                     
#define MTC_STATE_VIA_RESET                                   0x08                                                     
#define MTC_DEVICE_RESET                                      0x0B                                                     

//ConstantTable for MTC_SLEEP_TYPE
#define MTC_LIGHT_SLEEP                                       0x09                                                     
#define MTC_DEEP_SLEEP                                        0x0A                                                     

//ConstantTable for MTC_CLOCK_TYPE
#define MTC_SYSTEM_CLOCK                                      0x01                                                     
#define MTC_PROCESSOR_CLOCK                                   0x02                                                     

//ConstantTable for MTC_CLOCK_ACTION
#define MTC_SYSTEM_MODE_GSM                                   0x01                                                     
#define MTC_SYSTEM_MODE_DAMPS                                 0x02                                                     
#define MTC_HIGH_FREQUENCY_RESERVE                            0x10                                                  
#define MTC_HIGH_FREQUENCY_RELEASE                            0x20                                                  

//ConstantTable for MTC_WD_ACTION
#define MTC_WATCHDOG_ENABLE                                   0x01                                                     
#define MTC_WATCHDOG_DISABLE                                  0x02                                                     

//ConstantTable for MTC_FORCE_ACTION
#define MTC_SET                                               0x0E                                                     
#define MTC_CLEAR                                             0x0F                                                     

//ConstantTable for MTC_RAT_INFO
#define MTC_UNKNOWN_RAT                                       0x00                                                     
#define MTC_NO_RAT_SELECTION                                  0x01                                                     
#define MTC_GSM_RAT                                           0x02                                                     
#define MTC_UMTS_RAT                                          0x03                                                     

//ConstantTable for MTC_RAT_STATE
#define MTC_NO_CHANGE                                         0x00                                                     
//#define MTC_NORMAL                                          0x01                        //Already defined as 0x01
//#define MTC_CHARGING                                        0x02                        //Already defined as 0x02
//#define MTC_ALARM                                           0x03                        //Already defined as 0x03
//#define MTC_TEST                                            0x04                        //Already defined as 0x04
//#define MTC_LOCAL                                           0x05                        //Already defined as 0x05
//#define MTC_WARRANTY                                        0x06                        //Already defined as 0x06
//#define MTC_RELIABILITY                                     0x07                        //Already defined as 0x07
//#define MTC_SELFTEST_FAIL                                   0x08                        //Already defined as 0x08
//#define MTC_SWDL                                            0x09                        //Already defined as 0x09
//#define MTC_RF_INACTIVE                                     0x0A                        //Already defined as 0x0A
//#define MTC_ID_WRITE                                        0x0B                        //Already defined as 0x0B
//#define MTC_DISCHARGING                                     0x0C                        //Already defined as 0x0C
//#define MTC_DISK_WIPE                                       0x0D                        //Already defined as 0x0D

//ConstantTable for MTC_DEVICE_INFO
#define MTC_CDSP                                              0xA1                                                  
#define MTC_ADSP                                              0xA2                                                  

//ConstantTable for MTC_ACTION_SELECT
#define MTC_DISABLE                                           0x00                                                     
#define MTC_ENABLE                                            0x01                                                     

//ConstantTable for MTC_RESET_TYPE_HIDDEN
#define MTC_RESET_SW_RESET                                    0x00                                                     
#define MTC_RESET_SOS_RESET                                   0x01                                                     

//ConstantTable for MTC_POWER_OFF_INFO
#define MTC_NORMAL_POWER_OFF                                  0x00                                                     
#define MTC_POWER_KEY_PRESS_TOO_SHORT                         0x0D                                                     

//ConstantTable for MTC_NOT_VALID
#define MTC_NOT_VALID                                         0x00                                                     
//#define MTC_CMT_ONLY_MODE                                   0xFF                       //Already defined as 0xFF

//ConstantTable for MTC_GENERIC_STATUS_QUERY_ACTION
#define MTC_LONG_PWR_KEY_COUNT                                0x00                                                     

//ConstantTable for MTC_RF_STATUS
#define MTC_RF_OFF                                            0x00                                                     
#define MTC_RF_ON                                             0x01                                                     
#define MTC_RF_WIFI                                           0x02                                                     

//ConstantTable for PERF_STATUS_INFO
#define PERF_OK                                               0x00                                                     
#define PERF_FAIL                                             0x01                                                     
#define PERF_HAL_FAIL                                         0x02                                                     
#define PERF_NOT_ACTIVE                                       0x03                                                     

//ConstantTable for PERF_SUB_SYSTEM_ID
#define PERF_NETWORK_SUB_SYSTEM                               0x00                                                     
#define PERF_AUDIO_SUB_SYSTEM                                 0x01                                                     
#define PERF_VIDEO_SUB_SYSTEM                                 0x02                                                     
#define PERF_CAMERA_SUB_SYSTEM                                0x03                                                     
#define PERF_DISPLAY_SUB_SYSTEM                               0x04                                                     
#define PERF_USB_SUB_SYSTEM                                   0x05                                                     
#define PERF_BT_SUB_SYSTEM                                    0x06                                                     
#define PERF_IRDA_SUB_SYSTEM                                  0x07                                                     
#define PERF_WLAN_SUB_SYSTEM                                  0x08                                                     
#define PERF_MEMORY_SUB_SYSTEM                                0x09                                                     
#define PERF_SECURITY_SUB_SYSTEM                              0x0A                                                     

//ConstantTable for PERF_SUB_SYSTEM_SERVICE
#define PERF_IDLE                                             0x00                                                     
#define PERF_CALL                                             0x01                                                     
#define PERF_HS_CALL                                          0x02                                                     
#define PERF_NO_SERVICE                                       0xFFFF                                                

//ConstantTable for PERF_STATE_REQ_INFO
#define PERF_ON                                               0x00                                                     
#define PERF_OFF                                              0x01                                                     
#define PERF_SUB_SYSTEM_ON                                    0x02                                                     
#define PERF_SUB_SYSTEM_OFF                                   0x03                                                     
#define PERF_NOS_LOAD_ON                                      0x04                                                     
#define PERF_NOS_LOAD_OFF                                     0x05                                                     

//ConstantTable for PERF_VALUE_UNIT
#define PERF_MIPS                                             0x00                                                     
#define PERF_MHZ                                              0x01                                                     

//ConstantTable for PERF_VCORE_CALIB_STATUS
#define PERF_CALIBRATION_OK                                   0x00                                                     
#define PERF_CALIBRATION_OK_EFUSE_NOT_FOUND                   0x01                                                     
#define PERF_CALIBRATION_OK_UNDERFLOW                         0x02                                                     
#define PERF_CALIBRATION_FAIL_VCORE_TOO_HIGH                  0x10                                                  
#define PERF_CALIBRATION_FAIL_EFUSE_NOT_FOUND                 0x11                                                  
#define PERF_CALIBRATION_FAIL                                 0x12                                                  

//ConstantTable for PERF_VCORE_VSEL_MODE
#define PERF_SMPS_OPERATION_FORCED_PWM                        0x00                                                     
#define PERF_SMPS_OPERATION_FAST_PFM                          0x01                                                     

//ConstantTable for PERF_VCORE_CALIB_INFO
#define PERF_VCORE_1ST                                        0x00                                                     
#define PERF_VCORE_CUR                                        0x01                                                     

//BitmaskTables for MTC_RESET_TYPES
#define MTC_RESET_DEVICE_CDSP                                 0x01                                                     
#define MTC_RESET_DEVICE_ADSP                                 0x02                                                     
#define MTC_RESET_ALL                                         0xFF                                                  

//BitmaskTables for MTC_WD_TYPE
#define MTC_WATCHDOG_SW                                       0x01                                                     
#define MTC_WATCHDOG_UPP                                      0x02                                                     
#define MTC_WATCHDOG_CDSP                                     0x04                                                     
#define MTC_WATCHDOG_ADSP                                     0x08                                                     
#define MTC_WATCHDOG_MODEM                                    0x10                                                  
#define MTC_WATCHDOG_MODEM_SW                                 0x20                                                  
#define MTC_WATCHDOG_ALL                                      0xFF                                                  

//BitmaskTables for PERF_INFO_DATA
#define PERF_HW_CONF_VCORE                                    0x0001                                                     
#define PERF_HW_CONF_VCORE_PROD_1ST                           0x0002                                                     
#define PERF_HW_CONF_VCORE_PROD_CUR                           0x0004                                                     


//STRUCTURES


//Definition for struct PERF_HW_CONF_FREQ_SEQ
typedef struct
            { 
             uint32_t     hz;
             uint16_t     pll_mul;
             uint16_t     pll_div;
            } __attribute__((packed)) PERF_HW_CONF_FREQ_SEQ_STR;
#define SIZE_PERF_HW_CONF_FREQ_SEQ                            sizeof(PERF_HW_CONF_FREQ_SEQ_STR)


//Definition for struct PERF_HW_CONF_VCORE_SEQ
typedef struct
            { 
             uint32_t     smps_mode;
             uint32_t     vcore_raw;
             uint32_t     vcore_final;
             PERF_HW_CONF_FREQ_SEQ_STR    mcu_freq[0];
             PERF_HW_CONF_FREQ_SEQ_STR    dsp1_freq[0];
             PERF_HW_CONF_FREQ_SEQ_STR    dsp2_freq[0];
            } __attribute__((packed)) PERF_HW_CONF_VCORE_SEQ_STR;
#define SIZE_PERF_HW_CONF_VCORE_SEQ                           sizeof(PERF_HW_CONF_VCORE_SEQ_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//SUBBLOCKS


//Definition for struct MTC_SB_MEM_DL_DATA
#define MTC_SB_MEM_DL_DATA                                    0x01                                                     
typedef struct
            { 
             uint8_t      sb_id;
             uint8_t      sb_len;
             uint16_t     src_start_addr_msw;
             uint16_t     src_start_addr_lsw;
             uint16_t     src_end_addr_msw;
             uint16_t     src_end_addr_lsw;
             uint16_t     dest_start_addr_msw;
             uint16_t     dest_start_addr_lsw;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) MTC_SB_MEM_DL_DATA_STR;
#define SIZE_MTC_SB_MEM_DL_DATA                               sizeof(MTC_SB_MEM_DL_DATA_STR)


//Definition for struct MTC_SB_LONG_PWR_KEY_COUNT
#define MTC_SB_LONG_PWR_KEY_COUNT                             0x02                                                     
typedef struct
            { 
             uint8_t      sb_id;
             uint8_t      sb_len;
             uint8_t      status;
             uint8_t      count;
            } __attribute__((packed)) MTC_SB_LONG_PWR_KEY_COUNT_STR;
#define SIZE_MTC_SB_LONG_PWR_KEY_COUNT                        sizeof(MTC_SB_LONG_PWR_KEY_COUNT_STR)


//Definition for struct PERF_SB_OPERATING_POINT
#define PERF_SB_OPERATING_POINT                               0x30                                                  
typedef struct
            { 
             uint8_t      sb_id;
             uint8_t      sb_len;
             uint8_t      operating_point;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) PERF_SB_OPERATING_POINT_STR;
#define SIZE_PERF_SB_OPERATING_POINT                          sizeof(PERF_SB_OPERATING_POINT_STR)


//Definition for struct PERF_SB_SERVICE_SETTING
#define PERF_SB_SERVICE_SETTING                               0x31                                                  
typedef struct
            { 
             uint8_t      sb_id;
             uint8_t      sb_len;
             uint16_t     sub_system;
             uint16_t     service;
             uint8_t      operating_point;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) PERF_SB_SERVICE_SETTING_STR;
#define SIZE_PERF_SB_SERVICE_SETTING                          sizeof(PERF_SB_SERVICE_SETTING_STR)


//Definition for struct PERF_SB_PERFORMANCE
#define PERF_SB_PERFORMANCE                                   0x32                                                  
typedef struct
            { 
             uint8_t      sb_id;
             uint8_t      sb_len;
             uint8_t      fillerbyte1;
             uint8_t      value_unit;
             uint16_t     value;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
            } __attribute__((packed)) PERF_SB_PERFORMANCE_STR;
#define SIZE_PERF_SB_PERFORMANCE                              sizeof(PERF_SB_PERFORMANCE_STR)


//Definition for struct PERF_SB_HW_CONF_VCORE
#define PERF_SB_HW_CONF_VCORE                                 0x33                                                  
typedef struct
            { 
             uint8_t      sb_id;
             uint8_t      fillerbyte1;
             uint16_t     sb_len;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
             uint8_t      vcore1_count;
             uint8_t      vcore2_count;
             uint32_t     status;
             uint8_t      fillerbyte4[3];
             uint8_t      fillerbyte5[3];
             uint8_t      fillerbyte6[3];
             uint8_t      fillerbyte7[3];
             PERF_HW_CONF_VCORE_SEQ_STR    vcore_master[0];
             PERF_HW_CONF_VCORE_SEQ_STR    vcore_slave[0];
            } __attribute__((packed)) PERF_SB_HW_CONF_VCORE_STR;
#define SIZE_PERF_SB_HW_CONF_VCORE                            sizeof(PERF_SB_HW_CONF_VCORE_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct PERF_SB_HW_CONF_VCORE_PROD
#define PERF_SB_HW_CONF_VCORE_PROD                            0x36                                                  
typedef struct
            { 
             uint8_t      sb_id;
             uint8_t      sb_len;
             uint8_t      vcore_count;
             uint8_t      calib_info;
             uint32_t     status;
             uint8_t      fillerbyte1[3];
             uint8_t      fillerbyte2[3];
             uint8_t      fillerbyte3[3];
             uint8_t      fillerbyte4[3];
             uint32_t     vcore_raw[0];
             uint32_t     vcore_final[0];
            } __attribute__((packed)) PERF_SB_HW_CONF_VCORE_PROD_STR;
#define SIZE_PERF_SB_HW_CONF_VCORE_PROD                       sizeof(PERF_SB_HW_CONF_VCORE_PROD_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//MESSAGES


//Definition for struct MTC_POWER_OFF_REQ
#define MTC_POWER_OFF_REQ                                     0x03                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fill1;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) MTC_POWER_OFF_REQ_STR;
#define SIZE_MTC_POWER_OFF_REQ                                sizeof(MTC_POWER_OFF_REQ_STR)


//Definition for struct MTC_POWER_OFF_RESP
#define MTC_POWER_OFF_RESP                                    0x66                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) MTC_POWER_OFF_RESP_STR;
#define SIZE_MTC_POWER_OFF_RESP                               sizeof(MTC_POWER_OFF_RESP_STR)


//Definition for struct MTC_POWER_ON_REQ
#define MTC_POWER_ON_REQ                                      0x04                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) MTC_POWER_ON_REQ_STR;
#define SIZE_MTC_POWER_ON_REQ                                 sizeof(MTC_POWER_ON_REQ_STR)


//Definition for struct MTC_POWER_ON_RESP
#define MTC_POWER_ON_RESP                                     0x67                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) MTC_POWER_ON_RESP_STR;
#define SIZE_MTC_POWER_ON_RESP                                sizeof(MTC_POWER_ON_RESP_STR)


//Definition for struct MTC_RESET_GENERATE_REQ
#define MTC_RESET_GENERATE_REQ                                0x06                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      type;
             uint8_t      state;
            } __attribute__((packed)) MTC_RESET_GENERATE_REQ_STR;
#define SIZE_MTC_RESET_GENERATE_REQ                           sizeof(MTC_RESET_GENERATE_REQ_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct MTC_RESET_GENERATE_RESP
#define MTC_RESET_GENERATE_RESP                               0x69                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) MTC_RESET_GENERATE_RESP_STR;
#define SIZE_MTC_RESET_GENERATE_RESP                          sizeof(MTC_RESET_GENERATE_RESP_STR)


//Definition for struct MTC_SLEEP_REQ
#define MTC_SLEEP_REQ                                         0x05                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint16_t     timeout;
            } __attribute__((packed)) MTC_SLEEP_REQ_STR;
#define SIZE_MTC_SLEEP_REQ                                    sizeof(MTC_SLEEP_REQ_STR)


//Definition for struct MTC_SLEEP_RESP
#define MTC_SLEEP_RESP                                        0x68                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) MTC_SLEEP_RESP_STR;
#define SIZE_MTC_SLEEP_RESP                                   sizeof(MTC_SLEEP_RESP_STR)


//Definition for struct MTC_STATE_REQ
#define MTC_STATE_REQ                                         0x01                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      state;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) MTC_STATE_REQ_STR;
#define SIZE_MTC_STATE_REQ                                    sizeof(MTC_STATE_REQ_STR)


//Definition for struct MTC_STATE_RESP
#define MTC_STATE_RESP                                        0x64                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) MTC_STATE_RESP_STR;
#define SIZE_MTC_STATE_RESP                                   sizeof(MTC_STATE_RESP_STR)


//Definition for struct MTC_STATE_INFO_IND
#define MTC_STATE_INFO_IND                                    0xC0                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      state;
             uint8_t      action;
            } __attribute__((packed)) MTC_STATE_INFO_IND_STR;
#define SIZE_MTC_STATE_INFO_IND                               sizeof(MTC_STATE_INFO_IND_STR)


//Definition for struct MTC_STATE_QUERY_REQ
#define MTC_STATE_QUERY_REQ                                   0x02                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) MTC_STATE_QUERY_REQ_STR;
#define SIZE_MTC_STATE_QUERY_REQ                              sizeof(MTC_STATE_QUERY_REQ_STR)


//Definition for struct MTC_STATE_QUERY_RESP
#define MTC_STATE_QUERY_RESP                                  0x65                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      current;
             uint8_t      target;
            } __attribute__((packed)) MTC_STATE_QUERY_RESP_STR;
#define SIZE_MTC_STATE_QUERY_RESP                             sizeof(MTC_STATE_QUERY_RESP_STR)


//Definition for struct MTC_SLEEP_ENABLE_REQ
#define MTC_SLEEP_ENABLE_REQ                                  0x07                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      type;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) MTC_SLEEP_ENABLE_REQ_STR;
#define SIZE_MTC_SLEEP_ENABLE_REQ                             sizeof(MTC_SLEEP_ENABLE_REQ_STR)


//Definition for struct MTC_SLEEP_ENABLE_RESP
#define MTC_SLEEP_ENABLE_RESP                                 0x6A                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) MTC_SLEEP_ENABLE_RESP_STR;
#define SIZE_MTC_SLEEP_ENABLE_RESP                            sizeof(MTC_SLEEP_ENABLE_RESP_STR)


//Definition for struct MTC_SLEEP_DISABLE_REQ
#define MTC_SLEEP_DISABLE_REQ                                 0x08                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      type;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) MTC_SLEEP_DISABLE_REQ_STR;
#define SIZE_MTC_SLEEP_DISABLE_REQ                            sizeof(MTC_SLEEP_DISABLE_REQ_STR)


//Definition for struct MTC_SLEEP_DISABLE_RESP
#define MTC_SLEEP_DISABLE_RESP                                0x6B                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) MTC_SLEEP_DISABLE_RESP_STR;
#define SIZE_MTC_SLEEP_DISABLE_RESP                           sizeof(MTC_SLEEP_DISABLE_RESP_STR)


//Definition for struct MTC_CLOCK_CHANGE_REQ
#define MTC_CLOCK_CHANGE_REQ                                  0x09                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      clock;
             uint8_t      action;
            } __attribute__((packed)) MTC_CLOCK_CHANGE_REQ_STR;
#define SIZE_MTC_CLOCK_CHANGE_REQ                             sizeof(MTC_CLOCK_CHANGE_REQ_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct MTC_CLOCK_CHANGE_RESP
#define MTC_CLOCK_CHANGE_RESP                                 0x6C                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) MTC_CLOCK_CHANGE_RESP_STR;
#define SIZE_MTC_CLOCK_CHANGE_RESP                            sizeof(MTC_CLOCK_CHANGE_RESP_STR)


//Definition for struct MTC_CLOCK_CHANGE_IND
#define MTC_CLOCK_CHANGE_IND                                  0xC1                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      clock;
             uint8_t      action;
            } __attribute__((packed)) MTC_CLOCK_CHANGE_IND_STR;
#define SIZE_MTC_CLOCK_CHANGE_IND                             sizeof(MTC_CLOCK_CHANGE_IND_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct MTC_WATCHDOG_CONTROL_REQ
#define MTC_WATCHDOG_CONTROL_REQ                              0x0A                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      action;
             uint8_t      watchdog_list;
            } __attribute__((packed)) MTC_WATCHDOG_CONTROL_REQ_STR;
#define SIZE_MTC_WATCHDOG_CONTROL_REQ                         sizeof(MTC_WATCHDOG_CONTROL_REQ_STR)


//Definition for struct MTC_WATCHDOG_CONTROL_RESP
#define MTC_WATCHDOG_CONTROL_RESP                             0x6D                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) MTC_WATCHDOG_CONTROL_RESP_STR;
#define SIZE_MTC_WATCHDOG_CONTROL_RESP                        sizeof(MTC_WATCHDOG_CONTROL_RESP_STR)


//Definition for struct MTC_STARTUP_SYNQ_REQ
#define MTC_STARTUP_SYNQ_REQ                                  0x0B                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) MTC_STARTUP_SYNQ_REQ_STR;
#define SIZE_MTC_STARTUP_SYNQ_REQ                             sizeof(MTC_STARTUP_SYNQ_REQ_STR)


//Definition for struct MTC_STARTUP_SYNQ_RESP
#define MTC_STARTUP_SYNQ_RESP                                 0x6E                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) MTC_STARTUP_SYNQ_RESP_STR;
#define SIZE_MTC_STARTUP_SYNQ_RESP                            sizeof(MTC_STARTUP_SYNQ_RESP_STR)


//Definition for struct MTC_FORCE_STARTUP_STATE_REQ
#define MTC_FORCE_STARTUP_STATE_REQ                           0x0C                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      action;
             uint8_t      state;
            } __attribute__((packed)) MTC_FORCE_STARTUP_STATE_REQ_STR;
#define SIZE_MTC_FORCE_STARTUP_STATE_REQ                      sizeof(MTC_FORCE_STARTUP_STATE_REQ_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct MTC_FORCE_STARTUP_STATE_RESP
#define MTC_FORCE_STARTUP_STATE_RESP                          0x6F                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) MTC_FORCE_STARTUP_STATE_RESP_STR;
#define SIZE_MTC_FORCE_STARTUP_STATE_RESP                     sizeof(MTC_FORCE_STARTUP_STATE_RESP_STR)


//Definition for struct MTC_RAT_REQ
#define MTC_RAT_REQ                                           0x0D                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      rat;
             uint8_t      state;
            } __attribute__((packed)) MTC_RAT_REQ_STR;
#define SIZE_MTC_RAT_REQ                                      sizeof(MTC_RAT_REQ_STR)


//Definition for struct MTC_RAT_RESP
#define MTC_RAT_RESP                                          0x70                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) MTC_RAT_RESP_STR;
#define SIZE_MTC_RAT_RESP                                     sizeof(MTC_RAT_RESP_STR)


//Definition for struct MTC_RAT_QUERY_REQ
#define MTC_RAT_QUERY_REQ                                     0x0E                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) MTC_RAT_QUERY_REQ_STR;
#define SIZE_MTC_RAT_QUERY_REQ                                sizeof(MTC_RAT_QUERY_REQ_STR)


//Definition for struct MTC_RAT_QUERY_RESP
#define MTC_RAT_QUERY_RESP                                    0x71                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      rat;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) MTC_RAT_QUERY_RESP_STR;
#define SIZE_MTC_RAT_QUERY_RESP                               sizeof(MTC_RAT_QUERY_RESP_STR)


//Definition for struct MTC_EXT_MEM_ACCESS_REQ
#define MTC_EXT_MEM_ACCESS_REQ                                0x10                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      action;
             uint8_t      user;
            } __attribute__((packed)) MTC_EXT_MEM_ACCESS_REQ_STR;
#define SIZE_MTC_EXT_MEM_ACCESS_REQ                           sizeof(MTC_EXT_MEM_ACCESS_REQ_STR)


//Definition for struct MTC_EXT_MEM_ACCESS_RESP
#define MTC_EXT_MEM_ACCESS_RESP                               0x73                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) MTC_EXT_MEM_ACCESS_RESP_STR;
#define SIZE_MTC_EXT_MEM_ACCESS_RESP                          sizeof(MTC_EXT_MEM_ACCESS_RESP_STR)


//Definition for struct MTC_MEM_DL_REQ
#define MTC_MEM_DL_REQ                                        0x0F                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      user;
             uint8_t      no_of_blocks;
            } __attribute__((packed)) MTC_MEM_DL_REQ_STR;
#define SIZE_MTC_MEM_DL_REQ                                   sizeof(MTC_MEM_DL_REQ_STR)


//Definition for struct MTC_MEM_DL_RESP
#define MTC_MEM_DL_RESP                                       0x72                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) MTC_MEM_DL_RESP_STR;
#define SIZE_MTC_MEM_DL_RESP                                  sizeof(MTC_MEM_DL_RESP_STR)


//Definition for struct MTC_RESET_CONTROL_REQ
#define MTC_RESET_CONTROL_REQ                                 0x11                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      action;
             uint8_t      type;
            } __attribute__((packed)) MTC_RESET_CONTROL_REQ_STR;
#define SIZE_MTC_RESET_CONTROL_REQ                            sizeof(MTC_RESET_CONTROL_REQ_STR)


//Definition for struct MTC_RESET_CONTROL_RESP
#define MTC_RESET_CONTROL_RESP                                0x74                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) MTC_RESET_CONTROL_RESP_STR;
#define SIZE_MTC_RESET_CONTROL_RESP                           sizeof(MTC_RESET_CONTROL_RESP_STR)


//Definition for struct MTC_SOS_STATUS_QUERY_REQ
#define MTC_SOS_STATUS_QUERY_REQ                              0x13                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) MTC_SOS_STATUS_QUERY_REQ_STR;
#define SIZE_MTC_SOS_STATUS_QUERY_REQ                         sizeof(MTC_SOS_STATUS_QUERY_REQ_STR)


//Definition for struct MTC_SOS_STATUS_QUERY_RESP
#define MTC_SOS_STATUS_QUERY_RESP                             0x76                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) MTC_SOS_STATUS_QUERY_RESP_STR;
#define SIZE_MTC_SOS_STATUS_QUERY_RESP                        sizeof(MTC_SOS_STATUS_QUERY_RESP_STR)


//Definition for struct MTC_SHUTDOWN_SYNC_REQ
#define MTC_SHUTDOWN_SYNC_REQ                                 0x12                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) MTC_SHUTDOWN_SYNC_REQ_STR;
#define SIZE_MTC_SHUTDOWN_SYNC_REQ                            sizeof(MTC_SHUTDOWN_SYNC_REQ_STR)


//Definition for struct MTC_SHUTDOWN_SYNC_RESP
#define MTC_SHUTDOWN_SYNC_RESP                                0x75                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) MTC_SHUTDOWN_SYNC_RESP_STR;
#define SIZE_MTC_SHUTDOWN_SYNC_RESP                           sizeof(MTC_SHUTDOWN_SYNC_RESP_STR)


//Definition for struct MTC_GENERIC_STATUS_QUERY_REQ
#define MTC_GENERIC_STATUS_QUERY_REQ                          0x14                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      action;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) MTC_GENERIC_STATUS_QUERY_REQ_STR;
#define SIZE_MTC_GENERIC_STATUS_QUERY_REQ                     sizeof(MTC_GENERIC_STATUS_QUERY_REQ_STR)


//Definition for struct MTC_GENERIC_STATUS_QUERY_RESP
#define MTC_GENERIC_STATUS_QUERY_RESP                         0x77                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      sb_count;
            } __attribute__((packed)) MTC_GENERIC_STATUS_QUERY_RESP_STR;
#define SIZE_MTC_GENERIC_STATUS_QUERY_RESP                    sizeof(MTC_GENERIC_STATUS_QUERY_RESP_STR)


//Definition for struct MTC_RF_CONTROL_REQ
#define MTC_RF_CONTROL_REQ                                    0x15                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      action;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) MTC_RF_CONTROL_REQ_STR;
#define SIZE_MTC_RF_CONTROL_REQ                               sizeof(MTC_RF_CONTROL_REQ_STR)


//Definition for struct MTC_RF_CONTROL_RESP
#define MTC_RF_CONTROL_RESP                                   0x78                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) MTC_RF_CONTROL_RESP_STR;
#define SIZE_MTC_RF_CONTROL_RESP                              sizeof(MTC_RF_CONTROL_RESP_STR)


//Definition for struct MTC_RF_STATUS_QUERY_REQ
#define MTC_RF_STATUS_QUERY_REQ                               0x16                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint16_t     fillerbyte1;
            } __attribute__((packed)) MTC_RF_STATUS_QUERY_REQ_STR;
#define SIZE_MTC_RF_STATUS_QUERY_REQ                          sizeof(MTC_RF_STATUS_QUERY_REQ_STR)


//Definition for struct MTC_RF_STATUS_QUERY_RESP
#define MTC_RF_STATUS_QUERY_RESP                              0x79                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      current;
             uint8_t      target;
            } __attribute__((packed)) MTC_RF_STATUS_QUERY_RESP_STR;
#define SIZE_MTC_RF_STATUS_QUERY_RESP                         sizeof(MTC_RF_STATUS_QUERY_RESP_STR)


//Definition for struct MTC_RF_STATUS_INFO_IND
#define MTC_RF_STATUS_INFO_IND                                0xC2                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      target;
             uint8_t      action;
            } __attribute__((packed)) MTC_RF_STATUS_INFO_IND_STR;
#define SIZE_MTC_RF_STATUS_INFO_IND                           sizeof(MTC_RF_STATUS_INFO_IND_STR)


//Definition for struct MTC_RAT_INFO_NTF
#define MTC_RAT_INFO_NTF                                      0x7A                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      sb_count;
            } __attribute__((packed)) MTC_RAT_INFO_NTF_STR;
#define SIZE_MTC_RAT_INFO_NTF                                 sizeof(MTC_RAT_INFO_NTF_STR)


//Definition for struct MTC_VCORE_READ_REQ
#define MTC_VCORE_READ_REQ                                    0x17                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint16_t     fillerbyte1;
            } __attribute__((packed)) MTC_VCORE_READ_REQ_STR;
#define SIZE_MTC_VCORE_READ_REQ                               sizeof(MTC_VCORE_READ_REQ_STR)


//Definition for struct MTC_VCORE_READ_RESP
#define MTC_VCORE_READ_RESP                                   0x7B                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      fillerbyte1;
             uint32_t     vcore;
            } __attribute__((packed)) MTC_VCORE_READ_RESP_STR;
#define SIZE_MTC_VCORE_READ_RESP                              sizeof(MTC_VCORE_READ_RESP_STR)


//Definition for struct MTC_DSP_GENIO_CONFIG_NTF
#define MTC_DSP_GENIO_CONFIG_NTF                              0x7C                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      fillerbyte1;
             uint32_t     genio_conf_addr;
            } __attribute__((packed)) MTC_DSP_GENIO_CONFIG_NTF_STR;
#define SIZE_MTC_DSP_GENIO_CONFIG_NTF                         sizeof(MTC_DSP_GENIO_CONFIG_NTF_STR)


//Definition for struct PERF_SET_REQ
#define PERF_SET_REQ                                          0x30                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint16_t     sub_system;
             uint16_t     service;
             uint8_t      fillerbyte1;
             uint8_t      sb_count;
            } __attribute__((packed)) PERF_SET_REQ_STR;
#define SIZE_PERF_SET_REQ                                     sizeof(PERF_SET_REQ_STR)


//Definition for struct PERF_SET_RESP
#define PERF_SET_RESP                                         0x90                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint16_t     sub_system;
             uint16_t     service;
             uint8_t      status;
             uint8_t      sb_count;
            } __attribute__((packed)) PERF_SET_RESP_STR;
#define SIZE_PERF_SET_RESP                                    sizeof(PERF_SET_RESP_STR)


//Definition for struct PERF_STATE_REQ
#define PERF_STATE_REQ                                        0x31                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      state;
             uint8_t      sb_count;
            } __attribute__((packed)) PERF_STATE_REQ_STR;
#define SIZE_PERF_STATE_REQ                                   sizeof(PERF_STATE_REQ_STR)


//Definition for struct PERF_STATE_RESP
#define PERF_STATE_RESP                                       0x91                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) PERF_STATE_RESP_STR;
#define SIZE_PERF_STATE_RESP                                  sizeof(PERF_STATE_RESP_STR)


//Definition for struct PERF_SETTINGS_WRITE_REQ
#define PERF_SETTINGS_WRITE_REQ                               0x32                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      sb_count;
            } __attribute__((packed)) PERF_SETTINGS_WRITE_REQ_STR;
#define SIZE_PERF_SETTINGS_WRITE_REQ                          sizeof(PERF_SETTINGS_WRITE_REQ_STR)


//Definition for struct PERF_SETTINGS_WRITE_RESP
#define PERF_SETTINGS_WRITE_RESP                              0x92                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) PERF_SETTINGS_WRITE_RESP_STR;
#define SIZE_PERF_SETTINGS_WRITE_RESP                         sizeof(PERF_SETTINGS_WRITE_RESP_STR)


//Definition for struct PERF_INFO_REQ
#define PERF_INFO_REQ                                         0x33                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint16_t     req_data;
            } __attribute__((packed)) PERF_INFO_REQ_STR;
#define SIZE_PERF_INFO_REQ                                    sizeof(PERF_INFO_REQ_STR)


//Definition for struct PERF_INFO_RESP
#define PERF_INFO_RESP                                        0x93                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      sb_count;
            } __attribute__((packed)) PERF_INFO_RESP_STR;
#define SIZE_PERF_INFO_RESP                                   sizeof(PERF_INFO_RESP_STR)

#endif
