#ifndef _PN_PHONE_INFO_ISI_H_
#define _PN_PHONE_INFO_ISI_H_

#include <stdint.h> 

//Resource Info Server
//PN_PHONE_INFO 0x1B 
//ISI version 008.005
#define INFO_SERVER_ISI_VERSION_Z     8
#define INFO_SERVER_ISI_VERSION_Y     5

//In case of problems concerning content of this file contact Markku Loukusa, Sauli Laukka or Markus Mrsky
//Server specific message descriptions and feature&protocol descriptions can be found from: https://oucmswww.nmp.nokia.com:58443/document_browser/ccm_wa/GIF_SPECS/ 


//ISI VERSION CHANGE HISTORY

//Version: 008.005                                           
//Status: NonDraft                                          
//Date: 27-Jan-2009     Olli Porola
//Reason: SUB
//Reference: 417-31612, 417-30624, NON-DRAFT

//Version: 008.004                                           
//Status: NonDraft                                          
//Date: 31-Oct-2008     Olli Porola
//Reason: SUB
//Reference: 417-24223, NON-DRAFT

//Version: 008.003                                           
//Status: NonDraft                                          
//Date: 17-Mar-2008     Winfried Gamroth
//Reason: RM-RIM 010-30180
//Reference: ADB for SWAM WG08031741277, NON-DRAFT

//Version: 008.002                                           
//Status: NonDraft                                          
//Date: 14-Feb-2008     Winfried Gamroth
//Reason: RM-RIM 010-28684
//Reference: ADB for SWAM WG08021342778, NON-DRAFT

//Version: 008.001                                           
//Status: NonDraft                                          
//Date: 14-Nov-2007     Zoran Stevanovic
//Reason: RM-RIM 414-2275, 414-3045
//Reference: ADB for SWAM ZS07111540118., NON-DRAFT

//Version: 008.000                                           
//Status: NonDraft                                          
//Date: 11-Sep-2007     Zoran Stevanovic
//Reason: RM-RIM 404-2088
//Reference: ADB for SWAM ZS07091145641., NON-DRAFT

//Version: 007.000                                           
//Status: NonDraft                                          
//Date: 03-Apr-2007     Zoran Stevanovic
//Reason: RM-RIM 407-6
//Reference: ADB for SWAM ZS07040438377., NON-DRAFT

//Version: 006.001                                           
//Status: NonDraft                                          
//Date: 28-Feb-2007     Mika Halttunen
//Reason: SCO / inspection
//Reference: LN WP-PT-MS RM-RIM 010-33211, LN SWAM ADB MH07022841663., NON-DRAFT

//Version: 006.000                                           
//Status: NonDraft                                          
//Date: 16-Oct-2006     Mika Halttunen
//Reason: Inspection
//Reference: LN ADB SWAM MH06101642986., NON-DRAFT

//Version: 005.013                                           
//Status: NonDraft                                          
//Date: 12-Oct-2006     Mika Halttunen
//Reason: SCO
//Reference: see info_shared_isi_m.h v005.013., NON-DRAFT

//Version: 005.012                                           
//Status: NonDraft                                          
//Date: 02-Oct-2006     Mika Halttunen
//Reason: Inspection
//Reference: LN ADB SWAM MH06100245043., NON-DRAFT

//Version: 005.011                                           
//Status: NonDraft                                          
//Date: 01-Sep-2006     Mika Halttunen
//Reason: Inspection
//Reference: LN ADB SWAM MH06090454347., NON-DRAFT

//Version: 005.010                                           
//Status: NonDraft                                          
//Date: 28-Jun-2006     Mika Halttunen
//Reason: Inspection
//Reference: LN ADB SWAM MH06062862043., NON-DRAFT

//Version: 005.009                                           
//Status: NonDraft                                          
//Date: 15-May-2006     Mika Halttunen
//Reason: Inspection
//Reference: LN ADB SWAM MH06052344843, PCP Errors AT06031055080., NON-DRAFT

//Version: 005.008                                           
//Status: NonDraft                                          
//Date: 18-Apr-2006     Mika Halttunen
//Reason: Inspection
//Reference: LN ADB SWAM MH06022337728, WP-PT-MS RM-RIM 010-22223., NON-DRAFT

//Version: 005.007                                           
//Status: NonDraft                                          
//Date: 28-Feb-2006     Juho Heikkil
//Reason: Inspection
//Reference: LN ADB SWAM JH06022837365, WP-PT-MS RM-RIM 010-22536., NON-DRAFT

//Version: 005.005                                           
//Status: NonDraft                                          
//Date: 19-Jan-2006     Mika Halttunen
//Reason: Inspection
//Reference: LN ADB SWAM MH06011950424, WP-PT-MS RM-RIM 009-19253., NON-DRAFT

//Version: 005.004                                           
//Status: NonDraft                                          
//Date: 02-Nov-2005     Mika Halttunen
//Reason: Inspection
//Reference: LN ADB SWAM MH05110257369, WP-PT-MS RM-RIM 009-20804, 009-22054., NON-DRAFT

//Version: 005.003                                           
//Status: NonDraft                                          
//Date: 24-Oct-2005     Mika Halttunen
//Reason: Inspection
//Reference: LN ADB SWAM MH05102438391, WP-PT-MS RM-RIM 009-18943., NON-DRAFT

//Version: 005.002                                           
//Status: NonDraft                                          
//Date: 17-Oct-2005     Mika Halttunen
//Reason: Inspection, comments
//Reference: LN ADB SWAM MH05101255652, KM05101444837, WP RM-RIM 009-21354., NON-DRAFT

//Version: 005.001                                           
//Status: NonDraft                                          
//Date: 06-Oct-2005     Mika Halttunen
//Reason: Inspection
//Reference: LN ADB SWAM MH05100540860, WP RM-RIM 009-20651., NON-DRAFT

//Version: 005.000                                           
//Status: NonDraft                                          
//Date: 14-Sep-2005     Mika Halttunen
//Reason: Inspection, Comment
//Reference: LN ADB SWAM MH05090149734, KM05091353162, WP RM-RIM 009-20425, 009-20458., NON-DRAFT

//Version: 004.017                                           
//Status: NonDraft                                          
//Date: 04-May-2005     Mika Halttunen
//Reason: Inspection
//Reference: LN ADB SWAM MH05051041809, NON-DRAFT

//Version: 004.016                                           
//Status: NonDraft                                          
//Date: 02-May-2005     Mika Halttunen
//Reason: Inspection
//Reference: LN ADB SWAM MH05013144180, NON-DRAFT

//Version: 004.015                                           
//Status: NonDraft                                          
//Date: 23-Mar-2005     Mika Halttunen
//Reason: Inspection
//Reference: LN ADB SWAM MH05032345918, NON-DRAFT

//Version: 004.014                                           
//Status: NonDraft                                          
//Date: 25-Feb-2005     Mika Halttunen
//Reason: Inspection & comments
//Reference: LN ADB SWAM MH05030154628, LN WP RM-RIM 010-9887, NON-DRAFT

//Version: 004.013                                           
//Status: NonDraft                                          
//Date: 30-Nov-2004     Mika Halttunen
//Reason: SCO
//Reference: LN WP RM-RIM 009-13900, NON-DRAFT

//Version: 004.012                                           
//Status: NonDraft                                          
//Date: 14-Oct-2004     Mika Halttunen
//Reason: SCO
//Reference: ADB SWAM MH04101458438, LN WP RM-RIM 009-12873., NON-DRAFT

//Version: 004.011                                           
//Status: NonDraft                                          
//Date: 27-Sep-2004     Mika Halttunen
//Reason: SCO
//Reference: LN WP RM-RIM 009-10970., NON-DRAFT

//Version: 004.010                                           
//Status: NonDraft                                          
//Date: 23-Sep-2004     Mika Halttunen
//Reason: SCO
//Reference: LN WP RM-RIM 009-13813, ADB SWAM MH040, NON-DRAFT

//Version: 004.009                                           
//Status: NonDraft                                          
//Date: 30-Aug-2004     Mika Halttunen
//Reason: SCO
//Reference: LN WP RM-RIM 009-12385, ADB SWAM MH04090657967, NON-DRAFT

//Version: 004.008                                           
//Status: NonDraft                                          
//Date: 07-Apr-2004     Mika Halttunen
//Reason: SUB
//Reference: LN ADB SWAM MH04040744171, WP RM-RIM 010-1111, NON-DRAFT

//Version: 004.007                                           
//Status: NonDraft                                          
//Date: 12-Feb-2004     Mika Halttunen
//Reason: SCO
//Reference: LN ADB SWAM MH, ISA RM-RIM ID 010-3596, NON-DRAFT

//Version: 004.006                                           
//Status: NonDraft                                          
//Date: 29-Jan-2004     Mika Halttunen
//Reason: SCO
//Reference: LN ADB SWAM MH04011566405, ISA RM-RIM ID 009-8633, NON-DRAFT

//Version: 004.005                                           
//Status: NonDraft                                          
//Date: 18-Dec-2003     Mika Halttunen
//Reason: SCO
//Reference: LN ADB SWAM MH03120856566, LN ISA RM-RIM ID 009-5301, NON-DRAFT

//Version: 004.004                                           
//Status: NonDraft                                          
//Date: 19-Nov-2003     Mika Halttunen
//Reason: File location change + Inspection correction
//Reference: LN ADB SWAM MH03102361903, NON-DRAFT

//Version: 004.003                                           
//Status: NonDraft                                          
//Date: 15-Aug-2003     Mika Halttunen
//Reason: SUBs and inspection
//Reference: LN ISA RM-RIM 009-6673, LN ADB SWAM MH03082747192, LN ISA RM-RIM 009-4423,009-4425,009-4424,009-4422,009-4467,009-4466,009-4471,009-2049,010-1111, NON-DRAFT

//Version: 004.002                                           
//Status: Unknown                                           
//Date: 30-Jul-2003     Mika Halttunen
//Reason: Error correction
//Reference: LN PCP Errors JL03070342503, NON_DRAFT

//Version: 004.000                                           
//Status: Unknown                                           
//Date: -               -
//Reason: -
//Reference: -

//Version: 003.001                                           
//Status: Unknown                                           
//Date: -               -
//Reason: -
//Reference: -

//Version: 003.000                                           
//Status: Unknown                                           
//Date: -               -
//Reason: -
//Reference: -

//Version: 002.005                                           
//Status: Unknown                                           
//Date: -               -
//Reason: -
//Reference: -

//Version: 002.004                                           
//Status: Unknown                                           
//Date: -               -
//Reason: -
//Reference: -

//Version: 002.002                                           
//Status: Unknown                                           
//Date: -               -
//Reason: -
//Reference: -

//Version: 002.001                                           
//Status: Unknown                                           
//Date: -               -
//Reason: -
//Reference: -

//Version: 002.000                                           
//Status: Unknown                                           
//Date: -               -
//Reason: -
//Reference: -

//Version: 001.027                                           
//Status: Unknown                                           
//Date: -               -
//Reason: -
//Reference: -

//Version: 001.000                                           
//Status: Unknown                                           
//Date: -               -
//Reason: -
//Reference: -


//CONSTANTS
#define INFO_SW_ID_LEN                                        0x06                                                     
#define INFO_SB_SN_IMEI_PLAIN_STR_LEN                         0x10                                                  
#define INFO_SB_SN_IMEI_SPARE_TO_NET_STR_LEN                  0x08                                                     
#define INFO_SB_SN_ESN_PLAIN_STR_LEN                          0x0C                                                     
#define INFO_SB_SN_ESN_HEX_DATA_LEN                           0x04                                                     
#define INFO_SB_SN_ESNX_PLAIN_STR_LEN                         0x09                                                     
#define INFO_SB_SN_ESNX_HEX_DATA_LEN                          0x03                                                     
#define INFO_SN_RAW_MEID_LEN                                  0x07                                                     
#define INFO_SN_MEID_HEX_ASCII_LEN                            0x0F                                                     
#define INFO_SN_MEID_PLAIN_LEN                                0x14                                                  
#define INFO_SB_SN_PDC_DATA_LEN                               0x08                                                     
#define INFO_SB_HW_VERSION_STR_LEN                            0x05                                                     
#define INFO_SB_PCI_VERSION_STR_LEN                           0x05                                                     
#define INFO_SB_PRODUCTION_SN_STR_LEN                         0x0A                                                     
#define INFO_SB_LONG_PRODUCTION_SN_STR_LEN                    0x10                                                  
#define INFO_SB_PRODUCT_CODE_STR_LEN                          0x08                                                     
#define INFO_SB_BASIC_PRODUCT_CODE_STR_LEN                    0x08                                                     
#define INFO_SB_MODULE_CODE_STR_LEN                           0x08                                                     
#define INFO_SB_FLASH_CODE_STR_LEN                            0x06                                                     
#define INFO_SB_ORDER_NUMBER_STR_LEN                          0x08                                                     
#define INFO_BT_ID_LEN                                        0x06                                                     
#define INFO_WT_SERIAL_NUMBER_LENGTH                          0x14                                                  
#define INFO_WT_RPF_LEN                                       0x04                                                     
#define INFO_SB_RETU_LEN                                      0x07                                                     
#define INFO_SB_TAHVO_LEN                                     0x07                                                     
#define INFO_SB_RAP_LEN                                       0x07                                                     
#define INFO_WLAN_MAC_ADDR_LEN                                0x06                                                     


//TABLES

//ConstantTable for FtdTable
#define FTD_SB_MCU_VERSION                                    0x0101                                                   
#define FTD_SB_PPM_VERSION                                    0x0102                                                   
#define FTD_SB_VERSION_DATE                                   0x0103                                                   
#define FTD_SB_DSP_VERSION                                    0x0104                                                   
#define FTD_SB_MCU_CHECKSUM                                   0x0105                                                   
#define FTD_SB_HW_VERSION                                     0x0106                                                   
#define FTD_SB_TEXT_VERSION                                   0x0107                                                   

//ConstantTable for INFO_GENERAL_SYM
#define INFO_OK                                               0x00                                                     
#define INFO_FAIL                                             0x01                                                     
#define INFO_NO_NUMBER                                        0x02                                                     
#define INFO_NOT_SUPPORTED                                    0x03                                                     

//ConstantTable for INFO_SN_TARGET_IDENTIFIER
#define INFO_SN_IMEI_PLAIN                                    0x41                                                  
#define INFO_SN_IMEI_SPARE_TO_NET                             0x42                                                  
#define INFO_SN_IMEI_SV_TO_NET                                0x43                                                  
#define INFO_SN_ESN_PLAIN                                     0x44                                                  
#define INFO_SN_ESNX_PLAIN                                    0x56                                                  
#define INFO_SN_ESN_HEX                                       0x45                                                  
#define INFO_SN_ESNX_HEX                                      0x5A                                                  
#define INFO_SN_PDC                                           0x46                                                  
#define INFO_SN_DEFAULT                                       0x5D                                                  
#define INFO_SN_DEFAULT_PLAIN                                 0x5E                                                  
#define INFO_SN_MEID_HEX                                      0x61                                                  
#define INFO_SN_MEID_HEX_ASCII                                0x62                                                  
#define INFO_SN_MEID_PLAIN                                    0x63                                                  

//ConstantTable for INFO_BATCH_TYPE
#define INFO_PP_PROD_PROFILE_FEATURE                          0x00                                                     
#define INFO_PP_ALL_FEATURE                                   0x01                                                     

//ConstantTable for INFO_PRODUCT_TYPE_TARGET
#define INFO_PRODUCT_TYPE_CS                                  0x01                                                     
#define INFO_PRODUCT_TYPE_HW_INFO                             0x02                                                     
#define INFO_PRODUCT_TYPE_CS_SEC                              0x03                                                     

//ConstantTable for INFO_PRODUCT_INFO_TARGET
#define INFO_PRODUCT_NAME                                     0x01                                                     
#define INFO_PRODUCT_CATEGORY                                 0x02                                                     
#define INFO_PRODUCT_XID                                      0x03                                                     
#define INFO_PRODUCT_DEV_NAME                                 0x04                                                     
#define INFO_PRODUCT_COMP01                                   0x05                                                     
#define INFO_PRODUCT_NAME_COMPRESSED                          0x06                                                     
#define INFO_PRODUCT_MANUFACTURER                             0x07                                                     
#define INFO_PRODUCT_XCVR_ID                                  0x08                                                     
#define INFO_PRODUCT_NUM_ID                                   0x09                                                     
#define INFO_PRODUCT_TYPE_ID                                  0x0A                                                     
#define INFO_USB_VENDOR_ID                                    0x0B                                                     
#define INFO_USB_MASS_ID                                      0x0C                                                     
#define INFO_USB_NOKIA_ID                                     0x0D                                                     
#define INFO_USB_SICD_ID                                      0x0E                                                     
#define INFO_BT_PID                                           0x0F                                                     
#define INFO_USB_RNDIS_ID                                     0x10                                                  

//ConstantTable for INFO_BT_DATA_TARGET
#define INFO_BT_ID                                            0x01                                                     

//ConstantTable for INFO_WT_SN
#define INFO_WT_SN_TYPE_IMEI                                  0x01                                                     
#define INFO_WT_SN_TYPE_ESN                                   0x02                                                     
#define INFO_WT_SN_TYPE_CSN                                   0x03                                                     
#define INFO_WT_SN_TYPE_MEID                                  0x04                                                     

//ConstantTable for INFO_WT_STATUS
#define INFO_WT_OK                                            0x01                                                     
#define INFO_WT_FAIL                                          0x02                                                     
#define INFO_WT_INFO_STATE_DEF                                0x03                                                     
#define INFO_WT_INFO_STATE_EXC                                0x04                                                     
#define INFO_WT_INFO_STATE_USE                                0x05                                                     

//ConstantTable for INFO_WT_STATE
#define INFO_WT_LOCKED                                        0x01                                                     
#define INFO_WT_UNLOCKED                                      0x02                                                     

//ConstantTable for INFO_RAP_TYPE
#define INFO_RAP3G                                            0x08                                                     
#define INFO_RAPGSM                                           0x09                                                     
#define INFO_RAPCDMA                                          0x0A                                                     
#define INFO_RAPHSDPA                                         0x0B                                                     
#define INFO_RAPTOR                                           0x0C                                                     

//BitmaskTables for INFO_VERSION_TARGETS
#define INFO_MCUSW                                            0x0001                                                     
#define INFO_HW                                               0x0002                                                     
#define INFO_PCI                                              0x0004                                                     
#define INFO_UEM                                              0x0008                                                     
#define INFO_UPP                                              0x0010                                                  
#define INFO_RFIC                                             0x0020                                                  
#define INFO_DSP                                              0x0040                                                  
#define INFO_LCD                                              0x0080                                                  
#define INFO_PPM                                              0x0100                                                   
#define INFO_BT_MCM                                           0x0200                                                   
#define INFO_ADSP                                             0x0400                                                   
#define INFO_FLIP_MCUSW                                       0x1000                                                  
#define INFO_ADSP_DEVICE_ID                                   0x2000                                                  
#define INFO_ADSP_REVISION_ID                                 0x4000                                                  
#define INFO_GAZOO                                            0x8000                                                  

//BitmaskTables for INFO_VERSION_TARGETS_2
#define INFO_BOOTCODE_VER                                     0x00000001                                                     
#define INFO_APE_SW_CORE_VER                                  0x00000002                                                     
#define INFO_VARIANT_VER                                      0x00000004                                                     
#define INFO_APE_TEST_VER                                     0x00000008                                                     
#define INFO_RETU                                             0x00000010                                                  
#define INFO_TAHVO                                            0x00000020                                                  
#define INFO_APE_HW_VERSION                                   0x00000040                                                  
#define INFO_APE_ADSP_SW                                      0x00000080                                                  
#define INFO_CAMERA                                           0x00000100                                                   
#define INFO_APE_BT_VERSION                                   0x00000200                                                   
#define INFO_CONTENT_PACK                                     0x00000400                                                   
#define INFO_RAP                                              0x00000800                                                   
#define INFO_APE_CUI_LCD_VERSION                              0x00001000                                                  
#define INFO_APE_IPDC_VERSION                                 0x00002000                                                  
#define INFO_APE_DVB_H_RX_HW_VER                              0x00004000                                                  
#define INFO_APE_DVB_H_RX_SW_VER                              0x00008000                                                  
#define INFO_APE_DVB_H_RX_BOOTLOADER_VER                      0x00010000                                                 
#define INFO_CAMERA2                                          0x00020000                                                 
#define INFO_CONTENT_VERSIONS                                 0x00040000                                                 
#define INFO_ROFS_VERSIONS                                    0x00080000                                                 
#define INFO_BOM_ID_VERSION                                   0x00100000                                                
#define INFO_NAVISCROLL_VERSION                               0x00200000                                                
#define INFO_ACCELEROMETER_VERSION                            0x00400000                                                

//BitmaskTables for INFO_PRODUCT_TARGETS
#define INFO_PRODUCTION_SN                                    0x0001                                                     
#define INFO_PRODUCT_CODE                                     0x0002                                                     
#define INFO_MODULE_CODE                                      0x0004                                                     
#define INFO_BASIC_PRODUCT_CODE                               0x0008                                                     
#define INFO_FLASH_CODE                                       0x0010                                                  
#define INFO_ORDER_NUMBER                                     0x0020                                                  
#define INFO_PRODUCT_SPECIFIC_DATA                            0x0040                                                  
#define INFO_LONG_PRODUCTION_SN                               0x0080                                                  
#define INFO_ATO                                              0x0100                                                   
#define INFO_SN_DEFAULT_TYPE                                  0x0200                                                   

//BitmaskTables for INFO_CS_TYPE_1
#define INFO_TYPE_CS_WCDMA1900                                0x00000001                                                     
#define INFO_TYPE_CS_AMPS                                     0x00000002                                                     
#define INFO_TYPE_CS_CDMA800                                  0x00000004                                                     
#define INFO_TYPE_CS_CDMA1700                                 0x00000008                                                     
#define INFO_TYPE_CS_CDMA1900                                 0x00000010                                                  
#define INFO_TYPE_CS_US_TDMA                                  0x00000020                                                  
#define INFO_TYPE_CS_GSM400                                   0x00000040                                                  
#define INFO_TYPE_CS_GSM700                                   0x00000080                                                  
#define INFO_TYPE_CS_GSM850                                   0x00000100                                                   
#define INFO_TYPE_CS_GSM900                                   0x00000200                                                   
#define INFO_TYPE_CS_GSM1800                                  0x00000400                                                   
#define INFO_TYPE_CS_GSM1900                                  0x00000800                                                   
#define INFO_TYPE_CS_PREPAID                                  0x00001000                                                  
#define INFO_TYPE_CS_CDMA2100                                 0x00002000                                                  
#define INFO_TYPE_CS_RUIM                                     0x00004000                                                  

//BitmaskTables for INFO_WT_READ_BITS
#define INFO_WT_ORIG_SN                                       0x0001                                                     
#define INFO_WT_ORIG_MAN_MONTH_YEAR                           0x0002                                                     
#define INFO_WT_OWN_MAN_MONTH_YEAR                            0x0004                                                     
#define INFO_WT_PURCH_MONTH_YEAR                              0x0008                                                     
#define INFO_WT_REPAIR_MONTH_YEAR                             0x0010                                                  
#define INFO_WT_WIS                                           0x0020                                                  
#define INFO_WT_RPF                                           0x0040                                                  
#define INFO_WT_ALL_BITS                                      0x007F                                                  


//STRUCTURES


//Definition for struct CS_TYPE_SEC
typedef struct
            { 
             uint32_t     cs_type1;
             uint32_t     cs_type2;
             uint8_t      sw_id[6];
             uint16_t     checksum;
            } __attribute__((packed)) CS_TYPE_SEC_STR;
#define SIZE_CS_TYPE_SEC                                      sizeof(CS_TYPE_SEC_STR)


//Definition for struct INFO_BT_ID_SEC
typedef struct
            { 
             uint8_t      bt_id_enc[6];
             uint16_t     checksum;
            } __attribute__((packed)) INFO_BT_ID_SEC_STR;
#define SIZE_INFO_BT_ID_SEC                                   sizeof(INFO_BT_ID_SEC_STR)


//Definition for struct INFO_IPP_MACS
typedef struct
            { 
             uint8_t      ipp_mac_1[6];
             uint8_t      ipp_mac_2[6];
            } __attribute__((packed)) INFO_IPP_MACS_STR;
#define SIZE_INFO_IPP_MACS                                    sizeof(INFO_IPP_MACS_STR)


//SUBBLOCKS


//Definition for struct INFO_SB_SN_IMEI_PLAIN
#define INFO_SB_SN_IMEI_PLAIN                                 0x41                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      fillerbyte1;
             uint8_t      str_len;
             uint8_t      imei_plain_u8[16];
            } __attribute__((packed)) INFO_SB_SN_IMEI_PLAIN_STR;
#define SIZE_INFO_SB_SN_IMEI_PLAIN                            sizeof(INFO_SB_SN_IMEI_PLAIN_STR)


//Definition for struct INFO_SB_SN_IMEI_SPARE_TO_NET
#define INFO_SB_SN_IMEI_SPARE_TO_NET                          0x42                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      fillerbyte1;
             uint8_t      str_len;
             uint8_t      imei_spare_u8[8];
            } __attribute__((packed)) INFO_SB_SN_IMEI_SPARE_TO_NET_STR;
#define SIZE_INFO_SB_SN_IMEI_SPARE_TO_NET                     sizeof(INFO_SB_SN_IMEI_SPARE_TO_NET_STR)


//Definition for struct INFO_SB_SN_ESN_PLAIN
#define INFO_SB_SN_ESN_PLAIN                                  0x44                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      fillerbyte1;
             uint8_t      str_len;
             uint8_t      esn_plain_u8[12];
            } __attribute__((packed)) INFO_SB_SN_ESN_PLAIN_STR;
#define SIZE_INFO_SB_SN_ESN_PLAIN                             sizeof(INFO_SB_SN_ESN_PLAIN_STR)


//Definition for struct INFO_SB_SN_ESN_HEX
#define INFO_SB_SN_ESN_HEX                                    0x45                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      fillerbyte1;
             uint8_t      data_len;
             uint32_t     esn_hex_c8;
            } __attribute__((packed)) INFO_SB_SN_ESN_HEX_STR;
#define SIZE_INFO_SB_SN_ESN_HEX                               sizeof(INFO_SB_SN_ESN_HEX_STR)


//Definition for struct INFO_SB_SN_ESNX_PLAIN
#define INFO_SB_SN_ESNX_PLAIN                                 0x56                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      fillerbyte1;
             uint8_t      esnx_str_len;
             uint8_t      esnx_plain[9];
             uint8_t      fillerbyte2[3];
            } __attribute__((packed)) INFO_SB_SN_ESNX_PLAIN_STR;
#define SIZE_INFO_SB_SN_ESNX_PLAIN                            sizeof(INFO_SB_SN_ESNX_PLAIN_STR)


//Definition for struct INFO_SB_SN_ESNX_HEX
#define INFO_SB_SN_ESNX_HEX                                   0x5A                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      fillerbyte1;
             uint8_t      data_len;
             uint8_t      esnx_hex_c8[3];
             uint8_t      fillerbyte2;
            } __attribute__((packed)) INFO_SB_SN_ESNX_HEX_STR;
#define SIZE_INFO_SB_SN_ESNX_HEX                              sizeof(INFO_SB_SN_ESNX_HEX_STR)


//Definition for struct INFO_SB_SN_MEID_HEX
#define INFO_SB_SN_MEID_HEX                                   0x61                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint16_t     fillerbyte1;
             uint8_t      meid_hex[7];
             uint8_t      fillerbyte2;
            } __attribute__((packed)) INFO_SB_SN_MEID_HEX_STR;
#define SIZE_INFO_SB_SN_MEID_HEX                              sizeof(INFO_SB_SN_MEID_HEX_STR)


//Definition for struct INFO_SB_SN_MEID_HEX_ASCII
#define INFO_SB_SN_MEID_HEX_ASCII                             0x62                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint16_t     fillerbyte1;
             uint8_t      meid_hex_ascii[15];
             uint8_t      fillerbyte2;
            } __attribute__((packed)) INFO_SB_SN_MEID_HEX_ASCII_STR;
#define SIZE_INFO_SB_SN_MEID_HEX_ASCII                        sizeof(INFO_SB_SN_MEID_HEX_ASCII_STR)


//Definition for struct INFO_SB_SN_MEID_PLAIN
#define INFO_SB_SN_MEID_PLAIN                                 0x80                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint16_t     fillerbyte1;
             uint8_t      meid_plain[20];
            } __attribute__((packed)) INFO_SB_SN_MEID_PLAIN_STR;
#define SIZE_INFO_SB_SN_MEID_PLAIN                            sizeof(INFO_SB_SN_MEID_PLAIN_STR)


//Definition for struct INFO_SB_SN_PDC
#define INFO_SB_SN_PDC                                        0x46                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      fillerbyte1;
             uint8_t      pdc_data_len;
             uint8_t      pdc_c8[8];
            } __attribute__((packed)) INFO_SB_SN_PDC_STR;
#define SIZE_INFO_SB_SN_PDC                                   sizeof(INFO_SB_SN_PDC_STR)


//Definition for struct INFO_SB_MCUSW_VERSION
#define INFO_SB_MCUSW_VERSION                                 0x48                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      fillerbyte1;
             uint8_t      str_len;
             uint8_t      mcusw_versn_c8[0];
            } __attribute__((packed)) INFO_SB_MCUSW_VERSION_STR;
#define SIZE_INFO_SB_MCUSW_VERSION                            sizeof(INFO_SB_MCUSW_VERSION_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct INFO_SB_BT_MCM_VERSION
#define INFO_SB_BT_MCM_VERSION                                0x5B                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      fillerbyte1;
             uint8_t      str_len;
             uint8_t      mcusw_versn_c8[0];
            } __attribute__((packed)) INFO_SB_BT_MCM_VERSION_STR;
#define SIZE_INFO_SB_BT_MCM_VERSION                           sizeof(INFO_SB_BT_MCM_VERSION_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct INFO_SB_HW_VERSION
#define INFO_SB_HW_VERSION                                    0x49                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      fillerbyte1;
             uint8_t      str_len;
             uint8_t      hw_versn_str_c8[5];
             uint8_t      fillerbyte2[3];
            } __attribute__((packed)) INFO_SB_HW_VERSION_STR;
#define SIZE_INFO_SB_HW_VERSION                               sizeof(INFO_SB_HW_VERSION_STR)


//Definition for struct INFO_SB_PCI_VERSION
#define INFO_SB_PCI_VERSION                                   0x4A                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      fillerbyte1;
             uint8_t      str_len;
             uint8_t      pci_versn_str_c8[5];
             uint8_t      fillerbyte2[3];
            } __attribute__((packed)) INFO_SB_PCI_VERSION_STR;
#define SIZE_INFO_SB_PCI_VERSION                              sizeof(INFO_SB_PCI_VERSION_STR)


//Definition for struct INFO_SB_UEM_VERSION
#define INFO_SB_UEM_VERSION                                   0x4B                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      fillerbyte1;
             uint8_t      str_len;
             uint8_t      uem_versn_str_c8[0];
            } __attribute__((packed)) INFO_SB_UEM_VERSION_STR;
#define SIZE_INFO_SB_UEM_VERSION                              sizeof(INFO_SB_UEM_VERSION_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct INFO_SB_UPP_VERSION
#define INFO_SB_UPP_VERSION                                   0x4C                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      fillerbyte1;
             uint8_t      str_len;
             uint8_t      upp_versn_str_c8[0];
            } __attribute__((packed)) INFO_SB_UPP_VERSION_STR;
#define SIZE_INFO_SB_UPP_VERSION                              sizeof(INFO_SB_UPP_VERSION_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct INFO_SB_RFIC_VERSION
#define INFO_SB_RFIC_VERSION                                  0x54                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      fillerbyte1;
             uint8_t      str_len;
             uint8_t      rfic_versn_str_c8[0];
            } __attribute__((packed)) INFO_SB_RFIC_VERSION_STR;
#define SIZE_INFO_SB_RFIC_VERSION                             sizeof(INFO_SB_RFIC_VERSION_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct INFO_SB_BOM_ID
#define INFO_SB_BOM_ID                                        0x77                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      fillerbyte1;
             uint8_t      str_len;
             uint8_t      bom_id_str_c8[0];
            } __attribute__((packed)) INFO_SB_BOM_ID_STR;
#define SIZE_INFO_SB_BOM_ID                                   sizeof(INFO_SB_BOM_ID_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct INFO_SB_DSP_VERSION
#define INFO_SB_DSP_VERSION                                   0x55                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      fillerbyte1;
             uint8_t      str_len;
             uint8_t      dsp_versn_str_c8[0];
            } __attribute__((packed)) INFO_SB_DSP_VERSION_STR;
#define SIZE_INFO_SB_DSP_VERSION                              sizeof(INFO_SB_DSP_VERSION_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct INFO_SB_ADSP_VERSION
#define INFO_SB_ADSP_VERSION                                  0x5F                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      prod_id;
             uint8_t      str_len;
             uint8_t      adsp_versn_str[0];
            } __attribute__((packed)) INFO_SB_ADSP_VERSION_STR;
#define SIZE_INFO_SB_ADSP_VERSION                             sizeof(INFO_SB_ADSP_VERSION_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct INFO_SB_ADSP_DEVICE_ID
#define INFO_SB_ADSP_DEVICE_ID                                0x65                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      prod_id;
             uint8_t      str_len;
             uint8_t      adsp_versn_str[0];
            } __attribute__((packed)) INFO_SB_ADSP_DEVICE_ID_STR;
#define SIZE_INFO_SB_ADSP_DEVICE_ID                           sizeof(INFO_SB_ADSP_DEVICE_ID_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct INFO_SB_ADSP_REVISION_ID
#define INFO_SB_ADSP_REVISION_ID                              0x66                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      prod_id;
             uint8_t      str_len;
             uint8_t      adsp_versn_str[0];
            } __attribute__((packed)) INFO_SB_ADSP_REVISION_ID_STR;
#define SIZE_INFO_SB_ADSP_REVISION_ID                         sizeof(INFO_SB_ADSP_REVISION_ID_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct INFO_SB_VERSION_BY_DSP_CORE_SRV
#define INFO_SB_VERSION_BY_DSP_CORE_SRV                       0x64                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint16_t     target;
             uint8_t      prod_id;
             uint8_t      str_len;
             uint8_t      ver_by_dsp_core_srv[0];
            } __attribute__((packed)) INFO_SB_VERSION_BY_DSP_CORE_SRV_STR;
#define SIZE_INFO_SB_VERSION_BY_DSP_CORE_SRV                  sizeof(INFO_SB_VERSION_BY_DSP_CORE_SRV_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct INFO_SB_PPM_VERSION
#define INFO_SB_PPM_VERSION                                   0x58                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      fillerbyte1;
             uint8_t      str_len;
             uint8_t      ppm_versn_str_c8[0];
            } __attribute__((packed)) INFO_SB_PPM_VERSION_STR;
#define SIZE_INFO_SB_PPM_VERSION                              sizeof(INFO_SB_PPM_VERSION_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct INFO_SB_PP
#define INFO_SB_PP                                            0x47                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      customer_id;
             uint8_t      str_len;
             uint16_t     product_profile[0];
            } __attribute__((packed)) INFO_SB_PP_STR;
#define SIZE_INFO_SB_PP                                       sizeof(INFO_SB_PP_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct INFO_SB_PP_DATA
#define INFO_SB_PP_DATA                                       0x74                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      fillerbyte1;
             uint16_t     sub_block_len;
             uint8_t      customer_id;
             uint8_t      fillerbyte2;
             uint16_t     pp_fea_cnt;
             uint32_t     pp_feaval[0];
            } __attribute__((packed)) INFO_SB_PP_DATA_STR;
#define SIZE_INFO_SB_PP_DATA                                  sizeof(INFO_SB_PP_DATA_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct INFO_SB_PRODUCTION_SN
#define INFO_SB_PRODUCTION_SN                                 0x4D                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      fillerbyte1;
             uint8_t      str_len;
             uint8_t      prod_sn_c8[0];
            } __attribute__((packed)) INFO_SB_PRODUCTION_SN_STR;
#define SIZE_INFO_SB_PRODUCTION_SN                            sizeof(INFO_SB_PRODUCTION_SN_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct INFO_SB_LONG_PRODUCTION_SN
#define INFO_SB_LONG_PRODUCTION_SN                            0x59                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      fillerbyte1;
             uint8_t      str_len;
             uint8_t      prod_long_sn_c8[0];
            } __attribute__((packed)) INFO_SB_LONG_PRODUCTION_SN_STR;
#define SIZE_INFO_SB_LONG_PRODUCTION_SN                       sizeof(INFO_SB_LONG_PRODUCTION_SN_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct INFO_SB_PRODUCT_CODE
#define INFO_SB_PRODUCT_CODE                                  0x4E                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      fillerbyte1;
             uint8_t      str_len;
             uint8_t      product_code_c8[0];
            } __attribute__((packed)) INFO_SB_PRODUCT_CODE_STR;
#define SIZE_INFO_SB_PRODUCT_CODE                             sizeof(INFO_SB_PRODUCT_CODE_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct INFO_SB_BASIC_PRODUCT_CODE
#define INFO_SB_BASIC_PRODUCT_CODE                            0x4F                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      fillerbyte1;
             uint8_t      str_len;
             uint8_t      basic_product_code_c8[8];
            } __attribute__((packed)) INFO_SB_BASIC_PRODUCT_CODE_STR;
#define SIZE_INFO_SB_BASIC_PRODUCT_CODE                       sizeof(INFO_SB_BASIC_PRODUCT_CODE_STR)


//Definition for struct INFO_SB_MODULE_CODE
#define INFO_SB_MODULE_CODE                                   0x50                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      fillerbyte1;
             uint8_t      str_len;
             uint8_t      module_code_c8[8];
            } __attribute__((packed)) INFO_SB_MODULE_CODE_STR;
#define SIZE_INFO_SB_MODULE_CODE                              sizeof(INFO_SB_MODULE_CODE_STR)


//Definition for struct INFO_SB_FLASH_CODE
#define INFO_SB_FLASH_CODE                                    0x51                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      fillerbyte1;
             uint8_t      str_len;
             uint8_t      flash_code_c8[6];
             uint16_t     fillerbyte2;
            } __attribute__((packed)) INFO_SB_FLASH_CODE_STR;
#define SIZE_INFO_SB_FLASH_CODE                               sizeof(INFO_SB_FLASH_CODE_STR)


//Definition for struct INFO_SB_ORDER_NUMBER
#define INFO_SB_ORDER_NUMBER                                  0x52                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      fillerbyte1;
             uint8_t      str_len;
             uint8_t      order_number_c8[8];
            } __attribute__((packed)) INFO_SB_ORDER_NUMBER_STR;
#define SIZE_INFO_SB_ORDER_NUMBER                             sizeof(INFO_SB_ORDER_NUMBER_STR)


//Definition for struct INFO_SB_PRODUCT_SPECIFIC_DATA
#define INFO_SB_PRODUCT_SPECIFIC_DATA                         0x53                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      stest_status;
             uint8_t      project;
             uint32_t     cellular_type_u32;
             uint8_t      customer;
             uint8_t      revision_level;
             uint16_t     fillerbyte1;
            } __attribute__((packed)) INFO_SB_PRODUCT_SPECIFIC_DATA_STR;
#define SIZE_INFO_SB_PRODUCT_SPECIFIC_DATA                    sizeof(INFO_SB_PRODUCT_SPECIFIC_DATA_STR)


//Definition for struct INFO_SB_ATO
#define INFO_SB_ATO                                           0x5C                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      fillerbyte1;
             uint8_t      str_len;
             uint8_t      ato_data[0];
            } __attribute__((packed)) INFO_SB_ATO_STR;
#define SIZE_INFO_SB_ATO                                      sizeof(INFO_SB_ATO_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct INFO_SB_SN_DEFAULT
#define INFO_SB_SN_DEFAULT                                    0x5D                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      fillerbyte1;
             uint8_t      str_len;
             uint8_t      default_sn[0];
            } __attribute__((packed)) INFO_SB_SN_DEFAULT_STR;
#define SIZE_INFO_SB_SN_DEFAULT                               sizeof(INFO_SB_SN_DEFAULT_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct INFO_SB_SN_DEFAULT_TYPE
#define INFO_SB_SN_DEFAULT_TYPE                               0x5E                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      default_sn_type;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) INFO_SB_SN_DEFAULT_TYPE_STR;
#define SIZE_INFO_SB_SN_DEFAULT_TYPE                          sizeof(INFO_SB_SN_DEFAULT_TYPE_STR)


//Definition for struct INFO_SB_BAND_CS_TYPE
#define INFO_SB_BAND_CS_TYPE                                  0x67                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint16_t     fillerbyte1;
             uint32_t     info_band_cs_type;
            } __attribute__((packed)) INFO_SB_BAND_CS_TYPE_STR;
#define SIZE_INFO_SB_BAND_CS_TYPE                             sizeof(INFO_SB_BAND_CS_TYPE_STR)


//Definition for struct INFO_SB_SN_DEFAULT_PLAIN
#define INFO_SB_SN_DEFAULT_PLAIN                              0x63                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      type_id;
             uint8_t      str_len;
             uint8_t      default_sn[0];
            } __attribute__((packed)) INFO_SB_SN_DEFAULT_PLAIN_STR;
#define SIZE_INFO_SB_SN_DEFAULT_PLAIN                         sizeof(INFO_SB_SN_DEFAULT_PLAIN_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct INFO_SB_PRODUCT_TYPE_CS_SEC
#define INFO_SB_PRODUCT_TYPE_CS_SEC                           0x03                                                     
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             CS_TYPE_SEC_STR    cs_type_sec[0];
            } __attribute__((packed)) INFO_SB_PRODUCT_TYPE_CS_SEC_STR;
#define SIZE_INFO_SB_PRODUCT_TYPE_CS_SEC                      sizeof(INFO_SB_PRODUCT_TYPE_CS_SEC_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct INFO_SB_PRODUCT_TYPE_CS
#define INFO_SB_PRODUCT_TYPE_CS                               0x01                                                     
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             CS_TYPE_SEC_STR    cs_type_sec[0];
            } __attribute__((packed)) INFO_SB_PRODUCT_TYPE_CS_STR;
#define SIZE_INFO_SB_PRODUCT_TYPE_CS                          sizeof(INFO_SB_PRODUCT_TYPE_CS_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct INFO_SB_PRODUCT_TYPE_HW_INFO
#define INFO_SB_PRODUCT_TYPE_HW_INFO                          0x02                                                     
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      hw_info[22];
             uint8_t      fillerbyte3;
             uint8_t      fillerbyte4;
            } __attribute__((packed)) INFO_SB_PRODUCT_TYPE_HW_INFO_STR;
#define SIZE_INFO_SB_PRODUCT_TYPE_HW_INFO                     sizeof(INFO_SB_PRODUCT_TYPE_HW_INFO_STR)


//Definition for struct INFO_SB_PRODUCT_INFO_NAME
#define INFO_SB_PRODUCT_INFO_NAME                             0x01                                                     
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      fillerbyte1;
             uint8_t      str_len;
             uint8_t      prod_info_str_c8[0];
            } __attribute__((packed)) INFO_SB_PRODUCT_INFO_NAME_STR;
#define SIZE_INFO_SB_PRODUCT_INFO_NAME                        sizeof(INFO_SB_PRODUCT_INFO_NAME_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct INFO_SB_PRODUCT_INFO_CATEGORY
#define INFO_SB_PRODUCT_INFO_CATEGORY                         0x02                                                     
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      fillerbyte1;
             uint8_t      str_len;
             uint8_t      string[0];
            } __attribute__((packed)) INFO_SB_PRODUCT_INFO_CATEGORY_STR;
#define SIZE_INFO_SB_PRODUCT_INFO_CATEGORY                    sizeof(INFO_SB_PRODUCT_INFO_CATEGORY_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct INFO_SB_PRODUCT_INFO_XID
#define INFO_SB_PRODUCT_INFO_XID                              0x03                                                     
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      fillerbyte1;
             uint8_t      str_len;
             uint8_t      string[0];
            } __attribute__((packed)) INFO_SB_PRODUCT_INFO_XID_STR;
#define SIZE_INFO_SB_PRODUCT_INFO_XID                         sizeof(INFO_SB_PRODUCT_INFO_XID_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct INFO_SB_PRODUCT_INFO_DEV_NAME
#define INFO_SB_PRODUCT_INFO_DEV_NAME                         0x04                                                     
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      fillerbyte1;
             uint8_t      str_len;
             uint8_t      string[0];
            } __attribute__((packed)) INFO_SB_PRODUCT_INFO_DEV_NAME_STR;
#define SIZE_INFO_SB_PRODUCT_INFO_DEV_NAME                    sizeof(INFO_SB_PRODUCT_INFO_DEV_NAME_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct INFO_SB_PRODUCT_INFO_COMP01
#define INFO_SB_PRODUCT_INFO_COMP01                           0x05                                                     
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      fillerbyte1;
             uint8_t      str_len;
             uint8_t      string[0];
            } __attribute__((packed)) INFO_SB_PRODUCT_INFO_COMP01_STR;
#define SIZE_INFO_SB_PRODUCT_INFO_COMP01                      sizeof(INFO_SB_PRODUCT_INFO_COMP01_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct INFO_SB_PRODUCT_INFO_NAME_COMPRESSED
#define INFO_SB_PRODUCT_INFO_NAME_COMPRESSED                  0x06                                                     
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      fillerbyte1;
             uint8_t      str_len;
             uint8_t      string[0];
            } __attribute__((packed)) INFO_SB_PRODUCT_INFO_NAME_COMPRESSED_STR;
#define SIZE_INFO_SB_PRODUCT_INFO_NAME_COMPRESSED             sizeof(INFO_SB_PRODUCT_INFO_NAME_COMPRESSED_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct INFO_SB_PRODUCT_INFO_MANUFACTURER
#define INFO_SB_PRODUCT_INFO_MANUFACTURER                     0x07                                                     
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      fillerbyte1;
             uint8_t      str_len;
             uint8_t      string[0];
            } __attribute__((packed)) INFO_SB_PRODUCT_INFO_MANUFACTURER_STR;
#define SIZE_INFO_SB_PRODUCT_INFO_MANUFACTURER                sizeof(INFO_SB_PRODUCT_INFO_MANUFACTURER_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct INFO_SB_PRODUCT_INFO_XCVR_ID
#define INFO_SB_PRODUCT_INFO_XCVR_ID                          0x08                                                     
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      fillerbyte1;
             uint8_t      str_len;
             uint8_t      string[0];
            } __attribute__((packed)) INFO_SB_PRODUCT_INFO_XCVR_ID_STR;
#define SIZE_INFO_SB_PRODUCT_INFO_XCVR_ID                     sizeof(INFO_SB_PRODUCT_INFO_XCVR_ID_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct INFO_SB_PRODUCT_INFO_NUM_ID
#define INFO_SB_PRODUCT_INFO_NUM_ID                           0x09                                                     
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      fillerbyte1;
             uint8_t      str_len;
             uint8_t      string[0];
            } __attribute__((packed)) INFO_SB_PRODUCT_INFO_NUM_ID_STR;
#define SIZE_INFO_SB_PRODUCT_INFO_NUM_ID                      sizeof(INFO_SB_PRODUCT_INFO_NUM_ID_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct INFO_SB_PRODUCT_INFO_TYPE_ID
#define INFO_SB_PRODUCT_INFO_TYPE_ID                          0x0A                                                     
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      fillerbyte1;
             uint8_t      str_len;
             uint8_t      string[0];
            } __attribute__((packed)) INFO_SB_PRODUCT_INFO_TYPE_ID_STR;
#define SIZE_INFO_SB_PRODUCT_INFO_TYPE_ID                     sizeof(INFO_SB_PRODUCT_INFO_TYPE_ID_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct INFO_SB_USB_VENDOR_ID
#define INFO_SB_USB_VENDOR_ID                                 0x0B                                                     
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      fillerbyte1;
             uint8_t      str_len;
             uint8_t      string[0];
            } __attribute__((packed)) INFO_SB_USB_VENDOR_ID_STR;
#define SIZE_INFO_SB_USB_VENDOR_ID                            sizeof(INFO_SB_USB_VENDOR_ID_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct INFO_SB_USB_MASS_ID
#define INFO_SB_USB_MASS_ID                                   0x0C                                                     
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      fillerbyte1;
             uint8_t      str_len;
             uint8_t      string[0];
            } __attribute__((packed)) INFO_SB_USB_MASS_ID_STR;
#define SIZE_INFO_SB_USB_MASS_ID                              sizeof(INFO_SB_USB_MASS_ID_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct INFO_SB_USB_NOKIA_ID
#define INFO_SB_USB_NOKIA_ID                                  0x0D                                                     
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      fillerbyte1;
             uint8_t      str_len;
             uint8_t      string[0];
            } __attribute__((packed)) INFO_SB_USB_NOKIA_ID_STR;
#define SIZE_INFO_SB_USB_NOKIA_ID                             sizeof(INFO_SB_USB_NOKIA_ID_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct INFO_SB_USB_SICD_ID
#define INFO_SB_USB_SICD_ID                                   0x0E                                                     
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      fillerbyte1;
             uint8_t      str_len;
             uint8_t      string[0];
            } __attribute__((packed)) INFO_SB_USB_SICD_ID_STR;
#define SIZE_INFO_SB_USB_SICD_ID                              sizeof(INFO_SB_USB_SICD_ID_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct INFO_SB_USB_RNDIS_ID
#define INFO_SB_USB_RNDIS_ID                                  0x10                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      fillerbyte1;
             uint8_t      str_len;
             uint8_t      string[0];
            } __attribute__((packed)) INFO_SB_USB_RNDIS_ID_STR;
#define SIZE_INFO_SB_USB_RNDIS_ID                             sizeof(INFO_SB_USB_RNDIS_ID_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct INFO_SB_BT_PID
#define INFO_SB_BT_PID                                        0x0F                                                     
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      fillerbyte1;
             uint8_t      str_len;
             uint8_t      string[0];
            } __attribute__((packed)) INFO_SB_BT_PID_STR;
#define SIZE_INFO_SB_BT_PID                                   sizeof(INFO_SB_BT_PID_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct INFO_SB_BT_ID_PLAIN
#define INFO_SB_BT_ID_PLAIN                                   0x01                                                     
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      fillerbyte1;
             uint8_t      str_len;
             uint8_t      bt_id_plain[6];
             uint16_t     fillerbyte2;
            } __attribute__((packed)) INFO_SB_BT_ID_PLAIN_STR;
#define SIZE_INFO_SB_BT_ID_PLAIN                              sizeof(INFO_SB_BT_ID_PLAIN_STR)


//Definition for struct INFO_SB_BT_ID_SEC
#define INFO_SB_BT_ID_SEC                                     0x02                                                     
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint16_t     fillerbyte1;
             INFO_BT_ID_SEC_STR    bt_id_sec[0];
            } __attribute__((packed)) INFO_SB_BT_ID_SEC_STR;
#define SIZE_INFO_SB_BT_ID_SEC                                sizeof(INFO_SB_BT_ID_SEC_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct INFO_SB_WT_ORIG_SN_INFO
#define INFO_SB_WT_ORIG_SN_INFO                               0x01                                                     
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      fillerbyte1;
             uint8_t      serial_number_type;
             uint8_t      sn[20];
            } __attribute__((packed)) INFO_SB_WT_ORIG_SN_INFO_STR;
#define SIZE_INFO_SB_WT_ORIG_SN_INFO                          sizeof(INFO_SB_WT_ORIG_SN_INFO_STR)


//Definition for struct INFO_SB_WT_ORIG_MAN_MONTH_YEAR
#define INFO_SB_WT_ORIG_MAN_MONTH_YEAR                        0x02                                                     
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      fillerbyte1;
             uint8_t      month;
             uint16_t     year;
             uint16_t     fillerbyte2;
            } __attribute__((packed)) INFO_SB_WT_ORIG_MAN_MONTH_YEAR_STR;
#define SIZE_INFO_SB_WT_ORIG_MAN_MONTH_YEAR                   sizeof(INFO_SB_WT_ORIG_MAN_MONTH_YEAR_STR)


//Definition for struct INFO_SB_WT_OWN_MAN_MONTH_YEAR
#define INFO_SB_WT_OWN_MAN_MONTH_YEAR                         0x03                                                     
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      fillerbyte1;
             uint8_t      month;
             uint16_t     year;
             uint16_t     fillerbyte2;
            } __attribute__((packed)) INFO_SB_WT_OWN_MAN_MONTH_YEAR_STR;
#define SIZE_INFO_SB_WT_OWN_MAN_MONTH_YEAR                    sizeof(INFO_SB_WT_OWN_MAN_MONTH_YEAR_STR)


//Definition for struct INFO_SB_WT_REPAIR_MONTH_YEAR
#define INFO_SB_WT_REPAIR_MONTH_YEAR                          0x04                                                     
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      fillerbyte1;
             uint8_t      month;
             uint16_t     year;
             uint16_t     fillerbyte2;
            } __attribute__((packed)) INFO_SB_WT_REPAIR_MONTH_YEAR_STR;
#define SIZE_INFO_SB_WT_REPAIR_MONTH_YEAR                     sizeof(INFO_SB_WT_REPAIR_MONTH_YEAR_STR)


//Definition for struct INFO_SB_WT_PURCH_MONTH_YEAR
#define INFO_SB_WT_PURCH_MONTH_YEAR                           0x05                                                     
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      fillerbyte1;
             uint8_t      month;
             uint16_t     year;
             uint8_t      state;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) INFO_SB_WT_PURCH_MONTH_YEAR_STR;
#define SIZE_INFO_SB_WT_PURCH_MONTH_YEAR                      sizeof(INFO_SB_WT_PURCH_MONTH_YEAR_STR)


//Definition for struct INFO_SB_WT_WIS
#define INFO_SB_WT_WIS                                        0x06                                                     
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      fillerbyte1;
             uint8_t      wis;
            } __attribute__((packed)) INFO_SB_WT_WIS_STR;
#define SIZE_INFO_SB_WT_WIS                                   sizeof(INFO_SB_WT_WIS_STR)


//Definition for struct INFO_SB_WT_RPF
#define INFO_SB_WT_RPF                                        0x07                                                     
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint16_t     fillerbyte1;
             uint32_t     rpf;
            } __attribute__((packed)) INFO_SB_WT_RPF_STR;
#define SIZE_INFO_SB_WT_RPF                                   sizeof(INFO_SB_WT_RPF_STR)


//Definition for struct INFO_SB_RETU_VER
#define INFO_SB_RETU_VER                                      0x6C                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      fillerbyte1;
             uint8_t      str_len;
             uint8_t      hw_version[0];
            } __attribute__((packed)) INFO_SB_RETU_VER_STR;
#define SIZE_INFO_SB_RETU_VER                                 sizeof(INFO_SB_RETU_VER_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct INFO_SB_TAHVO_VER
#define INFO_SB_TAHVO_VER                                     0x6D                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      fillerbyte1;
             uint8_t      str_len;
             uint8_t      hw_version[0];
            } __attribute__((packed)) INFO_SB_TAHVO_VER_STR;
#define SIZE_INFO_SB_TAHVO_VER                                sizeof(INFO_SB_TAHVO_VER_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct INFO_SB_RAP_VERSION
#define INFO_SB_RAP_VERSION                                   0x73                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      rap_type;
             uint8_t      str_len;
             uint8_t      rap_version[0];
            } __attribute__((packed)) INFO_SB_RAP_VERSION_STR;
#define SIZE_INFO_SB_RAP_VERSION                              sizeof(INFO_SB_RAP_VERSION_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct INFO_SB_PRODUCT_VARIANT_NUMBER
#define INFO_SB_PRODUCT_VARIANT_NUMBER                        0x60                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      customer;
             uint8_t      revision_level;
            } __attribute__((packed)) INFO_SB_PRODUCT_VARIANT_NUMBER_STR;
#define SIZE_INFO_SB_PRODUCT_VARIANT_NUMBER                   sizeof(INFO_SB_PRODUCT_VARIANT_NUMBER_STR)


//Definition for struct INFO_SB_GAZOO
#define INFO_SB_GAZOO                                         0x76                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      version_major;
             uint8_t      version_minor;
             uint8_t      version_spare;
             uint8_t      fillerbyte1[3];
            } __attribute__((packed)) INFO_SB_GAZOO_STR;
#define SIZE_INFO_SB_GAZOO                                    sizeof(INFO_SB_GAZOO_STR)


//MESSAGES


//Definition for struct INFO_SERIAL_NUMBER_READ_REQ
#define INFO_SERIAL_NUMBER_READ_REQ                           0x00                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      target;
            } __attribute__((packed)) INFO_SERIAL_NUMBER_READ_REQ_STR;
#define SIZE_INFO_SERIAL_NUMBER_READ_REQ                      sizeof(INFO_SERIAL_NUMBER_READ_REQ_STR)


//Definition for struct INFO_SERIAL_NUMBER_READ_RESP
#define INFO_SERIAL_NUMBER_READ_RESP                          0x01                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      sub_block_count;
            } __attribute__((packed)) INFO_SERIAL_NUMBER_READ_RESP_STR;
#define SIZE_INFO_SERIAL_NUMBER_READ_RESP                     sizeof(INFO_SERIAL_NUMBER_READ_RESP_STR)


//Definition for struct INFO_PP_CUSTOMER_DEFAULTS_REQ
#define INFO_PP_CUSTOMER_DEFAULTS_REQ                         0x0F                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      customer_id;
            } __attribute__((packed)) INFO_PP_CUSTOMER_DEFAULTS_REQ_STR;
#define SIZE_INFO_PP_CUSTOMER_DEFAULTS_REQ                    sizeof(INFO_PP_CUSTOMER_DEFAULTS_REQ_STR)


//Definition for struct INFO_PP_CUSTOMER_DEFAULTS_RESP
#define INFO_PP_CUSTOMER_DEFAULTS_RESP                        0x10                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
            } __attribute__((packed)) INFO_PP_CUSTOMER_DEFAULTS_RESP_STR;
#define SIZE_INFO_PP_CUSTOMER_DEFAULTS_RESP                   sizeof(INFO_PP_CUSTOMER_DEFAULTS_RESP_STR)


//Definition for struct INFO_PP_READ_REQ
#define INFO_PP_READ_REQ                                      0x02                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      filler;
             uint8_t      sub_block_count;
            } __attribute__((packed)) INFO_PP_READ_REQ_STR;
#define SIZE_INFO_PP_READ_REQ                                 sizeof(INFO_PP_READ_REQ_STR)


//Definition for struct INFO_PP_READ_RESP
#define INFO_PP_READ_RESP                                     0x03                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      sub_block_count;
            } __attribute__((packed)) INFO_PP_READ_RESP_STR;
#define SIZE_INFO_PP_READ_RESP                                sizeof(INFO_PP_READ_RESP_STR)


//Definition for struct INFO_PP_WRITE_REQ
#define INFO_PP_WRITE_REQ                                     0x04                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      sub_block_count;
            } __attribute__((packed)) INFO_PP_WRITE_REQ_STR;
#define SIZE_INFO_PP_WRITE_REQ                                sizeof(INFO_PP_WRITE_REQ_STR)


//Definition for struct INFO_PP_WRITE_RESP
#define INFO_PP_WRITE_RESP                                    0x05                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
            } __attribute__((packed)) INFO_PP_WRITE_RESP_STR;
#define SIZE_INFO_PP_WRITE_RESP                               sizeof(INFO_PP_WRITE_RESP_STR)


//Definition for struct INFO_PP_IND
#define INFO_PP_IND                                           0x06                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      sub_block_count;
            } __attribute__((packed)) INFO_PP_IND_STR;
#define SIZE_INFO_PP_IND                                      sizeof(INFO_PP_IND_STR)


//Definition for struct INFO_PP_DATA_READ_REQ
#define INFO_PP_DATA_READ_REQ                                 0x29                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      filler;
             uint8_t      sub_block_count;
            } __attribute__((packed)) INFO_PP_DATA_READ_REQ_STR;
#define SIZE_INFO_PP_DATA_READ_REQ                            sizeof(INFO_PP_DATA_READ_REQ_STR)


//Definition for struct INFO_PP_DATA_READ_RESP
#define INFO_PP_DATA_READ_RESP                                0x2A                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      sub_block_count;
            } __attribute__((packed)) INFO_PP_DATA_READ_RESP_STR;
#define SIZE_INFO_PP_DATA_READ_RESP                           sizeof(INFO_PP_DATA_READ_RESP_STR)


//Definition for struct INFO_PP_DATA_WRITE_REQ
#define INFO_PP_DATA_WRITE_REQ                                0x2B                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      sub_block_count;
            } __attribute__((packed)) INFO_PP_DATA_WRITE_REQ_STR;
#define SIZE_INFO_PP_DATA_WRITE_REQ                           sizeof(INFO_PP_DATA_WRITE_REQ_STR)


//Definition for struct INFO_PP_DATA_WRITE_RESP
#define INFO_PP_DATA_WRITE_RESP                               0x2C                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      status;
            } __attribute__((packed)) INFO_PP_DATA_WRITE_RESP_STR;
#define SIZE_INFO_PP_DATA_WRITE_RESP                          sizeof(INFO_PP_DATA_WRITE_RESP_STR)


//Definition for struct INFO_PP_DATA_IND
#define INFO_PP_DATA_IND                                      0x2D                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      sub_block_count;
            } __attribute__((packed)) INFO_PP_DATA_IND_STR;
#define SIZE_INFO_PP_DATA_IND                                 sizeof(INFO_PP_DATA_IND_STR)


//Definition for struct INFO_VERSION_READ_REQ
#define INFO_VERSION_READ_REQ                                 0x07                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint16_t     target;
             uint32_t     target2;
            } __attribute__((packed)) INFO_VERSION_READ_REQ_STR;
#define SIZE_INFO_VERSION_READ_REQ                            sizeof(INFO_VERSION_READ_REQ_STR)


//Definition for struct INFO_VERSION_READ_RESP
#define INFO_VERSION_READ_RESP                                0x08                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      sub_block_count;
            } __attribute__((packed)) INFO_VERSION_READ_RESP_STR;
#define SIZE_INFO_VERSION_READ_RESP                           sizeof(INFO_VERSION_READ_RESP_STR)


//Definition for struct INFO_VERSION_WRITE_REQ
#define INFO_VERSION_WRITE_REQ                                0x09                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      sub_block_count;
            } __attribute__((packed)) INFO_VERSION_WRITE_REQ_STR;
#define SIZE_INFO_VERSION_WRITE_REQ                           sizeof(INFO_VERSION_WRITE_REQ_STR)


//Definition for struct INFO_VERSION_WRITE_RESP
#define INFO_VERSION_WRITE_RESP                               0x0A                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
            } __attribute__((packed)) INFO_VERSION_WRITE_RESP_STR;
#define SIZE_INFO_VERSION_WRITE_RESP                          sizeof(INFO_VERSION_WRITE_RESP_STR)


//Definition for struct INFO_PROD_INFO_READ_REQ
#define INFO_PROD_INFO_READ_REQ                               0x0B                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint16_t     target;
            } __attribute__((packed)) INFO_PROD_INFO_READ_REQ_STR;
#define SIZE_INFO_PROD_INFO_READ_REQ                          sizeof(INFO_PROD_INFO_READ_REQ_STR)


//Definition for struct INFO_PROD_INFO_READ_RESP
#define INFO_PROD_INFO_READ_RESP                              0x0C                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      sub_block_count;
            } __attribute__((packed)) INFO_PROD_INFO_READ_RESP_STR;
#define SIZE_INFO_PROD_INFO_READ_RESP                         sizeof(INFO_PROD_INFO_READ_RESP_STR)


//Definition for struct INFO_PROD_INFO_WRITE_REQ
#define INFO_PROD_INFO_WRITE_REQ                              0x0D                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      sub_block_count;
            } __attribute__((packed)) INFO_PROD_INFO_WRITE_REQ_STR;
#define SIZE_INFO_PROD_INFO_WRITE_REQ                         sizeof(INFO_PROD_INFO_WRITE_REQ_STR)


//Definition for struct INFO_PROD_INFO_WRITE_RESP
#define INFO_PROD_INFO_WRITE_RESP                             0x0E                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
            } __attribute__((packed)) INFO_PROD_INFO_WRITE_RESP_STR;
#define SIZE_INFO_PROD_INFO_WRITE_RESP                        sizeof(INFO_PROD_INFO_WRITE_RESP_STR)


//Definition for struct INFO_PRODUCT_TYPE_WRITE_REQ
#define INFO_PRODUCT_TYPE_WRITE_REQ                           0x11                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      sub_block_count;
            } __attribute__((packed)) INFO_PRODUCT_TYPE_WRITE_REQ_STR;
#define SIZE_INFO_PRODUCT_TYPE_WRITE_REQ                      sizeof(INFO_PRODUCT_TYPE_WRITE_REQ_STR)


//Definition for struct INFO_PRODUCT_TYPE_WRITE_RESP
#define INFO_PRODUCT_TYPE_WRITE_RESP                          0x12                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) INFO_PRODUCT_TYPE_WRITE_RESP_STR;
#define SIZE_INFO_PRODUCT_TYPE_WRITE_RESP                     sizeof(INFO_PRODUCT_TYPE_WRITE_RESP_STR)


//Definition for struct INFO_PRODUCT_TYPE_READ_REQ
#define INFO_PRODUCT_TYPE_READ_REQ                            0x13                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      type;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) INFO_PRODUCT_TYPE_READ_REQ_STR;
#define SIZE_INFO_PRODUCT_TYPE_READ_REQ                       sizeof(INFO_PRODUCT_TYPE_READ_REQ_STR)


//Definition for struct INFO_PRODUCT_TYPE_READ_RESP
#define INFO_PRODUCT_TYPE_READ_RESP                           0x14                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      sub_block_count;
            } __attribute__((packed)) INFO_PRODUCT_TYPE_READ_RESP_STR;
#define SIZE_INFO_PRODUCT_TYPE_READ_RESP                      sizeof(INFO_PRODUCT_TYPE_READ_RESP_STR)


//Definition for struct INFO_PRODUCT_INFO_READ_REQ
#define INFO_PRODUCT_INFO_READ_REQ                            0x15                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      target;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) INFO_PRODUCT_INFO_READ_REQ_STR;
#define SIZE_INFO_PRODUCT_INFO_READ_REQ                       sizeof(INFO_PRODUCT_INFO_READ_REQ_STR)


//Definition for struct INFO_PRODUCT_INFO_READ_RESP
#define INFO_PRODUCT_INFO_READ_RESP                           0x16                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      sub_block_count;
            } __attribute__((packed)) INFO_PRODUCT_INFO_READ_RESP_STR;
#define SIZE_INFO_PRODUCT_INFO_READ_RESP                      sizeof(INFO_PRODUCT_INFO_READ_RESP_STR)


//Definition for struct INFO_BT_ID_WRITE_REQ
#define INFO_BT_ID_WRITE_REQ                                  0x19                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      sub_block_count;
            } __attribute__((packed)) INFO_BT_ID_WRITE_REQ_STR;
#define SIZE_INFO_BT_ID_WRITE_REQ                             sizeof(INFO_BT_ID_WRITE_REQ_STR)


//Definition for struct INFO_BT_ID_WRITE_RESP
#define INFO_BT_ID_WRITE_RESP                                 0x1A                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) INFO_BT_ID_WRITE_RESP_STR;
#define SIZE_INFO_BT_ID_WRITE_RESP                            sizeof(INFO_BT_ID_WRITE_RESP_STR)


//Definition for struct INFO_BT_ID_READ_REQ
#define INFO_BT_ID_READ_REQ                                   0x17                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      target;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) INFO_BT_ID_READ_REQ_STR;
#define SIZE_INFO_BT_ID_READ_REQ                              sizeof(INFO_BT_ID_READ_REQ_STR)


//Definition for struct INFO_BT_ID_READ_RESP
#define INFO_BT_ID_READ_RESP                                  0x18                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      sub_block_count;
            } __attribute__((packed)) INFO_BT_ID_READ_RESP_STR;
#define SIZE_INFO_BT_ID_READ_RESP                             sizeof(INFO_BT_ID_READ_RESP_STR)


//Definition for struct INFO_WT_READ_REQ
#define INFO_WT_READ_REQ                                      0x1B                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint16_t     read_bits;
            } __attribute__((packed)) INFO_WT_READ_REQ_STR;
#define SIZE_INFO_WT_READ_REQ                                 sizeof(INFO_WT_READ_REQ_STR)


//Definition for struct INFO_WT_READ_RESP
#define INFO_WT_READ_RESP                                     0x1C                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      fillerbyte1;
             uint16_t     read_bits;
             uint8_t      fillerbyte2;
             uint8_t      sb_cnt;
            } __attribute__((packed)) INFO_WT_READ_RESP_STR;
#define SIZE_INFO_WT_READ_RESP                                sizeof(INFO_WT_READ_RESP_STR)


//Definition for struct INFO_WT_WRITE_REQ
#define INFO_WT_WRITE_REQ                                     0x1D                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      sb_cnt;
            } __attribute__((packed)) INFO_WT_WRITE_REQ_STR;
#define SIZE_INFO_WT_WRITE_REQ                                sizeof(INFO_WT_WRITE_REQ_STR)


//Definition for struct INFO_WT_WRITE_RESP
#define INFO_WT_WRITE_RESP                                    0x1E                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      fillerbyte1;
             uint16_t     read_bits;
             uint16_t     fillerbyte2;
            } __attribute__((packed)) INFO_WT_WRITE_RESP_STR;
#define SIZE_INFO_WT_WRITE_RESP                               sizeof(INFO_WT_WRITE_RESP_STR)


//Definition for struct INFO_LONG_DATA_READ_REQ
#define INFO_LONG_DATA_READ_REQ                               0x1F                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint16_t     fillerbyte1;
            } __attribute__((packed)) INFO_LONG_DATA_READ_REQ_STR;
#define SIZE_INFO_LONG_DATA_READ_REQ                          sizeof(INFO_LONG_DATA_READ_REQ_STR)


//Definition for struct INFO_LONG_DATA_READ_RESP
#define INFO_LONG_DATA_READ_RESP                              0x20                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      fillerbyte1;
             uint16_t     data_length;
             uint8_t      data[0];
            } __attribute__((packed)) INFO_LONG_DATA_READ_RESP_STR;
#define SIZE_INFO_LONG_DATA_READ_RESP                         sizeof(INFO_LONG_DATA_READ_RESP_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct INFO_LONG_DATA_WRITE_REQ
#define INFO_LONG_DATA_WRITE_REQ                              0x21                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint16_t     data_length;
             uint8_t      data[0];
            } __attribute__((packed)) INFO_LONG_DATA_WRITE_REQ_STR;
#define SIZE_INFO_LONG_DATA_WRITE_REQ                         sizeof(INFO_LONG_DATA_WRITE_REQ_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct INFO_LONG_DATA_WRITE_RESP
#define INFO_LONG_DATA_WRITE_RESP                             0x22                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) INFO_LONG_DATA_WRITE_RESP_STR;
#define SIZE_INFO_LONG_DATA_WRITE_RESP                        sizeof(INFO_LONG_DATA_WRITE_RESP_STR)


//Definition for struct INFO_WLAN_INFO_READ_REQ
#define INFO_WLAN_INFO_READ_REQ                               0x23                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint16_t     fillerbyte1;
            } __attribute__((packed)) INFO_WLAN_INFO_READ_REQ_STR;
#define SIZE_INFO_WLAN_INFO_READ_REQ                          sizeof(INFO_WLAN_INFO_READ_REQ_STR)


//Definition for struct INFO_WLAN_INFO_READ_RESP
#define INFO_WLAN_INFO_READ_RESP                              0x24                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      address[6];
             uint8_t      fillerbyte1[3];
            } __attribute__((packed)) INFO_WLAN_INFO_READ_RESP_STR;
#define SIZE_INFO_WLAN_INFO_READ_RESP                         sizeof(INFO_WLAN_INFO_READ_RESP_STR)


//Definition for struct INFO_IP_PASSTHROUGH_READ_REQ
#define INFO_IP_PASSTHROUGH_READ_REQ                          0x25                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint16_t     fillerbyte1;
            } __attribute__((packed)) INFO_IP_PASSTHROUGH_READ_REQ_STR;
#define SIZE_INFO_IP_PASSTHROUGH_READ_REQ                     sizeof(INFO_IP_PASSTHROUGH_READ_REQ_STR)


//Definition for struct INFO_IP_PASSTHROUGH_READ_RESP
#define INFO_IP_PASSTHROUGH_READ_RESP                         0x26                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      fillerbyte1;
             INFO_IPP_MACS_STR    ipp_macs[0];
            } __attribute__((packed)) INFO_IP_PASSTHROUGH_READ_RESP_STR;
#define SIZE_INFO_IP_PASSTHROUGH_READ_RESP                    sizeof(INFO_IP_PASSTHROUGH_READ_RESP_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct INFO_WLAN_INFO_WRITE_REQ
#define INFO_WLAN_INFO_WRITE_REQ                              0x27                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint16_t     fillerbyte1;
             uint8_t      enc_data[8];
            } __attribute__((packed)) INFO_WLAN_INFO_WRITE_REQ_STR;
#define SIZE_INFO_WLAN_INFO_WRITE_REQ                         sizeof(INFO_WLAN_INFO_WRITE_REQ_STR)


//Definition for struct INFO_WLAN_INFO_WRITE_RESP
#define INFO_WLAN_INFO_WRITE_RESP                             0x28                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      status;
            } __attribute__((packed)) INFO_WLAN_INFO_WRITE_RESP_STR;
#define SIZE_INFO_WLAN_INFO_WRITE_RESP                        sizeof(INFO_WLAN_INFO_WRITE_RESP_STR)


//Definition for struct INFO_PRODUCT_RAT_BAND_READ_REQ
#define INFO_PRODUCT_RAT_BAND_READ_REQ                        0x2E                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint16_t     fillerbyte1;
            } __attribute__((packed)) INFO_PRODUCT_RAT_BAND_READ_REQ_STR;
#define SIZE_INFO_PRODUCT_RAT_BAND_READ_REQ                   sizeof(INFO_PRODUCT_RAT_BAND_READ_REQ_STR)


//Definition for struct INFO_PRODUCT_RAT_BAND_READ_RESP
#define INFO_PRODUCT_RAT_BAND_READ_RESP                       0x2F                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      sb_cnt;
            } __attribute__((packed)) INFO_PRODUCT_RAT_BAND_READ_RESP_STR;
#define SIZE_INFO_PRODUCT_RAT_BAND_READ_RESP                  sizeof(INFO_PRODUCT_RAT_BAND_READ_RESP_STR)


//Definition for struct INFO_PRODUCT_RAT_BAND_WRITE_REQ
#define INFO_PRODUCT_RAT_BAND_WRITE_REQ                       0x30                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint16_t     fillerbyte1;
            } __attribute__((packed)) INFO_PRODUCT_RAT_BAND_WRITE_REQ_STR;
#define SIZE_INFO_PRODUCT_RAT_BAND_WRITE_REQ                  sizeof(INFO_PRODUCT_RAT_BAND_WRITE_REQ_STR)


//Definition for struct INFO_PRODUCT_RAT_BAND_WRITE_RESP
#define INFO_PRODUCT_RAT_BAND_WRITE_RESP                      0x31                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      status;
            } __attribute__((packed)) INFO_PRODUCT_RAT_BAND_WRITE_RESP_STR;
#define SIZE_INFO_PRODUCT_RAT_BAND_WRITE_RESP                 sizeof(INFO_PRODUCT_RAT_BAND_WRITE_RESP_STR)

#endif
