#ifndef _PN_PHONE_INFO_SHARED_ISI_H_
#define _PN_PHONE_INFO_SHARED_ISI_H_

#include <stdint.h> 

//Resource INFO server shared definitions
//PN_PHONE_INFO 0x1B 
//ISI version 008.005
#define INFO_SERVER_SHARED_DEFINITIONS_ISI_VERSION_Z     8
#define INFO_SERVER_SHARED_DEFINITIONS_ISI_VERSION_Y     5

//In case of problems concerning content of this file contact Markku Loukusa, Sauli Laukka or Markus Mrsky
//Server specific message descriptions and feature&protocol descriptions can be found from: https://oucmswww.nmp.nokia.com:58443/document_browser/ccm_wa/GIF_SPECS/ 


//ISI VERSION CHANGE HISTORY

//Version: 008.005                                           
//Status: NonDraft                                          
//Date: 27-Jan-2009     Olli Porola
//Reason: SUB
//Reference: 417-31612, 417-30624, NON-DRAFT

//Version: 008.004                                           
//Status: NonDraft                                          
//Date: 31-Oct-2008     Olli Porola
//Reason: SUB
//Reference: PTSW INFO: BCOM B1: BOM Detection, NON-DRAFT

//Version: 008.003                                           
//Status: NonDraft                                          
//Date: 17-Mar-2008     Winfried Gamroth
//Reason: RM-RIM 010-30180
//Reference: ADB for SWAM WG08031741277, NON-DRAFT

//Version: 008.002                                           
//Status: NonDraft                                          
//Date: 14-Feb-2008     Winfried Gamroth
//Reason: RM-RIM 010-28684
//Reference: ADB for SWAM WG08021342778, NON-DRAFT

//Version: 008.001                                           
//Status: NonDraft                                          
//Date: 14-Nov-2007     Zoran Stevanovic
//Reason: RM-RIM 414-2275, 414-3045
//Reference: ADB for SWAM ZS07111540118., NON-DRAFT

//Version: 008.000                                           
//Status: NonDraft                                          
//Date: 11-Sep-2007     Zoran Stevanovic
//Reason: RM-RIM 404-2088
//Reference: ADB for SWAM ZS07091145641., NON-DRAFT

//Version: 007.000                                           
//Status: NonDraft                                          
//Date: 03-Apr-2007     Zoran Stevanovic
//Reason: RM-RIM 407-6
//Reference: ADB for SWAM ZS07040438377., NON-DRAFT

//Version: 006.001                                           
//Status: NonDraft                                          
//Date: 28-Feb-2007     Mika Halttunen
//Reason: SCO / inspection
//Reference: LN WP-PT-MS RM-RIM 010-33211, LN SWAM ADB MH07022841663., NON-DRAFT

//Version: 006.000                                           
//Status: NonDraft                                          
//Date: 16-Oct-2006     Mika Halttunen
//Reason: SCO
//Reference: see info_isi_m.h v006.000, NON-DRAFT

//Version: 005.013                                           
//Status: NonDraft                                          
//Date: 12-Oct-2006     Mika Halttunen
//Reason: Inspection
//Reference: LN ADB SWAM MH06100244863, NON-DRAFT

//Version: 005.012                                           
//Status: NonDraft                                          
//Date: 02-Oct-2006     Mika Halttunen
//Reason: SCO
//Reference: see info_isi_m.h v005.012, NON-DRAFT

//Version: 005.011                                           
//Status: NonDraft                                          
//Date: 30-Aug-2006     Mika Halttunen
//Reason: SCO
//Reference: see info_isi_m.h v005.011, NON-DRAFT

//Version: 005.010                                           
//Status: NonDraft                                          
//Date: 28-Jun-2006     Mika Halttunen
//Reason: SCO
//Reference: see info_isi_m.h v005.010, NON-DRAFT

//Version: 005.009                                           
//Status: NonDraft                                          
//Date: 19-May-2006     Mika Halttunen
//Reason: Error
//Reference: see info_isi_m.h v005.009, NON-DRAFT

//Version: 005.008                                           
//Status: NonDraft                                          
//Date: 18-Apr-2006     Mika Halttunen
//Reason: SCO
//Reference: see info_isi_m.h v005.008, NON-DRAFT

//Version: 005.007                                           
//Status: NonDraft                                          
//Date: 28-Feb-2006     Juho Heikkila
//Reason: SCO
//Reference: see info_isi_m.h v005.007, NON-DRAFT

//Version: 005.005                                           
//Status: NonDraft                                          
//Date: 20-Jan-2006     Mika Halttunen
//Reason: SCO
//Reference: see info_isi_m.h v005.005, NON-DRAFT

//Version: 005.004                                           
//Status: NonDraft                                          
//Date: 02-Nov-2005     Mika Halttunen
//Reason: SCO
//Reference: see info_isi_m.h v005.004, NON-DRAFT

//Version: 005.003                                           
//Status: NonDraft                                          
//Date: 24-Oct-2005     Mika Halttunen
//Reason: SCO
//Reference: see info_isi_m.h v005.003, NON-DRAFT

//Version: 005.002                                           
//Status: NonDraft                                          
//Date: 14-Oct-2005     Mika Halttunen
//Reason: Inspection
//Reference: LN ADB SWAM MH05101255652, WP RM-RIM 009-21354, NON-DRAFT

//Version: 005.001                                           
//Status: NonDraft                                          
//Date: 14-Oct-2005     Mika Halttunen
//Reason: Inspection, comments
//Reference: LN ADB SWAM MH05100540860, MH05100746980, KM05101145470, WP-PT-MS RM-RIM 009-20651, NON-DRAFT

//Version: 004.003                                           
//Status: Unknown                                           
//Date: -               -
//Reason: -
//Reference: -

//Version: 001.000                                           
//Status: Unknown                                           
//Date: -               -
//Reason: -
//Reference: -


//CONSTANTS
#define INFO_BAND_ID_TABLE_MAX_CNT                            0x20                                                  
#define INFO_SB_SN_IMEI_SV_TO_NET_STR_LEN                     0x09                                                     
#define INFO_ANY_SIZE                                         1                                                     
#define INFO_SB_APE_HW_VER_LEN                                0x05                                                     
#define INFO_SB_APE_ADSP_VER_LEN                              0x05                                                     


//TABLES

//ConstantTable for INFO_BAND_POS
#define INFO_GSM_POS                                          0x00                                                     
#define INFO_WCDMA_POS                                        0x01                                                     
#define INFO_WCDMA_RX_DIV_POS                                 0x02                                                     
#define INFO_EUTRAN_POS                                       0x03                                                     

//BitmaskTables for INFO_RAT_ID
#define INFO_NO_RAT                                           0x00000000                                                     
#define INFO_RAT_GSM                                          0x00000001                                                     
#define INFO_RAT_WCDMA                                        0x00000002                                                     
#define INFO_RAT_WCDMA_RX_DIV                                 0x00000004                                                     
#define INFO_RAT_EUTRAN                                       0x00000008                                                     

//BitmaskTables for INFO_GSM_BAND
#define INFO_NO_GSM                                           0x00000000                                                     
#define INFO_GSM850                                           0x00000001                                                     
#define INFO_GSM900                                           0x00000002                                                     
#define INFO_GSM1800                                          0x00000004                                                     
#define INFO_GSM1900                                          0x00000008                                                     

//BitmaskTables for INFO_WCDMA_BAND
#define INFO_NO_WCDMA                                         0x00000000                                                     
#define INFO_WCDMA_FDD_BAND1                                  0x00000001                                                     
#define INFO_WCDMA_FDD_BAND2                                  0x00000002                                                     
#define INFO_WCDMA_FDD_BAND3                                  0x00000004                                                     
#define INFO_WCDMA_FDD_BAND4                                  0x00000008                                                     
#define INFO_WCDMA_FDD_BAND5                                  0x00000010                                                  
#define INFO_WCDMA_FDD_BAND6                                  0x00000020                                                  
#define INFO_WCDMA_FDD_BAND7                                  0x00000040                                                  
#define INFO_WCDMA_FDD_BAND8                                  0x00000080                                                  
#define INFO_WCDMA_FDD_BAND9                                  0x00000100                                                   
#define INFO_WCDMA_FDD_BAND10                                 0x00000200                                                   
#define INFO_WCDMA_FDD_BAND11                                 0x00000400                                                   
#define INFO_WCDMA_FDD_BAND12                                 0x00000800                                                   
#define INFO_WCDMA_FDD_BAND13                                 0x00001000                                                  
#define INFO_WCDMA_FDD_BAND14                                 0x00002000                                                  
#define INFO_WCDMA_FDD_BAND15                                 0x00004000                                                  
#define INFO_WCDMA_FDD_BAND16                                 0x00008000                                                  
#define INFO_WCDMA_FDD_BAND17                                 0x00010000                                                 
#define INFO_WCDMA_FDD_BAND18                                 0x00020000                                                 
#define INFO_WCDMA_FDD_BAND19                                 0x00040000                                                 
#define INFO_WCDMA_FDD_BAND20                                 0x00080000                                                 
#define INFO_WCDMA_FDD_BAND21                                 0x00100000                                                
#define INFO_WCDMA_FDD_BAND22                                 0x00200000                                                
#define INFO_WCDMA_FDD_BAND23                                 0x00400000                                                
#define INFO_WCDMA_FDD_BAND24                                 0x00800000                                                
#define INFO_WCDMA_FDD_BAND25                                 0x01000000                                               
#define INFO_WCDMA_FDD_BAND26                                 0x02000000                                               
#define INFO_WCDMA_FDD_BAND27                                 0x04000000                                               
#define INFO_WCDMA_FDD_BAND28                                 0x08000000                                               
#define INFO_WCDMA_FDD_BAND29                                 0x10000000                                            
#define INFO_WCDMA_FDD_BAND30                                 0x20000000                                            
#define INFO_WCDMA_FDD_BAND31                                 0x40000000                                            
#define INFO_WCDMA_FDD_BAND32                                 0x80000000                                            

//BitmaskTables for INFO_WCDMA_RX_DIV_BAND
#define INFO_NO_WCDMA_RX_DIV                                  0x00000000                                                     
#define INFO_WCDMA_RX_DIV_FDD_BAND1                           0x00000001                                                     
#define INFO_WCDMA_RX_DIV_FDD_BAND2                           0x00000002                                                     
#define INFO_WCDMA_RX_DIV_FDD_BAND3                           0x00000004                                                     
#define INFO_WCDMA_RX_DIV_FDD_BAND4                           0x00000008                                                     
#define INFO_WCDMA_RX_DIV_FDD_BAND5                           0x00000010                                                  
#define INFO_WCDMA_RX_DIV_FDD_BAND6                           0x00000020                                                  
#define INFO_WCDMA_RX_DIV_FDD_BAND7                           0x00000040                                                  
#define INFO_WCDMA_RX_DIV_FDD_BAND8                           0x00000080                                                  
#define INFO_WCDMA_RX_DIV_FDD_BAND9                           0x00000100                                                   
#define INFO_WCDMA_RX_DIV_FDD_BAND10                          0x00000200                                                   
#define INFO_WCDMA_RX_DIV_FDD_BAND11                          0x00000400                                                   
#define INFO_WCDMA_RX_DIV_FDD_BAND12                          0x00000800                                                   
#define INFO_WCDMA_RX_DIV_FDD_BAND13                          0x00001000                                                  
#define INFO_WCDMA_RX_DIV_FDD_BAND14                          0x00002000                                                  
#define INFO_WCDMA_RX_DIV_FDD_BAND15                          0x00004000                                                  
#define INFO_WCDMA_RX_DIV_FDD_BAND16                          0x00008000                                                  
#define INFO_WCDMA_RX_DIV_FDD_BAND17                          0x00010000                                                 
#define INFO_WCDMA_RX_DIV_FDD_BAND18                          0x00020000                                                 
#define INFO_WCDMA_RX_DIV_FDD_BAND19                          0x00040000                                                 
#define INFO_WCDMA_RX_DIV_FDD_BAND20                          0x00080000                                                 
#define INFO_WCDMA_RX_DIV_FDD_BAND21                          0x00100000                                                
#define INFO_WCDMA_RX_DIV_FDD_BAND22                          0x00200000                                                
#define INFO_WCDMA_RX_DIV_FDD_BAND23                          0x00400000                                                
#define INFO_WCDMA_RX_DIV_FDD_BAND24                          0x00800000                                                
#define INFO_WCDMA_RX_DIV_FDD_BAND25                          0x01000000                                               
#define INFO_WCDMA_RX_DIV_FDD_BAND26                          0x02000000                                               
#define INFO_WCDMA_RX_DIV_FDD_BAND27                          0x04000000                                               
#define INFO_WCDMA_RX_DIV_FDD_BAND28                          0x08000000                                               
#define INFO_WCDMA_RX_DIV_FDD_BAND29                          0x10000000                                            
#define INFO_WCDMA_RX_DIV_FDD_BAND30                          0x20000000                                            
#define INFO_WCDMA_RX_DIV_FDD_BAND31                          0x40000000                                            
#define INFO_WCDMA_RX_DIV_FDD_BAND32                          0x80000000                                            

//BitmaskTables for INFO_EUTRAN_BAND
#define INFO_NO_EUTRAN                                        0x00000000                                                     
#define INFO_EUTRAN_BAND1                                     0x00000001                                                     
#define INFO_EUTRAN_BAND2                                     0x00000002                                                     
#define INFO_EUTRAN_BAND3                                     0x00000004                                                     
#define INFO_EUTRAN_BAND4                                     0x00000008                                                     
#define INFO_EUTRAN_BAND5                                     0x00000010                                                  
#define INFO_EUTRAN_BAND6                                     0x00000020                                                  
#define INFO_EUTRAN_BAND7                                     0x00000040                                                  
#define INFO_EUTRAN_BAND8                                     0x00000080                                                  
#define INFO_EUTRAN_BAND9                                     0x00000100                                                   
#define INFO_EUTRAN_BAND10                                    0x00000200                                                   
#define INFO_EUTRAN_BAND11                                    0x00000400                                                   
#define INFO_EUTRAN_BAND12                                    0x00000800                                                   
#define INFO_EUTRAN_BAND13                                    0x00001000                                                  
#define INFO_EUTRAN_BAND14                                    0x00002000                                                  
#define INFO_EUTRAN_BAND15                                    0x00004000                                                  
#define INFO_EUTRAN_BAND16                                    0x00008000                                                  
#define INFO_EUTRAN_BAND17                                    0x00010000                                                 
#define INFO_EUTRAN_BAND18                                    0x00020000                                                 
#define INFO_EUTRAN_BAND19                                    0x00040000                                                 
#define INFO_EUTRAN_BAND20                                    0x00080000                                                 
#define INFO_EUTRAN_BAND21                                    0x00100000                                                
#define INFO_EUTRAN_BAND22                                    0x00200000                                                
#define INFO_EUTRAN_BAND23                                    0x00400000                                                
#define INFO_EUTRAN_BAND24                                    0x00800000                                                
#define INFO_EUTRAN_BAND25                                    0x01000000                                               
#define INFO_EUTRAN_BAND26                                    0x02000000                                               
#define INFO_EUTRAN_BAND27                                    0x04000000                                               
#define INFO_EUTRAN_BAND28                                    0x08000000                                               
#define INFO_EUTRAN_BAND29                                    0x10000000                                            
#define INFO_EUTRAN_BAND30                                    0x20000000                                            
#define INFO_EUTRAN_BAND31                                    0x40000000                                            
#define INFO_EUTRAN_BAND32                                    0x80000000                                            

//ConstantTable for INFO_CONTENT_LOCATION
#define UDA_APE                                               0x01                                                     
#define HDD_APE                                               0x02                                                     
#define MC_APE                                                0x04                                                     

//ConstantTable for INFO_ROFS_ID
#define INFO_APE_ROFS_VARIANT1                                0x01                                                     
#define INFO_APE_ROFS_VARIANT2                                0x02                                                     
#define INFO_APE_ROFS_VARIANT3                                0x03                                                     
#define INFO_APE_ROFS_VARIANT4                                0x04                                                     
#define INFO_APE_ROFS_VARIANT5                                0x05                                                     
#define INFO_APE_ROFS_VARIANT6                                0x06                                                     


//SUBBLOCKS


//Definition for struct INFO_SB_RAT_BAND_INFO
#define INFO_SB_RAT_BAND_INFO                                 0xF000                                                
typedef struct
            { 
             uint16_t     sb_id;
             uint8_t      sb_len;
             uint8_t      fillerbyte1;
             uint32_t     rats;
             uint8_t      bands[128];
            } __attribute__((packed)) INFO_SB_RAT_BAND_INFO_STR;
#define SIZE_INFO_SB_RAT_BAND_INFO                            sizeof(INFO_SB_RAT_BAND_INFO_STR)


//Definition for struct INFO_SB_SN_IMEI_SV_TO_NET
#define INFO_SB_SN_IMEI_SV_TO_NET                             0x43                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      fillerbyte1;
             uint8_t      str_len;
             uint8_t      imei_sv_u8[9];
             uint8_t      fillerbyte2[3];
            } __attribute__((packed)) INFO_SB_SN_IMEI_SV_TO_NET_STR;
#define SIZE_INFO_SB_SN_IMEI_SV_TO_NET                        sizeof(INFO_SB_SN_IMEI_SV_TO_NET_STR)


//Definition for struct INFO_SB_LCD_VERSION
#define INFO_SB_LCD_VERSION                                   0x57                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      fillerbyte1;
             uint8_t      str_len;
             uint8_t      lcd_versn_str_c8[0];
            } __attribute__((packed)) INFO_SB_LCD_VERSION_STR;
#define SIZE_INFO_SB_LCD_VERSION                              sizeof(INFO_SB_LCD_VERSION_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct INFO_SB_FLIP_MCUSW_VERSION
#define INFO_SB_FLIP_MCUSW_VERSION                            0x62                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      fillerbyte1;
             uint8_t      str_len;
             uint8_t      mcusw_versn_c8[0];
            } __attribute__((packed)) INFO_SB_FLIP_MCUSW_VERSION_STR;
#define SIZE_INFO_SB_FLIP_MCUSW_VERSION                       sizeof(INFO_SB_FLIP_MCUSW_VERSION_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct INFO_SB_BOOTCODE_VER
#define INFO_SB_BOOTCODE_VER                                  0x68                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      fillerbyte1;
             uint8_t      str_len;
             uint8_t      image_ver[0];
            } __attribute__((packed)) INFO_SB_BOOTCODE_VER_STR;
#define SIZE_INFO_SB_BOOTCODE_VER                             sizeof(INFO_SB_BOOTCODE_VER_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct INFO_SB_APE_SW_CORE_VER
#define INFO_SB_APE_SW_CORE_VER                               0x69                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      fillerbyte1;
             uint8_t      str_len;
             uint8_t      image_ver[0];
            } __attribute__((packed)) INFO_SB_APE_SW_CORE_VER_STR;
#define SIZE_INFO_SB_APE_SW_CORE_VER                          sizeof(INFO_SB_APE_SW_CORE_VER_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct INFO_SB_VARIANT_VER
#define INFO_SB_VARIANT_VER                                   0x6A                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      fillerbyte1;
             uint8_t      str_len;
             uint8_t      image_ver[0];
            } __attribute__((packed)) INFO_SB_VARIANT_VER_STR;
#define SIZE_INFO_SB_VARIANT_VER                              sizeof(INFO_SB_VARIANT_VER_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct INFO_SB_APE_TEST_VER
#define INFO_SB_APE_TEST_VER                                  0x6B                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      fillerbyte1;
             uint8_t      str_len;
             uint8_t      image_ver[0];
            } __attribute__((packed)) INFO_SB_APE_TEST_VER_STR;
#define SIZE_INFO_SB_APE_TEST_VER                             sizeof(INFO_SB_APE_TEST_VER_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct INFO_SB_APE_HW_VERSION
#define INFO_SB_APE_HW_VERSION                                0x6E                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      fillerbyte1;
             uint8_t      str_len;
             uint8_t      ape_hw_version[0];
            } __attribute__((packed)) INFO_SB_APE_HW_VERSION_STR;
#define SIZE_INFO_SB_APE_HW_VERSION                           sizeof(INFO_SB_APE_HW_VERSION_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct INFO_SB_APE_ADSP_SW
#define INFO_SB_APE_ADSP_SW                                   0x6F                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      fillerbyte1;
             uint8_t      str_len;
             uint8_t      sw_version[0];
            } __attribute__((packed)) INFO_SB_APE_ADSP_SW_STR;
#define SIZE_INFO_SB_APE_ADSP_SW                              sizeof(INFO_SB_APE_ADSP_SW_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct INFO_SB_CAMERA_VER
#define INFO_SB_CAMERA_VER                                    0x70                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      fillerbyte1;
             uint8_t      str_len;
             uint8_t      camera_ver[0];
            } __attribute__((packed)) INFO_SB_CAMERA_VER_STR;
#define SIZE_INFO_SB_CAMERA_VER                               sizeof(INFO_SB_CAMERA_VER_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct INFO_SB_CAMERA_DETAILED_VERSION_INFO
#define INFO_SB_CAMERA_DETAILED_VERSION_INFO                  0x75                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      made_by;
             uint8_t      version;
             uint16_t     model;
             uint8_t      fillerbyte1[6];
            } __attribute__((packed)) INFO_SB_CAMERA_DETAILED_VERSION_INFO_STR;
#define SIZE_INFO_SB_CAMERA_DETAILED_VERSION_INFO             sizeof(INFO_SB_CAMERA_DETAILED_VERSION_INFO_STR)


//Definition for struct INFO_SB_APE_BT_VERSION
#define INFO_SB_APE_BT_VERSION                                0x71                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      fillerbyte1;
             uint8_t      str_len;
             uint8_t      bt_version[0];
            } __attribute__((packed)) INFO_SB_APE_BT_VERSION_STR;
#define SIZE_INFO_SB_APE_BT_VERSION                           sizeof(INFO_SB_APE_BT_VERSION_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct INFO_SB_CONTENT_PACK_VER
#define INFO_SB_CONTENT_PACK_VER                              0x72                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      fillerbyte1;
             uint8_t      str_len;
             uint8_t      package_ver[0];
            } __attribute__((packed)) INFO_SB_CONTENT_PACK_VER_STR;
#define SIZE_INFO_SB_CONTENT_PACK_VER                         sizeof(INFO_SB_CONTENT_PACK_VER_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct INFO_SB_APE_CUI_LCD_VERSION
#define INFO_SB_APE_CUI_LCD_VERSION                           0x9F                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      fillerbyte1;
             uint8_t      version_string_len;
             uint8_t      version_string[0];
            } __attribute__((packed)) INFO_SB_APE_CUI_LCD_VERSION_STR;
#define SIZE_INFO_SB_APE_CUI_LCD_VERSION                      sizeof(INFO_SB_APE_CUI_LCD_VERSION_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct INFO_SB_APE_IPDC_VERSION
#define INFO_SB_APE_IPDC_VERSION                              0xA1                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      fillerbyte1;
             uint8_t      version_string_len;
             uint8_t      version_string[0];
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
             uint8_t      fillerbyte4;
            } __attribute__((packed)) INFO_SB_APE_IPDC_VERSION_STR;
#define SIZE_INFO_SB_APE_IPDC_VERSION                         sizeof(INFO_SB_APE_IPDC_VERSION_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct INFO_SB_APE_DVB_H_RX_HW_VER
#define INFO_SB_APE_DVB_H_RX_HW_VER                           0xA2                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint16_t     fillerbyte1;
             uint32_t     dvbh_rx_hw_ver;
            } __attribute__((packed)) INFO_SB_APE_DVB_H_RX_HW_VER_STR;
#define SIZE_INFO_SB_APE_DVB_H_RX_HW_VER                      sizeof(INFO_SB_APE_DVB_H_RX_HW_VER_STR)


//Definition for struct INFO_SB_APE_DVB_H_RX_SW_VER
#define INFO_SB_APE_DVB_H_RX_SW_VER                           0xA3                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint16_t     fillerbyte1;
             uint32_t     dvbh_rx_sw_ver;
            } __attribute__((packed)) INFO_SB_APE_DVB_H_RX_SW_VER_STR;
#define SIZE_INFO_SB_APE_DVB_H_RX_SW_VER                      sizeof(INFO_SB_APE_DVB_H_RX_SW_VER_STR)


//Definition for struct INFO_SB_APE_DVB_H_RX_BOOTLOADER_VER
#define INFO_SB_APE_DVB_H_RX_BOOTLOADER_VER                   0xA4                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint16_t     fillerbyte1;
             uint32_t     dvbh_rx_bootl_ver;
            } __attribute__((packed)) INFO_SB_APE_DVB_H_RX_BOOTLOADER_VER_STR;
#define SIZE_INFO_SB_APE_DVB_H_RX_BOOTLOADER_VER              sizeof(INFO_SB_APE_DVB_H_RX_BOOTLOADER_VER_STR)


//Definition for struct INFO_SB_CONTENT_VERSIONS
#define INFO_SB_CONTENT_VERSIONS                              0xA5                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint16_t     location;
             uint8_t      length;
             uint8_t      cont_ver[0];
            } __attribute__((packed)) INFO_SB_CONTENT_VERSIONS_STR;
#define SIZE_INFO_SB_CONTENT_VERSIONS                         sizeof(INFO_SB_CONTENT_VERSIONS_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct INFO_SB_ROFS_VERSION
#define INFO_SB_ROFS_VERSION                                  0xA6                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint16_t     rofs_id;
             uint8_t      fillerbyte1;
             uint8_t      length;
             uint8_t      rofs_ver[0];
            } __attribute__((packed)) INFO_SB_ROFS_VERSION_STR;
#define SIZE_INFO_SB_ROFS_VERSION                             sizeof(INFO_SB_ROFS_VERSION_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct INFO_SB_NAVISCROLL_VERSION
#define INFO_SB_NAVISCROLL_VERSION                            0xA7                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      driver_manufacturer_id;
             uint8_t      driver_branch_id;
             uint8_t      driver_release_year;
             uint8_t      driver_release_week;
             uint8_t      driver_release_subver;
             uint8_t      expected_chip_manufacturer;
             uint8_t      expected_chip_id;
             uint8_t      expected_chip_sw_ver_major;
             uint8_t      expected_chip_sw_ver_minor;
             uint8_t      chip_manufacturer;
             uint8_t      chip_id;
             uint8_t      chip_sw_ver_major;
             uint8_t      chip_sw_ver_minor;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) INFO_SB_NAVISCROLL_VERSION_STR;
#define SIZE_INFO_SB_NAVISCROLL_VERSION                       sizeof(INFO_SB_NAVISCROLL_VERSION_STR)


//Definition for struct INFO_SB_ACCELEROMETER_VERSION
#define INFO_SB_ACCELEROMETER_VERSION                         0xA8                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      major;
             uint8_t      minor;
             uint32_t     vendor_id;
             uint16_t     build;
             uint16_t     fillerbyte1;
            } __attribute__((packed)) INFO_SB_ACCELEROMETER_VERSION_STR;
#define SIZE_INFO_SB_ACCELEROMETER_VERSION                    sizeof(INFO_SB_ACCELEROMETER_VERSION_STR)

#endif
