#ifndef _PN_RTP_ISI_H_
#define _PN_RTP_ISI_H_

#include <stdint.h> 

//Resource RTP Server
//PN_RTP 0x74 
//ISI version 024.003
#define RTP_SERVER_ISI_VERSION_Z     24
#define RTP_SERVER_ISI_VERSION_Y     3

//In case of problems concerning content of this file contact Markku Loukusa, Sauli Laukka or Markus Mrsky
//Server specific message descriptions and feature&protocol descriptions can be found from: https://oucmswww.nmp.nokia.com:58443/document_browser/ccm_wa/GIF_SPECS/ 


//ISI VERSION CHANGE HISTORY

//Version: 024.003                                           
//Status: Approved                                          
//Date: 07-May-2008     Vesa Kokko
//Reason: Approved in the inspection
//Reference: ActionDB for SWAM / SW_ARCH / ISI-SPEC APPS&MIDDLEWARE (ID:VK08042257094), APPROVED

//Version: 024.002                                           
//Status: Proposal                                          
//Date: 17-Apr-2008     Vesa Kokko
//Reason: Proposal for RTP ISI interface 024.002 inspection
//Reference: CR: ADB for SWAM / INTERFACE / ISImessage_S40UI / (ID: VK08041432357), CR: ADB for SWAM / INTERFACE / ISImessage_S40UI / (ID: VK08041432026), PROPOSAL

//Version: 024.001                                           
//Status: Approved                                          
//Date: 18-Dec-2007     Vesa Kokko
//Reason: Approved in the inspection
//Reference: ActionDB for SWAM / SW_ARCH / ISI-SPEC PROTOCOLS (ID:VK07121148444), APPROVED

//Version: 024.000                                           
//Status: Proposal                                          
//Date: 12-Dec-2007     Vesa Kokko
//Reason: Proposal for RTP ISI interface 024.000 inspection
//Reference: CR: ADB for SWAM / INTERFACE / ISImessage_Protocol / (ID: VK07113047953), CR: ADB for SWAM / INTERFACE / ISImessage_Protocol / (ID: VK07113051089), CR: ADB for SWAM / INTERFACE / ISImessage_Protocol / (ID: VK07113055748), CR: ADB for SWAM / INTERFACE / ISImessage_Protocol / (ID: VK07120357204), CR: ADB for SWAM / INTERFACE / ISImessage_Protocol / (ID: VK07120556762), PROPOSAL

//Version: 023.001                                           
//Status: Approved                                          
//Date: 10-Oct-2007     Vesa Kokko
//Reason: Approved in the inspection
//Reference: ActionDB for SWAM / SW_ARCH / ISI-SPEC PROTOCOLS (ID:VK07092554072), APPROVED

//Version: 023.000                                           
//Status: Proposal                                          
//Date: 10-Sep-2007     Vesa Kokko
//Reason: Proposal for RTP ISI interface 023.000 inspection
//Reference: CR: ADB for SWAM / INTERFACE / ISImessage_Protocol / (ID: VK07082848908), CR: ADB for SWAM / INTERFACE / ISImessage_Protocol / (ID: VK07082849049), CR: ADB for SWAM / INTERFACE / ISImessage_Protocol / (ID: VK07082849148), CR: ADB for SWAM / INTERFACE / ISImessage_Protocol / (ID: VK07082851165), CR: ADB for SWAM / INTERFACE / ISImessage_Protocol / (ID: VK07082851606), CR: ADB for SWAM / INTERFACE / ISImessage_Protocol / (ID: VK07082851887), CR: ADB for SWAM / INTERFACE / ISImessage_Protocol / (ID: VK07091144632), CR: ADB for SWAM / INTERFACE / ISImessage_Protocol / (ID: VK07092045781), PROPOSAL

//Version: 022.001                                           
//Status: Approved                                          
//Date: 31-Aug-2007     Vesa Kokko
//Reason: Approved in the inspection
//Reference: ActionDB for SWAM / SW_ARCH / ISI-SPEC PROTOCOLS (ID:VK07081648198), APPROVED

//Version: 022.000                                           
//Status: Proposal                                          
//Date: 17-Aug-2007     Vesa Kokko
//Reason: Proposal for RTP ISI interface 022.000 inspection
//Reference: CR: ADB for SWAM / INTERFACE / ISImessage_Protocol / (ID: VK07081646021), CR: ADB for SWAM / INTERFACE / ISImessage_Protocol / (ID: VK07081750143), PROPOSAL

//Version: 021.001                                           
//Status: Approved                                          
//Date: 08-Jun-2007     Vesa Kokko
//Reason: Approved in the inspection
//Reference: ActionDB for SWAM / SW_ARCH / ISI-SPEC PROTOCOLS (ID:VK07052334836), APPROVED

//Version: 021.000                                           
//Status: Proposal                                          
//Date: 23-May-2007     Vesa Kokko
//Reason: Proposal for RTP ISI interface 021.000 inspection
//Reference: CR: ADB for SWAM / INTERFACE / ISImessage_Protocol / (ID: VK07051739758), CR: ADB for SWAM / INTERFACE / ISImessage_Protocol / (ID: VK07051744852), CR: ADB for SWAM / INTERFACE / ISImessage_Protocol / (ID: VK07051745174), CR: ADB for SWAM / INTERFACE / ISImessage_Protocol / (ID: VK07051746810), CR: ADB for SWAM / INTERFACE / ISImessage_Protocol / (ID: VK07051747203), CR: ADB for SWAM / INTERFACE / ISImessage_Protocol / (ID: VK07052261086), PROPOSAL

//Version: 020.001                                           
//Status: Approved                                          
//Date: 19-Apr-2007     Vesa Kokko
//Reason: Approved in the inspection
//Reference: ActionDB for SWAM / SW_ARCH / ISI-SPEC PROTOCOLS (ID:VK07040344183), APPROVED

//Version: 020.000                                           
//Status: Proposal                                          
//Date: 04-Apr-2007     Vesa Kokko
//Reason: Proposal for RTP ISI interface 020.000 inspection
//Reference: CR: ADB for SWAM / INTERFACE / ISImessage_Protocol / (ID: JL07032233253), CR: ADB for SWAM / INTERFACE / ISImessage_Protocol / (ID: JL07032236173), CR: ADB for SWAM / INTERFACE / ISImessage_Protocol / (ID: JL07032236988), CR: ADB for SWAM / INTERFACE / ISImessage_Protocol / (ID: JL07032237560), CR: ADB for SWAM / INTERFACE / ISImessage_Protocol / (ID: VK07032752244), CR: ADB for SWAM / INTERFACE / ISImessage_Protocol / (ID: VK07032751761), CR: ADB for SWAM / INTERFACE / ISImessage_Protocol / (ID: VK07040336722), PROPOSAL

//Version: 019.001                                           
//Status: Approved                                          
//Date: 25-Jan-2007     Vesa Kokko
//Reason: Approved in the inspection
//Reference: ActionDB for SWAM / SW_ARCH / ISI-SPEC PROTOCOLS (ID:VK07011747451), APPROVED

//Version: 019.000                                           
//Status: Proposal                                          
//Date: 18-Jan-2007     Vesa Kokko
//Reason: Proposal for RTP ISI interface 019.000 inspection
//Reference: CR: ADB for SWAM / INTERFACE / ISImessage_Protocol / (ID: VK06121237738), CR: ADB for SWAM / INTERFACE / ISImessage_Protocol / (ID: VK06121435929), CR: ADB for SWAM / INTERFACE / ISImessage_Protocol / (ID: VK06121440895), CR: ADB for SWAM / INTERFACE / ISImessage_Protocol / (ID: VK06121442036), CR: ADB for SWAM / INTERFACE / ISImessage_Protocol / (ID: VK06121442373), PROPOSAL

//Version: 018.003                                           
//Status: Approved                                          
//Date: 24-Oct-2006     Vesa Kokko
//Reason: Approved in inspection
//Reference: ActionDB for SWAM / SW_ARCH / ISI-SPEC PROTOCOLS (ID:VK06101244327), APPROVED

//Version: 018.002                                           
//Status: Proposal                                          
//Date: 06-Oct-2006     Vesa Kokko
//Reason: Proposal for RTP ISI interface 018.002 inspection
//Reference: CR: ADB for SWAM / INTERFACE / ISImessage (ID: VK06100348202), PROPOSAL

//Version: 018.001                                           
//Status: Approved                                          
//Date: 16-Aug-2006     Vesa Kokko
//Reason: Approved in inspection
//Reference: ActionDB for SWAM / SW_ARCH / ISI-SPEC PROTOCOLS (ID:VK06080457590), APPROVED

//Version: 018.000                                           
//Status: Proposal                                          
//Date: 08-Aug-2006     Vesa Kokko
//Reason: Proposal for RTP ISI interface 018.000 inspection
//Reference: CR: ADB for SWAM / INTERFACE / ISImessage (ID: VK06072641441), CR: ADB for SWAM / INTERFACE / ISImessage (ID: VK06072730364), CR: ADB for SWAM / INTERFACE / ISImessage (ID: VK06072730529), PROPOSAL

//Version: 017.001                                           
//Status: Approved                                          
//Date: 26-Mar-2006     Kristian Lappalainen
//Reason: Approved in inspection
//Reference: ActionDB for SWAM / SW_ARCH / ISI-SPEC PROTOCOLS (ID:KL06030938543), APPROVED

//Version: 017.000                                           
//Status: Proposal                                          
//Date: 9-Mar-2006      Kristian Lappalainen
//Reason: Proposal for RTP ISI interface 017.000 inspection
//Reference: CR: ADB for SWAM / INTERFACE / ISImessage (ID: KL06022037310), PROPOSAL

//Version: 016.007                                           
//Status: Approved                                          
//Date: 13-Feb-2006     Kristian Lappalainen
//Reason: Approved in inspection
//Reference: ActionDB for SWAM / SW_ARCH / ISI-SPEC PROTOCOLS (ID:KL06020615459), APPROVED

//Version: 016.006                                           
//Status: Proposal                                          
//Date: 6-Feb-2006      Kristian Lappalainen
//Reason: Proposal for RTP ISI interface 016.006 inspection
//Reference: CR: ADB for SWAM / INTERFACE / ISImessage (ID: KL0601312011), PROPOSAL

//Version: 016.005                                           
//Status: Approved                                          
//Date: 29-Jan-2006     Kristian Lappalainen
//Reason: Approved in inspection
//Reference: ActionDB for SWAM / SW_ARCH / ISI-SPEC PROTOCOLS (ID:KL06011969147), APPROVED

//Version: 016.004                                           
//Status: Proposal                                          
//Date: 19-Jan-2006     Kristian Lappalainen
//Reason: Proposal for RTP ISI interface 016.004 inspection
//Reference: CR: ADB for SWAM / INTERFACE / ISImessage (ID: KL06010953949), PROPOSAL

//Version: 016.003                                           
//Status: Approved                                          
//Date: 17-Oct-2005     Kristian Lappalainen
//Reason: Approved in inspection
//Reference: ActionDB for SWAM / SW_ARCH / ISI-SPEC PROTOCOLS (ID:KL05101247575), APPROVED

//Version: 016.002                                           
//Status: Proposal                                          
//Date: 12-Oct-2005     Kristian Lappalainen
//Reason: Proposal for RTP ISI interface 016.002 inspection
//Reference: CR: ADB for SWAM / INTERFACE / ISImessage (ID: KL05101034833), PROPOSAL

//Version: 016.001                                           
//Status: Approved                                          
//Date: 29-Aug-2005     Kristian Lappalainen
//Reason: Approved in inspection
//Reference: ActionDB for SWAM / SW_ARCH / ISI-SPEC PROTOCOLS (ID:KL05082338268), APPROVED

//Version: 016.000                                           
//Status: Proposal                                          
//Date: 22-Aug-2005     Kristian Lappalainen
//Reason: Proposal for RTP ISI interface 016.000 inspection
//Reference: CR: ADB for SWAM / INTERFACE / ISImessage (ID: KL05080835702), CR: ADB for SWAM / INTERFACE / ISImessage (ID: KL05080840848), PROPOSAL

//Version: 015.003                                           
//Status: Approved                                          
//Date: 2-Aug-2005      Kristian Lappalainen
//Reason: Approved in inspection
//Reference: ActionDB for SWAM / SW_ARCH / ISI-SPEC PROTOCOLS (ID:KL05072952543), APPROVED

//Version: 015.002                                           
//Status: Proposal                                          
//Date: 29-Jul-2005     Kristian Lappalainen
//Reason: Proposal for RTP ISI interface 015.002 inspection
//Reference: CR: ADB for SWAM / INTERFACE / ISImessage (ID: KL05052337351), PROPOSAL

//Version: 015.001                                           
//Status: Approved                                          
//Date: 12-Jul-2005     Kristian Lappalainen
//Reason: Approved in inspection
//Reference: ActionDB for SWAM / SW_ARCH / ISI-SPEC PROTOCOLS (ID:KL05052727572), APPROVED

//Version: 015.000                                           
//Status: Proposal                                          
//Date: 27-May-2005     Kristian Lappalainen
//Reason: Proposal for RTP ISI interface 015.000 inspection
//Reference: CR: ADB for SWAM / INTERFACE / ISImessage (ID: KL05052327632), CR: ADB for SWAM / INTERFACE / ISImessage (ID: KL05051126690), PROPOSAL

//Version: 014.001                                           
//Status: Approved                                          
//Date: 2-May-2005      Kristian Lappalainen
//Reason: Approved in inspection
//Reference: ActionDB for SWAM / SW_ARCH / ISI-SPEC PROTOCOLS (ID:KL05042033882), APPROVED

//Version: 014.000                                           
//Status: Proposal                                          
//Date: 20-Apr-2005     Kristian Lappalainen
//Reason: Proposal for RTP ISI interface 014.000 inspection
//Reference: CR: ADB for SWAM / INTERFACE / ISImessage (ID: KL05040135366), CR: ADB for SWAM / INTERFACE / ISImessage (ID: KL05040134652), CR: ADB for SWAM / INTERFACE / ISImessage (ID: KL05041544756), PROPOSAL

//Version: 013.001                                           
//Status: Approved                                          
//Date: 8-Mar-2005      Kristian Lappalainen
//Reason: Approved in inspection
//Reference: ActionDB for SWAM / SW_ARCH / ISI-SPEC PROTOCOLS (ID:KL05030161131), APPROVED

//Version: 013.000                                           
//Status: Proposal                                          
//Date: 1-Mar-2005      Kristian Lappalainen
//Reason: Proposal for RTP ISI interface 013.000 inspection
//Reference: CR: ADB for SWAM / INTERFACE / ISImessage (ID: KL05020925970), CR: ADB for SWAM / INTERFACE / ISImessage (ID: KL05021545269), CR: ADB for SWAM / INTERFACE / ISImessage (ID: KL05021760476), CR: ADB for SWAM / INTERFACE / ISImessage (ID: KL05021851367), PROPOSAL

//Version: 012.005                                           
//Status: Approved                                          
//Date: 11-Jan-2005     Kristian Lappalainen
//Reason: Approved in inspection
//Reference: ActionDB for SWAM / SW_ARCH / ISI-SPEC PROTOCOLS (ID:KL05010361989), APPROVED

//Version: 012.004                                           
//Status: Proposal                                          
//Date: 3-Jan-2005      Kristian Lappalainen
//Reason: Proposal for RTP ISI interface 012.004 inspection
//Reference: CR: ADB for SWAM / INTERFACE / ISImessage (ID: KL04121732331), PROPOSAL

//Version: 012.003                                           
//Status: Approved                                          
//Date: 15-Dec-2004     Kristian Lappalainen
//Reason: Approved in inspection
//Reference: ActionDB for SWAM / SW_ARCH / ISI-SPEC PROTOCOLS (ID:KL04120835355), APPROVED

//Version: 012.002                                           
//Status: Proposal                                          
//Date: 8-Dec-2004      Kristian Lappalainen
//Reason: Proposal for RTP ISI interface 012.002 inspection
//Reference: CR: ADB for SWAM / INTERFACE / ISImessage (ID: KL04112926753), PROPOSAL

//Version: 012.001                                           
//Status: Approved                                          
//Date: 19-Nov-2004     Kristian Lappalainen
//Reason: Approved in inspection
//Reference: ActionDB for SWAM / SW_ARCH / ISI-SPEC PROTOCOLS (ID:KL04111560141), APPROVED

//Version: 012.000                                           
//Status: Proposal                                          
//Date: 15-Nov-2004     Kristian Lappalainen
//Reason: Proposal for RTP ISI interface 012.000 inspection
//Reference: CR: ADB for SWAM / INTERFACE / ISImessage (ID: KL04110925398), CR: ADB for SWAM / INTERFACE / ISImessage (ID: KL04110947378), PROPOSAL

//Version: 011.003                                           
//Status: Approved                                          
//Date: 23-Aug-2004     Kristian Lappalainen
//Reason: Approved in inspection
//Reference: ActionDB for SWAM / SW_ARCH / ISI-SPEC PROTOCOLS (ID:KL04081357551), APPROVED

//Version: 011.002                                           
//Status: Proposal                                          
//Date: 13-Aug-2004     Kristian Lappalainen
//Reason: Proposal for RTP ISI interface 011.002 inspection
//Reference: CR: ADB for SWAM / INTERFACE / ISImessage (ID: KL04061831389), CR: ADB for SWAM / INTERFACE / ISImessage (ID: KL04061832836), PROPOSAL

//Version: 011.001                                           
//Status: Approved                                          
//Date: 31-Mar-2004     Kristian Lappalainen
//Reason: Approved in inspection
//Reference: ActionDB for SWAM / SW_ARCH / ISI-SPEC PROTOCOLS (ID:KL04032360815), APPROVED

//Version: 011.000                                           
//Status: Proposal                                          
//Date: 23-Mar-2004     Kristian Lappalainen
//Reason: Proposal for RTP ISI interface 011.000 inspection
//Reference: CR: ADB for SWAM / INTERFACE / ISImessage (ID: KL04031657228), PROPOSAL

//Version: 010.001                                           
//Status: Approved                                          
//Date: 6-Feb-2004      Kristian Lappalainen
//Reason: Approved in inspection
//Reference: ActionDB for SWAM / SW_ARCH / ISI-SPEC PROTOCOLS (ID:KL04012857397), APPROVED

//Version: 010.000                                           
//Status: Proposal                                          
//Date: 28-Jan-2004     Kristian Lappalainen
//Reason: Proposal for RTP ISI interface 010.000 inspection
//Reference: CR: ADB for SWAM / INTERFACE / ISImessage (ID: KL04010431548), CR: ADB for SWAM / INTERFACE / ISImessage (ID: KL04010432741), PROPOSAL

//Version: 009.003                                           
//Status: Approved                                          
//Date: 12-Nov-2003     Kristian Lappalainen
//Reason: Approved in inspection
//Reference: ActionDB for SWAM / SW_ARCH / ISI-SPEC PROTOCOLS (ID:KL03110429526), APPROVED

//Version: 009.002                                           
//Status: Proposal                                          
//Date: 4-Nov-2003      Kristian Lappalainen
//Reason: Proposal for RTP ISI interface 009.002 inspection
//Reference: CR: ADB for SWAM / INTERFACE / ISImessage (ID: KL03102451181), PROPOSAL

//Version: 009.001                                           
//Status: Approved                                          
//Date: 6-Oct-2003      Kristian Lappalainen
//Reason: Approved in inspection
//Reference: ActionDB for SWAM / SW_ARCH / ISI-SPEC PROTOCOLS (ID:KL03092646100), APPROVED

//Version: 009.000                                           
//Status: Proposal                                          
//Date: 26-Sep-2003     Kristian Lappalainen
//Reason: Proposal for RTP ISI interface 009.000 inspection
//Reference: CR: ADB for SWAM / INTERFACE / ISImessage (ID: KL03090345654), CR: ADB for SWAM / INTERFACE / ISImessage (ID: KL03090534700), CR: ADB for SWAM / INTERFACE / ISImessage (ID: KL03090535859), CR: ADB for SWAM / INTERFACE / ISImessage (ID: KL03091543928), CR: ADB for SWAM / INTERFACE / ISImessage (ID: KL03090931560), PROPOSAL

//Version: 008.001                                           
//Status: Approved                                          
//Date: 2-Sep-2003      Kristian Lappalainen
//Reason: Approved in inspection
//Reference: ActionDB for SWAM / SW_ARCH / ISI-SPEC PROTOCOLS (ID:KL03082541504), APPROVED

//Version: 008.000                                           
//Status: Proposal                                          
//Date: 25-Aug-2003     Kristian Lappalainen
//Reason: Proposal for RTP ISI interface 008.000 inspection
//Reference: CR: ADB for SWAM / INTERFACE / ISImessage (ID: KL03082049181), PROPOSAL

//Version: 007.001                                           
//Status: Approved                                          
//Date: 18-Jun-2003     Kristian Lappalainen
//Reason: Approved in inspection
//Reference: ActionDB for SWAM / SW_ARCH / ISI-SPEC PROTOCOLS (ID:KL03060947334), APPROVED

//Version: 007.000                                           
//Status: Proposal                                          
//Date: 9-Jun-2003      Kristian Lappalainen
//Reason: Proposal for RTP ISI interface 007.000 inspection
//Reference: CR: ADB for SWAM / INTERFACE / ISImessage (ID: KL03060236084), CR: ADB for SWAM / INTERFACE / ISImessage (ID: KL03060236215), PROPOSAL

//Version: 006.003                                           
//Status: Approved                                          
//Date: 24-Mar-2003     Kristian Lappalainen
//Reason: Approved in inspection
//Reference: ActionDB for SWAM / SW_ARCH / ISI-SPEC PROTOCOLS (ID:KL03031436275), APPROVED

//Version: 006.002                                           
//Status: Proposal                                          
//Date: 14-Mar-2003     Kristian Lappalainen
//Reason: Proposal for RTP ISI interface 006.002 inspection
//Reference: CR: ADB for SWAM / INTERFACE / ISImessage (ID: KL03022645066), PROPOSAL

//Version: 006.001                                           
//Status: Approved                                          
//Date: 24-Feb-2003     Kristian Lappalainen
//Reason: Approved in inspection
//Reference: ActionDB for SWAM / SW_ARCH / ISI-SPEC PROTOCOLS (ID: KL03021350647), APPROVED

//Version: 006.000                                           
//Status: Proposal                                          
//Date: 13-Feb-2003     Kristian Lappalainen
//Reason: Proposal for RTP ISI interface 006.000 inspection
//Reference: CR: ADB for SWAM / INTERFACE / ISImessage (ID: KL03020448336), PROPOSAL

//Version: 005.001                                           
//Status: Approved                                          
//Date: 8-Jan-2003      Kristian Lappalainen
//Reason: Approved in inspection
//Reference: ActionDB for SWAM / SW_ARCH / ISI-SPEC PROTOCOLS (ID: KL02122751390), APPROVED

//Version: 005.000                                           
//Status: Proposal                                          
//Date: 27-Dec-2002     Kristian Lappalainen
//Reason: Proposal for RTP ISI interface 005.000 inspection
//Reference: CR: ADB for SWAM / INTERFACE / ISImessage (ID: KL02121234963), PROPOSAL

//Version: 004.003                                           
//Status: Approved                                          
//Date: 22-Nov-2002     Kristian Lappalainen
//Reason: Approved in inspection
//Reference: ActionDB for SWAM / SW_ARCH / ISI-SPEC PROTOCOLS (ID: KL02111550446), APPROVED

//Version: 004.002                                           
//Status: Proposal                                          
//Date: 15-Nov-2002     Kristian Lappalainen
//Reason: Proposal for RTP ISI interface 004.002 inspection
//Reference: CR: ADB for SWAM / INTERFACE / ISImessage (ID:KL02110439713 and KL02110438317), PROPOSAL

//Version: 004.001                                           
//Status: Approved                                          
//Date: 29-Aug-2002     Kristian Lappalainen
//Reason: Approved in inspection
//Reference: ActionDB for SWAM / SW_ARCH / ISI-SPEC PROTOCOLS (ID: KL02072530595), APPROVED

//Version: 004.000                                           
//Status: Proposal                                          
//Date: 25-Jul-2002     Kristian Lappalainen
//Reason: First RTP ISI interface version to be handled thru ISI interface process.
//Reference: -

//Version: 003.002                                           
//Status: Draft                                             
//Date: 3-Jun-2002      Kristian Lappalainen
//Reason: 
//Reference: -

//Version: 003.001                                           
//Status: Draft                                             
//Date: 17-Apr-2002     Kristian Lappalainen
//Reason: Due to socket server if 3.2 support.
//Reference: -

//Version: 003.000                                           
//Status: Approved                                          
//Date: 26-Mar-2002     Kristian Lappalainen
//Reason: 
//Reference: Action DB for TEC Software (KL02032042504), APPROVED

//Version: 002.001                                           
//Status: Draft                                             
//Date: 20-Mar-2002     Kristian Lappalainen
//Reason: Updated due to RTP rel 4.2.1 requirements.
//Reference: -

//Version: 002.000                                           
//Status: Approved                                          
//Date: 08-Jan-2002     Kristian Lappalainen
//Reason: 
//Reference: Action DB for TEC Software (KL02010245222), APPROVED

//Version: 001.001                                           
//Status: Draft                                             
//Date: 02-Jan-2002     Kristian Lappalainen
//Reason: Updated due to RTP rel 2.0 requirements.
//Reference: -

//Version: 001.000                                           
//Status: Approved                                          
//Date: 16-Oct-2001     Kristian Lappalainen
//Reason: 
//Reference: Action DB for TP Software (KL01100851036), APPROVED

//Version: 000.004                                           
//Status: Draft                                             
//Date: 08-Oct-2001     Kristian Lappalainen
//Reason: 
//Reference: Action DB for TP Software (KL01100550590)., DRAFT

//Version: 000.003                                           
//Status: Draft                                             
//Date: 04-Oct-2001     Kristian Lappalainen
//Reason: Updated according to the work meeting held Oct-2nd-2001.
//Reference: Minutes from Action DB for TP Software (KL01100232290), DRAFT

//Version: 000.002                                           
//Status: Draft                                             
//Date: 07-Sep-2001     Kristian Lappalainen
//Reason: Changed due to changes in the Freestyle SW architecture.
//Reference: -

//Version: 000.001                                           
//Status: Draft                                             
//Date: 18-Jul-2001     Kristian Lappalainen
//Reason: Document created
//Reference: -


//CONSTANTS
#define RTP_MAX_POC_DATA                                      0x89                                                  
#define RTP_ANY_SIZE                                          1                                                     
#define RTP_MAX_IP_ADDR_LENGTH                                0x10                                                  
#define RTP_MAX_USERNAME_LENGTH                               0x48                                                  
#define RTP_MAX_PASSWORD_LENGTH                               0x40                                                  
#define RTP_MAX_RTCP_CNAME_STRING_SIZE                        0xFF                                                  
#define RTP_MAX_RTCP_NAME_STRING_SIZE                         0xFF                                                  
#define RTP_MAX_MEDIA_STREAMS                                 0x18                                                  
#define RTP_MAX_RTCP_BYE_STRING_SIZE                          0xFF                                                  
#define RTP_MAX_SRTP_MKI_LEN                                  0x80                                                  
#define RTP_MAX_SRTP_KEY_SALT_LEN                             0x20                                                  
#define RTP_MAX_POC_TB_REASON_STRING_SIZE                     0xFF                                                  
#define RTP_MAX_POC_CONTROL_MSG_LENGTH                        0x022F                                                   
#define RTP_MAX_AMR_FEC_DEPTH                                 0x02                                                     
#define RTP_MAX_AMRWB_FEC_DEPTH                               0x02                                                     
#define RTP_MAX_AMR_FRAMES_PER_PACKET                         0x14                                                  
#define RTP_MAX_AMRWB_FRAMES_PER_PACKET                       0x14                                                  
#define RTP_LEARN_PT                                          0xFF                                                  


//TABLES

//ConstantTable for RTP_BEARER_TYPE
#define RTP_GPRS                                              0x00                                                     
#define RTP_LINK_ID                                           0x03                                                     
#define RTP_WLAN                                              0x05                                                     
#define RTP_MBMS                                              0x06                                                     

//ConstantTable for RTP_DIRECTION
#define RTP_DOWNLINK                                          0x00                                                     
#define RTP_FULL_DUPLEX                                       0x01                                                     
#define RTP_UPLINK                                            0x02                                                     

//ConstantTable for RTP_STOP_MODE
#define RTP_STOP_MODE_DIRECT_AND_BUFFER_FLUSH                 0x00                                                     
#define RTP_STOP_MODE_PLAYBACK_TO_END_BEFORE_ENDING           0x01                                                     
#define RTP_STOP_MODE_DIRECT_AND_BUFFER_FLUSH_WITH_TALKSPURT_IGNORE    0x02                                                     
#define RTP_STOP_MODE_DIRECT_AND_TALKSPURT_IGNORE_UNTIL_DL_TIMEOUT    0x03                                                     

//ConstantTable for RTP_REPLAY_CAUSE
#define RTP_POC_REPLAY_CAUSE_NONE                             0x00                                                     
#define RTP_POC_REPLAY_CAUSE_BUFFER_EMPTY                     0x01                                                     
#define RTP_POC_REPLAY_CAUSE_AUDIO_BUSY                       0x02                                                     
#define RTP_POC_REPLAY_CAUSE_ANY                              0x03                                                     

//ConstantTable for RTP_AUDIO_STREAM_CAUSE
#define RTP_AUDIO_STREAM_CAUSE_NONE                           0x00                                                     
#define RTP_AUDIO_STREAM_NO_RESOURCES                         0x01                                                     
#define RTP_AUDIO_STREAM_CAUSE_ANY                            0x02                                                     

//ConstantTable for RTP_RESP_STATUS
#define RTP_OK                                                0x00                                                     
#define RTP_FAIL                                              0x01                                                     

//ConstantTable for RTP_STATUS
#define RTP_SOCKET_ERROR                                      0x00                                                     
#define RTP_BIND_ERROR                                        0x01                                                     
#define RTP_NETWORK_OPENED                                    0x03                                                     
#define RTP_NETWORK_ERROR                                     0x04                                                     
#define RTP_CLOSE_ERROR                                       0x05                                                     
#define RTP_NETWORK_CLOSE_ERROR                               0x06                                                     
#define RTP_NETWORK_CLOSED                                    0x07                                                     
#define RTP_RECEIVING_AUDIO                                   0x08                                                     
#define RTP_UNSUPPORTED_PROTOCOL                              0x09                                                     
#define RTP_HEADER_ERROR                                      0x0A                                                     
#define RTP_PAYLOAD_ERROR                                     0x0B                                                     
#define RTP_DL_TIMEOUT                                        0x0C                                                     
#define RTP_RECV_ERROR                                        0x0D                                                     
#define RTP_SENDTO_ERROR                                      0x0E                                                     
#define RTP_INVALID_IP                                        0x0F                                                     
#define RTP_SUSPENDED                                         0x10                                                  
#define RTP_RESUMED                                           0x11                                                  
#define RTP_CREATION_TIMEOUT                                  0x12                                                  
#define RTP_NETWORK_INIT_CLOSE                                0x13                                                  
#define RTP_CL_SOURCE_INFO                                    0x14                                                  
#define RTP_CL_SOURCE_OVERFLOW                                0x15                                                  
#define RTP_DL_BW_INFO                                        0x16                                                  
#define RTP_QOS_INFO                                          0x17                                                  
#define RTP_SESSION_TIMEOUT                                   0x18                                                  
#define RTP_POC_REPLAY_AUDIO_END                              0x19                                                  
#define RTP_SESSION_CREATED                                   0x1A                                                  
#define RTP_PORTS_RESERVED                                    0x1B                                                  
#define RTP_PORTS_RESERVING_ERROR                             0x1C                                                  
#define RTP_PORTS_REMOVED                                     0x1D                                                  
#define RTP_PORTS_REMOVE_FAIL                                 0x1E                                                  
#define RTP_MEDIA_ADDED                                       0x1F                                                  
#define RTP_RESERVING_LINK_FAILED                             0x20                                                  
#define RTP_UNCONNECTED                                       0x21                                                  
#define RTP_CHANGE_BITRATE_REQ                                0x22                                                  
#define RTP_ENCODE_INTRA_FRAME_REQ                            0x23                                                  
#define RTP_MEDIA_ADDING_ERROR                                0x24                                                  
#define RTP_CODEC_INFO                                        0x25                                                  
#define RTP_FER_LEVEL_TRIGGER_REACHED                         0x26                                                  
#define RTP_AVERAGE_JITTER_LEVEL_TRIGGER_REACHED              0x27                                                  
#define RTP_NETWORKLINK_OPENED                                0x28                                                  
#define RTP_NETWORKLINK_CLOSED                                0x29                                                  
#define RTP_LINK_MODIFIED                                     0x2A                                                  
#define RTP_LINK_MODIFICATION_FAILED                          0x2B                                                  
#define RTP_ACTIVE_LINK                                       0x2C                                                  
#define RTP_CL_SOURCE_CREATION_FAILED                         0x2D                                                  
#define RTP_PP_BW_INFO                                        0x2E                                                  
#define RTP_PP_BW_USE_PRECONFIGURED_VALUE                     0x2F                                                  
#define RTP_PP_BW_MEASUREMENT_FAILED                          0x30                                                  
#define RTP_RDT_RTT_RESPONSE                                  0x31                                                  
#define RTP_RDT_RTT_NO_RESPONSE                               0x32                                                  
#define RTP_SRTP_DECRYPT_PARAMS_MISSING                       0x33                                                  
#define RTP_SRTP_DECRYPT_PARAMS_OK                            0x34                                                  
#define RTP_RECEIVING_VIDEO                                   0x35                                                  

//ConstantTable for RTP_HDR_MODE
#define RTP_USE_RTP_HDR                                       0x00                                                     
#define RTP_USE_STP_HDR                                       0x01                                                     

//ConstantTable for RTP_POC_REPLAY_MODE
#define RTP_POC_REPLAY_START                                  0x00                                                     
#define RTP_POC_REPLAY_STOP                                   0x01                                                     
#define RTP_POC_REPLAY_FLUSH                                  0x02                                                     

//ConstantTable for RTP_DELAY
#define RTP_NO_DELAY                                          0x00                                                     
#define RTP_WAIT_FOR_AUDIO                                    0x01                                                     

//ConstantTable for RTP_POC_CTRL_TYPE
#define RTP_POC_CTRL_LEADER                                   0x00                                                     
#define RTP_POC_CTRL_TRAILER                                  0x01                                                     
#define RTP_POC_CTRL_OTHER                                    0xFF                                                  

//ConstantTable for RTP_PAYLOAD_TYPE
#define RTP_STPHDR_AUDIO                                      0x01                                                     
#define RTP_STPHDR_AUDIO_BE                                   0x02                                                     
#define RTP_RTPHDR_POCAMR                                     0x69                                                  
#define RTP_RTPHDR_POCAMR_BE                                  0x6A                                                  

//ConstantTable for RTP_WLAN_WEP_MODE
#define RTP_WLAN_WEP_OPEN                                     0x00                                                     
#define RTP_WLAN_WEP_SHARED                                   0x01                                                     

//ConstantTable for RTP_WLAN_SEC_MODE
#define RTP_WLAN_SEC_NONE                                     0x00                                                     
#define RTP_WLAN_SEC_WEP                                      0x01                                                     
#define RTP_WLAN_SEC_WPA                                      0x02                                                     
#define RTP_WLAN_SEC_WPA_PSK                                  0x03                                                     
#define RTP_WLAN_SEC_WPA2                                     0x04                                                     
#define RTP_WLAN_SEC_WPA2_PSK                                 0x05                                                     
#define RTP_WLAN_SEC_8021X                                    0x06                                                     

//BitmaskTables for RTP_PPP
#define RTP_PPP_NO_IP_ADDR_NEG                                0x0001                                                     
#define RTP_PPP_NO_HDLC                                       0x0002                                                     
#define RTP_PPP_IPV4                                          0x0004                                                     
#define RTP_PPP_IPV6                                          0x0008                                                     

//BitmaskTables for RTP_PPP_DER
//#define RTP_PPP_NO_IP_ADDR_NEG                              0x00                        //Already defined as 0x01
//#define RTP_PPP_NO_HDLC                                     0x00                        //Already defined as 0x02
//#define RTP_PPP_IPV4                                        0x00                        //Already defined as 0x04
//#define RTP_PPP_IPV6                                        0x00                        //Already defined as 0x08

//BitmaskTables for RTP_PPP_AUTH
#define RTP_PPP_NO_AUTH                                       0x00                                                     
#define RTP_PPP_AUTH_PAP                                      0x01                                                     
#define RTP_PPP_AUTH_CHAP                                     0x02                                                     

//BitmaskTables for RTP_PPP_AUTH_DER
//#define RTP_PPP_NO_AUTH                                     0x00                        //Already defined as 0x00
//#define RTP_PPP_AUTH_PAP                                    0x00                        //Already defined as 0x01
//#define RTP_PPP_AUTH_CHAP                                   0x00                        //Already defined as 0x02

//ConstantTable for RTP_TRUE_FALSE
#define RTP_FALSE                                             0x00                                                     
#define RTP_TRUE                                              0x01                                                     

//ConstantTable for RTP_AMR_PAYLOAD_FORMAT
#define RTP_AMR_OCTET_ALIGNED                                 0x00                                                     
#define RTP_AMR_BANDWIDTH_EFFICIENT                           0x01                                                     

//ConstantTable for RTP_AMRWB_PAYLOAD_FORMAT
#define RTP_AMRWB_OCTET_ALIGNED                               0x00                                                     
#define RTP_AMRWB_BANDWIDTH_EFFICIENT                         0x01                                                     

//ConstantTable for RTP_AMR_CODEC_MODE
#define RTP_AMR_4_75_MODE                                     0x00                                                     
#define RTP_AMR_5_15_MODE                                     0x01                                                     
#define RTP_AMR_5_90_MODE                                     0x02                                                     
#define RTP_AMR_6_70_MODE                                     0x03                                                     
#define RTP_AMR_7_40_MODE                                     0x04                                                     
#define RTP_AMR_7_95_MODE                                     0x05                                                     
#define RTP_AMR_10_2_MODE                                     0x06                                                     
#define RTP_AMR_12_2_MODE                                     0x07                                                     
#define RTP_AMR_NO_CMR                                        0x0F                                                     

//ConstantTable for RTP_AMRWB_CODEC_MODE
#define RTP_AMRWB_6_60_MODE                                   0x00                                                     
#define RTP_AMRWB_8_85_MODE                                   0x01                                                     
#define RTP_AMRWB_12_65_MODE                                  0x02                                                     
#define RTP_AMRWB_14_25_MODE                                  0x03                                                     
#define RTP_AMRWB_15_85_MODE                                  0x04                                                     
#define RTP_AMRWB_18_25_MODE                                  0x05                                                     
#define RTP_AMRWB_19_85_MODE                                  0x06                                                     
#define RTP_AMRWB_23_05_MODE                                  0x07                                                     
#define RTP_AMRWB_23_85_MODE                                  0x08                                                     
#define RTP_AMRWB_NO_CMR                                      0x0F                                                     

//ConstantTable for RTP_AMRWB_CHANNELS
#define RTP_AMRWB_SINGLE_CHANNEL                              0x00                                                     

//ConstantTable for RTP_AMR_CHANNELS
#define RTP_AMR_SINGLE_CHANNEL                                0x00                                                     

//BitmaskTables for RTP_AMR_MODE_BITMASK_FLAGS
#define RTP_AMR_4_75_FLAG                                     0x01                                                     
#define RTP_AMR_5_15_FLAG                                     0x02                                                     
#define RTP_AMR_5_90_FLAG                                     0x04                                                     
#define RTP_AMR_6_70_FLAG                                     0x08                                                     
#define RTP_AMR_7_40_FLAG                                     0x10                                                  
#define RTP_AMR_7_95_FLAG                                     0x20                                                  
#define RTP_AMR_10_2_FLAG                                     0x40                                                  
#define RTP_AMR_12_2_FLAG                                     0x80                                                  

//BitmaskTables for RTP_AMRWB_MODE_BITMASK_FLAGS
#define RTP_AMRWB_6_60_FLAG                                   0x0001                                                     
#define RTP_AMRWB_8_85_FLAG                                   0x0002                                                     
#define RTP_AMRWB_12_65_FLAG                                  0x0004                                                     
#define RTP_AMRWB_14_25_FLAG                                  0x0008                                                     
#define RTP_AMRWB_15_85_FLAG                                  0x0010                                                  
#define RTP_AMRWB_18_25_FLAG                                  0x0020                                                  
#define RTP_AMRWB_19_85_FLAG                                  0x0040                                                  
#define RTP_AMRWB_23_05_FLAG                                  0x0080                                                  
#define RTP_AMRWB_23_85_FLAG                                  0x0100                                                   

//BitmaskTables for RTP_SUPPORTED_CODECS_BITMASK_FLAGS
#define RTP_CODEC_AMR                                         0x00000001                                                     

//ConstantTable for RTP_IP_VERSION
#define RTP_IPv4                                              0x04                                                     
#define RTP_IPv6                                              0x10                                                  
#define RTP_IPv4_and_IPv6                                     0xFF                                                  

//ConstantTable for RTP_PREFER_IP_VERSION
#define RTP_PREFER_EITHER_ADDRESS                             0x00                                                     
#define RTP_PREFER_IPv4                                       0x01                                                     
#define RTP_PREFER_IPv6                                       0x02                                                     
#define RTP_PREFER_IPv4_and_IPv6                              0x03                                                     

//ConstantTable for RTCP_TIMER_SPEC
#define RTCP_RR_3GPP_R5_26_234                                0x00                                                     
#define RTCP_RR_FIXED_TIMER                                   0x01                                                     
#define RTCP_NO_TIMER                                         0x02                                                     
#define RTCP_RFC3550_TIMER                                    0x03                                                     

//ConstantTable for RTP_MEDIA_PAYLOAD_TYPE
#define RTP_PAYLOAD_AMR_NB_OA                                 0x00                                                     
#define RTP_PAYLOAD_H263                                      0x01                                                     
#define RTP_PAYLOAD_AMR_NB_BW                                 0x02                                                     
#define RTP_PAYLOAD_G711_G711A                                0x03                                                     
#define RTP_PAYLOAD_G729                                      0x04                                                     
#define RTP_PAYLOAD_CN                                        0x05                                                     
#define RTP_PAYLOAD_H264                                      0x06                                                     
#define RTP_PAYLOAD_MPEG4                                     0x07                                                     
#define RTP_PAYLOAD_G726                                      0x08                                                     
#define RTP_PAYLOAD_DTMF                                      0x09                                                     
#define RTP_PAYLOAD_ILBC                                      0x0A                                                     
#define RTP_PAYLOAD_AMRWB_OA                                  0x0B                                                     
#define RTP_PAYLOAD_AMRWB_BW                                  0x0C                                                     
#define RTP_PAYLOAD_GSM_FR                                    0x0D                                                     
#define RTP_PAYLOAD_GSM_EFR                                   0x0E                                                     

//ConstantTable for RTP_BITRATE_INTERPRET
#define RTP_BITRATE_MIN_LIMIT                                 0x00                                                     
#define RTP_BITRATE_MAX_LIMIT                                 0x01                                                     
#define RTP_BITRATE_CURR_VALUE                                0x02                                                     
#define RTP_BITRATE_REQ_VALUE                                 0x03                                                     
#define RTP_BITRATE_CHANGE_VALUE                              0x04                                                     

//ConstantTable for RTP_OMA_POC_VERSION
#define RTP_OMA_POC_R1                                        0x00                                                     

//ConstantTable for RTP_OMA_POC_TBCP_SEND_MSG_TYPE
#define RTP_OMA_POC_TBCP_SEND_REQUEST                         0x00                                                     
#define RTP_OMA_POC_TBCP_SEND_RELEASE                         0x04                                                     
#define RTP_OMA_POC_TBCP_SEND_ACK                             0x07                                                     
#define RTP_OMA_POC_TBCP_SEND_QUEUE_STATUS_REQ                0x08                                                     

//ConstantTable for RTP_OMA_POC_TBCP_RECV_MSG_TYPE
#define RTP_OMA_POC_TBCP_RECV_GRANTED                         0x01                                                     
#define RTP_OMA_POC_TBCP_RECV_DENY                            0x03                                                     
#define RTP_OMA_POC_TBCP_RECV_IDLE                            0x05                                                     
#define RTP_OMA_POC_TBCP_RECV_TAKEN_NO_ACK                    0x02                                                     
#define RTP_OMA_POC_TBCP_RECV_TAKEN_ACK                       0x12                                                  
#define RTP_OMA_POC_TBCP_RECV_REVOKE                          0x06                                                     
#define RTP_OMA_POC_TBCP_RECV_QUEUE_STATUS_RESP               0x09                                                     
#define RTP_OMA_POC_TBCP_DISCONNECT                           0x0B                                                     
#define RTP_OMA_POC_TBCP_CONNECT                              0x0F                                                     

//ConstantTable for RTP_OMA_POC_TB_REASON
#define RTP_OMA_POC_TB_REASON_ANOTHER_USER_HAS_PERMISSION     0x01                                                     
#define RTP_OMA_POC_TB_REASON_INTERNAL_POC_SERVER_ERROR       0x02                                                     
#define RTP_OMA_POC_TB_REASON_ONLY_ONE_PARTICIPATING          0x03                                                     
#define RTP_OMA_POC_TB_REASON_RETRY_AFTER_TIMER_NOT_EXPIRED    0x04                                                     
#define RTP_OMA_POC_TB_REASON_LISTEN_ONLY                     0x05                                                     

//ConstantTable for RTP_OMA_POC_TB_REVOKE_REASON
#define RTP_OMA_POC_TB_REVOKE_REASON_ONLY_ONE_POC_USER        0x01                                                     
#define RTP_OMA_POC_TB_REVOKE_REASON_TALKBURST_TOO_LONG       0x02                                                     
#define RTP_OMA_POC_TB_REVOKE_REASON_NO_PERMISSION_TO_SEND    0x03                                                     
#define RTP_OMA_POC_TB_REVOKE_REASON_TB_PRE_EMPTED            0x04                                                     

//ConstantTable for RTP_OMA_POC_TB_REASON_CODE
#define RTP_OMA_POC_TB_REASON_CODE_ACCEPTED                   0x00                                                     
#define RTP_OMA_POC_TB_REASON_CODE_BUSY                       0x01                                                     
#define RTP_OMA_POC_TB_REASON_CODE_NOT_ACCEPTED               0x02                                                     

//ConstantTable for RTP_OMA_POC_TB_QUEUE_PRIORITY
#define RTP_OMA_POC_TB_QUEUE_PRIORITY_NO                      0x00                                                     
#define RTP_OMA_POC_TB_QUEUE_PRIORITY_NORMAL                  0x01                                                     
#define RTP_OMA_POC_TB_QUEUE_PRIORITY_HIGH                    0x02                                                     
#define RTP_OMA_POC_TB_QUEUE_PRIORITY_PRE_EMP                 0x03                                                     

//ConstantTable for RTP_OMA_POC_TB_PRIORITY
#define RTP_OMA_POC_TB_PRIORITY_NORMAL                        0x01                                                     
#define RTP_OMA_POC_TB_PRIORITY_HIGH                          0x02                                                     
#define RTP_OMA_POC_TB_PRIORITY_PRE_EMPTIVE                   0x03                                                     

//BitmaskTables for RTP_OMA_POC_TB_SDES_CONTENT_BITMASK_FLAGS
#define RTP_OMA_POC_TB_SDES_CONTENT_IDENT_INV_POC_CLIENT      0x8000                                                  
#define RTP_OMA_POC_TB_SDES_CONTENT_NICK_INV_POC_CLIENT       0x4000                                                  
#define RTP_OMA_POC_TB_SDES_CONTENT_IDENT_POC_SESSION         0x2000                                                  
#define RTP_OMA_POC_TB_SDES_CONTENT_POC_GROUP_NAME            0x1000                                                  
#define RTP_OMA_POC_TB_SDES_CONTENT_POC_GROUP_IDENT           0x0800                                                   

//BitmaskTables for RTP_OMA_POC_TB_SESSION_TYPE_BITMASK_FLAGS
#define RTP_OMA_POC_TB_NO_SESSION                             0x00                                                     
#define RTP_OMA_POC_TB_ONE_TO_ONE                             0x01                                                     
#define RTP_OMA_POC_TB_ADHOC                                  0x02                                                     
#define RTP_OMA_POC_TB_PREARRANGED                            0x04                                                     
#define RTP_OMA_POC_TB_CHAT                                   0x08                                                     

//BitmaskTables for RTP_OMA_POC_TB_ADD_INDICATIONS_BITMASK_FLAGS
#define RTP_OMA_POC_TB_MANUAL_OVERRIDE                        0x80                                                  

//BitmaskTables for RTP_RTCP_PACKETS_BITMASK_FLAGS
#define RTP_RTCP_PACKETS_SDES                                 0x01                                                     
#define RTP_RTCP_PACKETS_BYE                                  0x02                                                     

//BitmaskTables for RTP_RTCP_SDES_CHUNKS_BITMASK_FLAGS
#define RTP_RTCP_SDES_CNAME                                   0x01                                                     
#define RTP_RTCP_SDES_NAME                                    0x02                                                     

//BitmaskTables for RTP_ALLOWED_STREAMING_QOS_RATS_BITMASK_FLAGS
#define RTP_ALLOWED_STREAMING_QOS_RATS_2G                     0x8000                                                  
#define RTP_ALLOWED_STREAMING_QOS_RATS_3G                     0x4000                                                  

//ConstantTable for RTP_RTCP_SR_RR
#define RTP_RTCP_SR                                           0x00                                                     
#define RTP_RTCP_RR                                           0x01                                                     

//ConstantTable for RTP_END_POINT
#define RTP_END_POINT_NETWORK                                 0x00                                                     
#define RTP_END_POINT_LOCAL                                   0x01                                                     

//ConstantTable for RTP_ALLOW_DISABLE
#define RTP_DISABLE                                           0x00                                                     
#define RTP_ALLOW                                             0x01                                                     

//ConstantTable for RTP_LOCAL_GENERATED_PACKET_TYPE
#define RTP_PACKET_TYPE_NO_PAYLOAD                            0x00                                                     
#define RTP_PACKET_TYPE_AMR                                   0x01                                                     
#define RTP_PACKET_TYPE_AMR_WB                                0x02                                                     

//ConstantTable for RTP_RTCP_MODIFY_PORTS_OPTION
#define RTP_MODIFY_PORTS_OPTION_ADD                           0x00                                                     
#define RTP_MODIFY_PORTS_OPTION_REMOVE                        0x01                                                     

//ConstantTable for RTP_SRTP_AND_FEC_ORDER
#define RTP_SRTP_AND_FEC_ORDER_FEC_FIRST                      0x00                                                     
#define RTP_SRTP_AND_FEC_ORDER_SRTP_FIRST                     0x01                                                     

//ConstantTable for RTP_ENCRYPTION_CIPHER
#define RTP_ENCRYPTION_CIPHER_NULL                            0x00                                                     
#define RTP_ENCRYPTION_CIPHER_AES_CM                          0x01                                                     

//ConstantTable for RTP_AUTHENTICATION_CIPHER
#define RTP_AUTHENTICATION_CIPHER_HMAC_SHA1                   0x01                                                     

//ConstantTable for RTP_KEY_DER_PS_RAND_FUNC
#define RTP_KEY_DER_PS_RAND_FUNC_AES_CM                       0x01                                                     

//ConstantTable for RTP_RCC_MODE
#define RTP_RCC_MODE_NONE                                     0x00                                                     
#define RTP_RCC_MODE_1                                        0x01                                                     
#define RTP_RCC_MODE_2                                        0x02                                                     
#define RTP_RCC_MODE_3                                        0x03                                                     

//BitmaskTables for RTP_FRAGMENT_INFORMATION_BITMASK_FLAGS
#define RTP_FRAGMENT_HAS_RTCP_INFO                            0x01                                                     
#define RTP_FRAGMENT_HAS_CNAME_INFO                           0x02                                                     
#define RTP_FRAGMENT_HAS_HEADER_EXT_INFO                      0x04                                                     

//BitmaskTables for RTP_RTCP_XR_BLOCK_BITMASK_FLAGS
#define RTP_RTCP_XR_BLOCK_LOSS_RLE                            0x8000                                                  

//ConstantTable for RTP_IP_FOR_RTP_OR_RTCP
#define RTP_IP_FOR_RTP                                        0x00                                                     
#define RTP_IP_FOR_RTCP                                       0x01                                                     

//ConstantTable for RTP_MS_STREAMING_MODE
#define RTP_MS_STREAMING_MODE_TCP                             0x00                                                     
#define RTP_MS_STREAMING_MODE_UDP                             0x01                                                     

//ConstantTable for RTP_REAL_STREAMING_MODE
#define RTP_REAL_STREAMING_MODE_UDP                           0x00                                                     

//ConstantTable for RTP_RDT_VERSION
#define RTP_RDTv2                                             0x02                                                     
#define RTP_RDTv3                                             0x03                                                     

//ConstantTable for RTP_RDT_SEND_REQ_NAME
#define RTP_RDT_SEND_TIMEOUT                                  0x01                                                     
#define RTP_RDT_SEND_RETRY                                    0x02                                                     

//ConstantTable for RTP_RDT_PACKET_TYPE
#define RTP_RDT_RTT_REQUEST                                   0xFF03                                                

//ConstantTable for RTP_CM_SOURCE_DATA_FRAGMENT_OFFSET
#define RTP_RTSP_TO_RTP_CM_SOURCE_EXTRA_SPACE_FOR_MODIFIED_FRAGMENT    0x14                                                  

//BitmaskTables for RTP_IP_ADDRESS_USAGE_BITMASK_FLAGS
#define RTP_IP_ADDR_FOR_ALL_RTP_RTCP_DL_UL                    0x00                                                     
#define RTP_IP_ADDR_FOR_RTP_DL                                0x01                                                     
#define RTP_IP_ADDR_FOR_RTP_UL                                0x02                                                     
#define RTP_IP_ADDR_FOR_RTCP_DL                               0x04                                                     
#define RTP_IP_ADDR_FOR_RTCP_UL                               0x08                                                     

//ConstantTable for FtdTable
#define FTD_SB_RTP_POC_TX_AUDIO_PACKET                        0x0100                                                   
#define FTD_SB_RTP_POC_RX_UDP_IP_PACKET                       0x0101                                                   
#define FTD_SB_RTP_POC_TX_CTRL_PACKET                         0x0102                                                   
#define FTD_SB_RTP_POC_TX_QOS                                 0x0103                                                   
#define FTD_SB_RTP_POC_RX_AUDIO_PACKET                        0x0104                                                   
#define FTD_SB_RTP_POC_TX_FAIL                                0x0105                                                   
#define FTD_SB_RTP_POC_STATE                                  0x0106                                                   
#define FTD_SB_RTP_POC_RX_REJECT                              0x0107                                                   
#define FTD_SB_RTP_POC_RX_CTRL_PACKET                         0x0108                                                   
#define FTD_SB_RTP_POC_REMOTE_PORT                            0x0109                                                   
#define FTD_SB_RTP_POC_FLOWCONTROL                            0x010A                                                   
#define FTD_SB_RTP_POC_RX_QOS                                 0x010B                                                   
#define FTD_SB_RTP_RESET_COUNTERS                             0x010C                                                   
#define FTD_SB_RTP_UMA_PRESENT_JITTER_EST                     0x010D                                                   
#define FTD_SB_RTP_UMA_WAIT_TIME                              0x010E                                                   
#define FTD_SB_RTP_UMA_PRESENT_JITTER_LEN                     0x010F                                                   
#define FTD_SB_RTP_UMA_FER_WITH_FEC                           0x0110                                                   
#define FTD_SB_RTP_UMA_FEA_WITHOUT_FEC                        0x0111                                                   
#define FTD_SB_RTP_UMA_LATE_FRAME_RATE                        0x0112                                                   
#define FTD_SB_RTP_UMA_SAMPLE_SIZE                            0x0113                                                   
#define FTD_SB_RTP_UMA_FEC_LEVEL                              0x0114                                                   
#define FTD_SB_RTP_UMA_CODEC_TYPE                             0x0115                                                   
#define FTD_SB_RTP_UMA_CODEC_MODE                             0x0116                                                   
#define FTD_SB_RTP_UMA_CMR_UL                                 0x0117                                                   
#define FTD_SB_RTP_UMA_CMR_DL                                 0x0118                                                   
#define FTD_SB_RTP_UMA_DTX                                    0x0119                                                   
#define FTD_SB_RTP_UMA_PLAYBACK_INCREASED                     0x011A                                                   
#define FTD_SB_RTP_UMA_PLAYBACK_DECREASED                     0x011B                                                   
#define FTD_SB_RTP_UMA_RESET                                  0x011C                                                   
#define FTD_SB_RTP_VS_RA_TUNE_VALUE_ONE                       0x011D                                                   
#define FTD_SB_RTP_VS_RA_TUNE_VALUE_TWO                       0x011E                                                   


//STRUCTURES


//Definition for struct RTP_POC_DATA_NTF
typedef struct
            { 
             uint16_t     session_id;
             uint16_t     marker_and_payload_type;
             uint16_t     sequence_number;
             uint16_t     ssrc_upper_part;
             uint16_t     ssrc_lower_part;
             uint16_t     data_length;
             uint8_t      amr_ietf_data[0];
            } __attribute__((packed)) RTP_POC_DATA_NTF_STR;
#define SIZE_RTP_POC_DATA_NTF                                 sizeof(RTP_POC_DATA_NTF_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//SUBBLOCKS


//Definition for struct RTP_SB_PORT
#define RTP_SB_PORT                                           0x00                                                     
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint16_t     port;
            } __attribute__((packed)) RTP_SB_PORT_STR;
#define SIZE_RTP_SB_PORT                                      sizeof(RTP_SB_PORT_STR)


//Definition for struct RTP_SB_SSRC
#define RTP_SB_SSRC                                           0x36                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint16_t     remote_rtp_port;
             uint32_t     ssrc;
            } __attribute__((packed)) RTP_SB_SSRC_STR;
#define SIZE_RTP_SB_SSRC                                      sizeof(RTP_SB_SSRC_STR)


//Definition for struct RTP_SB_RECEIVED_PACKETS
#define RTP_SB_RECEIVED_PACKETS                               0x0B                                                     
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint16_t     packet_count;
            } __attribute__((packed)) RTP_SB_RECEIVED_PACKETS_STR;
#define SIZE_RTP_SB_RECEIVED_PACKETS                          sizeof(RTP_SB_RECEIVED_PACKETS_STR)


//Definition for struct RTP_SB_POC_APPLICATION
#define RTP_SB_POC_APPLICATION                                0x08                                                     
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint8_t      timer_value;
             uint8_t      use_padding;
             uint32_t     ssrc;
             uint16_t     send_rtp_port_no;
             uint8_t      marker;
             uint8_t      pn_resource;
             uint8_t      rtp_mode;
             uint8_t      ip_version;
             uint16_t     recv_rtp_port_no;
             uint8_t      max_packet_gap;
             uint8_t      max_packet_misorder;
             uint8_t      amr_frame_count;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) RTP_SB_POC_APPLICATION_STR;
#define SIZE_RTP_SB_POC_APPLICATION                           sizeof(RTP_SB_POC_APPLICATION_STR)


//Definition for struct RTP_SB_POC_APPLICATION_UPDATE
#define RTP_SB_POC_APPLICATION_UPDATE                         0x09                                                     
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint16_t     send_rtp_port_no;
             uint32_t     ssrc;
             uint8_t      dest_ip_addr_len;
             uint8_t      dest_ip_addr[16];
             uint8_t      timer_value;
             uint8_t      amr_frame_count;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) RTP_SB_POC_APPLICATION_UPDATE_STR;
#define SIZE_RTP_SB_POC_APPLICATION_UPDATE                    sizeof(RTP_SB_POC_APPLICATION_UPDATE_STR)


//Definition for struct RTP_SB_SOCKET_PPP_AND_AUTH
#define RTP_SB_SOCKET_PPP_AND_AUTH                            0x07                                                     
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint16_t     options;
             uint16_t     mru;
             uint8_t      authentication;
             uint8_t      username_length;
             uint8_t      password_length;
             uint8_t      username[0];
             uint8_t      username_and_password[0];
            } __attribute__((packed)) RTP_SB_SOCKET_PPP_AND_AUTH_STR;
#define SIZE_RTP_SB_SOCKET_PPP_AND_AUTH                       sizeof(RTP_SB_SOCKET_PPP_AND_AUTH_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct RTP_SB_LINK_INFO
#define RTP_SB_LINK_INFO                                      0x0A                                                     
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint8_t      link_id;
             uint8_t      res_id;
             uint16_t     connection_id;
             uint8_t      context_id;
             uint8_t      ip_addr_len;
             uint8_t      ip_addr[16];
            } __attribute__((packed)) RTP_SB_LINK_INFO_STR;
#define SIZE_RTP_SB_LINK_INFO                                 sizeof(RTP_SB_LINK_INFO_STR)


//Definition for struct RTP_SB_3GPP_PSS_R6_RA_NADU
#define RTP_SB_3GPP_PSS_R6_RA_NADU                            0x18                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint16_t     fillerbyte1;
             uint32_t     nadu_func_ptr;
             uint32_t     nadu_func_param_ptr;
             uint8_t      nadu_report_freq;
             uint8_t      fillerbyte2[3];
            } __attribute__((packed)) RTP_SB_3GPP_PSS_R6_RA_NADU_STR;
#define SIZE_RTP_SB_3GPP_PSS_R6_RA_NADU                       sizeof(RTP_SB_3GPP_PSS_R6_RA_NADU_STR)


//Definition for struct RTP_SB_PAYLOAD_TYPE
#define RTP_SB_PAYLOAD_TYPE                                   0x5C                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint8_t      payload_type;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) RTP_SB_PAYLOAD_TYPE_STR;
#define SIZE_RTP_SB_PAYLOAD_TYPE                              sizeof(RTP_SB_PAYLOAD_TYPE_STR)


//Definition for struct RTP_SB_DL_MEDIA_STREAM
#define RTP_SB_DL_MEDIA_STREAM                                0x0E                                                     
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint16_t     recv_rtp_port_no;
             uint32_t     timescale;
             uint32_t     ssrc;
             uint8_t      ssrc_flag;
             uint8_t      payload_type;
             uint16_t     port_rand_min;
             uint16_t     port_rand_max;
             uint16_t     rtcp_timer_value;
             uint8_t      rtcp_timer_spec;
             uint8_t      unique_id;
             uint8_t      fillerbyte1;
             uint8_t      num_of_subs;
            } __attribute__((packed)) RTP_SB_DL_MEDIA_STREAM_STR;
#define SIZE_RTP_SB_DL_MEDIA_STREAM                           sizeof(RTP_SB_DL_MEDIA_STREAM_STR)


//Definition for struct RTP_SB_BW_INFO
#define RTP_SB_BW_INFO                                        0x1A                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint16_t     fillerbyte1;
             uint32_t     bw;
            } __attribute__((packed)) RTP_SB_BW_INFO_STR;
#define SIZE_RTP_SB_BW_INFO                                   sizeof(RTP_SB_BW_INFO_STR)


//Definition for struct RTP_SB_3GPP_PSS_R6_RA_BW
#define RTP_SB_3GPP_PSS_R6_RA_BW                              0x19                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint8_t      rtt_multiplier;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) RTP_SB_3GPP_PSS_R6_RA_BW_STR;
#define SIZE_RTP_SB_3GPP_PSS_R6_RA_BW                         sizeof(RTP_SB_3GPP_PSS_R6_RA_BW_STR)


//Definition for struct RTP_SB_RTCP_CNAME
#define RTP_SB_RTCP_CNAME                                     0x0F                                                     
typedef struct
            { 
             uint8_t      id;
             uint8_t      fillerbyte1;
             uint16_t     length;
             uint8_t      cname_length;
             uint8_t      cname[0];
            } __attribute__((packed)) RTP_SB_RTCP_CNAME_STR;
#define SIZE_RTP_SB_RTCP_CNAME                                sizeof(RTP_SB_RTCP_CNAME_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct RTP_SB_RTCP_NAME
#define RTP_SB_RTCP_NAME                                      0x30                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      fillerbyte1;
             uint16_t     length;
             uint8_t      name_length;
             uint8_t      name[0];
            } __attribute__((packed)) RTP_SB_RTCP_NAME_STR;
#define SIZE_RTP_SB_RTCP_NAME                                 sizeof(RTP_SB_RTCP_NAME_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct RTP_SB_CL_SOURCE_INFO
#define RTP_SB_CL_SOURCE_INFO                                 0x10                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint8_t      media_stream_id;
             uint8_t      payload_type;
             uint32_t     cm_source_instance;
             uint32_t     cm_source_category;
             uint8_t      unique_id;
             uint8_t      fillerbyte1[3];
            } __attribute__((packed)) RTP_SB_CL_SOURCE_INFO_STR;
#define SIZE_RTP_SB_CL_SOURCE_INFO                            sizeof(RTP_SB_CL_SOURCE_INFO_STR)


//Definition for struct RTP_SB_DL_MEDIA_STREAM_UPDATE
#define RTP_SB_DL_MEDIA_STREAM_UPDATE                         0x11                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint8_t      media_stream_id;
             uint8_t      fillerbyte1;
             uint16_t     send_rtcp_port_no;
             uint8_t      dest_ip_addr_len;
             uint8_t      dest_ip_addr[16];
             uint8_t      fillerbyte2;
            } __attribute__((packed)) RTP_SB_DL_MEDIA_STREAM_UPDATE_STR;
#define SIZE_RTP_SB_DL_MEDIA_STREAM_UPDATE                    sizeof(RTP_SB_DL_MEDIA_STREAM_UPDATE_STR)


//Definition for struct RTP_SB_MS_MEDIA_STREAM_UPDATE
#define RTP_SB_MS_MEDIA_STREAM_UPDATE                         0x54                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint8_t      media_stream_id;
             uint8_t      dest_ip_addr_len;
             uint16_t     send_rtp_port_no;
             uint16_t     send_rtcp_port_no;
             uint8_t      dest_ip_addr[16];
            } __attribute__((packed)) RTP_SB_MS_MEDIA_STREAM_UPDATE_STR;
#define SIZE_RTP_SB_MS_MEDIA_STREAM_UPDATE                    sizeof(RTP_SB_MS_MEDIA_STREAM_UPDATE_STR)


//Definition for struct RTP_SB_RTCP_SR_INFO
#define RTP_SB_RTCP_SR_INFO                                   0x13                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint16_t     fillerbyte1;
             uint32_t     ntp_timestamp_high;
             uint32_t     ntp_timestamp_low;
             uint32_t     rtp_timestamp;
             uint32_t     senders_packet_count;
             uint32_t     senders_octet_count;
            } __attribute__((packed)) RTP_SB_RTCP_SR_INFO_STR;
#define SIZE_RTP_SB_RTCP_SR_INFO                              sizeof(RTP_SB_RTCP_SR_INFO_STR)


//Definition for struct RTP_SB_RTCP_REPORT
#define RTP_SB_RTCP_REPORT                                    0x12                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint8_t      fillerbyte1;
             uint8_t      fractation_lost;
             uint32_t     ssrc_n;
             uint32_t     cumulative_packets_lost;
             uint32_t     ext_high_seq_number_received;
             uint32_t     interarrival_jitter;
             uint32_t     last_sr_timestamp;
             uint32_t     delay_since_last_sr;
            } __attribute__((packed)) RTP_SB_RTCP_REPORT_STR;
#define SIZE_RTP_SB_RTCP_REPORT                               sizeof(RTP_SB_RTCP_REPORT_STR)


//Definition for struct RTP_SB_DL_MEDIA_STREAM_INFO
#define RTP_SB_DL_MEDIA_STREAM_INFO                           0x14                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint8_t      media_stream_id;
             uint8_t      fillerbyte1;
             uint16_t     recv_rtp_port_no;
             uint16_t     recv_rtcp_port_no;
            } __attribute__((packed)) RTP_SB_DL_MEDIA_STREAM_INFO_STR;
#define SIZE_RTP_SB_DL_MEDIA_STREAM_INFO                      sizeof(RTP_SB_DL_MEDIA_STREAM_INFO_STR)


//Definition for struct RTP_SB_STREAMING_PLAY
#define RTP_SB_STREAMING_PLAY                                 0x4F                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint16_t     fillerbyte1;
            } __attribute__((packed)) RTP_SB_STREAMING_PLAY_STR;
#define SIZE_RTP_SB_STREAMING_PLAY                            sizeof(RTP_SB_STREAMING_PLAY_STR)


//Definition for struct RTP_SB_RTCP_XR_BLOCK_SUPPORT
#define RTP_SB_RTCP_XR_BLOCK_SUPPORT                          0x50                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint16_t     rtcp_xr_block_support;
            } __attribute__((packed)) RTP_SB_RTCP_XR_BLOCK_SUPPORT_STR;
#define SIZE_RTP_SB_RTCP_XR_BLOCK_SUPPORT                     sizeof(RTP_SB_RTCP_XR_BLOCK_SUPPORT_STR)


//Definition for struct RTP_SB_DL_STREAMING_APPLICATION_UPDATE
#define RTP_SB_DL_STREAMING_APPLICATION_UPDATE                0x0D                                                     
typedef struct
            { 
             uint8_t      id;
             uint8_t      fillerbyte1;
             uint16_t     length;
             uint8_t      rtcp_start;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
             uint8_t      num_of_subs;
            } __attribute__((packed)) RTP_SB_DL_STREAMING_APPLICATION_UPDATE_STR;
#define SIZE_RTP_SB_DL_STREAMING_APPLICATION_UPDATE           sizeof(RTP_SB_DL_STREAMING_APPLICATION_UPDATE_STR)


//Definition for struct RTP_SB_DL_STREAMING_APPLICATION
#define RTP_SB_DL_STREAMING_APPLICATION                       0x0C                                                     
typedef struct
            { 
             uint8_t      id;
             uint8_t      fillerbyte1;
             uint16_t     length;
             uint8_t      ip_version;
             uint8_t      multiplex;
             uint8_t      rtcp_sr;
             uint8_t      num_of_subs;
            } __attribute__((packed)) RTP_SB_DL_STREAMING_APPLICATION_STR;
#define SIZE_RTP_SB_DL_STREAMING_APPLICATION                  sizeof(RTP_SB_DL_STREAMING_APPLICATION_STR)


//Definition for struct RTP_SB_NETWORK_IP_ADDR
#define RTP_SB_NETWORK_IP_ADDR                                0x1F                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint8_t      ip_addr_usage;
             uint8_t      ip_addr_len;
             uint8_t      ip_addr[16];
            } __attribute__((packed)) RTP_SB_NETWORK_IP_ADDR_STR;
#define SIZE_RTP_SB_NETWORK_IP_ADDR                           sizeof(RTP_SB_NETWORK_IP_ADDR_STR)


//Definition for struct RTP_SB_PORTS
#define RTP_SB_PORTS                                          0x25                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint16_t     rtcp_port_no;
             uint16_t     rtp_port_no;
             uint8_t      rtcp_sckt_descriptor;
             uint8_t      rtp_sckt_descriptor;
            } __attribute__((packed)) RTP_SB_PORTS_STR;
#define SIZE_RTP_SB_PORTS                                     sizeof(RTP_SB_PORTS_STR)


//Definition for struct RTP_SB_AMR_UL_CODEC
#define RTP_SB_AMR_UL_CODEC                                   0x23                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint8_t      payload_format;
             uint8_t      payload_type;
             uint8_t      codec_mode;
             uint8_t      mode_set;
             uint8_t      mode_change_period;
             uint8_t      mode_change_neighbor;
             uint8_t      frames_per_rtp;
             uint8_t      fec;
             uint8_t      cmr;
             uint8_t      channels;
             uint8_t      dtx;
             uint8_t      frame_crc;
             uint8_t      robust_sorting;
             uint8_t      interleaving;
            } __attribute__((packed)) RTP_SB_AMR_UL_CODEC_STR;
#define SIZE_RTP_SB_AMR_UL_CODEC                              sizeof(RTP_SB_AMR_UL_CODEC_STR)


//Definition for struct RTP_SB_AMR_DL_CODEC
#define RTP_SB_AMR_DL_CODEC                                   0x24                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint8_t      payload_format;
             uint8_t      payload_type;
             uint8_t      mode_set;
             uint8_t      channels;
             uint8_t      frame_crc;
             uint8_t      robust_sorting;
             uint8_t      interleaving;
             uint8_t      fillerbyte1[3];
            } __attribute__((packed)) RTP_SB_AMR_DL_CODEC_STR;
#define SIZE_RTP_SB_AMR_DL_CODEC                              sizeof(RTP_SB_AMR_DL_CODEC_STR)


//Definition for struct RTP_SB_AMRWB_UL_CODEC
#define RTP_SB_AMRWB_UL_CODEC                                 0x5E                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint8_t      payload_format;
             uint8_t      payload_type;
             uint16_t     mode_set;
             uint8_t      codec_mode;
             uint8_t      mode_change_period;
             uint8_t      mode_change_neighbor;
             uint8_t      frames_per_rtp;
             uint8_t      fec;
             uint8_t      cmr;
             uint8_t      channels;
             uint8_t      dtx;
             uint8_t      frame_crc;
             uint8_t      robust_sorting;
             uint8_t      interleaving;
             uint8_t      fillerbyte1[3];
            } __attribute__((packed)) RTP_SB_AMRWB_UL_CODEC_STR;
#define SIZE_RTP_SB_AMRWB_UL_CODEC                            sizeof(RTP_SB_AMRWB_UL_CODEC_STR)


//Definition for struct RTP_SB_AMRWB_DL_CODEC
#define RTP_SB_AMRWB_DL_CODEC                                 0x5F                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint8_t      payload_format;
             uint8_t      payload_type;
             uint16_t     mode_set;
             uint8_t      channels;
             uint8_t      frame_crc;
             uint8_t      robust_sorting;
             uint8_t      interleaving;
             uint16_t     fillerbyte1;
            } __attribute__((packed)) RTP_SB_AMRWB_DL_CODEC_STR;
#define SIZE_RTP_SB_AMRWB_DL_CODEC                            sizeof(RTP_SB_AMRWB_DL_CODEC_STR)


//Definition for struct RTP_SB_ADD_CODEC_MEDIA
#define RTP_SB_ADD_CODEC_MEDIA                                0x33                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint16_t     rtp_port_no;
             uint16_t     rtcp_timer_value;
             uint8_t      rtcp_timer_spec;
             uint8_t      num_of_subs;
            } __attribute__((packed)) RTP_SB_ADD_CODEC_MEDIA_STR;
#define SIZE_RTP_SB_ADD_CODEC_MEDIA                           sizeof(RTP_SB_ADD_CODEC_MEDIA_STR)


//Definition for struct RTP_SB_RTCP_BYE_REASON
#define RTP_SB_RTCP_BYE_REASON                                0x15                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      fillerbyte1;
             uint16_t     length;
             uint8_t      bye_length;
             uint8_t      bye[0];
            } __attribute__((packed)) RTP_SB_RTCP_BYE_REASON_STR;
#define SIZE_RTP_SB_RTCP_BYE_REASON                           sizeof(RTP_SB_RTCP_BYE_REASON_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct RTP_SB_SUPPORTED_CODECS
#define RTP_SB_SUPPORTED_CODECS                               0x34                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint16_t     fillerbyte1;
             uint32_t     codecs;
            } __attribute__((packed)) RTP_SB_SUPPORTED_CODECS_STR;
#define SIZE_RTP_SB_SUPPORTED_CODECS                          sizeof(RTP_SB_SUPPORTED_CODECS_STR)


//Definition for struct RTP_SB_FER_FEC_LEVELS_FOR_AMR
#define RTP_SB_FER_FEC_LEVELS_FOR_AMR                         0x3A                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint8_t      codec_mode_1;
             uint8_t      codec_mode_1_fec_level;
             uint8_t      codec_mode_2;
             uint8_t      codec_mode_2_fec_level;
             uint8_t      codec_mode_3;
             uint8_t      codec_mode_3_fec_level;
             uint8_t      codec_mode_4;
             uint8_t      codec_mode_4_fec_level;
             uint16_t     fillerbyte1;
             uint16_t     fer_level_from_mode_1_to_mode_2;
             uint16_t     fer_level_from_mode_2_to_mode_3;
             uint16_t     fer_level_from_mode_3_to_mode_4;
             uint16_t     fer_level_from_mode_2_to_mode_1;
             uint16_t     fer_level_from_mode_3_to_mode_2;
             uint16_t     fer_level_from_mode_4_to_mode_3;
            } __attribute__((packed)) RTP_SB_FER_FEC_LEVELS_FOR_AMR_STR;
#define SIZE_RTP_SB_FER_FEC_LEVELS_FOR_AMR                    sizeof(RTP_SB_FER_FEC_LEVELS_FOR_AMR_STR)


//Definition for struct RTP_SB_FER_FEC_LEVELS_FOR_AMRWB
#define RTP_SB_FER_FEC_LEVELS_FOR_AMRWB                       0x60                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint16_t     codec_mode_1;
             uint16_t     codec_mode_2;
             uint16_t     codec_mode_3;
             uint16_t     codec_mode_4;
             uint8_t      codec_mode_1_fec_level;
             uint8_t      codec_mode_2_fec_level;
             uint8_t      codec_mode_3_fec_level;
             uint8_t      codec_mode_4_fec_level;
             uint16_t     fer_level_from_mode_1_to_mode_2;
             uint16_t     fer_level_from_mode_2_to_mode_3;
             uint16_t     fer_level_from_mode_3_to_mode_4;
             uint16_t     fer_level_from_mode_2_to_mode_1;
             uint16_t     fer_level_from_mode_3_to_mode_2;
             uint16_t     fer_level_from_mode_4_to_mode_3;
             uint16_t     fillerbyte1;
            } __attribute__((packed)) RTP_SB_FER_FEC_LEVELS_FOR_AMRWB_STR;
#define SIZE_RTP_SB_FER_FEC_LEVELS_FOR_AMRWB                  sizeof(RTP_SB_FER_FEC_LEVELS_FOR_AMRWB_STR)


//Definition for struct RTP_SB_FER_BASED_FEC_LEVEL_CHANGE
#define RTP_SB_FER_BASED_FEC_LEVEL_CHANGE                     0x27                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint8_t      activate;
             uint8_t      num_of_subs;
            } __attribute__((packed)) RTP_SB_FER_BASED_FEC_LEVEL_CHANGE_STR;
#define SIZE_RTP_SB_FER_BASED_FEC_LEVEL_CHANGE                sizeof(RTP_SB_FER_BASED_FEC_LEVEL_CHANGE_STR)


//Definition for struct RTP_SB_TTY_SUPPORT
#define RTP_SB_TTY_SUPPORT                                    0x28                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint8_t      activate;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) RTP_SB_TTY_SUPPORT_STR;
#define SIZE_RTP_SB_TTY_SUPPORT                               sizeof(RTP_SB_TTY_SUPPORT_STR)


//Definition for struct RTP_SB_TRIGGERS_TO_HO_TO_CS
#define RTP_SB_TRIGGERS_TO_HO_TO_CS                           0x3B                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint8_t      fer_level_trigger;
             uint8_t      fillerbyte1;
             uint16_t     avg_jitter_level_trigger;
             uint16_t     fillerbyte2;
            } __attribute__((packed)) RTP_SB_TRIGGERS_TO_HO_TO_CS_STR;
#define SIZE_RTP_SB_TRIGGERS_TO_HO_TO_CS                      sizeof(RTP_SB_TRIGGERS_TO_HO_TO_CS_STR)


//Definition for struct RTP_SB_UMA_APPLICATION
#define RTP_SB_UMA_APPLICATION                                0x22                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      fillerbyte1;
             uint16_t     length;
             uint8_t      link_id;
             uint8_t      res_id;
             uint8_t      ip_version;
             uint8_t      rtcp_support;
             uint16_t     port_rand_min;
             uint16_t     port_rand_max;
             uint16_t     recv_rtp_port_no;
             uint16_t     rtcp_timer_value;
             uint8_t      rtcp_timer_spec;
             uint8_t      timer_value;
             uint8_t      fillerbyte2;
             uint8_t      num_of_subs;
            } __attribute__((packed)) RTP_SB_UMA_APPLICATION_STR;
#define SIZE_RTP_SB_UMA_APPLICATION                           sizeof(RTP_SB_UMA_APPLICATION_STR)


//Definition for struct RTP_SB_VS_SYMMETRIC_RTP
#define RTP_SB_VS_SYMMETRIC_RTP                               0x1E                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint8_t      rate;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) RTP_SB_VS_SYMMETRIC_RTP_STR;
#define SIZE_RTP_SB_VS_SYMMETRIC_RTP                          sizeof(RTP_SB_VS_SYMMETRIC_RTP_STR)


//Definition for struct RTP_SB_SESSION_TIMEOUT
#define RTP_SB_SESSION_TIMEOUT                                0x20                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint8_t      timeout;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) RTP_SB_SESSION_TIMEOUT_STR;
#define SIZE_RTP_SB_SESSION_TIMEOUT                           sizeof(RTP_SB_SESSION_TIMEOUT_STR)


//Definition for struct RTP_SB_VIDEO_SHARING_APPLICATION
#define RTP_SB_VIDEO_SHARING_APPLICATION                      0x1B                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      fillerbyte1;
             uint16_t     length;
             uint8_t      direction;
             uint8_t      ip_version;
             uint8_t      timer_value;
             uint8_t      num_of_subs;
            } __attribute__((packed)) RTP_SB_VIDEO_SHARING_APPLICATION_STR;
#define SIZE_RTP_SB_VIDEO_SHARING_APPLICATION                 sizeof(RTP_SB_VIDEO_SHARING_APPLICATION_STR)


//Definition for struct RTP_SB_OMA_POC_APPLICATION
#define RTP_SB_OMA_POC_APPLICATION                            0x2F                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      fillerbyte1;
             uint16_t     length;
             uint8_t      version;
             uint8_t      ip_version;
             uint8_t      timer_value;
             uint8_t      num_of_subs;
            } __attribute__((packed)) RTP_SB_OMA_POC_APPLICATION_STR;
#define SIZE_RTP_SB_OMA_POC_APPLICATION                       sizeof(RTP_SB_OMA_POC_APPLICATION_STR)


//Definition for struct RTP_SB_VOIP_APPLICATION
#define RTP_SB_VOIP_APPLICATION                               0x46                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      fillerbyte1;
             uint16_t     length;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
             uint8_t      fillerbyte4;
             uint8_t      ip_version;
             uint8_t      dscp_value;
             uint8_t      rtcp_support;
             uint8_t      timer_value;
             uint8_t      num_of_subs;
            } __attribute__((packed)) RTP_SB_VOIP_APPLICATION_STR;
#define SIZE_RTP_SB_VOIP_APPLICATION                          sizeof(RTP_SB_VOIP_APPLICATION_STR)


//Definition for struct RTP_SB_STREAM_ID
#define RTP_SB_STREAM_ID                                      0x16                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint8_t      stream_id;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) RTP_SB_STREAM_ID_STR;
#define SIZE_RTP_SB_STREAM_ID                                 sizeof(RTP_SB_STREAM_ID_STR)


//Definition for struct RTP_SB_MEDIA_BITRATE
#define RTP_SB_MEDIA_BITRATE                                  0x29                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint8_t      interpret;
             uint8_t      fillerbyte1;
             uint32_t     bitrate;
            } __attribute__((packed)) RTP_SB_MEDIA_BITRATE_STR;
#define SIZE_RTP_SB_MEDIA_BITRATE                             sizeof(RTP_SB_MEDIA_BITRATE_STR)


//Definition for struct RTP_SB_SRTP_PARM
#define RTP_SB_SRTP_PARM                                      0x48                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      fillerbyte1;
             uint16_t     length;
             uint8_t      remove_srtp_context_flag;
             uint8_t      key_derivation_rate;
             uint8_t      srtp_and_fec_order;
             uint8_t      srtp_prefix_len;
             uint16_t     rcc_rate;
             uint8_t      rcc_mode;
             uint8_t      roc_flag;
             uint32_t     roc;
             uint16_t     window_size_hint;
             uint8_t      srtp_auth_tag_len;
             uint8_t      srtcp_auth_tag_len;
             uint8_t      key_der_ps_rand_func;
             uint8_t      srtp_enc_cipher;
             uint8_t      srtcp_enc_cipher;
             uint8_t      srtp_auth_cipher;
             uint8_t      srtcp_auth_cipher;
             uint8_t      mki_len;
             uint8_t      master_key_len;
             uint8_t      master_salt_len;
             uint8_t      mki[0];
             uint8_t      master_key[0];
             uint8_t      master_salt[0];
            } __attribute__((packed)) RTP_SB_SRTP_PARM_STR;
#define SIZE_RTP_SB_SRTP_PARM                                 sizeof(RTP_SB_SRTP_PARM_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct RTP_SB_UPDATE_MEDIA
#define RTP_SB_UPDATE_MEDIA                                   0x2E                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint8_t      stream_id;
             uint8_t      num_of_subs;
            } __attribute__((packed)) RTP_SB_UPDATE_MEDIA_STR;
#define SIZE_RTP_SB_UPDATE_MEDIA                              sizeof(RTP_SB_UPDATE_MEDIA_STR)


//Definition for struct RTP_SB_PORT_FILTER
#define RTP_SB_PORT_FILTER                                    0x32                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint8_t      end_point;
             uint8_t      operation;
             uint8_t      stream_id;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      num_of_subs;
            } __attribute__((packed)) RTP_SB_PORT_FILTER_STR;
#define SIZE_RTP_SB_PORT_FILTER                               sizeof(RTP_SB_PORT_FILTER_STR)


//Definition for struct RTP_SB_SEQUENCE_NUMBER
#define RTP_SB_SEQUENCE_NUMBER                                0x17                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint16_t     seq_num;
            } __attribute__((packed)) RTP_SB_SEQUENCE_NUMBER_STR;
#define SIZE_RTP_SB_SEQUENCE_NUMBER                           sizeof(RTP_SB_SEQUENCE_NUMBER_STR)


//Definition for struct RTP_SB_UMA_APPLICATION_UPDATE
#define RTP_SB_UMA_APPLICATION_UPDATE                         0x26                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint8_t      fillerbyte1;
             uint8_t      num_of_subs;
            } __attribute__((packed)) RTP_SB_UMA_APPLICATION_UPDATE_STR;
#define SIZE_RTP_SB_UMA_APPLICATION_UPDATE                    sizeof(RTP_SB_UMA_APPLICATION_UPDATE_STR)


//Definition for struct RTP_SB_VIDEO_SHARING_APPLICATION_UPDATE
#define RTP_SB_VIDEO_SHARING_APPLICATION_UPDATE               0x2C                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      fillerbyte1;
             uint16_t     length;
             uint8_t      fillerbyte2[3];
             uint8_t      num_of_subs;
            } __attribute__((packed)) RTP_SB_VIDEO_SHARING_APPLICATION_UPDATE_STR;
#define SIZE_RTP_SB_VIDEO_SHARING_APPLICATION_UPDATE          sizeof(RTP_SB_VIDEO_SHARING_APPLICATION_UPDATE_STR)


//Definition for struct RTP_SB_OMA_POC_APPLICATION_UPDATE
#define RTP_SB_OMA_POC_APPLICATION_UPDATE                     0x31                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      fillerbyte1;
             uint16_t     length;
             uint8_t      fillerbyte2[3];
             uint8_t      num_of_subs;
            } __attribute__((packed)) RTP_SB_OMA_POC_APPLICATION_UPDATE_STR;
#define SIZE_RTP_SB_OMA_POC_APPLICATION_UPDATE                sizeof(RTP_SB_OMA_POC_APPLICATION_UPDATE_STR)


//Definition for struct RTP_SB_VOIP_APPLICATION_UPDATE
#define RTP_SB_VOIP_APPLICATION_UPDATE                        0x47                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      fillerbyte1;
             uint16_t     length;
             uint8_t      rtp_session_timer_restart;
             uint8_t      rtcp_disable;
             uint8_t      rtcp_start;
             uint8_t      num_of_subs;
            } __attribute__((packed)) RTP_SB_VOIP_APPLICATION_UPDATE_STR;
#define SIZE_RTP_SB_VOIP_APPLICATION_UPDATE                   sizeof(RTP_SB_VOIP_APPLICATION_UPDATE_STR)


//Definition for struct RTP_SB_RESERVE_PORTS
#define RTP_SB_RESERVE_PORTS                                  0x1C                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint8_t      randomize;
             uint8_t      rtcp;
             uint16_t     port_rand_min;
             uint16_t     port_rand_max;
             uint16_t     recv_rtp_port_no;
             uint16_t     recv_rtcp_port_no;
            } __attribute__((packed)) RTP_SB_RESERVE_PORTS_STR;
#define SIZE_RTP_SB_RESERVE_PORTS                             sizeof(RTP_SB_RESERVE_PORTS_STR)


//Definition for struct RTP_SB_MEDIA_STREAM_ID
#define RTP_SB_MEDIA_STREAM_ID                                0x2D                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint8_t      media_stream_id;
             uint8_t      unique_id;
            } __attribute__((packed)) RTP_SB_MEDIA_STREAM_ID_STR;
#define SIZE_RTP_SB_MEDIA_STREAM_ID                           sizeof(RTP_SB_MEDIA_STREAM_ID_STR)


//Definition for struct RTP_SB_CODEC_MEDIA_STREAM_ID
#define RTP_SB_CODEC_MEDIA_STREAM_ID                          0x35                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint8_t      media_stream_id;
             uint8_t      payload_type;
             uint8_t      direction;
             uint8_t      fillerbyte1[3];
            } __attribute__((packed)) RTP_SB_CODEC_MEDIA_STREAM_ID_STR;
#define SIZE_RTP_SB_CODEC_MEDIA_STREAM_ID                     sizeof(RTP_SB_CODEC_MEDIA_STREAM_ID_STR)


//Definition for struct RTP_SB_UL_AV_MEDIA
#define RTP_SB_UL_AV_MEDIA                                    0x21                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint8_t      payload_type;
             uint8_t      unique_id;
             uint32_t     cm_source_instance;
             uint32_t     cm_source_category;
             uint32_t     timescale;
             uint16_t     rtcp_timer_value;
             uint8_t      rtcp_timer_spec;
             uint8_t      media_payload;
            } __attribute__((packed)) RTP_SB_UL_AV_MEDIA_STR;
#define SIZE_RTP_SB_UL_AV_MEDIA                               sizeof(RTP_SB_UL_AV_MEDIA_STR)


//Definition for struct RTP_SB_DL_AV_MEDIA
#define RTP_SB_DL_AV_MEDIA                                    0x2A                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint8_t      max_packet_gap;
             uint8_t      max_packet_misorder;
             uint32_t     timescale;
             uint16_t     rtcp_timer_value;
             uint8_t      rtcp_timer_spec;
             uint8_t      payload_type;
             uint8_t      unique_id;
             uint8_t      fillerbyte1[3];
            } __attribute__((packed)) RTP_SB_DL_AV_MEDIA_STR;
#define SIZE_RTP_SB_DL_AV_MEDIA                               sizeof(RTP_SB_DL_AV_MEDIA_STR)


//Definition for struct RTP_SB_ADD_AV_MEDIA
#define RTP_SB_ADD_AV_MEDIA                                   0x1D                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      fillerbyte1;
             uint16_t     length;
             uint16_t     rtp_port_no;
             uint8_t      multiplex_medias;
             uint8_t      num_of_subs;
            } __attribute__((packed)) RTP_SB_ADD_AV_MEDIA_STR;
#define SIZE_RTP_SB_ADD_AV_MEDIA                              sizeof(RTP_SB_ADD_AV_MEDIA_STR)


//Definition for struct RTP_SB_ADD_AV_MEDIA_TO_EXISTING_MEDIA
#define RTP_SB_ADD_AV_MEDIA_TO_EXISTING_MEDIA                 0x49                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      fillerbyte1;
             uint16_t     length;
             uint16_t     fillerbyte2;
             uint8_t      media_stream_id;
             uint8_t      num_of_subs;
            } __attribute__((packed)) RTP_SB_ADD_AV_MEDIA_TO_EXISTING_MEDIA_STR;
#define SIZE_RTP_SB_ADD_AV_MEDIA_TO_EXISTING_MEDIA            sizeof(RTP_SB_ADD_AV_MEDIA_TO_EXISTING_MEDIA_STR)


//Definition for struct RTP_SB_POC_TB_PRIORITY_LEVEL
#define RTP_SB_POC_TB_PRIORITY_LEVEL                          0x37                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint8_t      priority;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) RTP_SB_POC_TB_PRIORITY_LEVEL_STR;
#define SIZE_RTP_SB_POC_TB_PRIORITY_LEVEL                     sizeof(RTP_SB_POC_TB_PRIORITY_LEVEL_STR)


//Definition for struct RTP_SB_POC_TB_REASON
#define RTP_SB_POC_TB_REASON                                  0x38                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      fillerbyte1;
             uint16_t     length;
             uint8_t      reason;
             uint8_t      reason_length;
             uint8_t      reason_text[0];
            } __attribute__((packed)) RTP_SB_POC_TB_REASON_STR;
#define SIZE_RTP_SB_POC_TB_REASON                             sizeof(RTP_SB_POC_TB_REASON_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct RTP_SB_POC_TB_REASON_CODE
#define RTP_SB_POC_TB_REASON_CODE                             0x39                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      fillerbyte1;
             uint16_t     length;
             uint8_t      reason_code;
             uint8_t      reason_length;
             uint8_t      reason_text[0];
            } __attribute__((packed)) RTP_SB_POC_TB_REASON_CODE_STR;
#define SIZE_RTP_SB_POC_TB_REASON_CODE                        sizeof(RTP_SB_POC_TB_REASON_CODE_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct RTP_SB_POC_TB_PARTICIPANTS
#define RTP_SB_POC_TB_PARTICIPANTS                            0x3C                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      fillerbyte1;
             uint16_t     length;
             uint16_t     participants;
             uint16_t     fillerbyte2;
            } __attribute__((packed)) RTP_SB_POC_TB_PARTICIPANTS_STR;
#define SIZE_RTP_SB_POC_TB_PARTICIPANTS                       sizeof(RTP_SB_POC_TB_PARTICIPANTS_STR)


//Definition for struct RTP_SB_POC_TB_STOP_TALKING_TIME
#define RTP_SB_POC_TB_STOP_TALKING_TIME                       0x41                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      fillerbyte1;
             uint16_t     length;
             uint16_t     time;
             uint16_t     fillerbyte2;
            } __attribute__((packed)) RTP_SB_POC_TB_STOP_TALKING_TIME_STR;
#define SIZE_RTP_SB_POC_TB_STOP_TALKING_TIME                  sizeof(RTP_SB_POC_TB_STOP_TALKING_TIME_STR)


//Definition for struct RTP_SB_POC_TB_REVOKE_REASON_AND_ADD_INFO
#define RTP_SB_POC_TB_REVOKE_REASON_AND_ADD_INFO              0x43                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      fillerbyte1;
             uint16_t     length;
             uint16_t     reason;
             uint16_t     add_info;
            } __attribute__((packed)) RTP_SB_POC_TB_REVOKE_REASON_AND_ADD_INFO_STR;
#define SIZE_RTP_SB_POC_TB_REVOKE_REASON_AND_ADD_INFO         sizeof(RTP_SB_POC_TB_REVOKE_REASON_AND_ADD_INFO_STR)


//Definition for struct RTP_SB_POC_TB_QUEUE_STATUS
#define RTP_SB_POC_TB_QUEUE_STATUS                            0x42                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      fillerbyte1;
             uint16_t     length;
             uint8_t      priority;
             uint8_t      fillerbyte2;
             uint16_t     queue_pos;
            } __attribute__((packed)) RTP_SB_POC_TB_QUEUE_STATUS_STR;
#define SIZE_RTP_SB_POC_TB_QUEUE_STATUS                       sizeof(RTP_SB_POC_TB_QUEUE_STATUS_STR)


//Definition for struct RTP_SB_POC_TB_SDES_CONTENT
#define RTP_SB_POC_TB_SDES_CONTENT                            0x44                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      fillerbyte1;
             uint16_t     length;
             uint16_t     sdes_content;
             uint8_t      session_type;
             uint8_t      add_ind;
            } __attribute__((packed)) RTP_SB_POC_TB_SDES_CONTENT_STR;
#define SIZE_RTP_SB_POC_TB_SDES_CONTENT                       sizeof(RTP_SB_POC_TB_SDES_CONTENT_STR)


//Definition for struct RTP_SB_LOCAL_GENERATION
#define RTP_SB_LOCAL_GENERATION                               0x3D                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint16_t     timer_value;
             uint8_t      packet_type;
             uint8_t      fillerbyte1[3];
            } __attribute__((packed)) RTP_SB_LOCAL_GENERATION_STR;
#define SIZE_RTP_SB_LOCAL_GENERATION                          sizeof(RTP_SB_LOCAL_GENERATION_STR)


//Definition for struct RTP_SB_MS_STREAMING_PP_BW_MEASURE_START
#define RTP_SB_MS_STREAMING_PP_BW_MEASURE_START               0x55                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      fillerbyte1;
             uint16_t     length;
            } __attribute__((packed)) RTP_SB_MS_STREAMING_PP_BW_MEASURE_START_STR;
#define SIZE_RTP_SB_MS_STREAMING_PP_BW_MEASURE_START          sizeof(RTP_SB_MS_STREAMING_PP_BW_MEASURE_START_STR)


//Definition for struct RTP_SB_MS_STREAMING_DATA_SEND
#define RTP_SB_MS_STREAMING_DATA_SEND                         0x56                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      fillerbyte1;
             uint16_t     length;
            } __attribute__((packed)) RTP_SB_MS_STREAMING_DATA_SEND_STR;
#define SIZE_RTP_SB_MS_STREAMING_DATA_SEND                    sizeof(RTP_SB_MS_STREAMING_DATA_SEND_STR)


//Definition for struct RTP_SB_AV_MEDIA_INFO
#define RTP_SB_AV_MEDIA_INFO                                  0x2B                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint8_t      unique_id;
             uint8_t      media_stream_id;
            } __attribute__((packed)) RTP_SB_AV_MEDIA_INFO_STR;
#define SIZE_RTP_SB_AV_MEDIA_INFO                             sizeof(RTP_SB_AV_MEDIA_INFO_STR)


//Definition for struct RTP_SB_ALLOWED_STREAMING_QOS_RATS
#define RTP_SB_ALLOWED_STREAMING_QOS_RATS                     0x4A                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      fillerbyte1;
             uint16_t     length;
             uint16_t     allowed_str_qos_rats;
             uint16_t     fillerbyte2;
            } __attribute__((packed)) RTP_SB_ALLOWED_STREAMING_QOS_RATS_STR;
#define SIZE_RTP_SB_ALLOWED_STREAMING_QOS_RATS                sizeof(RTP_SB_ALLOWED_STREAMING_QOS_RATS_STR)


//Definition for struct RTP_SB_WLAN_SSID
#define RTP_SB_WLAN_SSID                                      0x4C                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint8_t      data_length;
             uint8_t      data[0];
            } __attribute__((packed)) RTP_SB_WLAN_SSID_STR;
#define SIZE_RTP_SB_WLAN_SSID                                 sizeof(RTP_SB_WLAN_SSID_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct RTP_SB_WLAN_WEP
#define RTP_SB_WLAN_WEP                                       0x4D                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint8_t      wep_mode;
             uint8_t      default_key;
             uint8_t      key_length;
             uint8_t      data[0];
            } __attribute__((packed)) RTP_SB_WLAN_WEP_STR;
#define SIZE_RTP_SB_WLAN_WEP                                  sizeof(RTP_SB_WLAN_WEP_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct RTP_SB_WLAN_WPA
#define RTP_SB_WLAN_WPA                                       0x4E                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint8_t      key_length;
             uint8_t      data[0];
            } __attribute__((packed)) RTP_SB_WLAN_WPA_STR;
#define SIZE_RTP_SB_WLAN_WPA                                  sizeof(RTP_SB_WLAN_WPA_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct RTP_SB_WLAN_PROFILE
#define RTP_SB_WLAN_PROFILE                                   0x4B                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint8_t      security_mode;
             uint8_t      num_of_subs;
            } __attribute__((packed)) RTP_SB_WLAN_PROFILE_STR;
#define SIZE_RTP_SB_WLAN_PROFILE                              sizeof(RTP_SB_WLAN_PROFILE_STR)


//Definition for struct RTP_SB_LINK_SETTINGS
#define RTP_SB_LINK_SETTINGS                                  0x3E                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      fillerbyte1;
             uint16_t     length;
             uint8_t      open_order;
             uint8_t      usage_order;
             uint8_t      create_timer_value;
             uint8_t      num_of_subs;
            } __attribute__((packed)) RTP_SB_LINK_SETTINGS_STR;
#define SIZE_RTP_SB_LINK_SETTINGS                             sizeof(RTP_SB_LINK_SETTINGS_STR)


//Definition for struct RTP_SB_DOMAIN_NAME
#define RTP_SB_DOMAIN_NAME                                    0x40                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      fillerbyte1;
             uint16_t     length;
             uint8_t      ip_version;
             uint8_t      ip_preference;
             uint8_t      domain_name[0];
            } __attribute__((packed)) RTP_SB_DOMAIN_NAME_STR;
#define SIZE_RTP_SB_DOMAIN_NAME                               sizeof(RTP_SB_DOMAIN_NAME_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct RTP_SB_DOMAIN_RESOLVE_RESULT
#define RTP_SB_DOMAIN_RESOLVE_RESULT                          0x3F                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      fillerbyte1;
             uint16_t     length;
             uint8_t      fillerbyte2[3];
             uint8_t      num_of_subs;
            } __attribute__((packed)) RTP_SB_DOMAIN_RESOLVE_RESULT_STR;
#define SIZE_RTP_SB_DOMAIN_RESOLVE_RESULT                     sizeof(RTP_SB_DOMAIN_RESOLVE_RESULT_STR)


//Definition for struct RTP_SB_MODIFY_PORTS
#define RTP_SB_MODIFY_PORTS                                   0x45                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      fillerbyte1;
             uint16_t     length;
             uint16_t     fillerbyte2;
             uint8_t      mod_opt;
             uint8_t      num_of_subs;
            } __attribute__((packed)) RTP_SB_MODIFY_PORTS_STR;
#define SIZE_RTP_SB_MODIFY_PORTS                              sizeof(RTP_SB_MODIFY_PORTS_STR)


//Definition for struct RTP_SB_MS_STREAMING_APPLICATION_UPDATE
#define RTP_SB_MS_STREAMING_APPLICATION_UPDATE                0x53                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      fillerbyte1;
             uint16_t     length;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
             uint8_t      send_data_flag;
             uint8_t      num_of_subs;
            } __attribute__((packed)) RTP_SB_MS_STREAMING_APPLICATION_UPDATE_STR;
#define SIZE_RTP_SB_MS_STREAMING_APPLICATION_UPDATE           sizeof(RTP_SB_MS_STREAMING_APPLICATION_UPDATE_STR)


//Definition for struct RTP_SB_MS_MEDIA_STREAM
#define RTP_SB_MS_MEDIA_STREAM                                0x52                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint16_t     recv_rtp_port_no;
             uint32_t     timescale;
             uint32_t     ssrc;
             uint8_t      ssrc_flag;
             uint8_t      payload_type;
             uint16_t     port_rand_min;
             uint16_t     port_rand_max;
             uint8_t      unique_id;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) RTP_SB_MS_MEDIA_STREAM_STR;
#define SIZE_RTP_SB_MS_MEDIA_STREAM                           sizeof(RTP_SB_MS_MEDIA_STREAM_STR)


//Definition for struct RTP_SB_MS_STREAMING_APPLICATION
#define RTP_SB_MS_STREAMING_APPLICATION                       0x51                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      fillerbyte1;
             uint16_t     length;
             uint32_t     cm_source_instance;
             uint32_t     cm_source_category;
             uint8_t      ip_version;
             uint8_t      streaming_mode;
             uint8_t      retransmission;
             uint8_t      num_of_subs;
            } __attribute__((packed)) RTP_SB_MS_STREAMING_APPLICATION_STR;
#define SIZE_RTP_SB_MS_STREAMING_APPLICATION                  sizeof(RTP_SB_MS_STREAMING_APPLICATION_STR)


//Definition for struct RTP_SB_RM_STREAMING_APPLICATION
#define RTP_SB_RM_STREAMING_APPLICATION                       0x57                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      fillerbyte1;
             uint16_t     length;
             uint8_t      real_streaming_mode;
             uint8_t      rdt_version;
             uint8_t      ip_version;
             uint8_t      fillerbyte2;
             uint16_t     port_rand_min;
             uint16_t     port_rand_max;
             uint32_t     rtp_rm_buffer_info_func_ptr;
             uint32_t     rtp_rm_buffer_info_func_param_ptr;
             uint8_t      rdt_bw_info_needed;
             uint8_t      number_of_streams;
             uint8_t      stream_id[0];
            } __attribute__((packed)) RTP_SB_RM_STREAMING_APPLICATION_STR;
#define SIZE_RTP_SB_RM_STREAMING_APPLICATION                  sizeof(RTP_SB_RM_STREAMING_APPLICATION_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct RTP_SB_RM_STREAMING_APPLICATION_UPDATE
#define RTP_SB_RM_STREAMING_APPLICATION_UPDATE                0x58                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint16_t     send_port;
             uint8_t      fillerbyte1[3];
             uint8_t      ip_addr_len;
             uint8_t      ip_addr[16];
            } __attribute__((packed)) RTP_SB_RM_STREAMING_APPLICATION_UPDATE_STR;
#define SIZE_RTP_SB_RM_STREAMING_APPLICATION_UPDATE           sizeof(RTP_SB_RM_STREAMING_APPLICATION_UPDATE_STR)


//Definition for struct RTP_SB_VALUE
#define RTP_SB_VALUE                                          0x59                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint16_t     name;
             uint32_t     value;
            } __attribute__((packed)) RTP_SB_VALUE_STR;
#define SIZE_RTP_SB_VALUE                                     sizeof(RTP_SB_VALUE_STR)


//Definition for struct RTP_SB_MBMS_MEDIA
#define RTP_SB_MBMS_MEDIA                                     0x5A                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint16_t     recv_rtp_port_no;
             uint32_t     ssrc;
             uint8_t      ssrc_flag;
             uint8_t      unique_id;
             uint8_t      fec_usage_flag;
             uint8_t      fillerbyte1;
             uint16_t     srtp_buffer_len;
             uint8_t      fillerbyte2;
             uint8_t      num_of_subs;
            } __attribute__((packed)) RTP_SB_MBMS_MEDIA_STR;
#define SIZE_RTP_SB_MBMS_MEDIA                                sizeof(RTP_SB_MBMS_MEDIA_STR)


//Definition for struct RTP_SB_MBMS_APPLICATION
#define RTP_SB_MBMS_APPLICATION                               0x5B                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      fillerbyte1;
             uint16_t     length;
             uint8_t      ip_version;
             uint8_t      rtcp_support;
             uint8_t      timer_value;
             uint8_t      num_of_subs;
            } __attribute__((packed)) RTP_SB_MBMS_APPLICATION_STR;
#define SIZE_RTP_SB_MBMS_APPLICATION                          sizeof(RTP_SB_MBMS_APPLICATION_STR)


//Definition for struct RTP_SB_MBMS_APPLICATION_UPDATE
#define RTP_SB_MBMS_APPLICATION_UPDATE                        0x5D                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      fillerbyte1;
             uint16_t     length;
             uint8_t      fillerbyte2[3];
             uint8_t      num_of_subs;
            } __attribute__((packed)) RTP_SB_MBMS_APPLICATION_UPDATE_STR;
#define SIZE_RTP_SB_MBMS_APPLICATION_UPDATE                   sizeof(RTP_SB_MBMS_APPLICATION_UPDATE_STR)


//MESSAGES


//Definition for struct RTP_CREATE_REQ
#define RTP_CREATE_REQ                                        0x00                                                     
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint8_t      bearer_type;
             uint8_t      application_id;
             uint16_t     fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      num_of_subs;
            } __attribute__((packed)) RTP_CREATE_REQ_STR;
#define SIZE_RTP_CREATE_REQ                                   sizeof(RTP_CREATE_REQ_STR)


//Definition for struct RTP_CREATE_RESP
#define RTP_CREATE_RESP                                       0x01                                                     
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint8_t      session_id;
             uint8_t      status;
            } __attribute__((packed)) RTP_CREATE_RESP_STR;
#define SIZE_RTP_CREATE_RESP                                  sizeof(RTP_CREATE_RESP_STR)


//Definition for struct RTP_PARM_UPDATE_REQ
#define RTP_PARM_UPDATE_REQ                                   0x02                                                     
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint8_t      session_id;
             uint8_t      num_of_subs;
            } __attribute__((packed)) RTP_PARM_UPDATE_REQ_STR;
#define SIZE_RTP_PARM_UPDATE_REQ                              sizeof(RTP_PARM_UPDATE_REQ_STR)


//Definition for struct RTP_PARM_UPDATE_RESP
#define RTP_PARM_UPDATE_RESP                                  0x03                                                     
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint8_t      session_id;
             uint8_t      status;
            } __attribute__((packed)) RTP_PARM_UPDATE_RESP_STR;
#define SIZE_RTP_PARM_UPDATE_RESP                             sizeof(RTP_PARM_UPDATE_RESP_STR)


//Definition for struct RTP_TERMINATE_REQ
#define RTP_TERMINATE_REQ                                     0x04                                                     
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint8_t      session_id;
            } __attribute__((packed)) RTP_TERMINATE_REQ_STR;
#define SIZE_RTP_TERMINATE_REQ                                sizeof(RTP_TERMINATE_REQ_STR)


//Definition for struct RTP_TERMINATE_RESP
#define RTP_TERMINATE_RESP                                    0x05                                                     
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint8_t      session_id;
             uint8_t      status;
            } __attribute__((packed)) RTP_TERMINATE_RESP_STR;
#define SIZE_RTP_TERMINATE_RESP                               sizeof(RTP_TERMINATE_RESP_STR)


//Definition for struct RTP_POC_CTRL_MSG_REQ
#define RTP_POC_CTRL_MSG_REQ                                  0x08                                                     
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint8_t      session_id;
             uint8_t      repeat_counter;
             uint8_t      delay;
             uint8_t      control_packet_type;
             uint8_t      use_padding;
             uint8_t      fillerbyte1;
             uint32_t     ssrc;
             uint16_t     send_rtp_port_no;
             uint8_t      ip_addr_len;
             uint8_t      ip_addr[16];
             uint8_t      fillerbyte2;
             uint16_t     payload_len;
             uint8_t      payload[0];
            } __attribute__((packed)) RTP_POC_CTRL_MSG_REQ_STR;
#define SIZE_RTP_POC_CTRL_MSG_REQ                             sizeof(RTP_POC_CTRL_MSG_REQ_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct RTP_POC_CTRL_MSG_RESP
#define RTP_POC_CTRL_MSG_RESP                                 0x09                                                     
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint8_t      session_id;
             uint8_t      status;
            } __attribute__((packed)) RTP_POC_CTRL_MSG_RESP_STR;
#define SIZE_RTP_POC_CTRL_MSG_RESP                            sizeof(RTP_POC_CTRL_MSG_RESP_STR)


//Definition for struct RTP_POC_CTRL_MSG_RECV_NTF
#define RTP_POC_CTRL_MSG_RECV_NTF                             0x07                                                     
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint8_t      session_id;
             uint8_t      fillerbyte1;
             uint32_t     ssrc;
             uint16_t     port;
             uint16_t     payload_len;
             uint8_t      payload[0];
            } __attribute__((packed)) RTP_POC_CTRL_MSG_RECV_NTF_STR;
#define SIZE_RTP_POC_CTRL_MSG_RECV_NTF                        sizeof(RTP_POC_CTRL_MSG_RECV_NTF_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct RTP_STATUS_NTF
#define RTP_STATUS_NTF                                        0x06                                                     
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint8_t      session_id;
             uint8_t      status;
             uint8_t      fillerbyte1[3];
             uint8_t      num_of_subs;
            } __attribute__((packed)) RTP_STATUS_NTF_STR;
#define SIZE_RTP_STATUS_NTF                                   sizeof(RTP_STATUS_NTF_STR)


//Definition for struct RTP_POC_DATA_NTF
#define RTP_POC_DATA_NTF                                      0x0A                                                     
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint16_t     session_id;
             uint8_t      marker_bit;
             uint8_t      payload_type;
             uint16_t     sequence_number;
             uint16_t     ssrc_up;
             uint16_t     ssrc_dn;
             uint16_t     data_length;
             uint8_t      amr_ietf_data[0];
            } __attribute__((packed)) RTP_POC_DATA_NTF_STR;
#define SIZE_RTP_POC_DATA_NTF                                 sizeof(RTP_POC_DATA_NTF_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct RTP_RTCP_SENDER_REPORT_NTF
#define RTP_RTCP_SENDER_REPORT_NTF                            0x0B                                                     
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint8_t      session_id;
             uint8_t      media_stream_id;
             uint32_t     ssrc;
             uint8_t      fillerbyte1[3];
             uint8_t      num_of_subs;
            } __attribute__((packed)) RTP_RTCP_SENDER_REPORT_NTF_STR;
#define SIZE_RTP_RTCP_SENDER_REPORT_NTF                       sizeof(RTP_RTCP_SENDER_REPORT_NTF_STR)


//Definition for struct RTP_RTCP_RECEIVER_REPORT_NTF
#define RTP_RTCP_RECEIVER_REPORT_NTF                          0x2C                                                  
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint8_t      session_id;
             uint8_t      media_stream_id;
             uint32_t     ssrc;
             uint8_t      fillerbyte1[3];
             uint8_t      num_of_subs;
            } __attribute__((packed)) RTP_RTCP_RECEIVER_REPORT_NTF_STR;
#define SIZE_RTP_RTCP_RECEIVER_REPORT_NTF                     sizeof(RTP_RTCP_RECEIVER_REPORT_NTF_STR)


//Definition for struct RTP_RESTART_STREAM_REQ
#define RTP_RESTART_STREAM_REQ                                0x0C                                                     
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint8_t      session_id;
             uint8_t      media_stream_id;
            } __attribute__((packed)) RTP_RESTART_STREAM_REQ_STR;
#define SIZE_RTP_RESTART_STREAM_REQ                           sizeof(RTP_RESTART_STREAM_REQ_STR)


//Definition for struct RTP_RESTART_STREAM_RESP
#define RTP_RESTART_STREAM_RESP                               0x0D                                                     
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint8_t      session_id;
             uint8_t      media_stream_id;
             uint8_t      status;
            } __attribute__((packed)) RTP_RESTART_STREAM_RESP_STR;
#define SIZE_RTP_RESTART_STREAM_RESP                          sizeof(RTP_RESTART_STREAM_RESP_STR)


//Definition for struct RTP_STREAM_PAUSED_REQ
#define RTP_STREAM_PAUSED_REQ                                 0x11                                                  
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint8_t      session_id;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) RTP_STREAM_PAUSED_REQ_STR;
#define SIZE_RTP_STREAM_PAUSED_REQ                            sizeof(RTP_STREAM_PAUSED_REQ_STR)


//Definition for struct RTP_STREAM_PAUSED_RESP
#define RTP_STREAM_PAUSED_RESP                                0x12                                                  
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint8_t      session_id;
             uint8_t      status;
            } __attribute__((packed)) RTP_STREAM_PAUSED_RESP_STR;
#define SIZE_RTP_STREAM_PAUSED_RESP                           sizeof(RTP_STREAM_PAUSED_RESP_STR)


//Definition for struct RTP_POC_GET_STATISTIC_REQ
#define RTP_POC_GET_STATISTIC_REQ                             0x0E                                                     
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint8_t      session_id;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) RTP_POC_GET_STATISTIC_REQ_STR;
#define SIZE_RTP_POC_GET_STATISTIC_REQ                        sizeof(RTP_POC_GET_STATISTIC_REQ_STR)


//Definition for struct RTP_POC_GET_STATISTIC_RESP
#define RTP_POC_GET_STATISTIC_RESP                            0x0F                                                     
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint8_t      session_id;
             uint8_t      status;
             uint8_t      fillerbyte1[3];
             uint8_t      num_of_subs;
            } __attribute__((packed)) RTP_POC_GET_STATISTIC_RESP_STR;
#define SIZE_RTP_POC_GET_STATISTIC_RESP                       sizeof(RTP_POC_GET_STATISTIC_RESP_STR)


//Definition for struct RTP_POC_REPLAY_REQ
#define RTP_POC_REPLAY_REQ                                    0x13                                                  
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint8_t      session_id;
             uint8_t      mode;
            } __attribute__((packed)) RTP_POC_REPLAY_REQ_STR;
#define SIZE_RTP_POC_REPLAY_REQ                               sizeof(RTP_POC_REPLAY_REQ_STR)


//Definition for struct RTP_POC_REPLAY_RESP
#define RTP_POC_REPLAY_RESP                                   0x14                                                  
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint8_t      session_id;
             uint8_t      status;
             uint8_t      cause;
             uint8_t      fillerbyte1[3];
            } __attribute__((packed)) RTP_POC_REPLAY_RESP_STR;
#define SIZE_RTP_POC_REPLAY_RESP                              sizeof(RTP_POC_REPLAY_RESP_STR)


//Definition for struct RTP_START_AUDIO_STREAM_REQ
#define RTP_START_AUDIO_STREAM_REQ                            0x15                                                  
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint8_t      session_id;
             uint8_t      direction;
             uint8_t      fillerbyte1[3];
             uint8_t      num_of_subs;
            } __attribute__((packed)) RTP_START_AUDIO_STREAM_REQ_STR;
#define SIZE_RTP_START_AUDIO_STREAM_REQ                       sizeof(RTP_START_AUDIO_STREAM_REQ_STR)


//Definition for struct RTP_START_AUDIO_STREAM_RESP
#define RTP_START_AUDIO_STREAM_RESP                           0x16                                                  
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint8_t      session_id;
             uint8_t      status;
             uint8_t      cause;
             uint8_t      fillerbyte1[3];
            } __attribute__((packed)) RTP_START_AUDIO_STREAM_RESP_STR;
#define SIZE_RTP_START_AUDIO_STREAM_RESP                      sizeof(RTP_START_AUDIO_STREAM_RESP_STR)


//Definition for struct RTP_STOP_AUDIO_STREAM_REQ
#define RTP_STOP_AUDIO_STREAM_REQ                             0x17                                                  
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint8_t      session_id;
             uint8_t      mode;
             uint8_t      fillerbyte1[3];
             uint8_t      num_of_subs;
            } __attribute__((packed)) RTP_STOP_AUDIO_STREAM_REQ_STR;
#define SIZE_RTP_STOP_AUDIO_STREAM_REQ                        sizeof(RTP_STOP_AUDIO_STREAM_REQ_STR)


//Definition for struct RTP_STOP_AUDIO_STREAM_RESP
#define RTP_STOP_AUDIO_STREAM_RESP                            0x18                                                  
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint8_t      session_id;
             uint8_t      status;
             uint8_t      cause;
             uint8_t      fillerbyte1[3];
            } __attribute__((packed)) RTP_STOP_AUDIO_STREAM_RESP_STR;
#define SIZE_RTP_STOP_AUDIO_STREAM_RESP                       sizeof(RTP_STOP_AUDIO_STREAM_RESP_STR)


//Definition for struct RTP_ADD_PORTS_REQ
#define RTP_ADD_PORTS_REQ                                     0x19                                                  
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint8_t      session_id;
             uint8_t      num_of_subs;
            } __attribute__((packed)) RTP_ADD_PORTS_REQ_STR;
#define SIZE_RTP_ADD_PORTS_REQ                                sizeof(RTP_ADD_PORTS_REQ_STR)


//Definition for struct RTP_ADD_PORTS_RESP
#define RTP_ADD_PORTS_RESP                                    0x1A                                                  
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint8_t      session_id;
             uint8_t      status;
            } __attribute__((packed)) RTP_ADD_PORTS_RESP_STR;
#define SIZE_RTP_ADD_PORTS_RESP                               sizeof(RTP_ADD_PORTS_RESP_STR)


//Definition for struct RTP_REMOVE_PORTS_REQ
#define RTP_REMOVE_PORTS_REQ                                  0x1B                                                  
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint8_t      session_id;
             uint8_t      num_of_subs;
            } __attribute__((packed)) RTP_REMOVE_PORTS_REQ_STR;
#define SIZE_RTP_REMOVE_PORTS_REQ                             sizeof(RTP_REMOVE_PORTS_REQ_STR)


//Definition for struct RTP_REMOVE_PORTS_RESP
#define RTP_REMOVE_PORTS_RESP                                 0x1C                                                  
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint8_t      session_id;
             uint8_t      status;
            } __attribute__((packed)) RTP_REMOVE_PORTS_RESP_STR;
#define SIZE_RTP_REMOVE_PORTS_RESP                            sizeof(RTP_REMOVE_PORTS_RESP_STR)


//Definition for struct RTP_ADD_MEDIA_REQ
#define RTP_ADD_MEDIA_REQ                                     0x1D                                                  
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint8_t      session_id;
             uint8_t      num_of_subs;
            } __attribute__((packed)) RTP_ADD_MEDIA_REQ_STR;
#define SIZE_RTP_ADD_MEDIA_REQ                                sizeof(RTP_ADD_MEDIA_REQ_STR)


//Definition for struct RTP_ADD_MEDIA_RESP
#define RTP_ADD_MEDIA_RESP                                    0x1E                                                  
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint8_t      session_id;
             uint8_t      status;
            } __attribute__((packed)) RTP_ADD_MEDIA_RESP_STR;
#define SIZE_RTP_ADD_MEDIA_RESP                               sizeof(RTP_ADD_MEDIA_RESP_STR)


//Definition for struct RTP_REMOVE_MEDIA_REQ
#define RTP_REMOVE_MEDIA_REQ                                  0x23                                                  
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint8_t      session_id;
             uint8_t      num_of_subs;
            } __attribute__((packed)) RTP_REMOVE_MEDIA_REQ_STR;
#define SIZE_RTP_REMOVE_MEDIA_REQ                             sizeof(RTP_REMOVE_MEDIA_REQ_STR)


//Definition for struct RTP_REMOVE_MEDIA_RESP
#define RTP_REMOVE_MEDIA_RESP                                 0x24                                                  
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint8_t      session_id;
             uint8_t      status;
            } __attribute__((packed)) RTP_REMOVE_MEDIA_RESP_STR;
#define SIZE_RTP_REMOVE_MEDIA_RESP                            sizeof(RTP_REMOVE_MEDIA_RESP_STR)


//Definition for struct RTP_ADD_LINK_REQ
#define RTP_ADD_LINK_REQ                                      0x1F                                                  
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint8_t      session_id;
             uint8_t      num_of_subs;
            } __attribute__((packed)) RTP_ADD_LINK_REQ_STR;
#define SIZE_RTP_ADD_LINK_REQ                                 sizeof(RTP_ADD_LINK_REQ_STR)


//Definition for struct RTP_ADD_LINK_RESP
#define RTP_ADD_LINK_RESP                                     0x20                                                  
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint8_t      session_id;
             uint8_t      status;
            } __attribute__((packed)) RTP_ADD_LINK_RESP_STR;
#define SIZE_RTP_ADD_LINK_RESP                                sizeof(RTP_ADD_LINK_RESP_STR)


//Definition for struct RTP_REMOVE_LINK_REQ
#define RTP_REMOVE_LINK_REQ                                   0x21                                                  
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint8_t      session_id;
             uint8_t      link_id;
             uint8_t      res_id;
             uint8_t      fillerbyte1[3];
            } __attribute__((packed)) RTP_REMOVE_LINK_REQ_STR;
#define SIZE_RTP_REMOVE_LINK_REQ                              sizeof(RTP_REMOVE_LINK_REQ_STR)


//Definition for struct RTP_REMOVE_LINK_RESP
#define RTP_REMOVE_LINK_RESP                                  0x22                                                  
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint8_t      session_id;
             uint8_t      status;
            } __attribute__((packed)) RTP_REMOVE_LINK_RESP_STR;
#define SIZE_RTP_REMOVE_LINK_RESP                             sizeof(RTP_REMOVE_LINK_RESP_STR)


//Definition for struct RTP_FLUSH_BUFFER_REQ
#define RTP_FLUSH_BUFFER_REQ                                  0x25                                                  
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint8_t      session_id;
             uint8_t      num_of_subs;
            } __attribute__((packed)) RTP_FLUSH_BUFFER_REQ_STR;
#define SIZE_RTP_FLUSH_BUFFER_REQ                             sizeof(RTP_FLUSH_BUFFER_REQ_STR)


//Definition for struct RTP_FLUSH_BUFFER_RESP
#define RTP_FLUSH_BUFFER_RESP                                 0x26                                                  
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint8_t      session_id;
             uint8_t      status;
            } __attribute__((packed)) RTP_FLUSH_BUFFER_RESP_STR;
#define SIZE_RTP_FLUSH_BUFFER_RESP                            sizeof(RTP_FLUSH_BUFFER_RESP_STR)


//Definition for struct RTP_OMA_POC_TALK_BURST_CTRL_REQ
#define RTP_OMA_POC_TALK_BURST_CTRL_REQ                       0x27                                                  
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint8_t      session_id;
             uint8_t      stream_id;
             uint16_t     nwk_tbcp_port;
             uint8_t      msg_type;
             uint8_t      num_of_subs;
            } __attribute__((packed)) RTP_OMA_POC_TALK_BURST_CTRL_REQ_STR;
#define SIZE_RTP_OMA_POC_TALK_BURST_CTRL_REQ                  sizeof(RTP_OMA_POC_TALK_BURST_CTRL_REQ_STR)


//Definition for struct RTP_OMA_POC_TALK_BURST_CTRL_RESP
#define RTP_OMA_POC_TALK_BURST_CTRL_RESP                      0x28                                                  
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint8_t      session_id;
             uint8_t      status;
            } __attribute__((packed)) RTP_OMA_POC_TALK_BURST_CTRL_RESP_STR;
#define SIZE_RTP_OMA_POC_TALK_BURST_CTRL_RESP                 sizeof(RTP_OMA_POC_TALK_BURST_CTRL_RESP_STR)


//Definition for struct RTP_OMA_POC_TALK_BURST_CTRL_NTF
#define RTP_OMA_POC_TALK_BURST_CTRL_NTF                       0x29                                                  
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint8_t      session_id;
             uint8_t      stream_id;
             uint16_t     nwk_tbcp_port;
             uint16_t     fillerbyte1;
             uint32_t     tbcp_ssrc;
             uint8_t      msg_type;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
             uint8_t      num_of_subs;
            } __attribute__((packed)) RTP_OMA_POC_TALK_BURST_CTRL_NTF_STR;
#define SIZE_RTP_OMA_POC_TALK_BURST_CTRL_NTF                  sizeof(RTP_OMA_POC_TALK_BURST_CTRL_NTF_STR)


//Definition for struct RTP_RESOLVE_ADDRESS_REQ
#define RTP_RESOLVE_ADDRESS_REQ                               0x2A                                                  
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint8_t      session_id;
             uint8_t      link_id;
             uint8_t      fillerbyte1[3];
             uint8_t      num_of_subs;
            } __attribute__((packed)) RTP_RESOLVE_ADDRESS_REQ_STR;
#define SIZE_RTP_RESOLVE_ADDRESS_REQ                          sizeof(RTP_RESOLVE_ADDRESS_REQ_STR)


//Definition for struct RTP_RESOLVE_ADDRESS_RESP
#define RTP_RESOLVE_ADDRESS_RESP                              0x2B                                                  
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint8_t      session_id;
             uint8_t      status;
             uint8_t      fillerbyte1[3];
             uint8_t      num_of_subs;
            } __attribute__((packed)) RTP_RESOLVE_ADDRESS_RESP_STR;
#define SIZE_RTP_RESOLVE_ADDRESS_RESP                         sizeof(RTP_RESOLVE_ADDRESS_RESP_STR)


//Definition for struct RTP_SEND_RTCP_REQ
#define RTP_SEND_RTCP_REQ                                     0x2D                                                  
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint8_t      session_id;
             uint8_t      ul_stream_id;
             uint8_t      dl_stream_id;
             uint8_t      rtcp_type;
             uint8_t      rtcp_packets;
             uint8_t      sdes_chunk;
             uint16_t     nwk_port;
             uint8_t      ssrc_remove;
             uint8_t      num_of_subs;
            } __attribute__((packed)) RTP_SEND_RTCP_REQ_STR;
#define SIZE_RTP_SEND_RTCP_REQ                                sizeof(RTP_SEND_RTCP_REQ_STR)


//Definition for struct RTP_SEND_RTCP_RESP
#define RTP_SEND_RTCP_RESP                                    0x2E                                                  
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint8_t      session_id;
             uint8_t      status;
            } __attribute__((packed)) RTP_SEND_RTCP_RESP_STR;
#define SIZE_RTP_SEND_RTCP_RESP                               sizeof(RTP_SEND_RTCP_RESP_STR)


//Definition for struct RTP_MODIFY_LINK_REQ
#define RTP_MODIFY_LINK_REQ                                   0x2F                                                  
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint8_t      session_id;
             uint8_t      link_id;
             uint16_t     fillerbyte1;
             uint8_t      res_id;
             uint8_t      num_of_subs;
            } __attribute__((packed)) RTP_MODIFY_LINK_REQ_STR;
#define SIZE_RTP_MODIFY_LINK_REQ                              sizeof(RTP_MODIFY_LINK_REQ_STR)


//Definition for struct RTP_MODIFY_LINK_RESP
#define RTP_MODIFY_LINK_RESP                                  0x30                                                  
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint8_t      session_id;
             uint8_t      status;
            } __attribute__((packed)) RTP_MODIFY_LINK_RESP_STR;
#define SIZE_RTP_MODIFY_LINK_RESP                             sizeof(RTP_MODIFY_LINK_RESP_STR)


//Definition for struct RTP_SEND_RDT_REQ
#define RTP_SEND_RDT_REQ                                      0x31                                                  
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint8_t      session_id;
             uint8_t      fillerbyte1;
             uint16_t     rdt_packet_type;
             uint8_t      num_of_subs;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) RTP_SEND_RDT_REQ_STR;
#define SIZE_RTP_SEND_RDT_REQ                                 sizeof(RTP_SEND_RDT_REQ_STR)


//Definition for struct RTP_SEND_RDT_RESP
#define RTP_SEND_RDT_RESP                                     0x32                                                  
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint8_t      session_id;
             uint8_t      status;
            } __attribute__((packed)) RTP_SEND_RDT_RESP_STR;
#define SIZE_RTP_SEND_RDT_RESP                                sizeof(RTP_SEND_RDT_RESP_STR)


//Definition for struct RTP_RTCP_BYE_NTF
#define RTP_RTCP_BYE_NTF                                      0x10                                                  
typedef struct
            { 
             uint8_t      transaction_id;
             uint8_t      message_id;
             uint8_t      session_id;
             uint8_t      media_stream_id;
             uint32_t     ssrc;
             uint8_t      fillerbyte1[3];
             uint8_t      num_of_subs;
            } __attribute__((packed)) RTP_RTCP_BYE_NTF_STR;
#define SIZE_RTP_RTCP_BYE_NTF                                 sizeof(RTP_RTCP_BYE_NTF_STR)

#endif
