#ifndef _PN_SIP_ISI_H_
#define _PN_SIP_ISI_H_

#include <stdint.h> 

//Resource SIP Server
//PN_SIP 0x73 
//ISI version 014.001
#define SIP_SERVER_ISI_VERSION_Z     14
#define SIP_SERVER_ISI_VERSION_Y     1

//In case of problems concerning content of this file contact Markku Loukusa, Sauli Laukka or Markus Mrsky
//Server specific message descriptions and feature&protocol descriptions can be found from: https://oucmswww.nmp.nokia.com:58443/document_browser/ccm_wa/GIF_SPECS/ 


//ISI VERSION CHANGE HISTORY

//Version: 014.001                                           
//Status: Approved                                          
//Date: 26-Aug-2008     Ville Kukkola
//Reason: Approved version
//Reference: PCP Errors DB: VK08050836512 S40 IETF VoIP : Transport resolved by DNS NAPTR query is not correctly used  , Inspection minutes in Lotus Notes, ActionDB for SWAM: VK08081135684 , APPROVED

//Version: 014.000                                           
//Status: Proposal                                          
//Date: 11-Aug-2008     Ville Kukkola
//Reason: Proposed version
//Reference: PCP Errors DB: VK08050836512 S40 IETF VoIP : Transport resolved by DNS NAPTR query is not correctly used  , Inspection minutes in Lotus Notes, ActionDB for SWAM: VK08081135684 , PROPOSAL

//Version: 013.001                                           
//Status: Approved                                          
//Date: 14-Aug-2007     Ville Kukkola
//Reason: Approved version
//Reference: RM/RIM REQ: 414-1149: S40: Secure VoIP Call using SIPS and SRTP with Security Descriptions , CR: ADB for SWAM SW_ARCH/ISI-SPEC PROTOCOLS/SPECIFICATION: VK07082827884 , CR: ADB for SWAM SW_ARCH/ISI-SPEC PROTOCOLS/SPECIFICATION: VK07090427788 , Inspection minutes in Lotus Notes, ActionDB for SWAM: VK07090740300 , APPROVED

//Version: 013.000                                           
//Status: Proposal                                          
//Date: 07-Aug-2007     Ville Kukkola
//Reason: Proposed version
//Reference: RM/RIM REQ: 414-1149: S40: Secure VoIP Call using SIPS and SRTP with Security Descriptions , CR: ADB for SWAM SW_ARCH/ISI-SPEC PROTOCOLS/SPECIFICATION: VK07082827884 , CR: ADB for SWAM SW_ARCH/ISI-SPEC PROTOCOLS/SPECIFICATION: VK07090427788 , Inspection minutes in Lotus Notes, ActionDB for SWAM: VK07090740300 , PROPOSAL

//Version: 012.001                                           
//Status: Approved                                          
//Date: 28-May-2007     Ville Kukkola
//Reason: Approved version
//Reference: CR: ADB for SWAM SW_ARCH/ISI-SPEC PROTOCOLS/SPECIFICATION: VK07050864191 , Inspection minutes in Lotus Notes, ActionDB for SWAM: VK07051854514 , APPROVED

//Version: 012.000                                           
//Status: Proposal                                          
//Date: 03-May-2007     Ville Kukkola
//Reason: Proposal version
//Reference: CR: ADB for SWAM SW_ARCH/ISI-SPEC PROTOCOLS/SPECIFICATION: VK07050864191 , Inspection minutes in Lotus Notes, ActionDB for SWAM: VK07051854514 , PROPOSAL

//Version: 011.003                                           
//Status: Approved                                          
//Date: 22-Jan-2007     Ville Kukkola
//Reason: Approved version
//Reference: Inspection minutes in Lotus Notes, ActionDB for SWAM: VK07011058305 CR: ADB for SWAM SW_ARCH/ISI-SPEC PROTOCOLS/SPECIFICATION: VK06110336377 , APPROVED

//Version: 011.002                                           
//Status: Proposal                                          
//Date: 10-Jan-2007     Ville Kukkola
//Reason: Proposal version
//Reference: Inspection minutes in Lotus Notes, ActionDB for SWAM: VK07011058305 CR: ADB for SWAM SW_ARCH/ISI-SPEC PROTOCOLS/SPECIFICATION: VK06110336377 , PROPOSAL

//Version: 011.001                                           
//Status: Approved                                          
//Date: 20-Sep-2006     Ville Kukkola
//Reason: Approved version
//Reference: Inspection minutes in Lotus Notes, ActionDB for SWAM: VK06091928014 CR: ADB for SWAM SW_ARCH/ISI-SPEC PROTOCOLS/SPECIFICATION: VK06090643253 , APPROVED

//Version: 011.000                                           
//Status: Proposal                                          
//Date: 19-Sep-2006     Ville Kukkola
//Reason: Proposal version
//Reference: Inspection minutes in Lotus Notes, ActionDB for SWAM: VK06091928014 CR: ADB for SWAM SW_ARCH/ISI-SPEC PROTOCOLS/SPECIFICATION: VK06090643253 , PROPOSAL

//Version: 010.001                                           
//Status: Approved                                          
//Date: 30-May-2006     Ville Kukkola
//Reason: Approved version
//Reference: Inspection minutes in Lotus Notes, ActionDB for SWAM: VK06051529703. CR: ADB for SWAM SW_ARCH/ISI-SPEC PROTOCOLS/SPECIFICATION: VK06042636197. , APPROVED

//Version: 010.000                                           
//Status: Proposal                                          
//Date: 15-May-2006     Ville Kukkola
//Reason: Proposed version for inspection
//Reference: Inspection minutes in Lotus Notes, ActionDB for SWAM: VK06051529703. CR: ADB for SWAM SW_ARCH/ISI-SPEC PROTOCOLS/SPECIFICATION: VK06042636197. , PROPOSAL

//Version: 009.004                                           
//Status: Approved                                          
//Date: 21-Mar-2006     Ville Kukkola
//Reason: Approved version
//Reference: Inspection minutes in Lotus Notes, ActionDB for SWAM: VK06030838656. CR: ADB for SWAM SW_ARCH/ISI-SPEC PROTOCOLS/SPECIFICATION: VK06030833669. , APPROVED

//Version: 009.003                                           
//Status: Proposal                                          
//Date: 16-Mar-2006     Ville Kukkola
//Reason: Proposal version
//Reference: Inspection minutes in Lotus Notes, ActionDB for SWAM: VK06030838656. CR: ADB for SWAM SW_ARCH/ISI-SPEC PROTOCOLS/SPECIFICATION: VK06030833669. , PROPOSAL

//Version: 009.002                                           
//Status: Approved                                          
//Date: 21-Dec-2005     Ville Kukkola
//Reason: Approved version
//Reference: Inspection minutes in Lotus Notes, ActionDB for SWAM: VK05121431042CR: ADB for SWAM SW_ARCH/ISI-SPEC PROTOCOLS/SPECIFICATION: VK05112832829 , APPROVED

//Version: 009.001                                           
//Status: Proposal                                          
//Date: 14-Dec-2005     Ville Kukkola
//Reason: Proposal version.
//Reference: Inspection minutes in Lotus Notes, ActionDB for SWAM: CR: ADB for SWAM SW_ARCH/ISI-SPEC PROTOCOLS/SPECIFICATION: VK05112832829 Inspection: VK05121431042, PROPOSAL

//Version: 009.000                                           
//Status: Proposal                                          
//Date: 07-Dec-2005     Ville Kukkola
//Reason: Proposal version.
//Reference: Inspection minutes in Lotus Notes, ActionDB for SWAM: CR: ADB for SWAM SW_ARCH/ISI-SPEC PROTOCOLS/SPECIFICATION: VK05112832829 Inspection: VK05112832829, PROPOSAL

//Version: 008.002                                           
//Status: Approved                                          
//Date: 02-Jun-2005     Mika Leinonen
//Reason: Approved version.
//Reference: Inspection minutes in Lotus Notes, ActionDB for SWAM: CR: ADB for SWAM SW_ARCH/ISI-SPEC PROTOCOLS/SPECIFICATION: Transaction level interface support  VK05052630385, APPROVED

//Version: 008.001                                           
//Status: Proposal                                          
//Date: 27-May-2005     Ville Kukkola
//Reason: Proposal for inspection.
//Reference: Inspection minutes in Lotus Notes, ActionDB for SWAM:   CR: ADB for SWAM SW_ARCH/ISI-SPEC PROTOCOLS/SPECIFICATION:                         Transaction level interface support  VK05052630385, PROPOSAL

//Version: 008.000                                           
//Status: Proposal                                          
//Date: 05-May-2005     Ville Kukkola
//Reason: Proposal for inspection.
//Reference: Inspection minutes in Lotus Notes, ActionDB for SWAM: VK05050649914  CR: ADB for SWAM SW_ARCH/ISI-SPEC PROTOCOLS/SPECIFICATION:                         Transaction level interface support  VK05041542967, PROPOSAL

//Version: 007.003                                           
//Status: Approved                                          
//Date: 22-Dec-2004     Mika Leinonen
//Reason: Approved version.
//Reference: Inspection minutes in Lotus Notes, ActionDB for SWAM: ML04120951702, APPROVED

//Version: 007.002                                           
//Status: Proposal                                          
//Date: 09-Dec-2004     Mika Leinonen
//Reason: Proposal for inspection.
//Reference: CR: ADB for SWAM / INTERFACE ISImessage: ML04120149945, New sub-blocks and media parameter definition for PoC phase 0+, PROPOSAL

//Version: 007.001                                           
//Status: Approved                                          
//Date: 18-Aug-2004     Mika Leinonen
//Reason: Approved version.
//Reference: Inspection minutes in Lotus Notes, ActionDB for SWAM: ML04081060705, APPROVED

//Version: 007.000                                           
//Status: Proposal                                          
//Date: 10-Aug-2004     Mika Leinonen
//Reason: Proposal for inspection.
//Reference: CR: ADB for SWAM / INTERFACE ISImessage: ML04062433374, Changes for PoC phase 0+, PROPOSAL

//Version: 006.001                                           
//Status: Approved                                          
//Date: 11-May-2004     Ville Kukkola
//Reason: Approved version.
//Reference: ADB for SWAM Minutes VK04050633248, APPROVED

//Version: 006.000                                           
//Status: Proposal                                          
//Date: 03-May-2004     Ville Kukkola
//Reason: Proposal for inspection.
//Reference: CR: ADB for SWAM / INTERFACE ISImessage: ML04042152478, Support for multiple clients, CR: ADB for SWAM / INTERFACE ISImessage: ML04042249499, Incoming INVITE support for CDMA 1x VoIP trial, CR: ADB for SWAM / INTERFACE ISImessage: ML04042646164, New error causes and other micellaneous improvements, PROPOSAL

//Version: 005.001                                           
//Status: Approved                                          
//Date: 04-Dec-2003     Mika Leinonen
//Reason: Approved version.
//Reference: Inspection minutes in Lotus Notes, ActionDB for SWAM: ML03112460828, APPROVED

//Version: 005.000                                           
//Status: Proposal                                          
//Date: 24-Nov-2003     Mika Leinonen
//Reason: Proposal for inspection.
//Reference: CR: ADB for SWAM / INTERFACE / ISImessage: ML03111743120, PROPOSAL

//Version: 004.001                                           
//Status: Approved                                          
//Date: 11-Nov-2003     Mika Leinonen
//Reason: Approved version.
//Reference: Inspection minutes in Lotus Notes, ActionDB for SWAM: ML03101051633, APPROVED

//Version: 004.000                                           
//Status: Proposal                                          
//Date: 10-Oct-2003     Mika Leinonen
//Reason: Proposal for inspection.
//Reference: CR: ADB for SWAM / INTERFACE / ISImessage: ML03092243718, CR: ADB for SWAM / INTERFACE / ISImessage: ML03092260554 , PROPOSAL

//Version: 003.001                                           
//Status: Approved                                          
//Date: 27-Jun-2003     Mika Leinonen
//Reason: Approved version.
//Reference: Inspection minutes in Lotus Notes, ActionDB for SWAM: ML03061047715, APPROVED

//Version: 003.000                                           
//Status: Proposal                                          
//Date: 10-Jun-2003     Mika Leinonen
//Reason: Proposal for inspection.
//Reference: CR: ADB for SWAM / INTERFACE / ISImessage: ML03050438666, CR: ADB for SWAM / INTERFACE / ISImessage: ML03052350195, PROPOSAL

//Version: 002.001                                           
//Status: Approved                                          
//Date: 20-Mar-2003     Mika Leinonen
//Reason: Approved version.
//Reference: Inspection minutes in Lotus Notes, ActionDB for SWAM: ML03022139299, APPROVED

//Version: 002.000                                           
//Status: Proposal                                          
//Date: 21-Feb-2003     Mika Leinonen
//Reason: Proposal for inspection.
//Reference: CR: ADB for SWAM / INTERFACE / ISImessage: ML03011547582, PROPOSAL

//Version: 001.002                                           
//Status: Approved                                          
//Date: 15-Oct-2002     Mika Leinonen
//Reason: Approved version.
//Reference: Inspection minutes in Lotus Notes, ActionDB for SWAM: ML02100439791, APPROVED

//Version: 001.001                                           
//Status: Proposal                                          
//Date: 04-Oct-2002     Mika Leinonen
//Reason: New proposal after rejection in inspection.
//Reference: Inspection minutes in Lotus Notes, ActionDB for SWAM: ML02090641204, PROPOSAL

//Version: 001.000                                           
//Status: Proposal                                          
//Date: 06-Sep-2002     Mika Leinonen
//Reason: First version of the SIP ISI interface handled through official ISI interface process.
//Reference: -, PROPOSAL


//CONSTANTS
#define SIP_SESSIONID_NONE                                    0x00                                                     
#define SIP_UNSUBSCRIBE_DURATION                              0x00                                                     
#define SIP_TIMER_VALUE_DEFAULT                               0xFFFFFFFF                                            
#define PN_PRIVATE_SIP_UI_HANDLER                             0xFF18                                                
#define SIP_ANY_SIZE                                          1                                                     
#define SIP_SB_REMOTE_ENDPOINT_ADDR                           0x00                                                     
#define SIP_SB_LOCAL_PROXY_ADDR                               0x00                                                     
#define SIP_SB_MEDIA_ADDR                                     0x00                                                     
#define SIP_MAX_MSG_DATA                                      0x03E8                                                   
#define SIP_MAX_USERNAME_LENGTH                               0x48                                                  
#define SIP_MAX_PASSWORD_LENGTH                               0x40                                                  
#define SIP_CONST_MAX_UI_REALM_LENGTH                         0x80                                                  
#define SIP_CONST_MAX_UI_URL_LENGTH                           0x80                                                  
#define SIP_CONST_MAX_UI_USER_NAME_LENGTH                     0xFA                                                  


//TABLES

//ConstantTable for SIP_STATUS_SYMBOLS
#define SIP_OPENING_NWKLINK                                   0x00                                                     
#define SIP_CLOSING_NWKLINK                                   0x01                                                     
#define SIP_CONNECTED                                         0x02                                                     
#define SIP_DISCONNECTED                                      0x03                                                     
#define SIP_USER_REGISTERED                                   0x04                                                     
#define SIP_USER_UNREGISTERED                                 0x05                                                     
#define SIP_CREATING_SESSION                                  0x06                                                     
#define SIP_WAIT_FOR_RESPONSE                                 0x07                                                     
#define SIP_SESSION_PROCEEDING                                0x08                                                     
#define SIP_REMOTE_ALERTING                                   0x09                                                     
#define SIP_SESSION_CONNECTED                                 0x0A                                                     
#define SIP_SESSION_ACTIVE                                    0x0B                                                     
#define SIP_MO_RELEASE                                        0x0C                                                     
#define SIP_SESSION_RELEASED                                  0x0D                                                     
#define SIP_MSG_SENT                                          0x0E                                                     
#define SIP_INFO_SENT                                         0x0F                                                     
#define SIP_SESSION_FAILED                                    0x10                                                  
#define SIP_SESSION_RELEASE_FAILED                            0x11                                                  
#define SIP_MSG_SENDING_FAILED                                0x12                                                  
#define SIP_INFO_SENDING_FAILED                               0x13                                                  
#define SIP_SUSPENDED                                         0x14                                                  
#define SIP_RESUMED                                           0x15                                                  
#define SIP_SUBSCRIPTION_DONE                                 0x16                                                  
#define SIP_SUBSCRIPTION_FAILED                               0x17                                                  
#define SIP_SUBSCRIPTION_REMOVED                              0x18                                                  

//ConstantTable for SIP_BEARER_TYPES
#define SIP_BEARER_GPRS                                       0x00                                                     
#define SIP_BEARER_WLAN                                       0x01                                                     

//ConstantTable for SIP_SESSION_SIGNALING_TYPES
#define SIP_AUDIO                                             0x00                                                     
#define SIP_VIDEO                                             0x01                                                     
#define SIP_EMERGENCY                                         0x02                                                     
#define SIP_POC                                               0x03                                                     

//ConstantTable for SIP_ERROR_CAUSES
#define SIP_OK                                                0x00                                                     
#define SIP_BAD_ADDRESS_FORMAT                                0x01                                                     
#define SIP_DESTINATION_UNREACHABLE                           0x02                                                     
#define SIP_REMOTE_REJECT                                     0x03                                                     
#define SIP_REMOTE_BUSY                                       0x04                                                     
#define SIP_NO_RESPONSE                                       0x05                                                     
#define SIP_NOT_FOUND                                         0x06                                                     
#define SIP_FORBIDDEN                                         0x07                                                     
#define SIP_TIMEOUT                                           0x08                                                     
#define SIP_RELEASE_BY_LOCAL_USER                             0x09                                                     
#define SIP_RELEASE_BY_REMOTE_USER                            0x0A                                                     
#define SIP_NETWORK_DISCONNECTED                              0x0B                                                     
#define SIP_REQUEST_ERROR                                     0x0C                                                     
#define SIP_SCKT_ERROR                                        0x0D                                                     
#define SIP_ANY_CAUSE                                         0x0E                                                     
#define SIP_MANDATORY_PARAM_MISSING                           0x11                                                  
#define SIP_INVALID_SESSION_ID                                0x12                                                  
#define SIP_CONTENT_TYPE_NOT_SUPPORTED                        0x15                                                  
#define SIP_NO_MORE_SESSIONS                                  0x16                                                  
#define SIP_TEMPORARILY_UNAVAILABLE                           0x18                                                  
#define SIP_SERVICE_UNAVAILABLE                               0x19                                                  
#define SIP_REMOTE_SERVER_ERROR                               0x1A                                                  
#define SIP_SESSION_DOES_NOT_EXIST                            0x1B                                                  
#define SIP_NOT_ALLOWED                                       0x1C                                                  
#define SIP_DATA_TOO_BIG                                      0x1D                                                  
#define SIP_ALTERNATIVE_SERVICE                               0x1E                                                  
#define SIP_CONNECTION_NOT_FOUND                              0x1F                                                  
#define SIP_NETWORK_FATAL_FAIL                                0x20                                                  
#define SIP_REQUEST_ENTITY_TOO_LARGE                          0x21                                                  
#define SIP_MESSAGE_TOO_BIG_FOR_UDP_TRANSPORT                 0x22                                                  
#define SIP_CONTEXT_NOT_FOUND                                 0x23                                                  
#define SIP_TRANSACTION_NOT_FOUND                             0x24                                                  
#define SIP_OUT_OF_MEMORY                                     0x25                                                  
#define SIP_LOCAL_ADDR_IN_USE                                 0x26                                                  
#define SIP_BEARER_SUSPENDED                                  0x27                                                  
#define SIP_CLIENT_REQUESTED_ABORT                            0x28                                                  
#define SIP_CONNECTION_PROHIBITED                             0x29                                                  
#define SIP_MESSAGE_MALFORMED                                 0x2A                                                  
#define SIP_SCHEME_NOT_SUPPORTED                              0x2B                                                  
#define SIP_TRANSPORT_NOT_SUPPORTED                           0x2C                                                  
#define SIP_DNS_QUERY_FAILED                                  0x2D                                                  
#define SIP_QUERY_HOST_NOT_FOUND                              0x2E                                                  
#define SIP_QUERY_TRY_AGAIN                                   0x2F                                                  
#define SIP_QUERY_NO_RECOVERY                                 0x30                                                  
#define SIP_QUERY_SERVICE_NOT_AVAILABLE                       0x31                                                  
#define SIP_QUERY_INVALID_URI                                 0x32                                                  
#define SIP_CONTEXT_INVALID_OPTIONS                           0x33                                                  
#define SIP_SETTINGS_ERROR                                    0x34                                                  
#define SIP_TCP_CONN_CLOSED                                   0x35                                                  
#define SIP_TCP_MAX_DATA_SIZE_EXCEEDED                        0x36                                                  
#define SIP_INVALID_PARAMS                                    0x37                                                  
#define SIP_TLS_HANDSHAKE                                     0x50                                                  
#define SIP_TLS_RECORD                                        0x51                                                  
#define SIP_TLS_DECODING                                      0x52                                                  
#define SIP_TLS_CERTIFICATE                                   0x53                                                  
#define SIP_TLS_EXPORT_RESTRICTED                             0x54                                                  
#define SIP_TLS_PROTOCOL                                      0x55                                                  
#define SIP_TLS_SECURITY_LEVEL                                0x56                                                  
#define SIP_TLS_PARAMS                                        0x57                                                  
#define SIP_TLS_CLIENT_AUTH                                   0x58                                                  
#define SIP_TLS_NUMBER_OF_CONN                                0x59                                                  
#define SIP_TLS_DOMAIN_MISMATCH                               0x5A                                                  
#define SIP_WIM_PIN_INVALID                                   0x60                                                  
#define SIP_WIM_PIN_BLOCKED                                   0x61                                                  
#define SIP_WIM_CARD                                          0x62                                                  
#define SIP_WIM_NO_SERVICE                                    0x63                                                  
#define SIP_WIM_NO_ROOM                                       0x64                                                  
#define SIP_CERT_BAD                                          0x70                                                  
#define SIP_CERT_NOT_SUPPORTED                                0x71                                                  
#define SIP_CERT_REVOKED                                      0x72                                                  
#define SIP_CERT_EXPIRED                                      0x73                                                  
#define SIP_CERT_CA_UNKNOWN                                   0x74                                                  
#define SIP_CERT_NOT_VALID                                    0x75                                                  
#define SIP_CERT_SIGNATURE                                    0x76                                                  
#define SIP_CERT_USAGE                                        0x77                                                  
#define SIP_CERT_POLICY                                       0x78                                                  

//ConstantTable for SIP_CONTENT_TYPES
#define SIP_CONTENT_TYPE_NONE                                 0x00                                                     
#define SIP_CONTENT_TYPE_TEXT_PLAIN                           0x01                                                     
#define SIP_CONTENT_TYPE_APPLICATION_POC_XML                  0x02                                                     
#define SIP_CONTENT_TYPE_APPLICATION_REGINFO_XML              0x03                                                     
#define SIP_CONTENT_TYPE_APPLICATION_PIDF_XML                 0x04                                                     
#define SIP_CONTENT_TYPE_APPLICATION_VND_POC_GROUP_EVENT_XML    0x05                                                     
#define SIP_CONTENT_TYPE_TEXT_POC                             0x06                                                     

//ConstantTable for SIP_ADDRESS_TYPES
#define SIP_URL                                               0x00                                                     
#define SIP_IPV4                                              0x01                                                     
#define SIP_IPV6                                              0x02                                                     
#define SIP_TEL_URI                                           0x03                                                     

//ConstantTable for SIP_USER_TYPES
#define SIP_LOCAL_USER                                        0x00                                                     
#define SIP_REMOTE_USER                                       0x01                                                     

//ConstantTable for SIP_SESSION_MEDIA_TYPES
#define SIP_SESSION_MEDIA_AUDIO                               0x00                                                     
#define SIP_SESSION_MEDIA_VIDEO                               0x01                                                     
#define SIP_SESSION_MEDIA_APPLICATION                         0x02                                                     
#define SIP_SESSION_MEDIA_DATA                                0x03                                                     
#define SIP_SESSION_MEDIA_CONTROL                             0x04                                                     
#define SIP_SESSION_MEDIA_IMAGE                               0x05                                                     
#define SIP_SESSION_MEDIA_MESSAGE                             0x06                                                     

//ConstantTable for SIP_SESSION_MEDIA_TRANSPORT_TYPES
#define SIP_SESSION_MEDIA_TRANSPORT_RTP_AVP                   0x00                                                     
#define SIP_SESSION_MEDIA_TRANSPORT_UDP                       0x01                                                     
#define SIP_SESSION_MEDIA_TRANSPORT_RTP_POC                   0x02                                                     

//ConstantTable for SIP_CODEC_TYPES
#define SIP_CODEC_AMR                                         0x00                                                     
#define SIP_CODEC_AMR_WB                                      0x01                                                     
#define SIP_CODEC_GSM_HR                                      0x02                                                     
#define SIP_CODEC_GSM_FR                                      0x03                                                     
#define SIP_CODEC_GSM_EFR                                     0x04                                                     
#define SIP_CODEC_H263                                        0x05                                                     

//ConstantTable for SIP_SESSION_MEDIA_PARAM_TYPES
#define SIP_SESSION_MEDIA_PARAM_POC_SSRC                      0x01                                                     
#define SIP_SESSION_MEDIA_PARAM_RTPMAP                        0x02                                                     
#define SIP_SESSION_MEDIA_PARAM_FMTP                          0x03                                                     
#define SIP_SESSION_MEDIA_PARAM_PTIME                         0x04                                                     
#define SIP_SESSION_MEDIA_PARAM_SENDONLY                      0x05                                                     
#define SIP_SESSION_MEDIA_PARAM_RECVONLY                      0x06                                                     
#define SIP_SESSION_MEDIA_PARAM_SENDRECV                      0x07                                                     
#define SIP_SESSION_MEDIA_PARAM_POC_URLVRIND                  0x0C                                                     
#define SIP_SESSION_MEDIA_PARAM_POC_MNEMONICIND               0x0D                                                     
#define SIP_SESSION_MEDIA_PARAM_POC_RTPMODE                   0x0E                                                     
#define SIP_SESSION_MEDIA_PARAM_MAXPTIME                      0x0F                                                     
#define SIP_SESSION_MEDIA_PARAM_POC_VERSION                   0x10                                                  
#define SIP_SESSION_MEDIA_PARAM_POC_RTP_HEARTBEAT             0x11                                                  
#define SIP_SESSION_MEDIA_PARAM_POC_1TO1_TIMERS               0x13                                                  
#define SIP_SESSION_MEDIA_PARAM_POC_GROUP_SCAN                0x14                                                  
#define SIP_SESSION_MEDIA_PARAM_POC_DNDMODE                   0x15                                                  
#define SIP_SESSION_MEDIA_PARAM_POC_CALLACCEPTANCE            0x16                                                  
#define SIP_SESSION_MEDIA_PARAM_POC_CN_SERVICES               0x17                                                  
#define SIP_SESSION_MEDIA_PARAM_POC_ADHOC_REG                 0x18                                                  
#define SIP_SESSION_MEDIA_PARAM_PRESENCE                      0x19                                                  
#define SIP_SESSION_MEDIA_PARAM_POC_ADHOCINSTANT              0x1A                                                  
#define SIP_SESSION_MEDIA_PARAM_POC_PRESENCE_SUBS             0x1B                                                  
#define SIP_SESSION_MEDIA_PARAM_POC_DIALOUTS                  0x1C                                                  

//ConstantTable for SIP_SESSION_REPLY_STATUS_TYPES
#define SIP_SESSION_ACCEPT                                    0x00                                                     
#define SIP_SESSION_BUSY                                      0x01                                                     
#define SIP_SESSION_REJECT                                    0x02                                                     

//ConstantTable for SIP_PROFILE_TYPES
#define SIP_PROFILE_TYPE_IETF                                 0x00                                                     
#define SIP_PROFILE_TYPE_IMS                                  0x01                                                     

//ConstantTable for SIP_TERMINATION_LEVEL_TYPES
#define SIP_TERM_LEVEL_NORMAL                                 0x00                                                     
#define SIP_TERM_LEVEL_IMMEDIATE                              0x01                                                     

//ConstantTable for SIP_UIHANDLER_OPT
#define SIP_UIHANDLER_NORMAL                                  0x00                                                     
#define SIP_UIHANDLER_DEFAULT                                 0x01                                                     
#define SIP_UIHANDLER_NO_UI                                   0x02                                                     

//ConstantTable for SIP_TIMER_VALUES_FOR_MO_TR
#define SIP_MO_TIMER_VALUE_DEFAULT                            0xFF                                                  
#define SIP_TIMER_VALUE_INVITE                                0x0A                                                     
#define SIP_TIMER_VALUE_NON_INVITE                            0xC0                                                  

//BitmaskTables for SIP_CODEC_AMR_MODE_MASK
#define SIP_CODEC_AMR_12_2                                    0x80                                                  
#define SIP_CODEC_AMR_10_2                                    0x40                                                  
#define SIP_CODEC_AMR_7_95                                    0x20                                                  
#define SIP_CODEC_AMR_7_4                                     0x10                                                  
#define SIP_CODEC_AMR_6_7                                     0x08                                                     
#define SIP_CODEC_AMR_5_9                                     0x04                                                     
#define SIP_CODEC_AMR_5_15                                    0x02                                                     
#define SIP_CODEC_AMR_4_75                                    0x01                                                     

//BitmaskTables for SIP_CONTEXT_OPTIONS_MASK
#define SIP_OPTION_SIGCOMP                                    0x80                                                  

//BitmaskTables for SIP_REQUEST_OPTIONS_MASK
//#define SIP_OPTION_SIGCOMP                                  0x80                       //Already defined as 0x80
#define SIP_OPTION_UDP_TRANSPORT                              0x40                                                  
#define SIP_OPTION_TCP_TRANSPORT                              0x20                                                  
#define SIP_OPTION_TLS_TRANSPORT                              0x10                                                  
#define SIP_OPTION_SEND_NON_INVITE_ONCE                       0x08                                                     

//ConstantTable for SIP_CONNECTION_TYPES
#define SIP_SERVICE_CONNECTION                                0x00                                                     

//ConstantTable for SIP_DOMAIN_QUERY_TYPES
#define SIP_DOMAIN_QUERY_TYPE_ADDRESS                         0x00                                                     
#define SIP_DOMAIN_QUERY_TYPE_NAPTR                           0x01                                                     
#define SIP_DOMAIN_QUERY_TYPE_SRV                             0x02                                                     
#define SIP_DOMAIN_QUERY_TYPE_ANY                             0x03                                                     

//BitmaskTables for SIP_LOCATE_OPTIONS_MASK
#define SIP_OPTION_CLEAR_RESULTS                              0x80                                                  
//#define SIP_OPTION_UDP_TRANSPORT                            0x40                       //Already defined as 0x40
//#define SIP_OPTION_TCP_TRANSPORT                            0x20                       //Already defined as 0x20
//#define SIP_OPTION_TLS_TRANSPORT                            0x10                       //Already defined as 0x10

//BitmaskTables for SIP_ALLOW_REQ_OPTIONS_MASK
#define SIP_OPTION_INCOMING_RESPONSES                         0x80                                                  
#define SIP_OPTION_INCOMING_REQUESTS                          0x40                                                  

//BitmaskTables for SIP_PPP
#define SIP_PPP_OPTIONS_DEFAULT                               0x0000                                                     
#define SIP_PPP_NO_IP_ADDR_NEG                                0x0001                                                     
#define SIP_PPP_NO_HDLC                                       0x0002                                                     
#define SIP_PPP_IPV4                                          0x0004                                                     
#define SIP_PPP_IPV6                                          0x0008                                                     

//BitmaskTables for SIP_PPP_AUTH
#define SIP_PPP_NO_AUTH                                       0x00                                                     
#define SIP_PPP_AUTH_PAP                                      0x01                                                     
#define SIP_PPP_AUTH_CHAP                                     0x02                                                     
#define SIP_PPP_AUTH_PROMPT                                   0x80                                                  

//BitmaskTables for SIP_SECURITY_OPTIONS_MASK
#define SIP_SEC_CLIENTAUTH                                    0x01                                                     
#define SIP_SEC_SERVERAUTH                                    0x02                                                     

//ConstantTable for SIP_UI_USER_OPTIONS
#define SIP_UI_USER_OK                                        0x00                                                     
#define SIP_UI_USER_CANCEL                                    0x01                                                     

//ConstantTable for SIP_UNREGISTRATION_MODES
#define SIP_UNREG_MODE_NORMAL                                 0x00                                                     
#define SIP_UNREG_MODE_SESSIONS_SILENT_SHUTDOWN               0x01                                                     
#define SIP_UNREG_MODE_SILENT_SHUTDOWN                        0x02                                                     
#define SIP_UNREG_MODE_SESSIONS_SILENT_SHUTDOWN_QUICK_TIMEOUT    0x03                                                     

//ConstantTable for FtdTable
#define FTD_SB_SIP_RESET_COUNTERS                             0x0100                                                   
#define FTD_SB_SIP_RECEIVED_PACKETS                           0x0101                                                   
#define FTD_SB_SIP_INVALID_PACKETS                            0x0102                                                   
#define FTD_SB_SIP_REJECT_REASON                              0x0103                                                   
#define FTD_SB_SIP_RETRANSMISSIONS                            0x0104                                                   
#define FTD_SB_SIP_RECEIVED_RESPONSE                          0x0105                                                   
#define FTD_SB_SIP_REGISTR_TIMER_VALUE                        0x0106                                                   
#define FTD_SB_SIP_SESSION_COUNT                              0x0107                                                   


//SUBBLOCKS


//Definition for struct SIP_SB_HOST_ADDR
#define SIP_SB_HOST_ADDR                                      0x00                                                     
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint16_t     port;
             uint8_t      addrtype;
             uint8_t      datalength;
             uint8_t      addr_data[0];
            } __attribute__((packed)) SIP_SB_HOST_ADDR_STR;
#define SIZE_SIP_SB_HOST_ADDR                                 sizeof(SIP_SB_HOST_ADDR_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct SIP_SB_USER_ADDR
#define SIP_SB_USER_ADDR                                      0x01                                                     
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint8_t      usertype;
             uint8_t      addrtype;
             uint8_t      displayname_length;
             uint8_t      username_length;
             uint8_t      hostname_length;
             uint8_t      str1[0];
             uint8_t      str2[0];
             uint8_t      data[0];
            } __attribute__((packed)) SIP_SB_USER_ADDR_STR;
#define SIZE_SIP_SB_USER_ADDR                                 sizeof(SIP_SB_USER_ADDR_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct SIP_SB_MSG_DATA
#define SIP_SB_MSG_DATA                                       0x06                                                     
typedef struct
            { 
             uint8_t      id;
             uint8_t      fillerbyte1;
             uint16_t     length;
             uint16_t     data_length;
             uint8_t      msg_data[0];
            } __attribute__((packed)) SIP_SB_MSG_DATA_STR;
#define SIZE_SIP_SB_MSG_DATA                                  sizeof(SIP_SB_MSG_DATA_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct SIP_SB_SESSION_MEDIA_CODEC
#define SIP_SB_SESSION_MEDIA_CODEC                            0x04                                                     
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint8_t      codectype;
             uint8_t      bitrate;
             uint8_t      octet_align;
             uint8_t      fillerbyte1[3];
            } __attribute__((packed)) SIP_SB_SESSION_MEDIA_CODEC_STR;
#define SIZE_SIP_SB_SESSION_MEDIA_CODEC                       sizeof(SIP_SB_SESSION_MEDIA_CODEC_STR)


//Definition for struct SIP_SB_SESSION_MEDIA_PARAM
#define SIP_SB_SESSION_MEDIA_PARAM                            0x05                                                     
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint8_t      paramtype;
             uint8_t      datalength;
             uint8_t      param_data[0];
            } __attribute__((packed)) SIP_SB_SESSION_MEDIA_PARAM_STR;
#define SIZE_SIP_SB_SESSION_MEDIA_PARAM                       sizeof(SIP_SB_SESSION_MEDIA_PARAM_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct SIP_SB_SESSION_MEDIA_DESC
#define SIP_SB_SESSION_MEDIA_DESC                             0x03                                                     
typedef struct
            { 
             uint8_t      id;
             uint8_t      fillerbyte1;
             uint16_t     length;
             uint16_t     port;
             uint8_t      mediatype;
             uint8_t      transport;
             uint8_t      fillerbyte2[3];
             uint8_t      num_of_sub_blocks;
            } __attribute__((packed)) SIP_SB_SESSION_MEDIA_DESC_STR;
#define SIZE_SIP_SB_SESSION_MEDIA_DESC                        sizeof(SIP_SB_SESSION_MEDIA_DESC_STR)


//Definition for struct SIP_SB_SESSION_SUBJECT
#define SIP_SB_SESSION_SUBJECT                                0x11                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint8_t      subject_length;
             uint8_t      data[0];
            } __attribute__((packed)) SIP_SB_SESSION_SUBJECT_STR;
#define SIZE_SIP_SB_SESSION_SUBJECT                           sizeof(SIP_SB_SESSION_SUBJECT_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct SIP_SB_SESSION_DESC
#define SIP_SB_SESSION_DESC                                   0x02                                                     
typedef struct
            { 
             uint8_t      id;
             uint8_t      fillerbyte1;
             uint16_t     length;
             uint8_t      fillerbyte2[3];
             uint8_t      num_of_sub_blocks;
            } __attribute__((packed)) SIP_SB_SESSION_DESC_STR;
#define SIZE_SIP_SB_SESSION_DESC                              sizeof(SIP_SB_SESSION_DESC_STR)


//Definition for struct SIP_SB_SOCKET_PPP_AND_AUTH
#define SIP_SB_SOCKET_PPP_AND_AUTH                            0x0D                                                     
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint16_t     options;
             uint16_t     mru;
             uint8_t      authentication;
             uint8_t      username_length;
             uint8_t      password_length;
             uint8_t      username[0];
             uint8_t      username_and_password[0];
            } __attribute__((packed)) SIP_SB_SOCKET_PPP_AND_AUTH_STR;
#define SIZE_SIP_SB_SOCKET_PPP_AND_AUTH                       sizeof(SIP_SB_SOCKET_PPP_AND_AUTH_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct SIP_SB_LINK_INFO
#define SIP_SB_LINK_INFO                                      0x0E                                                     
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint8_t      link_id;
             uint8_t      ip_addr_len;
             uint8_t      ip_addr[0];
            } __attribute__((packed)) SIP_SB_LINK_INFO_STR;
#define SIZE_SIP_SB_LINK_INFO                                 sizeof(SIP_SB_LINK_INFO_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct SIP_SB_EVENT
#define SIP_SB_EVENT                                          0x0F                                                     
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint8_t      event_name_length;
             uint8_t      data[0];
            } __attribute__((packed)) SIP_SB_EVENT_STR;
#define SIZE_SIP_SB_EVENT                                     sizeof(SIP_SB_EVENT_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct SIP_SB_WARNING
#define SIP_SB_WARNING                                        0x10                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint8_t      warning_length;
             uint8_t      data[0];
            } __attribute__((packed)) SIP_SB_WARNING_STR;
#define SIZE_SIP_SB_WARNING                                   sizeof(SIP_SB_WARNING_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct SIP_SB_DNSADDR_LIST
#define SIP_SB_DNSADDR_LIST                                   0x15                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      fillerbyte1;
             uint16_t     length;
             uint8_t      fillerbyte2[3];
             uint8_t      num_of_sub_blocks;
            } __attribute__((packed)) SIP_SB_DNSADDR_LIST_STR;
#define SIZE_SIP_SB_DNSADDR_LIST                              sizeof(SIP_SB_DNSADDR_LIST_STR)


//Definition for struct SIP_SB_UI_NTF_DIGEST_AUTH
#define SIP_SB_UI_NTF_DIGEST_AUTH                             0x13                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      fillerbyte1;
             uint16_t     length;
             uint8_t      realm_string_length;
             uint8_t      req_url_length;
             uint8_t      realm_string[0];
             uint8_t      req_url[0];
            } __attribute__((packed)) SIP_SB_UI_NTF_DIGEST_AUTH_STR;
#define SIZE_SIP_SB_UI_NTF_DIGEST_AUTH                        sizeof(SIP_SB_UI_NTF_DIGEST_AUTH_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct SIP_SB_UI_REQ_DIGEST_AUTH
#define SIP_SB_UI_REQ_DIGEST_AUTH                             0x14                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      fillerbyte1;
             uint16_t     length;
             uint8_t      user_ack;
             uint8_t      user_name_length;
             uint8_t      user_passwd_length;
             uint8_t      user_name[0];
             uint8_t      user_name_pwd[0];
            } __attribute__((packed)) SIP_SB_UI_REQ_DIGEST_AUTH_STR;
#define SIZE_SIP_SB_UI_REQ_DIGEST_AUTH                        sizeof(SIP_SB_UI_REQ_DIGEST_AUTH_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct SIP_SB_TIMER_SETTINGS
#define SIP_SB_TIMER_SETTINGS                                 0x16                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint16_t     fillerbyte1;
             uint32_t     timer_t1;
             uint32_t     timer_t2;
             uint32_t     timer_t4;
            } __attribute__((packed)) SIP_SB_TIMER_SETTINGS_STR;
#define SIZE_SIP_SB_TIMER_SETTINGS                            sizeof(SIP_SB_TIMER_SETTINGS_STR)


//Definition for struct SIP_SB_SECURITY_PARAMS
#define SIP_SB_SECURITY_PARAMS                                0x19                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint8_t      ssl_ui_handler_flag;
             uint8_t      sip_ui_handler_flag;
             uint16_t     ssl_ui_cm_handle;
             uint16_t     sip_ui_cm_handle;
             uint8_t      security_opt;
             uint8_t      appl_id;
             uint16_t     fillerbyte1;
            } __attribute__((packed)) SIP_SB_SECURITY_PARAMS_STR;
#define SIZE_SIP_SB_SECURITY_PARAMS                           sizeof(SIP_SB_SECURITY_PARAMS_STR)


//Definition for struct SIP_SB_PORT_TRANSPORT_INFO
#define SIP_SB_PORT_TRANSPORT_INFO                            0x20                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint8_t      fillerbyte1;
             uint8_t      transport;
             uint16_t     port;
             uint16_t     fillerbyte2;
            } __attribute__((packed)) SIP_SB_PORT_TRANSPORT_INFO_STR;
#define SIZE_SIP_SB_PORT_TRANSPORT_INFO                       sizeof(SIP_SB_PORT_TRANSPORT_INFO_STR)


//Definition for struct SIP_SB_8BIT_SB_CONTAINER
#define SIP_SB_8BIT_SB_CONTAINER                              0x21                                                  
typedef struct
            { 
             uint16_t     sb_id;
             uint16_t     sb_len;
             uint8_t      num_of_sub_blocks;
             uint8_t      fillerbyte1[3];
            } __attribute__((packed)) SIP_SB_8BIT_SB_CONTAINER_STR;
#define SIZE_SIP_SB_8BIT_SB_CONTAINER                         sizeof(SIP_SB_8BIT_SB_CONTAINER_STR)


//Definition for struct SIP_SB_TARGET_PTR
#define SIP_SB_TARGET_PTR                                     0x22                                                  
typedef struct
            { 
             uint8_t      id;
             uint8_t      length;
             uint8_t      fillerbyte1;
             uint8_t      string_length;
             uint8_t      string_ptr[0];
            } __attribute__((packed)) SIP_SB_TARGET_PTR_STR;
#define SIZE_SIP_SB_TARGET_PTR                                sizeof(SIP_SB_TARGET_PTR_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//MESSAGES


//Definition for struct SIP_CONNECT_REQ
#define SIP_CONNECT_REQ                                       0x00                                                     
typedef struct
            { 
             uint8_t      tid;
             uint8_t      msg_id;
             uint16_t     port;
             uint8_t      bearer;
             uint8_t      sip_ui_opt;
             uint16_t     uihandler_sip;
             uint8_t      application_id;
             uint8_t      connection_type;
             uint8_t      fillerbyte1;
             uint8_t      num_of_sub_blocks;
            } __attribute__((packed)) SIP_CONNECT_REQ_STR;
#define SIZE_SIP_CONNECT_REQ                                  sizeof(SIP_CONNECT_REQ_STR)


//Definition for struct SIP_CONNECT_RESP
#define SIP_CONNECT_RESP                                      0x01                                                     
typedef struct
            { 
             uint8_t      tid;
             uint8_t      msg_id;
             uint16_t     connection_id;
             uint8_t      status;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) SIP_CONNECT_RESP_STR;
#define SIZE_SIP_CONNECT_RESP                                 sizeof(SIP_CONNECT_RESP_STR)


//Definition for struct SIP_DISCONNECT_REQ
#define SIP_DISCONNECT_REQ                                    0x02                                                     
typedef struct
            { 
             uint8_t      tid;
             uint8_t      msg_id;
             uint16_t     connection_id;
            } __attribute__((packed)) SIP_DISCONNECT_REQ_STR;
#define SIZE_SIP_DISCONNECT_REQ                               sizeof(SIP_DISCONNECT_REQ_STR)


//Definition for struct SIP_DISCONNECT_RESP
#define SIP_DISCONNECT_RESP                                   0x03                                                     
typedef struct
            { 
             uint8_t      tid;
             uint8_t      msg_id;
             uint8_t      status;
            } __attribute__((packed)) SIP_DISCONNECT_RESP_STR;
#define SIZE_SIP_DISCONNECT_RESP                              sizeof(SIP_DISCONNECT_RESP_STR)


//Definition for struct SIP_REGISTER_REQ
#define SIP_REGISTER_REQ                                      0x04                                                     
typedef struct
            { 
             uint8_t      tid;
             uint8_t      msg_id;
             uint16_t     connection_id;
             uint32_t     period;
             uint8_t      fillerbyte1[3];
             uint8_t      num_of_sub_blocks;
            } __attribute__((packed)) SIP_REGISTER_REQ_STR;
#define SIZE_SIP_REGISTER_REQ                                 sizeof(SIP_REGISTER_REQ_STR)


//Definition for struct SIP_REGISTER_RESP
#define SIP_REGISTER_RESP                                     0x05                                                     
typedef struct
            { 
             uint8_t      tid;
             uint8_t      msg_id;
             uint8_t      status;
            } __attribute__((packed)) SIP_REGISTER_RESP_STR;
#define SIZE_SIP_REGISTER_RESP                                sizeof(SIP_REGISTER_RESP_STR)


//Definition for struct SIP_UNREGISTER_REQ
#define SIP_UNREGISTER_REQ                                    0x06                                                     
typedef struct
            { 
             uint8_t      tid;
             uint8_t      msg_id;
             uint16_t     connection_id;
             uint8_t      unreg_mode;
             uint16_t     fillerbyte1;
             uint8_t      num_of_sub_blocks;
            } __attribute__((packed)) SIP_UNREGISTER_REQ_STR;
#define SIZE_SIP_UNREGISTER_REQ                               sizeof(SIP_UNREGISTER_REQ_STR)


//Definition for struct SIP_UNREGISTER_RESP
#define SIP_UNREGISTER_RESP                                   0x07                                                     
typedef struct
            { 
             uint8_t      tid;
             uint8_t      msg_id;
             uint8_t      status;
            } __attribute__((packed)) SIP_UNREGISTER_RESP_STR;
#define SIZE_SIP_UNREGISTER_RESP                              sizeof(SIP_UNREGISTER_RESP_STR)


//Definition for struct SIP_STATUS_IND
#define SIP_STATUS_IND                                        0x08                                                     
typedef struct
            { 
             uint8_t      tid;
             uint8_t      msg_id;
             uint16_t     connection_id;
             uint8_t      status;
             uint8_t      cause;
             uint8_t      proxy;
             uint8_t      content_type;
             uint8_t      fillerbyte1[3];
             uint8_t      num_of_sub_blocks;
            } __attribute__((packed)) SIP_STATUS_IND_STR;
#define SIZE_SIP_STATUS_IND                                   sizeof(SIP_STATUS_IND_STR)


//Definition for struct SIP_SESSION_INITIATE_REQ
#define SIP_SESSION_INITIATE_REQ                              0x09                                                     
typedef struct
            { 
             uint8_t      tid;
             uint8_t      msg_id;
             uint16_t     connection_id;
             uint8_t      type;
             uint16_t     fillerbyte1;
             uint8_t      num_of_sub_blocks;
            } __attribute__((packed)) SIP_SESSION_INITIATE_REQ_STR;
#define SIZE_SIP_SESSION_INITIATE_REQ                         sizeof(SIP_SESSION_INITIATE_REQ_STR)


//Definition for struct SIP_SESSION_INITIATE_RESP
#define SIP_SESSION_INITIATE_RESP                             0x0A                                                     
typedef struct
            { 
             uint8_t      tid;
             uint8_t      msg_id;
             uint16_t     session_id;
             uint8_t      status;
            } __attribute__((packed)) SIP_SESSION_INITIATE_RESP_STR;
#define SIZE_SIP_SESSION_INITIATE_RESP                        sizeof(SIP_SESSION_INITIATE_RESP_STR)


//Definition for struct SIP_SESSION_INFO_REQ
#define SIP_SESSION_INFO_REQ                                  0x0B                                                     
typedef struct
            { 
             uint8_t      tid;
             uint8_t      msg_id;
             uint16_t     connection_id;
             uint16_t     session_id;
             uint8_t      fillerbyte1;
             uint8_t      content_type;
             uint16_t     data_length;
             uint8_t      info_data[0];
            } __attribute__((packed)) SIP_SESSION_INFO_REQ_STR;
#define SIZE_SIP_SESSION_INFO_REQ                             sizeof(SIP_SESSION_INFO_REQ_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct SIP_SESSION_INFO_RESP
#define SIP_SESSION_INFO_RESP                                 0x0C                                                     
typedef struct
            { 
             uint8_t      tid;
             uint8_t      msg_id;
             uint8_t      status;
             uint8_t      fillerbyte1;
             uint16_t     req_handle;
            } __attribute__((packed)) SIP_SESSION_INFO_RESP_STR;
#define SIZE_SIP_SESSION_INFO_RESP                            sizeof(SIP_SESSION_INFO_RESP_STR)


//Definition for struct SIP_SESSION_INFO_RECEIVED_IND
#define SIP_SESSION_INFO_RECEIVED_IND                         0x0D                                                     
typedef struct
            { 
             uint8_t      tid;
             uint8_t      msg_id;
             uint16_t     connection_id;
             uint16_t     session_id;
             uint8_t      fillerbyte1;
             uint8_t      content_type;
             uint16_t     data_length;
             uint8_t      info_data[0];
            } __attribute__((packed)) SIP_SESSION_INFO_RECEIVED_IND_STR;
#define SIZE_SIP_SESSION_INFO_RECEIVED_IND                    sizeof(SIP_SESSION_INFO_RECEIVED_IND_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct SIP_SESSION_RELEASE_REQ
#define SIP_SESSION_RELEASE_REQ                               0x0E                                                     
typedef struct
            { 
             uint8_t      tid;
             uint8_t      msg_id;
             uint16_t     connection_id;
             uint16_t     session_id;
             uint8_t      cause;
            } __attribute__((packed)) SIP_SESSION_RELEASE_REQ_STR;
#define SIZE_SIP_SESSION_RELEASE_REQ                          sizeof(SIP_SESSION_RELEASE_REQ_STR)


//Definition for struct SIP_SESSION_RELEASE_RESP
#define SIP_SESSION_RELEASE_RESP                              0x0F                                                     
typedef struct
            { 
             uint8_t      tid;
             uint8_t      msg_id;
             uint8_t      status;
            } __attribute__((packed)) SIP_SESSION_RELEASE_RESP_STR;
#define SIZE_SIP_SESSION_RELEASE_RESP                         sizeof(SIP_SESSION_RELEASE_RESP_STR)


//Definition for struct SIP_SESSION_STATUS_IND
#define SIP_SESSION_STATUS_IND                                0x10                                                  
typedef struct
            { 
             uint8_t      tid;
             uint8_t      msg_id;
             uint16_t     connection_id;
             uint16_t     session_id;
             uint16_t     req_handle;
             uint8_t      content_type;
             uint8_t      status;
             uint8_t      cause;
             uint8_t      num_of_sub_blocks;
            } __attribute__((packed)) SIP_SESSION_STATUS_IND_STR;
#define SIZE_SIP_SESSION_STATUS_IND                           sizeof(SIP_SESSION_STATUS_IND_STR)


//Definition for struct SIP_MSG_SEND_REQ
#define SIP_MSG_SEND_REQ                                      0x11                                                  
typedef struct
            { 
             uint8_t      tid;
             uint8_t      msg_id;
             uint16_t     connection_id;
             uint16_t     session_id;
             uint8_t      content_type;
             uint8_t      num_of_sub_blocks;
            } __attribute__((packed)) SIP_MSG_SEND_REQ_STR;
#define SIZE_SIP_MSG_SEND_REQ                                 sizeof(SIP_MSG_SEND_REQ_STR)


//Definition for struct SIP_MSG_SEND_RESP
#define SIP_MSG_SEND_RESP                                     0x12                                                  
typedef struct
            { 
             uint8_t      tid;
             uint8_t      msg_id;
             uint8_t      status;
             uint8_t      fillerbyte1;
             uint16_t     req_handle;
            } __attribute__((packed)) SIP_MSG_SEND_RESP_STR;
#define SIZE_SIP_MSG_SEND_RESP                                sizeof(SIP_MSG_SEND_RESP_STR)


//Definition for struct SIP_MSG_STATUS_IND
#define SIP_MSG_STATUS_IND                                    0x13                                                  
typedef struct
            { 
             uint8_t      tid;
             uint8_t      msg_id;
             uint16_t     connection_id;
             uint16_t     session_id;
             uint16_t     req_handle;
             uint8_t      status;
             uint8_t      cause;
             uint8_t      fillerbyte1;
             uint8_t      num_of_sub_blocks;
            } __attribute__((packed)) SIP_MSG_STATUS_IND_STR;
#define SIZE_SIP_MSG_STATUS_IND                               sizeof(SIP_MSG_STATUS_IND_STR)


//Definition for struct SIP_MSG_RECEIVED_IND
#define SIP_MSG_RECEIVED_IND                                  0x14                                                  
typedef struct
            { 
             uint8_t      tid;
             uint8_t      msg_id;
             uint16_t     connection_id;
             uint16_t     session_id;
             uint8_t      content_type;
             uint8_t      num_of_sub_blocks;
            } __attribute__((packed)) SIP_MSG_RECEIVED_IND_STR;
#define SIZE_SIP_MSG_RECEIVED_IND                             sizeof(SIP_MSG_RECEIVED_IND_STR)


//Definition for struct SIP_SUBSCRIBE_REQ
#define SIP_SUBSCRIBE_REQ                                     0x15                                                  
typedef struct
            { 
             uint8_t      tid;
             uint8_t      msg_id;
             uint16_t     connection_id;
             uint16_t     session_id;
             uint16_t     fillerbyte1;
             uint32_t     period;
             uint8_t      content_type;
             uint16_t     fillerbyte2;
             uint8_t      num_of_sub_blocks;
            } __attribute__((packed)) SIP_SUBSCRIBE_REQ_STR;
#define SIZE_SIP_SUBSCRIBE_REQ                                sizeof(SIP_SUBSCRIBE_REQ_STR)


//Definition for struct SIP_SUBSCRIBE_RESP
#define SIP_SUBSCRIBE_RESP                                    0x16                                                  
typedef struct
            { 
             uint8_t      tid;
             uint8_t      msg_id;
             uint16_t     session_id;
             uint8_t      status;
            } __attribute__((packed)) SIP_SUBSCRIBE_RESP_STR;
#define SIZE_SIP_SUBSCRIBE_RESP                               sizeof(SIP_SUBSCRIBE_RESP_STR)


//Definition for struct SIP_SUBSCRIBE_STATUS_IND
#define SIP_SUBSCRIBE_STATUS_IND                              0x17                                                  
typedef struct
            { 
             uint8_t      tid;
             uint8_t      msg_id;
             uint16_t     connection_id;
             uint16_t     session_id;
             uint8_t      status;
             uint8_t      cause;
             uint8_t      fillerbyte1[3];
             uint8_t      num_of_sub_blocks;
            } __attribute__((packed)) SIP_SUBSCRIBE_STATUS_IND_STR;
#define SIZE_SIP_SUBSCRIBE_STATUS_IND                         sizeof(SIP_SUBSCRIBE_STATUS_IND_STR)


//Definition for struct SIP_NOTIFY_RECEIVED_IND
#define SIP_NOTIFY_RECEIVED_IND                               0x18                                                  
typedef struct
            { 
             uint8_t      tid;
             uint8_t      msg_id;
             uint16_t     connection_id;
             uint16_t     session_id;
             uint8_t      content_type;
             uint8_t      num_of_sub_blocks;
            } __attribute__((packed)) SIP_NOTIFY_RECEIVED_IND_STR;
#define SIZE_SIP_NOTIFY_RECEIVED_IND                          sizeof(SIP_NOTIFY_RECEIVED_IND_STR)


//Definition for struct SIP_USER_INTERACTION_NEEDED_NTF
#define SIP_USER_INTERACTION_NEEDED_NTF                       0x19                                                  
typedef struct
            { 
             uint8_t      tid;
             uint8_t      msg_id;
             uint16_t     connection_id;
             uint32_t     sip_tr_id;
             uint8_t      fillerbyte1[3];
             uint8_t      num_of_sub_blocks;
            } __attribute__((packed)) SIP_USER_INTERACTION_NEEDED_NTF_STR;
#define SIZE_SIP_USER_INTERACTION_NEEDED_NTF                  sizeof(SIP_USER_INTERACTION_NEEDED_NTF_STR)


//Definition for struct SIP_USER_INTERACTION_RESULT_REQ
#define SIP_USER_INTERACTION_RESULT_REQ                       0x1A                                                  
typedef struct
            { 
             uint8_t      tid;
             uint8_t      msg_id;
             uint16_t     connection_id;
             uint32_t     sip_tr_id;
             uint8_t      fillerbyte1[3];
             uint8_t      num_of_sub_blocks;
            } __attribute__((packed)) SIP_USER_INTERACTION_RESULT_REQ_STR;
#define SIZE_SIP_USER_INTERACTION_RESULT_REQ                  sizeof(SIP_USER_INTERACTION_RESULT_REQ_STR)


//Definition for struct SIP_USER_INTERACTION_RESULT_RESP
#define SIP_USER_INTERACTION_RESULT_RESP                      0x1B                                                  
typedef struct
            { 
             uint8_t      tid;
             uint8_t      msg_id;
             uint16_t     fillerbyte1;
             uint32_t     sip_tr_id;
            } __attribute__((packed)) SIP_USER_INTERACTION_RESULT_RESP_STR;
#define SIZE_SIP_USER_INTERACTION_RESULT_RESP                 sizeof(SIP_USER_INTERACTION_RESULT_RESP_STR)


//Definition for struct SIP_USER_INTERACTION_ABORT_NTF
#define SIP_USER_INTERACTION_ABORT_NTF                        0x1C                                                  
typedef struct
            { 
             uint8_t      tid;
             uint8_t      msg_id;
             uint16_t     connection_id;
             uint32_t     sip_tr_id;
            } __attribute__((packed)) SIP_USER_INTERACTION_ABORT_NTF_STR;
#define SIZE_SIP_USER_INTERACTION_ABORT_NTF                   sizeof(SIP_USER_INTERACTION_ABORT_NTF_STR)


//Definition for struct SIP_INVITE_RECEIVED_IND
#define SIP_INVITE_RECEIVED_IND                               0x1D                                                  
typedef struct
            { 
             uint8_t      tid;
             uint8_t      msg_id;
             uint16_t     connection_id;
             uint16_t     session_id;
             uint8_t      fillerbyte1;
             uint8_t      num_of_sub_blocks;
            } __attribute__((packed)) SIP_INVITE_RECEIVED_IND_STR;
#define SIZE_SIP_INVITE_RECEIVED_IND                          sizeof(SIP_INVITE_RECEIVED_IND_STR)


//Definition for struct SIP_INVITE_RESPONSE_REQ
#define SIP_INVITE_RESPONSE_REQ                               0x1E                                                  
typedef struct
            { 
             uint8_t      tid;
             uint8_t      msg_id;
             uint16_t     connection_id;
             uint16_t     session_id;
             uint8_t      status;
             uint8_t      num_of_sub_blocks;
            } __attribute__((packed)) SIP_INVITE_RESPONSE_REQ_STR;
#define SIZE_SIP_INVITE_RESPONSE_REQ                          sizeof(SIP_INVITE_RESPONSE_REQ_STR)


//Definition for struct SIP_INVITE_RESPONSE_RESP
#define SIP_INVITE_RESPONSE_RESP                              0x1F                                                  
typedef struct
            { 
             uint8_t      tid;
             uint8_t      msg_id;
             uint8_t      status;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) SIP_INVITE_RESPONSE_RESP_STR;
#define SIZE_SIP_INVITE_RESPONSE_RESP                         sizeof(SIP_INVITE_RESPONSE_RESP_STR)


//Definition for struct SIP_CONTEXT_CREATE_REQ
#define SIP_CONTEXT_CREATE_REQ                                0x20                                                  
typedef struct
            { 
             uint8_t      tid;
             uint8_t      msg_id;
             uint8_t      link_id;
             uint8_t      options;
             uint16_t     local_serv_port;
             uint16_t     local_client_port;
             uint8_t      bearer_type;
             uint8_t      profile;
             uint8_t      fillerbyte1;
             uint8_t      num_of_sub_blocks;
            } __attribute__((packed)) SIP_CONTEXT_CREATE_REQ_STR;
#define SIZE_SIP_CONTEXT_CREATE_REQ                           sizeof(SIP_CONTEXT_CREATE_REQ_STR)


//Definition for struct SIP_CONTEXT_CREATE_RESP
#define SIP_CONTEXT_CREATE_RESP                               0x21                                                  
typedef struct
            { 
             uint8_t      tid;
             uint8_t      msg_id;
             uint8_t      status;
             uint8_t      fillerbyte1;
             uint32_t     context_id;
             uint16_t     local_serv_port;
             uint16_t     local_client_port;
             uint8_t      udp_serv_sckt_descr;
             uint8_t      udp_client_sckt_descr;
             uint8_t      num_of_sub_blocks;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) SIP_CONTEXT_CREATE_RESP_STR;
#define SIZE_SIP_CONTEXT_CREATE_RESP                          sizeof(SIP_CONTEXT_CREATE_RESP_STR)


//Definition for struct SIP_CONTEXT_DELETE_REQ
#define SIP_CONTEXT_DELETE_REQ                                0x22                                                  
typedef struct
            { 
             uint8_t      tid;
             uint8_t      msg_id;
             uint8_t      termination_level;
             uint8_t      fillerbyte1;
             uint32_t     context_id;
            } __attribute__((packed)) SIP_CONTEXT_DELETE_REQ_STR;
#define SIZE_SIP_CONTEXT_DELETE_REQ                           sizeof(SIP_CONTEXT_DELETE_REQ_STR)


//Definition for struct SIP_CONTEXT_DELETE_RESP
#define SIP_CONTEXT_DELETE_RESP                               0x23                                                  
typedef struct
            { 
             uint8_t      tid;
             uint8_t      msg_id;
             uint16_t     fillerbyte1;
             uint32_t     context_id;
            } __attribute__((packed)) SIP_CONTEXT_DELETE_RESP_STR;
#define SIZE_SIP_CONTEXT_DELETE_RESP                          sizeof(SIP_CONTEXT_DELETE_RESP_STR)


//Definition for struct SIP_REQUEST_SEND_REQ
#define SIP_REQUEST_SEND_REQ                                  0x24                                                  
typedef struct
            { 
             uint8_t      tid;
             uint8_t      msg_id;
             uint8_t      options;
             uint8_t      timeout_value;
             uint32_t     context_id;
             uint32_t     sip_tr_id;
             uint32_t     method_ptr;
             uint8_t      num_of_sub_blocks;
             uint8_t      fillerbyte1[3];
             uint32_t     req_uri_ptr;
             uint32_t     req_hdrs_ptr;
             uint32_t     body_len;
             uint32_t     req_body_ptr;
            } __attribute__((packed)) SIP_REQUEST_SEND_REQ_STR;
#define SIZE_SIP_REQUEST_SEND_REQ                             sizeof(SIP_REQUEST_SEND_REQ_STR)


//Definition for struct SIP_REQUEST_SEND_RESP
#define SIP_REQUEST_SEND_RESP                                 0x25                                                  
typedef struct
            { 
             uint8_t      tid;
             uint8_t      msg_id;
             uint8_t      status;
             uint8_t      fillerbyte1;
             uint32_t     sip_tr_id;
            } __attribute__((packed)) SIP_REQUEST_SEND_RESP_STR;
#define SIZE_SIP_REQUEST_SEND_RESP                            sizeof(SIP_REQUEST_SEND_RESP_STR)


//Definition for struct SIP_RESPONSE_SEND_REQ
#define SIP_RESPONSE_SEND_REQ                                 0x26                                                  
typedef struct
            { 
             uint8_t      tid;
             uint8_t      msg_id;
             uint16_t     fillerbyte1;
             uint32_t     context_id;
             uint32_t     sip_tr_id;
             uint16_t     status_code;
             uint16_t     reason_ph_len;
             uint32_t     reason_phrase_ptr;
             uint32_t     resp_hdrs_ptr;
             uint32_t     body_len;
             uint32_t     resp_body_ptr;
            } __attribute__((packed)) SIP_RESPONSE_SEND_REQ_STR;
#define SIZE_SIP_RESPONSE_SEND_REQ                            sizeof(SIP_RESPONSE_SEND_REQ_STR)


//Definition for struct SIP_RESPONSE_SEND_RESP
#define SIP_RESPONSE_SEND_RESP                                0x27                                                  
typedef struct
            { 
             uint8_t      tid;
             uint8_t      msg_id;
             uint8_t      status;
             uint8_t      fillerbyte1;
             uint32_t     sip_tr_id;
            } __attribute__((packed)) SIP_RESPONSE_SEND_RESP_STR;
#define SIZE_SIP_RESPONSE_SEND_RESP                           sizeof(SIP_RESPONSE_SEND_RESP_STR)


//Definition for struct SIP_ABORT_NTF
#define SIP_ABORT_NTF                                         0x28                                                  
typedef struct
            { 
             uint8_t      tid;
             uint8_t      msg_id;
             uint8_t      status;
             uint8_t      fillerbyte1;
             uint32_t     sip_tr_id;
            } __attribute__((packed)) SIP_ABORT_NTF_STR;
#define SIZE_SIP_ABORT_NTF                                    sizeof(SIP_ABORT_NTF_STR)


//Definition for struct SIP_ABORT_REQ
#define SIP_ABORT_REQ                                         0x29                                                  
typedef struct
            { 
             uint8_t      tid;
             uint8_t      msg_id;
             uint16_t     fillerbyte1;
             uint32_t     context_id;
             uint32_t     sip_tr_id;
            } __attribute__((packed)) SIP_ABORT_REQ_STR;
#define SIZE_SIP_ABORT_REQ                                    sizeof(SIP_ABORT_REQ_STR)


//Definition for struct SIP_ABORT_RESP
#define SIP_ABORT_RESP                                        0x2A                                                  
typedef struct
            { 
             uint8_t      tid;
             uint8_t      msg_id;
             uint16_t     fillerbyte1;
             uint32_t     sip_tr_id;
            } __attribute__((packed)) SIP_ABORT_RESP_STR;
#define SIZE_SIP_ABORT_RESP                                   sizeof(SIP_ABORT_RESP_STR)


//Definition for struct SIP_RESPONSE_RECV_NTF
#define SIP_RESPONSE_RECV_NTF                                 0x2B                                                  
typedef struct
            { 
             uint8_t      tid;
             uint8_t      msg_id;
             uint8_t      status;
             uint8_t      fillerbyte1;
             uint32_t     context_id;
             uint32_t     sip_tr_id;
             uint32_t     method_ptr;
             uint16_t     status_code;
             uint16_t     reason_ph_len;
             uint32_t     reason_phrase_ptr;
             uint32_t     resp_hdrs_ptr;
             uint32_t     body_len;
             uint32_t     resp_body_ptr;
             uint8_t      fillerbyte2[3];
             uint8_t      num_of_sub_blocks;
            } __attribute__((packed)) SIP_RESPONSE_RECV_NTF_STR;
#define SIZE_SIP_RESPONSE_RECV_NTF                            sizeof(SIP_RESPONSE_RECV_NTF_STR)


//Definition for struct SIP_REQUEST_RECV_NTF
#define SIP_REQUEST_RECV_NTF                                  0x2C                                                  
typedef struct
            { 
             uint8_t      tid;
             uint8_t      msg_id;
             uint16_t     fillerbyte1;
             uint32_t     req_uri_ptr;
             uint32_t     context_id;
             uint32_t     sip_tr_id;
             uint32_t     method_ptr;
             uint32_t     req_hdrs_ptr;
             uint32_t     body_len;
             uint32_t     req_body_ptr;
             uint8_t      fillerbyte2[3];
             uint8_t      num_of_sub_blocks;
            } __attribute__((packed)) SIP_REQUEST_RECV_NTF_STR;
#define SIZE_SIP_REQUEST_RECV_NTF                             sizeof(SIP_REQUEST_RECV_NTF_STR)


//Definition for struct SIP_RECV_ALLOW_REQ
#define SIP_RECV_ALLOW_REQ                                    0x2D                                                  
typedef struct
            { 
             uint8_t      tid;
             uint8_t      msg_id;
             uint8_t      options;
             uint8_t      fillerbyte1;
             uint32_t     context_id;
            } __attribute__((packed)) SIP_RECV_ALLOW_REQ_STR;
#define SIZE_SIP_RECV_ALLOW_REQ                               sizeof(SIP_RECV_ALLOW_REQ_STR)


//Definition for struct SIP_RECV_ALLOW_RESP
#define SIP_RECV_ALLOW_RESP                                   0x2E                                                  
typedef struct
            { 
             uint8_t      tid;
             uint8_t      msg_id;
             uint8_t      status;
             uint8_t      fillerbyte1;
             uint32_t     context_id;
            } __attribute__((packed)) SIP_RECV_ALLOW_RESP_STR;
#define SIZE_SIP_RECV_ALLOW_RESP                              sizeof(SIP_RECV_ALLOW_RESP_STR)


//Definition for struct SIP_LOCATE_SERVER_REQ
#define SIP_LOCATE_SERVER_REQ                                 0x2F                                                  
typedef struct
            { 
             uint8_t      tid;
             uint8_t      msg_id;
             uint8_t      query_type;
             uint8_t      options;
             uint32_t     context_id;
             uint8_t      link_id;
             uint8_t      addr_family;
             uint8_t      fillerbyte1;
             uint8_t      num_of_sub_blocks;
            } __attribute__((packed)) SIP_LOCATE_SERVER_REQ_STR;
#define SIZE_SIP_LOCATE_SERVER_REQ                            sizeof(SIP_LOCATE_SERVER_REQ_STR)


//Definition for struct SIP_LOCATE_SERVER_RESP
#define SIP_LOCATE_SERVER_RESP                                0x30                                                  
typedef struct
            { 
             uint8_t      tid;
             uint8_t      msg_id;
             uint8_t      status;
             uint8_t      fillerbyte1;
             uint32_t     context_id;
             uint8_t      fillerbyte2[3];
             uint8_t      num_of_sub_blocks;
            } __attribute__((packed)) SIP_LOCATE_SERVER_RESP_STR;
#define SIZE_SIP_LOCATE_SERVER_RESP                           sizeof(SIP_LOCATE_SERVER_RESP_STR)


//Definition for struct SIP_KEEPALIVE_START_REQ
#define SIP_KEEPALIVE_START_REQ                               0x31                                                  
typedef struct
            { 
             uint8_t      tid;
             uint8_t      msg_id;
             uint16_t     fillerbyte1;
             uint32_t     context_id;
             uint8_t      fillerbyte2[3];
             uint8_t      num_of_sub_blocks;
            } __attribute__((packed)) SIP_KEEPALIVE_START_REQ_STR;
#define SIZE_SIP_KEEPALIVE_START_REQ                          sizeof(SIP_KEEPALIVE_START_REQ_STR)


//Definition for struct SIP_KEEPALIVE_START_RESP
#define SIP_KEEPALIVE_START_RESP                              0x32                                                  
typedef struct
            { 
             uint8_t      tid;
             uint8_t      msg_id;
             uint8_t      status;
             uint8_t      fillerbyte1;
             uint32_t     context_id;
            } __attribute__((packed)) SIP_KEEPALIVE_START_RESP_STR;
#define SIZE_SIP_KEEPALIVE_START_RESP                         sizeof(SIP_KEEPALIVE_START_RESP_STR)


//Definition for struct SIP_KEEPALIVE_STOP_REQ
#define SIP_KEEPALIVE_STOP_REQ                                0x33                                                  
typedef struct
            { 
             uint8_t      tid;
             uint8_t      msg_id;
             uint16_t     fillerbyte1;
             uint32_t     context_id;
            } __attribute__((packed)) SIP_KEEPALIVE_STOP_REQ_STR;
#define SIZE_SIP_KEEPALIVE_STOP_REQ                           sizeof(SIP_KEEPALIVE_STOP_REQ_STR)


//Definition for struct SIP_KEEPALIVE_STOP_RESP
#define SIP_KEEPALIVE_STOP_RESP                               0x34                                                  
typedef struct
            { 
             uint8_t      tid;
             uint8_t      msg_id;
             uint16_t     fillerbyte1;
             uint32_t     context_id;
            } __attribute__((packed)) SIP_KEEPALIVE_STOP_RESP_STR;
#define SIZE_SIP_KEEPALIVE_STOP_RESP                          sizeof(SIP_KEEPALIVE_STOP_RESP_STR)


//Definition for struct SIP_CONTEXT_STATUS_NTF
#define SIP_CONTEXT_STATUS_NTF                                0x35                                                  
typedef struct
            { 
             uint8_t      tid;
             uint8_t      msg_id;
             uint8_t      status;
             uint8_t      fillerbyte1;
             uint32_t     context_id;
             uint8_t      fillerbyte2[3];
             uint8_t      num_of_sub_blocks;
            } __attribute__((packed)) SIP_CONTEXT_STATUS_NTF_STR;
#define SIZE_SIP_CONTEXT_STATUS_NTF                           sizeof(SIP_CONTEXT_STATUS_NTF_STR)

#endif
