#ifndef _PN_SMS_ISI_H_
#define _PN_SMS_ISI_H_

#include <stdint.h> 

//Resource SMS Server
//PN_SMS 0x02 
//ISI version 005.001
#define SMS_SERVER_ISI_VERSION_Z     5
#define SMS_SERVER_ISI_VERSION_Y     1

//In case of problems concerning content of this file contact Henrik Ala-Uotila
//Server specific message descriptions and feature&protocol descriptions can be found from: https://oucmswww.nmp.nokia.com:58443/document_browser/ccm_wa/GIF_SPECS/ 


//ISI VERSION CHANGE HISTORY

//Version: 005.001                                           
//Status: NonDraft                                          
//Date: 26-Jun-2008     Timo Krall
//Reason: New requirements
//Reference: 1) ADB for SWAM CR: EH08022232819 and EH07121341743 2) ADB for SWAM Inspection ID: EH08042942605, NON-DRAFT

//Version: 005.000                                           
//Status: NonDraft                                          
//Date: 28-Apr-2008     Esa Harju
//Reason: New requirements
//Reference: 1) ADB for SWAM CR: EH08022232819 2) ADB for SWAM Inspection ID: EH08042942605, NON-DRAFT

//Version: 004.001                                           
//Status: NonDraft                                          
//Date: 31-Mar-2008     Timo Krall
//Reason: New requirement
//Reference: 1) ADB for SWAM CR: TK080328426082) ADB for SWAM Inspection ID: TK08033144001, NON-DRAFT

//Version: 004.000                                           
//Status: NonDraft                                          
//Date: 01-Aug-2006     Esa Harju
//Reason: New requirements
//Reference: 1) ADB for SWAM CR: EH06062727597 2) ADB for SWAM Inspection ID: EH06080139852, NON-DRAFT

//Version: 003.000                                           
//Status: NonDraft                                          
//Date: 09-Feb-2006     Petri Kynsilehto
//Reason: New requirements
//Reference: 1) ADB for SWAM CR: PK06012032998 2) ADB for SWAM CR: PK06012335000 3) ADB for SWAM Inspection ID: PK06020238713, NON-DRAFT

//Version: 002.019                                           
//Status: NonDraft                                          
//Date: 15-Nov-2005     Petri Kynsilehto
//Reason: Implemented CR
//Reference: 1) ADB for SWAM Inspection ID: PK05111753203 2) ADB for SWAM: CR: TH05110382510 3) ADB for SWAM: CR: TH05110379330, NON-DRAFT

//Version: 002.018                                           
//Status: NonDraft                                          
//Date: 06-Sep-2005     Timo Krall
//Reason: Inspection
//Reference: ADB for SWAM: CR: TK05081552860, Inspection TK05082947314, NON-DRAFT

//Version: 002.017                                           
//Status: Draft                                             
//Date: 29-Aug-2005     Timo Krall
//Reason: Implemented CR
//Reference: ADB for SWAM: CR: TK05081552860, Inspection TK05082947314, DRAFT

//Version: 002.016                                           
//Status: NonDraft                                          
//Date: 04-May-2005     Juha Leskinen
//Reason: CB ID range
//Reference: 1) ADB for SWAM Inspection ID : JL05053048016 2) ADB for SWAM CR ID: JL05050345775 , NON-DRAFT

//Version: 002.015                                           
//Status: NonDraft                                          
//Date: 22-Mar-2005     Juha Leskinen
//Reason: Correction after inspection
//Reference: 1) ADB for SWAM Inspection ID : JL05031535400 2) ADB for SWAM CR ID: JL05022344472, NON-DRAFT

//Version: 002.014                                           
//Status: NonDraft                                          
//Date: 04-Mar-2005     Juha Leskinen
//Reason: New S40 Messaging platform.
//Reference: 1) ADB for SWAM Inspection ID : JL05031535400 2) ADB for SWAM CR ID: JL05022344472, NON-DRAFT

//Version: 002.013                                           
//Status: NonDraft                                          
//Date: 15-Nov-2004     Juha Leskinen
//Reason: Correction after inspection
//Reference: ADB for SWAM Inspection ID : JL04110348635, NON-DRAFT

//Version: 002.012                                           
//Status: NonDraft                                          
//Date: 03-Nov-2004     Juha Leskinen
//Reason: 3G CB
//Reference: 1) ADB for SWAM Inspection ID : JL04110348635 2) ADB for SWAM CR ID: TH04101146943, NON-DRAFT

//Version: 002.011                                           
//Status: NonDraft                                          
//Date: 27-Sep-2004     Juha Leskinen
//Reason: SMS hold.
//Reference: 1) ADB for SWAM Inspection ID : JL04092750850 2) ADB for SWAM CR ID: JL04092035095 3) ADB for SWAM CR ID: JL04081230027, NON-DRAFT

//Version: 002.010                                           
//Status: NonDraft                                          
//Date: 14-Sep-2004     Juha Leskinen
//Reason: Correction.
//Reference: ADB for SWAM Inspection ID : JL04091456596, NON-DRAFT

//Version: 002.009                                           
//Status: NonDraft                                          
//Date: 06-Sep-2004     Juha Leskinen
//Reason: Correction after inspection.
//Reference: ADB for SWAM Inspection ID : JL04082430785, NON-DRAFT

//Version: 002.008                                           
//Status: NonDraft                                          
//Date: 13-Aug-2004     Juha Leskinen
//Reason: SIM ATK MO SM control changes.
//Reference: 1) ADB for SWAM Inspection ID : JL04082430785 2) ADB for SWAM CR ID: JL04081230027 3) WP RM-RIM 006-4160, NON-DRAFT

//Version: 002.007                                           
//Status: NonDraft                                          
//Date: 16-Jun-2004     Jarno Passi
//Reason: Corrections after inspection.
//Reference: 1) ADB for SWAM Inspection ID:JP04061045435, NON-DRAFT

//Version: 002.006                                           
//Status: NonDraft                                          
//Date: 04-Jun-2004     Jarno Passi
//Reason: Offline mode changes.
//Reference: CN-R99-2166 Protocol SW support for the offline mode, NON-DRAFT

//Version: 002.005                                           
//Status: NonDraft                                          
//Date: 04-Aug-2003     Jarno Passi
//Reason: Corrections after inspection
//Reference: 1) ADB for SWAM Inspection ID : JP03071539250, NON-DRAFT

//Version: 002.004                                           
//Status: NonDraft                                          
//Date: 07-Jun-2003     Jarno Passi
//Reason: R4 changes and SIM ATK R99 CB DDLchanges to the SMS
//Reference: 1) ADB for SWAM CR : JP03070740807 2) ISA RM-RIM tool: 006-2042, NON-DRAFT

//Version: 002.003                                           
//Status: NonDraft                                          
//Date: 23-Apr-2003     Jarno Passi
//Reason: Corrections after inspection
//Reference: 1) ADB for SWAM Inspection ID: JP03041531408 2) ADB for SWAM CR: BF0311552476 3) ADB for SWAM CR: JP03032847160 4) ADB for SWAM CR: JP03041043989 5) ADB for CS6 SCF: TH03031236398, NON-DRAFT

//Version: 002.002                                           
//Status: NonDraft                                          
//Date: 14-Apr-2003     Jarno Passi
//Reason: Several changes
//Reference: 1) ADB for SWAM Inspection ID: JP03041531408 2) ADB for SWAM CR: BF0311552476 3) ADB for SWAM CR: JP03032847160 4) ADB for SWAM CR: JP03041043989 5) ADB for CS6 SCF: TH03031236398, NON-DRAFT

//Version: 002.001                                           
//Status: NonDraft                                          
//Date: 02-Apr-2003     Jarno Passi
//Reason: Several changes
//Reference: 1) ADB for SWAM Inspection ID: JP03040255108 2) ADB for SWAM CR: BF0311552476 3) ADB for SWAM CR: JP03032847160 4) ADB for CS6 SCF: TH03031236398, NON-DRAFT

//Version: 001.010                                           
//Status: NonDraft                                          
//Date: 09-Dec-2002     Juha Leskinen
//Reason: Added new send status.
//Reference: 1) ADB for SWAM Inspection ID: JL02121149932 and 2) ADB for SWAM CR: TH02111249600, NON-DRAFT

//Version: 001.009                                           
//Status: NonDraft                                          
//Date: 05-Dec-2002     Tuomo Heikka
//Reason: Error correction after tests.
//Reference: ADB for SWAM Inspection ID TH02120550612., NON-DRAFT

//Version: 001.008                                           
//Status: NonDraft                                          
//Date: 29-Nov-2002     Tuomo Heikka
//Reason: Defect corrections after the inspection.
//Reference: ADB for SWAM Inspection ID TH02112561026., NON-DRAFT

//Version: 001.007                                           
//Status: NonDraft                                          
//Date: 25-Nov-2002     Tuomo Heikka
//Reason: ISI Message macros taken into use.
//Reference: 1) ADB for SWAM Inspection ID TH02112561026 and 2) Action DB for CS6 SCF CR PL02090948236: CS6-R99-24047: ISI message macros into use., NON-DRAFT

//Version: 001.006                                           
//Status: NonDraft                                          
//Date: 17-Oct-2002     Tuomo Heikka
//Reason: Corrections after the inspection
//Reference: 1) ActionDB for SWAM CR ID:HK02051661818 and inspection minutes ID: HK02082948081 and 2) Continuus task ou_cs#29120., NON-DRAFT

//Version: 001.005                                           
//Status: NonDraft                                          
//Date: 29-Aug-2002     Heikki Kujala
//Reason: SMS Server improvement.
//Reference: 1) ActionDB for SWAM ID:HK02051661818 and 2) Continuus task ou_cs#28758., NON-DRAFT

//Version: 001.004                                           
//Status: NonDraft                                          
//Date: 26-Jun-2002     Heikki Kujala
//Reason: Correction after inspection.
//Reference: ActionDB for SWAM ID:JL02061736169,TH02062549219., NON-DRAFT

//Version: 001.003                                           
//Status: NonDraft                                          
//Date: 19-Jun-2002     Juha Leskinen
//Reason: ISI interface update.
//Reference: 1) ActionDB for SWAM ID:JL02061736169, NON-DRAFT

//Version: 001.002                                           
//Status: NonDraft                                          
//Date: 17-Jun-2002     Heikki Kujala
//Reason: Error correction.
//Reference: 1) ActionDB for CS6 SCF inspection ID:HK02061760238 and 2) PCP Errors ID's:MM02011048675., NON-DRAFT

//Version: 001.001                                           
//Status: NonDraft                                          
//Date: 13-Jun-2002     Heikki Kujala
//Reason: CS6-R99-8005: Automatic repeate mechanism.
//Reference: ActionDB for CS6 SCF Inspection ID:HK02061154131, NON-DRAFT

//Version: 001.000                                           
//Status: NonDraft                                          
//Date: 15-May-2002     Juha Leskinen
//Reason: Correction to SMS ISI version handling.
//Reference: ActionDB for CS6 SCF Inspection ID JL02051549271, NON-DRAFT

//Version: 000.001                                           
//Status: Unknown                                           
//Date: -               -
//Reason: -
//Reference: -


//CONSTANTS
#define SMS_ADDRESS_MAX_LEN                                   0x0C                                                     
#define SMS_DELIVER_UD_MAX_LEN                                0x8C                                                  
#define SMS_STATUS_RPRT_UD_MAX_LEN                            0x8F                                                  
#define SMS_SUBMIT_UD_MAX_LEN                                 0x8C                                                  
#define SMS_COMMAND_DATA_MAX_LEN                              0x9C                                                  
#define SMS_MT_UNDEFINED_MAX_LEN                              0xE7                                                  
#define SMS_MO_UNDEFINED_MAX_LEN                              0xE6                                                  
#define SMS_DELIVER_ACK_UD_MAX_LEN                            0x9F                                                  
#define SMS_DELIVER_ERR_UD_MAX_LEN                            0x9E                                                  
#define SMS_SUBMIT_ACK_UD_MAX_LEN                             0x98                                                  
#define SMS_SUBMIT_ERR_UD_MAX_LEN                             0x97                                                  
#define SMS_TPDU_MAX_LEN                                      0xE8                                                  
#define SMS_CB_MESSAGE_CONTENT_SIZE                           0x52                                                  
#define SMS_SETTING_REPLY_PATH                                0x01                                                     
#define SMS_SETTING_REPLY_PATH_MASK                           0xFE                                                  
#define SMS_SETTING_CONF_REQUEST                              0x02                                                     
#define SMS_SETTING_CONF_REQUEST_MASK                         0xFD                                                  
#define SMS_ANY_SIZE                                          1                                                     
#define SMS_CONCATENATED_UD_MAX_LEN                           0x857A                                                
#define SMS_PARAM_INDICATOR_MAX_LEN                           0x0A                                                     
#define SMS_SC_TIME_STAMP_SIZE                                0x07                                                     
#define SMS_DEFAULT_PARAMETER_LOCATION                        0x00                                                     
#define SMS_NEW_SUBSCRIPTION                                  0x00                                                     


//TABLES

//ConstantTable for SMS_CAPABILITY_ID

//ConstantTable for SMS_ROUTE

//ConstantTable for SMS_ROUTE
#define SMS_ROUTE_DEFAULT                                     0x00                                                     
#define SMS_ROUTE_CS                                          0x01                                                     
#define SMS_ROUTE_PS                                          0x02                                                     

//ConstantTable for SMS_SENDER

//ConstantTable for SMS_CAUSE_TYPE

//ConstantTable for SMS_CAUSE_TYPE
#define SMS_CAUSE_TYPE_COMMON                                 0x00                                                     
#define SMS_CAUSE_TYPE_EXT                                    0x01                                                     

//BitmaskTables for SMS_CAPABILITY_DATA
#define SMS_MT_RECEIVING                                      0x0001                                                     
#define SMS_MO_SENDING                                        0x0002                                                     
#define SMS_APPL_PORT_ROUTING                                 0x0004                                                     
#define SMS_CB_MESSAGE_RECEIVING                              0x0008                                                     
#define SMS_APPL_PORT_COPY_NOTIFYING                          0x0010                                                  
#define SMS_GPRS_MESSAGE_PASSING                              0x0020                                                  
#define SMS_MWI_ROUTING_MODES                                 0x0040                                                  
#define SMS_CLASS_ROUTING_MODES                               0x0080                                                  
#define SMS_DATACODE_ROUTING_MODES                            0x0100                                                   
#define SMS_MO_UNDEFINED_SENDING                              0x0200                                                   
#define SMS_TPDU_ROUTING                                      0x0400                                                   
#define SMS_MULTIMODE_SUPPORT                                 0x0800                                                   
#define SMS_MO_SEGMENTATION_SUPPORT                           0x1000                                                  

//ConstantTable for SMS_CAUSE
#define SMS_OK                                                0x00                                                     
#define SMS_ERR_ROUTING_RELEASED                              0x01                                                     
#define SMS_ERR_INVALID_PARAMETER                             0x02                                                     
#define SMS_ERR_DEVICE_FAILURE                                0x03                                                     
#define SMS_ERR_PP_RESERVED                                   0x04                                                     
#define SMS_ERR_ROUTE_NOT_AVAILABLE                           0x05                                                     
#define SMS_ERR_ROUTE_NOT_ALLOWED                             0x06                                                     
#define SMS_ERR_SERVICE_RESERVED                              0x07                                                     
#define SMS_ERR_INVALID_LOCATION                              0x08                                                     
#define SMS_ERR_NO_NETW_RESPONSE                              0x0B                                                     
#define SMS_ERR_DEST_ADDR_FDN_RESTRICTED                      0x0C                                                     
#define SMS_ERR_SMSC_ADDR_FDN_RESTRICTED                      0x0D                                                     
#define SMS_ERR_RESEND_ALREADY_DONE                           0x0E                                                     
#define SMS_ERR_SMSC_ADDR_NOT_AVAILABLE                       0x0F                                                     
#define SMS_ERR_ROUTING_FAILED                                0x10                                                  
#define SMS_ERR_CS_INACTIVE                                   0x11                                                  
#define SMS_ERR_SAT_MO_CONTROL_MODIFIED                       0x12                                                  
#define SMS_ERR_SAT_MO_CONTROL_REJECT                         0x13                                                  
#define SMS_ERR_TRACFONE_FAILED                               0x14                                                  
#define SMS_ERR_SENDING_ONGOING                               0x15                                                  
#define SMS_ERR_SERVER_NOT_READY                              0x16                                                  
#define SMS_ERR_NO_TRANSACTION                                0x17                                                  
#define SMS_ERR_REJECTED                                      0x18                                                  
#define SMS_ERR_INVALID_SUBSCRIPTION_NR                       0x19                                                  

//ConstantTable for SMS_GSM_CAUSE

//ConstantTable for SMS_EXT_CAUSE
#define SMS_EXT_ERR_UNASSIGNED_NUMBER                         0x01                                                     
#define SMS_EXT_ERR_OPER_DETERMINED_BARR                      0x08                                                     
#define SMS_EXT_ERR_CALL_BARRED                               0x0A                                                     
#define SMS_EXT_ERR_RESERVED                                  0x0B                                                     
#define SMS_EXT_ERR_MSG_TRANSFER_REJ                          0x15                                                  
#define SMS_EXT_ERR_MEMORY_CAPACITY_EXC                       0x16                                                  
#define SMS_EXT_ERR_DEST_OUT_OF_ORDER                         0x1B                                                  
#define SMS_EXT_ERR_UNDEFINED_SUBSCRIBER                      0x1C                                                  
#define SMS_EXT_ERR_FACILITY_REJECTED                         0x1D                                                  
#define SMS_EXT_ERR_UNKNOWN_SUBSCRIBER                        0x1E                                                  
#define SMS_EXT_ERR_NETW_OUT_OF_ORDER                         0x26                                                  
#define SMS_EXT_ERR_TEMPORARY_FAILURE                         0x29                                                  
#define SMS_EXT_ERR_CONGESTION                                0x2A                                                  
#define SMS_EXT_ERR_RESOURCE_UNAVAILABLE                      0x2F                                                  
#define SMS_EXT_ERR_REQ_FACILITY_NOT_SUB                      0x32                                                  
#define SMS_EXT_ERR_REQ_FACILITY_NOT_IMP                      0x45                                                  
#define SMS_EXT_ERR_INVALID_REFERENCE                         0x51                                                  
#define SMS_EXT_ERR_INCORRECT_MESSAGE                         0x5F                                                  
#define SMS_EXT_ERR_INVALID_MAND_INFO                         0x60                                                  
#define SMS_EXT_ERR_INVALID_MSG_TYPE                          0x61                                                  
#define SMS_EXT_ERR_MSG_NOT_COMP_WITH_ST                      0x62                                                  
#define SMS_EXT_ERR_INVALID_INFO_ELEMENT                      0x63                                                  
#define SMS_EXT_ERR_PROTOCOL_ERROR                            0x6F                                                  
#define SMS_EXT_ERR_INTERWORKING                              0x7F                                                  
#define SMS_EXT_ERR_NO_CAUSE                                  0x80                                                  
#define SMS_EXT_ERR_IMSI_UNKNOWN_HLR                          0x82                                                  
#define SMS_EXT_ERR_ILLEGAL_MS                                0x83                                                  
#define SMS_EXT_ERR_IMSI_UNKNOWN_VLR                          0x84                                                  
#define SMS_EXT_ERR_IMEI_NOT_ACCEPTED                         0x85                                                  
#define SMS_EXT_ERR_ILLEGAL_ME                                0x86                                                  
#define SMS_EXT_ERR_PLMN_NOT_ALLOWED                          0x8B                                                  
#define SMS_EXT_ERR_LA_NOT_ALLOWED                            0x8C                                                  
#define SMS_EXT_ERR_ROAM_NOT_ALLOWED_LA                       0x8D                                                  
#define SMS_EXT_ERR_NO_SUITABLE_CELLS_LA                      0x8F                                                  
#define SMS_EXT_ERR_NETWORK_FAILURE                           0x91                                                  
#define SMS_EXT_ERR_MAC_FAILURE                               0x94                                                  
#define SMS_EXT_ERR_SYNC_FAILURE                              0x95                                                  
#define SMS_EXT_ERR_LOW_LAYER_CONGESTION                      0x96                                                  
#define SMS_EXT_ERR_AUTH_UNACCEPTABLE                         0x97                                                  
#define SMS_EXT_ERR_SERV_OPT_NOT_SUPPORTED                    0xA0                                                  
#define SMS_EXT_ERR_SERV_OPT_NOT_SUBSCRIBED                   0xA1                                                  
#define SMS_EXT_ERR_SERV_OPT_TEMP_OUT_OF_ORDER                0xA2                                                  
#define SMS_EXT_ERR_CALL_CANNOT_BE_IDENTIFIED                 0xA6                                                  
#define SMS_EXT_ERR_SEMANTICALLY_INCORR_MSG                   0xDF                                                  
#define SMS_EXT_ERR_LOW_LAYER_INVALID_MAND_INFO               0xE0                                                  
#define SMS_EXT_ERR_LOW_LAYER_INVALID_MSG_TYPE                0xE1                                                  
#define SMS_EXT_ERR_LOW_LAYER_MSG_TYPE_NOT_COMP_WITH_ST       0xE2                                                  
#define SMS_EXT_ERR_LOW_LAYER_INVALID_INFO_ELEMENT            0xE3                                                  
#define SMS_EXT_ERR_CONDITIONAL_IE_ERROR                      0xE4                                                  
#define SMS_EXT_ERR_LOW_LAYER_MSG_NOT_COMP_WITH_ST            0xE5                                                  
#define SMS_EXT_ERR_CS_BARRED                                 0xE8                                                  
#define SMS_EXT_ERR_LOW_LAYER_PROTOCOL_ERROR                  0xEF                                                  

//ConstantTable for SMS_MESSAGE_TYPE

//ConstantTable for SMS_ROUTING_TYPE

//ConstantTable for SMS_ROUTING_COMMAND
#define SMS_ROUTING_RELEASE                                   0x00                                                     
#define SMS_ROUTING_SET                                       0x01                                                     
#define SMS_ROUTING_SUSPEND                                   0x02                                                     
#define SMS_ROUTING_RESUME                                    0x03                                                     
#define SMS_ROUTING_UPDATE                                    0x04                                                     
#define SMS_ROUTING_QUERY                                     0x05                                                     

//ConstantTable for SMS_GSM_SETTING_TYPE

//ConstantTable for SMS_SETTING_TYPE
#define SMS_SETTING_TYPE_SMS                                  0x00                                                     
#define SMS_SETTING_TYPE_RESEND                               0x01                                                     
#define SMS_SETTING_TYPE_ROUTE                                0x02                                                     
#define SMS_SETTING_TYPE_EFSMSP                               0x03                                                     
#define SMS_SETTING_TYPE_TEST_ENV                             0x04                                                     

//ConstantTable for SMS_ADDRESS_TYPE

//ConstantTable for SMS_ADDRESS_TYPE
#define SMS_UNICODE_ADDRESS                                   0x00                                                     
#define SMS_DESTINATION_ADDRESS                               0x01                                                     
#define SMS_SMSC_ADDRESS                                      0x02                                                     

//ConstantTable for SMS_APPL_PORT_ADDRESS_TYPE

//ConstantTable for SMS_ALPHA_TAG_TYPE

//ConstantTable for SMS_STORAGE_STATUS

//ConstantTable for SMS_SEND_STATUS
#define SMS_MSG_REROUTED                                      0x00                                                     
#define SMS_MSG_REPEATED                                      0x01                                                     
#define SMS_MSG_WAITING_NETWORK                               0x02                                                     
#define SMS_MSG_IDLE                                          0x03                                                     

//ConstantTable for SMS_PACKING
#define SMS_PACKING_NOT_REQUIRED                              0x00                                                     
#define SMS_PACKING_REQUIRED                                  0x01                                                     

//ConstantTable for SMS_GSM_ROUTING_MODE

//ConstantTable for SMS_GSM_CB_SUBJECT_LIST_TYPE

//ConstantTable for SMS_GSM_CB_LANGUAGES

//ConstantTable for SMS_CB_LANGUAGES
#define SMS_CB_GERMAN                                         0x00                                                     
#define SMS_CB_ENGLISH                                        0x01                                                     
#define SMS_CB_ITALIAN                                        0x02                                                     
#define SMS_CB_FRENCH                                         0x03                                                     
#define SMS_CB_SPANISH                                        0x04                                                     
#define SMS_CB_DUTCH                                          0x05                                                     
#define SMS_CB_SWEDISH                                        0x06                                                     
#define SMS_CB_DANISH                                         0x07                                                     
#define SMS_CB_PORTUGUESE                                     0x08                                                     
#define SMS_CB_FINNISH                                        0x09                                                     
#define SMS_CB_NORWEGIAN                                      0x0A                                                     
#define SMS_CB_GREEK                                          0x0B                                                     
#define SMS_CB_TURKISH                                        0x0C                                                     
#define SMS_CB_HUNGARIAN                                      0x0D                                                     
#define SMS_CB_POLISH                                         0x0E                                                     
#define SMS_CB_UNSPECIFIED                                    0x0F                                                     
#define SMS_CB_CZECH                                          0x20                                                  
#define SMS_CB_HEBREW                                         0x21                                                  
#define SMS_CB_ARABIC                                         0x22                                                  
#define SMS_CB_RUSSIAN                                        0x23                                                  
#define SMS_CB_ICELANDIC                                      0x24                                                  

//ConstantTable for SMS_SM_CONTROL_ACTION

//ConstantTable for SMS_SEND_HOLD_ACTION
#define SMS_SUSPEND                                           0x00                                                     
#define SMS_RESUME                                            0x01                                                     

//ConstantTable for SMS_CONTENT_TYPE

//ConstantTable for SMS_VALIDITY_PERIOD_FORMAT
#define SMS_VPF_RELATIVE                                      0x01                                                     
#define SMS_VPF_ABSOLUTE_OR_ENHANCED                          0x07                                                     

//ConstantTable for SMS_SERVER_STATUS
#define SMS_SERVER_READY                                      0x00                                                     
#define SMS_SERVER_NOT_READY                                  0x01                                                     

//ConstantTable for SMS_SERVER_STATE
#define SMS_SERVER_IDLE                                       0x00                                                     
#define SMS_SERVER_PARTIAL_MODE                               0x01                                                     
#define SMS_SERVER_CS_INACTIVE                                0x02                                                     

//ConstantTable for SMS_ROUTE_PRIORITY
#define SMS_ROUTE_NOT_AVAILABLE                               0x00                                                     
#define SMS_ROUTE_PRIORITY_1                                  0x01                                                     
#define SMS_ROUTE_PRIORITY_2                                  0x02                                                     

//ConstantTable for SMS_SUBSCRIPTION_TYPE
#define SMS_TYPE_DEFAULT                                      0x00                                                     
#define SMS_TYPE_SIM                                          0x01                                                     

//BitmaskTables for SMS_CHECK_INFO
#define SMS_CHECK_DISABLE_NONE                                0x00                                                     
#define SMS_CHECK_DISABLE_FDN                                 0x01                                                     

//ConstantTable for SMS_RECEPTION_COMMAND
#define SMS_RECEPTION_QUERY_STATUS                            0x00                                                     
#define SMS_RECEPTION_ACTIVATE                                0x01                                                     
#define SMS_RECEPTION_DEACTIVATE                              0x02                                                     
#define SMS_RECEPTION_STORAGE_STATUS_UPDATE                   0x03                                                     

//ConstantTable for SMS_RECEPTION_STATUS
#define SMS_RECEPTION_ACTIVE                                  0x01                                                     
#define SMS_RECEPTION_INACTIVE                                0x02                                                     

//ConstantTable for SMS_RESEND_SETTING
#define SMS_RESEND_DISABLED                                   0x00                                                     
#define SMS_RESEND_ONCE                                       0x01                                                     
#define SMS_RESEND_TWICE                                      0x02                                                     
#define SMS_RESEND_THRICE                                     0x03                                                     

//ConstantTable for SMS_RES_CONF_STATUS
#define SMS_RES_CONF_STARTUP                                  0x01                                                     
#define SMS_RES_CONF_RECONFIGURED                             0x02                                                     

//ConstantTable for SMS_RES_CONF_OPERATION
#define SMS_RES_CONF_GET                                      0x01                                                     
#define SMS_RES_CONF_SET                                      0x02                                                     

//BitmaskTables for SMS_RESOURCE_IDS
#define SMS_RES_ID_MO_SM_INIT                                 0x0001                                                     

//BitmaskTables for SMS_RESOURCE_IDS_MASK
#define SMS_RES_ID_MASK_MO_SM_INIT                            0x0001                                                     

//BitmaskTables for SMS_RESOURCE_IDS_CONF_REQ
#define SMS_RES_ID_CONF_MO_SM_INIT                            0x0001                                                     

//ConstantTable for SMS_RESOURCE_STATUS
#define SMS_RESOURCE_ALLOWED                                  0x01                                                     
#define SMS_RESOURCE_DENIED                                   0x02                                                     

//BitmaskTables for SMS_PARAMETER_INDICATOR
#define SMS_PI_DESTINATION_ADDRESS                            0x01                                                     
#define SMS_PI_SERVICE_CENTRE_ADDRESS                         0x02                                                     
#define SMS_PI_PROTOCOL_ID                                    0x04                                                     
#define SMS_PI_DATA_CODING_SCHEME                             0x08                                                     
#define SMS_PI_VALIDITY_PERIOD                                0x10                                                  

//ConstantTable for SMS_CB_SUBSCRIPTION_STATUS
#define SMS_CB_SBS_NONE_SUBSCRIBED                            0x00                                                     
#define SMS_CB_SBS_ALL_SUBSCRIBED                             0x01                                                     
#define SMS_CB_SBS_PARTIALLY_SUBSCRIBED                       0x02                                                     

//ConstantTable for SMS_TEST_MT_RECEPTION
#define SMS_TEST_MT_NORMAL                                    0x00                                                     
#define SMS_TEST_MT_AUTO_ACK                                  0x01                                                     


//SUBBLOCKS


//Definition for struct SMS_SB_ADDRESS
#define SMS_SB_ADDRESS                                        0x82                                                  
typedef struct
            { 
             uint16_t     sub_block_id;
             uint16_t     sub_block_length;
             uint8_t      address_type;
             uint8_t      address_data_length;
             uint8_t      address_data[0];
            } __attribute__((packed)) SMS_SB_ADDRESS_STR;
#define SIZE_SMS_SB_ADDRESS                                   sizeof(SMS_SB_ADDRESS_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct SMS_SB_USER_DATA
#define SMS_SB_USER_DATA                                      0x20                                                  
typedef struct
            { 
             uint16_t     sub_block_id;
             uint16_t     sub_block_length;
             uint16_t     data_length;
             uint16_t     character_amount;
             uint8_t      data_bytes[0];
            } __attribute__((packed)) SMS_SB_USER_DATA_STR;
#define SIZE_SMS_SB_USER_DATA                                 sizeof(SMS_SB_USER_DATA_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct SMS_SB_VALIDITY_PERIOD
#define SMS_SB_VALIDITY_PERIOD                                0x08                                                     
typedef struct
            { 
             uint16_t     sub_block_id;
             uint16_t     sub_block_length;
             uint8_t      validity_period_length;
             uint8_t      validity_period_data[0];
            } __attribute__((packed)) SMS_SB_VALIDITY_PERIOD_STR;
#define SIZE_SMS_SB_VALIDITY_PERIOD                           sizeof(SMS_SB_VALIDITY_PERIOD_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct SMS_SB_PARAM_INDICATOR
#define SMS_SB_PARAM_INDICATOR                                0x1D                                                  
typedef struct
            { 
             uint16_t     sub_block_id;
             uint16_t     sub_block_length;
             uint8_t      protocol_id;
             uint8_t      data_coding_scheme;
             uint8_t      parameter_indicator_length;
             uint8_t      parameter_indicators[0];
            } __attribute__((packed)) SMS_SB_PARAM_INDICATOR_STR;
#define SIZE_SMS_SB_PARAM_INDICATOR                           sizeof(SMS_SB_PARAM_INDICATOR_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct SMS_SB_SUBMIT
#define SMS_SB_SUBMIT                                         0x16                                                  
typedef struct
            { 
             uint16_t     sub_block_id;
             uint16_t     sub_block_length;
             uint8_t      message_parameters;
             uint8_t      message_reference;
             uint8_t      protocol_id;
             uint8_t      data_coding_scheme;
            } __attribute__((packed)) SMS_SB_SUBMIT_STR;
#define SIZE_SMS_SB_SUBMIT                                    sizeof(SMS_SB_SUBMIT_STR)


//Definition for struct SMS_SB_COMMAND
#define SMS_SB_COMMAND                                        0x15                                                  
typedef struct
            { 
             uint16_t     sub_block_id;
             uint16_t     sub_block_length;
             uint8_t      message_parameters;
             uint8_t      message_reference;
             uint8_t      protocol_id;
             uint8_t      command_type;
             uint8_t      message_number;
             uint8_t      fillerbyte1[3];
            } __attribute__((packed)) SMS_SB_COMMAND_STR;
#define SIZE_SMS_SB_COMMAND                                   sizeof(SMS_SB_COMMAND_STR)


//Definition for struct SMS_SB_MO_UNDEFINED
#define SMS_SB_MO_UNDEFINED                                   0x1F                                                  
typedef struct
            { 
             uint16_t     sub_block_id;
             uint16_t     sub_block_length;
             uint8_t      message_parameters;
             uint8_t      message_reference;
             uint16_t     fillerbyte1;
            } __attribute__((packed)) SMS_SB_MO_UNDEFINED_STR;
#define SIZE_SMS_SB_MO_UNDEFINED                              sizeof(SMS_SB_MO_UNDEFINED_STR)


//Definition for struct SMS_SB_DELIVER_REPORT
#define SMS_SB_DELIVER_REPORT                                 0x19                                                  
typedef struct
            { 
             uint16_t     sub_block_id;
             uint16_t     sub_block_length;
             uint8_t      message_parameters;
             uint8_t      gsm_tp_failure_cause;
             uint16_t     fillerbyte1;
            } __attribute__((packed)) SMS_SB_DELIVER_REPORT_STR;
#define SIZE_SMS_SB_DELIVER_REPORT                            sizeof(SMS_SB_DELIVER_REPORT_STR)


//Definition for struct SMS_SB_SUBMIT_REPORT
#define SMS_SB_SUBMIT_REPORT                                  0x1A                                                  
typedef struct
            { 
             uint16_t     sub_block_id;
             uint16_t     sub_block_length;
             uint8_t      message_parameters;
             uint8_t      sc_time_stamp[7];
             uint8_t      tp_failure_cause;
             uint8_t      fillerbyte1[3];
            } __attribute__((packed)) SMS_SB_SUBMIT_REPORT_STR;
#define SIZE_SMS_SB_SUBMIT_REPORT                             sizeof(SMS_SB_SUBMIT_REPORT_STR)


//Definition for struct SMS_SB_CB_MESSAGE
#define SMS_SB_CB_MESSAGE                                     0x0E                                                     
typedef struct
            { 
             uint16_t     sub_block_id;
             uint16_t     sub_block_length;
             uint16_t     serial_number;
             uint16_t     cb_message_id;
             uint8_t      data_coding_scheme;
             uint8_t      page;
             uint8_t      info_length;
             uint8_t      content_of_message[82];
             uint8_t      fillerbyte1[3];
            } __attribute__((packed)) SMS_SB_CB_MESSAGE_STR;
#define SIZE_SMS_SB_CB_MESSAGE                                sizeof(SMS_SB_CB_MESSAGE_STR)


//Definition for struct SMS_SB_RESEND_SETTING
#define SMS_SB_RESEND_SETTING                                 0x14                                                  
typedef struct
            { 
             uint16_t     sub_block_id;
             uint16_t     sub_block_length;
             uint8_t      resend_setting;
             uint8_t      fillerbyte1[3];
            } __attribute__((packed)) SMS_SB_RESEND_SETTING_STR;
#define SIZE_SMS_SB_RESEND_SETTING                            sizeof(SMS_SB_RESEND_SETTING_STR)


//Definition for struct SMS_SB_TPDU
#define SMS_SB_TPDU                                           0x1C                                                  
typedef struct
            { 
             uint16_t     sub_block_id;
             uint16_t     sub_block_length;
             uint8_t      packing_required;
             uint8_t      fillerbyte1[3];
            } __attribute__((packed)) SMS_SB_TPDU_STR;
#define SIZE_SMS_SB_TPDU                                      sizeof(SMS_SB_TPDU_STR)


//Definition for struct SMS_SB_CB_DCS_LIST
#define SMS_SB_CB_DCS_LIST                                    0x25                                                  
typedef struct
            { 
             uint16_t     sub_block_id;
             uint16_t     sub_block_length;
             uint8_t      fillerbyte1;
             uint8_t      dcs_count;
             uint8_t      dcs_value[0];
            } __attribute__((packed)) SMS_SB_CB_DCS_LIST_STR;
#define SIZE_SMS_SB_CB_DCS_LIST                               sizeof(SMS_SB_CB_DCS_LIST_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct SMS_SB_CB_SUBJECTS
#define SMS_SB_CB_SUBJECTS                                    0x26                                                  
typedef struct
            { 
             uint16_t     sub_block_id;
             uint16_t     sub_block_length;
             uint8_t      fillerbyte1;
             uint8_t      subject_count;
             uint16_t     subject_list_ids[0];
            } __attribute__((packed)) SMS_SB_CB_SUBJECTS_STR;
#define SIZE_SMS_SB_CB_SUBJECTS                               sizeof(SMS_SB_CB_SUBJECTS_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct SMS_SB_CB_SUBJECT_RANGE
#define SMS_SB_CB_SUBJECT_RANGE                               0x27                                                  
typedef struct
            { 
             uint16_t     sub_block_id;
             uint16_t     sub_block_length;
             uint16_t     cb_range_begin_id;
             uint16_t     cb_range_end_id;
            } __attribute__((packed)) SMS_SB_CB_SUBJECT_RANGE_STR;
#define SIZE_SMS_SB_CB_SUBJECT_RANGE                          sizeof(SMS_SB_CB_SUBJECT_RANGE_STR)


//Definition for struct SMS_SB_SETTINGS
#define SMS_SB_SETTINGS                                       0x21                                                  
typedef struct
            { 
             uint16_t     sub_block_id;
             uint16_t     sub_block_length;
             uint8_t      settings_indicator;
             uint8_t      reply_path_request;
             uint8_t      confirmation_request;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) SMS_SB_SETTINGS_STR;
#define SIZE_SMS_SB_SETTINGS                                  sizeof(SMS_SB_SETTINGS_STR)


//Definition for struct SMS_SB_SERVER_STATE_INFO
#define SMS_SB_SERVER_STATE_INFO                              0x22                                                  
typedef struct
            { 
             uint16_t     sub_block_id;
             uint16_t     sub_block_length;
             uint8_t      server_state;
             uint8_t      fillerbyte1[3];
            } __attribute__((packed)) SMS_SB_SERVER_STATE_INFO_STR;
#define SIZE_SMS_SB_SERVER_STATE_INFO                         sizeof(SMS_SB_SERVER_STATE_INFO_STR)


//Definition for struct SMS_SB_ROUTE_INFO
#define SMS_SB_ROUTE_INFO                                     0x23                                                  
typedef struct
            { 
             uint16_t     sub_block_id;
             uint16_t     sub_block_length;
             uint8_t      cs_route_info;
             uint8_t      ps_route_info;
             uint16_t     fillerbyte1;
            } __attribute__((packed)) SMS_SB_ROUTE_INFO_STR;
#define SIZE_SMS_SB_ROUTE_INFO                                sizeof(SMS_SB_ROUTE_INFO_STR)


//Definition for struct SMS_SB_CHECK_INFO
#define SMS_SB_CHECK_INFO                                     0x87                                                  
typedef struct
            { 
             uint16_t     sub_block_id;
             uint16_t     sub_block_length;
             uint8_t      int_check_info;
             uint8_t      fillerbyte1[3];
            } __attribute__((packed)) SMS_SB_CHECK_INFO_STR;
#define SIZE_SMS_SB_CHECK_INFO                                sizeof(SMS_SB_CHECK_INFO_STR)


//Definition for struct SMS_SB_RECEPTION_STATUS
#define SMS_SB_RECEPTION_STATUS                               0x2C                                                  
typedef struct
            { 
             uint16_t     sub_block_id;
             uint16_t     sub_block_length;
             uint8_t      status;
             uint8_t      fillerbyte1[3];
            } __attribute__((packed)) SMS_SB_RECEPTION_STATUS_STR;
#define SIZE_SMS_SB_RECEPTION_STATUS                          sizeof(SMS_SB_RECEPTION_STATUS_STR)


//Definition for struct SMS_SB_CBS_SUBSCRIPTION
#define SMS_SB_CBS_SUBSCRIPTION                               0x2D                                                  
typedef struct
            { 
             uint16_t     sub_block_id;
             uint16_t     sub_block_length;
             uint8_t      cbs_subscription_client_count;
             uint8_t      cbs_subscriber_id[0];
            } __attribute__((packed)) SMS_SB_CBS_SUBSCRIPTION_STR;
#define SIZE_SMS_SB_CBS_SUBSCRIPTION                          sizeof(SMS_SB_CBS_SUBSCRIPTION_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct SMS_SB_RESOURCE_CONF
#define SMS_SB_RESOURCE_CONF                                  0x2B                                                  
typedef struct
            { 
             uint16_t     sub_block_id;
             uint16_t     sub_block_length;
             uint16_t     resources;
             uint16_t     resource_mask;
            } __attribute__((packed)) SMS_SB_RESOURCE_CONF_STR;
#define SIZE_SMS_SB_RESOURCE_CONF                             sizeof(SMS_SB_RESOURCE_CONF_STR)


//Definition for struct SMS_SB_RESOURCE
#define SMS_SB_RESOURCE                                       0x2A                                                  
typedef struct
            { 
             uint16_t     sub_block_id;
             uint16_t     sub_block_length;
             uint16_t     resources;
             uint16_t     fillerbyte1;
            } __attribute__((packed)) SMS_SB_RESOURCE_STR;
#define SIZE_SMS_SB_RESOURCE                                  sizeof(SMS_SB_RESOURCE_STR)


//Definition for struct SMS_SB_CAUSE
#define SMS_SB_CAUSE                                          0x29                                                  
typedef struct
            { 
             uint16_t     sub_block_id;
             uint16_t     sub_block_length;
             uint8_t      cause_type;
             uint8_t      sms_cause;
             uint16_t     fillerbyte1;
            } __attribute__((packed)) SMS_SB_CAUSE_STR;
#define SIZE_SMS_SB_CAUSE                                     sizeof(SMS_SB_CAUSE_STR)


//Definition for struct SMS_SB_RESOURCE_CONF_REQUIRED
#define SMS_SB_RESOURCE_CONF_REQUIRED                         0x28                                                  
typedef struct
            { 
             uint16_t     sub_block_id;
             uint16_t     sub_block_length;
             uint16_t     res_pp;
             uint16_t     fillerbyte1;
            } __attribute__((packed)) SMS_SB_RESOURCE_CONF_REQUIRED_STR;
#define SIZE_SMS_SB_RESOURCE_CONF_REQUIRED                    sizeof(SMS_SB_RESOURCE_CONF_REQUIRED_STR)


//Definition for struct SMS_SB_RESOURCE_SEQ_ID
#define SMS_SB_RESOURCE_SEQ_ID                                0x2E                                                  
typedef struct
            { 
             uint16_t     sub_block_id;
             uint16_t     sub_block_length;
             uint8_t      sequence_id;
             uint8_t      fillerbyte1[3];
            } __attribute__((packed)) SMS_SB_RESOURCE_SEQ_ID_STR;
#define SIZE_SMS_SB_RESOURCE_SEQ_ID                           sizeof(SMS_SB_RESOURCE_SEQ_ID_STR)


//Definition for struct SMS_SB_RESOURCE_STATUS
#define SMS_SB_RESOURCE_STATUS                                0x2F                                                  
typedef struct
            { 
             uint16_t     sub_block_id;
             uint16_t     sub_block_length;
             uint8_t      res_status;
             uint8_t      fillerbyte1[3];
            } __attribute__((packed)) SMS_SB_RESOURCE_STATUS_STR;
#define SIZE_SMS_SB_RESOURCE_STATUS                           sizeof(SMS_SB_RESOURCE_STATUS_STR)


//Definition for struct SMS_SB_REQ_INFO
#define SMS_SB_REQ_INFO                                       0x30                                                  
typedef struct
            { 
             uint16_t     sub_block_id;
             uint16_t     sub_block_length;
             uint8_t      req_transaction_id;
             uint8_t      fillerbyte1[3];
            } __attribute__((packed)) SMS_SB_REQ_INFO_STR;
#define SIZE_SMS_SB_REQ_INFO                                  sizeof(SMS_SB_REQ_INFO_STR)


//Definition for struct SMS_SB_SMS_PARAMETERS
#define SMS_SB_SMS_PARAMETERS                                 0x31                                                  
typedef struct
            { 
             uint16_t     sub_block_id;
             uint16_t     sub_block_length;
             uint8_t      location_number;
             uint8_t      sms_parameters;
             uint16_t     fillerbyte1;
            } __attribute__((packed)) SMS_SB_SMS_PARAMETERS_STR;
#define SIZE_SMS_SB_SMS_PARAMETERS                            sizeof(SMS_SB_SMS_PARAMETERS_STR)


//Definition for struct SMS_SB_TEST_ENVIRONMENT_SETTINGS
#define SMS_SB_TEST_ENVIRONMENT_SETTINGS                      0x32                                                  
typedef struct
            { 
             uint16_t     sub_block_id;
             uint16_t     sub_block_length;
             uint8_t      settings_indicator;
             uint8_t      mt_sm_auto_ack;
             uint16_t     fillerbyte1;
            } __attribute__((packed)) SMS_SB_TEST_ENVIRONMENT_SETTINGS_STR;
#define SIZE_SMS_SB_TEST_ENVIRONMENT_SETTINGS                 sizeof(SMS_SB_TEST_ENVIRONMENT_SETTINGS_STR)


//MESSAGES


//Definition for struct SMS_MESSAGE_SEND_STATUS_IND
#define SMS_MESSAGE_SEND_STATUS_IND                           0x22                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      message_reference;
             uint8_t      route;
             uint8_t      current_segment;
             uint8_t      segments_total;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) SMS_MESSAGE_SEND_STATUS_IND_STR;
#define SIZE_SMS_MESSAGE_SEND_STATUS_IND                      sizeof(SMS_MESSAGE_SEND_STATUS_IND_STR)


//Definition for struct SMS_MEMORY_CAPACITY_EXC_IND
#define SMS_MEMORY_CAPACITY_EXC_IND                           0x1D                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint16_t     fillerbyte1;
            } __attribute__((packed)) SMS_MEMORY_CAPACITY_EXC_IND_STR;
#define SIZE_SMS_MEMORY_CAPACITY_EXC_IND                      sizeof(SMS_MEMORY_CAPACITY_EXC_IND_STR)


//Definition for struct SMS_SEND_HOLD_REQ
#define SMS_SEND_HOLD_REQ                                     0x27                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      action;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) SMS_SEND_HOLD_REQ_STR;
#define SIZE_SMS_SEND_HOLD_REQ                                sizeof(SMS_SEND_HOLD_REQ_STR)


//Definition for struct SMS_SEND_HOLD_RESP
#define SMS_SEND_HOLD_RESP                                    0x28                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      cause;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) SMS_SEND_HOLD_RESP_STR;
#define SIZE_SMS_SEND_HOLD_RESP                               sizeof(SMS_SEND_HOLD_RESP_STR)


//Definition for struct SMS_SEND_HOLD_IND
#define SMS_SEND_HOLD_IND                                     0x29                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      action;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) SMS_SEND_HOLD_IND_STR;
#define SIZE_SMS_SEND_HOLD_IND                                sizeof(SMS_SEND_HOLD_IND_STR)


//Definition for struct SMS_MESSAGE_SEND_REQ
#define SMS_MESSAGE_SEND_REQ                                  0x02                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      more_messages_to_send;
             uint8_t      sms_route;
             uint8_t      repeated_message;
             uint16_t     fillerbyte1;
             uint8_t      sub_block_count;
            } __attribute__((packed)) SMS_MESSAGE_SEND_REQ_STR;
#define SIZE_SMS_MESSAGE_SEND_REQ                             sizeof(SMS_MESSAGE_SEND_REQ_STR)


//Definition for struct SMS_MESSAGE_SEND_RESP
#define SMS_MESSAGE_SEND_RESP                                 0x03                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      cause_type;
             uint8_t      sms_cause;
             uint8_t      reference_for_message;
             uint16_t     fillerbyte1;
             uint8_t      sub_block_count;
            } __attribute__((packed)) SMS_MESSAGE_SEND_RESP_STR;
#define SIZE_SMS_MESSAGE_SEND_RESP                            sizeof(SMS_MESSAGE_SEND_RESP_STR)


//Definition for struct SMS_RECEIVED_MSG_REPORT_REQ
#define SMS_RECEIVED_MSG_REPORT_REQ                           0x3B                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      cause_type;
             uint8_t      sms_cause;
             uint8_t      fillerbyte1[3];
             uint8_t      sub_block_count;
            } __attribute__((packed)) SMS_RECEIVED_MSG_REPORT_REQ_STR;
#define SIZE_SMS_RECEIVED_MSG_REPORT_REQ                      sizeof(SMS_RECEIVED_MSG_REPORT_REQ_STR)


//Definition for struct SMS_RECEIVED_MSG_REPORT_RESP
#define SMS_RECEIVED_MSG_REPORT_RESP                          0x3C                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      sms_cause;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) SMS_RECEIVED_MSG_REPORT_RESP_STR;
#define SIZE_SMS_RECEIVED_MSG_REPORT_RESP                     sizeof(SMS_RECEIVED_MSG_REPORT_RESP_STR)


//Definition for struct SMS_RECEIVE_MESSAGE_REQ
#define SMS_RECEIVE_MESSAGE_REQ                               0x41                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      action;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) SMS_RECEIVE_MESSAGE_REQ_STR;
#define SIZE_SMS_RECEIVE_MESSAGE_REQ                          sizeof(SMS_RECEIVE_MESSAGE_REQ_STR)


//Definition for struct SMS_RECEIVE_MESSAGE_RESP
#define SMS_RECEIVE_MESSAGE_RESP                              0x42                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      sub_block_count;
            } __attribute__((packed)) SMS_RECEIVE_MESSAGE_RESP_STR;
#define SIZE_SMS_RECEIVE_MESSAGE_RESP                         sizeof(SMS_RECEIVE_MESSAGE_RESP_STR)


//Definition for struct SMS_RECEIVED_MSG_IND
#define SMS_RECEIVED_MSG_IND                                  0x43                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      sub_block_count;
            } __attribute__((packed)) SMS_RECEIVED_MSG_IND_STR;
#define SIZE_SMS_RECEIVED_MSG_IND                             sizeof(SMS_RECEIVED_MSG_IND_STR)


//Definition for struct SMS_RECEIVED_SIM_MSG_IND
#define SMS_RECEIVED_SIM_MSG_IND                              0x44                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      sub_block_count;
            } __attribute__((packed)) SMS_RECEIVED_SIM_MSG_IND_STR;
#define SIZE_SMS_RECEIVED_SIM_MSG_IND                         sizeof(SMS_RECEIVED_SIM_MSG_IND_STR)


//Definition for struct SMS_CB_ROUTING_REQ
#define SMS_CB_ROUTING_REQ                                    0x34                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      routing_command;
             uint8_t      subscription_number;
             uint8_t      subscription_type;
             uint16_t     fillerbyte1;
             uint8_t      sub_block_count;
            } __attribute__((packed)) SMS_CB_ROUTING_REQ_STR;
#define SIZE_SMS_CB_ROUTING_REQ                               sizeof(SMS_CB_ROUTING_REQ_STR)


//Definition for struct SMS_CB_ROUTING_RESP
#define SMS_CB_ROUTING_RESP                                   0x35                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      subscription_number;
             uint8_t      sms_cause;
             uint8_t      cb_subscription_status;
             uint16_t     fillerbyte1;
             uint8_t      sub_block_count;
            } __attribute__((packed)) SMS_CB_ROUTING_RESP_STR;
#define SIZE_SMS_CB_ROUTING_RESP                              sizeof(SMS_CB_ROUTING_RESP_STR)


//Definition for struct SMS_CB_ROUTING_IND
#define SMS_CB_ROUTING_IND                                    0x36                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      sub_block_count;
            } __attribute__((packed)) SMS_CB_ROUTING_IND_STR;
#define SIZE_SMS_CB_ROUTING_IND                               sizeof(SMS_CB_ROUTING_IND_STR)


//Definition for struct SMS_CB_SIM_ROUTING_IND
#define SMS_CB_SIM_ROUTING_IND                                0x37                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      sub_block_count;
            } __attribute__((packed)) SMS_CB_SIM_ROUTING_IND_STR;
#define SIZE_SMS_CB_SIM_ROUTING_IND                           sizeof(SMS_CB_SIM_ROUTING_IND_STR)


//Definition for struct SMS_SETTINGS_UPDATE_REQ
#define SMS_SETTINGS_UPDATE_REQ                               0x30                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      setting_type;
             uint8_t      sub_block_count;
            } __attribute__((packed)) SMS_SETTINGS_UPDATE_REQ_STR;
#define SIZE_SMS_SETTINGS_UPDATE_REQ                          sizeof(SMS_SETTINGS_UPDATE_REQ_STR)


//Definition for struct SMS_SETTINGS_UPDATE_RESP
#define SMS_SETTINGS_UPDATE_RESP                              0x31                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      sms_gsm_setting_type;
             uint8_t      sms_cause;
            } __attribute__((packed)) SMS_SETTINGS_UPDATE_RESP_STR;
#define SIZE_SMS_SETTINGS_UPDATE_RESP                         sizeof(SMS_SETTINGS_UPDATE_RESP_STR)


//Definition for struct SMS_SETTINGS_READ_REQ
#define SMS_SETTINGS_READ_REQ                                 0x32                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      sms_setting_type;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) SMS_SETTINGS_READ_REQ_STR;
#define SIZE_SMS_SETTINGS_READ_REQ                            sizeof(SMS_SETTINGS_READ_REQ_STR)


//Definition for struct SMS_SETTINGS_READ_RESP
#define SMS_SETTINGS_READ_RESP                                0x33                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      sms_cause;
             uint8_t      sub_block_count;
            } __attribute__((packed)) SMS_SETTINGS_READ_RESP_STR;
#define SIZE_SMS_SETTINGS_READ_RESP                           sizeof(SMS_SETTINGS_READ_RESP_STR)


//Definition for struct SMS_MT_SM_TEST_ENV_IND
#define SMS_MT_SM_TEST_ENV_IND                                0x38                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      sub_block_count;
            } __attribute__((packed)) SMS_MT_SM_TEST_ENV_IND_STR;
#define SIZE_SMS_MT_SM_TEST_ENV_IND                           sizeof(SMS_MT_SM_TEST_ENV_IND_STR)


//Definition for struct SMS_STATUS_REQ
#define SMS_STATUS_REQ                                        0x2E                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint16_t     fillerbyte1;
            } __attribute__((packed)) SMS_STATUS_REQ_STR;
#define SIZE_SMS_STATUS_REQ                                   sizeof(SMS_STATUS_REQ_STR)


//Definition for struct SMS_STATUS_RESP
#define SMS_STATUS_RESP                                       0x2F                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      server_status;
             uint8_t      sub_block_count;
            } __attribute__((packed)) SMS_STATUS_RESP_STR;
#define SIZE_SMS_STATUS_RESP                                  sizeof(SMS_STATUS_RESP_STR)


//Definition for struct SMS_STATUS_IND
#define SMS_STATUS_IND                                        0x2D                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      server_status;
             uint8_t      sub_block_count;
            } __attribute__((packed)) SMS_STATUS_IND_STR;
#define SIZE_SMS_STATUS_IND                                   sizeof(SMS_STATUS_IND_STR)


//Definition for struct SMS_RESOURCE_CONF_REQ
#define SMS_RESOURCE_CONF_REQ                                 0x45                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      conf_operation;
             uint8_t      sub_block_count;
            } __attribute__((packed)) SMS_RESOURCE_CONF_REQ_STR;
#define SIZE_SMS_RESOURCE_CONF_REQ                            sizeof(SMS_RESOURCE_CONF_REQ_STR)


//Definition for struct SMS_RESOURCE_CONF_RESP
#define SMS_RESOURCE_CONF_RESP                                0x46                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      conf_operation;
             uint8_t      sub_block_count;
            } __attribute__((packed)) SMS_RESOURCE_CONF_RESP_STR;
#define SIZE_SMS_RESOURCE_CONF_RESP                           sizeof(SMS_RESOURCE_CONF_RESP_STR)


//Definition for struct SMS_RESOURCE_CONF_IND
#define SMS_RESOURCE_CONF_IND                                 0x47                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      conf_status;
             uint8_t      sub_block_count;
            } __attribute__((packed)) SMS_RESOURCE_CONF_IND_STR;
#define SIZE_SMS_RESOURCE_CONF_IND                            sizeof(SMS_RESOURCE_CONF_IND_STR)


//Definition for struct SMS_RESOURCE_REQ
#define SMS_RESOURCE_REQ                                      0x49                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      sub_block_count;
            } __attribute__((packed)) SMS_RESOURCE_REQ_STR;
#define SIZE_SMS_RESOURCE_REQ                                 sizeof(SMS_RESOURCE_REQ_STR)


//Definition for struct SMS_RESOURCE_RESP
#define SMS_RESOURCE_RESP                                     0x4A                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      sub_block_count;
            } __attribute__((packed)) SMS_RESOURCE_RESP_STR;
#define SIZE_SMS_RESOURCE_RESP                                sizeof(SMS_RESOURCE_RESP_STR)


//Definition for struct SMS_RESOURCE_IND
#define SMS_RESOURCE_IND                                      0x4B                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      sub_block_count;
            } __attribute__((packed)) SMS_RESOURCE_IND_STR;
#define SIZE_SMS_RESOURCE_IND                                 sizeof(SMS_RESOURCE_IND_STR)

#endif
