#ifndef _PN_SS_ISI_H_
#define _PN_SS_ISI_H_

#include <stdint.h> 

//Resource Supplementary Services Server
//PN_SS 0x06 
//ISI version 010.003
#define SUPPLEMENTARY_SERVICES_SERVER_ISI_VERSION_Z     10
#define SUPPLEMENTARY_SERVICES_SERVER_ISI_VERSION_Y     3

//In case of problems concerning content of this file contact Henrik Ala-Uotila
//Server specific message descriptions and feature&protocol descriptions can be found from: https://oucmswww.nmp.nokia.com:58443/document_browser/ccm_wa/GIF_SPECS/ 


//ISI VERSION CHANGE HISTORY

//Version: 010.003                                           
//Status: Approved                                          
//Date: 04-Jun-2008     Olli Kettunen
//Reason: Corrected defects
//Reference: ADB for SWAM: Inspection: OK08060459364 , APPROVED

//Version: 010.002                                           
//Status: Approved                                          
//Date: 14-Apr-2008     Olli Kettunen
//Reason: Corrected defect
//Reference: ADB for SWAM: Inspection: OK08032856928 , APPROVED

//Version: 010.001                                           
//Status: Approved                                          
//Date: 10-Apr-2008     Olli Kettunen
//Reason: Corrected inspection defects
//Reference: ADB for SWAM: Inspection: OK08032856928 , APPROVED

//Version: 010.000                                           
//Status: Draft                                             
//Date: 31-Mar-2008     Olli Kettunen
//Reason: Implemented CR
//Reference: ADB for SWAM: CR: OK08022652538  Inspection: OK08032856928 , DRAFT

//Version: 009.002                                           
//Status: Approved                                          
//Date: 25-Apr-2007     Ilkka Leinonen
//Reason: Implemented CR
//Reference: ADB for SWAM: CR: IL07042634813, Inspection: IL07050742134, APPROVED

//Version: 009.001                                           
//Status: Approved                                          
//Date: 19-Jan-2007     Olli Kettunen
//Reason: Implemented CR
//Reference: ADB for SWAM: CR: OK06121932513, Inspection: OK07010853259 , APPROVED

//Version: 009.000                                           
//Status: Approved                                          
//Date: 13-Sep-2006     Olli Kettunen
//Reason: Implemented CR
//Reference: ADB for SWAM: CR: OK06090637069, Inspection OK06090739240 , APPROVED

//Version: 008.005                                           
//Status: Approved                                          
//Date: 14-Feb-2006     Olli Kettunen
//Reason: Implemented CR
//Reference: ADB for SWAM: CR: OK06012333398, Inspection OK06020644222 , APPROVED

//Version: 008.004                                           
//Status: Approved                                          
//Date: 06-Sep-2005     Timo Krall
//Reason: Inspection
//Reference: ADB for SWAM: CR: TK05081552860, Inspection TK05082947314, APPROVED

//Version: 008.003                                           
//Status: Draft                                             
//Date: 29-Aug-2005     Timo Krall
//Reason: Implemented CR
//Reference: ADB for SWAM: CR: TK05081552860, Inspection TK05082947314, DRAFT

//Version: 008.002                                           
//Status: Approved                                          
//Date: 15-Jun-2004     Jani R. Manninen
//Reason: Corrections after Inspection
//Reference: ADB for SWAM Inspection ID: JM04060734215, APPROVED

//Version: 008.001                                           
//Status: Approved                                          
//Date: 10-Jun-2004     Jani R. Manninen
//Reason: New Feature
//Reference: ADB for SWAM CR ID: AM04040732623, ADB for SWAM Inspection ID: JM04060734215, APPROVED

//Version: 008.000                                           
//Status: Approved                                          
//Date: 02-June-2004    Kalpana Mahanta
//Reason: Call Screening FeatureImplementation
//Reference: ADB for TDMA BU: CR ID: CH02081533156   ,ADB for TDMA BU: Inspection ID: KM04050557859, APPROVED

//Version: 007.000                                           
//Status: Approved                                          
//Date: 22-Oct-2003     Jani R. Manninen
//Reason: Implementation change
//Reference: ADB for SWAM CR ID: JM03101454352, APPROVED

//Version: 006.000                                           
//Status: Approved                                          
//Date: 01-Sep-2003     Jani R. Manninen
//Reason: Implementation change
//Reference: ADB for SWAM CR ID: JM03080737316, ADB for SWAM CR ID: JM03082847468, APPROVED

//Version: 005.000                                           
//Status: Approved                                          
//Date: 08-May-2003     Jani R. Manninen
//Reason: Implementation change and New feature
//Reference: ADB for SWAM CR ID: JM03040353363, APPROVED

//Version: 004.009                                           
//Status: Approved                                          
//Date: 28-Mar-2003     Jani R. Manninen
//Reason: Error Corrections and Implementation change
//Reference: ADB for SWAM CR ID: JM03032450568 , APPROVED

//Version: 004.008                                           
//Status: Approved                                          
//Date: 10-Dec-2002     Jani R. Manninen
//Reason: Corrections after Inspection
//Reference: ADB for SWAM inspection ID:  JM02120555877, APPROVED

//Version: 004.007                                           
//Status: Draft                                             
//Date: 04-Dec-2002     Jani R. Manninen
//Reason: Inspection
//Reference: ADB for SWAM inspection ID: JM02120555877, DRAFT

//Version: 004.006                                           
//Status: Unknown                                           
//Date: -               -
//Reason: -
//Reference: -

//Version: 004.005                                           
//Status: Unknown                                           
//Date: -               -
//Reason: -
//Reference: -

//Version: 004.004                                           
//Status: Unknown                                           
//Date: -               -
//Reason: -
//Reference: -

//Version: 004.003                                           
//Status: Unknown                                           
//Date: -               -
//Reason: -
//Reference: -

//Version: 004.002                                           
//Status: Unknown                                           
//Date: -               -
//Reason: -
//Reference: -

//Version: 004.001                                           
//Status: Unknown                                           
//Date: -               -
//Reason: -
//Reference: -

//Version: 004.000                                           
//Status: Unknown                                           
//Date: -               -
//Reason: -
//Reference: -

//Version: 003.004                                           
//Status: Unknown                                           
//Date: -               -
//Reason: -
//Reference: -

//Version: 003.003                                           
//Status: Unknown                                           
//Date: -               -
//Reason: -
//Reference: -

//Version: 003.002                                           
//Status: Unknown                                           
//Date: -               -
//Reason: -
//Reference: -

//Version: 003.001                                           
//Status: Unknown                                           
//Date: -               -
//Reason: -
//Reference: -

//Version: 003.000                                           
//Status: Unknown                                           
//Date: -               -
//Reason: -
//Reference: -

//Version: 002.000                                           
//Status: Unknown                                           
//Date: -               -
//Reason: -
//Reference: -

//Version: 001.000                                           
//Status: Unknown                                           
//Date: -               -
//Reason: -
//Reference: -


//CONSTANTS
#define MAX_USSD_LENGTH                                       0xA0                                                  
#define ISI_MSG_OK                                            0xFF                                                  
#define PASSWORD_LENGTH                                       0x04                                                     
#define UNICODE_PASSWORD_LENGTH                               0x08                                                     
#define SS_UNDEFINED_TIME                                     0x00                                                     
#define SS_UNKNOWN_NUMBER                                     0x3F                                                  
#define LCS_MAX_EXT_GEO_INFO_LENGTH                           0x14                                                  
#define LCS_MAX_SERVICE_LENGTH                                0x38                                                  
#define LCS_MAX_SIMULTANIOUS_TRANS                            0x05                                                     
#define SS_ANY_SIZE                                           1                                                     


//TABLES

//ConstantTable for SS_GSM_SS_CODES
#define SS_GSM_ALL_SS                                         0x0000                                                     
#define SS_GSM_ALL_FORWARDINGS                                0x02                                                     
#define SS_GSM_ALL_COND_FORWARDINGS                           0x04                                                     
#define SS_GSM_FORW_UNCONDITIONAL                             0x15                                                  
#define SS_GSM_FORW_BUSY                                      0x43                                                  
#define SS_GSM_FORW_NO_REPLY                                  0x3D                                                  
#define SS_GSM_FORW_NO_REACH                                  0x3E                                                  
#define SS_GSM_ALL_BARRINGS                                   0x014A                                                   
#define SS_GSM_BARR_ALL_OUT                                   0x21                                                  
#define SS_GSM_BARR_OUT_INTER                                 0x014B                                                   
#define SS_GSM_BARR_OUT_INTER_EXC_HOME                        0x014C                                                   
#define SS_GSM_BARR_ALL_IN                                    0x23                                                  
#define SS_GSM_BARR_ALL_IN_ROAM                               0x015F                                                   
#define SS_GSM_OUTGOING_BARR_SERV                             0x014D                                                   
#define SS_GSM_INCOMING_BARR_SERV                             0x0161                                                   
#define SS_GSM_CALL_WAITING                                   0x2B                                                  
#define SS_GSM_CLIP                                           0x1E                                                  
#define SS_GSM_CLIR                                           0x1F                                                  
#define SS_GSM_COLP                                           0x4C                                                  
#define SS_GSM_COLR                                           0x4D                                                  
#define SS_GSM_CCBS                                           0x25                                                  
#define SS_GSM_CNAP                                           0x012C                                                   
#define SS_GSM_ECT                                            0x60                                                  
#define SS_GSM_CD                                             0x42                                                  
#define SS_GSM_ALL_UUS                                        0x0168                                                   
#define SS_GSM_UUS1                                           0x0169                                                   
#define SS_GSM_UUS2                                           0x016A                                                   
#define SS_GSM_UUS3                                           0x016B                                                   
#define SS_GSM_MSP1                                           0x024F                                                   
#define SS_GSM_MSP2                                           0x0250                                                   
#define SS_GSM_MSP3                                           0x0251                                                   
#define SS_GSM_MSP4                                           0x0252                                                   

//ConstantTable for SS_BASIC_SERVICE_CODES
#define SS_ALL_TELE_AND_BEARER                                0x00                                                     
#define SS_GSM_ALL_TELE                                       0x0A                                                     
#define SS_GSM_TELEPHONY                                      0x0B                                                     
#define SS_GSM_ALL_DATA_TELE                                  0x0C                                                     
#define SS_GSM_FACSIMILE                                      0x0D                                                     
#define SS_GSM_SMS                                            0x10                                                  
#define SS_GSM_VOICE_GROUP                                    0x11                                                  
#define SS_GSM_ALL_TELE_EXC_SMS                               0x13                                                  
#define SS_GSM_ALL_PLMN_SPEC_TELE_SERV                        0x32                                                  
#define SS_GSM_PLMN_SPEC_TELE_SERV_1                          0x33                                                  
#define SS_GSM_PLMN_SPEC_TELE_SERV_2                          0x34                                                  
#define SS_GSM_PLMN_SPEC_TELE_SERV_3                          0x35                                                  
#define SS_GSM_PLMN_SPEC_TELE_SERV_4                          0x36                                                  
#define SS_GSM_PLMN_SPEC_TELE_SERV_5                          0x37                                                  
#define SS_GSM_PLMN_SPEC_TELE_SERV_6                          0x38                                                  
#define SS_GSM_PLMN_SPEC_TELE_SERV_7                          0x39                                                  
#define SS_GSM_PLMN_SPEC_TELE_SERV_8                          0x3A                                                  
#define SS_GSM_PLMN_SPEC_TELE_SERV_9                          0x3B                                                  
#define SS_GSM_PLMN_SPEC_TELE_SERV_A                          0x3C                                                  
#define SS_GSM_PLMN_SPEC_TELE_SERV_B                          0x3D                                                  
#define SS_GSM_PLMN_SPEC_TELE_SERV_C                          0x3E                                                  
#define SS_GSM_PLMN_SPEC_TELE_SERV_D                          0x3F                                                  
#define SS_GSM_PLMN_SPEC_TELE_SERV_E                          0x40                                                  
#define SS_GSM_PLMN_SPEC_TELE_SERV_F                          0x41                                                  
#define SS_GSM_AUX_TELEPHONY                                  0x59                                                  
#define SS_GSM_ALL_BEARER                                     0x14                                                  
#define SS_GSM_ALL_ASYNC                                      0x15                                                  
#define SS_GSM_ALL_SYNC                                       0x16                                                  
#define SS_GSM_ALL_DATA_CIRCUIT_SYNC                          0x18                                                  
#define SS_GSM_ALL_DATA_CIRCUIT_ASYNC                         0x19                                                  
#define SS_GSM_ALL_DATA_PACKET_SYNC                           0x1A                                                  
#define SS_GSM_ALL_PAD_ACCESS                                 0x1B                                                  
#define SS_GSM_ALL_PLMN_SPEC_BEAR_SERV                        0x46                                                  
#define SS_GSM_PLMN_SPEC_BEAR_SERV_1                          0x47                                                  
#define SS_GSM_PLMN_SPEC_BEAR_SERV_2                          0x48                                                  
#define SS_GSM_PLMN_SPEC_BEAR_SERV_3                          0x49                                                  
#define SS_GSM_PLMN_SPEC_BEAR_SERV_4                          0x4A                                                  
#define SS_GSM_PLMN_SPEC_BEAR_SERV_5                          0x4B                                                  
#define SS_GSM_PLMN_SPEC_BEAR_SERV_6                          0x4C                                                  
#define SS_GSM_PLMN_SPEC_BEAR_SERV_7                          0x4D                                                  
#define SS_GSM_PLMN_SPEC_BEAR_SERV_8                          0x4E                                                  
#define SS_GSM_PLMN_SPEC_BEAR_SERV_9                          0x4F                                                  
#define SS_GSM_PLMN_SPEC_BEAR_SERV_A                          0x50                                                  
#define SS_GSM_PLMN_SPEC_BEAR_SERV_B                          0x51                                                  
#define SS_GSM_PLMN_SPEC_BEAR_SERV_C                          0x52                                                  
#define SS_GSM_PLMN_SPEC_BEAR_SERV_D                          0x53                                                  
#define SS_GSM_PLMN_SPEC_BEAR_SERV_E                          0x54                                                  
#define SS_GSM_PLMN_SPEC_BEAR_SERV_F                          0x55                                                  
#define SS_UNKNOWN_SERVICE                                    0xFF                                                  

//ConstantTable for SS_GSM_ERROR_CODES
#define SS_GSM_UNKNOWN_ERROR                                  0x00                                                     
#define SS_GSM_UNKNOWN_SUBSCRIBER                             0x01                                                     
#define SS_GSM_ILLEGAL_SUBSCRIBER                             0x09                                                     
#define SS_GSM_BEARER_SERV_NOT_PROVISION                      0x0A                                                     
#define SS_GSM_TELE_SERV_NOT_PROVISION                        0x0B                                                     
#define SS_GSM_ILLEGAL_EQUIPMENT                              0x0C                                                     
#define SS_GSM_CALL_BARRED                                    0x0D                                                     
#define SS_GSM_ILLEGEL_SS_OPERATION                           0x10                                                  
#define SS_GSM_SS_ERROR_STATUS                                0x11                                                  
#define SS_GSM_SS_NOT_AVAILABLE                               0x12                                                  
#define SS_GSM_SS_SUBSCRIPTION_VIOLATION                      0x13                                                  
#define SS_GSM_SS_INCOMPATIBILITY                             0x14                                                  
#define SS_GSM_FACILITY_NOT_SUPPORTED                         0x15                                                  
#define SS_GSM_ABSENT_SUBSCRIBER                              0x1B                                                  
#define SS_GSM_SHORT_TERM_DENIAL                              0x1D                                                  
#define SS_GSM_LONG_TERM_DENIAL                               0x1E                                                  
#define SS_GSM_SYSTEM_FAILURE                                 0x22                                                  
#define SS_GSM_DATA_MISSING                                   0x23                                                  
#define SS_GSM_UNEXPECTED_DATA_VALUE                          0x24                                                  
#define SS_GSM_PASSWORD_REGIS_FAILURE                         0x25                                                  
#define SS_GSM_NEGATIVE_PASSWORD_CHECK                        0x26                                                  
#define SS_GSM_MAXNUM_OF_PW_ATT_VIOLATION                     0x2B                                                  
#define SS_GSM_LCS_POSITION_METHOD_FAILURE                    0x36                                                  
#define SS_GSM_UNKNOWN_ALPHABET                               0x47                                                  
#define SS_GSM_USSD_BUSY                                      0x48                                                  
#define SS_GSM_NBR_SB_EXCEEDED                                0x78                                                  
#define SS_GSM_MAXNUM_OF_MPTY_PART_EXCEED                     0x7E                                                  
#define SS_GSM_RESOURCES_NOT_AVAILABLE                        0x7F                                                  

//ConstantTable for SS_PROBLEM_TYPE
#define SS_GSM_GENERAL_PROBLEM                                0x80                                                  
#define SS_GSM_INVOKE_PROBLEM                                 0x81                                                  
#define SS_GSM_RETURN_RESULT_PROBLEM                          0x82                                                  
#define SS_GSM_RETURN_ERROR_PROBLEM                           0x83                                                  

//ConstantTable for SS_GSM_GENERAL_PROBLEM
#define SS_GSM_UNRECOGNIZED_COMP                              0x00                                                     
#define SS_GSM_MISTYPED_COMP                                  0x01                                                     
#define SS_GSM_BADLY_STRUCTURED_COMP                          0x02                                                     

//ConstantTable for SS_GSM_INVOKE_PROBLEM
#define SS_GSM_DUPLICATE_INVOKE_ID                            0x00                                                     
#define SS_GSM_UNRECOGNIZED_OPERATION                         0x01                                                     
#define SS_GSM_MISTYPED_INVOKE_PARAMETER                      0x02                                                     
#define SS_GSM_RECOURCE_LIMITATION                            0x03                                                     
#define SS_GSM_INITIATING_RELEASE                             0x04                                                     
#define SS_GSM_UNRECOGNIZED_LINKED_ID                         0x05                                                     
#define SS_GSM_LINKED_RESPONSE_UNEXPECTED                     0x06                                                     
#define SS_GSM_UNEXPECTED_LINKED_OPERATION                    0x07                                                     

//ConstantTable for SS_GSM_RETURN_RESULT_PROBLEM
#define SS_GSM_UNRECOGNIZED_INVOKE_ID                         0x00                                                     
#define SS_GSM_RETURN_RESULT_UNEXPECTED                       0x01                                                     
#define SS_GSM_MISTYPED_RESP_PARAMETER                        0x02                                                     

//ConstantTable for SS_GSM_RETURN_ERROR_PROBLEM
//#define SS_GSM_UNRECOGNIZED_INVOKE_ID                       0x00                        //Already defined as 0x00
#define SS_GSM_RETURN_ERROR_UNEXPECTED                        0x01                                                     
#define SS_GSM_UNRECOGNIZED_ERROR                             0x02                                                     
#define SS_GSM_UNEXPECTED_ERROR                               0x03                                                     
#define SS_GSM_MISTYPED_ERR_PARAMETER                         0x04                                                     

//ConstantTable for SS_OPERATION
#define SS_ACTIVATION                                         0x01                                                     
#define SS_DEACTIVATION                                       0x02                                                     
#define SS_REGISTRATION                                       0x03                                                     
#define SS_ERASURE                                            0x04                                                     
#define SS_INTERROGATION                                      0x05                                                     
#define SS_GSM_PASSWORD_REGISTRATION                          0x06                                                     

//ConstantTable for SS_GSM_CLI_RESTRICTION_OPTION
#define SS_GSM_CLI_PERMANENT                                  0x00                                                     
#define SS_GSM_DEFAULT_RESTRICTED                             0x01                                                     
#define SS_GSM_CLI_DEFAULT_ALLOWED                            0x02                                                     
#define SS_GSM_OVERRIDE_ENABLED                               0x03                                                     
#define SS_GSM_OVERRIDE_DISABLED                              0x04                                                     

//ConstantTable for SS_GSM_GUIDANCE_INFO
#define SS_GSM_BAD_PASSWORD                                   0x01                                                     
#define SS_GSM_BAD_PASSWORD_FORMAT                            0x02                                                     

//ConstantTable for SS_GSM_MESSAGE_ERRORS
#define SS_GSM_MSG_INCORRECT                                  0x01                                                     
#define SS_GSM_MSG_UNKNOWN_COMPONENT                          0x02                                                     
#define SS_GSM_MSG_INVALID_INVOKE_ID                          0x03                                                     

//ConstantTable for SS_GSM_USSD_TYPES
#define SS_GSM_USSD_MT_REPLY                                  0x01                                                     
#define SS_GSM_USSD_COMMAND                                   0x02                                                     
#define SS_GSM_USSD_REQUEST                                   0x03                                                     
#define SS_GSM_USSD_NOTIFY                                    0x04                                                     
#define SS_GSM_USSD_END                                       0x05                                                     

//BitmaskTables for SS_STATUS
#define SS_GSM_ACTIVE                                         0x01                                                     
#define SS_GSM_REGISTERED                                     0x02                                                     
#define SS_GSM_PROVISIONED                                    0x04                                                     
#define SS_GSM_QUIESCENT                                      0x08                                                     

//ConstantTable for SS_STATUS_INDICATIONS
#define SS_STATUS_REQUEST_SERVICE_START                       0x00                                                     
#define SS_STATUS_REQUEST_SERVICE_STOP                        0x01                                                     
#define SS_GSM_STATUS_REQUEST_USSD_START                      0x02                                                     
#define SS_GSM_STATUS_REQUEST_USSD_STOP                       0x03                                                     
#define SS_GSM_STATUS_REQUEST_USSD_FAILED                     0x04                                                     
#define SS_STATUS_SERVICE_CANCELLED                           0x05                                                     
#define SS_STATUS_REQUEST_SERVICE_BUSY                        0x06                                                     
#define SS_STATUS_REQUEST_SERVICE_FAILED                      0x07                                                     
#define SS_GSM_STATUS_REQUEST_USSD_BUSY                       0x08                                                     

//ConstantTable for SS_MISC_SS_ERRORS
#define SS_SERVICE_BUSY                                       0x00                                                     
#define SS_GSM_MM_RELEASE                                     0x01                                                     
#define SS_GSM_DATA_ERROR                                     0x02                                                     
#define SS_GSM_TIMER_EXPIRED                                  0x03                                                     
#define SS_GSM_REQUEST_CANCELLED                              0x04                                                     
#define SS_GSM_INDICATE_DEVICE_PASSWORD                       0x05                                                     
#define SS_GSM_ACTIVATION_DATA_LOST                           0x09                                                     
#define SS_GSM_MM_ERROR                                       0x0B                                                     
#define SS_GSM_SERVICE_NOT_ON_FDN_LIST                        0x0C                                                     
#define SS_SIMATKCC_REJECTED                                  0x0D                                                     
#define SS_SIMATKCC_MODIFIED                                  0x0E                                                     
#define SS_CS_INACTIVE                                        0x0F                                                     
//#define SS_GSM_SS_NOT_AVAILABLE                             0x12                       //Already defined as 0x12
#define SS_RESOURCE_CONTROL_DENIED                            0x13                                                  
#define SS_RESOURCE_CONTROL_FAILURE                           0x14                                                  
#define SS_RESOURCE_CONTROL_CONF_FAIL                         0x15                                                  
//#define SS_GSM_USSD_BUSY                                    0x48                       //Already defined as 0x48

//ConstantTable for SS_REASON_VALUES
#define SS_UNSPECIFIED_REASON                                 0x00                                                     
#define SS_UNKNOWN_MMI_SS_CODE                                0x01                                                     

//BitmaskTables for SS_GMS_FORWARDING_OPTION
#define SS_GSM_FORW_NOTIF_REASON_1                            0x04                                                     
#define SS_GSM_FORW_NOTIF_REASON_2                            0x08                                                     
#define SS_GSM_FORW_NOTIF_TO_CALLER                           0x20                                                  
#define SS_GSM_FORW_NOTIF_TO_FORWARDING                       0x80                                                  

//ConstantTable for SS_NUMBER_PLAN
#define SS_NBR_PLAN_UNKNOWN                                   0x00                                                     
#define SS_NBR_PLAN_ISDN_TELEPHONY                            0x01                                                     
#define SS_NBR_PLAN_DATA                                      0x03                                                     
#define SS_NBR_PLAN_TELEX                                     0x04                                                     
#define SS_NBR_PLAN_LAND_MOBILE                               0x06                                                     
#define SS_NBR_PLAN_NATIONAL                                  0x08                                                     
#define SS_NBR_PLAN_PRIVATE                                   0x09                                                     

//ConstantTable for SS_NUMBER_TYPE
#define SS_NBR_TYPE_UNKNOWN                                   0x00                                                     
#define SS_NBR_TYPE_INTERNATIONAL                             0x01                                                     
#define SS_NBR_TYPE_NATIONAL                                  0x02                                                     
#define SS_NBR_TYPE_NETWORK_SPECIFIC                          0x03                                                     
#define SS_NBR_TYPE_SUBSCRIBER                                0x04                                                     
#define SS_NBR_TYPE_ALPHANUMERIC                              0x05                                                     
#define SS_NBR_TYPE_ABBREVIATED                               0x06                                                     

//ConstantTable for SS_GSM_LCS_REQ_RESP_TYPES
#define SS_GSM_LCS_LOCATION_GET_TYP                           0x00                                                     
#define SS_GSM_LCS_LOCATION_SEND_TYP                          0x01                                                     
#define SS_GSM_LCS_ASSISTANCE_DATA_TYP                        0x02                                                     
#define SS_GSM_LCS_DECIPHERING_KEYS_TYP                       0x03                                                     
#define SS_GSM_LCS_PRIVACY_VER_TYP                            0x04                                                     
#define SS_GSM_LCS_STOP_TYP                                   0x05                                                     
#define SS_GSM_LCS_DISCONNECT_TYP                             0x06                                                     
#define SS_GSM_LCS_PRIVACY_VER_TIMEOUT_TYP                    0x07                                                     
#define SS_GSM_LCS_CONNECTION_FAIL_TYP                        0x08                                                     
#define SS_GSM_LCS_ERROR_TYP                                  0x09                                                     

//ConstantTable for SS_GSM_LCS_METHOD
#define SS_GSM_LCS_MS_BASED_EOTD                              0x00                                                     
#define SS_GSM_LCS_MS_ASSISTED_EOTD                           0x01                                                     
#define SS_GSM_LCS_ASSISTED_GPS                               0x02                                                     

//ConstantTable for SS_GSM_LCS_ESTIMATE_TYPES
#define SS_GSM_LCS_ELL_P_W_UNC_CIRCLE                         0x01                                                     
#define SS_GSM_LCS_ELL_P_W_UNC_ELL                            0x03                                                     
#define SS_GSM_LCS_ELL_P_W_ALT_A_UNC_ELL                      0x09                                                     
#define SS_GSM_LCS_ELL_ARC                                    0x0A                                                     

//ConstantTable for SS_GSM_LCS_PRIVACY_VERIFICATION
#define SS_GSM_LCS_PERMISSION_DENIED                          0x00                                                     
#define SS_GSM_LCS_PERMISSION_GRANTED                         0x01                                                     

//ConstantTable for SS_GSM_LCS_RESPONSE_TIME
#define SS_GSM_LCS_LOW_DELAY                                  0x00                                                     
#define SS_GSM_LCS_DELAY_TOLERATED                            0x01                                                     

//ConstantTable for SS_GSM_LCS_RESPONSE_STATUS
#define SS_GSM_LCS_SERVICE_GRANTED                            0x00                                                     
#define SS_GSM_LCS_SERVICE_DENIED                             0x01                                                     
#define SS_GSM_LCS_TIMEOUT                                    0x02                                                     

//ConstantTable for SS_GSM_LCS_VERTICAL_COORDINATE_REQUEST
#define SS_GSM_LCS_VERT_COORD_REQ                             0x00                                                     
#define SS_GSM_LCS_VERT_COORD_NOT_REQ                         0x01                                                     

//ConstantTable for SS_LOCATION_TYPE
#define SS_LOCATION_TYPE_CURRENT                              0x00                                                     
#define SS_LOCATION_TYPE_CURRENTORLAST                        0x01                                                     
#define SS_LOCATION_TYPE_INITIAL                              0x02                                                     

//ConstantTable for SS_SERVICE_TYPE_ID
#define SS_SERV_TYPE_EMERG_SERV                               0x00                                                     
#define SS_SERV_TYPE_EMERG_ALERT_SERV                         0x01                                                     
#define SS_SERV_TYPE_PERSON_TRACKING                          0x02                                                     
#define SS_SERV_TYPE_FLEET_MGMT                               0x03                                                     
#define SS_SERV_TYPE_ASSET_MGMT                               0x04                                                     
#define SS_SERV_TYPE_TRAFF_CONG_REPORT                        0x05                                                     
#define SS_SERV_TYPE_ROADSIDE_ASSISTANCE                      0x06                                                     
#define SS_SERV_TYPE_ROUTING_TO_NEAR_COMM_ENT                 0x07                                                     
#define SS_SERV_TYPE_NAVIGATION                               0x08                                                     
#define SS_SERV_TYPE_CITY_SIGHTSEEING                         0x09                                                     
#define SS_SERV_TYPE_LOCALIZED_ADVERTISING                    0x0A                                                     
#define SS_SERV_TYPE_MOBILE_YELLOW_PAGES                      0x0B                                                     
#define SS_SERV_TYPE_TRAF_AND_PUB_TRANSP_INFO                 0x0C                                                     
#define SS_SERV_TYPE_WEATHER                                  0x0D                                                     
#define SS_SERV_TYPE_ASSET_AND_SERV_FINDING                   0x0E                                                     
#define SS_SERV_TYPE_GAMING                                   0x0F                                                     
#define SS_SERV_TYPE_FIND_YOUR_FRIEND                         0x10                                                  
#define SS_SERV_TYPE_DATING                                   0x11                                                  
#define SS_SERV_TYPE_CHATTING                                 0x12                                                  
#define SS_SERV_TYPE_ROUTE_FINDING                            0x13                                                  
#define SS_SERV_TYPE_WHERE_AM_I                               0x14                                                  

//ConstantTable for SS_GSM_LCS_PSEUDONYM_REQUESTED
#define SS_PSEUDONYM_NOT_REQUESTED                            0x00                                                     
#define SS_PSEUDONYM_REQUESTED                                0x01                                                     

//ConstantTable for SS_MESSAGE_SENDER_INFORMATION
#define SS_SEND_DECODED_DATA                                  0x00                                                     
#define SS_SEND_ADDITIONAL_INFO                               0x01                                                     

//ConstantTable for SS_MM_CAUSE_VALUES
#define SS_GSM_MM_CAUSE_NO_CAUSE                              0x00                                                     
#define SS_GSM_MM_CAUSE_HLR_IMSI_UNKNOWN                      0x02                                                     
#define SS_GSM_MM_CAUSE_ILLEGAL_MS                            0x03                                                     
#define SS_GSM_MM_CAUSE_VLR_IMSI_UNKNOWN                      0x04                                                     
#define SS_GSM_MM_CAUSE_IMEI_NOT_ACCEPTED                     0x05                                                     
#define SS_GSM_MM_CAUSE_ILLEGAL_ME                            0x06                                                     
#define SS_GSM_MM_CAUSE_PLMN_NOT_ALLOWED                      0x0B                                                     
#define SS_GSM_MM_CAUSE_LA_NOT_ALLOWED                        0x0C                                                     
#define SS_GSM_MM_CAUSE_ROAM_NOT_ALLOWED_LA                   0x0D                                                     
#define SS_GSM_MM_CAUSE_NO_SUITABLE_CELLS_LA                  0x0F                                                     
#define SS_GSM_MM_CAUSE_NETWORK_FAILURE                       0x11                                                  
#define SS_GSM_MM_CAUSE_MAC_FAILURE                           0x14                                                  
#define SS_GSM_MM_CAUSE_SYNC_FAILURE                          0x15                                                  
#define SS_GSM_MM_CAUSE_CONGESTION                            0x16                                                  
#define SS_GSM_MM_CAUSE_AUTH_UNACCEPTABLE                     0x17                                                  
#define SS_GSM_MM_CAUSE_NOT_SUPP_S_OPTION                     0x20                                                  
#define SS_GSM_MM_CAUSE_NOT_SUBS_S_OPTION                     0x21                                                  
#define SS_GSM_MM_CAUSE_OUT_OF_ORDER_S_OPTION                 0x22                                                  
#define SS_GSM_MM_CAUSE_CALL_NOT_IDENTIFIED                   0x26                                                  
#define SS_GSM_MM_CAUSE_SEMANT_INCORRECT                      0x5F                                                  
#define SS_GSM_MM_CAUSE_INV_MAND_INFORMATION                  0x60                                                  
#define SS_GSM_MM_CAUSE_NON_EXISTENT_MSG_TYPE                 0x61                                                  
#define SS_GSM_MM_CAUSE_NOT_COMP_MSG_TYPE                     0x62                                                  
#define SS_GSM_MM_CAUSE_NOT_EXISTENT_IE                       0x63                                                  
#define SS_GSM_MM_CAUSE_CONDITIONAL_IE_ERROR                  0x64                                                  
#define SS_GSM_MM_CAUSE_MSG_NOT_COMPATIBLE                    0x65                                                  
#define SS_GSM_MM_CAUSE_PROTOCOL_ERROR                        0x6F                                                  

//ConstantTable for SS_FDN_CHECK_SUPPRESS_VALUES
#define SS_NO_FDN_CHECK_SUPPRESS                              0x01                                                     
#define SS_FDN_CHECK_SUPPRESS                                 0x02                                                     

//ConstantTable for SS_RESOURCE_CONTROL_SUPPRESS_VALUES
#define SS_NO_RESOURCE_CONTROL_SUPPRESS                       0x01                                                     
#define SS_RESOURCE_CONTROL_SUPPRESS                          0x02                                                     

//ConstantTable for SS_FDN_STATUS_VALUES

//ConstantTable for SS_ALPHA_ID_STATUS_VALUES

//ConstantTable for SS_ERROR_ADDITIONAL_INDICATION
#define SS_SHAPE_OF_LOCATION_ESTIMATE_NOT_SUPP                0x01                                                     
#define SS_NEEDED_LCS_CAPABILITY_NOT_SUPP_IN_SERVING_NODE     0x02                                                     
#define SS_DEFAULT_VALUE                                      0x00                                                     

//ConstantTable for SS_SIM_ATK_STATUS

//BitmaskTables for SS_RESOURCE_IDS
#define SS_RES_ID_MO_SS_OPERATION                             0x0001                                                     

//BitmaskTables for SS_RESOURCE_IDS_MASK
#define SS_RES_ID_MO_SS_OPERATION_MASK                        0x0001                                                     

//BitmaskTables for SS_RESOURCE_IDS_CONF_REQ
#define SS_RES_ID_CONF_MO_SS_OPERATION                        0x0001                                                     

//ConstantTable for SS_RESOURCE_STATUS
#define SS_RESOURCE_ALLOWED                                   0x01                                                     
#define SS_RESOURCE_DENIED                                    0x02                                                     

//ConstantTable for SS_RESOURCE_CONF_OPERATION
#define SS_RESOURCE_CONF_GET                                  0x01                                                     
#define SS_RESOURCE_CONF_SET                                  0x02                                                     

//ConstantTable for SS_RESOURCE_CONF_STATUS
#define SS_RESOURCE_CONF_READY                                0x01                                                     
#define SS_RESOURCE_CONF_RECONFIGURED                         0x02                                                     


//SUBBLOCKS


//Definition for struct SS_FORWARDING
#define SS_FORWARDING                                         0x00                                                     
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_length;
             uint8_t      type_of_number;
             uint8_t      no_reply_time;
             uint8_t      number_length;
             uint8_t      sub_address_length;
             uint16_t     number[0];
             uint8_t      sub_address[0];
            } __attribute__((packed)) SS_FORWARDING_STR;
#define SIZE_SS_FORWARDING                                    sizeof(SS_FORWARDING_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct SS_GSM_PASSWORD
#define SS_GSM_PASSWORD                                       0x03                                                     
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_length;
             uint8_t      old_password[8];
             uint8_t      new_password1[8];
             uint8_t      new_password2[8];
             uint16_t     fillerbyte1;
            } __attribute__((packed)) SS_GSM_PASSWORD_STR;
#define SIZE_SS_GSM_PASSWORD                                  sizeof(SS_GSM_PASSWORD_STR)


//Definition for struct SS_STATUS_RESULT
#define SS_STATUS_RESULT                                      0x01                                                     
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_length;
             uint8_t      ss_status;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) SS_STATUS_RESULT_STR;
#define SIZE_SS_STATUS_RESULT                                 sizeof(SS_STATUS_RESULT_STR)


//Definition for struct SS_GSM_FORWARDING_FEATURE
#define SS_GSM_FORWARDING_FEATURE                             0x05                                                     
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_length;
             uint8_t      basic_service_code;
             uint8_t      ss_status;
             uint8_t      type_of_number;
             uint8_t      no_reply_time;
             uint8_t      forwarding_option;
             uint8_t      number_length;
             uint8_t      sub_address_length;
             uint8_t      fillerbyte1;
             uint16_t     number[0];
             uint8_t      sub_address[0];
            } __attribute__((packed)) SS_GSM_FORWARDING_FEATURE_STR;
#define SIZE_SS_GSM_FORWARDING_FEATURE                        sizeof(SS_GSM_FORWARDING_FEATURE_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct SS_GSM_FORWARDING_INFO
#define SS_GSM_FORWARDING_INFO                                0x04                                                     
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_length;
             uint8_t      fillerbyte1;
             uint8_t      sub_block_count;
            } __attribute__((packed)) SS_GSM_FORWARDING_INFO_STR;
#define SIZE_SS_GSM_FORWARDING_INFO                           sizeof(SS_GSM_FORWARDING_INFO_STR)


//Definition for struct SS_GSM_BARRING_FEATURE
#define SS_GSM_BARRING_FEATURE                                0x07                                                     
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_length;
             uint8_t      basic_service_code;
             uint8_t      ss_status;
            } __attribute__((packed)) SS_GSM_BARRING_FEATURE_STR;
#define SIZE_SS_GSM_BARRING_FEATURE                           sizeof(SS_GSM_BARRING_FEATURE_STR)


//Definition for struct SS_GSM_BARRING_INFO
#define SS_GSM_BARRING_INFO                                   0x06                                                     
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_length;
             uint8_t      fillerbyte1;
             uint8_t      sub_block_count;
            } __attribute__((packed)) SS_GSM_BARRING_INFO_STR;
#define SIZE_SS_GSM_BARRING_INFO                              sizeof(SS_GSM_BARRING_INFO_STR)


//Definition for struct SS_GSM_BSC_INFO
#define SS_GSM_BSC_INFO                                       0x09                                                     
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_length;
             uint8_t      number_of_bsc;
             uint8_t      basic_service_code[0];
            } __attribute__((packed)) SS_GSM_BSC_INFO_STR;
#define SIZE_SS_GSM_BSC_INFO                                  sizeof(SS_GSM_BSC_INFO_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct SS_GSM_DATA
#define SS_GSM_DATA                                           0x08                                                     
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_length;
             uint8_t      ss_status;
             uint8_t      subscription_option;
             uint8_t      fillerbyte1[3];
             uint8_t      sub_block_count;
            } __attribute__((packed)) SS_GSM_DATA_STR;
#define SIZE_SS_GSM_DATA                                      sizeof(SS_GSM_DATA_STR)


//Definition for struct SS_GSM_CLIR_INFO
#define SS_GSM_CLIR_INFO                                      0x0C                                                     
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_length;
             uint8_t      cli_restriction_option;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) SS_GSM_CLIR_INFO_STR;
#define SIZE_SS_GSM_CLIR_INFO                                 sizeof(SS_GSM_CLIR_INFO_STR)


//Definition for struct SS_GSM_GENERIC_SERVICE_INFO
#define SS_GSM_GENERIC_SERVICE_INFO                           0x0A                                                     
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_length;
             uint8_t      ss_status;
             uint8_t      sub_block_count;
            } __attribute__((packed)) SS_GSM_GENERIC_SERVICE_INFO_STR;
#define SIZE_SS_GSM_GENERIC_SERVICE_INFO                      sizeof(SS_GSM_GENERIC_SERVICE_INFO_STR)


//Definition for struct SS_GSM_PASSWORD_INFO
#define SS_GSM_PASSWORD_INFO                                  0x0B                                                     
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_length;
             uint16_t     fillerbyte1;
             uint32_t     password;
            } __attribute__((packed)) SS_GSM_PASSWORD_INFO_STR;
#define SIZE_SS_GSM_PASSWORD_INFO                             sizeof(SS_GSM_PASSWORD_INFO_STR)


//Definition for struct SS_GSM_INDICATE_PASSWORD_ERROR
#define SS_GSM_INDICATE_PASSWORD_ERROR                        0x0D                                                     
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_length;
             uint8_t      guidance_info;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) SS_GSM_INDICATE_PASSWORD_ERROR_STR;
#define SIZE_SS_GSM_INDICATE_PASSWORD_ERROR                   sizeof(SS_GSM_INDICATE_PASSWORD_ERROR_STR)


//Definition for struct SS_GSM_INDICATE_ERROR
#define SS_GSM_INDICATE_ERROR                                 0x0E                                                     
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_length;
             uint8_t      error_code;
             uint8_t      additional_indication;
            } __attribute__((packed)) SS_GSM_INDICATE_ERROR_STR;
#define SIZE_SS_GSM_INDICATE_ERROR                            sizeof(SS_GSM_INDICATE_ERROR_STR)


//Definition for struct SS_GSM_INDICATE_PROBLEM
#define SS_GSM_INDICATE_PROBLEM                               0x0F                                                     
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_length;
             uint8_t      problem_type;
             uint8_t      problem_code;
            } __attribute__((packed)) SS_GSM_INDICATE_PROBLEM_STR;
#define SIZE_SS_GSM_INDICATE_PROBLEM                          sizeof(SS_GSM_INDICATE_PROBLEM_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct SS_GSM_INDICATE_MSG_ERROR
#define SS_GSM_INDICATE_MSG_ERROR                             0x10                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_length;
             uint8_t      message_error_code;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) SS_GSM_INDICATE_MSG_ERROR_STR;
#define SIZE_SS_GSM_INDICATE_MSG_ERROR                        sizeof(SS_GSM_INDICATE_MSG_ERROR_STR)


//Definition for struct SS_OTHER_ERROR
#define SS_OTHER_ERROR                                        0x02                                                     
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_length;
             uint8_t      error_code;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) SS_OTHER_ERROR_STR;
#define SIZE_SS_OTHER_ERROR                                   sizeof(SS_OTHER_ERROR_STR)


//Definition for struct SS_GSM_LCS_QUALITY_OF_SERVICE
#define SS_GSM_LCS_QUALITY_OF_SERVICE                         0x20                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_length;
             uint8_t      ss_parameter_indicator;
             uint8_t      horizontal_accuracy;
             uint8_t      vertical_coord_req;
             uint8_t      vertical_accuracy;
             uint8_t      response_time_category;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) SS_GSM_LCS_QUALITY_OF_SERVICE_STR;
#define SIZE_SS_GSM_LCS_QUALITY_OF_SERVICE                    sizeof(SS_GSM_LCS_QUALITY_OF_SERVICE_STR)


//Definition for struct SS_GSM_LCS_CLIENT_EXTERNAL_ID
#define SS_GSM_LCS_CLIENT_EXTERNAL_ID                         0x21                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_length;
             uint8_t      type_of_number;
             uint8_t      number_length;
             uint16_t     number[0];
            } __attribute__((packed)) SS_GSM_LCS_CLIENT_EXTERNAL_ID_STR;
#define SIZE_SS_GSM_LCS_CLIENT_EXTERNAL_ID                    sizeof(SS_GSM_LCS_CLIENT_EXTERNAL_ID_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct SS_GSM_LCS_MLC_NUMBER
#define SS_GSM_LCS_MLC_NUMBER                                 0x22                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_length;
             uint8_t      type_of_number;
             uint8_t      number_length;
             uint16_t     number[0];
            } __attribute__((packed)) SS_GSM_LCS_MLC_NUMBER_STR;
#define SIZE_SS_GSM_LCS_MLC_NUMBER                            sizeof(SS_GSM_LCS_MLC_NUMBER_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct SS_GSM_LCS_GPS_ASSISTANCE_DATA
#define SS_GSM_LCS_GPS_ASSISTANCE_DATA                        0x23                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_length;
             uint8_t      length_of_gps_assistance_data;
             uint8_t      gps_assistance_data[0];
            } __attribute__((packed)) SS_GSM_LCS_GPS_ASSISTANCE_DATA_STR;
#define SIZE_SS_GSM_LCS_GPS_ASSISTANCE_DATA                   sizeof(SS_GSM_LCS_GPS_ASSISTANCE_DATA_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct SS_GSM_LCS_ESTIMATED_LOCATION
#define SS_GSM_LCS_ESTIMATED_LOCATION                         0x24                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_length;
             uint8_t      location_estimate_shape;
             uint8_t      location_estimate[20];
             uint8_t      fillerbyte1;
            } __attribute__((packed)) SS_GSM_LCS_ESTIMATED_LOCATION_STR;
#define SIZE_SS_GSM_LCS_ESTIMATED_LOCATION                    sizeof(SS_GSM_LCS_ESTIMATED_LOCATION_STR)


//Definition for struct SS_GSM_LCS_DECIPHERING_KEYS
#define SS_GSM_LCS_DECIPHERING_KEYS                           0x25                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_length;
             uint8_t      deciphering_key_flag;
             uint8_t      current_deciphering_key[7];
             uint8_t      next_deciphering_key[7];
             uint8_t      fillerbyte1[3];
            } __attribute__((packed)) SS_GSM_LCS_DECIPHERING_KEYS_STR;
#define SIZE_SS_GSM_LCS_DECIPHERING_KEYS                      sizeof(SS_GSM_LCS_DECIPHERING_KEYS_STR)


//Definition for struct SS_GSM_LCS_LOCATION_METHOD
#define SS_GSM_LCS_LOCATION_METHOD                            0x26                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_length;
             uint8_t      location_method;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) SS_GSM_LCS_LOCATION_METHOD_STR;
#define SIZE_SS_GSM_LCS_LOCATION_METHOD                       sizeof(SS_GSM_LCS_LOCATION_METHOD_STR)


//Definition for struct SS_GSM_LCS_PRIVACY_VER
#define SS_GSM_LCS_PRIVACY_VER                                0x27                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_length;
             uint8_t      privacy_verification;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) SS_GSM_LCS_PRIVACY_VER_STR;
#define SIZE_SS_GSM_LCS_PRIVACY_VER                           sizeof(SS_GSM_LCS_PRIVACY_VER_STR)


//Definition for struct SS_GSM_LCS_PSEUDONYM_INDICATOR
#define SS_GSM_LCS_PSEUDONYM_INDICATOR                        0x28                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_length;
             uint8_t      pseudonym_indicator;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) SS_GSM_LCS_PSEUDONYM_INDICATOR_STR;
#define SIZE_SS_GSM_LCS_PSEUDONYM_INDICATOR                   sizeof(SS_GSM_LCS_PSEUDONYM_INDICATOR_STR)


//Definition for struct SS_GSM_LCS_MAX_LOCATION_AGE
#define SS_GSM_LCS_MAX_LOCATION_AGE                           0x29                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_length;
             uint16_t     age_of_location;
            } __attribute__((packed)) SS_GSM_LCS_MAX_LOCATION_AGE_STR;
#define SIZE_SS_GSM_LCS_MAX_LOCATION_AGE                      sizeof(SS_GSM_LCS_MAX_LOCATION_AGE_STR)


//Definition for struct SS_GSM_LCS_LOCATION_TYPE
#define SS_GSM_LCS_LOCATION_TYPE                              0x2A                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_length;
             uint8_t      location_type;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) SS_GSM_LCS_LOCATION_TYPE_STR;
#define SIZE_SS_GSM_LCS_LOCATION_TYPE                         sizeof(SS_GSM_LCS_LOCATION_TYPE_STR)


//Definition for struct SS_GSM_LCS_SERVICE_TYPE_ID
#define SS_GSM_LCS_SERVICE_TYPE_ID                            0x2B                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_length;
             uint8_t      service_type_id;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) SS_GSM_LCS_SERVICE_TYPE_ID_STR;
#define SIZE_SS_GSM_LCS_SERVICE_TYPE_ID                       sizeof(SS_GSM_LCS_SERVICE_TYPE_ID_STR)


//Definition for struct SS_GSM_ADDITIONAL_INFO
#define SS_GSM_ADDITIONAL_INFO                                0x2F                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_length;
             uint8_t      return_result_len;
             uint8_t      return_result[0];
            } __attribute__((packed)) SS_GSM_ADDITIONAL_INFO_STR;
#define SIZE_SS_GSM_ADDITIONAL_INFO                           sizeof(SS_GSM_ADDITIONAL_INFO_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct SS_GSM_MM_RELEASED
#define SS_GSM_MM_RELEASED                                    0x30                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_length;
             uint8_t      cause;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) SS_GSM_MM_RELEASED_STR;
#define SIZE_SS_GSM_MM_RELEASED                               sizeof(SS_GSM_MM_RELEASED_STR)


//Definition for struct SS_GSM_USSD_STRING
#define SS_GSM_USSD_STRING                                    0x32                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_length;
             uint8_t      coding_info;
             uint8_t      length_of_ussd_string;
             uint8_t      ussd_string[0];
            } __attribute__((packed)) SS_GSM_USSD_STRING_STR;
#define SIZE_SS_GSM_USSD_STRING                               sizeof(SS_GSM_USSD_STRING_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct SS_SB_RESOURCE
#define SS_SB_RESOURCE                                        0x41                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint16_t     res;
            } __attribute__((packed)) SS_SB_RESOURCE_STR;
#define SIZE_SS_SB_RESOURCE                                   sizeof(SS_SB_RESOURCE_STR)


//Definition for struct SS_SB_RESOURCE_SEQ_ID
#define SS_SB_RESOURCE_SEQ_ID                                 0x42                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      sequence_id;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) SS_SB_RESOURCE_SEQ_ID_STR;
#define SIZE_SS_SB_RESOURCE_SEQ_ID                            sizeof(SS_SB_RESOURCE_SEQ_ID_STR)


//Definition for struct SS_SB_SS_CONTROL
#define SS_SB_SS_CONTROL                                      0x44                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      ss_string_length;
             uint8_t      ss_string[0];
            } __attribute__((packed)) SS_SB_SS_CONTROL_STR;
#define SIZE_SS_SB_SS_CONTROL                                 sizeof(SS_SB_SS_CONTROL_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct SS_SB_USSD_CONTROL
#define SS_SB_USSD_CONTROL                                    0x45                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      coding_info;
             uint8_t      ussd_string_length;
             uint8_t      ussd_string[0];
            } __attribute__((packed)) SS_SB_USSD_CONTROL_STR;
#define SIZE_SS_SB_USSD_CONTROL                               sizeof(SS_SB_USSD_CONTROL_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct SS_SB_RESOURCE_STATUS
#define SS_SB_RESOURCE_STATUS                                 0x43                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      res_status;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) SS_SB_RESOURCE_STATUS_STR;
#define SIZE_SS_SB_RESOURCE_STATUS                            sizeof(SS_SB_RESOURCE_STATUS_STR)


//Definition for struct SS_SB_RESOURCE_CONTROL_INFO
#define SS_SB_RESOURCE_CONTROL_INFO                           0x46                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint8_t      data_length;
             uint8_t      data[0];
            } __attribute__((packed)) SS_SB_RESOURCE_CONTROL_INFO_STR;
#define SIZE_SS_SB_RESOURCE_CONTROL_INFO                      sizeof(SS_SB_RESOURCE_CONTROL_INFO_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct SS_SB_CHECK_INFO
#define SS_SB_CHECK_INFO                                      0x47                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_length;
             uint8_t      fdn_suppress_status;
             uint8_t      resource_control_status;
            } __attribute__((packed)) SS_SB_CHECK_INFO_STR;
#define SIZE_SS_SB_CHECK_INFO                                 sizeof(SS_SB_CHECK_INFO_STR)


//Definition for struct SS_SB_RESOURCE_CONF_REQUIRED
#define SS_SB_RESOURCE_CONF_REQUIRED                          0x48                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint16_t     res_pp;
            } __attribute__((packed)) SS_SB_RESOURCE_CONF_REQUIRED_STR;
#define SIZE_SS_SB_RESOURCE_CONF_REQUIRED                     sizeof(SS_SB_RESOURCE_CONF_REQUIRED_STR)


//Definition for struct SS_SB_RESOURCE_CONF
#define SS_SB_RESOURCE_CONF                                   0x49                                                  
typedef struct
            { 
             uint8_t      sub_block_id;
             uint8_t      sub_block_len;
             uint16_t     res;
             uint16_t     res_mask;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) SS_SB_RESOURCE_CONF_STR;
#define SIZE_SS_SB_RESOURCE_CONF                              sizeof(SS_SB_RESOURCE_CONF_STR)


//MESSAGES


//Definition for struct SS_SERVICE_REQ
#define SS_SERVICE_REQ                                        0x00                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      operation;
             uint8_t      basic_service_code;
             uint16_t     ss_code;
             uint8_t      response_data_to_send;
             uint8_t      sub_block_count;
            } __attribute__((packed)) SS_SERVICE_REQ_STR;
#define SIZE_SS_SERVICE_REQ                                   sizeof(SS_SERVICE_REQ_STR)


//Definition for struct SS_SERVICE_COMPLETED_RESP
#define SS_SERVICE_COMPLETED_RESP                             0x01                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      operation;
             uint8_t      basic_service_code;
             uint16_t     ss_code;
             uint8_t      fillerbyte1;
             uint8_t      sub_block_count;
            } __attribute__((packed)) SS_SERVICE_COMPLETED_RESP_STR;
#define SIZE_SS_SERVICE_COMPLETED_RESP                        sizeof(SS_SERVICE_COMPLETED_RESP_STR)


//Definition for struct SS_SERVICE_COMPLETED_IND
#define SS_SERVICE_COMPLETED_IND                              0x10                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      operation;
             uint8_t      basic_service_code;
             uint16_t     ss_code;
             uint8_t      fillerbyte1;
             uint8_t      sub_block_count;
            } __attribute__((packed)) SS_SERVICE_COMPLETED_IND_STR;
#define SIZE_SS_SERVICE_COMPLETED_IND                         sizeof(SS_SERVICE_COMPLETED_IND_STR)


//Definition for struct SS_SERVICE_FAILED_RESP
#define SS_SERVICE_FAILED_RESP                                0x02                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      sub_block_count;
            } __attribute__((packed)) SS_SERVICE_FAILED_RESP_STR;
#define SIZE_SS_SERVICE_FAILED_RESP                           sizeof(SS_SERVICE_FAILED_RESP_STR)


//Definition for struct SS_SERVICE_NOT_SUPPORTED_RESP
#define SS_SERVICE_NOT_SUPPORTED_RESP                         0x03                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      reason;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) SS_SERVICE_NOT_SUPPORTED_RESP_STR;
#define SIZE_SS_SERVICE_NOT_SUPPORTED_RESP                    sizeof(SS_SERVICE_NOT_SUPPORTED_RESP_STR)


//Definition for struct SS_GSM_USSD_SEND_REQ
#define SS_GSM_USSD_SEND_REQ                                  0x04                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      ussd_type;
             uint8_t      sub_block_count;
            } __attribute__((packed)) SS_GSM_USSD_SEND_REQ_STR;
#define SIZE_SS_GSM_USSD_SEND_REQ                             sizeof(SS_GSM_USSD_SEND_REQ_STR)


//Definition for struct SS_GSM_USSD_SEND_RESP
#define SS_GSM_USSD_SEND_RESP                                 0x05                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      coding_info;
             uint8_t      ussd_type;
             uint8_t      length_of_ussd_string;
             uint8_t      ussd_string[0];
            } __attribute__((packed)) SS_GSM_USSD_SEND_RESP_STR;
#define SIZE_SS_GSM_USSD_SEND_RESP                            sizeof(SS_GSM_USSD_SEND_RESP_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct SS_GSM_USSD_RECEIVE_IND
#define SS_GSM_USSD_RECEIVE_IND                               0x06                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      coding_info;
             uint8_t      ussd_type;
             uint8_t      length_of_ussd_string;
             uint8_t      ussd_string[0];
            } __attribute__((packed)) SS_GSM_USSD_RECEIVE_IND_STR;
#define SIZE_SS_GSM_USSD_RECEIVE_IND                          sizeof(SS_GSM_USSD_RECEIVE_IND_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct SS_STATUS_IND
#define SS_STATUS_IND                                         0x09                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      ss_status_indication;
             uint8_t      sub_block_count;
            } __attribute__((packed)) SS_STATUS_IND_STR;
#define SIZE_SS_STATUS_IND                                    sizeof(SS_STATUS_IND_STR)


//Definition for struct SS_GSM_LCS_SERVICE_REQ
#define SS_GSM_LCS_SERVICE_REQ                                0x0A                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      request_type;
             uint8_t      sub_block_count;
            } __attribute__((packed)) SS_GSM_LCS_SERVICE_REQ_STR;
#define SIZE_SS_GSM_LCS_SERVICE_REQ                           sizeof(SS_GSM_LCS_SERVICE_REQ_STR)


//Definition for struct SS_GSM_LCS_SERVICE_RESP
#define SS_GSM_LCS_SERVICE_RESP                               0x0B                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      response_status;
             uint8_t      response_type;
             uint8_t      fillerbyte1[3];
             uint8_t      sub_block_count;
            } __attribute__((packed)) SS_GSM_LCS_SERVICE_RESP_STR;
#define SIZE_SS_GSM_LCS_SERVICE_RESP                          sizeof(SS_GSM_LCS_SERVICE_RESP_STR)


//Definition for struct SS_CANCEL_REQ
#define SS_CANCEL_REQ                                         0x11                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint16_t     fillerbyte1;
            } __attribute__((packed)) SS_CANCEL_REQ_STR;
#define SIZE_SS_CANCEL_REQ                                    sizeof(SS_CANCEL_REQ_STR)


//Definition for struct SS_CANCEL_RESP
#define SS_CANCEL_RESP                                        0x12                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint16_t     fillerbyte1;
            } __attribute__((packed)) SS_CANCEL_RESP_STR;
#define SIZE_SS_CANCEL_RESP                                   sizeof(SS_CANCEL_RESP_STR)


//Definition for struct SS_RESOURCE_CONTROL_IND
#define SS_RESOURCE_CONTROL_IND                               0x21                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      sub_block_count;
            } __attribute__((packed)) SS_RESOURCE_CONTROL_IND_STR;
#define SIZE_SS_RESOURCE_CONTROL_IND                          sizeof(SS_RESOURCE_CONTROL_IND_STR)


//Definition for struct SS_RESOURCE_CONTROL_REQ
#define SS_RESOURCE_CONTROL_REQ                               0x22                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      sub_block_count;
            } __attribute__((packed)) SS_RESOURCE_CONTROL_REQ_STR;
#define SIZE_SS_RESOURCE_CONTROL_REQ                          sizeof(SS_RESOURCE_CONTROL_REQ_STR)


//Definition for struct SS_RESOURCE_CONTROL_RESP
#define SS_RESOURCE_CONTROL_RESP                              0x23                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      sub_block_count;
            } __attribute__((packed)) SS_RESOURCE_CONTROL_RESP_STR;
#define SIZE_SS_RESOURCE_CONTROL_RESP                         sizeof(SS_RESOURCE_CONTROL_RESP_STR)


//Definition for struct SS_RESOURCE_CONF_REQ
#define SS_RESOURCE_CONF_REQ                                  0x25                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      conf_operation;
             uint8_t      sub_block_count;
            } __attribute__((packed)) SS_RESOURCE_CONF_REQ_STR;
#define SIZE_SS_RESOURCE_CONF_REQ                             sizeof(SS_RESOURCE_CONF_REQ_STR)


//Definition for struct SS_RESOURCE_CONF_RESP
#define SS_RESOURCE_CONF_RESP                                 0x26                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      conf_operation;
             uint8_t      sub_block_count;
            } __attribute__((packed)) SS_RESOURCE_CONF_RESP_STR;
#define SIZE_SS_RESOURCE_CONF_RESP                            sizeof(SS_RESOURCE_CONF_RESP_STR)


//Definition for struct SS_RESOURCE_CONF_IND
#define SS_RESOURCE_CONF_IND                                  0x24                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      conf_status;
             uint8_t      sub_blocks;
            } __attribute__((packed)) SS_RESOURCE_CONF_IND_STR;
#define SIZE_SS_RESOURCE_CONF_IND                             sizeof(SS_RESOURCE_CONF_IND_STR)

#endif
