#ifndef _PN_ST_ISI_H_
#define _PN_ST_ISI_H_

#include <stdint.h> 

//Resource Self Test Server
//PN_SELFTEST 0x35 
//ISI version 027.004
#define SELF_TEST_SERVER_ISI_VERSION_Z     27
#define SELF_TEST_SERVER_ISI_VERSION_Y     4

//In case of problems concerning content of this file contact Markku Loukusa, Sauli Laukka or Markus Mrsky
//Server specific message descriptions and feature&protocol descriptions can be found from: https://oucmswww.nmp.nokia.com:58443/document_browser/ccm_wa/GIF_SPECS/ 


//ISI VERSION CHANGE HISTORY

//Version: 027.004                                           
//Status: Unknown                                           
//Date: 6-Aug-2008      Harri Palm
//Reason: SUB:417-15000
//Reference: ActionDB for SWAM CR:HP08080545603, NON_DRAFT

//Version: 027.003                                           
//Status: Unknown                                           
//Date: 6-Jun-2008      Harri Palm
//Reason: SCO:417-9633, 417-9628, 417-9792, 417-9634
//Reference: ActionDB for SWAM CR:HP08060625820, NON_DRAFT

//Version: 027.002                                           
//Status: Unknown                                           
//Date: 6-May-2008      Harri Palm
//Reason: SCO:417-5678
//Reference: ActionDB for SWAM CR:HP08050627100, NON_DRAFT

//Version: 027.001                                           
//Status: Unknown                                           
//Date: 14-Feb-2008     Kati Kylmanen
//Reason: SCO:414-4698
//Reference: ActionDB for SWAM CR:KK08021440048, NON_DRAFT

//Version: 027.000                                           
//Status: Unknown                                           
//Date: 07-Feb-2008     Kati Kylmanen
//Reason: SCO:414-4521 and 414-4523
//Reference: ActionDB for SWAM CR:KK08020442791, NON_DRAFT

//Version: 026.002                                           
//Status: Unknown                                           
//Date: 04-Dec-2007     Riitta Paavilainen
//Reason: SCO:414-2314
//Reference: ActionDB for SWAM CR:RP07120436232, NON_DRAFT

//Version: 026.001                                           
//Status: Unknown                                           
//Date: 21-Nov-2007     Kati Kylmanen
//Reason: SCO:414-3419 and 414-3416
//Reference: ActionDB for SWAM CR:KK07112137708, NON_DRAFT

//Version: 026.000                                           
//Status: Unknown                                           
//Date: 30-Oct-2007     Kati Kylmanen
//Reason: SCO:414-2140
//Reference: ActionDB for SWAM CR:KK07103031632, NON_DRAFT

//Version: 025.000                                           
//Status: Unknown                                           
//Date: 10-Oct-2007     Kati Kylmanen
//Reason: SCO:402-3678
//Reference: ActionDB for SWAM CR:KK07101050883, NON_DRAFT

//Version: 024.005                                           
//Status: Unknown                                           
//Date: 10-Oct-2007     Kati Kylmanen
//Reason: SCO:404-2941
//Reference: ActionDB for SWAM CR:KK07101050883, NON_DRAFT

//Version: 024.004                                           
//Status: Unknown                                           
//Date: 06-Jun-2007     Kati Kylmanen
//Reason: Mail from Daniel Ezekiel
//Reference: ActionDB for SWAM CR:KK07060636401, NON_DRAFT

//Version: 024.003                                           
//Status: Unknown                                           
//Date: 15-May-2007     Kati Kylmanen
//Reason: SCO: 402-1516
//Reference: ActionDB for SWAM CR:KK07052536332, NON_DRAFT

//Version: 024.002                                           
//Status: Unknown                                           
//Date: 13-Mar-2007     Kati Kylmanen
//Reason: SCO:009-31635 
//Reference: ActionDB for SWAM CR:KK07031353814, NON_DRAFT

//Version: 024.001                                           
//Status: Unknown                                           
//Date: 21-Feb-2007     Kati Kylmanen
//Reason: SCO:009-30190 and 009-31629 
//Reference: ActionDB for SWAM CR:KK07022162554, NON_DRAFT

//Version: 024.000                                           
//Status: Unknown                                           
//Date: 09-Feb-2007     Kati Kylmanen
//Reason: SCO:010-33330 
//Reference: ActionDB for SWAM CR:KK07020937926, NON_DRAFT

//Version: 023.002                                           
//Status: Unknown                                           
//Date: 15-Dec-2006     Kati Kylmanen
//Reason: SCO:009-28553 and 010-32432 
//Reference: ActionDB for SWAM CR:KK06121557655, NON_DRAFT

//Version: 023.001                                           
//Status: Unknown                                           
//Date: 15-Nov-2006     Kati Kylmanen
//Reason: SCO:010-31164 
//Reference: ActionDB for SWAM CR:KK06111554543, NON_DRAFT

//Version: 023.000                                           
//Status: Unknown                                           
//Date: 06-Nov-2006     Kati Kylmanen
//Reason: SCO:009-28489,009-28490 and 010-29757 
//Reference: ActionDB for SWAM inspection:KK06110641010, NON_DRAFT

//Version: 022.001                                           
//Status: Unknown                                           
//Date: 16-Oct-2006     Kati Kylmanen
//Reason: SCO:009-27698 
//Reference: ActionDB for SWAM inspection:KK06101651090, NON_DRAFT

//Version: 022.000                                           
//Status: Unknown                                           
//Date: 04-Sep-2006     Kati Kylmanen
//Reason: SCO:009-28130 and 009-27948, 
//Reference: ActionDB for SWAM CR:KK06090436137, NON_DRAFT

//Version: 021.000                                           
//Status: Unknown                                           
//Date: 18-Aug-2006     Kati Kylmanen
//Reason: SCO: 009-26579
//Reference: ActionDB for SWAM CR:KK06081843255, NON_DRAFT

//Version: 020.000                                           
//Status: NonDraft                                          
//Date: 14-Aug-2006     Kati Kylmanen
//Reason: ISA RM-RIM tool ID: 009-25359
//Reference: ADB for SWAM:KK06081458330, NON-DRAFT

//Version: 019.000                                           
//Status: NonDraft                                          
//Date: 23-Mar-2006     Kati Kylmanen
//Reason: ISA RM-RIM tool ID:010-19187 
//Reference: ADB for SWAM:KK06032453003, NON-DRAFT

//Version: 018.000                                           
//Status: NonDraft                                          
//Date: 18-Jan-2006     Kati Kylmanen
//Reason: ISA RM-RIM tool ID:010-21231 
//Reference: ADB for SWAM:KK06011848510, NON-DRAFT

//Version: 017.000                                           
//Status: NonDraft                                          
//Date: 22-Dec-2005     Kati Kylmanen
//Reason: ISA RM-RIM tool ID:010-1983 010-19840 and 009-21258 
//Reference: ADB for SWAM:KK051222334581, NON-DRAFT

//Version: 016.000                                           
//Status: NonDraft                                          
//Date: 29-Sep-2005     Kati Kylmanen
//Reason: ISA RM-RIM tool ID:090-20727
//Reference: ADB for SWAM:KK05092958296, NON-DRAFT

//Version: 015.006                                           
//Status: NonDraft                                          
//Date: 22-Aug-2005     Kati Kylmanen
//Reason: ISA RM-RIM tool IDs:009-20426,009-20517,009-20485,009-20566 and 009-18559
//Reference: ADB for SWAM:KK05082255030, NON-DRAFT

//Version: 015.005                                           
//Status: NonDraft                                          
//Date: 02-Jun-2005     Kati Kylmanen
//Reason: ISA RM-RIM tool ID:009-19115
//Reference: ADB for SWAM:KK05060245965, NON-DRAFT

//Version: 015.004                                           
//Status: NonDraft                                          
//Date: 13-May-2005     Kati Kylmanen
//Reason: ISA RM-RIM tool ID:010-13137
//Reference: ADB for SWAM:KK05051157034, NON-DRAFT

//Version: 015.003                                           
//Status: NonDraft                                          
//Date: 18-Mar-2005     Kati Kylmanen
//Reason: ISA RM-RIM tool ID:010-12654
//Reference: ADB for SWAM:KK05031852681, NON-DRAFT

//Version: 015.002                                           
//Status: NonDraft                                          
//Date: 24-Feb-2005     Kati Kylmanen
//Reason: ISA RM-RIM tool ID:010-11607 and 010-11603
//Reference: ADB for SWAM:KK05022457188, NON-DRAFT

//Version: 015.001                                           
//Status: NonDraft                                          
//Date: 10-Feb-2005     Kati Kylmanen
//Reason: ISA RM-RIM tool ID:010-11286
//Reference: ADB for SWAM:KK05021060465, NON-DRAFT

//Version: 015.000                                           
//Status: NonDraft                                          
//Date: 01-Feb-2005     Kati Kylmanen
//Reason: ISA RM-RIM tool ID:010-11151,010-11150
//Reference: ADB for SWAM:KK05020333755, NON-DRAFT

//Version: 014.001                                           
//Status: NonDraft                                          
//Date: 20-Jan-2005     Kati Kylmanen
//Reason: ISA RM-RIM tool ID:010-9308
//Reference: ADB for SWAM:KK05012052078, NON-DRAFT

//Version: 014.000                                           
//Status: NonDraft                                          
//Date: 20-Dec-2004     Kati Kylmanen
//Reason: ISA RM-RIM tool ID:010-9321,010-9664 010-9663 009-12742 
//Reference: ADB for SWAM:KK04122049381, NON-DRAFT

//Version: 013.006                                           
//Status: NonDraft                                          
//Date: 07-Oct-2004     Kati Kylmanen
//Reason: ISA RM-RIM tool ID:- 
//Reference: ADB for SWAM:KK04100756832, NON-DRAFT

//Version: 013.005                                           
//Status: NonDraft                                          
//Date: 05-Aug-2004     Kati Kylmanen
//Reason: ISA RM-RIM tool ID:009-12743 and 010-3827 
//Reference: ADB for SWAM:KK04080938241, NON-DRAFT

//Version: 013.004                                           
//Status: NonDraft                                          
//Date: 23-Jun-2004     Kati Kylmanen
//Reason: ISA RM-RIM tool ID:009-12861 
//Reference: ADB for SWAM:PA04062453531, NON-DRAFT

//Version: 013.003                                           
//Status: NonDraft                                          
//Date: 08-Jun-2004     Kati Kylmanen
//Reason: ISA RM-RIM tool ID:010-3725 
//Reference: ADB for SWAM:KK04052742340, NON-DRAFT

//Version: 013.002                                           
//Status: NonDraft                                          
//Date: 02-Marc-2004    Kati Kylmanen
//Reason: ISA RM-RIM tool ID 009-8080,009-9510 and 009-9487
//Reference: ADB for SWAM:KK04030230915, NON-DRAFT

//Version: 013.001                                           
//Status: NonDraft                                          
//Date: 06-Nov-2003     Kati Kylmanen
//Reason: ISA RM-RIM tool ID 009-7241,009-4503 and 009-4504
//Reference: ADB for SWAM:KK03110631341, NON-DRAFT

//Version: 013.000                                           
//Status: NonDraft                                          
//Date: 13-Jun-2003     Kati Kylmanen
//Reason: ISA RM-RIM tool ID 010-1592, 009-4671, 009-4673 and 009-4672
//Reference: ADB for SWAM:KK03060936640, NON-DRAFT

//Version: 012.009                                           
//Status: NonDraft                                          
//Date: 09-Jun-2003     Kati Kylmanen
//Reason: ISA RM-RIM tool ID 010-1592, 009-4671, 009-4673 and 009-4672
//Reference: ADB for SWAM:KK03060936640, NON-DRAFT

//Version: 012.008                                           
//Status: NonDraft                                          
//Date: 06-May-2003     Kati Kylmanen
//Reason: ISA RM-RIM tool ID 004-112
//Reference: ADB for SWAM: KK03050635502, NON-DRAFT

//Version: 012.007                                           
//Status: NonDraft                                          
//Date: 28-Apr-2003     Kati Kylmanen
//Reason: ISA RM-RIM tool ID 010-1358 and 009-387
//Reference: ADB for SWAM: KK03042853819, NON-DRAFT

//Version: 012.006                                           
//Status: NonDraft                                          
//Date: 15-Mar-2003     Toni Laivo
//Reason: ISA RM-RIM tool ID 010-1280
//Reference: ADB for SWAM: TL03032756963, NON-DRAFT

//Version: 012.005                                           
//Status: NonDraft                                          
//Date: 22-Oct-2002     Kati Kylmanen
//Reason: ISA RM-RIM tool ID 9696
//Reference: ADB for SWAM: KK02101456534, NON-DRAFT

//Version: 012.004                                           
//Status: Unknown                                           
//Date: -               -
//Reason: -
//Reference: -

//Version: 012.003                                           
//Status: Unknown                                           
//Date: -               -
//Reason: -
//Reference: -

//Version: 012.002                                           
//Status: Unknown                                           
//Date: -               -
//Reason: -
//Reference: -

//Version: 012.001                                           
//Status: Unknown                                           
//Date: -               -
//Reason: -
//Reference: -

//Version: 000.000                                           
//Status: Unknown                                           
//Date: -               -
//Reason: -
//Reference: -


//CONSTANTS
#define ST_ANY_SIZE                                           1                                                     


//TABLES

//ConstantTable for ST_TEST_TYPES
#define ST_LISTED_TESTS                                       0x00                                                     
#define ST_STARTUP_TESTS                                      0x01                                                     
#define ST_RUNTIME_TESTS                                      0x02                                                     
#define ST_ALL_POSSIBLE_TESTS                                 0x03                                                     
#define ST_BACKGROUND_TESTS                                   0x04                                                     

//ConstantTable for ST_PRODTEST_ACTION
#define ST_TEST_START                                         0x00                                                     
#define ST_TEST_STOP                                          0x01                                                     

//ConstantTable for ST_PRODTEST_TYPES
#define ST_DISPLAY_TEST                                       0x00                                                     
#define ST_TVOUT_TEST                                         0x01                                                     

//ConstantTable for ST_DISPTEST_STATUS
#define ST_DISP_TEST_OK                                       0x00                                                     
#define ST_DISP_TEST_ILLEGAL_PARAMETER                        0x01                                                     
#define ST_DISP_TEST_ILLEGAL_SB_ID                            0x02                                                     
#define ST_DISP_TEST_WRONG_STATE                              0x03                                                     
#define ST_DISP_TEST_WRONG_DISPLAY                            0x04                                                     
#define ST_DISP_TEST_NOTCONFIGURED                            0x05                                                     
#define ST_DISP_TEST_TIMEOUT                                  0x06                                                     
#define ST_ANOTHER_TEST_ON                                    0x07                                                     

//ConstantTable for ST_FAIL_INFO
#define ST_OK                                                 0x00                                                     
#define ST_FAIL                                               0x01                                                     
#define ST_BUSY                                               0x02                                                     
#define ST_NOT_EXECUTED                                       0x03                                                     
#define ST_NOT_SUPPORTED                                      0x04                                                     
#define ST_SHORT_CIRCUIT                                      0x05                                                     
#define ST_NO_SIGNAL                                          0x06                                                     
#define ST_NO_POWER                                           0x07                                                     
#define ST_WRONG_OR_MISSING_ID                                0x08                                                     
#define ST_NO_SIM                                             0x09                                                     
#define ST_MINOR                                              0x0A                                                     
#define ST_SEVERE                                             0x0B                                                     
#define ST_FATAL                                              0x0C                                                     
#define ST_TIMEOUT                                            0x0D                                                     
#define ST_EXECUTING                                          0x0E                                                     

//ConstantTable for ST_SELFTEST_ID
#define ST_AUX_DA_LOOP_TEST                                   0x01                                                     
#define ST_CURRENT_CONS_TEST                                  0x02                                                     
#define ST_EAR_DATA_LOOP_TEST                                 0x03                                                     
#define ST_CDMA_DSP_ALL_TEST                                  0x04                                                     
#define ST_CAMERA_ACCELERATOR_TEST                            0x05                                                     
#define ST_IR_LOOP_TEST                                       0x06                                                     
#define ST_KEYBOARD_STUCK_TEST                                0x07                                                     
#define ST_MBUS_RX_TX_LOOP_TEST                               0x08                                                     
#define ST_PMM_CHECKSUM_TEST                                  0x09                                                     
#define ST_PPM_VALIDITY_TEST                                  0x0A                                                     
#define ST_TILT_SENSOR_IF_TEST                                0x0B                                                     
#define ST_SIM_CLK_LOOP_TEST                                  0x0C                                                     
#define ST_SIM_IO_CTRL_LOOP_TEST                              0x0D                                                     
#define ST_MICB1_TEST                                         0x0E                                                     
#define ST_SLEEP_X_LOOP_TEST                                  0x0F                                                     
#define ST_TEMP_SENSOR_IF_TEST                                0x10                                                  
#define ST_TX_IDP_LOOP_TEST                                   0x11                                                  
#define ST_TX_IQ_DP_LOOP_TEST                                 0x12                                                  
#define ST_KELVIN_VIBRA_TEST                                  0x13                                                  
#define ST_BACKUP_BATT_TEST                                   0x14                                                  
#define ST_LPRF_IF_TEST                                       0x15                                                  
#define ST_CAMERA_IF_TEST                                     0x16                                                  
#define ST_KELVIN_BATVOLTAGE_TEST                             0x17                                                  
#define ST_CDMA_MEMORY_BUFFER_TEST                            0x18                                                  
#define ST_EXTERNAL_RAM_TEST                                  0x19                                                  
#define ST_KELVIN_CAPACITOR_TEST                              0x1A                                                  
#define ST_KELVIN_AUDIO_TEST                                  0x1B                                                  
#define ST_KELVIN_MIC_TEST                                    0x1C                                                  
#define ST_KELVIN_MISC_TEST                                   0x1D                                                  
#define ST_RF_CHIP_ID_TEST                                    0x1E                                                  
#define ST_KELVIN_CHARGING_TEST                               0x1F                                                  
#define ST_AMB_LIGHT_SENSOR_TEST                              0x20                                                  
#define ST_SIM_LOCK_TEST                                      0x21                                                  
#define ST_USB_CHARGING_TEST                                  0x22                                                  
#define ST_NAVISCROLL_TEST                                    0x23                                                  
#define ST_SEC_LCD_IF_TEST                                    0x24                                                  
#define ST_SEC_CAMERA_IF_TEST                                 0x25                                                  
#define ST_CAMERA_AUTOFOCUS_TEST                              0x26                                                  
#define ST_WARRANTY_TEST                                      0x27                                                  
#define ST_PMM_VALIDITY_TEST                                  0x28                                                  
#define ST_FLASH_CHECKSUM_TEST                                0x29                                                  
#define ST_RADIO_TEST                                         0x2A                                                  
#define ST_LCD_TEST                                           0x2B                                                  
#define ST_LPRF_AUDIO_LINES_TEST                              0x2C                                                  
#define ST_IR_IF_TEST                                         0x2D                                                  
#define ST_UEM_CBUS_IF_TEST                                   0x2E                                                  
#define ST_AEM_CBUS_IF_TEST                                   0x2F                                                  
#define ST_PROX_FAULT_TEST                                    0x30                                                  
#define ST_VIBRA_TEST_TEST                                    0x31                                                  
#define ST_MMC_INT_TEST                                       0x32                                                  
#define ST_PA_TEMP_TEST                                       0x33                                                  
#define ST_KEYB_LINE_TEST                                     0x34                                                  
#define ST_WCDMA_IF_TEST                                      0x35                                                  
#define ST_EXT_RAM_DATA_BUS_TEST                              0x36                                                  
#define ST_EXT_RAM_ADDR_BUS_TEST                              0x37                                                  
#define ST_CDSP_SLEEPCLK_FREQ_TEST                            0x38                                                  
#define ST_CURRENT_GAUGE_IF_TEST                              0x39                                                  
#define ST_CMT_APE_WAKEUP_TEST                                0x3A                                                  
#define ST_MAIN_LCD_IF_TEST                                   0x3B                                                  
#define ST_TOUCH_STUCK_TEST                                   0x3C                                                  
#define ST_QWERTY_IF_TEST                                     0x3D                                                  
#define ST_QWERTY_STUCK_TEST                                  0x3E                                                  
#define ST_APE_DAC_CTRL_IF_TEST                               0x3F                                                  
#define ST_APE_RAM_TEST                                       0x40                                                  
#define ST_APE_POST_CODE_TEST                                 0x41                                                  
#define ST_ADSP_STARTUP_TEST                                  0x42                                                  
#define ST_ADSP_EXT_FLASH_TEST                                0x43                                                  
#define ST_SW_TYPE_VALIDITY_TEST                              0x44                                                  
#define ST_BACKLIGHT_TEST                                     0x45                                                  
#define ST_NAND_FLASH_ID_TEST                                 0x46                                                  
#define ST_BT_WAKEUP_TEST                                     0x47                                                  
#define ST_WLAN_TEST                                          0x48                                                  
#define ST_XABUS_TEST                                         0x49                                                  
#define ST_CDSP_TXC_DATA_TEST                                 0x4A                                                  
#define ST_CDSP_WCDMA_TX_POWER_TEST                           0x4B                                                  
#define ST_CDSP_WCDMA_TX_IQ_QUAL_TEST                         0x4C                                                  
#define ST_CDSP_GSM_TX_POWER_TEST                             0x4D                                                  
#define ST_CDSP_GSM_TX_IQ_QUAL_TEST                           0x4E                                                  
#define ST_CDSP_RX_PLL_PHASE_LOCK_TEST                        0x4F                                                  
#define ST_CDSP_TX_PLL_PHASE_LOCK_TEST                        0x50                                                  
#define ST_CDSP_RX_IQ_LOOP_BACK_TEST                          0x51                                                  
#define ST_CDSP_PWR_DETECTOR_BIAS_TEST                        0x52                                                  
#define ST_CDSP_RF_SUPPLY_TEST                                0x53                                                  
#define ST_CDSP_PA_COMBINATION_TEST                           0x54                                                  
#define ST_CDSP_TX_IQ_TEST                                    0x55                                                  
#define ST_CDSP_RF_BB_IF_TEST                                 0x56                                                  
#define ST_TAHVOINT_TEST                                      0x58                                                  
#define ST_IVE_TEST                                           0x59                                                  
#define ST_PWR_KEY_TEST                                       0x5A                                                  
#define ST_USB_LOOP_TEST                                      0x5B                                                  
#define ST_BT_WLAN_COEXISTENCE_TEST                           0x5C                                                  
#define ST_SECURITY_TEST                                      0x5D                                                  
#define ST_GPS_TEST                                           0x5E                                                  
#define ST_PWRONX_PULSE_TEST                                  0x5F                                                  
#define ST_HOOKINT_TEST                                       0x60                                                  
#define ST_MASS_MEMORY_IF_TEST                                0x61                                                  
#define ST_2ND_JOYSTICK_STUCK_TEST                            0x62                                                  
#define ST_IRDA_LED_STRESS_TEST                               0x63                                                  
#define ST_CAMERA_FLASHLIGHT_TEST                             0x64                                                  
#define ST_BTEMP_TEST                                         0x65                                                  
#define ST_APE_EM_ASIC_TEST                                   0x66                                                  
#define ST_TOUCH_IF_TEST                                      0x67                                                  
#define ST_ACCEL_IF_TEST                                      0x68                                                  
#define ST_INTERNAL_ANTENNA_TEST                              0x69                                                  
#define ST_DVBH_TEST                                          0x6A                                                  
#define ST_BT_SLEEP_CLK_TEST                                  0x6B                                                  
#define ST_EXT_DEVICE_TEST                                    0x6C                                                  
#define ST_ZOOM_TEST                                          0x6D                                                  
#define ST_PREPAID_CSTYPE_TEST                                0x6E                                                  
#define ST_HRM_TEST                                           0x6F                                                  
#define ST_BT_CLK_REQ_TEST                                    0x70                                                  
#define ST_LCD_CONTROLLER_TEST                                0x71                                                  
#define ST_IO_EXPANDER_IF_TEST                                0x72                                                  
#define ST_TVOUT_IF_TEST                                      0x73                                                  
#define ST_KELVIN_XEAR_TEST                                   0x74                                                  
#define ST_DIGIMIC_TEST                                       0x75                                                  
#define ST_CDSP_ANTENNA_TEST                                  0x76                                                  
#define ST_IIC_TEST                                           0x77                                                  
#define ST_CAMERA_REVEAL_TEST                                 0x78                                                  
#define ST_LED_FLASH_TEST                                     0x79                                                  
#define ST_FMTX_TEST                                          0x7A                                                  
#define ST_CDSP_RX_IQ_TEST                                    0x7B                                                  
#define ST_CDSP_STROBE_TEST                                   0x7C                                                  
#define ST_CDSP_DIGI_RXTX_IF_TEST                             0x7D                                                  
#define ST_CDSP_SMPS_TEST                                     0x7E                                                  
#define ST_CDSP_PA_ID_PIN_TEST                                0x7F                                                  
#define ST_CDSP_SLEEPCLOCK_FREQ_TEST                          0x80                                                  
#define ST_CDSP_NO_TEST                                       0xC8                                                  
#define ST_MAGNETOMETER_TEST                                  0xC9                                                  
#define ST_ELECTROMAGNET_TEST                                 0xCA                                                  
#define ST_CHIPSET_API_PMU_TEST                               0xCB                                                  
#define ST_CHIPSET_API_RFPA_TEST                              0xCC                                                  
#define ST_CHIPSET_API_VIBRA_TEST                             0xCD                                                  
#define ST_CHIPSET_API_MIC_TEST                               0xCE                                                  
#define ST_CHIPSET_API_EARP_TEST                              0xCF                                                  
#define ST_CHIPSET_API_IHF_TEST                               0xD0                                                  
#define ST_HEADSET_AMPLIFIER_TEST                             0xD1                                                  
#define ST_SNV_MEMORY_TEST                                    0xD2                                                  
#define ST_WIMAX_SLEEP_CLK_TEST                               0xD3                                                  
#define ST_WIMAX_BOOT_IO_TEST                                 0xD4                                                  
#define ST_FINGERPRINT_SENSOR_TEST                            0xD5                                                  
#define ST_MODEM_IRQ_TEST                                     0xD6                                                  
#define ST_MODEM_TX_START_TEST                                0xD7                                                  
#define ST_MODEM_IQ_IF_TEST                                   0xD8                                                  
#define ST_MODEM_FDI_TEST                                     0xD9                                                  
#define ST_MODEM_TBTIMEMARK_TEST                              0xDA                                                  
#define ST_MODEM_CMTTIMEMARK_TEST                             0xDB                                                  
#define ST_MODEM_SDRAM_TEST                                   0xDC                                                  
#define ST_MODEM_VCORESMPS_TESTS                              0xDD                                                  
#define ST_LED_CONTROLLER_TEST                                0xDE                                                  

//ConstantTable for ST_DISPLAY_PATTERN
#define ST_CHESS_PATTERN                                      0x00                                                     
#define ST_CONTRAST_PATTERN_ADJ                               0x01                                                     
#define ST_ALL_WHITE                                          0x02                                                     
#define ST_ALL_BLACK                                          0x03                                                     
#define ST_CONTRAST_PATTERN                                   0x04                                                     

//ConstantTable for ST_DISPLAY_TYPE
#define ST_MAIN_DISPLAY                                       0x00                                                     
#define ST_SECONDARY_DISPLAY                                  0x01                                                     

//ConstantTable for ST_TVOUT_PATTERN
#define ST_TVOUT_WHITE_PATTERN                                0x00                                                     
#define ST_TVOUT_BLACK_PATTERN                                0x01                                                     
#define ST_TVOUT_YELLOW_PATTERN                               0x02                                                     
#define ST_TVOUT_CYAN_PATTERN                                 0x03                                                     
#define ST_TVOUT_GREEN_PATTERN                                0x04                                                     
#define ST_TVOUT_MAGNETA_PATTERN                              0x05                                                     
#define ST_TVOUT_RED_PATTERN                                  0x06                                                     
#define ST_TVOUT_BLUE_PATTERN                                 0x07                                                     

//ConstantTable for ST_AMPLIFIER_STATE
#define ST_TEST_ON                                            0x00                                                     
#define ST_TEST_OFF                                           0x01                                                     

//ConstantTable for ST_TV_SYSTEM
#define ST_TV_NTC                                             0x00                                                     
#define ST_TV_PAL                                             0x01                                                     


//SUBBLOCKS


//Definition for struct ST_SB_SELFTEST_LIST
#define ST_SB_SELFTEST_LIST                                   0x00                                                     
typedef struct
            { 
             uint8_t      sb_id;
             uint8_t      sb_length;
             uint8_t      list_length;
             uint8_t      fillerbyte1;
             uint8_t      list[0];
            } __attribute__((packed)) ST_SB_SELFTEST_LIST_STR;
#define SIZE_ST_SB_SELFTEST_LIST                              sizeof(ST_SB_SELFTEST_LIST_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct ST_SB_SELFTEST_RESULT
#define ST_SB_SELFTEST_RESULT                                 0x01                                                     
typedef struct
            { 
             uint8_t      sb_id;
             uint8_t      sb_length;
             uint8_t      selftest_id;
             uint8_t      result;
            } __attribute__((packed)) ST_SB_SELFTEST_RESULT_STR;
#define SIZE_ST_SB_SELFTEST_RESULT                            sizeof(ST_SB_SELFTEST_RESULT_STR)


//Definition for struct ST_SB_SELFTEST_NAME
#define ST_SB_SELFTEST_NAME                                   0x02                                                     
typedef struct
            { 
             uint8_t      sb_id;
             uint8_t      sb_length;
             uint8_t      selftest_id;
             uint8_t      name_length;
             uint8_t      name[0];
            } __attribute__((packed)) ST_SB_SELFTEST_NAME_STR;
#define SIZE_ST_SB_SELFTEST_NAME                              sizeof(ST_SB_SELFTEST_NAME_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct ST_SB_SELFTEST_DETAILED_RESULTS
#define ST_SB_SELFTEST_DETAILED_RESULTS                       0x03                                                     
typedef struct
            { 
             uint8_t      sb_id;
             uint8_t      sb_length;
             uint8_t      selftest_id;
             uint8_t      number_of_results;
             uint8_t      results[0];
            } __attribute__((packed)) ST_SB_SELFTEST_DETAILED_RESULTS_STR;
#define SIZE_ST_SB_SELFTEST_DETAILED_RESULTS                  sizeof(ST_SB_SELFTEST_DETAILED_RESULTS_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct ST_SB_DISPLAY_PATTERN
#define ST_SB_DISPLAY_PATTERN                                 0x04                                                     
typedef struct
            { 
             uint8_t      sb_id;
             uint8_t      sb_length;
             uint8_t      test_display;
             uint8_t      test_pattern;
            } __attribute__((packed)) ST_SB_DISPLAY_PATTERN_STR;
#define SIZE_ST_SB_DISPLAY_PATTERN                            sizeof(ST_SB_DISPLAY_PATTERN_STR)


//Definition for struct ST_SB_TVOUT_PATTERN
#define ST_SB_TVOUT_PATTERN                                   0x05                                                     
typedef struct
            { 
             uint8_t      sb_id;
             uint8_t      sb_length;
             uint8_t      test_pattern;
             uint8_t      amplifier;
             uint8_t      system;
             uint8_t      fillerbyte1[3];
            } __attribute__((packed)) ST_SB_TVOUT_PATTERN_STR;
#define SIZE_ST_SB_TVOUT_PATTERN                              sizeof(ST_SB_TVOUT_PATTERN_STR)


//MESSAGES


//Definition for struct ST_RUN_REQ
#define ST_RUN_REQ                                            0x00                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      action;
             uint8_t      sub_block_count;
            } __attribute__((packed)) ST_RUN_REQ_STR;
#define SIZE_ST_RUN_REQ                                       sizeof(ST_RUN_REQ_STR)


//Definition for struct ST_RUN_RESP
#define ST_RUN_RESP                                           0x01                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      sub_block_count;
            } __attribute__((packed)) ST_RUN_RESP_STR;
#define SIZE_ST_RUN_RESP                                      sizeof(ST_RUN_RESP_STR)


//Definition for struct ST_RESULTS_GET_REQ
#define ST_RESULTS_GET_REQ                                    0x02                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      action;
             uint8_t      sub_block_count;
            } __attribute__((packed)) ST_RESULTS_GET_REQ_STR;
#define SIZE_ST_RESULTS_GET_REQ                               sizeof(ST_RESULTS_GET_REQ_STR)


//Definition for struct ST_RESULTS_GET_RESP
#define ST_RESULTS_GET_RESP                                   0x03                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      sub_block_count;
            } __attribute__((packed)) ST_RESULTS_GET_RESP_STR;
#define SIZE_ST_RESULTS_GET_RESP                              sizeof(ST_RESULTS_GET_RESP_STR)


//Definition for struct ST_SELFTEST_LIST_GET_REQ
#define ST_SELFTEST_LIST_GET_REQ                              0x04                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      action;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) ST_SELFTEST_LIST_GET_REQ_STR;
#define SIZE_ST_SELFTEST_LIST_GET_REQ                         sizeof(ST_SELFTEST_LIST_GET_REQ_STR)


//Definition for struct ST_SELFTEST_LIST_GET_RESP
#define ST_SELFTEST_LIST_GET_RESP                             0x05                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      sub_block_count;
            } __attribute__((packed)) ST_SELFTEST_LIST_GET_RESP_STR;
#define SIZE_ST_SELFTEST_LIST_GET_RESP                        sizeof(ST_SELFTEST_LIST_GET_RESP_STR)


//Definition for struct ST_SELFTEST_NAMES_GET_REQ
#define ST_SELFTEST_NAMES_GET_REQ                             0x06                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      action;
             uint8_t      sub_block_count;
            } __attribute__((packed)) ST_SELFTEST_NAMES_GET_REQ_STR;
#define SIZE_ST_SELFTEST_NAMES_GET_REQ                        sizeof(ST_SELFTEST_NAMES_GET_REQ_STR)


//Definition for struct ST_SELFTEST_NAMES_GET_RESP
#define ST_SELFTEST_NAMES_GET_RESP                            0x07                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      sub_block_count;
            } __attribute__((packed)) ST_SELFTEST_NAMES_GET_RESP_STR;
#define SIZE_ST_SELFTEST_NAMES_GET_RESP                       sizeof(ST_SELFTEST_NAMES_GET_RESP_STR)


//Definition for struct ST_DETAILED_RESULTS_GET_REQ
#define ST_DETAILED_RESULTS_GET_REQ                           0x08                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      selftest_id;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) ST_DETAILED_RESULTS_GET_REQ_STR;
#define SIZE_ST_DETAILED_RESULTS_GET_REQ                      sizeof(ST_DETAILED_RESULTS_GET_REQ_STR)


//Definition for struct ST_DETAILED_RESULTS_GET_RESP
#define ST_DETAILED_RESULTS_GET_RESP                          0x09                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      sub_block_count;
            } __attribute__((packed)) ST_DETAILED_RESULTS_GET_RESP_STR;
#define SIZE_ST_DETAILED_RESULTS_GET_RESP                     sizeof(ST_DETAILED_RESULTS_GET_RESP_STR)


//Definition for struct ST_PRODUCT_TEST_REQ
#define ST_PRODUCT_TEST_REQ                                   0x0A                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      testid;
             uint8_t      action;
             uint8_t      fillerbyte1[3];
             uint8_t      sub_block_count;
            } __attribute__((packed)) ST_PRODUCT_TEST_REQ_STR;
#define SIZE_ST_PRODUCT_TEST_REQ                              sizeof(ST_PRODUCT_TEST_REQ_STR)


//Definition for struct ST_PRODUCT_TEST_RESP
#define ST_PRODUCT_TEST_RESP                                  0x0B                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      test;
             uint8_t      status;
            } __attribute__((packed)) ST_PRODUCT_TEST_RESP_STR;
#define SIZE_ST_PRODUCT_TEST_RESP                             sizeof(ST_PRODUCT_TEST_RESP_STR)

#endif
