#ifndef _PN_TOUCHPAD_ISI_H_
#define _PN_TOUCHPAD_ISI_H_

#include <stdint.h> 

//Resource Touchpad Server
//PN_TOUCHPAD 0x70 
//ISI version 002.007
#define TOUCHPAD_SERVER_ISI_VERSION_Z     2
#define TOUCHPAD_SERVER_ISI_VERSION_Y     7

//In case of problems concerning content of this file contact Markku Loukusa, Sauli Laukka or Markus Mrsky
//Server specific message descriptions and feature&protocol descriptions can be found from: https://oucmswww.nmp.nokia.com:58443/document_browser/ccm_wa/GIF_SPECS/ 


//ISI VERSION CHANGE HISTORY

//Version: 002.007                                           
//Status: NonDraft                                          
//Date: 11-Feb-2008     Sami Nieminen
//Reason: New feature
//Reference: Interface CR: ADB for SWAM: SN08031740546, NON-DRAFT

//Version: 002.006                                           
//Status: NonDraft                                          
//Date: 17-Dec-2007     Sami Nieminen
//Reason: New feature
//Reference: Interface CR: ADB for SWAM: SN07121832931, NON-DRAFT

//Version: 002.005                                           
//Status: NonDraft                                          
//Date: 01-Jul-2003     Jiang Feng-Fred
//Reason: New feature
//Reference: FJ03070136652, NON-DRAFT

//Version: 002.004                                           
//Status: NonDraft                                          
//Date: 18-Feb-2003     Jiang Feng-Fred
//Reason: Change after inspection 2003-2-7
//Reference: -

//Version: 002.002                                           
//Status: NonDraft                                          
//Date: 05-Dec-2002     Jiang Feng-Fred
//Reason: Change after inspection 2002-12-4
//Reference: FJ02112841263, NON-DRAFT

//Version: 002.001                                           
//Status: NonDraft                                          
//Date: 28-Nov-2002     Jiang Feng-Fred
//Reason: Change after inspection 2002-11-25
//Reference: FJ02112841263, NON-DRAFT

//Version: 002.000                                           
//Status: NonDraft                                          
//Date: 13-Nov-2002     Jiang Feng-Fred
//Reason: The first version in PCMS
//Reference: FJ02111356222, NON-DRAFT


//CONSTANTS
#define TOUCHPAD_FILL_BYTE                                    0x00                                                     
#define TOUCHPAD_OK                                           0x00                                                     
#define TOUCHPAD_FAIL                                         0x01                                                     


//TABLES

//ConstantTable for TOUCHPAD_TOUCHKEY_ID
#define TOUCHPAD_TK_LAYOUT0_KEY0                              0x00                                                     
#define TOUCHPAD_TK_LAYOUT0_KEY1                              0x01                                                     
#define TOUCHPAD_TK_LAYOUT0_KEY2                              0x02                                                     
#define TOUCHPAD_TK_LAYOUT0_KEY3                              0x03                                                     
#define TOUCHPAD_TK_LAYOUT0_KEY4                              0x04                                                     
#define TOUCHPAD_TK_LAYOUT0_KEY5                              0x05                                                     
#define TOUCHPAD_TK_LAYOUT0_KEY6                              0x06                                                     
#define TOUCHPAD_TK_LAYOUT0_KEY7                              0x07                                                     
#define TOUCHPAD_TK_LAYOUT0_KEY8                              0x08                                                     
#define TOUCHPAD_TK_LAYOUT0_KEY9                              0x09                                                     
#define TOUCHPAD_TK_LAYOUT0_KEY10                             0x0A                                                     
#define TOUCHPAD_TK_LAYOUT0_KEY11                             0x0B                                                     
#define TOUCHPAD_TK_LAYOUT0_KEY12                             0x0C                                                     
#define TOUCHPAD_TK_LAYOUT0_KEY13                             0x0D                                                     
#define TOUCHPAD_TK_LAYOUT0_KEY14                             0x0E                                                     
#define TOUCHPAD_TK_LAYOUT0_KEY15                             0x0F                                                     
#define TOUCHPAD_TK_LAYOUT0_KEY16                             0x10                                                  
#define TOUCHPAD_TK_LAYOUT0_KEY17                             0x11                                                  
#define TOUCHPAD_TK_LAYOUT0_KEY18                             0x12                                                  
#define TOUCHPAD_TK_LAYOUT0_KEY19                             0x13                                                  
#define TOUCHPAD_TK_LAYOUT0_KEY20                             0x14                                                  
#define TOUCHPAD_TK_LAYOUT0_KEY21                             0x15                                                  
#define TOUCHPAD_TK_LAYOUT0_KEY22                             0x16                                                  
#define TOUCHPAD_TK_LAYOUT0_KEY23                             0x17                                                  
#define TOUCHPAD_TK_LAYOUT0_KEY24                             0x18                                                  
#define TOUCHPAD_TK_LAYOUT0_KEY25                             0x19                                                  
#define TOUCHPAD_TK_LAYOUT0_KEY26                             0x1A                                                  
#define TOUCHPAD_TK_LAYOUT0_KEY27                             0x1B                                                  
#define TOUCHPAD_TK_LAYOUT0_KEY28                             0x1C                                                  
#define TOUCHPAD_TK_LAYOUT0_KEY29                             0x1D                                                  
#define TOUCHPAD_TK_LAYOUT0_KEY30                             0x1E                                                  
#define TOUCHPAD_TK_LAYOUT0_KEY31                             0x1F                                                  
#define TOUCHPAD_TK_LAYOUT0_KEY32                             0x20                                                  
#define TOUCHPAD_TK_LAYOUT0_KEY33                             0x21                                                  
#define TOUCHPAD_TK_LAYOUT0_KEY34                             0x22                                                  
#define TOUCHPAD_TK_LAYOUT0_KEY35                             0x23                                                  
#define TOUCHPAD_TK_LAYOUT0_KEY36                             0x24                                                  
#define TOUCHPAD_TK_LAYOUT0_KEY37                             0x25                                                  
#define TOUCHPAD_TK_LAYOUT0_KEY38                             0x26                                                  
#define TOUCHPAD_TK_LAYOUT0_KEY39                             0x27                                                  
#define TOUCHPAD_TK_LAYOUT0_KEY40                             0x28                                                  
#define TOUCHPAD_TK_LAYOUT0_KEY41                             0x29                                                  
#define TOUCHPAD_TK_LAYOUT0_KEY42                             0x2A                                                  
#define TOUCHPAD_TK_LAYOUT0_KEY43                             0x2B                                                  
#define TOUCHPAD_TK_LAYOUT0_KEY44                             0x2C                                                  
#define TOUCHPAD_TK_LAYOUT0_KEY45                             0x2D                                                  
#define TOUCHPAD_TK_LAYOUT0_KEY46                             0x2E                                                  
#define TOUCHPAD_TK_LAYOUT0_KEY47                             0x2F                                                  
#define TOUCHPAD_TK_LAYOUT0_KEY48                             0x30                                                  
#define TOUCHPAD_TK_LAYOUT0_KEY49                             0x31                                                  
#define TOUCHPAD_TK_LAYOUT0_KEY50                             0x32                                                  
#define TOUCHPAD_TK_LAYOUT0_KEY51                             0x33                                                  
#define TOUCHPAD_TK_LAYOUT0_KEY52                             0x34                                                  
#define TOUCHPAD_TK_LAYOUT0_KEY53                             0x35                                                  
#define TOUCHPAD_TK_LAYOUT0_KEY54                             0x36                                                  
#define TOUCHPAD_TK_LAYOUT0_KEY55                             0x37                                                  
#define TOUCHPAD_TK_LAYOUT0_KEY56                             0x38                                                  
#define TOUCHPAD_TK_LAYOUT0_KEY57                             0x39                                                  
#define TOUCHPAD_TK_LAYOUT0_KEY58                             0x3A                                                  
#define TOUCHPAD_TK_LAYOUT0_KEY59                             0x3B                                                  
#define TOUCHPAD_TK_LAYOUT0_KEY60                             0x3C                                                  
#define TOUCHPAD_TK_LAYOUT0_KEY61                             0x3D                                                  
#define TOUCHPAD_TK_LAYOUT0_KEY62                             0x3E                                                  
#define TOUCHPAD_TK_LAYOUT0_KEY63                             0x3F                                                  
#define TOUCHPAD_TK_LAYOUT1_KEY0                              0x40                                                  
#define TOUCHPAD_TK_LAYOUT1_KEY1                              0x41                                                  
#define TOUCHPAD_TK_LAYOUT1_KEY2                              0x42                                                  
#define TOUCHPAD_TK_LAYOUT1_KEY3                              0x43                                                  
#define TOUCHPAD_TK_LAYOUT1_KEY4                              0x44                                                  
#define TOUCHPAD_TK_LAYOUT1_KEY5                              0x45                                                  
#define TOUCHPAD_TK_LAYOUT1_KEY6                              0x46                                                  
#define TOUCHPAD_TK_LAYOUT1_KEY7                              0x47                                                  
#define TOUCHPAD_TK_LAYOUT1_KEY8                              0x48                                                  
#define TOUCHPAD_TK_LAYOUT1_KEY9                              0x49                                                  
#define TOUCHPAD_TK_LAYOUT1_KEY10                             0x4A                                                  
#define TOUCHPAD_TK_LAYOUT1_KEY11                             0x4B                                                  
#define TOUCHPAD_TK_LAYOUT1_KEY12                             0x4C                                                  
#define TOUCHPAD_TK_LAYOUT1_KEY13                             0x4D                                                  
#define TOUCHPAD_TK_LAYOUT1_KEY14                             0x4E                                                  
#define TOUCHPAD_TK_LAYOUT1_KEY15                             0x4F                                                  
#define TOUCHPAD_TK_LAYOUT1_KEY16                             0x50                                                  
#define TOUCHPAD_TK_LAYOUT1_KEY17                             0x51                                                  
#define TOUCHPAD_TK_LAYOUT1_KEY18                             0x52                                                  
#define TOUCHPAD_TK_LAYOUT1_KEY19                             0x53                                                  
#define TOUCHPAD_TK_LAYOUT1_KEY20                             0x54                                                  
#define TOUCHPAD_TK_LAYOUT1_KEY21                             0x55                                                  
#define TOUCHPAD_TK_LAYOUT1_KEY22                             0x56                                                  
#define TOUCHPAD_TK_LAYOUT1_KEY23                             0x57                                                  
#define TOUCHPAD_TK_LAYOUT1_KEY24                             0x58                                                  
#define TOUCHPAD_TK_LAYOUT1_KEY25                             0x59                                                  
#define TOUCHPAD_TK_LAYOUT1_KEY26                             0x5A                                                  
#define TOUCHPAD_TK_LAYOUT1_KEY27                             0x5B                                                  
#define TOUCHPAD_TK_LAYOUT1_KEY28                             0x5C                                                  
#define TOUCHPAD_TK_LAYOUT1_KEY29                             0x5D                                                  
#define TOUCHPAD_TK_LAYOUT1_KEY30                             0x5E                                                  
#define TOUCHPAD_TK_LAYOUT1_KEY31                             0x5F                                                  
#define TOUCHPAD_TK_LAYOUT1_KEY32                             0x60                                                  
#define TOUCHPAD_TK_LAYOUT1_KEY33                             0x61                                                  
#define TOUCHPAD_TK_LAYOUT1_KEY34                             0x62                                                  
#define TOUCHPAD_TK_LAYOUT1_KEY35                             0x63                                                  
#define TOUCHPAD_TK_LAYOUT1_KEY36                             0x64                                                  
#define TOUCHPAD_TK_LAYOUT1_KEY37                             0x65                                                  
#define TOUCHPAD_TK_LAYOUT1_KEY38                             0x66                                                  
#define TOUCHPAD_TK_LAYOUT1_KEY39                             0x67                                                  
#define TOUCHPAD_TK_LAYOUT1_KEY40                             0x68                                                  
#define TOUCHPAD_TK_LAYOUT1_KEY41                             0x69                                                  
#define TOUCHPAD_TK_LAYOUT1_KEY42                             0x6A                                                  
#define TOUCHPAD_TK_LAYOUT1_KEY43                             0x6B                                                  
#define TOUCHPAD_TK_LAYOUT1_KEY44                             0x6C                                                  
#define TOUCHPAD_TK_LAYOUT1_KEY45                             0x6D                                                  
#define TOUCHPAD_TK_LAYOUT1_KEY46                             0x6E                                                  
#define TOUCHPAD_TK_LAYOUT1_KEY47                             0x6F                                                  
#define TOUCHPAD_TK_LAYOUT1_KEY48                             0x70                                                  
#define TOUCHPAD_TK_LAYOUT1_KEY49                             0x71                                                  
#define TOUCHPAD_TK_LAYOUT1_KEY50                             0x72                                                  
#define TOUCHPAD_TK_LAYOUT1_KEY51                             0x73                                                  
#define TOUCHPAD_TK_LAYOUT1_KEY52                             0x74                                                  
#define TOUCHPAD_TK_LAYOUT1_KEY53                             0x75                                                  
#define TOUCHPAD_TK_LAYOUT1_KEY54                             0x76                                                  
#define TOUCHPAD_TK_LAYOUT1_KEY55                             0x77                                                  
#define TOUCHPAD_TK_LAYOUT1_KEY56                             0x78                                                  
#define TOUCHPAD_TK_LAYOUT1_KEY57                             0x79                                                  
#define TOUCHPAD_TK_LAYOUT1_KEY58                             0x7A                                                  
#define TOUCHPAD_TK_LAYOUT1_KEY59                             0x7B                                                  
#define TOUCHPAD_TK_LAYOUT1_KEY60                             0x7C                                                  
#define TOUCHPAD_TK_LAYOUT1_KEY61                             0x7D                                                  
#define TOUCHPAD_TK_LAYOUT1_KEY62                             0x7E                                                  
#define TOUCHPAD_TK_LAYOUT1_KEY63                             0x7F                                                  
#define TOUCHPAD_TK_LAYOUT2_KEY0                              0x80                                                  
#define TOUCHPAD_TK_LAYOUT2_KEY1                              0x81                                                  
#define TOUCHPAD_TK_LAYOUT2_KEY2                              0x82                                                  
#define TOUCHPAD_TK_LAYOUT2_KEY3                              0x83                                                  
#define TOUCHPAD_TK_LAYOUT2_KEY4                              0x84                                                  
#define TOUCHPAD_TK_LAYOUT2_KEY5                              0x85                                                  
#define TOUCHPAD_TK_LAYOUT2_KEY6                              0x86                                                  
#define TOUCHPAD_TK_LAYOUT2_KEY7                              0x87                                                  
#define TOUCHPAD_TK_LAYOUT2_KEY8                              0x88                                                  
#define TOUCHPAD_TK_LAYOUT2_KEY9                              0x89                                                  
#define TOUCHPAD_TK_LAYOUT2_KEY10                             0x8A                                                  
#define TOUCHPAD_TK_LAYOUT2_KEY11                             0x8B                                                  
#define TOUCHPAD_TK_LAYOUT2_KEY12                             0x8C                                                  
#define TOUCHPAD_TK_LAYOUT2_KEY13                             0x8D                                                  
#define TOUCHPAD_TK_LAYOUT2_KEY14                             0x8E                                                  
#define TOUCHPAD_TK_LAYOUT2_KEY15                             0x8F                                                  
#define TOUCHPAD_TK_LAYOUT2_KEY16                             0x90                                                  
#define TOUCHPAD_TK_LAYOUT2_KEY17                             0x91                                                  
#define TOUCHPAD_TK_LAYOUT2_KEY18                             0x92                                                  
#define TOUCHPAD_TK_LAYOUT2_KEY19                             0x93                                                  
#define TOUCHPAD_TK_LAYOUT2_KEY20                             0x94                                                  
#define TOUCHPAD_TK_LAYOUT2_KEY21                             0x95                                                  
#define TOUCHPAD_TK_LAYOUT2_KEY22                             0x96                                                  
#define TOUCHPAD_TK_LAYOUT2_KEY23                             0x97                                                  
#define TOUCHPAD_TK_LAYOUT2_KEY24                             0x98                                                  
#define TOUCHPAD_TK_LAYOUT2_KEY25                             0x99                                                  
#define TOUCHPAD_TK_LAYOUT2_KEY26                             0x9A                                                  
#define TOUCHPAD_TK_LAYOUT2_KEY27                             0x9B                                                  
#define TOUCHPAD_TK_LAYOUT2_KEY28                             0x9C                                                  
#define TOUCHPAD_TK_LAYOUT2_KEY29                             0x9D                                                  
#define TOUCHPAD_TK_LAYOUT2_KEY30                             0x9E                                                  
#define TOUCHPAD_TK_LAYOUT2_KEY31                             0x9F                                                  
#define TOUCHPAD_TK_LAYOUT2_KEY32                             0xA0                                                  
#define TOUCHPAD_TK_LAYOUT2_KEY33                             0xA1                                                  
#define TOUCHPAD_TK_LAYOUT2_KEY34                             0xA2                                                  
#define TOUCHPAD_TK_LAYOUT2_KEY35                             0xA3                                                  
#define TOUCHPAD_TK_LAYOUT2_KEY36                             0xA4                                                  
#define TOUCHPAD_TK_LAYOUT2_KEY37                             0xA5                                                  
#define TOUCHPAD_TK_LAYOUT2_KEY38                             0xA6                                                  
#define TOUCHPAD_TK_LAYOUT2_KEY39                             0xA7                                                  
#define TOUCHPAD_TK_LAYOUT2_KEY40                             0xA8                                                  
#define TOUCHPAD_TK_LAYOUT2_KEY41                             0xA9                                                  
#define TOUCHPAD_TK_LAYOUT2_KEY42                             0xAA                                                  
#define TOUCHPAD_TK_LAYOUT2_KEY43                             0xAB                                                  
#define TOUCHPAD_TK_LAYOUT2_KEY44                             0xAC                                                  
#define TOUCHPAD_TK_LAYOUT2_KEY45                             0xAD                                                  
#define TOUCHPAD_TK_LAYOUT2_KEY46                             0xAE                                                  
#define TOUCHPAD_TK_LAYOUT2_KEY47                             0xAF                                                  
#define TOUCHPAD_TK_LAYOUT2_KEY48                             0xB0                                                  
#define TOUCHPAD_TK_LAYOUT2_KEY49                             0xB1                                                  
#define TOUCHPAD_TK_LAYOUT2_KEY50                             0xB2                                                  
#define TOUCHPAD_TK_LAYOUT2_KEY51                             0xB3                                                  
#define TOUCHPAD_TK_LAYOUT2_KEY52                             0xB4                                                  
#define TOUCHPAD_TK_LAYOUT2_KEY53                             0xB5                                                  
#define TOUCHPAD_TK_LAYOUT2_KEY54                             0xB6                                                  
#define TOUCHPAD_TK_LAYOUT2_KEY55                             0xB7                                                  
#define TOUCHPAD_TK_LAYOUT2_KEY56                             0xB8                                                  
#define TOUCHPAD_TK_LAYOUT2_KEY57                             0xB9                                                  
#define TOUCHPAD_TK_LAYOUT2_KEY58                             0xBA                                                  
#define TOUCHPAD_TK_LAYOUT2_KEY59                             0xBB                                                  
#define TOUCHPAD_TK_LAYOUT2_KEY60                             0xBC                                                  
#define TOUCHPAD_TK_LAYOUT2_KEY61                             0xBD                                                  
#define TOUCHPAD_TK_LAYOUT2_KEY62                             0xBE                                                  
#define TOUCHPAD_TK_LAYOUT2_KEY63                             0xBF                                                  
#define TOUCHPAD_TK_LAYOUT3_KEY0                              0xC0                                                  
#define TOUCHPAD_TK_LAYOUT3_KEY1                              0xC1                                                  
#define TOUCHPAD_TK_LAYOUT3_KEY2                              0xC2                                                  
#define TOUCHPAD_TK_LAYOUT3_KEY3                              0xC3                                                  
#define TOUCHPAD_TK_LAYOUT3_KEY4                              0xC4                                                  
#define TOUCHPAD_TK_LAYOUT3_KEY5                              0xC5                                                  
#define TOUCHPAD_TK_LAYOUT3_KEY6                              0xC6                                                  
#define TOUCHPAD_TK_LAYOUT3_KEY7                              0xC7                                                  
#define TOUCHPAD_TK_LAYOUT3_KEY8                              0xC8                                                  
#define TOUCHPAD_TK_LAYOUT3_KEY9                              0xC9                                                  
#define TOUCHPAD_TK_LAYOUT3_KEY10                             0xCA                                                  
#define TOUCHPAD_TK_LAYOUT3_KEY11                             0xCB                                                  
#define TOUCHPAD_TK_LAYOUT3_KEY12                             0xCC                                                  
#define TOUCHPAD_TK_LAYOUT3_KEY13                             0xCD                                                  
#define TOUCHPAD_TK_LAYOUT3_KEY14                             0xCE                                                  
#define TOUCHPAD_TK_LAYOUT3_KEY15                             0xCF                                                  
#define TOUCHPAD_TK_LAYOUT3_KEY16                             0xD0                                                  
#define TOUCHPAD_TK_LAYOUT3_KEY17                             0xD1                                                  
#define TOUCHPAD_TK_LAYOUT3_KEY18                             0xD2                                                  
#define TOUCHPAD_TK_LAYOUT3_KEY19                             0xD3                                                  
#define TOUCHPAD_TK_LAYOUT3_KEY20                             0xD4                                                  
#define TOUCHPAD_TK_LAYOUT3_KEY21                             0xD5                                                  
#define TOUCHPAD_TK_LAYOUT3_KEY22                             0xD6                                                  
#define TOUCHPAD_TK_LAYOUT3_KEY23                             0xD7                                                  
#define TOUCHPAD_TK_LAYOUT3_KEY24                             0xD8                                                  
#define TOUCHPAD_TK_LAYOUT3_KEY25                             0xD9                                                  
#define TOUCHPAD_TK_LAYOUT3_KEY26                             0xDA                                                  
#define TOUCHPAD_TK_LAYOUT3_KEY27                             0xDB                                                  
#define TOUCHPAD_TK_LAYOUT3_KEY28                             0xDC                                                  
#define TOUCHPAD_TK_LAYOUT3_KEY29                             0xDD                                                  
#define TOUCHPAD_TK_LAYOUT3_KEY30                             0xDE                                                  
#define TOUCHPAD_TK_LAYOUT3_KEY31                             0xDF                                                  
#define TOUCHPAD_TK_LAYOUT3_KEY32                             0xE0                                                  
#define TOUCHPAD_TK_LAYOUT3_KEY33                             0xE1                                                  
#define TOUCHPAD_TK_LAYOUT3_KEY34                             0xE2                                                  
#define TOUCHPAD_TK_LAYOUT3_KEY35                             0xE3                                                  
#define TOUCHPAD_TK_LAYOUT3_KEY36                             0xE4                                                  
#define TOUCHPAD_TK_LAYOUT3_KEY37                             0xE5                                                  
#define TOUCHPAD_TK_LAYOUT3_KEY38                             0xE6                                                  
#define TOUCHPAD_TK_LAYOUT3_KEY39                             0xE7                                                  
#define TOUCHPAD_TK_LAYOUT3_KEY40                             0xE8                                                  
#define TOUCHPAD_TK_LAYOUT3_KEY41                             0xE9                                                  
#define TOUCHPAD_TK_LAYOUT3_KEY42                             0xEA                                                  
#define TOUCHPAD_TK_LAYOUT3_KEY43                             0xEB                                                  
#define TOUCHPAD_TK_LAYOUT3_KEY44                             0xEC                                                  
#define TOUCHPAD_TK_LAYOUT3_KEY45                             0xED                                                  
#define TOUCHPAD_TK_LAYOUT3_KEY46                             0xEE                                                  
#define TOUCHPAD_TK_LAYOUT3_KEY47                             0xEF                                                  
#define TOUCHPAD_TK_LAYOUT3_KEY48                             0xF0                                                  
#define TOUCHPAD_TK_LAYOUT3_KEY49                             0xF1                                                  
#define TOUCHPAD_TK_LAYOUT3_KEY50                             0xF2                                                  
#define TOUCHPAD_TK_LAYOUT3_KEY51                             0xF3                                                  
#define TOUCHPAD_TK_LAYOUT3_KEY52                             0xF4                                                  
#define TOUCHPAD_TK_LAYOUT3_KEY53                             0xF5                                                  
#define TOUCHPAD_TK_LAYOUT3_KEY54                             0xF6                                                  
#define TOUCHPAD_TK_LAYOUT3_KEY55                             0xF7                                                  
#define TOUCHPAD_TK_LAYOUT3_KEY56                             0xF8                                                  
#define TOUCHPAD_TK_LAYOUT3_KEY57                             0xF9                                                  
#define TOUCHPAD_TK_LAYOUT3_KEY58                             0xFA                                                  
#define TOUCHPAD_TK_LAYOUT3_KEY59                             0xFB                                                  
#define TOUCHPAD_TK_LAYOUT3_KEY60                             0xFC                                                  
#define TOUCHPAD_TK_LAYOUT3_KEY61                             0xFD                                                  
#define TOUCHPAD_TK_LAYOUT3_KEY62                             0xFE                                                  
#define TOUCHPAD_TK_LAYOUT3_KEY63                             0xFF                                                  

//ConstantTable for TOUCHPAD_PEN_STATE
#define TOUCHPAD_PEN_PRESSED                                  0x00                                                     
#define TOUCHPAD_PEN_MOVED                                    0x01                                                     
#define TOUCHPAD_PEN_RELEASED                                 0x02                                                     

//ConstantTable for TOUCHPAD_KEY_STATUS
#define TOUCHPAD_TK_UP                                        0x00                                                     
#define TOUCHPAD_TK_DOWN                                      0x01                                                     

//ConstantTable for TOUCHPAD_RESULT
#define TOUCHPAD_CONFIG_OK                                    0x00                                                     
#define TOUCHPAD_CONFIG_INVALID_LAYOUT                        0x01                                                     

//ConstantTable for TOUCHPAD_LAYOUT
#define TOUCHPAD_TK_LAYOUT_NULL                               0xFF                                                  
#define TOUCHPAD_TK_LAYOUT_RESET                              0xFE                                                  
#define TOUCHPAD_TK_LAYOUT_PREVIOUS                           0xFD                                                  
#define TOUCHPAD_TK_LAYOUT_0                                  0x00                                                     
#define TOUCHPAD_TK_LAYOUT_1                                  0x01                                                     
#define TOUCHPAD_TK_LAYOUT_2                                  0x02                                                     
#define TOUCHPAD_TK_LAYOUT_3                                  0x03                                                     

//ConstantTable for TOUCHPAD_TEST_ACTION
#define TOUCHPAD_TEST_START                                   0x00                                                     
#define TOUCHPAD_TEST_RESULT_GET                              0x01                                                     
#define TOUCHPAD_TEST_STOP                                    0x02                                                     

//ConstantTable for TOUCHPAD_TEST_RESULT
#define TOUCHPAD_TEST_OK                                      0x00                                                     
#define TOUCHPAD_TEST_WRONG_ACTION                            0x01                                                     
#define TOUCHPAD_TEST_NOT_STARTED                             0x02                                                     
#define TOUCHPAD_TEST_ALREADY_STARTED                         0x03                                                     

//ConstantTable for TOUCHPAD_CALIBRATION_MODE
#define TOUCHPAD_CALIBRATION_MODE_NORMAL                      0x00                                                     
#define TOUCHPAD_CALIBRATION_MODE_RESET                       0x01                                                     

//ConstantTable for TOUCHPAD_CALIBRATION_STATUS
#define TOUCHPAD_CALIBRATION_OK                               0x00                                                     
#define TOUCHPAD_CALIBRATION_FAIL                             0x01                                                     

//ConstantTable for TOUCHPAD_PEN_EVENTS_ACTION
#define TOUCHPAD_PEN_EVENTS_STOP                              0x00                                                     
#define TOUCHPAD_PEN_EVENTS_START                             0x01                                                     

//ConstantTable for TOUCHPAD_PEN_EVENTS_STATUS
#define TOUCHPAD_PEN_EVENTS_OK                                0x00                                                     
#define TOUCHPAD_PEN_EVENTS_FAIL                              0x01                                                     

//ConstantTable for TOUCHPAD_COORDINATE_TYPE
#define TOUCHPAD_COORDINATE_TYPE_RAW                          0x01                                                     
#define TOUCHPAD_COORDINATE_TYPE_DISPLAY                      0x02                                                     
#define TOUCHPAD_COORDINATE_TYPE_ALL                          0x03                                                     

//ConstantTable for TOUCHPAD_DISPLAY_TOUCH_STATUS
#define TOUCHPAD_TOUCH_OFF_DISPLAY                            0x00                                                     
#define TOUCHPAD_TOUCH_ON_DISPLAY                             0x01                                                     

//ConstantTable for FtdTable
#define FTD_SB_TP_SERVER_VERSION                              0x10                                                  
#define FTD_SB_TP_SERVER_DATE                                 0x11                                                  
#define FTD_SB_TP_DRIVER_VERSION                              0x12                                                  
#define FTD_SB_TP_DRIVER_DATE                                 0x13                                                  
#define FTD_SB_TP_PEN_STATUS                                  0x14                                                  
#define FTD_SB_TP_PEN_X                                       0x15                                                  
#define FTD_SB_TP_PEN_Y                                       0x16                                                  
#define FTD_SB_TP_PEN_Z                                       0x17                                                  


//SUBBLOCKS


//Definition for struct TOUCHPAD_SB_PEN_STATE_INFO
#define TOUCHPAD_SB_PEN_STATE_INFO                            0x00                                                     
typedef struct
            { 
             uint8_t      sb_id;
             uint8_t      sb_len;
             uint16_t     x;
             uint16_t     y;
             uint8_t      pressure;
             uint8_t      state;
            } __attribute__((packed)) TOUCHPAD_SB_PEN_STATE_INFO_STR;
#define SIZE_TOUCHPAD_SB_PEN_STATE_INFO                       sizeof(TOUCHPAD_SB_PEN_STATE_INFO_STR)


//Definition for struct TOUCHPAD_SB_DISPLAY_COORDINATE_DATA
#define TOUCHPAD_SB_DISPLAY_COORDINATE_DATA                   0x04                                                     
typedef struct
            { 
             uint8_t      sb_id;
             uint8_t      sb_len;
             uint16_t     x;
             uint16_t     y;
             uint8_t      display_touch_status;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) TOUCHPAD_SB_DISPLAY_COORDINATE_DATA_STR;
#define SIZE_TOUCHPAD_SB_DISPLAY_COORDINATE_DATA              sizeof(TOUCHPAD_SB_DISPLAY_COORDINATE_DATA_STR)


//Definition for struct TOUCHPAD_SB_CONFIG_LAYOUT_INFO
#define TOUCHPAD_SB_CONFIG_LAYOUT_INFO                        0x01                                                     
typedef struct
            { 
             uint8_t      sb_id;
             uint8_t      sb_len;
             uint8_t      layout_id;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) TOUCHPAD_SB_CONFIG_LAYOUT_INFO_STR;
#define SIZE_TOUCHPAD_SB_CONFIG_LAYOUT_INFO                   sizeof(TOUCHPAD_SB_CONFIG_LAYOUT_INFO_STR)


//Definition for struct TOUCHPAD_SB_TEST_RESULT_INFO
#define TOUCHPAD_SB_TEST_RESULT_INFO                          0x02                                                     
typedef struct
            { 
             uint8_t      sb_id;
             uint8_t      sb_len;
             uint16_t     x;
             uint16_t     y;
             uint8_t      pressure;
             uint8_t      state;
             uint16_t     total_event_number;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) TOUCHPAD_SB_TEST_RESULT_INFO_STR;
#define SIZE_TOUCHPAD_SB_TEST_RESULT_INFO                     sizeof(TOUCHPAD_SB_TEST_RESULT_INFO_STR)


//Definition for struct TOUCHPAD_SB_CALIBRATION_DATA
#define TOUCHPAD_SB_CALIBRATION_DATA                          0x03                                                     
typedef struct
            { 
             uint8_t      sb_id;
             uint8_t      sb_len;
             uint8_t      mode;
             uint8_t      fillerbyte1;
             uint16_t     x1;
             uint16_t     y1;
             uint16_t     x2;
             uint16_t     y2;
             uint16_t     x3;
             uint16_t     y3;
            } __attribute__((packed)) TOUCHPAD_SB_CALIBRATION_DATA_STR;
#define SIZE_TOUCHPAD_SB_CALIBRATION_DATA                     sizeof(TOUCHPAD_SB_CALIBRATION_DATA_STR)


//MESSAGES


//Definition for struct TOUCHPAD_PRESSED_ISR_IND
#define TOUCHPAD_PRESSED_ISR_IND                              0x00                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) TOUCHPAD_PRESSED_ISR_IND_STR;
#define SIZE_TOUCHPAD_PRESSED_ISR_IND                         sizeof(TOUCHPAD_PRESSED_ISR_IND_STR)


//Definition for struct TOUCHPAD_PEN_EVENT_NTF
#define TOUCHPAD_PEN_EVENT_NTF                                0x01                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      num_of_sub_blocks;
            } __attribute__((packed)) TOUCHPAD_PEN_EVENT_NTF_STR;
#define SIZE_TOUCHPAD_PEN_EVENT_NTF                           sizeof(TOUCHPAD_PEN_EVENT_NTF_STR)


//Definition for struct TOUCHPAD_TK_EVENT_NTF
#define TOUCHPAD_TK_EVENT_NTF                                 0x02                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      touchkey_index;
             uint8_t      touchkey_state;
            } __attribute__((packed)) TOUCHPAD_TK_EVENT_NTF_STR;
#define SIZE_TOUCHPAD_TK_EVENT_NTF                            sizeof(TOUCHPAD_TK_EVENT_NTF_STR)


//Definition for struct TOUCHPAD_PEN_EVENT_REQ
#define TOUCHPAD_PEN_EVENT_REQ                                0x03                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) TOUCHPAD_PEN_EVENT_REQ_STR;
#define SIZE_TOUCHPAD_PEN_EVENT_REQ                           sizeof(TOUCHPAD_PEN_EVENT_REQ_STR)


//Definition for struct TOUCHPAD_PEN_EVENT_RESP
#define TOUCHPAD_PEN_EVENT_RESP                               0x04                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      num_of_sub_blocks;
            } __attribute__((packed)) TOUCHPAD_PEN_EVENT_RESP_STR;
#define SIZE_TOUCHPAD_PEN_EVENT_RESP                          sizeof(TOUCHPAD_PEN_EVENT_RESP_STR)


//Definition for struct TOUCHPAD_CONFIG_READ_REQ
#define TOUCHPAD_CONFIG_READ_REQ                              0x05                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) TOUCHPAD_CONFIG_READ_REQ_STR;
#define SIZE_TOUCHPAD_CONFIG_READ_REQ                         sizeof(TOUCHPAD_CONFIG_READ_REQ_STR)


//Definition for struct TOUCHPAD_CONFIG_READ_RESP
#define TOUCHPAD_CONFIG_READ_RESP                             0x06                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      result;
             uint8_t      num_of_sub_blocks;
            } __attribute__((packed)) TOUCHPAD_CONFIG_READ_RESP_STR;
#define SIZE_TOUCHPAD_CONFIG_READ_RESP                        sizeof(TOUCHPAD_CONFIG_READ_RESP_STR)


//Definition for struct TOUCHPAD_CONFIG_WRITE_REQ
#define TOUCHPAD_CONFIG_WRITE_REQ                             0x07                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      num_of_sub_blocks;
            } __attribute__((packed)) TOUCHPAD_CONFIG_WRITE_REQ_STR;
#define SIZE_TOUCHPAD_CONFIG_WRITE_REQ                        sizeof(TOUCHPAD_CONFIG_WRITE_REQ_STR)


//Definition for struct TOUCHPAD_CONFIG_WRITE_RESP
#define TOUCHPAD_CONFIG_WRITE_RESP                            0x08                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      result;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) TOUCHPAD_CONFIG_WRITE_RESP_STR;
#define SIZE_TOUCHPAD_CONFIG_WRITE_RESP                       sizeof(TOUCHPAD_CONFIG_WRITE_RESP_STR)


//Definition for struct TOUCHPAD_TEST_REQ
#define TOUCHPAD_TEST_REQ                                     0x09                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      action;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) TOUCHPAD_TEST_REQ_STR;
#define SIZE_TOUCHPAD_TEST_REQ                                sizeof(TOUCHPAD_TEST_REQ_STR)


//Definition for struct TOUCHPAD_TEST_RESP
#define TOUCHPAD_TEST_RESP                                    0x0A                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      result;
             uint8_t      num_of_sub_blocks;
            } __attribute__((packed)) TOUCHPAD_TEST_RESP_STR;
#define SIZE_TOUCHPAD_TEST_RESP                               sizeof(TOUCHPAD_TEST_RESP_STR)


//Definition for struct TOUCHPAD_CALIBRATION_WRITE_REQ
#define TOUCHPAD_CALIBRATION_WRITE_REQ                        0x0B                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      num_of_sub_blocks;
            } __attribute__((packed)) TOUCHPAD_CALIBRATION_WRITE_REQ_STR;
#define SIZE_TOUCHPAD_CALIBRATION_WRITE_REQ                   sizeof(TOUCHPAD_CALIBRATION_WRITE_REQ_STR)


//Definition for struct TOUCHPAD_CALIBRATION_WRITE_RESP
#define TOUCHPAD_CALIBRATION_WRITE_RESP                       0x0C                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) TOUCHPAD_CALIBRATION_WRITE_RESP_STR;
#define SIZE_TOUCHPAD_CALIBRATION_WRITE_RESP                  sizeof(TOUCHPAD_CALIBRATION_WRITE_RESP_STR)


//Definition for struct TOUCHPAD_PEN_EVENTS_REQ
#define TOUCHPAD_PEN_EVENTS_REQ                               0x0D                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      action;
             uint8_t      coordinate_type;
            } __attribute__((packed)) TOUCHPAD_PEN_EVENTS_REQ_STR;
#define SIZE_TOUCHPAD_PEN_EVENTS_REQ                          sizeof(TOUCHPAD_PEN_EVENTS_REQ_STR)


//Definition for struct TOUCHPAD_PEN_EVENTS_RESP
#define TOUCHPAD_PEN_EVENTS_RESP                              0x0E                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      action;
            } __attribute__((packed)) TOUCHPAD_PEN_EVENTS_RESP_STR;
#define SIZE_TOUCHPAD_PEN_EVENTS_RESP                         sizeof(TOUCHPAD_PEN_EVENTS_RESP_STR)

#endif
