#ifndef _PN_LOCATION_ISI_H_
#define _PN_LOCATION_ISI_H_

#include <stdint.h> 

//Resource Location Server
//PN_LOCATION 0x54 
//ISI version 036.002
#define LOCATION_SERVER_ISI_VERSION_Z     36
#define LOCATION_SERVER_ISI_VERSION_Y     2

//In case of problems concerning content of this file contact Henrik Ala-Uotila
//Server specific message descriptions and feature&protocol descriptions can be found from: https://oucmswww.nmp.nokia.com:58443/document_browser/ccm_wa/GIF_SPECS/ 


//ISI VERSION CHANGE HISTORY

//Version: 036.002                                           
//Status: Approved                                          
//Date: 25-Sep-2008     Troels Riis
//Reason: SWAM CR: TR08092229668
//Reference: SWAM Inspection: TR08092230747, APPROVED

//Version: 036.001                                           
//Status: Approved                                          
//Date: 25-Aug-2008     Jens Schwarzer
//Reason: SWAM CR: JS08082127303
//Reference: SWAM Inspection: JS08082133130, APPROVED

//Version: 036.000                                           
//Status: Approved                                          
//Date: 25-Jun-2008     Jens Schwarzer
//Reason: Correction
//Reference: PCP Error Item: TK08062544513, APPROVED

//Version: 035.001                                           
//Status: Approved                                          
//Date: 16-Jun-2008     Anders Jorgensen
//Reason: SWAM CR: AJ08050686659
//Reference: SWAM Inspection: AJ08050647631, APPROVED

//Version: 035.000                                           
//Status: Unknown                                           
//Date: 06-Mar-2008     Jan Sundgaard Nielsen
//Reason: SWAM CR: JN08030553605
//Reference: SWAM Inspection: JN08030554423, Ready for Inspection

//Version: 034.000                                           
//Status: Approved                                          
//Date: 17-Jan-2008     Jesper Sandberg
//Reason: SWAM CR: JS08011825937
//Reference: SWAM Inspection: JS08011826900, APPROVED

//Version: 033.001                                           
//Status: Approved                                          
//Date: 04-Jan-2008     Anders Jorgensen
//Reason: SWAM CR: AJ07112749653
//Reference: SWAM Inspection: AJ07112839390, APPROVED

//Version: 033.000                                           
//Status: Approved                                          
//Date: 14-Aug-2007     Jens Schwarzer
//Reason: SWAM CR: JS07072645613
//Reference: SWAM Inspection: JS07072650336, APPROVED

//Version: 032.000                                           
//Status: Approved                                          
//Date: 06-Jun-2007     Jens Schwarzer
//Reason: SWAM CR: JS07060442905
//Reference: SWAM Inspection: JS07060443088, APPROVED

//Version: 031.013                                           
//Status: Approved                                          
//Date: 12-Feb-2007     Jens Schwarzer
//Reason: SWAM CR: JS07021247655
//Reference: SWAM Inspection: JS07021249476, APPROVED

//Version: 031.012                                           
//Status: Approved                                          
//Date: 09-Oct-2006     Jens Schwarzer
//Reason: CR in ADB for SWAM : JS06100947617
//Reference: ADB for SWAM : Inspection done in CR, APPROVED

//Version: 031.011                                           
//Status: Approved                                          
//Date: 24-May-2006     Jens Schwarzer
//Reason: CR in ADB for SWAM : JS06052345402
//Reference: ADB for SWAM : JS06052348295, APPROVED

//Version: 031.010                                           
//Status: Approved                                          
//Date: 25-Apr-2006     Jesper Sandberg
//Reason: CR in ADB for SWAM : JS06042533064
//Reference: ADB for SWAM : Inspection done in CR, APPROVED

//Version: 031.009                                           
//Status: Approved                                          
//Date: 11-Apr-2006     Jesper Sandberg
//Reason: CR in ADB for SWAM : JS06041151584
//Reference: ADB for SWAM : Inspection done in CR, APPROVED

//Version: 031.008                                           
//Status: Approved                                          
//Date: 04-Apr-2006     Troels Riis
//Reason: CR in ADB for SWAM : TR06033044277
//Reference: ADB for SWAM : Inspection done in CR, APPROVED

//Version: 031.007                                           
//Status: Approved                                          
//Date: 21-Mar-2006     Troels Riis
//Reason: CR in ADB for SWAM : TR06030238235
//Reference: ADB for SWAM : TR06030239500, APPROVED

//Version: 031.006                                           
//Status: Approved                                          
//Date: 20-Jan-2006     Jens Schwarzer/Jesper Sandberg/Troels Riis
//Reason: CR in ADB for SWAM : JS06011746439
//Reference: Action DB for SWAM : JS06011746133, APPROVED

//Version: 031.005                                           
//Status: Approved                                          
//Date: 29-Nov-2005     Troels Riis
//Reason: CR in ADB for SWAM : 1) TR05111439832 and 2) TR05112340386
//Reference: ADB for SWAM : TR05111444764, APPROVED

//Version: 031.004                                           
//Status: Approved                                          
//Date: 31-Oct-2005     Troels Riis
//Reason: CR in ADB for SWAM : TR05101846476
//Reference: ADB for SWAM : TR05101851055, APPROVED

//Version: 031.003                                           
//Status: Proposal                                          
//Date: 18-Oct-2005     Troels Riis
//Reason: CR in ADB for SWAM : TR05101846476
//Reference: ADB for SWAM : TR05101851055, PROPOSAL

//Version: 031.002                                           
//Status: Approved                                          
//Date: 13-Jul-2005     Jesper Sandberg
//Reason: CR in ADB for SWAM : JS05071441636
//Reference: ADB for SWAM : JS05071549024, APPROVED

//Version: 031.001                                           
//Status: Approved                                          
//Date: 30-May-2005     Jesper Sandberg
//Reason: CR in ADB for SWAM : JS05051954522
//Reference: ADB for SWAM JS05052044536, APPROVED

//Version: 031.000                                           
//Status: Approved                                          
//Date: 20-January-2005 Jens Schwarzer
//Reason: Support for Brew 3.1, MPC exceptions and MidLet Id
//Reference: Action DB for SWAM JS04122143089, APPROVED

//Version: 030.014                                           
//Status: Proposal                                          
//Date: 13-January-2005 Jens Schwarzer
//Reason: Support for Brew 3.1, MPC exceptions and MidLet Id
//Reference: Action DB for SWAM JS04122143089, PROPOSAL

//Version: 030.013                                           
//Status: Proposal                                          
//Date: 21-December-2004 Jens Schwarzer
//Reason: Support for Brew 3.1, MPC exceptions and MidLet Id
//Reference: Action DB for SWAM JS04122143089, PROPOSAL

//Version: 030.012                                           
//Status: Approved                                          
//Date: 16-September-2004 Jens Schwarzer
//Reason: New subblocks for identification of Brew and Java clients (plus some minor adjustments)
//Reference: Action DB for SWAM JS04071655805, APPROVED

//Version: 030.011                                           
//Status: Proposal                                          
//Date: 16-Jul-2004     Jens Schwarzer
//Reason: New subblocks for identification of Brew and Java clients (plus some minor adjustments)
//Reference: Action DB for SWAM JS04071655805, PROPOSAL

//Version: 030.010                                           
//Status: Approved                                          
//Date: 30-Jun-2004     Jens Schwarzer
//Reason: When GSM MT-LR fails report what GPS Assistance Data are needed in order to succeed (plus some minor adjustments)
//Reference: Action DB for SWAM JS04061836059, APPROVED

//Version: 030.009                                           
//Status: Proposal                                          
//Date: 18-Jun-2004     Jens Schwarzer
//Reason: When GSM MT-LR fails report what GPS Assistance Data are needed in order to succeed (plus some minor adjustments)
//Reference: Action DB for SWAM JS04061836059, PROPOSAL

//Version: 030.008                                           
//Status: Approved                                          
//Date: 24-Feb-2004     Jens Schwarzer
//Reason: Support for Accurate Time Transfer in GSM and made it possible to delete assistance data in LTM during R&D phases (finalized)
//Reference: Action DB for SWAM JS04021134267, APPROVED

//Version: 030.007                                           
//Status: Proposal                                          
//Date: 11-Feb-2004     Jens Schwarzer
//Reason: Support for Accurate Time Transfer in GSM and made it possible to delete assistance data in LTM during R&D phases
//Reference: Action DB for SWAM JS04021134267, PROPOSAL

//Version: 030.006                                           
//Status: Approved                                          
//Date: 04-Feb-2004     Jens Schwarzer
//Reason: Support for AGPS in GSM and minor adjustments (finalized)
//Reference: Action DB for SWAM JS04010960589, APPROVED

//Version: 030.005                                           
//Status: Proposal                                          
//Date: 30-Jan-2004     Jens Schwarzer
//Reason: Support for AGPS in GSM and minor adjustments (continued)
//Reference: Action DB for SWAM JS04010960589, PROPOSAL

//Version: 030.004                                           
//Status: Proposal                                          
//Date: 12-Jan-2004     Jens Schwarzer
//Reason: Support for AGPS in GSM and minor adjustments
//Reference: Action DB for SWAM JS04010960589, PROPOSAL

//Version: 030.002                                           
//Status: Approved                                          
//Date: 13-Oct-2003     Jens Schwarzer
//Reason: Minor adjustments (finalized)
//Reference: Action DB for SWAM JS03100260296, APPROVED

//Version: 030.001                                           
//Status: Proposal                                          
//Date: 02-Oct-2003     Jens Schwarzer
//Reason: Minor adjustments
//Reference: Action DB for SWAM JS03100260296, PROPOSAL

//Version: 030.000                                           
//Status: Approved                                          
//Date: 01-Sep-2003     Jens Schwarzer
//Reason: Major rework (finalized)
//Reference: Action DB for SWAM JS03070849056, APPROVED

//Version: 029.002                                           
//Status: Proposal                                          
//Date: 25-Aug-2003     Jens Schwarzer
//Reason: Major rework (continued)
//Reference: Action DB for SWAM JS03070849056, PROPOSAL

//Version: 029.001                                           
//Status: Proposal                                          
//Date: 18-Jul-2003     Jens Schwarzer
//Reason: Major rework: Navigator 1.5, Standalone GPS, JSR-179 and Symbian update of API, Privacy update
//Reference: Action DB for SWAM JS03070849056, PROPOSAL

//Version: 029.000                                           
//Status: Approved                                          
//Date: 05-Mar-2003     Jens Schwarzer
//Reason: Removal of old API
//Reference: Action DB for SWAM HJ03022651338, APPROVED


//CONSTANTS
#define LS_NPE_NOT_AVAILABLE_32                               0xFFFFFFFF                                            
#define LS_NPE_NOT_AVAILABLE_16                               0xFFFF                                                
#define LS_NPE_NOT_AVAILABLE_8                                0xFF                                                  
#define LS_NPE_NOT_AVAILABLE_N32                              0x80000000                                            
#define LS_NPE_NOT_AVAILABLE_N16                              0x8000                                                
#define LS_NPE_NOT_AVAILABLE_N8                               0x80                                                  
#define LS_NPE_NOT_AVAILABLE_32M                              0x7FFFFFFF                                            
#define LS_NPE_NOT_AVAILABLE_16M                              0x7FFF                                                
#define LS_NPE_NOT_AVAILABLE_8M                               0x7F                                                  
#define LOCATION_ANY_SIZE                                     1                                                     
#define LS_NO_UTC_TIME                                        0x00                                                     
#define LS_NO_GPS_TIME                                        0xFFFF                                                
#define LS_NOT_AVAILABLE                                      0xFFFF                                                
#define LS_NOT_COMPUTED                                       -32768                                                
#define LS_MAX_SAT_AMOUNT                                     0x40                                                  
#define LS_MAX_CHANNNEL_AMOUNT                                0x20                                                  
#define LS_GSM_UNDEFINED_ACCURACY                             0xFF                                                  
#define LS_NO_REF_FRAME                                       0xFFFF                                                
#define LS_MAX_MEAS_AMOUNT                                    0x10                                                  
#define LS_MAX_MEAS_SET_COUNT                                 0x03                                                     
#define LS_ABSENT                                             0xFF                                                  
#define LS_UNDEFINED_GPS_TOW                                  0xFFFFFFFF                                            
#define LS_GSM_NO_ASSISTANCE_NEEDED                           0x00                                                     
#define LS_MAX_CLIENT_EXT_ID_BYTES                            0x14                                                  
#define LS_MAX_USSD_LEN                                       0x48                                                  
#define LS_WCDMA_UNDEFINED_ACCURACY                           0xFF                                                  
#define LS_ALL_SVS                                            0xFF                                                  
#define LS_SS_MAX_REQUESTOR_ID_LEN                            0x48                                                  
#define LS_SS_MAX_CODEWORD_LEN                                0x16                                                  
#define LS_JAVA_UNIQUE_ID_LEN                                 0x15                                                  
#define LS_INFINITE                                           0x00                                                     
#define LS_UNDEFINED                                          0x00                                                     
#define LS_NO_INFORMATION                                     0xFFFFFFFF                                            
#define LS_SUPL_POS_MAX_LENGTH                                0x07D0                                                   
#define LS_SUPL_MAX_ID                                        0xFFFFFFFF                                            
#define LS_MAX_HYBRID_CLIENT_LEN                              0x50                                                  
#define LS_NPE_TIME_UNKNOWN                                   0x00                                                     
#define CLMI_UMTS_SFN_UNKNOWN                                 0xFFFF                                                
#define CLMI_UMTS_DRIFT_UNKNOWN                               0x80                                                  
#define CLMI_GSM_DRIFT_UNKNOWN                                0x80                                                  
#define LS_UMTS_UNDEFINED_RTT                                 0xFFFF                                                


//TABLES

//ConstantTable for LS_SUPL_ALLOWED_SETTING
#define LS_SUPL_ALLOWED_YES                                   0x00                                                     
#define LS_SUPL_ALLOWED_NO                                    0x01                                                     
#define LS_SUPL_ALLOWED_NOT_ROAMING                           0x02                                                     

//BitmaskTables for LS_GPS_SUPPORT
#define LS_GPS_SUPPORT_BLUETOOTH                              0x01                                                     
#define LS_GPS_SUPPORT_INTERNAL_STANDALONE_ONLY               0x02                                                     
#define LS_GPS_SUPPORT_INTERNAL_AGPS_SUPL                     0x04                                                     

//ConstantTable for LS_SOCKET_ADDRTYPE
#define LS_SOCKET_IPV4                                        0x00                                                     
#define LS_SOCKET_IPV6                                        0x01                                                     
#define LS_SOCKET_ALPHA                                       0x02                                                     

//ConstantTable for LS_SOCKET_USE_TCP
#define LS_SOCKET_USE_TCP_NO                                  0x00                                                     
#define LS_SOCKET_USE_TCP_YES                                 0x01                                                     

//ConstantTable for LS_SOCKET_STATUS
#define LS_SOCKET_STATUS_OK                                   0x00                                                     
#define LS_SOCKET_STATUS_ERROR                                0x01                                                     
#define LS_SOCKET_STATUS_SERVER_NOT_AUTHENTICATED             0x02                                                     

//ConstantTable for LS_SOCKET_BEARER_TYPES
#define LS_SOCKET_BEARER_GPRS                                 0x02                                                     
#define LS_SOCKET_BEARER_WLAN                                 0x40                                                  

//BitmaskTables for LS_STATUSES
#define LS_OK                                                 0x01                                                     
#define LS_FAIL                                               0x00                                                     
#define LS_COMPLETE                                           0x20                                                  
#define LS_ONGOING                                            0x00                                                     
#define LS_FIX                                                0x40                                                  
#define LS_INFO                                               0x00                                                     
#define LS_MEAS_FIX                                           0x80                                                  
#define LS_MEAS_INFO                                          0x00                                                     

//BitmaskTables for LS_STATUSES_OK_FAIL
//#define LS_OK                                               0x00                        //Already defined as 0x01
//#define LS_FAIL                                             0x00                        //Already defined as 0x00

//BitmaskTables for LS_STATUSES_OK_FAIL_PRIVACY_MULTIFIX
//#define LS_OK                                               0x00                        //Already defined as 0x01
//#define LS_FAIL                                             0x00                        //Already defined as 0x00

//BitmaskTables for LS_STATUSES_OK_FAIL_PRIVACY
//#define LS_OK                                               0x00                        //Already defined as 0x01
//#define LS_FAIL                                             0x00                        //Already defined as 0x00

//BitmaskTables for LS_STATUSES_API_NTF
//#define LS_OK                                               0x00                        //Already defined as 0x01
//#define LS_FAIL                                             0x00                        //Already defined as 0x00
//#define LS_COMPLETE                                         0x00                        //Already defined as 0x020
//#define LS_ONGOING                                          0x00                        //Already defined as 0x00
//#define LS_FIX                                              0x00                        //Already defined as 0x040
//#define LS_INFO                                             0x00                        //Already defined as 0x00

//BitmaskTables for LS_STATUSES_HYBRID_NTF
//#define LS_OK                                               0x00                        //Already defined as 0x01
//#define LS_FAIL                                             0x00                        //Already defined as 0x00
//#define LS_COMPLETE                                         0x00                        //Already defined as 0x020
//#define LS_ONGOING                                          0x00                        //Already defined as 0x00

//BitmaskTables for LS_STATUSES_CLMI_NTF
//#define LS_OK                                               0x00                        //Already defined as 0x01
//#define LS_FAIL                                             0x00                        //Already defined as 0x00
//#define LS_COMPLETE                                         0x00                        //Already defined as 0x020
//#define LS_ONGOING                                          0x00                        //Already defined as 0x00
//#define LS_FIX                                              0x00                        //Already defined as 0x040
//#define LS_INFO                                             0x00                        //Already defined as 0x00
//#define LS_MEAS_FIX                                         0x00                        //Already defined as 0x080
//#define LS_MEAS_INFO                                        0x00                        //Already defined as 0x00

//ConstantTable for LS_STATUSES_GSM_PRIVACY
#define LS_STATUS_OK                                          0x00                                                     
#define LS_STATUS_FAIL                                        0x01                                                     

//ConstantTable for LS_METHODS
#define LS_ANY_METHOD                                         0x00                                                     
#define LS_NW_SELECTED                                        0x01                                                     
#define LS_MS_ASSISTED_AGPS                                   0x10                                                  
#define LS_MS_BASED_AGPS                                      0x11                                                  
#define LS_STANDALONE_GPS                                     0x12                                                  
#define LS_BLUETOOTH_GPS                                      0x13                                                  

//ConstantTable for LS_PRIVACY_NTF_TYPE
#define LS_NOTIFICATION_INFORMATION                           0x00                                                     
#define LS_NOTIFICATION_VERIFICATION                          0x01                                                     
#define LS_NOTIFICATION_TIMEOUT                               0x04                                                     

//ConstantTable for LS_PRIVACY_REGISTRATION_STATUS
#define LS_PRIVACY_REGISTRATION_OK                            0x00                                                     
#define LS_PRIVACY_REGISTRATION_FAIL                          0x01                                                     

//ConstantTable for LS_NOTIFICATION_STATUS
#define LS_NOTIFICATION_STATUS_OK                             0x00                                                     
#define LS_NOTIFICATION_STATUS_FAIL                           0x01                                                     
#define LS_NOTIFICATION_STATUS_TIMEOUT                        0x02                                                     

//ConstantTable for LS_LTM_TEST_STATUS
#define LS_LTM_TEST_ACCEPTED                                  0x00                                                     
#define LS_LTM_TEST_REJECTED                                  0x01                                                     
#define LS_LTM_TEST_ABORTED                                   0x02                                                     
#define LS_LTM_TEST_PASSED                                    0x03                                                     
#define LS_LTM_TEST_FAILED                                    0x04                                                     
#define LS_LTM_TEST_INTERMEDIATE_RESULT                       0x05                                                     
#define LS_LTM_TEST_ERROR_IN_REQ                              0x06                                                     
#define LS_LTM_TEST_NOT_REGISTERED                            0x07                                                     

//ConstantTable for LS_LOCATION_TYPE
#define LS_LOCATION_TYPE_CURRENT                              0x00                                                     
#define LS_LOCATION_TYPE_CURRENTORLAST                        0x01                                                     
#define LS_LOCATION_TYPE_INITIAL                              0x02                                                     

//ConstantTable for LS_NOTIFICATION_TYPE
//#define LS_NOTIFICATION_INFORMATION                         0x00                        //Already defined as 0x00
//#define LS_NOTIFICATION_VERIFICATION                        0x01                        //Already defined as 0x01

//ConstantTable for LS_NOTIFICATION_RESULT
#define LS_NOTIFICATION_REJECTED                              0x00                                                     
#define LS_NOTIFICATION_ACCEPTED                              0x01                                                     

//ConstantTable for LS_GSM_NB_ID_PRESENCE

//ConstantTable for LS_GSM_REF_CELL_ID_TYPE

//ConstantTable for LS_GSM_NB_CELL_ID_TYPE

//ConstantTable for LS_GSM_EOTD_MEAS_NBR

//ConstantTable for LS_GSM_STD_RESOLUTION

//ConstantTable for LS_GSM_REF_BTS_RELATION
#define LS_GSM_REF1_TO_12_AND_2_TO_3                          0x00                                                     
#define LS_GSM_REF1_TO_13_AND_2_TO_2                          0x01                                                     
#define LS_GSM_REF1_TO_1_AND_2_TO_23                          0x02                                                     
#define LS_GSM_DIRECT_RELATION                                0xFF                                                  

//ConstantTable for LS_GSM_LOCATION_ERROR
#define LS_GSM_UNDEFINED_ERROR                                0x00                                                     
#define LS_GSM_EOTD_NOT_ENOUGH_BTS                            0x01                                                     
#define LS_GSM_GPS_NOT_ENOUGH_SATS                            0x02                                                     
#define LS_GSM_EOTD_LC_ASTNC_MSNG                             0x03                                                     
#define LS_GSM_EOTD_ASTNC_MSNG                                0x04                                                     
#define LS_GSM_GPS_LOC_CALC_ASTNC_MSNG                        0x05                                                     
#define LS_GSM_GPS_ASTNC_MSNG                                 0x06                                                     
#define LS_GSM_UNSUPPORTED_METHOD                             0x07                                                     
#define LS_GSM_NOT_PROCESSED                                  0x08                                                     
#define LS_GSM_GPS_REF_BTS_NOT_SERV_BTS                       0x09                                                     
#define LS_GSM_EOTD_REF_BTS_NOT_SERV_BTS                      0x0A                                                     
#define LS_GSM_MSMNTS_TERM_AO_RRPR                            0xFE                                                  
#define LS_GSM_MSMNTS_TERM_AO_REQ                             0xFF                                                  

//ConstantTable for LS_GSM_GAD_SHAPE_TYPE

//ConstantTable for LS_GSM_FIX_TYPE
#define LS_GSM_FIX_TYPE_2D                                    0x00                                                     
#define LS_GSM_FIX_TYPE_3D                                    0x01                                                     

//ConstantTable for LS_GSM_METHOD_TYPE
#define LS_GSM_ASSISTED_METHOD                                0x00                                                     
#define LS_GSM_BASED_METHOD                                   0x01                                                     
#define LS_GSM_BASED_PREFERRED_METHOD                         0x02                                                     
#define LS_GSM_ASSISTED_PREFERRED_METHOD                      0x03                                                     

//ConstantTable for LS_GSM_POSITIONING_METHOD
#define LS_GSM_EOTD_METHOD                                    0x00                                                     
#define LS_GSM_GPS_METHOD                                     0x01                                                     
#define LS_GSM_EOTD_OR_GPS_METHOD                             0x02                                                     

//ConstantTable for LS_WCDMA_METHOD_TYPE
#define LS_WCDMA_ASSISTED_METHOD                              0x00                                                     
#define LS_WCDMA_BASED_METHOD                                 0x01                                                     
#define LS_WCDMA_BASED_PREFERRED_METHOD                       0x02                                                     
#define LS_WCDMA_ASSISTED_PREFERRED_METHOD                    0x03                                                     

//ConstantTable for LS_WCDMA_REPORTING_QUANTITY
#define LS_WCDMA_QUANTITY_R_1                                 0x00                                                     
#define LS_WCDMA_QUANTITY_R_2                                 0x01                                                     
#define LS_WCDMA_QUANTITY_R_4                                 0x02                                                     
#define LS_WCDMA_QUANTITY_R_8                                 0x03                                                     
#define LS_WCDMA_QUANTITY_R_16                                0x04                                                     
#define LS_WCDMA_QUANTITY_R_32                                0x05                                                     
#define LS_WCDMA_QUANTITY_R_64                                0x06                                                     
#define LS_WCDMA_QUANTITY_R_INFINITY                          0x07                                                     

//ConstantTable for LS_WCDMA_REPORTING_INTERVAL
#define LS_WCDMA_INTERVAL_RIL_0                               0x00                                                     
#define LS_WCDMA_INTERVAL_RIL_0_25                            0x01                                                     
#define LS_WCDMA_INTERVAL_RIL_0_50                            0x02                                                     
#define LS_WCDMA_INTERVAL_RIL_1                               0x03                                                     
#define LS_WCDMA_INTERVAL_RIL_2                               0x04                                                     
#define LS_WCDMA_INTERVAL_RIL_3                               0x05                                                     
#define LS_WCDMA_INTERVAL_RIL_4                               0x06                                                     
#define LS_WCDMA_INTERVAL_RIL_6                               0x07                                                     
#define LS_WCDMA_INTERVAL_RIL_8                               0x08                                                     
#define LS_WCDMA_INTERVAL_RIL_12                              0x09                                                     
#define LS_WCDMA_INTERVAL_RIL_16                              0x0A                                                     
#define LS_WCDMA_INTERVAL_RIL_20                              0x0B                                                     
#define LS_WCDMA_INTERVAL_RIL_24                              0x0C                                                     
#define LS_WCDMA_INTERVAL_RIL_28                              0x0D                                                     
#define LS_WCDMA_INTERVAL_RIL_32                              0x0E                                                     
#define LS_WCDMA_INTERVAL_RIL_64                              0x0F                                                     

//ConstantTable for LS_WCDMA_MEASUREMENT_INTERVAL
#define LS_WCDMA_INTERVAL_E5                                  0x00                                                     
#define LS_WCDMA_INTERVAL_E15                                 0x01                                                     
#define LS_WCDMA_INTERVAL_E60                                 0x02                                                     
#define LS_WCDMA_INTERVAL_E300                                0x03                                                     
#define LS_WCDMA_INTERVAL_E900                                0x04                                                     
#define LS_WCDMA_INTERVAL_E1800                               0x05                                                     
#define LS_WCDMA_INTERVAL_E3600                               0x06                                                     
#define LS_WCDMA_INTERVAL_E7200                               0x07                                                     

//ConstantTable for LS_WCDMA_7A_THRESHHOLD
#define LS_WCDMA_7A_PC10                                      0x00                                                     
#define LS_WCDMA_7A_PC20                                      0x01                                                     
#define LS_WCDMA_7A_PC30                                      0x02                                                     
#define LS_WCDMA_7A_PC40                                      0x03                                                     
#define LS_WCDMA_7A_PC50                                      0x04                                                     
#define LS_WCDMA_7A_PC100                                     0x05                                                     
#define LS_WCDMA_7A_PC200                                     0x06                                                     
#define LS_WCDMA_7A_PC300                                     0x07                                                     
#define LS_WCDMA_7A_PC500                                     0x08                                                     
#define LS_WCDMA_7A_PC1000                                    0x09                                                     
#define LS_WCDMA_7A_PC2000                                    0x0A                                                     
#define LS_WCDMA_7A_PC5000                                    0x0B                                                     
#define LS_WCDMA_7A_PC10000                                   0x0C                                                     
#define LS_WCDMA_7A_PC20000                                   0x0D                                                     
#define LS_WCDMA_7A_PC50000                                   0x0E                                                     
#define LS_WCDMA_7A_PC100000                                  0x0F                                                     

//ConstantTable for LS_WCDMA_7B_THRESHHOLD
#define LS_WCDMA_7B_C0_25                                     0x00                                                     
#define LS_WCDMA_7B_C0_5                                      0x01                                                     
#define LS_WCDMA_7B_C1                                        0x02                                                     
#define LS_WCDMA_7B_C2                                        0x03                                                     
#define LS_WCDMA_7B_C3                                        0x04                                                     
#define LS_WCDMA_7B_C4                                        0x05                                                     
#define LS_WCDMA_7B_C5                                        0x06                                                     
#define LS_WCDMA_7B_C10                                       0x07                                                     
#define LS_WCDMA_7B_C20                                       0x08                                                     
#define LS_WCDMA_7B_C50                                       0x09                                                     
#define LS_WCDMA_7B_C100                                      0x0A                                                     
#define LS_WCDMA_7B_C200                                      0x0B                                                     
#define LS_WCDMA_7B_C500                                      0x0C                                                     
#define LS_WCDMA_7B_C1000                                     0x0D                                                     
#define LS_WCDMA_7B_C2000                                     0x0E                                                     
#define LS_WCDMA_7B_C5000                                     0x0F                                                     

//ConstantTable for LS_WCDMA_7C_THRESHHOLD
#define LS_WCDMA_7C_MS1                                       0x00                                                     
#define LS_WCDMA_7C_MS2                                       0x01                                                     
#define LS_WCDMA_7C_MS3                                       0x02                                                     
#define LS_WCDMA_7C_MS5                                       0x03                                                     
#define LS_WCDMA_7C_MS10                                      0x04                                                     
#define LS_WCDMA_7C_MS20                                      0x05                                                     
#define LS_WCDMA_7C_MS50                                      0x06                                                     
#define LS_WCDMA_7C_MS100                                     0x07                                                     

//ConstantTable for LS_WCDMA_MEASUREMENT_COMMAND
#define LS_WCDMA_MEAS_SETUP                                   0x00                                                     
#define LS_WCDMA_MEAS_MODIFY                                  0x01                                                     
#define LS_WCDMA_MEAS_RELEASE                                 0x02                                                     

//ConstantTable for LS_WCDMA_POSITIONING_METHOD
#define LS_WCDMA_OTDOA_METHOD                                 0x00                                                     
#define LS_WCDMA_GPS_METHOD                                   0x01                                                     
#define LS_WCDMA_OTDOA_OR_GPS_METHOD                          0x02                                                     
#define LS_WCDMA_CELLID                                       0x03                                                     

//ConstantTable for LS_WCDMA_REF_TIME_TYPE
#define LS_WCDMA_UTRAN_GPS_REF_TIME                           0x00                                                     
#define LS_WCDMA_GPS_REF_TIME_ONLY                            0x01                                                     
#define LS_WCDMA_CELL_TIMING                                  0x02                                                     

//ConstantTable for LS_WCDMA_LATITUDE_SIGN
#define LS_WCDMA_NORTH                                        0x00                                                     
#define LS_WCDMA_SOUTH                                        0x01                                                     

//ConstantTable for LS_WCDMA_ALTITUDE_DIRECTION
#define LS_WCDMA_HEIGHT                                       0x00                                                     
#define LS_WCDMA_DEPTH                                        0x01                                                     

//ConstantTable for LS_WCDMA_POSITION_TYPE
#define LS_WCDMA_POINT                                        0x00                                                     
#define LS_WCDMA_POINT_UNCER_CIRCLE                           0x01                                                     
#define LS_WCDMA_POINT_UNCERT_ELLIPSE                         0x02                                                     
#define LS_WCDMA_POINT_ALTITUDE                               0x03                                                     
#define LS_WCDMA_POINT_ALTITUDE_UNCERT                        0x04                                                     

//ConstantTable for LS_GSM_MULTIPLE_SETS
#define LS_GSM_MULTIPLE_SETS                                  0x00                                                     
#define LS_GSM_NO_MULTIPLE_SETS                               0x01                                                     

//ConstantTable for LS_GSM_ENV_CHARACTER
#define LS_GSM_HEAVY_MP_AND_NLOS                              0x00                                                     
#define LS_GSM_LIGHT_MP_AND_LOS                               0x01                                                     
#define LS_GSM_MIXED_OR_UNDEFINED_ENV                         0x02                                                     
#define LS_GSM_UNDEFINED_ENV_FIELD                            0xFF                                                  

//ConstantTable for LS_WCDMA_ENV_CHARACTER
#define LS_WCDMA_HEAVY_MP_AND_NLOS                            0x00                                                     
#define LS_WCDMA_LIGHT_MP_AND_LOS                             0x01                                                     
#define LS_WCDMA_MIXED_OR_UNDEFINED_ENV                       0x02                                                     
#define LS_WCDMA_UNDEFINED_ENV_FIELD                          0xFF                                                  

//ConstantTable for LS_GSM_NBR_PLAN
#define LS_GSM_NBR_PLAN_UNKNOWN                               0x00                                                     
#define LS_GSM_NBR_PLAN_ISDN_TELEPHONY                        0x01                                                     
#define LS_GSM_NBR_PLAN_DATA                                  0x03                                                     
#define LS_GSM_NBR_PLAN_TELEX                                 0x04                                                     
#define LS_GSM_NBR_PLAN_LAND_MOBILE                           0x05                                                     
#define LS_GSM_NBR_PLAN_NATIONAL                              0x08                                                     
#define LS_GSM_NBR_PLAN_PRIVATE                               0x09                                                     

//ConstantTable for LS_GSM_NBR_TYPE
#define SS_NBR_TYPE_UNKNOWN                                   0x00                                                     
#define SS_NBR_TYPE_INTERNATIONAL                             0x01                                                     
#define SS_NBR_TYPE_NATIONAL                                  0x02                                                     
#define SS_NBR_TYPE_NETWORK_SPECIFIC                          0x03                                                     
#define SS_NBR_TYPE_SUBSCRIBER                                0x04                                                     
#define SS_NBR_TYPE_ABBREVIATED                               0x06                                                     

//ConstantTable for LS_POSITION_TECHNOLOGY
#define LS_POS_TECHNOLOGY_AGPS                                0x00                                                     

//ConstantTable for LS_WCDMA_REPORT_CRITERIA
#define LS_WCDMA_REPORT_EVENT                                 0x00                                                     
#define LS_WCDMA_REPORT_PERIODIC                              0x01                                                     
#define LS_WCDMA_REPORT_NO_REPORTING                          0x02                                                     

//ConstantTable for LS_WCDMA_EVENT_TYPE
#define LS_WCDMA_EVENT_7A                                     0x00                                                     
#define LS_WCDMA_EVENT_7B                                     0x01                                                     
#define LS_WCDMA_EVENT_7C                                     0x02                                                     

//ConstantTable for LS_WCDMA_ERROR_CODE
#define LS_WCDMA_ERROR_SUCCESS                                0x00                                                     
#define LS_WCDMA_ERROR_UNSPECIFIED                            0x01                                                     
#define LS_WCDMA_ERROR_MISSING_DATA                           0x02                                                     
#define LS_WCDMA_ERROR_UNSUPPORTED_MEASUREMENT                0x03                                                     
#define LS_WCDMA_ERROR_INVALID_CONFIGURATION                  0x04                                                     
#define LS_WCDMA_ERROR_CONFIGURATION_INCOMPLETE               0x05                                                     

//ConstantTable for LS_WCDMA_MEAS_ERROR
#define LS_WCDMA_NOT_ENOUGH_OTDOA_CELLS                       0x00                                                     
#define LS_WCDMA_NOT_ENOUGH_GPS_SATELLITES                    0x01                                                     
#define LS_WCDMA_ASSISTANCE_DATA_MISSING                      0x02                                                     
#define LS_WCDMA_METHOD_NOT_SUPPORTED                         0x03                                                     
#define LS_WCDMA_UNDEFINED_ERROR                              0x04                                                     
#define LS_WCDMA_REQUEST_DENIED_BY_USER                       0x05                                                     
#define LS_WCDMA_NOT_PROCESSED_AND_TIMEOUT                    0x06                                                     
#define LS_WCDMA_REFERENCE_CELL_NOT_SERVING_CELL              0x07                                                     
#define LS_WCDMA_GPS_TIMING_OF_CELL_FRAMES_FAIL               0x08                                                     

//ConstantTable for LS_SS_LCS_SERVICE_TYPE_ID
#define LS_SS_LCS_SERV_TYPE_EMERG_SERV                        0x00                                                     
#define LS_SS_LCS_SERV_TYPE_EMERG_ALERT_SERV                  0x01                                                     
#define LS_SS_LCS_SERV_TYPE_PERSON_TRACKING                   0x02                                                     
#define LS_SS_LCS_SERV_TYPE_FLEET_MGMT                        0x03                                                     
#define LS_SS_LCS_SERV_TYPE_ASSET_MGMT                        0x04                                                     
#define LS_SS_LCS_SERV_TYPE_TRAFF_CONG_RPT                    0x05                                                     
#define LS_SS_LCS_SERV_TYPE_ROADSIDE_ASS                      0x06                                                     
#define LS_SS_LCS_SERV_TYPE_ROUTING_NEAR_COMM_ENT             0x07                                                     
#define LS_SS_LCS_SERV_TYPE_NAVIGATION                        0x08                                                     
#define LS_SS_LCS_SERV_TYPE_CITY_SIGHT_SEEING                 0x09                                                     
#define LS_SS_LCS_SERV_TYPE_LOCALIZED_ADV                     0x0A                                                     
#define LS_SS_LCS_SERV_TYPE_MOB_YELLOW_PAGES                  0x0B                                                     

//BitmaskTables for LS_GPS_SAT_LIST_STATUS
#define LS_GPS_SAT_LIST_STATUS_EPHEMERIS                      0x01                                                     
#define LS_GPS_SAT_LIST_STATUS_ALMANAC                        0x02                                                     

//BitmaskTables for LS_GPS_CH_COMMON_STATUS
#define LS_GPS_CH_COMMON_STATUS_SV_USED                       0x01                                                     
#define LS_GPS_CH_COMMON_STATUS_MP_DETECTED                   0x02                                                     

//ConstantTable for LS_GSM_GPS_MULTIPATH_INDICATOR
#define LS_GSM_GPS_MP_NOT_MEASURED                            0x00                                                     
#define LS_GSM_GPS_MP_LOW                                     0x01                                                     
#define LS_GSM_GPS_MP_MEDIUM                                  0x02                                                     
#define LS_GSM_GPS_MP_HIGH                                    0x03                                                     

//ConstantTable for LS_WCDMA_MULTIPATH_INDICATOR
#define LS_WCDMA_MP_NOT_MEASURED                              0x00                                                     
#define LS_WCDMA_MP_LOW                                       0x01                                                     
#define LS_WCDMA_MP_MEDIUM                                    0x02                                                     
#define LS_WCDMA_MP_HIGH                                      0x03                                                     

//ConstantTable for LS_PRIV_INFO_TYPE
#define LS_PRIV_NOT_APPLICABLE                                0x00                                                     
#define LS_PRIV_PHONE_NUMBER                                  0x01                                                     
#define LS_PRIV_LOGICAL_NAME                                  0x02                                                     
#define LS_PRIV_EMAIL                                         0x03                                                     
#define LS_PRIV_URL                                           0x04                                                     
#define LS_PRIV_SIP_URL                                       0x05                                                     
#define LS_PRIV_IMS_PUB_IDENT                                 0x06                                                     

//ConstantTable for LS_PRIV_VERIFICATION_TYPE

//BitmaskTables for LS_DELETE_SELECTION
#define LS_DELETE_ALL                                         0xFF                                                  
#define LS_DELETE_TIME                                        0x01                                                     
#define LS_DELETE_POSITION                                    0x02                                                     
#define LS_DELETE_EPHEMERIS                                   0x04                                                     
#define LS_DELETE_ALMANAC                                     0x08                                                     
#define LS_DELETE_IONO_UTC                                    0x10                                                  
#define LS_DELETE_SV_HEALTH                                   0x20                                                  

//ConstantTable for LS_PRIVACY_NTF_INITIATOR_ID
#define LS_NATIVE                                             0x00                                                     
#define LS_JAVA                                               0x01                                                     
#define LS_MLFW                                               0x02                                                     
#define LS_BROWSER                                            0x03                                                     
#define LS_GSM                                                0x04                                                     
#define LS_CDMA                                               0x05                                                     
#define LS_WCDMA                                              0x06                                                     
#define LS_BREW                                               0x07                                                     
#define LS_CDMA_SMS                                           0x08                                                     
#define LS_TEST                                               0x09                                                     
#define LS_SUPL                                               0x0A                                                     

//ConstantTable for LS_CLIENT_ID
#define LS_CLIENT_ALL                                         0x00                                                     
#define LS_CLIENT_NATIVE                                      0x01                                                     
#define LS_CLIENT_JAVA                                        0x02                                                     

//ConstantTable for LS_LTM_ID
#define LS_LTM_GOPHERS                                        0x01                                                     
#define LS_LTM_TEST                                           0x02                                                     
#define LS_LTM_BT_GPS                                         0x05                                                     

//ConstantTable for LS_PDE_TYPE

//BitmaskTables for LS_NMEA_OPTIONS
#define LS_NMEA_GGA                                           0x00000001                                                     
#define LS_NMEA_GLL                                           0x00000002                                                     
#define LS_NMEA_GSA                                           0x00000004                                                     
#define LS_NMEA_GST                                           0x00000008                                                     
#define LS_NMEA_GSV                                           0x00000010                                                  
#define LS_NMEA_RMC                                           0x00000020                                                  
#define LS_NMEA_VTG                                           0x00000040                                                  
#define LS_NMEA_ALL_STD                                       0x0000FFFF                                                  
#define LS_NMEA_ALL_PRO                                       0xFFFF0000                                            

//BitmaskTables for LS_FORCED_AD_REFRESH_OPTIONS
#define LS_FORCE_AD_REFRESH_ONLY                              0x01                                                     
#define LS_FORCE_AD_REFRESH_WITH_FIX                          0x02                                                     

//BitmaskTables for LS_REQUEST_OPTIONS
#define LS_TIMESTAMP                                          0x00000001                                                     
#define LS_LATITUDE_LONGITUDE                                 0x00000002                                                     
#define LS_ALTITUDE                                           0x00000004                                                     
#define LS_VELOCITY                                           0x00000008                                                     
#define LS_NMEA_0183                                          0x00000010                                                  
#define LS_GPS_EXACT_TIME                                     0x00000100                                                   
#define LS_GPS_USER_DOPS                                      0x00000200                                                   
#define LS_GPS_SAT_LIST                                       0x00000400                                                   
#define LS_GPS_CHANNEL_STATUS                                 0x00000800                                                   
#define LS_GPS_PSEUDORANGE_MEAS                               0x00001000                                                  

//BitmaskTables for LS_REQUEST_OPTIONS_API
//#define LS_TIMESTAMP                                        0x00                        //Already defined as 0x01
//#define LS_LATITUDE_LONGITUDE                               0x00                        //Already defined as 0x02
//#define LS_ALTITUDE                                         0x00                        //Already defined as 0x04
//#define LS_VELOCITY                                         0x00                        //Already defined as 0x08
//#define LS_NMEA_0183                                        0x00                        //Already defined as 0x010
//#define LS_GPS_EXACT_TIME                                   0x00                        //Already defined as 0x0100
//#define LS_GPS_USER_DOPS                                    0x00                        //Already defined as 0x0200
//#define LS_GPS_SAT_LIST                                     0x00                        //Already defined as 0x0400
//#define LS_GPS_CHANNEL_STATUS                               0x00                        //Already defined as 0x0800

//BitmaskTables for LS_REQUEST_OPTIONS_CLMI
//#define LS_LATITUDE_LONGITUDE                               0x00                        //Already defined as 0x02
//#define LS_ALTITUDE                                         0x00                        //Already defined as 0x04
//#define LS_VELOCITY                                         0x00                        //Already defined as 0x08
//#define LS_NMEA_0183                                        0x00                        //Already defined as 0x010
//#define LS_GPS_EXACT_TIME                                   0x00                        //Already defined as 0x0100
//#define LS_GPS_USER_DOPS                                    0x00                        //Already defined as 0x0200
//#define LS_GPS_SAT_LIST                                     0x00                        //Already defined as 0x0400
//#define LS_GPS_CHANNEL_STATUS                               0x00                        //Already defined as 0x0800
//#define LS_GPS_PSEUDORANGE_MEAS                             0x00                        //Already defined as 0x01000

//ConstantTable for LS_POWER_LEVEL
#define LS_POWER_LEVEL_UNKNOWN                                0x00                                                     
#define LS_POWER_LEVEL_ZERO                                   0x01                                                     
#define LS_POWER_LEVEL_LOW                                    0x02                                                     
#define LS_POWER_LEVEL_MEDIUM                                 0x03                                                     
#define LS_POWER_LEVEL_HIGH                                   0x04                                                     

//ConstantTable for LS_COST_LEVEL
#define LS_COST_LEVEL_UNKNOWN                                 0x00                                                     
#define LS_COST_LEVEL_ZERO                                    0x01                                                     
#define LS_COST_LEVEL_POSSIBLE                                0x02                                                     
#define LS_COST_LEVEL_CHARGE                                  0x03                                                     

//ConstantTable for LS_TTFF_INTERPRETATION
#define LS_TTFF_RESPONSE_TIME                                 0x00                                                     

//ConstantTable for LS_ERR_REASONS
#define LS_ERR_NONE                                           0x00                                                     
#define LS_ERR_GENERAL                                        0x01                                                     
#define LS_ERR_TIMEOUT                                        0x02                                                     
#define LS_ERR_PRIVACY_RESPECTED                              0x03                                                     
#define LS_ERR_NO_MULTIFIX                                    0x05                                                     
#define LS_ERR_NO_METHOD                                      0x06                                                     
#define LS_ERR_OUT_OF_RESOURCES                               0x0A                                                     

//ConstantTable for LS_PROGRESS_INDICATOR
#define LS_AD_REFRESH_NA                                      0x00                                                     

//ConstantTable for LS_FIX_TYPE
#define LS_FIX_TYPE_UNKNOWN                                   0x00                                                     
#define LS_FIX_TYPE_2D                                        0x01                                                     
#define LS_FIX_TYPE_3D                                        0x02                                                     

//ConstantTable for LS_METHOD_STATUS
#define LS_METHOD_AVAILABLE                                   0x01                                                     
#define LS_METHOD_UNAVAILABLE                                 0x02                                                     
#define LS_METHOD_HARDWARE_FAILURE                            0x03                                                     

//BitmaskTables for LS_METHOD_CAPABILITIES
#define LS_CAP_LATITUDE_LONGITUDE                             0x00000001                                                     
#define LS_CAP_ALTITUDE                                       0x00000002                                                     
#define LS_CAP_ALTITUDE_MSL                                   0x00000004                                                     
#define LS_CAP_HEADING                                        0x00000008                                                     
#define LS_CAP_HEADING_MAGNETIC                               0x00000010                                                  
#define LS_CAP_SPEED_VERTICAL                                 0x00000020                                                  
#define LS_CAP_SPEED_HORIZONTAL                               0x00000040                                                  
#define LS_CAP_GPS_EXACT_TIME                                 0x00000080                                                  
#define LS_CAP_GPS_USER_DOPS                                  0x00000100                                                   
#define LS_CAP_GPS_SAT_LIST                                   0x00000200                                                   
#define LS_CAP_GPS_CHANNEL_STATUS                             0x00000400                                                   
#define LS_CAP_NMEA_0183                                      0x00000800                                                   

//ConstantTable for LS_PING_TYPE
#define LS_PING_ENABLE                                        0x00                                                     
#define LS_PING_RENEW                                         0x01                                                     
#define LS_PING_DISABLE                                       0x02                                                     

//BitmaskTables for LS_SOURCE
#define LS_SOURCE_BT_GPS                                      0x01                                                     
#define LS_SOURCE_INT_GPS                                     0x02                                                     
#define LS_SOURCE_INT_AGPS                                    0x04                                                     

//BitmaskTables for LS_POSITIONING_SUPPORT
#define LS_SUPPORT_STANDALONE_GPS                             0x01                                                     
#define LS_SUPPORT_MS_BASED_GPS                               0x02                                                     
#define LS_SUPPORT_MS_ASSISTED_GPS                            0x04                                                     

//ConstantTable for LS_GPS_STATUS
#define LS_GPS_STATUS_OFF                                     0x00                                                     
#define LS_GPS_STATUS_ON                                      0x01                                                     

//ConstantTable for LS_GPS_ON_STATE
#define LS_GPS_ON_STATE_NONE                                  0x00                                                     
#define LS_GPS_ON_STATE_SEARCH                                0x01                                                     
#define LS_GPS_ON_STATE_FIX                                   0x02                                                     
#define LS_GPS_ON_STATE_SLEEP                                 0x03                                                     

//ConstantTable for LS_SENSOR_REGISTRATION_STATUS
#define LS_SENSOR_STATUS_FAIL                                 0x00                                                     
#define LS_SENSOR_STATUS_OK                                   0x01                                                     
#define LS_SENSOR_STATUS_ALREADY_REGISTERED                   0x02                                                     

//ConstantTable for LS_SENSOR_TYPE
#define LS_SENSOR_ACCELEROMETER                               0x00                                                     

//ConstantTable for LS_SENSOR_ACCELEROMETER_ACTION_PARAM
#define LS_SENSOR_ACCELEROMETER_START                         0x00                                                     
#define LS_SENSOR_ACCELEROMETER_STOP                          0x01                                                     

//ConstantTable for LS_RRLP_LOOPBACK_STATUS
#define LS_RRLP_LOOPBACK_STATUS_OK                            0x00                                                     
#define LS_RRLP_LOOPBACK_STATUS_SAME_REF_NBR                  0x01                                                     
#define LS_RRLP_LOOPBACK_STATUS_DIFF_REF_NBR                  0x02                                                     

//ConstantTable for LS_SUPL_STATUS
#define LS_SUPL_STATUS_OK                                     0x00                                                     
#define LS_SUPL_STATUS_FAIL                                   0x01                                                     
#define LS_SUPL_STATUS_FAIL_SESSION_UNKNOWN                   0x02                                                     
#define LS_SUPL_STATUS_FAIL_SESSION_EXISTS                    0x03                                                     
#define LS_SUPL_STATUS_SESSION_ENDED                          0x04                                                     
#define LS_SUPL_STATUS_UNDEFINED                              0xFF                                                  

//ConstantTable for LS_SUPL_POS_PAYLOAD_TYPE
#define LS_SUPL_POS_PAYLOAD_TYPE_TIA801                       0x00                                                     
#define LS_SUPL_POS_PAYLOAD_TYPE_RRLP                         0x01                                                     
#define LS_SUPL_POS_PAYLOAD_TYPE_RRC                          0x02                                                     

//ConstantTable for LS_SUPL_STATE
#define LS_SUPL_STATE_SESSION_CREATED                         0x00                                                     
#define LS_SUPL_STATE_SESSION_INITIALIZED                     0x01                                                     
#define LS_SUPL_STATE_SESSION_START                           0x02                                                     
#define LS_SUPL_STATE_SESSION_RESPONSE                        0x03                                                     
#define LS_SUPL_STATE_SESSION_INIT                            0x04                                                     
#define LS_SUPL_STATE_SESSION_POS_INIT                        0x05                                                     
#define LS_SUPL_STATE_SESSION_POS                             0x06                                                     
#define LS_SUPL_STATE_SESSION_END                             0x07                                                     
#define LS_SUPL_STATE_SESSION_CLOSE                           0x08                                                     
#define LS_SUPL_STATE_SESSION_ERROR                           0x09                                                     

//ConstantTable for LS_SUPL_POSITION_LATITUDE_SIGN
#define LS_SUPL_POSITION_LATITUDE_SIGN_NORTH                  0x00                                                     
#define LS_SUPL_POSITION_LATITUDE_SIGN_SOUTH                  0x01                                                     

//ConstantTable for LS_SUPL_POSITION_ALTITUDE_DIRECTION
#define LS_SUPL_POSITION_ALTITUDE_DIRECTION_HEIGHT            0x00                                                     
#define LS_SUPL_POSITION_ALTITUDE_DIRECTION_DEPTH             0x01                                                     

//ConstantTable for LS_SUPL_VELOCITY_DIRECTION_VERTICAL_SPEED
#define LS_SUPL_VELOCITY_DIRECTION_VERTICAL_SPEED_UPWARD      0x00                                                     
#define LS_SUPL_VELOCITY_DIRECTION_VERTICAL_SPEED_DOWNWARD    0x01                                                     

//ConstantTable for LS_SUPL_POSITION_ALTITUDE_PRESENCE
#define LS_SUPL_POSITION_ALTITUDE_NOT_INCL                    0x00                                                     
#define LS_SUPL_POSITION_ALTITUDE_INCL                        0x01                                                     

//ConstantTable for LS_SUPL_POSITION_UNCERTAINTY_PRESENCE
#define LS_SUPL_POSITION_UNCERTAINTY_NOT_INCL                 0x00                                                     
#define LS_SUPL_POSITION_UNCERTAINTY_INCL                     0x01                                                     

//ConstantTable for LS_SUPL_VELOCITY_TYPE
#define LS_SUPL_VELOCITY_TYPE_HORIZONTAL                      0x00                                                     
#define LS_SUPL_VELOCITY_TYPE_HORIZONTAL_VERTICAL             0x01                                                     
#define LS_SUPL_VELOCITY_TYPE_HORIZONTAL_UNCERT               0x02                                                     
#define LS_SUPL_VELOCITY_TYPE_HORIZONTAL_VERTICAL_UNCERT      0x03                                                     

//BitmaskTables for LS_SUPL_CAPABILITIES
#define LS_SUPL_TECH_SET_ASSISTED_AGPS                        0x00000001                                                     
#define LS_SUPL_TECH_SET_BASED_AGPS                           0x00000002                                                     
#define LS_SUPL_TECH_AUTONOMOUS_GPS                           0x00000004                                                     
#define LS_SUPL_TECH_AFLT                                     0x00000008                                                     
#define LS_SUPL_TECH_ECID                                     0x00000010                                                  
#define LS_SUPL_TECH_EOTD                                     0x00000020                                                  
#define LS_SUPL_TECH_OTDOA                                    0x00000040                                                  
#define LS_SUPL_PREFERRED_SET_ASSISTED                        0x00010000                                                 
#define LS_SUPL_PREFERRED_SET_BASED                           0x00020000                                                 
#define LS_SUPL_PROTOCOL_RRLP                                 0x01000000                                               
#define LS_SUPL_PROTOCOL_RRC                                  0x02000000                                               
#define LS_SUPL_PROTOCOL_TIA801                               0x04000000                                               

//BitmaskTables for LS_SUPL_METHODS
//#define LS_SUPL_TECH_SET_ASSISTED_AGPS                      0x00                        //Already defined as 0x01
//#define LS_SUPL_TECH_SET_BASED_AGPS                         0x00                        //Already defined as 0x02
//#define LS_SUPL_TECH_AUTONOMOUS_GPS                         0x00                        //Already defined as 0x04
//#define LS_SUPL_TECH_AFLT                                   0x00                        //Already defined as 0x08
//#define LS_SUPL_TECH_ECID                                   0x00                        //Already defined as 0x010
//#define LS_SUPL_TECH_EOTD                                   0x00                        //Already defined as 0x020
//#define LS_SUPL_TECH_OTDOA                                  0x00                        //Already defined as 0x040
//#define LS_SUPL_PREFERRED_SET_ASSISTED                      0x00                        //Already defined as 0x010000
//#define LS_SUPL_PREFERRED_SET_BASED                         0x00                        //Already defined as 0x020000

//BitmaskTables for LS_SUPL_ASTNC_TYPES
#define LS_SUPL_ASTNC_GPS_ALMANAC                             0x00000001                                                     
#define LS_SUPL_ASTNC_GPS_UTC                                 0x00000002                                                     
#define LS_SUPL_ASTNC_GPS_IONOSPHERIC                         0x00000004                                                     
#define LS_SUPL_ASTNC_GPS_DGPS                                0x00000008                                                     
#define LS_SUPL_ASTNC_GPS_REF_LOC                             0x00000010                                                  
#define LS_SUPL_ASTNC_GPS_REF_TIME                            0x00000020                                                  
#define LS_SUPL_ASTNC_GPS_ACQUISITION                         0x00000040                                                  
#define LS_SUPL_ASTNC_GPS_INTEGRITY                           0x00000080                                                  
#define LS_SUPL_ASTNC_GPS_NAVIGATION                          0x00000100                                                   

//BitmaskTables for LS_SUPL_INFO_REQUESTS
#define LS_SUPL_INFO_REQ_AD_REQUEST                           0x00000001                                                     
#define LS_SUPL_INFO_REQ_VELOCITY                             0x00000002                                                     
#define LS_SUPL_INFO_REQ_SET_CAPABILITIES                     0x00000004                                                     
#define LS_SUPL_INFO_REQ_POS_PAYLOAD                          0x00000008                                                     
#define LS_SUPL_INFO_REQ_POS_ESTIMATE                         0x00000010                                                  

//BitmaskTables for LS_SUPL_SESSION_OPTIONS
#define LS_SUPL_SESSION_OPTIONS_POSITION_REQUEST              0x01                                                     

//BitmaskTables for LS_SUPL_QOP_PARAMETERS_INCLUDED
#define LS_SUPL_QOP_MAC_LOC_AGE_INCL                          0x01                                                     
#define LS_SUPL_QOP_VERT_UNC_INCL                             0x02                                                     
#define LS_SUPL_QOP_DELAY_INCL                                0x04                                                     

//ConstantTable for LS_HYBRID_COMMAND
#define LS_HYBRID_MEAS_START                                  0x00                                                     
#define LS_HYBRID_MEAS_MODIFY                                 0x01                                                     
#define LS_HYBRID_MEAS_STOP                                   0x02                                                     

//BitmaskTables for LS_HYBRID_METHODS
#define LS_HYBRID_METHOD_CWP                                  0x00000001                                                     
#define LS_HYBRID_METHOD_ACWP                                 0x00000002                                                     
#define LS_HYBRID_METHOD_GNSS                                 0x00000004                                                     
#define LS_HYBRID_METHOD_AGNSS                                0x00000008                                                     

//BitmaskTables for LS_HYBRID_OPTIONS
#define LS_HYBRID_OPTION_CHANNEL_STATUS                       0x00000001                                                     
#define LS_HYBRID_OPTION_CELL_INFO                            0x00000002                                                     
#define LS_HYBRID_OPTION_NMEA_0183                            0x00000004                                                     

//ConstantTable for LS_HYBRID_REPORT_CRITERIA
#define LS_HYBRID_REPORT_AT_ALL_INTERVALS                     0x00                                                     
#define LS_HYBRID_REPORT_ONLY_POSITION_CHANGES                0x01                                                     

//ConstantTable for LS_HYBRID_INTERVAL
#define LS_HYBRID_INTERVAL_DEFAULT                            0x00                                                     
#define LS_HYBRID_INTERVAL_100MS                              0x01                                                     
#define LS_HYBRID_INTERVAL_500MS                              0x05                                                     
#define LS_HYBRID_INTERVAL_1S                                 0x0A                                                     
#define LS_HYBRID_INTERVAL_2S                                 0x14                                                  
#define LS_HYBRID_INTERVAL_5S                                 0x32                                                  
#define LS_HYBRID_INTERVAL_10S                                0x64                                                  
#define LS_HYBRID_INTERVAL_20S                                0xC8                                                  
#define LS_HYBRID_INTERVAL_30S                                0x012C                                                   
#define LS_HYBRID_INTERVAL_60S                                0x0258                                                   
#define LS_HYBRID_INTERVAL_120S                               0x04B0                                                   

//ConstantTable for LS_HYBRID_CAUSE
#define LS_HYBRID_CAUSE_SUCCESS                               0x00                                                     
#define LS_HYBRID_CAUSE_NO_POSITION_YET                       0x01                                                     
#define LS_HYBRID_CAUSE_ERROR_UNSPECIFIED                     0x02                                                     
#define LS_HYBRID_CAUSE_ERROR_NO_METHODS                      0x03                                                     

//BitmaskTables for LS_NPE_CHANNELS_STATUS
#define LS_NPE_CHANNELS_STATUS_SV_USED                        0x01                                                     
#define LS_NPE_CHANNELS_STATUS_MP_DETECTED                    0x02                                                     

//ConstantTable for LS_GPS_ANTENNA_CTRL
#define LS_GPS_ANTENNA_RELEASE                                0x00                                                     
#define LS_GPS_ANTENNA_FORCE_1                                0x01                                                     
#define LS_GPS_ANTENNA_FORCE_2                                0x02                                                     

//ConstantTable for FtdTable
#define LS_SB_FTD_LATITUDE_DIR                                0x10                                                  
#define LS_SB_FTD_LATITUDE_DEG                                0x11                                                  
#define LS_SB_FTD_LATITUDE                                    0x12                                                  
#define LS_SB_FTD_LONGITUDE_DIR                               0x13                                                  
#define LS_SB_FTD_LONGITUDE_DEG                               0x14                                                  
#define LS_SB_FTD_LONGITUDE                                   0x15                                                  
#define LS_SB_FTD_LOCATE_RESP_STATUS                          0x16                                                  
#define LS_SB_FTD_LOCATE_RESP_METHOD                          0x17                                                  
#define LS_SB_FTD_SPEED                                       0x7C                                                  
#define LS_SB_FTD_DIRECTION                                   0x7D                                                  
#define LS_SB_FTD_ALTITUDE                                    0x7E                                                  
#define LS_SB_FTD_FIX_TYPE                                    0x7F                                                  
#define LS_SB_FTD_ERR_ORIENTAT                                0x19                                                  
#define LS_SB_FTD_ERR_EAST                                    0x1A                                                  
#define LS_SB_FTD_ERR_NORTH                                   0x1B                                                  
#define LS_SB_FTD_ERR_VERT                                    0x1C                                                  
#define LS_SB_FTD_MS_TIME                                     0x1E                                                  
#define LS_SB_FTD_MS_DATE                                     0x1F                                                  
#define LS_SB_FTD_LOCATION_REQ                                0xE0                                                  
#define LS_SB_FTD_FIX_TIME                                    0xE1                                                  
#define LS_SB_FTD_TTF_LESS_5                                  0xE2                                                  
#define LS_SB_FTD_TTF_LESS_10                                 0xE3                                                  
#define LS_SB_FTD_TTF_LESS_15                                 0xE4                                                  
#define LS_SB_FTD_TTF_LESS_20                                 0xE5                                                  
#define LS_SB_FTD_TTF_LESS_25                                 0xE6                                                  
#define LS_SB_FTD_TTF_LESS_30                                 0xE7                                                  
#define LS_SB_FTD_TTF_LESS_35                                 0xE8                                                  
#define LS_SB_FTD_TTF_LESS_40                                 0xE9                                                  
#define LS_SB_FTD_TTF_LESS_45                                 0xEA                                                  
#define LS_SB_FTD_TTF_LESS_50                                 0xEB                                                  
#define LS_SB_FTD_TTF_LESS_55                                 0xEC                                                  
#define LS_SB_FTD_TTF_GREATER_55                              0xED                                                  
#define LS_SB_FTD_LS_VERSION                                  0x73                                                  
#define LS_SB_FTD_LS_DATE                                     0x74                                                  
#define LS_SB_FTD_LS_TEXT_1                                   0x75                                                  
#define LS_SB_FTD_LS_TEXT_2                                   0x76                                                  
#define LS_SB_FTD_GPS_REQS                                    0x23                                                  
#define LS_SB_FTD_GPS_OK                                      0x24                                                  
#define LS_SB_FTD_GPS_FAIL                                    0x25                                                  
#define LS_SB_FTD_GSM_METHOD_TYP                              0x26                                                  
#define LS_SB_FTD_GSM_POSIT_METHOD                            0x27                                                  
#define LS_SB_FTD_GSM_RESP_TIME                               0x28                                                  
#define LS_SB_FTD_GSM_MULTIPLE_SET                            0x29                                                  
#define LS_SB_FTD_GSM_POSIT_ACC                               0x2A                                                  
#define LS_SB_FTD_EOTD_ERR_1                                  0x6F                                                  
#define LS_SB_FTD_EOTD_ERR_2                                  0x70                                                  
#define LS_SB_FTD_EOTD_ERR_3                                  0x71                                                  
#define LS_SB_FTD_EOTD_ERR_4                                  0x72                                                  
#define LS_SB_FTD_GPS_MCU_VERSION                             0x80                                                  
#define LS_SB_FTD_GPS_MCU_DATE                                0x81                                                  
#define LS_SB_FTD_GPS_DSP_VERSION                             0x82                                                  
#define LS_SB_FTD_GPS_DSP_DATE                                0x83                                                  
#define LS_SB_FTD_SV_1                                        0x84                                                  
#define LS_SB_FTD_CNO_1                                       0x85                                                  
#define LS_SB_FTD_PSEUDORANGE_1                               0x86                                                  
#define LS_SB_FTD_DOPPLER_1                                   0x87                                                  
#define LS_SB_FTD_SV_2                                        0x88                                                  
#define LS_SB_FTD_CNO_2                                       0x89                                                  
#define LS_SB_FTD_PSEUDORANGE_2                               0x8A                                                  
#define LS_SB_FTD_DOPPLER_2                                   0x8B                                                  
#define LS_SB_FTD_SV_3                                        0x8C                                                  
#define LS_SB_FTD_CNO_3                                       0x8D                                                  
#define LS_SB_FTD_PSEUDORANGE_3                               0x8E                                                  
#define LS_SB_FTD_DOPPLER_3                                   0x8F                                                  
#define LS_SB_FTD_SV_4                                        0x90                                                  
#define LS_SB_FTD_CNO_4                                       0x91                                                  
#define LS_SB_FTD_PSEUDORANGE_4                               0x92                                                  
#define LS_SB_FTD_DOPPLER_4                                   0x93                                                  
#define LS_SB_FTD_SV_5                                        0x94                                                  
#define LS_SB_FTD_CNO_5                                       0x95                                                  
#define LS_SB_FTD_PSEUDORANGE_5                               0x96                                                  
#define LS_SB_FTD_DOPPLER_5                                   0x97                                                  
#define LS_SB_FTD_SV_6                                        0x98                                                  
#define LS_SB_FTD_CNO_6                                       0x99                                                  
#define LS_SB_FTD_PSEUDORANGE_6                               0x9A                                                  
#define LS_SB_FTD_DOPPLER_6                                   0x9B                                                  
#define LS_SB_FTD_SV_7                                        0x9C                                                  
#define LS_SB_FTD_CNO_7                                       0x9D                                                  
#define LS_SB_FTD_PSEUDORANGE_7                               0x9E                                                  
#define LS_SB_FTD_DOPPLER_7                                   0x9F                                                  
#define LS_SB_FTD_SV_8                                        0xA0                                                  
#define LS_SB_FTD_CNO_8                                       0xA1                                                  
#define LS_SB_FTD_PSEUDORANGE_8                               0xA2                                                  
#define LS_SB_FTD_DOPPLER_8                                   0xA3                                                  
#define LS_SB_FTD_SV_9                                        0xA4                                                  
#define LS_SB_FTD_CNO_9                                       0xA5                                                  
#define LS_SB_FTD_PSEUDORANGE_9                               0xA6                                                  
#define LS_SB_FTD_DOPPLER_9                                   0xA7                                                  
#define LS_SB_FTD_SV_10                                       0xA8                                                  
#define LS_SB_FTD_CNO_10                                      0xA9                                                  
#define LS_SB_FTD_PSEUDORANGE_10                              0xAA                                                  
#define LS_SB_FTD_DOPPLER_10                                  0xAB                                                  
#define LS_SB_FTD_SV_11                                       0xAC                                                  
#define LS_SB_FTD_CNO_11                                      0xAD                                                  
#define LS_SB_FTD_PSEUDORANGE_11                              0xAE                                                  
#define LS_SB_FTD_DOPPLER_11                                  0xAF                                                  
#define LS_SB_FTD_SV_12                                       0xB0                                                  
#define LS_SB_FTD_CNO_12                                      0xB1                                                  
#define LS_SB_FTD_PSEUDORANGE_12                              0xB2                                                  
#define LS_SB_FTD_DOPPLER_12                                  0xB3                                                  
#define LS_SB_FTD_UTC                                         0xEE                                                  
#define LS_SB_FTD_NUMBER_OF_SV                                0xEF                                                  
#define LS_SB_FTD_ALT_AMSL                                    0xF0                                                  
#define LS_SB_FTD_GEOID_SEP                                   0xF1                                                  
#define LS_SB_FTD_SV_USED_1                                   0xF2                                                  
#define LS_SB_FTD_SV_HEALTH_1                                 0xF3                                                  
#define LS_SB_FTD_ELEVATION_1                                 0xF4                                                  
#define LS_SB_FTD_AZIMUTH_1                                   0xF5                                                  
#define LS_SB_FTD_SV_USED_2                                   0xF6                                                  
#define LS_SB_FTD_SV_HEALTH_2                                 0xF7                                                  
#define LS_SB_FTD_ELEVATION_2                                 0xF8                                                  
#define LS_SB_FTD_AZIMUTH_2                                   0xF9                                                  
#define LS_SB_FTD_SV_USED_3                                   0xFF                                                  
#define LS_SB_FTD_SV_HEALTH_3                                 0x0101                                                   
#define LS_SB_FTD_ELEVATION_3                                 0x0103                                                   
#define LS_SB_FTD_AZIMUTH_3                                   0x0104                                                   
#define LS_SB_FTD_SV_USED_4                                   0x0105                                                   
#define LS_SB_FTD_SV_HEALTH_4                                 0x0107                                                   
#define LS_SB_FTD_ELEVATION_4                                 0x0109                                                   
#define LS_SB_FTD_AZIMUTH_4                                   0x010A                                                   
#define LS_SB_FTD_SV_USED_5                                   0x010B                                                   
#define LS_SB_FTD_SV_HEALTH_5                                 0x010D                                                   
#define LS_SB_FTD_ELEVATION_5                                 0x010F                                                   
#define LS_SB_FTD_AZIMUTH_5                                   0x0110                                                   
#define LS_SB_FTD_SV_USED_6                                   0x0111                                                   
#define LS_SB_FTD_SV_HEALTH_6                                 0x0113                                                   
#define LS_SB_FTD_ELEVATION_6                                 0x0115                                                   
#define LS_SB_FTD_AZIMUTH_6                                   0x0116                                                   
#define LS_SB_FTD_SV_USED_7                                   0x0117                                                   
#define LS_SB_FTD_SV_HEALTH_7                                 0x0119                                                   
#define LS_SB_FTD_ELEVATION_7                                 0x011B                                                   
#define LS_SB_FTD_AZIMUTH_7                                   0x011C                                                   
#define LS_SB_FTD_SV_USED_8                                   0x011D                                                   
#define LS_SB_FTD_SV_HEALTH_8                                 0x011F                                                   
#define LS_SB_FTD_ELEVATION_8                                 0x0121                                                   
#define LS_SB_FTD_AZIMUTH_8                                   0x0122                                                   
#define LS_SB_FTD_SV_USED_9                                   0x0123                                                   
#define LS_SB_FTD_SV_HEALTH_9                                 0x0125                                                   
#define LS_SB_FTD_ELEVATION_9                                 0x0127                                                   
#define LS_SB_FTD_AZIMUTH_9                                   0x0128                                                   
#define LS_SB_FTD_SV_USED_10                                  0x0129                                                   
#define LS_SB_FTD_SV_HEALTH_10                                0x012B                                                   
#define LS_SB_FTD_ELEVATION_10                                0x012D                                                   
#define LS_SB_FTD_AZIMUTH_10                                  0x012E                                                   
#define LS_SB_FTD_SV_USED_11                                  0x012F                                                   
#define LS_SB_FTD_SV_HEALTH_11                                0x0131                                                   
#define LS_SB_FTD_ELEVATION_11                                0x0133                                                   
#define LS_SB_FTD_AZIMUTH_11                                  0x0134                                                   
#define LS_SB_FTD_SV_USED_12                                  0x0135                                                   
#define LS_SB_FTD_SV_HEALTH_12                                0x0137                                                   
#define LS_SB_FTD_ELEVATION_12                                0x0139                                                   
#define LS_SB_FTD_AZIMUTH_12                                  0x013A                                                   
#define LS_SB_FTD_ASS_IONO                                    0x013E                                                   
#define LS_SB_FTD_ASS_UTC                                     0x013F                                                   
#define LS_SB_FTD_ASS_ALMANAC                                 0x0140                                                   
#define LS_SB_FTD_ASS_AA                                      0x0141                                                   
#define LS_SB_FTD_ASS_RTI                                     0x0142                                                   
#define LS_SB_FTD_ASS_DGPS                                    0x0143                                                   
#define LS_SB_FTD_ASS_EPHEMERIS                               0x0144                                                   
#define LS_SB_FTD_ASS_REF_TIME_AVAIL                          0x0145                                                   
#define LS_SB_FTD_ASS_REF_TIME_ACC                            0x0146                                                   
#define LS_SB_FTD_ASS_REF_LOC_AVAIL                           0x0147                                                   
#define LS_SB_FTD_ASS_REF_LOC_ACC                             0x0148                                                   
#define LS_SB_FTD_HDOP                                        0x013B                                                   
#define LS_SB_FTD_PDOP                                        0x013C                                                   
#define LS_SB_FTD_VDOP                                        0x013D                                                   

//ConstantTable for LS_ASTNC_GPS_DGPS_UDRE
#define LS_DPGS_UDRE_1_LESS                                   0x00                                                     
#define LS_DPGS_UDRE_1_TO_4                                   0x01                                                     
#define LS_DPGS_UDRE_4_TO_8                                   0x02                                                     
#define LS_DPGS_UDRE_8_ABOVE                                  0x03                                                     

//ConstantTable for LS_DGPS_STATUS_HEALTH
#define LS_DGPS_STATUS_HEALTH_1_00                            0x00                                                     
#define LS_DGPS_STATUS_HEALTH_0_75                            0x01                                                     
#define LS_DGPS_STATUS_HEALTH_0_50                            0x02                                                     
#define LS_DGPS_STATUS_HEALTH_0_30                            0x03                                                     
#define LS_DGPS_STATUS_HEALTH_0_20                            0x04                                                     
#define LS_DGPS_STATUS_HEALTH_0_10                            0x05                                                     
#define LS_DGPS_STATUS_HEALTH_NOT_MONITORED                   0x06                                                     
#define LS_DGPS_STATUS_HEALTH_INVALID                         0x07                                                     

//BitmaskTables for LS_GPS_NAV_MODEL_BITS
#define LS_GPS_P2_CODE_P_ON                                   0x01                                                     
#define LS_GPS_P2_CODE_CA_ON                                  0x02                                                     
#define LS_GPS_L2P_DATA_FLAG_SET                              0x04                                                     
#define LS_GPS_FIT_INTERVAL_FLAG_SET                          0x08                                                     
#define LS_GPS_NEW_SATELLITE                                  0x10                                                  
#define LS_GPS_NEW_NAVIGATION_MODEL                           0x20                                                  

//ConstantTable for LS_GPS_URA_INDEX
#define LS_URA_0000_TO_0002                                   0x00                                                     
#define LS_URA_0002_TO_0003                                   0x01                                                     
#define LS_URA_0003_TO_0004                                   0x02                                                     
#define LS_URA_0004_TO_0006                                   0x03                                                     
#define LS_URA_0006_TO_0009                                   0x04                                                     
#define LS_URA_0009_TO_0013                                   0x05                                                     
#define LS_URA_0013_TO_0024                                   0x06                                                     
#define LS_URA_0024_TO_0048                                   0x07                                                     
#define LS_URA_0048_TO_0096                                   0x08                                                     
#define LS_URA_0096_TO_0192                                   0x09                                                     
#define LS_URA_0192_TO_0384                                   0x0A                                                     
#define LS_URA_0384_TO_0768                                   0x0B                                                     
#define LS_URA_0768_TO_1536                                   0x0C                                                     
#define LS_URA_1536_TO_3072                                   0x0D                                                     
#define LS_URA_3072_TO_6144                                   0x0E                                                     
#define LS_URA_6144                                           0x0F                                                     

//ConstantTable for LS_GPS_SV_HEALTH
#define LS_SV_HEALTH_ALL_OK                                   0x00                                                     
#define LS_SV_HEALTH_ALL_WEAK                                 0x21                                                  
#define LS_SV_HEALTH_ALL_DEAD                                 0x22                                                  
#define LS_SV_HEALTH_ALL_NO_MODULATION                        0x23                                                  
#define LS_SV_HEALTH_L1P_WEAK                                 0x24                                                  
#define LS_SV_HEALTH_L1P_DEAD                                 0x25                                                  
#define LS_SV_HEALTH_L1P_NO_MODULATION                        0x26                                                  
#define LS_SV_HEALTH_L2P_WEAK                                 0x27                                                  
#define LS_SV_HEALTH_L2P_DEAD                                 0x28                                                  
#define LS_SV_HEALTH_L2P_NO_MODULATION                        0x29                                                  
#define LS_SV_HEALTH_L1C_WEAK                                 0x2A                                                  
#define LS_SV_HEALTH_L1C_DEAD                                 0x2B                                                  
#define LS_SV_HEALTH_L1C_NO_MODULATION                        0x2C                                                  
#define LS_SV_HEALTH_L2C_WEAK                                 0x2D                                                  
#define LS_SV_HEALTH_L2C_DEAD                                 0x2E                                                  
#define LS_SV_HEALTH_L2C_NO_MODULATION                        0x2F                                                  
#define LS_SV_HEALTH_L1P_L2P_WEAK                             0x30                                                  
#define LS_SV_HEALTH_L1P_L2P_DEAD                             0x31                                                  
#define LS_SV_HEALTH_L1P_L2P_NO_MODULATION                    0x32                                                  
#define LS_SV_HEALTH_L1C_L2C_WEAK                             0x33                                                  
#define LS_SV_HEALTH_L1C_L2C_DEAD                             0x34                                                  
#define LS_SV_HEALTH_L1C_L2C_NO_MODULATION                    0x35                                                  
#define LS_SV_HEALTH_L1_WEAK                                  0x36                                                  
#define LS_SV_HEALTH_L1_DEAD                                  0x37                                                  
#define LS_SV_HEALTH_L1_NO_MODULATION                         0x38                                                  
#define LS_SV_HEALTH_L2_WEAK                                  0x39                                                  
#define LS_SV_HEALTH_L2_DEAD                                  0x3A                                                  
#define LS_SV_HEALTH_L2_NO_MODULATION                         0x3B                                                  
#define LS_SV_HEALTH_IS_TEMP_OUT                              0x3C                                                  
#define LS_SV_HEALTH_WILL_BE_TEMP_OUT                         0x3D                                                  
#define LS_SV_HEALTH_MULTIPLE_ANOMALIES                       0x3F                                                  

//ConstantTable for LS_DOPPLER_WINDOW
#define LS_DOPPLER_WIN_200_HZ                                 0x00                                                     
#define LS_DOPPLER_WIN_100_HZ                                 0x01                                                     
#define LS_DOPPLER_WIN_050_HZ                                 0x02                                                     
#define LS_DOPPLER_WIN_025_HZ                                 0x03                                                     
#define LS_DOPPLER_WIN_012_HZ                                 0x04                                                     

//BitmaskTables for LS_GPS_ACQ_INCL
#define LS_GPS_ACQ_DOPPLER0_INCL                              0x01                                                     
#define LS_GPS_ACQ_DOPPLER1_INCL                              0x02                                                     
#define LS_GPS_ACQ_CODE_PHASE_INCL                            0x04                                                     
#define LS_GPS_ACQ_AZ_EL_INCL                                 0x08                                                     

//BitmaskTables for LS_ASTNC_TYPES
#define LS_ASTNC_GPS_ACQUISITION                              0x00000001                                                     
#define LS_ASTNC_GPS_EPHEMERIS                                0x00000002                                                     
#define LS_ASTNC_GPS_IONOSPHERIC                              0x00000004                                                     
#define LS_ASTNC_GPS_ALMANAC                                  0x00000008                                                     
#define LS_ASTNC_GPS_BAD_SV                                   0x00000010                                                  
#define LS_ASTNC_GPS_REF_TIME                                 0x00000020                                                  
#define LS_ASTNC_GPS_REF_LOC                                  0x00000040                                                  
#define LS_ASTNC_GPS_REF_LOC_ALT                              0x00000080                                                  
#define LS_ASTNC_GPS_DGPS                                     0x00000400                                                   
#define LS_ASTNC_GPS_UTC                                      0x00000800                                                   
#define LS_ASTNC_FRAME_TRIGGER                                0x00001000                                                  

//ConstantTable for CLMI_GPS_TIME_REF_SRC

//ConstantTable for CLMI_GPS_MULTIPATH_INDICATOR
#define CLMI_GPS_MP_NOT_MEASURED                              0x00                                                     
#define CLMI_GPS_MP_LOW                                       0x01                                                     
#define CLMI_GPS_MP_MEDIUM                                    0x02                                                     
#define CLMI_GPS_MP_HIGH                                      0x03                                                     

//ConstantTable for LS_HW_TEST_INFO
#define LS_TEST_NA                                            0x00                                                     
#define LS_TEST_PASSED                                        0x01                                                     
#define LS_TEST_FAILED                                        0x02                                                     


//STRUCTURES


//Definition for struct LS_GPS_SAT_INFO_SEQ
typedef struct
            { 
             uint8_t      prn;
             uint8_t      health;
             int16_t      elevation;
             uint16_t     azimuth;
             uint8_t      sat_status;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) LS_GPS_SAT_INFO_SEQ_STR;
#define SIZE_LS_GPS_SAT_INFO_SEQ                              sizeof(LS_GPS_SAT_INFO_SEQ_STR)


//Definition for struct LS_GPS_CHANNEL_STATUS_SEQ
typedef struct
            { 
             uint8_t      prn;
             uint8_t      common_status;
             uint8_t      cno;
             uint8_t      fillerbyte1;
             uint16_t     status;
             int16_t      elevation;
             uint16_t     azimuth;
             uint16_t     fillerbyte2;
            } __attribute__((packed)) LS_GPS_CHANNEL_STATUS_SEQ_STR;
#define SIZE_LS_GPS_CHANNEL_STATUS_SEQ                        sizeof(LS_GPS_CHANNEL_STATUS_SEQ_STR)


//Definition for struct LS_GSM_GPS_MEAS_SEQ
typedef struct
            { 
             uint8_t      sv_id;
             uint8_t      sv_cno;
             uint16_t     sv_code_ph_wh;
             uint16_t     sv_code_ph_fr;
             int16_t      ps_doppler;
             uint8_t      mul_path_ind;
             uint8_t      ps_range_rms_er;
             uint16_t     fillerbyte1;
            } __attribute__((packed)) LS_GSM_GPS_MEAS_SEQ_STR;
#define SIZE_LS_GSM_GPS_MEAS_SEQ                              sizeof(LS_GSM_GPS_MEAS_SEQ_STR)


//Definition for struct LS_GSM_GPS_MEAS_INFO_SEQ
typedef struct
            { 
             uint32_t     gps_tow;
             uint16_t     frame_number;
             uint8_t      fillerbyte1;
             uint8_t      num_prm;
             LS_GSM_GPS_MEAS_SEQ_STR    measures[0];
            } __attribute__((packed)) LS_GSM_GPS_MEAS_INFO_SEQ_STR;
#define SIZE_LS_GSM_GPS_MEAS_INFO_SEQ                         sizeof(LS_GSM_GPS_MEAS_INFO_SEQ_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct LS_WCDMA_EVENT_SEQ
typedef struct
            { 
             uint8_t      event_quantity;
             uint8_t      report_first;
             uint8_t      measurement_interval;
             uint8_t      value_7a;
             uint8_t      value_7b;
             uint8_t      value_7c;
             uint8_t      fillerbyte1;
             uint8_t      event_type;
            } __attribute__((packed)) LS_WCDMA_EVENT_SEQ_STR;
#define SIZE_LS_WCDMA_EVENT_SEQ                               sizeof(LS_WCDMA_EVENT_SEQ_STR)


//Definition for struct LS_SAT_DATA_SEQ
typedef struct
            { 
             uint8_t      satellite_id;
             uint8_t      iode;
             uint16_t     fillerbyte1;
            } __attribute__((packed)) LS_SAT_DATA_SEQ_STR;
#define SIZE_LS_SAT_DATA_SEQ                                  sizeof(LS_SAT_DATA_SEQ_STR)


//Definition for struct LS_PSEUDO_RANGE_DATA_SEQ
typedef struct
            { 
             uint8_t      satellite_id;
             uint8_t      satellite_cno;
             uint16_t     whole_chips;
             uint16_t     fractional_chips;
             int16_t      doppler;
             uint8_t      multipath_indicator;
             uint8_t      pr_rms_error;
             uint16_t     fillerbyte1;
            } __attribute__((packed)) LS_PSEUDO_RANGE_DATA_SEQ_STR;
#define SIZE_LS_PSEUDO_RANGE_DATA_SEQ                         sizeof(LS_PSEUDO_RANGE_DATA_SEQ_STR)


//Definition for struct CLMI_ASTNC_GPS_CURR_NAV_MODEL_SEQ
typedef struct
            { 
             uint8_t      sv_id;
             uint8_t      iode;
             uint16_t     fillerbyte1;
            } __attribute__((packed)) CLMI_ASTNC_GPS_CURR_NAV_MODEL_SEQ_STR;
#define SIZE_CLMI_ASTNC_GPS_CURR_NAV_MODEL_SEQ                sizeof(CLMI_ASTNC_GPS_CURR_NAV_MODEL_SEQ_STR)


//Definition for struct LS_SUPL_ASTNC_GPS_SAT_INFO_SEQ
typedef struct
            { 
             uint8_t      sat_id;
             uint8_t      iode;
             uint16_t     fillerbyte1;
            } __attribute__((packed)) LS_SUPL_ASTNC_GPS_SAT_INFO_SEQ_STR;
#define SIZE_LS_SUPL_ASTNC_GPS_SAT_INFO_SEQ                   sizeof(LS_SUPL_ASTNC_GPS_SAT_INFO_SEQ_STR)


//Definition for struct LS_NPE_CHANNELS_STATUS_SEQ
typedef struct
            { 
             uint16_t     svs_id;
             uint8_t      common_status;
             uint8_t      cno;
             uint16_t     status;
             int16_t      elevation;
             uint16_t     azimuth;
             uint16_t     fillerbyte1;
            } __attribute__((packed)) LS_NPE_CHANNELS_STATUS_SEQ_STR;
#define SIZE_LS_NPE_CHANNELS_STATUS_SEQ                       sizeof(LS_NPE_CHANNELS_STATUS_SEQ_STR)


//Definition for struct CLMI_ASTNC_GPS_TOW_ASSIST_SEQ
typedef struct
            { 
             uint32_t     tow_assist;
            } __attribute__((packed)) CLMI_ASTNC_GPS_TOW_ASSIST_SEQ_STR;
#define SIZE_CLMI_ASTNC_GPS_TOW_ASSIST_SEQ                    sizeof(CLMI_ASTNC_GPS_TOW_ASSIST_SEQ_STR)


//Definition for struct CLMI_ASTNC_GPS_DGPS_CORRECTION_SEQ
typedef struct
            { 
             uint8_t      sv_id;
             uint8_t      fillerbyte1;
             uint8_t      iode;
             uint8_t      udre;
             int16_t      prc;
             int8_t       rrc;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) CLMI_ASTNC_GPS_DGPS_CORRECTION_SEQ_STR;
#define SIZE_CLMI_ASTNC_GPS_DGPS_CORRECTION_SEQ               sizeof(CLMI_ASTNC_GPS_DGPS_CORRECTION_SEQ_STR)


//Definition for struct CLMI_ASTNC_GPS_NAV_MODEL_SEQ
typedef struct
            { 
             uint8_t      nav_model_bits;
             uint8_t      sv_accuracy;
             uint8_t      sv_health;
             uint8_t      sf1_reserved[11];
             int8_t       tgd;
             uint8_t      aodo;
            } __attribute__((packed)) CLMI_ASTNC_GPS_NAV_MODEL_SEQ_STR;
#define SIZE_CLMI_ASTNC_GPS_NAV_MODEL_SEQ                     sizeof(CLMI_ASTNC_GPS_NAV_MODEL_SEQ_STR)


//Definition for struct CLMI_ASTNC_GPS_EPHEMERIS_SEQ
typedef struct
            { 
             uint8_t      sv_id;
             uint8_t      fillerbyte1;
             int16_t      delta_n;
             int32_t      m0;
             uint32_t     e;
             uint32_t     a_sqrt;
             int32_t      omega0;
             int32_t      i0;
             int32_t      omega;
             int32_t      omegadot;
             int16_t      idot;
             int16_t      cuc;
             int16_t      cus;
             int16_t      crc;
             int16_t      crs;
             int16_t      cic;
             int16_t      cis;
             uint16_t     toe;
             uint16_t     iodc;
             uint16_t     toc;
             int32_t      af0;
             int16_t      af1;
             int8_t       af2;
             uint8_t      nav_model_incl;
			 CLMI_ASTNC_GPS_NAV_MODEL_SEQ_STR    nav_model[1];
            } __attribute__((packed)) CLMI_ASTNC_GPS_EPHEMERIS_SEQ_STR;
#define SIZE_CLMI_ASTNC_GPS_EPHEMERIS_SEQ                     sizeof(CLMI_ASTNC_GPS_EPHEMERIS_SEQ_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct CLMI_ASTNC_GPS_ALMANAC_SEQ
typedef struct
            { 
             uint8_t      sv_id;
             uint8_t      toa;
             uint16_t     e;
             int16_t      delta_i;
             int16_t      omegadot;
             uint32_t     a_sqrt;
             int32_t      omega0;
             int32_t      omega;
             int32_t      m0;
             int16_t      af0;
             int16_t      af1;
            } __attribute__((packed)) CLMI_ASTNC_GPS_ALMANAC_SEQ_STR;
#define SIZE_CLMI_ASTNC_GPS_ALMANAC_SEQ                       sizeof(CLMI_ASTNC_GPS_ALMANAC_SEQ_STR)


//Definition for struct CLMI_ASTNC_GPS_ACQUISITION_SEQ
typedef struct
            { 
             uint8_t      sv_id;
             uint8_t      parts_incl;
             int16_t      doppler0;
             int8_t       doppler1;
             uint8_t      doppler_win;
             uint16_t     sv_code_ph;
             uint8_t      sv_code_ph_int;
             uint8_t      gps_bit_num;
             uint16_t     sv_code_ph_win;
             uint8_t      azimuth;
             uint8_t      elevation;
             uint16_t     fillerbyte1;
            } __attribute__((packed)) CLMI_ASTNC_GPS_ACQUISITION_SEQ_STR;
#define SIZE_CLMI_ASTNC_GPS_ACQUISITION_SEQ                   sizeof(CLMI_ASTNC_GPS_ACQUISITION_SEQ_STR)


//Definition for struct CLMI_PSEUDORANGE_MEASUREMENT_SEQ
typedef struct
            { 
             uint8_t      sv_id;
             uint8_t      sv_cno;
             int16_t      ps_doppler;
             uint16_t     sv_code_ph_wh;
             uint16_t     sv_code_ph_fr;
             uint8_t      mul_path_ind;
             uint8_t      ps_range_rms_er;
             uint16_t     fillerbyte1;
            } __attribute__((packed)) CLMI_PSEUDORANGE_MEASUREMENT_SEQ_STR;
#define SIZE_CLMI_PSEUDORANGE_MEASUREMENT_SEQ                 sizeof(CLMI_PSEUDORANGE_MEASUREMENT_SEQ_STR)


//SUBBLOCKS


//Definition for struct LS_SB_SOCKET_ADDR
#define LS_SB_SOCKET_ADDR                                     0x1200                                                
typedef struct
            { 
             uint16_t     sb_id;
             uint16_t     sb_len;
             uint16_t     port;
             uint8_t      addrtype;
             uint8_t      ip_len;
             uint8_t      fqdn_len;
             uint8_t      fillerbyte1[3];
             uint8_t      ip_addr[0];
             uint8_t      fqdn_addr[0];
            } __attribute__((packed)) LS_SB_SOCKET_ADDR_STR;
#define SIZE_LS_SB_SOCKET_ADDR                                sizeof(LS_SB_SOCKET_ADDR_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct LS_SB_SOCKET_ADDR_EXT
#define LS_SB_SOCKET_ADDR_EXT                                 0x1201                                                
typedef struct
            { 
             uint16_t     sb_id;
             uint16_t     sb_len;
             uint8_t      use_tcp;
             uint8_t      dns_len;
             uint8_t      apn_len;
             uint8_t      apn_login_len;
             uint8_t      apn_pass_len;
             uint8_t      fillerbyte1[3];
             uint8_t      dns_addr[0];
             uint8_t      apn[0];
             uint8_t      apn_login[0];
             uint8_t      apn_pass[0];
            } __attribute__((packed)) LS_SB_SOCKET_ADDR_EXT_STR;
#define SIZE_LS_SB_SOCKET_ADDR_EXT                            sizeof(LS_SB_SOCKET_ADDR_EXT_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct LS_SB_SOCKET_BEARER_TYPE
#define LS_SB_SOCKET_BEARER_TYPE                              0x1202                                                
typedef struct
            { 
             uint16_t     sb_id;
             uint16_t     sb_len;
             uint8_t      bearer;
             uint8_t      fillerbyte1[3];
            } __attribute__((packed)) LS_SB_SOCKET_BEARER_TYPE_STR;
#define SIZE_LS_SB_SOCKET_BEARER_TYPE                         sizeof(LS_SB_SOCKET_BEARER_TYPE_STR)


//Definition for struct LS_SB_SOCKET_IPADDR
#define LS_SB_SOCKET_IPADDR                                   0x1203                                                
typedef struct
            { 
             uint16_t     sb_id;
             uint16_t     sb_len;
             uint8_t      ip_len;
             uint8_t      fillerbyte1[3];
             uint8_t      ip_addr[0];
            } __attribute__((packed)) LS_SB_SOCKET_IPADDR_STR;
#define SIZE_LS_SB_SOCKET_IPADDR                              sizeof(LS_SB_SOCKET_IPADDR_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct LS_SB_GPS_EXACT_TIME
#define LS_SB_GPS_EXACT_TIME                                  0x0160                                                   
typedef struct
            { 
             uint16_t     sb_id;
             uint16_t     sb_len;
             uint16_t     utc_year;
             uint8_t      utc_month;
             uint8_t      utc_day;
             uint8_t      utc_hour;
             uint8_t      utc_minute;
             uint16_t     utc_second;
             uint16_t     gps_week;
             uint16_t     fillerbyte1;
             uint32_t     gps_tow;
            } __attribute__((packed)) LS_SB_GPS_EXACT_TIME_STR;
#define SIZE_LS_SB_GPS_EXACT_TIME                             sizeof(LS_SB_GPS_EXACT_TIME_STR)


//Definition for struct LS_SB_GPS_USER_DOPS
#define LS_SB_GPS_USER_DOPS                                   0x0161                                                   
typedef struct
            { 
             uint16_t     sb_id;
             uint16_t     sb_len;
             uint16_t     user_gdop;
             uint16_t     user_pdop;
             uint16_t     user_hdop;
             uint16_t     user_vdop;
             uint16_t     user_tdop;
             uint16_t     fillerbyte1;
            } __attribute__((packed)) LS_SB_GPS_USER_DOPS_STR;
#define SIZE_LS_SB_GPS_USER_DOPS                              sizeof(LS_SB_GPS_USER_DOPS_STR)


//Definition for struct LS_SB_GPS_SAT_LIST
#define LS_SB_GPS_SAT_LIST                                    0x0162                                                   
typedef struct
            { 
             uint16_t     sb_id;
             uint16_t     sb_len;
             uint8_t      sat_count;
             uint8_t      fillerbyte1[3];
             LS_GPS_SAT_INFO_SEQ_STR    sat_info[0];
            } __attribute__((packed)) LS_SB_GPS_SAT_LIST_STR;
#define SIZE_LS_SB_GPS_SAT_LIST                               sizeof(LS_SB_GPS_SAT_LIST_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct LS_SB_GPS_CHANNEL_STATUS
#define LS_SB_GPS_CHANNEL_STATUS                              0x0163                                                   
typedef struct
            { 
             uint16_t     sb_id;
             uint16_t     sb_len;
             uint16_t     fillerbyte1;
             uint8_t      used_sv_count;
             uint8_t      channel_count;
             LS_GPS_CHANNEL_STATUS_SEQ_STR    channel_status[0];
            } __attribute__((packed)) LS_SB_GPS_CHANNEL_STATUS_STR;
#define SIZE_LS_SB_GPS_CHANNEL_STATUS                         sizeof(LS_SB_GPS_CHANNEL_STATUS_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct LS_SB_GSM_POSITIONING_INSTR
#define LS_SB_GSM_POSITIONING_INSTR                           0x052A                                                   
typedef struct
            { 
             uint16_t     sb_id;
             uint16_t     sb_len;
             uint8_t      method_type;
             uint8_t      positioning_method;
             uint8_t      response_time;
             uint8_t      accuracy;
             uint8_t      multiple_sets;
             uint8_t      env_character;
             uint16_t     fillerbyte1;
            } __attribute__((packed)) LS_SB_GSM_POSITIONING_INSTR_STR;
#define SIZE_LS_SB_GSM_POSITIONING_INSTR                      sizeof(LS_SB_GSM_POSITIONING_INSTR_STR)


//Definition for struct LS_SB_GSM_EXT_REF_ID
#define LS_SB_GSM_EXT_REF_ID                                  0x052D                                                   
typedef struct
            { 
             uint16_t     sb_id;
             uint16_t     sb_len;
             uint32_t     ext_tran_id;
             uint8_t      smlc_code;
             uint8_t      fillerbyte1[3];
            } __attribute__((packed)) LS_SB_GSM_EXT_REF_ID_STR;
#define SIZE_LS_SB_GSM_EXT_REF_ID                             sizeof(LS_SB_GSM_EXT_REF_ID_STR)


//Definition for struct LS_SB_GSM_GPS_MEAS_INFO
#define LS_SB_GSM_GPS_MEAS_INFO                               0x052C                                                   
typedef struct
            { 
             uint16_t     sb_id;
             uint16_t     sb_len;
             uint8_t      fillerbyte1[3];
             uint8_t      measurement_sets;
             LS_GSM_GPS_MEAS_INFO_SEQ_STR    meas_sets[0];
            } __attribute__((packed)) LS_SB_GSM_GPS_MEAS_INFO_STR;
#define SIZE_LS_SB_GSM_GPS_MEAS_INFO                          sizeof(LS_SB_GSM_GPS_MEAS_INFO_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct LS_SB_GSM_MULTIPLE_SETS
#define LS_SB_GSM_MULTIPLE_SETS                               0x0524                                                   
typedef struct
            { 
             uint16_t     sb_id;
             uint16_t     sb_len;
             uint8_t      measurement_sets;
             uint8_t      reference_btss;
             uint8_t      btss_sets_relation;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) LS_SB_GSM_MULTIPLE_SETS_STR;
#define SIZE_LS_SB_GSM_MULTIPLE_SETS                          sizeof(LS_SB_GSM_MULTIPLE_SETS_STR)


//Definition for struct LS_SB_GSM_GPS_TIME_ASSIST_MEAS
#define LS_SB_GSM_GPS_TIME_ASSIST_MEAS                        0x0530                                                   
typedef struct
            { 
             uint16_t     sb_id;
             uint16_t     sb_len;
             uint16_t     gps_tow_subms;
             uint8_t      ref_frame_msb;
             uint8_t      delta_tow;
             uint8_t      gps_ref_time_unc;
             uint8_t      fillerbyte1[3];
            } __attribute__((packed)) LS_SB_GSM_GPS_TIME_ASSIST_MEAS_STR;
#define SIZE_LS_SB_GSM_GPS_TIME_ASSIST_MEAS                   sizeof(LS_SB_GSM_GPS_TIME_ASSIST_MEAS_STR)


//Definition for struct LS_SB_GSM_REQUIRED_RESPONSE_TIME
#define LS_SB_GSM_REQUIRED_RESPONSE_TIME                      0x0531                                                   
typedef struct
            { 
             uint16_t     sb_id;
             uint16_t     sb_len;
             uint8_t      required_response_time;
             uint8_t      fillerbyte1[3];
            } __attribute__((packed)) LS_SB_GSM_REQUIRED_RESPONSE_TIME_STR;
#define SIZE_LS_SB_GSM_REQUIRED_RESPONSE_TIME                 sizeof(LS_SB_GSM_REQUIRED_RESPONSE_TIME_STR)


//Definition for struct LS_SB_GSM_LOCATION_INFO
#define LS_SB_GSM_LOCATION_INFO                               0x052B                                                   
typedef struct
            { 
             uint16_t     sb_id;
             uint16_t     sb_len;
             uint32_t     gps_tow;
             uint16_t     frame_number;
             uint8_t      fix_type;
             uint8_t      byte_count;
             uint8_t      pos_est[0];
            } __attribute__((packed)) LS_SB_GSM_LOCATION_INFO_STR;
#define SIZE_LS_SB_GSM_LOCATION_INFO                          sizeof(LS_SB_GSM_LOCATION_INFO_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct LS_SB_GSM_MEAS_ERROR_INFO
#define LS_SB_GSM_MEAS_ERROR_INFO                             0x0529                                                   
typedef struct
            { 
             uint16_t     sb_id;
             uint16_t     sb_len;
             uint8_t      error_reason;
             uint8_t      length;
             uint8_t      data[0];
            } __attribute__((packed)) LS_SB_GSM_MEAS_ERROR_INFO_STR;
#define SIZE_LS_SB_GSM_MEAS_ERROR_INFO                        sizeof(LS_SB_GSM_MEAS_ERROR_INFO_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct LS_SB_SS_CLIENT_EXT_ID
#define LS_SB_SS_CLIENT_EXT_ID                                0x0551                                                   
typedef struct
            { 
             uint16_t     sb_id;
             uint16_t     sb_len;
             uint8_t      number_plan;
             uint8_t      number_type;
             uint8_t      fillerbyte1;
             uint8_t      data_len;
             uint16_t     client_external_id[0];
            } __attribute__((packed)) LS_SB_SS_CLIENT_EXT_ID_STR;
#define SIZE_LS_SB_SS_CLIENT_EXT_ID                           sizeof(LS_SB_SS_CLIENT_EXT_ID_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct LS_SB_SS_CLIENT_NAME
#define LS_SB_SS_CLIENT_NAME                                  0x0554                                                   
typedef struct
            { 
             uint16_t     sb_id;
             uint16_t     sb_len;
             uint16_t     fillerbyte1;
             uint8_t      priv_info_type;
             uint8_t      name_len;
             uint16_t     ussd_string[0];
            } __attribute__((packed)) LS_SB_SS_CLIENT_NAME_STR;
#define SIZE_LS_SB_SS_CLIENT_NAME                             sizeof(LS_SB_SS_CLIENT_NAME_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct LS_SB_SS_NOTIFICATION_INFO
#define LS_SB_SS_NOTIFICATION_INFO                            0x0556                                                   
typedef struct
            { 
             uint16_t     sb_id;
             uint16_t     sb_len;
             uint8_t      location_type;
             uint8_t      notification_type;
             uint8_t      result;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) LS_SB_SS_NOTIFICATION_INFO_STR;
#define SIZE_LS_SB_SS_NOTIFICATION_INFO                       sizeof(LS_SB_SS_NOTIFICATION_INFO_STR)


//Definition for struct LS_SB_LTM_TEST_ABORT
#define LS_SB_LTM_TEST_ABORT                                  0x0689                                                   
typedef struct
            { 
             uint16_t     sb_id;
             uint16_t     sb_len;
            } __attribute__((packed)) LS_SB_LTM_TEST_ABORT_STR;
#define SIZE_LS_SB_LTM_TEST_ABORT                             sizeof(LS_SB_LTM_TEST_ABORT_STR)


//Definition for struct LS_SB_WCDMA_POSITIONING_INSTR
#define LS_SB_WCDMA_POSITIONING_INSTR                         0x0A00                                                   
typedef struct
            { 
             uint16_t     sb_id;
             uint16_t     sb_len;
             uint8_t      measurement_id;
             uint8_t      measurement_command;
             uint8_t      method_type;
             uint8_t      positioning_method;
             uint8_t      h_accuracy;
             uint8_t      v_accuracy;
             uint8_t      gps_sfn_timing;
             uint8_t      env_character;
             uint8_t      add_data;
             uint8_t      report_criteria;
             uint8_t      report_quantity;
             uint8_t      report_interval;
             uint8_t      num_events;
             uint8_t      fillerbyte1[3];
             LS_WCDMA_EVENT_SEQ_STR    events[0];
            } __attribute__((packed)) LS_SB_WCDMA_POSITIONING_INSTR_STR;
#define SIZE_LS_SB_WCDMA_POSITIONING_INSTR                    sizeof(LS_SB_WCDMA_POSITIONING_INSTR_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct LS_SB_WCDMA_LOCATION_INFO
#define LS_SB_WCDMA_LOCATION_INFO                             0x0A01                                                   
typedef struct
            { 
             uint16_t     sb_id;
             uint16_t     sb_len;
             uint8_t      ref_time_type;
             uint8_t      fillerbyte1;
             uint16_t     cellfrtime_ms;
             uint32_t     cellfrtime_ls;
             uint16_t     sfn;
             uint16_t     scrambling_code;
             uint32_t     gps_ref_time_only;
             uint8_t      est_type;
             uint8_t      un_semi_major;
             uint8_t      un_semi_minor;
             uint8_t      latitude_sign;
             uint32_t     latitude;
             int32_t      longitude;
             uint8_t      un_altitude;
             uint8_t      altitude_dir;
             uint16_t     altitude;
             uint8_t      un_code;
             uint8_t      orientation;
             uint8_t      confidence;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) LS_SB_WCDMA_LOCATION_INFO_STR;
#define SIZE_LS_SB_WCDMA_LOCATION_INFO                        sizeof(LS_SB_WCDMA_LOCATION_INFO_STR)


//Definition for struct LS_SB_WCDMA_MEAS_ERROR_INFO
#define LS_SB_WCDMA_MEAS_ERROR_INFO                           0x0A02                                                   
typedef struct
            { 
             uint16_t     sb_id;
             uint16_t     sb_len;
             uint8_t      error;
             uint8_t      ad_req;
             uint8_t      almanac_req;
             uint8_t      utc_model_req;
             uint8_t      ionspheric_model_req;
             uint8_t      navigation_model_req;
             uint8_t      dgps_corrections_req;
             uint8_t      reference_location_req;
             uint8_t      ref_time_req;
             uint8_t      aa_req;
             uint8_t      rt_intregrity_req;
             uint8_t      navigation_model_ad_req;
             uint16_t     gps_week;
             uint8_t      gps_toe;
             uint8_t      ttoe_limit;
             uint8_t      fillerbyte1[3];
             uint8_t      nbr_satellites;
             LS_SAT_DATA_SEQ_STR    pos_est[0];
            } __attribute__((packed)) LS_SB_WCDMA_MEAS_ERROR_INFO_STR;
#define SIZE_LS_SB_WCDMA_MEAS_ERROR_INFO                      sizeof(LS_SB_WCDMA_MEAS_ERROR_INFO_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct LS_SB_WCDMA_GPS_MEAS_INFO
#define LS_SB_WCDMA_GPS_MEAS_INFO                             0x0A03                                                   
typedef struct
            { 
             uint16_t     sb_id;
             uint16_t     sb_len;
             uint8_t      ref_time_type;
             uint8_t      fillerbyte1;
             uint16_t     cellfrtime_ms;
             uint32_t     cellfrtime_ls;
             uint16_t     sfn;
             uint16_t     scrambling_code;
             uint32_t     gps_ref_time_only;
             uint8_t      fillerbyte2[3];
             uint8_t      nbr_satellites;
             LS_PSEUDO_RANGE_DATA_SEQ_STR    pos_est[0];
            } __attribute__((packed)) LS_SB_WCDMA_GPS_MEAS_INFO_STR;
#define SIZE_LS_SB_WCDMA_GPS_MEAS_INFO                        sizeof(LS_SB_WCDMA_GPS_MEAS_INFO_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct LS_SB_LTM_AI2_CMD_PACKET
#define LS_SB_LTM_AI2_CMD_PACKET                              0x070B                                                   
typedef struct
            { 
             uint16_t     sb_id;
             uint16_t     sb_len;
             uint16_t     length;
             uint8_t      data;
            } __attribute__((packed)) LS_SB_LTM_AI2_CMD_PACKET_STR;
#define SIZE_LS_SB_LTM_AI2_CMD_PACKET                         sizeof(LS_SB_LTM_AI2_CMD_PACKET_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct LS_SB_LTM_AI2_RSP_PACKET
#define LS_SB_LTM_AI2_RSP_PACKET                              0x070C                                                   
typedef struct
            { 
             uint16_t     sb_id;
             uint16_t     sb_len;
             uint16_t     length;
             uint8_t      data;
            } __attribute__((packed)) LS_SB_LTM_AI2_RSP_PACKET_STR;
#define SIZE_LS_SB_LTM_AI2_RSP_PACKET                         sizeof(LS_SB_LTM_AI2_RSP_PACKET_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct LS_SB_LTM_DELETE_ASSISTANCE_DATA
#define LS_SB_LTM_DELETE_ASSISTANCE_DATA                      0x070D                                                   
typedef struct
            { 
             uint16_t     sb_id;
             uint16_t     sb_len;
             uint8_t      delete_selection;
             uint8_t      sv_id;
             uint16_t     fillerbyte1;
            } __attribute__((packed)) LS_SB_LTM_DELETE_ASSISTANCE_DATA_STR;
#define SIZE_LS_SB_LTM_DELETE_ASSISTANCE_DATA                 sizeof(LS_SB_LTM_DELETE_ASSISTANCE_DATA_STR)


//Definition for struct LS_SB_PRIVACY
#define LS_SB_PRIVACY                                         0x0103                                                   
typedef struct
            { 
             uint16_t     sb_id;
             uint16_t     sb_len;
             uint8_t      priv_info_type;
             uint8_t      fillerbyte1;
             uint16_t     string_len;
             uint8_t      priv_string[0];
            } __attribute__((packed)) LS_SB_PRIVACY_STR;
#define SIZE_LS_SB_PRIVACY                                    sizeof(LS_SB_PRIVACY_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct LS_SB_SS_REQUESTOR_ID
#define LS_SB_SS_REQUESTOR_ID                                 0x0109                                                   
typedef struct
            { 
             uint16_t     sb_id;
             uint16_t     sb_len;
             uint8_t      priv_info_type;
             uint8_t      fillerbyte1;
             uint16_t     string_len;
             uint16_t     requestor_string[0];
            } __attribute__((packed)) LS_SB_SS_REQUESTOR_ID_STR;
#define SIZE_LS_SB_SS_REQUESTOR_ID                            sizeof(LS_SB_SS_REQUESTOR_ID_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct LS_SB_SS_CODEWORD
#define LS_SB_SS_CODEWORD                                     0x010A                                                   
typedef struct
            { 
             uint16_t     sb_id;
             uint16_t     sb_len;
             uint8_t      fillerbyte1;
             uint8_t      string_len;
             uint16_t     codeword_string[0];
            } __attribute__((packed)) LS_SB_SS_CODEWORD_STR;
#define SIZE_LS_SB_SS_CODEWORD                                sizeof(LS_SB_SS_CODEWORD_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct LS_SB_SS_SERVICE_TYPE_ID
#define LS_SB_SS_SERVICE_TYPE_ID                              0x010B                                                   
typedef struct
            { 
             uint16_t     sb_id;
             uint16_t     sb_len;
             uint8_t      service_type;
             uint8_t      fillerbyte1[3];
            } __attribute__((packed)) LS_SB_SS_SERVICE_TYPE_ID_STR;
#define SIZE_LS_SB_SS_SERVICE_TYPE_ID                         sizeof(LS_SB_SS_SERVICE_TYPE_ID_STR)


//Definition for struct LS_SB_JAVA_INFO
#define LS_SB_JAVA_INFO                                       0x0105                                                   
typedef struct
            { 
             uint16_t     sb_id;
             uint16_t     sb_len;
             uint32_t     midlet_id;
             uint8_t      unique_id[21];
             uint8_t      name_len;
             uint16_t     name[0];
            } __attribute__((packed)) LS_SB_JAVA_INFO_STR;
#define SIZE_LS_SB_JAVA_INFO                                  sizeof(LS_SB_JAVA_INFO_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct LS_SB_CDMA_WAP_INFO
#define LS_SB_CDMA_WAP_INFO                                   0x0108                                                   
typedef struct
            { 
             uint16_t     sb_id;
             uint16_t     sb_len;
             uint8_t      url_code;
             uint8_t      fillerbyte1;
             uint16_t     url_len;
             uint8_t      url[0];
            } __attribute__((packed)) LS_SB_CDMA_WAP_INFO_STR;
#define SIZE_LS_SB_CDMA_WAP_INFO                              sizeof(LS_SB_CDMA_WAP_INFO_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct CLMI_SB_ASTNC_GPS_CURR_NAV_MODEL
#define CLMI_SB_ASTNC_GPS_CURR_NAV_MODEL                      0x0999                                                   
typedef struct
            { 
             uint16_t     sb_id;
             uint16_t     sb_len;
             uint16_t     gps_week;
             uint8_t      gps_toe;
             uint8_t      toe_limit;
             uint8_t      fillerbyte1[3];
             uint8_t      n_iodes;
             CLMI_ASTNC_GPS_CURR_NAV_MODEL_SEQ_STR    iodes[0];
            } __attribute__((packed)) CLMI_SB_ASTNC_GPS_CURR_NAV_MODEL_STR;
#define SIZE_CLMI_SB_ASTNC_GPS_CURR_NAV_MODEL                 sizeof(CLMI_SB_ASTNC_GPS_CURR_NAV_MODEL_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct LS_SB_TIMESTAMP
#define LS_SB_TIMESTAMP                                       0x0134                                                   
typedef struct
            { 
             uint16_t     sb_id;
             uint16_t     sb_len;
             uint16_t     year;
             uint8_t      month;
             uint8_t      day;
             uint8_t      hour;
             uint8_t      minute;
             uint8_t      second;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) LS_SB_TIMESTAMP_STR;
#define SIZE_LS_SB_TIMESTAMP                                  sizeof(LS_SB_TIMESTAMP_STR)


//Definition for struct LS_SB_NMEA_OPTIONS
#define LS_SB_NMEA_OPTIONS                                    0x0135                                                   
typedef struct
            { 
             uint16_t     sb_id;
             uint16_t     sb_len;
             uint32_t     options;
            } __attribute__((packed)) LS_SB_NMEA_OPTIONS_STR;
#define SIZE_LS_SB_NMEA_OPTIONS                               sizeof(LS_SB_NMEA_OPTIONS_STR)


//Definition for struct LS_SB_LATITUDE_LONGITUDE
#define LS_SB_LATITUDE_LONGITUDE                              0x0130                                                   
typedef struct
            { 
             uint16_t     sb_id;
             uint16_t     sb_len;
             int32_t      latitude;
             int32_t      longitude;
             uint32_t     uncertainty_a;
             uint32_t     uncertainty_p;
             uint8_t      uncertainty_ang;
             uint8_t      fix_type;
             uint16_t     fillerbyte1;
            } __attribute__((packed)) LS_SB_LATITUDE_LONGITUDE_STR;
#define SIZE_LS_SB_LATITUDE_LONGITUDE                         sizeof(LS_SB_LATITUDE_LONGITUDE_STR)


//Definition for struct LS_SB_ALTITUDE
#define LS_SB_ALTITUDE                                        0x0131                                                   
typedef struct
            { 
             uint16_t     sb_id;
             uint16_t     sb_len;
             int16_t      altitude;
             uint16_t     uncertainty;
             int16_t      altitude_msl;
             uint16_t     fillerbyte1;
            } __attribute__((packed)) LS_SB_ALTITUDE_STR;
#define SIZE_LS_SB_ALTITUDE                                   sizeof(LS_SB_ALTITUDE_STR)


//Definition for struct LS_SB_VELOCITY
#define LS_SB_VELOCITY                                        0x0132                                                   
typedef struct
            { 
             uint16_t     sb_id;
             uint16_t     sb_len;
             uint16_t     heading;
             uint16_t     heading_magnetic;
             uint16_t     heading_uncrtnty;
             uint16_t     speed_hor;
             uint16_t     speed_hor_uncrtnty;
             int16_t      speed_ver;
             uint16_t     speed_ver_uncrtnty;
             uint16_t     fillerbyte1;
            } __attribute__((packed)) LS_SB_VELOCITY_STR;
#define SIZE_LS_SB_VELOCITY                                   sizeof(LS_SB_VELOCITY_STR)


//Definition for struct LS_SB_NMEA_0183
#define LS_SB_NMEA_0183                                       0x0133                                                   
typedef struct
            { 
             uint16_t     sb_id;
             uint16_t     sb_len;
             uint16_t     size;
             uint8_t      str[0];
            } __attribute__((packed)) LS_SB_NMEA_0183_STR;
#define SIZE_LS_SB_NMEA_0183                                  sizeof(LS_SB_NMEA_0183_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct LS_SB_METHOD_INFORMATION
#define LS_SB_METHOD_INFORMATION                              0xEFEE                                                
typedef struct
            { 
             uint16_t     sb_id;
             uint16_t     sb_len;
             uint8_t      method;
             uint8_t      status;
             uint8_t      resource_lock;
             uint8_t      fillerbyte1;
             uint32_t     capabilities;
             uint8_t      cost;
             uint8_t      power_consumption;
             uint16_t     ttff;
             uint16_t     ttnf;
             uint16_t     uncertainty_hor;
             uint16_t     uncertainty_ver;
             uint16_t     fillerbyte2;
            } __attribute__((packed)) LS_SB_METHOD_INFORMATION_STR;
#define SIZE_LS_SB_METHOD_INFORMATION                         sizeof(LS_SB_METHOD_INFORMATION_STR)


//Definition for struct LS_SB_SENSOR_TYPE
#define LS_SB_SENSOR_TYPE                                     0x1101                                                
typedef struct
            { 
             uint16_t     sb_id;
             uint16_t     sb_len;
             uint8_t      type;
             uint8_t      fillerbyte1[3];
            } __attribute__((packed)) LS_SB_SENSOR_TYPE_STR;
#define SIZE_LS_SB_SENSOR_TYPE                                sizeof(LS_SB_SENSOR_TYPE_STR)


//Definition for struct LS_SB_SENSOR_REGISTRATION_STATUS
#define LS_SB_SENSOR_REGISTRATION_STATUS                      0x1100                                                
typedef struct
            { 
             uint16_t     sb_id;
             uint16_t     sb_len;
             uint8_t      status;
             uint8_t      fillerbyte1[3];
            } __attribute__((packed)) LS_SB_SENSOR_REGISTRATION_STATUS_STR;
#define SIZE_LS_SB_SENSOR_REGISTRATION_STATUS                 sizeof(LS_SB_SENSOR_REGISTRATION_STATUS_STR)


//Definition for struct LS_SB_SENSOR_ACCELEROMETER_ACTION
#define LS_SB_SENSOR_ACCELEROMETER_ACTION                     0x1102                                                
typedef struct
            { 
             uint16_t     sb_id;
             uint16_t     sb_len;
             uint8_t      action;
             uint8_t      fillerbyte1[3];
            } __attribute__((packed)) LS_SB_SENSOR_ACCELEROMETER_ACTION_STR;
#define SIZE_LS_SB_SENSOR_ACCELEROMETER_ACTION                sizeof(LS_SB_SENSOR_ACCELEROMETER_ACTION_STR)


//Definition for struct LS_SB_SUPL_RRLP_LOOPBACK
#define LS_SB_SUPL_RRLP_LOOPBACK                              0x0807                                                   
typedef struct
            { 
             uint16_t     sb_id;
             uint16_t     sb_len;
             uint32_t     supl_id;
             uint8_t      rrlp_ref_nbr;
             uint8_t      status;
             uint16_t     fillerbyte1;
            } __attribute__((packed)) LS_SB_SUPL_RRLP_LOOPBACK_STR;
#define SIZE_LS_SB_SUPL_RRLP_LOOPBACK                         sizeof(LS_SB_SUPL_RRLP_LOOPBACK_STR)


//Definition for struct LS_SB_SUPL_TIMESTAMP
#define LS_SB_SUPL_TIMESTAMP                                  0x0800                                                   
typedef struct
            { 
             uint16_t     sb_id;
             uint16_t     sb_len;
             uint16_t     year;
             uint8_t      month;
             uint8_t      day;
             uint8_t      hour;
             uint8_t      minute;
             uint16_t     second;
            } __attribute__((packed)) LS_SB_SUPL_TIMESTAMP_STR;
#define SIZE_LS_SB_SUPL_TIMESTAMP                             sizeof(LS_SB_SUPL_TIMESTAMP_STR)


//Definition for struct LS_SB_SUPL_POSITION
#define LS_SB_SUPL_POSITION                                   0x0801                                                   
typedef struct
            { 
             uint16_t     sb_id;
             uint16_t     sb_len;
             uint8_t      uncertainty_present;
             uint8_t      altitude_present;
             uint8_t      fillerbyte1;
             uint8_t      latitude_sign;
             uint32_t     latitude;
             int32_t      longitude;
             uint8_t      uncert_semi_major;
             uint8_t      uncert_semi_minor;
             uint8_t      orient_major_axis;
             uint8_t      confidence;
             uint16_t     altitude;
             uint8_t      direction;
             uint8_t      uncert_altitude;
            } __attribute__((packed)) LS_SB_SUPL_POSITION_STR;
#define SIZE_LS_SB_SUPL_POSITION                              sizeof(LS_SB_SUPL_POSITION_STR)


//Definition for struct LS_SB_SUPL_SESSION_POSITION
#define LS_SB_SUPL_SESSION_POSITION                           0x0809                                                   
typedef struct
            { 
             uint16_t     sb_id;
             uint16_t     sb_len;
             uint8_t      fillerbyte1[3];
             uint8_t      latitude_sign;
             uint32_t     latitude;
             int32_t      longitude;
             uint32_t     horiz_uncert;
             uint8_t      altitude_present;
             uint8_t      direction;
             uint16_t     altitude;
             uint16_t     vert_uncert;
             uint16_t     fillerbyte2;
            } __attribute__((packed)) LS_SB_SUPL_SESSION_POSITION_STR;
#define SIZE_LS_SB_SUPL_SESSION_POSITION                      sizeof(LS_SB_SUPL_SESSION_POSITION_STR)


//Definition for struct LS_SB_SUPL_VELOCITY
#define LS_SB_SUPL_VELOCITY                                   0x0802                                                   
typedef struct
            { 
             uint16_t     sb_id;
             uint16_t     sb_len;
             uint8_t      type;
             uint8_t      fillerbyte1[3];
             uint16_t     horizontal_speed;
             uint16_t     bearing;
             uint8_t      direction;
             uint8_t      vertical_speed;
             uint8_t      horizontal_uncertainty_speed;
             uint8_t      vertical_uncertainty_speed;
            } __attribute__((packed)) LS_SB_SUPL_VELOCITY_STR;
#define SIZE_LS_SB_SUPL_VELOCITY                              sizeof(LS_SB_SUPL_VELOCITY_STR)


//Definition for struct LS_SB_SUPL_ALLOWED_CAPABILITIES
#define LS_SB_SUPL_ALLOWED_CAPABILITIES                       0x0803                                                   
typedef struct
            { 
             uint16_t     sb_id;
             uint16_t     sb_len;
             uint32_t     allowed_capabilities;
            } __attribute__((packed)) LS_SB_SUPL_ALLOWED_CAPABILITIES_STR;
#define SIZE_LS_SB_SUPL_ALLOWED_CAPABILITIES                  sizeof(LS_SB_SUPL_ALLOWED_CAPABILITIES_STR)


//Definition for struct LS_SB_SUPL_SERVER_METHOD
#define LS_SB_SUPL_SERVER_METHOD                              0x080A                                                   
typedef struct
            { 
             uint16_t     sb_id;
             uint16_t     sb_len;
             uint32_t     server_method;
            } __attribute__((packed)) LS_SB_SUPL_SERVER_METHOD_STR;
#define SIZE_LS_SB_SUPL_SERVER_METHOD                         sizeof(LS_SB_SUPL_SERVER_METHOD_STR)


//Definition for struct LS_SB_SUPL_INFO_SET_CAPABILITIES
#define LS_SB_SUPL_INFO_SET_CAPABILITIES                      0x0804                                                   
typedef struct
            { 
             uint16_t     sb_id;
             uint16_t     sb_len;
             uint32_t     set_capabilities;
            } __attribute__((packed)) LS_SB_SUPL_INFO_SET_CAPABILITIES_STR;
#define SIZE_LS_SB_SUPL_INFO_SET_CAPABILITIES                 sizeof(LS_SB_SUPL_INFO_SET_CAPABILITIES_STR)


//Definition for struct LS_SB_SUPL_INFO_AD_REQUEST
#define LS_SB_SUPL_INFO_AD_REQUEST                            0x0805                                                   
typedef struct
            { 
             uint16_t     sb_id;
             uint16_t     sb_len;
             uint32_t     requests;
             uint16_t     gps_week;
             uint8_t      gps_toe;
             uint8_t      toe_limit;
             uint8_t      fillerbyte1[3];
             uint8_t      n_sat;
             LS_SUPL_ASTNC_GPS_SAT_INFO_SEQ_STR    sat_info[0];
            } __attribute__((packed)) LS_SB_SUPL_INFO_AD_REQUEST_STR;
#define SIZE_LS_SB_SUPL_INFO_AD_REQUEST                       sizeof(LS_SB_SUPL_INFO_AD_REQUEST_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct LS_SB_SUPL_POS
#define LS_SB_SUPL_POS                                        0x0806                                                   
typedef struct
            { 
             uint16_t     sb_id;
             uint16_t     sb_len;
             uint8_t      pos_type;
             uint8_t      fillerbyte1;
             uint16_t     pos_len;
             uint8_t      pos[0];
            } __attribute__((packed)) LS_SB_SUPL_POS_STR;
#define SIZE_LS_SB_SUPL_POS                                   sizeof(LS_SB_SUPL_POS_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct LS_SB_SUPL_QOP
#define LS_SB_SUPL_QOP                                        0x0808                                                   
typedef struct
            { 
             uint16_t     sb_id;
             uint16_t     sb_len;
             uint16_t     max_loc_age;
             uint8_t      horiz_uncert;
             uint8_t      vert_uncert;
             uint8_t      delay;
             uint8_t      qop_parameters;
             uint16_t     fillerbyte1;
            } __attribute__((packed)) LS_SB_SUPL_QOP_STR;
#define SIZE_LS_SB_SUPL_QOP                                   sizeof(LS_SB_SUPL_QOP_STR)


//Definition for struct LS_SB_HYBRID_TRACKING_INSTR
#define LS_SB_HYBRID_TRACKING_INSTR                           0x0901                                                   
typedef struct
            { 
             uint16_t     sb_id;
             uint16_t     sb_len;
             uint32_t     allowed_methods;
             uint32_t     options;
             uint16_t     interval;
             uint8_t      report_criteria;
             uint8_t      acwp_timer;
            } __attribute__((packed)) LS_SB_HYBRID_TRACKING_INSTR_STR;
#define SIZE_LS_SB_HYBRID_TRACKING_INSTR                      sizeof(LS_SB_HYBRID_TRACKING_INSTR_STR)


//Definition for struct LS_SB_CLIENT_IDENT
#define LS_SB_CLIENT_IDENT                                    0x0900                                                   
typedef struct
            { 
             uint16_t     sb_id;
             uint16_t     sb_len;
             uint8_t      fillerbyte1[3];
             uint8_t      name_len;
             uint16_t     client_string[0];
            } __attribute__((packed)) LS_SB_CLIENT_IDENT_STR;
#define SIZE_LS_SB_CLIENT_IDENT                               sizeof(LS_SB_CLIENT_IDENT_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct LS_SB_NPE_POSITION
#define LS_SB_NPE_POSITION                                    0x0902                                                   
typedef struct
            { 
             uint16_t     sb_id;
             uint16_t     sb_len;
             int32_t      latitude;
             int32_t      longitude;
             uint32_t     uncertainty_a;
             uint32_t     uncertainty_p;
             uint8_t      uncertainty_ang;
             uint8_t      fillerbyte1;
             int16_t      altitude;
             uint16_t     uncertainty_alt;
             int16_t      geoid_separation;
            } __attribute__((packed)) LS_SB_NPE_POSITION_STR;
#define SIZE_LS_SB_NPE_POSITION                               sizeof(LS_SB_NPE_POSITION_STR)


//Definition for struct LS_SB_NPE_TIME
#define LS_SB_NPE_TIME                                        0x0903                                                   
typedef struct
            { 
             uint16_t     sb_id;
             uint16_t     sb_len;
             uint16_t     utc_year;
             uint8_t      utc_month;
             uint8_t      utc_day;
             uint8_t      utc_wday;
             uint8_t      utc_hour;
             uint8_t      utc_min;
             uint8_t      fillerbyte1;
             uint16_t     utc_millisec;
             uint16_t     fillerbyte2;
            } __attribute__((packed)) LS_SB_NPE_TIME_STR;
#define SIZE_LS_SB_NPE_TIME                                   sizeof(LS_SB_NPE_TIME_STR)


//Definition for struct LS_SB_NPE_VELOCITY
#define LS_SB_NPE_VELOCITY                                    0x0904                                                   
typedef struct
            { 
             uint16_t     sb_id;
             uint16_t     sb_len;
             uint16_t     heading;
             uint16_t     heading_unc;
             int16_t      magnetic_declination;
             uint16_t     speed_hor;
             uint16_t     speed_hor_unc;
             int16_t      speed_ver;
             uint16_t     speed_ver_unc;
             uint16_t     fillerbyte1;
            } __attribute__((packed)) LS_SB_NPE_VELOCITY_STR;
#define SIZE_LS_SB_NPE_VELOCITY                               sizeof(LS_SB_NPE_VELOCITY_STR)


//Definition for struct LS_SB_NPE_CHANNELS
#define LS_SB_NPE_CHANNELS                                    0x0905                                                   
typedef struct
            { 
             uint16_t     sb_id;
             uint16_t     sb_len;
             uint8_t      channel_count;
             uint8_t      fillerbyte1[3];
             LS_NPE_CHANNELS_STATUS_SEQ_STR    channel_status[0];
            } __attribute__((packed)) LS_SB_NPE_CHANNELS_STR;
#define SIZE_LS_SB_NPE_CHANNELS                               sizeof(LS_SB_NPE_CHANNELS_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct LS_SB_NPE_NMEA
#define LS_SB_NPE_NMEA                                        0x0906                                                   
typedef struct
            { 
             uint16_t     sb_id;
             uint16_t     sb_len;
             uint16_t     size;
             uint8_t      str[0];
            } __attribute__((packed)) LS_SB_NPE_NMEA_STR;
#define SIZE_LS_SB_NPE_NMEA                                   sizeof(LS_SB_NPE_NMEA_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct LS_SB_CELL_INFO_GSM
#define LS_SB_CELL_INFO_GSM                                   0x0907                                                   
typedef struct
            { 
             uint16_t     sb_id;
             uint16_t     sb_len;
             uint16_t     current_mcc;
             uint16_t     current_mnc;
             uint16_t     current_lac;
             uint16_t     current_cell_id;
            } __attribute__((packed)) LS_SB_CELL_INFO_GSM_STR;
#define SIZE_LS_SB_CELL_INFO_GSM                              sizeof(LS_SB_CELL_INFO_GSM_STR)


//Definition for struct LS_SB_CELL_INFO_WCDMA
#define LS_SB_CELL_INFO_WCDMA                                 0x0908                                                   
typedef struct
            { 
             uint16_t     sb_id;
             uint16_t     sb_len;
             uint16_t     current_mcc;
             uint16_t     current_mnc;
             uint32_t     current_uc_id;
            } __attribute__((packed)) LS_SB_CELL_INFO_WCDMA_STR;
#define SIZE_LS_SB_CELL_INFO_WCDMA                            sizeof(LS_SB_CELL_INFO_WCDMA_STR)


//Definition for struct CLMI_SB_ASTNC_GPS_REF_TIME
#define CLMI_SB_ASTNC_GPS_REF_TIME                            0x1030                                                
typedef struct
            { 
             uint16_t     sb_id;
             uint16_t     sb_len;
             uint32_t     gps_tow_int;
             uint32_t     gps_tow_frac;
             uint16_t     gps_week;
             uint8_t      time_available;
             uint8_t      time_hw_synchronized;
             uint16_t     time_accuracy_value;
             uint8_t      fillerbyte1;
             uint8_t      n_ta;
             CLMI_ASTNC_GPS_TOW_ASSIST_SEQ_STR    gps_tow_assist[0];
            } __attribute__((packed)) CLMI_SB_ASTNC_GPS_REF_TIME_STR;
#define SIZE_CLMI_SB_ASTNC_GPS_REF_TIME                       sizeof(CLMI_SB_ASTNC_GPS_REF_TIME_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct CLMI_SB_ASTNC_GPS_REF_TIME_UMTS
#define CLMI_SB_ASTNC_GPS_REF_TIME_UMTS                       0x1031                                                
typedef struct
            { 
             uint16_t     sb_id;
             uint16_t     sb_len;
             uint32_t     tow_msb;
             uint32_t     tow_lsb;
             uint16_t     gps_week;
             uint16_t     sfn;
             uint16_t     cell_info;
             int8_t       drift;
             uint8_t      n_ta;
             CLMI_ASTNC_GPS_TOW_ASSIST_SEQ_STR    gps_tow_assist[0];
            } __attribute__((packed)) CLMI_SB_ASTNC_GPS_REF_TIME_UMTS_STR;
#define SIZE_CLMI_SB_ASTNC_GPS_REF_TIME_UMTS                  sizeof(CLMI_SB_ASTNC_GPS_REF_TIME_UMTS_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct CLMI_SB_ASTNC_GPS_REF_TIME_GSM
#define CLMI_SB_ASTNC_GPS_REF_TIME_GSM                        0x1032                                                
typedef struct
            { 
             uint16_t     sb_id;
             uint16_t     sb_len;
             uint32_t     gps_tow_int;
             uint32_t     gps_tow_frac;
             uint16_t     gps_week;
             uint16_t     bcch_carrier;
             uint8_t      bsic;
             uint8_t      tn;
             uint8_t      bn;
             int8_t       drift;
             uint32_t     fnm;
             uint8_t      fillerbyte1[3];
             uint8_t      n_ta;
             CLMI_ASTNC_GPS_TOW_ASSIST_SEQ_STR    gps_tow_assist[0];
            } __attribute__((packed)) CLMI_SB_ASTNC_GPS_REF_TIME_GSM_STR;
#define SIZE_CLMI_SB_ASTNC_GPS_REF_TIME_GSM                   sizeof(CLMI_SB_ASTNC_GPS_REF_TIME_GSM_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct CLMI_SB_ASTNC_GPS_DGPS_CORRECTIONS
#define CLMI_SB_ASTNC_GPS_DGPS_CORRECTIONS                    0x1012                                                
typedef struct
            { 
             uint16_t     sb_id;
             uint16_t     sb_len;
             uint32_t     tow;
             uint8_t      health;
             uint8_t      num_sv;
             uint16_t     fillerbyte1;
             CLMI_ASTNC_GPS_DGPS_CORRECTION_SEQ_STR    correction[0];
            } __attribute__((packed)) CLMI_SB_ASTNC_GPS_DGPS_CORRECTIONS_STR;
#define SIZE_CLMI_SB_ASTNC_GPS_DGPS_CORRECTIONS               sizeof(CLMI_SB_ASTNC_GPS_DGPS_CORRECTIONS_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct CLMI_SB_ASTNC_GPS_EPHEMERIS
#define CLMI_SB_ASTNC_GPS_EPHEMERIS                           0x1013                                                
typedef struct
            { 
             uint16_t     sb_id;
             uint16_t     sb_len;
             uint8_t      fillerbyte1[3];
             uint8_t      num_sv;
             CLMI_ASTNC_GPS_EPHEMERIS_SEQ_STR    ephemeris[0];
            } __attribute__((packed)) CLMI_SB_ASTNC_GPS_EPHEMERIS_STR;
#define SIZE_CLMI_SB_ASTNC_GPS_EPHEMERIS                      sizeof(CLMI_SB_ASTNC_GPS_EPHEMERIS_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct CLMI_SB_ASTNC_GPS_IONOSPHERIC
#define CLMI_SB_ASTNC_GPS_IONOSPHERIC                         0x1014                                                
typedef struct
            { 
             uint16_t     sb_id;
             uint16_t     sb_len;
             int8_t       alpha0;
             int8_t       alpha1;
             int8_t       alpha2;
             int8_t       alpha3;
             int8_t       beta0;
             int8_t       beta1;
             int8_t       beta2;
             int8_t       beta3;
            } __attribute__((packed)) CLMI_SB_ASTNC_GPS_IONOSPHERIC_STR;
#define SIZE_CLMI_SB_ASTNC_GPS_IONOSPHERIC                    sizeof(CLMI_SB_ASTNC_GPS_IONOSPHERIC_STR)


//Definition for struct CLMI_SB_ASTNC_GPS_UTC
#define CLMI_SB_ASTNC_GPS_UTC                                 0x1015                                                
typedef struct
            { 
             uint16_t     sb_id;
             uint16_t     sb_len;
             int32_t      a0;
             int32_t      a1;
             int8_t       delta_tls;
             uint8_t      tot;
             uint8_t      wnt;
             uint8_t      wnlsf;
             uint8_t      dn;
             int8_t       delta_tlsf;
             uint16_t     fillerbyte1;
            } __attribute__((packed)) CLMI_SB_ASTNC_GPS_UTC_STR;
#define SIZE_CLMI_SB_ASTNC_GPS_UTC                            sizeof(CLMI_SB_ASTNC_GPS_UTC_STR)


//Definition for struct CLMI_SB_ASTNC_GPS_ALMANAC
#define CLMI_SB_ASTNC_GPS_ALMANAC                             0x1016                                                
typedef struct
            { 
             uint16_t     sb_id;
             uint16_t     sb_len;
             uint16_t     fillerbyte1;
             uint8_t      num_sv;
             uint8_t      week_num;
             CLMI_ASTNC_GPS_ALMANAC_SEQ_STR    almanac[0];
            } __attribute__((packed)) CLMI_SB_ASTNC_GPS_ALMANAC_STR;
#define SIZE_CLMI_SB_ASTNC_GPS_ALMANAC                        sizeof(CLMI_SB_ASTNC_GPS_ALMANAC_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct CLMI_SB_ASTNC_GPS_ACQUISITION
#define CLMI_SB_ASTNC_GPS_ACQUISITION                         0x101B                                                
typedef struct
            { 
             uint16_t     sb_id;
             uint16_t     sb_len;
             uint16_t     time_of_app;
             uint8_t      fillerbyte1;
             uint8_t      num_sv;
             CLMI_ASTNC_GPS_ACQUISITION_SEQ_STR    acquisition[0];
            } __attribute__((packed)) CLMI_SB_ASTNC_GPS_ACQUISITION_STR;
#define SIZE_CLMI_SB_ASTNC_GPS_ACQUISITION                    sizeof(CLMI_SB_ASTNC_GPS_ACQUISITION_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct CLMI_SB_ASTNC_GPS_BAD_SATELLITES
#define CLMI_SB_ASTNC_GPS_BAD_SATELLITES                      0x1017                                                
typedef struct
            { 
             uint16_t     sb_id;
             uint16_t     sb_len;
             uint8_t      num_sv;
             uint8_t      sv_id[0];
            } __attribute__((packed)) CLMI_SB_ASTNC_GPS_BAD_SATELLITES_STR;
#define SIZE_CLMI_SB_ASTNC_GPS_BAD_SATELLITES                 sizeof(CLMI_SB_ASTNC_GPS_BAD_SATELLITES_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct CLMI_SB_ASTNC_FRAME_TRIGGER_UMTS
#define CLMI_SB_ASTNC_FRAME_TRIGGER_UMTS                      0x1048                                                
typedef struct
            { 
             uint16_t     sb_id;
             uint16_t     sb_len;
             uint16_t     sfn_trigger;
             uint16_t     cell_info;
             uint16_t     rtt;
             uint16_t     fillerbyte1;
            } __attribute__((packed)) CLMI_SB_ASTNC_FRAME_TRIGGER_UMTS_STR;
#define SIZE_CLMI_SB_ASTNC_FRAME_TRIGGER_UMTS                 sizeof(CLMI_SB_ASTNC_FRAME_TRIGGER_UMTS_STR)


//Definition for struct CLMI_SB_ASTNC_FRAME_TRIGGER_GSM
#define CLMI_SB_ASTNC_FRAME_TRIGGER_GSM                       0x1049                                                
typedef struct
            { 
             uint16_t     sb_id;
             uint16_t     sb_len;
             uint32_t     frame_nbr;
             uint16_t     bit_nbr;
             uint8_t      time_slot;
             uint8_t      timing_advance;
             uint16_t     bcch_carrier;
             uint8_t      bsic;
             uint8_t      success_code;
            } __attribute__((packed)) CLMI_SB_ASTNC_FRAME_TRIGGER_GSM_STR;
#define SIZE_CLMI_SB_ASTNC_FRAME_TRIGGER_GSM                  sizeof(CLMI_SB_ASTNC_FRAME_TRIGGER_GSM_STR)


//Definition for struct CLMI_SB_GPS_TOW_RELATION_UMTS
#define CLMI_SB_GPS_TOW_RELATION_UMTS                         0x104A                                                
typedef struct
            { 
             uint16_t     sb_id;
             uint16_t     sb_len;
             uint32_t     gps_tow_ms;
             uint32_t     gps_tow_subms;
             uint8_t      time_ref_unc;
             uint8_t      fillerbyte1;
             uint16_t     ref_frame;
            } __attribute__((packed)) CLMI_SB_GPS_TOW_RELATION_UMTS_STR;
#define SIZE_CLMI_SB_GPS_TOW_RELATION_UMTS                    sizeof(CLMI_SB_GPS_TOW_RELATION_UMTS_STR)


//Definition for struct CLMI_SB_GPS_TOW_RELATION_GSM
#define CLMI_SB_GPS_TOW_RELATION_GSM                          0x104B                                                
typedef struct
            { 
             uint16_t     sb_id;
             uint16_t     sb_len;
             uint32_t     gps_tow_ms;
             uint16_t     gps_tow_subms;
             uint8_t      time_ref_unc;
             uint8_t      fillerbyte1;
             uint32_t     ref_frame;
            } __attribute__((packed)) CLMI_SB_GPS_TOW_RELATION_GSM_STR;
#define SIZE_CLMI_SB_GPS_TOW_RELATION_GSM                     sizeof(CLMI_SB_GPS_TOW_RELATION_GSM_STR)


//Definition for struct CLMI_SB_GPS_PSEUDORANGE_MEAS
#define CLMI_SB_GPS_PSEUDORANGE_MEAS                          0xEEEF                                                
typedef struct
            { 
             uint16_t     sb_id;
             uint16_t     sb_len;
             uint32_t     time_ref;
             uint8_t      time_ref_unc;
             uint8_t      num_prm;
             uint16_t     fillerbyte1;
             CLMI_PSEUDORANGE_MEASUREMENT_SEQ_STR    measurement[0];
            } __attribute__((packed)) CLMI_SB_GPS_PSEUDORANGE_MEAS_STR;
#define SIZE_CLMI_SB_GPS_PSEUDORANGE_MEAS                     sizeof(CLMI_SB_GPS_PSEUDORANGE_MEAS_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//MESSAGES


//Definition for struct LS_LOCATION_REQ
#define LS_LOCATION_REQ                                       0x00                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      method;
             uint8_t      nbr_of_fixes;
             uint16_t     interval;
             uint16_t     ttff;
             uint16_t     max_age;
             uint16_t     uncertainty_hor;
             uint16_t     uncertainty_ver;
             uint8_t      cost;
             uint8_t      power_consumption;
             uint32_t     options;
             uint8_t      ttff_interpretation;
             uint8_t      fillerbyte1;
             uint8_t      initiator_id;
             uint8_t      sb_count;
            } __attribute__((packed)) LS_LOCATION_REQ_STR;
#define SIZE_LS_LOCATION_REQ                                  sizeof(LS_LOCATION_REQ_STR)


//Definition for struct LS_LOCATION_RESP
#define LS_LOCATION_RESP                                      0x01                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      method;
             uint8_t      error_reason;
             uint8_t      fillerbyte1[3];
            } __attribute__((packed)) LS_LOCATION_RESP_STR;
#define SIZE_LS_LOCATION_RESP                                 sizeof(LS_LOCATION_RESP_STR)


//Definition for struct LS_LOCATION_NTF
#define LS_LOCATION_NTF                                       0x02                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      method;
             uint8_t      error_reason;
             uint8_t      progress_indication;
             uint8_t      fillerbyte1;
             uint8_t      sb_count;
            } __attribute__((packed)) LS_LOCATION_NTF_STR;
#define SIZE_LS_LOCATION_NTF                                  sizeof(LS_LOCATION_NTF_STR)


//Definition for struct LS_LOCATION_STOP_REQ
#define LS_LOCATION_STOP_REQ                                  0x03                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint16_t     fillerbyte1;
            } __attribute__((packed)) LS_LOCATION_STOP_REQ_STR;
#define SIZE_LS_LOCATION_STOP_REQ                             sizeof(LS_LOCATION_STOP_REQ_STR)


//Definition for struct LS_LOCATION_STOP_RESP
#define LS_LOCATION_STOP_RESP                                 0x04                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) LS_LOCATION_STOP_RESP_STR;
#define SIZE_LS_LOCATION_STOP_RESP                            sizeof(LS_LOCATION_STOP_RESP_STR)


//Definition for struct LS_METHOD_INFORMATION_REQ
#define LS_METHOD_INFORMATION_REQ                             0x07                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      client_id;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) LS_METHOD_INFORMATION_REQ_STR;
#define SIZE_LS_METHOD_INFORMATION_REQ                        sizeof(LS_METHOD_INFORMATION_REQ_STR)


//Definition for struct LS_METHOD_INFORMATION_RESP
#define LS_METHOD_INFORMATION_RESP                            0x08                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      sb_count;
            } __attribute__((packed)) LS_METHOD_INFORMATION_RESP_STR;
#define SIZE_LS_METHOD_INFORMATION_RESP                       sizeof(LS_METHOD_INFORMATION_RESP_STR)


//Definition for struct LS_METHOD_INFORMATION_IND
#define LS_METHOD_INFORMATION_IND                             0x09                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      sb_count;
            } __attribute__((packed)) LS_METHOD_INFORMATION_IND_STR;
#define SIZE_LS_METHOD_INFORMATION_IND                        sizeof(LS_METHOD_INFORMATION_IND_STR)


//Definition for struct LS_SERVICE_REQUIRED_REQ
#define LS_SERVICE_REQUIRED_REQ                               0x0A                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint16_t     fillerbyte1;
            } __attribute__((packed)) LS_SERVICE_REQUIRED_REQ_STR;
#define SIZE_LS_SERVICE_REQUIRED_REQ                          sizeof(LS_SERVICE_REQUIRED_REQ_STR)


//Definition for struct LS_SERVICE_REQUIRED_RESP
#define LS_SERVICE_REQUIRED_RESP                              0x0B                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      service_required;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) LS_SERVICE_REQUIRED_RESP_STR;
#define SIZE_LS_SERVICE_REQUIRED_RESP                         sizeof(LS_SERVICE_REQUIRED_RESP_STR)


//Definition for struct LS_SERVICE_REQUIRED_IND
#define LS_SERVICE_REQUIRED_IND                               0x0C                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint16_t     fillerbyte1;
            } __attribute__((packed)) LS_SERVICE_REQUIRED_IND_STR;
#define SIZE_LS_SERVICE_REQUIRED_IND                          sizeof(LS_SERVICE_REQUIRED_IND_STR)


//Definition for struct LS_PRIVACY_REGISTRATION_REQ
#define LS_PRIVACY_REGISTRATION_REQ                           0x0D                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint16_t     fillerbyte1;
            } __attribute__((packed)) LS_PRIVACY_REGISTRATION_REQ_STR;
#define SIZE_LS_PRIVACY_REGISTRATION_REQ                      sizeof(LS_PRIVACY_REGISTRATION_REQ_STR)


//Definition for struct LS_PRIVACY_REGISTRATION_RESP
#define LS_PRIVACY_REGISTRATION_RESP                          0x0E                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) LS_PRIVACY_REGISTRATION_RESP_STR;
#define SIZE_LS_PRIVACY_REGISTRATION_RESP                     sizeof(LS_PRIVACY_REGISTRATION_RESP_STR)


//Definition for struct LS_PRIVACY_NTF
#define LS_PRIVACY_NTF                                        0x0F                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      initiator_id;
             uint8_t      notification_type;
             uint8_t      day;
             uint8_t      month;
             uint16_t     year;
             uint8_t      hour;
             uint8_t      min;
             uint8_t      sec;
             uint8_t      sub_block_count;
            } __attribute__((packed)) LS_PRIVACY_NTF_STR;
#define SIZE_LS_PRIVACY_NTF                                   sizeof(LS_PRIVACY_NTF_STR)


//Definition for struct LS_PRIVACY_NOTIFICATION_RESULT_REQ
#define LS_PRIVACY_NOTIFICATION_RESULT_REQ                    0x10                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      initiator_id;
             uint8_t      result;
            } __attribute__((packed)) LS_PRIVACY_NOTIFICATION_RESULT_REQ_STR;
#define SIZE_LS_PRIVACY_NOTIFICATION_RESULT_REQ               sizeof(LS_PRIVACY_NOTIFICATION_RESULT_REQ_STR)


//Definition for struct LS_PRIVACY_NOTIFICATION_RESULT_RESP
#define LS_PRIVACY_NOTIFICATION_RESULT_RESP                   0x11                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      initiator_id;
             uint8_t      status;
            } __attribute__((packed)) LS_PRIVACY_NOTIFICATION_RESULT_RESP_STR;
#define SIZE_LS_PRIVACY_NOTIFICATION_RESULT_RESP              sizeof(LS_PRIVACY_NOTIFICATION_RESULT_RESP_STR)


//Definition for struct LS_CLEAR_GPS_DATA_REQ
#define LS_CLEAR_GPS_DATA_REQ                                 0x30                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      pos_technology;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) LS_CLEAR_GPS_DATA_REQ_STR;
#define SIZE_LS_CLEAR_GPS_DATA_REQ                            sizeof(LS_CLEAR_GPS_DATA_REQ_STR)


//Definition for struct LS_CLEAR_GPS_DATA_RESP
#define LS_CLEAR_GPS_DATA_RESP                                0x31                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint16_t     fillerbyte1;
            } __attribute__((packed)) LS_CLEAR_GPS_DATA_RESP_STR;
#define SIZE_LS_CLEAR_GPS_DATA_RESP                           sizeof(LS_CLEAR_GPS_DATA_RESP_STR)


//Definition for struct LS_PING_REQ
#define LS_PING_REQ                                           0x32                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      type;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) LS_PING_REQ_STR;
#define SIZE_LS_PING_REQ                                      sizeof(LS_PING_REQ_STR)


//Definition for struct LS_PING_RESP
#define LS_PING_RESP                                          0x33                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint16_t     fillerbyte1;
            } __attribute__((packed)) LS_PING_RESP_STR;
#define SIZE_LS_PING_RESP                                     sizeof(LS_PING_RESP_STR)


//Definition for struct LS_PING_NTF
#define LS_PING_NTF                                           0x34                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint16_t     fillerbyte1;
            } __attribute__((packed)) LS_PING_NTF_STR;
#define SIZE_LS_PING_NTF                                      sizeof(LS_PING_NTF_STR)


//Definition for struct LS_WCDMA_LOCATE_REQ
#define LS_WCDMA_LOCATE_REQ                                   0x60                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      sub_block_count;
            } __attribute__((packed)) LS_WCDMA_LOCATE_REQ_STR;
#define SIZE_LS_WCDMA_LOCATE_REQ                              sizeof(LS_WCDMA_LOCATE_REQ_STR)


//Definition for struct LS_WCDMA_LOCATE_RESP
#define LS_WCDMA_LOCATE_RESP                                  0x61                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      measurement_id;
             uint8_t      error;
             uint8_t      fillerbyte1[3];
             uint8_t      sub_block_count;
            } __attribute__((packed)) LS_WCDMA_LOCATE_RESP_STR;
#define SIZE_LS_WCDMA_LOCATE_RESP                             sizeof(LS_WCDMA_LOCATE_RESP_STR)


//Definition for struct LS_WCDMA_LOCATE_NTF
#define LS_WCDMA_LOCATE_NTF                                   0x62                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      final_measurement;
             uint8_t      measurement_id;
             uint8_t      fillerbyte1[3];
             uint8_t      sub_block_count;
            } __attribute__((packed)) LS_WCDMA_LOCATE_NTF_STR;
#define SIZE_LS_WCDMA_LOCATE_NTF                              sizeof(LS_WCDMA_LOCATE_NTF_STR)


//Definition for struct LS_LTM_TEST_REQ
#define LS_LTM_TEST_REQ                                       0x36                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      ltm_type;
             uint8_t      sub_block_count;
            } __attribute__((packed)) LS_LTM_TEST_REQ_STR;
#define SIZE_LS_LTM_TEST_REQ                                  sizeof(LS_LTM_TEST_REQ_STR)


//Definition for struct LS_LTM_TEST_RESP
#define LS_LTM_TEST_RESP                                      0x37                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      sub_block_count;
            } __attribute__((packed)) LS_LTM_TEST_RESP_STR;
#define SIZE_LS_LTM_TEST_RESP                                 sizeof(LS_LTM_TEST_RESP_STR)


//Definition for struct LS_LTM_TEST_NTF
#define LS_LTM_TEST_NTF                                       0x38                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      sub_block_count;
            } __attribute__((packed)) LS_LTM_TEST_NTF_STR;
#define SIZE_LS_LTM_TEST_NTF                                  sizeof(LS_LTM_TEST_NTF_STR)


//Definition for struct LS_HW_CONN_TEST_REQ
#define LS_HW_CONN_TEST_REQ                                   0x39                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint16_t     fillerbyte1;
            } __attribute__((packed)) LS_HW_CONN_TEST_REQ_STR;
#define SIZE_LS_HW_CONN_TEST_REQ                              sizeof(LS_HW_CONN_TEST_REQ_STR)


//Definition for struct LS_HW_CONN_TEST_RESP
#define LS_HW_CONN_TEST_RESP                                  0x3A                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      result;
            } __attribute__((packed)) LS_HW_CONN_TEST_RESP_STR;
#define SIZE_LS_HW_CONN_TEST_RESP                             sizeof(LS_HW_CONN_TEST_RESP_STR)


//Definition for struct LS_DEBUG_REQ
#define LS_DEBUG_REQ                                          0xE0                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint16_t     len;
             uint8_t      str[0];
            } __attribute__((packed)) LS_DEBUG_REQ_STR;
#define SIZE_LS_DEBUG_REQ                                     sizeof(LS_DEBUG_REQ_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct LS_DEBUG_RESP
#define LS_DEBUG_RESP                                         0xE1                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint16_t     len;
             uint8_t      str[0];
            } __attribute__((packed)) LS_DEBUG_RESP_STR;
#define SIZE_LS_DEBUG_RESP                                    sizeof(LS_DEBUG_RESP_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct LS_SOURCE_LIST_REQ
#define LS_SOURCE_LIST_REQ                                    0x63                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint16_t     fillerbyte1;
            } __attribute__((packed)) LS_SOURCE_LIST_REQ_STR;
#define SIZE_LS_SOURCE_LIST_REQ                               sizeof(LS_SOURCE_LIST_REQ_STR)


//Definition for struct LS_SOURCE_LIST_RESP
#define LS_SOURCE_LIST_RESP                                   0x64                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      source;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) LS_SOURCE_LIST_RESP_STR;
#define SIZE_LS_SOURCE_LIST_RESP                              sizeof(LS_SOURCE_LIST_RESP_STR)


//Definition for struct LS_TRACKING_START_REQ
#define LS_TRACKING_START_REQ                                 0x65                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      source;
             uint8_t      interval;
            } __attribute__((packed)) LS_TRACKING_START_REQ_STR;
#define SIZE_LS_TRACKING_START_REQ                            sizeof(LS_TRACKING_START_REQ_STR)


//Definition for struct LS_TRACKING_START_RESP
#define LS_TRACKING_START_RESP                                0x66                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      session_id;
            } __attribute__((packed)) LS_TRACKING_START_RESP_STR;
#define SIZE_LS_TRACKING_START_RESP                           sizeof(LS_TRACKING_START_RESP_STR)


//Definition for struct LS_TRACKING_DATA_NTF
#define LS_TRACKING_DATA_NTF                                  0x67                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      session_id;
             uint8_t      fillerbyte1[3];
             uint8_t      sb_count;
            } __attribute__((packed)) LS_TRACKING_DATA_NTF_STR;
#define SIZE_LS_TRACKING_DATA_NTF                             sizeof(LS_TRACKING_DATA_NTF_STR)


//Definition for struct LS_TRACKING_STOP_REQ
#define LS_TRACKING_STOP_REQ                                  0x68                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      session_id;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) LS_TRACKING_STOP_REQ_STR;
#define SIZE_LS_TRACKING_STOP_REQ                             sizeof(LS_TRACKING_STOP_REQ_STR)


//Definition for struct LS_TRACKING_STOP_RESP
#define LS_TRACKING_STOP_RESP                                 0x69                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      session_id;
            } __attribute__((packed)) LS_TRACKING_STOP_RESP_STR;
#define SIZE_LS_TRACKING_STOP_RESP                            sizeof(LS_TRACKING_STOP_RESP_STR)


//Definition for struct LS_POSITIONING_SUPPORT_REQ
#define LS_POSITIONING_SUPPORT_REQ                            0x70                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint16_t     fillerbyte1;
            } __attribute__((packed)) LS_POSITIONING_SUPPORT_REQ_STR;
#define SIZE_LS_POSITIONING_SUPPORT_REQ                       sizeof(LS_POSITIONING_SUPPORT_REQ_STR)


//Definition for struct LS_POSITIONING_SUPPORT_RESP
#define LS_POSITIONING_SUPPORT_RESP                           0x71                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      support;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) LS_POSITIONING_SUPPORT_RESP_STR;
#define SIZE_LS_POSITIONING_SUPPORT_RESP                      sizeof(LS_POSITIONING_SUPPORT_RESP_STR)


//Definition for struct LS_POSITIONING_SUPPORT_NTF
#define LS_POSITIONING_SUPPORT_NTF                            0x72                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      support;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) LS_POSITIONING_SUPPORT_NTF_STR;
#define SIZE_LS_POSITIONING_SUPPORT_NTF                       sizeof(LS_POSITIONING_SUPPORT_NTF_STR)


//Definition for struct LS_GPS_STATUS_REQ
#define LS_GPS_STATUS_REQ                                     0x73                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint16_t     fillerbyte1;
            } __attribute__((packed)) LS_GPS_STATUS_REQ_STR;
#define SIZE_LS_GPS_STATUS_REQ                                sizeof(LS_GPS_STATUS_REQ_STR)


//Definition for struct LS_GPS_STATUS_RESP
#define LS_GPS_STATUS_RESP                                    0x74                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      on_state;
            } __attribute__((packed)) LS_GPS_STATUS_RESP_STR;
#define SIZE_LS_GPS_STATUS_RESP                               sizeof(LS_GPS_STATUS_RESP_STR)


//Definition for struct LS_GPS_STATUS_IND
#define LS_GPS_STATUS_IND                                     0x7D                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      on_state;
            } __attribute__((packed)) LS_GPS_STATUS_IND_STR;
#define SIZE_LS_GPS_STATUS_IND                                sizeof(LS_GPS_STATUS_IND_STR)


//Definition for struct LS_SENSOR_REGISTRATION_REQ
#define LS_SENSOR_REGISTRATION_REQ                            0x78                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      sub_block_count;
            } __attribute__((packed)) LS_SENSOR_REGISTRATION_REQ_STR;
#define SIZE_LS_SENSOR_REGISTRATION_REQ                       sizeof(LS_SENSOR_REGISTRATION_REQ_STR)


//Definition for struct LS_SENSOR_REGISTRATION_RESP
#define LS_SENSOR_REGISTRATION_RESP                           0x79                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      sub_block_count;
            } __attribute__((packed)) LS_SENSOR_REGISTRATION_RESP_STR;
#define SIZE_LS_SENSOR_REGISTRATION_RESP                      sizeof(LS_SENSOR_REGISTRATION_RESP_STR)


//Definition for struct LS_SENSOR_EVENT_REQ
#define LS_SENSOR_EVENT_REQ                                   0x7A                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      sub_block_count;
            } __attribute__((packed)) LS_SENSOR_EVENT_REQ_STR;
#define SIZE_LS_SENSOR_EVENT_REQ                              sizeof(LS_SENSOR_EVENT_REQ_STR)


//Definition for struct LS_SENSOR_EVENT_RESP
#define LS_SENSOR_EVENT_RESP                                  0x7B                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
            } __attribute__((packed)) LS_SENSOR_EVENT_RESP_STR;
#define SIZE_LS_SENSOR_EVENT_RESP                             sizeof(LS_SENSOR_EVENT_RESP_STR)


//Definition for struct LS_SENSOR_NTF
#define LS_SENSOR_NTF                                         0x7C                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      sub_block_count;
            } __attribute__((packed)) LS_SENSOR_NTF_STR;
#define SIZE_LS_SENSOR_NTF                                    sizeof(LS_SENSOR_NTF_STR)


//Definition for struct LS_GSM_PRIVACY_REQ
#define LS_GSM_PRIVACY_REQ                                    0x40                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      sub_block_count;
            } __attribute__((packed)) LS_GSM_PRIVACY_REQ_STR;
#define SIZE_LS_GSM_PRIVACY_REQ                               sizeof(LS_GSM_PRIVACY_REQ_STR)


//Definition for struct LS_GSM_PRIVACY_RESP
#define LS_GSM_PRIVACY_RESP                                   0x41                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint16_t     fillerbyte1;
            } __attribute__((packed)) LS_GSM_PRIVACY_RESP_STR;
#define SIZE_LS_GSM_PRIVACY_RESP                              sizeof(LS_GSM_PRIVACY_RESP_STR)


//Definition for struct LS_GSM_PRIVACY_TIMEOUT_REQ
#define LS_GSM_PRIVACY_TIMEOUT_REQ                            0x42                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint16_t     fillerbyte1;
            } __attribute__((packed)) LS_GSM_PRIVACY_TIMEOUT_REQ_STR;
#define SIZE_LS_GSM_PRIVACY_TIMEOUT_REQ                       sizeof(LS_GSM_PRIVACY_TIMEOUT_REQ_STR)


//Definition for struct LS_GSM_PRIVACY_TIMEOUT_RESP
#define LS_GSM_PRIVACY_TIMEOUT_RESP                           0x43                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) LS_GSM_PRIVACY_TIMEOUT_RESP_STR;
#define SIZE_LS_GSM_PRIVACY_TIMEOUT_RESP                      sizeof(LS_GSM_PRIVACY_TIMEOUT_RESP_STR)


//Definition for struct LS_GSM_LOCATE_REQ
#define LS_GSM_LOCATE_REQ                                     0x44                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      sub_block_count;
            } __attribute__((packed)) LS_GSM_LOCATE_REQ_STR;
#define SIZE_LS_GSM_LOCATE_REQ                                sizeof(LS_GSM_LOCATE_REQ_STR)


//Definition for struct LS_GSM_LOCATE_RESP
#define LS_GSM_LOCATE_RESP                                    0x45                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      sub_block_count;
            } __attribute__((packed)) LS_GSM_LOCATE_RESP_STR;
#define SIZE_LS_GSM_LOCATE_RESP                               sizeof(LS_GSM_LOCATE_RESP_STR)


//Definition for struct LS_SUPL_LISTENER_REGISTRATION_REQ
#define LS_SUPL_LISTENER_REGISTRATION_REQ                     0x50                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint16_t     fillerbyte1;
            } __attribute__((packed)) LS_SUPL_LISTENER_REGISTRATION_REQ_STR;
#define SIZE_LS_SUPL_LISTENER_REGISTRATION_REQ                sizeof(LS_SUPL_LISTENER_REGISTRATION_REQ_STR)


//Definition for struct LS_SUPL_LISTENER_REGISTRATION_RESP
#define LS_SUPL_LISTENER_REGISTRATION_RESP                    0x51                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) LS_SUPL_LISTENER_REGISTRATION_RESP_STR;
#define SIZE_LS_SUPL_LISTENER_REGISTRATION_RESP               sizeof(LS_SUPL_LISTENER_REGISTRATION_RESP_STR)


//Definition for struct LS_SUPL_CREATE_SESSION_REQUEST_NTF
#define LS_SUPL_CREATE_SESSION_REQUEST_NTF                    0x52                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      sb_count;
             uint8_t      options;
             uint32_t     request_id;
            } __attribute__((packed)) LS_SUPL_CREATE_SESSION_REQUEST_NTF_STR;
#define SIZE_LS_SUPL_CREATE_SESSION_REQUEST_NTF               sizeof(LS_SUPL_CREATE_SESSION_REQUEST_NTF_STR)


//Definition for struct LS_SUPL_CREATE_SESSION_RESPONSE_NTF
#define LS_SUPL_CREATE_SESSION_RESPONSE_NTF                   0x53                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      fillerbyte1;
             uint32_t     request_id;
            } __attribute__((packed)) LS_SUPL_CREATE_SESSION_RESPONSE_NTF_STR;
#define SIZE_LS_SUPL_CREATE_SESSION_RESPONSE_NTF              sizeof(LS_SUPL_CREATE_SESSION_RESPONSE_NTF_STR)


//Definition for struct LS_SUPL_SESSION_END_NTF
#define LS_SUPL_SESSION_END_NTF                               0x54                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      sb_count;
             uint32_t     request_id;
            } __attribute__((packed)) LS_SUPL_SESSION_END_NTF_STR;
#define SIZE_LS_SUPL_SESSION_END_NTF                          sizeof(LS_SUPL_SESSION_END_NTF_STR)


//Definition for struct LS_SUPL_GET_SUPL_INFO_REQ
#define LS_SUPL_GET_SUPL_INFO_REQ                             0x55                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      supl_state;
             uint32_t     request_id;
             uint32_t     session_id;
             uint32_t     requests;
             uint8_t      sb_count;
             uint8_t      fillerbyte2[3];
            } __attribute__((packed)) LS_SUPL_GET_SUPL_INFO_REQ_STR;
#define SIZE_LS_SUPL_GET_SUPL_INFO_REQ                        sizeof(LS_SUPL_GET_SUPL_INFO_REQ_STR)


//Definition for struct LS_SUPL_GET_SUPL_INFO_RESP
#define LS_SUPL_GET_SUPL_INFO_RESP                            0x56                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      sb_count;
             uint8_t      fillerbyte1;
             uint32_t     session_id;
            } __attribute__((packed)) LS_SUPL_GET_SUPL_INFO_RESP_STR;
#define SIZE_LS_SUPL_GET_SUPL_INFO_RESP                       sizeof(LS_SUPL_GET_SUPL_INFO_RESP_STR)


//Definition for struct LS_SUPL_CANCEL_SUPL_INFO_REQ
#define LS_SUPL_CANCEL_SUPL_INFO_REQ                          0x57                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint16_t     fillerbyte1;
             uint32_t     session_id;
            } __attribute__((packed)) LS_SUPL_CANCEL_SUPL_INFO_REQ_STR;
#define SIZE_LS_SUPL_CANCEL_SUPL_INFO_REQ                     sizeof(LS_SUPL_CANCEL_SUPL_INFO_REQ_STR)


//Definition for struct LS_SUPL_CANCEL_SUPL_INFO_RESP
#define LS_SUPL_CANCEL_SUPL_INFO_RESP                         0x58                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      fillerbyte1;
             uint32_t     session_id;
            } __attribute__((packed)) LS_SUPL_CANCEL_SUPL_INFO_RESP_STR;
#define SIZE_LS_SUPL_CANCEL_SUPL_INFO_RESP                    sizeof(LS_SUPL_CANCEL_SUPL_INFO_RESP_STR)


//Definition for struct LS_SUPL_POS_NTF
#define LS_SUPL_POS_NTF                                       0x59                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      segment_nbr;
             uint8_t      total_segment;
             uint32_t     request_id;
             uint32_t     session_id;
             uint16_t     fillerbyte1;
             uint8_t      last_pos;
             uint8_t      sb_count;
            } __attribute__((packed)) LS_SUPL_POS_NTF_STR;
#define SIZE_LS_SUPL_POS_NTF                                  sizeof(LS_SUPL_POS_NTF_STR)


//Definition for struct LS_SUPL_POS_ACK_NTF
#define LS_SUPL_POS_ACK_NTF                                   0x5A                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      segment_nbr;
             uint32_t     session_id;
            } __attribute__((packed)) LS_SUPL_POS_ACK_NTF_STR;
#define SIZE_LS_SUPL_POS_ACK_NTF                              sizeof(LS_SUPL_POS_ACK_NTF_STR)


//Definition for struct LS_SUPL_POS_END_NTF
#define LS_SUPL_POS_END_NTF                                   0x5B                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      fillerbyte1;
             uint32_t     session_id;
            } __attribute__((packed)) LS_SUPL_POS_END_NTF_STR;
#define SIZE_LS_SUPL_POS_END_NTF                              sizeof(LS_SUPL_POS_END_NTF_STR)


//Definition for struct LS_SUPL_SESSION_STATUS_REQUEST_NTF
#define LS_SUPL_SESSION_STATUS_REQUEST_NTF                    0x5C                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint16_t     fillerbyte1;
             uint32_t     session_id;
            } __attribute__((packed)) LS_SUPL_SESSION_STATUS_REQUEST_NTF_STR;
#define SIZE_LS_SUPL_SESSION_STATUS_REQUEST_NTF               sizeof(LS_SUPL_SESSION_STATUS_REQUEST_NTF_STR)


//Definition for struct LS_SUPL_SESSION_STATUS_RESPONSE_NTF
#define LS_SUPL_SESSION_STATUS_RESPONSE_NTF                   0x5D                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      fillerbyte1;
             uint32_t     session_id;
            } __attribute__((packed)) LS_SUPL_SESSION_STATUS_RESPONSE_NTF_STR;
#define SIZE_LS_SUPL_SESSION_STATUS_RESPONSE_NTF              sizeof(LS_SUPL_SESSION_STATUS_RESPONSE_NTF_STR)


//Definition for struct LS_SUPL_POSITION_FIX_NTF
#define LS_SUPL_POSITION_FIX_NTF                              0x5E                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      sb_count;
             uint32_t     session_id;
            } __attribute__((packed)) LS_SUPL_POSITION_FIX_NTF_STR;
#define SIZE_LS_SUPL_POSITION_FIX_NTF                         sizeof(LS_SUPL_POSITION_FIX_NTF_STR)


//Definition for struct LS_SUPL_ALLOWED_REQ
#define LS_SUPL_ALLOWED_REQ                                   0x76                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      setting;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) LS_SUPL_ALLOWED_REQ_STR;
#define SIZE_LS_SUPL_ALLOWED_REQ                              sizeof(LS_SUPL_ALLOWED_REQ_STR)


//Definition for struct LS_SUPL_ALLOWED_RESP
#define LS_SUPL_ALLOWED_RESP                                  0x77                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      gps_support;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) LS_SUPL_ALLOWED_RESP_STR;
#define SIZE_LS_SUPL_ALLOWED_RESP                             sizeof(LS_SUPL_ALLOWED_RESP_STR)


//Definition for struct LS_SUPL_SERVER_CONF_REQ
#define LS_SUPL_SERVER_CONF_REQ                               0x7E                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      sb_count;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) LS_SUPL_SERVER_CONF_REQ_STR;
#define SIZE_LS_SUPL_SERVER_CONF_REQ                          sizeof(LS_SUPL_SERVER_CONF_REQ_STR)


//Definition for struct LS_SUPL_SERVER_CONF_RESP
#define LS_SUPL_SERVER_CONF_RESP                              0x7F                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint16_t     fillerbyte1;
            } __attribute__((packed)) LS_SUPL_SERVER_CONF_RESP_STR;
#define SIZE_LS_SUPL_SERVER_CONF_RESP                         sizeof(LS_SUPL_SERVER_CONF_RESP_STR)


//Definition for struct LS_SUPL_NW_INIT_REQ
#define LS_SUPL_NW_INIT_REQ                                   0x80                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint16_t     data_length;
             uint8_t      data[0];
            } __attribute__((packed)) LS_SUPL_NW_INIT_REQ_STR;
#define SIZE_LS_SUPL_NW_INIT_REQ                              sizeof(LS_SUPL_NW_INIT_REQ_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct LS_SUPL_NW_INIT_RESP
#define LS_SUPL_NW_INIT_RESP                                  0x81                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint16_t     fillerbyte1;
            } __attribute__((packed)) LS_SUPL_NW_INIT_RESP_STR;
#define SIZE_LS_SUPL_NW_INIT_RESP                             sizeof(LS_SUPL_NW_INIT_RESP_STR)


//Definition for struct LS_SOCKET_REGISTRATION_REQ
#define LS_SOCKET_REGISTRATION_REQ                            0x82                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint16_t     fillerbyte1;
            } __attribute__((packed)) LS_SOCKET_REGISTRATION_REQ_STR;
#define SIZE_LS_SOCKET_REGISTRATION_REQ                       sizeof(LS_SOCKET_REGISTRATION_REQ_STR)


//Definition for struct LS_SOCKET_REGISTRATION_RESP
#define LS_SOCKET_REGISTRATION_RESP                           0x83                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint16_t     fillerbyte1;
            } __attribute__((packed)) LS_SOCKET_REGISTRATION_RESP_STR;
#define SIZE_LS_SOCKET_REGISTRATION_RESP                      sizeof(LS_SOCKET_REGISTRATION_RESP_STR)


//Definition for struct LS_SOCKET_OPEN_REQUEST_NTF
#define LS_SOCKET_OPEN_REQUEST_NTF                            0x84                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      sb_count;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) LS_SOCKET_OPEN_REQUEST_NTF_STR;
#define SIZE_LS_SOCKET_OPEN_REQUEST_NTF                       sizeof(LS_SOCKET_OPEN_REQUEST_NTF_STR)


//Definition for struct LS_SOCKET_OPEN_RESPONSE_NTF
#define LS_SOCKET_OPEN_RESPONSE_NTF                           0x85                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      sckt_descriptor;
             uint8_t      status;
             uint8_t      sb_count;
             uint8_t      fillerbyte1[3];
            } __attribute__((packed)) LS_SOCKET_OPEN_RESPONSE_NTF_STR;
#define SIZE_LS_SOCKET_OPEN_RESPONSE_NTF                      sizeof(LS_SOCKET_OPEN_RESPONSE_NTF_STR)


//Definition for struct LS_SOCKET_SEND_REQUEST_NTF
#define LS_SOCKET_SEND_REQUEST_NTF                            0x86                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      sckt_descriptor;
             uint8_t      fillerbyte1;
             uint16_t     data_length;
             uint16_t     fillerbyte2;
             uint8_t      data[0];
            } __attribute__((packed)) LS_SOCKET_SEND_REQUEST_NTF_STR;
#define SIZE_LS_SOCKET_SEND_REQUEST_NTF                       sizeof(LS_SOCKET_SEND_REQUEST_NTF_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct LS_SOCKET_SEND_RESPONSE_NTF
#define LS_SOCKET_SEND_RESPONSE_NTF                           0x87                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      sckt_descriptor;
             uint8_t      status;
             uint16_t     err_nbr;
             uint16_t     fillerbyte1;
            } __attribute__((packed)) LS_SOCKET_SEND_RESPONSE_NTF_STR;
#define SIZE_LS_SOCKET_SEND_RESPONSE_NTF                      sizeof(LS_SOCKET_SEND_RESPONSE_NTF_STR)


//Definition for struct LS_SOCKET_RECV_REQ
#define LS_SOCKET_RECV_REQ                                    0x88                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      sckt_descriptor;
             uint8_t      fillerbyte1;
             uint16_t     data_length;
             uint16_t     fillerbyte2;
             uint8_t      data[0];
            } __attribute__((packed)) LS_SOCKET_RECV_REQ_STR;
#define SIZE_LS_SOCKET_RECV_REQ                               sizeof(LS_SOCKET_RECV_REQ_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct LS_SOCKET_RECV_RESP
#define LS_SOCKET_RECV_RESP                                   0x89                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      sckt_descriptor;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) LS_SOCKET_RECV_RESP_STR;
#define SIZE_LS_SOCKET_RECV_RESP                              sizeof(LS_SOCKET_RECV_RESP_STR)


//Definition for struct LS_SOCKET_CLOSE_REQUEST_NTF
#define LS_SOCKET_CLOSE_REQUEST_NTF                           0x8A                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      sckt_descriptor;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) LS_SOCKET_CLOSE_REQUEST_NTF_STR;
#define SIZE_LS_SOCKET_CLOSE_REQUEST_NTF                      sizeof(LS_SOCKET_CLOSE_REQUEST_NTF_STR)


//Definition for struct LS_SOCKET_CLOSE_RESPONSE_NTF
#define LS_SOCKET_CLOSE_RESPONSE_NTF                          0x8B                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      sckt_descriptor;
             uint8_t      status;
            } __attribute__((packed)) LS_SOCKET_CLOSE_RESPONSE_NTF_STR;
#define SIZE_LS_SOCKET_CLOSE_RESPONSE_NTF                     sizeof(LS_SOCKET_CLOSE_RESPONSE_NTF_STR)


//Definition for struct LS_SOCKET_CLOSED_REQ
#define LS_SOCKET_CLOSED_REQ                                  0x8C                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      sckt_descriptor;
             uint8_t      fillerbyte1;
             uint16_t     err_nbr;
             uint16_t     fillerbyte2;
            } __attribute__((packed)) LS_SOCKET_CLOSED_REQ_STR;
#define SIZE_LS_SOCKET_CLOSED_REQ                             sizeof(LS_SOCKET_CLOSED_REQ_STR)


//Definition for struct LS_SOCKET_CLOSED_RESP
#define LS_SOCKET_CLOSED_RESP                                 0x8D                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint16_t     fillerbyte1;
            } __attribute__((packed)) LS_SOCKET_CLOSED_RESP_STR;
#define SIZE_LS_SOCKET_CLOSED_RESP                            sizeof(LS_SOCKET_CLOSED_RESP_STR)


//Definition for struct LS_HYBRID_TRACKING_REQ
#define LS_HYBRID_TRACKING_REQ                                0x90                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      command;
             uint8_t      n_sbs;
             uint32_t     client_id;
             uint32_t     npe_id;
            } __attribute__((packed)) LS_HYBRID_TRACKING_REQ_STR;
#define SIZE_LS_HYBRID_TRACKING_REQ                           sizeof(LS_HYBRID_TRACKING_REQ_STR)


//Definition for struct LS_HYBRID_TRACKING_RESP
#define LS_HYBRID_TRACKING_RESP                               0x91                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      cause;
             uint32_t     client_id;
             uint32_t     npe_id;
            } __attribute__((packed)) LS_HYBRID_TRACKING_RESP_STR;
#define SIZE_LS_HYBRID_TRACKING_RESP                          sizeof(LS_HYBRID_TRACKING_RESP_STR)


//Definition for struct LS_HYBRID_TRACKING_NTF
#define LS_HYBRID_TRACKING_NTF                                0x92                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      cause;
             uint32_t     npe_id;
             uint8_t      n_sbs;
             uint8_t      fillerbyte1[3];
            } __attribute__((packed)) LS_HYBRID_TRACKING_NTF_STR;
#define SIZE_LS_HYBRID_TRACKING_NTF                           sizeof(LS_HYBRID_TRACKING_NTF_STR)


//Definition for struct LS_GPS_ANTENNA_CTRL_REQ
#define LS_GPS_ANTENNA_CTRL_REQ                               0xA0                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      ctrl;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) LS_GPS_ANTENNA_CTRL_REQ_STR;
#define SIZE_LS_GPS_ANTENNA_CTRL_REQ                          sizeof(LS_GPS_ANTENNA_CTRL_REQ_STR)


//Definition for struct LS_GPS_ANTENNA_CTRL_RESP
#define LS_GPS_ANTENNA_CTRL_RESP                              0xA1                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) LS_GPS_ANTENNA_CTRL_RESP_STR;
#define SIZE_LS_GPS_ANTENNA_CTRL_RESP                         sizeof(LS_GPS_ANTENNA_CTRL_RESP_STR)


//Definition for struct LS_NMEA_LISTENER_REQ
#define LS_NMEA_LISTENER_REQ                                  0x20                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      status;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) LS_NMEA_LISTENER_REQ_STR;
#define SIZE_LS_NMEA_LISTENER_REQ                             sizeof(LS_NMEA_LISTENER_REQ_STR)


//Definition for struct LS_NMEA_LISTENER_RESP
#define LS_NMEA_LISTENER_RESP                                 0x21                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint16_t     fillerbyte1;
            } __attribute__((packed)) LS_NMEA_LISTENER_RESP_STR;
#define SIZE_LS_NMEA_LISTENER_RESP                            sizeof(LS_NMEA_LISTENER_RESP_STR)


//Definition for struct LS_NMEA_LISTENER_NTF
#define LS_NMEA_LISTENER_NTF                                  0x22                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      fillerbyte1;
             uint8_t      sb_count;
            } __attribute__((packed)) LS_NMEA_LISTENER_NTF_STR;
#define SIZE_LS_NMEA_LISTENER_NTF                             sizeof(LS_NMEA_LISTENER_NTF_STR)


//Definition for struct LS_METHOD_REGISTRATION_REQ
#define LS_METHOD_REGISTRATION_REQ                            0x12                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      ltm_id;
             uint8_t      sb_count;
            } __attribute__((packed)) LS_METHOD_REGISTRATION_REQ_STR;
#define SIZE_LS_METHOD_REGISTRATION_REQ                       sizeof(LS_METHOD_REGISTRATION_REQ_STR)


//Definition for struct LS_METHOD_REGISTRATION_RESP
#define LS_METHOD_REGISTRATION_RESP                           0x13                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint16_t     fillerbyte1;
            } __attribute__((packed)) LS_METHOD_REGISTRATION_RESP_STR;
#define SIZE_LS_METHOD_REGISTRATION_RESP                      sizeof(LS_METHOD_REGISTRATION_RESP_STR)


//Definition for struct LS_METHOD_ASSISTANCE_REQ
#define LS_METHOD_ASSISTANCE_REQ                              0x14                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      method;
             uint8_t      sb_count;
             uint32_t     requests;
            } __attribute__((packed)) LS_METHOD_ASSISTANCE_REQ_STR;
#define SIZE_LS_METHOD_ASSISTANCE_REQ                         sizeof(LS_METHOD_ASSISTANCE_REQ_STR)


//Definition for struct LS_METHOD_ASSISTANCE_RESP
#define LS_METHOD_ASSISTANCE_RESP                             0x15                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint16_t     fillerbyte1;
             uint32_t     accepted_requests;
            } __attribute__((packed)) LS_METHOD_ASSISTANCE_RESP_STR;
#define SIZE_LS_METHOD_ASSISTANCE_RESP                        sizeof(LS_METHOD_ASSISTANCE_RESP_STR)


//Definition for struct LS_CLMI


//Definition for struct LS_CLMI_CLMI_REQ
#define LS_CLMI_CLMI_REQ                                      0xFF                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      submessage_id;
             uint8_t      method;
             uint16_t     nbr_of_fixes;
             uint16_t     interval;
             uint16_t     ttff;
             uint16_t     uncertainty_hor;
             uint16_t     uncertainty_ver;
             uint8_t      ttff_interpretation;
             uint8_t      sb_count;
             uint32_t     options;
            } __attribute__((packed)) LS_CLMI_CLMI_REQ_STR;
#define SIZE_LS_CLMI_CLMI_REQ                                 sizeof(LS_CLMI_CLMI_REQ_STR)


//Definition for struct LS_CLMI


//Definition for struct LS_CLMI_CLMI_RESP
#define LS_CLMI_CLMI_RESP                                     0xFF                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      submessage_id;
             uint8_t      status;
             uint8_t      method;
             uint8_t      error_reason;
             uint16_t     fillerbyte1;
            } __attribute__((packed)) LS_CLMI_CLMI_RESP_STR;
#define SIZE_LS_CLMI_CLMI_RESP                                sizeof(LS_CLMI_CLMI_RESP_STR)


//Definition for struct LS_CLMI


//Definition for struct LS_CLMI_CLMI_NTF
#define LS_CLMI_CLMI_NTF                                      0xFF                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      submessage_id;
             uint8_t      status;
             uint8_t      method;
             uint8_t      error_reason;
             uint8_t      fillerbyte1;
             uint8_t      sb_count;
            } __attribute__((packed)) LS_CLMI_CLMI_NTF_STR;
#define SIZE_LS_CLMI_CLMI_NTF                                 sizeof(LS_CLMI_CLMI_NTF_STR)


//Definition for struct LS_CLMI


//Definition for struct LS_CLMI_CLMI_PUSH_ASSISTANCE_REQ
#define LS_CLMI_CLMI_PUSH_ASSISTANCE_REQ                      0xFF                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      submessage_id;
             uint8_t      method;
             uint8_t      fillerbyte1[3];
             uint8_t      sb_count;
             uint32_t     failed_requests;
            } __attribute__((packed)) LS_CLMI_CLMI_PUSH_ASSISTANCE_REQ_STR;
#define SIZE_LS_CLMI_CLMI_PUSH_ASSISTANCE_REQ                 sizeof(LS_CLMI_CLMI_PUSH_ASSISTANCE_REQ_STR)


//Definition for struct LS_CLMI


//Definition for struct LS_CLMI_CLMI_PUSH_ASSISTANCE_RESP
#define LS_CLMI_CLMI_PUSH_ASSISTANCE_RESP                     0xFF                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      submessage_id;
             uint8_t      status;
             uint8_t      method;
             uint8_t      fillerbyte1[3];
            } __attribute__((packed)) LS_CLMI_CLMI_PUSH_ASSISTANCE_RESP_STR;
#define SIZE_LS_CLMI_CLMI_PUSH_ASSISTANCE_RESP                sizeof(LS_CLMI_CLMI_PUSH_ASSISTANCE_RESP_STR)


//Definition for struct LS_CLMI


//Definition for struct LS_CLMI_CLMI_STOP_REQ
#define LS_CLMI_CLMI_STOP_REQ                                 0xFF                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      submessage_id;
             uint8_t      method;
            } __attribute__((packed)) LS_CLMI_CLMI_STOP_REQ_STR;
#define SIZE_LS_CLMI_CLMI_STOP_REQ                            sizeof(LS_CLMI_CLMI_STOP_REQ_STR)


//Definition for struct LS_CLMI


//Definition for struct LS_CLMI_CLMI_STOP_RESP
#define LS_CLMI_CLMI_STOP_RESP                                0xFF                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      submessage_id;
             uint8_t      status;
             uint8_t      method;
             uint8_t      fillerbyte1[3];
            } __attribute__((packed)) LS_CLMI_CLMI_STOP_RESP_STR;
#define SIZE_LS_CLMI_CLMI_STOP_RESP                           sizeof(LS_CLMI_CLMI_STOP_RESP_STR)


//Definition for struct LS_CLMI


//Definition for struct LS_CLMI_CLMI_TEST_REQ
#define LS_CLMI_CLMI_TEST_REQ                                 0xFF                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      sub_message_id;
             uint8_t      sub_block_count;
            } __attribute__((packed)) LS_CLMI_CLMI_TEST_REQ_STR;
#define SIZE_LS_CLMI_CLMI_TEST_REQ                            sizeof(LS_CLMI_CLMI_TEST_REQ_STR)


//Definition for struct LS_CLMI


//Definition for struct LS_CLMI_CLMI_TEST_RESP
#define LS_CLMI_CLMI_TEST_RESP                                0xFF                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      sub_message_id;
             uint8_t      status;
             uint8_t      sub_block_count;
             uint8_t      fillerbyte1[3];
            } __attribute__((packed)) LS_CLMI_CLMI_TEST_RESP_STR;
#define SIZE_LS_CLMI_CLMI_TEST_RESP                           sizeof(LS_CLMI_CLMI_TEST_RESP_STR)


//Definition for struct LS_CLMI


//Definition for struct LS_CLMI_CLMI_TEST_NTF
#define LS_CLMI_CLMI_TEST_NTF                                 0xFF                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      sub_message_id;
             uint8_t      status;
             uint8_t      sub_block_count;
             uint8_t      fillerbyte1[3];
            } __attribute__((packed)) LS_CLMI_CLMI_TEST_NTF_STR;
#define SIZE_LS_CLMI_CLMI_TEST_NTF                            sizeof(LS_CLMI_CLMI_TEST_NTF_STR)


//Definition for struct LS_CLMI


//Definition for struct LS_CLMI_CLMI_HW_CONN_TEST_REQ
#define LS_CLMI_CLMI_HW_CONN_TEST_REQ                         0xFF                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      submessage_id;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) LS_CLMI_CLMI_HW_CONN_TEST_REQ_STR;
#define SIZE_LS_CLMI_CLMI_HW_CONN_TEST_REQ                    sizeof(LS_CLMI_CLMI_HW_CONN_TEST_REQ_STR)


//Definition for struct LS_CLMI


//Definition for struct LS_CLMI_CLMI_HW_CONN_TEST_RESP
#define LS_CLMI_CLMI_HW_CONN_TEST_RESP                        0xFF                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      submessage_id;
             uint8_t      result;
             uint8_t      test1;
             uint8_t      test2;
             uint8_t      test3;
             uint8_t      test4;
            } __attribute__((packed)) LS_CLMI_CLMI_HW_CONN_TEST_RESP_STR;
#define SIZE_LS_CLMI_CLMI_HW_CONN_TEST_RESP                   sizeof(LS_CLMI_CLMI_HW_CONN_TEST_RESP_STR)


//Definition for struct LS_CLMI


//Definition for struct LS_CLMI_CLMI_RXD_NTF
#define LS_CLMI_CLMI_RXD_NTF                                  0xFF                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      submessage_id;
            } __attribute__((packed)) LS_CLMI_CLMI_RXD_NTF_STR;
#define SIZE_LS_CLMI_CLMI_RXD_NTF                             sizeof(LS_CLMI_CLMI_RXD_NTF_STR)


//Definition for struct LS_CLMI


//Definition for struct LS_CLMI_CLMI_TXD_NTF
#define LS_CLMI_CLMI_TXD_NTF                                  0xFF                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      submessage_id;
            } __attribute__((packed)) LS_CLMI_CLMI_TXD_NTF_STR;
#define SIZE_LS_CLMI_CLMI_TXD_NTF                             sizeof(LS_CLMI_CLMI_TXD_NTF_STR)


//Definition for struct LS_CLMI


//Definition for struct LS_CLMI_CLMI_INT_NTF
#define LS_CLMI_CLMI_INT_NTF                                  0xFF                                                  
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      submessage_id;
            } __attribute__((packed)) LS_CLMI_CLMI_INT_NTF_STR;
#define SIZE_LS_CLMI_CLMI_INT_NTF                             sizeof(LS_CLMI_CLMI_INT_NTF_STR)

#endif
