#ifndef _PN_SIM_ISI_H_
#define _PN_SIM_ISI_H_

#include <stdint.h> 

//Resource SIM Server
//PN_SIM 0x09 
//ISI version 018.002
#define SIM_SERVER_ISI_VERSION_Z     18
#define SIM_SERVER_ISI_VERSION_Y     2

//In case of problems concerning content of this file contact Henrik Ala-Uotila
//Server specific message descriptions and feature&protocol descriptions can be found from: https://oucmswww.nmp.nokia.com:58443/document_browser/ccm_wa/GIF_SPECS/ 


//ISI VERSION CHANGE HISTORY

//Version: 018.002                                           
//Status: Approved                                          
//Date: 11-Feb-2009     Nikolaj Skov
//Reason: Change to SUB_MSG_REQUEST_HDR macro.
//Reference: ActionDB for SWAM: NS09021134415, Approved

//Version: 018.000                                           
//Status: Approved                                          
//Date: 07-Jan-2008     Thomas Stormark
//Reason: Updating ISI interface CR to I_CPR_7.2 on Smartcard profile: Parental Control Pincode and OMA BCAST AUTHENTICATE response
//Reference: RM-RIM: 006-15505, 006-16563, Synergy/CM task: co1core#86560, ActionDB for SWAM:TS07110689414, Approved

//Version: 017.006                                           
//Status: Approved                                          
//Date: 05-Dec-2007     John Soerensen
//Reason: RM-RIM:408-2329
//Reference: Synergy/CM task: co1core#87508, ActionDB for SWAM: JS07111351317, Approved

//Version: 017.004                                           
//Status: Approved                                          
//Date: 20-Aug-2007     John Soerensen
//Reason: RM-RIM:006-14131
//Reference: Synergy/CM task: co1core#74622, ActionDB for SWAM: JS07062732576, Approved

//Version: 017.003                                           
//Status: Approved                                          
//Date: 03-Aug-2007     Thomas Stormark
//Reason: Updating ISI interface for 408-1076: SIM Server support for lumiere gba_u and MGV_U
//Reference: Synergy/CM task: co1core#76808, ActionDB for SWAM: TS07061989406, Approved

//Version: 017.002                                           
//Status: Approved                                          
//Date: 19-Dec-2006     Nikolaj Skov
//Reason: Addition of SIM_ST_REFRESH_STARTING service type to SIM_REFRESH_NTF.
//Reference: Synergy/CM task: co1core#70603, ActionDB for SWAM: NS07032335341, Synergy/CM task: co1core#64901, ActionDB for SWAM: NS06112745514, Approved

//Version: 017.001                                           
//Status: Approved                                          
//Date: 15-Dec-2006     Thomas Stormark
//Reason: Updating ISI interface for 006-12840: Enhanced FETCH handling
//Reference: CM Synergy task: co1core#56686, WP RM-RIM Tool: 006-12840, ActionDB for SWAM: TS06103133373, Approved

//Version: 017.000                                           
//Status: Approved                                          
//Date: 23-Oct-2006     Soren Engquist
//Reason: Remove RUIM and GAIT
//Reference: CM Synergy task: co1core#62431, WP RM-RIM Tool: 006-14124, ActionDB for SWAM: SE06102354231, Approved

//Version: 016.000                                           
//Status: Approved                                          
//Date: 10-Aug-2006     Paetur Petersen
//Reason: Remove dependency to Tracfone Server
//Reference: CM Synergy task: co1core#11885, WP RM-RIM Tool: 006-13174, ActionDB for SWAM: PP06072156397, Approved

//Version: 015.011                                           
//Status: Approved                                          
//Date: 19-May-2006     Annette Thy
//Reason: Macrofile should be created for SIM server
//Reference: CM Synergy task: co1core#50080, WP RM-RIM Tool: 006-8365, ActionDB for SWAM: AT06051933264, Approved

//Version: 015.010                                           
//Status: Approved                                          
//Date: 02-May-2006     Thomas Stormark
//Reason: Updating ISI interface for 010-182: Support for EF-ACL UI part
//Reference: CM Synergy task: co1core#50821, WP RM-RIM Tool: 010-182, ActionDB for SWAM: TS06050249393, Approved

//Version: 015.009                                           
//Status: Approved                                          
//Date: 06-Apr-2006     Soren Engquist
//Reason: Changing constant for 006-10452: Remove SIM_SERV_LOC_NOT_VALID
//Reference: CM Synergy task: co1core#49940, WP RM-RIM Tool: 006-10452, ActionDB for SWAM: SE06040351729, Approved

//Version: 015.008                                           
//Status: Approved                                          
//Date: 04-Apr-2006     Soren Engquist
//Reason: PCP Error: EO06032951336 GSM/WCDMA - OTC - SIm phonebook : entering a 70 caracters long email address
//Reference: CM Synergy task: co1core#49973, PCP Error: EO06032951336, ActionDB for SWAM: SE06040442314, Approved

//Version: 015.007                                           
//Status: Approved                                          
//Date: 13-Mar-2006     Michael Noerlev
//Reason: Adding ISI interface for 006-5954: APN - Support for EFACL
//Reference: CM Synergy task: co1core#48518, WP RM-RIM Tool: 006-5954, ActionDB for SWAM: MN05122035049, Approved

//Version: 015.006                                           
//Status: Approved                                          
//Date: 21-Feb-2006     Michael Noerlev
//Reason: Adding ISI interface for 006-5954: APN - Support for EFACL
//Reference: CM Synergy task: co1core#42462, WP RM-RIM Tool: 006-5954, ActionDB for SWAM: MN05122035049, Approved

//Version: 015.005                                           
//Status: Approved                                          
//Date: 09-Jan-2006     Nikolaj Skov Hansen
//Reason: New ISI message to retrieve number of remaining verification attempts for PIN and PUK.
//Reference: CM Synergy task: co1core#43453, ActionDB for SWAM: NH05120235814, Approved

//Version: 015.004                                           
//Status: Approved                                          
//Date: 02-Jan-2006     Paetur Petersen
//Reason: Adding ISI interface for TracFone integration to GSM ISA
//Reference: CM Synergy task: co1core#42394, WP RM-RIM Tool: 006-8308, ActionDB for SWAM: PE05121357262, Approved

//Version: 015.003                                           
//Status: Approved                                          
//Date: 14-Dec-2005     Soren Engquist
//Reason: Adding service types for SIM_READ_TABLE_REQ
//Reference: CM Synergy task: co1core#30746, WP RM-RIM Tool: 006-10401, ActionDB for SWAM: SE05121450785, Approved

//Version: 015.001                                           
//Status: Approved                                          
//Date: 17-Nov-2005     Soren Engquist
//Reason: Adding service types for SIM_DATA_SIZES_REQ
//Reference: CM Synergy task: co1core#40951, ActionDB for SWAM: SE05110833235, Approved

//Version: 015.000                                           
//Status: Approved                                          
//Date: 31-Oct-2005     Nikolaj Skov Hansen
//Reason: Change of status values for R-UIM Operational Mode
//Reference: CM Synergy task: co1core#39074, ActionDB for SWAM: NH05100554048, Approved

//Version: 014.019                                           
//Status: Approved                                          
//Date: 06-Oct-2005     Michael Noerlev
//Reason: Support EF-EHPLMN field on USIM
//Reference: CM Synergy task: co1core#38855, WP RM-RIM Tool: 006-8926, ActionDB for SWAM: PP05090846932, Approved

//Version: 014.018                                           
//Status: Approved                                          
//Date: 06-Sep-2005     Nikolaj Skov Hansen
//Reason: Interface for ESN
//Reference: CM Synergy task: co1core#38516, WP RM-RIM Tool: 006-9582, ActionDB for SWAM: NH05083056389, Approved

//Version: 014.017                                           
//Status: Approved                                          
//Date: 06-Jul-2005     Soren Engquist
//Reason: Long configuration subblocks for phonebook.
//Reference: CM Synergy task: co1core#37125, WP RM-RIM Tool: 006-9284, ActionDB for SWAM: SE05070537600 (Change Request), ActionDB for SWAM: SE05070654225 (Inspection Minutes), Approved

//Version: 014.016                                           
//Status: Approved                                          
//Date: 06-Jun-2005     Annette Thy
//Reason: New ServiceTypes for O2 HomeZone
//Reference: CM Synergy task: co1core#34393, WP RM-RIM Tool: 006-8372 & 006-8373, ActionDB for SWAM: AT05051844532 (Change Request), ActionDB for SWAM: AT05052733033 (Inspection Minutes), Approved

//Version: 014.015                                           
//Status: Approved                                          
//Date: 17-Mar-2005     Nikolaj Skov Hansen
//Reason: New ServiceType for CALL CONTROL
//Reference: CM Synergy task: co1core#29306, WP RM-RIM Tool: 006-7198, ActionDB for SWAM: NH05022459122 (Change Request), ActionDB for SWAM: NH05031732544 (Inspection Minutes), Approved

//Version: 014.014                                           
//Status: Approved                                          
//Date: 11-Mar-2005     Nikolaj Skov Hansen
//Reason: SIM: New SMS interface for SCO 006-5531 - Support for new messaging platform.
//Reference: CM Synergy task: co1core#28220, WP RM-RIM Tool: 006-5531, ActionDB for SWAM: NH04102546452 (Change Request), ActionDB for SWAM: NH05030245613 (Inspection Minutes), Approved

//Version: 014.013                                           
//Status: Approved                                          
//Date: 03-Mar-2005     Nikolaj Skov Hansen
//Reason: Additions to SIM_RUIM_IND and SIM_STATUS_REQ.
//Reference: CM Synergy task: co1core#27327, ActionDB for SWAM: NH05013146615 (Change Request), ActionDB for SWAM: NH05021845815 (Inspection Agenda), Approved

//Version: 014.012                                           
//Status: Approved                                          
//Date: 23-Feb-2005     Erik Laursen
//Reason: SIM: Icon buffering in ISA and splitting to SOS
//Reference: CM Synergy task co1core#27565, WP RM-RIM Tool: 009-16822: Icon buffering in ISA and splitting to SOS, ActionDB for SWAM: EL05021030307 (Change Request), ActionDB for SWAM: EL05022353233 (Inspection Minutes), Approved

//Version: 014.011                                           
//Status: Approved                                          
//Date: 31-Jan-2005     Erik Laursen
//Reason: SIM: Support of ISIM for IMS access
//Reference: CM Synergy task co1core#24439, WP RM-RIM Tool: 006-3097, ActionDB for SWAM: EL04122339567 (Change Request), ActionDB for SWAM: EL05013146658 (Inspection Minutes), PCP Error: VS05020960999, Approved

//Version: 014.010                                           
//Status: Approved                                          
//Date: 11-Jan-2005     Annette Thy
//Reason: SIM: EAP-AKA authentication support in SIMSON
//Reference: CM Synergy task co1core#15124, WP RM-RIM Tool: 006-3761, ActionDB for SWAM: AT04092342665 (Change Request), ActionDB for SWAM: AT04112555298 (Inspection Minutes), Approved

//Version: 014.009                                           
//Status: Approved                                          
//Date: 06-Jan-2005     Dan Egebo
//Reason: New service type added
//Reference: CM Synergy task co1core#21462, WP RM-RIM Tool: 006-5886: Connecting SIM from PDA mode in DSS, ActionDB for SWAM:  DE04110854756(Change Request), ActionDB for SWAM:  DE04112334116(Inspection Minutes), Approved

//Version: 014.008                                           
//Status: Approved                                          
//Date: 26-Nov-2004     Jorgen Moller Ilsoe
//Reason: Addition of new subblock to phonebook start-up phase 2
//Reference: CM Synergy task co1core#20930, WP RM-RIM Tool: 006-6382, ActionDB for SWAM: JI04102053490 (Change Request), ActionDB for SWAM: JI04111546442 (Inspection Minutes), Approved

//Version: 014.007                                           
//Status: Approved                                          
//Date: 04-Nov-2004     Erik Laursen
//Reason: SIM: Addition of missing file IDs for Refresh Release 99 implementation
//Reference: CM Synergy task co1core#20852, WP RM-RIM Tool: 006-2213, ActionDB for SWAM: EL04102542507 (Change Request), ActionDB for SWAM: EL04110542986 (Inspection Minutes), Approved

//Version: 014.006                                           
//Status: Approved                                          
//Date: 08-Sep-2004     Nikolaj Skov Hansen
//Reason: SIM: New interface for R-UIM
//Reference: CM Synergy task co1core#14144, WP RM-RIM Tool: 006-4630, ActionDB for SWAM: NH04063042099 (Change Request), ActionDB for SWAM: NH04072053264 (Inspection Minutes), Approved

//Version: 014.005                                           
//Status: Approved                                          
//Date: 01-Jul-2004     Nikolaj Skov Hansen
//Reason: SIM: SIMLOCK state enquiry with req/resp message
//Reference: Continuus task co1core#12352, WP RM-RIM Tool: 006-4864, ActionDB for SWAM: NH04061753527 (Change Request), ActionDB for SWAM: NH04062444852 (Inspection Minutes), Approved

//Version: 014.004                                           
//Status: Approved                                          
//Date: 10-Jun-2004     Erik Laursen
//Reason: SIM: Support for disabling and enabling of PIN2 on USIM Cards
//Reference: Continuus task co_sim#37182, WP RM-RIM Tool: 006-4125: Disable/Enable PIN2 on USIM, ActionDB for SWAM: EL04052746922 (Change Request), Approved

//Version: 014.003                                           
//Status: Approved                                          
//Date: 03-Jun-2004     Nikolaj Skov Hansen
//Reason: New ISI interface for provisioning of MMS settings on the (U)SIM
//Reference: Continuus task co_sim#36409, WP RM-RIM Tool: 006-3566, ActionDB for SWAM: NH04042755103 (Change Request), ActionDB for SWAM: NH04051949372 (Inspection Minutes), Approved

//Version: 014.002                                           
//Status: Approved                                          
//Date: 13-May-2004     Nikolaj Skov Hansen
//Reason: Implementation of full refresh according to 3GPP TS 11.14
//Reference: Continuus task co_sim#35574, WP RM-RIM Tool: 006-2213, ActionDB for SWAM: JM04032334025 (Change Request), ActionDB for SWAM: NH04042643144 (Inspection), Approved

//Version: 014.000                                           
//Status: Approved                                          
//Date: 19-Mar-2004     Jorgen Ilsoe
//Reason: PCP MM04021959464
//Reference: CM Synergy task co_sim#33486 (simson) , CM Synergy task co_sim#35601 (DSS), PCP MM04021959464, ActionDB for SWAM: JI04022354652, ActionDB for SWAM: JI04031944552, Approved

//Version: 013.000                                           
//Status: Unknown                                           
//Date: -               -
//Reason: -
//Reference: -

//Version: 012.000                                           
//Status: Unknown                                           
//Date: -               -
//Reason: -
//Reference: -

//Version: 001.000                                           
//Status: Unknown                                           
//Date: -               -
//Reason: -
//Reference: -


//CONSTANTS
#define COMM_MAX_FTD_STRING_LENGTH                            0x7C                                                  
#define SIM_MAX_NBR_OF_CBMIDS                                 0x05                                                     
#define SIM_MAX_NBR_OF_EMRG_CALL_CODES                        0x05                                                     
#define SIM_NBR_OF_CELL_BC_MSG_IDS                            0x0F                                                     
#define SIM_NAME_LEN                                          0x33                                                  
#define SIM_NUMBER_LEN                                        0x31                                                  
#define SIM_TEXT_LEN                                          0x3D                                                  
#define SIM_PUCT_CURRENCY_CODE_LEN                            0x04                                                     
#define SIM_FILE_PATH_LEN                                     0x08                                                     
#define SMS_ADDRESS_MAX_LENGTH                                0x0C                                                     
#define MAX_CODE_LEN                                          0x09                                                     
#define SIM_PLMN_LEN                                          0x03                                                     
#define SIM_PLMN_ACCESS_TECHNOLOGY_LEN                        0x02                                                     
#define SIM_MAX_NUMBER_OF_TAGS                                0x0A                                                     
#define SIM_ICC_ID_LEN                                        0x0A                                                     
#define SIM_IMSI_LEN                                          0x08                                                     
#define SIM_PLMN_SELECTOR_LIST_LEN                            0x54                                                  
#define SIM_ANY_SIZE                                          1                                                     
#define SIM_ACC_CTRL_LEN                                      0x02                                                     
#define SIM_BCCH_INFO_LEN                                     0x10                                                  
#define SIM_HPLMN_LEN                                         0x03                                                     
#define SIM_LAI_LEN                                           0x05                                                     
#define RPLMN_LAST_USED_AT_LEN                                0x02                                                     
#define SIM_TMSI_LEN                                          0x04                                                     
#define SIM_GPRS_CIPH_KEY_LEN                                 0x08                                                     
#define SIM_RAI_LEN                                           0x06                                                     
#define SIM_GPRS_TMSI_LEN                                     0x04                                                     
#define SIM_GPRS_TMSI_SIGN_VAL_LEN                            0x03                                                     
#define SIM_CIPH_KEY_LEN                                      0x08                                                     
#define SIM_UMTS_CS_CIPH_KEY_LEN                              0x10                                                  
#define SIM_UMTS_CS_INTE_KEY_LEN                              0x10                                                  
#define SIM_EAP_CIPH_KEY_LEN                                  0x10                                                  
#define SIM_EAP_INTE_KEY_LEN                                  0x10                                                  
#define SIM_UMTS_PS_CIPH_KEY_LEN                              0x10                                                  
#define SIM_UMTS_PS_INTE_KEY_LEN                              0x10                                                  
#define SIM_UMTS_PS_HFN_LEN                                   0x03                                                     
#define SIM_UMTS_CS_HFN_LEN                                   0x03                                                     
#define SIM_UMTS_START_MAX_LEN                                0x03                                                     
#define ICCID_LENGTH                                          0x0A                                                     
#define SIM_UMTS_AUTS_PARAMS_LEN                              0x0E                                                     
#define SIM_RES_MAX_LEN                                       0x10                                                  
#define SIM_RND_PARAMS_LEN                                    0x10                                                  
#define SIM_UMTS_AUTN_PARAMS_LEN                              0x10                                                  
#define SIM_SMS_TIME_STAMP_LEN                                0x07                                                     
#define READ_FIELD_OFFSET_LEN                                 0x02                                                     
#define SIM_LANG_PREF_LEN                                     0x04                                                     
#define SIM_MAX_NBR_OF_JACOB_IDS                              0x20                                                  


//TABLES

//ConstantTable for SIM_ATK_SERVICE_TYPE_TABLE
#define SIM_ST_REFRESH_INIT_FROM_PIN                          0x00                                                     
#define SIM_ST_REFRESH_FCN                                    0x01                                                     
#define SIM_ST_REFRESH_INIT_FROM_PIN_FCN                      0x02                                                     
#define SIM_ST_REFRESH_INIT_FROM_PIN_FFCN                     0x03                                                     
#define SIM_ST_REFRESH_RESET                                  0x04                                                     
#define SIM_ST_REFRESH_APPLICATION_RESET                      0x05                                                     
#define SIM_ST_REFRESH_REFRESH_3G_SESSION_RESET               0x06                                                     
#define SIM_ST_SET_POLLING                                    0x10                                                  
#define SIM_ST_READ_ICON                                      0x11                                                  
#define SIM_ST_READ_ICON_CLUT                                 0x12                                                  
#define SIM_ST_READ_ICON_BODY_DATA                            0x13                                                  
#define SIM_ST_SEND_ENVELOPE                                  0x14                                                  
#define SIM_ST_CAT_SUPPORT_ENABLE                             0x15                                                  
#define SIM_ST_CAT_SUPPORT_DISABLE                            0x16                                                  

//ConstantTable for SIM_PIN_STATE_SERVICE_TYPE_TABLE
#define SIM_ST_GET_ACTIVE_PIN                                 0x9B                                                  

//ConstantTable for SIM_STATUS_SERVICE_TYPE_TABLE
#define SIM_ST_CARD_STATUS                                    0x00                                                     
#define SIM_ST_SIMLOCK_STATUS                                 0x01                                                     

//ConstantTable for SIM_PREF_LANGUAGE_SERVICE_TYPE_TABLE
#define SIM_ST_READ_PL_LANGUAGE                               0x01                                                     
#define SIM_ST_READ_LI_LANGUAGE                               0x02                                                     
#define SIM_ST_WRITE_PL_LANGUAGE                              0x03                                                     
#define SIM_ST_WRITE_LI_LANGUAGE                              0x04                                                     

//ConstantTable for SIM_ACM_SERVICE_TYPE_TABLE
#define SIM_ST_INCREMENT                                      0x12                                                  
#define SIM_ST_SET                                            0x13                                                  
#define SIM_ST_READ_AOC                                       0x14                                                  
#define SIM_ST_MAX_VALUE_SET                                  0x15                                                  
#define SIM_ST_MAX_VALUE_READ                                 0x16                                                  

//ConstantTable for SIM_IMSI_SERVICE_TYPE_TABLE
#define READ_IMSI                                             0x2D                                                  

//ConstantTable for SIM_SERV_PROV_NAME_SERVICE_TYPE_TABLE
#define SIM_ST_SPN_DISPLAY_INFO                               0x01                                                     
#define SIM_ST_READ_SERV_PROV_NAME                            0x2C                                                  

//ConstantTable for SIM_VOICE_MSG_CALL_FWD_SERVICE_TYPE_TABLE
#define SIM_ST_WRITE_MSG_FLAGS                                0x01                                                     
#define SIM_ST_READ_MSG_FLAGS                                 0x02                                                     
#define SIM_ST_WRITE_CALL_FWD_FLAGS                           0x03                                                     
#define SIM_ST_READ_CALL_FWD_FLAGS                            0x04                                                     
#define SIM_ST_WRITE_FLAGS                                    0x39                                                  
#define SIM_ST_READ_FLAGS                                     0x3A                                                  

//ConstantTable for SIM_APP_SELECTION_SERVICE_TYPE_TABLE
#define SIM_ST_GET_NUMBER_OF_APP                              0x01                                                     
#define SIM_ST_GET_ALL_APP_LABELS                             0x02                                                     
#define SIM_ST_GET_ACTIVE_APP_LABEL                           0x03                                                     
#define SIM_ST_SET_DEFAULT_APP                                0x04                                                     
#define SIM_ST_ACTIVATE_APP                                   0x05                                                     
#define SIM_ST_SET_APP_SELECTION_AUTOMATIC                    0x06                                                     
#define SIM_ST_SET_APP_SELECTION_MANUAL                       0x07                                                     
#define SIM_ST_GET_APP_SELECTION_STATUS                       0x08                                                     
#define SIM_ST_GET_ISIM_LABEL                                 0x09                                                     
#define SIM_ST_GET_LABEL_BY_NO                                0x0A                                                     

//ConstantTable for SIM_CONNECTION_SERVICE_TYPE_TABLE
#define SIM_ST_SIM_DISCONNECT                                 0x01                                                     
#define SIM_ST_SIM_CONNECT                                    0x02                                                     
#define SIM_ST_SIM_RECONNECT                                  0x03                                                     
#define SIM_ST_SIM_CONNECT_FORCED_PIN                         0x04                                                     

//ConstantTable for SIM_OPERATOR_SERVICE_TYPE_TABLE
#define SIM_ST_READ_OPL                                       0x13                                                  
#define SIM_ST_READ_PNN                                       0x14                                                  
#define READ_NAME                                             0x3E                                                  

//ConstantTable for SIM_PB_SERVICE_TYPE_TABLE
#define SIM_PB_READ                                           0x0F                                                     
#define SIM_PB_WRITE                                          0x10                                                  
#define SIM_PB_GET_CONF                                       0x11                                                  
#define SIM_PB_SELECT_PB                                      0x13                                                  

//ConstantTable for SIM_PN_SERVICE_TYPE_TABLE
#define SIM_ST_ADN                                            0x07                                                     
#define SIM_ST_FDN                                            0x09                                                     
#define SIM_ST_VMBX                                           0x0B                                                     
#define SDN                                                   0x49                                                  

//ConstantTable for SIM_REFRESH_SERVICE_TYPE_TABLE
#define SIM_ST_REFRESH_REGISTER                               0x01                                                     
#define SIM_ST_REFRESH_UNREGISTER                             0x02                                                     
#define SIM_ST_REFRESH_OK                                     0x03                                                     
#define SIM_ST_REFRESH_NOT_OK                                 0x04                                                     
#define SIM_ST_REFRESH_DONE                                   0x05                                                     
#define SIM_ST_REFRESH_ERROR                                  0x06                                                     
#define SIM_ST_REFRESH_REQUESTED                              0x07                                                     
#define SIM_ST_REFRESH_NOW                                    0x08                                                     
#define SIM_ST_REFRESH_CANCELLED                              0x09                                                     

//ConstantTable for SIM_MMS_SERVICE_TYPE_TABLE
#define SIM_ST_MMS_ICP_READ                                   0x01                                                     
#define SIM_ST_MMS_UP_READ                                    0x02                                                     

//ConstantTable for SIM_IMS_SERVICE_TYPE_TABLE
#define SIM_ST_IMS_START_SESSION                              0x01                                                     
#define SIM_ST_IMS_END_SESSION                                0x02                                                     
#define SIM_ST_IMS_STATUS                                     0x03                                                     
#define SIM_ST_IMS_READ_DATA                                  0x04                                                     

//ConstantTable for SIM_CS_SERVICE_TYPE_TABLE
#define SIM_ST_CS_DATA_READ_REQ                               0x01                                                     
#define SIM_ST_CS_DATA_READ_ALL_REQ                           0x02                                                     
#define SIM_ST_CS_DATA_WRITE_REQ                              0x03                                                     
#define SIM_ST_CS_STATUS_REQ                                  0x04                                                     
#define SIM_ST_CS_DATA_READ_ALL_GSS_REQ                       0x05                                                     

//ConstantTable for SIM_AUTH_SERVICE_TYPE_TABLE
#define SIM_ST_CS_GSM_CONTEXT                                 0x05                                                     
#define SIM_ST_CS_UMTS_CONTEXT                                0x06                                                     
#define SIM_ST_PS_GSM_CONTEXT                                 0x07                                                     
#define SIM_ST_PS_UMTS_CONTEXT                                0x08                                                     
#define SIM_ST_EAP_SIM_CONTEXT                                0x09                                                     
#define SIM_ST_EAP_AKA_CONTEXT                                0x0A                                                     
#define SIM_ST_IMS_CONTEXT                                    0x0B                                                     
#define SIM_ST_GBA_BOOTSTRAP                                  0x0C                                                     
#define SIM_ST_GBA_BOOTSTRAP_UPDATE                           0x0D                                                     
#define SIM_ST_GBA_NAF_DERIVATION                             0x0E                                                     
#define SIM_ST_MSK_UPDATE                                     0x0F                                                     
#define SIM_ST_MTK_GENERATION                                 0x10                                                  
#define SIM_ST_MSK_DELETION                                   0x11                                                  
#define SIM_ST_MUK_DELETION                                   0x12                                                  
#define SIM_ST_BCAST_SPE_AUDIT_KEYS                           0x13                                                  
#define SIM_ST_BCAST_SPE_AUDIT_SECURITY_POLICY                0x14                                                  
#define SIM_ST_BCAST_SPE_DELETION                             0x15                                                  
#define SIM_ST_BCAST_REC_DELETION                             0x16                                                  
#define SIM_ST_BCAST_REC_SIGNALLING                           0x17                                                  
#define SIM_ST_BCAST_REC_AUDIT_CONTENT                        0x18                                                  

//ConstantTable for SIM_AM_SERVICE_TYPE_TABLE
#define SIM_ST_APP_INFO                                       0x01                                                     
#define SIM_ST_APP_GET_ALL_LABELS                             0x02                                                     
#define SIM_ST_APP_ACTIVATE                                   0x03                                                     
#define SIM_ST_APP_RELEASE                                    0x04                                                     
#define SIM_ST_APP_SERVICE_AVAIL                              0x05                                                     
#define SIM_ST_FILE_DATA_READ                                 0x06                                                     

//ConstantTable for SIM_SMS_SERVICE_TYPE_TABLE
#define SIM_ST_SMS_GET_NUM_OF_LOC                             0x01                                                     
#define SIM_ST_SMS_READ                                       0x02                                                     
#define SIM_ST_SMS_WRITE                                      0x03                                                     
#define SIM_ST_SMS_ERASE                                      0x04                                                     
#define SIM_ST_SMS_UPDATE_STATUS                              0x05                                                     
#define SIM_ST_SMS_READ_RAW                                   0x06                                                     
#define SIM_ST_SMS_WRITE_RAW                                  0x07                                                     

//ConstantTable for SIM_HOMEZONE_SERVICE_TYPE_TABLE
#define SIM_ST_READ_SUBSCRIBED_LAC_CI                         0x4F                                                  
#define SIM_ST_READ_HZ_TAGS                                   0x50                                                  
#define SIM_ST_READ_UHZIUE_SETTINGS                           0x51                                                  
#define SIM_ST_WRITE_UHZIUE_SETTINGS                          0x52                                                  

//ConstantTable for SIM_ACM_ACCESS_SERVICE_TYPE_TABLE
#define ACM_SET                                               0x43                                                  
#define ACM_MAX_SET                                           0x44                                                  
#define PUCT_SET                                              0x45                                                  

//ConstantTable for SIM_ICC_TYPE_SERVICE_TYPE_TABLE
#define SIM_ST_READ_SB                                        0x01                                                     
#define SIM_ST_READ_ALL_SB                                    0x02                                                     
#define SIM_ST_READ_ACTIVE_AID_SB                             0x03                                                     

//ConstantTable for SIM_STATE_TABLE
#define STATE_SIM_INIT_WAIT                                   0x01                                                     
#define STATE_SIM_LOCK_OPERATIVE                              0x02                                                     
#define STATE_SIM_PIN_VERIFY_REQUIRED                         0x03                                                     
#define STATE_SIM_PERMANENTLY_BLOCKED                         0x04                                                     
#define STATE_SIM_REMOVED                                     0x05                                                     
#define STATE_SIM_REJECTED                                    0x06                                                     
#define STATE_SIM_BLOCKED                                     0x07                                                     
#define STATE_SIM_OK                                          0x08                                                     

//ConstantTable for SIM_PLMN_OPERATIONS_TABLE
#define PLMN_ADD                                              0x2A                                                  
#define PLMN_REMOVE                                           0x57                                                  

//ConstantTable for SIM_MISC_SERVICE_TYPE_TABLE
#define SIM_ST_PIN                                            0x01                                                     
#define SIM_ST_PIN2                                           0x02                                                     
#define SIM_ST_ALL_SERVICES                                   0x05                                                     
//#define SIM_ST_ADN                                          0x07                        //Already defined as 0x07
//#define SIM_ST_FDN                                          0x09                        //Already defined as 0x09
#define VMBX                                                  0x0B                                                     
#define SIM_ST_INFONUM                                        0x0C                                                     
#define SIM_ST_INFO                                           0x0D                                                     
#define SIM_ST_JACOB                                          0x0E                                                     
#define SMS                                                   0x0F                                                     
#define ACM                                                   0x10                                                  
#define SERVICE_TABLE                                         0x11                                                  
#define READ_ADN_CNT                                          0x18                                                  
#define READ_ADN_ALPHA_LEN                                    0x19                                                  
#define READ_PLMN_SELECTOR_CNT                                0x1A                                                  
#define READ_FDN_CNT                                          0x1B                                                  
#define READ_FDN_ALPHA_LEN                                    0x1C                                                  
#define READ_MSISDN_CNT                                       0x1D                                                  
#define READ_MSISDN_ALPHA_LEN                                 0x1E                                                  
#define READ_SMS_PARAM_CNT                                    0x1F                                                  
#define READ_SMS_PARAM_ALPHA_LEN                              0x20                                                  
#define READ_PREF_LANGUAGE_CNT                                0x21                                                  
#define READ_OPERATOR_NAME_LEN                                0x22                                                  
#define READ_MBX_CNT                                          0x23                                                  
#define READ_MBX_ALPHA_LEN                                    0x24                                                  
#define READ_CB_MSG_ID_CNT                                    0x25                                                  
#define READ_CSP1_LEN                                         0x26                                                  
#define READ_INF_NBR_CNT                                      0x27                                                  
#define READ_JACOB_ID_CNT                                     0x28                                                  
#define READ_VMWI_LEN                                         0x29                                                  
#define READ_CPHS_LEN                                         0x2A                                                  
#define READ_ECC_CNT                                          0x2B                                                  
#define READ_PREF_LANGUAGE                                    0x2E                                                  
#define READ_HPLMN                                            0x2F                                                  
#define WRITE_FIRST_PLMN                                      0x31                                                  
#define MSISDN_STORE                                          0x32                                                  
#define CHECK_CELL_ID                                         0x33                                                  
#define READ_ID                                               0x34                                                  
#define READ_DYN_FLAGS                                        0x35                                                  
#define WRITE_DYN_FLAGS                                       0x36                                                  
#define READ_DYN2_FLAGS                                       0x37                                                  
#define WRITE_DYN2_FLAGS                                      0x38                                                  
#define READ_LINE_DATA                                        0x3B                                                  
#define READ_TO_SCM                                           0x3C                                                  
#define WRITE_FROM_SCM                                        0x3D                                                  
#define READ_DATA                                             0x3F                                                  
#define READ_PACKAGE                                          0x40                                                  
#define READ_COORDINATES                                      0x41                                                  
#define MSISDN_READ                                           0x42                                                  
//#define ACM_SET                                             0x43                       //Already defined as 0x43
//#define ACM_MAX_SET                                         0x44                       //Already defined as 0x44
//#define PUCT_SET                                            0x45                       //Already defined as 0x45
#define PREF_LANGUAGE                                         0x46                                                  
#define EMERGENCY_CODES                                       0x47                                                  
#define READ_CB_MSG_IDS                                       0x48                                                  
//#define SDN                                                 0x49                       //Already defined as 0x49
#define INFO_USER_WHEN_MSG_SEND                               0x4A                                                  
#define FACTORY_SETTING                                       0x4B                                                  
#define READ_PARAM                                            0x4C                                                  
#define READ_CACHE                                            0x4D                                                  
#define WRITE_CACHE                                           0x4E                                                  
#define READ_PARAMETER                                        0x52                                                  
#define UPDATE_PARAMETER                                      0x53                                                  
#define READ_STATUS                                           0x54                                                  
#define WRITE_STATUS                                          0x55                                                  
#define GPRS_AUTH                                             0x61                                                  
#define GSM_AUTH                                              0x62                                                  
#define CS                                                    0x63                                                  
#define READ_FIELD                                            0x64                                                  
#define ACC                                                   0x65                                                  
#define ICC                                                   0x66                                                  
#define AD                                                    0x67                                                  
#define ICC_EQUAL                                             0x68                                                  
#define UPDATE_CB_MSGIDS                                      0x69                                                  
#define READ_REAL_JACOB_IDS                                   0x6A                                                  
#define CB_DOWNLOAD                                           0x6B                                                  
#define READ_CBMIDS                                           0x6C                                                  
#define READ_ADN_NBR_LEN                                      0x6E                                                  
#define READ_FDN_NBR_LEN                                      0x6F                                                  
#define READ_MSISDN_NBR_LEN                                   0x70                                                  
#define SIM_ST_APP_SELECTION                                  0x96                                                  
#define SIM_ST_PIN_UNIVERSAL                                  0x97                                                  
#define SIM_ST_SUBSTITUTE_PIN                                 0x99                                                  
#define SIM_ST_SUBSTITUTE_PIN_UNIVERSAL                       0x9A                                                  
#define SIM_ST_READ_VMBX_CNT                                  0x9C                                                  
#define SIM_ST_READ_VMBX_ALPHA_LEN                            0x9D                                                  
#define SIM_ST_READ_VMBX_NBR_LEN                              0x9E                                                  
#define SIM_ST_READ_MBDN_CNT                                  0x9F                                                  
#define SIM_ST_READ_MBDN_PROFILE_SIZE                         0xA0                                                  
#define SIM_ST_READ_MBDN_PROFILE_CNT                          0xA1                                                  
#define SIM_ST_READ_MBDN_ALPHA_LEN                            0xA2                                                  
#define SIM_ST_READ_MBDN_NBR_LEN                              0xA3                                                  
#define SIM_ST_PUK                                            0xA4                                                  
#define SIM_ST_PUK2                                           0xA5                                                  
#define SIM_ST_PUK_UNIVERSAL                                  0xA6                                                  
#define SIM_ST_PIN_PARENTAL_CONTROL                           0xA7                                                  
#define SIM_ST_PUK_PARENTAL_CONTROL                           0xA8                                                  
#define NO_SERVICE_TYPE                                       0xFA                                                  

//ConstantTable for SIM_ST_TABLE
#define SIM_ST_PIN1_DISABLE_FUNCTION                          0x01                                                     
#define SIM_ST_ADN_AVAIL                                      0x02                                                     
#define SIM_ST_FDN_AVAIL                                      0x72                                                  
#define SIM_ST_SMS_AVAIL                                      0x04                                                     
#define SIM_ST_AOC_AVAIL                                      0x71                                                  
#define SIM_ST_CCP_AVAIL                                      0x06                                                     
#define SIM_ST_PLMN_SELECTOR_AVAIL                            0x07                                                     
#define SIM_ST_MSISDN_AVAIL                                   0x08                                                     
#define SIM_ST_EXT1_AVAIL                                     0x09                                                     
#define SIM_ST_EXT2_AVAIL                                     0x0A                                                     
#define SIM_ST_EXT3_AVAIL                                     0x0B                                                     
#define SIM_ST_EXT4_AVAIL                                     0x0C                                                     
#define SIM_ST_EXT5_AVAIL                                     0x0D                                                     
#define SIM_ST_SMSP_AVAIL                                     0x0E                                                     
#define SIM_ST_LDN_AVAIL                                      0x0F                                                     
#define SIM_ST_CBMI_AVAIL                                     0x10                                                  
#define SIM_ST_GID_L1_AVAIL                                   0x03                                                     
#define SIM_ST_GID_L2_AVAIL                                   0x12                                                  
#define SIM_ST_SPN_AVAIL                                      0x13                                                  
#define SIM_ST_SDN_AVAIL                                      0x14                                                  
#define SIM_ST_VGCS_GID_LIST_AVAIL                            0x15                                                  
#define SIM_ST_VBS_GID_LIST_AVAIL                             0x16                                                  
#define SIM_ST_EMLPP_SERVICE_AVAIL                            0x17                                                  
#define SIM_ST_AA_EMLPP_AVAIL                                 0x18                                                  
#define SIM_ST_SMSCB_DATA_DOWNLOAD_AVAIL                      0x73                                                  
#define SIM_ST_SMSPP_DATA_DOWNLOAD_AVAIL                      0x1A                                                  
#define SIM_ST_MENU_SELECTION_AVAIL                           0x1B                                                  
#define SIM_ST_CALL_CONTROL_AVAIL                             0x74                                                  
#define SIM_ST_PROACTIVE_SIM                                  0x1D                                                  
#define SIM_ST_CBMIR_AVAIL                                    0x1E                                                  
#define SIM_ST_BDN_AVAIL                                      0x1F                                                  
#define SIM_ST_DEPERSONALIZATION_KC_AVAIL                     0x20                                                  
#define SIM_ST_CO_OP_NET_LIST_AVAIL                           0x21                                                  
#define SIM_ST_SMSR_AVAIL                                     0x22                                                  
#define SIM_ST_NET_IND_ALERT_IN_MS_AVAIL                      0x23                                                  
#define SIM_ST_MO_SMS_SIM_CONTROL_AVAIL                       0x24                                                  
#define SIM_ST_GPRS_AVAIL                                     0x25                                                  
#define SIM_ST_IMAGE_AVAIL                                    0x26                                                  
#define SIM_ST_SOLSA_AVAIL                                    0x27                                                  
#define SIM_ST_USSD_IN_CALL_CONTROL_AVAIL                     0x28                                                  
#define SIM_ST_RUN_AT_COMMAND_AVAIL                           0x29                                                  
#define SIM_ST_UPLMN_WITH_AT_AVAIL                            0x2A                                                  
#define SIM_ST_OPLMN_WITH_AT_AVAIL                            0x2B                                                  
#define SIM_ST_HPLMN_WITH_AT_AVAIL                            0x2C                                                  
#define SIM_ST_CPBCCH_INFO_AVAIL                              0x2D                                                  
#define SIM_ST_INVESTIGATION_SCAN_AVAIL                       0x2E                                                  
#define SIM_ST_EXT_CC_PARAMS_AVAIL                            0x2F                                                  
#define SIM_ST_MEXE_AVAIL                                     0x30                                                  
#define SIM_ST_RPLMN_LAST_USED_AT_AVAIL                       0x31                                                  
#define SIM_ST_LOCAL_PHONE_BOOK_AVAIL                         0x32                                                  
#define SIM_ST_ICI_AVAIL                                      0x33                                                  
#define SIM_ST_GSM_ACCESS_AVAIL                               0x34                                                  
#define SIM_ST_ENABLED_SERVICE_TABLE_AVAIL                    0x35                                                  
#define SIM_ST_ACL_AVAIL                                      0x36                                                  
#define SIM_ST_GSM_SECURITY_CONTEXT_AVAIL                     0x37                                                  
#define SIM_ST_GPRS_CALL_CONTROL_AVAIL                        0x38                                                  

//ConstantTable for SIM_PB_LOCATION_TYPE_TABLE
#define SIM_PB_ADN                                            0x00C8                                                  
#define SIM_PB_ADN_NUMBER_LENGTH                              0x00C9                                                  
#define SIM_PB_ANR                                            0x00CA                                                  
#define SIM_PB_BDN                                            0x00CB                                                  
#define SIM_PB_CC                                             0x00CC                                                  
#define SIM_PB_CCP                                            0x00CD                                                  
#define SIM_PB_CCP1                                           0x00CE                                                  
#define SIM_PB_CCP2                                           0x00CF                                                  
#define SIM_PB_CONF_ADN_SB                                    0x00D0                                                  
#define SIM_PB_CONF_ANR_SB                                    0x00D1                                                  
#define SIM_PB_CONF_EMAIL_SB                                  0x00D2                                                  
#define SIM_PB_CONF_FDN_SB                                    0x00D3                                                  
#define SIM_PB_CONF_GAS_SB                                    0x00D4                                                  
#define SIM_PB_CONF_GRP_SB                                    0x00D5                                                  
#define SIM_PB_CONF_MISC_SB                                   0x00D6                                                  
#define SIM_PB_CONF_PH_1                                      0x00D7                                                  
#define SIM_PB_CONF_PH_3                                      0x00D8                                                  
#define SIM_PB_CONF_SNE_SB                                    0x00D9                                                  
#define SIM_PB_CONF_AAS_SB                                    0x00DA                                                  
#define SIM_PB_DELETE_ALL                                     0x00DB                                                  
#define SIM_PB_DELETE_LOCATION                                0x00DC                                                  
#define SIM_PB_EMAIL                                          0x00DD                                                  
#define SIM_PB_FDN                                            0x00DE                                                  
#define SIM_PB_FDN_LIST_STATUS                                0x00DF                                                  
#define SIM_PB_FDN_NUMBER_LENGTH                              0x00E0                                                  
#define SIM_PB_GAS                                            0x00E1                                                  
#define SIM_PB_GRP                                            0x00E2                                                  
#define SIM_PB_HIDDEN                                         0x00E3                                                  
#define SIM_PB_INFO_REQUEST                                   0x00E4                                                  
#define SIM_PB_LDN                                            0x00E5                                                  
#define SIM_PB_LOC                                            0x00E6                                                  
#define SIM_PB_LOC_ANR                                        0x00E7                                                  
#define SIM_PB_LOC_EMAIL                                      0x00E8                                                  
#define SIM_PB_LOC_FIRST                                      0x00E9                                                  
#define SIM_PB_LOC_GAS                                        0x00EA                                                  
#define SIM_PB_LOC_GRP                                        0x00EB                                                  
#define SIM_PB_LOC_NEXT                                       0x00EC                                                  
#define SIM_PB_LOC_SNE                                        0x00ED                                                  
#define SIM_PB_LOC_AAS                                        0x00EE                                                  
#define SIM_PB_MSISDN_NUMBER_LENGTH                           0x00EF                                                  
#define SIM_PB_PBC                                            0x00F0                                                  
#define SIM_PB_PSC                                            0x00F1                                                  
#define SIM_PB_PUID                                           0x00F2                                                  
#define SIM_PB_ROOM_INFO_ERROR                                0x00F3                                                  
#define SIM_PB_ROOM_INFO_REQUEST                              0x00F4                                                  
#define SIM_PB_SDN                                            0x00F5                                                  
#define SIM_PB_SELECT_PB_SB                                   0x00F6                                                  
#define SIM_PB_SNE                                            0x00F7                                                  
#define SIM_PB_STARTUP_PHASE_1                                0x00F8                                                  
#define SIM_PB_STARTUP_PHASE_2                                0x00F9                                                  
#define SIM_PB_STARTUP_PHASE_3                                0x00FA                                                  
#define SIM_PB_STATUS                                         0x00FB                                                  
#define SIM_PB_UID                                            0x00FC                                                  
#define SIM_PB_AAS                                            0x00FD                                                  
#define SIM_PB_LOCATION                                       0x00FE                                                  
#define SIM_PB_LOCATION_SEARCH                                0x00FF                                                  
#define SIM_PB_MSISDN                                         0x0100                                                 
#define SIM_PB_VMBX                                           0x0101                                                 
#define SIM_PB_LOC_VMBX                                       0x0102                                                 
#define SIM_PB_VMBX_NUMBER_LENGTH                             0x0103                                                 
#define SIM_PB_LOC_BDN                                        0x0104                                                 
#define SIM_PB_BDN_NUMBER_LENGTH                              0x0105                                                 
#define SIM_PB_MBDN                                           0x0106                                                 
#define SIM_PB_CONF_ADN_LONG_SB                               0x0107                                                 
#define SIM_PB_CONF_ANR_LONG_SB                               0x0108                                                 
#define SIM_PB_CONF_EMAIL_LONG_SB                             0x0109                                                 
#define SIM_PB_CONF_SNE_LONG_SB                               0x010A                                                 
#define SIM_PB_CONF_GRP_LONG_SB                               0x010B                                                 
#define SIM_PB_SB_END                                         0x010C                                                 

//ConstantTable for SIM_PRESENCE_TYPE_TABLE
#define SIM_NONE                                              0x04                                                     
#define SIM_PUBLIC                                            0x01                                                     
#define SIM_PRIVATE                                           0x02                                                     
#define SIM_BOTH                                              0x03                                                     

//ConstantTable for SIM_ATT_RAT_MODE
#define SIM_RAT_DUAL_MODE                                     0x00                                                     
#define SIM_RAT_2G_ONLY                                       0x01                                                     
#define SIM_RAT_3G_ONLY                                       0x02                                                     

//ConstantTable for SIM_LINE_TYPE_TABLE
#define SIM_PRIMARY_LINE                                      0x00                                                     
#define SIM_ALTERNATE_LINE                                    0x01                                                     
#define SIM_ALL_LINES                                         0x02                                                     

//ConstantTable for SIM_ADDRESS_TYPE_TABLE
#define SIM_SMS_GSM_0340_ADDRESS                              0x01                                                     
#define SIM_SMS_GSM_0411_ADDRESS                              0x02                                                     

//ConstantTable for SIM_ACCESS_CONDITION_TABLE
#define SIM_ALW                                               0x00                                                     
#define SIM_PIN1                                              0x01                                                     
#define SIM_PIN2                                              0x02                                                     
#define SIM_ADM                                               0x05                                                     

//ConstantTable for SIM_REFRESH_FILE_ID_TABLE
#define SIM_REFRESH_ICC_ID                                    0x01                                                     
#define SIM_REFRESH_ADMINISTRATIVE_DATA                       0x02                                                     
#define SIM_REFRESH_SERVICE_TABLE                             0x03                                                     
#define SIM_REFRESH_IMSI                                      0x04                                                     
#define SIM_REFRESH_FORBIDDEN_PLMNS                           0x05                                                     
#define SIM_REFRESH_LOCATION_INFOMATION                       0x06                                                     
#define SIM_REFRESH_CIPHERING_KEY_KC                          0x07                                                     
#define SIM_REFRESH_PLMN_SELECTOR                             0x08                                                     
#define SIM_REFRESH_CELL_BROADCAST_CONTROL_CHANNELS           0x09                                                     
#define SIM_REFRESH_CELL_BROADCAST_MESSAGE_IDENTIFIER         0x0A                                                     
#define SIM_REFRESH_ACCESS_CONTROL_CLASS                      0x0B                                                     
#define SIM_REFRESH_LANGUAGE_PREFERENCE                       0x0C                                                     
#define SIM_REFRESH_ACCUMULATED_CALL_METER                    0x0D                                                     
#define SIM_REFRESH_ACM_MAXIMUM_VALUE                         0x0E                                                     
#define SIM_REFRESH_PRICE_PER_UNIT_CURRENCY_TABLE             0x0F                                                     
#define SIM_REFRESH_HPLMN_SEACH_PERIOD                        0x10                                                  
#define SIM_REFRESH_PHASE_IDENTIFICATION                      0x11                                                  
#define SIM_REFRESH_GROUP_ID_LEVEL_1                          0x12                                                  
#define SIM_REFRESH_GROUP_ID_LEVEL_2                          0x13                                                  
#define SIM_REFRESH_SERVICE_PROVIDER_NAME                     0x14                                                  
#define SIM_REFRESH_EMERGENCY_CALL_CODES                      0x15                                                  
#define SIM_REFRESH_CELL_BROADCAST_MESSSAGE_ID_DATA_DOWNLOAD    0x16                                                  
#define SIM_REFRESH_GPRS_LOCATION_INFORMATION                 0x17                                                  
#define SIM_REFRESH_GPRS_CIPHERING_KEY_KCGPRS                 0x18                                                  
#define SIM_REFRESH_OPERATOR_PLMN_LIST                        0x19                                                  
#define SIM_REFRESH_PLMN_NETWORK_NAME                         0x1A                                                  
#define SIM_REFRESH_CUSTORMER_SERVICE_PROFILE                 0x1B                                                  
#define SIM_REFRESH_VOICE_MESSAGE_WAITING                     0x1C                                                  
#define SIM_REFRESH_CALL_FORWARD_FLAGS                        0x1D                                                  
#define SIM_REFRESH_OPERATOR_NAME_STRING                      0x1E                                                  
#define SIM_REFRESH_MAILBOX_NUMBERS                           0x1F                                                  
#define SIM_REFRESH_CPHS_INFO                                 0x20                                                  
#define SIM_REFRESH_INFO_NUMBERS                              0x21                                                  
#define SIM_REFRESH_ABBREVIATED_DIALLING_NUMBERS              0x22                                                  
#define SIM_REFRESH_SHORT_MESSAGES                            0x23                                                  
#define SIM_REFRESH_FIXED_DIALLING_NUMBERS                    0x24                                                  
#define SIM_REFRESH_MSISDN                                    0x25                                                  
#define SIM_REFRESH_SHORT_MESSAGE_SERVICE_PARAMETERS          0x26                                                  
#define SIM_REFRESH_SHORT_MESSAGE_SERVICE_STATUS              0x27                                                  
#define SIM_REFRESH_SERVICE_DIALLING_NUMBERS                  0x28                                                  
#define SIM_REFRESH_CSP_LINE_2                                0x29                                                  
#define SIM_REFRESH_USER_CONTROLLED_PLMN_SELECTOR_ACCESS_TECH    0x2A                                                  
#define SIM_REFRESH_OPERATOR_CONTROLLED_PLMN_SELECTOR_ACCESS_TECH    0x2B                                                  
#define SIM_REFRESH_HPLMN_SELECTOR_ACCESS_TECH                0x2C                                                  
#define SIM_REFRESH_MESSAGE_WAITING_INDICATION_STATUS         0x2D                                                  
#define SIM_REFRESH_CALL_FORWARDING_INDICATION_STATUS         0x2E                                                  
#define SIM_REFRESH_MAILBOX_IDENTIFIER                        0x2F                                                  
#define SIM_REFRESH_MAILBOX_DIALLING_NUMBERS                  0x30                                                  
#define SIM_REFRESH_EXTENDED_LANGUAGE_PREFERENCE              0x31                                                  
#define SIM_REFRESH_SERVICE_PROVIDER_DISPLAY_INFOMARTION      0x32                                                  
#define SIM_REFRESH_CIPHERING_INTEGRITY_KEYS                  0x33                                                  
#define SIM_REFRESH_CIPHERING_INTEGRITY_KEYS_PACKET_SWITCHED_DOMAIN    0x34                                                  
#define SIM_REFRESH_INITIALISATION_VALUES_FOR_HYPERFRAME_NUMBER    0x35                                                  
#define SIM_REFRESH_MAXIMUM_VALUE_OF_START                    0x36                                                  
#define SIM_REFRESH_PACKET_SWITCHED_LOCATION_INFORMATION      0x37                                                  
#define SIM_REFRESH_NETWORK_PARAMETERS                        0x38                                                  
#define SIM_REFRESH_ENABLED_SERVICES_TABLE                    0x39                                                  
#define SIM_REFRESH_APPLICATION_DIRECTORY                     0x3A                                                  
#define SIM_REFRESH_PHONE_BOOK_REFERENCE_FILE                 0x3B                                                  
#define SIM_REFRESH_INDEX_ADMINISTRATION_PHONE_BOOK           0x3C                                                  
#define SIM_REFRESH_GROUPING_FILE                             0x3D                                                  
#define SIM_REFRESH_GROUPING_INFORMATION_ALPHA_STRING         0x3E                                                  
#define SIM_REFRESH_SECOND_NAME_ENTRY                         0x3F                                                  
#define SIM_REFRESH_UNKNOWN_FILES                             0x40                                                  
#define SIM_REFRESH_TERMINAL_SUPPORT_TABLE                    0x41                                                  
#define SIM_REFRESH_ACTING_HPLMN                              0x42                                                  
#define SIM_REFRESH_IMAGE                                     0x43                                                  
#define SIM_REFRESH_VIAG_HOMEZONE_PARM                        0x44                                                  
#define SIM_REFRESH_VIAG_CACHE1                               0x45                                                  
#define SIM_REFRESH_VIAG_CACHE2                               0x46                                                  
#define SIM_REFRESH_VIAG_CACHE3                               0x47                                                  
#define SIM_REFRESH_VIAG_CACHE4                               0x48                                                  
#define SIM_REFRESH_MMS_USER_PREF                             0x49                                                  
#define SIM_REFRESH_MMS_ISSUER_CONN_PAR                       0x4A                                                  
#define SIM_REFRESH_DYNAMIC_FLAGS1                            0x4B                                                  
#define SIM_REFRESH_DYNAMIC_FLAGS2                            0x4C                                                  
#define SIM_REFRESH_PSC                                       0x4D                                                  
#define SIM_REFRESH_CC                                        0x4E                                                  
#define SIM_REFRESH_PUID                                      0x4F                                                  
#define SIM_REFRESH_ANR                                       0x50                                                  
#define SIM_REFRESH_PBC                                       0x51                                                  
#define SIM_REFRESH_EMAIL                                     0x52                                                  
#define SIM_REFRESH_UID                                       0x53                                                  
#define SIM_REFRESH_AAS                                       0x54                                                  
#define SIM_REFRESH_IMS_PRIVATE_USER_ID                       0x55                                                  
#define SIM_REFRESH_IMS_PUBLIC_USER_ID                        0x56                                                  
#define SIM_REFRESH_IMS_HOME_NW_DOMAIN_NAME                   0x57                                                  
#define SIM_REFRESH_VIAG_HOMEZONE_SUBS_LAC_CI_1               0x58                                                  
#define SIM_REFRESH_VIAG_HOMEZONE_SUBS_LAC_CI_2               0x59                                                  
#define SIM_REFRESH_VIAG_HOMEZONE_SUBS_LAC_CI_3               0x5A                                                  
#define SIM_REFRESH_VIAG_HOMEZONE_SUBS_LAC_CI_4               0x5B                                                  
#define SIM_REFRESH_VIAG_HOMEZONE_TAGS                        0x5C                                                  
#define SIM_REFRESH_VIAG_HOMEZONE_UHZIUE_SETTINGS             0x5D                                                  
#define SIM_REFRESH_EQUIVALENT_HPLMNS                         0x5E                                                  
#define SIM_REFRESH_ACL                                       0x5F                                                  
#define SIM_REFRESH_GBABP                                     0x60                                                  
#define SIM_REFRESH_GBANL                                     0x61                                                  
#define SIM_REFRESH_MSK                                       0x62                                                  
#define SIM_REFRESH_MUK                                       0x63                                                  
#define SIM_REFRESH_ATT_RAT                                   0x64                                                  

//ConstantTable for SIM_CAUSES_TABLE
#define SIM_NO_CAUSE                                          0x01                                                     
#define SIM_CAUSE_3V5V_CARD                                   0x02                                                     
#define SIM_CAUSE_5V_CARD                                     0x03                                                     

//ConstantTable for SIM_2G_3G_TABLE
#define SIM_2G_GSM                                            0x00                                                     
#define SIM_2G_WIM                                            0x01                                                     
#define SIM_2G                                                0x02                                                     
#define SIM_3G                                                0x03                                                     
#define SIM_ICC_TYPE_UNKNOWN                                  0x04                                                     
#define SIM_2G_SWIM                                           0x05                                                     

//ConstantTable for SIM_CARD_TYPE_TABLE
#define SIM_NORMAL_SIM                                        0x00                                                     
#define SIM_TYPE_APPROVAL_SIM                                 0x80                                                  
#define SIM_TEST_SIM                                          0x04                                                     
#define SIM_NORMAL_SIM_SPE_FACILITY                           0x01                                                     
#define SIM_TYPE_APPROVAL_SIM_SPE_FACILITY                    0x81                                                  
#define SIM_MAINTENANCE                                       0x02                                                     

//ConstantTable for SIM_STATUS_TABLE
#define SIM_SERV_NOT_AVAIL                                    0x00                                                     
#define SIM_SERV_OK                                           0x01                                                     
#define SIM_SERV_PIN_VERIFY_REQUIRED                          0x02                                                     
#define SIM_SERV_PIN_REQUIRED                                 0x03                                                     
#define SIM_SERV_SIM_BLOCKED                                  0x04                                                     
#define SIM_SERV_SIM_PERMANENTLY_BLOCKED                      0x05                                                     
#define SIM_SERV_SIM_DISCONNECTED                             0x06                                                     
#define SIM_SERV_SIM_REJECTED                                 0x07                                                     
#define SIM_SERV_LOCK_ACTIVE                                  0x08                                                     
#define SIM_SERV_AUTOLOCK_CLOSED                              0x09                                                     
#define SIM_SERV_AUTOLOCK_ERROR                               0x0A                                                     
#define SIM_SERV_INIT_OK                                      0x0B                                                     
#define SIM_SERV_INIT_NOT_OK                                  0x0C                                                     
#define SIM_SERV_WRONG_OLD_PIN                                0x0D                                                     
#define SIM_SERV_PIN_DISABLED                                 0x0E                                                     
#define SIM_SERV_COMMUNICATION_ERROR                          0x0F                                                     
#define SIM_SERV_UPDATE_IMPOSSIBLE                            0x10                                                  
#define SIM_SERV_NO_SECRET_CODE_IN_SIM                        0x11                                                  
#define SIM_SERV_PIN_ENABLE_OK                                0x12                                                  
#define SIM_SERV_PIN_DISABLE_OK                               0x13                                                  
#define SIM_SERV_WRONG_UNBLOCKING_KEY                         0x15                                                  
#define SIM_SERV_ILLEGAL_NUMBER                               0x2E                                                  
#define SIM_SERV_NOT_OK                                       0x1C                                                  
#define SIM_SERV_PN_LIST_ENABLE_OK                            0x1E                                                  
#define SIM_SERV_PN_LIST_DISABLE_OK                           0x1F                                                  
#define SIM_SERV_NO_PIN                                       0x20                                                  
#define SIM_SERV_PIN_VERIFY_OK                                0x21                                                  
#define SIM_SERV_PIN_BLOCKED                                  0x22                                                  
#define SIM_SERV_PIN_PERM_BLOCKED                             0x23                                                  
#define SIM_SERV_DATA_NOT_AVAIL                               0x24                                                  
#define SIM_SERV_IN_HOME_ZONE                                 0x25                                                  
#define SIM_SERV_STATE_CHANGED                                0x27                                                  
#define SIM_SERV_INF_NBR_READ_OK                              0x28                                                  
#define SIM_SERV_INF_NBR_READ_NOT_OK                          0x29                                                  
#define SIM_SERV_IMSI_EQUAL                                   0x2A                                                  
#define SIM_SERV_IMSI_NOT_EQUAL                               0x2B                                                  
#define SIM_SERV_INVALID_LOCATION                             0x2C                                                  
#define SIM_SERV_STA_SIM_REMOVED                              0x35                                                  
#define SIM_SERV_SECOND_SIM_REMOVED_CS                        0x36                                                  
#define SIM_SERV_CONNECTED_INDICATION_CS                      0x37                                                  
#define SIM_SERV_SECOND_SIM_CONNECTED_CS                      0x38                                                  
#define SIM_SERV_PIN_RIGHTS_LOST_IND_CS                       0x39                                                  
#define SIM_SERV_PIN_RIGHTS_GRANTED_IND_CS                    0x3A                                                  
#define SIM_SERV_INIT_OK_CS                                   0x3B                                                  
#define SIM_SERV_INIT_NOT_OK_CS                               0x3C                                                  
#define SIM_FDN_ENABLED                                       0x19                                                  
#define SIM_FDN_DISABLED                                      0x1A                                                  
#define SIM_SERV_INVALID_FILE                                 0x45                                                  
#define SIM_SERV_DATA_AVAIL                                   0x4F                                                  
#define SIM_SERV_ICC_EQUAL                                    0x49                                                  
#define SIM_SERV_ICC_NOT_EQUAL                                0x4A                                                  
#define SIM_SERV_SIM_NOT_INITIALISED                          0x4B                                                  
#define SIM_SERV_SERVICE_NOT_AVAIL                            0x50                                                  
#define SIM_SERV_FDN_STATUS_ERROR                             0x57                                                  
#define SIM_SERV_FDN_CHECK_PASSED                             0x58                                                  
#define SIM_SERV_FDN_CHECK_FAILED                             0x59                                                  
#define SIM_SERV_FDN_CHECK_DISABLED                           0x5A                                                  
#define SIM_SERV_FDN_CHECK_NO_FDN_SIM                         0x5B                                                  
#define SIM_STA_ISIM_AVAILEBLE_PIN_REQUIRED                   0x5C                                                  
#define SIM_STA_ISIM_AVAILEBLE                                0x5D                                                  
#define SIM_STA_USIM_AVAILEBLE                                0x5E                                                  
#define SIM_STA_SIM_AVAILEBLE                                 0x5F                                                  
#define SIM_STA_ISIM_NOT_INITIALIZED                          0x60                                                  
#define SIM_STA_IMS_READY                                     0x61                                                  
#define SIM_STA_APP_DATA_READ_OK                              0x96                                                  
#define SIM_STA_APP_ACTIVATE_OK                               0x97                                                  
#define SIM_STA_APP_ACTIVATE_NOT_OK                           0x98                                                  
#define SIM_SERV_NOT_DEFINED                                  0xF9                                                  
#define SIM_SERV_NOSERVICE                                    0xFA                                                  
#define SIM_SERV_NOTREADY                                     0xFB                                                  
#define SIM_SERV_ERROR                                        0xFC                                                  
#define SIM_SERV_CIPHERING_INDICATOR_DISPLAY_REQUIRED         0x30                                                  
#define SIM_SERV_CIPHERING_INDICATOR_DISPLAY_NOT_REQUIRED     0x31                                                  
#define SIM_SERV_FILE_NOT_AVAILABLE                           0x4D                                                  

//ConstantTable for SIM_SIMLOCK_STATUS_TABLE
#define SIM_STA_SIMLOCK_OK                                    0x01                                                     
#define SIM_STA_SIMLOCK_RESTRICTED                            0x08                                                     
#define SIM_STA_SIMLOCK_RESTRICTION_ON                        0x09                                                     
#define SIM_STA_SIMLOCK_RESTRICTION_PENDING                   0x0A                                                     
#define SIM_STA_SIMLOCK_STATUS_NOT_INITIALIZED                0x24                                                  
#define SIM_STA_NOSERVICE                                     0xFA                                                  
#define SIM_STA_NOTREADY                                      0xFB                                                  
#define SIM_STA_ERROR                                         0xFC                                                  

//ConstantTable for SIM_PB_STATUS_TABLE
//#define SIM_SERV_NOT_AVAIL                                  0x00                        //Already defined as 0x00
//#define SIM_SERV_OK                                         0x01                        //Already defined as 0x01
//#define SIM_SERV_PIN_VERIFY_REQUIRED                        0x02                        //Already defined as 0x02
//#define SIM_SERV_PIN_REQUIRED                               0x03                        //Already defined as 0x03
//#define SIM_SERV_SIM_BLOCKED                                0x04                        //Already defined as 0x04
//#define SIM_SERV_SIM_PERMANENTLY_BLOCKED                    0x05                        //Already defined as 0x05
//#define SIM_SERV_SIM_DISCONNECTED                           0x06                        //Already defined as 0x06
//#define SIM_SERV_SIM_REJECTED                               0x07                        //Already defined as 0x07
//#define SIM_SERV_LOCK_ACTIVE                                0x08                        //Already defined as 0x08
//#define SIM_SERV_AUTOLOCK_CLOSED                            0x09                        //Already defined as 0x09
//#define SIM_SERV_AUTOLOCK_ERROR                             0x0A                        //Already defined as 0x0A
//#define SIM_SERV_INIT_OK                                    0x0B                        //Already defined as 0x0B
//#define SIM_SERV_INIT_NOT_OK                                0x0C                        //Already defined as 0x0C
//#define SIM_SERV_WRONG_OLD_PIN                              0x0D                        //Already defined as 0x0D
//#define SIM_SERV_PIN_DISABLED                               0x0E                        //Already defined as 0x0E
//#define SIM_SERV_COMMUNICATION_ERROR                        0x0F                        //Already defined as 0x0F
//#define SIM_SERV_UPDATE_IMPOSSIBLE                          0x10                       //Already defined as 0x10
//#define SIM_SERV_NO_SECRET_CODE_IN_SIM                      0x11                       //Already defined as 0x11
#define SIM_SERV_NO_FREE_LOCATIONS                            0x12                                                  
//#define SIM_SERV_WRONG_UNBLOCKING_KEY                       0x15                       //Already defined as 0x15
#define SIM_SERV_NO_MATCH                                     0x16                                                  
//#define SIM_SERV_ILLEGAL_NUMBER                             0x2E                       //Already defined as 0x2E
//#define SIM_SERV_NOT_OK                                     0x1C                       //Already defined as 0x1C
//#define SIM_SERV_PN_LIST_ENABLE_OK                          0x1E                       //Already defined as 0x1E
//#define SIM_SERV_PN_LIST_DISABLE_OK                         0x1F                       //Already defined as 0x1F
//#define SIM_SERV_NO_PIN                                     0x20                       //Already defined as 0x20
//#define SIM_SERV_PIN_VERIFY_OK                              0x21                       //Already defined as 0x21
//#define SIM_SERV_PIN_BLOCKED                                0x22                       //Already defined as 0x22
//#define SIM_SERV_PIN_PERM_BLOCKED                           0x23                       //Already defined as 0x23
//#define SIM_SERV_DATA_NOT_AVAIL                             0x24                       //Already defined as 0x24
//#define SIM_SERV_IN_HOME_ZONE                               0x25                       //Already defined as 0x25
//#define SIM_SERV_STATE_CHANGED                              0x27                       //Already defined as 0x27
//#define SIM_SERV_INF_NBR_READ_OK                            0x28                       //Already defined as 0x28
//#define SIM_SERV_INF_NBR_READ_NOT_OK                        0x29                       //Already defined as 0x29
//#define SIM_SERV_IMSI_EQUAL                                 0x2A                       //Already defined as 0x2A
//#define SIM_SERV_IMSI_NOT_EQUAL                             0x2B                       //Already defined as 0x2B
//#define SIM_SERV_INVALID_LOCATION                           0x2C                       //Already defined as 0x2C
#define SIM_SERV_NAME_TOO_LONG                                0x32                                                  
#define SIM_SERV_SRES_ERROR                                   0x34                                                  
//#define SIM_SERV_STA_SIM_REMOVED                            0x35                       //Already defined as 0x35
//#define SIM_SERV_SECOND_SIM_REMOVED_CS                      0x36                       //Already defined as 0x36
//#define SIM_SERV_CONNECTED_INDICATION_CS                    0x37                       //Already defined as 0x37
//#define SIM_SERV_SECOND_SIM_CONNECTED_CS                    0x38                       //Already defined as 0x38
//#define SIM_SERV_PIN_RIGHTS_LOST_IND_CS                     0x39                       //Already defined as 0x39
//#define SIM_SERV_PIN_RIGHTS_GRANTED_IND_CS                  0x3A                       //Already defined as 0x3A
//#define SIM_SERV_INIT_OK_CS                                 0x3B                       //Already defined as 0x3B
//#define SIM_SERV_INIT_NOT_OK_CS                             0x3C                       //Already defined as 0x3C
//#define SIM_FDN_ENABLED                                     0x19                       //Already defined as 0x19
//#define SIM_FDN_DISABLED                                    0x1A                       //Already defined as 0x1A
//#define SIM_SERV_INVALID_FILE                               0x45                       //Already defined as 0x45
//#define SIM_SERV_ICC_EQUAL                                  0x49                       //Already defined as 0x49
//#define SIM_SERV_ICC_NOT_EQUAL                              0x4A                       //Already defined as 0x4A
//#define SIM_SERV_SIM_NOT_INITIALISED                        0x4B                       //Already defined as 0x4B
#define SIM_SERV_ILLEGAL_LENGTH                               0x4C                                                  
#define SIM_SERV_INIT_OK_TDMA_CS                              0x4E                                                  
#define SIM_SERV_NUMBER_TOO_LONG                              0x4F                                                  
//#define SIM_SERV_SERVICE_NOT_AVAIL                          0x50                       //Already defined as 0x50
#define SIM_SERV_AAS_TOO_LONG                                 0x51                                                  
#define SIM_SERV_ANR_TOO_LONG                                 0x52                                                  
#define SIM_SERV_GAS_APLPHA_STRING_TOO_LONG                   0x53                                                  
#define SIM_SERV_ILLEGAL_CCP1_VALUE                           0x54                                                  
#define SIM_SERV_CC_COUNTER_HAS_WRAPPED                       0x55                                                  
#define SIM_SERV_PSC_COUNTER_HAS_WRAPPED                      0x56                                                  
//#define SIM_SERV_FDN_CHECK_PASSED                           0x58                       //Already defined as 0x58
//#define SIM_SERV_FDN_CHECK_FAILED                           0x59                       //Already defined as 0x59
//#define SIM_SERV_FDN_CHECK_DISABLED                         0x5A                       //Already defined as 0x5A
//#define SIM_SERV_FDN_CHECK_NO_FDN_SIM                       0x5B                       //Already defined as 0x5B
//#define SIM_STA_APP_DATA_READ_OK                            0x96                       //Already defined as 0x96
//#define SIM_STA_APP_ACTIVATE_OK                             0x97                       //Already defined as 0x97
//#define SIM_STA_APP_ACTIVATE_NOT_OK                         0x98                       //Already defined as 0x98
//#define SIM_SERV_NOSERVICE                                  0xFA                       //Already defined as 0xFA
//#define SIM_SERV_NOTREADY                                   0xFB                       //Already defined as 0xFB
//#define SIM_SERV_ERROR                                      0xFC                       //Already defined as 0xFC
//#define SIM_SERV_CIPHERING_INDICATOR_DISPLAY_REQUIRED       0x30                       //Already defined as 0x30
//#define SIM_SERV_CIPHERING_INDICATOR_DISPLAY_NOT_REQUIRED    0x31                       //Already defined as 0x31
//#define SIM_SERV_FILE_NOT_AVAILABLE                         0x4D                       //Already defined as 0x4D

//ConstantTable for SIM_SB_STA_TABLE
#define SIM_SB_STA_OK                                         0x01                                                     
#define SIM_SB_STA_NOT_OK                                     0x02                                                     
#define SIM_SB_STA_FILE_NOT_AVAIL                             0x03                                                     
#define SIM_SB_STA_UNKNOWN_SB_ID                              0x04                                                     
#define SIM_SB_STA_3G_GSM_NOT_SUPPORTED                       0x05                                                     
#define SIM_SB_STA_SYNCH_FAIL                                 0x06                                                     
#define SIM_SB_STA_MAC_FAIL                                   0x07                                                     
#define SIM_SB_STA_PS_NOT_SUPPORTED                           0x08                                                     
//#define SIM_SERV_NOSERVICE                                  0xFA                       //Already defined as 0xFA
//#define SIM_SERV_NOTREADY                                   0xFB                       //Already defined as 0xFB
//#define SIM_SERV_ERROR                                      0xFC                       //Already defined as 0xFC

//ConstantTable for SIM_STA_TABLE
#define SIM_STA_OK                                            0x01                                                     
#define SIM_STA_UPDATE_IMPOSSIBLE                             0x10                                                  
#define SIM_STA_FILE_NOT_AVAILABLE                            0x14                                                  
#define SIM_STA_NOT_OK                                        0x1C                                                  
#define SIM_STA_DATA_NOT_AVAILABLE                            0x24                                                  
#define SIM_STA_EQUAL                                         0x2A                                                  
#define SIM_STA_NOT_EQUAL                                     0x2B                                                  
#define SIM_STA_INVALID_LOCATION                              0x2C                                                  
#define SIM_STA_LOCATION_EMPTY                                0x2D                                                  
#define SIM_STA_SB_NOT_OK                                     0x4B                                                  
#define SIM_STA_ILLEGAL_LENGTH                                0x4C                                                  
#define SIM_STA_SERVICE_NOT_AVAIL                             0x50                                                  
//#define SIM_STA_NOSERVICE                                   0xFA                       //Already defined as 0xFA
//#define SIM_STA_NOTREADY                                    0xFB                       //Already defined as 0xFB
//#define SIM_STA_ERROR                                       0xFC                       //Already defined as 0xFC

//ConstantTable for SIM_HZ_STATUS_TABLE
//#define SIM_STA_OK                                          0x01                        //Already defined as 0x01
//#define SIM_STA_NOT_OK                                      0x1C                       //Already defined as 0x1C
#define SIM_STA_DATA_NOT_AVAIL                                0x24                                                  
//#define SIM_STA_NOSERVICE                                   0xFA                       //Already defined as 0xFA
//#define SIM_STA_NOTREADY                                    0xFB                       //Already defined as 0xFB
//#define SIM_STA_ERROR                                       0xFC                       //Already defined as 0xFC

//ConstantTable for SIM_SERV_STA_TABLE
#define SIM_SERV_STA_OK                                       0x01                                                     
#define SIM_SERV_STA_UPDATE_IMPOSSIBLE                        0x10                                                  
#define SIM_SERV_STA_DATA_NOT_AVAILABLE                       0x24                                                  
#define SIM_SERV_STA_NOT_OK                                   0x1C                                                  
#define SIM_SERV_STA_AID_NOT_ACTIVE                           0x1D                                                  
#define SIM_SERV_STA_SB_NOT_OK                                0x4B                                                  
//#define SIM_SERV_STA_SIM_REMOVED                            0x35                       //Already defined as 0x35
//#define SIM_SERV_NOSERVICE                                  0xFA                       //Already defined as 0xFA
//#define SIM_SERV_NOTREADY                                   0xFB                       //Already defined as 0xFB
//#define SIM_SERV_ERROR                                      0xFC                       //Already defined as 0xFC

//ConstantTable for SIM_STATUS_SMS_TABLE
//#define SIM_STA_OK                                          0x01                        //Already defined as 0x01
//#define SIM_STA_FILE_NOT_AVAILABLE                          0x14                       //Already defined as 0x14
//#define SIM_STA_INVALID_LOCATION                            0x2C                       //Already defined as 0x2C
//#define SIM_STA_LOCATION_EMPTY                              0x2D                       //Already defined as 0x2D
//#define SIM_STA_NOT_OK                                      0x1C                       //Already defined as 0x1C
//#define SIM_SERV_NOSERVICE                                  0xFA                       //Already defined as 0xFA
//#define SIM_SERV_NOTREADY                                   0xFB                       //Already defined as 0xFB
//#define SIM_SERV_ERROR                                      0xFC                       //Already defined as 0xFC

//ConstantTable for SIM_SMS_MSG_STATUS_TABLE
#define SIM_SMS_FREE_SPACE                                    0x00                                                     
#define SIM_SMS_REC_F_NETWORK_READ                            0x01                                                     
#define SIM_SMS_REC_F_NETWORK_TO_BE_READ                      0x03                                                     
#define SIM_SMS_UE_ORG_TO_BE_SEND                             0x07                                                     
#define SIM_SMS_UE_ORG_NO_STATUS_REPORT                       0x05                                                     
#define SIM_SMS_UE_ORG_STATUS_REPORT_REQ                      0x0D                                                     
#define SIM_SMS_UE_ORG_STATUS_REP_REC_NO_SMSR                 0x15                                                  

//ConstantTable for SIM_STATUS_REFRESH_TABLE
//#define SIM_STA_OK                                          0x01                        //Already defined as 0x01
//#define SIM_STA_NOT_OK                                      0x1C                       //Already defined as 0x1C
//#define SIM_SERV_NOSERVICE                                  0xFA                       //Already defined as 0xFA
//#define SIM_SERV_NOTREADY                                   0xFB                       //Already defined as 0xFB
//#define SIM_SERV_ERROR                                      0xFC                       //Already defined as 0xFC

//ConstantTable for SIM_STATUS_MMS_TABLE
//#define SIM_STA_OK                                          0x01                        //Already defined as 0x01
//#define SIM_STA_DATA_NOT_AVAILABLE                          0x24                       //Already defined as 0x24
//#define SIM_STA_FILE_NOT_AVAILABLE                          0x14                       //Already defined as 0x14
//#define SIM_SERV_NOSERVICE                                  0xFA                       //Already defined as 0xFA
//#define SIM_SERV_NOTREADY                                   0xFB                       //Already defined as 0xFB
//#define SIM_SERV_ERROR                                      0xFC                       //Already defined as 0xFC

//BitmaskTables for SIM_HZCZ_ACTIVE_FLAG
#define SIM_HOMEZONE_ACTIVE                                   0x01                                                     
#define SIM_HOMEZONE_NOT_ACTIVE                               0x00                                                     
#define SIM_CITYZONE_ACTIVE                                   0x02                                                     
#define SIM_CITYZONE_NOT_ACTIVE                               0x00                                                     

//ConstantTable for SIM_SB_CS_WRITE_RESP_SB_ID_DEFINES_TABLE
#define SIM_SB_TMSI_ID                                        0x0074                                                  
#define SIM_SB_BCCH_ID                                        0x0065                                                  
#define SIM_SB_LAI_ID                                         0x0073                                                  
#define SIM_SB_LOC_UPD_STATUS_ID                              0x007E                                                  
#define SIM_SB_GSM_NETPAR_ID                                  0x0087                                                  
#define SIM_SB_FDD_NETPAR_ID                                  0x0088                                                  
#define SIM_SB_TDD_NETPAR_ID                                  0x0089                                                  
#define SIM_SB_FORBIDDEN_PLMNS_ID                             0x0069                                                  
#define SIM_SB_USER_PLMN_ID                                   0x0080                                                  
#define SIM_SB_PLMN_SELECTOR_ID                               0x0084                                                  
#define SIM_SB_RPLMN_ID                                       0x0082                                                  
#define SIM_SB_GPRS_CIPHERING_KEY_SNR_ID                      0x006B                                                  
#define SIM_SB_GPRS_RAI_ID                                    0x006C                                                  
#define SIM_SB_GPRS_RAUS_ID                                   0x006D                                                  
#define SIM_SB_GPRS_TMSI_ID                                   0x006E                                                  
#define SIM_SB_GPRS_TMSI_SIGN_VALUE_ID                        0x006F                                                  
#define SIM_SB_CIPHERING_KEY_SNR_ID                           0x0068                                                  
#define SIM_SB_UMTS_CS_KSI_ID                                 0x0075                                                  
#define SIM_SB_UMTS_PS_KSI_ID                                 0x0078                                                  
#define SIM_SB_UMTS_START_PS_ID                               0x007B                                                  
#define SIM_SB_UMTS_START_CS_ID                               0x007D                                                  

//ConstantTable for SIM_SB_APP_SELECTION_TYPE_DEF_TABLE
#define SIM_USIM_APPLICATION                                  0x01                                                     
#define SIM_ISIM_APPLICATION                                  0x02                                                     
#define SIM_UNKNOWN_APPLICATION                               0xFF                                                  

//ConstantTable for SIM_CONDITION_TABLE
#define NOT_PROTECTED                                         0x01                                                     
#define PROTECTED_BY_PIN1                                     0x02                                                     
#define PROTECTED_BY_PIN2                                     0x03                                                     

//ConstantTable for SIM_GPRS_REQ_ST_TABLE
#define SIM_ST_ACL_STATUS                                     0x76                                                  
#define SIM_ST_ACL_ENABLE                                     0x77                                                  
#define SIM_ST_ACL_DISABLE                                    0x78                                                  
#define SIM_ST_ACL_READ                                       0x79                                                  
#define SIM_ST_ACL_WRITE                                      0x7A                                                  
#define SIM_ST_CHECK_APN                                      0x7B                                                  

//ConstantTable for SIM_GPRS_REQ_STATUS_TABLE
#define SIM_STA_ACL_ENABLED                                   0x69                                                  
#define SIM_STA_ACL_DISABLED                                  0x6A                                                  
#define SIM_STA_APN_CHECK_PASSED                              0x6B                                                  
#define SIM_STA_APN_CHECK_FAILED                              0x6C                                                  
#define SIM_STA_ACL_NOT_AVAILABLE                             0x6E                                                  
//#define SIM_SERV_DATA_NOT_AVAIL                             0x24                       //Already defined as 0x24
//#define SIM_SERV_OK                                         0x01                        //Already defined as 0x01
//#define SIM_STA_ILLEGAL_LENGTH                              0x4C                       //Already defined as 0x4C
//#define SIM_SERV_NOSERVICE                                  0xFA                       //Already defined as 0xFA
//#define SIM_SERV_NOTREADY                                   0xFB                       //Already defined as 0xFB
//#define SIM_SERV_ERROR                                      0xFC                       //Already defined as 0xFC

//ConstantTable for MISC_STATUS_TABLE_1
#define SIM_SERV_STATUS_END                                   0xFF                                                  
#define SIM_SERV_TEXT_TOO_LONG                                0x4E                                                  
#define SIM_SERV_ACM_MAX_VALUE_REACHED                        0x19                                                  

//ConstantTable for SIM_SERVICE_STATUS_TABLE_TYPE

//ConstantTable for SIM_AM_APP_TYPE_TABLE_TYPE

//ConstantTable for SIM_AM_APP_STATUS_TABLE_TYPE

//ConstantTable for SIM_GEC_TABLE_TYPE

//ConstantTable for SIM_FDI_TABLE_TYPE
#define SIM_FDI_IMPI                                          0x00                                                     
#define SIM_FDI_GBABP                                         0x01                                                     
#define SIM_FDI_GBANL                                         0x02                                                     
#define SIM_FDI_MSK                                           0x03                                                     
#define SIM_FDI_MUK                                           0x04                                                     

//ConstantTable for SIM_SERVICE_ID_TABLE_TYPE
#define SIM_APP_GBA_AVAIL                                     0x00                                                     
#define SIM_APP_MBMS_AVAIL                                    0x01                                                     
#define SIM_APP_BCAST_AVAIL                                   0x02                                                     


//STRUCTURES


//Definition for struct SIM_SERV_CARD_TYPE
typedef struct
            { 
             uint8_t      normal_or_type_approval;
            } __attribute__((packed)) SIM_SERV_CARD_TYPE_STR;
#define SIZE_SIM_SERV_CARD_TYPE                               sizeof(SIM_SERV_CARD_TYPE_STR)


//Definition for struct SIM_EMRG_CALL_CODE
typedef struct
            { 
             uint8_t      emrg_call_code[7];
             uint8_t      fillerbyte1;
            } __attribute__((packed)) SIM_EMRG_CALL_CODE_STR;
#define SIZE_SIM_EMRG_CALL_CODE                               sizeof(SIM_EMRG_CALL_CODE_STR)


//Definition for struct SIM_EMRG_CALL_CODES
typedef struct
            { 
             SIM_EMRG_CALL_CODE_STR    emrg_call_codes[40];
            } __attribute__((packed)) SIM_EMRG_CALL_CODES_STR;
#define SIZE_SIM_EMRG_CALL_CODES                              sizeof(SIM_EMRG_CALL_CODES_STR)


//Definition for struct CHANGE_CODE
typedef struct
            { 
             uint8_t      oldpword[9];
             uint8_t      newpword[9];
            } __attribute__((packed)) CHANGE_CODE_STR;
#define SIZE_CHANGE_CODE                                      sizeof(CHANGE_CODE_STR)


//Definition for struct UNBLOCK_CODE
typedef struct
            { 
             uint8_t      unblockkey[9];
             uint8_t      password[9];
            } __attribute__((packed)) UNBLOCK_CODE_STR;
#define SIZE_UNBLOCK_CODE                                     sizeof(UNBLOCK_CODE_STR)


//Definition for struct SERVICE_PROVIDER
typedef struct
            { 
             uint8_t      serv_prov_name[34];
             uint8_t      display_condition;
             uint8_t      display_con_not_in_hplmn_or_spdi;
            } __attribute__((packed)) SERVICE_PROVIDER_STR;
#define SIZE_SERVICE_PROVIDER                                 sizeof(SERVICE_PROVIDER_STR)


//Definition for struct SIM_SERV_VOICE_MSG_OPTIONAL_DATA
typedef struct
            { 
             uint8_t      faxdata;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
            } __attribute__((packed)) SIM_SERV_VOICE_MSG_OPTIONAL_DATA_STR;
#define SIZE_SIM_SERV_VOICE_MSG_OPTIONAL_DATA                 sizeof(SIM_SERV_VOICE_MSG_OPTIONAL_DATA_STR)


//Definition for struct SIM_SERV_VOICE_MSG_WAIT_FLAG
typedef struct
            { 
             uint8_t      prim_line;
             uint8_t      alt_line;
             uint8_t      fax;
             uint8_t      data;
            } __attribute__((packed)) SIM_SERV_VOICE_MSG_WAIT_FLAG_STR;
#define SIZE_SIM_SERV_VOICE_MSG_WAIT_FLAG                     sizeof(SIM_SERV_VOICE_MSG_WAIT_FLAG_STR)


//Definition for struct SIM_SERV_CALL_FWD_FLAG
typedef struct
            { 
             uint8_t      prim_line;
             uint8_t      alt_line;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) SIM_SERV_CALL_FWD_FLAG_STR;
#define SIZE_SIM_SERV_CALL_FWD_FLAG                           sizeof(SIM_SERV_CALL_FWD_FLAG_STR)


//Definition for struct SIM_VIAG_HOME_ZONE_SEQ
typedef struct
            { 
             uint32_t     zone_x;
             uint32_t     zone_y;
             uint32_t     zone_r2;
             uint8_t      homezoneid;
             uint8_t      hzczactiveflag;
             uint8_t      hzcztag[26];
            } __attribute__((packed)) SIM_VIAG_HOME_ZONE_SEQ_STR;
#define SIZE_SIM_VIAG_HOME_ZONE_SEQ                           sizeof(SIM_VIAG_HOME_ZONE_SEQ_STR)


//Definition for struct SIM_INFO_DYNAMIC_FLAGS
typedef struct
            { 
             uint8_t      selected_line;
             uint8_t      clir_flag;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) SIM_INFO_DYNAMIC_FLAGS_STR;
#define SIZE_SIM_INFO_DYNAMIC_FLAGS                           sizeof(SIM_INFO_DYNAMIC_FLAGS_STR)


//Definition for struct SIM_DYNAMIC_FLAGS
typedef struct
            { 
             uint8_t      line;
             uint8_t      clir_flag;
            } __attribute__((packed)) SIM_DYNAMIC_FLAGS_STR;
#define SIZE_SIM_DYNAMIC_FLAGS                                sizeof(SIM_DYNAMIC_FLAGS_STR)


//Definition for struct SIM_INFO_DYNAMIC2_FLAGS
typedef struct
            { 
             uint8_t      als_status;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
            } __attribute__((packed)) SIM_INFO_DYNAMIC2_FLAGS_STR;
#define SIZE_SIM_INFO_DYNAMIC2_FLAGS                          sizeof(SIM_INFO_DYNAMIC2_FLAGS_STR)


//Definition for struct SIM_DYNAMIC2_FLAGS
typedef struct
            { 
             uint8_t      als_status;
            } __attribute__((packed)) SIM_DYNAMIC2_FLAGS_STR;
#define SIZE_SIM_DYNAMIC2_FLAGS                               sizeof(SIM_DYNAMIC2_FLAGS_STR)


//Definition for struct SIM_SB_ECC_RECORD
typedef struct
            { 
             uint8_t      ecc1;
             uint8_t      ecc2;
             uint8_t      ecc3;
             uint8_t      ecctypeindicator;
             uint8_t      eccalphaidentifier[0];
            } __attribute__((packed)) SIM_SB_ECC_RECORD_STR;
#define SIZE_SIM_SB_ECC_RECORD                                sizeof(SIM_SB_ECC_RECORD_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct SIM_SB_FORBIDDEN_PLMNS_PLMN
typedef struct
            { 
             uint8_t      plmn[3];
             uint8_t      fillerbyte1;
            } __attribute__((packed)) SIM_SB_FORBIDDEN_PLMNS_PLMN_STR;
#define SIZE_SIM_SB_FORBIDDEN_PLMNS_PLMN                      sizeof(SIM_SB_FORBIDDEN_PLMNS_PLMN_STR)


//Definition for struct SIM_SB_PLMN_RECORD
typedef struct
            { 
             uint8_t      plmn[3];
             uint8_t      fillerbyte1;
            } __attribute__((packed)) SIM_SB_PLMN_RECORD_STR;
#define SIZE_SIM_SB_PLMN_RECORD                               sizeof(SIM_SB_PLMN_RECORD_STR)


//Definition for struct SIM_SB_OPERATOR_PLMNS_PLMN
typedef struct
            { 
             uint8_t      plmn[3];
             uint8_t      fillerbyte1;
             uint16_t     plmnaccesstechnologyid;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
            } __attribute__((packed)) SIM_SB_OPERATOR_PLMNS_PLMN_STR;
#define SIZE_SIM_SB_OPERATOR_PLMNS_PLMN                       sizeof(SIM_SB_OPERATOR_PLMNS_PLMN_STR)


//Definition for struct SIM_SB_CS_WRITE_RESP_SB
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      status;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
            } __attribute__((packed)) SIM_SB_CS_WRITE_RESP_SB_STR;
#define SIZE_SIM_SB_CS_WRITE_RESP_SB                          sizeof(SIM_SB_CS_WRITE_RESP_SB_STR)


//Definition for struct SIM_SB_SPN_DISPLAY_INFO_PLMNS_PLMN
typedef struct
            { 
             uint8_t      plmn[3];
             uint8_t      fillerbyte1;
            } __attribute__((packed)) SIM_SB_SPN_DISPLAY_INFO_PLMNS_PLMN_STR;
#define SIZE_SIM_SB_SPN_DISPLAY_INFO_PLMNS_PLMN               sizeof(SIM_SB_SPN_DISPLAY_INFO_PLMNS_PLMN_STR)


//Definition for struct SIM_SB_LOCATION
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint16_t     locationtype;
             uint16_t     location;
            } __attribute__((packed)) SIM_SB_LOCATION_STR;
#define SIZE_SIM_SB_LOCATION                                  sizeof(SIM_SB_LOCATION_STR)


//Definition for struct SIM_SB_NAME_NUMBER
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint16_t     location;
             uint8_t      namelength;
             uint8_t      numberlength;
             uint16_t     name[0];
             uint16_t     number[0];
            } __attribute__((packed)) SIM_SB_NAME_NUMBER_STR;
#define SIZE_SIM_SB_NAME_NUMBER                               sizeof(SIM_SB_NAME_NUMBER_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct SIM_SB_UINT16
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint16_t     data;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) SIM_SB_UINT16_STR;
#define SIZE_SIM_SB_UINT16                                    sizeof(SIM_SB_UINT16_STR)


//Definition for struct SIM_SB_TEXT
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint16_t     location;
             uint8_t      textlength;
             uint8_t      fillerbyte1;
             uint16_t     text[0];
            } __attribute__((packed)) SIM_SB_TEXT_STR;
#define SIZE_SIM_SB_TEXT                                      sizeof(SIM_SB_TEXT_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct SIM_SB_UINT8
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      data;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
            } __attribute__((packed)) SIM_SB_UINT8_STR;
#define SIZE_SIM_SB_UINT8                                     sizeof(SIM_SB_UINT8_STR)


//Definition for struct SIM_SB_PRIMITIVE
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
            } __attribute__((packed)) SIM_SB_PRIMITIVE_STR;
#define SIZE_SIM_SB_PRIMITIVE                                 sizeof(SIM_SB_PRIMITIVE_STR)


//Definition for struct SIM_SB_CONF_TXT
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      filetype;
             uint8_t      filelength;
             uint8_t      textlength;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) SIM_SB_CONF_TXT_STR;
#define SIZE_SIM_SB_CONF_TXT                                  sizeof(SIM_SB_CONF_TXT_STR)


//Definition for struct SIM_SB_CONF_LONG_TXT
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint16_t     entrycount;
             uint8_t      textlength;
             uint8_t      type1filesperadn;
             uint8_t      type2filesperadn;
             uint8_t      fillerbyte1[3];
            } __attribute__((packed)) SIM_SB_CONF_LONG_TXT_STR;
#define SIZE_SIM_SB_CONF_LONG_TXT                             sizeof(SIM_SB_CONF_LONG_TXT_STR)


//Definition for struct SIM_SB_INFO_REQUEST
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      numberoftags;
             uint8_t      fillerbyte1;
             uint16_t     tags[0];
            } __attribute__((packed)) SIM_SB_INFO_REQUEST_STR;
#define SIZE_SIM_SB_INFO_REQUEST                              sizeof(SIM_SB_INFO_REQUEST_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct SIM_REQUEST_PIN
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      applicationnumber;
            } __attribute__((packed)) SIM_REQUEST_PIN_STR;
#define SIZE_SIM_REQUEST_PIN                                  sizeof(SIM_REQUEST_PIN_STR)


//Definition for struct SIM_REQUEST
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) SIM_REQUEST_STR;
#define SIZE_SIM_REQUEST                                      sizeof(SIM_REQUEST_STR)


//Definition for struct SIM_REQ
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
            } __attribute__((packed)) SIM_REQ_STR;
#define SIZE_SIM_REQ                                          sizeof(SIM_REQ_STR)


//Definition for struct SIM_RESPONSE
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
            } __attribute__((packed)) SIM_RESPONSE_STR;
#define SIZE_SIM_RESPONSE                                     sizeof(SIM_RESPONSE_STR)


//Definition for struct SIM_INFORESPONSE
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
            } __attribute__((packed)) SIM_INFORESPONSE_STR;
#define SIZE_SIM_INFORESPONSE                                 sizeof(SIM_INFORESPONSE_STR)


//Definition for struct SIM_ICC_ID_DATA
typedef struct
            { 
             uint8_t      id_data[10];
            } __attribute__((packed)) SIM_ICC_ID_DATA_STR;
#define SIZE_SIM_ICC_ID_DATA                                  sizeof(SIM_ICC_ID_DATA_STR)


//Definition for struct SIM_ICC
typedef struct
            { 
             SIM_ICC_ID_DATA_STR    icc[0];
            } __attribute__((packed)) SIM_ICC_STR;
#define SIZE_SIM_ICC                                          sizeof(SIM_ICC_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct SIM_RESP_IMSI
typedef struct
            { 
             uint8_t      length;
             uint8_t      imsi[8];
            } __attribute__((packed)) SIM_RESP_IMSI_STR;
#define SIZE_SIM_RESP_IMSI                                    sizeof(SIM_RESP_IMSI_STR)


//Definition for struct SIM_IMSI
typedef struct
            { 
             SIM_RESP_IMSI_STR    imsi[0];
            } __attribute__((packed)) SIM_IMSI_STR;
#define SIZE_SIM_IMSI                                         sizeof(SIM_IMSI_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct SIM_ACM
typedef struct
            { 
             uint32_t     count;
            } __attribute__((packed)) SIM_ACM_STR;
#define SIZE_SIM_ACM                                          sizeof(SIM_ACM_STR)


//Definition for struct SIM_ACM_MAX_VALUE
typedef struct
            { 
             uint32_t     count;
            } __attribute__((packed)) SIM_ACM_MAX_VALUE_STR;
#define SIZE_SIM_ACM_MAX_VALUE                                sizeof(SIM_ACM_MAX_VALUE_STR)


//Definition for struct SIM_PUCT_UNICODE
typedef struct
            { 
             uint8_t      currency_code[8];
             uint16_t     eppu;
             int8_t       ex;
            } __attribute__((packed)) SIM_PUCT_UNICODE_STR;
#define SIZE_SIM_PUCT_UNICODE                                 sizeof(SIM_PUCT_UNICODE_STR)


//Definition for struct SIM_INFO_CB_MSG_IDS
typedef struct
            { 
             uint8_t      cell_bc_msg_ids[30];
            } __attribute__((packed)) SIM_INFO_CB_MSG_IDS_STR;
#define SIZE_SIM_INFO_CB_MSG_IDS                              sizeof(SIM_INFO_CB_MSG_IDS_STR)


//Definition for struct SIM_PLMNT_STRUCT
typedef struct
            { 
             uint8_t      mcc2_mcc1;
             uint8_t      mnc3_mcc3;
             uint8_t      mnc2_mnc1;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) SIM_PLMNT_STRUCT_STR;
#define SIZE_SIM_PLMNT_STRUCT                                 sizeof(SIM_PLMNT_STRUCT_STR)


//Definition for struct SIM_PLMN_SELECTOR
typedef struct
            { 
             SIM_PLMNT_STRUCT_STR    plmn[336];
            } __attribute__((packed)) SIM_PLMN_SELECTOR_STR;
#define SIZE_SIM_PLMN_SELECTOR                                sizeof(SIM_PLMN_SELECTOR_STR)


//Definition for struct CPHS_OPTIONALS
typedef struct
            { 
             uint8_t      mailboxnumbinfo;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
            } __attribute__((packed)) CPHS_OPTIONALS_STR;
#define SIZE_CPHS_OPTIONALS                                   sizeof(CPHS_OPTIONALS_STR)


//Definition for struct SIM_SERV_CPHS
typedef struct
            { 
             uint8_t      phase;
             uint8_t      csp_allocated;
             uint8_t      csp_active;
             uint8_t      service_string_tbl_allocated;
             uint8_t      service_string_tbl_active;
             uint8_t      mailbox_numbers_allocated;
             uint8_t      mailbox_numbers_active;
             uint8_t      inf_nbr_allocated;
             uint8_t      inf_nbr_active;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
            } __attribute__((packed)) SIM_SERV_CPHS_STR;
#define SIZE_SIM_SERV_CPHS                                    sizeof(SIM_SERV_CPHS_STR)


//Definition for struct SIM_SERV_OPERATOR_NAME
typedef struct
            { 
             uint8_t      operator_name[50];
            } __attribute__((packed)) SIM_SERV_OPERATOR_NAME_STR;
#define SIZE_SIM_SERV_OPERATOR_NAME                           sizeof(SIM_SERV_OPERATOR_NAME_STR)


//Definition for struct SIM_OPL
typedef struct
            { 
             uint8_t      mcc2_mcc1;
             uint8_t      mnc3_mcc3;
             uint8_t      mnc2_mnc1;
             uint8_t      lac_lower_msb;
             uint8_t      lac_lower_lsb;
             uint8_t      lac_upper_msb;
             uint8_t      lac_upper_lsb;
             uint8_t      pnn_identifier;
            } __attribute__((packed)) SIM_OPL_STR;
#define SIZE_SIM_OPL                                          sizeof(SIM_OPL_STR)


//Definition for struct CSP_OPTIONALS
typedef struct
            { 
             uint8_t      hml_spec;
             uint8_t      d5infonumbers;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) CSP_OPTIONALS_STR;
#define SIZE_CSP_OPTIONALS                                    sizeof(CSP_OPTIONALS_STR)


//Definition for struct SIM_SERV_CSP_CALL_OFFERING
typedef struct
            { 
             uint8_t      call_transfer;
             uint8_t      not_reachable;
             uint8_t      no_reply;
             uint8_t      busy;
             uint8_t      unconditional;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
            } __attribute__((packed)) SIM_SERV_CSP_CALL_OFFERING_STR;
#define SIZE_SIM_SERV_CSP_CALL_OFFERING                       sizeof(SIM_SERV_CSP_CALL_OFFERING_STR)


//Definition for struct SIM_SERV_CSP_CALL_RESTRICTION
typedef struct
            { 
             uint8_t      incoming_if_roaming;
             uint8_t      incoming;
             uint8_t      international_ex_hplmn;
             uint8_t      outgoing_international;
             uint8_t      outgoing;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
            } __attribute__((packed)) SIM_SERV_CSP_CALL_RESTRICTION_STR;
#define SIZE_SIM_SERV_CSP_CALL_RESTRICTION                    sizeof(SIM_SERV_CSP_CALL_RESTRICTION_STR)


//Definition for struct SIM_SERV_CSP_OTHER_SS
typedef struct
            { 
             uint8_t      aoc;
             uint8_t      cug;
             uint8_t      multi_party;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) SIM_SERV_CSP_OTHER_SS_STR;
#define SIZE_SIM_SERV_CSP_OTHER_SS                            sizeof(SIM_SERV_CSP_OTHER_SS_STR)


//Definition for struct SIM_SERV_CSP_CALL_COMPLETION
typedef struct
            { 
             uint8_t      call_completion_to_busy;
             uint8_t      call_waiting;
             uint8_t      call_hold;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) SIM_SERV_CSP_CALL_COMPLETION_STR;
#define SIZE_SIM_SERV_CSP_CALL_COMPLETION                     sizeof(SIM_SERV_CSP_CALL_COMPLETION_STR)


//Definition for struct SIM_SERV_CSP_TELESERVICES
typedef struct
            { 
             uint8_t      sms_validity_period;
             uint8_t      sms_protocol_id;
             uint8_t      sms_delivery_conf;
             uint8_t      sms_reply_path;
             uint8_t      sms_cb;
             uint8_t      sms_mo;
             uint8_t      sms_mt;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) SIM_SERV_CSP_TELESERVICES_STR;
#define SIZE_SIM_SERV_CSP_TELESERVICES                        sizeof(SIM_SERV_CSP_TELESERVICES_STR)


//Definition for struct SIM_SERV_CSP_CPHS_TELESERVICES
typedef struct
            { 
             uint8_t      als;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
            } __attribute__((packed)) SIM_SERV_CSP_CPHS_TELESERVICES_STR;
#define SIZE_SIM_SERV_CSP_CPHS_TELESERVICES                   sizeof(SIM_SERV_CSP_CPHS_TELESERVICES_STR)


//Definition for struct SIM_SERV_CSP_CPHS_FEATURES
typedef struct
            { 
             uint8_t      sap;
             uint8_t      browser;
             uint8_t      services;
             uint8_t      sst;
            } __attribute__((packed)) SIM_SERV_CSP_CPHS_FEATURES_STR;
#define SIZE_SIM_SERV_CSP_CPHS_FEATURES                       sizeof(SIM_SERV_CSP_CPHS_FEATURES_STR)


//Definition for struct SIM_SERV_CSP_NBR_IDENTIFICATION
typedef struct
            { 
             uint8_t      cli_block;
             uint8_t      cli_send;
             uint8_t      malicious_call_ind;
             uint8_t      conn_line_ind_pres;
             uint8_t      conn_line_ind_restriction;
             uint8_t      clip;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) SIM_SERV_CSP_NBR_IDENTIFICATION_STR;
#define SIZE_SIM_SERV_CSP_NBR_IDENTIFICATION                  sizeof(SIM_SERV_CSP_NBR_IDENTIFICATION_STR)


//Definition for struct SIM_SERV_CSP_HML_SPECIFICS
typedef struct
            { 
             uint8_t      lang;
             uint8_t      rfu;
             uint8_t      data;
             uint8_t      fax;
             uint8_t      sm_mo_email;
             uint8_t      sm_mo_paging;
             uint8_t      vps;
             uint8_t      plmn_mode;
            } __attribute__((packed)) SIM_SERV_CSP_HML_SPECIFICS_STR;
#define SIZE_SIM_SERV_CSP_HML_SPECIFICS                       sizeof(SIM_SERV_CSP_HML_SPECIFICS_STR)


//Definition for struct SIM_SERV_CSP
typedef struct
            { 
             SIM_SERV_CSP_CALL_OFFERING_STR    call_offering[0];
             SIM_SERV_CSP_CALL_RESTRICTION_STR    call_restriction[0];
             SIM_SERV_CSP_OTHER_SS_STR    other_ss[0];
             SIM_SERV_CSP_CALL_COMPLETION_STR    call_completion[0];
             SIM_SERV_CSP_TELESERVICES_STR    teleservices[0];
             SIM_SERV_CSP_CPHS_TELESERVICES_STR    cphs_teleservices[0];
             SIM_SERV_CSP_CPHS_FEATURES_STR    cphs_features[0];
             SIM_SERV_CSP_NBR_IDENTIFICATION_STR    nbr_identification[0];
             SIM_SERV_CSP_HML_SPECIFICS_STR    hml_specifics[0];
             uint8_t      byte_d5_inf_numbers;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
            } __attribute__((packed)) SIM_SERV_CSP_STR;
#define SIZE_SIM_SERV_CSP                                     sizeof(SIM_SERV_CSP_STR)


//Definition for struct SIM_INFO_CBMID
typedef struct
            { 
             uint8_t      cbmid[10];
            } __attribute__((packed)) SIM_INFO_CBMID_STR;
#define SIZE_SIM_INFO_CBMID                                   sizeof(SIM_INFO_CBMID_STR)


//Definition for struct SIM_REFRESH_FILE_LIST
typedef struct
            { 
             uint8_t      fileid;
             uint8_t      askbeforerefresh;
            } __attribute__((packed)) SIM_REFRESH_FILE_LIST_STR;
#define SIZE_SIM_REFRESH_FILE_LIST                            sizeof(SIM_REFRESH_FILE_LIST_STR)


//Definition for struct SIM_ST_IMS_READ_DATA_REQ
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      numberofsubblocks;
            } __attribute__((packed)) SIM_ST_IMS_READ_DATA_REQ_STR;
#define SIZE_SIM_ST_IMS_READ_DATA_REQ                         sizeof(SIM_ST_IMS_READ_DATA_REQ_STR)


//Definition for struct SIM_INFO_PLMN
typedef struct
            { 
             uint8_t      mcc2_mcc1;
             uint8_t      mnc3_mcc3;
             uint8_t      mnc2_mnc1;
            } __attribute__((packed)) SIM_INFO_PLMN_STR;
#define SIZE_SIM_INFO_PLMN                                    sizeof(SIM_INFO_PLMN_STR)


//Definition for struct SIM_NUMBER
typedef struct
            { 
             uint8_t      namelen;
             uint8_t      numlen;
             uint8_t      namnum[200];
            } __attribute__((packed)) SIM_NUMBER_STR;
#define SIZE_SIM_NUMBER                                       sizeof(SIM_NUMBER_STR)


//Definition for struct SIM_FTD_DATA_ASCII_STRING
typedef struct
            { 
             uint16_t     subblockid;
             uint8_t      subblock_length;
             uint8_t      string_lenght;
             uint8_t      string[124];
            } __attribute__((packed)) SIM_FTD_DATA_ASCII_STRING_STR;
#define SIZE_SIM_FTD_DATA_ASCII_STRING                        sizeof(SIM_FTD_DATA_ASCII_STRING_STR)


//Definition for struct SIM_FTD_DATA_BYTE
typedef struct
            { 
             uint16_t     subblockid;
             uint8_t      subblock_length;
             uint8_t      data;
            } __attribute__((packed)) SIM_FTD_DATA_BYTE_STR;
#define SIZE_SIM_FTD_DATA_BYTE                                sizeof(SIM_FTD_DATA_BYTE_STR)


//Definition for struct SIM_FTD_DATA_FAIL
typedef struct
            { 
             uint16_t     subblockid;
             uint8_t      subblock_length;
             uint8_t      filler1;
             uint16_t     not_identified_subblockid;
             uint8_t      fail_reason;
             uint8_t      filler2;
            } __attribute__((packed)) SIM_FTD_DATA_FAIL_STR;
#define SIZE_SIM_FTD_DATA_FAIL                                sizeof(SIM_FTD_DATA_FAIL_STR)


//Definition for struct SIM_FTD_DATA_WORD
typedef struct
            { 
             uint16_t     subblockid;
             uint8_t      subblock_length;
             uint8_t      filler1;
             uint16_t     data;
             uint8_t      filler2;
             uint8_t      filler3;
            } __attribute__((packed)) SIM_FTD_DATA_WORD_STR;
#define SIZE_SIM_FTD_DATA_WORD                                sizeof(SIM_FTD_DATA_WORD_STR)


//Definition for struct GENERALSUBBLOCK
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblock_length;
             uint8_t      status;
             uint8_t      rec_length;
             uint16_t     data_length;
             uint8_t      content[0];
            } __attribute__((packed)) GENERALSUBBLOCK_STR;
#define SIZE_GENERALSUBBLOCK                                  sizeof(GENERALSUBBLOCK_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct GENERALSUBBLOCKRESP
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblock_length;
             uint8_t      status;
             uint8_t      filler2;
             uint16_t     data_length;
             uint8_t      content[0];
            } __attribute__((packed)) GENERALSUBBLOCKRESP_STR;
#define SIZE_GENERALSUBBLOCKRESP                              sizeof(GENERALSUBBLOCKRESP_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct SIM_FDN_CHECK_GENERIC_SB
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      status;
             uint8_t      numlen;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint16_t     num[0];
            } __attribute__((packed)) SIM_FDN_CHECK_GENERIC_SB_STR;
#define SIZE_SIM_FDN_CHECK_GENERIC_SB                         sizeof(SIM_FDN_CHECK_GENERIC_SB_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct SIM_INFO_ZONE_IDENTITY
typedef struct
            { 
             uint16_t     ci;
            } __attribute__((packed)) SIM_INFO_ZONE_IDENTITY_STR;
#define SIZE_SIM_INFO_ZONE_IDENTITY                           sizeof(SIM_INFO_ZONE_IDENTITY_STR)


//Definition for struct SIM_INFO_ZONE_COORD
typedef struct
            { 
             uint32_t     square_radius;
             uint32_t     x_coord;
             uint32_t     y_coord;
             uint8_t      grid_id;
            } __attribute__((packed)) SIM_INFO_ZONE_COORD_STR;
#define SIZE_SIM_INFO_ZONE_COORD                              sizeof(SIM_INFO_ZONE_COORD_STR)


//Definition for struct SIM_SERV_ZONE_COORD
typedef struct
            { 
             uint32_t     square_radius;
             uint32_t     x_coord;
             uint32_t     y_coord;
             uint8_t      grid_id;
            } __attribute__((packed)) SIM_SERV_ZONE_COORD_STR;
#define SIZE_SIM_SERV_ZONE_COORD                              sizeof(SIM_SERV_ZONE_COORD_STR)


//Definition for struct SIM_JACOB_ID_READ
typedef struct
            { 
             uint16_t     loc_nbr;
             uint8_t      odd_key;
             uint8_t      even_key;
            } __attribute__((packed)) SIM_JACOB_ID_READ_STR;
#define SIZE_SIM_JACOB_ID_READ                                sizeof(SIM_JACOB_ID_READ_STR)


//Definition for struct SIM_SB
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
            } __attribute__((packed)) SIM_SB_STR;
#define SIZE_SIM_SB                                           sizeof(SIM_SB_STR)


//Definition for struct SIM_SB_CS_STANDARD
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      status;
             uint8_t      fillerbyte1[3];
            } __attribute__((packed)) SIM_SB_CS_STANDARD_STR;
#define SIZE_SIM_SB_CS_STANDARD                               sizeof(SIM_SB_CS_STANDARD_STR)


//Definition for struct SIM_SB_NETPAR
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      status;
             uint8_t      filesize;
             uint8_t      fillerbyte1;
             uint8_t      datalength;
             uint8_t      data[0];
            } __attribute__((packed)) SIM_SB_NETPAR_STR;
#define SIZE_SIM_SB_NETPAR                                    sizeof(SIM_SB_NETPAR_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct SIM_SB_UNSUPPORTED
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      status;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
            } __attribute__((packed)) SIM_SB_UNSUPPORTED_STR;
#define SIZE_SIM_SB_UNSUPPORTED                               sizeof(SIM_SB_UNSUPPORTED_STR)


//Definition for struct SIM_SB_PLMN_INFO
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      status;
             uint8_t      usercontrolledplmns;
             uint8_t      operatorcontrolledplmns;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) SIM_SB_PLMN_INFO_STR;
#define SIZE_SIM_SB_PLMN_INFO                                 sizeof(SIM_SB_PLMN_INFO_STR)


//Definition for struct SIM_SB_PREF_PLMN
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      status;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
            } __attribute__((packed)) SIM_SB_PREF_PLMN_STR;
#define SIZE_SIM_SB_PREF_PLMN                                 sizeof(SIM_SB_PREF_PLMN_STR)


//Definition for struct SIM_STRUCT_AM_MBMS_MTP_X
typedef struct
            { 
             uint32_t     xthmtp_msk_id;
             uint32_t     xthmtp_timestampcounter;
            } __attribute__((packed)) SIM_STRUCT_AM_MBMS_MTP_X_STR;
#define SIZE_SIM_STRUCT_AM_MBMS_MTP_X                         sizeof(SIM_STRUCT_AM_MBMS_MTP_X_STR)


//SUBBLOCKS


//Definition for struct SIM_SB_ACC_ID
#define SIM_SB_ACC_ID                                         0x64                                                  
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      status;
             uint8_t      fillerbyte1;
             uint16_t     accdata;
            } __attribute__((packed)) SIM_SB_ACC_ID_STR;
#define SIZE_SIM_SB_ACC_ID                                    sizeof(SIM_SB_ACC_ID_STR)


//Definition for struct SIM_SB_BCCH_ID
//#define SIM_SB_BCCH_ID                                      0x65                       //Already defined as 0x65
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      status;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
             uint8_t      bcchinfo[16];
            } __attribute__((packed)) SIM_SB_BCCH_ID_STR;
#define SIZE_SIM_SB_BCCH_ID                                   sizeof(SIM_SB_BCCH_ID_STR)


//Definition for struct SIM_SB_CARD_TYPE_ID
#define SIM_SB_CARD_TYPE_ID                                   0x66                                                  
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      status;
             uint8_t      cardgeneration;
             uint8_t      cardtype;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) SIM_SB_CARD_TYPE_ID_STR;
#define SIZE_SIM_SB_CARD_TYPE_ID                              sizeof(SIM_SB_CARD_TYPE_ID_STR)


//Definition for struct SIM_SB_ECC_ID
#define SIM_SB_ECC_ID                                         0x83                                                  
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      status;
             uint8_t      numberofecccodes;
             uint8_t      ecccodelength;
             uint8_t      eccalphaidentifierlength;
             SIM_SB_ECC_RECORD_STR    eccrecord[0];
            } __attribute__((packed)) SIM_SB_ECC_ID_STR;
#define SIZE_SIM_SB_ECC_ID                                    sizeof(SIM_SB_ECC_ID_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct SIM_SB_FORBIDDEN_PLMNS_ID
//#define SIM_SB_FORBIDDEN_PLMNS_ID                           0x69                       //Already defined as 0x69
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      status;
             uint8_t      fplmnlistoperation;
             uint16_t     maxnooffplmns;
             SIM_SB_FORBIDDEN_PLMNS_PLMN_STR    fplmns[0];
            } __attribute__((packed)) SIM_SB_FORBIDDEN_PLMNS_ID_STR;
#define SIZE_SIM_SB_FORBIDDEN_PLMNS_ID                        sizeof(SIM_SB_FORBIDDEN_PLMNS_ID_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct SIM_SB_HPLMN_ID
#define SIM_SB_HPLMN_ID                                       0x70                                                  
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      status;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
             uint8_t      noofdigitsinmnc;
             uint8_t      hplmn[3];
            } __attribute__((packed)) SIM_SB_HPLMN_ID_STR;
#define SIZE_SIM_SB_HPLMN_ID                                  sizeof(SIM_SB_HPLMN_ID_STR)


//Definition for struct SIM_SB_HPLMN_SEARCH_ID
#define SIM_SB_HPLMN_SEARCH_ID                                0x71                                                  
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      status;
             uint8_t      timeinterval;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) SIM_SB_HPLMN_SEARCH_ID_STR;
#define SIZE_SIM_SB_HPLMN_SEARCH_ID                           sizeof(SIM_SB_HPLMN_SEARCH_ID_STR)


//Definition for struct SIM_SB_LAI_ID
//#define SIM_SB_LAI_ID                                       0x73                       //Already defined as 0x73
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      status;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
             uint8_t      lai[5];
             uint8_t      fillerbyte4;
             uint8_t      fillerbyte5;
             uint8_t      fillerbyte6;
            } __attribute__((packed)) SIM_SB_LAI_ID_STR;
#define SIZE_SIM_SB_LAI_ID                                    sizeof(SIM_SB_LAI_ID_STR)


//Definition for struct SIM_SB_LOC_UPD_STATUS_ID
//#define SIM_SB_LOC_UPD_STATUS_ID                            0x7E                       //Already defined as 0x7E
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      status;
             uint8_t      locationupdatestatus;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) SIM_SB_LOC_UPD_STATUS_ID_STR;
#define SIZE_SIM_SB_LOC_UPD_STATUS_ID                         sizeof(SIM_SB_LOC_UPD_STATUS_ID_STR)


//Definition for struct SIM_SB_OPERATOR_PLMN_ID
#define SIM_SB_OPERATOR_PLMN_ID                               0x7F                                                  
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      status;
             uint8_t      oplmnlistoperation;
             uint16_t     maxnoofoplmns;
             SIM_SB_OPERATOR_PLMNS_PLMN_STR    oplmns[0];
            } __attribute__((packed)) SIM_SB_OPERATOR_PLMN_ID_STR;
#define SIZE_SIM_SB_OPERATOR_PLMN_ID                          sizeof(SIM_SB_OPERATOR_PLMN_ID_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct SIM_SB_USER_PLMN_ID
//#define SIM_SB_USER_PLMN_ID                                 0x80                       //Already defined as 0x80
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      status;
             uint8_t      uplmnlistoperation;
             uint16_t     maxnoofuplmns;
             SIM_SB_OPERATOR_PLMNS_PLMN_STR    uplmns[0];
            } __attribute__((packed)) SIM_SB_USER_PLMN_ID_STR;
#define SIZE_SIM_SB_USER_PLMN_ID                              sizeof(SIM_SB_USER_PLMN_ID_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct SIM_SB_HOME_PLMN_ID
#define SIM_SB_HOME_PLMN_ID                                   0x81                                                  
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      status;
             uint8_t      hplmnlistoperation;
             uint16_t     maxnoofhplmns;
             SIM_SB_OPERATOR_PLMNS_PLMN_STR    hplmns[0];
            } __attribute__((packed)) SIM_SB_HOME_PLMN_ID_STR;
#define SIZE_SIM_SB_HOME_PLMN_ID                              sizeof(SIM_SB_HOME_PLMN_ID_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct SIM_SB_PLMN_SELECTOR_ID
//#define SIM_SB_PLMN_SELECTOR_ID                             0x84                       //Already defined as 0x84
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      status;
             uint8_t      plmnsellistoperation;
             uint16_t     maxnoofplmns;
             SIM_SB_PLMN_RECORD_STR    plmnrecord[0];
            } __attribute__((packed)) SIM_SB_PLMN_SELECTOR_ID_STR;
#define SIZE_SIM_SB_PLMN_SELECTOR_ID                          sizeof(SIM_SB_PLMN_SELECTOR_ID_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct SIM_SB_ATT_RAT_ID
#define SIM_SB_ATT_RAT_ID                                     0x8B                                                  
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      status;
             uint8_t      att_rat_mode;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) SIM_SB_ATT_RAT_ID_STR;
#define SIZE_SIM_SB_ATT_RAT_ID                                sizeof(SIM_SB_ATT_RAT_ID_STR)


//Definition for struct SIM_SB_EQUIVALENT_HPLMNS_ID
#define SIM_SB_EQUIVALENT_HPLMNS_ID                           0x8A                                                  
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      status;
             uint8_t      fillerbyte1;
             uint16_t     noehplmns;
             SIM_SB_PLMN_RECORD_STR    ehplmnrecord[0];
            } __attribute__((packed)) SIM_SB_EQUIVALENT_HPLMNS_ID_STR;
#define SIZE_SIM_SB_EQUIVALENT_HPLMNS_ID                      sizeof(SIM_SB_EQUIVALENT_HPLMNS_ID_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct SIM_SB_RPLMN_ID
//#define SIM_SB_RPLMN_ID                                     0x82                       //Already defined as 0x82
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      status;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
             uint16_t     rplmnlastusedat;
             uint8_t      fillerbyte4;
             uint8_t      fillerbyte5;
            } __attribute__((packed)) SIM_SB_RPLMN_ID_STR;
#define SIZE_SIM_SB_RPLMN_ID                                  sizeof(SIM_SB_RPLMN_ID_STR)


//Definition for struct SIM_SB_GSM_NETPAR_ID
//#define SIM_SB_GSM_NETPAR_ID                                0x87                       //Already defined as 0x87
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      status;
             uint8_t      filesize;
             uint8_t      fillerbyte1;
             uint8_t      datalength;
             uint8_t      data[0];
            } __attribute__((packed)) SIM_SB_GSM_NETPAR_ID_STR;
#define SIZE_SIM_SB_GSM_NETPAR_ID                             sizeof(SIM_SB_GSM_NETPAR_ID_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct SIM_SB_FDD_NETPAR_ID
//#define SIM_SB_FDD_NETPAR_ID                                0x88                       //Already defined as 0x88
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      status;
             uint8_t      filesize;
             uint8_t      fillerbyte1;
             uint8_t      datalength;
             uint8_t      data[0];
            } __attribute__((packed)) SIM_SB_FDD_NETPAR_ID_STR;
#define SIZE_SIM_SB_FDD_NETPAR_ID                             sizeof(SIM_SB_FDD_NETPAR_ID_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct SIM_SB_TDD_NETPAR_ID
//#define SIM_SB_TDD_NETPAR_ID                                0x89                       //Already defined as 0x89
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      status;
             uint8_t      filesize;
             uint8_t      fillerbyte1;
             uint8_t      datalength;
             uint8_t      data[0];
            } __attribute__((packed)) SIM_SB_TDD_NETPAR_ID_STR;
#define SIZE_SIM_SB_TDD_NETPAR_ID                             sizeof(SIM_SB_TDD_NETPAR_ID_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct SIM_SB_IMSI_ID
#define SIM_SB_IMSI_ID                                        0x72                                                  
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      status;
             uint8_t      lengthofimsi;
             uint8_t      noofdigitsinmnc;
             uint8_t      fillerbyte1;
             uint8_t      imsi[8];
            } __attribute__((packed)) SIM_SB_IMSI_ID_STR;
#define SIZE_SIM_SB_IMSI_ID                                   sizeof(SIM_SB_IMSI_ID_STR)


//Definition for struct SIM_SB_TMSI_ID
//#define SIM_SB_TMSI_ID                                      0x74                       //Already defined as 0x74
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      status;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
             uint32_t     tmsi;
            } __attribute__((packed)) SIM_SB_TMSI_ID_STR;
#define SIZE_SIM_SB_TMSI_ID                                   sizeof(SIM_SB_TMSI_ID_STR)


//Definition for struct SIM_SB_GPRS_CIPHERING_KEY_ID
#define SIM_SB_GPRS_CIPHERING_KEY_ID                          0x6A                                                  
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      status;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
             uint8_t      gprscipheringkey[8];
            } __attribute__((packed)) SIM_SB_GPRS_CIPHERING_KEY_ID_STR;
#define SIZE_SIM_SB_GPRS_CIPHERING_KEY_ID                     sizeof(SIM_SB_GPRS_CIPHERING_KEY_ID_STR)


//Definition for struct SIM_SB_GPRS_CIPHERING_KEY_SNR_ID
//#define SIM_SB_GPRS_CIPHERING_KEY_SNR_ID                    0x6B                       //Already defined as 0x6B
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      status;
             uint8_t      gprscipheringkeysnr;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) SIM_SB_GPRS_CIPHERING_KEY_SNR_ID_STR;
#define SIZE_SIM_SB_GPRS_CIPHERING_KEY_SNR_ID                 sizeof(SIM_SB_GPRS_CIPHERING_KEY_SNR_ID_STR)


//Definition for struct SIM_SB_GPRS_RAI_ID
//#define SIM_SB_GPRS_RAI_ID                                  0x6C                       //Already defined as 0x6C
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      status;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
             uint8_t      rai[6];
             uint8_t      fillerbyte4;
             uint8_t      fillerbyte5;
            } __attribute__((packed)) SIM_SB_GPRS_RAI_ID_STR;
#define SIZE_SIM_SB_GPRS_RAI_ID                               sizeof(SIM_SB_GPRS_RAI_ID_STR)


//Definition for struct SIM_SB_GPRS_RAUS_ID
//#define SIM_SB_GPRS_RAUS_ID                                 0x6D                       //Already defined as 0x6D
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      status;
             uint8_t      gprsraus;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) SIM_SB_GPRS_RAUS_ID_STR;
#define SIZE_SIM_SB_GPRS_RAUS_ID                              sizeof(SIM_SB_GPRS_RAUS_ID_STR)


//Definition for struct SIM_SB_GPRS_TMSI_ID
//#define SIM_SB_GPRS_TMSI_ID                                 0x6E                       //Already defined as 0x6E
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      status;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
             uint32_t     gprstmsi;
            } __attribute__((packed)) SIM_SB_GPRS_TMSI_ID_STR;
#define SIZE_SIM_SB_GPRS_TMSI_ID                              sizeof(SIM_SB_GPRS_TMSI_ID_STR)


//Definition for struct SIM_SB_GPRS_TMSI_SIGN_VALUE_ID
//#define SIM_SB_GPRS_TMSI_SIGN_VALUE_ID                      0x6F                       //Already defined as 0x6F
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      status;
             uint8_t      gprstmsisignaturevalue[3];
            } __attribute__((packed)) SIM_SB_GPRS_TMSI_SIGN_VALUE_ID_STR;
#define SIZE_SIM_SB_GPRS_TMSI_SIGN_VALUE_ID                   sizeof(SIM_SB_GPRS_TMSI_SIGN_VALUE_ID_STR)


//Definition for struct SIM_SB_CIPHERING_KEY_ID
#define SIM_SB_CIPHERING_KEY_ID                               0x67                                                  
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      status;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
             uint8_t      cipheringkey[8];
            } __attribute__((packed)) SIM_SB_CIPHERING_KEY_ID_STR;
#define SIZE_SIM_SB_CIPHERING_KEY_ID                          sizeof(SIM_SB_CIPHERING_KEY_ID_STR)


//Definition for struct SIM_SB_CIPHERING_KEY_SNR_ID
//#define SIM_SB_CIPHERING_KEY_SNR_ID                         0x68                       //Already defined as 0x68
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      status;
             uint8_t      cipheringkeysequencenumber;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) SIM_SB_CIPHERING_KEY_SNR_ID_STR;
#define SIZE_SIM_SB_CIPHERING_KEY_SNR_ID                      sizeof(SIM_SB_CIPHERING_KEY_SNR_ID_STR)


//Definition for struct SIM_SB_UMTS_CS_KSI_ID
//#define SIM_SB_UMTS_CS_KSI_ID                               0x75                       //Already defined as 0x75
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      status;
             uint8_t      csksi;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) SIM_SB_UMTS_CS_KSI_ID_STR;
#define SIZE_SIM_SB_UMTS_CS_KSI_ID                            sizeof(SIM_SB_UMTS_CS_KSI_ID_STR)


//Definition for struct SIM_SB_UMTS_CS_CIPHERING_KEY_ID
#define SIM_SB_UMTS_CS_CIPHERING_KEY_ID                       0x76                                                  
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      status;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
             uint8_t      cscipheringkey[16];
            } __attribute__((packed)) SIM_SB_UMTS_CS_CIPHERING_KEY_ID_STR;
#define SIZE_SIM_SB_UMTS_CS_CIPHERING_KEY_ID                  sizeof(SIM_SB_UMTS_CS_CIPHERING_KEY_ID_STR)


//Definition for struct SIM_SB_UMTS_CS_INTEGRITY_KEY_ID
#define SIM_SB_UMTS_CS_INTEGRITY_KEY_ID                       0x77                                                  
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      status;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
             uint8_t      csintegritykey[16];
            } __attribute__((packed)) SIM_SB_UMTS_CS_INTEGRITY_KEY_ID_STR;
#define SIZE_SIM_SB_UMTS_CS_INTEGRITY_KEY_ID                  sizeof(SIM_SB_UMTS_CS_INTEGRITY_KEY_ID_STR)


//Definition for struct SIM_SB_EAP_CIPHERING_KEY_ID
#define SIM_SB_EAP_CIPHERING_KEY_ID                           0x01CD                                                   
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      status;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
             uint8_t      eapcipheringkey[16];
            } __attribute__((packed)) SIM_SB_EAP_CIPHERING_KEY_ID_STR;
#define SIZE_SIM_SB_EAP_CIPHERING_KEY_ID                      sizeof(SIM_SB_EAP_CIPHERING_KEY_ID_STR)


//Definition for struct SIM_SB_EAP_INTEGRITY_KEY_ID
#define SIM_SB_EAP_INTEGRITY_KEY_ID                           0x01CC                                                   
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      status;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
             uint8_t      eapintegritykey[16];
            } __attribute__((packed)) SIM_SB_EAP_INTEGRITY_KEY_ID_STR;
#define SIZE_SIM_SB_EAP_INTEGRITY_KEY_ID                      sizeof(SIM_SB_EAP_INTEGRITY_KEY_ID_STR)


//Definition for struct SIM_SB_UMTS_PS_KSI_ID
//#define SIM_SB_UMTS_PS_KSI_ID                               0x78                       //Already defined as 0x78
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      status;
             uint8_t      psksi;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) SIM_SB_UMTS_PS_KSI_ID_STR;
#define SIZE_SIM_SB_UMTS_PS_KSI_ID                            sizeof(SIM_SB_UMTS_PS_KSI_ID_STR)


//Definition for struct SIM_SB_UMTS_PS_CIPHERING_KEY_ID
#define SIM_SB_UMTS_PS_CIPHERING_KEY_ID                       0x79                                                  
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      status;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
             uint8_t      pscipheringkey[16];
            } __attribute__((packed)) SIM_SB_UMTS_PS_CIPHERING_KEY_ID_STR;
#define SIZE_SIM_SB_UMTS_PS_CIPHERING_KEY_ID                  sizeof(SIM_SB_UMTS_PS_CIPHERING_KEY_ID_STR)


//Definition for struct SIM_SB_UMTS_PS_INTEGRITY_KEY_ID
#define SIM_SB_UMTS_PS_INTEGRITY_KEY_ID                       0x7A                                                  
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      status;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
             uint8_t      psintegritykey[16];
            } __attribute__((packed)) SIM_SB_UMTS_PS_INTEGRITY_KEY_ID_STR;
#define SIZE_SIM_SB_UMTS_PS_INTEGRITY_KEY_ID                  sizeof(SIM_SB_UMTS_PS_INTEGRITY_KEY_ID_STR)


//Definition for struct SIM_SB_UMTS_START_PS_ID
//#define SIM_SB_UMTS_START_PS_ID                             0x7B                       //Already defined as 0x7B
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      status;
             uint8_t      hfn[3];
            } __attribute__((packed)) SIM_SB_UMTS_START_PS_ID_STR;
#define SIZE_SIM_SB_UMTS_START_PS_ID                          sizeof(SIM_SB_UMTS_START_PS_ID_STR)


//Definition for struct SIM_SB_UMTS_START_CS_ID
//#define SIM_SB_UMTS_START_CS_ID                             0x7D                       //Already defined as 0x7D
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      status;
             uint8_t      hfn[3];
            } __attribute__((packed)) SIM_SB_UMTS_START_CS_ID_STR;
#define SIZE_SIM_SB_UMTS_START_CS_ID                          sizeof(SIM_SB_UMTS_START_CS_ID_STR)


//Definition for struct SIM_SB_UMTS_START_MAX_ID
#define SIM_SB_UMTS_START_MAX_ID                              0x7C                                                  
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      status;
             uint8_t      startmax[3];
            } __attribute__((packed)) SIM_SB_UMTS_START_MAX_ID_STR;
#define SIZE_SIM_SB_UMTS_START_MAX_ID                         sizeof(SIM_SB_UMTS_START_MAX_ID_STR)


//Definition for struct SIM_SB_PHONE_NUMBER_FIELD_ID
#define SIM_SB_PHONE_NUMBER_FIELD_ID                          0xB4                                                  
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      status;
             uint8_t      numlen;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint16_t     num[0];
            } __attribute__((packed)) SIM_SB_PHONE_NUMBER_FIELD_ID_STR;
#define SIZE_SIM_SB_PHONE_NUMBER_FIELD_ID                     sizeof(SIM_SB_PHONE_NUMBER_FIELD_ID_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct SIM_SB_SMS_DEST_ADR_ID
#define SIM_SB_SMS_DEST_ADR_ID                                0xB5                                                  
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      status;
             uint8_t      numlen;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint16_t     num[0];
            } __attribute__((packed)) SIM_SB_SMS_DEST_ADR_ID_STR;
#define SIZE_SIM_SB_SMS_DEST_ADR_ID                           sizeof(SIM_SB_SMS_DEST_ADR_ID_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct SIM_SB_SMSC_ADR_ID
#define SIM_SB_SMSC_ADR_ID                                    0xB6                                                  
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      status;
             uint8_t      numlen;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint16_t     num[0];
            } __attribute__((packed)) SIM_SB_SMSC_ADR_ID_STR;
#define SIZE_SIM_SB_SMSC_ADR_ID                               sizeof(SIM_SB_SMSC_ADR_ID_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct SIM_SB_ICC_TYPE_ID
#define SIM_SB_ICC_TYPE_ID                                    0x0190                                                   
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      status;
             uint8_t      cardgeneration;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) SIM_SB_ICC_TYPE_ID_STR;
#define SIZE_SIM_SB_ICC_TYPE_ID                               sizeof(SIM_SB_ICC_TYPE_ID_STR)


//Definition for struct SIM_SB_AID_ID
#define SIM_SB_AID_ID                                         0x0191                                                   
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      status;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      aidlength;
             uint8_t      aid[0];
            } __attribute__((packed)) SIM_SB_AID_ID_STR;
#define SIZE_SIM_SB_AID_ID                                    sizeof(SIM_SB_AID_ID_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct SIM_SB_ICCID_ID
#define SIM_SB_ICCID_ID                                       0x0192                                                   
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      status;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
             uint8_t      iccid[10];
             uint8_t      fillerbyte4;
             uint8_t      fillerbyte5;
            } __attribute__((packed)) SIM_SB_ICCID_ID_STR;
#define SIZE_SIM_SB_ICCID_ID                                  sizeof(SIM_SB_ICCID_ID_STR)


//Definition for struct SIM_SB_REFRESH_FILE_ID
#define SIM_SB_REFRESH_FILE_ID                                0x0193                                                   
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
             uint8_t      datalength;
             uint8_t      filepath[0];
            } __attribute__((packed)) SIM_SB_REFRESH_FILE_ID_STR;
#define SIZE_SIM_SB_REFRESH_FILE_ID                           sizeof(SIM_SB_REFRESH_FILE_ID_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct SIM_SB_ICON_DATA_ID
#define SIM_SB_ICON_DATA_ID                                   0x0194                                                   
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint16_t     width;
             uint16_t     height;
             uint8_t      depth;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
             uint32_t     cm_source_instance;
             uint32_t     cm_source_category;
            } __attribute__((packed)) SIM_SB_ICON_DATA_ID_STR;
#define SIZE_SIM_SB_ICON_DATA_ID                              sizeof(SIM_SB_ICON_DATA_ID_STR)


//Definition for struct SIM_SB_ICON_DATA_CLUT_ID
#define SIM_SB_ICON_DATA_CLUT_ID                              0x0195                                                   
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint16_t     width;
             uint16_t     height;
             uint8_t      depth;
             uint8_t      numberofclut;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      clut[0];
            } __attribute__((packed)) SIM_SB_ICON_DATA_CLUT_ID_STR;
#define SIZE_SIM_SB_ICON_DATA_CLUT_ID                         sizeof(SIM_SB_ICON_DATA_CLUT_ID_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct SIM_SB_ICON_BODY_DATA_ID
#define SIM_SB_ICON_BODY_DATA_ID                              0x0196                                                   
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint16_t     width;
             uint16_t     height;
             uint8_t      depth;
             uint8_t      numberofclut;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      iconbodydata[0];
            } __attribute__((packed)) SIM_SB_ICON_BODY_DATA_ID_STR;
#define SIZE_SIM_SB_ICON_BODY_DATA_ID                         sizeof(SIM_SB_ICON_BODY_DATA_ID_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct SIM_SB_FULL_NETWORK_NAME
#define SIM_SB_FULL_NETWORK_NAME                              0x85                                                  
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblock_length;
             uint8_t      status;
             uint8_t      full_name_length;
             uint8_t      full_name[0];
             uint8_t      fillerbyte1;
            } __attribute__((packed)) SIM_SB_FULL_NETWORK_NAME_STR;
#define SIZE_SIM_SB_FULL_NETWORK_NAME                         sizeof(SIM_SB_FULL_NETWORK_NAME_STR)


//Definition for struct SIM_SB_SHORT_NETWORK_NAME
#define SIM_SB_SHORT_NETWORK_NAME                             0x86                                                  
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblock_length;
             uint8_t      status;
             uint8_t      short_name_length;
             uint8_t      short_name[0];
             uint8_t      fillerbyte1;
            } __attribute__((packed)) SIM_SB_SHORT_NETWORK_NAME_STR;
#define SIZE_SIM_SB_SHORT_NETWORK_NAME                        sizeof(SIM_SB_SHORT_NETWORK_NAME_STR)


//Definition for struct SIM_SB_UMTS_AUTN_FAIL_PARAMS_ID
#define SIM_SB_UMTS_AUTN_FAIL_PARAMS_ID                       0x012E                                                   
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      status;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      lengthofauts;
             uint8_t      autsparams[14];
             uint8_t      fillerbyte3;
             uint8_t      fillerbyte4;
            } __attribute__((packed)) SIM_SB_UMTS_AUTN_FAIL_PARAMS_ID_STR;
#define SIZE_SIM_SB_UMTS_AUTN_FAIL_PARAMS_ID                  sizeof(SIM_SB_UMTS_AUTN_FAIL_PARAMS_ID_STR)


//Definition for struct SIM_SB_RES_PARAMS_ID
#define SIM_SB_RES_PARAMS_ID                                  0x012D                                                   
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      status;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      lengthofres;
             uint8_t      res[16];
            } __attribute__((packed)) SIM_SB_RES_PARAMS_ID_STR;
#define SIZE_SIM_SB_RES_PARAMS_ID                             sizeof(SIM_SB_RES_PARAMS_ID_STR)


//Definition for struct SIM_SB_RAND_PARAMS_ID
#define SIM_SB_RAND_PARAMS_ID                                 0x012F                                                   
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      status;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
             uint8_t      rnd[16];
            } __attribute__((packed)) SIM_SB_RAND_PARAMS_ID_STR;
#define SIZE_SIM_SB_RAND_PARAMS_ID                            sizeof(SIM_SB_RAND_PARAMS_ID_STR)


//Definition for struct SIM_SB_UMTS_AUTN_PARAMS_ID
#define SIM_SB_UMTS_AUTN_PARAMS_ID                            0x012C                                                   
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      status;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
             uint8_t      autnparams[16];
            } __attribute__((packed)) SIM_SB_UMTS_AUTN_PARAMS_ID_STR;
#define SIZE_SIM_SB_UMTS_AUTN_PARAMS_ID                       sizeof(SIM_SB_UMTS_AUTN_PARAMS_ID_STR)


//Definition for struct SIM_SB_APP_SELECTION
#define SIM_SB_APP_SELECTION                                  0x96                                                  
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      status;
             uint8_t      applicationnumber;
             uint8_t      length;
             uint8_t      fillerbyte1;
             uint8_t      label[0];
            } __attribute__((packed)) SIM_SB_APP_SELECTION_STR;
#define SIZE_SIM_SB_APP_SELECTION                             sizeof(SIM_SB_APP_SELECTION_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct SIM_SB_APP_SELECTION_UNICODE
#define SIM_SB_APP_SELECTION_UNICODE                          0x98                                                  
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      status;
             uint8_t      applicationnumber;
             uint8_t      applicationtype;
             uint8_t      length;
             uint16_t     label[0];
            } __attribute__((packed)) SIM_SB_APP_SELECTION_UNICODE_STR;
#define SIZE_SIM_SB_APP_SELECTION_UNICODE                     sizeof(SIM_SB_APP_SELECTION_UNICODE_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct SIM_SB_SMS_ADDRESS_ID
#define SIM_SB_SMS_ADDRESS_ID                                 0x0164                                                   
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      addresstype;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      datalength;
             uint8_t      addressdata[0];
            } __attribute__((packed)) SIM_SB_SMS_ADDRESS_ID_STR;
#define SIZE_SIM_SB_SMS_ADDRESS_ID                            sizeof(SIM_SB_SMS_ADDRESS_ID_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct SIM_SB_SMS_COMMON_DATA_ID
#define SIM_SB_SMS_COMMON_DATA_ID                             0x0165                                                   
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      characteramount;
             uint8_t      datalength;
             uint8_t      data[0];
            } __attribute__((packed)) SIM_SB_SMS_COMMON_DATA_ID_STR;
#define SIZE_SIM_SB_SMS_COMMON_DATA_ID                        sizeof(SIM_SB_SMS_COMMON_DATA_ID_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct SIM_SB_SMS_VALIDITY_PERIOD_ID
#define SIM_SB_SMS_VALIDITY_PERIOD_ID                         0x0166                                                   
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
             uint8_t      datalength;
             uint8_t      validityperioddata[0];
            } __attribute__((packed)) SIM_SB_SMS_VALIDITY_PERIOD_ID_STR;
#define SIZE_SIM_SB_SMS_VALIDITY_PERIOD_ID                    sizeof(SIM_SB_SMS_VALIDITY_PERIOD_ID_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct SIM_SB_SMS_DELIVER_ID
#define SIM_SB_SMS_DELIVER_ID                                 0x015E                                                   
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      messageparameters;
             uint8_t      protocolid;
             uint8_t      datacodingscheme;
             uint8_t      fillerbyte1;
             uint8_t      sctimestamp[7];
             uint8_t      numofsb;
            } __attribute__((packed)) SIM_SB_SMS_DELIVER_ID_STR;
#define SIZE_SIM_SB_SMS_DELIVER_ID                            sizeof(SIM_SB_SMS_DELIVER_ID_STR)


//Definition for struct SIM_SB_SMS_STATUS_REPORT_ID
#define SIM_SB_SMS_STATUS_REPORT_ID                           0x015F                                                   
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      messageparameters;
             uint8_t      messagereference;
             uint8_t      smsstatus;
             uint8_t      fillerbyte1;
             uint8_t      sctimestamp[7];
             uint8_t      fillerbyte2;
             uint8_t      dischargetime[7];
             uint8_t      numofsb;
            } __attribute__((packed)) SIM_SB_SMS_STATUS_REPORT_ID_STR;
#define SIZE_SIM_SB_SMS_STATUS_REPORT_ID                      sizeof(SIM_SB_SMS_STATUS_REPORT_ID_STR)


//Definition for struct SIM_SB_SMS_SUBMIT_ID
#define SIM_SB_SMS_SUBMIT_ID                                  0x0160                                                   
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      messageparameters;
             uint8_t      messagereference;
             uint8_t      protocolid;
             uint8_t      datacodingscheme;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
             uint8_t      numofsb;
            } __attribute__((packed)) SIM_SB_SMS_SUBMIT_ID_STR;
#define SIZE_SIM_SB_SMS_SUBMIT_ID                             sizeof(SIM_SB_SMS_SUBMIT_ID_STR)


//Definition for struct SIM_SB_SMS_COMMAND_ID
#define SIM_SB_SMS_COMMAND_ID                                 0x0161                                                   
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      messageparameters;
             uint8_t      messagereference;
             uint8_t      protocolid;
             uint8_t      commandtype;
             uint8_t      messagenumber;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      numofsb;
            } __attribute__((packed)) SIM_SB_SMS_COMMAND_ID_STR;
#define SIZE_SIM_SB_SMS_COMMAND_ID                            sizeof(SIM_SB_SMS_COMMAND_ID_STR)


//Definition for struct SIM_SB_SMS_MO_UNDEFINED_ID
#define SIM_SB_SMS_MO_UNDEFINED_ID                            0x0162                                                   
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      messageparameters;
             uint8_t      messagereference;
             uint8_t      fillerbyte1;
             uint8_t      numofsb;
            } __attribute__((packed)) SIM_SB_SMS_MO_UNDEFINED_ID_STR;
#define SIZE_SIM_SB_SMS_MO_UNDEFINED_ID                       sizeof(SIM_SB_SMS_MO_UNDEFINED_ID_STR)


//Definition for struct SIM_SB_SMS_MT_UNDEFINED_ID
#define SIM_SB_SMS_MT_UNDEFINED_ID                            0x0163                                                   
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      messageparameters;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      numofsb;
            } __attribute__((packed)) SIM_SB_SMS_MT_UNDEFINED_ID_STR;
#define SIZE_SIM_SB_SMS_MT_UNDEFINED_ID                       sizeof(SIM_SB_SMS_MT_UNDEFINED_ID_STR)


//Definition for struct SIM_SB_SPN_DISPLAY_INFO_PLMNS_ID
#define SIM_SB_SPN_DISPLAY_INFO_PLMNS_ID                      0x97                                                  
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      status;
             uint8_t      fillerbyte1;
             uint16_t     noofplmns;
             SIM_SB_SPN_DISPLAY_INFO_PLMNS_PLMN_STR    plmns[0];
            } __attribute__((packed)) SIM_SB_SPN_DISPLAY_INFO_PLMNS_ID_STR;
#define SIZE_SIM_SB_SPN_DISPLAY_INFO_PLMNS_ID                 sizeof(SIM_SB_SPN_DISPLAY_INFO_PLMNS_ID_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct SIM_SB_CPHS_MSG_FLAGS_ID
#define SIM_SB_CPHS_MSG_FLAGS_ID                              0x01A4                                                   
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      status;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
             uint8_t      voiceline1;
             uint8_t      voiceline2;
             uint8_t      fax;
             uint8_t      data;
            } __attribute__((packed)) SIM_SB_CPHS_MSG_FLAGS_ID_STR;
#define SIZE_SIM_SB_CPHS_MSG_FLAGS_ID                         sizeof(SIM_SB_CPHS_MSG_FLAGS_ID_STR)


//Definition for struct SIM_SB_REL4_MSG_FLAGS_ID
#define SIM_SB_REL4_MSG_FLAGS_ID                              0x01A5                                                   
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      status;
             uint8_t      profileno;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      voicestatus;
             uint8_t      voicemessages;
             uint8_t      faxstatus;
             uint8_t      faxmessages;
             uint8_t      emailstatus;
             uint8_t      emailmessages;
             uint8_t      otherstatus;
             uint8_t      othermessages;
            } __attribute__((packed)) SIM_SB_REL4_MSG_FLAGS_ID_STR;
#define SIZE_SIM_SB_REL4_MSG_FLAGS_ID                         sizeof(SIM_SB_REL4_MSG_FLAGS_ID_STR)


//Definition for struct SIM_SB_CPHS_CALL_FWD_FLAGS_ID
#define SIM_SB_CPHS_CALL_FWD_FLAGS_ID                         0x01A6                                                   
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      status;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
             uint8_t      voiceline1;
             uint8_t      voiceline2;
             uint8_t      fax;
             uint8_t      data;
            } __attribute__((packed)) SIM_SB_CPHS_CALL_FWD_FLAGS_ID_STR;
#define SIZE_SIM_SB_CPHS_CALL_FWD_FLAGS_ID                    sizeof(SIM_SB_CPHS_CALL_FWD_FLAGS_ID_STR)


//Definition for struct SIM_SB_REL4_CALL_FWD_FLAGS_ID
#define SIM_SB_REL4_CALL_FWD_FLAGS_ID                         0x01A7                                                   
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      status;
             uint8_t      profileno;
             uint8_t      voicestatus;
             uint8_t      faxstatus;
             uint8_t      datastatus;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      numberlength;
             uint16_t     number[0];
            } __attribute__((packed)) SIM_SB_REL4_CALL_FWD_FLAGS_ID_STR;
#define SIZE_SIM_SB_REL4_CALL_FWD_FLAGS_ID                    sizeof(SIM_SB_REL4_CALL_FWD_FLAGS_ID_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct SIM_PB_INFO_REQUEST
//#define SIM_PB_INFO_REQUEST                                 0xE4                       //Already defined as 0xE4
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      numberoftags;
             uint8_t      fillerbyte1;
             uint16_t     tags[0];
            } __attribute__((packed)) SIM_PB_INFO_REQUEST_STR;
#define SIZE_SIM_PB_INFO_REQUEST                              sizeof(SIM_PB_INFO_REQUEST_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct SIM_PB_LOCATION
//#define SIM_PB_LOCATION                                     0xFE                       //Already defined as 0xFE
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint16_t     locationtype;
             uint16_t     location;
            } __attribute__((packed)) SIM_PB_LOCATION_STR;
#define SIZE_SIM_PB_LOCATION                                  sizeof(SIM_PB_LOCATION_STR)


//Definition for struct SIM_PB_LOCATION_SEARCH
//#define SIM_PB_LOCATION_SEARCH                              0xFF                       //Already defined as 0xFF
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint16_t     locationtype;
             uint16_t     location;
            } __attribute__((packed)) SIM_PB_LOCATION_SEARCH_STR;
#define SIZE_SIM_PB_LOCATION_SEARCH                           sizeof(SIM_PB_LOCATION_SEARCH_STR)


//Definition for struct SIM_PB_ADN
//#define SIM_PB_ADN                                          0xC8                       //Already defined as 0xC8
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint16_t     location;
             uint8_t      namelength;
             uint8_t      numberlength;
             uint16_t     name[0];
             uint16_t     number[0];
            } __attribute__((packed)) SIM_PB_ADN_STR;
#define SIZE_SIM_PB_ADN                                       sizeof(SIM_PB_ADN_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct SIM_PB_ANR
//#define SIM_PB_ANR                                          0xCA                       //Already defined as 0xCA
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint16_t     location;
             uint8_t      numberlength;
             uint8_t      aasnumber;
             uint16_t     number[0];
            } __attribute__((packed)) SIM_PB_ANR_STR;
#define SIZE_SIM_PB_ANR                                       sizeof(SIM_PB_ANR_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct SIM_PB_BDN
//#define SIM_PB_BDN                                          0xCB                       //Already defined as 0xCB
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint16_t     location;
             uint8_t      namelength;
             uint8_t      numberlength;
             uint16_t     name[0];
             uint16_t     number[0];
            } __attribute__((packed)) SIM_PB_BDN_STR;
#define SIZE_SIM_PB_BDN                                       sizeof(SIM_PB_BDN_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct SIM_PB_CC
//#define SIM_PB_CC                                           0xCC                       //Already defined as 0xCC
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint16_t     data;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) SIM_PB_CC_STR;
#define SIZE_SIM_PB_CC                                        sizeof(SIM_PB_CC_STR)


//Definition for struct SIM_PB_CCP
//#define SIM_PB_CCP                                          0xCD                       //Already defined as 0xCD
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint16_t     location;
             uint8_t      data[14];
            } __attribute__((packed)) SIM_PB_CCP_STR;
#define SIZE_SIM_PB_CCP                                       sizeof(SIM_PB_CCP_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct SIM_PB_EMAIL
//#define SIM_PB_EMAIL                                        0xDD                       //Already defined as 0xDD
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint16_t     location;
             uint8_t      textlength;
             uint8_t      fillerbyte1;
             uint16_t     text[0];
            } __attribute__((packed)) SIM_PB_EMAIL_STR;
#define SIZE_SIM_PB_EMAIL                                     sizeof(SIM_PB_EMAIL_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct SIM_PB_FDN
//#define SIM_PB_FDN                                          0xDE                       //Already defined as 0xDE
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint16_t     location;
             uint8_t      namelength;
             uint8_t      numberlength;
             uint16_t     name[0];
             uint16_t     number[0];
            } __attribute__((packed)) SIM_PB_FDN_STR;
#define SIZE_SIM_PB_FDN                                       sizeof(SIM_PB_FDN_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct SIM_PB_FDN_LIST_STATUS
//#define SIM_PB_FDN_LIST_STATUS                              0xDF                       //Already defined as 0xDF
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      data;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
            } __attribute__((packed)) SIM_PB_FDN_LIST_STATUS_STR;
#define SIZE_SIM_PB_FDN_LIST_STATUS                           sizeof(SIM_PB_FDN_LIST_STATUS_STR)


//Definition for struct SIM_PB_GAS
//#define SIM_PB_GAS                                          0xE1                       //Already defined as 0xE1
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint16_t     location;
             uint8_t      textlength;
             uint8_t      fillerbyte1;
             uint16_t     text[0];
            } __attribute__((packed)) SIM_PB_GAS_STR;
#define SIZE_SIM_PB_GAS                                       sizeof(SIM_PB_GAS_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct SIM_PB_GRP
//#define SIM_PB_GRP                                          0xE2                       //Already defined as 0xE2
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint16_t     locationgrp;
             uint8_t      locationgas[20];
            } __attribute__((packed)) SIM_PB_GRP_STR;
#define SIZE_SIM_PB_GRP                                       sizeof(SIM_PB_GRP_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct SIM_PB_HIDDEN
//#define SIM_PB_HIDDEN                                       0xE3                       //Already defined as 0xE3
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      data;
             uint8_t      fillerbyte1[3];
            } __attribute__((packed)) SIM_PB_HIDDEN_STR;
#define SIZE_SIM_PB_HIDDEN                                    sizeof(SIM_PB_HIDDEN_STR)


//Definition for struct SIM_PB_MSISDN
//#define SIM_PB_MSISDN                                       0x100                      //Already defined as 0x100
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint16_t     location;
             uint8_t      namelength;
             uint8_t      numberlength;
             uint16_t     name[0];
             uint16_t     number[0];
            } __attribute__((packed)) SIM_PB_MSISDN_STR;
#define SIZE_SIM_PB_MSISDN                                    sizeof(SIM_PB_MSISDN_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct SIM_PB_PSC
//#define SIM_PB_PSC                                          0xF1                       //Already defined as 0xF1
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint32_t     data;
            } __attribute__((packed)) SIM_PB_PSC_STR;
#define SIZE_SIM_PB_PSC                                       sizeof(SIM_PB_PSC_STR)


//Definition for struct SIM_PB_SDN
//#define SIM_PB_SDN                                          0xF5                       //Already defined as 0xF5
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint16_t     location;
             uint8_t      namelength;
             uint8_t      numberlength;
             uint16_t     name[0];
             uint16_t     number[0];
            } __attribute__((packed)) SIM_PB_SDN_STR;
#define SIZE_SIM_PB_SDN                                       sizeof(SIM_PB_SDN_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct SIM_PB_SNE
//#define SIM_PB_SNE                                          0xF7                       //Already defined as 0xF7
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint16_t     location;
             uint8_t      textlength;
             uint8_t      fillerbyte1;
             uint16_t     text[0];
            } __attribute__((packed)) SIM_PB_SNE_STR;
#define SIZE_SIM_PB_SNE                                       sizeof(SIM_PB_SNE_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct SIM_PB_STATUS
//#define SIM_PB_STATUS                                       0xFB                       //Already defined as 0xFB
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      status;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
            } __attribute__((packed)) SIM_PB_STATUS_STR;
#define SIZE_SIM_PB_STATUS                                    sizeof(SIM_PB_STATUS_STR)


//Definition for struct SIM_PB_UID
//#define SIM_PB_UID                                          0xFC                       //Already defined as 0xFC
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint16_t     data;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) SIM_PB_UID_STR;
#define SIZE_SIM_PB_UID                                       sizeof(SIM_PB_UID_STR)


//Definition for struct SIM_PB_VMBX
//#define SIM_PB_VMBX                                         0x101                      //Already defined as 0x101
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint16_t     location;
             uint8_t      namelength;
             uint8_t      numberlength;
             uint16_t     name[0];
             uint16_t     number[0];
            } __attribute__((packed)) SIM_PB_VMBX_STR;
#define SIZE_SIM_PB_VMBX                                      sizeof(SIM_PB_VMBX_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct SIM_PB_MBDN
//#define SIM_PB_MBDN                                         0x106                      //Already defined as 0x106
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint16_t     location;
             uint8_t      namelength;
             uint8_t      numberlength;
             uint16_t     name[0];
             uint16_t     number[0];
            } __attribute__((packed)) SIM_PB_MBDN_STR;
#define SIZE_SIM_PB_MBDN                                      sizeof(SIM_PB_MBDN_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct SIM_PB_AAS
//#define SIM_PB_AAS                                          0xFD                       //Already defined as 0xFD
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint16_t     location;
             uint8_t      textlength;
             uint8_t      fillerbyte1;
             uint16_t     text[0];
            } __attribute__((packed)) SIM_PB_AAS_STR;
#define SIZE_SIM_PB_AAS                                       sizeof(SIM_PB_AAS_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct SIM_PB_STARTUP_PHASE_1
//#define SIM_PB_STARTUP_PHASE_1                              0xF8                       //Already defined as 0xF8
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
            } __attribute__((packed)) SIM_PB_STARTUP_PHASE_1_STR;
#define SIZE_SIM_PB_STARTUP_PHASE_1                           sizeof(SIM_PB_STARTUP_PHASE_1_STR)


//Definition for struct SIM_PB_STARTUP_PHASE_2
//#define SIM_PB_STARTUP_PHASE_2                              0xF9                       //Already defined as 0xF9
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
            } __attribute__((packed)) SIM_PB_STARTUP_PHASE_2_STR;
#define SIZE_SIM_PB_STARTUP_PHASE_2                           sizeof(SIM_PB_STARTUP_PHASE_2_STR)


//Definition for struct SIM_PB_STARTUP_PHASE_3
//#define SIM_PB_STARTUP_PHASE_3                              0xFA                       //Already defined as 0xFA
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
            } __attribute__((packed)) SIM_PB_STARTUP_PHASE_3_STR;
#define SIZE_SIM_PB_STARTUP_PHASE_3                           sizeof(SIM_PB_STARTUP_PHASE_3_STR)


//Definition for struct SIM_PB_DELETE_ALL
//#define SIM_PB_DELETE_ALL                                   0xDB                       //Already defined as 0xDB
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint16_t     data;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) SIM_PB_DELETE_ALL_STR;
#define SIZE_SIM_PB_DELETE_ALL                                sizeof(SIM_PB_DELETE_ALL_STR)


//Definition for struct SIM_PB_DELETE_LOCATION
//#define SIM_PB_DELETE_LOCATION                              0xDC                       //Already defined as 0xDC
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint16_t     locationtype;
             uint16_t     location;
            } __attribute__((packed)) SIM_PB_DELETE_LOCATION_STR;
#define SIZE_SIM_PB_DELETE_LOCATION                           sizeof(SIM_PB_DELETE_LOCATION_STR)


//Definition for struct SIM_PB_CONF_PH_1
//#define SIM_PB_CONF_PH_1                                    0xD7                       //Already defined as 0xD7
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      generation;
             uint8_t      fdnliststatus;
             uint8_t      pbpresence;
             uint8_t      pbrcountpub;
             uint8_t      syncsupportpub;
             uint8_t      fillerbyte1;
             uint16_t     pscpub;
             uint16_t     ccpub;
             uint8_t      pbc2gchangedpub;
             uint8_t      pbrcountpriv;
             uint8_t      syncsupportpriv;
             uint8_t      fillerbyte2;
             uint16_t     pscpriv;
             uint16_t     ccpriv;
             uint8_t      pbc2gchangedpriv;
             uint8_t      fillerbyte3;
            } __attribute__((packed)) SIM_PB_CONF_PH_1_STR;
#define SIZE_SIM_PB_CONF_PH_1                                 sizeof(SIM_PB_CONF_PH_1_STR)


//Definition for struct SIM_PB_CONF_ADN_SB
//#define SIM_PB_CONF_ADN_SB                                  0xD0                       //Already defined as 0xD0
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      filelength;
             uint8_t      textlength;
             uint8_t      numberlength;
             uint8_t      adnaccessstatuswhenfdnisenabled;
            } __attribute__((packed)) SIM_PB_CONF_ADN_SB_STR;
#define SIZE_SIM_PB_CONF_ADN_SB                               sizeof(SIM_PB_CONF_ADN_SB_STR)


//Definition for struct SIM_PB_CONF_ADN_LONG_SB
//#define SIM_PB_CONF_ADN_LONG_SB                             0x107                      //Already defined as 0x107
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint16_t     entrycount;
             uint8_t      textlength;
             uint8_t      numberlength;
             uint8_t      adnaccessstatuswhenfdnisenabled;
             uint8_t      fillerbyte1[3];
            } __attribute__((packed)) SIM_PB_CONF_ADN_LONG_SB_STR;
#define SIZE_SIM_PB_CONF_ADN_LONG_SB                          sizeof(SIM_PB_CONF_ADN_LONG_SB_STR)


//Definition for struct SIM_PB_CONF_SNE_SB
//#define SIM_PB_CONF_SNE_SB                                  0xD9                       //Already defined as 0xD9
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      filetype;
             uint8_t      filelength;
             uint8_t      textlength;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) SIM_PB_CONF_SNE_SB_STR;
#define SIZE_SIM_PB_CONF_SNE_SB                               sizeof(SIM_PB_CONF_SNE_SB_STR)


//Definition for struct SIM_PB_CONF_SNE_LONG_SB
//#define SIM_PB_CONF_SNE_LONG_SB                             0x10A                      //Already defined as 0x10A
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint16_t     entrycount;
             uint8_t      textlength;
             uint8_t      type1filesperadn;
             uint8_t      type2filesperadn;
             uint8_t      fillerbyte1[3];
            } __attribute__((packed)) SIM_PB_CONF_SNE_LONG_SB_STR;
#define SIZE_SIM_PB_CONF_SNE_LONG_SB                          sizeof(SIM_PB_CONF_SNE_LONG_SB_STR)


//Definition for struct SIM_PB_CONF_ANR_SB
//#define SIM_PB_CONF_ANR_SB                                  0xD1                       //Already defined as 0xD1
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      filetype;
             uint8_t      filelength;
             uint8_t      numberlength;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) SIM_PB_CONF_ANR_SB_STR;
#define SIZE_SIM_PB_CONF_ANR_SB                               sizeof(SIM_PB_CONF_ANR_SB_STR)


//Definition for struct SIM_PB_CONF_ANR_LONG_SB
//#define SIM_PB_CONF_ANR_LONG_SB                             0x108                      //Already defined as 0x108
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint16_t     entrycount;
             uint8_t      numberlength;
             uint8_t      type1filesperadn;
             uint8_t      type2filesperadn;
             uint8_t      fillerbyte1[3];
            } __attribute__((packed)) SIM_PB_CONF_ANR_LONG_SB_STR;
#define SIZE_SIM_PB_CONF_ANR_LONG_SB                          sizeof(SIM_PB_CONF_ANR_LONG_SB_STR)


//Definition for struct SIM_PB_CONF_GRP_SB
//#define SIM_PB_CONF_GRP_SB                                  0xD5                       //Already defined as 0xD5
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      numberofgroups;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) SIM_PB_CONF_GRP_SB_STR;
#define SIZE_SIM_PB_CONF_GRP_SB                               sizeof(SIM_PB_CONF_GRP_SB_STR)


//Definition for struct SIM_PB_CONF_GRP_LONG_SB
//#define SIM_PB_CONF_GRP_LONG_SB                             0x10B                      //Already defined as 0x10B
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint16_t     entrycount;
             uint8_t      numberofgroups;
             uint8_t      type1filesperadn;
            } __attribute__((packed)) SIM_PB_CONF_GRP_LONG_SB_STR;
#define SIZE_SIM_PB_CONF_GRP_LONG_SB                          sizeof(SIM_PB_CONF_GRP_LONG_SB_STR)


//Definition for struct SIM_PB_CONF_AAS_SB
//#define SIM_PB_CONF_AAS_SB                                  0xDA                       //Already defined as 0xDA
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      filetype;
             uint8_t      filelength;
             uint8_t      textlength;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) SIM_PB_CONF_AAS_SB_STR;
#define SIZE_SIM_PB_CONF_AAS_SB                               sizeof(SIM_PB_CONF_AAS_SB_STR)


//Definition for struct SIM_PB_CONF_GAS_SB
//#define SIM_PB_CONF_GAS_SB                                  0xD4                       //Already defined as 0xD4
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      filelength;
             uint8_t      textlength;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) SIM_PB_CONF_GAS_SB_STR;
#define SIZE_SIM_PB_CONF_GAS_SB                               sizeof(SIM_PB_CONF_GAS_SB_STR)


//Definition for struct SIM_PB_CONF_EMAIL_SB
//#define SIM_PB_CONF_EMAIL_SB                                0xD2                       //Already defined as 0xD2
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      filetype;
             uint8_t      filelength;
             uint8_t      textlength;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) SIM_PB_CONF_EMAIL_SB_STR;
#define SIZE_SIM_PB_CONF_EMAIL_SB                             sizeof(SIM_PB_CONF_EMAIL_SB_STR)


//Definition for struct SIM_PB_CONF_EMAIL_LONG_SB
//#define SIM_PB_CONF_EMAIL_LONG_SB                           0x109                      //Already defined as 0x109
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint16_t     entrycount;
             uint8_t      textlength;
             uint8_t      type1filesperadn;
             uint8_t      type2filesperadn;
             uint8_t      fillerbyte1[3];
            } __attribute__((packed)) SIM_PB_CONF_EMAIL_LONG_SB_STR;
#define SIZE_SIM_PB_CONF_EMAIL_LONG_SB                        sizeof(SIM_PB_CONF_EMAIL_LONG_SB_STR)


//Definition for struct SIM_PB_CONF_MISC_SB
//#define SIM_PB_CONF_MISC_SB                                 0xD6                       //Already defined as 0xD6
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      presenceof_ext1;
             uint8_t      presenceof_cc;
             uint8_t      presenceof_uid;
             uint8_t      presenceof_puid;
            } __attribute__((packed)) SIM_PB_CONF_MISC_SB_STR;
#define SIZE_SIM_PB_CONF_MISC_SB                              sizeof(SIM_PB_CONF_MISC_SB_STR)


//Definition for struct SIM_PB_CONF_FDN_SB
//#define SIM_PB_CONF_FDN_SB                                  0xD3                       //Already defined as 0xD3
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      filelength;
             uint8_t      textlength;
             uint8_t      numberlength;
             uint8_t      fdnliststatus;
            } __attribute__((packed)) SIM_PB_CONF_FDN_SB_STR;
#define SIZE_SIM_PB_CONF_FDN_SB                               sizeof(SIM_PB_CONF_FDN_SB_STR)


//Definition for struct SIM_PB_CONF_PH_3
//#define SIM_PB_CONF_PH_3                                    0xD8                       //Already defined as 0xD8
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      sdn_numberof;
             uint8_t      sdn_namelength;
             uint8_t      sdn_numberlength;
             uint8_t      bdn_numberof;
             uint8_t      bdn_namelength;
             uint8_t      bdn_numberlength;
             uint8_t      msisdn_accesscondition;
             uint8_t      msisdn_number_of;
             uint8_t      msisdn_namelength;
             uint8_t      msisdn_numberlength;
             uint8_t      vmbx_number_of;
             uint8_t      vmbx_namelength;
             uint8_t      vmbx_numberlength;
             uint8_t      mbdn_numberofprofiles;
             uint8_t      mbdn_numberof;
             uint8_t      mbdn_namelength;
             uint8_t      mbdn_numberlength;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
            } __attribute__((packed)) SIM_PB_CONF_PH_3_STR;
#define SIZE_SIM_PB_CONF_PH_3                                 sizeof(SIM_PB_CONF_PH_3_STR)


//Definition for struct SIM_PB_SELECT_PB_SB
//#define SIM_PB_SELECT_PB_SB                                 0xF6                       //Already defined as 0xF6
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      phonebook;
             uint8_t      slowsyncneeded;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) SIM_PB_SELECT_PB_SB_STR;
#define SIZE_SIM_PB_SELECT_PB_SB                              sizeof(SIM_PB_SELECT_PB_SB_STR)


//Definition for struct SIM_SB_MMS_CONNECTIVITY_PARAMETERS_ID
#define SIM_SB_MMS_CONNECTIVITY_PARAMETERS_ID                 0x01AE                                                   
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint16_t     datalength;
             uint8_t      data[0];
            } __attribute__((packed)) SIM_SB_MMS_CONNECTIVITY_PARAMETERS_ID_STR;
#define SIZE_SIM_SB_MMS_CONNECTIVITY_PARAMETERS_ID            sizeof(SIM_SB_MMS_CONNECTIVITY_PARAMETERS_ID_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct SIM_SB_MMS_USER_PREFERENCES_ID
#define SIM_SB_MMS_USER_PREFERENCES_ID                        0x01AF                                                   
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint16_t     datalength;
             uint8_t      data[0];
            } __attribute__((packed)) SIM_SB_MMS_USER_PREFERENCES_ID_STR;
#define SIZE_SIM_SB_MMS_USER_PREFERENCES_ID                   sizeof(SIM_SB_MMS_USER_PREFERENCES_ID_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct SIM_SB_IMS_PRIVATE_USER_ID
#define SIM_SB_IMS_PRIVATE_USER_ID                            0x01B8                                                   
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      datalength;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
             uint8_t      imsprivateuserid[0];
            } __attribute__((packed)) SIM_SB_IMS_PRIVATE_USER_ID_STR;
#define SIZE_SIM_SB_IMS_PRIVATE_USER_ID                       sizeof(SIM_SB_IMS_PRIVATE_USER_ID_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct SIM_SB_IMS_PUBLIC_USER_ID
#define SIM_SB_IMS_PUBLIC_USER_ID                             0x01B9                                                   
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      datalength;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
             uint8_t      imspublicuserid[0];
            } __attribute__((packed)) SIM_SB_IMS_PUBLIC_USER_ID_STR;
#define SIZE_SIM_SB_IMS_PUBLIC_USER_ID                        sizeof(SIM_SB_IMS_PUBLIC_USER_ID_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct SIM_SB_IMS_HOME_NW_DOMAIN_NAME_ID
#define SIM_SB_IMS_HOME_NW_DOMAIN_NAME_ID                     0x01BA                                                   
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      datalength;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
             uint8_t      imshomenwnameid[0];
            } __attribute__((packed)) SIM_SB_IMS_HOME_NW_DOMAIN_NAME_ID_STR;
#define SIZE_SIM_SB_IMS_HOME_NW_DOMAIN_NAME_ID                sizeof(SIM_SB_IMS_HOME_NW_DOMAIN_NAME_ID_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct SIM_SB_CONNECTION_ID
#define SIM_SB_CONNECTION_ID                                  0x01C2                                                   
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint16_t     objectid;
             uint8_t      deviseid;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) SIM_SB_CONNECTION_ID_STR;
#define SIZE_SIM_SB_CONNECTION_ID                             sizeof(SIM_SB_CONNECTION_ID_STR)


//Definition for struct SIM_SB_AM_APP_LABEL_ID
#define SIM_SB_AM_APP_LABEL_ID                                0x0201                                                   
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      status;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      applabellength;
             uint8_t      applabel[0];
            } __attribute__((packed)) SIM_SB_AM_APP_LABEL_ID_STR;
#define SIZE_SIM_SB_AM_APP_LABEL_ID                           sizeof(SIM_SB_AM_APP_LABEL_ID_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct SIM_SB_AM_APP_INFO_RECORD_ID
#define SIM_SB_AM_APP_INFO_RECORD_ID                          0x0202                                                   
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      status;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      numofsb;
            } __attribute__((packed)) SIM_SB_AM_APP_INFO_RECORD_ID_STR;
#define SIZE_SIM_SB_AM_APP_INFO_RECORD_ID                     sizeof(SIM_SB_AM_APP_INFO_RECORD_ID_STR)


//Definition for struct SIM_SB_AM_FILE_DATA_ID_ID
#define SIM_SB_AM_FILE_DATA_ID_ID                             0x0203                                                   
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      filedataid;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
            } __attribute__((packed)) SIM_SB_AM_FILE_DATA_ID_ID_STR;
#define SIZE_SIM_SB_AM_FILE_DATA_ID_ID                        sizeof(SIM_SB_AM_FILE_DATA_ID_ID_STR)


//Definition for struct SIM_SB_AM_SERVICE_ID_ID
#define SIM_SB_AM_SERVICE_ID_ID                               0x0204                                                   
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      status;
             uint8_t      appserviceid;
             uint8_t      appservicestatus;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) SIM_SB_AM_SERVICE_ID_ID_STR;
#define SIZE_SIM_SB_AM_SERVICE_ID_ID                          sizeof(SIM_SB_AM_SERVICE_ID_ID_STR)


//Definition for struct SIM_SB_AM_GBA_B_TID_ID
#define SIM_SB_AM_GBA_B_TID_ID                                0x0205                                                   
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      status;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      datalength;
             uint8_t      data[0];
            } __attribute__((packed)) SIM_SB_AM_GBA_B_TID_ID_STR;
#define SIZE_SIM_SB_AM_GBA_B_TID_ID                           sizeof(SIM_SB_AM_GBA_B_TID_ID_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct SIM_SB_AM_GBA_KEY_LIFETIME_ID
#define SIM_SB_AM_GBA_KEY_LIFETIME_ID                         0x0206                                                   
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      status;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      datalength;
             uint8_t      data[0];
            } __attribute__((packed)) SIM_SB_AM_GBA_KEY_LIFETIME_ID_STR;
#define SIZE_SIM_SB_AM_GBA_KEY_LIFETIME_ID                    sizeof(SIM_SB_AM_GBA_KEY_LIFETIME_ID_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct SIM_SB_AM_GBA_NAF_ID_ID
#define SIM_SB_AM_GBA_NAF_ID_ID                               0x0207                                                   
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      status;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      datalength;
             uint8_t      data[0];
            } __attribute__((packed)) SIM_SB_AM_GBA_NAF_ID_ID_STR;
#define SIZE_SIM_SB_AM_GBA_NAF_ID_ID                          sizeof(SIM_SB_AM_GBA_NAF_ID_ID_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct SIM_SB_AM_GBA_GBANL_RECORD_ID
#define SIM_SB_AM_GBA_GBANL_RECORD_ID                         0x0208                                                   
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      status;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      numofsb;
            } __attribute__((packed)) SIM_SB_AM_GBA_GBANL_RECORD_ID_STR;
#define SIZE_SIM_SB_AM_GBA_GBANL_RECORD_ID                    sizeof(SIM_SB_AM_GBA_GBANL_RECORD_ID_STR)


//Definition for struct SIM_SB_AM_GBA_KS_EXT_NAF_ID
#define SIM_SB_AM_GBA_KS_EXT_NAF_ID                           0x0209                                                   
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      status;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      datalength;
             uint8_t      data[0];
            } __attribute__((packed)) SIM_SB_AM_GBA_KS_EXT_NAF_ID_STR;
#define SIZE_SIM_SB_AM_GBA_KS_EXT_NAF_ID                      sizeof(SIM_SB_AM_GBA_KS_EXT_NAF_ID_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct SIM_SB_AM_MBMS_MSK_RECORD_ID
#define SIM_SB_AM_MBMS_MSK_RECORD_ID                          0x020A                                                   
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      status;
             uint8_t      keydomainidbyte1;
             uint8_t      keydomainidbyte2;
             uint8_t      keydomainidbyte3;
             uint8_t      maxnumofmtp;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      numofmtp;
             SIM_STRUCT_AM_MBMS_MTP_X_STR    mtps[0];
            } __attribute__((packed)) SIM_SB_AM_MBMS_MSK_RECORD_ID_STR;
#define SIZE_SIM_SB_AM_MBMS_MSK_RECORD_ID                     sizeof(SIM_SB_AM_MBMS_MSK_RECORD_ID_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct SIM_SB_AM_MBMS_MUK_RECORD_ID
#define SIM_SB_AM_MBMS_MUK_RECORD_ID                          0x020B                                                   
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      status;
             uint8_t      mukidrlength;
             uint8_t      mukidilength;
             uint8_t      timestampcounterlength;
             uint8_t      mukidrdata[0];
             uint8_t      mukididata[0];
             uint8_t      timestampcounterdata[0];
            } __attribute__((packed)) SIM_SB_AM_MBMS_MUK_RECORD_ID_STR;
#define SIZE_SIM_SB_AM_MBMS_MUK_RECORD_ID                     sizeof(SIM_SB_AM_MBMS_MUK_RECORD_ID_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct SIM_SB_AM_MBMS_MIKEY_ID
#define SIM_SB_AM_MBMS_MIKEY_ID                               0x020C                                                   
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      status;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      datalength;
             uint8_t      data[0];
            } __attribute__((packed)) SIM_SB_AM_MBMS_MIKEY_ID_STR;
#define SIZE_SIM_SB_AM_MBMS_MIKEY_ID                          sizeof(SIM_SB_AM_MBMS_MIKEY_ID_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct SIM_SB_AM_MBMS_MTK_SALT_ID
#define SIM_SB_AM_MBMS_MTK_SALT_ID                            0x020D                                                   
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      status;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      datalength;
             uint8_t      data[0];
            } __attribute__((packed)) SIM_SB_AM_MBMS_MTK_SALT_ID_STR;
#define SIZE_SIM_SB_AM_MBMS_MTK_SALT_ID                       sizeof(SIM_SB_AM_MBMS_MTK_SALT_ID_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct SIM_SB_AM_MBMS_KEY_DOMAIN_ID_ID
#define SIM_SB_AM_MBMS_KEY_DOMAIN_ID_ID                       0x020E                                                   
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      status;
             uint8_t      keydomainidbyte1;
             uint8_t      keydomainidbyte2;
             uint8_t      keydomainidbyte3;
            } __attribute__((packed)) SIM_SB_AM_MBMS_KEY_DOMAIN_ID_ID_STR;
#define SIZE_SIM_SB_AM_MBMS_KEY_DOMAIN_ID_ID                  sizeof(SIM_SB_AM_MBMS_KEY_DOMAIN_ID_ID_STR)


//Definition for struct SIM_SB_AM_MBMS_KEY_GROUP_ID_PART_ID
#define SIM_SB_AM_MBMS_KEY_GROUP_ID_PART_ID                   0x020F                                                   
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      status;
             uint8_t      fillerbyte1;
             uint16_t     keygroupidpart;
            } __attribute__((packed)) SIM_SB_AM_MBMS_KEY_GROUP_ID_PART_ID_STR;
#define SIZE_SIM_SB_AM_MBMS_KEY_GROUP_ID_PART_ID              sizeof(SIM_SB_AM_MBMS_KEY_GROUP_ID_PART_ID_STR)


//Definition for struct SIM_SB_AM_BCAST_KEY_NUMBER_ID_PART_ID
#define SIM_SB_AM_BCAST_KEY_NUMBER_ID_PART_ID                 0x0210                                                   
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      status;
             uint8_t      fillerbyte1;
             uint16_t     keynumberidpart;
            } __attribute__((packed)) SIM_SB_AM_BCAST_KEY_NUMBER_ID_PART_ID_STR;
#define SIZE_SIM_SB_AM_BCAST_KEY_NUMBER_ID_PART_ID            sizeof(SIM_SB_AM_BCAST_KEY_NUMBER_ID_PART_ID_STR)


//Definition for struct SIM_SB_AM_BCAST_KEY_VALIDITY_DATA_TSLOW_TSHIGH_ID
#define SIM_SB_AM_BCAST_KEY_VALIDITY_DATA_TSLOW_TSHIGH_ID     0x0211                                                   
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      status;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
             uint8_t      key_validity_tslow_tshigh[8];
            } __attribute__((packed)) SIM_SB_AM_BCAST_KEY_VALIDITY_DATA_TSLOW_TSHIGH_ID_STR;
#define SIZE_SIM_SB_AM_BCAST_KEY_VALIDITY_DATA_TSLOW_TSHIGH_ID    sizeof(SIM_SB_AM_BCAST_KEY_VALIDITY_DATA_TSLOW_TSHIGH_ID_STR)


//Definition for struct SIM_SB_AM_BCAST_SECURITY_POLICY_EXTENSION_ID
#define SIM_SB_AM_BCAST_SECURITY_POLICY_EXTENSION_ID          0x0212                                                   
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      status;
             uint8_t      spe;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) SIM_SB_AM_BCAST_SECURITY_POLICY_EXTENSION_ID_STR;
#define SIZE_SIM_SB_AM_BCAST_SECURITY_POLICY_EXTENSION_ID     sizeof(SIM_SB_AM_BCAST_SECURITY_POLICY_EXTENSION_ID_STR)


//Definition for struct SIM_SB_AM_BCAST_MANAGEMENT_DATA_ID
#define SIM_SB_AM_BCAST_MANAGEMENT_DATA_ID                    0x0213                                                   
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      status;
             uint8_t      mgmt_data;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) SIM_SB_AM_BCAST_MANAGEMENT_DATA_ID_STR;
#define SIZE_SIM_SB_AM_BCAST_MANAGEMENT_DATA_ID               sizeof(SIM_SB_AM_BCAST_MANAGEMENT_DATA_ID_STR)


//Definition for struct SIM_SB_AM_BCAST_SPE_USER_PURSE_ID
#define SIM_SB_AM_BCAST_SPE_USER_PURSE_ID                     0x0214                                                   
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      status;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
             uint32_t     user_purse_value;
            } __attribute__((packed)) SIM_SB_AM_BCAST_SPE_USER_PURSE_ID_STR;
#define SIZE_SIM_SB_AM_BCAST_SPE_USER_PURSE_ID                sizeof(SIM_SB_AM_BCAST_SPE_USER_PURSE_ID_STR)


//Definition for struct SIM_SB_AM_BCAST_SPE_LIVE_PPT_PURSE_ID
#define SIM_SB_AM_BCAST_SPE_LIVE_PPT_PURSE_ID                 0x0215                                                   
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      status;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
             uint32_t     live_ppt_purse_value;
            } __attribute__((packed)) SIM_SB_AM_BCAST_SPE_LIVE_PPT_PURSE_ID_STR;
#define SIZE_SIM_SB_AM_BCAST_SPE_LIVE_PPT_PURSE_ID            sizeof(SIM_SB_AM_BCAST_SPE_LIVE_PPT_PURSE_ID_STR)


//Definition for struct SIM_SB_AM_BCAST_SPE_PLAYBACK_PPT_PURSE_ID
#define SIM_SB_AM_BCAST_SPE_PLAYBACK_PPT_PURSE_ID             0x0216                                                   
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      status;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
             uint32_t     playback_ppt_purse_value;
            } __attribute__((packed)) SIM_SB_AM_BCAST_SPE_PLAYBACK_PPT_PURSE_ID_STR;
#define SIZE_SIM_SB_AM_BCAST_SPE_PLAYBACK_PPT_PURSE_ID        sizeof(SIM_SB_AM_BCAST_SPE_PLAYBACK_PPT_PURSE_ID_STR)


//Definition for struct SIM_SB_AM_BCAST_SPE_KEPT_TEK_COUNTER_ID
#define SIM_SB_AM_BCAST_SPE_KEPT_TEK_COUNTER_ID               0x0217                                                   
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      status;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
             uint32_t     kept_tek_counter_val;
            } __attribute__((packed)) SIM_SB_AM_BCAST_SPE_KEPT_TEK_COUNTER_ID_STR;
#define SIZE_SIM_SB_AM_BCAST_SPE_KEPT_TEK_COUNTER_ID          sizeof(SIM_SB_AM_BCAST_SPE_KEPT_TEK_COUNTER_ID_STR)


//Definition for struct SIM_SB_AM_BCAST_KEY_GROUP_DESCRIPTION_ID
#define SIM_SB_AM_BCAST_KEY_GROUP_DESCRIPTION_ID              0x0218                                                   
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      status;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      numofsb;
            } __attribute__((packed)) SIM_SB_AM_BCAST_KEY_GROUP_DESCRIPTION_ID_STR;
#define SIZE_SIM_SB_AM_BCAST_KEY_GROUP_DESCRIPTION_ID         sizeof(SIM_SB_AM_BCAST_KEY_GROUP_DESCRIPTION_ID_STR)


//Definition for struct SIM_SB_AM_BCAST_SPE_KEY_PROPERTIES_ID
#define SIM_SB_AM_BCAST_SPE_KEY_PROPERTIES_ID                 0x0219                                                   
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      status;
             uint8_t      key_properties;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) SIM_SB_AM_BCAST_SPE_KEY_PROPERTIES_ID_STR;
#define SIZE_SIM_SB_AM_BCAST_SPE_KEY_PROPERTIES_ID            sizeof(SIM_SB_AM_BCAST_SPE_KEY_PROPERTIES_ID_STR)


//Definition for struct SIM_SB_AM_BCAST_SPE_COST_VALUE_ID
#define SIM_SB_AM_BCAST_SPE_COST_VALUE_ID                     0x021A                                                   
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      status;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
             uint32_t     cost_val;
            } __attribute__((packed)) SIM_SB_AM_BCAST_SPE_COST_VALUE_ID_STR;
#define SIZE_SIM_SB_AM_BCAST_SPE_COST_VALUE_ID                sizeof(SIM_SB_AM_BCAST_SPE_COST_VALUE_ID_STR)


//Definition for struct SIM_SB_AM_BCAST_SPE_PLAYBACK_COUNTER_ID
#define SIM_SB_AM_BCAST_SPE_PLAYBACK_COUNTER_ID               0x021B                                                   
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      status;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
             uint32_t     playback_counter_val;
            } __attribute__((packed)) SIM_SB_AM_BCAST_SPE_PLAYBACK_COUNTER_ID_STR;
#define SIZE_SIM_SB_AM_BCAST_SPE_PLAYBACK_COUNTER_ID          sizeof(SIM_SB_AM_BCAST_SPE_PLAYBACK_COUNTER_ID_STR)


//Definition for struct SIM_SB_AM_BCAST_SPE_TEK_COUNTER_ID
#define SIM_SB_AM_BCAST_SPE_TEK_COUNTER_ID                    0x021C                                                   
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      status;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
             uint32_t     tek_counter_val;
            } __attribute__((packed)) SIM_SB_AM_BCAST_SPE_TEK_COUNTER_ID_STR;
#define SIZE_SIM_SB_AM_BCAST_SPE_TEK_COUNTER_ID               sizeof(SIM_SB_AM_BCAST_SPE_TEK_COUNTER_ID_STR)


//Definition for struct SIM_SB_AM_BCAST_SPE_DESCRIPTION_ID
#define SIM_SB_AM_BCAST_SPE_DESCRIPTION_ID                    0x021D                                                   
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      status;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      numofsb;
            } __attribute__((packed)) SIM_SB_AM_BCAST_SPE_DESCRIPTION_ID_STR;
#define SIZE_SIM_SB_AM_BCAST_SPE_DESCRIPTION_ID               sizeof(SIM_SB_AM_BCAST_SPE_DESCRIPTION_ID_STR)


//Definition for struct SIM_SB_AM_BCAST_SPE_PARENTAL_RATING_ID
#define SIM_SB_AM_BCAST_SPE_PARENTAL_RATING_ID                0x021E                                                   
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      status;
             uint8_t      rating_type;
             uint8_t      level_granted;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) SIM_SB_AM_BCAST_SPE_PARENTAL_RATING_ID_STR;
#define SIZE_SIM_SB_AM_BCAST_SPE_PARENTAL_RATING_ID           sizeof(SIM_SB_AM_BCAST_SPE_PARENTAL_RATING_ID_STR)


//Definition for struct SIM_SB_AM_BCAST_SPE_PARENTAL_CONTROL_OPERATION_ID
#define SIM_SB_AM_BCAST_SPE_PARENTAL_CONTROL_OPERATION_ID     0x021F                                                   
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      status;
             uint8_t      pco_rating_type;
             uint8_t      pco_rating_value;
             uint8_t      pco_level_granted_value;
            } __attribute__((packed)) SIM_SB_AM_BCAST_SPE_PARENTAL_CONTROL_OPERATION_ID_STR;
#define SIZE_SIM_SB_AM_BCAST_SPE_PARENTAL_CONTROL_OPERATION_ID    sizeof(SIM_SB_AM_BCAST_SPE_PARENTAL_CONTROL_OPERATION_ID_STR)


//Definition for struct SIM_SB_AM_BCAST_TEK_DATA_ID
#define SIM_SB_AM_BCAST_TEK_DATA_ID                           0x0220                                                   
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      status;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      datalength;
             uint8_t      data[0];
            } __attribute__((packed)) SIM_SB_AM_BCAST_TEK_DATA_ID_STR;
#define SIZE_SIM_SB_AM_BCAST_TEK_DATA_ID                      sizeof(SIM_SB_AM_BCAST_TEK_DATA_ID_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct SIM_SB_AM_BCAST_TERMINAL_IDENTIFIER_ID
#define SIM_SB_AM_BCAST_TERMINAL_IDENTIFIER_ID                0x0221                                                   
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      status;
             uint8_t      terminal_id_type;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      terminal_id_value[16];
            } __attribute__((packed)) SIM_SB_AM_BCAST_TERMINAL_IDENTIFIER_ID_STR;
#define SIZE_SIM_SB_AM_BCAST_TERMINAL_IDENTIFIER_ID           sizeof(SIM_SB_AM_BCAST_TERMINAL_IDENTIFIER_ID_STR)


//Definition for struct SIM_SB_AM_BCAST_CONTENT_IDENTIFIER_ID
#define SIM_SB_AM_BCAST_CONTENT_IDENTIFIER_ID                 0x0222                                                   
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      status;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      datalength;
             uint8_t      data[0];
            } __attribute__((packed)) SIM_SB_AM_BCAST_CONTENT_IDENTIFIER_ID_STR;
#define SIZE_SIM_SB_AM_BCAST_CONTENT_IDENTIFIER_ID            sizeof(SIM_SB_AM_BCAST_CONTENT_IDENTIFIER_ID_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct SIM_SB_AM_BCAST_REC_TS_INTERVAL_ID
#define SIM_SB_AM_BCAST_REC_TS_INTERVAL_ID                    0x0223                                                   
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      status;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
             uint32_t     ts_start_val;
             uint32_t     ts_end_val;
            } __attribute__((packed)) SIM_SB_AM_BCAST_REC_TS_INTERVAL_ID_STR;
#define SIZE_SIM_SB_AM_BCAST_REC_TS_INTERVAL_ID               sizeof(SIM_SB_AM_BCAST_REC_TS_INTERVAL_ID_STR)


//Definition for struct SIM_SB_AM_BCAST_SPE_AVAILABLE_NR_OF_REC_ID
#define SIM_SB_AM_BCAST_SPE_AVAILABLE_NR_OF_REC_ID            0x0224                                                   
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      status;
             uint8_t      fillerbyte1;
             uint16_t     avail_spe_rec;
            } __attribute__((packed)) SIM_SB_AM_BCAST_SPE_AVAILABLE_NR_OF_REC_ID_STR;
#define SIZE_SIM_SB_AM_BCAST_SPE_AVAILABLE_NR_OF_REC_ID       sizeof(SIM_SB_AM_BCAST_SPE_AVAILABLE_NR_OF_REC_ID_STR)


//Definition for struct SIM_SB_AM_BCAST_REC_CONTENT_DESCRIPTION_ID
#define SIM_SB_AM_BCAST_REC_CONTENT_DESCRIPTION_ID            0x0225                                                   
typedef struct
            { 
             uint16_t     subblockid;
             uint16_t     subblocklength;
             uint8_t      status;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      numofsb;
            } __attribute__((packed)) SIM_SB_AM_BCAST_REC_CONTENT_DESCRIPTION_ID_STR;
#define SIZE_SIM_SB_AM_BCAST_REC_CONTENT_DESCRIPTION_ID       sizeof(SIM_SB_AM_BCAST_REC_CONTENT_DESCRIPTION_ID_STR)


//MESSAGES


//Definition for struct SIM_PIN_VERIFY_REQ
#define SIM_PIN_VERIFY_REQ                                    0x01                                                     
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      applicationnumber;
             uint8_t      code[9];
            } __attribute__((packed)) SIM_PIN_VERIFY_REQ_STR;
#define SIZE_SIM_PIN_VERIFY_REQ                               sizeof(SIM_PIN_VERIFY_REQ_STR)


//Definition for struct SIM_PIN_VERIFY_RESP
#define SIM_PIN_VERIFY_RESP                                   0x02                                                     
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
            } __attribute__((packed)) SIM_PIN_VERIFY_RESP_STR;
#define SIZE_SIM_PIN_VERIFY_RESP                              sizeof(SIM_PIN_VERIFY_RESP_STR)


//Definition for struct SIM_PIN_CHANGE_REQ
#define SIM_PIN_CHANGE_REQ                                    0x03                                                     
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      applicationnumber;
             uint8_t      oldcode[9];
             uint8_t      newcode[9];
            } __attribute__((packed)) SIM_PIN_CHANGE_REQ_STR;
#define SIZE_SIM_PIN_CHANGE_REQ                               sizeof(SIM_PIN_CHANGE_REQ_STR)


//Definition for struct SIM_PIN_CHANGE_RESP
#define SIM_PIN_CHANGE_RESP                                   0x04                                                     
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
            } __attribute__((packed)) SIM_PIN_CHANGE_RESP_STR;
#define SIZE_SIM_PIN_CHANGE_RESP                              sizeof(SIM_PIN_CHANGE_RESP_STR)


//Definition for struct SIM_PIN_ENABLE_REQ


//Definition for struct SIM_PIN_ENABLE_REQ_SIM_ST_PIN
#define SIM_PIN_ENABLE_REQ_SIM_ST_PIN                         0x05                                                     
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      applicationnumber;
             uint8_t      enable;
             uint8_t      code[9];
            } __attribute__((packed)) SIM_PIN_ENABLE_REQ_SIM_ST_PIN_STR;
#define SIZE_SIM_PIN_ENABLE_REQ_SIM_ST_PIN                    sizeof(SIM_PIN_ENABLE_REQ_SIM_ST_PIN_STR)


//Definition for struct SIM_PIN_ENABLE_REQ


//Definition for struct SIM_PIN_ENABLE_REQ_SIM_ST_PIN_UNIVERSAL
#define SIM_PIN_ENABLE_REQ_SIM_ST_PIN_UNIVERSAL               0x05                                                     
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      applicationnumber;
             uint8_t      enable;
             uint8_t      code[9];
            } __attribute__((packed)) SIM_PIN_ENABLE_REQ_SIM_ST_PIN_UNIVERSAL_STR;
#define SIZE_SIM_PIN_ENABLE_REQ_SIM_ST_PIN_UNIVERSAL          sizeof(SIM_PIN_ENABLE_REQ_SIM_ST_PIN_UNIVERSAL_STR)


//Definition for struct SIM_PIN_ENABLE_REQ


//Definition for struct SIM_PIN_ENABLE_REQ_SIM_ST_PIN2
#define SIM_PIN_ENABLE_REQ_SIM_ST_PIN2                        0x05                                                     
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      applicationnumber;
             uint8_t      enable;
             uint8_t      code[9];
            } __attribute__((packed)) SIM_PIN_ENABLE_REQ_SIM_ST_PIN2_STR;
#define SIZE_SIM_PIN_ENABLE_REQ_SIM_ST_PIN2                   sizeof(SIM_PIN_ENABLE_REQ_SIM_ST_PIN2_STR)


//Definition for struct SIM_PIN_ENABLE_REQ


//Definition for struct SIM_PIN_ENABLE_REQ_SIM_ST_PIN_PARENTAL_CONTROL
#define SIM_PIN_ENABLE_REQ_SIM_ST_PIN_PARENTAL_CONTROL        0x05                                                     
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      applicationnumber;
             uint8_t      enable;
             uint8_t      code[9];
            } __attribute__((packed)) SIM_PIN_ENABLE_REQ_SIM_ST_PIN_PARENTAL_CONTROL_STR;
#define SIZE_SIM_PIN_ENABLE_REQ_SIM_ST_PIN_PARENTAL_CONTROL    sizeof(SIM_PIN_ENABLE_REQ_SIM_ST_PIN_PARENTAL_CONTROL_STR)


//Definition for struct SIM_PIN_ENABLE_REQ


//Definition for struct SIM_PIN_ENABLE_REQ_SIM_ST_SUBSTITUTE_PIN
#define SIM_PIN_ENABLE_REQ_SIM_ST_SUBSTITUTE_PIN              0x05                                                     
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      applicationnumber;
             uint8_t      code[9];
            } __attribute__((packed)) SIM_PIN_ENABLE_REQ_SIM_ST_SUBSTITUTE_PIN_STR;
#define SIZE_SIM_PIN_ENABLE_REQ_SIM_ST_SUBSTITUTE_PIN         sizeof(SIM_PIN_ENABLE_REQ_SIM_ST_SUBSTITUTE_PIN_STR)


//Definition for struct SIM_PIN_ENABLE_REQ


//Definition for struct SIM_PIN_ENABLE_REQ_SIM_ST_SUBSTITUTE_PIN_UNIVERSAL
#define SIM_PIN_ENABLE_REQ_SIM_ST_SUBSTITUTE_PIN_UNIVERSAL    0x05                                                     
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      applicationnumber;
             uint8_t      code[9];
            } __attribute__((packed)) SIM_PIN_ENABLE_REQ_SIM_ST_SUBSTITUTE_PIN_UNIVERSAL_STR;
#define SIZE_SIM_PIN_ENABLE_REQ_SIM_ST_SUBSTITUTE_PIN_UNIVERSAL    sizeof(SIM_PIN_ENABLE_REQ_SIM_ST_SUBSTITUTE_PIN_UNIVERSAL_STR)


//Definition for struct SIM_PIN_ENABLE_RESP


//Definition for struct SIM_PIN_ENABLE_RESP_SIM_ST_PIN
#define SIM_PIN_ENABLE_RESP_SIM_ST_PIN                        0x06                                                     
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
            } __attribute__((packed)) SIM_PIN_ENABLE_RESP_SIM_ST_PIN_STR;
#define SIZE_SIM_PIN_ENABLE_RESP_SIM_ST_PIN                   sizeof(SIM_PIN_ENABLE_RESP_SIM_ST_PIN_STR)


//Definition for struct SIM_PIN_ENABLE_RESP


//Definition for struct SIM_PIN_ENABLE_RESP_SIM_ST_PIN_UNIVERSAL
#define SIM_PIN_ENABLE_RESP_SIM_ST_PIN_UNIVERSAL              0x06                                                     
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
            } __attribute__((packed)) SIM_PIN_ENABLE_RESP_SIM_ST_PIN_UNIVERSAL_STR;
#define SIZE_SIM_PIN_ENABLE_RESP_SIM_ST_PIN_UNIVERSAL         sizeof(SIM_PIN_ENABLE_RESP_SIM_ST_PIN_UNIVERSAL_STR)


//Definition for struct SIM_PIN_ENABLE_RESP


//Definition for struct SIM_PIN_ENABLE_RESP_SIM_ST_PIN2
#define SIM_PIN_ENABLE_RESP_SIM_ST_PIN2                       0x06                                                     
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
            } __attribute__((packed)) SIM_PIN_ENABLE_RESP_SIM_ST_PIN2_STR;
#define SIZE_SIM_PIN_ENABLE_RESP_SIM_ST_PIN2                  sizeof(SIM_PIN_ENABLE_RESP_SIM_ST_PIN2_STR)


//Definition for struct SIM_PIN_ENABLE_RESP


//Definition for struct SIM_PIN_ENABLE_RESP_SIM_ST_PIN_PARENTAL_CONTROL
#define SIM_PIN_ENABLE_RESP_SIM_ST_PIN_PARENTAL_CONTROL       0x06                                                     
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
            } __attribute__((packed)) SIM_PIN_ENABLE_RESP_SIM_ST_PIN_PARENTAL_CONTROL_STR;
#define SIZE_SIM_PIN_ENABLE_RESP_SIM_ST_PIN_PARENTAL_CONTROL    sizeof(SIM_PIN_ENABLE_RESP_SIM_ST_PIN_PARENTAL_CONTROL_STR)


//Definition for struct SIM_PIN_ENABLE_RESP


//Definition for struct SIM_PIN_ENABLE_RESP_SIM_ST_SUBSTITUTE_PIN
#define SIM_PIN_ENABLE_RESP_SIM_ST_SUBSTITUTE_PIN             0x06                                                     
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
            } __attribute__((packed)) SIM_PIN_ENABLE_RESP_SIM_ST_SUBSTITUTE_PIN_STR;
#define SIZE_SIM_PIN_ENABLE_RESP_SIM_ST_SUBSTITUTE_PIN        sizeof(SIM_PIN_ENABLE_RESP_SIM_ST_SUBSTITUTE_PIN_STR)


//Definition for struct SIM_PIN_ENABLE_RESP


//Definition for struct SIM_PIN_ENABLE_RESP_SIM_ST_SUBSTITUTE_PIN_UNIVERSAL
#define SIM_PIN_ENABLE_RESP_SIM_ST_SUBSTITUTE_PIN_UNIVERSAL    0x06                                                     
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
            } __attribute__((packed)) SIM_PIN_ENABLE_RESP_SIM_ST_SUBSTITUTE_PIN_UNIVERSAL_STR;
#define SIZE_SIM_PIN_ENABLE_RESP_SIM_ST_SUBSTITUTE_PIN_UNIVERSAL    sizeof(SIM_PIN_ENABLE_RESP_SIM_ST_SUBSTITUTE_PIN_UNIVERSAL_STR)


//Definition for struct SIM_PIN_STATE_GET_REQ


//Definition for struct SIM_PIN_STATE_GET_REQ_SIM_ST_PIN
#define SIM_PIN_STATE_GET_REQ_SIM_ST_PIN                      0x09                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      servicetype;
             uint8_t      applicationnumber;
            } __attribute__((packed)) SIM_PIN_STATE_GET_REQ_SIM_ST_PIN_STR;
#define SIZE_SIM_PIN_STATE_GET_REQ_SIM_ST_PIN                 sizeof(SIM_PIN_STATE_GET_REQ_SIM_ST_PIN_STR)


//Definition for struct SIM_PIN_STATE_GET_REQ


//Definition for struct SIM_PIN_STATE_GET_REQ_SIM_ST_PIN2
#define SIM_PIN_STATE_GET_REQ_SIM_ST_PIN2                     0x09                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      servicetype;
             uint8_t      applicationnumber;
            } __attribute__((packed)) SIM_PIN_STATE_GET_REQ_SIM_ST_PIN2_STR;
#define SIZE_SIM_PIN_STATE_GET_REQ_SIM_ST_PIN2                sizeof(SIM_PIN_STATE_GET_REQ_SIM_ST_PIN2_STR)


//Definition for struct SIM_PIN_STATE_GET_REQ


//Definition for struct SIM_PIN_STATE_GET_REQ_SIM_ST_PIN_UNIVERSAL
#define SIM_PIN_STATE_GET_REQ_SIM_ST_PIN_UNIVERSAL            0x09                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      servicetype;
             uint8_t      applicationnumber;
            } __attribute__((packed)) SIM_PIN_STATE_GET_REQ_SIM_ST_PIN_UNIVERSAL_STR;
#define SIZE_SIM_PIN_STATE_GET_REQ_SIM_ST_PIN_UNIVERSAL       sizeof(SIM_PIN_STATE_GET_REQ_SIM_ST_PIN_UNIVERSAL_STR)


//Definition for struct SIM_PIN_STATE_GET_REQ


//Definition for struct SIM_PIN_STATE_GET_REQ_SIM_ST_PIN_PARENTAL_CONTROL
#define SIM_PIN_STATE_GET_REQ_SIM_ST_PIN_PARENTAL_CONTROL     0x09                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      servicetype;
             uint8_t      applicationnumber;
            } __attribute__((packed)) SIM_PIN_STATE_GET_REQ_SIM_ST_PIN_PARENTAL_CONTROL_STR;
#define SIZE_SIM_PIN_STATE_GET_REQ_SIM_ST_PIN_PARENTAL_CONTROL    sizeof(SIM_PIN_STATE_GET_REQ_SIM_ST_PIN_PARENTAL_CONTROL_STR)


//Definition for struct SIM_PIN_STATE_GET_REQ


//Definition for struct SIM_PIN_STATE_GET_REQ_SIM_ST_GET_ACTIVE_PIN
#define SIM_PIN_STATE_GET_REQ_SIM_ST_GET_ACTIVE_PIN           0x09                                                     
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      applicationnumber;
            } __attribute__((packed)) SIM_PIN_STATE_GET_REQ_SIM_ST_GET_ACTIVE_PIN_STR;
#define SIZE_SIM_PIN_STATE_GET_REQ_SIM_ST_GET_ACTIVE_PIN      sizeof(SIM_PIN_STATE_GET_REQ_SIM_ST_GET_ACTIVE_PIN_STR)


//Definition for struct SIM_PIN_STATE_GET_RESP


//Definition for struct SIM_PIN_STATE_GET_RESP_SIM_ST_PIN
#define SIM_PIN_STATE_GET_RESP_SIM_ST_PIN                     0x0A                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      servicetype;
             uint8_t      status;
            } __attribute__((packed)) SIM_PIN_STATE_GET_RESP_SIM_ST_PIN_STR;
#define SIZE_SIM_PIN_STATE_GET_RESP_SIM_ST_PIN                sizeof(SIM_PIN_STATE_GET_RESP_SIM_ST_PIN_STR)


//Definition for struct SIM_PIN_STATE_GET_RESP


//Definition for struct SIM_PIN_STATE_GET_RESP_SIM_ST_PIN2
#define SIM_PIN_STATE_GET_RESP_SIM_ST_PIN2                    0x0A                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      servicetype;
             uint8_t      status;
            } __attribute__((packed)) SIM_PIN_STATE_GET_RESP_SIM_ST_PIN2_STR;
#define SIZE_SIM_PIN_STATE_GET_RESP_SIM_ST_PIN2               sizeof(SIM_PIN_STATE_GET_RESP_SIM_ST_PIN2_STR)


//Definition for struct SIM_PIN_STATE_GET_RESP


//Definition for struct SIM_PIN_STATE_GET_RESP_SIM_ST_PIN_UNIVERSAL
#define SIM_PIN_STATE_GET_RESP_SIM_ST_PIN_UNIVERSAL           0x0A                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      servicetype;
             uint8_t      status;
            } __attribute__((packed)) SIM_PIN_STATE_GET_RESP_SIM_ST_PIN_UNIVERSAL_STR;
#define SIZE_SIM_PIN_STATE_GET_RESP_SIM_ST_PIN_UNIVERSAL      sizeof(SIM_PIN_STATE_GET_RESP_SIM_ST_PIN_UNIVERSAL_STR)


//Definition for struct SIM_PIN_STATE_GET_RESP


//Definition for struct SIM_PIN_STATE_GET_RESP_SIM_ST_PIN_PARENTAL_CONTROL
#define SIM_PIN_STATE_GET_RESP_SIM_ST_PIN_PARENTAL_CONTROL    0x0A                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      servicetype;
             uint8_t      status;
            } __attribute__((packed)) SIM_PIN_STATE_GET_RESP_SIM_ST_PIN_PARENTAL_CONTROL_STR;
#define SIZE_SIM_PIN_STATE_GET_RESP_SIM_ST_PIN_PARENTAL_CONTROL    sizeof(SIM_PIN_STATE_GET_RESP_SIM_ST_PIN_PARENTAL_CONTROL_STR)


//Definition for struct SIM_PIN_STATE_GET_RESP


//Definition for struct SIM_PIN_STATE_GET_RESP_SIM_ST_GET_ACTIVE_PIN
#define SIM_PIN_STATE_GET_RESP_SIM_ST_GET_ACTIVE_PIN          0x0A                                                     
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
            } __attribute__((packed)) SIM_PIN_STATE_GET_RESP_SIM_ST_GET_ACTIVE_PIN_STR;
#define SIZE_SIM_PIN_STATE_GET_RESP_SIM_ST_GET_ACTIVE_PIN     sizeof(SIM_PIN_STATE_GET_RESP_SIM_ST_GET_ACTIVE_PIN_STR)


//Definition for struct SIM_PIN_UNBLOCK_REQ
#define SIM_PIN_UNBLOCK_REQ                                   0x07                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      service_type;
             uint8_t      applicationnumber;
             UNBLOCK_CODE_STR    unblock_code[0];
            } __attribute__((packed)) SIM_PIN_UNBLOCK_REQ_STR;
#define SIZE_SIM_PIN_UNBLOCK_REQ                              sizeof(SIM_PIN_UNBLOCK_REQ_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct SIM_PIN_UNBLOCK_RESP
#define SIM_PIN_UNBLOCK_RESP                                  0x08                                                     
typedef struct
            { 
             uint8_t      trans_id;
             uint8_t      message_id;
             uint8_t      service_type;
             uint8_t      status;
            } __attribute__((packed)) SIM_PIN_UNBLOCK_RESP_STR;
#define SIZE_SIM_PIN_UNBLOCK_RESP                             sizeof(SIM_PIN_UNBLOCK_RESP_STR)


//Definition for struct SIM_PIN_ATTEMPTS_LEFT_REQ
#define SIM_PIN_ATTEMPTS_LEFT_REQ                             0x73                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      applicationnumber;
            } __attribute__((packed)) SIM_PIN_ATTEMPTS_LEFT_REQ_STR;
#define SIZE_SIM_PIN_ATTEMPTS_LEFT_REQ                        sizeof(SIM_PIN_ATTEMPTS_LEFT_REQ_STR)


//Definition for struct SIM_PIN_ATTEMPTS_LEFT_RESP
#define SIM_PIN_ATTEMPTS_LEFT_RESP                            0x74                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
             uint8_t      remainingattempts;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
            } __attribute__((packed)) SIM_PIN_ATTEMPTS_LEFT_RESP_STR;
#define SIZE_SIM_PIN_ATTEMPTS_LEFT_RESP                       sizeof(SIM_PIN_ATTEMPTS_LEFT_RESP_STR)


//Definition for struct SIM_AUTHENTICATION_REQ
#define SIM_AUTHENTICATION_REQ                                0xD8                                                  
typedef struct
            { 
             uint8_t      transactionid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      noofsubblocks;
            } __attribute__((packed)) SIM_AUTHENTICATION_REQ_STR;
#define SIZE_SIM_AUTHENTICATION_REQ                           sizeof(SIM_AUTHENTICATION_REQ_STR)


//Definition for struct SIM_AUTHENTICATION_RESP
#define SIM_AUTHENTICATION_RESP                               0xD9                                                  
typedef struct
            { 
             uint8_t      transactionid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
             uint8_t      noofsubblocks;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
            } __attribute__((packed)) SIM_AUTHENTICATION_RESP_STR;
#define SIZE_SIM_AUTHENTICATION_RESP                          sizeof(SIM_AUTHENTICATION_RESP_STR)


//Definition for struct SIM_CS_READ_REQ


//Definition for struct SIM_CS_READ_REQ_SIM_ST_CS_DATA_READ_REQ
#define SIM_CS_READ_REQ_SIM_ST_CS_DATA_READ_REQ               0xD4                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      numberofsubblocks;
            } __attribute__((packed)) SIM_CS_READ_REQ_SIM_ST_CS_DATA_READ_REQ_STR;
#define SIZE_SIM_CS_READ_REQ_SIM_ST_CS_DATA_READ_REQ          sizeof(SIM_CS_READ_REQ_SIM_ST_CS_DATA_READ_REQ_STR)


//Definition for struct SIM_CS_READ_REQ


//Definition for struct SIM_CS_READ_REQ_SIM_ST_CS_DATA_READ_ALL_REQ
#define SIM_CS_READ_REQ_SIM_ST_CS_DATA_READ_ALL_REQ           0xD4                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      numberofsubblocks;
            } __attribute__((packed)) SIM_CS_READ_REQ_SIM_ST_CS_DATA_READ_ALL_REQ_STR;
#define SIZE_SIM_CS_READ_REQ_SIM_ST_CS_DATA_READ_ALL_REQ      sizeof(SIM_CS_READ_REQ_SIM_ST_CS_DATA_READ_ALL_REQ_STR)


//Definition for struct SIM_CS_READ_REQ


//Definition for struct SIM_CS_READ_REQ_SIM_ST_CS_DATA_READ_ALL_GSS_REQ
#define SIM_CS_READ_REQ_SIM_ST_CS_DATA_READ_ALL_GSS_REQ       0xD4                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      numberofsubblocks;
            } __attribute__((packed)) SIM_CS_READ_REQ_SIM_ST_CS_DATA_READ_ALL_GSS_REQ_STR;
#define SIZE_SIM_CS_READ_REQ_SIM_ST_CS_DATA_READ_ALL_GSS_REQ    sizeof(SIM_CS_READ_REQ_SIM_ST_CS_DATA_READ_ALL_GSS_REQ_STR)


//Definition for struct SIM_CS_READ_REQ


//Definition for struct SIM_CS_READ_REQ_SIM_ST_CS_STATUS_REQ
#define SIM_CS_READ_REQ_SIM_ST_CS_STATUS_REQ                  0xD4                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) SIM_CS_READ_REQ_SIM_ST_CS_STATUS_REQ_STR;
#define SIZE_SIM_CS_READ_REQ_SIM_ST_CS_STATUS_REQ             sizeof(SIM_CS_READ_REQ_SIM_ST_CS_STATUS_REQ_STR)


//Definition for struct SIM_CS_READ_RESP


//Definition for struct SIM_CS_READ_RESP_SIM_ST_CS_DATA_READ_REQ
#define SIM_CS_READ_RESP_SIM_ST_CS_DATA_READ_REQ              0xD5                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
             uint8_t      numberofsubblocks;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
            } __attribute__((packed)) SIM_CS_READ_RESP_SIM_ST_CS_DATA_READ_REQ_STR;
#define SIZE_SIM_CS_READ_RESP_SIM_ST_CS_DATA_READ_REQ         sizeof(SIM_CS_READ_RESP_SIM_ST_CS_DATA_READ_REQ_STR)


//Definition for struct SIM_CS_READ_RESP


//Definition for struct SIM_CS_READ_RESP_SIM_ST_CS_DATA_READ_ALL_REQ
#define SIM_CS_READ_RESP_SIM_ST_CS_DATA_READ_ALL_REQ          0xD5                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
             uint8_t      numberofsubblocks;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
            } __attribute__((packed)) SIM_CS_READ_RESP_SIM_ST_CS_DATA_READ_ALL_REQ_STR;
#define SIZE_SIM_CS_READ_RESP_SIM_ST_CS_DATA_READ_ALL_REQ     sizeof(SIM_CS_READ_RESP_SIM_ST_CS_DATA_READ_ALL_REQ_STR)


//Definition for struct SIM_CS_READ_RESP


//Definition for struct SIM_CS_READ_RESP_SIM_ST_CS_DATA_READ_ALL_GSS_REQ
#define SIM_CS_READ_RESP_SIM_ST_CS_DATA_READ_ALL_GSS_REQ      0xD5                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
             uint8_t      numberofsubblocks;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
            } __attribute__((packed)) SIM_CS_READ_RESP_SIM_ST_CS_DATA_READ_ALL_GSS_REQ_STR;
#define SIZE_SIM_CS_READ_RESP_SIM_ST_CS_DATA_READ_ALL_GSS_REQ    sizeof(SIM_CS_READ_RESP_SIM_ST_CS_DATA_READ_ALL_GSS_REQ_STR)


//Definition for struct SIM_CS_READ_RESP


//Definition for struct SIM_CS_READ_RESP_SIM_ST_CS_STATUS_REQ
#define SIM_CS_READ_RESP_SIM_ST_CS_STATUS_REQ                 0xD5                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
            } __attribute__((packed)) SIM_CS_READ_RESP_SIM_ST_CS_STATUS_REQ_STR;
#define SIZE_SIM_CS_READ_RESP_SIM_ST_CS_STATUS_REQ            sizeof(SIM_CS_READ_RESP_SIM_ST_CS_STATUS_REQ_STR)


//Definition for struct SIM_CS_WRITE_REQ


//Definition for struct SIM_CS_WRITE_REQ_SIM_ST_CS_DATA_WRITE_REQ
#define SIM_CS_WRITE_REQ_SIM_ST_CS_DATA_WRITE_REQ             0xD6                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      numberofsubblocks;
            } __attribute__((packed)) SIM_CS_WRITE_REQ_SIM_ST_CS_DATA_WRITE_REQ_STR;
#define SIZE_SIM_CS_WRITE_REQ_SIM_ST_CS_DATA_WRITE_REQ        sizeof(SIM_CS_WRITE_REQ_SIM_ST_CS_DATA_WRITE_REQ_STR)


//Definition for struct SIM_CS_WRITE_RESP


//Definition for struct SIM_CS_WRITE_RESP_SIM_ST_CS_DATA_WRITE_REQ
#define SIM_CS_WRITE_RESP_SIM_ST_CS_DATA_WRITE_REQ            0xD7                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
             uint8_t      numberofsubblocks;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
             SIM_SB_CS_WRITE_RESP_SB_STR    sub_blocks[0];
            } __attribute__((packed)) SIM_CS_WRITE_RESP_SIM_ST_CS_DATA_WRITE_REQ_STR;
#define SIZE_SIM_CS_WRITE_RESP_SIM_ST_CS_DATA_WRITE_REQ       sizeof(SIM_CS_WRITE_RESP_SIM_ST_CS_DATA_WRITE_REQ_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct SIM_READ_FIELD_REQ


//Definition for struct SIM_READ_FIELD_REQ_READ_FIELD
#define SIM_READ_FIELD_REQ_READ_FIELD                         0xBA                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      fillerbyte1;
             uint16_t     length;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
             uint8_t      fileid[8];
             uint16_t     offset;
             uint8_t      fillerbyte4;
             uint8_t      fillerbyte5;
            } __attribute__((packed)) SIM_READ_FIELD_REQ_READ_FIELD_STR;
#define SIZE_SIM_READ_FIELD_REQ_READ_FIELD                    sizeof(SIM_READ_FIELD_REQ_READ_FIELD_STR)


//Definition for struct SIM_READ_FIELD_REQ


//Definition for struct SIM_READ_FIELD_REQ_ACC
#define SIM_READ_FIELD_REQ_ACC                                0xBA                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) SIM_READ_FIELD_REQ_ACC_STR;
#define SIZE_SIM_READ_FIELD_REQ_ACC                           sizeof(SIM_READ_FIELD_REQ_ACC_STR)


//Definition for struct SIM_READ_FIELD_REQ


//Definition for struct SIM_READ_FIELD_REQ_ICC
#define SIM_READ_FIELD_REQ_ICC                                0xBA                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) SIM_READ_FIELD_REQ_ICC_STR;
#define SIZE_SIM_READ_FIELD_REQ_ICC                           sizeof(SIM_READ_FIELD_REQ_ICC_STR)


//Definition for struct SIM_READ_FIELD_REQ


//Definition for struct SIM_READ_FIELD_REQ_AD
#define SIM_READ_FIELD_REQ_AD                                 0xBA                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) SIM_READ_FIELD_REQ_AD_STR;
#define SIZE_SIM_READ_FIELD_REQ_AD                            sizeof(SIM_READ_FIELD_REQ_AD_STR)


//Definition for struct SIM_READ_FIELD_RESP


//Definition for struct SIM_READ_FIELD_RESP_READ_FIELD
#define SIM_READ_FIELD_RESP_READ_FIELD                        0xBB                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint16_t     length;
             uint8_t      data[0];
            } __attribute__((packed)) SIM_READ_FIELD_RESP_READ_FIELD_STR;
#define SIZE_SIM_READ_FIELD_RESP_READ_FIELD                   sizeof(SIM_READ_FIELD_RESP_READ_FIELD_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct SIM_READ_FIELD_RESP


//Definition for struct SIM_READ_FIELD_RESP_ACC
#define SIM_READ_FIELD_RESP_ACC                               0xBB                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
             uint16_t     acc;
            } __attribute__((packed)) SIM_READ_FIELD_RESP_ACC_STR;
#define SIZE_SIM_READ_FIELD_RESP_ACC                          sizeof(SIM_READ_FIELD_RESP_ACC_STR)


//Definition for struct SIM_READ_FIELD_RESP


//Definition for struct SIM_READ_FIELD_RESP_ICC
#define SIM_READ_FIELD_RESP_ICC                               0xBB                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
             SIM_ICC_STR    icc[0];
            } __attribute__((packed)) SIM_READ_FIELD_RESP_ICC_STR;
#define SIZE_SIM_READ_FIELD_RESP_ICC                          sizeof(SIM_READ_FIELD_RESP_ICC_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct SIM_READ_FIELD_RESP


//Definition for struct SIM_READ_FIELD_RESP_AD
#define SIM_READ_FIELD_RESP_AD                                0xBB                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
             SIM_SERV_CARD_TYPE_STR    cardtype[0];
            } __attribute__((packed)) SIM_READ_FIELD_RESP_AD_STR;
#define SIZE_SIM_READ_FIELD_RESP_AD                           sizeof(SIM_READ_FIELD_RESP_AD_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct SIM_DATA_SIZES_REQ
#define SIM_DATA_SIZES_REQ                                    0x23                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
            } __attribute__((packed)) SIM_DATA_SIZES_REQ_STR;
#define SIZE_SIM_DATA_SIZES_REQ                               sizeof(SIM_DATA_SIZES_REQ_STR)


//Definition for struct SIM_DATA_SIZES_RESP
#define SIM_DATA_SIZES_RESP                                   0x24                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
             uint8_t      datasize;
            } __attribute__((packed)) SIM_DATA_SIZES_RESP_STR;
#define SIZE_SIM_DATA_SIZES_RESP                              sizeof(SIM_DATA_SIZES_RESP_STR)


//Definition for struct SIM_PREF_LANGUAGE_REQ


//Definition for struct SIM_PREF_LANGUAGE_REQ_SIM_ST_READ_PL_LANGUAGE
#define SIM_PREF_LANGUAGE_REQ_SIM_ST_READ_PL_LANGUAGE         0x1F                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) SIM_PREF_LANGUAGE_REQ_SIM_ST_READ_PL_LANGUAGE_STR;
#define SIZE_SIM_PREF_LANGUAGE_REQ_SIM_ST_READ_PL_LANGUAGE    sizeof(SIM_PREF_LANGUAGE_REQ_SIM_ST_READ_PL_LANGUAGE_STR)


//Definition for struct SIM_PREF_LANGUAGE_REQ


//Definition for struct SIM_PREF_LANGUAGE_REQ_SIM_ST_READ_LI_LANGUAGE
#define SIM_PREF_LANGUAGE_REQ_SIM_ST_READ_LI_LANGUAGE         0x1F                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) SIM_PREF_LANGUAGE_REQ_SIM_ST_READ_LI_LANGUAGE_STR;
#define SIZE_SIM_PREF_LANGUAGE_REQ_SIM_ST_READ_LI_LANGUAGE    sizeof(SIM_PREF_LANGUAGE_REQ_SIM_ST_READ_LI_LANGUAGE_STR)


//Definition for struct SIM_PREF_LANGUAGE_REQ


//Definition for struct SIM_PREF_LANGUAGE_REQ_SIM_ST_WRITE_PL_LANGUAGE
#define SIM_PREF_LANGUAGE_REQ_SIM_ST_WRITE_PL_LANGUAGE        0x1F                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      count;
             uint8_t      languages;
            } __attribute__((packed)) SIM_PREF_LANGUAGE_REQ_SIM_ST_WRITE_PL_LANGUAGE_STR;
#define SIZE_SIM_PREF_LANGUAGE_REQ_SIM_ST_WRITE_PL_LANGUAGE    sizeof(SIM_PREF_LANGUAGE_REQ_SIM_ST_WRITE_PL_LANGUAGE_STR)


//Definition for struct SIM_PREF_LANGUAGE_REQ


//Definition for struct SIM_PREF_LANGUAGE_REQ_SIM_ST_WRITE_LI_LANGUAGE
#define SIM_PREF_LANGUAGE_REQ_SIM_ST_WRITE_LI_LANGUAGE        0x1F                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      count;
             uint8_t      languages;
            } __attribute__((packed)) SIM_PREF_LANGUAGE_REQ_SIM_ST_WRITE_LI_LANGUAGE_STR;
#define SIZE_SIM_PREF_LANGUAGE_REQ_SIM_ST_WRITE_LI_LANGUAGE    sizeof(SIM_PREF_LANGUAGE_REQ_SIM_ST_WRITE_LI_LANGUAGE_STR)


//Definition for struct SIM_PREF_LANGUAGE_REQ


//Definition for struct SIM_PREF_LANGUAGE_REQ_READ_PREF_LANGUAGE
#define SIM_PREF_LANGUAGE_REQ_READ_PREF_LANGUAGE              0x1F                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) SIM_PREF_LANGUAGE_REQ_READ_PREF_LANGUAGE_STR;
#define SIZE_SIM_PREF_LANGUAGE_REQ_READ_PREF_LANGUAGE         sizeof(SIM_PREF_LANGUAGE_REQ_READ_PREF_LANGUAGE_STR)


//Definition for struct SIM_PREF_LANGUAGE_RESP


//Definition for struct SIM_PREF_LANGUAGE_RESP_SIM_ST_READ_PL_LANGUAGE
#define SIM_PREF_LANGUAGE_RESP_SIM_ST_READ_PL_LANGUAGE        0x20                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
             uint8_t      count;
             uint8_t      languages[0];
            } __attribute__((packed)) SIM_PREF_LANGUAGE_RESP_SIM_ST_READ_PL_LANGUAGE_STR;
#define SIZE_SIM_PREF_LANGUAGE_RESP_SIM_ST_READ_PL_LANGUAGE    sizeof(SIM_PREF_LANGUAGE_RESP_SIM_ST_READ_PL_LANGUAGE_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct SIM_PREF_LANGUAGE_RESP


//Definition for struct SIM_PREF_LANGUAGE_RESP_SIM_ST_READ_LI_LANGUAGE
#define SIM_PREF_LANGUAGE_RESP_SIM_ST_READ_LI_LANGUAGE        0x20                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
             uint8_t      count;
             uint8_t      languages[0];
            } __attribute__((packed)) SIM_PREF_LANGUAGE_RESP_SIM_ST_READ_LI_LANGUAGE_STR;
#define SIZE_SIM_PREF_LANGUAGE_RESP_SIM_ST_READ_LI_LANGUAGE    sizeof(SIM_PREF_LANGUAGE_RESP_SIM_ST_READ_LI_LANGUAGE_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct SIM_PREF_LANGUAGE_RESP


//Definition for struct SIM_PREF_LANGUAGE_RESP_SIM_ST_WRITE_PL_LANGUAGE
#define SIM_PREF_LANGUAGE_RESP_SIM_ST_WRITE_PL_LANGUAGE       0x20                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
            } __attribute__((packed)) SIM_PREF_LANGUAGE_RESP_SIM_ST_WRITE_PL_LANGUAGE_STR;
#define SIZE_SIM_PREF_LANGUAGE_RESP_SIM_ST_WRITE_PL_LANGUAGE    sizeof(SIM_PREF_LANGUAGE_RESP_SIM_ST_WRITE_PL_LANGUAGE_STR)


//Definition for struct SIM_PREF_LANGUAGE_RESP


//Definition for struct SIM_PREF_LANGUAGE_RESP_SIM_ST_WRITE_LI_LANGUAGE
#define SIM_PREF_LANGUAGE_RESP_SIM_ST_WRITE_LI_LANGUAGE       0x20                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
            } __attribute__((packed)) SIM_PREF_LANGUAGE_RESP_SIM_ST_WRITE_LI_LANGUAGE_STR;
#define SIZE_SIM_PREF_LANGUAGE_RESP_SIM_ST_WRITE_LI_LANGUAGE    sizeof(SIM_PREF_LANGUAGE_RESP_SIM_ST_WRITE_LI_LANGUAGE_STR)


//Definition for struct SIM_PREF_LANGUAGE_RESP


//Definition for struct SIM_PREF_LANGUAGE_RESP_READ_PREF_LANGUAGE
#define SIM_PREF_LANGUAGE_RESP_READ_PREF_LANGUAGE             0x20                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
             uint8_t      count;
             uint32_t     languagetable;
            } __attribute__((packed)) SIM_PREF_LANGUAGE_RESP_READ_PREF_LANGUAGE_STR;
#define SIZE_SIM_PREF_LANGUAGE_RESP_READ_PREF_LANGUAGE        sizeof(SIM_PREF_LANGUAGE_RESP_READ_PREF_LANGUAGE_STR)


//Definition for struct SIM_STATUS_REQ


//Definition for struct SIM_STATUS_REQ_SIM_ST_CARD_STATUS
#define SIM_STATUS_REQ_SIM_ST_CARD_STATUS                     0xC0                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
            } __attribute__((packed)) SIM_STATUS_REQ_SIM_ST_CARD_STATUS_STR;
#define SIZE_SIM_STATUS_REQ_SIM_ST_CARD_STATUS                sizeof(SIM_STATUS_REQ_SIM_ST_CARD_STATUS_STR)


//Definition for struct SIM_STATUS_REQ


//Definition for struct SIM_STATUS_REQ_SIM_ST_SIMLOCK_STATUS
#define SIM_STATUS_REQ_SIM_ST_SIMLOCK_STATUS                  0xC0                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
            } __attribute__((packed)) SIM_STATUS_REQ_SIM_ST_SIMLOCK_STATUS_STR;
#define SIZE_SIM_STATUS_REQ_SIM_ST_SIMLOCK_STATUS             sizeof(SIM_STATUS_REQ_SIM_ST_SIMLOCK_STATUS_STR)


//Definition for struct SIM_STATUS_RESP


//Definition for struct SIM_STATUS_RESP_SIM_ST_CARD_STATUS
#define SIM_STATUS_RESP_SIM_ST_CARD_STATUS                    0xC1                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
             uint8_t      cardtyperead;
             uint8_t      cardtype;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) SIM_STATUS_RESP_SIM_ST_CARD_STATUS_STR;
#define SIZE_SIM_STATUS_RESP_SIM_ST_CARD_STATUS               sizeof(SIM_STATUS_RESP_SIM_ST_CARD_STATUS_STR)


//Definition for struct SIM_STATUS_RESP


//Definition for struct SIM_STATUS_RESP_SIM_ST_SIMLOCK_STATUS
#define SIM_STATUS_RESP_SIM_ST_SIMLOCK_STATUS                 0xC1                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
            } __attribute__((packed)) SIM_STATUS_RESP_SIM_ST_SIMLOCK_STATUS_STR;
#define SIZE_SIM_STATUS_RESP_SIM_ST_SIMLOCK_STATUS            sizeof(SIM_STATUS_RESP_SIM_ST_SIMLOCK_STATUS_STR)


//Definition for struct SIM_IMSI_REQ


//Definition for struct SIM_IMSI_REQ_READ_IMSI
#define SIM_IMSI_REQ_READ_IMSI                                0x1D                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) SIM_IMSI_REQ_READ_IMSI_STR;
#define SIZE_SIM_IMSI_REQ_READ_IMSI                           sizeof(SIM_IMSI_REQ_READ_IMSI_STR)


//Definition for struct SIM_IMSI_RESP


//Definition for struct SIM_IMSI_RESP_READ_IMSI
#define SIM_IMSI_RESP_READ_IMSI                               0x1E                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
             SIM_RESP_IMSI_STR    imsi[0];
            } __attribute__((packed)) SIM_IMSI_RESP_READ_IMSI_STR;
#define SIZE_SIM_IMSI_RESP_READ_IMSI                          sizeof(SIM_IMSI_RESP_READ_IMSI_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct SIM_IMSI_EQUAL_REQ


//Definition for struct SIM_IMSI_EQUAL_REQ_NO_SERVICE_TYPE
#define SIM_IMSI_EQUAL_REQ_NO_SERVICE_TYPE                    0x3B                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) SIM_IMSI_EQUAL_REQ_NO_SERVICE_TYPE_STR;
#define SIZE_SIM_IMSI_EQUAL_REQ_NO_SERVICE_TYPE               sizeof(SIM_IMSI_EQUAL_REQ_NO_SERVICE_TYPE_STR)


//Definition for struct SIM_IMSI_EQUAL_REQ


//Definition for struct SIM_IMSI_EQUAL_REQ_ICC_EQUAL
#define SIM_IMSI_EQUAL_REQ_ICC_EQUAL                          0x3B                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) SIM_IMSI_EQUAL_REQ_ICC_EQUAL_STR;
#define SIZE_SIM_IMSI_EQUAL_REQ_ICC_EQUAL                     sizeof(SIM_IMSI_EQUAL_REQ_ICC_EQUAL_STR)


//Definition for struct SIM_IMSI_EQUAL_RESP


//Definition for struct SIM_IMSI_EQUAL_RESP_NO_SERVICE_TYPE
#define SIM_IMSI_EQUAL_RESP_NO_SERVICE_TYPE                   0x3C                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
            } __attribute__((packed)) SIM_IMSI_EQUAL_RESP_NO_SERVICE_TYPE_STR;
#define SIZE_SIM_IMSI_EQUAL_RESP_NO_SERVICE_TYPE              sizeof(SIM_IMSI_EQUAL_RESP_NO_SERVICE_TYPE_STR)


//Definition for struct SIM_IMSI_EQUAL_RESP


//Definition for struct SIM_IMSI_EQUAL_RESP_ICC_EQUAL
#define SIM_IMSI_EQUAL_RESP_ICC_EQUAL                         0x3C                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
            } __attribute__((packed)) SIM_IMSI_EQUAL_RESP_ICC_EQUAL_STR;
#define SIZE_SIM_IMSI_EQUAL_RESP_ICC_EQUAL                    sizeof(SIM_IMSI_EQUAL_RESP_ICC_EQUAL_STR)


//Definition for struct SIM_SMS_REQ


//Definition for struct SIM_SMS_REQ_READ_PARAMETER
#define SIM_SMS_REQ_READ_PARAMETER                            0xBC                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      locationnumber;
            } __attribute__((packed)) SIM_SMS_REQ_READ_PARAMETER_STR;
#define SIZE_SIM_SMS_REQ_READ_PARAMETER                       sizeof(SIM_SMS_REQ_READ_PARAMETER_STR)


//Definition for struct SIM_SMS_REQ


//Definition for struct SIM_SMS_REQ_UPDATE_PARAMETER
#define SIM_SMS_REQ_UPDATE_PARAMETER                          0xBC                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      locationnumber;
             uint8_t      parametersindicators;
             uint8_t      protocolid;
             uint8_t      datacodingscheme;
             uint8_t      validityperiod;
             uint8_t      destinationaddress[12];
             uint8_t      servicecenteraddress[12];
             uint8_t      length;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
             uint8_t      alphatag[34];
            } __attribute__((packed)) SIM_SMS_REQ_UPDATE_PARAMETER_STR;
#define SIZE_SIM_SMS_REQ_UPDATE_PARAMETER                     sizeof(SIM_SMS_REQ_UPDATE_PARAMETER_STR)


//Definition for struct SIM_SMS_REQ


//Definition for struct SIM_SMS_REQ_READ_STATUS
#define SIM_SMS_REQ_READ_STATUS                               0xBC                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) SIM_SMS_REQ_READ_STATUS_STR;
#define SIZE_SIM_SMS_REQ_READ_STATUS                          sizeof(SIM_SMS_REQ_READ_STATUS_STR)


//Definition for struct SIM_SMS_REQ


//Definition for struct SIM_SMS_REQ_WRITE_STATUS
#define SIM_SMS_REQ_WRITE_STATUS                              0xBC                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      messagereference;
             uint8_t      messagecapacityexceeded;
            } __attribute__((packed)) SIM_SMS_REQ_WRITE_STATUS_STR;
#define SIZE_SIM_SMS_REQ_WRITE_STATUS                         sizeof(SIM_SMS_REQ_WRITE_STATUS_STR)


//Definition for struct SIM_SMS_REQ


//Definition for struct SIM_SMS_REQ_SIM_ST_SMS_GET_NUM_OF_LOC
#define SIM_SMS_REQ_SIM_ST_SMS_GET_NUM_OF_LOC                 0xBC                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) SIM_SMS_REQ_SIM_ST_SMS_GET_NUM_OF_LOC_STR;
#define SIZE_SIM_SMS_REQ_SIM_ST_SMS_GET_NUM_OF_LOC            sizeof(SIM_SMS_REQ_SIM_ST_SMS_GET_NUM_OF_LOC_STR)


//Definition for struct SIM_SMS_REQ


//Definition for struct SIM_SMS_REQ_SIM_ST_SMS_READ
#define SIM_SMS_REQ_SIM_ST_SMS_READ                           0xBC                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      location;
            } __attribute__((packed)) SIM_SMS_REQ_SIM_ST_SMS_READ_STR;
#define SIZE_SIM_SMS_REQ_SIM_ST_SMS_READ                      sizeof(SIM_SMS_REQ_SIM_ST_SMS_READ_STR)


//Definition for struct SIM_SMS_REQ


//Definition for struct SIM_SMS_REQ_SIM_ST_SMS_WRITE
#define SIM_SMS_REQ_SIM_ST_SMS_WRITE                          0xBC                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      location;
             uint8_t      storagestatus;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      numofsubblocks;
            } __attribute__((packed)) SIM_SMS_REQ_SIM_ST_SMS_WRITE_STR;
#define SIZE_SIM_SMS_REQ_SIM_ST_SMS_WRITE                     sizeof(SIM_SMS_REQ_SIM_ST_SMS_WRITE_STR)


//Definition for struct SIM_SMS_REQ


//Definition for struct SIM_SMS_REQ_SIM_ST_SMS_ERASE
#define SIM_SMS_REQ_SIM_ST_SMS_ERASE                          0xBC                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      location;
            } __attribute__((packed)) SIM_SMS_REQ_SIM_ST_SMS_ERASE_STR;
#define SIZE_SIM_SMS_REQ_SIM_ST_SMS_ERASE                     sizeof(SIM_SMS_REQ_SIM_ST_SMS_ERASE_STR)


//Definition for struct SIM_SMS_REQ


//Definition for struct SIM_SMS_REQ_SIM_ST_SMS_UPDATE_STATUS
#define SIM_SMS_REQ_SIM_ST_SMS_UPDATE_STATUS                  0xBC                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      location;
             uint8_t      storagestatus;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
            } __attribute__((packed)) SIM_SMS_REQ_SIM_ST_SMS_UPDATE_STATUS_STR;
#define SIZE_SIM_SMS_REQ_SIM_ST_SMS_UPDATE_STATUS             sizeof(SIM_SMS_REQ_SIM_ST_SMS_UPDATE_STATUS_STR)


//Definition for struct SIM_SMS_REQ


//Definition for struct SIM_SMS_REQ_SIM_ST_SMS_READ_RAW
#define SIM_SMS_REQ_SIM_ST_SMS_READ_RAW                       0xBC                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      location;
            } __attribute__((packed)) SIM_SMS_REQ_SIM_ST_SMS_READ_RAW_STR;
#define SIZE_SIM_SMS_REQ_SIM_ST_SMS_READ_RAW                  sizeof(SIM_SMS_REQ_SIM_ST_SMS_READ_RAW_STR)


//Definition for struct SIM_SMS_REQ


//Definition for struct SIM_SMS_REQ_SIM_ST_SMS_WRITE_RAW
#define SIM_SMS_REQ_SIM_ST_SMS_WRITE_RAW                      0xBC                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      location;
             uint8_t      storagestatus;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      datalength;
             uint8_t      data[0];
            } __attribute__((packed)) SIM_SMS_REQ_SIM_ST_SMS_WRITE_RAW_STR;
#define SIZE_SIM_SMS_REQ_SIM_ST_SMS_WRITE_RAW                 sizeof(SIM_SMS_REQ_SIM_ST_SMS_WRITE_RAW_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct SIM_SMS_RESP


//Definition for struct SIM_SMS_RESP_READ_PARAMETER
#define SIM_SMS_RESP_READ_PARAMETER                           0xBD                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
             uint8_t      locationnumber;
             uint8_t      parametersindicators;
             uint8_t      protocolid;
             uint8_t      datacodingscheme;
             uint8_t      destinationaddress[12];
             uint8_t      servicecenteraddress[12];
             uint8_t      validityperiod;
             uint8_t      length;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      alphatag[34];
            } __attribute__((packed)) SIM_SMS_RESP_READ_PARAMETER_STR;
#define SIZE_SIM_SMS_RESP_READ_PARAMETER                      sizeof(SIM_SMS_RESP_READ_PARAMETER_STR)


//Definition for struct SIM_SMS_RESP


//Definition for struct SIM_SMS_RESP_UPDATE_PARAMETER
#define SIM_SMS_RESP_UPDATE_PARAMETER                         0xBD                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
            } __attribute__((packed)) SIM_SMS_RESP_UPDATE_PARAMETER_STR;
#define SIZE_SIM_SMS_RESP_UPDATE_PARAMETER                    sizeof(SIM_SMS_RESP_UPDATE_PARAMETER_STR)


//Definition for struct SIM_SMS_RESP


//Definition for struct SIM_SMS_RESP_READ_STATUS
#define SIM_SMS_RESP_READ_STATUS                              0xBD                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
             uint8_t      messagereference;
             uint8_t      messagecapacityexceeded;
            } __attribute__((packed)) SIM_SMS_RESP_READ_STATUS_STR;
#define SIZE_SIM_SMS_RESP_READ_STATUS                         sizeof(SIM_SMS_RESP_READ_STATUS_STR)


//Definition for struct SIM_SMS_RESP


//Definition for struct SIM_SMS_RESP_WRITE_STATUS
#define SIM_SMS_RESP_WRITE_STATUS                             0xBD                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
            } __attribute__((packed)) SIM_SMS_RESP_WRITE_STATUS_STR;
#define SIZE_SIM_SMS_RESP_WRITE_STATUS                        sizeof(SIM_SMS_RESP_WRITE_STATUS_STR)


//Definition for struct SIM_SMS_RESP


//Definition for struct SIM_SMS_RESP_SIM_ST_SMS_GET_NUM_OF_LOC
#define SIM_SMS_RESP_SIM_ST_SMS_GET_NUM_OF_LOC                0xBD                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
             uint8_t      numofloc;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
            } __attribute__((packed)) SIM_SMS_RESP_SIM_ST_SMS_GET_NUM_OF_LOC_STR;
#define SIZE_SIM_SMS_RESP_SIM_ST_SMS_GET_NUM_OF_LOC           sizeof(SIM_SMS_RESP_SIM_ST_SMS_GET_NUM_OF_LOC_STR)


//Definition for struct SIM_SMS_RESP


//Definition for struct SIM_SMS_RESP_SIM_ST_SMS_READ
#define SIM_SMS_RESP_SIM_ST_SMS_READ                          0xBD                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
             uint8_t      location;
             uint8_t      storagestatus;
             uint8_t      fillerbyte1;
             uint8_t      numofsubblocks;
            } __attribute__((packed)) SIM_SMS_RESP_SIM_ST_SMS_READ_STR;
#define SIZE_SIM_SMS_RESP_SIM_ST_SMS_READ                     sizeof(SIM_SMS_RESP_SIM_ST_SMS_READ_STR)


//Definition for struct SIM_SMS_RESP


//Definition for struct SIM_SMS_RESP_SIM_ST_SMS_WRITE
#define SIM_SMS_RESP_SIM_ST_SMS_WRITE                         0xBD                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
            } __attribute__((packed)) SIM_SMS_RESP_SIM_ST_SMS_WRITE_STR;
#define SIZE_SIM_SMS_RESP_SIM_ST_SMS_WRITE                    sizeof(SIM_SMS_RESP_SIM_ST_SMS_WRITE_STR)


//Definition for struct SIM_SMS_RESP


//Definition for struct SIM_SMS_RESP_SIM_ST_SMS_ERASE
#define SIM_SMS_RESP_SIM_ST_SMS_ERASE                         0xBD                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
            } __attribute__((packed)) SIM_SMS_RESP_SIM_ST_SMS_ERASE_STR;
#define SIZE_SIM_SMS_RESP_SIM_ST_SMS_ERASE                    sizeof(SIM_SMS_RESP_SIM_ST_SMS_ERASE_STR)


//Definition for struct SIM_SMS_RESP


//Definition for struct SIM_SMS_RESP_SIM_ST_SMS_UPDATE_STATUS
#define SIM_SMS_RESP_SIM_ST_SMS_UPDATE_STATUS                 0xBD                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
            } __attribute__((packed)) SIM_SMS_RESP_SIM_ST_SMS_UPDATE_STATUS_STR;
#define SIZE_SIM_SMS_RESP_SIM_ST_SMS_UPDATE_STATUS            sizeof(SIM_SMS_RESP_SIM_ST_SMS_UPDATE_STATUS_STR)


//Definition for struct SIM_SMS_RESP


//Definition for struct SIM_SMS_RESP_SIM_ST_SMS_READ_RAW
#define SIM_SMS_RESP_SIM_ST_SMS_READ_RAW                      0xBD                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
             uint8_t      location;
             uint8_t      storagestatus;
             uint8_t      fillerbyte1;
             uint8_t      datalength;
             uint8_t      data[0];
            } __attribute__((packed)) SIM_SMS_RESP_SIM_ST_SMS_READ_RAW_STR;
#define SIZE_SIM_SMS_RESP_SIM_ST_SMS_READ_RAW                 sizeof(SIM_SMS_RESP_SIM_ST_SMS_READ_RAW_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct SIM_SMS_RESP


//Definition for struct SIM_SMS_RESP_SIM_ST_SMS_WRITE_RAW
#define SIM_SMS_RESP_SIM_ST_SMS_WRITE_RAW                     0xBD                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
            } __attribute__((packed)) SIM_SMS_RESP_SIM_ST_SMS_WRITE_RAW_STR;
#define SIZE_SIM_SMS_RESP_SIM_ST_SMS_WRITE_RAW                sizeof(SIM_SMS_RESP_SIM_ST_SMS_WRITE_RAW_STR)


//Definition for struct SIM_ATK_REQ


//Definition for struct SIM_ATK_REQ_SIM_ST_SET_POLLING
#define SIM_ATK_REQ_SIM_ST_SET_POLLING                        0xE2                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      cardid;
             uint8_t      pollinterval;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
            } __attribute__((packed)) SIM_ATK_REQ_SIM_ST_SET_POLLING_STR;
#define SIZE_SIM_ATK_REQ_SIM_ST_SET_POLLING                   sizeof(SIM_ATK_REQ_SIM_ST_SET_POLLING_STR)


//Definition for struct SIM_ATK_REQ


//Definition for struct SIM_ATK_REQ_SIM_ST_REFRESH_INIT_FROM_PIN
#define SIM_ATK_REQ_SIM_ST_REFRESH_INIT_FROM_PIN              0xE2                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      cardid;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
             uint8_t      noofsubblocks;
            } __attribute__((packed)) SIM_ATK_REQ_SIM_ST_REFRESH_INIT_FROM_PIN_STR;
#define SIZE_SIM_ATK_REQ_SIM_ST_REFRESH_INIT_FROM_PIN         sizeof(SIM_ATK_REQ_SIM_ST_REFRESH_INIT_FROM_PIN_STR)


//Definition for struct SIM_ATK_REQ


//Definition for struct SIM_ATK_REQ_SIM_ST_REFRESH_FCN
#define SIM_ATK_REQ_SIM_ST_REFRESH_FCN                        0xE2                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      cardid;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
             uint8_t      noofsubblocks;
            } __attribute__((packed)) SIM_ATK_REQ_SIM_ST_REFRESH_FCN_STR;
#define SIZE_SIM_ATK_REQ_SIM_ST_REFRESH_FCN                   sizeof(SIM_ATK_REQ_SIM_ST_REFRESH_FCN_STR)


//Definition for struct SIM_ATK_REQ


//Definition for struct SIM_ATK_REQ_SIM_ST_REFRESH_INIT_FROM_PIN_FCN
#define SIM_ATK_REQ_SIM_ST_REFRESH_INIT_FROM_PIN_FCN          0xE2                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      cardid;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
             uint8_t      noofsubblocks;
            } __attribute__((packed)) SIM_ATK_REQ_SIM_ST_REFRESH_INIT_FROM_PIN_FCN_STR;
#define SIZE_SIM_ATK_REQ_SIM_ST_REFRESH_INIT_FROM_PIN_FCN     sizeof(SIM_ATK_REQ_SIM_ST_REFRESH_INIT_FROM_PIN_FCN_STR)


//Definition for struct SIM_ATK_REQ


//Definition for struct SIM_ATK_REQ_SIM_ST_REFRESH_INIT_FROM_PIN_FFCN
#define SIM_ATK_REQ_SIM_ST_REFRESH_INIT_FROM_PIN_FFCN         0xE2                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      cardid;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
             uint8_t      noofsubblocks;
            } __attribute__((packed)) SIM_ATK_REQ_SIM_ST_REFRESH_INIT_FROM_PIN_FFCN_STR;
#define SIZE_SIM_ATK_REQ_SIM_ST_REFRESH_INIT_FROM_PIN_FFCN    sizeof(SIM_ATK_REQ_SIM_ST_REFRESH_INIT_FROM_PIN_FFCN_STR)


//Definition for struct SIM_ATK_REQ


//Definition for struct SIM_ATK_REQ_SIM_ST_REFRESH_RESET
#define SIM_ATK_REQ_SIM_ST_REFRESH_RESET                      0xE2                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      cardid;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
             uint8_t      noofsubblocks;
            } __attribute__((packed)) SIM_ATK_REQ_SIM_ST_REFRESH_RESET_STR;
#define SIZE_SIM_ATK_REQ_SIM_ST_REFRESH_RESET                 sizeof(SIM_ATK_REQ_SIM_ST_REFRESH_RESET_STR)


//Definition for struct SIM_ATK_REQ


//Definition for struct SIM_ATK_REQ_SIM_ST_REFRESH_APPLICATION_RESET
#define SIM_ATK_REQ_SIM_ST_REFRESH_APPLICATION_RESET          0xE2                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      cardid;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
             uint8_t      noofsubblocks;
            } __attribute__((packed)) SIM_ATK_REQ_SIM_ST_REFRESH_APPLICATION_RESET_STR;
#define SIZE_SIM_ATK_REQ_SIM_ST_REFRESH_APPLICATION_RESET     sizeof(SIM_ATK_REQ_SIM_ST_REFRESH_APPLICATION_RESET_STR)


//Definition for struct SIM_ATK_REQ


//Definition for struct SIM_ATK_REQ_SIM_ST_REFRESH_REFRESH_3G_SESSION_RESET
#define SIM_ATK_REQ_SIM_ST_REFRESH_REFRESH_3G_SESSION_RESET    0xE2                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      cardid;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
             uint8_t      noofsubblocks;
            } __attribute__((packed)) SIM_ATK_REQ_SIM_ST_REFRESH_REFRESH_3G_SESSION_RESET_STR;
#define SIZE_SIM_ATK_REQ_SIM_ST_REFRESH_REFRESH_3G_SESSION_RESET    sizeof(SIM_ATK_REQ_SIM_ST_REFRESH_REFRESH_3G_SESSION_RESET_STR)


//Definition for struct SIM_ATK_REQ


//Definition for struct SIM_ATK_REQ_SIM_ST_READ_ICON
#define SIM_ATK_REQ_SIM_ST_READ_ICON                          0xE2                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      cardid;
             uint8_t      recordnumber;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
            } __attribute__((packed)) SIM_ATK_REQ_SIM_ST_READ_ICON_STR;
#define SIZE_SIM_ATK_REQ_SIM_ST_READ_ICON                     sizeof(SIM_ATK_REQ_SIM_ST_READ_ICON_STR)


//Definition for struct SIM_ATK_REQ


//Definition for struct SIM_ATK_REQ_SIM_ST_READ_ICON_CLUT
#define SIM_ATK_REQ_SIM_ST_READ_ICON_CLUT                     0xE2                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      cardid;
             uint8_t      recordnumber;
             uint8_t      iconinstancenumber;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) SIM_ATK_REQ_SIM_ST_READ_ICON_CLUT_STR;
#define SIZE_SIM_ATK_REQ_SIM_ST_READ_ICON_CLUT                sizeof(SIM_ATK_REQ_SIM_ST_READ_ICON_CLUT_STR)


//Definition for struct SIM_ATK_REQ


//Definition for struct SIM_ATK_REQ_SIM_ST_READ_ICON_BODY_DATA
#define SIM_ATK_REQ_SIM_ST_READ_ICON_BODY_DATA                0xE2                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      cardid;
             uint8_t      recordnumber;
             uint8_t      iconinstancenumber;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) SIM_ATK_REQ_SIM_ST_READ_ICON_BODY_DATA_STR;
#define SIZE_SIM_ATK_REQ_SIM_ST_READ_ICON_BODY_DATA           sizeof(SIM_ATK_REQ_SIM_ST_READ_ICON_BODY_DATA_STR)


//Definition for struct SIM_ATK_REQ


//Definition for struct SIM_ATK_REQ_SIM_ST_SEND_ENVELOPE
#define SIM_ATK_REQ_SIM_ST_SEND_ENVELOPE                      0xE2                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      cardid;
             uint8_t      datalength;
             uint8_t      envelopedata[0];
            } __attribute__((packed)) SIM_ATK_REQ_SIM_ST_SEND_ENVELOPE_STR;
#define SIZE_SIM_ATK_REQ_SIM_ST_SEND_ENVELOPE                 sizeof(SIM_ATK_REQ_SIM_ST_SEND_ENVELOPE_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct SIM_ATK_REQ


//Definition for struct SIM_ATK_REQ_SIM_ST_CAT_SUPPORT_ENABLE
#define SIM_ATK_REQ_SIM_ST_CAT_SUPPORT_ENABLE                 0xE2                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) SIM_ATK_REQ_SIM_ST_CAT_SUPPORT_ENABLE_STR;
#define SIZE_SIM_ATK_REQ_SIM_ST_CAT_SUPPORT_ENABLE            sizeof(SIM_ATK_REQ_SIM_ST_CAT_SUPPORT_ENABLE_STR)


//Definition for struct SIM_ATK_REQ


//Definition for struct SIM_ATK_REQ_SIM_ST_CAT_SUPPORT_DISABLE
#define SIM_ATK_REQ_SIM_ST_CAT_SUPPORT_DISABLE                0xE2                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) SIM_ATK_REQ_SIM_ST_CAT_SUPPORT_DISABLE_STR;
#define SIZE_SIM_ATK_REQ_SIM_ST_CAT_SUPPORT_DISABLE           sizeof(SIM_ATK_REQ_SIM_ST_CAT_SUPPORT_DISABLE_STR)


//Definition for struct SIM_ATK_RESP


//Definition for struct SIM_ATK_RESP_SIM_ST_SET_POLLING
#define SIM_ATK_RESP_SIM_ST_SET_POLLING                       0xE3                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
             uint8_t      pollinterval;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
            } __attribute__((packed)) SIM_ATK_RESP_SIM_ST_SET_POLLING_STR;
#define SIZE_SIM_ATK_RESP_SIM_ST_SET_POLLING                  sizeof(SIM_ATK_RESP_SIM_ST_SET_POLLING_STR)


//Definition for struct SIM_ATK_RESP


//Definition for struct SIM_ATK_RESP_SIM_ST_REFRESH_INIT_FROM_PIN
#define SIM_ATK_RESP_SIM_ST_REFRESH_INIT_FROM_PIN             0xE3                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
            } __attribute__((packed)) SIM_ATK_RESP_SIM_ST_REFRESH_INIT_FROM_PIN_STR;
#define SIZE_SIM_ATK_RESP_SIM_ST_REFRESH_INIT_FROM_PIN        sizeof(SIM_ATK_RESP_SIM_ST_REFRESH_INIT_FROM_PIN_STR)


//Definition for struct SIM_ATK_RESP


//Definition for struct SIM_ATK_RESP_SIM_ST_REFRESH_FCN
#define SIM_ATK_RESP_SIM_ST_REFRESH_FCN                       0xE3                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
            } __attribute__((packed)) SIM_ATK_RESP_SIM_ST_REFRESH_FCN_STR;
#define SIZE_SIM_ATK_RESP_SIM_ST_REFRESH_FCN                  sizeof(SIM_ATK_RESP_SIM_ST_REFRESH_FCN_STR)


//Definition for struct SIM_ATK_RESP


//Definition for struct SIM_ATK_RESP_SIM_ST_REFRESH_INIT_FROM_PIN_FCN
#define SIM_ATK_RESP_SIM_ST_REFRESH_INIT_FROM_PIN_FCN         0xE3                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
            } __attribute__((packed)) SIM_ATK_RESP_SIM_ST_REFRESH_INIT_FROM_PIN_FCN_STR;
#define SIZE_SIM_ATK_RESP_SIM_ST_REFRESH_INIT_FROM_PIN_FCN    sizeof(SIM_ATK_RESP_SIM_ST_REFRESH_INIT_FROM_PIN_FCN_STR)


//Definition for struct SIM_ATK_RESP


//Definition for struct SIM_ATK_RESP_SIM_ST_REFRESH_INIT_FROM_PIN_FFCN
#define SIM_ATK_RESP_SIM_ST_REFRESH_INIT_FROM_PIN_FFCN        0xE3                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
            } __attribute__((packed)) SIM_ATK_RESP_SIM_ST_REFRESH_INIT_FROM_PIN_FFCN_STR;
#define SIZE_SIM_ATK_RESP_SIM_ST_REFRESH_INIT_FROM_PIN_FFCN    sizeof(SIM_ATK_RESP_SIM_ST_REFRESH_INIT_FROM_PIN_FFCN_STR)


//Definition for struct SIM_ATK_RESP


//Definition for struct SIM_ATK_RESP_SIM_ST_REFRESH_RESET
#define SIM_ATK_RESP_SIM_ST_REFRESH_RESET                     0xE3                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
            } __attribute__((packed)) SIM_ATK_RESP_SIM_ST_REFRESH_RESET_STR;
#define SIZE_SIM_ATK_RESP_SIM_ST_REFRESH_RESET                sizeof(SIM_ATK_RESP_SIM_ST_REFRESH_RESET_STR)


//Definition for struct SIM_ATK_RESP


//Definition for struct SIM_ATK_RESP_SIM_ST_REFRESH_APPLICATION_RESET
#define SIM_ATK_RESP_SIM_ST_REFRESH_APPLICATION_RESET         0xE3                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
            } __attribute__((packed)) SIM_ATK_RESP_SIM_ST_REFRESH_APPLICATION_RESET_STR;
#define SIZE_SIM_ATK_RESP_SIM_ST_REFRESH_APPLICATION_RESET    sizeof(SIM_ATK_RESP_SIM_ST_REFRESH_APPLICATION_RESET_STR)


//Definition for struct SIM_ATK_RESP


//Definition for struct SIM_ATK_RESP_SIM_ST_REFRESH_REFRESH_3G_SESSION_RESET
#define SIM_ATK_RESP_SIM_ST_REFRESH_REFRESH_3G_SESSION_RESET    0xE3                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
            } __attribute__((packed)) SIM_ATK_RESP_SIM_ST_REFRESH_REFRESH_3G_SESSION_RESET_STR;
#define SIZE_SIM_ATK_RESP_SIM_ST_REFRESH_REFRESH_3G_SESSION_RESET    sizeof(SIM_ATK_RESP_SIM_ST_REFRESH_REFRESH_3G_SESSION_RESET_STR)


//Definition for struct SIM_ATK_RESP


//Definition for struct SIM_ATK_RESP_SIM_ST_READ_ICON
#define SIM_ATK_RESP_SIM_ST_READ_ICON                         0xE3                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
             uint8_t      noofsubblocks;
            } __attribute__((packed)) SIM_ATK_RESP_SIM_ST_READ_ICON_STR;
#define SIZE_SIM_ATK_RESP_SIM_ST_READ_ICON                    sizeof(SIM_ATK_RESP_SIM_ST_READ_ICON_STR)


//Definition for struct SIM_ATK_RESP


//Definition for struct SIM_ATK_RESP_SIM_ST_READ_ICON_CLUT
#define SIM_ATK_RESP_SIM_ST_READ_ICON_CLUT                    0xE3                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
             uint8_t      noofsubblocks;
            } __attribute__((packed)) SIM_ATK_RESP_SIM_ST_READ_ICON_CLUT_STR;
#define SIZE_SIM_ATK_RESP_SIM_ST_READ_ICON_CLUT               sizeof(SIM_ATK_RESP_SIM_ST_READ_ICON_CLUT_STR)


//Definition for struct SIM_ATK_RESP


//Definition for struct SIM_ATK_RESP_SIM_ST_READ_ICON_BODY_DATA
#define SIM_ATK_RESP_SIM_ST_READ_ICON_BODY_DATA               0xE3                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
             uint8_t      noofsubblocks;
            } __attribute__((packed)) SIM_ATK_RESP_SIM_ST_READ_ICON_BODY_DATA_STR;
#define SIZE_SIM_ATK_RESP_SIM_ST_READ_ICON_BODY_DATA          sizeof(SIM_ATK_RESP_SIM_ST_READ_ICON_BODY_DATA_STR)


//Definition for struct SIM_ATK_RESP


//Definition for struct SIM_ATK_RESP_SIM_ST_SEND_ENVELOPE
#define SIM_ATK_RESP_SIM_ST_SEND_ENVELOPE                     0xE3                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
             uint8_t      sw1;
             uint8_t      sw2;
             uint16_t     datalength;
             uint8_t      responsedata[0];
            } __attribute__((packed)) SIM_ATK_RESP_SIM_ST_SEND_ENVELOPE_STR;
#define SIZE_SIM_ATK_RESP_SIM_ST_SEND_ENVELOPE                sizeof(SIM_ATK_RESP_SIM_ST_SEND_ENVELOPE_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct SIM_ATK_RESP


//Definition for struct SIM_ATK_RESP_SIM_ST_CAT_SUPPORT_ENABLE
#define SIM_ATK_RESP_SIM_ST_CAT_SUPPORT_ENABLE                0xE3                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
            } __attribute__((packed)) SIM_ATK_RESP_SIM_ST_CAT_SUPPORT_ENABLE_STR;
#define SIZE_SIM_ATK_RESP_SIM_ST_CAT_SUPPORT_ENABLE           sizeof(SIM_ATK_RESP_SIM_ST_CAT_SUPPORT_ENABLE_STR)


//Definition for struct SIM_ATK_RESP


//Definition for struct SIM_ATK_RESP_SIM_ST_CAT_SUPPORT_DISABLE
#define SIM_ATK_RESP_SIM_ST_CAT_SUPPORT_DISABLE               0xE3                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
            } __attribute__((packed)) SIM_ATK_RESP_SIM_ST_CAT_SUPPORT_DISABLE_STR;
#define SIZE_SIM_ATK_RESP_SIM_ST_CAT_SUPPORT_DISABLE          sizeof(SIM_ATK_RESP_SIM_ST_CAT_SUPPORT_DISABLE_STR)


//Definition for struct SIM_SERV_PROV_NAME_REQ


//Definition for struct SIM_SERV_PROV_NAME_REQ_SIM_ST_READ_SERV_PROV_NAME
#define SIM_SERV_PROV_NAME_REQ_SIM_ST_READ_SERV_PROV_NAME     0x21                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) SIM_SERV_PROV_NAME_REQ_SIM_ST_READ_SERV_PROV_NAME_STR;
#define SIZE_SIM_SERV_PROV_NAME_REQ_SIM_ST_READ_SERV_PROV_NAME    sizeof(SIM_SERV_PROV_NAME_REQ_SIM_ST_READ_SERV_PROV_NAME_STR)


//Definition for struct SIM_SERV_PROV_NAME_REQ


//Definition for struct SIM_SERV_PROV_NAME_REQ_SIM_ST_SPN_DISPLAY_INFO
#define SIM_SERV_PROV_NAME_REQ_SIM_ST_SPN_DISPLAY_INFO        0x21                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      paddingbyte;
            } __attribute__((packed)) SIM_SERV_PROV_NAME_REQ_SIM_ST_SPN_DISPLAY_INFO_STR;
#define SIZE_SIM_SERV_PROV_NAME_REQ_SIM_ST_SPN_DISPLAY_INFO    sizeof(SIM_SERV_PROV_NAME_REQ_SIM_ST_SPN_DISPLAY_INFO_STR)


//Definition for struct SIM_SERV_PROV_NAME_RESP


//Definition for struct SIM_SERV_PROV_NAME_RESP_SIM_ST_READ_SERV_PROV_NAME
#define SIM_SERV_PROV_NAME_RESP_SIM_ST_READ_SERV_PROV_NAME    0x22                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
             SERVICE_PROVIDER_STR    serviceprovider[0];
            } __attribute__((packed)) SIM_SERV_PROV_NAME_RESP_SIM_ST_READ_SERV_PROV_NAME_STR;
#define SIZE_SIM_SERV_PROV_NAME_RESP_SIM_ST_READ_SERV_PROV_NAME    sizeof(SIM_SERV_PROV_NAME_RESP_SIM_ST_READ_SERV_PROV_NAME_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct SIM_SERV_PROV_NAME_RESP


//Definition for struct SIM_SERV_PROV_NAME_RESP_SIM_ST_SPN_DISPLAY_INFO
#define SIM_SERV_PROV_NAME_RESP_SIM_ST_SPN_DISPLAY_INFO       0x22                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
            } __attribute__((packed)) SIM_SERV_PROV_NAME_RESP_SIM_ST_SPN_DISPLAY_INFO_STR;
#define SIZE_SIM_SERV_PROV_NAME_RESP_SIM_ST_SPN_DISPLAY_INFO    sizeof(SIM_SERV_PROV_NAME_RESP_SIM_ST_SPN_DISPLAY_INFO_STR)


//Definition for struct SIM_VOICE_MSG_REQ


//Definition for struct SIM_VOICE_MSG_REQ_SIM_ST_WRITE_FLAGS
#define SIM_VOICE_MSG_REQ_SIM_ST_WRITE_FLAGS                  0x2B                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      fillerbyte1;
             SIM_SERV_VOICE_MSG_OPTIONAL_DATA_STR    optionaldata[0];
             SIM_SERV_VOICE_MSG_WAIT_FLAG_STR    voicemsgflags[0];
            } __attribute__((packed)) SIM_VOICE_MSG_REQ_SIM_ST_WRITE_FLAGS_STR;
#define SIZE_SIM_VOICE_MSG_REQ_SIM_ST_WRITE_FLAGS             sizeof(SIM_VOICE_MSG_REQ_SIM_ST_WRITE_FLAGS_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct SIM_VOICE_MSG_REQ


//Definition for struct SIM_VOICE_MSG_REQ_SIM_ST_READ_FLAGS
#define SIM_VOICE_MSG_REQ_SIM_ST_READ_FLAGS                   0x2B                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) SIM_VOICE_MSG_REQ_SIM_ST_READ_FLAGS_STR;
#define SIZE_SIM_VOICE_MSG_REQ_SIM_ST_READ_FLAGS              sizeof(SIM_VOICE_MSG_REQ_SIM_ST_READ_FLAGS_STR)


//Definition for struct SIM_VOICE_MSG_REQ


//Definition for struct SIM_VOICE_MSG_REQ_SIM_ST_WRITE_MSG_FLAGS
#define SIM_VOICE_MSG_REQ_SIM_ST_WRITE_MSG_FLAGS              0x2B                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      nbrofsubblocks;
            } __attribute__((packed)) SIM_VOICE_MSG_REQ_SIM_ST_WRITE_MSG_FLAGS_STR;
#define SIZE_SIM_VOICE_MSG_REQ_SIM_ST_WRITE_MSG_FLAGS         sizeof(SIM_VOICE_MSG_REQ_SIM_ST_WRITE_MSG_FLAGS_STR)


//Definition for struct SIM_VOICE_MSG_REQ


//Definition for struct SIM_VOICE_MSG_REQ_SIM_ST_READ_MSG_FLAGS
#define SIM_VOICE_MSG_REQ_SIM_ST_READ_MSG_FLAGS               0x2B                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      padding;
            } __attribute__((packed)) SIM_VOICE_MSG_REQ_SIM_ST_READ_MSG_FLAGS_STR;
#define SIZE_SIM_VOICE_MSG_REQ_SIM_ST_READ_MSG_FLAGS          sizeof(SIM_VOICE_MSG_REQ_SIM_ST_READ_MSG_FLAGS_STR)


//Definition for struct SIM_VOICE_MSG_RESP


//Definition for struct SIM_VOICE_MSG_RESP_SIM_ST_WRITE_FLAGS
#define SIM_VOICE_MSG_RESP_SIM_ST_WRITE_FLAGS                 0x2C                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
            } __attribute__((packed)) SIM_VOICE_MSG_RESP_SIM_ST_WRITE_FLAGS_STR;
#define SIZE_SIM_VOICE_MSG_RESP_SIM_ST_WRITE_FLAGS            sizeof(SIM_VOICE_MSG_RESP_SIM_ST_WRITE_FLAGS_STR)


//Definition for struct SIM_VOICE_MSG_RESP


//Definition for struct SIM_VOICE_MSG_RESP_SIM_ST_READ_FLAGS
#define SIM_VOICE_MSG_RESP_SIM_ST_READ_FLAGS                  0x2C                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
             SIM_SERV_VOICE_MSG_OPTIONAL_DATA_STR    optionaldata[0];
             SIM_SERV_VOICE_MSG_WAIT_FLAG_STR    voicemsgflags[0];
            } __attribute__((packed)) SIM_VOICE_MSG_RESP_SIM_ST_READ_FLAGS_STR;
#define SIZE_SIM_VOICE_MSG_RESP_SIM_ST_READ_FLAGS             sizeof(SIM_VOICE_MSG_RESP_SIM_ST_READ_FLAGS_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct SIM_VOICE_MSG_RESP


//Definition for struct SIM_VOICE_MSG_RESP_SIM_ST_WRITE_MSG_FLAGS
#define SIM_VOICE_MSG_RESP_SIM_ST_WRITE_MSG_FLAGS             0x2C                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
            } __attribute__((packed)) SIM_VOICE_MSG_RESP_SIM_ST_WRITE_MSG_FLAGS_STR;
#define SIZE_SIM_VOICE_MSG_RESP_SIM_ST_WRITE_MSG_FLAGS        sizeof(SIM_VOICE_MSG_RESP_SIM_ST_WRITE_MSG_FLAGS_STR)


//Definition for struct SIM_VOICE_MSG_RESP


//Definition for struct SIM_VOICE_MSG_RESP_SIM_ST_READ_MSG_FLAGS
#define SIM_VOICE_MSG_RESP_SIM_ST_READ_MSG_FLAGS              0x2C                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
             uint8_t      nbrofsubblocks;
            } __attribute__((packed)) SIM_VOICE_MSG_RESP_SIM_ST_READ_MSG_FLAGS_STR;
#define SIZE_SIM_VOICE_MSG_RESP_SIM_ST_READ_MSG_FLAGS         sizeof(SIM_VOICE_MSG_RESP_SIM_ST_READ_MSG_FLAGS_STR)


//Definition for struct SIM_CALL_FWD_REQ


//Definition for struct SIM_CALL_FWD_REQ_SIM_ST_WRITE_FLAGS
#define SIM_CALL_FWD_REQ_SIM_ST_WRITE_FLAGS                   0x2D                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      fillerbyte1;
             SIM_SERV_CALL_FWD_FLAG_STR    call_fwd_flags[0];
            } __attribute__((packed)) SIM_CALL_FWD_REQ_SIM_ST_WRITE_FLAGS_STR;
#define SIZE_SIM_CALL_FWD_REQ_SIM_ST_WRITE_FLAGS              sizeof(SIM_CALL_FWD_REQ_SIM_ST_WRITE_FLAGS_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct SIM_CALL_FWD_REQ


//Definition for struct SIM_CALL_FWD_REQ_SIM_ST_READ_FLAGS
#define SIM_CALL_FWD_REQ_SIM_ST_READ_FLAGS                    0x2D                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) SIM_CALL_FWD_REQ_SIM_ST_READ_FLAGS_STR;
#define SIZE_SIM_CALL_FWD_REQ_SIM_ST_READ_FLAGS               sizeof(SIM_CALL_FWD_REQ_SIM_ST_READ_FLAGS_STR)


//Definition for struct SIM_CALL_FWD_REQ


//Definition for struct SIM_CALL_FWD_REQ_SIM_ST_WRITE_CALL_FWD_FLAGS
#define SIM_CALL_FWD_REQ_SIM_ST_WRITE_CALL_FWD_FLAGS          0x2D                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      nbrofsubblocks;
            } __attribute__((packed)) SIM_CALL_FWD_REQ_SIM_ST_WRITE_CALL_FWD_FLAGS_STR;
#define SIZE_SIM_CALL_FWD_REQ_SIM_ST_WRITE_CALL_FWD_FLAGS     sizeof(SIM_CALL_FWD_REQ_SIM_ST_WRITE_CALL_FWD_FLAGS_STR)


//Definition for struct SIM_CALL_FWD_REQ


//Definition for struct SIM_CALL_FWD_REQ_SIM_ST_READ_CALL_FWD_FLAGS
#define SIM_CALL_FWD_REQ_SIM_ST_READ_CALL_FWD_FLAGS           0x2D                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) SIM_CALL_FWD_REQ_SIM_ST_READ_CALL_FWD_FLAGS_STR;
#define SIZE_SIM_CALL_FWD_REQ_SIM_ST_READ_CALL_FWD_FLAGS      sizeof(SIM_CALL_FWD_REQ_SIM_ST_READ_CALL_FWD_FLAGS_STR)


//Definition for struct SIM_CALL_FWD_RESP


//Definition for struct SIM_CALL_FWD_RESP_SIM_ST_WRITE_FLAGS
#define SIM_CALL_FWD_RESP_SIM_ST_WRITE_FLAGS                  0x2E                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
            } __attribute__((packed)) SIM_CALL_FWD_RESP_SIM_ST_WRITE_FLAGS_STR;
#define SIZE_SIM_CALL_FWD_RESP_SIM_ST_WRITE_FLAGS             sizeof(SIM_CALL_FWD_RESP_SIM_ST_WRITE_FLAGS_STR)


//Definition for struct SIM_CALL_FWD_RESP


//Definition for struct SIM_CALL_FWD_RESP_SIM_ST_READ_FLAGS
#define SIM_CALL_FWD_RESP_SIM_ST_READ_FLAGS                   0x2E                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
             SIM_SERV_CALL_FWD_FLAG_STR    call_fwd_flags[0];
            } __attribute__((packed)) SIM_CALL_FWD_RESP_SIM_ST_READ_FLAGS_STR;
#define SIZE_SIM_CALL_FWD_RESP_SIM_ST_READ_FLAGS              sizeof(SIM_CALL_FWD_RESP_SIM_ST_READ_FLAGS_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct SIM_CALL_FWD_RESP


//Definition for struct SIM_CALL_FWD_RESP_SIM_ST_WRITE_CALL_FWD_FLAGS
#define SIM_CALL_FWD_RESP_SIM_ST_WRITE_CALL_FWD_FLAGS         0x2E                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
            } __attribute__((packed)) SIM_CALL_FWD_RESP_SIM_ST_WRITE_CALL_FWD_FLAGS_STR;
#define SIZE_SIM_CALL_FWD_RESP_SIM_ST_WRITE_CALL_FWD_FLAGS    sizeof(SIM_CALL_FWD_RESP_SIM_ST_WRITE_CALL_FWD_FLAGS_STR)


//Definition for struct SIM_CALL_FWD_RESP


//Definition for struct SIM_CALL_FWD_RESP_SIM_ST_READ_CALL_FWD_FLAGS
#define SIM_CALL_FWD_RESP_SIM_ST_READ_CALL_FWD_FLAGS          0x2E                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
             uint8_t      nbrofsubblocks;
            } __attribute__((packed)) SIM_CALL_FWD_RESP_SIM_ST_READ_CALL_FWD_FLAGS_STR;
#define SIZE_SIM_CALL_FWD_RESP_SIM_ST_READ_CALL_FWD_FLAGS     sizeof(SIM_CALL_FWD_RESP_SIM_ST_READ_CALL_FWD_FLAGS_STR)


//Definition for struct SIM_DYNAMIC_FLAGS_REQ


//Definition for struct SIM_DYNAMIC_FLAGS_REQ_WRITE_DYN_FLAGS
#define SIM_DYNAMIC_FLAGS_REQ_WRITE_DYN_FLAGS                 0x29                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      fillerbyte1;
             SIM_INFO_DYNAMIC_FLAGS_STR    dynflags[0];
            } __attribute__((packed)) SIM_DYNAMIC_FLAGS_REQ_WRITE_DYN_FLAGS_STR;
#define SIZE_SIM_DYNAMIC_FLAGS_REQ_WRITE_DYN_FLAGS            sizeof(SIM_DYNAMIC_FLAGS_REQ_WRITE_DYN_FLAGS_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct SIM_DYNAMIC_FLAGS_REQ


//Definition for struct SIM_DYNAMIC_FLAGS_REQ_READ_DYN_FLAGS
#define SIM_DYNAMIC_FLAGS_REQ_READ_DYN_FLAGS                  0x29                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) SIM_DYNAMIC_FLAGS_REQ_READ_DYN_FLAGS_STR;
#define SIZE_SIM_DYNAMIC_FLAGS_REQ_READ_DYN_FLAGS             sizeof(SIM_DYNAMIC_FLAGS_REQ_READ_DYN_FLAGS_STR)


//Definition for struct SIM_DYNAMIC_FLAGS_REQ


//Definition for struct SIM_DYNAMIC_FLAGS_REQ_WRITE_DYN2_FLAGS
#define SIM_DYNAMIC_FLAGS_REQ_WRITE_DYN2_FLAGS                0x29                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      fillerbyte1;
             SIM_INFO_DYNAMIC2_FLAGS_STR    dyn2flags[0];
            } __attribute__((packed)) SIM_DYNAMIC_FLAGS_REQ_WRITE_DYN2_FLAGS_STR;
#define SIZE_SIM_DYNAMIC_FLAGS_REQ_WRITE_DYN2_FLAGS           sizeof(SIM_DYNAMIC_FLAGS_REQ_WRITE_DYN2_FLAGS_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct SIM_DYNAMIC_FLAGS_REQ


//Definition for struct SIM_DYNAMIC_FLAGS_REQ_READ_DYN2_FLAGS
#define SIM_DYNAMIC_FLAGS_REQ_READ_DYN2_FLAGS                 0x29                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) SIM_DYNAMIC_FLAGS_REQ_READ_DYN2_FLAGS_STR;
#define SIZE_SIM_DYNAMIC_FLAGS_REQ_READ_DYN2_FLAGS            sizeof(SIM_DYNAMIC_FLAGS_REQ_READ_DYN2_FLAGS_STR)


//Definition for struct SIM_DYNAMIC_FLAGS_RESP


//Definition for struct SIM_DYNAMIC_FLAGS_RESP_WRITE_DYN_FLAGS
#define SIM_DYNAMIC_FLAGS_RESP_WRITE_DYN_FLAGS                0x2A                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
            } __attribute__((packed)) SIM_DYNAMIC_FLAGS_RESP_WRITE_DYN_FLAGS_STR;
#define SIZE_SIM_DYNAMIC_FLAGS_RESP_WRITE_DYN_FLAGS           sizeof(SIM_DYNAMIC_FLAGS_RESP_WRITE_DYN_FLAGS_STR)


//Definition for struct SIM_DYNAMIC_FLAGS_RESP


//Definition for struct SIM_DYNAMIC_FLAGS_RESP_READ_DYN_FLAGS
#define SIM_DYNAMIC_FLAGS_RESP_READ_DYN_FLAGS                 0x2A                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
             SIM_INFO_DYNAMIC_FLAGS_STR    dynflags[0];
            } __attribute__((packed)) SIM_DYNAMIC_FLAGS_RESP_READ_DYN_FLAGS_STR;
#define SIZE_SIM_DYNAMIC_FLAGS_RESP_READ_DYN_FLAGS            sizeof(SIM_DYNAMIC_FLAGS_RESP_READ_DYN_FLAGS_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct SIM_DYNAMIC_FLAGS_RESP


//Definition for struct SIM_DYNAMIC_FLAGS_RESP_WRITE_DYN2_FLAGS
#define SIM_DYNAMIC_FLAGS_RESP_WRITE_DYN2_FLAGS               0x2A                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
            } __attribute__((packed)) SIM_DYNAMIC_FLAGS_RESP_WRITE_DYN2_FLAGS_STR;
#define SIZE_SIM_DYNAMIC_FLAGS_RESP_WRITE_DYN2_FLAGS          sizeof(SIM_DYNAMIC_FLAGS_RESP_WRITE_DYN2_FLAGS_STR)


//Definition for struct SIM_DYNAMIC_FLAGS_RESP


//Definition for struct SIM_DYNAMIC_FLAGS_RESP_READ_DYN2_FLAGS
#define SIM_DYNAMIC_FLAGS_RESP_READ_DYN2_FLAGS                0x2A                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
             SIM_INFO_DYNAMIC2_FLAGS_STR    dyn2flags[0];
            } __attribute__((packed)) SIM_DYNAMIC_FLAGS_RESP_READ_DYN2_FLAGS_STR;
#define SIZE_SIM_DYNAMIC_FLAGS_RESP_READ_DYN2_FLAGS           sizeof(SIM_DYNAMIC_FLAGS_RESP_READ_DYN2_FLAGS_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct SIM_APP_SELECTION_REQ


//Definition for struct SIM_APP_SELECTION_REQ_SIM_ST_GET_ALL_APP_LABELS
#define SIM_APP_SELECTION_REQ_SIM_ST_GET_ALL_APP_LABELS       0xDA                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      applicationnumber;
            } __attribute__((packed)) SIM_APP_SELECTION_REQ_SIM_ST_GET_ALL_APP_LABELS_STR;
#define SIZE_SIM_APP_SELECTION_REQ_SIM_ST_GET_ALL_APP_LABELS    sizeof(SIM_APP_SELECTION_REQ_SIM_ST_GET_ALL_APP_LABELS_STR)


//Definition for struct SIM_APP_SELECTION_REQ


//Definition for struct SIM_APP_SELECTION_REQ_SIM_ST_GET_ACTIVE_APP_LABEL
#define SIM_APP_SELECTION_REQ_SIM_ST_GET_ACTIVE_APP_LABEL     0xDA                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      applicationnumber;
            } __attribute__((packed)) SIM_APP_SELECTION_REQ_SIM_ST_GET_ACTIVE_APP_LABEL_STR;
#define SIZE_SIM_APP_SELECTION_REQ_SIM_ST_GET_ACTIVE_APP_LABEL    sizeof(SIM_APP_SELECTION_REQ_SIM_ST_GET_ACTIVE_APP_LABEL_STR)


//Definition for struct SIM_APP_SELECTION_REQ


//Definition for struct SIM_APP_SELECTION_REQ_SIM_ST_GET_ISIM_LABEL
#define SIM_APP_SELECTION_REQ_SIM_ST_GET_ISIM_LABEL           0xDA                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      applicationnumber;
            } __attribute__((packed)) SIM_APP_SELECTION_REQ_SIM_ST_GET_ISIM_LABEL_STR;
#define SIZE_SIM_APP_SELECTION_REQ_SIM_ST_GET_ISIM_LABEL      sizeof(SIM_APP_SELECTION_REQ_SIM_ST_GET_ISIM_LABEL_STR)


//Definition for struct SIM_APP_SELECTION_REQ


//Definition for struct SIM_APP_SELECTION_REQ_SIM_ST_GET_LABEL_BY_NO
#define SIM_APP_SELECTION_REQ_SIM_ST_GET_LABEL_BY_NO          0xDA                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      applicationnumber;
            } __attribute__((packed)) SIM_APP_SELECTION_REQ_SIM_ST_GET_LABEL_BY_NO_STR;
#define SIZE_SIM_APP_SELECTION_REQ_SIM_ST_GET_LABEL_BY_NO     sizeof(SIM_APP_SELECTION_REQ_SIM_ST_GET_LABEL_BY_NO_STR)


//Definition for struct SIM_APP_SELECTION_REQ


//Definition for struct SIM_APP_SELECTION_REQ_SIM_ST_GET_NUMBER_OF_APP
#define SIM_APP_SELECTION_REQ_SIM_ST_GET_NUMBER_OF_APP        0xDA                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) SIM_APP_SELECTION_REQ_SIM_ST_GET_NUMBER_OF_APP_STR;
#define SIZE_SIM_APP_SELECTION_REQ_SIM_ST_GET_NUMBER_OF_APP    sizeof(SIM_APP_SELECTION_REQ_SIM_ST_GET_NUMBER_OF_APP_STR)


//Definition for struct SIM_APP_SELECTION_REQ


//Definition for struct SIM_APP_SELECTION_REQ_SIM_ST_SET_DEFAULT_APP
#define SIM_APP_SELECTION_REQ_SIM_ST_SET_DEFAULT_APP          0xDA                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      applicationnumber;
            } __attribute__((packed)) SIM_APP_SELECTION_REQ_SIM_ST_SET_DEFAULT_APP_STR;
#define SIZE_SIM_APP_SELECTION_REQ_SIM_ST_SET_DEFAULT_APP     sizeof(SIM_APP_SELECTION_REQ_SIM_ST_SET_DEFAULT_APP_STR)


//Definition for struct SIM_APP_SELECTION_REQ


//Definition for struct SIM_APP_SELECTION_REQ_SIM_ST_ACTIVATE_APP
#define SIM_APP_SELECTION_REQ_SIM_ST_ACTIVATE_APP             0xDA                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      applicationnumber;
            } __attribute__((packed)) SIM_APP_SELECTION_REQ_SIM_ST_ACTIVATE_APP_STR;
#define SIZE_SIM_APP_SELECTION_REQ_SIM_ST_ACTIVATE_APP        sizeof(SIM_APP_SELECTION_REQ_SIM_ST_ACTIVATE_APP_STR)


//Definition for struct SIM_APP_SELECTION_REQ


//Definition for struct SIM_APP_SELECTION_REQ_SIM_ST_SET_APP_SELECTION_AUTOMATIC
#define SIM_APP_SELECTION_REQ_SIM_ST_SET_APP_SELECTION_AUTOMATIC    0xDA                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) SIM_APP_SELECTION_REQ_SIM_ST_SET_APP_SELECTION_AUTOMATIC_STR;
#define SIZE_SIM_APP_SELECTION_REQ_SIM_ST_SET_APP_SELECTION_AUTOMATIC    sizeof(SIM_APP_SELECTION_REQ_SIM_ST_SET_APP_SELECTION_AUTOMATIC_STR)


//Definition for struct SIM_APP_SELECTION_REQ


//Definition for struct SIM_APP_SELECTION_REQ_SIM_ST_SET_APP_SELECTION_MANUAL
#define SIM_APP_SELECTION_REQ_SIM_ST_SET_APP_SELECTION_MANUAL    0xDA                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) SIM_APP_SELECTION_REQ_SIM_ST_SET_APP_SELECTION_MANUAL_STR;
#define SIZE_SIM_APP_SELECTION_REQ_SIM_ST_SET_APP_SELECTION_MANUAL    sizeof(SIM_APP_SELECTION_REQ_SIM_ST_SET_APP_SELECTION_MANUAL_STR)


//Definition for struct SIM_APP_SELECTION_REQ


//Definition for struct SIM_APP_SELECTION_REQ_SIM_ST_GET_APP_SELECTION_STATUS
#define SIM_APP_SELECTION_REQ_SIM_ST_GET_APP_SELECTION_STATUS    0xDA                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) SIM_APP_SELECTION_REQ_SIM_ST_GET_APP_SELECTION_STATUS_STR;
#define SIZE_SIM_APP_SELECTION_REQ_SIM_ST_GET_APP_SELECTION_STATUS    sizeof(SIM_APP_SELECTION_REQ_SIM_ST_GET_APP_SELECTION_STATUS_STR)


//Definition for struct SIM_APP_SELECTION_RESP


//Definition for struct SIM_APP_SELECTION_RESP_SIM_ST_GET_ALL_APP_LABELS
#define SIM_APP_SELECTION_RESP_SIM_ST_GET_ALL_APP_LABELS      0xDB                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
             uint8_t      numberofsubblocks;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
            } __attribute__((packed)) SIM_APP_SELECTION_RESP_SIM_ST_GET_ALL_APP_LABELS_STR;
#define SIZE_SIM_APP_SELECTION_RESP_SIM_ST_GET_ALL_APP_LABELS    sizeof(SIM_APP_SELECTION_RESP_SIM_ST_GET_ALL_APP_LABELS_STR)


//Definition for struct SIM_APP_SELECTION_RESP


//Definition for struct SIM_APP_SELECTION_RESP_SIM_ST_GET_ACTIVE_APP_LABEL
#define SIM_APP_SELECTION_RESP_SIM_ST_GET_ACTIVE_APP_LABEL    0xDB                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
             uint8_t      numberofsubblocks;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
            } __attribute__((packed)) SIM_APP_SELECTION_RESP_SIM_ST_GET_ACTIVE_APP_LABEL_STR;
#define SIZE_SIM_APP_SELECTION_RESP_SIM_ST_GET_ACTIVE_APP_LABEL    sizeof(SIM_APP_SELECTION_RESP_SIM_ST_GET_ACTIVE_APP_LABEL_STR)


//Definition for struct SIM_APP_SELECTION_RESP


//Definition for struct SIM_APP_SELECTION_RESP_SIM_ST_GET_ISIM_LABEL
#define SIM_APP_SELECTION_RESP_SIM_ST_GET_ISIM_LABEL          0xDB                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
             uint8_t      numberofsubblocks;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
            } __attribute__((packed)) SIM_APP_SELECTION_RESP_SIM_ST_GET_ISIM_LABEL_STR;
#define SIZE_SIM_APP_SELECTION_RESP_SIM_ST_GET_ISIM_LABEL     sizeof(SIM_APP_SELECTION_RESP_SIM_ST_GET_ISIM_LABEL_STR)


//Definition for struct SIM_APP_SELECTION_RESP


//Definition for struct SIM_APP_SELECTION_RESP_SIM_ST_GET_LABEL_BY_NO
#define SIM_APP_SELECTION_RESP_SIM_ST_GET_LABEL_BY_NO         0xDB                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
             uint8_t      numberofsubblocks;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
            } __attribute__((packed)) SIM_APP_SELECTION_RESP_SIM_ST_GET_LABEL_BY_NO_STR;
#define SIZE_SIM_APP_SELECTION_RESP_SIM_ST_GET_LABEL_BY_NO    sizeof(SIM_APP_SELECTION_RESP_SIM_ST_GET_LABEL_BY_NO_STR)


//Definition for struct SIM_APP_SELECTION_RESP


//Definition for struct SIM_APP_SELECTION_RESP_SIM_ST_GET_NUMBER_OF_APP
#define SIM_APP_SELECTION_RESP_SIM_ST_GET_NUMBER_OF_APP       0xDB                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
             uint8_t      numberofappl;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
            } __attribute__((packed)) SIM_APP_SELECTION_RESP_SIM_ST_GET_NUMBER_OF_APP_STR;
#define SIZE_SIM_APP_SELECTION_RESP_SIM_ST_GET_NUMBER_OF_APP    sizeof(SIM_APP_SELECTION_RESP_SIM_ST_GET_NUMBER_OF_APP_STR)


//Definition for struct SIM_APP_SELECTION_RESP


//Definition for struct SIM_APP_SELECTION_RESP_SIM_ST_SET_DEFAULT_APP
#define SIM_APP_SELECTION_RESP_SIM_ST_SET_DEFAULT_APP         0xDB                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
            } __attribute__((packed)) SIM_APP_SELECTION_RESP_SIM_ST_SET_DEFAULT_APP_STR;
#define SIZE_SIM_APP_SELECTION_RESP_SIM_ST_SET_DEFAULT_APP    sizeof(SIM_APP_SELECTION_RESP_SIM_ST_SET_DEFAULT_APP_STR)


//Definition for struct SIM_APP_SELECTION_RESP


//Definition for struct SIM_APP_SELECTION_RESP_SIM_ST_ACTIVATE_APP
#define SIM_APP_SELECTION_RESP_SIM_ST_ACTIVATE_APP            0xDB                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
            } __attribute__((packed)) SIM_APP_SELECTION_RESP_SIM_ST_ACTIVATE_APP_STR;
#define SIZE_SIM_APP_SELECTION_RESP_SIM_ST_ACTIVATE_APP       sizeof(SIM_APP_SELECTION_RESP_SIM_ST_ACTIVATE_APP_STR)


//Definition for struct SIM_APP_SELECTION_RESP


//Definition for struct SIM_APP_SELECTION_RESP_SIM_ST_SET_APP_SELECTION_AUTOMATIC
#define SIM_APP_SELECTION_RESP_SIM_ST_SET_APP_SELECTION_AUTOMATIC    0xDB                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
            } __attribute__((packed)) SIM_APP_SELECTION_RESP_SIM_ST_SET_APP_SELECTION_AUTOMATIC_STR;
#define SIZE_SIM_APP_SELECTION_RESP_SIM_ST_SET_APP_SELECTION_AUTOMATIC    sizeof(SIM_APP_SELECTION_RESP_SIM_ST_SET_APP_SELECTION_AUTOMATIC_STR)


//Definition for struct SIM_APP_SELECTION_RESP


//Definition for struct SIM_APP_SELECTION_RESP_SIM_ST_SET_APP_SELECTION_MANUAL
#define SIM_APP_SELECTION_RESP_SIM_ST_SET_APP_SELECTION_MANUAL    0xDB                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
            } __attribute__((packed)) SIM_APP_SELECTION_RESP_SIM_ST_SET_APP_SELECTION_MANUAL_STR;
#define SIZE_SIM_APP_SELECTION_RESP_SIM_ST_SET_APP_SELECTION_MANUAL    sizeof(SIM_APP_SELECTION_RESP_SIM_ST_SET_APP_SELECTION_MANUAL_STR)


//Definition for struct SIM_APP_SELECTION_RESP


//Definition for struct SIM_APP_SELECTION_RESP_SIM_ST_GET_APP_SELECTION_STATUS
#define SIM_APP_SELECTION_RESP_SIM_ST_GET_APP_SELECTION_STATUS    0xDB                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
            } __attribute__((packed)) SIM_APP_SELECTION_RESP_SIM_ST_GET_APP_SELECTION_STATUS_STR;
#define SIZE_SIM_APP_SELECTION_RESP_SIM_ST_GET_APP_SELECTION_STATUS    sizeof(SIM_APP_SELECTION_RESP_SIM_ST_GET_APP_SELECTION_STATUS_STR)


//Definition for struct SIM_FDN_CHECK_REQ
#define SIM_FDN_CHECK_REQ                                     0x68                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      numberofsubblocks;
            } __attribute__((packed)) SIM_FDN_CHECK_REQ_STR;
#define SIZE_SIM_FDN_CHECK_REQ                                sizeof(SIM_FDN_CHECK_REQ_STR)


//Definition for struct SIM_FDN_CHECK_RESP
#define SIM_FDN_CHECK_RESP                                    0x69                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
             uint8_t      numberofsubblocks;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
            } __attribute__((packed)) SIM_FDN_CHECK_RESP_STR;
#define SIZE_SIM_FDN_CHECK_RESP                               sizeof(SIM_FDN_CHECK_RESP_STR)


//Definition for struct SIM_CONNECTION_REQ
#define SIM_CONNECTION_REQ                                    0xE0                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      numberofsubblocks;
            } __attribute__((packed)) SIM_CONNECTION_REQ_STR;
#define SIZE_SIM_CONNECTION_REQ                               sizeof(SIM_CONNECTION_REQ_STR)


//Definition for struct SIM_CONNECTION_RESP
#define SIM_CONNECTION_RESP                                   0xE1                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
            } __attribute__((packed)) SIM_CONNECTION_RESP_STR;
#define SIZE_SIM_CONNECTION_RESP                              sizeof(SIM_CONNECTION_RESP_STR)


//Definition for struct SIM_PB_REQ


//Definition for struct SIM_PB_REQ_SIM_PB_READ
#define SIM_PB_REQ_SIM_PB_READ                                0xDC                                                  
typedef struct
            { 
             uint8_t      transactionid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      numberofsubblocks;
            } __attribute__((packed)) SIM_PB_REQ_SIM_PB_READ_STR;
#define SIZE_SIM_PB_REQ_SIM_PB_READ                           sizeof(SIM_PB_REQ_SIM_PB_READ_STR)


//Definition for struct SIM_PB_REQ


//Definition for struct SIM_PB_REQ_SIM_PB_WRITE
#define SIM_PB_REQ_SIM_PB_WRITE                               0xDC                                                  
typedef struct
            { 
             uint8_t      transactionid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      numberofsubblocks;
            } __attribute__((packed)) SIM_PB_REQ_SIM_PB_WRITE_STR;
#define SIZE_SIM_PB_REQ_SIM_PB_WRITE                          sizeof(SIM_PB_REQ_SIM_PB_WRITE_STR)


//Definition for struct SIM_PB_REQ


//Definition for struct SIM_PB_REQ_SIM_PB_GET_CONF
#define SIM_PB_REQ_SIM_PB_GET_CONF                            0xDC                                                  
typedef struct
            { 
             uint8_t      transactionid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      numberofsubblocks;
            } __attribute__((packed)) SIM_PB_REQ_SIM_PB_GET_CONF_STR;
#define SIZE_SIM_PB_REQ_SIM_PB_GET_CONF                       sizeof(SIM_PB_REQ_SIM_PB_GET_CONF_STR)


//Definition for struct SIM_PB_REQ


//Definition for struct SIM_PB_REQ_SIM_PB_SELECT_PB
#define SIM_PB_REQ_SIM_PB_SELECT_PB                           0xDC                                                  
typedef struct
            { 
             uint8_t      transactionid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      numberofsubblocks;
            } __attribute__((packed)) SIM_PB_REQ_SIM_PB_SELECT_PB_STR;
#define SIZE_SIM_PB_REQ_SIM_PB_SELECT_PB                      sizeof(SIM_PB_REQ_SIM_PB_SELECT_PB_STR)


//Definition for struct SIM_PB_RESP


//Definition for struct SIM_PB_RESP_SIM_PB_READ
#define SIM_PB_RESP_SIM_PB_READ                               0xDD                                                  
typedef struct
            { 
             uint8_t      transactionid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      numberofsubblocks;
            } __attribute__((packed)) SIM_PB_RESP_SIM_PB_READ_STR;
#define SIZE_SIM_PB_RESP_SIM_PB_READ                          sizeof(SIM_PB_RESP_SIM_PB_READ_STR)


//Definition for struct SIM_PB_RESP


//Definition for struct SIM_PB_RESP_SIM_PB_WRITE
#define SIM_PB_RESP_SIM_PB_WRITE                              0xDD                                                  
typedef struct
            { 
             uint8_t      transactionid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      numberofsubblocks;
            } __attribute__((packed)) SIM_PB_RESP_SIM_PB_WRITE_STR;
#define SIZE_SIM_PB_RESP_SIM_PB_WRITE                         sizeof(SIM_PB_RESP_SIM_PB_WRITE_STR)


//Definition for struct SIM_PB_RESP


//Definition for struct SIM_PB_RESP_SIM_PB_GET_CONF
#define SIM_PB_RESP_SIM_PB_GET_CONF                           0xDD                                                  
typedef struct
            { 
             uint8_t      transactionid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      numberofsubblocks;
            } __attribute__((packed)) SIM_PB_RESP_SIM_PB_GET_CONF_STR;
#define SIZE_SIM_PB_RESP_SIM_PB_GET_CONF                      sizeof(SIM_PB_RESP_SIM_PB_GET_CONF_STR)


//Definition for struct SIM_PB_RESP


//Definition for struct SIM_PB_RESP_SIM_PB_SELECT_PB
#define SIM_PB_RESP_SIM_PB_SELECT_PB                          0xDD                                                  
typedef struct
            { 
             uint8_t      transactionid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      numberofsubblocks;
            } __attribute__((packed)) SIM_PB_RESP_SIM_PB_SELECT_PB_STR;
#define SIZE_SIM_PB_RESP_SIM_PB_SELECT_PB                     sizeof(SIM_PB_RESP_SIM_PB_SELECT_PB_STR)


//Definition for struct SIM_READ_EMERG_CODES_REQ


//Definition for struct SIM_READ_EMERG_CODES_REQ_NO_SERVICE_TYPE
#define SIM_READ_EMERG_CODES_REQ_NO_SERVICE_TYPE              0x3D                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) SIM_READ_EMERG_CODES_REQ_NO_SERVICE_TYPE_STR;
#define SIZE_SIM_READ_EMERG_CODES_REQ_NO_SERVICE_TYPE         sizeof(SIM_READ_EMERG_CODES_REQ_NO_SERVICE_TYPE_STR)


//Definition for struct SIM_READ_EMERG_CODES_RESP


//Definition for struct SIM_READ_EMERG_CODES_RESP_NO_SERVICE_TYPE
#define SIM_READ_EMERG_CODES_RESP_NO_SERVICE_TYPE             0x3E                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
             SIM_EMRG_CALL_CODES_STR    emergcodes[0];
            } __attribute__((packed)) SIM_READ_EMERG_CODES_RESP_NO_SERVICE_TYPE_STR;
#define SIZE_SIM_READ_EMERG_CODES_RESP_NO_SERVICE_TYPE        sizeof(SIM_READ_EMERG_CODES_RESP_NO_SERVICE_TYPE_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct SIM_GSM_DIR_REQ


//Definition for struct SIM_GSM_DIR_REQ_UPDATE_CB_MSGIDS
#define SIM_GSM_DIR_REQ_UPDATE_CB_MSGIDS                      0x3F                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      length;
             uint8_t      cell_bc_msg_ids[0];
            } __attribute__((packed)) SIM_GSM_DIR_REQ_UPDATE_CB_MSGIDS_STR;
#define SIZE_SIM_GSM_DIR_REQ_UPDATE_CB_MSGIDS                 sizeof(SIM_GSM_DIR_REQ_UPDATE_CB_MSGIDS_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct SIM_GSM_DIR_REQ


//Definition for struct SIM_GSM_DIR_REQ_READ_CB_MSG_IDS
#define SIM_GSM_DIR_REQ_READ_CB_MSG_IDS                       0x3F                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) SIM_GSM_DIR_REQ_READ_CB_MSG_IDS_STR;
#define SIZE_SIM_GSM_DIR_REQ_READ_CB_MSG_IDS                  sizeof(SIM_GSM_DIR_REQ_READ_CB_MSG_IDS_STR)


//Definition for struct SIM_GSM_DIR_RESP


//Definition for struct SIM_GSM_DIR_RESP_UPDATE_CB_MSGIDS
#define SIM_GSM_DIR_RESP_UPDATE_CB_MSGIDS                     0x40                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
            } __attribute__((packed)) SIM_GSM_DIR_RESP_UPDATE_CB_MSGIDS_STR;
#define SIZE_SIM_GSM_DIR_RESP_UPDATE_CB_MSGIDS                sizeof(SIM_GSM_DIR_RESP_UPDATE_CB_MSGIDS_STR)


//Definition for struct SIM_GSM_DIR_RESP


//Definition for struct SIM_GSM_DIR_RESP_READ_CB_MSG_IDS
#define SIM_GSM_DIR_RESP_READ_CB_MSG_IDS                      0x40                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
             uint8_t      cb_msgids[30];
            } __attribute__((packed)) SIM_GSM_DIR_RESP_READ_CB_MSG_IDS_STR;
#define SIZE_SIM_GSM_DIR_RESP_READ_CB_MSG_IDS                 sizeof(SIM_GSM_DIR_RESP_READ_CB_MSG_IDS_STR)


//Definition for struct SIM_NETWORK_INFO_REQ


//Definition for struct SIM_NETWORK_INFO_REQ_READ_HPLMN
#define SIM_NETWORK_INFO_REQ_READ_HPLMN                       0x19                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) SIM_NETWORK_INFO_REQ_READ_HPLMN_STR;
#define SIZE_SIM_NETWORK_INFO_REQ_READ_HPLMN                  sizeof(SIM_NETWORK_INFO_REQ_READ_HPLMN_STR)


//Definition for struct SIM_NETWORK_INFO_REQ


//Definition for struct SIM_NETWORK_INFO_REQ_WRITE_FIRST_PLMN
#define SIM_NETWORK_INFO_REQ_WRITE_FIRST_PLMN                 0x19                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      fillerbyte1;
             SIM_INFO_PLMN_STR    plmn[0];
            } __attribute__((packed)) SIM_NETWORK_INFO_REQ_WRITE_FIRST_PLMN_STR;
#define SIZE_SIM_NETWORK_INFO_REQ_WRITE_FIRST_PLMN            sizeof(SIM_NETWORK_INFO_REQ_WRITE_FIRST_PLMN_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct SIM_NETWORK_INFO_RESP


//Definition for struct SIM_NETWORK_INFO_RESP_READ_HPLMN
#define SIM_NETWORK_INFO_RESP_READ_HPLMN                      0x1A                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
             SIM_PLMNT_STRUCT_STR    hplmn[0];
            } __attribute__((packed)) SIM_NETWORK_INFO_RESP_READ_HPLMN_STR;
#define SIZE_SIM_NETWORK_INFO_RESP_READ_HPLMN                 sizeof(SIM_NETWORK_INFO_RESP_READ_HPLMN_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct SIM_NETWORK_INFO_RESP


//Definition for struct SIM_NETWORK_INFO_RESP_WRITE_FIRST_PLMN
#define SIM_NETWORK_INFO_RESP_WRITE_FIRST_PLMN                0x1A                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
            } __attribute__((packed)) SIM_NETWORK_INFO_RESP_WRITE_FIRST_PLMN_STR;
#define SIZE_SIM_NETWORK_INFO_RESP_WRITE_FIRST_PLMN           sizeof(SIM_NETWORK_INFO_RESP_WRITE_FIRST_PLMN_STR)


//Definition for struct SIM_CPHS_REQ


//Definition for struct SIM_CPHS_REQ_READ_DATA
#define SIM_CPHS_REQ_READ_DATA                                0x2F                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) SIM_CPHS_REQ_READ_DATA_STR;
#define SIZE_SIM_CPHS_REQ_READ_DATA                           sizeof(SIM_CPHS_REQ_READ_DATA_STR)


//Definition for struct SIM_CPHS_RESP


//Definition for struct SIM_CPHS_RESP_READ_DATA
#define SIM_CPHS_RESP_READ_DATA                               0x30                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
             uint8_t      mailboxnumbinfo;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
             uint8_t      phase;
             uint8_t      csp_allocated;
             uint8_t      csp_active;
             uint8_t      service_string_tbl_allocated;
             uint8_t      service_string_tbl_active;
             uint8_t      mailbox_numbers_allocated;
             uint8_t      mailbox_numbers_active;
             uint8_t      inf_nbr_allocated;
             uint8_t      inf_nbr_active;
             uint8_t      fillerbyte4;
             uint8_t      fillerbyte5;
            } __attribute__((packed)) SIM_CPHS_RESP_READ_DATA_STR;
#define SIZE_SIM_CPHS_RESP_READ_DATA                          sizeof(SIM_CPHS_RESP_READ_DATA_STR)


//Definition for struct SIM_READ_TABLE_REQ
#define SIM_READ_TABLE_REQ                                    0x13                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) SIM_READ_TABLE_REQ_STR;
#define SIZE_SIM_READ_TABLE_REQ                               sizeof(SIM_READ_TABLE_REQ_STR)


//Definition for struct SIM_READ_TABLE_RESP
#define SIM_READ_TABLE_RESP                                   0x14                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
            } __attribute__((packed)) SIM_READ_TABLE_RESP_STR;
#define SIZE_SIM_READ_TABLE_RESP                              sizeof(SIM_READ_TABLE_RESP_STR)


//Definition for struct SIM_OPERATOR_REQ


//Definition for struct SIM_OPERATOR_REQ_SIM_ST_READ_PNN
#define SIM_OPERATOR_REQ_SIM_ST_READ_PNN                      0x33                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      fillerbyte1;
             uint8_t      pnnidentifier;
            } __attribute__((packed)) SIM_OPERATOR_REQ_SIM_ST_READ_PNN_STR;
#define SIZE_SIM_OPERATOR_REQ_SIM_ST_READ_PNN                 sizeof(SIM_OPERATOR_REQ_SIM_ST_READ_PNN_STR)


//Definition for struct SIM_OPERATOR_REQ


//Definition for struct SIM_OPERATOR_REQ_SIM_ST_READ_OPL
#define SIM_OPERATOR_REQ_SIM_ST_READ_OPL                      0x33                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) SIM_OPERATOR_REQ_SIM_ST_READ_OPL_STR;
#define SIZE_SIM_OPERATOR_REQ_SIM_ST_READ_OPL                 sizeof(SIM_OPERATOR_REQ_SIM_ST_READ_OPL_STR)


//Definition for struct SIM_OPERATOR_REQ


//Definition for struct SIM_OPERATOR_REQ_READ_NAME
#define SIM_OPERATOR_REQ_READ_NAME                            0x33                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) SIM_OPERATOR_REQ_READ_NAME_STR;
#define SIZE_SIM_OPERATOR_REQ_READ_NAME                       sizeof(SIM_OPERATOR_REQ_READ_NAME_STR)


//Definition for struct SIM_OPERATOR_RESP


//Definition for struct SIM_OPERATOR_RESP_SIM_ST_READ_PNN
#define SIM_OPERATOR_RESP_SIM_ST_READ_PNN                     0x34                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
             uint8_t      pnnidentifier;
             uint8_t      numofsubblocks;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
            } __attribute__((packed)) SIM_OPERATOR_RESP_SIM_ST_READ_PNN_STR;
#define SIZE_SIM_OPERATOR_RESP_SIM_ST_READ_PNN                sizeof(SIM_OPERATOR_RESP_SIM_ST_READ_PNN_STR)


//Definition for struct SIM_OPERATOR_RESP


//Definition for struct SIM_OPERATOR_RESP_SIM_ST_READ_OPL
#define SIM_OPERATOR_RESP_SIM_ST_READ_OPL                     0x34                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
             uint8_t      numberofrecords;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
             SIM_OPL_STR    operatorplmnlist[0];
            } __attribute__((packed)) SIM_OPERATOR_RESP_SIM_ST_READ_OPL_STR;
#define SIZE_SIM_OPERATOR_RESP_SIM_ST_READ_OPL                sizeof(SIM_OPERATOR_RESP_SIM_ST_READ_OPL_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct SIM_OPERATOR_RESP


//Definition for struct SIM_OPERATOR_RESP_READ_NAME
#define SIM_OPERATOR_RESP_READ_NAME                           0x34                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
             SIM_SERV_OPERATOR_NAME_STR    operatorname[0];
            } __attribute__((packed)) SIM_OPERATOR_RESP_READ_NAME_STR;
#define SIZE_SIM_OPERATOR_RESP_READ_NAME                      sizeof(SIM_OPERATOR_RESP_READ_NAME_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct SIM_ICC_TYPE_REQ
#define SIM_ICC_TYPE_REQ                                      0xDE                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      cardreaderid;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
             uint8_t      noofsbid;
            } __attribute__((packed)) SIM_ICC_TYPE_REQ_STR;
#define SIZE_SIM_ICC_TYPE_REQ                                 sizeof(SIM_ICC_TYPE_REQ_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct SIM_ICC_TYPE_RESP
#define SIM_ICC_TYPE_RESP                                     0xDF                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
             uint8_t      cardreaderid;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      numberofsubblocks;
            } __attribute__((packed)) SIM_ICC_TYPE_RESP_STR;
#define SIZE_SIM_ICC_TYPE_RESP                                sizeof(SIM_ICC_TYPE_RESP_STR)


//Definition for struct SIM_READ_CI_REQ


//Definition for struct SIM_READ_CI_REQ_NO_SERVICE_TYPE
#define SIM_READ_CI_REQ_NO_SERVICE_TYPE                       0x60                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) SIM_READ_CI_REQ_NO_SERVICE_TYPE_STR;
#define SIZE_SIM_READ_CI_REQ_NO_SERVICE_TYPE                  sizeof(SIM_READ_CI_REQ_NO_SERVICE_TYPE_STR)


//Definition for struct SIM_READ_CI_RESP


//Definition for struct SIM_READ_CI_RESP_NO_SERVICE_TYPE
#define SIM_READ_CI_RESP_NO_SERVICE_TYPE                      0x61                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
            } __attribute__((packed)) SIM_READ_CI_RESP_NO_SERVICE_TYPE_STR;
#define SIZE_SIM_READ_CI_RESP_NO_SERVICE_TYPE                 sizeof(SIM_READ_CI_RESP_NO_SERVICE_TYPE_STR)


//Definition for struct SIM_READ_ACM_ACCESS_REQ
#define SIM_READ_ACM_ACCESS_REQ                               0x39                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
            } __attribute__((packed)) SIM_READ_ACM_ACCESS_REQ_STR;
#define SIZE_SIM_READ_ACM_ACCESS_REQ                          sizeof(SIM_READ_ACM_ACCESS_REQ_STR)


//Definition for struct SIM_READ_ACM_ACCESS_RESP
#define SIM_READ_ACM_ACCESS_RESP                              0x3A                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
             uint8_t      condition;
            } __attribute__((packed)) SIM_READ_ACM_ACCESS_RESP_STR;
#define SIZE_SIM_READ_ACM_ACCESS_RESP                         sizeof(SIM_READ_ACM_ACCESS_RESP_STR)


//Definition for struct SIM_ACM_REQ


//Definition for struct SIM_ACM_REQ_SIM_ST_INCREMENT
#define SIM_ACM_REQ_SIM_ST_INCREMENT                          0x15                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      fillerbyte1;
             SIM_ACM_STR    value[0];
             uint8_t      line;
            } __attribute__((packed)) SIM_ACM_REQ_SIM_ST_INCREMENT_STR;
#define SIZE_SIM_ACM_REQ_SIM_ST_INCREMENT                     sizeof(SIM_ACM_REQ_SIM_ST_INCREMENT_STR)


//Definition for struct SIM_ACM_REQ


//Definition for struct SIM_ACM_REQ_SIM_ST_SET
#define SIM_ACM_REQ_SIM_ST_SET                                0x15                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      fillerbyte1;
             SIM_ACM_STR    value[0];
             uint8_t      line;
            } __attribute__((packed)) SIM_ACM_REQ_SIM_ST_SET_STR;
#define SIZE_SIM_ACM_REQ_SIM_ST_SET                           sizeof(SIM_ACM_REQ_SIM_ST_SET_STR)


//Definition for struct SIM_ACM_REQ


//Definition for struct SIM_ACM_REQ_SIM_ST_MAX_VALUE_SET
#define SIM_ACM_REQ_SIM_ST_MAX_VALUE_SET                      0x15                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      fillerbyte1;
             SIM_ACM_MAX_VALUE_STR    value[0];
            } __attribute__((packed)) SIM_ACM_REQ_SIM_ST_MAX_VALUE_SET_STR;
#define SIZE_SIM_ACM_REQ_SIM_ST_MAX_VALUE_SET                 sizeof(SIM_ACM_REQ_SIM_ST_MAX_VALUE_SET_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct SIM_ACM_REQ


//Definition for struct SIM_ACM_REQ_SIM_ST_READ_AOC
#define SIM_ACM_REQ_SIM_ST_READ_AOC                           0x15                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      line;
            } __attribute__((packed)) SIM_ACM_REQ_SIM_ST_READ_AOC_STR;
#define SIZE_SIM_ACM_REQ_SIM_ST_READ_AOC                      sizeof(SIM_ACM_REQ_SIM_ST_READ_AOC_STR)


//Definition for struct SIM_ACM_REQ


//Definition for struct SIM_ACM_REQ_SIM_ST_MAX_VALUE_READ
#define SIM_ACM_REQ_SIM_ST_MAX_VALUE_READ                     0x15                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
            } __attribute__((packed)) SIM_ACM_REQ_SIM_ST_MAX_VALUE_READ_STR;
#define SIZE_SIM_ACM_REQ_SIM_ST_MAX_VALUE_READ                sizeof(SIM_ACM_REQ_SIM_ST_MAX_VALUE_READ_STR)


//Definition for struct SIM_ACM_RESP


//Definition for struct SIM_ACM_RESP_SIM_ST_INCREMENT
#define SIM_ACM_RESP_SIM_ST_INCREMENT                         0x16                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
            } __attribute__((packed)) SIM_ACM_RESP_SIM_ST_INCREMENT_STR;
#define SIZE_SIM_ACM_RESP_SIM_ST_INCREMENT                    sizeof(SIM_ACM_RESP_SIM_ST_INCREMENT_STR)


//Definition for struct SIM_ACM_RESP


//Definition for struct SIM_ACM_RESP_SIM_ST_SET
#define SIM_ACM_RESP_SIM_ST_SET                               0x16                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
            } __attribute__((packed)) SIM_ACM_RESP_SIM_ST_SET_STR;
#define SIZE_SIM_ACM_RESP_SIM_ST_SET                          sizeof(SIM_ACM_RESP_SIM_ST_SET_STR)


//Definition for struct SIM_ACM_RESP


//Definition for struct SIM_ACM_RESP_SIM_ST_MAX_VALUE_SET
#define SIM_ACM_RESP_SIM_ST_MAX_VALUE_SET                     0x16                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
            } __attribute__((packed)) SIM_ACM_RESP_SIM_ST_MAX_VALUE_SET_STR;
#define SIZE_SIM_ACM_RESP_SIM_ST_MAX_VALUE_SET                sizeof(SIM_ACM_RESP_SIM_ST_MAX_VALUE_SET_STR)


//Definition for struct SIM_ACM_RESP


//Definition for struct SIM_ACM_RESP_SIM_ST_READ_AOC
#define SIM_ACM_RESP_SIM_ST_READ_AOC                          0x16                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
             SIM_ACM_STR    value[0];
             uint8_t      line;
            } __attribute__((packed)) SIM_ACM_RESP_SIM_ST_READ_AOC_STR;
#define SIZE_SIM_ACM_RESP_SIM_ST_READ_AOC                     sizeof(SIM_ACM_RESP_SIM_ST_READ_AOC_STR)


//Definition for struct SIM_ACM_RESP


//Definition for struct SIM_ACM_RESP_SIM_ST_MAX_VALUE_READ
#define SIM_ACM_RESP_SIM_ST_MAX_VALUE_READ                    0x16                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
             SIM_ACM_STR    value[0];
            } __attribute__((packed)) SIM_ACM_RESP_SIM_ST_MAX_VALUE_READ_STR;
#define SIZE_SIM_ACM_RESP_SIM_ST_MAX_VALUE_READ               sizeof(SIM_ACM_RESP_SIM_ST_MAX_VALUE_READ_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct SIM_CSP_REQ


//Definition for struct SIM_CSP_REQ_READ_LINE_DATA
#define SIM_CSP_REQ_READ_LINE_DATA                            0x31                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      fillerbyte1;
             uint8_t      line;
            } __attribute__((packed)) SIM_CSP_REQ_READ_LINE_DATA_STR;
#define SIZE_SIM_CSP_REQ_READ_LINE_DATA                       sizeof(SIM_CSP_REQ_READ_LINE_DATA_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct SIM_CSP_RESP


//Definition for struct SIM_CSP_RESP_READ_LINE_DATA
#define SIM_CSP_RESP_READ_LINE_DATA                           0x32                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
             CSP_OPTIONALS_STR    optionaldata[0];
             SIM_SERV_CSP_STR    csp_data[0];
            } __attribute__((packed)) SIM_CSP_RESP_READ_LINE_DATA_STR;
#define SIZE_SIM_CSP_RESP_READ_LINE_DATA                      sizeof(SIM_CSP_RESP_READ_LINE_DATA_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct SIM_SAT_REQ


//Definition for struct SIM_SAT_REQ_READ_CBMIDS
#define SIM_SAT_REQ_READ_CBMIDS                               0xD0                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) SIM_SAT_REQ_READ_CBMIDS_STR;
#define SIZE_SIM_SAT_REQ_READ_CBMIDS                          sizeof(SIM_SAT_REQ_READ_CBMIDS_STR)


//Definition for struct SIM_SAT_RESP


//Definition for struct SIM_SAT_RESP_READ_CBMIDS
#define SIM_SAT_RESP_READ_CBMIDS                              0xD1                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
             uint8_t      ef_cbmid_count;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
             SIM_INFO_CBMID_STR    ef_cbmid[0];
            } __attribute__((packed)) SIM_SAT_RESP_READ_CBMIDS_STR;
#define SIZE_SIM_SAT_RESP_READ_CBMIDS                         sizeof(SIM_SAT_RESP_READ_CBMIDS_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct SIM_VIAG_HOME_ZONE_REQ


//Definition for struct SIM_VIAG_HOME_ZONE_REQ_READ_PARAM
#define SIM_VIAG_HOME_ZONE_REQ_READ_PARAM                     0x62                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      paddingbyte;
            } __attribute__((packed)) SIM_VIAG_HOME_ZONE_REQ_READ_PARAM_STR;
#define SIZE_SIM_VIAG_HOME_ZONE_REQ_READ_PARAM                sizeof(SIM_VIAG_HOME_ZONE_REQ_READ_PARAM_STR)


//Definition for struct SIM_VIAG_HOME_ZONE_REQ


//Definition for struct SIM_VIAG_HOME_ZONE_REQ_READ_CACHE
#define SIM_VIAG_HOME_ZONE_REQ_READ_CACHE                     0x62                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      cache;
             uint8_t      recordnumber;
            } __attribute__((packed)) SIM_VIAG_HOME_ZONE_REQ_READ_CACHE_STR;
#define SIZE_SIM_VIAG_HOME_ZONE_REQ_READ_CACHE                sizeof(SIM_VIAG_HOME_ZONE_REQ_READ_CACHE_STR)


//Definition for struct SIM_VIAG_HOME_ZONE_REQ


//Definition for struct SIM_VIAG_HOME_ZONE_REQ_WRITE_CACHE
#define SIM_VIAG_HOME_ZONE_REQ_WRITE_CACHE                    0x62                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      cache;
             uint16_t     lac;
             uint16_t     cellid;
             uint8_t      recordnumber;
            } __attribute__((packed)) SIM_VIAG_HOME_ZONE_REQ_WRITE_CACHE_STR;
#define SIZE_SIM_VIAG_HOME_ZONE_REQ_WRITE_CACHE               sizeof(SIM_VIAG_HOME_ZONE_REQ_WRITE_CACHE_STR)


//Definition for struct SIM_VIAG_HOME_ZONE_REQ


//Definition for struct SIM_VIAG_HOME_ZONE_REQ_SIM_ST_READ_SUBSCRIBED_LAC_CI
#define SIM_VIAG_HOME_ZONE_REQ_SIM_ST_READ_SUBSCRIBED_LAC_CI    0x62                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      subscribedlacci;
            } __attribute__((packed)) SIM_VIAG_HOME_ZONE_REQ_SIM_ST_READ_SUBSCRIBED_LAC_CI_STR;
#define SIZE_SIM_VIAG_HOME_ZONE_REQ_SIM_ST_READ_SUBSCRIBED_LAC_CI    sizeof(SIM_VIAG_HOME_ZONE_REQ_SIM_ST_READ_SUBSCRIBED_LAC_CI_STR)


//Definition for struct SIM_VIAG_HOME_ZONE_REQ


//Definition for struct SIM_VIAG_HOME_ZONE_REQ_SIM_ST_READ_HZ_TAGS
#define SIM_VIAG_HOME_ZONE_REQ_SIM_ST_READ_HZ_TAGS            0x62                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      zonenumber;
            } __attribute__((packed)) SIM_VIAG_HOME_ZONE_REQ_SIM_ST_READ_HZ_TAGS_STR;
#define SIZE_SIM_VIAG_HOME_ZONE_REQ_SIM_ST_READ_HZ_TAGS       sizeof(SIM_VIAG_HOME_ZONE_REQ_SIM_ST_READ_HZ_TAGS_STR)


//Definition for struct SIM_VIAG_HOME_ZONE_REQ


//Definition for struct SIM_VIAG_HOME_ZONE_REQ_SIM_ST_READ_UHZIUE_SETTINGS
#define SIM_VIAG_HOME_ZONE_REQ_SIM_ST_READ_UHZIUE_SETTINGS    0x62                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) SIM_VIAG_HOME_ZONE_REQ_SIM_ST_READ_UHZIUE_SETTINGS_STR;
#define SIZE_SIM_VIAG_HOME_ZONE_REQ_SIM_ST_READ_UHZIUE_SETTINGS    sizeof(SIM_VIAG_HOME_ZONE_REQ_SIM_ST_READ_UHZIUE_SETTINGS_STR)


//Definition for struct SIM_VIAG_HOME_ZONE_REQ


//Definition for struct SIM_VIAG_HOME_ZONE_REQ_SIM_ST_WRITE_UHZIUE_SETTINGS
#define SIM_VIAG_HOME_ZONE_REQ_SIM_ST_WRITE_UHZIUE_SETTINGS    0x62                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
             uint16_t     datalength;
             uint8_t      data[0];
            } __attribute__((packed)) SIM_VIAG_HOME_ZONE_REQ_SIM_ST_WRITE_UHZIUE_SETTINGS_STR;
#define SIZE_SIM_VIAG_HOME_ZONE_REQ_SIM_ST_WRITE_UHZIUE_SETTINGS    sizeof(SIM_VIAG_HOME_ZONE_REQ_SIM_ST_WRITE_UHZIUE_SETTINGS_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct SIM_VIAG_HOME_ZONE_RESP


//Definition for struct SIM_VIAG_HOME_ZONE_RESP_READ_PARAM
#define SIM_VIAG_HOME_ZONE_RESP_READ_PARAM                    0x63                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
             uint8_t      smscnumber[30];
             uint8_t      scpnumber[30];
             uint8_t      subscriptionversion;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
             SIM_VIAG_HOME_ZONE_SEQ_STR    element[160];
            } __attribute__((packed)) SIM_VIAG_HOME_ZONE_RESP_READ_PARAM_STR;
#define SIZE_SIM_VIAG_HOME_ZONE_RESP_READ_PARAM               sizeof(SIM_VIAG_HOME_ZONE_RESP_READ_PARAM_STR)


//Definition for struct SIM_VIAG_HOME_ZONE_RESP


//Definition for struct SIM_VIAG_HOME_ZONE_RESP_READ_CACHE
#define SIM_VIAG_HOME_ZONE_RESP_READ_CACHE                    0x63                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
             uint16_t     lac;
             uint16_t     cellid;
            } __attribute__((packed)) SIM_VIAG_HOME_ZONE_RESP_READ_CACHE_STR;
#define SIZE_SIM_VIAG_HOME_ZONE_RESP_READ_CACHE               sizeof(SIM_VIAG_HOME_ZONE_RESP_READ_CACHE_STR)


//Definition for struct SIM_VIAG_HOME_ZONE_RESP


//Definition for struct SIM_VIAG_HOME_ZONE_RESP_WRITE_CACHE
#define SIM_VIAG_HOME_ZONE_RESP_WRITE_CACHE                   0x63                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
            } __attribute__((packed)) SIM_VIAG_HOME_ZONE_RESP_WRITE_CACHE_STR;
#define SIZE_SIM_VIAG_HOME_ZONE_RESP_WRITE_CACHE              sizeof(SIM_VIAG_HOME_ZONE_RESP_WRITE_CACHE_STR)


//Definition for struct SIM_VIAG_HOME_ZONE_RESP


//Definition for struct SIM_VIAG_HOME_ZONE_RESP_SIM_ST_READ_SUBSCRIBED_LAC_CI
#define SIM_VIAG_HOME_ZONE_RESP_SIM_ST_READ_SUBSCRIBED_LAC_CI    0x63                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint16_t     datalength;
             uint8_t      data[0];
            } __attribute__((packed)) SIM_VIAG_HOME_ZONE_RESP_SIM_ST_READ_SUBSCRIBED_LAC_CI_STR;
#define SIZE_SIM_VIAG_HOME_ZONE_RESP_SIM_ST_READ_SUBSCRIBED_LAC_CI    sizeof(SIM_VIAG_HOME_ZONE_RESP_SIM_ST_READ_SUBSCRIBED_LAC_CI_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct SIM_VIAG_HOME_ZONE_RESP


//Definition for struct SIM_VIAG_HOME_ZONE_RESP_SIM_ST_READ_HZ_TAGS
#define SIM_VIAG_HOME_ZONE_RESP_SIM_ST_READ_HZ_TAGS           0x63                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint16_t     datalength;
             uint8_t      data[0];
            } __attribute__((packed)) SIM_VIAG_HOME_ZONE_RESP_SIM_ST_READ_HZ_TAGS_STR;
#define SIZE_SIM_VIAG_HOME_ZONE_RESP_SIM_ST_READ_HZ_TAGS      sizeof(SIM_VIAG_HOME_ZONE_RESP_SIM_ST_READ_HZ_TAGS_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct SIM_VIAG_HOME_ZONE_RESP


//Definition for struct SIM_VIAG_HOME_ZONE_RESP_SIM_ST_READ_UHZIUE_SETTINGS
#define SIM_VIAG_HOME_ZONE_RESP_SIM_ST_READ_UHZIUE_SETTINGS    0x63                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint16_t     datalength;
             uint8_t      data[0];
            } __attribute__((packed)) SIM_VIAG_HOME_ZONE_RESP_SIM_ST_READ_UHZIUE_SETTINGS_STR;
#define SIZE_SIM_VIAG_HOME_ZONE_RESP_SIM_ST_READ_UHZIUE_SETTINGS    sizeof(SIM_VIAG_HOME_ZONE_RESP_SIM_ST_READ_UHZIUE_SETTINGS_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct SIM_VIAG_HOME_ZONE_RESP


//Definition for struct SIM_VIAG_HOME_ZONE_RESP_SIM_ST_WRITE_UHZIUE_SETTINGS
#define SIM_VIAG_HOME_ZONE_RESP_SIM_ST_WRITE_UHZIUE_SETTINGS    0x63                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
            } __attribute__((packed)) SIM_VIAG_HOME_ZONE_RESP_SIM_ST_WRITE_UHZIUE_SETTINGS_STR;
#define SIZE_SIM_VIAG_HOME_ZONE_RESP_SIM_ST_WRITE_UHZIUE_SETTINGS    sizeof(SIM_VIAG_HOME_ZONE_RESP_SIM_ST_WRITE_UHZIUE_SETTINGS_STR)


//Definition for struct SIM_REFRESH_REQ


//Definition for struct SIM_REFRESH_REQ_SIM_ST_REFRESH_REGISTER
#define SIM_REFRESH_REQ_SIM_ST_REFRESH_REGISTER               0xE4                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      numberoffiles;
             SIM_REFRESH_FILE_LIST_STR    filelist[0];
            } __attribute__((packed)) SIM_REFRESH_REQ_SIM_ST_REFRESH_REGISTER_STR;
#define SIZE_SIM_REFRESH_REQ_SIM_ST_REFRESH_REGISTER          sizeof(SIM_REFRESH_REQ_SIM_ST_REFRESH_REGISTER_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct SIM_REFRESH_REQ


//Definition for struct SIM_REFRESH_REQ_SIM_ST_REFRESH_UNREGISTER
#define SIM_REFRESH_REQ_SIM_ST_REFRESH_UNREGISTER             0xE4                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) SIM_REFRESH_REQ_SIM_ST_REFRESH_UNREGISTER_STR;
#define SIZE_SIM_REFRESH_REQ_SIM_ST_REFRESH_UNREGISTER        sizeof(SIM_REFRESH_REQ_SIM_ST_REFRESH_UNREGISTER_STR)


//Definition for struct SIM_REFRESH_REQ


//Definition for struct SIM_REFRESH_REQ_SIM_ST_REFRESH_OK
#define SIM_REFRESH_REQ_SIM_ST_REFRESH_OK                     0xE4                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) SIM_REFRESH_REQ_SIM_ST_REFRESH_OK_STR;
#define SIZE_SIM_REFRESH_REQ_SIM_ST_REFRESH_OK                sizeof(SIM_REFRESH_REQ_SIM_ST_REFRESH_OK_STR)


//Definition for struct SIM_REFRESH_REQ


//Definition for struct SIM_REFRESH_REQ_SIM_ST_REFRESH_NOT_OK
#define SIM_REFRESH_REQ_SIM_ST_REFRESH_NOT_OK                 0xE4                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) SIM_REFRESH_REQ_SIM_ST_REFRESH_NOT_OK_STR;
#define SIZE_SIM_REFRESH_REQ_SIM_ST_REFRESH_NOT_OK            sizeof(SIM_REFRESH_REQ_SIM_ST_REFRESH_NOT_OK_STR)


//Definition for struct SIM_REFRESH_REQ


//Definition for struct SIM_REFRESH_REQ_SIM_ST_REFRESH_DONE
#define SIM_REFRESH_REQ_SIM_ST_REFRESH_DONE                   0xE4                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) SIM_REFRESH_REQ_SIM_ST_REFRESH_DONE_STR;
#define SIZE_SIM_REFRESH_REQ_SIM_ST_REFRESH_DONE              sizeof(SIM_REFRESH_REQ_SIM_ST_REFRESH_DONE_STR)


//Definition for struct SIM_REFRESH_REQ


//Definition for struct SIM_REFRESH_REQ_SIM_ST_REFRESH_ERROR
#define SIM_REFRESH_REQ_SIM_ST_REFRESH_ERROR                  0xE4                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) SIM_REFRESH_REQ_SIM_ST_REFRESH_ERROR_STR;
#define SIZE_SIM_REFRESH_REQ_SIM_ST_REFRESH_ERROR             sizeof(SIM_REFRESH_REQ_SIM_ST_REFRESH_ERROR_STR)


//Definition for struct SIM_REFRESH_RESP


//Definition for struct SIM_REFRESH_RESP_SIM_ST_REFRESH_REGISTER
#define SIM_REFRESH_RESP_SIM_ST_REFRESH_REGISTER              0xE5                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
            } __attribute__((packed)) SIM_REFRESH_RESP_SIM_ST_REFRESH_REGISTER_STR;
#define SIZE_SIM_REFRESH_RESP_SIM_ST_REFRESH_REGISTER         sizeof(SIM_REFRESH_RESP_SIM_ST_REFRESH_REGISTER_STR)


//Definition for struct SIM_REFRESH_RESP


//Definition for struct SIM_REFRESH_RESP_SIM_ST_REFRESH_UNREGISTER
#define SIM_REFRESH_RESP_SIM_ST_REFRESH_UNREGISTER            0xE5                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
            } __attribute__((packed)) SIM_REFRESH_RESP_SIM_ST_REFRESH_UNREGISTER_STR;
#define SIZE_SIM_REFRESH_RESP_SIM_ST_REFRESH_UNREGISTER       sizeof(SIM_REFRESH_RESP_SIM_ST_REFRESH_UNREGISTER_STR)


//Definition for struct SIM_REFRESH_RESP


//Definition for struct SIM_REFRESH_RESP_SIM_ST_REFRESH_OK
#define SIM_REFRESH_RESP_SIM_ST_REFRESH_OK                    0xE5                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
            } __attribute__((packed)) SIM_REFRESH_RESP_SIM_ST_REFRESH_OK_STR;
#define SIZE_SIM_REFRESH_RESP_SIM_ST_REFRESH_OK               sizeof(SIM_REFRESH_RESP_SIM_ST_REFRESH_OK_STR)


//Definition for struct SIM_REFRESH_RESP


//Definition for struct SIM_REFRESH_RESP_SIM_ST_REFRESH_NOT_OK
#define SIM_REFRESH_RESP_SIM_ST_REFRESH_NOT_OK                0xE5                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
            } __attribute__((packed)) SIM_REFRESH_RESP_SIM_ST_REFRESH_NOT_OK_STR;
#define SIZE_SIM_REFRESH_RESP_SIM_ST_REFRESH_NOT_OK           sizeof(SIM_REFRESH_RESP_SIM_ST_REFRESH_NOT_OK_STR)


//Definition for struct SIM_REFRESH_RESP


//Definition for struct SIM_REFRESH_RESP_SIM_ST_REFRESH_DONE
#define SIM_REFRESH_RESP_SIM_ST_REFRESH_DONE                  0xE5                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
            } __attribute__((packed)) SIM_REFRESH_RESP_SIM_ST_REFRESH_DONE_STR;
#define SIZE_SIM_REFRESH_RESP_SIM_ST_REFRESH_DONE             sizeof(SIM_REFRESH_RESP_SIM_ST_REFRESH_DONE_STR)


//Definition for struct SIM_REFRESH_RESP


//Definition for struct SIM_REFRESH_RESP_SIM_ST_REFRESH_ERROR
#define SIM_REFRESH_RESP_SIM_ST_REFRESH_ERROR                 0xE5                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
            } __attribute__((packed)) SIM_REFRESH_RESP_SIM_ST_REFRESH_ERROR_STR;
#define SIZE_SIM_REFRESH_RESP_SIM_ST_REFRESH_ERROR            sizeof(SIM_REFRESH_RESP_SIM_ST_REFRESH_ERROR_STR)


//Definition for struct SIM_REFRESH_NTF


//Definition for struct SIM_REFRESH_NTF_SIM_ST_REFRESH_REQUESTED
#define SIM_REFRESH_NTF_SIM_ST_REFRESH_REQUESTED              0xE6                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      numberoffiles;
             uint8_t      filelist[0];
            } __attribute__((packed)) SIM_REFRESH_NTF_SIM_ST_REFRESH_REQUESTED_STR;
#define SIZE_SIM_REFRESH_NTF_SIM_ST_REFRESH_REQUESTED         sizeof(SIM_REFRESH_NTF_SIM_ST_REFRESH_REQUESTED_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct SIM_REFRESH_NTF


//Definition for struct SIM_REFRESH_NTF_SIM_ST_REFRESH_NOW
#define SIM_REFRESH_NTF_SIM_ST_REFRESH_NOW                    0xE6                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      numberoffiles;
             uint8_t      filelist[0];
            } __attribute__((packed)) SIM_REFRESH_NTF_SIM_ST_REFRESH_NOW_STR;
#define SIZE_SIM_REFRESH_NTF_SIM_ST_REFRESH_NOW               sizeof(SIM_REFRESH_NTF_SIM_ST_REFRESH_NOW_STR)
//NOTE: Definition contains variable size field(s). SIZE_ and offsets following variable field cannot be defined correctly.


//Definition for struct SIM_REFRESH_NTF


//Definition for struct SIM_REFRESH_NTF_SIM_ST_REFRESH_CANCELLED
#define SIM_REFRESH_NTF_SIM_ST_REFRESH_CANCELLED              0xE6                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) SIM_REFRESH_NTF_SIM_ST_REFRESH_CANCELLED_STR;
#define SIZE_SIM_REFRESH_NTF_SIM_ST_REFRESH_CANCELLED         sizeof(SIM_REFRESH_NTF_SIM_ST_REFRESH_CANCELLED_STR)


//Definition for struct SIM_REFRESH_NTF


//Definition for struct SIM_REFRESH_NTF_SIM_ST_REFRESH_STARTING
#define SIM_REFRESH_NTF_SIM_ST_REFRESH_STARTING               0xE6                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) SIM_REFRESH_NTF_SIM_ST_REFRESH_STARTING_STR;
#define SIZE_SIM_REFRESH_NTF_SIM_ST_REFRESH_STARTING          sizeof(SIM_REFRESH_NTF_SIM_ST_REFRESH_STARTING_STR)


//Definition for struct SIM_MMS_REQ


//Definition for struct SIM_MMS_REQ_SIM_ST_MMS_ICP_READ
#define SIM_MMS_REQ_SIM_ST_MMS_ICP_READ                       0x6A                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) SIM_MMS_REQ_SIM_ST_MMS_ICP_READ_STR;
#define SIZE_SIM_MMS_REQ_SIM_ST_MMS_ICP_READ                  sizeof(SIM_MMS_REQ_SIM_ST_MMS_ICP_READ_STR)


//Definition for struct SIM_MMS_REQ


//Definition for struct SIM_MMS_REQ_SIM_ST_MMS_UP_READ
#define SIM_MMS_REQ_SIM_ST_MMS_UP_READ                        0x6A                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) SIM_MMS_REQ_SIM_ST_MMS_UP_READ_STR;
#define SIZE_SIM_MMS_REQ_SIM_ST_MMS_UP_READ                   sizeof(SIM_MMS_REQ_SIM_ST_MMS_UP_READ_STR)


//Definition for struct SIM_MMS_RESP


//Definition for struct SIM_MMS_RESP_SIM_ST_MMS_ICP_READ
#define SIM_MMS_RESP_SIM_ST_MMS_ICP_READ                      0x6B                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
             uint8_t      numberofsubblocks;
            } __attribute__((packed)) SIM_MMS_RESP_SIM_ST_MMS_ICP_READ_STR;
#define SIZE_SIM_MMS_RESP_SIM_ST_MMS_ICP_READ                 sizeof(SIM_MMS_RESP_SIM_ST_MMS_ICP_READ_STR)


//Definition for struct SIM_MMS_RESP


//Definition for struct SIM_MMS_RESP_SIM_ST_MMS_UP_READ
#define SIM_MMS_RESP_SIM_ST_MMS_UP_READ                       0x6B                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
             uint8_t      numberofsubblocks;
            } __attribute__((packed)) SIM_MMS_RESP_SIM_ST_MMS_UP_READ_STR;
#define SIZE_SIM_MMS_RESP_SIM_ST_MMS_UP_READ                  sizeof(SIM_MMS_RESP_SIM_ST_MMS_UP_READ_STR)


//Definition for struct SIM_IMS_REQ


//Definition for struct SIM_IMS_REQ_SIM_ST_IMS_START_SESSION
#define SIM_IMS_REQ_SIM_ST_IMS_START_SESSION                  0x6C                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) SIM_IMS_REQ_SIM_ST_IMS_START_SESSION_STR;
#define SIZE_SIM_IMS_REQ_SIM_ST_IMS_START_SESSION             sizeof(SIM_IMS_REQ_SIM_ST_IMS_START_SESSION_STR)


//Definition for struct SIM_IMS_REQ


//Definition for struct SIM_IMS_REQ_SIM_ST_IMS_END_SESSION
#define SIM_IMS_REQ_SIM_ST_IMS_END_SESSION                    0x6C                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) SIM_IMS_REQ_SIM_ST_IMS_END_SESSION_STR;
#define SIZE_SIM_IMS_REQ_SIM_ST_IMS_END_SESSION               sizeof(SIM_IMS_REQ_SIM_ST_IMS_END_SESSION_STR)


//Definition for struct SIM_IMS_REQ


//Definition for struct SIM_IMS_REQ_SIM_ST_IMS_STATUS
#define SIM_IMS_REQ_SIM_ST_IMS_STATUS                         0x6C                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) SIM_IMS_REQ_SIM_ST_IMS_STATUS_STR;
#define SIZE_SIM_IMS_REQ_SIM_ST_IMS_STATUS                    sizeof(SIM_IMS_REQ_SIM_ST_IMS_STATUS_STR)


//Definition for struct SIM_IMS_REQ


//Definition for struct SIM_IMS_REQ_SIM_ST_IMS_READ_DATA
#define SIM_IMS_REQ_SIM_ST_IMS_READ_DATA                      0x6C                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      numberofsubblocks;
            } __attribute__((packed)) SIM_IMS_REQ_SIM_ST_IMS_READ_DATA_STR;
#define SIZE_SIM_IMS_REQ_SIM_ST_IMS_READ_DATA                 sizeof(SIM_IMS_REQ_SIM_ST_IMS_READ_DATA_STR)


//Definition for struct SIM_IMS_RESP


//Definition for struct SIM_IMS_RESP_SIM_ST_IMS_START_SESSION
#define SIM_IMS_RESP_SIM_ST_IMS_START_SESSION                 0x6D                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
            } __attribute__((packed)) SIM_IMS_RESP_SIM_ST_IMS_START_SESSION_STR;
#define SIZE_SIM_IMS_RESP_SIM_ST_IMS_START_SESSION            sizeof(SIM_IMS_RESP_SIM_ST_IMS_START_SESSION_STR)


//Definition for struct SIM_IMS_RESP


//Definition for struct SIM_IMS_RESP_SIM_ST_IMS_END_SESSION
#define SIM_IMS_RESP_SIM_ST_IMS_END_SESSION                   0x6D                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
            } __attribute__((packed)) SIM_IMS_RESP_SIM_ST_IMS_END_SESSION_STR;
#define SIZE_SIM_IMS_RESP_SIM_ST_IMS_END_SESSION              sizeof(SIM_IMS_RESP_SIM_ST_IMS_END_SESSION_STR)


//Definition for struct SIM_IMS_RESP


//Definition for struct SIM_IMS_RESP_SIM_ST_IMS_STATUS
#define SIM_IMS_RESP_SIM_ST_IMS_STATUS                        0x6D                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
            } __attribute__((packed)) SIM_IMS_RESP_SIM_ST_IMS_STATUS_STR;
#define SIZE_SIM_IMS_RESP_SIM_ST_IMS_STATUS                   sizeof(SIM_IMS_RESP_SIM_ST_IMS_STATUS_STR)


//Definition for struct SIM_IMS_RESP


//Definition for struct SIM_IMS_RESP_SIM_ST_IMS_READ_DATA
#define SIM_IMS_RESP_SIM_ST_IMS_READ_DATA                     0x6D                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
             uint8_t      numberofsubblocks;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
            } __attribute__((packed)) SIM_IMS_RESP_SIM_ST_IMS_READ_DATA_STR;
#define SIZE_SIM_IMS_RESP_SIM_ST_IMS_READ_DATA                sizeof(SIM_IMS_RESP_SIM_ST_IMS_READ_DATA_STR)


//Definition for struct SIM_TRACFONE_REQ


//Definition for struct SIM_TRACFONE_REQ_SIM_ST_TRACFONE_STATUS
#define SIM_TRACFONE_REQ_SIM_ST_TRACFONE_STATUS               0x75                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) SIM_TRACFONE_REQ_SIM_ST_TRACFONE_STATUS_STR;
#define SIZE_SIM_TRACFONE_REQ_SIM_ST_TRACFONE_STATUS          sizeof(SIM_TRACFONE_REQ_SIM_ST_TRACFONE_STATUS_STR)


//Definition for struct SIM_TRACFONE_REQ


//Definition for struct SIM_TRACFONE_REQ_SIM_ST_TRACFONE_COMPLETED_SUCCESS
#define SIM_TRACFONE_REQ_SIM_ST_TRACFONE_COMPLETED_SUCCESS    0x75                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) SIM_TRACFONE_REQ_SIM_ST_TRACFONE_COMPLETED_SUCCESS_STR;
#define SIZE_SIM_TRACFONE_REQ_SIM_ST_TRACFONE_COMPLETED_SUCCESS    sizeof(SIM_TRACFONE_REQ_SIM_ST_TRACFONE_COMPLETED_SUCCESS_STR)


//Definition for struct SIM_TRACFONE_REQ


//Definition for struct SIM_TRACFONE_REQ_SIM_ST_TRACFONE_COMPLETED_FAIL
#define SIM_TRACFONE_REQ_SIM_ST_TRACFONE_COMPLETED_FAIL       0x75                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) SIM_TRACFONE_REQ_SIM_ST_TRACFONE_COMPLETED_FAIL_STR;
#define SIZE_SIM_TRACFONE_REQ_SIM_ST_TRACFONE_COMPLETED_FAIL    sizeof(SIM_TRACFONE_REQ_SIM_ST_TRACFONE_COMPLETED_FAIL_STR)


//Definition for struct SIM_TRACFONE_RESP


//Definition for struct SIM_TRACFONE_RESP_SIM_ST_TRACFONE_STATUS
#define SIM_TRACFONE_RESP_SIM_ST_TRACFONE_STATUS              0x76                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
            } __attribute__((packed)) SIM_TRACFONE_RESP_SIM_ST_TRACFONE_STATUS_STR;
#define SIZE_SIM_TRACFONE_RESP_SIM_ST_TRACFONE_STATUS         sizeof(SIM_TRACFONE_RESP_SIM_ST_TRACFONE_STATUS_STR)


//Definition for struct SIM_TRACFONE_RESP


//Definition for struct SIM_TRACFONE_RESP_SIM_ST_TRACFONE_COMPLETED_SUCCESS
#define SIM_TRACFONE_RESP_SIM_ST_TRACFONE_COMPLETED_SUCCESS    0x76                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
            } __attribute__((packed)) SIM_TRACFONE_RESP_SIM_ST_TRACFONE_COMPLETED_SUCCESS_STR;
#define SIZE_SIM_TRACFONE_RESP_SIM_ST_TRACFONE_COMPLETED_SUCCESS    sizeof(SIM_TRACFONE_RESP_SIM_ST_TRACFONE_COMPLETED_SUCCESS_STR)


//Definition for struct SIM_TRACFONE_RESP


//Definition for struct SIM_TRACFONE_RESP_SIM_ST_TRACFONE_COMPLETED_FAIL
#define SIM_TRACFONE_RESP_SIM_ST_TRACFONE_COMPLETED_FAIL      0x76                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
            } __attribute__((packed)) SIM_TRACFONE_RESP_SIM_ST_TRACFONE_COMPLETED_FAIL_STR;
#define SIZE_SIM_TRACFONE_RESP_SIM_ST_TRACFONE_COMPLETED_FAIL    sizeof(SIM_TRACFONE_RESP_SIM_ST_TRACFONE_COMPLETED_FAIL_STR)


//Definition for struct SIM_TRACFONE_NTF


//Definition for struct SIM_TRACFONE_NTF_SIM_ST_TRACFONE_REQUESTED
#define SIM_TRACFONE_NTF_SIM_ST_TRACFONE_REQUESTED            0x77                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      fillerbyte1;
             uint8_t      icc_id[10];
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
            } __attribute__((packed)) SIM_TRACFONE_NTF_SIM_ST_TRACFONE_REQUESTED_STR;
#define SIZE_SIM_TRACFONE_NTF_SIM_ST_TRACFONE_REQUESTED       sizeof(SIM_TRACFONE_NTF_SIM_ST_TRACFONE_REQUESTED_STR)


//Definition for struct SIM_PN_READ_REQ
#define SIM_PN_READ_REQ                                       0x0F                                                     
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint16_t     location;
            } __attribute__((packed)) SIM_PN_READ_REQ_STR;
#define SIZE_SIM_PN_READ_REQ                                  sizeof(SIM_PN_READ_REQ_STR)


//Definition for struct SIM_PN_READ_RESP
#define SIM_PN_READ_RESP                                      0x10                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
             uint16_t     location;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             SIM_NUMBER_STR    namenumber[0];
            } __attribute__((packed)) SIM_PN_READ_RESP_STR;
#define SIZE_SIM_PN_READ_RESP                                 sizeof(SIM_PN_READ_RESP_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct SIM_PN_WRITE_REQ
#define SIM_PN_WRITE_REQ                                      0x11                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint16_t     location;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             SIM_NUMBER_STR    namenumber[0];
            } __attribute__((packed)) SIM_PN_WRITE_REQ_STR;
#define SIZE_SIM_PN_WRITE_REQ                                 sizeof(SIM_PN_WRITE_REQ_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct SIM_PN_WRITE_RESP
#define SIM_PN_WRITE_RESP                                     0x12                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
            } __attribute__((packed)) SIM_PN_WRITE_RESP_STR;
#define SIZE_SIM_PN_WRITE_RESP                                sizeof(SIM_PN_WRITE_RESP_STR)


//Definition for struct SIM_PUCT_REQ


//Definition for struct SIM_PUCT_REQ_SIM_ST_SET
#define SIM_PUCT_REQ_SIM_ST_SET                               0x17                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      fillerbyte1;
             SIM_PUCT_UNICODE_STR    puctstr[0];
            } __attribute__((packed)) SIM_PUCT_REQ_SIM_ST_SET_STR;
#define SIZE_SIM_PUCT_REQ_SIM_ST_SET                          sizeof(SIM_PUCT_REQ_SIM_ST_SET_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct SIM_PUCT_REQ


//Definition for struct SIM_PUCT_REQ_SIM_ST_READ_AOC
#define SIM_PUCT_REQ_SIM_ST_READ_AOC                          0x17                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
            } __attribute__((packed)) SIM_PUCT_REQ_SIM_ST_READ_AOC_STR;
#define SIZE_SIM_PUCT_REQ_SIM_ST_READ_AOC                     sizeof(SIM_PUCT_REQ_SIM_ST_READ_AOC_STR)


//Definition for struct SIM_PUCT_RESP


//Definition for struct SIM_PUCT_RESP_SIM_ST_SET
#define SIM_PUCT_RESP_SIM_ST_SET                              0x18                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
            } __attribute__((packed)) SIM_PUCT_RESP_SIM_ST_SET_STR;
#define SIZE_SIM_PUCT_RESP_SIM_ST_SET                         sizeof(SIM_PUCT_RESP_SIM_ST_SET_STR)


//Definition for struct SIM_PUCT_RESP


//Definition for struct SIM_PUCT_RESP_SIM_ST_READ_AOC
#define SIM_PUCT_RESP_SIM_ST_READ_AOC                         0x18                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
             SIM_PUCT_UNICODE_STR    puctstr[0];
            } __attribute__((packed)) SIM_PUCT_RESP_SIM_ST_READ_AOC_STR;
#define SIZE_SIM_PUCT_RESP_SIM_ST_READ_AOC                    sizeof(SIM_PUCT_RESP_SIM_ST_READ_AOC_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct SIM_HOME_ZONE_REQ


//Definition for struct SIM_HOME_ZONE_REQ_CHECK_CELL_ID
#define SIM_HOME_ZONE_REQ_CHECK_CELL_ID                       0x25                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      fillerbyte1;
             uint8_t      line;
             SIM_INFO_PLMN_STR    current_plmn[0];
             uint8_t      fillerbyte2;
             SIM_INFO_ZONE_IDENTITY_STR    current_zone[0];
            } __attribute__((packed)) SIM_HOME_ZONE_REQ_CHECK_CELL_ID_STR;
#define SIZE_SIM_HOME_ZONE_REQ_CHECK_CELL_ID                  sizeof(SIM_HOME_ZONE_REQ_CHECK_CELL_ID_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct SIM_HOME_ZONE_REQ


//Definition for struct SIM_HOME_ZONE_REQ_READ_COORDINATES
#define SIM_HOME_ZONE_REQ_READ_COORDINATES                    0x25                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) SIM_HOME_ZONE_REQ_READ_COORDINATES_STR;
#define SIZE_SIM_HOME_ZONE_REQ_READ_COORDINATES               sizeof(SIM_HOME_ZONE_REQ_READ_COORDINATES_STR)


//Definition for struct SIM_HOME_ZONE_RESP


//Definition for struct SIM_HOME_ZONE_RESP_CHECK_CELL_ID
#define SIM_HOME_ZONE_RESP_CHECK_CELL_ID                      0x26                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
            } __attribute__((packed)) SIM_HOME_ZONE_RESP_CHECK_CELL_ID_STR;
#define SIZE_SIM_HOME_ZONE_RESP_CHECK_CELL_ID                 sizeof(SIM_HOME_ZONE_RESP_CHECK_CELL_ID_STR)


//Definition for struct SIM_HOME_ZONE_RESP


//Definition for struct SIM_HOME_ZONE_RESP_READ_COORDINATES
#define SIM_HOME_ZONE_RESP_READ_COORDINATES                   0x26                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
             SIM_SERV_ZONE_COORD_STR    zonecoordinates[0];
            } __attribute__((packed)) SIM_HOME_ZONE_RESP_READ_COORDINATES_STR;
#define SIZE_SIM_HOME_ZONE_RESP_READ_COORDINATES              sizeof(SIM_HOME_ZONE_RESP_READ_COORDINATES_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct SIM_JACOB_REQ


//Definition for struct SIM_JACOB_REQ_READ_ID
#define SIM_JACOB_REQ_READ_ID                                 0x27                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      fillerbyte1;
             uint16_t     location;
            } __attribute__((packed)) SIM_JACOB_REQ_READ_ID_STR;
#define SIZE_SIM_JACOB_REQ_READ_ID                            sizeof(SIM_JACOB_REQ_READ_ID_STR)


//Definition for struct SIM_JACOB_REQ


//Definition for struct SIM_JACOB_REQ_READ_REAL_JACOB_IDS
#define SIM_JACOB_REQ_READ_REAL_JACOB_IDS                     0x27                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) SIM_JACOB_REQ_READ_REAL_JACOB_IDS_STR;
#define SIZE_SIM_JACOB_REQ_READ_REAL_JACOB_IDS                sizeof(SIM_JACOB_REQ_READ_REAL_JACOB_IDS_STR)


//Definition for struct SIM_JACOB_RESP


//Definition for struct SIM_JACOB_RESP_READ_ID
#define SIM_JACOB_RESP_READ_ID                                0x28                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
             SIM_JACOB_ID_READ_STR    jacob_id[0];
            } __attribute__((packed)) SIM_JACOB_RESP_READ_ID_STR;
#define SIZE_SIM_JACOB_RESP_READ_ID                           sizeof(SIM_JACOB_RESP_READ_ID_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct SIM_JACOB_RESP


//Definition for struct SIM_JACOB_RESP_READ_REAL_JACOB_IDS
#define SIM_JACOB_RESP_READ_REAL_JACOB_IDS                    0x28                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
             uint8_t      jacob_count;
             uint8_t      fillerbyte1;
             uint8_t      real_jacobids[64];
            } __attribute__((packed)) SIM_JACOB_RESP_READ_REAL_JACOB_IDS_STR;
#define SIZE_SIM_JACOB_RESP_READ_REAL_JACOB_IDS               sizeof(SIM_JACOB_RESP_READ_REAL_JACOB_IDS_STR)


//Definition for struct SIM_TARIFF_REQ


//Definition for struct SIM_TARIFF_REQ_READ_PACKAGE
#define SIM_TARIFF_REQ_READ_PACKAGE                           0x35                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
            } __attribute__((packed)) SIM_TARIFF_REQ_READ_PACKAGE_STR;
#define SIZE_SIM_TARIFF_REQ_READ_PACKAGE                      sizeof(SIM_TARIFF_REQ_READ_PACKAGE_STR)


//Definition for struct SIM_TARIFF_RESP


//Definition for struct SIM_TARIFF_RESP_READ_PACKAGE
#define SIM_TARIFF_RESP_READ_PACKAGE                          0x36                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
             uint8_t      tariffpackage;
            } __attribute__((packed)) SIM_TARIFF_RESP_READ_PACKAGE_STR;
#define SIZE_SIM_TARIFF_RESP_READ_PACKAGE                     sizeof(SIM_TARIFF_RESP_READ_PACKAGE_STR)


//Definition for struct SIM_GPRS_REQ


//Definition for struct SIM_GPRS_REQ_SIM_ST_ACL_STATUS
#define SIM_GPRS_REQ_SIM_ST_ACL_STATUS                        0xC8                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) SIM_GPRS_REQ_SIM_ST_ACL_STATUS_STR;
#define SIZE_SIM_GPRS_REQ_SIM_ST_ACL_STATUS                   sizeof(SIM_GPRS_REQ_SIM_ST_ACL_STATUS_STR)


//Definition for struct SIM_GPRS_REQ


//Definition for struct SIM_GPRS_REQ_SIM_ST_ACL_ENABLE
#define SIM_GPRS_REQ_SIM_ST_ACL_ENABLE                        0xC8                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) SIM_GPRS_REQ_SIM_ST_ACL_ENABLE_STR;
#define SIZE_SIM_GPRS_REQ_SIM_ST_ACL_ENABLE                   sizeof(SIM_GPRS_REQ_SIM_ST_ACL_ENABLE_STR)


//Definition for struct SIM_GPRS_REQ


//Definition for struct SIM_GPRS_REQ_SIM_ST_ACL_DISABLE
#define SIM_GPRS_REQ_SIM_ST_ACL_DISABLE                       0xC8                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) SIM_GPRS_REQ_SIM_ST_ACL_DISABLE_STR;
#define SIZE_SIM_GPRS_REQ_SIM_ST_ACL_DISABLE                  sizeof(SIM_GPRS_REQ_SIM_ST_ACL_DISABLE_STR)


//Definition for struct SIM_GPRS_REQ


//Definition for struct SIM_GPRS_REQ_SIM_ST_ACL_READ
#define SIM_GPRS_REQ_SIM_ST_ACL_READ                          0xC8                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) SIM_GPRS_REQ_SIM_ST_ACL_READ_STR;
#define SIZE_SIM_GPRS_REQ_SIM_ST_ACL_READ                     sizeof(SIM_GPRS_REQ_SIM_ST_ACL_READ_STR)


//Definition for struct SIM_GPRS_REQ


//Definition for struct SIM_GPRS_REQ_SIM_ST_ACL_WRITE
#define SIM_GPRS_REQ_SIM_ST_ACL_WRITE                         0xC8                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      datanumtlv;
             uint16_t     datalength;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      data[0];
            } __attribute__((packed)) SIM_GPRS_REQ_SIM_ST_ACL_WRITE_STR;
#define SIZE_SIM_GPRS_REQ_SIM_ST_ACL_WRITE                    sizeof(SIM_GPRS_REQ_SIM_ST_ACL_WRITE_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct SIM_GPRS_REQ


//Definition for struct SIM_GPRS_REQ_SIM_ST_CHECK_APN
#define SIM_GPRS_REQ_SIM_ST_CHECK_APN                         0xC8                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      apnlength;
             uint8_t      data[0];
            } __attribute__((packed)) SIM_GPRS_REQ_SIM_ST_CHECK_APN_STR;
#define SIZE_SIM_GPRS_REQ_SIM_ST_CHECK_APN                    sizeof(SIM_GPRS_REQ_SIM_ST_CHECK_APN_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct SIM_GPRS_RESP


//Definition for struct SIM_GPRS_RESP_SIM_ST_ACL_STATUS
#define SIM_GPRS_RESP_SIM_ST_ACL_STATUS                       0xC9                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
            } __attribute__((packed)) SIM_GPRS_RESP_SIM_ST_ACL_STATUS_STR;
#define SIZE_SIM_GPRS_RESP_SIM_ST_ACL_STATUS                  sizeof(SIM_GPRS_RESP_SIM_ST_ACL_STATUS_STR)


//Definition for struct SIM_GPRS_RESP


//Definition for struct SIM_GPRS_RESP_SIM_ST_ACL_ENABLE
#define SIM_GPRS_RESP_SIM_ST_ACL_ENABLE                       0xC9                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
            } __attribute__((packed)) SIM_GPRS_RESP_SIM_ST_ACL_ENABLE_STR;
#define SIZE_SIM_GPRS_RESP_SIM_ST_ACL_ENABLE                  sizeof(SIM_GPRS_RESP_SIM_ST_ACL_ENABLE_STR)


//Definition for struct SIM_GPRS_RESP


//Definition for struct SIM_GPRS_RESP_SIM_ST_ACL_DISABLE
#define SIM_GPRS_RESP_SIM_ST_ACL_DISABLE                      0xC9                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
            } __attribute__((packed)) SIM_GPRS_RESP_SIM_ST_ACL_DISABLE_STR;
#define SIZE_SIM_GPRS_RESP_SIM_ST_ACL_DISABLE                 sizeof(SIM_GPRS_RESP_SIM_ST_ACL_DISABLE_STR)


//Definition for struct SIM_GPRS_RESP


//Definition for struct SIM_GPRS_RESP_SIM_ST_ACL_READ
#define SIM_GPRS_RESP_SIM_ST_ACL_READ                         0xC9                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
             uint16_t     maxdataspace;
             uint16_t     datalength;
             uint8_t      datanumtlv;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
             uint8_t      data[0];
            } __attribute__((packed)) SIM_GPRS_RESP_SIM_ST_ACL_READ_STR;
#define SIZE_SIM_GPRS_RESP_SIM_ST_ACL_READ                    sizeof(SIM_GPRS_RESP_SIM_ST_ACL_READ_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct SIM_GPRS_RESP


//Definition for struct SIM_GPRS_RESP_SIM_ST_ACL_WRITE
#define SIM_GPRS_RESP_SIM_ST_ACL_WRITE                        0xC9                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
            } __attribute__((packed)) SIM_GPRS_RESP_SIM_ST_ACL_WRITE_STR;
#define SIZE_SIM_GPRS_RESP_SIM_ST_ACL_WRITE                   sizeof(SIM_GPRS_RESP_SIM_ST_ACL_WRITE_STR)


//Definition for struct SIM_GPRS_RESP


//Definition for struct SIM_GPRS_RESP_SIM_ST_CHECK_APN
#define SIM_GPRS_RESP_SIM_ST_CHECK_APN                        0xC9                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
            } __attribute__((packed)) SIM_GPRS_RESP_SIM_ST_CHECK_APN_STR;
#define SIZE_SIM_GPRS_RESP_SIM_ST_CHECK_APN                   sizeof(SIM_GPRS_RESP_SIM_ST_CHECK_APN_STR)


//Definition for struct SIM_AM_REQ
#define SIM_AM_REQ                                            0x82                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      noofsubblocks;
            } __attribute__((packed)) SIM_AM_REQ_STR;
#define SIZE_SIM_AM_REQ                                       sizeof(SIM_AM_REQ_STR)


//Definition for struct SIM_AM_RESP
#define SIM_AM_RESP                                           0x83                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
             uint8_t      noofsubblocks;
            } __attribute__((packed)) SIM_AM_RESP_STR;
#define SIZE_SIM_AM_RESP                                      sizeof(SIM_AM_RESP_STR)


//Definition for struct SIM_ICC_TYPE_IND
#define SIM_ICC_TYPE_IND                                      0xEB                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
             uint8_t      cardreaderid;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      numberofsubblocks;
            } __attribute__((packed)) SIM_ICC_TYPE_IND_STR;
#define SIZE_SIM_ICC_TYPE_IND                                 sizeof(SIM_ICC_TYPE_IND_STR)


//Definition for struct SIM_IMS_IND
#define SIM_IMS_IND                                           0xE8                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
            } __attribute__((packed)) SIM_IMS_IND_STR;
#define SIZE_SIM_IMS_IND                                      sizeof(SIM_IMS_IND_STR)


//Definition for struct SIM_IND
#define SIM_IND                                               0xEF                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
             uint8_t      state;
             uint8_t      cause;
             uint8_t      applicationnumber;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) SIM_IND_STR;
#define SIZE_SIM_IND                                          sizeof(SIM_IND_STR)


//Definition for struct SIM_IND


//Definition for struct SIM_IND_PREF_LANGUAGE
#define SIM_IND_PREF_LANGUAGE                                 0xEF                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
             uint8_t      state;
             uint8_t      cause;
             uint8_t      applicationnumber;
             uint8_t      fillerbyte1;
             uint8_t      count;
             uint32_t     languagetable;
            } __attribute__((packed)) SIM_IND_PREF_LANGUAGE_STR;
#define SIZE_SIM_IND_PREF_LANGUAGE                            sizeof(SIM_IND_PREF_LANGUAGE_STR)


//Definition for struct SIM_IND


//Definition for struct SIM_IND_EMERGENCY_CODES
#define SIM_IND_EMERGENCY_CODES                               0xEF                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
             uint8_t      state;
             uint8_t      cause;
             uint8_t      applicationnumber;
             uint8_t      fillerbyte1;
             SIM_EMRG_CALL_CODES_STR    emergcodes[0];
            } __attribute__((packed)) SIM_IND_EMERGENCY_CODES_STR;
#define SIZE_SIM_IND_EMERGENCY_CODES                          sizeof(SIM_IND_EMERGENCY_CODES_STR)
//NOTE: Definition contains array(s), sequence(s) or IF/ELSE statements. SIZE_ and offsets following array or sequence might be defined incorrectly.


//Definition for struct SIM_PB_IND
#define SIM_PB_IND                                            0xEA                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      numberofsubblocks;
            } __attribute__((packed)) SIM_PB_IND_STR;
#define SIZE_SIM_PB_IND                                       sizeof(SIM_PB_IND_STR)


//Definition for struct SIM_SERVER_READY_IND
#define SIM_SERVER_READY_IND                                  0xED                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
             uint8_t      state;
             uint8_t      cause;
             uint8_t      applicationnumber;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) SIM_SERVER_READY_IND_STR;
#define SIZE_SIM_SERVER_READY_IND                             sizeof(SIM_SERVER_READY_IND_STR)


//Definition for struct SIM_CS_IND
#define SIM_CS_IND                                            0xEE                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
             uint8_t      state;
             uint8_t      cause;
             uint8_t      applicationnumber;
             uint8_t      fillerbyte1;
            } __attribute__((packed)) SIM_CS_IND_STR;
#define SIZE_SIM_CS_IND                                       sizeof(SIM_CS_IND_STR)


//Definition for struct SIM_AM_IND
#define SIM_AM_IND                                            0x8C                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
             uint8_t      fillerbyte1;
             uint8_t      fillerbyte2;
             uint8_t      fillerbyte3;
             uint8_t      numberofsubblocks;
            } __attribute__((packed)) SIM_AM_IND_STR;
#define SIZE_SIM_AM_IND                                       sizeof(SIM_AM_IND_STR)


//Definition for struct SIM_ACL_IND
#define SIM_ACL_IND                                           0xE7                                                  
typedef struct
            { 
             uint8_t      transid;
             uint8_t      messageid;
             uint8_t      servicetype;
             uint8_t      status;
            } __attribute__((packed)) SIM_ACL_IND_STR;
#define SIZE_SIM_ACL_IND                                      sizeof(SIM_ACL_IND_STR)

#endif
